/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],S=0,k=K.length;S<k;S++)e[S]=Z[K[S]];return e};define(Z[84],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=S}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function k(R){const f=[];for(let y in R)S.call(R,y)&&f.push(R[y]);return f}e.values=k;function A(R,f){for(let y in R)if(S.call(R,y)&&f({key:y,value:R[y]},function(){delete R[y]})===!1)return}e.forEach=A;function L(R,f){const y=Object.create(null);for(const b of R){const o=f(b);let E=y[o];E||(E=y[o]=[]),E.push(b)}return y}e.groupBy=L;function U(R){const f=Object.create(null);return R&&R.forEach((y,b)=>{f[b]=y}),f}e.fromMap=U;function O(R,f){const y=[],b=[];for(let o of R)f.has(o)||y.push(o);for(let o of f)R.has(o)||b.push(o);return{removed:y,added:b}}e.diffSets=O;function m(R,f){const y=[],b=[];for(let[o,E]of R)f.has(o)||y.push(E);for(let[o,E]of f)R.has(o)||b.push(E);return{removed:y,added:b}}e.diffMaps=m;class v{constructor(){this.map=new Map}add(f,y){let b=this.map.get(f);b||(b=new Set,this.map.set(f,b)),b.add(y)}delete(f,y){const b=this.map.get(f);!b||(b.delete(y),b.size===0&&this.map.delete(f))}forEach(f,y){const b=this.map.get(f);!b||b.forEach(y)}}e.SetMap=v}),define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function S(m){return(v,R,f)=>{let y=null,b=null;if(typeof f.value=="function"?(y="value",b=f.value):typeof f.get=="function"&&(y="get",b=f.get),!b)throw new Error("not supported");f[y]=m(b,R)}}e.createDecorator=S;let k=0;function A(){const m=`$memoize${k++}`;let v;const R=function(y,b,o){let E=null,w=null;if(typeof o.value=="function"?(E="value",w=o.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(E="get",w=o.get),!w)throw new Error("not supported");const C=`${m}:${b}`;o[E]=function(...I){return v=this,this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!0,enumerable:!1,writable:!0,value:w.apply(this,I)}),this[C]}};return R.clear=()=>{typeof v!="undefined"&&Object.getOwnPropertyNames(v).forEach(f=>{f.indexOf(m)===0&&delete v[f]})},R}e.createMemoizer=A;function L(m,v,R){return A()(m,v,R)}e.memoize=L;function U(m,v,R){return S((f,y)=>{const b=`$debounce$${y}`,o=`$debounce$result$${y}`;return function(...E){this[o]||(this[o]=R?R():void 0),clearTimeout(this[b]),v&&(this[o]=v(this[o],...E),E=[this[o]]),this[b]=setTimeout(()=>{f.apply(this,E),this[o]=R?R():void 0},m)}})}e.debounce=U;function O(m,v,R){return S((f,y)=>{const b=`$throttle$timer$${y}`,o=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...C){if(this[o]||(this[o]=R?R():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),v&&(this[o]=v(this[o],...C)),!this[w]){const I=this[E]+m;I<=Date.now()?(this[E]=Date.now(),f.apply(this,[this[o]]),this[o]=R?R():void 0):(this[w]=!0,this[b]=setTimeout(()=>{this[w]=!1,this[E]=Date.now(),f.apply(this,[this[o]]),this[o]=R?R():void 0},I-Date.now()))}}})}e.throttle=O}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function k(r){e.errorHandler.setUnexpectedErrorHandler(r)}e.setUnexpectedErrorHandler=k;function A(r){m(r)||e.errorHandler.onUnexpectedError(r)}e.onUnexpectedError=A;function L(r){m(r)||e.errorHandler.onUnexpectedExternalError(r)}e.onUnexpectedExternalError=L;function U(r){if(r instanceof Error){let{name:t,message:i}=r;const n=r.stacktrace||r.stack;return{$isError:!0,name:t,message:i,stack:n}}return r}e.transformErrorForSerialization=U;const O="Canceled";function m(r){return r instanceof Error&&r.name===O&&r.message===O}e.isPromiseCanceledError=m;class v extends Error{constructor(){super(O);this.name=this.message}}e.CancellationError=v;function R(){const r=new Error(O);return r.name=r.message,r}e.canceled=R;function f(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}e.illegalArgument=f;function y(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}e.illegalState=y;function b(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function o(r){const t=new Error(`${r} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function E(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}e.getErrorMessage=E;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class C extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=C;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function g(r){const t=r;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function s(r,t=Object.create(null)){const i=new Error(r);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=s}),define(Z[18],ee([0,1,11]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(q,H=0){return q[q.length-(1+H)]}e.tail=k;function A(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=A;function L(q,H,z=(D,T)=>D===T){if(q===H)return!0;if(!q||!H||q.length!==H.length)return!1;for(let D=0,T=q.length;D<T;D++)if(!z(q[D],H[D]))return!1;return!0}e.equals=L;function U(q,H,z){let D=0,T=q.length-1;for(;D<=T;){const F=(D+T)/2|0,N=z(q[F],H);if(N<0)D=F+1;else if(N>0)T=F-1;else return F}return-(D+1)}e.binarySearch=U;function O(q,H){let z=0,D=q.length;if(D===0)return 0;for(;z<D;){const T=Math.floor((z+D)/2);H(q[T])?D=T:z=T+1}return z}e.findFirstInSorted=O;function m(q,H,z){if(q=q|0,q>=H.length)throw new TypeError("invalid index");let D=H[Math.floor(H.length*Math.random())],T=[],F=[],N=[];for(let x of H){const G=z(x,D);G<0?T.push(x):G>0?F.push(x):N.push(x)}return q<T.length?m(q,T,z):q<T.length+N.length?N[0]:m(q-(T.length+N.length),F,z)}e.quickSelect=m;function v(q,H){const z=[];let D;for(const T of q.slice(0).sort(H))!D||H(D[0],T)!==0?(D=[T],z.push(D)):D.push(T);return z}e.groupBy=v;function R(q,H,z){const D=[];function T(x,G,J){if(!(G===0&&J.length===0)){const Q=D[D.length-1];Q&&Q.start+Q.deleteCount===x?(Q.deleteCount+=G,Q.toInsert.push(...J)):D.push({start:x,deleteCount:G,toInsert:J})}}let F=0,N=0;for(;;){if(F===q.length){T(F,0,H.slice(N));break}if(N===H.length){T(F,q.length-F,[]);break}const x=q[F],G=H[N],J=z(x,G);J===0?(F+=1,N+=1):J<0?(T(F,1,[]),F+=1):J>0&&(T(F,0,[G]),N+=1)}return D}e.sortedDiff=R;function f(q,H,z){const D=R(q,H,z),T=[],F=[];for(const N of D)T.push(...q.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:T,added:F}}e.delta=f;function y(q,H,z){if(z===0)return[];const D=q.slice(0,z).sort(H);return o(q,H,D,z,q.length),D}e.top=y;function b(q,H,z,D,T){return z===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const x=q.length,G=q.slice(0,z).sort(H);for(let J=z,Q=Math.min(z+D,x);J<x;J=Q,Q=Math.min(Q+D,x)){if(J>z&&await new Promise(ne=>setTimeout(ne)),T&&T.isCancellationRequested)throw(0,S.canceled)();o(q,H,G,J,Q)}return G})().then(F,N)})}e.topAsync=b;function o(q,H,z,D,T){for(const F=z.length;D<T;D++){const N=q[D];if(H(N,z[F-1])<0){z.pop();const x=O(z,G=>H(N,G)<0);z.splice(x,0,N)}}}function E(q){return q.filter(H=>!!H)}e.coalesce=E;function w(q){let H=0;for(let z=0;z<q.length;z++)q[z]&&(q[H]=q[z],H+=1);q.length=H}e.coalesceInPlace=w;function C(q,H,z){q.splice(z,0,q.splice(H,1)[0])}e.move=C;function I(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=I;function g(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=g;function s(q,H){if(!H)return q.filter((D,T)=>q.indexOf(D)===T);const z=Object.create(null);return q.filter(D=>{const T=H(D);return z[T]?!1:(z[T]=!0,!0)})}e.distinct=s;function r(q){const H=new Set;return q.filter(z=>H.has(z)?!1:(H.add(z),!0))}e.distinctES6=r;function t(q){const H=Object.create(null);return z=>{const D=q(z);return H[D]?!1:(H[D]=!0,!0)}}e.uniqueFilter=t;function i(q,H){for(let z=q.length-1;z>=0;z--){const D=q[z];if(H(D))return z}return-1}e.lastIndex=i;function n(q,H){return q.length>0?q[0]:H}e.firstOrDefault=n;function a(q,H,z=(D,T)=>D===T){let D=0;for(let T=0,F=Math.min(q.length,H.length);T<F&&z(q[T],H[T]);T++)D++;return D}e.commonPrefixLength=a;function c(q){return[].concat(...q)}e.flatten=c;function l(q,H){let z=typeof H=="number"?q:0;typeof H=="number"?z=q:(z=0,H=q);const D=[];if(z<=H)for(let T=z;T<H;T++)D.push(T);else for(let T=z;T>H;T--)D.push(T);return D}e.range=l;function u(q,H,z){return q.reduce((D,T)=>(D[H(T)]=z?z(T):T,D),Object.create(null))}e.index=u;function d(q,H){return q.push(H),()=>p(q,H)}e.insert=d;function p(q,H){const z=q.indexOf(H);if(z>-1)return q.splice(z,1),H}e.remove=p;function h(q,H,z){const D=q.slice(0,H),T=q.slice(H);return D.concat(z,T)}e.arrayInsert=h;function P(q,H){let z;if(typeof H=="number"){let D=H;z=()=>{const T=Math.sin(D++)*179426549;return T-Math.floor(T)}}else z=Math.random;for(let D=q.length-1;D>0;D-=1){const T=Math.floor(z()*(D+1)),F=q[D];q[D]=q[T],q[T]=F}}e.shuffle=P;function _(q,H){const z=q.indexOf(H);z>-1&&(q.splice(z,1),q.unshift(H))}e.pushToStart=_;function j(q,H){const z=q.indexOf(H);z>-1&&(q.splice(z,1),q.push(H))}e.pushToEnd=j;function B(q,H){return Array.isArray(q)?q.map(H):H(q)}e.mapArrayOrNot=B;function M(q){return Array.isArray(q)?q:[q]}e.asArray=M;function $(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=$;function V(q,H){for(const z of q){const D=H(z);if(D!==void 0)return D}}e.mapFind=V}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(k){const A=this;let L=!1,U;return function(){return L||(L=!0,U=k.apply(A,arguments)),U}}e.once=S}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(k){function A(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}k.is=A;const L=Object.freeze([]);function U(){return L}k.empty=U;function*O(r){yield r}k.single=O;function m(r){return r||L}k.from=m;function v(r){return!r||r[Symbol.iterator]().next().done===!0}k.isEmpty=v;function R(r){return r[Symbol.iterator]().next().value}k.first=R;function f(r,t){for(const i of r)if(t(i))return!0;return!1}k.some=f;function y(r,t){for(const i of r)if(t(i))return i}k.find=y;function*b(r,t){for(const i of r)t(i)&&(yield i)}k.filter=b;function*o(r,t){for(const i of r)yield t(i)}k.map=o;function*E(...r){for(const t of r)for(const i of t)yield i}k.concat=E;function*w(r){for(const t of r)for(const i of t)yield i}k.concatNested=w;function C(r,t,i){let n=i;for(const a of r)n=t(n,a);return n}k.reduce=C;function*I(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}k.slice=I;function g(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const n=r[Symbol.iterator]();for(let a=0;a<t;a++){const c=n.next();if(c.done)return[i,k.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return n}}]}k.consume=g;function s(r,t,i=(n,a)=>n===a){const n=r[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const c=n.next(),l=a.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!i(c.value,l.value))return!1}}k.equals=s})(S=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let n=0,a=t.length,c="",l=0,u=16,d=0;function p($){let V=0,q=0;for(;V<$;){const H=t.charCodeAt(n);if(H>=48&&H<=57)q=q*16+H-48;else if(H>=65&&H<=70)q=q*16+H-65+10;else if(H>=97&&H<=102)q=q*16+H-97+10;else break;n++,V++}return V<$&&(q=-1),q}function h($){n=$,c="",l=0,u=16,d=0}function P(){const $=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&v(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&v(t.charCodeAt(n)))for(n++;n<t.length&&v(t.charCodeAt(n));)n++;else return d=3,t.substring($,n);let V=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&v(t.charCodeAt(n))){for(n++;n<t.length&&v(t.charCodeAt(n));)n++;V=n}else d=3;return t.substring($,V)}function _(){let $="",V=n;for(;;){if(n>=a){$+=t.substring(V,n),d=2;break}const q=t.charCodeAt(n);if(q===34){$+=t.substring(V,n),n++;break}if(q===92){if($+=t.substring(V,n),n++,n>=a){d=2;break}switch(t.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const z=p(4);z>=0?$+=String.fromCharCode(z):d=4;break;default:d=5}V=n;continue}if(q>=0&&q<=31)if(m(q)){$+=t.substring(V,n),d=2;break}else d=6;n++}return $}function j(){if(c="",d=0,l=n,n>=a)return l=a,u=17;let $=t.charCodeAt(n);if(O($)){do n++,c+=String.fromCharCode($),$=t.charCodeAt(n);while(O($));return u=15}if(m($))return n++,c+=String.fromCharCode($),$===13&&t.charCodeAt(n)===10&&(n++,c+=`
`),u=14;switch($){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,c=_(),u=10;case 47:const V=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<a&&!m(t.charCodeAt(n));)n++;return c=t.substring(V,n),u=12}if(t.charCodeAt(n+1)===42){n+=2;const q=a-1;let H=!1;for(;n<q;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,d=1),c=t.substring(V,n),u=13}return c+=String.fromCharCode($),n++,u=16;case 45:if(c+=String.fromCharCode($),n++,n===a||!v(t.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),u=11;default:for(;n<a&&B($);)n++,$=t.charCodeAt(n);if(l!==n){switch(c=t.substring(l,n),c){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return c+=String.fromCharCode($),n++,u=16}}function B($){if(O($)||m($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=j();while($>=12&&$<=15);return $}return{setPosition:h,getPosition:()=>n,scan:i?M:j,getToken:()=>u,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=U;function O(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function f(t,i){const n=[],a=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(p,h,P,_){l.value=p,l.offset=h,l.length=P,l.type=_,l.colonOffset=void 0,c=l}try{g(t,{onObjectBegin:(p,h)=>{if(i<=p)throw a;c=void 0,u=i>p,n.push("")},onObjectProperty:(p,h,P)=>{if(i<h||(d(p,h,P,"property"),n[n.length-1]=p,i<=h+P))throw a},onObjectEnd:(p,h)=>{if(i<=p)throw a;c=void 0,n.pop()},onArrayBegin:(p,h)=>{if(i<=p)throw a;c=void 0,n.push(0)},onArrayEnd:(p,h)=>{if(i<=p)throw a;c=void 0,n.pop()},onLiteralValue:(p,h,P)=>{if(i<h||(d(p,h,P,r(p)),i<=h+P))throw a},onSeparator:(p,h,P)=>{if(i<=h)throw a;if(p===":"&&c&&c.type==="property")c.colonOffset=h,u=!1,c=void 0;else if(p===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(u=!0,n[n.length-1]=""),c=void 0}}})}catch(p){if(p!==a)throw p}return{path:n,previousNode:c,isAtPropertyKey:u,matches:p=>{let h=0;for(let P=0;h<p.length&&P<n.length;P++)if(p[h]===n[P]||p[h]==="*")h++;else if(p[h]!=="**")return!1;return h===p.length}}}e.getLocation=f;function y(t,i=[],n=L.DEFAULT){let a=null,c=[];const l=[];function u(p){Array.isArray(c)?c.push(p):a!==null&&(c[a]=p)}return g(t,{onObjectBegin:()=>{const p={};u(p),l.push(c),c=p,a=null},onObjectProperty:p=>{a=p},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const p=[];u(p),l.push(c),c=p,a=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:u,onError:(p,h,P)=>{i.push({error:p,offset:h,length:P})}},n),c[0]}e.parse=y;function b(t,i=[],n=L.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(p){a.type==="property"&&(a.length=p-a.offset,a=a.parent)}function l(p){return a.children.push(p),p}g(t,{onObjectBegin:p=>{a=l({type:"object",offset:p,length:-1,parent:a,children:[]})},onObjectProperty:(p,h,P)=>{a=l({type:"property",offset:h,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:p,offset:h,length:P,parent:a})},onObjectEnd:(p,h)=>{a.length=p+h-a.offset,a=a.parent,c(p+h)},onArrayBegin:(p,h)=>{a=l({type:"array",offset:p,length:-1,parent:a,children:[]})},onArrayEnd:(p,h)=>{a.length=p+h-a.offset,a=a.parent,c(p+h)},onLiteralValue:(p,h,P)=>{l({type:r(p),offset:h,length:P,parent:a,value:p}),c(h+P)},onSeparator:(p,h,P)=>{a.type==="property"&&(p===":"?a.colonOffset=h:p===","&&c(h))},onError:(p,h,P)=>{i.push({error:p,offset:h,length:P})}},n);const d=a.children[0];return d&&delete d.parent,d}e.parseTree=b;function o(t,i){if(!!t){let n=t;for(let a of i)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===a){n=l.children[1],c=!0;break}if(!c)return}else{const c=a;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}}e.findNodeAtLocation=o;function E(t){if(!t.parent||!t.parent.children)return[];const i=E(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=E;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const i=Object.create(null);for(let n of t.children){const a=n.children[1];a&&(i[n.children[0].value]=w(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function C(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=C;function I(t,i,n=!1){if(C(t,i,n)){const a=t.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=i;c++){const l=I(a[c],i,n);if(l)return l}return t}}e.findNodeAtOffset=I;function g(t,i,n=L.DEFAULT){const a=U(t,!1);function c(G){return G?()=>G(a.getTokenOffset(),a.getTokenLength()):()=>!0}function l(G){return G?J=>G(J,a.getTokenOffset(),a.getTokenLength()):()=>!0}const u=c(i.onObjectBegin),d=l(i.onObjectProperty),p=c(i.onObjectEnd),h=c(i.onArrayBegin),P=c(i.onArrayEnd),_=l(i.onLiteralValue),j=l(i.onSeparator),B=c(i.onComment),M=l(i.onError),$=n&&n.disallowComments,V=n&&n.allowTrailingComma;function q(){for(;;){const G=a.scan();switch(a.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(G){case 12:case 13:$?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return G}}}function H(G,J=[],Q=[]){if(M(G),J.length+Q.length>0){let ne=a.getToken();for(;ne!==17;){if(J.indexOf(ne)!==-1){q();break}else if(Q.indexOf(ne)!==-1)break;ne=q()}}}function z(G){const J=a.getTokenValue();return G?_(J):d(J),q(),!0}function D(){switch(a.getToken()){case 11:let G=0;try{G=JSON.parse(a.getTokenValue()),typeof G!="number"&&(H(2),G=0)}catch(J){H(2)}_(G);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return q(),!0}function T(){return a.getToken()!==10?(H(3,[],[2,5]),!1):(z(!1),a.getToken()===6?(j(":"),q(),x()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){u(),q();let G=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(G||H(4,[],[]),j(","),q(),a.getToken()===2&&V)break}else G&&H(6,[],[]);T()||H(4,[],[2,5]),G=!0}return p(),a.getToken()!==2?H(7,[2],[]):q(),!0}function N(){h(),q();let G=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(G||H(4,[],[]),j(","),q(),a.getToken()===4&&V)break}else G&&H(6,[],[]);x()||H(4,[],[4,5]),G=!0}return P(),a.getToken()!==4?H(8,[4],[]):q(),!0}function x(){switch(a.getToken()){case 3:return N();case 1:return F();case 10:return z(!0);default:return D()}}return q(),a.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):x()?(a.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=g;function s(t,i){let n=U(t),a=[],c,l=0,u;do switch(u=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:l!==u&&a.push(t.substring(l,u)),i!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,i)),l=n.getPosition();break}while(c!==17);return a.join("")}e.stripComments=s;function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=r}),define(Z[46],ee([0,1,32]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(m,v,R){let f,y,b,o,E;if(v){for(o=v.offset,E=o+v.length,b=o;b>0&&!O(m,b-1);)b--;let l=E;for(;l<m.length&&!O(m,l);)l++;y=m.substring(b,l),f=L(y,R)}else y=m,f=0,b=0,o=0,E=m.length;const w=U(R,m);let C=!1,I=0,g;R.insertSpaces?g=A(" ",R.tabSize||4):g="	";const s=(0,S.createScanner)(y,!1);let r=!1;function t(){return w+A(g,f+I)}function i(){let l=s.scan();for(C=!1;l===15||l===14;)C=C||l===14,l=s.scan();return r=l===16||s.getTokenError()!==0,l}const n=[];function a(l,u,d){!r&&u<E&&d>o&&m.substring(u,d)!==l&&n.push({offset:u,length:d-u,content:l})}let c=i();if(c!==17){const l=s.getTokenOffset()+b,u=A(g,f);a(u,b,l)}for(;c!==17;){let l=s.getTokenOffset()+s.getTokenLength()+b,u=i(),d="";for(;!C&&(u===12||u===13);){const h=s.getTokenOffset()+b;a(" ",l,h),l=s.getTokenOffset()+s.getTokenLength()+b,d=u===12?t():"",u=i()}if(u===2)c!==1&&(I--,d=t());else if(u===4)c!==3&&(I--,d=t());else{switch(c){case 3:case 1:I++,d=t();break;case 5:case 12:d=t();break;case 13:C?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}C&&(u===12||u===13)&&(d=t())}const p=s.getTokenOffset()+b;a(d,l,p),c=u}return n}e.format=k;function A(m,v){let R="";for(let f=0;f<v;f++)R+=m;return R}function L(m,v){let R=0,f=0;const y=v.tabSize||4;for(;R<m.length;){const b=m.charAt(R);if(b===" ")f++;else if(b==="	")f+=y;else break;R++}return Math.floor(f/y)}function U(m,v){for(let R=0;R<v.length;R++){const f=v.charAt(R);if(f==="\r")return R+1<v.length&&v.charAt(R+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=U;function O(m,v){return`\r
`.indexOf(m.charAt(v))!==-1}e.isEOL=O}),define(Z[41],ee([0,1,32,46]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(v,R,f){return L(v,R,void 0,f)}e.removeProperty=A;function L(v,R,f,y,b){const o=R.slice(),E=[],w=(0,S.parseTree)(v,E);let C,I;for(;o.length>0&&(I=o.pop(),C=(0,S.findNodeAtLocation)(w,o),C===void 0&&f!==void 0);)typeof I=="string"?f={[I]:f}:f=[f];if(C)if(C.type==="object"&&typeof I=="string"&&Array.isArray(C.children)){const g=(0,S.findNodeAtLocation)(C,[I]);if(g!==void 0)if(f===void 0){if(!g.parent)throw new Error("Malformed AST");const s=C.children.indexOf(g.parent);let r,t=g.parent.offset+g.parent.length;if(s>0){const i=C.children[s-1];r=i.offset+i.length}else r=C.offset+1,C.children.length>1&&(t=C.children[1].offset);return U(v,{offset:r,length:t-r,content:""},y)}else return U(v,{offset:g.offset,length:g.length,content:JSON.stringify(f)},y);else{if(f===void 0)return[];const s=`${JSON.stringify(I)}: ${JSON.stringify(f)}`,r=b?b(C.children.map(i=>i.children[0].value)):C.children.length;let t;if(r>0){const i=C.children[r-1];t={offset:i.offset+i.length,length:0,content:","+s}}else C.children.length===0?t={offset:C.offset+1,length:0,content:s}:t={offset:C.offset+1,length:0,content:s+","};return U(v,t,y)}}else if(C.type==="array"&&typeof I=="number"&&Array.isArray(C.children))if(f!==void 0){const g=`${JSON.stringify(f)}`;let s;if(C.children.length===0||I===0)s={offset:C.offset+1,length:0,content:C.children.length===0?g:g+","};else{const r=I===-1||I>C.children.length?C.children.length:I,t=C.children[r-1];s={offset:t.offset+t.length,length:0,content:","+g}}return U(v,s,y)}else{const g=I,s=C.children[g];let r;if(C.children.length===1)r={offset:C.offset+1,length:C.length-2,content:""};else if(C.children.length-1===g){const t=C.children[g-1],i=t.offset+t.length,n=C.offset+C.length;r={offset:i,length:n-2-i,content:""}}else r={offset:s.offset,length:C.children[g+1].offset-s.offset,content:""};return U(v,r,y)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${C.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return U(v,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(f)},y)}}e.setProperty=L;function U(v,R,f){let y=O(v,R),b=R.offset,o=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;b>0&&!(0,k.isEOL)(y,b-1);)b--;for(;o<y.length&&!(0,k.isEOL)(y,o);)o++}const E=(0,k.format)(y,{offset:b,length:o-b},f);for(let C=E.length-1;C>=0;C--){const I=E[C];y=O(y,I),b=Math.min(b,I.offset),o=Math.max(o,I.offset+I.length),o+=I.content.length-I.length}const w=v.length-(y.length-o)-b;return[{offset:b,length:w,content:y.substring(b,o)}]}e.withFormatting=U;function O(v,R){return v.substring(0,R.offset)+R.content+v.substring(R.offset+R.length)}e.applyEdit=O;function m(v,R){let f=R.slice(0).sort((b,o)=>{const E=b.offset-o.offset;return E===0?b.length-o.length:E}),y=v.length;for(let b=f.length-1;b>=0;b--){let o=f[b];if(o.offset+o.length<=y)v=O(v,o);else throw new Error("Overlapping edit");y=o.offset}return v}e.applyEdits=m}),define(Z[2],ee([0,1,63,53]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let L=null;function U(g){L=g}if(e.setDisposableTracker=U,A){const g="__is_disposable_tracked__";L=new class{trackDisposable(s){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[g]||console.log(r)},3e3)}markTracked(s){if(s&&s!==E.None)try{s[g]=!0}catch(r){}}}}function O(g){!L||L.markTracked(g)}function m(g){return L&&L.trackDisposable(g),g}e.trackDisposable=m;class v extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=v;function R(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=R;function f(g){if(k.Iterable.is(g)){let s=[];for(const r of g)if(r){O(r);try{r.dispose()}catch(t){s.push(t)}}if(s.length===1)throw s[0];if(s.length>1)throw new v(s);return Array.isArray(g)?[]:g}else if(g)return O(g),g.dispose(),g}e.dispose=f;function y(...g){return g.forEach(O),b(()=>f(g))}e.combinedDisposable=y;function b(g){const s=m({dispose:()=>{O(s),g()}});return s}e.toDisposable=b;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(O(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return O(s),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new o,m(this)}dispose(){O(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var r;this._isDisposed||s===this._value||((r=this._value)===null||r===void 0||r.dispose(),s&&O(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,O(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=w;class C{constructor(){this.references=new Map}acquire(s,...r){let t=this.references.get(s);t||(t={counter:0,object:this.createReferencedObject(s,...r)},this.references.set(s,t));const{object:i}=t,n=(0,S.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(s,t.object),this.references.delete(s))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=C;class I{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=I}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class k{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,U){const O=new S(L);if(this._first===S.Undefined)this._first=O,this._last=O;else if(U){const v=this._last;this._last=O,O.prev=v,v.next=O}else{const v=this._first;this._first=O,O.next=v,v.prev=O}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(O))}}shift(){if(this._first!==S.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==S.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const U=L.prev;U.next=L.next,L.next.prev=U}else L.prev===S.Undefined&&L.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):L.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):L.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.LinkedList=k});"use strict";(function(){function K(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function U(m){L.push(m,Date.now())}function O(){const m=[];for(let v=0;v<L.length;v+=2)m.push({name:L[v],startTime:L[v+1]});return m}return{mark:U,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const U of performance.getEntriesByType("mark"))L.push({name:U.name,startTime:Math.round(A+U.startTime)});return L}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=S(k))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,L=!1,U=!1,O=!1,m=!1,v=!1,R=!1,f,y=k,b,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof e.globals.vscode!="undefined"?E=e.globals.vscode.process:typeof process!="undefined"&&(E=process);const w=typeof((S=E==null?void 0:E.versions)===null||S===void 0?void 0:S.electron)=="string"&&E.type==="renderer";if(e.isElectronSandboxed=w&&(E==null?void 0:E.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=E==null?void 0:E.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)o=navigator.userAgent,A=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=o.indexOf("Linux")>=0,v=!0,f=navigator.language,y=f;else if(typeof E=="object"){A=E.platform==="win32",L=E.platform==="darwin",U=E.platform==="linux",O=U&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,f=k,y=k;const a=E.env.VSCODE_NLS_CONFIG;if(a)try{const c=JSON.parse(a),l=c.availableLanguages["*"];f=c.locale,y=l||k,b=c._translationsConfigFile}catch(c){}m=!0}else console.error("Unable to resolve platform.");var C;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function I(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let g=0;L?g=1:A?g=3:U&&(g=2),e.isWindows=A,e.isMacintosh=L,e.isLinux=U,e.isLinuxSnap=O,e.isNative=m,e.isWeb=v,e.isIOS=R,e.platform=g,e.userAgent=o,e.language=y;var s;(function(a){function c(){return e.language}a.value=c;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=l;function u(){return e.language==="en"}a.isDefault=u})(s=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let p=0,h=l.length;p<h;p++){const P=l[p];if(P.id===d.data.vscodeSetImmediateId){l.splice(p,1),P.callback();return}}});let u=0;return d=>{const p=++u;l.push({id:p,callback:d}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof(E==null?void 0:E.nextTick)=="function")return E.nextTick.bind(E);const c=Promise.resolve();return l=>c.then(l)}();var r;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||R?2:A?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(Z[36],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof S.globals.vscode!="undefined"){const A=S.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(L){return(0,S.setImmediate)(L)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(A){return(0,S.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,36]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,L=90,U=122,O=46,m=47,v=92,R=58,f=63;class y extends Error{constructor(s,r,t){let i;typeof r=="string"&&r.indexOf("not ")===0?(i="must not be",r=r.replace(/^not /,"")):i="must be";const n=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${n} ${i} of type ${r}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function b(g,s){if(typeof g!="string")throw new y(s,"string",g)}function o(g){return g===m||g===v}function E(g){return g===m}function w(g){return g>=k&&g<=L||g>=A&&g<=U}function C(g,s,r,t){let i="",n=0,a=-1,c=0,l=0;for(let u=0;u<=g.length;++u){if(u<g.length)l=g.charCodeAt(u);else{if(t(l))break;l=m}if(t(l)){if(!(a===u-1||c===1))if(c===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==O||i.charCodeAt(i.length-2)!==O){if(i.length>2){const d=i.lastIndexOf(r);d===-1?(i="",n=0):(i=i.slice(0,d),n=i.length-1-i.lastIndexOf(r)),a=u,c=0;continue}else if(i.length!==0){i="",n=0,a=u,c=0;continue}}s&&(i+=i.length>0?`${r}..`:"..",n=2)}else i.length>0?i+=`${r}${g.slice(a+1,u)}`:i=g.slice(a+1,u),n=u-a-1;a=u,c=0}else l===O&&c!==-1?++c:c=-1}return i}function I(g,s){if(s===null||typeof s!="object")throw new y("pathObject","Object",s);const r=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${t}`:`${r}${g}${t}`:t}e.win32={resolve(...g){let s="",r="",t=!1;for(let i=g.length-1;i>=-1;i--){let n;if(i>=0){if(n=g[i],b(n,"path"),n.length===0)continue}else s.length===0?n=S.cwd():(n=S.env[`=${s}`]||S.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==s.toLowerCase()&&n.charCodeAt(2)===v)&&(n=`${s}\\`));const a=n.length;let c=0,l="",u=!1;const d=n.charCodeAt(0);if(a===1)o(d)&&(c=1,u=!0);else if(o(d))if(u=!0,o(n.charCodeAt(1))){let p=2,h=p;for(;p<a&&!o(n.charCodeAt(p));)p++;if(p<a&&p!==h){const P=n.slice(h,p);for(h=p;p<a&&o(n.charCodeAt(p));)p++;if(p<a&&p!==h){for(h=p;p<a&&!o(n.charCodeAt(p));)p++;(p===a||p!==h)&&(l=`\\\\${P}\\${n.slice(h,p)}`,c=p)}}}else c=1;else w(d)&&n.charCodeAt(1)===R&&(l=n.slice(0,2),c=2,a>2&&o(n.charCodeAt(2))&&(u=!0,c=3));if(l.length>0)if(s.length>0){if(l.toLowerCase()!==s.toLowerCase())continue}else s=l;if(t){if(s.length>0)break}else if(r=`${n.slice(c)}\\${r}`,t=u,u&&s.length>0)break}return r=C(r,!t,"\\",o),t?`${s}\\${r}`:`${s}${r}`||"."},normalize(g){b(g,"path");const s=g.length;if(s===0)return".";let r=0,t,i=!1;const n=g.charCodeAt(0);if(s===1)return E(n)?"\\":g;if(o(n))if(i=!0,o(g.charCodeAt(1))){let c=2,l=c;for(;c<s&&!o(g.charCodeAt(c));)c++;if(c<s&&c!==l){const u=g.slice(l,c);for(l=c;c<s&&o(g.charCodeAt(c));)c++;if(c<s&&c!==l){for(l=c;c<s&&!o(g.charCodeAt(c));)c++;if(c===s)return`\\\\${u}\\${g.slice(l)}\\`;c!==l&&(t=`\\\\${u}\\${g.slice(l,c)}`,r=c)}}}else r=1;else w(n)&&g.charCodeAt(1)===R&&(t=g.slice(0,2),r=2,s>2&&o(g.charCodeAt(2))&&(i=!0,r=3));let a=r<s?C(g.slice(r),!i,"\\",o):"";return a.length===0&&!i&&(a="."),a.length>0&&o(g.charCodeAt(s-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(g){b(g,"path");const s=g.length;if(s===0)return!1;const r=g.charCodeAt(0);return o(r)||s>2&&w(r)&&g.charCodeAt(1)===R&&o(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let s,r;for(let n=0;n<g.length;++n){const a=g[n];b(a,"path"),a.length>0&&(s===void 0?s=r=a:s+=`\\${a}`)}if(s===void 0)return".";let t=!0,i=0;if(typeof r=="string"&&o(r.charCodeAt(0))){++i;const n=r.length;n>1&&o(r.charCodeAt(1))&&(++i,n>2&&(o(r.charCodeAt(2))?++i:t=!1))}if(t){for(;i<s.length&&o(s.charCodeAt(i));)i++;i>=2&&(s=`\\${s.slice(i)}`)}return e.win32.normalize(s)},relative(g,s){if(b(g,"from"),b(s,"to"),g===s)return"";const r=e.win32.resolve(g),t=e.win32.resolve(s);if(r===t||(g=r.toLowerCase(),s=t.toLowerCase(),g===s))return"";let i=0;for(;i<g.length&&g.charCodeAt(i)===v;)i++;let n=g.length;for(;n-1>i&&g.charCodeAt(n-1)===v;)n--;const a=n-i;let c=0;for(;c<s.length&&s.charCodeAt(c)===v;)c++;let l=s.length;for(;l-1>c&&s.charCodeAt(l-1)===v;)l--;const u=l-c,d=a<u?a:u;let p=-1,h=0;for(;h<d;h++){const _=g.charCodeAt(i+h);if(_!==s.charCodeAt(c+h))break;_===v&&(p=h)}if(h!==d){if(p===-1)return t}else{if(u>d){if(s.charCodeAt(c+h)===v)return t.slice(c+h+1);if(h===2)return t.slice(c+h)}a>d&&(g.charCodeAt(i+h)===v?p=h:h===2&&(p=3)),p===-1&&(p=0)}let P="";for(h=i+p+1;h<=n;++h)(h===n||g.charCodeAt(h)===v)&&(P+=P.length===0?"..":"\\..");return c+=p,P.length>0?`${P}${t.slice(c,l)}`:(t.charCodeAt(c)===v&&++c,t.slice(c,l))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const s=e.win32.resolve(g);if(s.length<=2)return g;if(s.charCodeAt(0)===v){if(s.charCodeAt(1)===v){const r=s.charCodeAt(2);if(r!==f&&r!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===v)return`\\\\?\\${s}`;return g},dirname(g){b(g,"path");const s=g.length;if(s===0)return".";let r=-1,t=0;const i=g.charCodeAt(0);if(s===1)return o(i)?g:".";if(o(i)){if(r=t=1,o(g.charCodeAt(1))){let c=2,l=c;for(;c<s&&!o(g.charCodeAt(c));)c++;if(c<s&&c!==l){for(l=c;c<s&&o(g.charCodeAt(c));)c++;if(c<s&&c!==l){for(l=c;c<s&&!o(g.charCodeAt(c));)c++;if(c===s)return g;c!==l&&(r=t=c+1)}}}}else w(i)&&g.charCodeAt(1)===R&&(r=s>2&&o(g.charCodeAt(2))?3:2,t=r);let n=-1,a=!0;for(let c=s-1;c>=t;--c)if(o(g.charCodeAt(c))){if(!a){n=c;break}}else a=!1;if(n===-1){if(r===-1)return".";n=r}return g.slice(0,n)},basename(g,s){s!==void 0&&b(s,"ext"),b(g,"path");let r=0,t=-1,i=!0,n;if(g.length>=2&&w(g.charCodeAt(0))&&g.charCodeAt(1)===R&&(r=2),s!==void 0&&s.length>0&&s.length<=g.length){if(s===g)return"";let a=s.length-1,c=-1;for(n=g.length-1;n>=r;--n){const l=g.charCodeAt(n);if(o(l)){if(!i){r=n+1;break}}else c===-1&&(i=!1,c=n+1),a>=0&&(l===s.charCodeAt(a)?--a==-1&&(t=n):(a=-1,t=c))}return r===t?t=c:t===-1&&(t=g.length),g.slice(r,t)}for(n=g.length-1;n>=r;--n)if(o(g.charCodeAt(n))){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":g.slice(r,t)},extname(g){b(g,"path");let s=0,r=-1,t=0,i=-1,n=!0,a=0;g.length>=2&&g.charCodeAt(1)===R&&w(g.charCodeAt(0))&&(s=t=2);for(let c=g.length-1;c>=s;--c){const l=g.charCodeAt(c);if(o(l)){if(!n){t=c+1;break}continue}i===-1&&(n=!1,i=c+1),l===O?r===-1?r=c:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||i===-1||a===0||a===1&&r===i-1&&r===t+1?"":g.slice(r,i)},format:I.bind(null,"\\"),parse(g){b(g,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return s;const r=g.length;let t=0,i=g.charCodeAt(0);if(r===1)return o(i)?(s.root=s.dir=g,s):(s.base=s.name=g,s);if(o(i)){if(t=1,o(g.charCodeAt(1))){let p=2,h=p;for(;p<r&&!o(g.charCodeAt(p));)p++;if(p<r&&p!==h){for(h=p;p<r&&o(g.charCodeAt(p));)p++;if(p<r&&p!==h){for(h=p;p<r&&!o(g.charCodeAt(p));)p++;p===r?t=p:p!==h&&(t=p+1)}}}}else if(w(i)&&g.charCodeAt(1)===R){if(r<=2)return s.root=s.dir=g,s;if(t=2,o(g.charCodeAt(2))){if(r===3)return s.root=s.dir=g,s;t=3}}t>0&&(s.root=g.slice(0,t));let n=-1,a=t,c=-1,l=!0,u=g.length-1,d=0;for(;u>=t;--u){if(i=g.charCodeAt(u),o(i)){if(!l){a=u+1;break}continue}c===-1&&(l=!1,c=u+1),i===O?n===-1?n=u:d!==1&&(d=1):n!==-1&&(d=-1)}return c!==-1&&(n===-1||d===0||d===1&&n===c-1&&n===a+1?s.base=s.name=g.slice(a,c):(s.name=g.slice(a,n),s.base=g.slice(a,c),s.ext=g.slice(n,c))),a>0&&a!==t?s.dir=g.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let s="",r=!1;for(let t=g.length-1;t>=-1&&!r;t--){const i=t>=0?g[t]:S.cwd();b(i,"path"),i.length!==0&&(s=`${i}/${s}`,r=i.charCodeAt(0)===m)}return s=C(s,!r,"/",E),r?`/${s}`:s.length>0?s:"."},normalize(g){if(b(g,"path"),g.length===0)return".";const s=g.charCodeAt(0)===m,r=g.charCodeAt(g.length-1)===m;return g=C(g,!s,"/",E),g.length===0?s?"/":r?"./":".":(r&&(g+="/"),s?`/${g}`:g)},isAbsolute(g){return b(g,"path"),g.length>0&&g.charCodeAt(0)===m},join(...g){if(g.length===0)return".";let s;for(let r=0;r<g.length;++r){const t=g[r];b(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(g,s){if(b(g,"from"),b(s,"to"),g===s||(g=e.posix.resolve(g),s=e.posix.resolve(s),g===s))return"";const r=1,t=g.length,i=t-r,n=1,a=s.length-n,c=i<a?i:a;let l=-1,u=0;for(;u<c;u++){const p=g.charCodeAt(r+u);if(p!==s.charCodeAt(n+u))break;p===m&&(l=u)}if(u===c)if(a>c){if(s.charCodeAt(n+u)===m)return s.slice(n+u+1);if(u===0)return s.slice(n+u)}else i>c&&(g.charCodeAt(r+u)===m?l=u:u===0&&(l=0));let d="";for(u=r+l+1;u<=t;++u)(u===t||g.charCodeAt(u)===m)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(n+l)}`},toNamespacedPath(g){return g},dirname(g){if(b(g,"path"),g.length===0)return".";const s=g.charCodeAt(0)===m;let r=-1,t=!0;for(let i=g.length-1;i>=1;--i)if(g.charCodeAt(i)===m){if(!t){r=i;break}}else t=!1;return r===-1?s?"/":".":s&&r===1?"//":g.slice(0,r)},basename(g,s){s!==void 0&&b(s,"ext"),b(g,"path");let r=0,t=-1,i=!0,n;if(s!==void 0&&s.length>0&&s.length<=g.length){if(s===g)return"";let a=s.length-1,c=-1;for(n=g.length-1;n>=0;--n){const l=g.charCodeAt(n);if(l===m){if(!i){r=n+1;break}}else c===-1&&(i=!1,c=n+1),a>=0&&(l===s.charCodeAt(a)?--a==-1&&(t=n):(a=-1,t=c))}return r===t?t=c:t===-1&&(t=g.length),g.slice(r,t)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===m){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":g.slice(r,t)},extname(g){b(g,"path");let s=-1,r=0,t=-1,i=!0,n=0;for(let a=g.length-1;a>=0;--a){const c=g.charCodeAt(a);if(c===m){if(!i){r=a+1;break}continue}t===-1&&(i=!1,t=a+1),c===O?s===-1?s=a:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||t===-1||n===0||n===1&&s===t-1&&s===r+1?"":g.slice(s,t)},format:I.bind(null,"/"),parse(g){b(g,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return s;const r=g.charCodeAt(0)===m;let t;r?(s.root="/",t=1):t=0;let i=-1,n=0,a=-1,c=!0,l=g.length-1,u=0;for(;l>=t;--l){const d=g.charCodeAt(l);if(d===m){if(!c){n=l+1;break}continue}a===-1&&(c=!1,a=l+1),d===O?i===-1?i=l:u!==1&&(u=1):i!==-1&&(u=-1)}if(a!==-1){const d=n===0&&r?1:n;i===-1||u===0||u===1&&i===a-1&&i===n+1?s.base=s.name=g.slice(d,a):(s.name=g.slice(d,i),s.base=g.slice(d,a),s.ext=g.slice(i,a))}return n>0?s.dir=g.slice(0,n-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var k in S)(typeof exports=="object"?exports:K)[k]=S[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function S(k){if(e[k])return e[k].exports;var A=e[k]={i:k,l:!1,exports:{}};return K[k].call(A.exports,A,A.exports,S),A.l=!0,A.exports}return S.m=K,S.c=e,S.d=function(k,A,L){S.o(k,A)||Object.defineProperty(k,A,{enumerable:!0,get:L})},S.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},S.t=function(k,A){if(1&A&&(k=S(k)),8&A||4&A&&typeof k=="object"&&k&&k.__esModule)return k;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:k}),2&A&&typeof k!="string")for(var U in k)S.d(L,U,function(O){return k[O]}.bind(null,U));return L},S.n=function(k){var A=k&&k.__esModule?function(){return k.default}:function(){return k};return S.d(A,"a",A),A},S.o=function(k,A){return Object.prototype.hasOwnProperty.call(k,A)},S.p="",S(S.s=0)}([function(K,e,S){(function(k){var A;e=K.exports=Q,A=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],m=e.src=[],v=0,R=v++;m[R]="0|[1-9]\\d*";var f=v++;m[f]="[0-9]+";var y=v++;m[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=v++;m[b]="("+m[R]+")\\.("+m[R]+")\\.("+m[R]+")";var o=v++;m[o]="("+m[f]+")\\.("+m[f]+")\\.("+m[f]+")";var E=v++;m[E]="(?:"+m[R]+"|"+m[y]+")";var w=v++;m[w]="(?:"+m[f]+"|"+m[y]+")";var C=v++;m[C]="(?:-("+m[E]+"(?:\\."+m[E]+")*))";var I=v++;m[I]="(?:-?("+m[w]+"(?:\\."+m[w]+")*))";var g=v++;m[g]="[0-9A-Za-z-]+";var s=v++;m[s]="(?:\\+("+m[g]+"(?:\\."+m[g]+")*))";var r=v++,t="v?"+m[b]+m[C]+"?"+m[s]+"?";m[r]="^"+t+"$";var i="[v=\\s]*"+m[o]+m[I]+"?"+m[s]+"?",n=v++;m[n]="^"+i+"$";var a=v++;m[a]="((?:<|>)?=?)";var c=v++;m[c]=m[f]+"|x|X|\\*";var l=v++;m[l]=m[R]+"|x|X|\\*";var u=v++;m[u]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[C]+")?"+m[s]+"?)?)?";var d=v++;m[d]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[I]+")?"+m[s]+"?)?)?";var p=v++;m[p]="^"+m[a]+"\\s*"+m[u]+"$";var h=v++;m[h]="^"+m[a]+"\\s*"+m[d]+"$";var P=v++;m[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;m[_]="(?:~>?)";var j=v++;m[j]="(\\s*)"+m[_]+"\\s+",O[j]=new RegExp(m[j],"g");var B=v++;m[B]="^"+m[_]+m[u]+"$";var M=v++;m[M]="^"+m[_]+m[d]+"$";var $=v++;m[$]="(?:\\^)";var V=v++;m[V]="(\\s*)"+m[$]+"\\s+",O[V]=new RegExp(m[V],"g");var q=v++;m[q]="^"+m[$]+m[u]+"$";var H=v++;m[H]="^"+m[$]+m[d]+"$";var z=v++;m[z]="^"+m[a]+"\\s*("+i+")$|^$";var D=v++;m[D]="^"+m[a]+"\\s*("+t+")$|^$";var T=v++;m[T]="(\\s*)"+m[a]+"\\s*("+i+"|"+m[u]+")",O[T]=new RegExp(m[T],"g");var F=v++;m[F]="^\\s*("+m[u]+")\\s+-\\s+("+m[u]+")\\s*$";var N=v++;m[N]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var x=v++;m[x]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)A(G,m[G]),O[G]||(O[G]=new RegExp(m[G]));function J(X,re){if(X instanceof Q)return X;if(typeof X!="string"||X.length>L||!(re?O[n]:O[r]).test(X))return null;try{return new Q(X,re)}catch(se){return null}}function Q(X,re){if(X instanceof Q){if(X.loose===re)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(X,re);A("SemVer",X,re),this.loose=re;var se=X.trim().match(re?O[n]:O[r]);if(!se)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var W=+me;if(W>=0&&W<U)return W}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,re){var se=J(X,re);return se?se.version:null},e.clean=function(X,re){var se=J(X.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return A("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),ie(this.major,X.major)||ie(this.minor,X.minor)||ie(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=X.prerelease[re];if(A("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ie(se,me)}while(++re)},Q.prototype.inc=function(X,re){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(X,se).inc(re,me).version}catch(W){return null}},e.diff=function(X,re){if(Ee(X,re))return null;var se=J(X),me=J(re);if(se.prerelease.length||me.prerelease.length){for(var W in se)if((W==="major"||W==="minor"||W==="patch")&&se[W]!==me[W])return"pre"+W;return"prerelease"}for(var W in se)if((W==="major"||W==="minor"||W==="patch")&&se[W]!==me[W])return W},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(X,re){var se=ne.test(X),me=ne.test(re);return se&&me&&(X=+X,re=+re),se&&!me?-1:me&&!se?1:X<re?-1:X>re?1:0}function ce(X,re,se){return new Q(X,se).compare(new Q(re,se))}function ue(X,re,se){return ce(X,re,se)>0}function ge(X,re,se){return ce(X,re,se)<0}function Ee(X,re,se){return ce(X,re,se)===0}function Ie(X,re,se){return ce(X,re,se)!==0}function Oe(X,re,se){return ce(X,re,se)>=0}function Ae(X,re,se){return ce(X,re,se)<=0}function Ue(X,re,se,me){var W;switch(re){case"===":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),W=X===se;break;case"!==":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),W=X!==se;break;case"":case"=":case"==":W=Ee(X,se,me);break;case"!=":W=Ie(X,se,me);break;case">":W=ue(X,se,me);break;case">=":W=Oe(X,se,me);break;case"<":W=ge(X,se,me);break;case"<=":W=Ae(X,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return W}function ke(X,re){if(X instanceof ke){if(X.loose===re)return X;X=X.value}if(!(this instanceof ke))return new ke(X,re);A("comparator",X,re),this.loose=re,this.parse(X),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(X,re){return ie(re,X)},e.major=function(X,re){return new Q(X,re).major},e.minor=function(X,re){return new Q(X,re).minor},e.patch=function(X,re){return new Q(X,re).patch},e.compare=ce,e.compareLoose=function(X,re){return ce(X,re,!0)},e.rcompare=function(X,re,se){return ce(re,X,se)},e.sort=function(X,re){return X.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(X,re){return X.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=ue,e.lt=ge,e.eq=Ee,e.neq=Ie,e.gte=Oe,e.lte=Ae,e.cmp=Ue,e.Comparator=ke;var Ne={};function De(X,re){if(X instanceof De)return X.loose===re?X:new De(X.raw,re);if(X instanceof ke)return new De(X.value,re);if(!(this instanceof De))return new De(X,re);if(this.loose=re,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Te(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ge(X,re,se,me,W,te,oe,ae,le,fe,ve,Se,we){return((re=Te(se)?"":Te(me)?">="+se+".0.0":Te(W)?">="+se+"."+me+".0":">="+re)+" "+(ae=Te(le)?"":Te(fe)?"<"+(+le+1)+".0.0":Te(ve)?"<"+le+"."+(+fe+1)+".0":Se?"<="+le+"."+fe+"."+ve+"-"+Se:"<="+ae)).trim()}function Ke(X,re){for(var se=0;se<X.length;se++)if(!X[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<X.length;se++)if(A(X[se].semver),X[se].semver!==Ne&&X[se].semver.prerelease.length>0){var me=X[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(X,re,se){try{re=new De(re,se)}catch(me){return!1}return re.test(X)}function ze(X,re,se,me){var W,te,oe,ae,le;switch(X=new Q(X,me),re=new De(re,me),se){case">":W=ue,te=Ae,oe=ge,ae=">",le=">=";break;case"<":W=ge,te=Oe,oe=ue,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(X,re,me))return!1;for(var fe=0;fe<re.set.length;++fe){var ve=re.set[fe],Se=null,we=null;if(ve.forEach(function(be){be.semver===Ne&&(be=new ke(">=0.0.0")),Se=Se||be,we=we||be,W(be.semver,Se.semver,me)?Se=be:oe(be.semver,we.semver,me)&&(we=be)}),Se.operator===ae||Se.operator===le||(!we.operator||we.operator===ae)&&te(X,we.semver)||we.operator===le&&oe(X,we.semver))return!1}return!0}ke.prototype.parse=function(X){var re=this.loose?O[z]:O[D],se=X.match(re);if(!se)throw new TypeError("Invalid comparator: "+X);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=Ne},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return A("Comparator.test",X,this.loose),this.semver===Ne||(typeof X=="string"&&(X=new Q(X,this.loose)),Ue(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,re){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new De(X.value,re),$e(this.value,se,re);if(X.operator==="")return se=new De(this.value,re),$e(X.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),W=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),te=this.semver.version===X.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Ue(this.semver,"<",X.semver,re)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Ue(this.semver,">",X.semver,re)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return me||W||te&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(X){var re=this.loose;X=X.trim(),A("range",X,re);var se=re?O[N]:O[F];X=X.replace(se,Ge),A("hyphen replace",X),X=X.replace(O[T],"$1$2$3"),A("comparator trim",X,O[T]),X=(X=(X=X.replace(O[j],"$1~")).replace(O[V],"$1^")).split(/\s+/).join(" ");var me=re?O[z]:O[D],W=X.split(" ").map(function(te){return function(oe,ae){return A("comp",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){A("caret",Se,we);var be=we?O[H]:O[q];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("caret",Se,Pe,ye,pe,Ce,Re),Te(ye)?de="":Te(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te(Ce)?de=ye==="0"?">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+".0 <"+(+ye+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+Re+" <"+(+ye+1)+".0.0"):(A("no pr"),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+" <"+(+ye+1)+".0.0"),A("caret return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("caret",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){var be=we?O[M]:O[B];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("tilde",Se,Pe,ye,pe,Ce,Re),Te(ye)?de="":Te(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te(Ce)?de=">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0"):de=">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0",A("tilde return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("tildes",oe),oe=function(le,fe){return A("replaceXRanges",le,fe),le.split(/\s+/).map(function(ve){return function(Se,we){Se=Se.trim();var be=we?O[h]:O[p];return Se.replace(be,function(Pe,ye,pe,Ce,Re,de){A("xRange",Se,Pe,ye,pe,Ce,Re,de);var Le=Te(pe),_e=Le||Te(Ce),Fe=_e||Te(Re);return ye==="="&&Fe&&(ye=""),Le?Pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Fe?(_e&&(Ce=0),Fe&&(Re=0),ye===">"?(ye=">=",_e?(pe=+pe+1,Ce=0,Re=0):Fe&&(Ce=+Ce+1,Re=0)):ye==="<="&&(ye="<",_e?pe=+pe+1:Ce=+Ce+1),Pe=ye+pe+"."+Ce+"."+Re):_e?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":Fe&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),A("xRange return",Pe),Pe})}(ve,fe)}).join(" ")}(oe,ae),A("xrange",oe),oe=function(le,fe){return A("replaceStars",le,fe),le.trim().replace(O[x],"")}(oe,ae),A("stars",oe),oe}(te,re)}).join(" ").split(/\s+/);return this.loose&&(W=W.filter(function(te){return!!te.match(me)})),W=W.map(function(te){return new ke(te,re)})},De.prototype.intersects=function(X,re){if(!(X instanceof De))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return X.set.some(function(W){return W.every(function(te){return me.intersects(te,re)})})})})},e.toComparators=function(X,re){return new De(X,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var re=0;re<this.set.length;re++)if(Ke(this.set[re],X))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(X,re,se){var me=null,W=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&W.compare(oe)!==-1||(W=new Q(me=oe,se)))}),me},e.minSatisfying=function(X,re,se){var me=null,W=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&W.compare(oe)!==1||(W=new Q(me=oe,se)))}),me},e.validRange=function(X,re){try{return new De(X,re).range||"*"}catch(se){return null}},e.ltr=function(X,re,se){return ze(X,re,"<",se)},e.gtr=function(X,re,se){return ze(X,re,">",se)},e.outside=ze,e.prerelease=function(X,re){var se=J(X,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(X,re,se){return X=new De(X,se),re=new De(re,se),X.intersects(re)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var re=X.match(O[P]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,S(1))},function(K,e){var S,k,A=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function O(w){if(S===setTimeout)return setTimeout(w,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch(C){try{return S.call(null,w,0)}catch(I){return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch(w){S=L}try{k=typeof clearTimeout=="function"?clearTimeout:U}catch(w){k=U}})();var m,v=[],R=!1,f=-1;function y(){R&&m&&(R=!1,m.length?v=m.concat(v):f=-1,v.length&&b())}function b(){if(!R){var w=O(y);R=!0;for(var C=v.length;C;){for(m=v,v=[];++f<C;)m&&m[f].run();f=-1,C=v.length}m=null,R=!1,function(I){if(k===clearTimeout)return clearTimeout(I);if((k===U||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(I);try{k(I)}catch(g){try{return k.call(null,I)}catch(s){return k.call(this,I)}}}(w)}}function o(w,C){this.fun=w,this.array=C}function E(){}A.nextTick=function(w){var C=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)C[I-1]=arguments[I];v.push(new o(w,C)),v.length!==1||R||O(b)},o.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=E,A.addListener=E,A.once=E,A.off=E,A.removeListener=E,A.removeAllListeners=E,A.emit=E,A.prependListener=E,A.prependOnceListener=E,A.listeners=function(w){return[]},A.binding=function(w){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(w){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[86],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=S.globals.performance&&typeof S.globals.performance.now=="function";class A{constructor(U){this._highResolution=k&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new A(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,11,63,2,64,86]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var O;(function(C){C.None=()=>A.Disposable.None;function I(M){return($,V=null,q)=>{let H=!1,z;return z=M(D=>{if(!H)return z?z.dispose():H=!0,$.call(V,D)},null,q),H&&z.dispose(),z}}C.once=I;function g(M,$){return a((V,q=null,H)=>M(z=>V.call(q,$(z)),null,H))}C.map=g;function s(M,$){return a((V,q=null,H)=>M(z=>{$(z),V.call(q,z)},null,H))}C.forEach=s;function r(M,$){return a((V,q=null,H)=>M(z=>$(z)&&V.call(q,z),null,H))}C.filter=r;function t(M){return M}C.signal=t;function i(...M){return($,V=null,q)=>(0,A.combinedDisposable)(...M.map(H=>H(z=>$.call(V,z),null,q)))}C.any=i;function n(M,$,V){let q=V;return g(M,H=>(q=$(q,H),q))}C.reduce=n;function a(M){let $;const V=new y({onFirstListenerAdd(){$=M(V.fire,V)},onLastListenerRemove(){$.dispose()}});return V.event}C.snapshot=a;function c(M,$,V=100,q=!1,H){let z,D,T,F=0;const N=new y({leakWarningThreshold:H,onFirstListenerAdd(){z=M(x=>{F++,D=$(D,x),q&&!T&&(N.fire(D),D=void 0),clearTimeout(T),T=setTimeout(()=>{const G=D;D=void 0,T=void 0,(!q||F>1)&&N.fire(G),F=0},V)})},onLastListenerRemove(){z.dispose()}});return N.event}C.debounce=c;function l(M){const $=new Date().getTime();return g(I(M),V=>new Date().getTime()-$)}C.stopwatch=l;function u(M){let $=!0,V;return r(M,q=>{const H=$||q!==V;return $=!1,V=q,H})}C.latch=u;function d(M,$=!1,V=[]){let q=V.slice(),H=M(T=>{q?q.push(T):D.fire(T)});const z=()=>{q&&q.forEach(T=>D.fire(T)),q=null},D=new y({onFirstListenerAdd(){H||(H=M(T=>D.fire(T)))},onFirstListenerDidAdd(){q&&($?setTimeout(z):z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return D.event}C.buffer=d;class p{constructor($){this.event=$}map($){return new p(g(this.event,$))}forEach($){return new p(s(this.event,$))}filter($){return new p(r(this.event,$))}reduce($,V){return new p(n(this.event,$,V))}latch(){return new p(u(this.event))}debounce($,V=100,q=!1,H){return new p(c(this.event,$,V,q,H))}on($,V,q){return this.event($,V,q)}once($,V,q){return I(this.event)($,V,q)}}function h(M){return new p(M)}C.chain=h;function P(M,$,V=q=>q){const q=(...T)=>D.fire(V(...T)),H=()=>M.on($,q),z=()=>M.removeListener($,q),D=new y({onFirstListenerAdd:H,onLastListenerRemove:z});return D.event}C.fromNodeEventEmitter=P;function _(M,$,V=q=>q){const q=(...T)=>D.fire(V(...T)),H=()=>M.addEventListener($,q),z=()=>M.removeEventListener($,q),D=new y({onFirstListenerAdd:H,onLastListenerRemove:z});return D.event}C.fromDOMEventEmitter=_;function j(M){const $=new y;let V=!1;return M.then(void 0,()=>null).then(()=>{V?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),V=!0,$.event}C.fromPromise=j;function B(M){return new Promise($=>I(M)($))}C.toPromise=B})(O=e.Event||(e.Event={}));class m{constructor(I){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${I}_${m._idPool++}`}start(I){this._stopWatch=new U.StopWatch(!0),this._listenerCount=I}stop(){if(this._stopWatch){const I=this._stopWatch.elapsed();this._elapsedOverall+=I,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${I.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let v=-1;function R(C){const I=v;return v=C,{dispose(){v=I}}}e.setGlobalLeakWarningThreshold=R;class f{constructor(I,g=Math.random().toString(18).slice(2,5)){this.customThreshold=I,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(I){let g=v;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),!(g<=0||I<g)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,i=0;for(const[n,a]of this._stacks)(!t||i<a)&&(t=n,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}}class y{constructor(I){var g;this._disposed=!1,this._options=I,this._leakageMon=v>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(I,g,s)=>{var r;this._listeners||(this._listeners=new L.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(g?[I,g]:I);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,I,g);const n=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size);let a;return a={dispose:()=>{n&&n(),a.dispose=y._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof A.DisposableStore?s.add(a):Array.isArray(s)&&s.push(a),a}),this._event}fire(I){var g,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,I]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,t]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,t):r[0].call(r[1],t)}catch(i){(0,S.onUnexpectedError)(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var I,g,s;(I=this._listeners)===null||I===void 0||I.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(s=this._leakageMon)===null||s===void 0||s.dispose(),this._disposed=!0}}e.Emitter=y,y._noop=function(){};class b extends y{constructor(I){super(I);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=I==null?void 0:I.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const I=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(I))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(I){this._listeners&&(this._isPaused!==0?this._eventQueue.push(I):super.fire(I))}}e.PauseableEmitter=b;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(I){const g={event:I,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const s=()=>{this.hasListeners&&this.unhook(g);const r=this.events.indexOf(g);this.events.splice(r,1)};return(0,A.toDisposable)((0,k.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(I=>this.hook(I))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(I=>this.unhook(I))}hook(I){I.listener=I.event(g=>this.emitter.fire(g))}unhook(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class E{constructor(){this.buffers=[]}wrapEvent(I){return(g,s,r)=>I(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>g.call(s,t)):g.call(s,t)},void 0,r)}bufferEvents(I){const g=[];this.buffers.push(g);const s=I();return this.buffers.pop(),g.forEach(r=>r()),s}}e.EventBufferer=E;class w{constructor(){this.listening=!1,this.inputEvent=O.None,this.inputEventListener=A.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(I){this.inputEvent=I,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=I(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(Z[30],ee([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(O,m){const v=setTimeout(O.bind(m),0);return{dispose(){clearTimeout(v)}}});var A;(function(O){function m(v){return v===O.None||v===O.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}O.isCancellationToken=m,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=A.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=U}),define(Z[47],ee([0,1,11,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(g){const s=g;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=A;function L(g){const s=g;return s?A(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=L;function U(g,s){return new O(g,s)}e.newWriteableStream=U;class O{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,S.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(r);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(g,s){const r=[];let t;for(;(t=g.read())!==null;)r.push(t);return s(r)}e.consumeReadable=m;function v(g,s,r){const t=[];let i;for(;(i=g.read())!==null&&t.length<r;)t.push(i);return i===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return g.read()}}}e.peekReadable=v;function R(g,s){return new Promise((r,t)=>{const i=[];f(g,{onData:n=>{s&&i.push(n)},onError:n=>{s?t(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}e.consumeStream=R;function f(g,s){g.on("error",r=>s.onError(r)),g.on("end",()=>s.onEnd()),g.on("data",r=>s.onData(r))}e.listenStream=f;function y(g,s){return new Promise((r,t)=>{const i=new k.DisposableStore,n=[],a=u=>{if(n.push(u),n.length>s)return i.dispose(),g.pause(),r({stream:g,buffer:n,ended:!1})},c=u=>t(u),l=()=>r({stream:g,buffer:n,ended:!0});i.add((0,k.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),i.add((0,k.toDisposable)(()=>g.removeListener("end",l))),g.on("end",l),i.add((0,k.toDisposable)(()=>g.removeListener("data",a))),g.on("data",a)})}e.peekStream=y;function b(g,s){const r=U(s);return r.end(g),r}e.toStream=b;function o(){const g=U(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=o;function E(g){let s=!1;return{read:()=>s?null:(s=!0,g)}}e.toReadable=E;function w(g,s,r){const t=U(r);return f(g,{onData:i=>t.write(s.data(i)),onError:i=>t.error(s.error?s.error(i):i),onEnd:()=>t.end()}),t}e.transform=w;function C(g,s,r){let t=!1;return{read:()=>{const i=s.read();return t?i:(t=!0,i!==null?r([g,i]):g)}}}e.prefixedReadable=C;function I(g,s,r){let t=!1;const i=U(r);return f(s,{onData:n=>t?i.write(n):(t=!0,i.write(r([g,n]))),onError:n=>i.error(n),onEnd:()=>{t||(t=!0,i.write(g)),i.end()}}),i}e.prefixedStream=I}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function S(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=S;const k=/{(\d+)}/g;function A(W,...te){return te.length===0?W:W.replace(k,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=te.length?oe:te[le]})}e.format=A;function L(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=L;function U(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function O(W,te){let oe=0;const ae=te.charCodeAt(0);for(let le=W.length-1;le>=0;le--)W.charCodeAt(le)===ae&&oe++;return oe}e.count=O;function m(W,te,oe="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${oe}`}e.truncate=m;function v(W,te=" "){const oe=R(W,te);return f(oe,te)}e.trim=v;function R(W,te){if(!W||!te)return W;const oe=te.length;if(oe===0||W.length===0)return W;let ae=0;for(;W.indexOf(te,ae)===ae;)ae=ae+oe;return W.substring(ae)}e.ltrim=R;function f(W,te){if(!W||!te)return W;const oe=te.length,ae=W.length;if(oe===0||ae===0)return W;let le=ae,fe=-1;for(;fe=W.lastIndexOf(te,le-1),!(fe===-1||fe+oe!==le);){if(fe===0)return"";le=fe}return W.substring(0,le)}e.rtrim=f;function y(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function b(W){return W.replace(/\*/g,"")}e.stripWildcards=b;function o(W,te,oe={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=U(W)),oe.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(W,ae)}e.createRegExp=o;function E(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function w(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function C(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=C;function I(W){return W.split(/\r\n|\r|\n/)}e.splitLines=I;function g(W){for(let te=0,oe=W.length;te<oe;te++){const ae=W.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=g;function s(W,te=0,oe=W.length){for(let ae=te;ae<oe;ae++){const le=W.charCodeAt(ae);if(le!==32&&le!==9)return W.substring(te,ae)}return W.substring(te,oe)}e.getLeadingWhitespace=s;function r(W,te=W.length-1){for(let oe=te;oe>=0;oe--){const ae=W.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function t(W,te){return W<te?-1:W>te?1:0}e.compare=t;function i(W,te,oe=0,ae=W.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=W.charCodeAt(oe),be=te.charCodeAt(le);if(we<be)return-1;if(we>be)return 1}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstring=i;function n(W,te){return a(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=n;function a(W,te,oe=0,ae=W.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=W.charCodeAt(oe),be=te.charCodeAt(le);if(we!==be){const Pe=we-be;if(!(Pe===32&&l(be))&&!(Pe===-32&&l(we)))return c(we)&&c(be)?Pe:i(W.toLowerCase(),te.toLowerCase(),oe,ae,le,fe)}}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstringIgnoreCase=a;function c(W){return W>=97&&W<=122}e.isLowerAsciiLetter=c;function l(W){return W>=65&&W<=90}e.isUpperAsciiLetter=l;function u(W){return c(W)||l(W)}function d(W,te){return W.length===te.length&&p(W,te)}e.equalsIgnoreCase=d;function p(W,te,oe=W.length){for(let ae=0;ae<oe;ae++){const le=W.charCodeAt(ae),fe=te.charCodeAt(ae);if(le!==fe){if(u(le)&&u(fe)){const ve=Math.abs(le-fe);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function h(W,te){const oe=te.length;return te.length>W.length?!1:p(W,te,oe)}e.startsWithIgnoreCase=h;function P(W,te){let oe,ae=Math.min(W.length,te.length);for(oe=0;oe<ae;oe++)if(W.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(W,te){let oe,ae=Math.min(W.length,te.length);const le=W.length-1,fe=te.length-1;for(oe=0;oe<ae;oe++)if(W.charCodeAt(le-oe)!==te.charCodeAt(fe-oe))return oe;return ae}e.commonSuffixLength=_;function j(W){return 55296<=W&&W<=56319}e.isHighSurrogate=j;function B(W){return 56320<=W&&W<=57343}e.isLowSurrogate=B;function M(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=M;function $(W,te,oe){const ae=W.charCodeAt(oe);if(j(ae)&&oe+1<te){const le=W.charCodeAt(oe+1);if(B(le))return M(ae,le)}return ae}e.getNextCodePoint=$;function V(W,te){const oe=W.charCodeAt(te-1);if(B(oe)&&te>1){const ae=W.charCodeAt(te-2);if(j(ae))return M(ae,oe)}return oe}function q(W,te){const oe=se.getInstance(),ae=te,le=W.length,fe=$(W,le,te);te+=fe>=65536?2:1;let ve=oe.getGraphemeBreakType(fe);for(;te<le;){const Se=$(W,le,te),we=oe.getGraphemeBreakType(Se);if(X(ve,we))break;te+=Se>=65536?2:1,ve=we}return te-ae}e.nextCharLength=q;function H(W,te){const oe=se.getInstance(),ae=te,le=V(W,te);te-=le>=65536?2:1;let fe=oe.getGraphemeBreakType(le);for(;te>0;){const ve=V(W,te),Se=oe.getGraphemeBreakType(ve);if(X(Se,fe))break;te-=ve>=65536?2:1,fe=Se}return ae-te}e.prevCharLength=H;function z(W,te){const oe=se.getInstance(),ae=W.length,le=te,fe=$(W,ae,te),ve=oe.getGraphemeBreakType(fe);te+=fe>=65536?2:1;let Se=ve;for(;te<ae;){const be=$(W,ae,te),Pe=oe.getGraphemeBreakType(be);if(X(Se,Pe))break;te+=be>=65536?2:1,Se=Pe}const we=te;for(te=le,Se=ve;te>0;){const be=V(W,te),Pe=oe.getGraphemeBreakType(be);if(X(Pe,Se))break;te-=be>=65536?2:1,Se=Pe}return[te,we]}function D(W,te){return te>0&&B(W.charCodeAt(te))?z(W,te-1):z(W,te)}e.getCharContainingOffset=D;function T(W){const te=W.length;let oe=0,ae=0;for(;ae<te;){const ve=$(W,te,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let fe=0;for(;ae<te;){const ve=$(W,te,ae);ae+=ve>=65536?2:1,ve<128?le[fe++]=ve:ve<2048?(le[fe++]=192|(ve&1984)>>>6,le[fe++]=128|(ve&63)>>>0):ve<65536?(le[fe++]=224|(ve&61440)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0):(le[fe++]=240|(ve&1835008)>>>18,le[fe++]=128|(ve&258048)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=T;function F(W){const te=W.byteLength,oe=[];let ae=0;for(;ae<te;){const le=W[ae];let fe;if(le>=240&&ae+3<te?fe=(W[ae++]&7)<<18>>>0|(W[ae++]&63)<<12>>>0|(W[ae++]&63)<<6>>>0|(W[ae++]&63)<<0>>>0:le>=224&&ae+2<te?fe=(W[ae++]&15)<<12>>>0|(W[ae++]&63)<<6>>>0|(W[ae++]&63)<<0>>>0:le>=192&&ae+1<te?fe=(W[ae++]&31)<<6>>>0|(W[ae++]&63)<<0>>>0:fe=W[ae++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)oe.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ve=fe-65536,Se=55296+((ve&1047552)>>>10),we=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(Se)),oe.push(String.fromCharCode(we))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(W){return N.test(W)}e.containsRTL=x;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(W){return G.test(W)}e.containsEmoji=J;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(W){return Q.test(W)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=ie;function ce(W){for(let te=0,oe=W.length;te<oe;te++)if(ue(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ue;function ge(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ge;function Ee(W,te){if(W.length<te)return W;const oe=/\b/g;let ae=0;for(;oe.test(W)&&!(W.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return W.substring(ae).replace(/^\s/,"")}e.lcut=Ee;const Ie=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Ue(W){return W&&(W=W.replace(Ie,""),W=W.replace(Oe,""),W=W.replace(Ae,"")),W}e.removeAnsiEscapeCodes=Ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ne(W){return ke(W)?W.substr(1):W}e.stripUTF8BOM=Ne;function De(W,te){if(!W||!te||W.length<te.length)return!1;const oe=te.length,ae=W.toLowerCase();let le=0,fe=-1;for(;le<oe;){const ve=ae.indexOf(te[le],fe+1);if(ve<0)return!1;fe=ve,le++}return!0}e.fuzzyContains=De;function Te(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Te;function Ge(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Ge;function Ke(W,te=1){if(te===0)return"";let oe=-1;do oe=W.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?W:(W[oe-1]==="\r"&&oe--,W.substr(0,oe))}e.getNLines=Ke;function $e(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=$e;function ze(W){return se.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ze;function X(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=X;var re;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(te<oe[3*le])le=2*le;else if(te>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[22],ee([0,1,21,47]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let O,m;class v{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return A?new v(Buffer.allocUnsafe(u)):new v(new Uint8Array(u))}static wrap(u){return A&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new v(u)}static fromString(u,d){return!((d==null?void 0:d.dontUseNodeBuffer)||!1)&&A?new v(Buffer.from(u)):L?(O||(O=new TextEncoder),new v(O.encode(u))):new v(S.encodeUTF8(u))}static concat(u,d){if(typeof d=="undefined"){d=0;for(let P=0,_=u.length;P<_;P++)d+=u[P].byteLength}const p=v.alloc(d);let h=0;for(let P=0,_=u.length;P<_;P++){const j=u[P];p.set(j,h),h+=j.byteLength}return p}toString(){return A?this.buffer.toString():U?(m||(m=new TextDecoder),m.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(u,d){return new v(this.buffer.subarray(u,d))}set(u,d){u instanceof v?this.buffer.set(u.buffer,d):this.buffer.set(u,d)}readUInt32BE(u){return y(this.buffer,u)}writeUInt32BE(u,d){b(this.buffer,u,d)}readUInt32LE(u){return o(this.buffer,u)}writeUInt32LE(u,d){E(this.buffer,u,d)}readUInt8(u){return w(this.buffer,u)}writeUInt8(u,d){C(this.buffer,u,d)}}e.VSBuffer=v;function R(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0}e.readUInt16LE=R;function f(l,u,d){l[d+0]=u&255,u=u>>>8,l[d+1]=u&255}e.writeUInt16LE=f;function y(l,u){return l[u]*2**24+l[u+1]*2**16+l[u+2]*2**8+l[u+3]}e.readUInt32BE=y;function b(l,u,d){l[d+3]=u,u=u>>>8,l[d+2]=u,u=u>>>8,l[d+1]=u,u=u>>>8,l[d]=u}e.writeUInt32BE=b;function o(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0|l[u+2]<<16>>>0|l[u+3]<<24>>>0}e.readUInt32LE=o;function E(l,u,d){l[d+0]=u&255,u=u>>>8,l[d+1]=u&255,u=u>>>8,l[d+2]=u&255,u=u>>>8,l[d+3]=u&255}e.writeUInt32LE=E;function w(l,u){return l[u]}e.readUInt8=w;function C(l,u,d){l[d]=u}e.writeUInt8=C;function I(l){return k.consumeReadable(l,u=>v.concat(u))}e.readableToBuffer=I;function g(l){return k.toReadable(l)}e.bufferToReadable=g;function s(l){return k.consumeStream(l,u=>v.concat(u))}e.streamToBuffer=s;async function r(l){return l.ended?v.concat(l.buffer):v.concat([...l.buffer,await s(l.stream)])}e.bufferedStreamToBuffer=r;function t(l){return k.toStream(l,u=>v.concat(u))}e.bufferToStream=t;function i(l){return k.transform(l,{data:u=>typeof u=="string"?v.fromString(u):v.wrap(u)},u=>v.concat(u))}e.streamToBufferReadableStream=i;function n(l){return k.newWriteableStream(u=>v.concat(u),l)}e.newWriteableBufferStream=n;function a(l,u){return k.prefixedReadable(l,u,d=>v.concat(d))}e.prefixedBufferReadable=a;function c(l,u){return k.prefixedStream(l,u,d=>v.concat(d))}e.prefixedBufferStream=c}),define(Z[15],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(u){return Array.isArray(u)}e.isArray=S;function k(u){return typeof u=="string"}e.isString=k;function A(u){return Array.isArray(u)&&u.every(d=>k(d))}e.isStringArray=A;function L(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=L;function U(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=U;function O(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=O;function m(u){return u===!0||u===!1}e.isBoolean=m;function v(u){return typeof u=="undefined"}e.isUndefined=v;function R(u){return!f(u)}e.isDefined=R;function f(u){return v(u)||u===null}e.isUndefinedOrNull=f;function y(u,d){if(!u)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=y;function b(u){if(f(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=b;function o(...u){const d=[];for(let p=0;p<u.length;p++){const h=u[p];if(f(h))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);d.push(h)}return d}e.assertAllDefined=o;const E=Object.prototype.hasOwnProperty;function w(u){if(!L(u))return!1;for(let d in u)if(E.call(u,d))return!1;return!0}e.isEmptyObject=w;function C(u){return typeof u=="function"}e.isFunction=C;function I(...u){return u.length>0&&u.every(C)}e.areFunctions=I;function g(u,d){const p=Math.min(u.length,d.length);for(let h=0;h<p;h++)s(u[h],d[h])}e.validateConstraints=g;function s(u,d){if(k(d)){if(typeof u!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(C(d)){try{if(u instanceof d)return}catch(p){}if(!f(u)&&u.constructor===d||d.length===1&&d.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function r(u){let d=[],p=Object.getPrototypeOf(u);for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}e.getAllPropertyNames=r;function t(u){const d=[];for(const p of r(u))typeof u[p]=="function"&&d.push(p);return d}e.getAllMethodNames=t;function i(u,d){const p=P=>function(){const _=Array.prototype.slice.call(arguments,0);return d(P,_)};let h={};for(const P of u)h[P]=p(P);return h}e.createProxyObject=i;function n(u){return u===null?void 0:u}e.withNullAsUndefined=n;function a(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=a;function c(u){return class{constructor(){return new Proxy({},{get(d,p){if(d[p])return d[p];throw new Error(`Not Implemented: ${u}->${String(p)}`)}})}}}e.NotImplementedProxy=c;function l(u){throw new Error("Unreachable")}e.assertNever=l}),define(Z[42],ee([0,1,7,21,8,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function U(i){return i===47||i===92}e.isPathSeparator=U;function O(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=O;function m(i,n=A.posix.sep){if(!i)return"";const a=i.length,c=i.charCodeAt(0);if(U(c)){if(U(i.charCodeAt(1))&&!U(i.charCodeAt(2))){let u=3;const d=u;for(;u<a&&!U(i.charCodeAt(u));u++);if(d!==u&&!U(i.charCodeAt(u+1))){for(u+=1;u<a;u++)if(U(i.charCodeAt(u)))return i.slice(0,u+1).replace(/[\\/]/g,n)}}return n}else if(w(c)&&i.charCodeAt(1)===58)return U(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<a;l++)if(U(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=m;function v(i){if(!S.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let a=2;const c=a;for(;a<i.length&&(n=i.charCodeAt(a),n!==92);a++);return!(c===a||(n=i.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=v;const R=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(i,n=S.isWindows){const a=n?R:f;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||n&&y.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=b;function o(i,n,a){const c=i===n;return!a||c?c:!i||!n?!1:(0,k.equalsIgnoreCase)(i,n)}e.isEqual=o;function E(i,n,a,c=A.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let u=n.length;return n.charAt(n.length-1)===c&&u--,i.charAt(u)===c}return n.charAt(n.length-1)!==c&&(n+=c),i.indexOf(n)===0}e.isEqualOrParent=E;function w(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=w;function C(i,n){return S.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(n,i)),i=(0,A.normalize)(i),S.isWindows?(i=(0,k.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,k.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=C;function I(i){const n=(0,A.normalize)(i);return S.isWindows?i.length>3?!1:g(n)&&(i.length===2||n.charCodeAt(2)===92):n===A.posix.sep}e.isRootOrDriveLetter=I;function g(i){return S.isWindows?w(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function s(i){return g(i)?i[0]:void 0}e.getDriveLetter=s;function r(i,n,a){return n.length>i.length?-1:i===n?0:(a&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=r;function t(i){const n=i.split(":");let a,c,l;if(n.forEach(u=>{const d=Number(u);(0,L.isNumber)(d)?c===void 0?c=d:l===void 0&&(l=d):a=a?[a,u].join(":"):u}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,15]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const E=Array.isArray(o)?[]:{};return Object.keys(o).forEach(w=>{o[w]&&typeof o[w]=="object"?E[w]=k(o[w]):E[w]=o[w]}),E}e.deepClone=k;function A(o){if(!o||typeof o!="object")return o;const E=[o];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const C in w)if(L.call(w,C)){const I=w[C];typeof I=="object"&&!Object.isFrozen(I)&&E.push(I)}}return o}e.deepFreeze=A;const L=Object.prototype.hasOwnProperty;function U(o,E){return O(o,E,new Set)}e.cloneAndChange=U;function O(o,E,w){if((0,S.isUndefinedOrNull)(o))return o;const C=E(o);if(typeof C!="undefined")return C;if((0,S.isArray)(o)){const I=[];for(const g of o)I.push(O(g,E,w));return I}if((0,S.isObject)(o)){if(w.has(o))throw new Error("Cannot clone recursive data-structure");w.add(o);const I={};for(let g in o)L.call(o,g)&&(I[g]=O(o[g],E,w));return w.delete(o),I}return o}function m(o,E,w=!0){return(0,S.isObject)(o)?((0,S.isObject)(E)&&Object.keys(E).forEach(C=>{C in o?w&&((0,S.isObject)(o[C])&&(0,S.isObject)(E[C])?m(o[C],E[C],w):o[C]=E[C]):o[C]=E[C]}),o):E}e.mixin=m;function v(o,E){if(o===E)return!0;if(o==null||E===null||E===void 0||typeof o!=typeof E||typeof o!="object"||Array.isArray(o)!==Array.isArray(E))return!1;let w,C;if(Array.isArray(o)){if(o.length!==E.length)return!1;for(w=0;w<o.length;w++)if(!v(o[w],E[w]))return!1}else{const I=[];for(C in o)I.push(C);I.sort();const g=[];for(C in E)g.push(C);if(g.sort(),!v(I,g))return!1;for(w=0;w<I.length;w++)if(!v(o[I[w]],E[I[w]]))return!1}return!0}e.equals=v;function R(o){const E=new Set;return JSON.stringify(o,(w,C)=>{if((0,S.isObject)(C)||Array.isArray(C)){if(E.has(C))return"[Circular]";E.add(C)}return C})}e.safeStringify=R;function f(o,E,w){const C=E(o);return typeof C=="undefined"?w:C}e.getOrDefault=f;function y(o,E){const w=Object.create(null);return!o||!E||Object.keys(E).forEach(I=>{const g=o[I],s=E[I];v(g,s)||(w[I]=s)}),w}e.distinct=y;function b(o,E){const w=E.toLowerCase(),C=Object.keys(o).find(I=>I.toLowerCase()===w);return C?o[C]:o[E]}e.getCaseInsensitive=b}),define(Z[4],ee([0,1,7,8]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,U=/^\/\//;function O(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,a){return!n&&!a?"file":n}function v(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==f&&(a=f+a):a=f;break}return a}const R="",f="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(a,c,l,u,d,p=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=m(a,p),this.authority=c||R,this.path=v(this.scheme,l||R),this.query=u||R,this.fragment=d||R,O(this,p))}static isUri(a){return a instanceof b?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:l,path:u,query:d,fragment:p}=a;return c===void 0?c=this.scheme:c===null&&(c=R),l===void 0?l=this.authority:l===null&&(l=R),u===void 0?u=this.path:u===null&&(u=R),d===void 0?d=this.query:d===null&&(d=R),p===void 0?p=this.fragment:p===null&&(p=R),c===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&p===this.fragment?this:new E(c,l,u,d,p)}static parse(a,c=!1){const l=y.exec(a);return l?new E(l[2]||R,i(l[4]||R),i(l[5]||R),i(l[7]||R),i(l[9]||R),c):new E(R,R,R,R,R)}static file(a){let c=R;if(S.isWindows&&(a=a.replace(/\\/g,f)),a[0]===f&&a[1]===f){const l=a.indexOf(f,2);l===-1?(c=a.substring(2),a=f):(c=a.substring(2,l),a=a.substring(l)||f)}return new E("file",c,a,R,R)}static from(a){return new E(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return S.isWindows&&a.scheme==="file"?l=b.file(k.win32.join(g(a,!0),...c)).path:l=k.posix.join(a.path,...c),a.with({path:l})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof b)return a;{const c=new E(a);return c._formatted=a.external,c._fsPath=a._sep===o?a.fsPath:null,c}}else return a}}e.URI=b;const o=S.isWindows?1:void 0;class E extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=o),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function C(n,a){let c,l=-1;for(let u=0;u<n.length;u++){const d=n.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||a&&d===47)l!==-1&&(c+=encodeURIComponent(n.substring(l,u)),l=-1),c!==void 0&&(c+=n.charAt(u));else{c===void 0&&(c=n.substr(0,u));const p=w[d];p!==void 0?(l!==-1&&(c+=encodeURIComponent(n.substring(l,u)),l=-1),c+=p):l===-1&&(l=u)}}return l!==-1&&(c+=encodeURIComponent(n.substring(l))),c!==void 0?c:n}function I(n){let a;for(let c=0;c<n.length;c++){const l=n.charCodeAt(c);l===35||l===63?(a===void 0&&(a=n.substr(0,c)),a+=w[l]):a!==void 0&&(a+=n[c])}return a!==void 0?a:n}function g(n,a){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,S.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function s(n,a){const c=a?I:C;let l="",{scheme:u,authority:d,path:p,query:h,fragment:P}=n;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=f,l+=f),d){let _=d.indexOf("@");if(_!==-1){const j=d.substr(0,_);d=d.substr(_+1),_=j.indexOf(":"),_===-1?l+=c(j,!1):(l+=c(j.substr(0,_),!1),l+=":",l+=c(j.substr(_+1),!1)),l+="@"}d=d.toLowerCase(),_=d.indexOf(":"),_===-1?l+=c(d,!1):(l+=c(d.substr(0,_),!1),l+=d.substr(_))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const _=p.charCodeAt(1);_>=65&&_<=90&&(p=`/${String.fromCharCode(_+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const _=p.charCodeAt(0);_>=65&&_<=90&&(p=`${String.fromCharCode(_+32)}:${p.substr(2)}`)}l+=c(p,!0)}return h&&(l+="?",l+=c(h,!1)),P&&(l+="#",l+=a?P:C(P,!1)),l}function r(n){try{return decodeURIComponent(n)}catch(a){return n.length>3?n.substr(0,3)+r(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,a=>r(a)):n}}),define(Z[87],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=k;function A(v){const R=[];let f;try{const y=JSON.parse(v.arguments),b=y[y.length-1];b&&b.__$stack&&(y.pop(),f=b.__$stack),R.push(...y)}catch(y){R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:f}}e.parse=A;function L(v){if(typeof v!="string")return L(A(v).stack);const R=v;if(R){const f=U(R),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=L;function U(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function O(v,R){const{args:f,stack:y}=A(v),b=typeof f[0]=="string"&&f.length===1;let o=U(y);o&&(o=`(${o.trim()})`);let E=[];if(typeof f[0]=="string"?o&&b?E=[`%c[${R}] %c${f[0]} %c${o}`,m("blue"),m(""),m("grey")]:E=[`%c[${R}] %c${f[0]}`,m("blue"),m(""),...f.slice(1)]:E=[`%c[${R}]%`,m("blue"),...f],o&&!b&&E.push(o),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,E)}e.log=O;function m(v){return`color: ${v}`}});var lt=this&&this.__classPrivateFieldSet||function(K,e,S,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!A:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(K,S):A?A.value=S:e.set(K,S),S},je=this&&this.__classPrivateFieldGet||function(K,e,S,k){if(S==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?k:S==="a"?k.call(K):k?k.value:e.get(K)};define(Z[37],ee([0,1,4,21]),function(K,e,S,k){"use strict";var A,L,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function O(t,i,n){let a=t.get(i);return a===void 0&&(a=n,t.set(i,a)),a}e.getOrSet=O;function m(t){const i=[];return t.forEach((n,a)=>{i.push(`${a} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=m;function v(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=v;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return n-a}value(){return this._value[this._pos]}}e.StringIterator=R;class f{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class y{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class E{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(i){this._iter=i}static forUris(i=()=>!1){return new w(new o(i))}static forPaths(){return new w(new y)}static forStrings(){return new w(new R)}static forConfigKeys(){return new w(new f)}clear(){this._root=void 0}set(i,n){const a=this._iter.reset(i);let c;for(this._root||(this._root=new E,this._root.segment=a.value()),c=this._root;;){const u=a.cmp(c.segment);if(u>0)c.left||(c.left=new E,c.left.segment=a.value()),c=c.left;else if(u<0)c.right||(c.right=new E,c.right.segment=a.value()),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new E,c.mid.segment=a.value()),c=c.mid;else break}const l=c.value;return c.value=n,c.key=i,l}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let a=this._root;for(;a;){const c=n.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(n.hasNext())n.next(),a=a.mid;else break}return a}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const a=this._iter.reset(i),c=[];let l=this._root;for(;l;){const u=a.cmp(l.segment);if(u>0)c.push([1,l]),l=l.left;else if(u<0)c.push([-1,l]),l=l.right;else if(a.hasNext())a.next(),c.push([0,l]),l=l.mid;else{for(n?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;c.length>0&&l.isEmpty();){let[d,p]=c.pop();switch(d){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}l=p}break}}}findSubstr(i){const n=this._iter.reset(i);let a=this._root,c;for(;a;){const l=n.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(n.hasNext())n.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(i){const n=this._iter.reset(i);let a=this._root;for(;a;){const c=n.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(n.hasNext())n.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[n,a]of this)i(a,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=w;class C{constructor(i,n){this[A]="ResourceMap",i instanceof C?(this.map=new Map(i.map),this.toKey=n!=null?n:C.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:C.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[a,c]of this.map)i(c,S.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield S.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[S.URI.parse(i[0]),i[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[S.URI.parse(i[0]),i[1]]}}e.ResourceMap=C,C.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class g{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const a=this._map.get(i);if(!!a)return n!==0&&this.touch(a,n),a.value}set(i,n,a=0){let c=this._map.get(i);if(c)c.value=n,a!==0&&this.touch(c,a);else{switch(c={key:i,value:n,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,n){const a=this._state;let c=this._head;for(;c;){if(n?i.bind(n)(c.value,c.key,this):i(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,n=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:a.key,done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return c}values(){const i=this,n=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:a.value,done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return c}entries(){const i=this,n=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:[a.key,a.value],done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let n=this._head,a=this.size;for(;n&&a>i;)this._map.delete(n.key),n=n.next,a--;this._head=n,this._size=a,n&&(n.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,a=i.previous;if(!n||!a)throw new Error("Invalid list");n.previous=a,a.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const a=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const a=i.next,c=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,a)=>{i.push([a,n])}),i}fromJSON(i){this.clear();for(const[n,a]of i)this.set(n,a)}}e.LinkedMap=g;class s extends g{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class r{constructor(i){U.set(this,void 0),lt(this,U,i,"f")}get size(){return je(this,U,"f").size}forEach(i,n){je(this,U,"f").forEach(i,n)}get(i){return je(this,U,"f").get(i)}has(i){return je(this,U,"f").has(i)}entries(){return je(this,U,"f").entries()}keys(){return je(this,U,"f").keys()}values(){return je(this,U,"f").values()}[(U=new WeakMap,Symbol.iterator)](){return je(this,U,"f").entries()}}e.ReadonlyMapView=r}),define(Z[88],ee([0,1,22,21,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(v){return JSON.stringify(v,O)}e.stringify=L;function U(v){let R=JSON.parse(v);return R=m(R),R}e.parse=U;function O(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function m(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return A.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof S.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let f=0;f<v.length;++f)v[f]=m(v[f],R+1);else for(const f in v)Object.hasOwnProperty.call(v,f)&&(v[f]=m(v[f],R+1))}return v}e.revive=m}),define(Z[16],ee([0,1,4,7]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(O){O.inMemory="inmemory",O.vscode="vscode",O.internal="private",O.walkThrough="walkThrough",O.walkThroughSnippet="walkThroughSnippet",O.http="http",O.https="https",O.file="file",O.mailto="mailto",O.untitled="untitled",O.data="data",O.command="command",O.vscodeRemote="vscode-remote",O.vscodeRemoteResource="vscode-remote-resource",O.userData="vscode-userdata",O.vscodeCustomEditor="vscode-custom-editor",O.vscodeNotebook="vscode-notebook",O.vscodeNotebookCell="vscode-notebook-cell",O.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",O.vscodeSettings="vscode-settings",O.vscodeWorkspaceTrust="vscode-workspace-trust",O.vscodeTerminal="vscode-terminal",O.webviewPanel="webview-panel",O.vscodeWebview="vscode-webview",O.extension="extension",O.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,v,R){this._hosts[m]=v,this._ports[m]=R}setConnectionToken(m,v){this._connectionTokens[m]=v}rewrite(m){if(this._delegate)return this._delegate(m);const v=m.authority;let R=this._hosts[v];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const f=this._ports[v],y=this._connectionTokens[v];let b=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(b+=`&tkn=${encodeURIComponent(y)}`),S.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${f}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new L;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(m,v,R){const f=this.toUri(m,v);return f.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(f):k.isNative&&(R||k.isPreferringBrowserCodeLoad)&&f.scheme===A.file?f.with({scheme:A.vscodeFileResource,authority:f.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(m,v){const R=this.toUri(m,v);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(m,v){return S.URI.isUri(m)?m:S.URI.parse(v.toUrl(m))}}e.FileAccess=new U}),define(Z[65],ee([0,1,37]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new S.LRUCache(1e4);function A(v){return m(v,"NFC",k)}e.normalizeNFC=A;const L=new S.LRUCache(1e4);function U(v){return m(v,"NFD",L)}e.normalizeNFD=U;const O=/[^\u0000-\u0080]/;function m(v,R,f){if(!e.canNormalize||!v)return v;const y=f.get(v);if(y)return y;let b;return O.test(v)?b=v.normalize(R):b=v,f.set(v,b),b}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(R){return U(R).replace(v,"")}}else return function(v){return v}}()}),define(Z[12],ee([0,1,42,8,4,21,16,7]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=m;class v{constructor(o){this._ignorePathCasing=o}compare(o,E,w=!1){return o===E?0:(0,L.compare)(this.getComparisonKey(o,w),this.getComparisonKey(E,w))}isEqual(o,E,w=!1){return o===E?!0:!o||!E?!1:this.getComparisonKey(o,w)===this.getComparisonKey(E,w)}getComparisonKey(o,E=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,E,w=!1){if(o.scheme===E.scheme){if(o.scheme===U.Schemas.file)return S.isEqualOrParent(m(o),m(E),this._ignorePathCasing(o))&&o.query===E.query&&(w||o.fragment===E.fragment);if((0,e.isEqualAuthority)(o.authority,E.authority))return S.isEqualOrParent(o.path,E.path,this._ignorePathCasing(o),"/")&&o.query===E.query&&(w||o.fragment===E.fragment)}return!1}joinPath(o,...E){return A.URI.joinPath(o,...E)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return k.posix.basename(o.path)}extname(o){return k.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let E;return o.scheme===U.Schemas.file?E=A.URI.file(k.dirname(m(o))).path:(E=k.posix.dirname(o.path),o.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),E="/")),o.with({path:E})}normalizePath(o){if(!o.path.length)return o;let E;return o.scheme===U.Schemas.file?E=A.URI.file(k.normalize(m(o))).path:E=k.posix.normalize(o.path),o.with({path:E})}relativePath(o,E){if(!(o.scheme!==E.scheme||!(0,e.isEqualAuthority)(o.authority,E.authority))){if(o.scheme===U.Schemas.file){const I=k.relative(m(o),m(E));return O.isWindows?S.toSlashes(I):I}let w=o.path||"/",C=E.path||"/";if(this._ignorePathCasing(o)){let I=0;for(const g=Math.min(w.length,C.length);I<g&&!(w.charCodeAt(I)!==C.charCodeAt(I)&&w.charAt(I).toLowerCase()!==C.charAt(I).toLowerCase());I++);w=C.substr(0,I)+w.substr(I)}return k.posix.relative(w,C)}}resolvePath(o,E){if(o.scheme===U.Schemas.file){const w=A.URI.file(k.resolve(m(o),E));return o.with({authority:w.authority,path:w.path})}return E.indexOf("/")===-1&&(E=S.toSlashes(E),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E)),o.with({path:k.posix.resolve(o.path,E)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,E){return o===E||(0,L.equalsIgnoreCase)(o,E)}hasTrailingPathSeparator(o,E=k.sep){if(o.scheme===U.Schemas.file){const w=m(o);return w.length>S.getRoot(w).length&&w[w.length-1]===E}else{const w=o.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,E=k.sep){return(0,e.hasTrailingPathSeparator)(o,E)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,E=k.sep){let w=!1;if(o.scheme===U.Schemas.file){const C=m(o);w=C!==void 0&&C.length===S.getRoot(C).length&&C[C.length-1]===E}else{E="/";const C=o.path;w=C.length===1&&C.charCodeAt(C.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(o,E)?o.with({path:o.path+"/"}):o}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(b=>b.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new v(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(b,o){const E=[];for(let w=0;w<b.length;w++){const C=o(b[w]);b.some((I,g)=>g===w?!1:(0,e.isEqualOrParent)(C,o(I)))||E.push(b[w])}return E}e.distinctParents=R;var f;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function o(E){const w=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(g=>{const[s,r]=g.split(":");s&&r&&w.set(s,r)});const I=E.path.substring(0,E.path.indexOf(";"));return I&&w.set(b.META_DATA_MIME,I),w}b.parseMetaData=o})(f=e.DataUri||(e.DataUri={}));function y(b,o,E){if(o){let w=b.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),b.with({scheme:E,authority:o,path:w})}return b.with({scheme:E})}e.toLocalResource=y}),define(Z[6],ee([0,1,30,11,3,2,64,12]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(z){return!!z&&typeof z.then=="function"}e.isThenable=m;function v(z){const D=new S.CancellationTokenSource,T=z(D.token),F=new Promise((N,x)=>{D.token.onCancellationRequested(()=>{x((0,k.canceled)())}),Promise.resolve(T).then(G=>{D.dispose(),N(G)},G=>{D.dispose(),x(G)})});return new class{cancel(){D.cancel()}then(N,x){return F.then(N,x)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=v;function R(z,D,T){return Promise.race([z,new Promise(F=>D.onCancellationRequested(()=>F(T)))])}e.raceCancellation=R;async function f(z){let D=-1;const T=z.map((N,x)=>N.then(G=>(D=x,G))),F=await Promise.race(T);return z.forEach((N,x)=>{x!==D&&N.cancel()}),F}e.raceCancellablePromises=f;function y(z,D,T){let F;const N=setTimeout(()=>{F==null||F(void 0),T==null||T()},D);return Promise.race([z.finally(()=>clearTimeout(N)),new Promise(x=>F=x)])}e.raceTimeout=y;function b(z){return new Promise((D,T)=>{const F=z();m(F)?F.then(D,T):D(F)})}e.asPromise=b;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(T,T).then(F)})}return new Promise((T,F)=>{this.queuedPromise.then(T,F)})}return this.activePromise=D(),new Promise((T,F)=>{this.activePromise.then(N=>{this.activePromise=null,T(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=o;class E{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=E;class w{constructor(){this.promiseMap=new Map}queue(D,T){var F;const x=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(D)===x&&this.promiseMap.delete(D)});return this.promiseMap.set(D,x),x}}e.SequencerByKey=w;class C{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,T=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=C;class I{constructor(D){this.delayer=new C(D),this.throttler=new o}trigger(D,T){return this.delayer.trigger(()=>this.throttler.queue(D),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class g{constructor(){this._isOpen=!1,this._promise=new Promise((D,T)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class s extends g{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(z,D){return D?new Promise((T,F)=>{const N=setTimeout(T,z);D.onCancellationRequested(()=>{clearTimeout(N),F((0,k.canceled)())})}):v(T=>r(z,T))}e.timeout=r;function t(z,D=0){const T=setTimeout(z,D);return(0,L.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=t;function i(z){return z.then(void 0,D=>{})}e.ignoreErrors=i;function n(z){const D=[];let T=0;const F=z.length;function N(){return T<F?z[T++]():null}function x(G){G!=null&&D.push(G);const J=N();return J?J.then(x):Promise.resolve(D)}return Promise.resolve(null).then(x)}e.sequence=n;function a(z,D=F=>!!F,T=null){let F=0;const N=z.length,x=()=>{if(F>=N)return Promise.resolve(T);const G=z[F++];return Promise.resolve(G()).then(Q=>D(Q)?Promise.resolve(Q):x())};return x()}e.first=a;function c(z,D=F=>!!F,T=null){if(z.length===0)return Promise.resolve(T);let F=z.length;const N=()=>{var x,G;F=-1;for(const J of z)(G=(x=J).cancel)===null||G===void 0||G.call(x)};return new Promise((x,G)=>{for(const J of z)J.then(Q=>{--F>=0&&D(Q)?(N(),x(Q)):F===0&&x(T)}).catch(Q=>{--F>=0&&(N(),G(Q))})})}e.firstParallel=c;class l{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((T,F)=>{this.outstandingPromises.push({factory:D,c:T,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const T=D.factory();T.then(D.c,D.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class u extends l{constructor(){super(1)}}e.Queue=u;class d{constructor(){this.queues=new Map}queueFor(D,T=O.extUri){const F=T.getComparisonKey(D);let N=this.queues.get(F);return N||(N=new u,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=d;class p{constructor(D,T){this._token=-1,typeof D=="function"&&typeof T=="number"&&this.setIfNotSet(D,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},T)}setIfNotSet(D,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},T))}}e.TimeoutTimer=p;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setInterval(()=>{D()},T)}}e.IntervalTimer=h;class P{constructor(D,T){this.timeoutToken=-1,this.runner=D,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(D,T){super(D,T);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const T=setTimeout(()=>D(z));let F=!1;return{dispose(){F||(F=!0,clearTimeout(T))}}}}else e.runWhenIdle=(z,D)=>{const T=requestIdleCallback(z,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(T))}}}}();class j{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function B(z,D,T){let F;for(let N=0;N<T;N++)try{return await z()}catch(x){F=x,await r(D)}throw F}e.retry=B;class M{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,T,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:T},T.then(()=>this.donePending(D),()=>this.donePending(D)),T}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let T,F;const N=new Promise((x,G)=>{T=x,F=G});this._next={run:D,promise:N,promiseResolve:T,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class ${constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,T)=>{this.completeCallback=D,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(T=>{this.completeCallback(D),this.resolved=!0,T()})}error(D){return new Promise(T=>{this.errorCallback(D),this.rejected=!0,T()})}cancel(){new Promise(D=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=V;class q extends A.Emitter{async fireAsync(D,T,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,D]);for(;this._asyncDeliveryQueue.size>0&&!T.isCancellationRequested;){const[N,x]=this._asyncDeliveryQueue.shift(),G=[],J=Object.assign(Object.assign({},x),{waitUntil:Q=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),G.push(Q)}});try{typeof N=="function"?N.call(void 0,J):N[0].call(N[1],J)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(G),await H.settled(G).catch(Q=>(0,k.onUnexpectedError)(Q))}}}}e.AsyncEmitter=q;var H;(function(z){async function D(x){return typeof Promise.allSettled=="function"?T(x):F(x)}z.allSettled=D;async function T(x){return Promise.allSettled(x)}async function F(x){return Promise.all(x.map(G=>G.then(J=>({status:"fulfilled",value:J}),J=>({status:"rejected",reason:J}))))}async function N(x){let G;const J=await Promise.all(x.map(Q=>Q.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return J}z.settled=N})(H=e.Promises||(e.Promises={}))}),define(Z[89],ee([0,1,21,42,8,37,6]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function O(){return Object.create(null)}e.getEmptyExpression=O;const m="**",v="/",R="[/\\\\]",f="[^/\\\\]",y=/\//g;function b(T){switch(T){case 0:return"";case 1:return`${f}*?`;default:return`(?:${R}|${f}+${R}|${R}${f}+)*?`}}function o(T,F){if(!T)return[];const N=[];let x=!1,G=!1,J="";for(const Q of T){switch(Q){case F:if(!x&&!G){N.push(J),J="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":G=!0;break;case"]":G=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=o;function E(T){if(!T)return"";let F="";const N=o(T,v);if(N.every(x=>x===m))F=".*";else{let x=!1;N.forEach((G,J)=>{if(G===m){x||(F+=b(2),x=!0);return}let Q=!1,ne="",ie=!1,ce="";for(const ue of G){if(ue!=="}"&&Q){ne+=ue;continue}if(ie&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===v?ge="":ge=S.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${o(ne,",").map(Ie=>E(Ie)).join("|")})`,Q=!1,ne="";break;case"]":F+="["+ce+"]",ie=!1,ce="";break;case"?":F+=f;continue;case"*":F+=b(1);continue;default:F+=S.escapeRegExpCharacters(ue)}}J<N.length-1&&(N[J+1]!==m||J+2<N.length)&&(F+=R),x=!1})}return F}const w=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),i=function(){return!1},n=function(){return null};function a(T,F){if(!T)return n;let N;typeof T!="string"?N=T.pattern:N=T,N=N.trim();const x=`${N}_${!!F.trimForExclusions}`;let G=t.get(x);if(G)return c(G,T);let J;if(w.test(N)){const Q=N.substr(4);G=function(ne,ie){return typeof ne=="string"&&ne.endsWith(Q)?N:null}}else(J=C.exec(l(N,F)))?G=u(J[1],N):(F.trimForExclusions?g:I).test(N)?G=d(N,F):(J=s.exec(l(N,F)))?G=p(J[1].substr(1),N,!0):(J=r.exec(l(N,F)))?G=p(J[1],N,!1):G=h(N);return t.set(x,G),c(G,T)}function c(T,F){return typeof F=="string"?T:function(N,x){return k.isEqualOrParent(N,F.base)?T(A.relative(F.base,N),x):null}}function l(T,F){return F.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function u(T,F){const N=`/${T}`,x=`\\${T}`,G=function(Q,ne){return typeof Q!="string"?null:ne?ne===T?F:null:Q===T||Q.endsWith(N)||Q.endsWith(x)?F:null},J=[T];return G.basenames=J,G.patterns=[F],G.allBasenames=J,G}function d(T,F){const N=D(T.slice(1,-1).split(",").map(ne=>a(ne,F)).filter(ne=>ne!==n),T),x=N.length;if(!x)return n;if(x===1)return N[0];const G=function(ne,ie){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ne,ie))return T;return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function p(T,F,N){const x=A.sep===A.posix.sep,G=x?T:T.replace(y,A.sep),J=A.sep+G,Q=A.posix.sep+T,ne=N?function(ie,ce){return typeof ie=="string"&&(ie===G||ie.endsWith(J)||!x&&(ie===T||ie.endsWith(Q)))?F:null}:function(ie,ce){return typeof ie=="string"&&(ie===G||!x&&ie===T)?F:null};return ne.allPaths=[(N?"*/":"./")+T],ne}function h(T){try{const F=new RegExp(`^${E(T)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?T:null}}catch(F){return n}}function P(T,F,N){return!T||typeof F!="string"?!1:_(T)(F,void 0,N)}e.match=P;function _(T,F={}){if(!T)return i;if(typeof T=="string"||$(T)){const N=a(T,F);if(N===n)return i;const x=function(G,J){return!!N(G,J)};return N.allBasenames&&(x.allBasenames=N.allBasenames),N.allPaths&&(x.allPaths=N.allPaths),x}return H(T,F)}e.parse=_;function j(T){if(!!T){let F;return N=>(F||(F=(T()||Promise.resolve([])).then(x=>x?M(x):{})),F.then(x=>!!x[N]))}}e.hasSiblingPromiseFn=j;function B(T){if(!!T){let F;return N=>{if(!F){const x=T();F=x?M(x):{}}return!!F[N]}}}e.hasSiblingFn=B;function M(T){const F={};for(const N of T)F[N]=!0;return F}function $(T){const F=T;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=$;function V(T){return T.allBasenames||[]}e.getBasenameTerms=V;function q(T){return T.allPaths||[]}e.getPathTerms=q;function H(T,F){const N=D(Object.getOwnPropertyNames(T).map(ne=>z(ne,T[ne],F)).filter(ne=>ne!==n)),x=N.length;if(!x)return n;if(!N.some(ne=>!!ne.requiresSiblings)){if(x===1)return N[0];const ne=function(ue,ge){for(let Ee=0,Ie=N.length;Ee<Ie;Ee++){const Oe=N[Ee](ue,ge);if(Oe)return Oe}return null},ie=N.find(ue=>!!ue.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ne.allPaths=ce),ne}const G=function(ne,ie,ce){let ue;for(let ge=0,Ee=N.length;ge<Ee;ge++){const Ie=N[ge];Ie.requiresSiblings&&ce&&(ie||(ie=A.basename(ne)),ue||(ue=ie.substr(0,ie.length-A.extname(ne).length)));const Oe=Ie(ne,ie,ue,ce);if(Oe)return Oe}return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function z(T,F,N){if(F===!1)return n;const x=a(T,N);if(x===n)return n;if(typeof F=="boolean")return x;if(F){const G=F.when;if(typeof G=="string"){const J=(Q,ne,ie,ce)=>{if(!ce||!x(Q,ne))return null;const ue=G.replace("$(basename)",ie),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(Ee=>Ee?T:null):ge?T:null};return J.requiresSiblings=!0,J}}return x}function D(T,F){const N=T.filter(ne=>!!ne.basenames);if(N.length<2)return T;const x=N.reduce((ne,ie)=>{const ce=ie.basenames;return ce?ne.concat(ce):ne},[]);let G;if(F){G=[];for(let ne=0,ie=x.length;ne<ie;ne++)G.push(F)}else G=N.reduce((ne,ie)=>{const ce=ie.patterns;return ce?ne.concat(ce):ne},[]);const J=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let ue;for(ue=ne.length;ue>0;ue--){const ge=ne.charCodeAt(ue-1);if(ge===47||ge===92)break}ie=ne.substr(ue)}const ce=x.indexOf(ie);return ce!==-1?G[ce]:null};J.basenames=x,J.patterns=G,J.allBasenames=x;const Q=T.filter(ne=>!ne.basenames);return Q.push(J),Q}}),define(Z[90],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(R){return R.toJSON()}class A{constructor(f){this._uriTransformer=f}transformIncoming(f){const y=this._uriTransformer.transformIncoming(f);return y===f?f:k(S.URI.from(y))}transformOutgoing(f){const y=this._uriTransformer.transformOutgoing(f);return y===f?f:k(S.URI.from(y))}transformOutgoingURI(f){const y=this._uriTransformer.transformOutgoing(f);return y===f?f:S.URI.from(y)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,f,y){if(!R||y>200)return null;if(typeof R=="object"){if(R instanceof S.URI)return f.transformOutgoing(R);for(let b in R)if(Object.hasOwnProperty.call(R,b)){const o=L(R[b],f,y+1);o!==null&&(R[b]=o)}}return null}function U(R,f){const y=L(R,f,0);return y===null?R:y}e.transformOutgoingURIs=U;function O(R,f,y,b){if(!R||b>200)return null;if(typeof R=="object"){if(R.$mid===1)return y?S.URI.revive(f.transformIncoming(R)):f.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const E=O(R[o],f,y,b+1);E!==null&&(R[o]=E)}}return null}function m(R,f){const y=O(R,f,!1,0);return y===null?R:y}e.transformIncomingURIs=m;function v(R,f){const y=O(R,f,!0,0);return y===null?R:y}e.transformAndReviveIncomingURIs=v}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(m){return S.test(m)}e.isUUID=k;const A=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(m){for(let v=0;v<m.length;v++)m[v]=Math.floor(Math.random()*256);return m};function O(){U(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let m=0,v="";return v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v}e.generateUuid=O}),define(Z[66],ee([0,1,199]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(L="utf8"){this.stringDecoder=new S.StringDecoder(L),this.remaining=null}write(L){const U=[],O=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(O.length<1)return U;let m=0,v,R=m;for(;R<O.length;)if(v=O.charCodeAt(R),v===13||v===10){if(U.push(O.substring(m,R)),R++,R<O.length){const f=v;v=O.charCodeAt(R),(f===13&&v===10||f===10&&v===13)&&R++}m=R}else R++;return this.remaining=m<O.length?O.substr(m):null,U}end(){return this.remaining}}e.LineDecoder=k}),define(Z[91],ee([0,1,38]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const m=O.replace(/\-/g,":").toLowerCase();return!k.has(m)}function L(){return new Promise(async(O,m)=>{const v=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{O(await U())}catch(R){m(R)}finally{clearTimeout(v)}})}e.getMac=L;function U(){return new Promise((O,m)=>{try{const v=(0,S.networkInterfaces)();for(let R in v){const f=v[R];if(f){for(const{mac:y}of f)if(A(y))return O(y)}}m("Unable to retrieve mac address (unexpected format)")}catch(v){m(v)}})}}),define(Z[92],ee([0,1,11,31,38,37,91]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,f=0;const y=(0,A.networkInterfaces)();for(let b in y){const o=y[b];if(o)for(const{mac:E,internal:w}of o)w||(f+=1,this._isVirtualMachineMacAdress(E.toUpperCase())&&(R+=1))}this._value=f>0?R/f:0}return this._value}};let O;async function m(){return O||(O=(async()=>await v()||k.generateUuid())()),O}e.getMachineId=m;async function v(){try{const R=await new Promise((y,b)=>{K(["crypto"],y,b)}),f=await(0,U.getMac)();return R.createHash("sha256").update(f,"utf8").digest("hex")}catch(R){S.onUnexpectedError(R);return}}}),define(Z[23],ee([0,1,27,38,8,6,7,42,31,65,12,4]),function(K,e,S,k,A,L,U,O,m,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var y;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function b(V,q=y.UNLINK){if((0,O.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return q===y.UNLINK?E(V):o(V)}e.rimraf=b;async function o(V){try{const q=(0,A.join)((0,k.tmpdir)(),(0,m.generateUuid)());try{await S.promises.rename(V,q)}catch(H){return E(V)}E(q).catch(H=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function E(V){return S.promises.rmdir(V,{recursive:!0,maxRetries:3})}function w(V){if((0,O.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(V,{recursive:!0})}e.rimrafSync=w;async function C(V,q){return s(await(q?I(V):S.promises.readdir(V)))}e.readdir=C;async function I(V){try{return await S.promises.readdir(V,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const q=[],H=await C(V);for(const z of H){let D=!1,T=!1,F=!1;try{const N=await S.promises.lstat((0,A.join)(V,z));D=N.isFile(),T=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}q.push({name:z,isFile:()=>D,isDirectory:()=>T,isSymbolicLink:()=>F})}return q}function g(V){return s(S.readdirSync(V))}e.readdirSync=g;function s(V){return V.map(q=>typeof q=="string"?U.isMacintosh?(0,v.normalizeNFC)(q):q:(q.name=U.isMacintosh?(0,v.normalizeNFC)(q.name):q.name,q))}async function r(V){const q=await C(V),H=[];for(const z of q)await i.existsDirectory((0,A.join)(V,z))&&H.push(z);return H}e.readDirsInDir=r;function t(V,q=1e3){return new Promise(H=>{let z=!1;const D=setInterval(()=>{z||(z=!0,S.access(V,T=>{z=!1,T&&(clearInterval(D),H(void 0))}))},q)})}e.whenDeleted=t;var i;(function(V){async function q(D){let T;try{if(T=await S.promises.lstat(D),!T.isSymbolicLink())return{stat:T}}catch(F){}try{return{stat:await S.promises.stat(D),symbolicLink:(T==null?void 0:T.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await S.promises.stat(await S.promises.readlink(D)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw N}throw F}}V.stat=q;async function H(D){try{const{stat:T,symbolicLink:F}=await V.stat(D);return T.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(T){}return!1}V.existsFile=H;async function z(D){try{const{stat:T,symbolicLink:F}=await V.stat(D);return T.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(T){}return!1}V.existsDirectory=z})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new L.ResourceQueue;function a(V,q,H){return n.queueFor(f.URI.file(V),R.extUriBiasedIgnorePathCase).queue(()=>{const z=d(H);return new Promise((D,T)=>l(V,q,z,F=>F?T(F):D()))})}e.writeFile=a;let c=!0;function l(V,q,H,z){if(!c)return S.writeFile(V,q,{mode:H.mode,flag:H.flag},z);S.open(V,H.flag,H.mode,(D,T)=>{if(D)return z(D);S.writeFile(T,q,F=>{if(F)return S.close(T,()=>z(F));S.fdatasync(T,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c=!1),S.close(T,x=>z(x))))})})}function u(V,q,H){const z=d(H);if(!c)return S.writeFileSync(V,q,{mode:z.mode,flag:z.flag});const D=S.openSync(V,z.flag,z.mode);try{S.writeFileSync(D,q);try{S.fdatasyncSync(D)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),c=!1}}finally{S.closeSync(D)}}e.writeFileSync=u;function d(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function p(V,q){if(V!==q){async function H(z){try{const D=await S.promises.lstat(z);if(D.isDirectory()||D.isSymbolicLink())return;const T=await S.promises.open(z,"a");try{await T.utimes(D.atime,new Date)}finally{await T.close()}}catch(D){}}try{await S.promises.rename(V,q),await H(q)}catch(z){if(V.toLowerCase()!==q.toLowerCase()&&z.code==="EXDEV"||V.endsWith("."))await h(V,q,{preserveSymlinks:!1}),await b(V,y.MOVE),await H(q);else throw z}}}e.move=p;async function h(V,q,H){return _(V,q,{root:{source:V,target:q},options:H,handledSourcePaths:new Set})}e.copy=h;const P=511;async function _(V,q,H){if(!H.handledSourcePaths.has(V)){H.handledSourcePaths.add(V);const{stat:z,symbolicLink:D}=await i.stat(V);if(D){if(H.options.preserveSymlinks)try{return await M(V,q,H)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(D.dangling)return}return z.isDirectory()?j(V,q,z.mode&P,H):B(V,q,z.mode&P)}}async function j(V,q,H,z){await S.promises.mkdir(q,{recursive:!0,mode:H});const D=await C(V);for(const T of D)await _((0,A.join)(V,T),(0,A.join)(q,T),z)}async function B(V,q,H){await S.promises.copyFile(V,q),await S.promises.chmod(q,H)}async function M(V,q,H){let z=await S.promises.readlink(V);(0,O.isEqualOrParent)(z,H.root.source,!U.isLinux)&&(z=(0,A.join)(H.root.target,z.substr(H.root.source.length+1))),await S.promises.symlink(z,q)}async function $(V){try{return await S.promises.access(V),!0}catch(q){return!1}}e.exists=$}),define(Z[93],ee([0,1,27,94,21,8,23]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(f){const y=(0,L.dirname)(f);if(f===y)return f;const b=((0,L.basename)(f)||f).toLowerCase();try{const E=(0,U.readdirSync)(y).filter(w=>w.toLowerCase()===b);if(E.length===1){const w=O(y);if(w)return(0,L.join)(w,E[0])}else if(E.length>1){const w=E.indexOf(b);if(w>=0){const C=O(y);if(C)return(0,L.join)(C,E[w])}}}catch(o){}return null}e.realcaseSync=O;async function m(f){try{return await(0,k.promisify)(S.realpath)(f)}catch(y){const b=R(f);return await S.promises.access(b,S.constants.R_OK),b}}e.realpath=m;function v(f){try{return S.realpathSync(f)}catch(y){const b=R(f);return S.accessSync(b,S.constants.R_OK),b}}e.realpathSync=v;function R(f){return(0,A.rtrim)((0,L.normalize)(f),L.sep)}}),define(Z[95],ee([0,1,48,16]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(U){return new Promise((O,m)=>{let v;const R=new Map;function f(o,E,w,C,I){const g=R.get(E);if(o===U||g){const s={name:y(w),cmd:w,pid:o,ppid:E,load:C,mem:I};R.set(o,s),o===U&&(v=s),g&&(g.children||(g.children=[]),g.children.push(s),g.children.length>1&&(g.children=g.children.sort((r,t)=>r.pid-t.pid)))}}function y(o){const E=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,C=/--crashes-directory/,I=/\\pipe\\winpty-control/,g=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(w.exec(o))return"watcherService ";if(C.exec(o))return"electron-crash-reporter";if(I.exec(o))return"winpty-process";if(g.exec(o))return"console-window-host (Windows internal process)";let r=s.exec(o);if(r&&r.length===2)return r[1]==="renderer"?E.exec(o)?"shared-process":"window":r[1];const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(o),r&&(i+=r+" ");while(r);return i&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron_node ${i}`:o}if(process.platform==="win32"){const o=E=>E.indexOf("\\\\?\\")===0||E.indexOf("\\??\\")===0?E.substr(4):E.indexOf('"\\\\?\\')===0||E.indexOf('"\\??\\')===0?'"'+E.substr(5):E;new Promise((E,w)=>{K(["windows-process-tree"],E,w)}).then(E=>{E.getProcessList(U,w=>{E.getProcessCpuUsage(w,C=>{const I=new Map;C.forEach(g=>{const s=o(g.commandLine||"");I.set(g.pid,{name:y(s),cmd:s,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),v=I.get(U),v?(I.forEach(g=>{const s=I.get(g.ppid);s&&(s.children||(s.children=[]),s.children.push(g))}),I.forEach(g=>{g.children&&(g.children=g.children.sort((s,r)=>s.pid-r.pid))}),O(v)):m(new Error(`Root process ${U} not found`))})},E.ProcessDataFlag.CommandLine|E.ProcessDataFlag.Memory)})}else{function b(){let o=[v];const E=[];for(;o.length;){const C=o.shift();C&&(E.push(C.pid),C.children&&(o=o.concat(C.children)))}let w=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);w+=" "+E.join(" "),(0,S.exec)(w,{},(C,I,g)=>{if(C||g)m(C||new Error(g.toString()));else{const s=I.toString().split(`
`);for(let r=0;r<E.length;r++){const t=R.get(E[r]);t.load=parseFloat(s[r])}if(!v){m(new Error(`Root process ${U} not found`));return}O(v)}})}(0,S.exec)("which ps",{},(o,E,w)=>{if(o||w)if(process.platform!=="linux")m(o||new Error(w.toString()));else{const C=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,S.exec)(C,{},(I,g,s)=>{I||s?m(I||new Error(s.toString())):(L(g,f),b())})}else{const C=E.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${C} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,s,r)=>{g||r&&!r.includes("screen size is bogus")?m(g||new Error(r.toString())):(L(s,f),process.platform==="linux"?b():v?O(v):m(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=A;function L(U,O){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=U.toString().split(`
`);for(const R of v){const f=m.exec(R.trim());f&&f.length===6&&O(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(Z[96],ee([0,1,8,27,7,65,2,23]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function m(f,y,b){return R({path:f,isDirectory:!1},y,b)}e.watchFile=m;function v(f,y,b){return R({path:f,isDirectory:!0},y,b)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function R(f,y,b){const o=(0,S.basename)(f.path),E=new Map;let w=!1,C=[(0,U.toDisposable)(()=>{E.forEach(I=>(0,U.dispose)(I)),E.clear()})];try{const I=(0,k.watch)(f.path);C.push((0,U.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const g=new Set;f.isDirectory&&(0,O.readdir)(f.path).then(s=>s.forEach(r=>g.add(r))),I.on("error",(s,r)=>{w||b(`Failed to watch ${f.path} for changes using fs.watch() (${s}, ${r})`)}),I.on("change",(s,r)=>{if(!w){let t="";if(r&&(t=r.toString(),A.isMacintosh&&(t=(0,L.normalizeNFC)(t))),!(!t||s!=="change"&&s!=="rename")){const i=f.isDirectory?(0,S.join)(f.path,t):f.path;if(f.isDirectory)if(s==="rename"){const n=E.get(i);n&&(0,U.dispose)(n);const a=setTimeout(async()=>{E.delete(i);const c=await(0,O.exists)(i);if(!w){let l;c?g.has(t)?l="changed":(l="added",g.add(t)):(g.delete(t),l="deleted"),y(l,i)}},e.CHANGE_BUFFER_DELAY);E.set(i,(0,U.toDisposable)(()=>clearTimeout(a)))}else{let n;g.has(t)?n="changed":(n="added",g.add(t)),y(n,i)}else if(s==="rename"||t!==o){const n=setTimeout(async()=>{const a=await(0,O.exists)(i);w||(a?(y("changed",i),C=[R(f,y,b)]):y("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(C),C=[(0,U.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(I){(0,O.exists)(f.path).then(g=>{g&&!w&&b(`Failed to watch ${f.path} for changes using fs.watch() (${I.toString()})`)})}return(0,U.toDisposable)(()=>{w=!0,C=(0,U.dispose)(C)})}}),define(Z[34],ee([0,1,3,2,6,30,11,22,18,15,88,21]),function(K,e,S,k,A,L,U,O,m,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function b(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(o=e.ResponseType||(e.ResponseType={}));function E(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(w||(w={}));class C{constructor(D){this.buffer=D,this.pos=0}read(D){const T=this.buffer.slice(this.pos,this.pos+D);return this.pos+=T.byteLength,T}}class I{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var g;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(g||(g={}));function s(z){const D=O.VSBuffer.alloc(4);return D.writeUInt32BE(z,0),D}function r(z){return z.read(4).readUInt32BE(0)}function t(z){const D=O.VSBuffer.alloc(1);return D.writeUInt8(z,0),D}const i={Undefined:t(g.Undefined),String:t(g.String),Buffer:t(g.Buffer),VSBuffer:t(g.VSBuffer),Array:t(g.Array),Object:t(g.Object)},n=typeof Buffer!="undefined";function a(z,D){if(typeof D=="undefined")z.write(i.Undefined);else if(typeof D=="string"){const T=O.VSBuffer.fromString(D);z.write(i.String),z.write(s(T.byteLength)),z.write(T)}else if(n&&Buffer.isBuffer(D)){const T=O.VSBuffer.wrap(D);z.write(i.Buffer),z.write(s(T.byteLength)),z.write(T)}else if(D instanceof O.VSBuffer)z.write(i.VSBuffer),z.write(s(D.byteLength)),z.write(D);else if(Array.isArray(D)){z.write(i.Array),z.write(s(D.length));for(const T of D)a(z,T)}else{const T=O.VSBuffer.fromString(JSON.stringify(D));z.write(i.Object),z.write(s(T.byteLength)),z.write(T)}}function c(z){switch(z.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return z.read(r(z)).toString();case g.Buffer:return z.read(r(z)).buffer;case g.VSBuffer:return z.read(r(z));case g.Array:{const T=r(z),F=[];for(let N=0;N<T;N++)F.push(c(z));return F}case g.Object:return JSON.parse(z.read(r(z)).toString())}}class l{constructor(D,T,F=null,N=1e3){this.protocol=D,this.ctx=T,this.logger=F,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel(D,T){this.channels.set(D,T),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const T=this.send([D.type]);this.logger&&this.logger.logOutgoing(T,0,1,E(D.type));return}case 201:case 202:case 204:case 203:{const T=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(T,D.id,1,E(D.type),D.data);return}}}send(D,T=void 0){const F=new I;return a(F,D),a(F,T),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(T){return 0}}onRawMessage(D){const T=new C(D),F=c(T),N=c(T),x=F[0];switch(x){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}: ${F[2]}.${F[3]}`,N),this.onPromise({type:x,id:F[1],channelName:F[2],name:F[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}: ${F[2]}.${F[3]}`,N),this.onEventListen({type:x,id:F[1],channelName:F[2],name:F[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}`),this.disposeActiveRequest({type:x,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(x)}`),this.disposeActiveRequest({type:x,id:F[1]})}}onPromise(D){const T=this.channels.get(D.channelName);if(!T){this.collectPendingRequest(D);return}const F=new L.CancellationTokenSource;let N;try{N=T.call(this.ctx,D.name,D.arg,F.token)}catch(J){N=Promise.reject(J)}const x=D.id;N.then(J=>{this.sendResponse({id:x,data:J,type:201}),this.activeRequests.delete(D.id)},J=>{J instanceof Error?this.sendResponse({id:x,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:x,data:J,type:203}),this.activeRequests.delete(D.id)});const G=(0,k.toDisposable)(()=>F.cancel());this.activeRequests.set(D.id,G)}onEventListen(D){const T=this.channels.get(D.channelName);if(!T){this.collectPendingRequest(D);return}const F=D.id,x=T.listen(this.ctx,D.name,D.arg)(G=>this.sendResponse({id:F,data:G,type:204}));this.activeRequests.set(D.id,x)}disposeActiveRequest(D){const T=this.activeRequests.get(D.id);T&&(T.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let T=this.pendingRequests.get(D.channelName);T||(T=[],this.pendingRequests.set(D.channelName,T));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);T.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const T=this.pendingRequests.get(D);if(T){for(const F of T)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var u;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(D,T=null){this.protocol=D,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=T}getChannel(D){const T=this;return{call(F,N,x){return T.isDisposed?Promise.reject(U.canceled()):T.requestPromise(D,F,N,x)},listen(F,N){return T.isDisposed?Promise.reject(U.canceled()):T.requestEvent(D,F,N)}}}requestPromise(D,T,F,N=L.CancellationToken.None){const x=this.lastRequestId++,J={id:x,type:100,channelName:D,name:T,arg:F};if(N.isCancellationRequested)return Promise.reject(U.canceled());let Q;return new Promise((ie,ce)=>{if(N.isCancellationRequested)return ce(U.canceled());const ue=()=>{const Oe=Ae=>{switch(Ae.type){case 201:this.handlers.delete(x),ie(Ae.data);break;case 202:this.handlers.delete(x);const Ue=new Error(Ae.data.message);Ue.stack=Ae.data.stack,Ue.name=Ae.data.name,ce(Ue);break;case 203:this.handlers.delete(x),ce(Ae.data);break}};this.handlers.set(x,Oe),this.sendRequest(J)};let ge=null;this.state===w.Idle?ue():(ge=(0,A.createCancelablePromise)(Oe=>this.whenInitialized()),ge.then(()=>{ge=null,ue()}));const Ee=()=>{ge?(ge.cancel(),ge=null):this.sendRequest({id:x,type:101}),ce(U.canceled())},Ie=N.onCancellationRequested(Ee);Q=(0,k.combinedDisposable)((0,k.toDisposable)(Ee),Ie),this.activeRequests.add(Q)}).finally(()=>{this.activeRequests.delete(Q)})}requestEvent(D,T,F){const N=this.lastRequestId++,G={id:N,type:102,channelName:D,name:T,arg:F};let J=null;const Q=new S.Emitter({onFirstListenerAdd:()=>{J=(0,A.createCancelablePromise)(ie=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(Q),this.sendRequest(G)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(Q),this.sendRequest({id:N,type:103}))}}),ne=ie=>Q.fire(ie.data);return this.handlers.set(N,ne),Q.event}sendRequest(D){switch(D.type){case 100:case 102:{const T=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(T,D.id,0,`${b(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const T=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(T,D.id,0,b(D.type));return}}}send(D,T=void 0){const F=new I;return a(F,D),a(F,T),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(T){return 0}}onBuffer(D){const T=new C(D),F=c(T),N=c(T),x=F[0];switch(x){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,E(x)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,E(x),N),this.onResponse({type:F[0],id:F[1],data:N})}}onResponse(D){if(D.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const T=this.handlers.get(D.id);T&&T(D)}whenInitialized(){return this.state===w.Idle?Promise.resolve():S.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelClient=d;class p{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:T,onDidClientDisconnect:F})=>{S.Event.once(T.onMessage)(x=>{const G=new C(x),J=c(G),Q=new l(T,J),ne=new d(T);this.channels.forEach((ce,ue)=>Q.registerChannel(ue,ce));const ie={channelServer:Q,channelClient:ne,ctx:J};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{Q.dispose(),ne.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const D=[];return this._connections.forEach(T=>D.push(T)),D}getChannel(D,T){const F=this;return{call(N,x,G){let J;if((0,v.isFunction)(T)){let ne=(0,m.getRandomElement)(F.connections.filter(T));J=ne?Promise.resolve(ne):S.Event.toPromise(S.Event.filter(F.onDidAddConnection,T))}else J=T.routeCall(F,N,x);const Q=J.then(ne=>ne.channelClient.getChannel(D));return P(Q).call(N,x,G)},listen(N,x){if((0,v.isFunction)(T))return F.getMulticastEvent(D,T,N,x);const G=T.routeEvent(F,N,x).then(J=>J.channelClient.getChannel(D));return P(G).listen(N,x)}}}getMulticastEvent(D,T,F,N){const x=this;let G=new k.DisposableStore;const J=new S.Emitter({onFirstListenerAdd:()=>{G=new k.DisposableStore;const Q=new S.EventMultiplexer,ne=new Map,ie=ue=>{const Ee=ue.channelClient.getChannel(D).listen(F,N),Ie=Q.add(Ee);ne.set(ue,Ie)},ce=ue=>{const ge=ne.get(ue);!ge||(ge.dispose(),ne.delete(ue))};x.connections.filter(T).forEach(ie),S.Event.filter(x.onDidAddConnection,T)(ie,void 0,G),x.onDidRemoveConnection(ce,void 0,G),Q.event(J.fire,J,G),G.add(Q)},onLastListenerRemove:()=>{G.dispose()}});return J.event}registerChannel(D,T){this.channels.set(D,T),this._connections.forEach(F=>{F.channelServer.registerChannel(D,T)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class h{constructor(D,T,F=null){const N=new I;a(N,T),D.send(N.buffer),this.channelClient=new d(D,F),this.channelServer=new l(D,T,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,T){this.channelServer.registerChannel(D,T)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=h;function P(z){return{call(D,T,F){return z.then(N=>N.call(D,T,F))},listen(D,T){const F=new S.Relay;return z.then(N=>F.input=N.listen(D,T)),F.event}}}e.getDelayedChannel=P;function _(z){let D=!1;return{call(T,F,N){return D?z.call(T,F,N):(0,A.timeout)(0).then(()=>D=!0).then(()=>z.call(T,F,N))},listen(T,F){if(D)return z.listen(T,F);const N=new S.Relay;return(0,A.timeout)(0).then(()=>D=!0).then(()=>N.input=z.listen(T,F)),N.event}}}e.getNextTickChannel=_;class j{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const T of D.connections)if(await Promise.resolve(this.fn(T.ctx)))return Promise.resolve(T);return await S.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=j;var B;(function(z){function D(N,x){const G=N,J=x&&x.disableMarshalling,Q=new Map;for(const ne in G)F(ne)&&Q.set(ne,S.Event.buffer(G[ne],!0));return new class{listen(ne,ie){const ce=Q.get(ie);if(ce)return ce;throw new Error(`Event not found: ${ie}`)}call(ne,ie,ce){const ue=G[ie];if(typeof ue=="function"){if(!J&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,R.revive)(ce[ge]);return ue.apply(G,ce)}throw new Error(`Method not found: ${ie}`)}}}z.fromService=D;function T(N,x){const G=x&&x.disableMarshalling;return new Proxy({},{get(J,Q){var ne;if(typeof Q=="string")return((ne=x==null?void 0:x.properties)===null||ne===void 0?void 0:ne.has(Q))?x.properties.get(Q):F(Q)?N.listen(Q):async function(...ie){let ce;x&&!(0,v.isUndefinedOrNull)(x.context)?ce=[x.context,...ie]:ce=ie;const ue=await N.call(Q,ce);return G?ue:(0,R.revive)(ue)};throw new Error(`Property not found: ${String(Q)}`)}})}z.toService=T;function F(N){return N[0]==="o"&&N[1]==="n"&&f.isUpperAsciiLetter(N.charCodeAt(2))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let D=z.toString();if(D!=="[object Object]")return D}return z}function V(z){return Array.isArray(z)?z.map($):$(z)}function q(z,D,T,F,N,x,G){G=V(G);const J=M[N],Q=J[F%J.length];let ne=[`%c[${z}]%c[${String(D).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(x)?(ne=ne.concat(G),ne.push(")")):ne.push(G),console.log.apply(console,ne)}e.logWithColors=q;class H{constructor(D,T){this._outgoingPrefix=D,this._incomingPrefix=T,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,T,F,N,x){this._totalOutgoing+=D,q(this._outgoingPrefix,this._totalOutgoing,D,T,F,N,x)}logIncoming(D,T,F,N,x){this._totalIncoming+=D,q(this._incomingPrefix,this._totalIncoming,D,T,F,N,x)}}e.IPCLogger=H}),define(Z[97],ee([0,1,3,34,22]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(m){this.port=m,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",v=>A.VSBuffer.wrap(v.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class U extends k.IPCClient{constructor(m,v){const R=new L(m);super(R,v);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[98],ee([0,1,99,3,34,97]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends A.IPCServer{static getOnDidClientConnect(){const m=k.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(v,R)=>R);return k.Event.map(m,v=>{const{port1:R,port2:f}=new MessageChannel,b={protocol:new L.Protocol(R),onDidClientDisconnect:k.Event.fromDOMEventEmitter(R,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[f]),b})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[100],ee([0,1,11,22]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(O,m){O.proxyAuthorization&&(O.headers=Object.assign(Object.assign({},O.headers||{}),{"Proxy-Authorization":O.proxyAuthorization}));const v=new XMLHttpRequest;return new Promise((R,f)=>{v.open(O.type||"GET",O.url||"",!0,O.user,O.password),L(v,O),v.responseType="arraybuffer",v.onerror=y=>f(new Error(v.statusText&&"XHR failed: "+v.statusText||"XHR failed")),v.onload=y=>{R({res:{statusCode:v.status,headers:U(v)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(v.response)))})},v.ontimeout=y=>f(new Error(`XHR timeout: ${O.timeout}ms`)),O.timeout&&(v.timeout=O.timeout),v.send(O.data),m.onCancellationRequested(()=>{v.abort(),f((0,S.canceled)())})})}e.request=A;function L(O,m){if(m.headers){e:for(let v in m.headers){switch(v){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}O.setRequestHeader(v,m.headers[v])}}}function U(O){const m=Object.create(null);for(const v of O.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(v){const R=v.indexOf(":");m[v.substr(0,R).trim().toLowerCase()]=v.substr(R+1).trim()}return m}}),define(Z[67],ee([0,1,2,3,6,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var O;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(O||(O={}));class m extends S.Disposable{constructor(f,y=Object.create(null)){super();this.database=f,this.options=y,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=O.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){var y,b;(y=f.changed)===null||y===void 0||y.forEach((o,E)=>this.accept(E,o)),(b=f.deleted)===null||b===void 0||b.forEach(o=>this.accept(o,void 0))}accept(f,y){if(this.state!==O.Closed){let b=!1;(0,L.isUndefinedOrNull)(y)?b=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),b=!0),b&&this._onDidChangeStorage.fire(f)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===O.None&&(this.state=O.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const b=this.cache.get(f);return(0,L.isUndefinedOrNull)(b)?y:b}getBoolean(f,y){const b=this.get(f);return(0,L.isUndefinedOrNull)(b)?y:b==="true"}getNumber(f,y){const b=this.get(f);return(0,L.isUndefinedOrNull)(b)?y:parseInt(b,10)}async set(f,y){if(this.state!==O.Closed){if((0,L.isUndefinedOrNull)(y))return this.delete(f);const b=String(y);if(this.cache.get(f)!==b)return this.cache.set(f,b),this.pendingInserts.set(f,b),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(f){if(this.state!==O.Closed&&!!this.cache.delete(f))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=O.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((y,b)=>this.items.set(b,y)),f.delete&&f.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[101],ee([13,14]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[54],ee([0,1,101]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,L=A*24,U=L*7,O=L*30,m=L*365;function v(f,y){typeof f!="number"&&(f=f.getTime());const b=Math.round((new Date().getTime()-f)/1e3);if(b<-30)return(0,S.localize)(0,null,v(new Date().getTime()+b*1e3,!1));if(b<30)return(0,S.localize)(1,null);let o;return b<k?(o=b,y?o===1?(0,S.localize)(2,null,o):(0,S.localize)(3,null,o):o===1?(0,S.localize)(4,null,o):(0,S.localize)(5,null,o)):b<A?(o=Math.floor(b/k),y?o===1?(0,S.localize)(6,null,o):(0,S.localize)(7,null,o):o===1?(0,S.localize)(8,null,o):(0,S.localize)(9,null,o)):b<L?(o=Math.floor(b/A),y?o===1?(0,S.localize)(10,null,o):(0,S.localize)(11,null,o):o===1?(0,S.localize)(12,null,o):(0,S.localize)(13,null,o)):b<U?(o=Math.floor(b/L),y?o===1?(0,S.localize)(14,null,o):(0,S.localize)(15,null,o):o===1?(0,S.localize)(16,null,o):(0,S.localize)(17,null,o)):b<O?(o=Math.floor(b/U),y?o===1?(0,S.localize)(18,null,o):(0,S.localize)(19,null,o):o===1?(0,S.localize)(20,null,o):(0,S.localize)(21,null,o)):b<m?(o=Math.floor(b/O),y?o===1?(0,S.localize)(22,null,o):(0,S.localize)(23,null,o):o===1?(0,S.localize)(24,null,o):(0,S.localize)(25,null,o)):(o=Math.floor(b/m),y?o===1?(0,S.localize)(26,null,o):(0,S.localize)(27,null,o):o===1?(0,S.localize)(28,null,o):(0,S.localize)(29,null,o))}e.fromNow=v;function R(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Z[102],ee([13,14]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,102,15,18]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(v,R){return R&&(v.stack||v.stacktrace)?S.localize(0,null,O(v),U(v.stack)||U(v.stacktrace)):O(v)}function U(v){return Array.isArray(v)?v.join(`
`):v}function O(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function m(v=null,R=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const f=A.coalesce(v),y=m(f[0],R);return f.length>1?S.localize(4,null,y,f.length):y}if(k.isString(v))return v;if(v.detail){const f=v.detail;if(f.error)return L(f.error,R);if(f.exception)return L(f.exception,R)}return v.stack?L(v,R):v.message?v.message:S.localize(5,null)}e.toErrorMessage=m}),define(Z[103],ee([13,14]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[104],ee([0,1,8,27,23,48,103,36,15,26,42,7,66,16]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function o(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function E(r,t){if(f.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const n=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(a=>{n.once("error",c=>{a({success:!1,error:c})}),n.once("exit",(c,l)=>{a(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?o(i.status):1})}else if(f.isLinux||f.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{L.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(a,c,l)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function w(r=O.env){return r.comspec||"cmd.exe"}e.getWindowsShell=w;class C{constructor(t,i,n,a){if(i!==void 0&&n!==void 0&&a!==void 0)this.cmd=t,this.args=i,this.shell=n,this.options=a;else{const c=t;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(O.env).forEach(l=>{c[l]=O.env[l]}),Object.keys(this.options.env).forEach(l=>{c[l]=this.options.env[l]}),this.options.env=c}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(S.sep);return i!==-1&&(t=t.substring(i+1)),C.WellKnowCommands[t]?t:"other"}start(t){return f.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(O.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let n,a;const c=new Promise((l,u)=>{n=l,a=u});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=L.exec(l,this.options,(u,d,p)=>{this.childProcess=null;const h=u;h&&h.killed?a({killed:this.terminateRequested,stdout:d.toString(),stderr:p.toString()}):this.handleExec(n,t,u,d,p)})}else{let l=null;const u=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,t,a);const p={terminated:this.terminateRequested};m.isNumber(d)&&(p.cmdCode=d),n(p)};if(this.shell&&f.isWindows){const d=v.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let p=!1,h=!1;const P=[];let _=this.ensureQuotes(this.cmd);P.push(_.value),p=_.quoted,this.args&&this.args.forEach(B=>{_=this.ensureQuotes(B),P.push(_.value),h=h&&_.quoted});const j=["/s","/c"];p?h?j.push('"'+P.join(" ")+'"'):P.length>1?j.push('"'+P[0]+'" '+P.slice(1).join(" ")):j.push('"'+P[0]+'"'):j.push(P.join(" ")),l=L.spawn(w(),j,d)}else this.cmd&&(l=L.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(m.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,a({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",u),this.handleSpawn(l,n,t,a,!0)))}return c})}handleClose(t,i,n,a){}ensureQuotes(t){return C.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,E(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!f.isWindows)return t(!1);const i=L.spawn(w(),["/s","/c"]);i.on("error",n=>t(!0)),i.on("exit",n=>t(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class I extends C{constructor(t,i,n,a){super(t,i,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,n,a,c){[a,c].forEach((l,u)=>{const d=new y.LineDecoder;d.write(l).forEach(P=>{i({line:P,source:u===0?0:1})});const h=d.end();h&&i({line:h,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,i,n,a,c){const l=new y.LineDecoder,u=new y.LineDecoder;t.stdout.on("data",d=>{l.write(d).forEach(h=>n({line:h,source:0}))}),t.stderr.on("data",d=>{u.write(d).forEach(h=>n({line:h,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=u}handleClose(t,i,n,a){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&n({line:c,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&n({line:l,source:1})}}e.LineProcess=I;function g(r){let t=[],i=!1;const n=function(a){if(i){t.push(a);return}(!r.send(a,l=>{if(l&&console.error(l),i=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(d=>n(d))}})||f.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=g;var s;(function(r){async function t(i,n,a){if(S.isAbsolute(i))return i;if(n===void 0&&(n=O.cwd()),S.dirname(i)!=="."||(a===void 0&&m.isString(O.env.PATH)&&(a=O.env.PATH.split(S.delimiter)),a===void 0||a.length===0))return S.join(n,i);async function l(u){return await A.exists(u)?!(await k.promises.stat(u)).isDirectory():!1}for(let u of a){let d;if(S.isAbsolute(u)?d=S.join(u,i):d=S.join(n,u,i),await l(d))return d;let p=d+".com";if(await l(p)||(p=d+".exe",await l(p)))return p}return S.join(n,i)}r.findExecutable=t})(s=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,104,34,87,30,11,22,7]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class o extends m.ChannelServer{constructor(C){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(g){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",I=>y.VSBuffer.wrap(Buffer.from(I,"base64")))},C);process.once("disconnect",()=>this.dispose())}}e.Server=o;class E{constructor(C,I){this.modulePath=C,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new A.Delayer(g),this.child=null,this._client=null}getChannel(C){const I=this;return{call(g,s,r){return I.requestPromise(C,g,s,r)},listen(g,s){return I.requestEvent(C,g,s)}}}requestPromise(C,I,g,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(C),t=(0,A.createCancelablePromise)(a=>r.call(I,g,a)),i=s.onCancellationRequested(()=>t.cancel()),n=(0,k.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(C,I,g){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let s;const r=new U.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(C).listen(I,g)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},(0,L.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),b.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,C,I);const g=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,v.isRemoteConsoleLog)(c)){(0,v.log)(c,`IPC Library: ${this.options.serverName}`);return}g.fire(y.VSBuffer.wrap(Buffer.from(c,"base64")))});const r=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&r.send(c.buffer.toString("base64")),i=g.event,n={send:t,onMessage:i};this._client=new m.ChannelClient(n);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",a),this.activeRequests.forEach(u=>(0,k.dispose)(u)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(C){let I=this.channels.get(C);return I||(I=this.client.getChannel(C),this.channels.set(C,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Z[105],ee([13,14]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[106],ee([13,14]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[107],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[108],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[109],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[110],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[111],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[112],ee([13,14]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[113],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[114],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[115],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[116],ee([13,14]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[117],ee([13,14]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[118],ee([13,14]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[119],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[120],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[121],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[122],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[123],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[124],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var he=this&&this.__decorate||function(K,e,S,k){var A=arguments.length,L=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,S):k,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,S,k);else for(var O=K.length-1;O>=0;O--)(U=K[O])&&(L=(A<3?U(L):A>3?U(e,S,L):U(e,S))||L);return A>3&&L&&Object.defineProperty(e,S,L),L};define(Z[125],ee([0,1,8,12,85,54,16,4,36]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(o,E,w){this._args=o,this.paths=E,this.productService=w}get appRoot(){return(0,S.dirname)(U.FileAccess.asFileUri("",K).fsPath)}get userHome(){return O.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return O.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const o=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",o)}return this.args.logsPath}get userDataSyncLogResource(){return O.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(O.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return O.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return O.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=m.env.VSCODE_PORTABLE;return o?O.URI.file((0,S.join)(o,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,S.resolve)(o):(0,S.normalize)((0,S.join)(U.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const o=this.args["extensions-download-dir"];return o?(0,S.resolve)(o):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,S.resolve)(o);const E=m.env.VSCODE_EXTENSIONS;if(E)return E;const w=m.env.VSCODE_PORTABLE;return w?(0,S.join)(w,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(E=>/^[^:/?#]+?:\/\//.test(E)?O.URI.parse(E):O.URI.file((0,S.normalize)(E)))}get extensionDevelopmentKind(){var o;return(o=this.args.extensionDevelopmentKind)===null||o===void 0?void 0:o.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?O.URI.parse(o):O.URI.file((0,S.normalize)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!m.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return O.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}he([A.memoize],v.prototype,"appRoot",null),he([A.memoize],v.prototype,"userHome",null),he([A.memoize],v.prototype,"userDataPath",null),he([A.memoize],v.prototype,"appSettingsHome",null),he([A.memoize],v.prototype,"tmpDir",null),he([A.memoize],v.prototype,"userRoamingDataHome",null),he([A.memoize],v.prototype,"settingsResource",null),he([A.memoize],v.prototype,"userDataSyncHome",null),he([A.memoize],v.prototype,"userDataSyncLogResource",null),he([A.memoize],v.prototype,"sync",null),he([A.memoize],v.prototype,"machineSettingsResource",null),he([A.memoize],v.prototype,"globalStorageHome",null),he([A.memoize],v.prototype,"workspaceStorageHome",null),he([A.memoize],v.prototype,"keybindingsResource",null),he([A.memoize],v.prototype,"keyboardLayoutResource",null),he([A.memoize],v.prototype,"argvResource",null),he([A.memoize],v.prototype,"snippetsHome",null),he([A.memoize],v.prototype,"isExtensionDevelopment",null),he([A.memoize],v.prototype,"untitledWorkspacesHome",null),he([A.memoize],v.prototype,"installSourcePath",null),he([A.memoize],v.prototype,"builtinExtensionsPath",null),he([A.memoize],v.prototype,"extensionsPath",null),he([A.memoize],v.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],v.prototype,"extensionDevelopmentKind",null),he([A.memoize],v.prototype,"extensionTestsLocationURI",null),he([A.memoize],v.prototype,"debugExtensionHost",null),he([A.memoize],v.prototype,"serviceMachineIdResource",null),he([A.memoize],v.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=v;function R(b,o){return y(b["inspect-extensions"],b["inspect-brk-extensions"],5870,o,b.debugId)}e.parseExtensionHostPort=R;function f(b,o){return y(b["inspect-search"],b["inspect-brk-search"],5876,o)}e.parseSearchPort=f;function y(b,o,E,w,C){const g=Number(o||b)||(w?null:E),s=g?Boolean(!!o):!1;return{port:g,break:s,debugId:C}}}),function(){"use strict";function K(e,S,k,A){function L(O){const m=U(O),v=[m];return e.isAbsolute(m)||v.unshift(A),e.resolve(...v)}function U(O){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");const v=O["user-data-dir"];if(v)return v;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(f,"AppData","Roaming")}break;case"darwin":R=e.join(S.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,k)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[126],ee([0,200,38,16,12,36]),function(e,S,k,A,L,U){const O=L.dirname(A.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(L.joinPath(O,"package.json").fsPath);return K(S,k,m.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),k=require("os");module.exports=K(S,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[127],ee([0,1,38,126,125]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends A.AbstractNativeEnvironmentService{constructor(O,m){super(O,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(O)},m)}}e.NativeEnvironmentService=L}),define(Z[128],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,O=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(w){const C=w.match(U);return C?C[1]:null}function R(w){if(w.indexOf("://")===-1){const C=w.match(k);return C?v(C[2]):null}try{const C=S.URI.parse(w);if(C.authority)return v(C.authority)}catch(C){}return null}function f(w,C){const I=new Set;let g;for(;g=O.exec(w);){const r=R(g[1]);r&&I.add(r)}const s=new Set(C);return Array.from(I).map(r=>s.has(r)?r:r.replace(m,"a"))}e.getDomainsOfRemotes=f;function y(w){const C=w.match(L);return C?C[2]:null}function b(w,C,I){return w&&C?(I&&C.endsWith(".git")&&(C=C.substr(0,C.length-4)),C.indexOf("/")===0?`${w}${C}`:`${w}/${C}`):null}function o(w,C){if(w.indexOf("://")===-1){const I=w.match(A);if(I)return b(I[2],I[3],C)}try{const I=S.URI.parse(w);if(I.authority)return b(y(I.authority),I.path,C)}catch(I){}return null}function E(w,C=!1){const I=[];let g;for(;g=O.exec(w);){const s=o(g[1],C);s&&I.push(s)}return I}e.getRemotes=E}),define(Z[129],ee([0,1,3,4,90,26,2]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function O(o,E){return k.URI.revive(E?E.transformIncoming(o):o)}function m(o,E){return E?E.transformOutgoingURI(o):o}function v(o,E){E=E||A.DefaultURITransformer;const w=o.manifest,C=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},o),{manifest:void 0}),E);return Object.assign(Object.assign({},C),{manifest:w})}function R(o,E){return E?(0,L.cloneAndChange)(o,w=>w instanceof k.URI?E.transformOutgoingURI(w):void 0):o}class f{constructor(E,w){this.service=E,this.getUriTransformer=w,this.onInstallExtension=S.Event.buffer(E.onInstallExtension,!0),this.onDidInstallExtension=S.Event.buffer(E.onDidInstallExtension,!0),this.onUninstallExtension=S.Event.buffer(E.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(E.onDidUninstallExtension,!0)}listen(E,w){const C=this.getUriTransformer(E);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return S.Event.map(this.onDidInstallExtension,I=>Object.assign(Object.assign({},I),{local:I.local?R(I.local,C):I.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(E,w,C){const I=this.getUriTransformer(E);switch(w){case"zip":return this.service.zip(v(C[0],I)).then(g=>m(g,I));case"unzip":return this.service.unzip(O(C[0],I));case"install":return this.service.install(O(C[0],I));case"getManifest":return this.service.getManifest(O(C[0],I));case"canInstall":return this.service.canInstall(C[0]);case"installFromGallery":return this.service.installFromGallery(C[0],C[1]);case"uninstall":return this.service.uninstall(v(C[0],I),C[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(C[0],I));case"getInstalled":return this.service.getInstalled(C[0]).then(g=>g.map(s=>R(s,I)));case"updateMetadata":return this.service.updateMetadata(v(C[0],I),C[1]).then(g=>R(g,I));case"updateExtensionScope":return this.service.updateExtensionScope(v(C[0],I),C[1]).then(g=>R(g,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class y extends U.Disposable{constructor(E){super();this.channel=E,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new S.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire(w))),this._register(this.channel.listen("onDidInstallExtension")(w=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},w),{local:w.local?v(w.local,null):w.local})))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}zip(E){return Promise.resolve(this.channel.call("zip",[E]).then(w=>k.URI.revive(w)))}unzip(E){return Promise.resolve(this.channel.call("unzip",[E]))}install(E){return Promise.resolve(this.channel.call("install",[E])).then(w=>v(w,null))}getManifest(E){return Promise.resolve(this.channel.call("getManifest",[E]))}async canInstall(E){return!0}installFromGallery(E,w){return Promise.resolve(this.channel.call("installFromGallery",[E,w])).then(C=>v(C,null))}uninstall(E,w){return Promise.resolve(this.channel.call("uninstall",[E,w]))}reinstallFromGallery(E){return Promise.resolve(this.channel.call("reinstallFromGallery",[E]))}getInstalled(E=null){return Promise.resolve(this.channel.call("getInstalled",[E])).then(w=>w.map(C=>v(C,null)))}updateMetadata(E,w){return Promise.resolve(this.channel.call("updateMetadata",[E,w])).then(C=>v(C,null))}updateExtensionScope(E,w){return Promise.resolve(this.channel.call("updateExtensionScope",[E,w])).then(C=>v(C,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=y;class b{constructor(E){this.service=E}listen(E,w){throw new Error("Invalid listen")}call(E,w,C){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(C[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[130],ee([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function A(L,U){const O=m=>{if(typeof m=="string"){const v=k.exec(m);if(!!v)return U[v[1]]||m}};return(0,S.cloneAndChange)(L,O)}e.localizeManifest=A}),define(Z[131],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,U,O,m){return this.channel.call("promptImportantExtensionsInstallNotification",[L,U,O,m])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class k{constructor(L){this.service=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,O){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(O[0],O[1],O[2],O[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[68],ee([0,1,112]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=A;function L(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=f.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=L;function U(f){if(!f)return null;let y=f.majorBase,b=f.majorMustEqual,o=f.minorBase,E=f.minorMustEqual,w=f.patchBase,C=f.patchMustEqual;return f.hasCaret&&(y===0||(E=!1),C=!1),{majorBase:y,majorMustEqual:b,minorBase:o,minorMustEqual:E,patchBase:w,patchMustEqual:C,isMinimum:f.hasGreaterEquals}}e.normalizeVersion=U;function O(f,y){let b;typeof f=="string"?b=U(L(f)):b=f;let o;if(typeof y=="string"?o=U(L(y)):o=y,!b||!o)return!1;let E=b.majorBase,w=b.minorBase,C=b.patchBase,I=o.majorBase,g=o.minorBase,s=o.patchBase,r=o.majorMustEqual,t=o.minorMustEqual,i=o.patchMustEqual;return o.isMinimum?E>I?!0:E<I?!1:w>g?!0:w<g?!1:C>=s:(E===1&&I===0&&(!r||!t||!i)&&(I=1,g=0,s=0,r=!0,t=!1,i=!1),E<I?!1:E>I?!r:w<g?!1:w>g?!t:C<s?!1:C>s?!i:!0)}e.isValidVersion=O;function m(f,y,b){return y.isBuiltin||typeof y.main=="undefined"?!0:R(f,y.engines.vscode,b)}e.isValidExtensionVersion=m;function v(f,y){return f==="*"||R(y,f)}e.isEngineValid=v;function R(f,y,b=[]){let o=U(L(y));if(!o)return b.push(S.localize(0,null,y)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return b.push(S.localize(1,null,y)),!1}else if(!o.majorMustEqual)return b.push(S.localize(2,null,y)),!1;return O(f,o)?!0:(b.push(S.localize(3,null,f,y)),!1)}e.isVersionValid=R}),define(Z[132],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(m,v,R,f){super();this.folders=m,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(m,v,R,f,y={}){super();this.folders=m,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=f,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(m.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[134],ee([0,1,48,66,89,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(m,v,R,f,y){this.watchedFolder=m,this.eventCallback=R,this.logCallback=f,this.verboseLogging=y,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(b=>A.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=S.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const v=new k.LineDecoder;this.handle.stdout.on("data",R=>{const f=[];v.write(R).forEach(y=>{const b=y.split("|");if(b.length===2){const o=Number(b[0]),E=b[1];if(o>=0&&o<3){if(this.ignored&&this.ignored.some(w=>w(E))){this.verboseLogging&&this.log(E);return}f.push({type:U.changeTypeMap[o],path:E})}else this.log(b[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,f)=>this.onExit(R,f))}onError(m){this.error("process error: "+m.toString())}onExit(m,v){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${v})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[135],ee([0,1,134,8,21]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L{constructor(O,m,v,R){this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=R,this.service=void 0,this.folder=O[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,O=>this.onFileEvents(O),O=>this.onLogMessage(O),this.verboseLogging)}setVerboseLogging(O){this.verboseLogging=O,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(O){this.isDisposed||O.length>0&&this.onDidFilesChange(O)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=L}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class S{constructor(L,U=[],O=!1){this.ctor=L,this.staticArguments=U,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=S;const k=(A,...L)=>new S(A,L);e.createSyncDescriptor=k}),define(Z[136],ee([0,1,50]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(U,O,m){O instanceof S.SyncDescriptor||(O=new S.SyncDescriptor(O,[],m)),k.push([U,O])}e.registerSingleton=A;function L(){return k}e.getSingletonServiceDescriptors=L}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=S;class k{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let U of this._nodes.values())U.outgoing.size===0&&L.push(U);return L}insertEdge(L,U){const O=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(U);O.outgoing.set(this._hashFn(U),m),m.incoming.set(this._hashFn(L),O)}removeNode(L){const U=this._hashFn(L);this._nodes.delete(U);for(let O of this._nodes.values())O.outgoing.delete(U),O.incoming.delete(U)}lookupOrInsertNode(L){const U=this._hashFn(L);let O=this._nodes.get(U);return O||(O=new S(L),this._nodes.set(U,O)),O}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[U,O]of this._nodes)L.push(`${U}, (incoming)[${[...O.incoming.keys()].join(", ")}], (outgoing)[${[...O.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,U]of this._nodes){const O=new Set([L]),m=this._findCycle(U,O);if(m)return m}}_findCycle(L,U){for(let[O,m]of L.outgoing){if(U.has(O))return[...U,O].join(" -> ");U.add(O);const v=this._findCycle(m,U);if(v)return v;U.delete(O)}}}e.Graph=k}),define(Z[5],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function m(v){return v[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=m})(S=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(O,m,v,R){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:O,index:v,optional:R}):(m[S.DI_DEPENDENCIES]=[{id:O,index:v,optional:R}],m[S.DI_TARGET]=m)}function A(O){if(S.serviceIds.has(O))return S.serviceIds.get(O);const m=function(v,R,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(m,v,f,!1)};return m.toString=()=>O,S.serviceIds.set(O,m),m}e.createDecorator=A;function L(O){return O}e.refineServiceDecorator=L;function U(O){return function(m,v,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(O,m,R,!0)}}e.optional=U}),define(Z[138],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(Z[139],ee([0,1,21,5,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=A.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",A.isMacintosh),U.set("isLinux",A.isLinux),U.set("isWindows",A.isWindows),U.set("isWeb",A.isWeb),U.set("isMacNative",A.isMacintosh&&!A.isWeb),U.set("isEdge",L.indexOf("Edg/")>=0),U.set("isFirefox",L.indexOf("Firefox")>=0),U.set("isChrome",L.indexOf("Chrome")>=0),U.set("isSafari",L.indexOf("Safari")>=0),U.set("isIPad",L.indexOf("iPad")>=0);const O=Object.prototype.hasOwnProperty;var m;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return f.INSTANCE}static true(){return y.INSTANCE}static has(h){return b.create(h)}static equals(h,P){return o.create(h,P)}static notEquals(h,P){return C.create(h,P)}static regex(h,P){return i.create(h,P)}static in(h,P){return E.create(h,P)}static not(h){return I.create(h)}static and(...h){return a.create(h)}static or(...h){return c.create(h)}static greater(h,P){return g.create(h,P)}static less(h,P){return r.create(h,P)}static deserialize(h,P=!1){if(!!h)return this._deserializeOrExpression(h,P)}static _deserializeOrExpression(h,P){let _=h.split("||");return c.create(_.map(j=>this._deserializeAndExpression(j,P)))}static _deserializeAndExpression(h,P){let _=h.split("&&");return a.create(_.map(j=>this._deserializeOne(j,P)))}static _deserializeOne(h,P){if(h=h.trim(),h.indexOf("!=")>=0){let _=h.split("!=");return C.create(_[0].trim(),this._deserializeValue(_[1],P))}if(h.indexOf("==")>=0){let _=h.split("==");return o.create(_[0].trim(),this._deserializeValue(_[1],P))}if(h.indexOf("=~")>=0){let _=h.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(h.indexOf(" in ")>=0){let _=h.split(" in ");return E.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const _=h.split(">=");return s.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const _=h.split(">");return g.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const _=h.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const _=h.split("<");return r.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(h)?I.create(h.substr(1).trim()):b.create(h)}static _deserializeValue(h,P){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let _=/^'([^']*)'$/.exec(h);return _?_[1].trim():h}static _deserializeRegexValue(h,P){if((0,S.isFalsyOrWhitespace)(h)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=h.indexOf("/"),j=h.lastIndexOf("/");if(_===j||_<0){if(P)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let B=h.slice(_+1,j),M=h[j+1]==="i"?"i":"";try{return new RegExp(B,M)}catch($){if(P)throw new Error(`bad regexp-value '${h}', parse error: ${$}`);return console.warn(`bad regexp-value '${h}', parse error: ${$}`),null}}}e.ContextKeyExpr=v;function R(p,h){return p.cmp(h)}class f{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class y{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class b{constructor(h){this.key=h,this.type=2}static create(h){const P=U.get(h);return typeof P=="boolean"?P?y.INSTANCE:f.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:u(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=b;class o{constructor(h,P){this.key=h,this.value=P,this.type=4}static create(h,P){if(typeof P=="boolean")return P?b.create(h):I.create(h);const _=U.get(h);return typeof _=="boolean"?P===(_?"true":"false")?y.INSTANCE:f.INSTANCE:new o(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return C.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class E{constructor(h,P){this.key=h,this.valueKey=P,this.type=10}static create(h,P){return new E(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const P=h.getValue(this.valueKey),_=h.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?O.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=E;class w{constructor(h){this._actual=h,this.type=11}static create(h){return new w(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new w(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class C{constructor(h,P){this.key=h,this.value=P,this.type=5}static create(h,P){if(typeof P=="boolean")return P?I.create(h):b.create(h);const _=U.get(h);return typeof _=="boolean"?P===(_?"true":"false")?f.INSTANCE:y.INSTANCE:new C(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=C;class I{constructor(h){this.key=h,this.type=3}static create(h){const P=U.get(h);return typeof P=="boolean"?P?f.INSTANCE:y.INSTANCE:new I(h)}cmp(h){return h.type!==this.type?this.type-h.type:u(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=I;class g{constructor(h,P){this.key=h,this.value=P,this.type=12}static create(h,P){return new g(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class s{constructor(h,P){this.key=h,this.value=P,this.type=13}static create(h,P){return new s(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class r{constructor(h,P){this.key=h,this.value=P,this.type=14}static create(h,P){return new r(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=r;class t{constructor(h,P){this.key=h,this.value=P,this.type=15}static create(h,P){return new t(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(h,P){this.key=h,this.regexp=P,this.type=7}static create(h,P){return new i(h,P)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const P=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return P<_?-1:P>_?1:0}equals(h){if(h.type===this.type){const P=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return this.key===h.key&&P===_}return!1}evaluate(h){let P=h.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(h){this._actual=h,this.type=8}static create(h){return new n(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new n(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class a{constructor(h){this.expr=h,this.type=6}static create(h){return a._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const j=R(this.expr[P],h.expr[P]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}evaluate(h){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(h))return!1;return!0}static _normalizeArr(h){const P=[];let _=!1;for(const j of h)if(!!j){if(j.type===1){_=!0;continue}if(j.type===0)return f.INSTANCE;if(j.type===6){P.push(...j.expr);continue}P.push(j)}if(P.length===0&&_)return y.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(R);P.length>1;){const j=P[P.length-1];if(j.type!==9)break;P.pop();const B=P.pop(),M=c.create(j.expr.map($=>a.create([$,B])));M&&(P.push(M),P.sort(R))}return P.length===1?P[0]:new a(P)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let P of this.expr)h.push(...P.keys());return h}map(h){return new a(this.expr.map(P=>P.map(h)))}negate(){let h=[];for(let P of this.expr)h.push(P.negate());return c.create(h)}}e.ContextKeyAndExpr=a;class c{constructor(h){this.expr=h,this.type=9}static create(h){const P=c._normalizeArr(h);if(P.length!==0)return P.length===1?P[0]:new c(P)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const j=R(this.expr[P],h.expr[P]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}evaluate(h){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(h))return!0;return!1}static _normalizeArr(h){let P=[],_=!1;if(h){for(let j=0,B=h.length;j<B;j++){const M=h[j];if(!!M){if(M.type===0){_=!0;continue}if(M.type===1)return[y.INSTANCE];if(M.type===9){P=P.concat(M.expr);continue}P.push(M)}}if(P.length===0&&_)return[f.INSTANCE];P.sort(R)}return P}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let P of this.expr)h.push(...P.keys());return h}map(h){return new c(this.expr.map(P=>P.map(h)))}negate(){let h=[];for(let _ of this.expr)h.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;h.length>1;){const _=h.shift(),j=h.shift(),B=[];for(const M of P(_))for(const $ of P(j))B.push(v.and(M,$));h.unshift(v.or(...B))}return h[0]}}e.ContextKeyOrExpr=c;class l extends b{constructor(h,P,_){super(h);this._defaultValue=P,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:h})):_!==!0&&l._info.push({key:h,description:_,type:P!=null?typeof P:void 0})}static all(){return l._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(h){return v.equals(this.key,h)}notEqualsTo(h){return v.notEquals(this.key,h)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(p,h){return p<h?-1:p>h?1:0}function d(p,h,P,_){return p<P?-1:p>P?1:h<_?-1:h>_?1:0}}),define(Z[69],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function k(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[70],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(Z[9],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(S,k){e(S,k,K)}};define(Z[140],ee([0,1,9,8,23,11,2,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let m=class extends U.Disposable{constructor(R){super();this.environmentService=R,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let R=setTimeout(()=>{R=void 0;const f=(0,k.basename)(this.environmentService.logsPath),y=(0,k.dirname)(this.environmentService.logsPath);(0,A.readdir)(y).then(b=>{const E=b.filter(C=>/^\d{8}T\d{6}$/.test(C)).sort().filter((C,I)=>C!==f),w=E.slice(0,Math.max(0,E.length-9));return O.Promises.settled(w.map(C=>(0,A.rimraf)((0,k.join)(y,C))))}).then(null,L.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};m=he([Y(0,S.IEnvironmentService)],m),e.LogsDataCleaner=m}),define(Z[141],ee([0,1,27,9,8,23,11,2]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let m=class ct extends O.Disposable{constructor(R,f){super();this.backupWorkspacesPath=R,this.environmentService=f,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let R=setTimeout(()=>{R=void 0,(async()=>{try{const f=await S.promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(f).emptyWorkspaceInfos.map(w=>w.backupFolder),o=await(0,L.readdir)(this.environmentService.workspaceStorageHome.fsPath),E=[];o.forEach(w=>{w.length!==ct.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(w)===-1&&E.push((0,L.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,w)))}),await Promise.all(E)}catch(f){(0,U.onUnexpectedError)(f)}})()},30*1e3);this._register((0,O.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};m.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,m=he([Y(1,k.INativeEnvironmentService)],m),e.StorageDataCleaner=m}),define(Z[29],ee([0,1,107,5,16]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var U;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var O;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(O=e.SortOrder||(e.SortOrder={}));var m;(function(f){f.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(y,b){super(y);this.code=b}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[142],ee([0,1,2,29]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends S.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=he([Y(0,k.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[71],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function A(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var L;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[72],ee([0,1,21,5]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));class U{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,f){if(typeof R=="undefined"||R===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof R=="string"||typeof f=="string"){let y=typeof R=="string"?R:R.value,b=typeof f=="string"?f:f.value;return S.equalsIgnoreCase(y,b)}return R._lower===f._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=U;function O(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function m(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=m,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,72]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(b,o){return b.uuid&&o.uuid?b.uuid===o.uuid:b.id===o.id?!0:(0,S.compareIgnoreCase)(b.id,o.id)===0}e.areSameExtensions=A;class L{constructor(o,E){this.version=E,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof L?A(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=L;function U(b,o){return`${b}.${o}`}e.getExtensionId=U;function O(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function m(b,o){return O(U(b,o))}e.getGalleryExtensionId=m;function v(b,o){const E=[],w=C=>{for(const I of E)if(I.some(g=>A(o(g),o(C))))return I;return null};for(const C of b){const I=w(C);I?I.push(C):E.push([C])}return E}e.groupByExtension=v;function R(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function f(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function y(b){const o=new Set;for(const E of b)E.malicious&&o.add(E.id.id);return o}e.getMaliciousExtensionsSet=y}),define(Z[143],ee([0,1,2,8,72,23]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends S.Disposable{constructor(m,v){super();this.environmentService=m,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(v.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(m){m.error||this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){L.rimraf(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,114,8,4,5,21,15,37]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,L.createDecorator)("fileService");function v(M){return M.create===!0}e.isFileOpenForWriteOptions=v;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function b(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=b;function o(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function E(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=E;var w;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=C;function I(M,$){const V=new C(M.toString(),$);return s(V,$),V}e.createFileSystemProviderError=I;function g(M){return M||I((0,S.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=g;function s(M,$){return M.name=$?`${$} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=s;function r(M){if(!M)return w.Unknown;if(M instanceof C)return M.code;const $=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!$)return w.Unknown;switch($[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=r;function t(M){if(M instanceof u)return M.fileOperationResult;switch(r(M)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor($,V,q){this.resource=$,this.operation=V,this.target=q}isOperation($){return this.operation===$}}e.FileOperationEvent=n;var a;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,V){this.ignorePathCasing=V,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const q of $)switch(q.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(q.resource,q);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...q){var H,z,D,T,F,N;if(!$)return!1;const x=q.length>0;return!!((!x||q.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get($))||V.includeChildren&&((z=this.added)===null||z===void 0?void 0:z.findSuperstr($)))||(!x||q.includes(0))&&(((D=this.updated)===null||D===void 0?void 0:D.get($))||V.includeChildren&&((T=this.updated)===null||T===void 0?void 0:T.findSuperstr($)))||(!x||q.includes(2))&&(((F=this.deleted)===null||F===void 0?void 0:F.findSubstr($))||V.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const V=[],q=$===1?this.added:$===0?this.updated:this.deleted;if(q)for(const[,H]of q)V.push(H);return V}filter($){return new c(this.changes.filter(V=>$(V)),this.ignorePathCasing)}}e.FileChangesEvent=c;function l(M,$,V){return!M||!$||M===$||$.length>M.length?!1:($.charAt($.length-1)!==k.sep&&($+=k.sep),V?(0,U.startsWithIgnoreCase)(M,$):M.indexOf($)===0)}e.isParent=l;class u extends Error{constructor($,V,q){super($);this.fileOperationResult=V,this.options=q}static isFileOperationError($){return $ instanceof Error&&!(0,O.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=u;var d;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=h;async function P(M,$){if(!$.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise(V=>{const q=$.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(q.dispose(),V())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize($){return(0,O.isNumber)($)||($=0),$<_.KB?(0,S.localize)(1,null,$.toFixed(0)):$<_.MB?(0,S.localize)(2,null,($/_.KB).toFixed(2)):$<_.GB?(0,S.localize)(3,null,($/_.MB).toFixed(2)):$<_.TB?(0,S.localize)(4,null,($/_.GB).toFixed(2)):(0,S.localize)(5,null,($/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var j;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*_.MB:16*_.GB,maxHeapSize:M===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=B}),define(Z[144],ee([0,1,145,47,10]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(O){this.fileService=O}checksum(O){return new Promise(async(m,v)=>{const R=(0,S.createHash)("md5"),f=(await this.fileService.readFileStream(O)).value;(0,k.listenStream)(f,{onData:y=>R.update(y.buffer),onError:y=>v(y),onEnd:()=>m(R.digest("base64").replace(/=+$/,""))})})}};L=he([Y(0,A.IFileService)],L),e.ChecksumService=L}),define(Z[73],ee([0,1,4,10,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function L(m){return m.map(v=>({type:v.type,resource:S.URI.file(v.path)}))}e.toFileChanges=L;function U(m){const v=new O;for(const R of m)v.processEvent(R);return v.normalize()}e.normalizeFileChanges=U;class O{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const R=this.mapPathToChange.get(v.path);if(R){const f=R.type,y=v.type;f===1&&y===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(R),1)):f===2&&y===1?R.type=0:f===1&&y===0||(R.type=y)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],R=[];return this.normalized.filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,y)=>f.path.length-y.path.length).filter(f=>R.some(y=>(0,k.isParent)(f.path,y,!A.isLinux))?!1:(R.push(f.path),!0)).concat(v)}}}),define(Z[146],ee([0,1,73,2,23,93,96,6,8]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends k.Disposable{constructor(f,y,b,o){super();this.path=f,this.onDidFilesChange=y,this.onLogMessage=b,this.verboseLogging=o,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:y}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(y)try{b=await(0,L.realpath)(b)}catch(o){if(this.onError(o),y.dangling)return}f.isDirectory()?this._register((0,U.watchFolder)(b,(o,E)=>{this.onFileChange({type:o==="changed"?0:o==="added"?1:2,path:(0,m.join)(this.path,(0,m.basename)(E))})},o=>this.onError(o))):this._register((0,U.watchFile)(b,o=>{this.onFileChange({type:o==="changed"?0:2,path:this.path})},o=>this.onError(o)))}catch(f){f.code!=="ENOENT"&&this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,S.normalizeFileChanges)(y);this.verboseLogging&&b.forEach(o=>{this.onVerbose(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(Z[74],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...A){this._entries=new Map;for(let[L,U]of A)this.set(L,U)}set(A,L){const U=this._entries.get(A);return this._entries.set(A,L),U}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=S}),define(Z[147],ee([0,1,11,137,50,5,74,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class v extends Error{constructor(o){var E;super("cyclic dependency between services");this.message=(E=o.findCycleSlow())!==null&&E!==void 0?E:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class R{constructor(o=new U.ServiceCollection,E=!1,w){this._activeInstantiations=new Set,this._services=o,this._strict=E,this._parent=w,this._services.set(L.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...E){let w=y.traceInvocation(o),C=!1;try{return o({get:(g,s)=>{if(C)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(g,w);if(!r&&s!==L.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return r}},...E)}finally{C=!0,w.stop()}}createInstance(o,...E){let w,C;return o instanceof A.SyncDescriptor?(w=y.traceCreation(o.ctor),C=this._createInstance(o.ctor,o.staticArguments.concat(E),w)):(w=y.traceCreation(o),C=this._createInstance(o,E,w)),w.stop(),C}_createInstance(o,E=[],w){let C=L._util.getServiceDependencies(o).sort((s,r)=>s.index-r.index),I=[];for(const s of C){let r=this._getOrCreateServiceInstance(s.id,w);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`);I.push(r)}let g=C.length>0?C[0].index:E.length;if(E.length!==g){console.warn(`[createInstance] First service dependency of ${o.name} at position ${g+1} conflicts with ${E.length} static arguments`);let s=g-E.length;s>0?E=E.concat(new Array(s)):E=E.slice(0,g)}return new o(...[...E,...I])}_setServiceInstance(o,E){if(this._services.get(o)instanceof A.SyncDescriptor)this._services.set(o,E);else if(this._parent)this._parent._setServiceInstance(o,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let E=this._services.get(o);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):E}_getOrCreateServiceInstance(o,E){let w=this._getServiceInstanceOrDescriptor(o);return w instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,w,E.branch(o,!0)):(E.branch(o,!1),w)}_safeCreateAndCacheServiceInstance(o,E,w){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,E,w)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,E,w){const C=new k.Graph(s=>s.id.toString());let I=0;const g=[{id:o,desc:E,_trace:w}];for(;g.length;){const s=g.pop();if(C.lookupOrInsertNode(s),I++>1e3)throw new v(C);for(let r of L._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(r.id);if(!t&&!r.optional&&console.warn(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:r.id,desc:t,_trace:s._trace.branch(r.id,!0)};C.insertEdge(s,i),g.push(i)}}}for(;;){const s=C.roots();if(s.length===0){if(!C.isEmpty())throw new v(C);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}C.removeNode(r)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,E,w=[],C,I){if(this._services.get(o)instanceof A.SyncDescriptor)return this._createServiceInstance(E,w,C,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,E,w,C,I);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(o,E=[],w,C){if(w){const I=new O.IdleValue(()=>this._createInstance(o,E,C));return new Proxy(Object.create(null),{get(g,s){if(s in g)return g[s];let r=I.value,t=r[s];return typeof t!="function"||(t=t.bind(r),g[s]=t),t},set(g,s,r){return I.value[s]=r,!0}})}else return this._createInstance(o,E,C)}}e.InstantiationService=R;var f;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(f||(f={}));class y{constructor(o,E){this.type=o,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return m?new y(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(o){return m?new y(0,o.name):y._None}branch(o,E){let w=new y(2,o.toString());return this._dep.push([o,E,w]),w}stop(){let o=Date.now()-this._start;y._totals+=o;let E=!1;function w(I,g){let s=[],r=new Array(I+1).join("	");for(const[t,i,n]of g._dep)if(i&&n){E=!0,s.push(`${r}CREATES -> ${t}`);let a=w(I+1,n);a&&s.push(a)}else s.push(`${r}uses -> ${t}`);return s.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(o>2||E)&&console.log(C.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(A,L){this.server=A,this.router=L}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,L){this.server.registerChannel(A,L)}}e.MessagePortMainProcessService=S}),define(Z[149],ee([0,1,34,50,136,5]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(b,o,E){const w=E.getChannel(b);return O(o)?new o.channelClientCtor(w):S.ProxyChannel.toService(w,o==null?void 0:o.proxyOptions)}}function O(y){const b=y;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let m=class extends U{constructor(b,o,E){super(b,o,E)}};m=he([Y(2,e.IMainProcessService)],m);function v(y,b,o){(0,A.registerSingleton)(y,new k.SyncDescriptor(m,[b,o],o==null?void 0:o.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let R=class extends U{constructor(b,o,E){super(b,o,E)}};R=he([Y(2,e.ISharedProcessService)],R);function f(y,b,o){(0,A.registerSingleton)(y,new k.SyncDescriptor(R,[b,o],o==null?void 0:o.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=f}),define(Z[55],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function k(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const L of A.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[150],ee([0,1,2,55]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends S.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=he([Y(0,k.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[17],ee([0,1,5,2,7,3,43]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function O(){return new Date().toISOString()}var m;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class v extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class R extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let a=t[n];if(typeof a=="object")try{a=JSON.stringify(a)}catch(c){}i+=(n>0?" ":"")+a}return i}}e.AbstractMessageLogger=R;class f extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}debug(t,...i){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}info(t,...i){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}warn(t,...i){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${O()}][0m`,t,...i):console.warn(`[main ${O()}]`,t,...i))}error(t,...i){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}critical(t,...i){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class y extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=y;class b extends v{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class o extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class E extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=E;class w extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?m.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class C{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=C;function I(r){if(r.verbose)return m.Trace;if(typeof r.logLevel=="string"){const t=g(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function g(r){switch(r){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=g;function s(r){switch(r){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=s}),define(Z[151],ee([0,1,27,2,10,29,9,4,12,33,17,31,56,7,6,11]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let C=class extends k.Disposable{constructor(g,s,r,t){super();this.fileService=s,this.extensionGalleryService=r,this.logService=t,this.extensionsDownloadDir=O.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,s){await this.cleanUpPromise;const r=this.getName(g),t=(0,m.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(t)){const i=(0,m.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,s);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(a){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,E.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(g){}async rename(g,s,r){try{await S.promises.rename(g.fsPath,s.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${g} to ${s} with 'EPERM' error. Trying again...`),this.rename(g,s,r);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const s=[],r=[];for(const n of g.children){const a=this.parse(n.name);a&&r.push([a,n])}const t=(0,v.groupByExtension)(r,([n])=>n),i=[];for(const n of t)n.sort((a,c)=>y.rcompare(a[0].version,c[0].version)),s.push(...n.slice(1).map(a=>a[1].resource)),i.push(n[0][1]);i.sort((n,a)=>n.mtime-a.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await o.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?new v.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase():(0,f.generateUuid)()}parse(g){const s=w.exec(g);return s&&s[1]&&s[2]?new v.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};C=he([Y(0,U.INativeEnvironmentService),Y(1,A.IFileService),Y(2,L.IExtensionGalleryService),Y(3,R.ILogService)],C),e.ExtensionsDownloader=C}),define(Z[152],ee([0,1,2,17,48,43,8,6,3,16,23,9]),function(K,e,S,k,A,L,U,O,m,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends S.Disposable{constructor(o,E){super();this.environmentService=o,this.logService=E,this.processesLimiter=new O.Limiter(5)}async postUninstall(o){const E=this.parseScript(o,"uninstall");return E&&(this.logService.info(o.identifier.id,o.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,o).then(()=>this.logService.info(o.identifier.id,o.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(o.identifier.id,o.manifest.version,`Failed to run post uninstall script: ${w}`)))),(0,R.rimraf)(this.getExtensionStoragePath(o)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(o,E){const w=`vscode:${E}`;if(o.location.scheme===v.Schemas.file&&o.manifest&&o.manifest.scripts&&typeof o.manifest.scripts[w]=="string"){const C=o.manifest.scripts[w].split(" ");return C.length<2||C[0]!=="node"||!C[1]?(this.logService.warn(o.identifier.id,o.manifest.version,`${w} should be a node script`),null):{script:(0,U.join)(o.location.fsPath,C[1]),args:C.slice(2)||[]}}return null}runLifecycleHook(o,E,w,C,I){return new Promise((g,s)=>{const r=this.start(o,E,w,I);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?s(n):g(void 0)};r.on("error",n=>{i((0,L.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,a)=>{i(n?`post-${E} process exited with code ${n}`:void 0)}),C&&(t=setTimeout(()=>{t=null,r.kill(),s("timed out")},5e3))})}start(o,E,w,C){const I={silent:!0,execArgv:void 0},g=(0,A.fork)(o,[`--type=extension-post-${E}`,...w],I);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const s=m.Event.fromNodeEventEmitter(g.stdout,"data"),r=m.Event.fromNodeEventEmitter(g.stderr,"data");s(n=>this.logService.info(C.identifier.id,C.manifest.version,`post-${E}`,n)),r(n=>this.logService.error(C.identifier.id,C.manifest.version,`post-${E}`,n));const t=m.Event.any(m.Event.map(s,n=>({data:`%c${n}`,format:[""]})),m.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return m.Event.debounce(t,(n,a)=>n?{data:n.data+a.data,format:[...n.format,...a.format]}:{data:a.data,format:a.format},100)(n=>{console.group(C.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(o){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,o.identifier.id.toLowerCase())}};y=he([Y(0,f.IEnvironmentService),Y(1,k.ILogService)],y),e.ExtensionsLifecycle=y}),define(Z[153],ee([0,1,2,9,3,10,4,33,12,17]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends S.Disposable{constructor(y,b,o,E){super();this.extensionsManagementService=y,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(I=>this.onInstallExtension(I))),this._register(y.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(y.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const w=U.URI.file(o.extensionsPath),C=new m.ExtUri(I=>!b.hasCapability(I,1024));this._register(b.watch(w)),this._register(A.Event.filter(b.onDidFilesChange,I=>I.changes.some(g=>this.doesChangeAffects(g,w,C)))(()=>this.onDidChange()))}doesChangeAffects(y,b,o){return o.isEqual(o.dirname(y.resource),b)?o.isEqual(y.resource,o.joinPath(b,".obsolete"))?!0:!(y.type!==1&&y.type!==2||o.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(b=>!(0,O.areSameExtensions)(b,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,O.areSameExtensions)(b,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),b=y.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,O.areSameExtensions)(w,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),o=this.installedExtensions.filter(E=>this.installingExtensions.some(w=>(0,O.areSameExtensions)(w,E))?!1:y.every(w=>!(0,O.areSameExtensions)(w.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=y.map(E=>E.identifier),(b.length||o.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:o})}}};R=he([Y(1,L.IFileService),Y(2,k.INativeEnvironmentService),Y(3,v.ILogService)],R),e.ExtensionsWatcher=R}),define(Z[154],ee([0,1,23,27,145,29,2,9,6,33,17,55,18,3,16,8]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let w=class extends U.Disposable{constructor(g,s,r){super();this.extensionManagementService=g,this.logService=r,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new C(s,r)),this._register(g.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(g.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(g=>{const s=["en",...Object.keys(g)];return(0,y.distinct)(s)})}onDidInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",g.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(g){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(t=>(0,v.areSameExtensions)(t.extensionIdentifier,g)))&&(this.logService.debug("Removing language packs from the extension",g.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[g,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,y.equals)(Object.keys(g),Object.keys(r))}};w=he([Y(0,L.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,R.ILogService)],w),e.LocalizationsService=w;let C=class extends U.Disposable{constructor(g,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new m.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,r);Object.keys(g).forEach(r=>this.updateHash(g[r]))}createLanguagePacksFromExtension(g,s){const r=s.identifier,t=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of t)if(s.location.scheme===o.Schemas.file&&(0,f.isValidLocalization)(i)){let n=g[i.languageId];n||(n={hash:"",extensions:[],translations:{}},g[i.languageId]=n);let a=n.extensions.filter(c=>(0,v.areSameExtensions)(c.extensionIdentifier,r))[0];a?a.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const c of i.translations)n.translations[c.id]=(0,E.join)(s.location.fsPath,c.path)}}updateHash(g){if(g){const s=(0,A.createHash)("md5");for(const r of g.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);g.hash=s.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return k.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(t){return{}}}).then(r=>(s=g(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,S.writeFile)(this.languagePacksFilePath,t)}).then(()=>s,r=>this.logService.error(r))})}};C=he([Y(0,O.INativeEnvironmentService),Y(1,R.ILogService)],C)}),define(Z[75],ee([0,1,17,3,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(y){this.service=y,this.onDidChangeLogLevel=k.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(y,b,o){switch(b){case"setLevel":return this.service.setLevel(o)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=L;class U{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){U.setLevel(this.channel,y)}static setLevel(y,b){return y.call("setLevel",b)}}e.LogLevelChannelClient=U;class O{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,b){throw new Error(`Event not found: ${b}`)}async call(y,b,o){switch(b){case"createLogger":this.createLogger(A.URI.revive(o[0]),o[1]);return;case"log":return this.log(A.URI.revive(o[0]),o[1]);case"consoleLog":return this.consoleLog(o[0],o[1])}throw new Error(`Call not found: ${b}`)}createLogger(y,b){this.loggers.set(y.toString(),this.loggerService.createLogger(y,b))}consoleLog(y,b){let o=console.log;switch(y){case S.LogLevel.Error:o=console.error;break;case S.LogLevel.Warning:o=console.warn;break;case S.LogLevel.Info:o=console.info;break}o.call(console,...b)}log(y,b){const o=this.loggers.get(y.toString());if(!o)throw new Error("Create the logger before logging");for(const[E,w]of b)switch(E){case S.LogLevel.Trace:o.trace(w);break;case S.LogLevel.Debug:o.debug(w);break;case S.LogLevel.Info:o.info(w);break;case S.LogLevel.Warning:o.warn(w);break;case S.LogLevel.Error:o.error(w);break;case S.LogLevel.Critical:o.critical(w);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=O;class m extends S.AbstractLoggerService{constructor(y,b,o){super(y,b);this.channel=o}createConsoleMainLogger(){return new S.AdapterLogger({log:(y,b)=>{this.channel.call("consoleLog",[y,b])}})}doCreateLogger(y,b,o){return new v(this.channel,y,b,o)}}e.LoggerChannelClient=m;class v extends S.AbstractMessageLogger{constructor(y,b,o,E){super(E==null?void 0:E.always);this.channel=y,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(o),this.channel.call("createLogger",[b,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,b){const o=[[y,b]];this.isLoggerCreated?this.doLog(o):this.buffer.push(...o)}doLog(y){this.channel.call("log",[this.file,y])}}class R extends S.LogService{constructor(y,b){super(b);this.parent=y,this._register(y.onDidChangeLogLevel(o=>b.setLevel(o)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=R}),define(Z[57],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,7,36,12]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof k.globals.vscode!="undefined"){const O=k.globals.vscode.context.configuration();if(O)U=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const O=(0,L.dirname)(S.FileAccess.asFileUri("",K));U=K.__$__nodeRequire((0,L.joinPath)(O,"product.json").fsPath);const m=K.__$__nodeRequire((0,L.joinPath)(O,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:m.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.56.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[76],ee([0,1,115,22,10,11,51]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(f,y,b,o,E,w){let C;try{await m(f,y,b,o,E,w)}catch(I){C=I}finally{C&&E.errorTransformer&&(C=E.errorTransformer(C)),typeof C!="undefined"&&b.error(C),b.end()}}e.readFileIntoStream=O;async function m(f,y,b,o,E,w){v(w);const C=await f.open(y,{create:!1});try{v(w);let I=0,g=0,s=E&&typeof E.length=="number"?E.length:void 0,r=k.VSBuffer.alloc(Math.min(E.bufferSize,typeof s=="number"?s:E.bufferSize)),t=E&&typeof E.position=="number"?E.position:0,i=0;do g=await f.read(C,t,r.buffer,i,r.byteLength-i),t+=g,i+=g,I+=g,typeof s=="number"&&(s-=g),i===r.byteLength&&(await b.write(o(r)),r=k.VSBuffer.alloc(Math.min(E.bufferSize,typeof s=="number"?s:E.bufferSize)),i=0);while(g>0&&(typeof s!="number"||s>0)&&v(w)&&R(I,E));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),b.write(o(r.slice(0,n)))}}catch(I){throw(0,A.ensureFileSystemProviderError)(I)}finally{await f.close(C)}}function v(f){if(f.isCancellationRequested)throw(0,L.canceled)();return!0}function R(f,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&f>y.limits.memory)throw(0,A.createFileSystemProviderError)((0,S.localize)(0,null,U.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&f>y.limits.size)throw(0,A.createFileSystemProviderError)((0,S.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[155],ee([0,1,113,156,2,10,3,12,37,18,17,22,47,6,30,16,76,53]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class extends A.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const t=new A.DisposableStore;return t.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new L.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),t.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&t.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,A.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){r.push(t)}}),!this.provider.has(s)&&await b.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return C.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,O.isAbsolutePath)(s))throw new L.FileOperationError((0,S.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,s.toString()),t}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasReadWriteCapability)(r)||(0,L.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(t){throw(0,L.toFileSystemProviderErrorCode)(t)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError((0,S.localize)(2,null,this.resourceForError(s)),1):(0,L.ensureFileSystemProviderError)(t)}}async doResolveFile(s,r){const t=await this.withProvider(s),i=this.isPathCaseSensitive(t),n=r==null?void 0:r.resolveTo,a=r==null?void 0:r.resolveSingleChildDescendants,c=r==null?void 0:r.resolveMetadata,l=await t.stat(s);let u;return this.toFileStat(t,s,l,void 0,!!c,(d,p)=>(u||(u=m.TernarySearchTree.forUris(()=>!i),u.set(s,!0),(0,v.isNonEmptyArray)(n)&&n.forEach(h=>u.set(h,!0))),Boolean(u.findSuperstr(d.resource)||u.get(d.resource))?!0:d.isDirectory&&a?p===1:!1))}async toFileStat(s,r,t,i,n,a){const{providerExtUri:c}=this.getExtUri(s),l={resource:r,name:c.basename(r),isFile:(t.type&L.FileType.File)!=0,isDirectory:(t.type&L.FileType.Directory)!=0,isSymbolicLink:(t.type&L.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,L.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&a(l,i)){try{const u=await s.readdir(r),d=await b.Promises.settled(u.map(async([p,h])=>{try{const P=c.joinPath(r,p),_=n?await s.stat(P):{type:h};return await this.toFileStat(s,P,_,u.length,n,a)}catch(P){return this.logService.trace(P),null}}));l.children=(0,v.coalesce)(d)}catch(u){this.logService.trace(u),l.children=[]}return l}return l}async resolveAll(s){return b.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(t){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(t){return t}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new L.FileOperationError((0,S.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=f.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new L.FileOperationEvent(s,0,i)),i}async writeFile(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,t)||await this.mkdirp(i,n.dirname(s));let c;if((0,L.hasReadWriteCapability)(i)&&!(r instanceof f.VSBuffer))if((0,y.isReadableStream)(r)){const l=await(0,y.peekStream)(r,3);l.ended?c=f.VSBuffer.concat(l.buffer):c=l}else c=(0,y.peekReadable)(r,l=>f.VSBuffer.concat(l),3);else c=r;!(0,L.hasOpenReadWriteCloseCapability)(i)||(0,L.hasReadWriteCapability)(i)&&c instanceof f.VSBuffer?await this.doWriteUnbuffered(i,s,t,c):await this.doWriteBuffered(i,s,t,c instanceof f.VSBuffer?(0,f.bufferToReadable)(c):c)}catch(a){throw new L.FileOperationError((0,S.localize)(4,null,this.resourceForError(s),(0,L.ensureFileSystemProviderError)(a).toString()),(0,L.toFileOperationResult)(a),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,t){if(!!(t==null?void 0:t.unlock)&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(a){return}if((n.type&L.FileType.Directory)!=0)throw new L.FileOperationError((0,S.localize)(6,null,this.resourceForError(r)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,L.etag)({mtime:t.mtime,size:n.size}))throw new L.FileOperationError((0,S.localize)(7,null),3,t);return n}async readFile(s,r){const t=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(t,s,r):this.doReadFile(t,s,r)}async doReadFileAtomic(s,r,t){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,r,t);i(a)}catch(a){n(a)}})})}async doReadFile(s,r,t){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,f.streamToBuffer)(i.value)})}async readFileStream(s,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,r)}async doReadFileStream(s,r,t){const i=new o.CancellationTokenSource,n=this.validateReadFile(r,t).then(c=>c,c=>{throw i.cancel(),c});let a;try{t&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&await n,!((0,L.hasOpenReadWriteCloseCapability)(s)||(0,L.hasFileReadStreamCapability)(s))||(0,L.hasReadWriteCapability)(s)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(s,r,t):(0,L.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,r,i.token,t):a=this.readFileBuffered(s,r,i.token,t);const c=await n;return Object.assign(Object.assign({},c),{value:a})}catch(c){throw a&&await(0,y.consumeStream)(a),new L.FileOperationError((0,S.localize)(8,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(c).toString()),(0,L.toFileOperationResult)(c),t)}}readFileStreamed(s,r,t,i=Object.create(null)){const n=s.readFileStream(r,i,t);return(0,y.transform)(n,{data:a=>a instanceof f.VSBuffer?a:f.VSBuffer.wrap(a),error:a=>new L.FileOperationError((0,S.localize)(9,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(a).toString()),(0,L.toFileOperationResult)(a),i)},a=>f.VSBuffer.concat(a))}readFileBuffered(s,r,t,i=Object.create(null)){const n=(0,f.newWriteableBufferStream)();return(0,w.readFileIntoStream)(s,r,n,a=>a,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new L.FileOperationError((0,S.localize)(10,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(a).toString()),(0,L.toFileOperationResult)(a),i)}),t),n}readFileUnbuffered(s,r,t){const i=(0,y.newWriteableStream)(n=>f.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(r,n.byteLength,t),i.end(f.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new L.FileOperationError((0,S.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==L.ETAG_DISABLED&&r.etag===t.etag)throw new L.FileOperationError((0,S.localize)(12,null),2,r);return this.validateReadFileLimits(s,t.size,r),t}validateReadFileLimits(s,r,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError((0,S.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,t){return this.doCanMoveCopy(s,r,"move",t)}async canCopy(s,r,t){return this.doCanMoveCopy(s,r,"copy",t)}async doCanMoveCopy(s,r,t,i){if(s.toString()!==r.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,a,r,t,i)}catch(n){return n}return!0}async move(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,s,n,r,"move",!!t),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(s,a==="move"?2:3,c)),c}async copy(s,r,t){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,s,n,r,"copy",!!t),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(s,a==="copy"?3:2,c)),c}async doMoveCopy(s,r,t,i,n,a){if(r.toString()===i.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(s,r,t,i,n,a);if(c&&!l&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(s===t&&(0,L.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:a});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(s,u,t,i):await this.doCopyFile(s,r,t,i)}return n}else return s===t?(await s.rename(r,i,{overwrite:a}),n):(await this.doMoveCopy(s,r,t,i,"copy",a),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,t,i){if((0,L.hasOpenReadWriteCloseCapability)(s)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,r,t,i);if((0,L.hasOpenReadWriteCloseCapability)(s)&&(0,L.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,r,t,i);if((0,L.hasReadWriteCapability)(s)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,r,t,i);if((0,L.hasReadWriteCapability)(s)&&(0,L.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,r,t,i)}async doCopyFolder(s,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await b.Promises.settled(r.children.map(async n=>{const a=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),t,a):this.doCopyFile(s,n.resource,t,a)}))}async doValidateMoveCopy(s,r,t,i,n,a){let c=!1;if(s===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(s);if(d||(c=u.isEqual(r,i)),c&&n==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!c&&u.isEqualOrParent(i,r))throw new Error((0,S.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!c){if(!a)throw new L.FileOperationError((0,S.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===t){const{providerExtUri:u}=this.getExtUri(s);if(u.isEqualOrParent(r,i))throw new Error((0,S.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?O.extUri:O.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(s,0,t)),t}async mkdirp(s,r){const t=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&L.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,L.toFileSystemProviderErrorCode)(n)!==L.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(r)),r=i.dirname(r)}for(let n=t.length-1;n>=0;n--){r=i.joinPath(r,t[n]);try{await s.mkdir(r)}catch(a){if((0,L.toFileSystemProviderErrorCode)(a)!==L.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(t){return t}return!0}async doValidateDelete(s,r){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new L.FileOperationError((0,S.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(s)))}return t}async del(s,r){const t=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await t.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(s,r).then(n=>{t?(0,A.dispose)(n):i=()=>(0,A.dispose)(n)},n=>this.logService.error(n)),(0,A.toDisposable)(()=>i())}async doWatch(s,r){const t=await this.withProvider(s),i=this.toWatchKey(t,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,A.toDisposable)(()=>{n.count--,n.count===0&&((0,A.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,t){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,A.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const a=await s.open(r,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,a,i):await this.doWriteReadableBufferedQueued(s,a,i)}catch(c){throw(0,L.ensureFileSystemProviderError)(c)}finally{await s.close(a)}})}async doWriteStreamBufferedQueued(s,r,t){let i=0,n;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=f.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,r,a,a.byteLength,i,0),i+=a.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(a,c)=>{(0,y.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(s,r,l,l.byteLength,i,0)}catch(u){return c(u)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>c(l),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(s,r,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,t,i,n,a){let c=0;for(;c<i;)c+=await s.write(r,n+c,t.buffer,a+c,i-c)}async doWriteUnbuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,t,i))}async doWriteUnbufferedQueued(s,r,t,i){var n;let a;i instanceof f.VSBuffer?a=i:(0,y.isReadableStream)(i)?a=await(0,f.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?a=await(0,f.bufferedStreamToBuffer)(i):a=(0,f.readableToBuffer)(i),await s.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,t,i))}async doPipeBufferedQueued(s,r,t,i){let n,a;try{n=await s.open(r,{create:!1}),a=await t.open(i,{create:!0,unlock:!1});const c=f.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,d=0;do d=await s.read(n,l,c.buffer,u,c.byteLength-u),await this.doWriteBuffer(t,a,c,d,l,u),l+=d,u+=d,u===c.byteLength&&(u=0);while(d>0)}catch(c){throw(0,L.ensureFileSystemProviderError)(c)}finally{await b.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,t,i))}async doPipeUnbufferedQueued(s,r,t,i){return t.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,t,i))}async doPipeUnbufferedToBufferedQueued(s,r,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const a=await s.readFile(r);await this.doWriteBuffer(t,n,f.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(s,r,t,i){const n=await(0,f.streamToBuffer)(this.readFileBuffered(s,r,o.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new L.FileOperationError((0,S.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===E.Schemas.file?s.fsPath:s.toString(!0)}};I=he([Y(0,R.ILogService)],I),e.FileService=I}),define(Z[157],ee([0,1,27,94,2,10,3,7,23,8,12,42,6,17,116,73,133,135,132,146,47,76,18,22]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends A.Disposable{constructor(c,l){var u;super();this.logService=c,this.options=l,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(c){try{const{stat:l,symbolicLink:u}=await m.SymlinkSupport.stat(this.toFilePath(c));return{type:this.toType(l,u),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(c){try{const l=await(0,m.readdir)(this.toFilePath(c),{withFileTypes:!0}),u=[];return await Promise.all(l.map(async d=>{try{let p;d.isSymbolicLink()?p=(await this.stat((0,R.joinPath)(c,d.name))).type:p=this.toType(d),u.push([d.name,p])}catch(p){this.logService.trace(p)}})),u}catch(l){throw this.toFileSystemProviderError(l)}}toType(c,l){let u;return(l==null?void 0:l.dangling)?u=L.FileType.Unknown:c.isFile()?u=L.FileType.File:c.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,l&&(u|=L.FileType.SymbolicLink),u}async readFile(c){try{const l=this.toFilePath(c);return await S.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(c,l,u){const d=(0,s.newWriteableStream)(p=>i.VSBuffer.concat(p.map(h=>i.VSBuffer.wrap(h))).buffer);return(0,r.readFileIntoStream)(this,c,d,p=>p.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),u),d}async writeFile(c,l,u){let d;try{const p=this.toFilePath(c);if(!u.create||!u.overwrite){if(await(0,m.exists)(p)){if(!u.overwrite)throw(0,L.createFileSystemProviderError)((0,o.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,L.createFileSystemProviderError)((0,o.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(c,{create:!0,unlock:u.unlock}),await this.write(d,0,l,0,l.byteLength)}catch(p){throw await this.toFileSystemProviderWriteError(c,p)}finally{typeof d=="number"&&await this.close(d)}}async open(c,l){try{const u=this.toFilePath(c);if((0,L.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(u);h.mode&128||await S.promises.chmod(u,h.mode|128)}catch(h){this.logService.trace(h)}let d;if((0,L.isFileOpenForWriteOptions)(l)){if(O.isWindows)try{await S.promises.truncate(u,0),d="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}d||(d="w")}else d="r";const p=await(0,k.promisify)(S.open)(u,d);return this.mapHandleToPos.set(p,0),(0,L.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(p,c),p}catch(u){throw(0,L.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(c,u):this.toFileSystemProviderError(u)}}async close(c){try{if(this.mapHandleToPos.delete(c),this.writeHandles.delete(c)&&this.canFlush)try{await(0,k.promisify)(S.fdatasync)(c)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,k.promisify)(S.close)(c)}catch(l){throw this.toFileSystemProviderError(l)}}async read(c,l,u,d,p){const h=this.normalizePos(c,l);let P=null;try{const _=await(0,k.promisify)(S.read)(c,u,d,p,h);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(c,h,P)}}normalizePos(c,l){return l===this.mapHandleToPos.get(c)?null:l}updatePos(c,l,u){const d=this.mapHandleToPos.get(c);typeof d=="number"&&(typeof l=="number"||(typeof u=="number"?this.mapHandleToPos.set(c,d+u):this.mapHandleToPos.delete(c)))}async write(c,l,u,d,p){return(0,y.retry)(()=>this.doWrite(c,l,u,d,p),100,3)}async doWrite(c,l,u,d,p){const h=this.normalizePos(c,l);let P=null;try{const _=await(0,k.promisify)(S.write)(c,u,d,p,h);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(c),_)}finally{this.updatePos(c,h,P)}}async mkdir(c){try{await S.promises.mkdir(this.toFilePath(c))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(c,l){try{const u=this.toFilePath(c);await this.doDelete(u,l)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(c,l){l.recursive?await(0,m.rimraf)(c,m.RimRafMode.MOVE):await S.promises.unlink(c)}async rename(c,l,u){const d=this.toFilePath(c),p=this.toFilePath(l);if(d!==p)try{await this.validateTargetDeleted(c,l,"move",u.overwrite),await(0,m.move)(d,p)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,o.localize)(2,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(p)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(c,l,u){const d=this.toFilePath(c),p=this.toFilePath(l);if(d!==p)try{await this.validateTargetDeleted(c,l,"copy",u.overwrite),await(0,m.copy)(d,p,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,o.localize)(3,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(p)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(c,l,u,d){const p=this.toFilePath(c),h=this.toFilePath(l);let P=!1;if(!!(this.capabilities&1024)||(P=(0,f.isEqual)(p,h,!0)),P&&u==="copy")throw(0,L.createFileSystemProviderError)((0,o.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,m.exists)(h)){if(!d)throw(0,L.createFileSystemProviderError)((0,o.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(c,l){return l.recursive?this.watchRecursive(c,l.excludes):this.watchNonRecursive(c)}watchRecursive(c,l){const u={path:this.toFilePath(c),excludes:l},d=(0,t.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var c,l,u;if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let d,p;((l=(c=this.options)===null||c===void 0?void 0:c.watcher)===null||l===void 0?void 0:l.usePolling)?(d=w.FileWatcher,p=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?O.isWindows?d=C.FileWatcher:d=w.FileWatcher:d=I.FileWatcher,this.recursiveWatcher=new d(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,E.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===b.LogLevel.Trace,p),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(c){const l=new g.FileWatcher(this.toFilePath(c),d=>this._onDidChangeFile.fire((0,E.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===b.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,A.combinedDisposable)(l,u)}toFilePath(c){return(0,v.normalize)(c.fsPath)}toFileSystemProviderError(c){if(c instanceof L.FileSystemProviderError)return c;let l;switch(c.code){case"ENOENT":l=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=L.FileSystemProviderErrorCode.NoPermissions;break;default:l=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(c,l)}async toFileSystemProviderWriteError(c,l){let u=this.toFileSystemProviderError(l);if(c&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await m.SymlinkSupport.stat(this.toFilePath(c));d.mode&128||(u=(0,L.createFileSystemProviderError)(l,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return u}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=n}),define(Z[28],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(Z[158],ee([0,1,27,8,23,28,2,11,17,9]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends U.Disposable{constructor(y,b,o){super();this._environmentService=y,this._logService=b,this._productService=o,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let y=setTimeout(async()=>{y=void 0,this._logService.info("Starting to clean up unused language packs.");try{const b=Object.create(null),o=JSON.parse(await S.promises.readFile(k.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(o)){const g=o[I];b[`${g.hash}.${I}`]=!0}const E=k.join(this._environmentService.userDataPath,"clp");if(!await A.exists(E))return;for(let I of await A.readdir(E)){if(b[I]){this._logService.info(`Skipping directory ${I}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",I),await A.rimraf(k.join(E,I))}const C=Date.now();for(let I of Object.keys(b)){const g=k.join(E,I);for(let s of await A.readdir(g))if(s!=="tcf.json"){const r=k.join(g,s),t=await S.promises.stat(r);t.isDirectory()&&C-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",k.join(I,s)),await A.rimraf(r))}}}catch(b){(0,O.onUnexpectedError)(b)}},40*1e3);this._register((0,U.toDisposable)(()=>{y!==void 0&&clearTimeout(y)}))}};R=he([Y(0,v.INativeEnvironmentService),Y(1,m.ILogService),Y(2,L.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(Z[159],ee([0,1,27,8,11,2,23,28]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let m=class{constructor(R,f){this.nodeCachedDataDir=R,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new L.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const R=(0,k.dirname)(this.nodeCachedDataDir),f=(0,k.basename)(this.nodeCachedDataDir);let y=setTimeout(()=>{y=void 0,(0,U.readdir)(R).then(b=>{const o=Date.now(),E=[];return b.forEach(w=>{if(w!==f){const C=(0,k.join)(R,w);E.push(S.promises.stat(C).then(I=>{if(I.isDirectory()&&o-I.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(C)}))}}),Promise.all(E)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,L.toDisposable)(()=>{y&&(clearTimeout(y),y=void 0)}))}}};m=he([Y(1,O.IProductService)],m),e.NodeCachedDataCleaner=m}),define(Z[35],ee([0,1,15,84]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(U,O){k.ok(S.isString(U)),k.ok(S.isObject(O)),k.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,O)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new A}),define(Z[77],ee([0,1,35,3]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,v){this.schemasById[A(m)]=v,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new L;S.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[39],ee([0,1,106,3,35,15,77]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=A.Registry.as(U.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,I=!0){this.registerConfigurations([C],I)}registerConfigurations(C,I=!0){const g=[];C.forEach(s=>{g.push(...this.validateAndRegisterProperties(s,I,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(C){const I=[],g=s=>{if(s.properties)for(const r in s.properties)I.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>g(r))};for(const s of C){g(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(C){const I=[],g=[];for(const s of C)for(const r in s)if(I.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const t={type:"object",default:this.defaultValues[r],description:S.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};g.push(f(r)),this.configurationProperties[r]=t,this.defaultLanguageConfigurationOverridesNode.properties[r]=t}else{this.defaultValues[r]=s[r];const t=this.configurationProperties[r];t&&(this.updatePropertyDefaultValue(r,t),this.updateSchema(r,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(C){const I=[];for(const g of C)for(const s in g)if(I.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const I of C)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,I=!0,g,s=3){var r;s=L.isUndefinedOrNull(C.scope)?s:C.scope;let t=[],i=C.properties;if(i)for(let a in i){if(I&&o(a)){delete i[a];continue}const c=i[a];if(this.updatePropertyDefaultValue(a,c),e.OVERRIDE_PROPERTY_PATTERN.test(a)?c.scope=void 0:(c.scope=L.isUndefinedOrNull(c.scope)?s:c.scope,c.requireTrust=L.isUndefinedOrNull(c.requireTrust)?!!((r=g==null?void 0:g.requireTrustForConfigurations)===null||r===void 0?void 0:r.includes(a)):c.requireTrust),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),t.push(a)}let n=C.allOf;if(n)for(let a of n)t.push(...this.validateAndRegisterProperties(a,I,g,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const I=g=>{let s=g.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let r=g.allOf;r&&r.forEach(I)};I(C)}updateSchema(C,I){switch(e.allSettings.properties[C]=I,I.scope){case 1:e.applicationSettings.properties[C]=I;break;case 2:e.machineSettings.properties[C]=I;break;case 6:e.machineOverridableSettings.properties[C]=I;break;case 3:e.windowSettings.properties[C]=I;break;case 4:e.resourceSettings.properties[C]=I;break;case 5:e.resourceSettings.properties[C]=I,this.resourceLanguageSettingsSchema.properties[C]=I;break}}removeFromSchema(C,I){switch(delete e.allSettings.properties[C],I.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const I=`[${C}]`,g={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,g),e.allSettings.properties[I]=g,e.applicationSettings.properties[I]=g,e.machineSettings.properties[I]=g,e.machineOverridableSettings.properties[I]=g,e.windowSettings.properties[I]=g,e.resourceSettings.properties[I]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,I){let g=this.defaultValues[C];L.isUndefined(g)&&(g=I.default),L.isUndefined(g)&&(g=y(I.type)),I.default=g}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function f(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=f;function y(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const b=new v;A.Registry.add(e.Extensions.Configuration,b);function o(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?S.localize(5,null,w):b.getConfigurationProperties()[w]!==void 0?S.localize(6,null,w):null:S.localize(4,null)}e.validateProperty=o;function E(){const w=[],C=b.getConfigurationProperties();for(const I of Object.keys(C))w.push([I,C[I].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=E}),define(Z[24],ee([0,1,26,15,4,35,5,39]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function m(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=m;var v;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function f(i,n){const a=n?i?n.keys.filter(P=>i.keys.indexOf(P)===-1):[...n.keys]:[],c=i?n?i.keys.filter(P=>n.keys.indexOf(P)===-1):[...i.keys]:[],l=[];if(n&&i){for(const P of i.keys)if(n.keys.indexOf(P)!==-1){const _=C(i.contents,P),j=C(n.contents,P);S.equals(_,j)||l.push(P)}}const u=[],d=P=>{const _={};for(const j of P)for(const B of j.identifiers)_[r(B)]=j;return _},p=n?d(n.overrides):{},h=i?d(i.overrides):{};if(Object.keys(p).length)for(const P of a){const _=p[P];_&&u.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(h).length)for(const P of c){const _=h[P];_&&u.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(p).length&&Object.keys(h).length)for(const P of l){const _=h[P],j=p[P];if(_&&j){const B=f({contents:_.contents,keys:_.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});u.push([(0,O.overrideIdentifierFromKey)(P),[...B.added,...B.removed,...B.updated]])}}return{added:a,removed:c,updated:l,overrides:u}}e.compare=f;function y(i,n){const a=[];for(const c of Object.keys(i))if(O.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const u in i[c])l[u]=i[c][u];a.push({identifiers:[(0,O.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:b(l,n)})}return a}e.toOverrides=y;function b(i,n){const a=Object.create(null);for(let c in i)o(a,c,i[c],n);return a}e.toValuesTree=b;function o(i,n,a,c){const l=n.split("."),u=l.pop();let d=i;for(let p=0;p<l.length;p++){let h=l[p],P=d[h];switch(typeof P){case"undefined":P=d[h]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${l.slice(0,p+1).join(".")} is ${JSON.stringify(P)}`);return}d=P}if(typeof d=="object"&&d!==null)try{d[u]=a}catch(p){c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=o;function E(i,n){const a=n.split(".");w(i,a)}e.removeFromValueTree=E;function w(i,n){const a=n.shift();if(n.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const c=i[a];typeof c=="object"&&!Array.isArray(c)&&(w(c,n),Object.keys(c).length===0&&delete i[a])}}function C(i,n,a){function c(d,p){let h=d;for(const P of p){if(typeof h!="object"||h===null)return;h=h[P]}return h}const l=n.split("."),u=c(i,l);return typeof u=="undefined"?a:u}e.getConfigurationValue=C;function I(i,n,a){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in i?k.isObject(i[c])&&k.isObject(n[c])?I(i[c],n[c],a):a&&(i[c]=n[c]):i[c]=n[c])})}e.merge=I;function g(){const i=L.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=g;function s(){const i=Object.create(null),n=L.Registry.as(O.Extensions.Configuration).getConfigurationProperties();for(let a in n){let c=n[a].default;o(i,a,c,l=>console.error(`Conflict in default settings: ${l}`))}return i}e.getDefaultValues=s;function r(i){return`[${i}]`}e.keyFromOverrideIdentifier=r;function t(i,n,a){const c=i.inspect(n),l=i.inspect(a);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[160],ee([0,1,32,37,18,15,26,4,39,24,35,2,3]),function(K,e,S,k,A,L,U,O,m,v,R,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,v.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,v.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const a of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[a],l=i[a];l&&(typeof c=="object"&&typeof l=="object"?(c=U.deepClone(c),this.mergeContents(c,l)):c=l),n[a]=c}return new b(n,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),n=U.deepClone(this.overrides),a=[...this.keys];for(const c of t){this.mergeContents(i,c.contents);for(const l of c.overrides){const[u]=n.filter(d=>A.equals(d.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):n.push(U.deepClone(l))}for(const l of c.keys)a.indexOf(l)===-1&&a.push(l)}return new b(i,a,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&L.isObject(t[n])&&L.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=U.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,v.addToValueTree)(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,v.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class o extends b{constructor(){const t=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),n=[];for(const a of Object.keys(t))m.OVERRIDE_PROPERTY_PATTERN.test(a)&&n.push({identifiers:[(0,m.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,v.toValuesTree)(t[a],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,i,n)}}e.DefaultConfigurationModel=o;class E{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!L.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:a,overrides:c,untrusted:l}=this.doParseRaw(t,i);this._configurationModel=new b(n,a,c),this._untrustedConfigurations=l||[]}doParseContent(t){let i={},n=null,a=[],c=[],l=[];function u(p){Array.isArray(a)?a.push(p):n&&(a[n]=p)}let d={onObjectBegin:()=>{let p={};u(p),c.push(a),a=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let p=[];u(p),c.push(a),a=p,n=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:u,onError:(p,h,P)=>{l.push({error:p,offset:h,length:P})}};if(t)try{S.visit(t,d),i=a[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(t,i){const n=R.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,n,!0,i);t=a.raw;const c=(0,v.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),u=(0,v.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:l,overrides:u,untrusted:a.untrusted}}filter(t,i,n,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.isUntrusted))return{raw:t,untrusted:[]};const c={},l=[];for(let u in t)if(m.OVERRIDE_PROPERTY_PATTERN.test(u)&&n){const d=this.filter(t[u],i,!1,a);c[u]=d.raw,l.push(...d.untrusted)}else{const d=i[u],p=d?typeof d.scope!="undefined"?d.scope:3:void 0;(p===void 0||a.scopes===void 0||a.scopes.includes(p))&&(a.isUntrusted&&(d==null?void 0:d.requireTrust)?l.push(u):c[u]=t[u])}return{raw:c,untrusted:l}}}e.ConfigurationModelParser=E;class w extends f.Disposable{constructor(t,i,n,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=w;class C{constructor(t,i,n=new b,a=new b,c=new k.ResourceMap,l=new b,u=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let a;n.resource?(a=this._memoryConfigurationByResource.get(n.resource),a||(a=new b,this._memoryConfigurationByResource.set(n.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const a=this.getConsolidateConfigurationModel(i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,j=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(t):l.getValue(t),B=a.getValue(t),M=A.distinct(A.flatten(a.overrides.map($=>$.identifiers))).filter($=>a.getOverrideValue(t,$)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:p,userRemoteValue:h,workspaceValue:P,workspaceFolderValue:_,memoryValue:j,value:B,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:i.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:l.getValue(t),override:i.overrideIdentifier?l.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(a=>m.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const c=(0,m.overrideIdentifierFromKey)(a),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),u=t.getKeysForOverrideIdentifier(c),d=[...u.filter(p=>l.indexOf(p)===-1),...l.filter(p=>u.indexOf(p)===-1),...l.filter(p=>!U.equals(this._defaultConfiguration.override(c).getValue(p),t.override(c).getValue(p)))];return[c,d]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:a,overrides:c}=(0,v.compare)(this.localUserConfiguration,t),l=[...i,...n,...a];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:a,overrides:c}=(0,v.compare)(this.remoteUserConfiguration,t);let l=[...i,...n,...a];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:a,overrides:c}=(0,v.compare)(this.workspaceConfiguration,t);let l=[...i,...n,...a];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:a,updated:c,removed:l,overrides:u}=(0,v.compare)(n,i);let d=[...a,...c,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,i),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:a,removed:c,overrides:l}=(0,v.compare)(i,void 0);return{keys:[...n,...a,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(n=this.getFolderConsolidatedConfiguration(a.uri)||n);const c=this._memoryConfigurationByResource.get(t);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=n.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:a,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:a,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,u)=>(l.set(O.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new k.ResourceMap);return new C(i,n,new b,a,c,new b,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=C;function I(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const a of r)a.keys.forEach(c=>t.add(c)),a.overrides.forEach(([c,l])=>{const u=(0,k.getOrSet)(i,c,new Set);l.forEach(d=>u.add(d))});const n=[];return i.forEach((a,c)=>n.push([c,[...a.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=I;class g{constructor(t,i,n,a){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(u=>c.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>c.add(d))),this.affectedKeys=[...c.values()];const l=new b;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,c=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(a,c)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=(0,v.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof n=="object"&&(a=Object.keys(n)[0]);){if(t=t[a],!t)return!1;n=n[a]}return!0}}e.ConfigurationChangeEvent=g;class s extends g{constructor(t,i,n,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=s}),define(Z[161],ee([0,1,35,39,2,24,160,3,6,12]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends A.Disposable{constructor(y,b){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,b)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new m.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(o=>this.onDidDefaultConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,b){const o=typeof y=="string"?y:void 0,E=(0,L.isConfigurationOverrides)(y)?y:(0,L.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(o,E,void 0)}updateValue(y,b,o,E){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const b=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(o,b,1)}onDidDefaultConfigurationChange(y){const b=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,y);this.trigger(o,b,6)}trigger(y,b,o){const E=new U.ConfigurationChangeEvent(y,{data:b},this.configuration);E.source=o,E.sourceConfig=this.getTargetConfiguration(o),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(Z[162],ee([0,1,24,17,100]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(O,m){this.configurationService=O,this.logService=m}request(O,m){return this.logService.trace("RequestService#request",O.url),O.proxyAuthorization||(O.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(O,m)}async resolveProxy(O){}};L=he([Y(0,S.IConfigurationService),Y(1,k.ILogService)],L),e.RequestService=L}),define(Z[40],ee([0,1,117,5,39,35,22]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function O(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}e.isSuccess=O;function m(o){return o.res.statusCode===204}async function v(o){if(!O(o))throw new Error("Server returned "+o.res.statusCode);return m(o)?null:(await(0,U.streamToBuffer)(o.stream)).toString()}e.asText=v;async function R(o){if(!O(o))throw new Error("Server returned "+o.res.statusCode);if(m(o))return null;const w=(await(0,U.streamToBuffer)(o.stream)).toString();try{return JSON.parse(w)}catch(C){throw C.message+=`:
`+w,C}}e.asJson=R;function f(o){b(o)}e.updateProxyConfigurationsScope=f;let y;function b(o){const E=L.Registry.as(A.Extensions.Configuration);y&&E.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),requireTrust:!0}}},E.registerConfiguration(y)}b(2)}),define(Z[163],ee([0,1,40,30,10,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(m,v){this.requestService=m,this.fileService=v}async download(m,v,R=k.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,v);return}const f={type:"GET",url:m.toString()},y=await this.requestService.request(f,R);if(y.res.statusCode===200)await this.fileService.writeFile(v,y.stream);else{const b=await(0,S.asText)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${b}`)}}};U=he([Y(0,S.IRequestService),Y(1,A.IFileService)],U),e.DownloadService=U}),define(Z[164],ee([0,1,28,10,18,62,40,30,17,12,128,2]),function(K,e,S,k,A,L,U,O,m,v,R,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends f.Disposable{constructor(o,E,w,C){super();this.fileService=o,this.productService=E,this.requestService=w,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(o){return this.getValidConfigBasedTips(o)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(o){const E=[];for(const[w,C]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,v.joinPath)(o,w)),g=new Map;(0,L.forEach)(C.recommendations,({key:r,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const i of t.remotes)g.set(i,{extensionId:r,extensionName:t.name,configName:C.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else E.push({extensionId:r,extensionName:t.name,configName:C.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,R.getDomainsOfRemotes)(I.value.toString(),[...g.keys()]);for(const r of s){const t=g.get(r);t&&E.push(t)}}catch(I){}return E}async fetchWorkspacesTips(){var o,E;if(!((o=this.productService.extensionsGallery)===null||o===void 0?void 0:o.recommendationsUrl))return[];try{const w=await this.requestService.request({type:"GET",url:(E=this.productService.extensionsGallery)===null||E===void 0?void 0:E.recommendationsUrl},O.CancellationToken.None);if(w.res.statusCode!==200)return[];const C=await(0,U.asJson)(w);return C?C.workspaceRecommendations||[]:[]}catch(w){return this.logService.error(w),[]}}};y=he([Y(0,k.IFileService),Y(1,S.IProductService),Y(2,U.IRequestService),Y(3,m.ILogService)],y),e.ExtensionTipsService=y}),define(Z[44],ee([0,1,31,22]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(L,U,O){let m=O&&O.get("storage.serviceMachineId",0)||null;if(m)return m;try{const R=(await U.readFile(L.serviceMachineIdResource)).value.toString();m=(0,S.isUUID)(R)?R:null}catch(v){m=null}if(!m){m=(0,S.generateUuid)();try{await U.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(m))}catch(v){}}return O&&O.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=A}),define(Z[19],ee([0,1,5,3,2,15,67,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var v;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var f;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class y extends A.Disposable{constructor(w={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,C){C===m?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:C,target:this.getKeyTargets(w)[C]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,C,I){var g;return(g=this.getStorage(C))===null||g===void 0?void 0:g.get(w,I)}getBoolean(w,C,I){var g;return(g=this.getStorage(C))===null||g===void 0?void 0:g.getBoolean(w,I)}getNumber(w,C,I){var g;return(g=this.getStorage(C))===null||g===void 0?void 0:g.getNumber(w,I)}store(w,C,I,g){if((0,L.isUndefinedOrNull)(C)){this.remove(w,I);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(w,I,g),(s=this.getStorage(I))===null||s===void 0||s.set(w,C)})}remove(w,C){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(w,C,void 0),(I=this.getStorage(C))===null||I===void 0||I.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,C){const I=[],g=this.getKeyTargets(w);for(const s of Object.keys(g))g[s]===C&&I.push(s);return I}updateKeyTarget(w,C,I){var g,s;const r=this.getKeyTargets(C);typeof I=="number"?r[w]!==I&&(r[w]=I,(g=this.getStorage(C))===null||g===void 0||g.set(m,JSON.stringify(r))):typeof r[w]=="number"&&(delete r[w],(s=this.getStorage(C))===null||s===void 0||s.set(m,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const C=this.get(m,w);if(C)try{return JSON.parse(C)}catch(I){}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(){var w,C,I,g;this._onWillSaveState.fire({reason:v.NONE}),await O.Promises.settled([(C=(w=this.getStorage(0))===null||w===void 0?void 0:w.whenFlushed())!==null&&C!==void 0?C:Promise.resolve(),(g=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&g!==void 0?g:Promise.resolve()])}async logStorage(){var w,C,I,g,s,r;const t=(C=(w=this.getStorage(0))===null||w===void 0?void 0:w.items)!==null&&C!==void 0?C:new Map,i=(g=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&g!==void 0?g:new Map;return o(t,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends y{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=b;async function o(E,w,C,I){const g=c=>{try{return JSON.parse(c)}catch(l){return c}},s=new Map,r=new Map;E.forEach((c,l)=>{s.set(l,c),r.set(l,g(c))});const t=new Map,i=new Map;w.forEach((c,l)=>{t.set(l,c),i.set(l,g(c))}),console.group(`Storage: Global (path: ${C})`);let n=[];s.forEach((c,l)=>{n.push({key:l,value:c})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${I})`);let a=[];t.forEach((c,l)=>{a.push({key:l,value:c})}),console.table(a),console.groupEnd(),console.log(i)}e.logStorage=o}),define(Z[165],ee([0,1,3,2,29,33,19,15]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends k.Disposable{constructor(f){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(f)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"})))}async enableExtension(f,y){return this._removeFromDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:y}),!0):!1}async disableExtension(f,y){return this._addToDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:y}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(f){let y=this.getDisabledExtensions();return y.every(b=>!(0,L.areSameExtensions)(b,f))?(y.push(f),this._setDisabledExtensions(y),!0):!1}_removeFromDisabledExtensions(f){let y=this.getDisabledExtensions();for(let b=0;b<y.length;b++){const o=y[b];if((0,L.areSameExtensions)(o,f))return y.splice(b,1),this._setDisabledExtensions(y),!0}return!1}_setDisabledExtensions(f){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,f)}_getExtensions(f){return this.storageManger.get(f,0)}_setExtensions(f,y){this.storageManger.set(f,y,0)}};m=he([Y(0,U.IStorageService)],m),e.GlobalExtensionEnablementService=m;class v extends k.Disposable{constructor(f){super();this.storageService=f,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(f.onDidChangeValue(y=>this.onDidStorageChange(y)))}get(f,y){let b;return y===0?((0,O.isUndefinedOrNull)(this.storage[f])&&(this.storage[f]=this._get(f,y)),b=this.storage[f]):b=this._get(f,y),JSON.parse(b)}set(f,y,b){let o=JSON.stringify(y.map(({id:w,uuid:C})=>({id:w,uuid:C})));this._get(f,b)!==o&&(b===0&&(y.length?this.storage[f]=o:delete this.storage[f]),this._set(f,y.length?o:void 0,b))}onDidStorageChange(f){if(f.scope===0&&!(0,O.isUndefinedOrNull)(this.storage[f.key])&&this._get(f.key,f.scope)!==this.storage[f.key]){const b=this.get(f.key,f.scope);delete this.storage[f.key];const o=this.get(f.key,f.scope),E=b.filter(C=>!o.some(I=>(0,L.areSameExtensions)(C,I))),w=o.filter(C=>!b.some(I=>(0,L.areSameExtensions)(I,C)));(E.length||w.length)&&this._onDidChange.fire([...E,...w])}}_get(f,y){return this.storageService.get(f,y,"[]")}_set(f,y,b){y?this.storageService.store(f,y,b,1):this.storageService.remove(f,b)}}e.StorageManager=v}),define(Z[166],ee([0,1,3,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R}async getItems(){const v={workspace:this.workspace},R=await this.channel.call("getItems",v);return new Map(R)}updateItems(v){const R={workspace:this.workspace};return v.insert&&(R.insert=Array.from(v.insert.entries())),v.delete&&(R.delete=Array.from(v.delete.values())),this.channel.call("updateItems",R)}}class L extends A{constructor(v){super(v,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(v=>this.onDidChangeGlobalStorage(v)))}onDidChangeGlobalStorage(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this._onDidChangeItemsExternal.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}async close(){this.dispose()}}class U extends A{constructor(v,R){super(v,R);this.onDidChangeItemsExternal=S.Event.None}async close(){const v={workspace:this.workspace};return this.channel.call("close",v)}}class O extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=O}),define(Z[167],ee([0,1,2,19,67,6,156,166,12]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends k.AbstractStorageService{constructor(f,y,b){super();this.mainProcessService=y,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(f)}createGlobalStorage(){const f=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),y=new A.Storage(f.globalStorage);return this._register(y.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),y}createWorkspaceStorage(f){const y=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),f);if(y.workspaceStorage){const b=new A.Storage(y.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(o=>this.emitDidChangeValue(1,o)),this.workspaceStorageId=f==null?void 0:f.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var f,y;(0,U.mark)("code/willInitStorage");try{await L.Promises.settled([this.globalStorage.init(),(y=(f=this.workspaceStorage)===null||f===void 0?void 0:f.init())!==null&&y!==void 0?y:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,m.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var f,y;this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),(y=(f=this.workspaceStorage)===null||f===void 0?void 0:f.close())!==null&&y!==void 0?y:Promise.resolve()])}async migrate(f){var y;const b=this.workspaceStorage,o=(y=b==null?void 0:b.items)!==null&&y!==void 0?y:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(f),await this.workspaceStorage.init();for(const[E,w]of o)this.workspaceStorage.set(E,w)}}e.NativeStorageService=v}),define(Z[168],ee([0,1,7,36,31,4]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function U(v){if(S.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function O(v,R,f,y,b,o,E,w,C,I){const g=Object.create(null);g["common.machineId"]=E,g.sessionID=(0,A.generateUuid)()+Date.now(),g.commitHash=b,g.version=o,g["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.PlatformToString)(S.platform),g["common.nodePlatform"]=k.platform,g["common.nodeArch"]=y,g["common.product"]=I||"desktop";const s=m(w||[]);s&&(g["common.msftInternal"]=s);let r=0;const t=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),S.isLinuxSnap&&(g["common.snap"]="true");const i=U(f);i&&(g["common.platformDetail"]=i);try{const n=await v.readFile(L.URI.file(C));g["common.source"]=n.value.toString().slice(0,30)}catch(n){}return g}e.resolveCommonProperties=O;function m(v){const R=k.env.USERDNSDOMAIN;if(!R)return!1;const f=R.toLowerCase();return v.some(y=>f===y)}}),define(Z[25],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[169],ee([0,1,38,92,69,27,8,32,95,28,7,4,25,53,16,10,23]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function C(t,i){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],a=new Map,c=new Map,l=2e4;function u(h,P,_,j){const B=P.substring(h.length+1);return new Promise(async M=>{var $,V,q;let H;try{H=await(0,w.readdir)(P,{withFileTypes:!0})}catch(T){M();return}if(j.count>=l){j.count+=H.length,j.maxReached=!0,M();return}let z=H.length;if(z===0){M();return}let D=H;j.count+H.length>l&&(j.maxReached=!0,z=l-j.count,D=H.slice(0,z)),j.count+=H.length;for(const T of D)if(T.isDirectory()){if(_.includes(T.name)||await u(h,(0,U.join)(P,T.name),_,j),--z==0){M();return}}else{const F=T.name.lastIndexOf(".");if(F>=0){const N=T.name.substring(F+1);N&&a.set(N,(($=a.get(N))!==null&&$!==void 0?$:0)+1)}for(const N of n)((V=N.relativePathPattern)===null||V===void 0?void 0:V.test(B))!==!1&&N.filePattern.test(T.name)&&c.set(N.tag,((q=c.get(N.tag))!==null&&q!==void 0?q:0)+1);if(--z==0){M();return}}})}const d={count:0,maxReached:!1};await u(t,t,i,d);const p=await s(t);return{configFiles:I(c),fileTypes:I(a),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=C;function I(t){return[...b.Iterable.map(t.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function g(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=g;function s(t){let i=new Map,n=(0,U.join)(t,".vscode","launch.json");return new Promise((a,c)=>{(0,L.exists)(n,l=>{if(l)(0,L.readFile)(n,(u,d)=>{if(u)return a([]);const p=[],h=(0,O.parse)(d.toString(),p);if(p.length)return console.log(`Unable to parse ${n}`),a([]);if((0,O.getNodeType)(h)==="object"&&h.configurations)for(const P of h.configurations){const _=P.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return a(I(i))});else return a([])})})}e.collectLaunchConfigs=s;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const a=S.cpus();return a&&a.length>0&&n.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${S.loadavg().map(c=>Math.round(c)).join(", ")}`),n.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,m.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async a=>{let[c,l]=a,u=this.formatProcessList(i,c);return n.forEach(d=>{if((0,A.isRemoteDiagnosticError)(d))u+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(u+=`

Remote: ${d.hostName}`,d.processes&&(u+=`
${this.formatProcessList(i,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const p of Object.keys(d.workspaceMetadata)){const h=d.workspaceMetadata[p];let P=`${h.fileCount} files`;h.maxFilesReached&&(P=`more than ${P}`),l+=`|    Folder (${p}): ${P}`,l+=this.formatWorkspaceStats(h)}}}),{processInfo:u,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:a,vmHint:c,os:l,cpus:u}=g(),d={os:l,memory:a,cpus:u,vmHint:c,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(d.load=`${S.loadavg().map(p=>Math.round(p)).join(", ")}`),R.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(i,n){const a=[];return(0,m.listProcesses)(i.mainPID).then(async c=>(a.push(""),a.push(this.formatEnvironment(i)),a.push(""),a.push(this.formatProcessList(i,c)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,A.isRemoteDiagnosticError)(l))a.push(`
${l.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${l.hostName}`),a.push(this.formatMachineInfo(l.machineInfo)),l.processes&&a.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const u of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[u];let p=`${d.fileCount} files`;d.maxFilesReached&&(p=`more than ${p}`),a.push(`Folder (${u}): ${p}`),a.push(this.formatWorkspaceStats(d))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(i){const n=[],a=60;let c=0;const l=(h,P)=>{const _=` ${h}(${P})`;c+_.length>a?(n.push(u),u="|                 ",c=u.length):c+=_.length,u+=_};let u="|      File types:";const d=10;let p=i.fileTypes.length>d?d:i.fileTypes.length;for(let h=0;h<p;h++){const P=i.fileTypes[h];l(P.name,P.count)}if(n.push(u),i.configFiles.length>=0&&(u="|      Conf files:",c=0,i.configFiles.forEach(h=>{l(h.name,h.count)}),n.push(u)),i.launchConfigFiles.length>0){let h="|      Launch Configs:";i.launchConfigFiles.forEach(P=>{h+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),n.push(h)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(a=>a.length));return Object.keys(i).map(a=>`${a}:  ${" ".repeat(n-a.length)}  ${i[a]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],a=[];return i.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(n.push(`|  Window (${c.title})`),c.folderURIs.forEach(l=>{const u=f.URI.revive(l);if(u.scheme===o.Schemas.file){const d=u.fsPath;a.push(C(d,["node_modules",".git"]).then(p=>{let h=`${p.fileCount} files`;p.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,U.basename)(d)}): ${h}`),n.push(this.formatWorkspaceStats(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${p.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(c=>n.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(i,n){const a=new Map;i.windows.forEach(l=>a.set(l.pid,l.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,a,c,n,0),c.join(`
`)}formatProcessItem(i,n,a,c,l){const u=l===0;let d;u?d=c.pid===i?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${c.name}`,c.name==="window"&&(d=`${d} (${n.get(c.pid)})`));const p=process.platform==="win32"?c.mem:S.totalmem()*(c.mem/100);a.push(`${c.load.toFixed(0).padStart(5," ")}	${(p/E.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(c.children)&&c.children.forEach(h=>this.formatProcessItem(i,n,a,h,l+1))}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const a=f.URI.revive(n);if(a.scheme===o.Schemas.file){const c=a.fsPath;try{const l=await C(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),l.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),l.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})})}catch(l){}}}}};r=he([Y(0,y.ITelemetryService),Y(1,v.IProductService)],r),e.DiagnosticsService=r}),define(Z[170],ee([0,1,11,29,33,26,25,40,68,9,30,17,10,4,28,19,44,5,12]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var g;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(g||(g={}));function s(...D){return String(D.reduce((T,F)=>T|F,0))}var r;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:g.None,criteria:[],assetTypes:[]};class c{constructor(T=a){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,F=this.state.pageSize){return new c(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:F}))}withFilter(T,...F){const N=[...this.state.criteria,...F.length?F.map(x=>({filterType:T,value:x})):[{filterType:T}]];return new c(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(T){return new c(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new c(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new c(Object.assign(Object.assign({},this.state),{flags:T.reduce((F,N)=>F|N,0)}))}withAssetTypes(...T){return new c(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:F,pageSize:N,sortBy:x,sortOrder:G,flags:J,assetTypes:Q}=this.state;return{filters:[{criteria:T,pageNumber:F,pageSize:N,sortBy:x,sortOrder:G}],assetTypes:Q,flags:J}}get searchText(){const T=this.state.criteria.filter(F=>F.filterType===r.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(D,T){const F=(D||[]).filter(N=>N.statisticName===T)[0];return F?F.value:0}function u(D){const T="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(N=>N.assetType.indexOf(T)===0).reduce((N,x)=>{const G=P(D,x.assetType);return G&&N.push([x.assetType.substring(T.length),G]),N},[])}function d(D){if(D.properties){const T=D.properties.filter(x=>x.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=T.filter(x=>F.test(x.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return P(D,t.Repository)}function p(D){return{uri:`${D.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${D.fallbackAssetUri}/${t.VSIX}`}}function h(D){const T=P(D,t.Icon);if(T)return T;const F=k.DefaultIconPath;return{uri:F,fallbackUri:F}}function P(D,T){return D.files.filter(N=>N.assetType===T)[0]?{uri:`${D.assetUri}/${T}`,fallbackUri:`${D.fallbackAssetUri}/${T}`}:null}function _(D,T){const F=D.properties?D.properties.filter(x=>x.key===T):[],N=F.length>0&&F[0].value;return N?N.split(",").map(x=>(0,A.adoptToGalleryExtensionId)(x)):[]}function j(D){const T=D.properties?D.properties.filter(F=>F.key===i.Engine):[];return T.length>0&&T[0].value||""}function B(D){const T=D.properties?D.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=T.length>0&&T[0].value||"";return F?F.split(","):[]}function M(D){return D.indexOf("preview")!==-1}function $(D){const T=D.properties?D.properties.find(F=>F.key===i.WebExtension):void 0;return!!T&&T.value==="true"}function V(D){return D.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,I.joinPath)(b.URI.parse(D.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function q(D,T,F,N,x){const G={manifest:P(T,t.Manifest),readme:P(T,t.Details),changelog:P(T,t.Changelog),license:P(T,t.License),repository:d(T),download:p(T),icon:h(T),coreTranslations:u(T)};return{identifier:{id:(0,A.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:T.version,date:T.lastUpdated,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:l(D.statistics,"install"),rating:l(D.statistics,"averagerating"),ratingCount:l(D.statistics,"ratingcount"),assetUri:b.URI.parse(T.assetUri),webResource:V(T),assetTypes:T.files.map(({assetType:J})=>J),assets:G,properties:{dependencies:_(T,i.Dependency),extensionPack:_(T,i.ExtensionPack),engine:j(T),localizedLanguages:B(T),webExtension:$(T)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,searchText:N.searchText,querySource:x},preview:M(D.flags)}}let H=class{constructor(T,F,N,x,G,J,Q){this.requestService=T,this.logService=F,this.environmentService=N,this.telemetryService=x,this.fileService=G,this.productService=J;const ne=J.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=z(J.version,this.environmentService,this.fileService,Q)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,F){const N=[];let{total:x,firstPage:G,getPage:J}=await this.query({names:T,pageSize:T.length},F);N.push(...G);for(let Q=1;N.length<x&&(G=await J(Q,F),G.length);Q++)N.push(...G);return N}async getCompatibleExtension(T,F){const N=await this.getCompatibleExtensionByEngine(T,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(T,F){const N=(0,k.isIExtensionIdentifier)(T)?null:T;if(N&&N.properties.engine&&(0,m.isEngineValid)(N.properties.engine,this.productService.version))return N;const{id:x,uuid:G}=N?N.identifier:T;let J=new c().withFlags(g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");G?J=J.withFilter(r.ExtensionId,G):J=J.withFilter(r.ExtensionName,x);const{galleryExtensions:Q}=await this.queryGallery(J,R.CancellationToken.None),[ne]=Q;if(!ne||!ne.versions.length)return null;if(F){const ce=ne.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=q(ne,ce,0,J);if(ue.properties.engine&&(0,m.isEngineValid)(ue.properties.engine,this.productService.version))return ue}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?q(ne,ie,0,J):null}async query(T,F){const N=R.CancellationToken.isCancellationToken(T)?{}:T,x=R.CancellationToken.isCancellationToken(T)?T:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=N.text||"";const J=(0,L.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new c().withFlags(g.IncludeLatestVersionOnly,g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,J).withFilter(r.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(r.Category,Ie||Ee),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(r.Tag,Ie||Ee),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(r.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Q=Q.withFilter(r.SearchText,G)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(r.ExtensionId,...N.ids):N.names?Q=Q.withFilter(r.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(Q,x),ce=ne.map((ge,Ee)=>q(ge,ge.versions[0],Ee,Q,N.source)),ue=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw(0,S.canceled)();const Ie=Q.withPage(ge+1),{galleryExtensions:Oe}=await this.queryGallery(Ie,Ee);return Oe.map((Ae,Ue)=>q(Ae,Ae.versions[0],Ue,Ie,N.source))};return{firstPage:ce,total:ie,pageSize:Q.pageSize,getPage:ue}}async queryGallery(T,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,g.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(g.Unpublished));const N=await this.commonHeadersPromise,x=JSON.stringify(T.raw),G=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)}),J=new Date().getTime();let Q,ne,ie=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:G},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await(0,O.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,Ee=ue.resultMetadata&&ue.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ie=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw ne=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(x.length),duration:new Date().getTime()-J,success:!!Q&&(0,O.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ne?(0,S.isPromiseCanceledError)(ne)?"canceled":(0,S.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(T,F,N,x){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,J=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${F}/${N}/stats?statType=${x}`),headers:J},R.CancellationToken.None)}catch(Q){}}}async download(T,F,N){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const x=(0,A.getGalleryExtensionTelemetryData)(T),G=new Date().getTime(),J=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},x),{duration:ce})),Q=N===1?"install":N===2?"update":"",ne=Q?{uri:`${T.assets.download.uri}&${Q}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${Q}=true`}:T.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),J(new Date().getTime()-G)}async getReadme(T,F){if(T.assets.readme){const N=await this.getAsset(T.assets.readme,{},F);return await(0,O.asText)(N)||""}return""}async getManifest(T,F){if(T.assets.manifest){const N=await this.getAsset(T.assets.manifest,{},F),x=await(0,O.asText)(N);return x?JSON.parse(x):null}return null}async getCoreTranslation(T,F){const N=T.assets.coreTranslations.filter(x=>x[0]===F.toUpperCase())[0];if(N){const x=await this.getAsset(N[1]),G=await(0,O.asText)(x);return G?JSON.parse(G):null}return null}async getChangelog(T,F){if(T.assets.changelog){const N=await this.getAsset(T.assets.changelog,{},F);return await(0,O.asText)(N)||""}return""}async getAllVersions(T,F){let N=new c().withFlags(g.IncludeVersions,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?N=N.withFilter(r.ExtensionId,T.identifier.uuid):N=N.withFilter(r.ExtensionName,T.identifier.id);const x=[],{galleryExtensions:G}=await this.queryGallery(N,R.CancellationToken.None);return G.length&&(F?await Promise.all(G[0].versions.map(async J=>{let Q;try{Q=await this.getEngine(J)}catch(ne){}Q&&(0,m.isEngineValid)(Q,this.productService.version)&&x.push({version:J.version,date:J.lastUpdated})})):x.push(...G[0].versions.map(J=>({version:J.version,date:J.lastUpdated})))),x}async getAsset(T,F={},N=R.CancellationToken.None){const x=await this.commonHeadersPromise,G={type:"GET"},J=Object.assign(Object.assign({},x),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),G),{headers:J});const Q=T.uri,ne=T.fallbackUri,ie=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ie,N);if(ce.res.statusCode===200)return ce;const ue=await(0,O.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,S.isPromiseCanceledError)(ce))throw ce;const ue=(0,S.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(T,F){const N=this.getLastValidExtensionVersionFromProperties(T,F);return N||this.getLastValidExtensionVersionRecursively(T,F)}getLastValidExtensionVersionFromProperties(T,F){for(const N of F){const x=j(N);if(!x)return null;if((0,m.isEngineValid)(x,this.productService.version))return N}return null}async getEngine(T){const F=j(T);if(F)return F;const N=P(T,t.Manifest);if(!N)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},G=await this.getAsset(N,{headers:x}),J=await(0,O.asJson)(G);if(J)return J.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,F){if(!F.length)return null;const N=F[0],x=await this.getEngine(N);return(0,m.isEngineValid)(x,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:x}),N):this.getLastValidExtensionVersionRecursively(T,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,O.asJson)(T),N=new Map;if(F)for(const x of F.malicious){const G=N.get(x)||{id:{id:x},malicious:!0,slow:!1};G.malicious=!0,N.set(x,G)}return[...N.values()]}};H=he([Y(0,O.IRequestService),Y(1,f.ILogService),Y(2,v.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,y.IFileService),Y(5,o.IProductService),Y(6,(0,C.optional)(E.IStorageService))],H),e.ExtensionGalleryService=H;async function z(D,T,F,N){const x={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},G=await(0,w.getServiceMachineId)(T,F,N);return x["X-Market-User-Id"]=G,x}e.resolveMarketplaceHeaders=z}),define(Z[171],ee([0,1,4,8,28,9,36,10,7,18,29,62,40,17,164,6,25,71,108,19,3,57]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let n=class extends o.ExtensionTipsService{constructor(c,l,u,d,p,h,P,_,j,B){super(P,_,j,B);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=p,this.extensionRecommendationNotificationService=h,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,f.forEach)(_.exeBasedExtensionTips,({key:M,value:$})=>{const V=[],q=[],H=[];(0,f.forEach)($.recommendations,({key:z,value:D})=>{D.important?$.important?V.push({extensionId:z,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):q.push({extensionId:z,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):H.push({extensionId:z,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V}),q.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:q}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,E.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(c,l){const u=new Map;c.forEach(_=>u.set(_.extensionId.toLowerCase(),_));const{installed:d,uninstalled:p}=this.groupByInstalled([...u.keys()],l);for(const _ of d){const j=u.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}for(const _ of p){const j=u.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}const h=this.getPromptedExecutableTips(),P=new Map;for(const _ of p){const j=u.get(_);if(j&&(!h[j.exeName]||!h[j.exeName].includes(j.extensionId))){let B=P.get(j.exeName);B||(B=[],P.set(j.exeName,B)),B.push(j)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const d=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,E.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,u=7*24*60*60*1e3;if(l<u){const h=this._register((0,E.disposableTimeout)(()=>{h.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(h=>{switch(h){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(p[0].exeName,p);const P=this._register((0,E.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register((0,E.disposableTimeout)(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(c){const l=c.map(({extensionId:d})=>d.toLowerCase()),u=(0,I.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(i,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(i,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const u=this.getPromptedExecutableTips();u[c]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(c,l){const u=[],d=[],p=l.reduce((h,P)=>(h.add(P.identifier.id.toLowerCase()),h),new Set);return c.forEach(h=>{p.has(h.toLowerCase())?u.push(h):d.push(h)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(c){const l=[],u=new Map;for(const d of c.keys()){const p=c.get(d);if(!(!p||!(0,v.isNonEmptyArray)(p.recommendations))){const h=[];m.isWindows?p.windowsPath&&h.push(p.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(h.push((0,k.join)("/usr/local/bin",d)),h.push((0,k.join)("/usr/bin",d)),h.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const P of h){let _=u.get(P);if(_===void 0&&(_=await this.fileService.exists(S.URI.file(P)),u.set(P,_)),_)for(const{extensionId:j,extensionName:B,isExtensionPack:M}of p.recommendations)l.push({extensionId:j,extensionName:B,isExtensionPack:M,exeName:d,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}}return l}};n=he([Y(0,L.INativeEnvironmentService),Y(1,w.ITelemetryService),Y(2,R.IExtensionManagementService),Y(3,g.IStorageService),Y(4,r.INativeHostService),Y(5,C.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,A.IProductService),Y(8,y.IRequestService),Y(9,b.ILogService)],n),e.ExtensionTipsService=n}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(L){this.appender=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,{eventName:O,data:m}){return this.appender.log(O,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class k{constructor(L){this.channel=L}log(L,U){return this.channel.call("log",{eventName:L,data:U}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[79],ee([0,1,51,118,21,5,24,39,2,26,35]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(o,E){this._configurationService=E,this._experimentProperties={},this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appender=o.appender,this._commonProperties=o.commonProperties||Promise.resolve({}),this._piiPaths=o.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!o.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(w=>{const C=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!C})}))}setExperimentProperty(o,E){this._experimentProperties[o]=E}setEnabled(o){this._enabled=o}_updateUserOptIn(){var o;const E=(o=this._configurationService)===null||o===void 0?void 0:o.getValue(y);this._userOptIn=E?E.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const o=await this._commonProperties;let E=o.sessionID,w=o["common.instanceId"],C=o["common.machineId"],I=o["common.firstSessionDate"],g=o["common.msftInternal"];return{sessionId:E,instanceId:w,machineId:C,firstSessionDate:I,msftInternal:g}}dispose(){this._disposables.dispose()}publicLog(o,E,w){return this.isOptedIn?this._commonProperties.then(C=>{E=(0,v.mixin)(E,C),E=(0,v.mixin)(E,this._experimentProperties),E=(0,v.cloneAndChange)(E,I=>{if(typeof I=="string")return this._cleanupInfo(I,w)}),this._appender.log(o,E)},C=>{console.error(C)}):Promise.resolve(void 0)}publicLog2(o,E,w){return this.publicLog(o,E,w)}publicLogError(o,E){return this.sendErrorTelemetry?this.publicLog(o,E,!0):Promise.resolve(void 0)}publicLogError2(o,E){return this.publicLogError(o,E)}_cleanupInfo(o,E){let w=o;if(E){const C=[];for(let r of this._cleanupPatterns)for(;;){const t=r.exec(o);if(!t)break;C.push([t.index,r.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(w="";;){const r=g.exec(o);if(!r)break;!I.test(r[0])&&C.every(([t,i])=>r.index<t||r.index>=i)&&(w+=o.substring(s,r.index)+"<REDACTED: user-file-path>",s=g.lastIndex)}s<o.length&&(w+=o.substr(s))}for(let C of this._cleanupPatterns)w=w.replace(C,"");return w}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=he([Y(1,(0,L.optional)(U.IConfigurationService))],f),e.TelemetryService=f;const y="telemetry";R.Registry.as(O.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(2,null,S.default.privacyStatementUrl):(0,k.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,24,26,15,6]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(o,E){return Promise.resolve(void 0)}publicLog2(o,E){return this.publicLog(o,E)}publicLogError(o,E){return Promise.resolve(void 0)}publicLogError2(o,E){return this.publicLogError(o,E)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(E,w,C){}async publicLogError(E,w,C){}}e.NullEndpointTelemetryService=U;function O(...o){return{log:(E,w)=>o.forEach(C=>C.log(E,w)),flush:()=>L.Promises.settled(o.map(E=>E.flush()))}}e.combinedAppender=O,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(o,E){return E.onDidChangeConfiguration(w=>{w.source!==6&&o.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(w.source),configurationKeys:y(w.sourceConfig)})})}e.configurationTelemetry=m;function v(o){const E=Object.create(null),w=Object.create(null),C=Object.create(null);f(o,C);for(let I in C){I=I.length>150?I.substr(I.length-149):I;const g=C[I];typeof g=="number"?w[I]=g:typeof g=="boolean"?w[I]=g?1:0:typeof g=="string"?E[I]=g.substring(0,1023):typeof g!="undefined"&&g!==null&&(E[I]=g)}return{properties:E,measurements:w}}e.validateTelemetryData=v;function R(o){if(!o)return"none";let E="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{o.indexOf(`${C}+`)===0&&(E=C)}),E}e.cleanRemoteAuthority=R;function f(o,E,w=0,C){if(!!o)for(let I of Object.getOwnPropertyNames(o)){const g=o[I],s=C?C+I:I;Array.isArray(g)?E[s]=(0,k.safeStringify)(g):g instanceof Date?E[s]=g.toISOString():(0,A.isObject)(g)?w<2?f(g,E,w+1,s+"."):E[s]=(0,k.safeStringify)(g):E[s]=g}}function y(o){if(!o)return[];const E=[];return b(E,"",o),E}function b(o,E,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(C=>b(o,E?`${E}.${C}`:C,w[C])):o.push(E)}}),define(Z[172],ee([0,1,2,9,17,58]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends S.Disposable{constructor(m,v){super();this.logger=this._register(m.createLogger(v.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(m,v){this.logger.trace(`telemetry/${m}`,(0,L.validateTelemetryData)(v))}};U=he([Y(0,A.ILoggerService),Y(1,k.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[173],ee([0,1,11,26,58]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(O){const m=await new Promise((R,f)=>{K(["applicationinsights"],R,f)});let v;return m.defaultClient?(v=new m.TelemetryClient(O),v.channel.setUseDiskRetryCaching(!0)):(m.setup(O).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=m.defaultClient),O.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class U{constructor(m,v,R){this._eventPrefix=m,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(v=>{m(v)},v=>{(0,S.onUnexpectedError)(v),console.error(v)})}}log(m,v){!this._aiClient||(v=(0,k.mixin)(v,this._defaultData),v=(0,A.validateTelemetryData)(v),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+m,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[174],ee([0,1,49,78,16,79,24,25]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(R,f){this.configurationService=R,this.telemetryService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(R){if(!this.customTelemetryServices.has(R.id)){const{machineId:f,sessionId:y}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=f,b["common.vscodesessionid"]=y;const o=[R.id,JSON.stringify(b),R.aiKey],w=new S.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:o,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=new k.TelemetryAppenderClient(w);this.customTelemetryServices.set(R.id,new L.TelemetryService({appender:C,sendErrorTelemetry:R.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(R.id)}async publicLog(R,f,y){await(await this.getCustomTelemetryService(R)).publicLog(f,y)}async publicLogError(R,f,y){await(await this.getCustomTelemetryService(R)).publicLogError(f,y)}};m=he([Y(0,U.IConfigurationService),Y(1,O.ITelemetryService)],m),e.CustomEndpointTelemetryService=m}),define(Z[80],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var k;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,S.createDecorator)("localTerminalService"),e.IPtyService=(0,S.createDecorator)("ptyService");var L;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(L=e.HeartbeatConstants||(e.HeartbeatConstants={}));var U;(function(m){m[m.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",m[m.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(U=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var O;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(O=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[175],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(Z[176],ee([0,1,2,17,80,49,16,34,3,75]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var R;(function(b){b[b.MaxRestarts=5]="MaxRestarts"})(R||(R={}));let f=0,y=class extends S.Disposable{constructor(o){super();this._logService=o,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new m.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new m.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new m.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new m.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new m.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new m.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new m.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new m.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new m.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new m.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new m.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new m.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new m.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,S.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const o=new L.Client(U.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:f,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),O.ProxyChannel.toService(o.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(o.onDidProcessExit(I=>{this._onPtyHostExit.fire(I.code),this._isDisposed||(this._restartCount<=R.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${I.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${I.code}, giving up`))}));const w=o.getChannel(A.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(w,this._logService.getLevel())}));const C=O.ProxyChannel.toService(o.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(C.onProcessData(I=>this._onProcessData.fire(I))),this._register(C.onProcessExit(I=>this._onProcessExit.fire(I))),this._register(C.onProcessReady(I=>this._onProcessReady.fire(I))),this._register(C.onProcessTitleChanged(I=>this._onProcessTitleChanged.fire(I))),this._register(C.onProcessShellTypeChanged(I=>this._onProcessShellTypeChanged.fire(I))),this._register(C.onProcessOverrideDimensions(I=>this._onProcessOverrideDimensions.fire(I))),this._register(C.onProcessResolvedShellLaunchConfig(I=>this._onProcessResolvedShellLaunchConfig.fire(I))),this._register(C.onProcessReplay(I=>this._onProcessReplay.fire(I))),this._register(C.onProcessOrphanQuestion(I=>this._onProcessOrphanQuestion.fire(I))),[o,C]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,E,w,C,I,g,s,r,t,i){const n=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),a=await this._proxy.createProcess(o,E,w,C,I,g,s,r,t,i);return clearTimeout(n),f=Math.max(f,a),a}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,E){return this._proxy.shutdown(o,E)}input(o,E){return this._proxy.input(o,E)}processBinary(o,E){return this._proxy.processBinary(o,E)}resize(o,E,w){return this._proxy.resize(o,E,w)}acknowledgeDataEvent(o,E){return this._proxy.acknowledgeDataEvent(o,E)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}getShellEnvironment(){return this._proxy.getShellEnvironment()}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};y=he([Y(0,k.ILogService)],y),e.PtyHostService=y}),define(Z[52],ee([0,1,41]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(U,O,m,v){const R=(0,S.setProperty)(U,O,m,v)[0];return R&&(U=U.substring(0,R.offset)+R.content+U.substring(R.offset+R.length)),U}e.edit=k;function A(U,O,m){let v=m;for(;v>=0;){if(U.charAt(v)===O.charAt(O.length-1)&&O.length===1)return v+1;if(v--,O.length===2&&v>=0&&U.charAt(v)===O.charAt(0))return v+2}return 0}e.getLineStartOffset=A;function L(U,O,m){let v=m;for(;v>=0;)if(U.charAt(v)===O.charAt(O.length-1)&&O.length===1||(v++,O.length===2&&v>=0&&U.charAt(v)===O.charAt(1)))return v;return U.length-1}e.getLineEndOffset=L}),define(Z[177],ee([0,1,26,56]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,y,b,o,E){var w,C;const I=[],g=[],s=[];if(!y){const j=f.filter(({identifier:B})=>E.every(M=>M.toLowerCase()!==B.id.toLowerCase()));return{added:I,removed:g,updated:s,remote:j.length>0?j:null}}f=f.map(v),y=y.map(v),b=b?b.map(v):null;const r=new Map,t=j=>{j.uuid&&r.set(j.id.toLowerCase(),j.uuid)};f.forEach(({identifier:j})=>t(j)),y.forEach(({identifier:j})=>t(j)),b&&b.forEach(({identifier:j})=>t(j));const i=j=>{const B=j.identifier.uuid||r.get(j.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${j.identifier.id.toLowerCase()}`},n=(j,B)=>(j.set(i(B),B),j),a=f.reduce(n,new Map),c=y.reduce(n,new Map),l=y.reduce((j,B)=>{const M=i(B);B=(0,S.deepClone)(B);const $=a.get(M);return $&&($.installed&&(B.installed=!0),B.version||(B.version=$.version)),n(j,B)},new Map),u=b?b.reduce(n,new Map):null,d=o.reduce(n,new Map),p=E.reduce((j,B)=>{const M=r.get(B.toLowerCase());return j.add(M?`uuid:${M}`:`id:${B.toLowerCase()}`)},new Set),h=L(a,c,p);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const j=L(u,a,p),B=L(u,c,p),M=($,V)=>{const q=a.get($);if(q){const H=c.get($);return Object.assign(Object.assign({},V?H:q),{version:(H.version&&k.gt(H.version,q.version),q.version),state:U(q,H,u==null?void 0:u.get($))})}};for(const $ of B.removed.values()){const V=a.get($);V&&g.push(V.identifier)}for(const $ of B.added.values())if(j.added.has($)){if(h.updated.has($)){const V=M($,!0);V&&(s.push(R(V,$)),l.set($,V))}}else{const V=c.get($);V.installed&&I.push(R(V,$))}for(const $ of B.updated.values()){const V=M($,!0);V&&(s.push(R(V,$)),l.set($,V))}for(const $ of j.added.values())B.added.has($)||l.set($,a.get($));for(const $ of j.updated.values())if(!B.removed.has($)&&!B.updated.has($)){const V=M($,!1);V&&(((w=l.get($))===null||w===void 0?void 0:w.installed)&&(V.installed=!0),l.set($,V))}for(const $ of j.removed.values())!d.has($)&&!B.updated.has($)&&((C=u==null?void 0:u.get($))===null||C===void 0?void 0:C.installed)&&l.delete($)}const P=[],_=L(c,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((j,B)=>P.push(R(j,B))),{added:I,removed:g,updated:s,remote:P.length?P:null}}e.merge=A;function L(f,y,b,{checkInstalledProperty:o,checkVersionProperty:E}={checkInstalledProperty:!1,checkVersionProperty:!1}){const w=f?[...f.keys()].filter(r=>!b.has(r)):[],C=[...y.keys()].filter(r=>!b.has(r)),I=C.filter(r=>w.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),g=w.filter(r=>C.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of w)if(!g.has(r)){const t=f.get(r),i=y.get(r);(!i||t.disabled!==i.disabled||!m(t.state,i.state)||E&&t.version!==i.version||o&&t.installed!==i.installed)&&s.add(r)}return{added:I,removed:g,updated:s}}function U(f,y,b){const o=f.state,E=y.state,w=b==null?void 0:b.state;if(!y.version||o&&k.gt(f.version,y.version))return o;if(E&&k.gt(y.version,f.version)||!o)return E;if(!E)return o;const C=(0,S.deepClone)(o),I=w?O(w,E):{added:Object.keys(E).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set},g=w?O(w,o):{added:Object.keys(o).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set};for(const s of[...I.added.values(),...I.updated.values()])C[s]=E[s];for(const s of I.removed.values())g.updated.has(s)||delete C[s];return C}function O(f,y){const b=Object.keys(f),o=Object.keys(y),E=o.filter(I=>b.indexOf(I)===-1).reduce((I,g)=>(I.add(g),I),new Set),w=b.filter(I=>o.indexOf(I)===-1).reduce((I,g)=>(I.add(g),I),new Set),C=new Set;for(const I of b)if(!w.has(I)){const g=f[I],s=y[I];(0,S.equals)(g,s)||C.add(I)}return{added:E,removed:w,updated:C}}function m(f={},y={}){const{added:b,removed:o,updated:E}=O(f,y);return b.size===0&&o.size===0&&E.size===0}function v(f){return Object.assign(Object.assign({},f),{disabled:!!f.disabled,installed:!!f.installed})}function R(f,y){const b={identifier:{id:f.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0}};return f.version&&(b.version=f.version),f.disabled&&(b.disabled=!0),f.installed&&(b.installed=!0),f.state&&(b.state=f.state),b}}),define(Z[81],ee([0,1,18,3,2,33,5,28,19]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let R=class Xe extends A.Disposable{constructor(y,b){super();this.storageService=y,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(o=>this.onDidChangeStorageValue(o)))}static toKey(y){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const b=v.exec(y);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const y=this.storageService.keys(0,1);for(const b of y){const o=Xe.fromKey(b);o&&this.extensionsWithKeysForSync.add(o.id.toLowerCase())}}onDidChangeStorageValue(y){if(y.scope===0){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Xe.fromKey(y.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(y,b){this.storageService.store(Xe.toKey(y),JSON.stringify(b),0,1)}getKeysForSync(y){var b;const o=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[y.id.toLowerCase()],E=this.storageService.get(Xe.toKey(y),0),w=E?JSON.parse(E):void 0;return w&&o?(0,S.distinct)([...w,...o]):w||o}};R=he([Y(0,m.IStorageService),Y(1,O.IProductService)],R),e.ExtensionsStorageSyncService=R}),define(Z[82],ee([0,1,18,24,5]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(O){this.configurationService=O}hasToNeverSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,m){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==O&&R!==`-${O}`),m&&v.push(O.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}updateSynchronizedExtensions(O,m){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==O&&R!==`-${O}`),m&&v.push(`-${O.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}getIgnoredExtensions(O){const m=O.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(y=>y.toLowerCase()),R=[],f=[];if(Array.isArray(v))for(const y of v)y.startsWith("-")?f.push(y.substring(1)):R.push(y);return(0,S.distinct)([...m,...R].filter(y=>f.indexOf(y)===-1))}getConfiguredIgnoredExtensions(){let O=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.configurationService.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};L=he([Y(0,k.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(Z[178],ee([0,1,26,32,18,139,52]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function O(s){return(0,k.parse)(s)||[]}e.parseKeybindings=O;async function m(s,r,t,i,n){const a=O(s),c=O(r),l=t?O(t):null,u=[...a,...c,...l||[]].map(q=>q.key),d=await n.resolveUserBindings(u);let p=R(a,c,l,d);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:r,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const h=y(a),P=y(c),_=l?y(l):null,j=o(h,P,d),B=_?o(_,h,d):{added:[...h.keys()].reduce((q,H)=>(q.add(H),q),new Set),removed:new Set,updated:new Set},M=_?o(_,P,d):{added:[...P.keys()].reduce((q,H)=>(q.add(H),q),new Set),removed:new Set,updated:new Set},$=v(j,B,M);let V=s;for(const q of $.removed.values())$.conflicts.has(q)||(V=I(V,q,i));for(const q of $.added.values())if(!$.conflicts.has(q)){const H=P.get(q);if(H.some(z=>z.command!==`-${q}`&&p.conflicts.has(d[z.key]))){$.conflicts.add(q);continue}V=C(V,H,i)}for(const q of $.updated.values())if(!$.conflicts.has(q)){const H=P.get(q);if(H.some(z=>z.command!==`-${q}`&&p.conflicts.has(d[z.key]))){$.conflicts.add(q);continue}V=g(V,q,H,i)}return{mergeContent:V,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=m;function v(s,r,t){const i=new Set,n=new Set,a=new Set,c=new Set;for(const l of r.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(r.updated.has(l)?c.add(l):n.add(l));for(const l of r.added.values())c.has(l)||t.added.has(l)&&s.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(r.added.has(l)?s.updated.has(l)&&c.add(l):i.add(l));for(const l of r.updated.values())c.has(l)||t.updated.has(l)&&s.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(r.updated.has(l)?s.updated.has(l)&&c.add(l):a.add(l));return{added:i,removed:n,updated:a,conflicts:c}}function R(s,r,t,i){const n=new Set,a=f(s,i),c=f(r,i),l=t?f(t,i):null,u=b(a,c);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?b(l,a):{added:[...a.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=l?b(l,c):{added:[...c.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:P,updated:_,conflicts:j}=v(u,d,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:P,updated:_,conflicts:j}}function f(s,r){const t=new Map;for(const i of s){const n=r[i.key];let a=t.get(n);a||(a=[],t.set(n,a)),a.push(i)}return t}function y(s){const r=new Map;for(const t of s){const i=t.command[0]==="-"?t.command.substring(1):t.command;let n=r.get(i);n||(n=[],r.set(i,n)),n.push(t)}return r}function b(s,r){const t=[...s.keys()],i=[...r.keys()],n=i.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),a=t.filter(l=>i.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),c=new Set;for(const l of t)if(!a.has(l)){const u=s.get(l).map(p=>Object.assign(Object.assign({},p),{key:l})),d=r.get(l).map(p=>Object.assign(Object.assign({},p),{key:l}));(0,A.equals)(u,d,(p,h)=>w(p,h))||c.add(l)}return{added:n,removed:a,updated:c}}function o(s,r,t){const i=[...s.keys()],n=[...r.keys()],a=n.filter(u=>i.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),c=i.filter(u=>n.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of i)if(!c.has(u)){const d=s.get(u).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]})),p=r.get(u).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]}));E(d,p)||l.add(u)}return{added:a,removed:c,updated:l}}function E(s,r){return!(!(0,A.equals)(s.filter(({command:t})=>t[0]!=="-"),r.filter(({command:t})=>t[0]!=="-"),(t,i)=>w(t,i))||!(0,A.equals)(s.filter(({command:t})=>t[0]==="-"),r.filter(({command:t})=>t[0]==="-"),(t,i)=>w(t,i)))}function w(s,r){if(s.command!==r.command||s.key!==r.key)return!1;const t=L.ContextKeyExpr.deserialize(s.when),i=L.ContextKeyExpr.deserialize(r.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!S.equals(s.args,r.args))}function C(s,r,t){for(const i of r)s=U.edit(s,[-1],i,t);return s}function I(s,r,t){const i=O(s);for(let n=i.length-1;n>=0;n--)(i[n].command===r||i[n].command===`-${r}`)&&(s=U.edit(s,[n],void 0,t));return s}function g(s,r,t,i){const n=O(s),a=n.findIndex(c=>c.command===r||c.command===`-${r}`);for(let c=n.length-1;c>=0;c--)(n[c].command===r||n[c].command===`-${r}`)&&(s=U.edit(s,[c],void 0,i));for(let c=t.length-1;c>=0;c--)s=U.edit(s,[a],t[c],i);return s}}),define(Z[179],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(L,U,O){const m={},v={},R=new Set;if(!U)return{local:{added:m,updated:v,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const f=k(L,U);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{local:{added:m,updated:v,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=k(O,L),b=k(O,U),o={},E={},w=new Set,C=new Set;for(const I of y.removed.values())b.updated.has(I)?m[I]=U[I]:w.add(I);for(const I of b.removed.values())C.has(I)||(y.updated.has(I)?C.add(I):R.add(I));for(const I of y.updated.values())C.has(I)||(b.updated.has(I)?f.updated.has(I)&&C.add(I):E[I]=L[I]);for(const I of b.updated.values())C.has(I)||(y.updated.has(I)?f.updated.has(I)&&C.add(I):L[I]!==void 0&&(v[I]=U[I]));for(const I of y.added.values())C.has(I)||(b.added.has(I)?f.updated.has(I)&&C.add(I):o[I]=L[I]);for(const I of b.added.values())C.has(I)||(y.added.has(I)?f.updated.has(I)&&C.add(I):m[I]=U[I]);return{local:{added:m,removed:[...R.values()],updated:v},remote:{added:o,removed:[...w.values()],updated:E},conflicts:[...C.values()]}}e.merge=S;function k(L,U){const O=L?Object.keys(L):[],m=U?Object.keys(U):[],v=m.filter(y=>O.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),R=O.filter(y=>m.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),f=new Set;for(const y of O)if(!R.has(y)){const b=L[y],o=U[y];b!==o&&f.add(y)}return{added:v,removed:R,updated:f}}function A(L,U){const{added:O,removed:m,updated:v}=k(L,U);return O.size===0&&m.size===0&&v.size===0}e.areSame=A}),define(Z[20],ee([0,1,5,29,35,39,123,77,12,18,15]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function f(){const c=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=f;function y(){const c=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(p=>!!c[p].ignoreSync),u=Object.keys(c).filter(p=>c[p].scope===2||c[p].scope===6),d=f();return(0,v.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...u,...d])}e.getDefaultIgnoredSettings=y;function b(){const c="vscode://schemas/ignoredSettings",l=A.Registry.as(L.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=A.Registry.as(O.Extensions.JSONContribution),d=()=>{const p=f(),h=y().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(L.allSettings.properties).filter(B=>h.indexOf(B)===-1),_=h.filter(B=>p.indexOf(B)===-1),j={items:{type:"string",enum:[...P,..._.map(B=>`-${B}`)]}};u.registerSchema(c,j)};return l.onDidUpdateConfiguration(()=>d())}e.registerConfiguration=b;function o(c){return c&&(0,R.isObject)(c)&&(0,R.isString)(c.id)&&(0,R.isArray)(c.scopes)}e.isAuthenticationProvider=o;var E;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(E=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function w(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=w;var C;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class I extends Error{constructor(l,u,d,p){super(l);this.code=u,this.resource=d,this.operationId=p,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=I;class g extends I{constructor(l,u,d,p){super(l,d,void 0,p);this.url=u}}e.UserDataSyncStoreError=g;class s extends I{constructor(l,u){super(l,u)}}e.UserDataAutoSyncError=s,function(c){function l(u){if(u instanceof c)return u;const d=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(d&&d[1]){const p=d[2]==="unknown"?void 0:d[2],h=d[3]==="unknown"?void 0:d[3];return new c(u.message,d[1],p,h)}return new c(u.message,C.Unknown)}c.toUserDataSyncError=l}(I=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var t;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(c){return`sync.enable.${c}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,m.isEqualOrParent)(c,(0,m.joinPath)(l.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(Z[45],ee([0,1,2,10,22,4,20,9,12,6,3,25,32,119,24,15,21,18,44,19,30]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=r;function t(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}let i=class extends S.Disposable{constructor(u,d,p,h,P,_,j,B,M,$){super();this.resource=u,this.fileService=d,this.environmentService=p,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=j,this.telemetryService=B,this.logService=M,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new v.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new R.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,w.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(p.userDataSyncHome,1024)?m.extUri:m.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(u,p,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(p,d,h)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:p})=>p!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const d=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,d={}){await this._sync(u,!0,d)}async preview(u,d={}){return this._sync(u,!1,d)}async apply(u,d={}){try{this.syncHeaders=Object.assign({},d);const p=await this.doApply(u);return this.setStatus(p),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,d,p){try{if(this.syncHeaders=Object.assign({},p),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let h="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(u,P);return h=await this.performSync(_,P,d),h==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):h==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(h)}}finally{this.syncHeaders={}}}async replace(u){const d=await this.resolveContent(u);if(!d)return!1;const p=this.parseSyncData(d);if(!p)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const h=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,h),_=await this.generateSyncPreview({ref:P.ref,syncData:p},h,s.CancellationToken.None),j=[];for(const B of _){const M=await this.getAcceptResult(B,B.remoteResource,void 0,s.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,s.CancellationToken.None);j.push([B,Object.assign(Object.assign({},M),{remoteChange:$!==0?$:2})])}await this.applyResult(P,h,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(u,d){if(d){const p=u&&u.latest?u.latest[this.resource]:void 0;if(d.ref===p||p===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(u,d,p){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,u.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(u,d,p)}catch(h){if(h instanceof U.UserDataSyncError)switch(h.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,d,p);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(u,d,p)}throw h}}async doSync(u,d,p){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,v.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(u,d,p,P)));const h=await this.syncPreviewPromise;return this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":p?await this.doApply(!1):"syncing"}catch(h){throw this.syncPreviewPromise=null,h}}async merge(u){return await this.updateSyncResourcePreview(u,async d=>{const p=await this.getMergeResult(d,s.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString((p==null?void 0:p.content)||""));const h=p&&!p.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,s.CancellationToken.None):void 0;return d.acceptResult=h,d.mergeState=p.hasConflicts?"conflict":h?"accepted":"preview",d.localChange=h?h.localChange:p.localChange,d.remoteChange=h?h.remoteChange:p.remoteChange,d}),this.syncPreviewPromise}async accept(u,d){return await this.updateSyncResourcePreview(u,async p=>{const h=await this.getAcceptResult(p,u,d,s.CancellationToken.None);return p.acceptResult=h,p.mergeState="accepted",p.localChange=h.localChange,p.remoteChange=h.remoteChange,p}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async d=>{const p=await this.getMergeResult(d,s.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(p.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=p.localChange,d.remoteChange=p.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(u,d){if(!!this.syncPreviewPromise){let p=await this.syncPreviewPromise;const h=p.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:j})=>this.extUri.isEqual(P,u)||this.extUri.isEqual(_,u)||this.extUri.isEqual(j,u));h!==-1&&(this.syncPreviewPromise=(0,v.createCancelablePromise)(async P=>{const _=[...p.resourcePreviews];return _[h]=await d(_[h]),Object.assign(Object.assign({},p),{resourcePreviews:_})}),p=await this.syncPreviewPromise,this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(u){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(p=>[p,p.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const d=u.filter(({mergeState:p})=>p==="conflict");(0,C.equals)(this._conflicts,d,(p,h)=>this.extUri.isEqual(p.previewResource,h.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:p})=>({created:d,uri:this.toRemoteBackupResource(p)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:p})=>({created:d,uri:this.toLocalBackupResource(p)}))}toRemoteBackupResource(u){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const d=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(d))){const{content:p}=await this.getUserData(d);if(p){const h=this.parseSyncData(p);return h==null?void 0:h.machineId}}}async resolveContent(u){const d=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(d))){const{content:p}=await this.getUserData(d);return p}return this.extUri.isEqual(u,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(u){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const p of d.resourcePreviews){if(this.extUri.isEqual(p.acceptedResource,u))return p.acceptResult?p.acceptResult.content:null;if(this.extUri.isEqual(p.remoteResource,u))return p.remoteContent;if(this.extUri.isEqual(p.localResource,u))return p.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,d,p,h){var P;const _=await this.currentMachineIdPromise,j=!!((P=u.syncData)===null||P===void 0?void 0:P.machineId)&&u.syncData.machineId===_,B=d===null&&j&&!this.hasSyncResourceStateVersionChanged?u:d,M=await this.generateSyncPreview(u,B,h),$=[];for(const V of M){const q=V.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(V.localChange===0&&V.remoteChange===0)$.push(Object.assign(Object.assign({},V),{acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const H=p?await this.getMergeResult(V,h):void 0;if(h.isCancellationRequested)break;await this.fileService.writeFile(V.previewResource,A.VSBuffer.fromString((H==null?void 0:H.content)||""));const z=H&&!H.hasConflicts?await this.getAcceptResult(V,V.previewResource,void 0,h):void 0;$.push(Object.assign(Object.assign({},V),{acceptResult:z,mergeState:(H==null?void 0:H.hasConflicts)?"conflict":z?"accepted":"preview",localChange:z?z.localChange:H?H.localChange:V.localChange,remoteChange:z?z.remoteChange:H?H.remoteChange:V.remoteChange}))}}return{remoteUserData:u,lastSyncUserData:d,resourcePreviews:$,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(u.value.toString()),p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&p&&d.version!==p,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;const h=d;if(h.content===null)return{ref:d.ref,syncData:null};const P=JSON.parse(h.content);if(r(P))return Object.assign(Object.assign({},d),{syncData:P,content:void 0})}catch(u){u instanceof k.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),h=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:p},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(h)))}async getRemoteUserData(u){const{ref:d,content:p}=await this.getUserData(u);let h=null;return p!==null&&(h=this.parseSyncData(p)),{ref:d,syncData:h}}parseSyncData(u){try{const d=JSON.parse(u);if(r(d))return d}catch(d){this.logService.error(d)}throw new U.UserDataSyncError((0,b.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(u){if((0,E.isString)(u)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:d}}else{const d=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(u,d){const p=await this.currentMachineIdPromise,h={version:this.version,machineId:p,content:u};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(h),d,this.syncHeaders),{ref:d,syncData:h}}async backupLocal(u){const d={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=he([Y(1,k.IFileService),Y(2,O.IEnvironmentService),Y(3,g.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,f.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,o.IConfigurationService)],i),e.AbstractSynchroniser=i;let n=class extends i{constructor(u,d,p,h,P,_,j,B,M,$,V){super(d,p,h,P,_,j,B,M,$,V);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,d,p){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(u),p?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(u),{overwrite:p})}catch(h){throw h instanceof k.FileOperationError&&h.fileOperationResult===1||h instanceof k.FileOperationError&&h.fileOperationResult===3?new U.UserDataSyncError(h.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):h}}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=he([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,g.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,o.IConfigurationService)],n),e.AbstractFileSynchroniser=n;let a=class extends n{constructor(u,d,p,h,P,_,j,B,M,$,V,q){super(u,d,p,h,P,_,j,B,M,$,q);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(u){const d=[];return(0,y.parse)(u,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=he([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,g.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,o.IConfigurationService)],a),e.AbstractJsonFileSynchroniser=a;let c=class{constructor(u,d,p,h){this.resource=u,this.environmentService=d,this.logService=p,this.fileService=h,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?m.extUri:m.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,d,m.extUri)}async initialize({ref:u,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const p=this.parseSyncData(d);if(!!p){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:u,syncData:p})}catch(P){this.logService.error(P)}}}parseSyncData(u){try{const d=JSON.parse(u);if(r(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,d={}){const p=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}};c=he([Y(1,O.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,k.IFileService)],c),e.AbstractInitializer=c}),define(Z[180],ee([0,1,20,3,9,29,33,10,24,177,45,25,4,46,41,21,19,82,11,81,6]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function r(c,l){const u=JSON.parse(c.content);if(c.version===1||c.version===2){const d=(await l.getInstalled(0)).filter(p=>p.isBuiltin);for(const p of u)c.version===1&&(p.enabled===!1&&(p.disabled=!0),delete p.enabled),c.version===2&&d.every(h=>!(0,U.areSameExtensions)(h.identifier,p.identifier))&&(p.installed=!0)}return u}function t(c,l,u){const d=u.get((0,U.getExtensionId)(c,l),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function i(c,l,u,d){d.store((0,U.getExtensionId)(c,l),JSON.stringify(u),0,1)}e.storeExtensionStorageState=i;let n=class st extends R.AbstractSynchroniser{constructor(l,u,d,p,h,P,_,j,B,M,$,V,q,H){super("extensions",u,l,d,p,h,V,q,B,$);this.storageService=d,this.extensionManagementService=P,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=M,this.extensionsStorageSyncService=H,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,z=>!!z.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,z=>!z.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,u){const d=l.syncData?await r(l.syncData,this.extensionManagementService):null,p=(u==null?void 0:u.skippedExtensions)||[],h=(u==null?void 0:u.syncData)?await r(u.syncData,this.extensionManagementService):null,P=await this.extensionManagementService.getInstalled(),_=this.getLocalExtensions(P),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(P);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:B,removed:M,updated:$,remote:V}=(0,v.merge)(_,d,h,p,j),q={added:B,removed:M,updated:$,remote:V,content:this.getPreviewContent(_,B,$,M),localChange:B.length>0||M.length>0||$.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:p,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,u,d,p){const h=[...u,...d],P=new Set,_=j=>{P.add(j.id.toLowerCase()),j.uuid&&P.add(j.uuid)};h.forEach(({identifier:j})=>_(j)),p.forEach(_);for(const j of l)P.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&P.has(j.identifier.uuid)||h.push(j);return this.format(h)}async getMergeResult(l,u){return Object.assign(Object.assign({},l.previewResult),{hasConflicts:!1})}async getAcceptResult(l,u,d,p){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(l){const u=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),p=(0,v.merge)(l.localExtensions,null,null,l.skippedExtensions,d),{added:h,removed:P,updated:_,remote:j}=p;return{content:l.localContent,added:h,removed:P,updated:_,remote:j,localChange:h.length>0||P.length>0||_.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(l){const u=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),p=l.remoteContent?JSON.parse(l.remoteContent):null;if(p!==null){const h=(0,v.merge)(l.localExtensions,p,l.localExtensions,[],d),{added:P,removed:_,updated:j,remote:B}=h;return{content:l.remoteContent,added:P,removed:_,updated:j,remote:B,localChange:P.length>0||_.length>0||j.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:l.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(l,u,d,p){let{skippedExtensions:h,localExtensions:P}=d[0][0],{added:_,removed:j,updated:B,remote:M,localChange:$,remoteChange:V}=d[0][1];if($===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(P)),h=await this.updateLocalExtensions(_,j,B,h)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(M);l=await this.updateRemoteUserData(q,p?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(u==null?void 0:u.ref)!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:h}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:st.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,st.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),h=this.getLocalExtensions(d).filter(P=>!p.some(_=>(0,U.areSameExtensions)({id:_},P.identifier)));return this.format(h)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let u=await super.resolveContent(l);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(l)),u){const d=this.parseSyncData(u);if(d)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(l){l.sort((p,h)=>!p.identifier.uuid&&h.identifier.uuid?-1:p.identifier.uuid&&!h.identifier.uuid?1:(0,E.compare)(p.identifier.id,h.identifier.id));const u=JSON.stringify(l),d=(0,b.format)(u,void 0,{});return(0,o.applyEdits)(u,d)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(d=>d.installed||d.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,u,d,p){const h=[],P=[],_=await this.extensionManagementService.getInstalled();if(u.length){const B=_.filter(({identifier:M,isBuiltin:$})=>!$&&u.some(V=>(0,U.areSameExtensions)(M,V)));await s.Promises.settled(B.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),h.push(M.identifier)}))}(l.length||d.length)&&await s.Promises.settled([...l,...d].map(async B=>{const M=_.find(V=>(0,U.areSameExtensions)(V.identifier,B.identifier));if(M&&M.isBuiltin){B.state&&M.manifest.version===B.version&&this.updateExtensionState(B.state,M.manifest.publisher,M.manifest.name,M.manifest.version),B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id)),h.push(B.identifier);return}const $=await this.extensionGalleryService.getCompatibleExtension(B.identifier);if(B.state&&(M?M.manifest.version===B.version:!!$)){const V=M?M.manifest.publisher:$.publisher,q=M?M.manifest.name:$.name;this.updateExtensionState(B.state,V,q,M==null?void 0:M.manifest.version)}if($)try{B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id,$.version)),M||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,B.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,B.identifier.id,$.version),h.push($.identifier))}catch(V){P.push(B),this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else P.push(B)}));const j=[];for(const B of p)h.some(M=>(0,U.areSameExtensions)(M,B.identifier))||j.push(B);for(const B of P)j.some(M=>(0,U.areSameExtensions)(M.identifier,B.identifier))||j.push(B);return j}updateExtensionState(l,u,d,p){const h=t(u,d,this.storageService),P=p?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(u,d),version:p}):void 0;P?P.forEach(_=>{h[_]=l[_]}):Object.keys(l).forEach(_=>h[_]=l[_]),i(u,d,h,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const u=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:d,isBuiltin:p,manifest:h})=>{const P={identifier:d,version:h.version};u.some(_=>(0,U.areSameExtensions)(_,d))&&(P.disabled=!0),p||(P.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:h.version});if(_){const j=t(h.publisher,h.name,this.storageService);P.state=Object.keys(j).reduce((B,M)=>(_.includes(M)&&(B[M]=j[M]),B),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(_))}return P})}};n.EXTENSIONS_DATA_URI=y.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=he([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,w.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,L.IExtensionManagementService),Y(6,L.IGlobalExtensionEnablementService),Y(7,C.IIgnoredExtensionsManagementService),Y(8,S.IUserDataSyncLogService),Y(9,L.IExtensionGalleryService),Y(10,m.IConfigurationService),Y(11,S.IUserDataSyncResourceEnablementService),Y(12,f.ITelemetryService),Y(13,g.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let a=class extends R.AbstractInitializer{constructor(l,u,d,p,h){super("extensions",p,h,d);this.extensionManagementService=l,this.ignoredExtensionsManagementService=u}async parseExtensions(l){return l.syncData?await r(l.syncData,this.extensionManagementService):null}generatePreview(l,u){const d=[],p=[],h=[];for(const P of l)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(P.identifier.id)){const _=u.find(j=>(0,U.areSameExtensions)(j.identifier,P.identifier));_?(d.push(_),P.disabled&&h.push(P.identifier)):P.installed&&(p.push(P.identifier),P.disabled&&h.push(P.identifier))}return{installedExtensions:d,newExtensions:p,disabledExtensions:h,remoteExtensions:l}}};a=he([Y(0,L.IExtensionManagementService),Y(1,C.IIgnoredExtensionsManagementService),Y(2,O.IFileService),Y(3,A.IEnvironmentService),Y(4,S.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(Z[181],ee([0,1,26,20]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(O,m,v,R,f){if(!m)return{remote:Object.keys(O).length>0?O:null,local:{added:{},removed:[],updated:{}}};const y=L(O,m);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=v?L(v,m):{added:Object.keys(m).reduce((I,g)=>(I.add(g),I),new Set),removed:new Set,updated:new Set},o=v?L(v,O):{added:Object.keys(O).reduce((I,g)=>(I.add(g),I),new Set),removed:new Set,updated:new Set},E={added:{},removed:[],updated:{}},w=S.deepClone(m),C=!v;for(const I of o.added.values())I!==k.SYNC_SERVICE_URL_TYPE&&C&&b.added.has(I)||(w[I]=O[I]);for(const I of o.updated.values())w[I]=O[I];for(const I of o.removed.values())R.unregistered.includes(I)||delete w[I];for(const I of b.added.values()){const g=m[I];if(R.machine.includes(I)){f.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(!(v&&o.added.has(I))){const s=O[I];s&&s.value===g.value||I===k.SYNC_SERVICE_URL_TYPE&&C&&o.added.has(I)||(s?E.updated[I]=g:E.added[I]=g)}}for(const I of b.updated.values()){const g=m[I];if(R.machine.includes(I)){f.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(!(o.updated.has(I)||o.removed.has(I))){const s=O[I];s&&s.value===g.value||(E.updated[I]=g)}}for(const I of b.removed.values()){if(R.machine.includes(I)){f.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}o.updated.has(I)||o.removed.has(I)||E.removed.push(I)}return{local:E,remote:U(w,m)?null:w}}e.merge=A;function L(O,m){const v=Object.keys(O),R=Object.keys(m),f=R.filter(o=>v.indexOf(o)===-1).reduce((o,E)=>(o.add(E),o),new Set),y=v.filter(o=>R.indexOf(o)===-1).reduce((o,E)=>(o.add(E),o),new Set),b=new Set;for(const o of v)if(!y.has(o)){const E=O[o],w=m[o];S.equals(E,w)||b.add(o)}return{added:f,removed:y,updated:b}}function U(O,m){const{added:v,removed:R,updated:f}=L(O,m);return v.size===0&&R.size===0&&f.size===0}}),define(Z[182],ee([0,1,20,22,3,9,10,52,181,32,45,25,24,4,46,41,19,7,44,31,17]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(u){const d=u.storage?Object.keys(u.storage).sort():[],p={};d.forEach(_=>p[_]=u.storage[_]),u.storage=p;const h=JSON.stringify(u),P=(0,o.format)(h,void 0,{});return(0,E.applyEdits)(h,P)}const n=1;let a=class ot extends R.AbstractSynchroniser{constructor(d,p,h,P,_,j,B,M,$){super("globalState",d,_,$,p,h,j,B,P,M);this.storageService=$,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(d.onDidFilesChange,V=>V.contains(this.environmentService.argvResource)),A.Event.filter($.onDidChangeValue,V=>V.scope===0&&V.target!==void 0?V.target===0:$.keys(0,0).includes(V.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,p,h){const P=d.syncData?JSON.parse(d.syncData.content):null,_=p&&p.syncData?JSON.parse(p.syncData.content):null,j=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(_),{local:M,remote:$}=(0,m.merge)(j.storage,P?P.storage:null,_?_.storage:null,B,this.logService),V={content:null,local:M,remote:$,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:i(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:P?i(P):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(d,p){return Object.assign(Object.assign({},d.previewResult),{hasConflicts:!1})}async getAcceptResult(d,p,h,P){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(p,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const p=JSON.parse(d.remoteContent),{local:h,remote:P}=(0,m.merge)(d.localUserData.storage,p.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:h,remote:P,localChange:Object.keys(h.added).length>0||Object.keys(h.updated).length>0||h.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,p,h,P){let{localUserData:_}=h[0][0],{local:j,remote:B,localChange:M,remoteChange:$}=h[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const V=JSON.stringify({storage:B});d=await this.updateRemoteUserData(V,P?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(p==null?void 0:p.ref)!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const h=await this.getLocalGlobalState();return i(h)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let p=await super.resolveContent(d);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(d)),p){const h=this.parseSyncData(p);if(h)switch(this.extUri.basename(d)){case"globalState.json":return i(JSON.parse(h.content))}}return null}async hasLocalData(){var d;try{const{storage:p}=await this.getLocalGlobalState();if(Object.keys(p).length>1||((d=p[`${r}.locale`])===null||d===void 0?void 0:d.value)!=="en")return!0}catch(p){}return!1}async getLocalGlobalState(){const d={},p=await this.getLocalArgvContent(),h=(0,v.parse)(p);for(const P of t)h[P]!==void 0&&(d[`${r}${P}`]={version:1,value:h[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(d[P]={version:1,value:_})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:p,updated:h}){const P={},_={},j=(M,$)=>{for(const V of M){if(V.startsWith(r)){P[V.substring(r.length)]=$?$[V].value:void 0;continue}if($){const q=$[V];q.value!==String(this.storageService.get(V,0))&&(_[V]=q.value)}else this.storageService.get(V,0)!==void 0&&(_[V]=void 0)}};if(j(Object.keys(d),d),j(Object.keys(h),h),j(p),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(_))this.storageService.store(M,_[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(d){const p=await this.getLocalArgvContent();let h=p;for(const P of Object.keys(d))h=(0,O.edit)(h,[P],d[P],{});p!==h&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(h)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const p=this.storageService.keys(0,0),h=this.storageService.keys(0,1),P=[...p,...h],_=(d==null?void 0:d.storage)?Object.keys(d.storage).filter(j=>!j.startsWith(r)&&!P.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!C.isWeb){const j=[...S.ALL_SYNC_RESOURCES.map(B=>(0,S.getEnablementKey)(B)),S.SYNC_SERVICE_URL_TYPE];_.push(...j),h.push(...j)}return{user:p,machine:h,unregistered:_}}};a.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=he([Y(0,U.IFileService),Y(1,S.IUserDataSyncStoreService),Y(2,S.IUserDataSyncBackupStoreService),Y(3,S.IUserDataSyncLogService),Y(4,L.IEnvironmentService),Y(5,S.IUserDataSyncResourceEnablementService),Y(6,f.ITelemetryService),Y(7,y.IConfigurationService),Y(8,w.IStorageService)],a),e.GlobalStateSynchroniser=a;let c=class extends R.AbstractInitializer{constructor(d,p,h,P){super("globalState",h,P,p);this.storageService=d}async doInitialize(d){const p=d.syncData?JSON.parse(d.syncData.content):null;if(!p){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const h={},P={};for(const _ of Object.keys(p.storage))_.startsWith(r)?h[_.substring(r.length)]=p.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=p.storage[_].value);if(Object.keys(h).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(h))_=(0,O.edit)(_,[j],h[j],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};c=he([Y(0,w.IStorageService),Y(1,U.IFileService),Y(2,L.IEnvironmentService),Y(3,S.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(d,p,h,P,_){this.userDataSyncStoreClient=d,this.storageService=p,this.environmentService=h,this.fileService=P,this.logService=_}getSyncStoreType(d){var p;const h=this.parseGlobalState(d);return(p=h==null?void 0:h.storage[S.SYNC_SERVICE_URL_TYPE])===null||p===void 0?void 0:p.value}async sync(d){const p=(0,S.createSyncHeaders)((0,g.generateUuid)());try{return await this.doSync(d,p)}catch(h){if(h instanceof S.UserDataSyncError)switch(h.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,p)}throw h}}async doSync(d,p){const h=await this.userDataSyncStoreClient.read("globalState",null,p),P=this.parseGlobalState(h)||{storage:{}};P.storage[S.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const _=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),j={version:n,machineId:_,content:i(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),h.ref,p)}parseGlobalState({content:d}){if(!d)return null;const p=JSON.parse(d);if((0,R.isSyncData)(p))return p?JSON.parse(p.content):null;throw new Error("Invalid remote data")}};l=he([Y(1,w.IStorageService),Y(2,L.IEnvironmentService),Y(3,U.IFileService),Y(4,s.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[183],ee([0,1,10,20,178,32,120,9,24,7,15,18,45,25,19,22,3]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function C(s,r){const t=JSON.parse(s);if(!r)return(0,R.isUndefined)(t.all)?null:t.all;switch(v.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=C;let I=class extends y.AbstractJsonFileSynchroniser{constructor(r,t,i,n,a,c,l,u,d,p){super(l.keybindingsResource,"keybindings",c,l,u,r,t,a,p,i,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(w.Event.filter(n.onDidChangeConfiguration,h=>h.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i){const n=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null,a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let u=null,d=!1,p=!1,h=!1;if(n){let _=c?c.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new k.UserDataSyncError((0,U.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==_||a!==n){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,A.merge)(_,n,a,l,this.userDataSyncUtilService);j.hasChanges&&(u=j.mergeContent,h=j.hasConflicts,d=h||j.mergeContent!==_,p=h||j.mergeContent!==n)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=c.value.toString(),p=!0);const P={content:u,localChange:d?c?2:1:0,remoteChange:p?2:0,hasConflicts:h};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:n,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,n){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,n){var a;const{fileContent:c}=i[0][0];let{content:l,localChange:u,remoteChange:d}=i[0][1];if(u===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new k.UserDataSyncError((0,U.localize)(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(l||"[]",c,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const p=this.toSyncContent(l||"[]",(a=r.syncData)===null||a===void 0?void 0:a.content);r=await this.updateRemoteUserData(p,n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(p){}(t==null?void 0:t.ref)!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,L.parse)(r.value.toString());if((0,f.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(r.syncData.content)}getKeybindingsContentFromSyncContent(r){try{return C(r,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,v.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let r=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return r!==void 0||(r=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,r!==void 0)?r:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=he([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,m.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,S.IFileService),Y(6,O.IEnvironmentService),Y(7,o.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let g=class extends y.AbstractInitializer{constructor(r,t,i){super("keybindings",t,i,r)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,E.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,L.parse)(r.value.toString());return!(0,f.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return C(r,!0)}catch(t){return this.logService.error(t),null}}};g=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],g),e.KeybindingsInitializer=g}),define(Z[184],ee([0,1,26,32,41,46,52,20,18]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function v(l,u,d){let p=[];d?p=f(d):p=R(u);const h=[],P=[...(0,O.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const _ of p)_.startsWith("-")?P.push(_.substring(1)):h.push(_);return(0,m.distinct)([...l,...h].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=v;function R(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function f(l){const u=(0,k.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function y(l,u,d,p){if(d.length){const h=c(u),P=(0,k.parse)(u),_=(0,k.parse)(l),j=[];for(const B of d){const M=P[B],$=_[B];M===void 0?l=U.edit(l,[B],void 0,p):$!==void 0?l=U.edit(l,[B],M,p):j.push(r(B,h))}j.sort((B,M)=>B.startOffset-M.startOffset),j.forEach(B=>l=C(B.setting.key,u,l,p))}return l}e.updateIgnoredSettings=y;function b(l,u,d,p,h,P){const _=y(l,u,p,P),j=d!==_,B=d!==u;if(!j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(B&&!j)return{conflictsSettings:[],localContent:y(u,l,p,P),remoteContent:null,hasConflicts:!1};if(d===null&&E(l)){const ie=o(l,u,p)?null:y(u,l,p,P);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let M=l,$=u;const V=(0,k.parse)(l),q=(0,k.parse)(u),H=d?(0,k.parse)(d):null,z=p.reduce((ie,ce)=>(ie.add(ce),ie),new Set),D=w(V,q,z),T=w(H,V,z),F=w(H,q,z),N=new Map,x=new Set,G=ie=>{x.add(ie);const ce=h.filter(({key:ue})=>ue===ie)[0];ce?(M=U.edit(M,[ie],ce.value,P),$=U.edit($,[ie],ce.value,P)):N.set(ie,{key:ie,localValue:V[ie],remoteValue:q[ie]})};for(const ie of T.removed.values())F.updated.has(ie)?G(ie):$=U.edit($,[ie],void 0,P);for(const ie of F.removed.values())x.has(ie)||(T.updated.has(ie)?G(ie):M=U.edit(M,[ie],void 0,P));for(const ie of T.updated.values())x.has(ie)||(F.updated.has(ie)?D.updated.has(ie)&&G(ie):$=U.edit($,[ie],V[ie],P));for(const ie of F.updated.values())x.has(ie)||(T.updated.has(ie)?D.updated.has(ie)&&G(ie):M=U.edit(M,[ie],q[ie],P));for(const ie of T.added.values())x.has(ie)||(F.added.has(ie)?D.updated.has(ie)&&G(ie):$=C(ie,M,$,P));for(const ie of F.added.values())x.has(ie)||(T.added.has(ie)?D.updated.has(ie)&&G(ie):M=C(ie,$,M,P));const J=N.size>0||!o(M,$,p),Q=J||!o(M,l,[]),ne=J||!o($,u,[]);return{localContent:Q?M:null,remoteContent:ne?$:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=b;function o(l,u,d){if(l===u)return!0;const p=(0,k.parse)(l),h=(0,k.parse)(u),P=d.reduce((B,M)=>(B.add(M),B),new Set),_=c(l).filter(B=>!(B.setting&&P.has(B.setting.key))),j=c(u).filter(B=>!(B.setting&&P.has(B.setting.key)));if(_.length!==j.length)return!1;for(let B=0;B<_.length;B++){const M=_[B],$=j[B];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!S.equals(p[M.setting.key],h[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=o;function E(l){return l?c(l).length===0:!0}e.isEmpty=E;function w(l,u,d){const p=l?Object.keys(l).filter(B=>!d.has(B)):[],h=Object.keys(u).filter(B=>!d.has(B)),P=h.filter(B=>p.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),_=p.filter(B=>h.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),j=new Set;if(l){for(const B of p)if(!_.has(B)){const M=l[B],$=u[B];S.equals(M,$)||j.add(B)}}return{added:P,removed:_,updated:j}}function C(l,u,d,p){const h=(0,k.parse)(u),P=c(u),_=c(d),j=I(l,P,_);return g(d,l,h[l],j,_,p)}e.addSetting=C;function I(l,u,d){const p=u.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===l}),h=u[p-1];if(h){if(h.setting){const _=r(h.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!0}}else{const _=t(p,u);if(_){const j=r(_.setting.key,d);if(j){const B=i(d.indexOf(j),d),M=n(u,_,u[p]);if(B){const $=n(d,j,B),V=a(M,$);return V?{index:d.indexOf(V),insertAfter:!0}:{index:d.indexOf(B),insertAfter:!1}}else{const $=n(d,j,d[d.length-1]),V=a(M,$);return V?{index:d.indexOf(V),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const P=u[p+1];if(P)if(P.setting){const _=r(P.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!1}}else{const _=i(p,u);if(_){const j=r(_.setting.key,d);if(j){const B=t(d.indexOf(j),d),M=n(u,u[p],_);if(B){const $=n(d,B,j),V=a(M.reverse(),$.reverse());return V?{index:d.indexOf(V),insertAfter:!1}:{index:d.indexOf(B),insertAfter:!0}}else{const $=n(d,d[0],j),V=a(M.reverse(),$.reverse());return V?{index:d.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function g(l,u,d,p,h,P){let _;return p.index===-1?_=(0,A.setProperty)(l,[u],d,P):_=s(l,u,d,p,h,P).map(j=>(0,A.withFormatting)(l,j,P)[0]),(0,A.applyEdits)(l,_)}function s(l,u,d,p,h,P){var _;const j=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,B=(0,L.getEOL)(P,l),M=h[p.index];if(p.insertAfter){const $=[];if(M.setting)$.push({offset:M.endOffset,length:0,content:","+j});else{const V=i(p.index,h),q=t(p.index,h),H=(_=q==null?void 0:q.setting)===null||_===void 0?void 0:_.commaOffset;q&&H===void 0&&$.push({offset:q.endOffset,length:0,content:","});const z=H!==void 0&&H>M.endOffset;$.push({offset:z?H+1:M.endOffset,length:0,content:V?B+j+",":B+j})}return $}else{if(M.setting)return[{offset:M.startOffset,length:0,content:j+","}];const $=(h[p.index-1]&&!h[p.index-1].setting?B:"")+j+(i(p.index,h)?",":"")+B;return[{offset:M.startOffset,length:0,content:$}]}}function r(l,u){return u.filter(d=>{var p;return((p=d.setting)===null||p===void 0?void 0:p.key)===l})[0]}function t(l,u){for(let d=l-1;d>=0;d--)if(u[d].setting)return u[d]}function i(l,u){for(let d=l+1;d<u.length;d++)if(u[d].setting)return u[d]}function n(l,u,d){const p=l.indexOf(u),h=l.indexOf(d);return l.filter((P,_)=>p<_&&_<h)}function a(l,u){if(l.length&&u.length){let d=0;for(;d<u.length&&d<l.length;d++)if(l[d].value!==u[d].value)return u[d-1];return u[d-1]}}function c(l){const u=[];let d=-1,p,h;const P={onObjectBegin:_=>{d++},onObjectProperty:(_,j,B)=>{d===0&&(p=j,h=_)},onObjectEnd:(_,j)=>{d--,d===0&&u.push({startOffset:p,endOffset:_+j,value:l.substring(p,_+j),setting:{key:h,commaOffset:void 0}})},onArrayBegin:(_,j)=>{d++},onArrayEnd:(_,j)=>{d--,d===0&&u.push({startOffset:p,endOffset:_+j,value:l.substring(p,_+j),setting:{key:h,commaOffset:void 0}})},onLiteralValue:(_,j,B)=>{d===0&&u.push({startOffset:p,endOffset:j+B,value:l.substring(p,j+B),setting:{key:h,commaOffset:void 0}})},onSeparator:(_,j,B)=>{if(d===0&&_===","){let M=u.length-1;for(;M>=0&&!u[M].setting;M--);const $=u[M];$&&u.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:j}})}},onComment:(_,j)=>{d===0&&u.push({startOffset:_,endOffset:_+j,value:l.substring(_,_+j)})}};return(0,k.visit)(l,P),u}}),define(Z[185],ee([0,1,10,20,22,121,3,9,24,184,52,45,25,29,19,41]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function w(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function C(r){const t=JSON.parse(r);return w(t)?t:{settings:r}}e.parseSettingsSyncContent=C;let I=class extends f.AbstractJsonFileSynchroniser{constructor(t,i,n,a,c,l,u,d,p,h,P){super(i.settingsResource,"settings",t,i,n,a,c,p,h,l,u,d);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,n){const a=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),u=i?this.getSettingsSyncContent(i):null,d=await this.getIgnoredSettings();let p=null,h=!1,P=!1,_=!1;if(l){let B=a?a.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,v.merge)(B,l.settings,u?u.settings:null,d,[],c);p=M.localContent||M.remoteContent,h=M.localContent!==null,P=M.remoteContent!==null,_=M.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),p=a.value.toString(),P=!0);const j={content:p,localChange:h?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const n=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",a,n):null})}async getAcceptResult(t,i,n,a){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,v.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,n,a){const{fileContent:c}=n[0][0];let{content:l,localChange:u,remoteChange:d}=n[0][1];if(u===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const p=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(l);l=(0,v.updateIgnoredSettings)(l,h?h.settings:"{}",P,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(p){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),n=(0,R.edit)(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,v.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const n=this.parseSyncData(i);if(n){const a=this.parseSettingsSyncContent(n.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const n=await this.getFormattingOptions(),a=await this.getIgnoredSettings();i=(0,v.updateIgnoredSettings)(i,"{}",a,n)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return C(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,a=>!!a.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError((0,L.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!s(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(i.content);if(!n||!n.settings)return;let a=n.settings;const c=await this.getFormattingOptions();for(const l in i)if(["version","content","machineId"].indexOf(l)===-1&&i[l]!==void 0){const u=(0,E.setProperty)(a,[l],i[l],c);u.length&&(a=(0,E.applyEdits)(a,u))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(a))}catch(t){}}};I=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,o.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,m.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,y.ITelemetryService),Y(10,b.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let g=class extends f.AbstractInitializer{constructor(t,i,n){super("settings",i,n,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return C(t)}catch(i){this.logService.error(i)}return null}};g=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],g),e.SettingsInitializer=g;function s(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&r.machineId!==void 0&&typeof r.machineId=="string")}}),define(Z[186],ee([0,1,20,9,10,24,45,25,22,179,19,26,3]),function(K,e,S,k,A,L,U,O,m,v,R,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends U.AbstractSynchroniser{constructor(w,C,I,g,s,r,t,i,n){super("snippets",C,w,I,g,s,i,n,r,t);this.version=1,this.snippetsFolder=w.snippetsHome,this._register(this.fileService.watch(w.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(y.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(w,C,I){const g=await this.getSnippetsFileContents(),s=this.toSnippetsContents(g),r=w.syncData?this.parseSnippets(w.syncData):null,t=C&&C.syncData?this.parseSnippets(C.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(s,r,t);return this.getResourcePreviews(i,g,r||{})}async getMergeResult(w,C){return w.previewResult}async getAcceptResult(w,C,I,g){if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:w.fileContent?w.fileContent.value.toString():null,localChange:0,remoteChange:w.fileContent?w.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:w.remoteContent,localChange:w.remoteContent!==null?w.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder))return I===void 0?{content:w.previewResult.content,localChange:w.previewResult.localChange,remoteChange:w.previewResult.remoteChange}:{content:I,localChange:I===null?w.fileContent!==null?3:0:2,remoteChange:I===null?w.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async applyResult(w,C,I,g){const s=I.map(([r,t])=>Object.assign(Object.assign({},r),{acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,g)),s.some(({remoteChange:r})=>r!==0)&&(w=await this.updateRemoteSnippets(s,w,g)),(C==null?void 0:C.ref)!==w.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(w),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch(t){}}getResourcePreviews(w,C,I){const g=new Map;for(const s of Object.keys(w.local.added)){const r={content:w.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};g.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(w.local.updated)){const r={content:w.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of w.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(w.remote.added)){const r={content:w.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(w.remote.updated)){const r={content:w.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of w.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of w.conflicts){const r={content:C[s]?C[s].value.toString():null,hasConflicts:!0,localChange:C[s]?2:1,remoteChange:I[s]?2:1};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s]||null,localContent:C[s]?C[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(C))if(!g.has(s)){const r={content:C[s]?C[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s]||null,localContent:C[s]?C[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:w}){let C=await super.resolveContent(w);if(C){const I=this.parseSyncData(C);if(I){const g=this.parseSnippets(I),s=[];for(const r of Object.keys(g)){const t=this.extUri.joinPath(w,r),i=this.extUri.joinPath(this.snippetsFolder,r),n=await this.fileService.exists(i);s.push({resource:t,comparableResource:n?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(w){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(w);let C=await super.resolveContent(w);if(C)return C;if(C=await super.resolveContent(this.extUri.dirname(w)),C){const I=this.parseSyncData(C);if(I)return this.parseSnippets(I)[this.extUri.basename(w)]||null}return null}async hasLocalData(){try{const w=await this.getSnippetsFileContents();if(Object.keys(w).length)return!0}catch(w){}return!1}async updateLocalBackup(w){const C={};for(const I of w)I.fileContent&&(C[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(C)))}async updateLocalSnippets(w,C){for(const{fileContent:I,acceptResult:g,localResource:s,remoteResource:r,localChange:t}of w)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),n=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,m.VSBuffer.fromString(g.content),{overwrite:C}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,m.VSBuffer.fromString(g.content),C?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(w,C,I){const g=C.syncData?this.parseSnippets(C.syncData):{},s=(0,f.deepClone)(g);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:n}of w)if(n!==0){const a=t?this.extUri.basename(t):this.extUri.basename(i);n===3?delete s[a]:s[a]=r.content}return(0,v.areSame)(g,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),C=await this.updateRemoteUserData(JSON.stringify(s),I?null:C.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),C}parseSnippets(w){return JSON.parse(w.content)}toSnippetsContents(w){const C={};for(const I of Object.keys(w))C[I]=w[I].value.toString();return C}async getSnippetsFileContents(){const w={};let C;try{C=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof A.FileOperationError&&I.fileOperationResult===1)return w;throw I}for(const I of C.children||[]){const g=I.resource,s=this.extUri.extname(g);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,g),t=await this.fileService.readFile(g);w[r]=t}}return w}};b=he([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,L.IConfigurationService),Y(7,S.IUserDataSyncResourceEnablementService),Y(8,O.ITelemetryService)],b),e.SnippetsSynchroniser=b;let o=class extends U.AbstractInitializer{constructor(w,C,I){super("snippets",C,I,w)}async doInitialize(w){const C=w.syncData?JSON.parse(w.syncData.content):null;if(!C){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(C)){const s=C[g];if(s){const r=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(r,m.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(w)}async isEmpty(){var w;try{return!((w=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||w===void 0?void 0:w.length)}catch(C){return C.fileOperationResult===1}}};o=he([Y(0,A.IFileService),Y(1,k.IEnvironmentService),Y(2,S.IUserDataSyncLogService)],o),e.SnippetsInitializer=o}),define(Z[59],ee([0,1,5,3,2,20]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let U=class extends A.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};U=he([Y(0,L.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[187],ee([0,1,2,20,12,24,10,9,54,22,6]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let f=class extends S.Disposable{constructor(b,o,E,w){super();this.environmentService=b,this.fileService=o,this.configurationService=E,this.logService=w,k.ALL_SYNC_RESOURCES.forEach(C=>this.cleanUpBackup(C))}async getAllRefs(b){const o=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),E=await this.fileService.resolve(o);return E.children?E.children.filter(C=>C.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(C.name)).sort().reverse().map(C=>({ref:C.name,created:this.getCreationTime(C)})):[]}async resolveContent(b,o){if(!o){const E=await this.getAllRefs(b);E.length&&(o=E[E.length-1].ref)}if(o){const E=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,o);return(await this.fileService.readFile(E)).value.toString()}return null}async backup(b,o){const E=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),w=(0,A.joinPath)(E,`${(0,m.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(w,v.VSBuffer.fromString(o))}catch(C){this.logService.error(C)}try{this.cleanUpBackup(b)}catch(C){}}async cleanUpBackup(b){const o=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(o))return}catch(w){return}const E=await this.fileService.resolve(o);if(E.children){const w=E.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),C=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=w.filter(s=>Date.now()-this.getCreationTime(s)>C);const g=w.length-I.length;g<10&&(I=I.slice(10-g)),await R.Promises.settled(I.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};f=he([Y(0,O.IEnvironmentService),Y(1,U.IFileService),Y(2,L.IConfigurationService),Y(3,k.IUserDataSyncLogService)],f),e.UserDataSyncBackupStoreService=f}),define(Z[188],ee([0,1,4,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(y){this.service=y}listen(y,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(y,b,o){switch(b){case"triggerSync":return this.service.triggerSync(o[0],o[1],o[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(o[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class L{constructor(y){this.service=y}listen(y,b){throw new Error(`Event not found: ${b}`)}call(y,b,o){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(o[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(o[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class U{constructor(y){this.channel=y}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.channel.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.channel.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=U;class O{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(y,b,o){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(o[0],o[1]);case"setEnablement":return this.service.setEnablement(o[0],o[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=O;class m{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(y,b,o){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(o)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class v{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(y,b,o){switch(b){case"switch":return this.service.switch(o[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class R extends k.Disposable{constructor(y){super();this.channel=y,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.channel.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(y)}revive(y){return{url:S.URI.revive(y.url),type:y.type,defaultUrl:S.URI.revive(y.defaultUrl),insidersUrl:S.URI.revive(y.insidersUrl),stableUrl:S.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(Z[189],ee([0,1,17,9]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends S.AbstractLogger{constructor(U,O){super();this.logger=this._register(U.createLogger(O.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...O){this.logger.trace(U,...O)}debug(U,...O){this.logger.debug(U,...O)}info(U,...O){this.logger.info(U,...O)}warn(U,...O){this.logger.warn(U,...O)}error(U,...O){this.logger.error(U,...O)}critical(U,...O){this.logger.critical(U,...O)}flush(){this.logger.flush()}};A=he([Y(0,S.ILoggerService),Y(1,k.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,5,2,44,9,10,19,20,124,28,7,21,3]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const o="sync.currentMachineName";let E=class He extends k.Disposable{constructor(C,I,g,s,r,t){super();this.storageService=g,this.userDataSyncStoreService=s,this.logService=r,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(C,I,g)}async getMachines(C){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(C)).machines.map(s=>Object.assign(Object.assign({},s),{isCurrent:s.id===I}))}async addCurrentMachine(C){const I=await this.currentMachineIdPromise,g=await this.readMachinesData(C);g.machines.some(({id:s})=>s===I)||(g.machines.push({id:I,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(C){const I=await this.currentMachineIdPromise,g=await this.readMachinesData(C),s=g.machines.filter(({id:r})=>r!==I);s.length!==g.machines.length&&(g.machines=s,await this.writeMachinesData(g))}async renameMachine(C,I,g){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(g),t=r.machines.find(({id:i})=>i===C);t&&(t.name=I,await this.writeMachinesData(r),r.machines.some(({id:i})=>i===s)&&this.storageService.store(o,I,0,1))}async setEnablement(C,I){const g=await this.readMachinesData(),s=g.machines.find(({id:r})=>r===C);s&&(s.disabled=I?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(C){const I=this.storageService.get(o,0);if(I)return I;const g=`${this.productService.nameLong} (${(0,f.PlatformToString)(f.isWeb?0:f.platform)})`,s=new RegExp(`${(0,y.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let r=0;for(const t of C){const i=s.exec(t.name),n=i?parseInt(i[1]):0;r=n>r?n:r}return`${g} #${r+1}`}async readMachinesData(C){this.userData=await this.readUserData(C);const I=this.parse(this.userData);if(I.version!==He.VERSION)throw new Error((0,v.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(C){var I;const g=JSON.stringify(C),s=await this.userDataSyncStoreService.write(He.RESOURCE,g,((I=this.userData)===null||I===void 0?void 0:I.ref)||null);this.userData={ref:s,content:g},this._onDidChange.fire()}async readUserData(C){if(this.userData){const I=C&&C.latest?C.latest[He.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(He.RESOURCE,this.userData)}parse(C){if(C.content!==null)try{return JSON.parse(C.content)}catch(I){this.logService.error(I)}return{version:He.VERSION,machines:[]}}};E.VERSION=1,E.RESOURCE="machines",E=he([Y(0,L.IEnvironmentService),Y(1,U.IFileService),Y(2,O.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncLogService),Y(5,R.IProductService)],E),e.UserDataSyncMachinesService=E}),define(Z[83],ee([0,1,6,3,2,20,59,25,11,19,9,60,122,54,4,12,7,28]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",g="sync.disableMachineEventually",s="sync.sessionId",r="sync.storeUrl",t="sync.productQuality";let i=class extends A.Disposable{constructor(l,u,d){super();this.storageService=l,this.environmentService=u,this.userDataSyncStoreManagementService=d,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(p=>this.onDidStorageChange(p)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(I,l,0,1)}onDidStorageChange(l){if(l.scope===0&&I===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Y(0,v.IStorageService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let n=class extends A.Disposable{constructor(l,u,d,p,h,P,_,j,B,M,$){var V;super();this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=d,this.userDataSyncResourceEnablementService=p,this.userDataSyncService=h,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=j,this.userDataSyncMachinesService=B,this.storageService=M,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=$,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(V=u.userDataSyncStore)===null||V===void 0?void 0:V.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(u.onDidChangeUserDataSyncStore(()=>{var q,H;(0,E.isEqual)(this.syncUrl,(q=u.userDataSyncStore)===null||q===void 0?void 0:q.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=u.userDataSyncStore)===null||H===void 0?void 0:H.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(d.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(h.onDidChangeLocal,(q,H)=>q?[...q,H]:[H],1e3)(q=>this.triggerSync(q,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,q])=>q)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(r,0);return l?o.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(r,l.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:u}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(d=>this.onDidFinishSync(d))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(u&&this.logService.info(u),this.autoSync.clear()):u&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(u))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,b.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,u,d){try{this.userDataSyncAccountService.account&&!d&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(p){if(u)this.logService.error(p),this.updateEnablement(!1);else throw p}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(I,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const u=L.UserDataSyncError.toUserDataSyncError(l);u instanceof L.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:u.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),u.code===L.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):u.code===L.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):u.code===L.UserDataSyncErrorCode.LocalTooManyRequests||u.code===L.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):u.code===L.UserDataSyncErrorCode.UpgradeRequired||u.code===L.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):u.code===L.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with newer version than of client. Requires client upgrade.`)):u.code===L.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with older version than of client. Requires server reset.`)):u.code===L.UserDataSyncErrorCode.ServiceChanged||u.code===L.UserDataSyncErrorCode.DefaultServiceChanged?w.isWeb&&u.code===L.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(u),this.successiveFailures++),this._onError.fire(u)}async disableMachineEventually(){this.storageService.store(g,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,0,!1)}stopDisableMachineEventually(){this.storageService.remove(g,0)}async triggerSync(l,u,d){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(u&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",d)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=he([Y(0,C.IProductService),Y(1,L.IUserDataSyncStoreManagementService),Y(2,L.IUserDataSyncStoreService),Y(3,L.IUserDataSyncResourceEnablementService),Y(4,L.IUserDataSyncService),Y(5,L.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,O.ITelemetryService),Y(8,f.IUserDataSyncMachinesService),Y(9,v.IStorageService),Y(10,L.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class a extends A.Disposable{constructor(l,u,d,p,h,P,_,j){super();this.lastSyncUrl=l,this.interval=u,this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=p,this.userDataSyncService=h,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=j,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(l,u){const d=(0,S.createCancelablePromise)(async p=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,m.isPromiseCanceledError)(h))return}return this.doSync(l,u,p)});return this.syncPromise=d,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),u=this.userDataSyncStoreManagementService.userDataSyncStore;return!!u&&!!l&&(!(0,E.isEqual)(u.defaultUrl,l.defaultUrl)||!(0,E.isEqual)(u.insidersUrl,l.insidersUrl)||!(0,E.isEqual)(u.stableUrl,l.stableUrl))}async doSync(l,u,d){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let p;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(u),d.isCancellationRequested)return;let h=this.syncTask.manifest;if(h===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(0,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(1,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(2,null),L.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(s,0);if(P&&h&&P!==h.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(3,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(4,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(5,null),L.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(h||void 0);if(d.isCancellationRequested)return;const j=_.find(B=>B.isCurrent);if(j==null?void 0:j.disabled)throw new L.UserDataAutoSyncError((0,y.localize)(6,null),L.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),h===null&&(h=await this.userDataSyncStoreService.manifest()),h&&h.session!==P&&this.storageService.store(s,h.session,0,1),d.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(h||void 0)}catch(h){this.logService.error(h),p=h}this._onDidFinishSync.fire(p)}register(l){return super._register(l)}}a.INTERVAL_SYNCING="Interval"}),define(Z[190],ee([0,1,20,2,3,19,25,7]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends k.Disposable{constructor(R,f){super();this.storageService=R,this.telemetryService=f,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(R.onDidChangeValue(y=>this.onDidStorageChange(y)))}isResourceEnabled(R){return this.storageService.getBoolean((0,S.getEnablementKey)(R),0,!0)}setResourceEnablement(R,f){if(this.isResourceEnabled(R)!==f){const y=(0,S.getEnablementKey)(R);this.telemetryService.publicLog2(y,{enabled:f}),this.storeResourceEnablement(y,f)}}getResourceSyncStateVersion(R){}storeResourceEnablement(R,f){this.storageService.store(R,f,0,O.isWeb?0:1)}onDidStorageChange(R){if(R.scope===0){const f=S.ALL_SYNC_RESOURCES.filter(y=>(0,S.getEnablementKey)(y)===R.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}}};m=he([Y(0,L.IStorageService),Y(1,U.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(Z[191],ee([0,1,20,2,5,3,180,183,182,43,25,18,19,185,12,186,31,6,11]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const g="sync.lastSyncTime";let s=class extends k.Disposable{constructor(n,a,c,l,u,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=a,this.instantiationService=c,this.logService=l,this.telemetryService=u,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(O.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(E.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(m.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(p=>L.Event.map(p.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(p=>L.Event.map(p.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(g,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(p=>L.Event.map(p.onDidChangeLocal,()=>p.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n){await this.checkEnablement();const a=(0,w.generateUuid)();let c;try{const p=(0,S.createSyncHeaders)(a);n&&(p["Cache-Control"]="no-cache"),c=await this.userDataSyncStoreService.manifest(p)}catch(p){const h=S.UserDataSyncError.toUserDataSyncError(p);throw this.reportUserDataSyncError(h,a),h}let l=!1;const u=this;let d;return{manifest:c,run(){if(l)throw new Error("Can run a task only once");return d=(0,C.createCancelablePromise)(p=>u.sync(c,a,p)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,w.generateUuid)(),a=(0,S.createSyncHeaders)(n);let c;try{c=await this.userDataSyncStoreService.manifest(a)}catch(l){const u=S.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(u,n),u}return new r(n,c,a,this.synchronisers,this.logService)}async sync(n,a,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!c.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,S.createSyncHeaders)(a);for(const d of this.synchronisers){if(c.isCancellationRequested)return;try{await d.sync(n,u)}catch(p){if(p instanceof S.UserDataSyncError)switch(p.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(p.message,p.code,d.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw p}const h=S.UserDataSyncError.toUserDataSyncError(p);this.reportUserDataSyncError(h,a),this.logService.error(p),this.logService.error(`${d.resource}: ${(0,v.toErrorMessage)(p)}`),this._syncErrors.push([d.resource,h])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(u){const d=S.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,a),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(a){this.logService.error(a)}}async replace(n){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(n))return}async accept(n,a,c,l){await this.checkEnablement();const u=this.getSynchroniser(n);await u.accept(a,c),l&&await u.apply(!1,(0,S.createSyncHeaders)((0,w.generateUuid)()))}async resolveContent(n){for(const a of this.synchronisers){const c=await a.resolveContent(n);if(c)return c}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,a){return this.getSynchroniser(n).getAssociatedResources(a)}getMachineId(n,a){return this.getSynchroniser(n).getMachineId(a)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of n)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(g,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(a){this.logService.error(`${n.resource}: ${(0,v.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const a=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,f.equals)(this._conflicts,n,([a,c],[l,u])=>a===a&&(0,f.equals)(c,u,(d,p)=>(0,o.isEqual)(d.previewResource,p.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(g,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,a){this.telemetryService.publicLog2("sync/error",{code:n.code,url:n instanceof S.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(a=>a.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=he([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,S.IUserDataSyncLogService),Y(4,R.ITelemetryService),Y(5,y.IStorageService)],s),e.UserDataSyncService=s;class r extends k.Disposable{constructor(n,a,c,l,u){super();this.id=n,this.manifest=a,this.syncHeaders=c,this.synchronisers=l,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,C.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,a){try{return await this.performAction(n,c=>c.accept(n,a))}catch(c){throw this.logService.error(c),c}}async merge(n){try{return n?await this.performAction(n,a=>a.merge(n)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(n){try{return await this.performAction(n,a=>a.discard(n))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,a]of this.previews)for(const c of a.resourcePreviews)c.mergeState==="conflict"&&n.push(c.previewResource);for(const a of n)await this.discard(a);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[a,c]of this.previews){this.synchronizingResources.push([a,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===a);for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const u=await l.apply(!1,this.syncHeaders);u&&n.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,a]of this.previews){this.synchronizingResources.push([n,a.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of a.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,a]of this.previews){this.synchronizingResources.push([n,a.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of a.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(a){(0,I.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(n,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:B,previewResource:M,remoteResource:$})=>(0,o.isEqual)(n,B)||(0,o.isEqual)(n,M)||(0,o.isEqual)(n,$)));if(c===-1)return this.previews;const[l,u]=this.previews[c],d=u.resourcePreviews.find(({localResource:j,remoteResource:B,previewResource:M})=>(0,o.isEqual)(j,n)||(0,o.isEqual)(B,n)||(0,o.isEqual)(M,n));if(!d)return this.previews;let p=this.synchronizingResources.find(j=>j[0]===l);p||(p=[l,[]],this.synchronizingResources.push(p)),p[1].some(j=>(0,o.isEqual)(j,d.localResource))||(p[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const h=this.synchronisers.find(j=>j.resource===this.previews[c][0]),P=await a(h);P?this.previews.splice(c,1,this.toSyncResourcePreview(h.resource,P)):this.previews.splice(c,1);const _=this.synchronizingResources.findIndex(j=>j[0]===l);return this.synchronizingResources[_][1].splice(p[1].findIndex(j=>(0,o.isEqual)(j,d.localResource)),1),p[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[a,c]of this.previews){this.synchronizingResources.push([a,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===a);let u=c;for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(u=await l.merge(d.previewResource));u&&n.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const a=[];for(const c of this.synchronisers){if(n.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&a.push(this.toSyncResourcePreview(c.resource,l))}return a}toSyncResourcePreview(n,a){return[n,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[192],ee([0,1,3,20,4,2,15]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class O{constructor(f,y){this.service=f,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(f,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(f,y,b){try{return await this._call(f,y,b)}catch(o){throw this.logService.error(o),o}}async _call(f,y,b){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],A.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const o=y.substring("manualSync/".length),E=b[0],w=this.getManualSyncTask(E);switch(b=b.slice(1),o){case"preview":return w.preview();case"accept":return w.accept(A.URI.revive(b[0]),b[1]);case"merge":return w.merge(A.URI.revive(b[0]));case"discard":return w.discard(A.URI.revive(b[0]));case"discardConflicts":return w.discardConflicts();case"apply":return w.apply();case"pull":return w.pull();case"push":return w.push();case"stop":return w.stop();case"_getStatus":return w.status;case"dispose":return this.disposeManualSyncTask(w)}}throw new Error("Invalid call")}getManualSyncTask(f){const y=this.manualSyncTasks.get(this.createKey(f));if(!y)throw new Error(`Manual sync taks not found: ${f}`);return y.manualSyncTask}async createManualSyncTask(){const f=new L.DisposableStore,y=f.add(await this.service.createManualSyncTask());return f.add(y.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:b}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:f}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(f){var y;f.dispose();const b=this.createKey(f.id);(y=this.manualSyncTasks.get(b))===null||y===void 0||y.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=O;class m extends L.Disposable{constructor(f){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,b,o){return f.call(y,b,o).then(null,E=>{throw k.UserDataSyncError.toUserDataSyncError(E)})},listen(y,b){return f.listen(y,b)}},this.channel.call("_getInitialData").then(([y,b,o])=>{this.updateStatus(y),this.updateConflicts(b),o&&this.updateLastSyncTime(o),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([b,o])=>[b,k.UserDataSyncError.toUserDataSyncError(o)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:f,manifest:y,status:b}=await this.channel.call("createManualSyncTask"),o=this,E=new v(f,y,b,{async call(w,C,I){return o.channel.call(`manualSync/${w}`,[f,...(0,U.isArray)(C)?C:[C]],I)},listen(w,C){return S.Event.map(S.Event.filter(o.channel.listen(`manualSync/${w}`,C),I=>!E.isDiposed()&&I.manualSyncTaskId===f),I=>I.data)}});return E}replace(f){return this.channel.call("replace",[f])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,y,b,o){return this.channel.call("accept",[f,y,b,o])}resolveContent(f){return this.channel.call("resolveContent",[f])}async getLocalSyncResourceHandles(f){return(await this.channel.call("getLocalSyncResourceHandles",[f])).map(({created:b,uri:o})=>({created:b,uri:A.URI.revive(o)}))}async getRemoteSyncResourceHandles(f){return(await this.channel.call("getRemoteSyncResourceHandles",[f])).map(({created:b,uri:o})=>({created:b,uri:A.URI.revive(o)}))}async getAssociatedResources(f,y){return(await this.channel.call("getAssociatedResources",[f,y])).map(({resource:o,comparableResource:E})=>({resource:A.URI.revive(o),comparableResource:A.URI.revive(E)}))}async getMachineId(f,y){return this.channel.call("getMachineId",[f,y])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(([y,b])=>[y,b.map(o=>Object.assign(Object.assign({},o),{localResource:A.URI.revive(o.localResource),remoteResource:A.URI.revive(o.remoteResource),previewResource:A.URI.revive(o.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}}e.UserDataSyncChannelClient=m;class v extends L.Disposable{constructor(f,y,b,o){super();this.id=f,this.manifest=y,this._disposed=!1,this._status=b;const E=this;this.channel={async call(w,C,I){try{const g=await o.call(w,C,I);return E.isDiposed()||(E._status=await o.call("_getStatus")),g}catch(g){throw k.UserDataSyncError.toUserDataSyncError(g)}},listen(w,C){return o.listen(w,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const f=await this.channel.call("preview");return this.deserializePreviews(f)}async accept(f,y){const b=await this.channel.call("accept",[f,y]);return this.deserializePreviews(b)}async merge(f){const y=await this.channel.call("merge",[f]);return this.deserializePreviews(y)}async discard(f){const y=await this.channel.call("discard",[f]);return this.deserializePreviews(y)}async discardConflicts(){const f=await this.channel.call("discardConflicts");return this.deserializePreviews(f)}async apply(){const f=await this.channel.call("apply");return this.deserializePreviews(f)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(f){return f.map(([y,b])=>[y,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(o=>Object.assign(Object.assign({},o),{localResource:A.URI.revive(o.localResource),remoteResource:A.URI.revive(o.remoteResource),previewResource:A.URI.revive(o.previewResource),acceptedResource:A.URI.revive(o.acceptedResource)}))}])}}}),define(Z[193],ee([0,1,2,20,40,12,30,24,28,44,9,10,19,31,7,3,6,15,4,11]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",r="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",n=100,a=1e3*60*5;let c=class extends S.Disposable{constructor(P,_,j){super();this.productService=P,this.configurationService=_,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new E.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(E.Event.filter(j.onDidChangeValue,B=>{var M;return B.key===k.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((M=this.userDataSyncStore)===null||M===void 0?void 0:M.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,P,0,o.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=o.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const j=Object.assign(Object.assign({},P||{}),_||{});if(j&&(0,C.isString)(j.url)&&(0,C.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(B=>(0,C.isArray)(j.authenticationProviders[B].scopes))){const B=j,M=!!B.canSwitch&&!(_==null?void 0:_.url),$=B.url===B.insidersUrl?"insiders":"stable",V=(M?this.userDataSyncStoreType:void 0)||$,q=(_==null?void 0:_.url)||(V==="insiders"?B.insidersUrl:V==="stable"?B.stableUrl:B.url);return{url:I.URI.parse(q),type:V,defaultType:$,defaultUrl:I.URI.parse(B.url),stableUrl:I.URI.parse(B.stableUrl),insidersUrl:I.URI.parse(B.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(B.authenticationProviders).reduce((H,z)=>(H.push({id:z,scopes:B.authenticationProviders[z].scopes}),H),[])}}}};c=he([Y(0,m.IProductService),Y(1,O.IConfigurationService),Y(2,y.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(P,_,j){super(P,_,j);const B=this.storageService.get(s,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const M=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(s,JSON.stringify(M),0,1):this.storageService.remove(s,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=he([Y(0,m.IProductService),Y(1,O.IConfigurationService),Y(2,y.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let u=class extends S.Disposable{constructor(P,_,j,B,M,$,V){super();this.requestService=j,this.logService=B,this.storageService=V,this._onTokenFailed=this._register(new E.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new E.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new E.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,v.getServiceMachineId)(M,$,V).then(q=>{const H={"X-Client-Name":`${_.applicationName}${o.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":q};return _.commit&&(H["X-Client-Commit"]=_.commit),H}),this.session=new p(n,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,L.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(r,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,w.createCancelablePromise)(j=>(0,w.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),j).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,j=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P),j={},B=await this.request(_.toString(),{type:"GET",headers:j},[],U.CancellationToken.None);return(await(0,A.asJson)(B)||[]).map(({url:$,created:V})=>({ref:(0,L.relativePath)(_,_.with({path:$})),created:V*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),B={};B["Cache-Control"]="no-cache";const M=await this.request(j,{type:"GET",headers:B},[],U.CancellationToken.None);return await(0,A.asText)(M)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),j={};await this.request(_,{type:"DELETE",headers:j},[],U.CancellationToken.None)}async read(P,_,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();j=Object.assign({},j),j["Cache-Control"]="no-cache",_&&(j["If-None-Match"]=_.ref);const M=await this.request(B,{type:"GET",headers:j},[304],U.CancellationToken.None);if(M.res.statusCode===304)return _;const $=M.res.headers.etag;if(!$)throw new k.UserDataSyncStoreError("Server did not return the ref",B,k.UserDataSyncErrorCode.NoRef,M.res.headers[k.HEADER_OPERATION_ID]);const V=await(0,A.asText)(M);return{ref:$,content:V}}async write(P,_,j,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",j&&(B["If-Match"]=j);const $=await this.request(M,{type:"POST",data:_,headers:B},[],U.CancellationToken.None),V=$.res.headers.etag;if(!V)throw new k.UserDataSyncStoreError("Server did not return the ref",M,k.UserDataSyncErrorCode.NoRef,$.res.headers[k.HEADER_OPERATION_ID]);return V}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const j=await this.request(_,{type:"GET",headers:P},[],U.CancellationToken.None),B=await(0,A.asJson)(j),M=this.storageService.get(t,0);return M&&B&&M!==B.session&&this.clearSession(),B===null&&M&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(P,_,j,B){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",P,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),M),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let $;try{$=await this.session.request(P,_,B)}catch(z){if(!(z instanceof k.UserDataSyncStoreError)){const D=(0,g.isPromiseCanceledError)(z)?k.UserDataSyncErrorCode.RequestCanceled:(0,g.getErrorMessage)(z).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;z=new k.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,D,void 0)}throw this.logService.info("Request failed",P),z}const V=$.res.headers[k.HEADER_OPERATION_ID],q={url:P,status:$.res.statusCode,"execution-id":_.headers[k.HEADER_EXECUTION_ID],"operation-id":V},H=(0,A.isSuccess)($)||$.res.statusCode&&j.indexOf($.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,k.UserDataSyncErrorCode.Unauthorized,V);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.Conflict,V);if($.res.statusCode===410)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,k.UserDataSyncErrorCode.Gone,V);if($.res.statusCode===412)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.PreconditionFailed,V);if($.res.statusCode===413)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,k.UserDataSyncErrorCode.TooLarge,V);if($.res.statusCode===426)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,k.UserDataSyncErrorCode.UpgradeRequired,V);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V)):new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequests,V)}if(!H)throw new k.UserDataSyncStoreError("Server returned "+$.res.statusCode,P,k.UserDataSyncErrorCode.Unknown,V);return $}addSessionHeaders(P){let _=this.storageService.get(i,0);_===void 0&&(_=(0,b.generateUuid)(),this.storageService.store(i,_,0,1)),P["X-Machine-Session-Id"]=_;const j=this.storageService.get(t,0);j!==void 0&&(P["X-User-Session-Id"]=j)}};u=he([Y(1,m.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,f.IFileService),Y(6,y.IStorageService)],u),e.UserDataSyncStoreClient=u;let d=class extends u{constructor(P,_,j,B,M,$,V){var q;super((q=P.userDataSyncStore)===null||q===void 0?void 0:q.url,_,j,B,M,$,V);this._register(P.onDidChangeUserDataSyncStore(()=>{var H;return this.updateUserDataSyncStoreUrl((H=P.userDataSyncStore)===null||H===void 0?void 0:H.url)}))}};d=he([Y(0,k.IUserDataSyncStoreManagementService),Y(1,m.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,f.IFileService),Y(6,y.IStorageService)],d),e.UserDataSyncStoreService=d;class p{constructor(P,_,j,B){this.limit=P,this.interval=_,this.requestService=j,this.logService=B,this.requests=[],this.startTime=void 0}request(P,_,j){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=p}),define(Z[194],ee([0,1,20,3,57,83,59,25,19,60,28]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let f=class extends L.UserDataAutoSyncService{constructor(b,o,E,w,C,I,g,s,r,t,i,n){super(b,o,E,w,C,g,s,r,t,i,n);this._register(k.Event.debounce(k.Event.any(k.Event.map(I.onDidFocusWindow,()=>"windowFocus"),k.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(a,c)=>a?[...a,c]:[c],1e3)(a=>this.triggerSync(a,!0,!1)))}};f=he([Y(0,R.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncResourceEnablementService),Y(4,S.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,S.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,O.ITelemetryService),Y(9,v.IUserDataSyncMachinesService),Y(10,m.IStorageService),Y(11,S.IUserDataAutoSyncEnablementService)],f),e.UserDataAutoSyncService=f}),define(Z[195],ee([0,1,3,2,6]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:O,onDidFocusWindow:m,getActiveWindowId:v}){super();this.disposables=this._register(new k.DisposableStore),S.Event.latch(S.Event.any(O,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch(f){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(O){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=O}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[61],ee([0,1,105,8,27,6,23,201,202,15]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=R;function f(r){const t=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function y(r){if(r instanceof R)return r;let t;return/end of central directory record signature not found/.test(r.message)&&(t="CorruptZip"),new R(t,r)}function b(r,t,i,n,a,c){const l=k.dirname(t),u=k.join(n,l);if(!u.startsWith(n))return Promise.reject(new Error(S.localize(0,null,t)));const d=k.join(n,t);let p;return c.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(A.promises.mkdir(u,{recursive:!0})).then(()=>new Promise((h,P)=>{if(!c.isCancellationRequested)try{p=(0,A.createWriteStream)(d,{mode:i}),p.once("close",()=>h()),p.once("error",P),r.once("error",P),r.pipe(p)}catch(_){P(_)}}))}function o(r,t,i,n){let a=(0,L.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{a.cancel(),r.close()}),new Promise((l,u)=>{const d=new L.Sequencer,p=h=>{h.isCancellationRequested||(c++,r.readEntry())};r.once("error",u),r.once("close",()=>a.then(()=>{n.isCancellationRequested||r.entryCount===c?l():u(new R("Incomplete",new Error(S.localize(1,null,c,r.entryCount))))},u)),r.readEntry(),r.on("entry",h=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(h.fileName)){p(n);return}const P=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(P)){const B=k.join(t,P);a=(0,L.createCancelablePromise)(M=>A.promises.mkdir(B,{recursive:!0}).then(()=>p(M)).then(void 0,u));return}const _=w(r,h),j=f(h);a=(0,L.createCancelablePromise)(B=>d.queue(()=>_.then(M=>b(M,P,j,t,i,B).then(()=>p(B)))).then(null,u))}})})}function E(r,t=!1){return new Promise((i,n)=>{(0,O.open)(r,t?{lazyEntries:!0}:void 0,(a,c)=>{a?n(y(a)):i((0,v.assertIsDefined)(c))})})}function w(r,t){return new Promise((i,n)=>{r.openReadStream(t,(a,c)=>{a?n(y(a)):i((0,v.assertIsDefined)(c))})})}function C(r,t){return new Promise((i,n)=>{const a=new m.ZipFile;t.forEach(l=>{l.contents?a.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&a.addFile(l.localPath,l.path)}),a.end();const c=(0,A.createWriteStream)(r);a.outputStream.pipe(c),a.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>i(r))})}e.zip=C;function I(r,t,i={},n){const a=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let c=E(r,!0);return i.overwrite&&(c=c.then(l=>(0,U.rimraf)(t).then(()=>l))),c.then(l=>o(l,t,{sourcePathRegex:a},n))}e.extract=I;function g(r,t){return E(r).then(i=>new Promise((n,a)=>{i.on("entry",c=>{c.fileName===t&&w(i,c).then(l=>n(l),l=>a(l))}),i.once("close",()=>a(new Error(S.localize(2,null,t))))}))}function s(r,t){return g(r,t).then(i=>new Promise((n,a)=>{const c=[];i.once("error",a),i.on("data",l=>c.push(l)),i.on("end",()=>n(Buffer.concat(c)))}))}e.buffer=s}),define(Z[196],ee([0,1,61,110]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(L){return(0,S.buffer)(L,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(O){throw new Error((0,k.localize)(0,null))}})}e.getManifest=A}),define(Z[197],ee([0,1,27,56,2,23,8,17,29,33,6,4,9,130,111,28,61,7,18,16,10,12,31,11]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const n="scanningSystem",a="scanningUser",c="extracting",l="deleting",u="renaming";let d=class extends A.Disposable{constructor(h,P,_,j,B){super();this.beforeRemovingExtension=h,this.fileService=P,this.logService=_,this.environmentService=j,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(h){const P=[];(h===null||h===0)&&P.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(_).message,n)))),(h===null||h===1)&&P.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(_).message,a))));try{const _=await Promise.all(P);return(0,I.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(h){this.logService.trace("Started scanning user extensions");let[P,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(j=>!P[new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),h&&(_=(0,v.groupByExtension)(_,B=>B.identifier).map(B=>B.sort((M,$)=>k.rcompare(M.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(h,P,_){const j=h.key(),B=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),M=U.join(this.extensionsPath,j);try{await L.rimraf(M)}catch(V){try{await L.rimraf(M)}catch(q){}throw new m.ExtensionManagementError((0,o.localize)(0,null,M,h.id),l)}await this.extractAtLocation(h,P,B,_);let $=await this.scanExtension(f.URI.file(B),1);if(!$)throw new Error((0,o.localize)(1,null,B));await this.storeMetadata($,{installedTimestamp:Date.now()});try{await this.rename(h,B,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(V){try{await L.rimraf(B)}catch(q){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",h.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(V)}. Deleted from extracted location`,B),V}try{$=await this.scanExtension(f.URI.file(M),1)}catch(V){}if($)return $;throw new Error((0,o.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(h,P){return this.setMetadata(h,P),await this.storeMetadata(h,Object.assign(Object.assign({},P),{installedTimestamp:h.installedTimestamp})),h}async storeMetadata(h,P){P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0,P.installedTimestamp=P.installedTimestamp||void 0;const _=U.join(h.location.fsPath,"package.json"),j=await S.promises.readFile(_,"utf8"),{manifest:B}=await this.parseManifest(j);return B.__metadata=P,await L.writeFile(_,JSON.stringify(B,null,"	")),h}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...h){const P=h.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{P.forEach(j=>_[j.key()]=!0)})}async setInstalled(h){await this.withUninstalledExtensions(j=>delete j[h.key()]);const _=(await this.scanExtensions(1)).find(j=>new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(h))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(h){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await S.promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let _={};if(P)try{_=JSON.parse(P)}catch(j){}return h&&(h(_),Object.keys(_).length?await L.writeFile(this.uninstalledPath,JSON.stringify(_)):await L.rimraf(this.uninstalledPath)),_})}async removeExtension(h,P){this.logService.trace(`Deleting ${P} extension from disk`,h.identifier.id,h.location.fsPath),await L.rimraf(h.location.fsPath),this.logService.info("Deleted from disk",h.identifier.id,h.location.fsPath)}async removeUninstalledExtension(h){await this.removeExtension(h,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new v.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()])}async extractAtLocation(h,P,_,j){this.logService.trace(`Started extracting the extension from ${P} to ${_}`);try{await L.rimraf(_)}catch(B){throw new m.ExtensionManagementError(this.joinErrors(B).message,l)}try{await(0,w.extract)(P,_,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${_}:`,h.id)}catch(B){try{await L.rimraf(_)}catch(M){}throw new m.ExtensionManagementError(B.message,B instanceof w.ExtractError&&B.type?B.type:c)}}async rename(h,P,_,j){try{await S.promises.rename(P,_)}catch(B){if(C.isWindows&&B&&B.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${P} to ${_} with 'EPERM' error. Trying again...`,h.id),this.rename(h,P,_,j);throw new m.ExtensionManagementError(B.message||(0,o.localize)(3,null,P,_),B.code||u)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const h=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return h;const P=this.scanDevSystemExtensions(),[_,j]=await Promise.all([h,P]);return[..._,...j]}async scanExtensionsInDir(h,P){const _=new R.Limiter(10),j=await this.fileService.resolve(f.URI.file(h));return j.children?(await Promise.all(j.children.filter(M=>M.isDirectory).map(M=>_.queue(async()=>P===1&&(0,r.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,P))))).filter(M=>M&&M.identifier):[]}async scanExtension(h,P){var _,j;try{const B=await this.fileService.resolve(h);if(B.children){const{manifest:M,metadata:$}=await this.readManifest(h.fsPath),V=(_=B.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D)))===null||_===void 0?void 0:_.resource,q=(j=B.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D)))===null||j===void 0?void 0:j.resource,H={id:(0,v.getGalleryExtensionId)(M.publisher,M.name)},z={type:P,identifier:H,manifest:M,location:h,readmeUrl:V,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return $&&(this.setMetadata(z,$),z.installedTimestamp=$.installedTimestamp),z}}catch(B){P!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const h=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",h.length),h}async scanDevSystemExtensions(){const h=this.getDevSystemExtensionsList();if(h.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(_=>h.some(j=>(0,v.areSameExtensions)(_.identifier,{id:j})))}else return[]}setMetadata(h,P){h.publisherDisplayName=P.publisherDisplayName||null,h.publisherId=P.publisherId||null,h.identifier.uuid=P.id,h.isMachineScoped=!!P.isMachineScoped,h.isBuiltin=h.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const h=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),_=new Set;for(const M of P)h[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||_.add(M.identifier.id.toLowerCase());const j=(0,v.groupByExtension)(P,M=>M.identifier);await R.Promises.settled(j.map(async M=>{const $=M.sort((V,q)=>k.rcompare(V.manifest.version,q.manifest.version))[0];_.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const B=P.filter(M=>h[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await R.Promises.settled(B.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const h=await this.scanAllUserExtensions(),P=[],_=(0,v.groupByExtension)(h,j=>j.identifier);P.push(...(0,I.flatten)(_.map(j=>j.sort((B,M)=>k.rcompare(B.manifest.version,M.manifest.version)).slice(1)))),await R.Promises.settled(P.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(h=>h.name)}joinErrors(h){const P=Array.isArray(h)?h:[h];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((_,j)=>new Error(`${_.message}${_.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(g.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(h){const P=[S.promises.readFile(U.join(h,"package.json"),"utf8").then(M=>this.parseManifest(M)),S.promises.readFile(U.join(h,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:_,metadata:j},B]=await Promise.all(P);return{manifest:(0,b.localizeManifest)(_,B),metadata:j}}parseManifest(h){return new Promise((P,_)=>{try{const j=JSON.parse(h),B=j.__metadata||null;P({manifest:j,metadata:B})}catch(j){_(new Error((0,o.localize)(4,null)))}})}};d=he([Y(1,s.IFileService),Y(2,O.ILogService),Y(3,y.INativeEnvironmentService),Y(4,E.IProductService)],d),e.ExtensionsScanner=d}),define(Z[198],ee([0,1,27,109,8,23,2,18,61,29,33,9,6,3,56,4,51,7,17,143,43,25,68,12,31,70,5,16,30,196,151,197,152,153,10]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s,r,t,i,n,a,c,l,u,d,p,h,P,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const B="unsetUninstalled",M="downloading",$="validating",V="local",q="unknown";let H=class extends U.Disposable{constructor(D,T,F,N,x,G,J){super();this.environmentService=D,this.galleryService=T,this.logService=F,this.downloadService=N,this.telemetryService=x,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(G.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(h.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new g.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(G.createInstance(p.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,J,D,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ce})=>{ie.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(D){this.logService.trace("ExtensionManagementService#zip",D.identifier.id);const T=await this.collectFiles(D),F=await(0,m.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,T);return E.URI.file(F)}async unzip(D){return this.logService.trace("ExtensionManagementService#unzip",D.toString()),(await this.install(D)).identifier}async getManifest(D){const T=await this.downloadVsix(D),F=A.resolve(T.fsPath);return(0,d.getManifest)(F)}async collectFiles(D){const T=async N=>{let x=await L.readdir(N);x=x.map(Q=>A.join(N,Q));const G=await Promise.all(x.map(Q=>S.promises.stat(Q)));let J=Promise.resolve([]);return G.forEach((Q,ne)=>{const ie=x[ne];Q.isFile()&&(J=J.then(ce=>[...ce,ie])),Q.isDirectory()&&(J=J.then(ce=>T(ie).then(ue=>[...ce,...ue])))}),J};return(await T(D.location.fsPath)).map(N=>({path:`extension/${A.relative(D.location.fsPath,N)}`,localPath:N}))}async install(D,T={}){return this.logService.trace("ExtensionManagementService#install",D.toString()),(0,y.createCancelablePromise)(async F=>{const N=await this.downloadVsix(D),x=A.resolve(N.fsPath),G=await(0,d.getManifest)(x),J={id:(0,R.getGalleryExtensionId)(G.publisher,G.name)};let Q=1;if(G.engines&&G.engines.vscode&&!(0,t.isEngineValid)(G.engines.vscode,w.default.version))throw new Error(k.localize(0,null,J.id,w.default.version));const ne=new R.ExtensionIdentifierWithVersion(J,G.version),ce=(await this.getInstalled(1)).find(ge=>(0,R.areSameExtensions)(J,ge.identifier));if(ce)if(T.isMachineScoped=T.isMachineScoped||ce.isMachineScoped,T.isBuiltin=T.isBuiltin||ce.isBuiltin,Q=2,ne.equals(new R.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(k.localize(1,null,G.displayName||G.name))}else o.gt(ce.manifest.version,G.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ne);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(Ee){throw new Error(k.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",J.id),this._onInstallExtension.fire({identifier:J,zipPath:x});let ue;try{ue=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(G.publisher,G.name))}catch(ge){}try{const ge=await this.installFromZipPath(ne,x,Object.assign(Object.assign({},ue||{}),T),T,Q,F);return this.logService.info("Successfully installed the extension:",J.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",J.id,ge.message),ge}})}async downloadVsix(D){if(D.scheme===l.Schemas.file)return D;if(!this.downloadService)throw new Error("Download service is not available");const T=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(D,T),T}async installFromZipPath(D,T,F,N,x,G){try{const J=await this.installExtension({zipPath:T,identifierWithVersion:D,metadata:F},G);try{await this.installDependenciesAndPackExtensions(J,void 0,N)}catch(Q){(0,O.isNonEmptyArray)(J.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",J.identifier.id,Q.message),(0,O.isNonEmptyArray)(J.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",J.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:D,zipPath:T,local:J,operation:x}),J}catch(J){throw this._onDidInstallExtension.fire({identifier:D,zipPath:T,operation:x,error:J}),J}}async canInstall(D){return!0}async installFromGallery(D,T={}){if(!this.galleryService.isEnabled())throw new Error(k.localize(3,null));try{D=await this.checkAndGetCompatibleVersion(D)}catch(x){const G=x&&x.code?x.code:q;throw this.logService.error("Failed to install extension:",D.identifier.id,x?x.message:G),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(D),void 0,x),x instanceof Error&&(x.name=G),x}const F=new R.ExtensionIdentifierWithVersion(D.identifier,D.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,y.createCancelablePromise)(x=>this.doInstallFromGallery(D,T,x)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(D,T,F){const N=new Date().getTime();let x=1;this.logService.info("Installing extension:",D.identifier.id),this._onInstallExtension.fire({identifier:D.identifier,gallery:D});try{const J=(await this.getInstalled(1)).find(ie=>(0,R.areSameExtensions)(ie.identifier,D.identifier));J&&(x=2);const Q=await this.downloadInstallableExtension(D,x);Q.metadata.isMachineScoped=T.isMachineScoped||(J==null?void 0:J.isMachineScoped),Q.metadata.isBuiltin=T.isBuiltin||(J==null?void 0:J.isBuiltin);const ne=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(E.URI.file(Q.zipPath))}catch(ie){}if(!T.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,J,T)}catch(ie){try{await this.uninstall(ne)}catch(ce){}throw ie}return J&&o.neq(J.manifest.version,D.version)&&await this.extensionsScanner.setUninstalled(J),this.logService.info("Extensions installed successfully:",D.identifier.id),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,local:ne,operation:x}),this.reportTelemetry(this.getTelemetryEvent(x),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,void 0),ne}catch(G){const J=G&&G.code?G.code:q;throw this.logService.error("Failed to install extension:",D.identifier.id,G?G.message:J),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,operation:x,error:J}),this.reportTelemetry(this.getTelemetryEvent(x),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,G),G instanceof Error&&(G.name=J),G}}async checkAndGetCompatibleVersion(D){if(await this.isMalicious(D))throw new v.ExtensionManagementError(k.localize(4,null),v.INSTALL_ERROR_MALICIOUS);const T=await this.galleryService.getCompatibleExtension(D);if(!T)throw new v.ExtensionManagementError(k.localize(5,null,D.identifier.id,w.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return T}async reinstallFromGallery(D){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",D.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(6,null));const T=await this.findGalleryExtension(D);if(!T)throw new Error(k.localize(7,null));await this.extensionsScanner.setUninstalled(D);try{await this.extensionsScanner.removeUninstalledExtension(D)}catch(F){throw new Error(k.localize(8,null,(0,s.toErrorMessage)(F)))}await this.installFromGallery(T)}getTelemetryEvent(D){return D===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(D){const T=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(T).has(D.identifier.id)}async downloadInstallableExtension(D,T){const F={id:D.identifier.uuid,publisherId:D.publisherId,publisherDisplayName:D.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",D.identifier.id),N=(await this.extensionsDownloader.downloadExtension(D,T)).fsPath,this.logService.info("Downloaded extension:",D.identifier.id,N)}catch(x){throw new v.ExtensionManagementError(this.joinErrors(x).message,M)}try{const x=await(0,d.getManifest)(N);return{zipPath:N,identifierWithVersion:new R.ExtensionIdentifierWithVersion(D.identifier,x.version),metadata:F}}catch(x){throw new v.ExtensionManagementError(this.joinErrors(x).message,$)}}async installExtension(D,T){try{const F=await this.unsetUninstalledAndGetLocal(D.identifierWithVersion);if(F)return D.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,D.metadata):F}catch(F){throw C.isMacintosh?new v.ExtensionManagementError(k.localize(9,null),B):new v.ExtensionManagementError(k.localize(10,null),B)}return this.extractAndInstall(D,T)}async unsetUninstalledAndGetLocal(D){if(!await this.isUninstalled(D))return null;this.logService.trace("Removing the extension from uninstalled list:",D.id);const F=await this.extensionsScanner.setInstalled(D);return this.logService.info("Removed the extension from uninstalled list:",D.id),F}async extractAndInstall({zipPath:D,identifierWithVersion:T,metadata:F},N){let x=await this.extensionsScanner.extractUserExtension(T,D,N);return this.logService.info("Installation completed.",T.id),F&&(x=await this.extensionsScanner.saveMetadataForLocalExtension(x,F)),x}async installDependenciesAndPackExtensions(D,T,F){if(!!this.galleryService.isEnabled()){const N=D.manifest.extensionDependencies||[];if(D.manifest.extensionPack)for(const x of D.manifest.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(G=>(0,R.areSameExtensions)({id:G},{id:x}))||N.every(G=>!(0,R.areSameExtensions)({id:G},{id:x}))&&N.push(x);if(N.length){const x=await this.getInstalled(),G=N.filter(J=>x.every(({identifier:Q})=>!(0,R.areSameExtensions)(Q,{id:J})));if(G.length){const Q=(await this.galleryService.query({names:G,pageSize:N.length},u.CancellationToken.None)).firstPage;try{await y.Promises.settled(Q.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(Q)}catch(ie){}throw ne}}}}}async rollback(D){const F=(await this.getInstalled(1)).filter(N=>D.some(x=>new R.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new R.ExtensionIdentifierWithVersion(x.identifier,x.version))));await y.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(D,T={}){this.logService.trace("ExtensionManagementService#uninstall",D.identifier.id);const F=await this.getInstalled(1),N=F.find(x=>(0,R.areSameExtensions)(x.identifier,D.identifier));if(!N)throw new Error(k.localize(11,null,D.manifest.displayName||D.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,T)}catch(x){throw this.joinErrors(x)}}async updateMetadata(D,T){return this.logService.trace("ExtensionManagementService#updateMetadata",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),T)),this.manifestCache.invalidate(),D}async updateExtensionScope(D,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),{isMachineScoped:T})),this.manifestCache.invalidate(),D}async getGalleryMetadata(D){const T=await this.findGalleryExtensionByName(D);return T?{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId}:void 0}async findGalleryExtension(D){if(D.identifier.uuid){const T=await this.findGalleryExtensionById(D.identifier.uuid);return T||this.findGalleryExtensionByName(D.identifier.id)}return this.findGalleryExtensionByName(D.identifier.id)}async findGalleryExtensionById(D){return(await this.galleryService.query({ids:[D],pageSize:1},u.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(D){return(await this.galleryService.query({names:[D],pageSize:1},u.CancellationToken.None)).firstPage[0]}joinErrors(D){const T=Array.isArray(D)?D:[D];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(D,T,F){try{await this.preUninstallExtension(D);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(D,T);await this.uninstallExtensions(D,N,T,F)}catch(N){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(N instanceof Error?N.message:N,V)),N}await this.postUninstallExtension(D)}async uninstallExtensions(D,T,F,N){const x=[D,...T];if(!N.donotCheckDependents)for(const G of x)this.checkForDependents(G,x,F,D);await y.Promises.settled([this.uninstallExtension(D),...T.map(G=>this.doUninstall(G))])}checkForDependents(D,T,F,N){const x=this.getDependents(D,F);if(x.length){const G=x.filter(J=>T.indexOf(J)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(D,G,N))}}getDependentsErrorMessage(D,T,F){return F===D?T.length===1?k.localize(12,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?k.localize(13,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):k.localize(14,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):T.length===1?k.localize(15,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?k.localize(16,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):k.localize(17,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name)}getAllPackExtensionsToUninstall(D,T,F=[]){if(F.indexOf(D)!==-1)return[];F.push(D);const N=D.manifest.extensionPack?D.manifest.extensionPack:[];if(N.length){const x=T.filter(J=>!J.isBuiltin&&N.some(Q=>(0,R.areSameExtensions)({id:Q},J.identifier))),G=[];for(const J of x)G.push(...this.getAllPackExtensionsToUninstall(J,T,F));return[...x,...G]}return[]}getDependents(D,T){return T.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,R.areSameExtensions)({id:N},D.identifier)))}async doUninstall(D){try{await this.preUninstallExtension(D),await this.uninstallExtension(D)}catch(T){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(T instanceof Error?T.message:T,V)),T}await this.postUninstallExtension(D)}async preUninstallExtension(D){if(!await L.exists(D.location.fsPath))throw new Error(k.localize(18,null));this.logService.info("Uninstalling extension:",D.identifier.id),this._onUninstallExtension.fire(D.identifier)}async uninstallExtension(D){let T=this.uninstallingExtensions.get(D.identifier.id);return T||(T=(0,y.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,R.areSameExtensions)(N.identifier,D.identifier)))}),this.uninstallingExtensions.set(D.identifier.id,T),T.finally(()=>this.uninstallingExtensions.delete(D.identifier.id))),T}async postUninstallExtension(D,T){if(T)this.logService.error("Failed to uninstall extension:",D.identifier.id,T.message);else if(this.logService.info("Successfully uninstalled extension:",D.identifier.id),D.identifier.uuid)try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(D),void 0,T);const F=T?T instanceof v.ExtensionManagementError?T.code:q:void 0;this._onDidUninstallExtension.fire({identifier:D.identifier,error:F})}getInstalled(D=null){return this.extensionsScanner.scanExtensions(D)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(D){return(await this.filterUninstalled(D)).length===1}async filterUninstalled(...D){const T=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of D)F[N.key()]&&T.push(N.key());return T}getExtensionsReport(){const D=new Date().getTime();return(!this.reportedExtensions||D-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=D),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const D=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${D.length} reported extensions from service`),D}catch(D){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(D,T,F,N){const x=N?N instanceof v.ExtensionManagementError?N.code:q:void 0;this.telemetryService.publicLogError(D,Object.assign(Object.assign({},T),{success:!N,duration:F,errorcode:x}))}};H=he([Y(0,f.INativeEnvironmentService),Y(1,v.IExtensionGalleryService),Y(2,I.ILogService),Y(3,(0,c.optional)(a.IDownloadService)),Y(4,r.ITelemetryService),Y(5,c.IInstantiationService),Y(6,j.IFileService)],H),e.ExtensionManagementService=H}),define(Z[203],ee([0,1,27,38,204,99,51,98,34,74,50,147,9,127,129,29,198,170,24,161,40,162,25,58,168,78,79,173,17,75,154,55,2,163,70,159,158,141,140,149,148,169,69,155,10,157,16,28,20,191,193,188,57,189,194,167,19,165,190,59,187,171,60,71,131,195,172,83,82,81,5,150,142,11,43,80,176,175,192,138,144,174,4,12]),function(K,e,S,k,A,L,U,O,m,v,R,f,y,b,o,E,w,C,I,g,s,r,t,i,n,a,c,l,u,d,p,h,P,_,j,B,M,$,V,q,H,z,D,T,F,N,x,G,J,Q,ne,ie,ce,ue,ge,Ee,Ie,Oe,Ae,Ue,ke,Ne,De,Te,Ge,Ke,$e,ze,X,re,se,me,W,te,oe,ae,le,fe,ve,Se,we,be,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends P.Disposable{constructor(de){super();this.configuration=de,this.server=this._register(new O.Server),(0,A.gracefulify)(S),this.registerListeners()}registerListeners(){const de=()=>this.dispose();process.once("exit",de),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",de)}async open(){const de=await this.initServices();(0,J.registerConfiguration)(),de.invokeFunction(Le=>{const _e=Le.get(u.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,P.combinedDisposable)(de.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),de.createInstance(M.LanguagePackCachedDataCleaner),de.createInstance($.StorageDataCleaner,this.configuration.backupWorkspacesPath),de.createInstance(V.LogsDataCleaner),de.createInstance(me.LocalizationsUpdater),de.createInstance(W.DeprecatedExtensionsCleaner)))}async initServices(){const de=new v.ServiceCollection,Le=Object.assign({_serviceBrand:void 0},U.default);de.set(G.IProductService,Le);const _e=new m.StaticRouter(qe=>qe==="main"),Fe=new H.MessagePortMainProcessService(this.server,_e);de.set(q.IMainProcessService,Fe);const Me=new b.NativeEnvironmentService(this.configuration.args,Le);de.set(y.INativeEnvironmentService,Me);const Qe=new d.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),Ye=new d.LoggerChannelClient(this.configuration.logLevel,Qe.onDidChangeLogLevel,Fe.getChannel("logger"));de.set(u.ILoggerService,Ye);const tt=this._register(new u.MultiplexLogService([this._register(new u.ConsoleLogger(this.configuration.logLevel)),this._register(Ye.createLogger((0,ye.joinPath)(Pe.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new d.FollowerLogService(Qe,tt));de.set(u.ILogService,Be);const We=this._register(new T.FileService(Be));de.set(F.IFileService,We);const it=this._register(new N.DiskFileSystemProvider(Be));We.registerProvider(x.Schemas.file,it);const Ve=this._register(new g.ConfigurationService(Me.settingsResource,We));de.set(I.IConfigurationService,Ve),await Ve.initialize();const Je=new Ee.NativeStorageService(void 0,Fe,Me);de.set(Ie.IStorageService,Je),await Je.initialize(),this._register((0,P.toDisposable)(()=>Je.flush())),de.set(s.IRequestService,new R.SyncDescriptor(r.RequestService)),de.set(Se.IChecksumService,new R.SyncDescriptor(we.ChecksumService));const Ze=m.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});de.set(ce.INativeHostService,Ze),de.set(j.IDownloadService,new R.SyncDescriptor(_.DownloadService));const nt=this._register(new Ke.ActiveWindowManager(Ze)),ut=new m.StaticRouter(qe=>nt.getActiveClientId().then(rt=>qe===rt));de.set(Te.IExtensionRecommendationNotificationService,new Ge.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let et,xe;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Le.enableTelemetry){xe=new $e.TelemetryLogAppender(Ye,Me);const{appRoot:qe,extensionsPath:rt,isBuilt:dt,installSourcePath:ft}=Me;if(Le.aiConfig&&Le.aiConfig.asimovKey&&dt){const at=new l.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>at.flush())),xe=(0,i.combinedAppender)(at,xe)}et=new c.TelemetryService({appender:xe,commonProperties:(0,n.resolveCommonProperties)(We,(0,k.release)(),(0,k.hostname)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,ft),sendErrorTelemetry:!0,piiPaths:[qe,rt]},Ve)}else et=i.NullTelemetryService,xe=i.NullAppender;this.server.registerChannel("telemetryAppender",new a.TelemetryAppenderChannel(xe)),de.set(t.ITelemetryService,et);const ht=new be.CustomEndpointTelemetryService(Ve,et);return de.set(t.ICustomEndpointTelemetryService,ht),de.set(E.IExtensionManagementService,new R.SyncDescriptor(w.ExtensionManagementService)),de.set(E.IExtensionGalleryService,new R.SyncDescriptor(C.ExtensionGalleryService)),de.set(E.IExtensionTipsService,new R.SyncDescriptor(Ne.ExtensionTipsService)),de.set(h.ILocalizationsService,new R.SyncDescriptor(p.LocalizationsService)),de.set(D.IDiagnosticsService,new R.SyncDescriptor(z.DiagnosticsService)),de.set(Ue.IUserDataSyncAccountService,new R.SyncDescriptor(Ue.UserDataSyncAccountService)),de.set(J.IUserDataSyncLogService,new R.SyncDescriptor(ue.UserDataSyncLogService)),de.set(J.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",qe=>qe.ctx!=="main"))),de.set(E.IGlobalExtensionEnablementService,new R.SyncDescriptor(Oe.GlobalExtensionEnablementService)),de.set(X.IIgnoredExtensionsManagementService,new R.SyncDescriptor(X.IgnoredExtensionsManagementService)),de.set(re.IExtensionsStorageSyncService,new R.SyncDescriptor(re.ExtensionsStorageSyncService)),de.set(J.IUserDataSyncStoreManagementService,new R.SyncDescriptor(ne.UserDataSyncStoreManagementService)),de.set(J.IUserDataSyncStoreService,new R.SyncDescriptor(ne.UserDataSyncStoreService)),de.set(De.IUserDataSyncMachinesService,new R.SyncDescriptor(De.UserDataSyncMachinesService)),de.set(J.IUserDataSyncBackupStoreService,new R.SyncDescriptor(ke.UserDataSyncBackupStoreService)),de.set(J.IUserDataAutoSyncEnablementService,new R.SyncDescriptor(ze.UserDataAutoSyncEnablementService)),de.set(J.IUserDataSyncResourceEnablementService,new R.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),de.set(J.IUserDataSyncService,new R.SyncDescriptor(Q.UserDataSyncService)),de.set(fe.ILocalPtyService,this._register(new le.PtyHostService(Be))),new f.InstantiationService(de)}initChannels(de){const Le=new o.ExtensionManagementChannel(de.get(E.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=m.ProxyChannel.fromService(de.get(h.ILocalizationsService));this.server.registerChannel("localizations",_e);const Fe=m.ProxyChannel.fromService(de.get(D.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new o.ExtensionTipsChannel(de.get(E.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const Qe=m.ProxyChannel.fromService(de.get(Se.IChecksumService));this.server.registerChannel("checksum",Qe);const Ye=new ie.UserDataSyncMachinesServiceChannel(de.get(De.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ye);const tt=m.ProxyChannel.fromService(de.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",tt);const Be=new ie.UserDataSyncAccountServiceChannel(de.get(Ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const We=new ie.UserDataSyncStoreManagementServiceChannel(de.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const it=new ve.UserDataSyncChannel(de.get(J.IUserDataSyncService),de.get(u.ILogService));this.server.registerChannel("userDataSync",it);const Ve=this._register(de.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Je=new ie.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",Je);const Ze=de.get(fe.ILocalPtyService),nt=m.ProxyChannel.fromService(Ze);this.server.registerChannel(ae.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(de){window.addEventListener("unhandledrejection",Le=>{(0,te.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,te.setUnexpectedErrorHandler)(Le=>{const _e=(0,oe.toErrorMessage)(Le,!0);!_e||de.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Ce(Re){const de=new pe(Re);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await de.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5080d21c0b538b996c83fb7b14a746f656eaef15/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
