/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/base/common/types","electron","vs/nls","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","fs","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(q){for(var e=[],m=0,A=q.length;m<A;m++)e[m]=X[q[m]];return e};define(X[100],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(A,L){if(!A)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=m}),define(X[53],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function m(S){return(y,r,g)=>{let E=null,p=null;if(typeof g.value=="function"?(E="value",p=g.value):typeof g.get=="function"&&(E="get",p=g.get),!p)throw new Error("not supported");g[E]=S(p,r)}}e.createDecorator=m;let A=0;function L(){const S=`$memoize${A++}`;let y;const r=function(E,p,h){let w=null,P=null;if(typeof h.value=="function"?(w="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(w="get",P=h.get),!P)throw new Error("not supported");const I=`${S}:${p}`;h[w]=function(...a){return y=this,this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!0,enumerable:!1,writable:!0,value:P.apply(this,a)}),this[I]}};return r.clear=()=>{typeof y!="undefined"&&Object.getOwnPropertyNames(y).forEach(g=>{g.indexOf(S)===0&&delete y[g]})},r}e.createMemoizer=L;function b(S,y,r){return L()(S,y,r)}e.memoize=b;function M(S,y,r){return m((g,E)=>{const p=`$debounce$${E}`,h=`$debounce$result$${E}`;return function(...w){this[h]||(this[h]=r?r():void 0),clearTimeout(this[p]),y&&(this[h]=y(this[h],...w),w=[this[h]]),this[p]=setTimeout(()=>{g.apply(this,w),this[h]=r?r():void 0},S)}})}e.debounce=M;function n(S,y,r){return m((g,E)=>{const p=`$throttle$timer$${E}`,h=`$throttle$result$${E}`,w=`$throttle$lastRun$${E}`,P=`$throttle$pending$${E}`;return function(...I){if(this[h]||(this[h]=r?r():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),y&&(this[h]=y(this[h],...I)),!this[P]){const a=this[w]+S;a<=Date.now()?(this[w]=Date.now(),g.apply(this,[this[h]]),this[h]=r?r():void 0):(this[P]=!0,this[p]=setTimeout(()=>{this[P]=!1,this[w]=Date.now(),g.apply(this,[this[h]]),this[h]=r?r():void 0},a-Date.now()))}}})}e.throttle=n}),define(X[17],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function A(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=A;function L(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=L;function b(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=b;function M(c){if(c instanceof Error){let{name:t,message:i}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:i,stack:s}}return c}e.transformErrorForSerialization=M;const n="Canceled";function S(c){return c instanceof Error&&c.name===n&&c.message===n}e.isPromiseCanceledError=S;class y extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=y;function r(){const c=new Error(n);return c.name=c.message,c}e.canceled=r;function g(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=g;function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=E;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function w(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=w;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class a extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=a;function l(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function o(c,t=Object.create(null)){const i=new Error(c);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=o}),define(X[35],J([0,1,17]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(C,j=0){return C[C.length-(1+j)]}e.tail=A;function L(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=L;function b(C,j,N=(T,R)=>T===R){if(C===j)return!0;if(!C||!j||C.length!==j.length)return!1;for(let T=0,R=C.length;T<R;T++)if(!N(C[T],j[T]))return!1;return!0}e.equals=b;function M(C,j,N){let T=0,R=C.length-1;for(;T<=R;){const W=(T+R)/2|0,k=N(C[W],j);if(k<0)T=W+1;else if(k>0)R=W-1;else return W}return-(T+1)}e.binarySearch=M;function n(C,j){let N=0,T=C.length;if(T===0)return 0;for(;N<T;){const R=Math.floor((N+T)/2);j(C[R])?T=R:N=R+1}return N}e.findFirstInSorted=n;function S(C,j,N){if(C=C|0,C>=j.length)throw new TypeError("invalid index");let T=j[Math.floor(j.length*Math.random())],R=[],W=[],k=[];for(let F of j){const B=N(F,T);B<0?R.push(F):B>0?W.push(F):k.push(F)}return C<R.length?S(C,R,N):C<R.length+k.length?k[0]:S(C-(R.length+k.length),W,N)}e.quickSelect=S;function y(C,j){const N=[];let T;for(const R of C.slice(0).sort(j))!T||j(T[0],R)!==0?(T=[R],N.push(T)):T.push(R);return N}e.groupBy=y;function r(C,j,N){const T=[];function R(F,B,V){if(!(B===0&&V.length===0)){const G=T[T.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=B,G.toInsert.push(...V)):T.push({start:F,deleteCount:B,toInsert:V})}}let W=0,k=0;for(;;){if(W===C.length){R(W,0,j.slice(k));break}if(k===j.length){R(W,C.length-W,[]);break}const F=C[W],B=j[k],V=N(F,B);V===0?(W+=1,k+=1):V<0?(R(W,1,[]),W+=1):V>0&&(R(W,0,[B]),k+=1)}return T}e.sortedDiff=r;function g(C,j,N){const T=r(C,j,N),R=[],W=[];for(const k of T)R.push(...C.slice(k.start,k.start+k.deleteCount)),W.push(...k.toInsert);return{removed:R,added:W}}e.delta=g;function E(C,j,N){if(N===0)return[];const T=C.slice(0,N).sort(j);return h(C,j,T,N,C.length),T}e.top=E;function p(C,j,N,T,R){return N===0?Promise.resolve([]):new Promise((W,k)=>{(async()=>{const F=C.length,B=C.slice(0,N).sort(j);for(let V=N,G=Math.min(N+T,F);V<F;V=G,G=Math.min(G+T,F)){if(V>N&&await new Promise(Y=>setTimeout(Y)),R&&R.isCancellationRequested)throw(0,m.canceled)();h(C,j,B,V,G)}return B})().then(W,k)})}e.topAsync=p;function h(C,j,N,T,R){for(const W=N.length;T<R;T++){const k=C[T];if(j(k,N[W-1])<0){N.pop();const F=n(N,B=>j(k,B)<0);N.splice(F,0,k)}}}function w(C){return C.filter(j=>!!j)}e.coalesce=w;function P(C){let j=0;for(let N=0;N<C.length;N++)C[N]&&(C[j]=C[N],j+=1);C.length=j}e.coalesceInPlace=P;function I(C,j,N){C.splice(N,0,C.splice(j,1)[0])}e.move=I;function a(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=a;function l(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=l;function o(C,j){if(!j)return C.filter((T,R)=>C.indexOf(T)===R);const N=Object.create(null);return C.filter(T=>{const R=j(T);return N[R]?!1:(N[R]=!0,!0)})}e.distinct=o;function c(C){const j=new Set;return C.filter(N=>j.has(N)?!1:(j.add(N),!0))}e.distinctES6=c;function t(C){const j=Object.create(null);return N=>{const T=C(N);return j[T]?!1:(j[T]=!0,!0)}}e.uniqueFilter=t;function i(C,j){for(let N=C.length-1;N>=0;N--){const T=C[N];if(j(T))return N}return-1}e.lastIndex=i;function s(C,j){return C.length>0?C[0]:j}e.firstOrDefault=s;function u(C,j,N=(T,R)=>T===R){let T=0;for(let R=0,W=Math.min(C.length,j.length);R<W&&N(C[R],j[R]);R++)T++;return T}e.commonPrefixLength=u;function d(C){return[].concat(...C)}e.flatten=d;function f(C,j){let N=typeof j=="number"?C:0;typeof j=="number"?N=C:(N=0,j=C);const T=[];if(N<=j)for(let R=N;R<j;R++)T.push(R);else for(let R=N;R>j;R--)T.push(R);return T}e.range=f;function v(C,j,N){return C.reduce((T,R)=>(T[j(R)]=N?N(R):R,T),Object.create(null))}e.index=v;function D(C,j){return C.push(j),()=>_(C,j)}e.insert=D;function _(C,j){const N=C.indexOf(j);if(N>-1)return C.splice(N,1),j}e.remove=_;function U(C,j,N){const T=C.slice(0,j),R=C.slice(j);return T.concat(N,R)}e.arrayInsert=U;function H(C,j){let N;if(typeof j=="number"){let T=j;N=()=>{const R=Math.sin(T++)*179426549;return R-Math.floor(R)}}else N=Math.random;for(let T=C.length-1;T>0;T-=1){const R=Math.floor(N()*(T+1)),W=C[T];C[T]=C[R],C[R]=W}}e.shuffle=H;function Q(C,j){const N=C.indexOf(j);N>-1&&(C.splice(N,1),C.unshift(j))}e.pushToStart=Q;function ie(C,j){const N=C.indexOf(j);N>-1&&(C.splice(N,1),C.push(j))}e.pushToEnd=ie;function ae(C,j){return Array.isArray(C)?C.map(j):j(C)}e.mapArrayOrNot=ae;function O(C){return Array.isArray(C)?C:[C]}e.asArray=O;function $(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=$;function z(C,j){for(const N of C){const T=j(N);if(T!==void 0)return T}}e.mapFind=z}),define(X[42],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(A){const L=this;let b=!1,M;return function(){return b||(b=!0,M=A.apply(L,arguments)),M}}e.once=m}),define(X[62],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(A){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}A.is=L;const b=Object.freeze([]);function M(){return b}A.empty=M;function*n(c){yield c}A.single=n;function S(c){return c||b}A.from=S;function y(c){return!c||c[Symbol.iterator]().next().done===!0}A.isEmpty=y;function r(c){return c[Symbol.iterator]().next().value}A.first=r;function g(c,t){for(const i of c)if(t(i))return!0;return!1}A.some=g;function E(c,t){for(const i of c)if(t(i))return i}A.find=E;function*p(c,t){for(const i of c)t(i)&&(yield i)}A.filter=p;function*h(c,t){for(const i of c)yield t(i)}A.map=h;function*w(...c){for(const t of c)for(const i of t)yield i}A.concat=w;function*P(c){for(const t of c)for(const i of t)yield i}A.concatNested=P;function I(c,t,i){let s=i;for(const u of c)s=t(s,u);return s}A.reduce=I;function*a(c,t,i=c.length){for(t<0&&(t+=c.length),i<0?i+=c.length:i>c.length&&(i=c.length);t<i;t++)yield c[t]}A.slice=a;function l(c,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,c];const s=c[Symbol.iterator]();for(let u=0;u<t;u++){const d=s.next();if(d.done)return[i,A.empty()];i.push(d.value)}return[i,{[Symbol.iterator](){return s}}]}A.consume=l;function o(c,t,i=(s,u)=>s===u){const s=c[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const d=s.next(),f=u.next();if(d.done!==f.done)return!1;if(d.done)return!0;if(!i(d.value,f.value))return!1}}A.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(X[43],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function M(t,i=!1){let s=0,u=t.length,d="",f=0,v=16,D=0;function _($){let z=0,C=0;for(;z<$;){const j=t.charCodeAt(s);if(j>=48&&j<=57)C=C*16+j-48;else if(j>=65&&j<=70)C=C*16+j-65+10;else if(j>=97&&j<=102)C=C*16+j-97+10;else break;s++,z++}return z<$&&(C=-1),C}function U($){s=$,d="",f=0,v=16,D=0}function H(){const $=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return D=3,t.substring($,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;z=s}else D=3;return t.substring($,z)}function Q(){let $="",z=s;for(;;){if(s>=u){$+=t.substring(z,s),D=2;break}const C=t.charCodeAt(s);if(C===34){$+=t.substring(z,s),s++;break}if(C===92){if($+=t.substring(z,s),s++,s>=u){D=2;break}switch(t.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const N=_(4);N>=0?$+=String.fromCharCode(N):D=4;break;default:D=5}z=s;continue}if(C>=0&&C<=31)if(S(C)){$+=t.substring(z,s),D=2;break}else D=6;s++}return $}function ie(){if(d="",D=0,f=s,s>=u)return f=u,v=17;let $=t.charCodeAt(s);if(n($)){do s++,d+=String.fromCharCode($),$=t.charCodeAt(s);while(n($));return v=15}if(S($))return s++,d+=String.fromCharCode($),$===13&&t.charCodeAt(s)===10&&(s++,d+=`
`),v=14;switch($){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,d=Q(),v=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<u&&!S(t.charCodeAt(s));)s++;return d=t.substring(z,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const C=u-1;let j=!1;for(;s<C;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,j=!0;break}s++}return j||(s++,D=1),d=t.substring(z,s),v=13}return d+=String.fromCharCode($),s++,v=16;case 45:if(d+=String.fromCharCode($),s++,s===u||!y(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=H(),v=11;default:for(;s<u&&ae($);)s++,$=t.charCodeAt(s);if(f!==s){switch(d=t.substring(f,s),d){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return d+=String.fromCharCode($),s++,v=16}}function ae($){if(n($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let $;do $=ie();while($>=12&&$<=15);return $}return{setPosition:U,getPosition:()=>s,scan:i?O:ie,getToken:()=>v,getTokenValue:()=>d,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>D}}e.createScanner=M;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function g(t,i){const s=[],u=new Object;let d;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function D(_,U,H,Q){f.value=_,f.offset=U,f.length=H,f.type=Q,f.colonOffset=void 0,d=f}try{l(t,{onObjectBegin:(_,U)=>{if(i<=_)throw u;d=void 0,v=i>_,s.push("")},onObjectProperty:(_,U,H)=>{if(i<U||(D(_,U,H,"property"),s[s.length-1]=_,i<=U+H))throw u},onObjectEnd:(_,U)=>{if(i<=_)throw u;d=void 0,s.pop()},onArrayBegin:(_,U)=>{if(i<=_)throw u;d=void 0,s.push(0)},onArrayEnd:(_,U)=>{if(i<=_)throw u;d=void 0,s.pop()},onLiteralValue:(_,U,H)=>{if(i<U||(D(_,U,H,c(_)),i<=U+H))throw u},onSeparator:(_,U,H)=>{if(i<=U)throw u;if(_===":"&&d&&d.type==="property")d.colonOffset=U,v=!1,d=void 0;else if(_===","){const Q=s[s.length-1];typeof Q=="number"?s[s.length-1]=Q+1:(v=!0,s[s.length-1]=""),d=void 0}}})}catch(_){if(_!==u)throw _}return{path:s,previousNode:d,isAtPropertyKey:v,matches:_=>{let U=0;for(let H=0;U<_.length&&H<s.length;H++)if(_[U]===s[H]||_[U]==="*")U++;else if(_[U]!=="**")return!1;return U===_.length}}}e.getLocation=g;function E(t,i=[],s=b.DEFAULT){let u=null,d=[];const f=[];function v(_){Array.isArray(d)?d.push(_):u!==null&&(d[u]=_)}return l(t,{onObjectBegin:()=>{const _={};v(_),f.push(d),d=_,u=null},onObjectProperty:_=>{u=_},onObjectEnd:()=>{d=f.pop()},onArrayBegin:()=>{const _=[];v(_),f.push(d),d=_,u=null},onArrayEnd:()=>{d=f.pop()},onLiteralValue:v,onError:(_,U,H)=>{i.push({error:_,offset:U,length:H})}},s),d[0]}e.parse=E;function p(t,i=[],s=b.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(_){u.type==="property"&&(u.length=_-u.offset,u=u.parent)}function f(_){return u.children.push(_),_}l(t,{onObjectBegin:_=>{u=f({type:"object",offset:_,length:-1,parent:u,children:[]})},onObjectProperty:(_,U,H)=>{u=f({type:"property",offset:U,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:_,offset:U,length:H,parent:u})},onObjectEnd:(_,U)=>{u.length=_+U-u.offset,u=u.parent,d(_+U)},onArrayBegin:(_,U)=>{u=f({type:"array",offset:_,length:-1,parent:u,children:[]})},onArrayEnd:(_,U)=>{u.length=_+U-u.offset,u=u.parent,d(_+U)},onLiteralValue:(_,U,H)=>{f({type:c(_),offset:U,length:H,parent:u,value:_}),d(U+H)},onSeparator:(_,U,H)=>{u.type==="property"&&(_===":"?u.colonOffset=U:_===","&&d(U))},onError:(_,U,H)=>{i.push({error:_,offset:U,length:H})}},s);const D=u.children[0];return D&&delete D.parent,D}e.parseTree=p;function h(t,i){if(!!t){let s=t;for(let u of i)if(typeof u=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let d=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===u){s=f.children[1],d=!0;break}if(!d)return}else{const d=u;if(s.type!=="array"||d<0||!Array.isArray(s.children)||d>=s.children.length)return;s=s.children[d]}return s}}e.findNodeAtLocation=h;function w(t){if(!t.parent||!t.parent.children)return[];const i=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=w;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const i=Object.create(null);for(let s of t.children){const u=s.children[1];u&&(i[s.children[0].value]=P(u))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function I(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=I;function a(t,i,s=!1){if(I(t,i,s)){const u=t.children;if(Array.isArray(u))for(let d=0;d<u.length&&u[d].offset<=i;d++){const f=a(u[d],i,s);if(f)return f}return t}}e.findNodeAtOffset=a;function l(t,i,s=b.DEFAULT){const u=M(t,!1);function d(B){return B?()=>B(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(B){return B?V=>B(V,u.getTokenOffset(),u.getTokenLength()):()=>!0}const v=d(i.onObjectBegin),D=f(i.onObjectProperty),_=d(i.onObjectEnd),U=d(i.onArrayBegin),H=d(i.onArrayEnd),Q=f(i.onLiteralValue),ie=f(i.onSeparator),ae=d(i.onComment),O=f(i.onError),$=s&&s.disallowComments,z=s&&s.allowTrailingComma;function C(){for(;;){const B=u.scan();switch(u.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:$||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(B){case 12:case 13:$?j(10):ae();break;case 16:j(1);break;case 15:case 14:break;default:return B}}}function j(B,V=[],G=[]){if(O(B),V.length+G.length>0){let Y=u.getToken();for(;Y!==17;){if(V.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function N(B){const V=u.getTokenValue();return B?Q(V):D(V),C(),!0}function T(){switch(u.getToken()){case 11:let B=0;try{B=JSON.parse(u.getTokenValue()),typeof B!="number"&&(j(2),B=0)}catch(V){j(2)}Q(B);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return C(),!0}function R(){return u.getToken()!==10?(j(3,[],[2,5]),!1):(N(!1),u.getToken()===6?(ie(":"),C(),F()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function W(){v(),C();let B=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(B||j(4,[],[]),ie(","),C(),u.getToken()===2&&z)break}else B&&j(6,[],[]);R()||j(4,[],[2,5]),B=!0}return _(),u.getToken()!==2?j(7,[2],[]):C(),!0}function k(){U(),C();let B=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(B||j(4,[],[]),ie(","),C(),u.getToken()===4&&z)break}else B&&j(6,[],[]);F()||j(4,[],[4,5]),B=!0}return H(),u.getToken()!==4?j(8,[4],[]):C(),!0}function F(){switch(u.getToken()){case 3:return k();case 1:return W();case 10:return N(!0);default:return T()}}return C(),u.getToken()===17?s.allowEmptyContent?!0:(j(4,[],[]),!1):F()?(u.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=l;function o(t,i){let s=M(t),u=[],d,f=0,v;do switch(v=s.getPosition(),d=s.scan(),d){case 12:case 13:case 17:f!==v&&u.push(t.substring(f,v)),i!==void 0&&u.push(s.getTokenValue().replace(/[^\r\n]/g,i)),f=s.getPosition();break}while(d!==17);return u.join("")}e.stripComments=o;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(X[101],J([0,1,43]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(S,y,r){let g,E,p,h,w;if(y){for(h=y.offset,w=h+y.length,p=h;p>0&&!n(S,p-1);)p--;let f=w;for(;f<S.length&&!n(S,f);)f++;E=S.substring(p,f),g=b(E,r)}else E=S,g=0,p=0,h=0,w=S.length;const P=M(r,S);let I=!1,a=0,l;r.insertSpaces?l=L(" ",r.tabSize||4):l="	";const o=(0,m.createScanner)(E,!1);let c=!1;function t(){return P+L(l,g+a)}function i(){let f=o.scan();for(I=!1;f===15||f===14;)I=I||f===14,f=o.scan();return c=f===16||o.getTokenError()!==0,f}const s=[];function u(f,v,D){!c&&v<w&&D>h&&S.substring(v,D)!==f&&s.push({offset:v,length:D-v,content:f})}let d=i();if(d!==17){const f=o.getTokenOffset()+p,v=L(l,g);u(v,p,f)}for(;d!==17;){let f=o.getTokenOffset()+o.getTokenLength()+p,v=i(),D="";for(;!I&&(v===12||v===13);){const U=o.getTokenOffset()+p;u(" ",f,U),f=o.getTokenOffset()+o.getTokenLength()+p,D=v===12?t():"",v=i()}if(v===2)d!==1&&(a--,D=t());else if(v===4)d!==3&&(a--,D=t());else{switch(d){case 3:case 1:a++,D=t();break;case 5:case 12:D=t();break;case 13:I?D=t():D=" ";break;case 6:D=" ";break;case 10:if(v===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?D=" ":v!==5&&v!==17&&(c=!0);break;case 16:c=!0;break}I&&(v===12||v===13)&&(D=t())}const _=o.getTokenOffset()+p;u(D,f,_),d=v}return s}e.format=A;function L(S,y){let r="";for(let g=0;g<y;g++)r+=S;return r}function b(S,y){let r=0,g=0;const E=y.tabSize||4;for(;r<S.length;){const p=S.charAt(r);if(p===" ")g++;else if(p==="	")g+=E;else break;r++}return Math.floor(g/E)}function M(S,y){for(let r=0;r<y.length;r++){const g=y.charAt(r);if(g==="\r")return r+1<y.length&&y.charAt(r+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=M;function n(S,y){return`\r
`.indexOf(S.charAt(y))!==-1}e.isEOL=n}),define(X[102],J([0,1,43,101]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(y,r,g){return b(y,r,void 0,g)}e.removeProperty=L;function b(y,r,g,E,p){const h=r.slice(),w=[],P=(0,m.parseTree)(y,w);let I,a;for(;h.length>0&&(a=h.pop(),I=(0,m.findNodeAtLocation)(P,h),I===void 0&&g!==void 0);)typeof a=="string"?g={[a]:g}:g=[g];if(I)if(I.type==="object"&&typeof a=="string"&&Array.isArray(I.children)){const l=(0,m.findNodeAtLocation)(I,[a]);if(l!==void 0)if(g===void 0){if(!l.parent)throw new Error("Malformed AST");const o=I.children.indexOf(l.parent);let c,t=l.parent.offset+l.parent.length;if(o>0){const i=I.children[o-1];c=i.offset+i.length}else c=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return M(y,{offset:c,length:t-c,content:""},E)}else return M(y,{offset:l.offset,length:l.length,content:JSON.stringify(g)},E);else{if(g===void 0)return[];const o=`${JSON.stringify(a)}: ${JSON.stringify(g)}`,c=p?p(I.children.map(i=>i.children[0].value)):I.children.length;let t;if(c>0){const i=I.children[c-1];t={offset:i.offset+i.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return M(y,t,E)}}else if(I.type==="array"&&typeof a=="number"&&Array.isArray(I.children))if(g!==void 0){const l=`${JSON.stringify(g)}`;let o;if(I.children.length===0||a===0)o={offset:I.offset+1,length:0,content:I.children.length===0?l:l+","};else{const c=a===-1||a>I.children.length?I.children.length:a,t=I.children[c-1];o={offset:t.offset+t.length,length:0,content:","+l}}return M(y,o,E)}else{const l=a,o=I.children[l];let c;if(I.children.length===1)c={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===l){const t=I.children[l-1],i=t.offset+t.length,s=I.offset+I.length;c={offset:i,length:s-2-i,content:""}}else c={offset:o.offset,length:I.children[l+1].offset-o.offset,content:""};return M(y,c,E)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${I.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return M(y,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(g)},E)}}e.setProperty=b;function M(y,r,g){let E=n(y,r),p=r.offset,h=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;p>0&&!(0,A.isEOL)(E,p-1);)p--;for(;h<E.length&&!(0,A.isEOL)(E,h);)h++}const w=(0,A.format)(E,{offset:p,length:h-p},g);for(let I=w.length-1;I>=0;I--){const a=w[I];E=n(E,a),p=Math.min(p,a.offset),h=Math.max(h,a.offset+a.length),h+=a.content.length-a.length}const P=y.length-(E.length-h)-p;return[{offset:p,length:P,content:E.substring(p,h)}]}e.withFormatting=M;function n(y,r){return y.substring(0,r.offset)+r.content+y.substring(r.offset+r.length)}e.applyEdit=n;function S(y,r){let g=r.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),E=y.length;for(let p=g.length-1;p>=0;p--){let h=g[p];if(h.offset+h.length<=E)y=n(y,h);else throw new Error("Overlapping edit");E=h.offset}return y}e.applyEdits=S}),define(X[57],J([0,1,17]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(a){a[a.DependsOnKbLayout=-1]="DependsOnKbLayout",a[a.Unknown=0]="Unknown",a[a.Backspace=1]="Backspace",a[a.Tab=2]="Tab",a[a.Enter=3]="Enter",a[a.Shift=4]="Shift",a[a.Ctrl=5]="Ctrl",a[a.Alt=6]="Alt",a[a.PauseBreak=7]="PauseBreak",a[a.CapsLock=8]="CapsLock",a[a.Escape=9]="Escape",a[a.Space=10]="Space",a[a.PageUp=11]="PageUp",a[a.PageDown=12]="PageDown",a[a.End=13]="End",a[a.Home=14]="Home",a[a.LeftArrow=15]="LeftArrow",a[a.UpArrow=16]="UpArrow",a[a.RightArrow=17]="RightArrow",a[a.DownArrow=18]="DownArrow",a[a.Insert=19]="Insert",a[a.Delete=20]="Delete",a[a.KEY_0=21]="KEY_0",a[a.KEY_1=22]="KEY_1",a[a.KEY_2=23]="KEY_2",a[a.KEY_3=24]="KEY_3",a[a.KEY_4=25]="KEY_4",a[a.KEY_5=26]="KEY_5",a[a.KEY_6=27]="KEY_6",a[a.KEY_7=28]="KEY_7",a[a.KEY_8=29]="KEY_8",a[a.KEY_9=30]="KEY_9",a[a.KEY_A=31]="KEY_A",a[a.KEY_B=32]="KEY_B",a[a.KEY_C=33]="KEY_C",a[a.KEY_D=34]="KEY_D",a[a.KEY_E=35]="KEY_E",a[a.KEY_F=36]="KEY_F",a[a.KEY_G=37]="KEY_G",a[a.KEY_H=38]="KEY_H",a[a.KEY_I=39]="KEY_I",a[a.KEY_J=40]="KEY_J",a[a.KEY_K=41]="KEY_K",a[a.KEY_L=42]="KEY_L",a[a.KEY_M=43]="KEY_M",a[a.KEY_N=44]="KEY_N",a[a.KEY_O=45]="KEY_O",a[a.KEY_P=46]="KEY_P",a[a.KEY_Q=47]="KEY_Q",a[a.KEY_R=48]="KEY_R",a[a.KEY_S=49]="KEY_S",a[a.KEY_T=50]="KEY_T",a[a.KEY_U=51]="KEY_U",a[a.KEY_V=52]="KEY_V",a[a.KEY_W=53]="KEY_W",a[a.KEY_X=54]="KEY_X",a[a.KEY_Y=55]="KEY_Y",a[a.KEY_Z=56]="KEY_Z",a[a.Meta=57]="Meta",a[a.ContextMenu=58]="ContextMenu",a[a.F1=59]="F1",a[a.F2=60]="F2",a[a.F3=61]="F3",a[a.F4=62]="F4",a[a.F5=63]="F5",a[a.F6=64]="F6",a[a.F7=65]="F7",a[a.F8=66]="F8",a[a.F9=67]="F9",a[a.F10=68]="F10",a[a.F11=69]="F11",a[a.F12=70]="F12",a[a.F13=71]="F13",a[a.F14=72]="F14",a[a.F15=73]="F15",a[a.F16=74]="F16",a[a.F17=75]="F17",a[a.F18=76]="F18",a[a.F19=77]="F19",a[a.NumLock=78]="NumLock",a[a.ScrollLock=79]="ScrollLock",a[a.US_SEMICOLON=80]="US_SEMICOLON",a[a.US_EQUAL=81]="US_EQUAL",a[a.US_COMMA=82]="US_COMMA",a[a.US_MINUS=83]="US_MINUS",a[a.US_DOT=84]="US_DOT",a[a.US_SLASH=85]="US_SLASH",a[a.US_BACKTICK=86]="US_BACKTICK",a[a.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",a[a.US_BACKSLASH=88]="US_BACKSLASH",a[a.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",a[a.US_QUOTE=90]="US_QUOTE",a[a.OEM_8=91]="OEM_8",a[a.OEM_102=92]="OEM_102",a[a.NUMPAD_0=93]="NUMPAD_0",a[a.NUMPAD_1=94]="NUMPAD_1",a[a.NUMPAD_2=95]="NUMPAD_2",a[a.NUMPAD_3=96]="NUMPAD_3",a[a.NUMPAD_4=97]="NUMPAD_4",a[a.NUMPAD_5=98]="NUMPAD_5",a[a.NUMPAD_6=99]="NUMPAD_6",a[a.NUMPAD_7=100]="NUMPAD_7",a[a.NUMPAD_8=101]="NUMPAD_8",a[a.NUMPAD_9=102]="NUMPAD_9",a[a.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",a[a.NUMPAD_ADD=104]="NUMPAD_ADD",a[a.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",a[a.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",a[a.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",a[a.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",a[a.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",a[a.ABNT_C1=110]="ABNT_C1",a[a.ABNT_C2=111]="ABNT_C2",a[a.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,o){this._keyCodeToStr[l]=o,this._strToKeyCode[o.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||0}}const b=new L,M=new L,n=new L;(function(){function a(l,o,c=o,t=c){b.define(l,o),M.define(l,c),n.define(l,t)}a(0,"unknown"),a(1,"Backspace"),a(2,"Tab"),a(3,"Enter"),a(4,"Shift"),a(5,"Ctrl"),a(6,"Alt"),a(7,"PauseBreak"),a(8,"CapsLock"),a(9,"Escape"),a(10,"Space"),a(11,"PageUp"),a(12,"PageDown"),a(13,"End"),a(14,"Home"),a(15,"LeftArrow","Left"),a(16,"UpArrow","Up"),a(17,"RightArrow","Right"),a(18,"DownArrow","Down"),a(19,"Insert"),a(20,"Delete"),a(21,"0"),a(22,"1"),a(23,"2"),a(24,"3"),a(25,"4"),a(26,"5"),a(27,"6"),a(28,"7"),a(29,"8"),a(30,"9"),a(31,"A"),a(32,"B"),a(33,"C"),a(34,"D"),a(35,"E"),a(36,"F"),a(37,"G"),a(38,"H"),a(39,"I"),a(40,"J"),a(41,"K"),a(42,"L"),a(43,"M"),a(44,"N"),a(45,"O"),a(46,"P"),a(47,"Q"),a(48,"R"),a(49,"S"),a(50,"T"),a(51,"U"),a(52,"V"),a(53,"W"),a(54,"X"),a(55,"Y"),a(56,"Z"),a(57,"Meta"),a(58,"ContextMenu"),a(59,"F1"),a(60,"F2"),a(61,"F3"),a(62,"F4"),a(63,"F5"),a(64,"F6"),a(65,"F7"),a(66,"F8"),a(67,"F9"),a(68,"F10"),a(69,"F11"),a(70,"F12"),a(71,"F13"),a(72,"F14"),a(73,"F15"),a(74,"F16"),a(75,"F17"),a(76,"F18"),a(77,"F19"),a(78,"NumLock"),a(79,"ScrollLock"),a(80,";",";","OEM_1"),a(81,"=","=","OEM_PLUS"),a(82,",",",","OEM_COMMA"),a(83,"-","-","OEM_MINUS"),a(84,".",".","OEM_PERIOD"),a(85,"/","/","OEM_2"),a(86,"`","`","OEM_3"),a(110,"ABNT_C1"),a(111,"ABNT_C2"),a(87,"[","[","OEM_4"),a(88,"\\","\\","OEM_5"),a(89,"]","]","OEM_6"),a(90,"'","'","OEM_7"),a(91,"OEM_8"),a(92,"OEM_102"),a(93,"NumPad0"),a(94,"NumPad1"),a(95,"NumPad2"),a(96,"NumPad3"),a(97,"NumPad4"),a(98,"NumPad5"),a(99,"NumPad6"),a(100,"NumPad7"),a(101,"NumPad8"),a(102,"NumPad9"),a(103,"NumPad_Multiply"),a(104,"NumPad_Add"),a(105,"NumPad_Separator"),a(106,"NumPad_Subtract"),a(107,"NumPad_Decimal"),a(108,"NumPad_Divide")})();var S;(function(a){function l(s){return b.keyCodeToStr(s)}a.toString=l;function o(s){return b.strToKeyCode(s)}a.fromString=o;function c(s){return M.keyCodeToStr(s)}a.toUserSettingsUS=c;function t(s){return n.keyCodeToStr(s)}a.toUserSettingsGeneral=t;function i(s){return M.strToKeyCode(s)||n.strToKeyCode(s)}a.fromUserSettings=i})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl",a[a.KeyCode=255]="KeyCode"})(y||(y={}));var r;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl"})(r=e.KeyMod||(e.KeyMod={}));function g(a,l){const o=(l&65535)<<16>>>0;return(a|o)>>>0}e.KeyChord=g;function E(a,l){if(a===0)return null;const o=(a&65535)>>>0,c=(a&4294901760)>>>16;return c!==0?new w([p(o,l),p(c,l)]):new w([p(o,l)])}e.createKeybinding=E;function p(a,l){const o=!!(a&2048),c=!!(a&256),t=l===2?c:o,i=!!(a&1024),s=!!(a&512),u=l===2?o:c,d=a&255;return new h(t,i,s,u,d)}e.createSimpleKeybinding=p;class h{constructor(l,o,c,t,i){this.ctrlKey=l,this.shiftKey=o,this.altKey=c,this.metaKey=t,this.keyCode=i}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",c=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${l}${o}${c}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=h;class w{constructor(l){if(l.length===0)throw(0,m.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let o=0,c=this.parts.length;o<c;o++)o!==0&&(l+=";"),l+=this.parts[o].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(l.parts[o]))return!1;return!0}}e.ChordKeybinding=w;class P{constructor(l,o,c,t,i,s){this.ctrlKey=l,this.shiftKey=o,this.altKey=c,this.metaKey=t,this.keyLabel=i,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=P;class I{}e.ResolvedKeybinding=I}),define(X[2],J([0,1,42,62]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let b=null;function M(l){b=l}if(e.setDisposableTracker=M,L){const l="__is_disposable_tracked__";b=new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(c)},3e3)}markTracked(o){if(o&&o!==w.None)try{o[l]=!0}catch(c){}}}}function n(l){!b||b.markTracked(l)}function S(l){return b&&b.trackDisposable(l),l}e.trackDisposable=S;class y extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=y;function r(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=r;function g(l){if(A.Iterable.is(l)){let o=[];for(const c of l)if(c){n(c);try{c.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new y(o);return Array.isArray(l)?[]:l}else if(l)return n(l),l.dispose(),l}e.dispose=g;function E(...l){return l.forEach(n),p(()=>g(l))}e.combinedDisposable=E;function p(l){const o=S({dispose:()=>{n(o),l()}});return o}e.toDisposable=p;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return n(o),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new h,S(this)}dispose(){n(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class P{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var c;this._isDisposed||o===this._value||((c=this._value)===null||c===void 0||c.dispose(),o&&n(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,n(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=P;class I{constructor(){this.references=new Map}acquire(o,...c){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,t));const{object:i}=t,s=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=I;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a}),define(X[78],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(b){this.element=b,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class A{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,M){const n=new m(b);if(this._first===m.Undefined)this._first=n,this._last=n;else if(M){const y=this._last;this._last=n,n.prev=y,y.next=n}else{const y=this._first;this._first=n,n.next=y,y.prev=n}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==m.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==m.Undefined&&b.next!==m.Undefined){const M=b.prev;M.next=b.next,b.next.prev=M}else b.prev===m.Undefined&&b.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):b.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):b.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==m.Undefined;)yield b.element,b=b.next}}e.LinkedList=A});"use strict";(function(){function q(L){const b=[];typeof L=="number"&&b.push("code/timeOrigin",L);function M(S){b.push(S,Date.now())}function n(){const S=[];for(let y=0;y<b.length;y+=2)S.push({name:b[y],startTime:b[y+1]});return S}return{mark:M,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))b.push({name:M.name,startTime:Math.round(L+M.startTime)});return b}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function m(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=m(A))})(),define(X[3],J([0,1]),function(q,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let L=!1,b=!1,M=!1,n=!1,S=!1,y=!1,r=!1,g,E=A,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const P=typeof((m=w==null?void 0:w.versions)===null||m===void 0?void 0:m.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=P&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=w==null?void 0:w.env.VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!P)h=navigator.userAgent,L=h.indexOf("Windows")>=0,b=h.indexOf("Macintosh")>=0,r=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=h.indexOf("Linux")>=0,y=!0,g=navigator.language,E=g;else if(typeof w=="object"){L=w.platform==="win32",b=w.platform==="darwin",M=w.platform==="linux",n=M&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,g=A,E=A;const u=w.env.VSCODE_NLS_CONFIG;if(u)try{const d=JSON.parse(u),f=d.availableLanguages["*"];g=d.locale,E=f||A,p=d._translationsConfigFile}catch(d){}S=!0}else console.error("Unable to resolve platform.");var I;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let l=0;b?l=1:L?l=3:M&&(l=2),e.isWindows=L,e.isMacintosh=b,e.isLinux=M,e.isLinuxSnap=n,e.isNative=S,e.isWeb=y,e.isIOS=r,e.platform=l,e.userAgent=h,e.language=E;var o;(function(u){function d(){return e.language}u.value=d;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function v(){return e.language==="en"}u.isDefault=v})(o=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let _=0,U=f.length;_<U;_++){const H=f[_];if(H.id===D.data.vscodeSetImmediateId){f.splice(_,1),H.callback();return}}});let v=0;return D=>{const _=++v;f.push({id:_,callback:D}),e.globals.postMessage({vscodeSetImmediateId:_},"*")}}if(typeof(w==null?void 0:w.nextTick)=="function")return w.nextTick.bind(w);const d=Promise.resolve();return f=>d.then(f)}();var c;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||r?2:L?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(X[32],J([0,1,3]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof m.globals.vscode!="undefined"){const L=m.globals.vscode.process;A={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(b){return(0,m.setImmediate)(b)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:A={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(L){return(0,m.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(X[8],J([0,1,32]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,L=97,b=90,M=122,n=46,S=47,y=92,r=58,g=63;class E extends Error{constructor(o,c,t){let i;typeof c=="string"&&c.indexOf("not ")===0?(i="must not be",c=c.replace(/^not /,"")):i="must be";const s=o.indexOf(".")!==-1?"property":"argument";let u=`The "${o}" ${s} ${i} of type ${c}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function p(l,o){if(typeof l!="string")throw new E(o,"string",l)}function h(l){return l===S||l===y}function w(l){return l===S}function P(l){return l>=A&&l<=b||l>=L&&l<=M}function I(l,o,c,t){let i="",s=0,u=-1,d=0,f=0;for(let v=0;v<=l.length;++v){if(v<l.length)f=l.charCodeAt(v);else{if(t(f))break;f=S}if(t(f)){if(!(u===v-1||d===1))if(d===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==n||i.charCodeAt(i.length-2)!==n){if(i.length>2){const D=i.lastIndexOf(c);D===-1?(i="",s=0):(i=i.slice(0,D),s=i.length-1-i.lastIndexOf(c)),u=v,d=0;continue}else if(i.length!==0){i="",s=0,u=v,d=0;continue}}o&&(i+=i.length>0?`${c}..`:"..",s=2)}else i.length>0?i+=`${c}${l.slice(u+1,v)}`:i=l.slice(u+1,v),s=v-u-1;u=v,d=0}else f===n&&d!==-1?++d:d=-1}return i}function a(l,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const c=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${t}`:`${c}${l}${t}`:t}e.win32={resolve(...l){let o="",c="",t=!1;for(let i=l.length-1;i>=-1;i--){let s;if(i>=0){if(s=l[i],p(s,"path"),s.length===0)continue}else o.length===0?s=m.cwd():(s=m.env[`=${o}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${o}\\`));const u=s.length;let d=0,f="",v=!1;const D=s.charCodeAt(0);if(u===1)h(D)&&(d=1,v=!0);else if(h(D))if(v=!0,h(s.charCodeAt(1))){let _=2,U=_;for(;_<u&&!h(s.charCodeAt(_));)_++;if(_<u&&_!==U){const H=s.slice(U,_);for(U=_;_<u&&h(s.charCodeAt(_));)_++;if(_<u&&_!==U){for(U=_;_<u&&!h(s.charCodeAt(_));)_++;(_===u||_!==U)&&(f=`\\\\${H}\\${s.slice(U,_)}`,d=_)}}}else d=1;else P(D)&&s.charCodeAt(1)===r&&(f=s.slice(0,2),d=2,u>2&&h(s.charCodeAt(2))&&(v=!0,d=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(t){if(o.length>0)break}else if(c=`${s.slice(d)}\\${c}`,t=v,v&&o.length>0)break}return c=I(c,!t,"\\",h),t?`${o}\\${c}`:`${o}${c}`||"."},normalize(l){p(l,"path");const o=l.length;if(o===0)return".";let c=0,t,i=!1;const s=l.charCodeAt(0);if(o===1)return w(s)?"\\":l;if(h(s))if(i=!0,h(l.charCodeAt(1))){let d=2,f=d;for(;d<o&&!h(l.charCodeAt(d));)d++;if(d<o&&d!==f){const v=l.slice(f,d);for(f=d;d<o&&h(l.charCodeAt(d));)d++;if(d<o&&d!==f){for(f=d;d<o&&!h(l.charCodeAt(d));)d++;if(d===o)return`\\\\${v}\\${l.slice(f)}\\`;d!==f&&(t=`\\\\${v}\\${l.slice(f,d)}`,c=d)}}}else c=1;else P(s)&&l.charCodeAt(1)===r&&(t=l.slice(0,2),c=2,o>2&&h(l.charCodeAt(2))&&(i=!0,c=3));let u=c<o?I(l.slice(c),!i,"\\",h):"";return u.length===0&&!i&&(u="."),u.length>0&&h(l.charCodeAt(o-1))&&(u+="\\"),t===void 0?i?`\\${u}`:u:i?`${t}\\${u}`:`${t}${u}`},isAbsolute(l){p(l,"path");const o=l.length;if(o===0)return!1;const c=l.charCodeAt(0);return h(c)||o>2&&P(c)&&l.charCodeAt(1)===r&&h(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let o,c;for(let s=0;s<l.length;++s){const u=l[s];p(u,"path"),u.length>0&&(o===void 0?o=c=u:o+=`\\${u}`)}if(o===void 0)return".";let t=!0,i=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++i;const s=c.length;s>1&&h(c.charCodeAt(1))&&(++i,s>2&&(h(c.charCodeAt(2))?++i:t=!1))}if(t){for(;i<o.length&&h(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.win32.normalize(o)},relative(l,o){if(p(l,"from"),p(o,"to"),l===o)return"";const c=e.win32.resolve(l),t=e.win32.resolve(o);if(c===t||(l=c.toLowerCase(),o=t.toLowerCase(),l===o))return"";let i=0;for(;i<l.length&&l.charCodeAt(i)===y;)i++;let s=l.length;for(;s-1>i&&l.charCodeAt(s-1)===y;)s--;const u=s-i;let d=0;for(;d<o.length&&o.charCodeAt(d)===y;)d++;let f=o.length;for(;f-1>d&&o.charCodeAt(f-1)===y;)f--;const v=f-d,D=u<v?u:v;let _=-1,U=0;for(;U<D;U++){const Q=l.charCodeAt(i+U);if(Q!==o.charCodeAt(d+U))break;Q===y&&(_=U)}if(U!==D){if(_===-1)return t}else{if(v>D){if(o.charCodeAt(d+U)===y)return t.slice(d+U+1);if(U===2)return t.slice(d+U)}u>D&&(l.charCodeAt(i+U)===y?_=U:U===2&&(_=3)),_===-1&&(_=0)}let H="";for(U=i+_+1;U<=s;++U)(U===s||l.charCodeAt(U)===y)&&(H+=H.length===0?"..":"\\..");return d+=_,H.length>0?`${H}${t.slice(d,f)}`:(t.charCodeAt(d)===y&&++d,t.slice(d,f))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const o=e.win32.resolve(l);if(o.length<=2)return l;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const c=o.charCodeAt(2);if(c!==g&&c!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===r&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return l},dirname(l){p(l,"path");const o=l.length;if(o===0)return".";let c=-1,t=0;const i=l.charCodeAt(0);if(o===1)return h(i)?l:".";if(h(i)){if(c=t=1,h(l.charCodeAt(1))){let d=2,f=d;for(;d<o&&!h(l.charCodeAt(d));)d++;if(d<o&&d!==f){for(f=d;d<o&&h(l.charCodeAt(d));)d++;if(d<o&&d!==f){for(f=d;d<o&&!h(l.charCodeAt(d));)d++;if(d===o)return l;d!==f&&(c=t=d+1)}}}}else P(i)&&l.charCodeAt(1)===r&&(c=o>2&&h(l.charCodeAt(2))?3:2,t=c);let s=-1,u=!0;for(let d=o-1;d>=t;--d)if(h(l.charCodeAt(d))){if(!u){s=d;break}}else u=!1;if(s===-1){if(c===-1)return".";s=c}return l.slice(0,s)},basename(l,o){o!==void 0&&p(o,"ext"),p(l,"path");let c=0,t=-1,i=!0,s;if(l.length>=2&&P(l.charCodeAt(0))&&l.charCodeAt(1)===r&&(c=2),o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let u=o.length-1,d=-1;for(s=l.length-1;s>=c;--s){const f=l.charCodeAt(s);if(h(f)){if(!i){c=s+1;break}}else d===-1&&(i=!1,d=s+1),u>=0&&(f===o.charCodeAt(u)?--u==-1&&(t=s):(u=-1,t=d))}return c===t?t=d:t===-1&&(t=l.length),l.slice(c,t)}for(s=l.length-1;s>=c;--s)if(h(l.charCodeAt(s))){if(!i){c=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":l.slice(c,t)},extname(l){p(l,"path");let o=0,c=-1,t=0,i=-1,s=!0,u=0;l.length>=2&&l.charCodeAt(1)===r&&P(l.charCodeAt(0))&&(o=t=2);for(let d=l.length-1;d>=o;--d){const f=l.charCodeAt(d);if(h(f)){if(!s){t=d+1;break}continue}i===-1&&(s=!1,i=d+1),f===n?c===-1?c=d:u!==1&&(u=1):c!==-1&&(u=-1)}return c===-1||i===-1||u===0||u===1&&c===i-1&&c===t+1?"":l.slice(c,i)},format:a.bind(null,"\\"),parse(l){p(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const c=l.length;let t=0,i=l.charCodeAt(0);if(c===1)return h(i)?(o.root=o.dir=l,o):(o.base=o.name=l,o);if(h(i)){if(t=1,h(l.charCodeAt(1))){let _=2,U=_;for(;_<c&&!h(l.charCodeAt(_));)_++;if(_<c&&_!==U){for(U=_;_<c&&h(l.charCodeAt(_));)_++;if(_<c&&_!==U){for(U=_;_<c&&!h(l.charCodeAt(_));)_++;_===c?t=_:_!==U&&(t=_+1)}}}}else if(P(i)&&l.charCodeAt(1)===r){if(c<=2)return o.root=o.dir=l,o;if(t=2,h(l.charCodeAt(2))){if(c===3)return o.root=o.dir=l,o;t=3}}t>0&&(o.root=l.slice(0,t));let s=-1,u=t,d=-1,f=!0,v=l.length-1,D=0;for(;v>=t;--v){if(i=l.charCodeAt(v),h(i)){if(!f){u=v+1;break}continue}d===-1&&(f=!1,d=v+1),i===n?s===-1?s=v:D!==1&&(D=1):s!==-1&&(D=-1)}return d!==-1&&(s===-1||D===0||D===1&&s===d-1&&s===u+1?o.base=o.name=l.slice(u,d):(o.name=l.slice(u,s),o.base=l.slice(u,d),o.ext=l.slice(s,d))),u>0&&u!==t?o.dir=l.slice(0,u-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let o="",c=!1;for(let t=l.length-1;t>=-1&&!c;t--){const i=t>=0?l[t]:m.cwd();p(i,"path"),i.length!==0&&(o=`${i}/${o}`,c=i.charCodeAt(0)===S)}return o=I(o,!c,"/",w),c?`/${o}`:o.length>0?o:"."},normalize(l){if(p(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===S,c=l.charCodeAt(l.length-1)===S;return l=I(l,!o,"/",w),l.length===0?o?"/":c?"./":".":(c&&(l+="/"),o?`/${l}`:l)},isAbsolute(l){return p(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let o;for(let c=0;c<l.length;++c){const t=l[c];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(l,o){if(p(l,"from"),p(o,"to"),l===o||(l=e.posix.resolve(l),o=e.posix.resolve(o),l===o))return"";const c=1,t=l.length,i=t-c,s=1,u=o.length-s,d=i<u?i:u;let f=-1,v=0;for(;v<d;v++){const _=l.charCodeAt(c+v);if(_!==o.charCodeAt(s+v))break;_===S&&(f=v)}if(v===d)if(u>d){if(o.charCodeAt(s+v)===S)return o.slice(s+v+1);if(v===0)return o.slice(s+v)}else i>d&&(l.charCodeAt(c+v)===S?f=v:v===0&&(f=0));let D="";for(v=c+f+1;v<=t;++v)(v===t||l.charCodeAt(v)===S)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(s+f)}`},toNamespacedPath(l){return l},dirname(l){if(p(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===S;let c=-1,t=!0;for(let i=l.length-1;i>=1;--i)if(l.charCodeAt(i)===S){if(!t){c=i;break}}else t=!1;return c===-1?o?"/":".":o&&c===1?"//":l.slice(0,c)},basename(l,o){o!==void 0&&p(o,"ext"),p(l,"path");let c=0,t=-1,i=!0,s;if(o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let u=o.length-1,d=-1;for(s=l.length-1;s>=0;--s){const f=l.charCodeAt(s);if(f===S){if(!i){c=s+1;break}}else d===-1&&(i=!1,d=s+1),u>=0&&(f===o.charCodeAt(u)?--u==-1&&(t=s):(u=-1,t=d))}return c===t?t=d:t===-1&&(t=l.length),l.slice(c,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===S){if(!i){c=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":l.slice(c,t)},extname(l){p(l,"path");let o=-1,c=0,t=-1,i=!0,s=0;for(let u=l.length-1;u>=0;--u){const d=l.charCodeAt(u);if(d===S){if(!i){c=u+1;break}continue}t===-1&&(i=!1,t=u+1),d===n?o===-1?o=u:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===c+1?"":l.slice(o,t)},format:a.bind(null,"/"),parse(l){p(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const c=l.charCodeAt(0)===S;let t;c?(o.root="/",t=1):t=0;let i=-1,s=0,u=-1,d=!0,f=l.length-1,v=0;for(;f>=t;--f){const D=l.charCodeAt(f);if(D===S){if(!d){s=f+1;break}continue}u===-1&&(d=!1,u=f+1),D===n?i===-1?i=f:v!==1&&(v=1):i!==-1&&(v=-1)}if(u!==-1){const D=s===0&&c?1:s;i===-1||v===0||v===1&&i===u-1&&i===s+1?o.base=o.name=l.slice(D,u):(o.name=l.slice(D,i),o.base=l.slice(D,u),o.ext=l.slice(i,u))}return s>0?o.dir=l.slice(0,s-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[79],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const A=[],L=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>b[n]||0,toEnum:n=>L[n]||0,toString:n=>A[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class M{constructor(S,y,r,g,E){this.ctrlKey=S,this.shiftKey=y,this.altKey=r,this.metaKey=g,this.scanCode=E}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=M,function(){function n(S,y){A[S]=y,L[y]=S,b[y.toLowerCase()]=S}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let S=0;S<=193;S++)e.IMMUTABLE_CODE_TO_KEY_CODE[S]=-1;for(let S=0;S<=112;S++)e.IMMUTABLE_KEY_CODE_TO_CODE[S]=-1;function n(S,y){e.IMMUTABLE_CODE_TO_KEY_CODE[S]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=S)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(X[103],J([0,1,57,79]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(M){M=M.toLowerCase().trim();let n=!1,S=!1,y=!1,r=!1,g;do g=!1,/^ctrl(\+|\-)/.test(M)&&(n=!0,M=M.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(M)&&(S=!0,M=M.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(M)&&(y=!0,M=M.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(M)&&(r=!0,M=M.substr("meta-".length),g=!0),/^win(\+|\-)/.test(M)&&(r=!0,M=M.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(M)&&(r=!0,M=M.substr("cmd-".length),g=!0);while(g);let E;const p=M.indexOf(" ");return p>0?(E=M.substring(0,p),M=M.substring(p)):(E=M,M=""),{remains:M,ctrl:n,shift:S,alt:y,meta:r,key:E}}static parseSimpleKeybinding(M){const n=this._readModifiers(M),S=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,S),n.remains]}static parseKeybinding(M,n){if(!M)return null;const S=[];let y;do[y,M]=this.parseSimpleKeybinding(M),S.push(y);while(M.length>0);return new m.ChordKeybinding(S)}static parseSimpleUserBinding(M){const n=this._readModifiers(M),S=n.key.match(/^\[([^\]]+)\]$/);if(S){const r=S[1],g=A.ScanCodeUtils.lowerCaseToEnum(r);return[new A.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,g),n.remains]}const y=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseUserBinding(M){if(!M)return[];const n=[];let S;for(;M.length>0;)[S,M]=this.parseSimpleUserBinding(M),n.push(S);return n}}e.KeybindingParser=L}),define(X[104],J([0,1,3]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=m.globals.performance&&typeof m.globals.performance.now=="function";class L{constructor(M){this._highResolution=A&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new L(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=L}),define(X[5],J([0,1,17,42,2,78,104]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(I){I.None=()=>L.Disposable.None;function a(O){return($,z=null,C)=>{let j=!1,N;return N=O(T=>{if(!j)return N?N.dispose():j=!0,$.call(z,T)},null,C),j&&N.dispose(),N}}I.once=a;function l(O,$){return u((z,C=null,j)=>O(N=>z.call(C,$(N)),null,j))}I.map=l;function o(O,$){return u((z,C=null,j)=>O(N=>{$(N),z.call(C,N)},null,j))}I.forEach=o;function c(O,$){return u((z,C=null,j)=>O(N=>$(N)&&z.call(C,N),null,j))}I.filter=c;function t(O){return O}I.signal=t;function i(...O){return($,z=null,C)=>(0,L.combinedDisposable)(...O.map(j=>j(N=>$.call(z,N),null,C)))}I.any=i;function s(O,$,z){let C=z;return l(O,j=>(C=$(C,j),C))}I.reduce=s;function u(O){let $;const z=new E({onFirstListenerAdd(){$=O(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}I.snapshot=u;function d(O,$,z=100,C=!1,j){let N,T,R,W=0;const k=new E({leakWarningThreshold:j,onFirstListenerAdd(){N=O(F=>{W++,T=$(T,F),C&&!R&&(k.fire(T),T=void 0),clearTimeout(R),R=setTimeout(()=>{const B=T;T=void 0,R=void 0,(!C||W>1)&&k.fire(B),W=0},z)})},onLastListenerRemove(){N.dispose()}});return k.event}I.debounce=d;function f(O){const $=new Date().getTime();return l(a(O),z=>new Date().getTime()-$)}I.stopwatch=f;function v(O){let $=!0,z;return c(O,C=>{const j=$||C!==z;return $=!1,z=C,j})}I.latch=v;function D(O,$=!1,z=[]){let C=z.slice(),j=O(R=>{C?C.push(R):T.fire(R)});const N=()=>{C&&C.forEach(R=>T.fire(R)),C=null},T=new E({onFirstListenerAdd(){j||(j=O(R=>T.fire(R)))},onFirstListenerDidAdd(){C&&($?setTimeout(N):N())},onLastListenerRemove(){j&&j.dispose(),j=null}});return T.event}I.buffer=D;class _{constructor($){this.event=$}map($){return new _(l(this.event,$))}forEach($){return new _(o(this.event,$))}filter($){return new _(c(this.event,$))}reduce($,z){return new _(s(this.event,$,z))}latch(){return new _(v(this.event))}debounce($,z=100,C=!1,j){return new _(d(this.event,$,z,C,j))}on($,z,C){return this.event($,z,C)}once($,z,C){return a(this.event)($,z,C)}}function U(O){return new _(O)}I.chain=U;function H(O,$,z=C=>C){const C=(...R)=>T.fire(z(...R)),j=()=>O.on($,C),N=()=>O.removeListener($,C),T=new E({onFirstListenerAdd:j,onLastListenerRemove:N});return T.event}I.fromNodeEventEmitter=H;function Q(O,$,z=C=>C){const C=(...R)=>T.fire(z(...R)),j=()=>O.addEventListener($,C),N=()=>O.removeEventListener($,C),T=new E({onFirstListenerAdd:j,onLastListenerRemove:N});return T.event}I.fromDOMEventEmitter=Q;function ie(O){const $=new E;let z=!1;return O.then(void 0,()=>null).then(()=>{z?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),z=!0,$.event}I.fromPromise=ie;function ae(O){return new Promise($=>a(O)($))}I.toPromise=ae})(n=e.Event||(e.Event={}));class S{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${S._idPool++}`}start(a){this._stopWatch=new M.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let y=-1;function r(I){const a=y;return y=I,{dispose(){y=a}}}e.setGlobalLeakWarningThreshold=r;class g{constructor(a,l=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let l=y;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||a<l)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(o)||0;if(this._stacks.set(o,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,i=0;for(const[s,u]of this._stacks)(!t||i<u)&&(t=s,i=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class E{constructor(a){var l;this._disposed=!1,this._options=a,this._leakageMon=y>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(a,l,o)=>{var c;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(l?[a,l]:a);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,l);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let u;return u={dispose:()=>{s&&s(),u.dispose=E._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof L.DisposableStore?o.add(u):Array.isArray(o)&&o.push(u),u}),this._event}fire(a){var l,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,a]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(i){(0,m.onUnexpectedError)(i)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var a,l,o;(a=this._listeners)===null||a===void 0||a.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class p extends E{constructor(a){super(a);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=p;class h{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const l={event:a,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const o=()=>{this.hasListeners&&this.unhook(l);const c=this.events.indexOf(l);this.events.splice(c,1)};return(0,L.toDisposable)((0,A.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(l=>this.emitter.fire(l))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=h;class w{constructor(){this.buffers=[]}wrapEvent(a){return(l,o,c)=>a(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>l.call(o,t)):l.call(o,t)},void 0,c)}bufferEvents(a){const l=[];this.buffers.push(l);const o=a();return this.buffers.pop(),l.forEach(c=>c()),o}}e.EventBufferer=w;class P{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=L.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(X[25],J([0,1,5]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(n,S){const y=setTimeout(n.bind(S),0);return{dispose(){clearTimeout(y)}}});var L;(function(n){function S(y){return y===n.None||y===n.Cancelled||y instanceof b?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}n.isCancellationToken=S,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(L=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=L.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=M}),define(X[105],J([0,1,5]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(g){const E=this._icons.get(g.id);E?g.description?E.description=g.description:console.error(`Duplicate registration of codicon ${g.id}`):(this._icons.set(g.id,g),this._onDidRegister.fire(g))}get(g){return this._icons.get(g)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new A;e.iconRegistry=L;function b(r,g){return new n(r,g)}e.registerCodicon=b;function M(r){return r?r.replace(/\$\((.*?)\)/g,(g,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=M;class n{constructor(g,E,p){this.id=g,this.definition=E,this.description=p,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function S(r,g){const E=["codicon","codicon-"+r];return g&&E.push("codicon-modifier-"+g),E}e.getClassNamesArray=S;var y;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const g=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function E(w){if(w instanceof n)return["codicon","codicon-"+w.id];const P=g.exec(w.id);if(!P)return E(n.error);let[,I,a]=P;const l=["codicon","codicon-"+I];return a&&l.push("codicon-modifier-"+a.substr(1)),l}r.asClassNameArray=E;function p(w){return E(w).join(" ")}r.asClassName=p;function h(w){return"."+E(w).join(".")}r.asCSSSelector=h})(y=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(X[63],J([0,1,17,2]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(l){const o=l;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function b(l){const o=l;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=b;function M(l,o){return new n(l,o)}e.newWriteableStream=M;class n{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,m.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(!this.state.destroyed){let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(c);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,o){const c=[];let t;for(;(t=l.read())!==null;)c.push(t);return o(c)}e.consumeReadable=S;function y(l,o,c){const t=[];let i;for(;(i=l.read())!==null&&t.length<c;)t.push(i);return i===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return l.read()}}}e.peekReadable=y;function r(l,o){return new Promise((c,t)=>{const i=[];g(l,{onData:s=>{o&&i.push(s)},onError:s=>{o?t(s):c(void 0)},onEnd:()=>{c(o?o(i):void 0)}})})}e.consumeStream=r;function g(l,o){l.on("error",c=>o.onError(c)),l.on("end",()=>o.onEnd()),l.on("data",c=>o.onData(c))}e.listenStream=g;function E(l,o){return new Promise((c,t)=>{const i=new A.DisposableStore,s=[],u=v=>{if(s.push(v),s.length>o)return i.dispose(),l.pause(),c({stream:l,buffer:s,ended:!1})},d=v=>t(v),f=()=>c({stream:l,buffer:s,ended:!0});i.add((0,A.toDisposable)(()=>l.removeListener("error",d))),l.on("error",d),i.add((0,A.toDisposable)(()=>l.removeListener("end",f))),l.on("end",f),i.add((0,A.toDisposable)(()=>l.removeListener("data",u))),l.on("data",u)})}e.peekStream=E;function p(l,o){const c=M(o);return c.end(l),c}e.toStream=p;function h(){const l=M(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=h;function w(l){let o=!1;return{read:()=>o?null:(o=!0,l)}}e.toReadable=w;function P(l,o,c){const t=M(c);return g(l,{onData:i=>t.write(o.data(i)),onError:i=>t.error(o.error?o.error(i):i),onEnd:()=>t.end()}),t}e.transform=P;function I(l,o,c){let t=!1;return{read:()=>{const i=o.read();return t?i:(t=!0,i!==null?c([l,i]):l)}}}e.prefixedReadable=I;function a(l,o,c){let t=!1;const i=M(c);return g(o,{onData:s=>t?i.write(s):(t=!0,i.write(c([l,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(l)),i.end()}}),i}e.prefixedStream=a}),define(X[22],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=m;const A=/{(\d+)}/g;function L(K,...te){return te.length===0?K:K.replace(A,function(oe,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=te.length?oe:te[de]})}e.format=L;function b(K){return K.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=b;function M(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=M;function n(K,te){let oe=0;const le=te.charCodeAt(0);for(let de=K.length-1;de>=0;de--)K.charCodeAt(de)===le&&oe++;return oe}e.count=n;function S(K,te,oe="\u2026"){return K.length<=te?K:`${K.substr(0,te)}${oe}`}e.truncate=S;function y(K,te=" "){const oe=r(K,te);return g(oe,te)}e.trim=y;function r(K,te){if(!K||!te)return K;const oe=te.length;if(oe===0||K.length===0)return K;let le=0;for(;K.indexOf(te,le)===le;)le=le+oe;return K.substring(le)}e.ltrim=r;function g(K,te){if(!K||!te)return K;const oe=te.length,le=K.length;if(oe===0||le===0)return K;let de=le,pe=-1;for(;pe=K.lastIndexOf(te,de-1),!(pe===-1||pe+oe!==de);){if(pe===0)return"";de=pe}return K.substring(0,de)}e.rtrim=g;function E(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function h(K,te,oe={}){if(!K)throw new Error("Cannot create regex from empty string");te||(K=M(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(K,le)}e.createRegExp=h;function w(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function P(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function I(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=I;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function l(K){for(let te=0,oe=K.length;te<oe;te++){const le=K.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=l;function o(K,te=0,oe=K.length){for(let le=te;le<oe;le++){const de=K.charCodeAt(le);if(de!==32&&de!==9)return K.substring(te,le)}return K.substring(te,oe)}e.getLeadingWhitespace=o;function c(K,te=K.length-1){for(let oe=te;oe>=0;oe--){const le=K.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=c;function t(K,te){return K<te?-1:K>te?1:0}e.compare=t;function i(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce<Ne)return-1;if(Ce>Ne)return 1}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstring=i;function s(K,te){return u(K,te,0,K.length,0,te.length)}e.compareIgnoreCase=s;function u(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce!==Ne){const qe=Ce-Ne;if(!(qe===32&&f(Ne))&&!(qe===-32&&f(Ce)))return d(Ce)&&d(Ne)?qe:i(K.toLowerCase(),te.toLowerCase(),oe,le,de,pe)}}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstringIgnoreCase=u;function d(K){return K>=97&&K<=122}e.isLowerAsciiLetter=d;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function v(K){return d(K)||f(K)}function D(K,te){return K.length===te.length&&_(K,te)}e.equalsIgnoreCase=D;function _(K,te,oe=K.length){for(let le=0;le<oe;le++){const de=K.charCodeAt(le),pe=te.charCodeAt(le);if(de!==pe){if(v(de)&&v(pe)){const Ie=Math.abs(de-pe);if(Ie!==0&&Ie!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(pe).toLowerCase())return!1}}return!0}function U(K,te){const oe=te.length;return te.length>K.length?!1:_(K,te,oe)}e.startsWithIgnoreCase=U;function H(K,te){let oe,le=Math.min(K.length,te.length);for(oe=0;oe<le;oe++)if(K.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return le}e.commonPrefixLength=H;function Q(K,te){let oe,le=Math.min(K.length,te.length);const de=K.length-1,pe=te.length-1;for(oe=0;oe<le;oe++)if(K.charCodeAt(de-oe)!==te.charCodeAt(pe-oe))return oe;return le}e.commonSuffixLength=Q;function ie(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ie;function ae(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ae;function O(K,te){return(K-55296<<10)+(te-56320)+65536}e.computeCodePoint=O;function $(K,te,oe){const le=K.charCodeAt(oe);if(ie(le)&&oe+1<te){const de=K.charCodeAt(oe+1);if(ae(de))return O(le,de)}return le}e.getNextCodePoint=$;function z(K,te){const oe=K.charCodeAt(te-1);if(ae(oe)&&te>1){const le=K.charCodeAt(te-2);if(ie(le))return O(le,oe)}return oe}function C(K,te){const oe=ze.getInstance(),le=te,de=K.length,pe=$(K,de,te);te+=pe>=65536?2:1;let Ie=oe.getGraphemeBreakType(pe);for(;te<de;){const Oe=$(K,de,te),Ce=oe.getGraphemeBreakType(Oe);if(Ke(Ie,Ce))break;te+=Oe>=65536?2:1,Ie=Ce}return te-le}e.nextCharLength=C;function j(K,te){const oe=ze.getInstance(),le=te,de=z(K,te);te-=de>=65536?2:1;let pe=oe.getGraphemeBreakType(de);for(;te>0;){const Ie=z(K,te),Oe=oe.getGraphemeBreakType(Ie);if(Ke(Oe,pe))break;te-=Ie>=65536?2:1,pe=Oe}return le-te}e.prevCharLength=j;function N(K,te){const oe=ze.getInstance(),le=K.length,de=te,pe=$(K,le,te),Ie=oe.getGraphemeBreakType(pe);te+=pe>=65536?2:1;let Oe=Ie;for(;te<le;){const Ne=$(K,le,te),qe=oe.getGraphemeBreakType(Ne);if(Ke(Oe,qe))break;te+=Ne>=65536?2:1,Oe=qe}const Ce=te;for(te=de,Oe=Ie;te>0;){const Ne=z(K,te),qe=oe.getGraphemeBreakType(Ne);if(Ke(qe,Oe))break;te-=Ne>=65536?2:1,Oe=qe}return[te,Ce]}function T(K,te){return te>0&&ae(K.charCodeAt(te))?N(K,te-1):N(K,te)}e.getCharContainingOffset=T;function R(K){const te=K.length;let oe=0,le=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?oe+=1:Ie<2048?oe+=2:Ie<65536?oe+=3:oe+=4}const de=new Uint8Array(oe);le=0;let pe=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?de[pe++]=Ie:Ie<2048?(de[pe++]=192|(Ie&1984)>>>6,de[pe++]=128|(Ie&63)>>>0):Ie<65536?(de[pe++]=224|(Ie&61440)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0):(de[pe++]=240|(Ie&1835008)>>>18,de[pe++]=128|(Ie&258048)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0)}return de}e.encodeUTF8=R;function W(K){const te=K.byteLength,oe=[];let le=0;for(;le<te;){const de=K[le];let pe;if(de>=240&&le+3<te?pe=(K[le++]&7)<<18>>>0|(K[le++]&63)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=224&&le+2<te?pe=(K[le++]&15)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=192&&le+1<te?pe=(K[le++]&31)<<6>>>0|(K[le++]&63)<<0>>>0:pe=K[le++],pe>=0&&pe<=55295||pe>=57344&&pe<=65535)oe.push(String.fromCharCode(pe));else if(pe>=65536&&pe<=1114111){const Ie=pe-65536,Oe=55296+((Ie&1047552)>>>10),Ce=56320+((Ie&1023)>>>0);oe.push(String.fromCharCode(Oe)),oe.push(String.fromCharCode(Ce))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=W;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(K){return k.test(K)}e.containsRTL=F;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(K){return B.test(K)}e.containsEmoji=V;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return G.test(K)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Z;function re(K){for(let te=0,oe=K.length;te<oe;te++)if(se(K.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function se(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=se;function x(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=x;function ne(K,te){if(K.length<te)return K;const oe=/\b/g;let le=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<te);)le=oe.lastIndex,oe.lastIndex+=1;return K.substring(le).replace(/^\s/,"")}e.lcut=ne;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(K){return K&&(K=K.replace(ue,""),K=K.replace(ye,""),K=K.replace(ge,"")),K}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function me(K,te){if(!K||!te||K.length<te.length)return!1;const oe=te.length,le=K.toLowerCase();let de=0,pe=-1;for(;de<oe;){const Ie=le.indexOf(te[de],pe+1);if(Ie<0)return!1;pe=Ie,de++}return!0}e.fuzzyContains=me;function be(K,te=!1){return K?(te&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=be;function Te(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Te;function _e(K,te=1){if(te===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=_e;function Ye(K){const te=90-65+1;return K=K%(2*te),K<te?String.fromCharCode(97+K):String.fromCharCode(65+K-te)}e.singleLetterHash=Ye;function xe(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=xe;function Ke(K,te){return K===0?te!==5&&te!==7:K===2&&te===3?!1:K===4||K===2||K===3||te===4||te===2||te===3?!0:!(K===8&&(te===8||te===9||te===11||te===12)||(K===11||K===9)&&(te===9||te===10)||(K===12||K===10)&&te===10||te===5||te===13||te===7||K===1||K===13&&te===14||K===6&&te===6)}e.breakBetweenGraphemeBreakType=Ke;var ot;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=nt()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,le=oe.length/3;let de=1;for(;de<=le;)if(te<oe[3*de])de=2*de;else if(te>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}ze._INSTANCE=null;function nt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(X[23],J([0,1,22,63]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",M=typeof TextDecoder!="undefined";let n,S;class y{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return L?new y(Buffer.allocUnsafe(v)):new y(new Uint8Array(v))}static wrap(v){return L&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new y(v)}static fromString(v,D){return!((D==null?void 0:D.dontUseNodeBuffer)||!1)&&L?new y(Buffer.from(v)):b?(n||(n=new TextEncoder),new y(n.encode(v))):new y(m.encodeUTF8(v))}static concat(v,D){if(typeof D=="undefined"){D=0;for(let H=0,Q=v.length;H<Q;H++)D+=v[H].byteLength}const _=y.alloc(D);let U=0;for(let H=0,Q=v.length;H<Q;H++){const ie=v[H];_.set(ie,U),U+=ie.byteLength}return _}toString(){return L?this.buffer.toString():M?(S||(S=new TextDecoder),S.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(v,D){return new y(this.buffer.subarray(v,D))}set(v,D){v instanceof y?this.buffer.set(v.buffer,D):this.buffer.set(v,D)}readUInt32BE(v){return E(this.buffer,v)}writeUInt32BE(v,D){p(this.buffer,v,D)}readUInt32LE(v){return h(this.buffer,v)}writeUInt32LE(v,D){w(this.buffer,v,D)}readUInt8(v){return P(this.buffer,v)}writeUInt8(v,D){I(this.buffer,v,D)}}e.VSBuffer=y;function r(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0}e.readUInt16LE=r;function g(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255}e.writeUInt16LE=g;function E(f,v){return f[v]*2**24+f[v+1]*2**16+f[v+2]*2**8+f[v+3]}e.readUInt32BE=E;function p(f,v,D){f[D+3]=v,v=v>>>8,f[D+2]=v,v=v>>>8,f[D+1]=v,v=v>>>8,f[D]=v}e.writeUInt32BE=p;function h(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0|f[v+2]<<16>>>0|f[v+3]<<24>>>0}e.readUInt32LE=h;function w(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255,v=v>>>8,f[D+2]=v&255,v=v>>>8,f[D+3]=v&255}e.writeUInt32LE=w;function P(f,v){return f[v]}e.readUInt8=P;function I(f,v,D){f[D]=v}e.writeUInt8=I;function a(f){return A.consumeReadable(f,v=>y.concat(v))}e.readableToBuffer=a;function l(f){return A.toReadable(f)}e.bufferToReadable=l;function o(f){return A.consumeStream(f,v=>y.concat(v))}e.streamToBuffer=o;async function c(f){return f.ended?y.concat(f.buffer):y.concat([...f.buffer,await o(f.stream)])}e.bufferedStreamToBuffer=c;function t(f){return A.toStream(f,v=>y.concat(v))}e.bufferToStream=t;function i(f){return A.transform(f,{data:v=>typeof v=="string"?y.fromString(v):y.wrap(v)},v=>y.concat(v))}e.streamToBufferReadableStream=i;function s(f){return A.newWriteableStream(v=>y.concat(v),f)}e.newWriteableBufferStream=s;function u(f,v){return A.prefixedReadable(f,v,D=>y.concat(D))}e.prefixedBufferReadable=u;function d(f,v){return A.prefixedStream(f,v,D=>y.concat(D))}e.prefixedBufferStream=d}),define(X[80],J([0,1,22]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(I){return L(I,0)}e.hash=A;function L(I,a){switch(typeof I){case"object":return I===null?b(349,a):Array.isArray(I)?S(I,a):y(I,a);case"string":return n(I,a);case"boolean":return M(I,a);case"number":return b(I,a);case"undefined":return b(937,a);default:return b(617,a)}}e.doHash=L;function b(I,a){return(a<<5)-a+I|0}function M(I,a){return b(I?433:863,a)}function n(I,a){a=b(149417,a);for(let l=0,o=I.length;l<o;l++)a=b(I.charCodeAt(l),a);return a}e.stringHash=n;function S(I,a){return a=b(104579,a),I.reduce((l,o)=>L(o,l),a)}function y(I,a){return a=b(181387,a),Object.keys(I).sort().reduce((l,o)=>(l=n(o,l),L(I[o],l)),a)}class r{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=L(a,this._value),this._value}}e.Hasher=r;var g;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function E(I,a,l=32){const o=l-a,c=~((1<<o)-1);return(I<<a|(c&I)>>>o)>>>0}function p(I,a=0,l=I.byteLength,o=0){for(let c=0;c<l;c++)I[a+c]=o}function h(I,a,l="0"){for(;I.length<a;)I=l+I;return I}function w(I,a=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(l=>l.toString(16).padStart(2,"0")).join(""):h((I>>>0).toString(16),a/4)}e.toHexString=w;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const l=a.length;if(l!==0){const o=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=a.charCodeAt(0),s=0);;){let u=i;if(m.isHighSurrogate(i))if(s+1<l){const d=a.charCodeAt(s+1);m.isLowSurrogate(d)?(s++,u=m.computeCodePoint(i,d)):u=65533}else{t=i;break}else m.isLowSurrogate(i)&&(u=65533);if(c=this._push(o,c,u),s++,s<l)i=a.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(a,l,o){return o<128?a[l++]=o:o<2048?(a[l++]=192|(o&1984)>>>6,a[l++]=128|(o&63)>>>0):o<65536?(a[l++]=224|(o&61440)>>>12,a[l++]=128|(o&4032)>>>6,a[l++]=128|(o&63)>>>0):(a[l++]=240|(o&1835008)>>>18,a[l++]=128|(o&258048)>>>12,a[l++]=128|(o&4032)>>>6,a[l++]=128|(o&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=P._bigBlock32,l=this._buffDV;for(let v=0;v<64;v+=4)a.setUint32(v,l.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)a.setUint32(v,E(a.getUint32(v-12,!1)^a.getUint32(v-32,!1)^a.getUint32(v-56,!1)^a.getUint32(v-64,!1),1),!1);let o=this._h0,c=this._h1,t=this._h2,i=this._h3,s=this._h4,u,d,f;for(let v=0;v<80;v++)v<20?(u=c&t|~c&i,d=1518500249):v<40?(u=c^t^i,d=1859775393):v<60?(u=c&t|c&i|t&i,d=2400959708):(u=c^t^i,d=3395469782),f=E(o,5)+u+s+d+a.getUint32(v*4,!1)&4294967295,s=i,i=t,t=E(c,30),c=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[12],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(v){return Array.isArray(v)}e.isArray=m;function A(v){return typeof v=="string"}e.isString=A;function L(v){return Array.isArray(v)&&v.every(D=>A(D))}e.isStringArray=L;function b(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=b;function M(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=M;function n(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=n;function S(v){return v===!0||v===!1}e.isBoolean=S;function y(v){return typeof v=="undefined"}e.isUndefined=y;function r(v){return!g(v)}e.isDefined=r;function g(v){return y(v)||v===null}e.isUndefinedOrNull=g;function E(v,D){if(!v)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=E;function p(v){if(g(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=p;function h(...v){const D=[];for(let _=0;_<v.length;_++){const U=v[_];if(g(U))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);D.push(U)}return D}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function P(v){if(!b(v))return!1;for(let D in v)if(w.call(v,D))return!1;return!0}e.isEmptyObject=P;function I(v){return typeof v=="function"}e.isFunction=I;function a(...v){return v.length>0&&v.every(I)}e.areFunctions=a;function l(v,D){const _=Math.min(v.length,D.length);for(let U=0;U<_;U++)o(v[U],D[U])}e.validateConstraints=l;function o(v,D){if(A(D)){if(typeof v!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(I(D)){try{if(v instanceof D)return}catch(_){}if(!g(v)&&v.constructor===D||D.length===1&&D.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(v){let D=[],_=Object.getPrototypeOf(v);for(;Object.prototype!==_;)D=D.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return D}e.getAllPropertyNames=c;function t(v){const D=[];for(const _ of c(v))typeof v[_]=="function"&&D.push(_);return D}e.getAllMethodNames=t;function i(v,D){const _=H=>function(){const Q=Array.prototype.slice.call(arguments,0);return D(H,Q)};let U={};for(const H of v)U[H]=_(H);return U}e.createProxyObject=i;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function u(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=u;function d(v){return class{constructor(){return new Proxy({},{get(D,_){if(D[_])return D[_];throw new Error(`Not Implemented: ${v}->${String(_)}`)}})}}}e.NotImplementedProxy=d;function f(v){throw new Error("Unreachable")}e.assertNever=f}),define(X[30],J([0,1,3,22,8,12]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function M(i){return i===47||i===92}e.isPathSeparator=M;function n(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=n;function S(i,s=L.posix.sep){if(!i)return"";const u=i.length,d=i.charCodeAt(0);if(M(d)){if(M(i.charCodeAt(1))&&!M(i.charCodeAt(2))){let v=3;const D=v;for(;v<u&&!M(i.charCodeAt(v));v++);if(D!==v&&!M(i.charCodeAt(v+1))){for(v+=1;v<u;v++)if(M(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,s)}}return s}else if(P(d)&&i.charCodeAt(1)===58)return M(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(M(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=S;function y(i){if(!m.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let u=2;const d=u;for(;u<i.length&&(s=i.charCodeAt(u),s!==92);u++);return!(d===u||(s=i.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=y;const r=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(i,s=m.isWindows){const u=s?r:g;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||s&&E.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=p;function h(i,s,u){const d=i===s;return!u||d?d:!i||!s?!1:(0,A.equalsIgnoreCase)(i,s)}e.isEqual=h;function w(i,s,u,d=L.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(u){if(!(0,A.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let v=s.length;return s.charAt(s.length-1)===d&&v--,i.charAt(v)===d}return s.charAt(s.length-1)!==d&&(s+=d),i.indexOf(s)===0}e.isEqualOrParent=w;function P(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=P;function I(i,s){return m.isWindows&&i.endsWith(":")&&(i+=L.sep),(0,L.isAbsolute)(i)||(i=(0,L.join)(s,i)),i=(0,L.normalize)(i),m.isWindows?(i=(0,A.rtrim)(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=(0,A.rtrim)(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=I;function a(i){const s=(0,L.normalize)(i);return m.isWindows?i.length>3?!1:l(s)&&(i.length===2||s.charCodeAt(2)===92):s===L.posix.sep}e.isRootOrDriveLetter=a;function l(i){return m.isWindows?P(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function o(i){return l(i)?i[0]:void 0}e.getDriveLetter=o;function c(i,s,u){return s.length>i.length?-1:i===s?0:(u&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=c;function t(i){const s=i.split(":");let u,d,f;if(s.forEach(v=>{const D=Number(v);(0,b.isNumber)(D)?d===void 0?d=D:f===void 0&&(f=D):u=u?[u,v].join(":"):v}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(X[44],J([0,1,12]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const w=Array.isArray(h)?[]:{};return Object.keys(h).forEach(P=>{h[P]&&typeof h[P]=="object"?w[P]=A(h[P]):w[P]=h[P]}),w}e.deepClone=A;function L(h){if(!h||typeof h!="object")return h;const w=[h];for(;w.length>0;){const P=w.shift();Object.freeze(P);for(const I in P)if(b.call(P,I)){const a=P[I];typeof a=="object"&&!Object.isFrozen(a)&&w.push(a)}}return h}e.deepFreeze=L;const b=Object.prototype.hasOwnProperty;function M(h,w){return n(h,w,new Set)}e.cloneAndChange=M;function n(h,w,P){if((0,m.isUndefinedOrNull)(h))return h;const I=w(h);if(typeof I!="undefined")return I;if((0,m.isArray)(h)){const a=[];for(const l of h)a.push(n(l,w,P));return a}if((0,m.isObject)(h)){if(P.has(h))throw new Error("Cannot clone recursive data-structure");P.add(h);const a={};for(let l in h)b.call(h,l)&&(a[l]=n(h[l],w,P));return P.delete(h),a}return h}function S(h,w,P=!0){return(0,m.isObject)(h)?((0,m.isObject)(w)&&Object.keys(w).forEach(I=>{I in h?P&&((0,m.isObject)(h[I])&&(0,m.isObject)(w[I])?S(h[I],w[I],P):h[I]=w[I]):h[I]=w[I]}),h):w}e.mixin=S;function y(h,w){if(h===w)return!0;if(h==null||w===null||w===void 0||typeof h!=typeof w||typeof h!="object"||Array.isArray(h)!==Array.isArray(w))return!1;let P,I;if(Array.isArray(h)){if(h.length!==w.length)return!1;for(P=0;P<h.length;P++)if(!y(h[P],w[P]))return!1}else{const a=[];for(I in h)a.push(I);a.sort();const l=[];for(I in w)l.push(I);if(l.sort(),!y(a,l))return!1;for(P=0;P<a.length;P++)if(!y(h[a[P]],w[a[P]]))return!1}return!0}e.equals=y;function r(h){const w=new Set;return JSON.stringify(h,(P,I)=>{if((0,m.isObject)(I)||Array.isArray(I)){if(w.has(I))return"[Circular]";w.add(I)}return I})}e.safeStringify=r;function g(h,w,P){const I=w(h);return typeof I=="undefined"?P:I}e.getOrDefault=g;function E(h,w){const P=Object.create(null);return!h||!w||Object.keys(w).forEach(a=>{const l=h[a],o=w[a];y(l,o)||(P[a]=o)}),P}e.distinct=E;function p(h,w){const P=w.toLowerCase(),I=Object.keys(h).find(a=>a.toLowerCase()===P);return I?h[I]:h[w]}e.getCaseInsensitive=p}),define(X[7],J([0,1,3,8]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,b=/^\//,M=/^\/\//;function n(s,u){if(!s.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!b.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,u){return!s&&!u?"file":s}function y(s,u){switch(s){case"https":case"http":case"file":u?u[0]!==g&&(u=g+u):u=g;break}return u}const r="",g="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(u,d,f,v,D,_=!1){typeof u=="object"?(this.scheme=u.scheme||r,this.authority=u.authority||r,this.path=u.path||r,this.query=u.query||r,this.fragment=u.fragment||r):(this.scheme=S(u,_),this.authority=d||r,this.path=y(this.scheme,f||r),this.query=v||r,this.fragment=D||r,n(this,_))}static isUri(u){return u instanceof p?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return l(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:f,path:v,query:D,fragment:_}=u;return d===void 0?d=this.scheme:d===null&&(d=r),f===void 0?f=this.authority:f===null&&(f=r),v===void 0?v=this.path:v===null&&(v=r),D===void 0?D=this.query:D===null&&(D=r),_===void 0?_=this.fragment:_===null&&(_=r),d===this.scheme&&f===this.authority&&v===this.path&&D===this.query&&_===this.fragment?this:new w(d,f,v,D,_)}static parse(u,d=!1){const f=E.exec(u);return f?new w(f[2]||r,i(f[4]||r),i(f[5]||r),i(f[7]||r),i(f[9]||r),d):new w(r,r,r,r,r)}static file(u){let d=r;if(m.isWindows&&(u=u.replace(/\\/g,g)),u[0]===g&&u[1]===g){const f=u.indexOf(g,2);f===-1?(d=u.substring(2),u=g):(d=u.substring(2,f),u=u.substring(f)||g)}return new w("file",d,u,r,r)}static from(u){return new w(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&u.scheme==="file"?f=p.file(A.win32.join(l(u,!0),...d)).path:f=A.posix.join(u.path,...d),u.with({path:f})}toString(u=!1){return o(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof p)return u;{const d=new w(u);return d._formatted=u.external,d._fsPath=u._sep===h?u.fsPath:null,d}}else return u}}e.URI=p;const h=m.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(u=!1){return u?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=h),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(s,u){let d,f=-1;for(let v=0;v<s.length;v++){const D=s.charCodeAt(v);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||u&&D===47)f!==-1&&(d+=encodeURIComponent(s.substring(f,v)),f=-1),d!==void 0&&(d+=s.charAt(v));else{d===void 0&&(d=s.substr(0,v));const _=P[D];_!==void 0?(f!==-1&&(d+=encodeURIComponent(s.substring(f,v)),f=-1),d+=_):f===-1&&(f=v)}}return f!==-1&&(d+=encodeURIComponent(s.substring(f))),d!==void 0?d:s}function a(s){let u;for(let d=0;d<s.length;d++){const f=s.charCodeAt(d);f===35||f===63?(u===void 0&&(u=s.substr(0,d)),u+=P[f]):u!==void 0&&(u+=s[d])}return u!==void 0?u:s}function l(s,u){let d;return s.authority&&s.path.length>1&&s.scheme==="file"?d=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?u?d=s.path.substr(1):d=s.path[1].toLowerCase()+s.path.substr(2):d=s.path,m.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=l;function o(s,u){const d=u?a:I;let f="",{scheme:v,authority:D,path:_,query:U,fragment:H}=s;if(v&&(f+=v,f+=":"),(D||v==="file")&&(f+=g,f+=g),D){let Q=D.indexOf("@");if(Q!==-1){const ie=D.substr(0,Q);D=D.substr(Q+1),Q=ie.indexOf(":"),Q===-1?f+=d(ie,!1):(f+=d(ie.substr(0,Q),!1),f+=":",f+=d(ie.substr(Q+1),!1)),f+="@"}D=D.toLowerCase(),Q=D.indexOf(":"),Q===-1?f+=d(D,!1):(f+=d(D.substr(0,Q),!1),f+=D.substr(Q))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const Q=_.charCodeAt(1);Q>=65&&Q<=90&&(_=`/${String.fromCharCode(Q+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const Q=_.charCodeAt(0);Q>=65&&Q<=90&&(_=`${String.fromCharCode(Q+32)}:${_.substr(2)}`)}f+=d(_,!0)}return U&&(f+="?",f+=d(U,!1)),H&&(f+="#",f+=u?H:I(H,!1)),f}function c(s){try{return decodeURIComponent(s)}catch(u){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,u=>c(u)):s}}),define(X[106],J([0,1,7]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(y){const r=y;return r&&typeof r.type=="string"&&typeof r.severity=="string"}e.isRemoteConsoleLog=A;function L(y){const r=[];let g;try{const E=JSON.parse(y.arguments),p=E[E.length-1];p&&p.__$stack&&(E.pop(),g=p.__$stack),r.push(...E)}catch(E){r.push("Unable to log remote console arguments",y.arguments)}return{args:r,stack:g}}e.parse=L;function b(y){if(typeof y!="string")return b(L(y).stack);const r=y;if(r){const g=M(r),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(E&&E.length===4)return{uri:m.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=b;function M(y){if(!y)return y;const r=y.indexOf(`
`);return r===-1?y:y.substring(0,r)}function n(y,r){const{args:g,stack:E}=L(y),p=typeof g[0]=="string"&&g.length===1;let h=M(E);h&&(h=`(${h.trim()})`);let w=[];if(typeof g[0]=="string"?h&&p?w=[`%c[${r}] %c${g[0]} %c${h}`,S("blue"),S(""),S("grey")]:w=[`%c[${r}] %c${g[0]}`,S("blue"),S(""),...g.slice(1)]:w=[`%c[${r}]%`,S("blue"),...g],h&&!p&&w.push(h),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,w)}e.log=n;function S(y){return`color: ${y}`}});var yt=this&&this.__classPrivateFieldSet||function(q,e,m,A,L){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?q!==e||!L:!e.has(q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?L.call(q,m):L?L.value=m:e.set(q,m),m},Ge=this&&this.__classPrivateFieldGet||function(q,e,m,A){if(m==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?q!==e||!A:!e.has(q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?A:m==="a"?A.call(q):A?A.value:e.get(q)};define(X[36],J([0,1,7,22]),function(q,e,m,A){"use strict";var L,b,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,i,s){let u=t.get(i);return u===void 0&&(u=s,t.set(i,u)),u}e.getOrSet=n;function S(t){const i=[];return t.forEach((s,u)=>{i.push(`${u} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=S;function y(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=y;class r{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=r;class g{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class E{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,A.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(i){this._iter=i}static forUris(i=()=>!1){return new P(new h(i))}static forPaths(){return new P(new E)}static forStrings(){return new P(new r)}static forConfigKeys(){return new P(new g)}clear(){this._root=void 0}set(i,s){const u=this._iter.reset(i);let d;for(this._root||(this._root=new w,this._root.segment=u.value()),d=this._root;;){const v=u.cmp(d.segment);if(v>0)d.left||(d.left=new w,d.left.segment=u.value()),d=d.left;else if(v<0)d.right||(d.right=new w,d.right.segment=u.value()),d=d.right;else if(u.hasNext())u.next(),d.mid||(d.mid=new w,d.mid.segment=u.value()),d=d.mid;else break}const f=d.value;return d.value=s,d.key=i,f}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const u=this._iter.reset(i),d=[];let f=this._root;for(;f;){const v=u.cmp(f.segment);if(v>0)d.push([1,f]),f=f.left;else if(v<0)d.push([-1,f]),f=f.right;else if(u.hasNext())u.next(),d.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;d.length>0&&f.isEmpty();){let[D,_]=d.pop();switch(D){case 1:_.left=void 0;break;case 0:_.mid=void 0;break;case-1:_.right=void 0;break}f=_}break}}}findSubstr(i){const s=this._iter.reset(i);let u=this._root,d;for(;u;){const f=s.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(s.hasNext())s.next(),d=u.value||d,u=u.mid;else break}return u&&u.value||d}findSuperstr(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[s,u]of this)i(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=P;class I{constructor(i,s){this[L]="ResourceMap",i instanceof I?(this.map=new Map(i.map),this.toKey=s!=null?s:I.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:I.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[u,d]of this.map)i(d,m.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=I,I.defaultToKey=t=>t.toString();var a;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const u=this._map.get(i);if(!!u)return s!==0&&this.touch(u,s),u.value}set(i,s,u=0){let d=this._map.get(i);if(d)d.value=s,u!==0&&this.touch(d,u);else{switch(d={key:i,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(i,d),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,s){const u=this._state;let d=this._head;for(;d;){if(s?i.bind(s)(d.value,d.key,this):i(d.value,d.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const i=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return d}values(){const i=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return d}entries(){const i=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return d}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>i;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,u=i.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const u=i.next,d=i.previous;i===this._tail?(d.next=void 0,this._tail=d):(u.previous=d,d.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const u=i.next,d=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=d,d.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,u)=>{i.push([u,s])}),i}fromJSON(i){this.clear();for(const[s,u]of i)this.set(s,u)}}e.LinkedMap=l;class o extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class c{constructor(i){M.set(this,void 0),yt(this,M,i,"f")}get size(){return Ge(this,M,"f").size}forEach(i,s){Ge(this,M,"f").forEach(i,s)}get(i){return Ge(this,M,"f").get(i)}has(i){return Ge(this,M,"f").has(i)}entries(){return Ge(this,M,"f").entries()}keys(){return Ge(this,M,"f").keys()}values(){return Ge(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ge(this,M,"f").entries()}}e.ReadonlyMapView=c}),define(X[107],J([0,1,23,22,7]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(y){return JSON.stringify(y,n)}e.stringify=b;function M(y){let r=JSON.parse(y);return r=S(r),r}e.parse=M;function n(y,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:(0,A.regExpFlags)(r)}:r}function S(y,r=0){if(!y||r>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return L.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof m.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let g=0;g<y.length;++g)y[g]=S(y[g],r+1);else for(const g in y)Object.hasOwnProperty.call(y,g)&&(y[g]=S(y[g],r+1))}return y}e.revive=S}),define(X[10],J([0,1,7,3]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file"})(L=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,y,r){this._hosts[S]=y,this._ports[S]=r}setConnectionToken(S,y){this._connectionTokens[S]=y}rewrite(S){if(this._delegate)return this._delegate(S);const y=S.authority;let r=this._hosts[y];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const g=this._ports[y],E=this._connectionTokens[y];let p=`path=${encodeURIComponent(S.path)}`;return typeof E=="string"&&(p+=`&tkn=${encodeURIComponent(E)}`),m.URI.from({scheme:A.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${r}:${g}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new b;class M{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,y,r){const g=this.toUri(S,y);return g.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(g):A.isNative&&(r||A.isPreferringBrowserCodeLoad)&&g.scheme===L.file?g.with({scheme:L.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(S,y){const r=this.toUri(S,y);return r.scheme===L.vscodeFileResource?r.with({scheme:L.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(S,y){return m.URI.isUri(S)?S:m.URI.parse(y.toUrl(S))}}e.FileAccess=new M}),define(X[64],J([0,1,36]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new m.LRUCache(1e4);function L(y){return S(y,"NFC",A)}e.normalizeNFC=L;const b=new m.LRUCache(1e4);function M(y){return S(y,"NFD",b)}e.normalizeNFD=M;const n=/[^\u0000-\u0080]/;function S(y,r,g){if(!e.canNormalize||!y)return y;const E=g.get(y);if(E)return E;let p;return n.test(y)?p=y.normalize(r):p=y,g.set(y,p),p}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(r){return M(r).replace(y,"")}}else return function(y){return y}}()}),define(X[15],J([0,1,30,8,7,22,10,3]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,L.uriToFsPath)(p,!0)}e.originalFSPath=S;class y{constructor(h){this._ignorePathCasing=h}compare(h,w,P=!1){return h===w?0:(0,b.compare)(this.getComparisonKey(h,P),this.getComparisonKey(w,P))}isEqual(h,w,P=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,P)===this.getComparisonKey(w,P)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,P=!1){if(h.scheme===w.scheme){if(h.scheme===M.Schemas.file)return m.isEqualOrParent(S(h),S(w),this._ignorePathCasing(h))&&h.query===w.query&&(P||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return m.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(P||h.fragment===w.fragment)}return!1}joinPath(h,...w){return L.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return A.posix.basename(h.path)}extname(h){return A.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===M.Schemas.file?w=L.URI.file(A.dirname(S(h))).path:(w=A.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===M.Schemas.file?w=L.URI.file(A.normalize(S(h))).path:w=A.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(!(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))){if(h.scheme===M.Schemas.file){const a=A.relative(S(h),S(w));return n.isWindows?m.toSlashes(a):a}let P=h.path||"/",I=w.path||"/";if(this._ignorePathCasing(h)){let a=0;for(const l=Math.min(P.length,I.length);a<l&&!(P.charCodeAt(a)!==I.charCodeAt(a)&&P.charAt(a).toLowerCase()!==I.charAt(a).toLowerCase());a++);P=I.substr(0,a)+P.substr(a)}return A.posix.relative(P,I)}}resolvePath(h,w){if(h.scheme===M.Schemas.file){const P=L.URI.file(A.resolve(S(h),w));return h.with({authority:P.authority,path:P.path})}return w.indexOf("/")===-1&&(w=m.toSlashes(w),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w)),h.with({path:A.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||(0,b.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=A.sep){if(h.scheme===M.Schemas.file){const P=S(h);return P.length>m.getRoot(P).length&&P[P.length-1]===w}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=A.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=A.sep){let P=!1;if(h.scheme===M.Schemas.file){const I=S(h);P=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===w}else{w="/";const I=h.path;P=I.length===1&&I.charCodeAt(I.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===M.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(p,h){const w=[];for(let P=0;P<p.length;P++){const I=h(p[P]);p.some((a,l)=>l===P?!1:(0,e.isEqualOrParent)(I,h(a)))||w.push(p[P])}return w}e.distinctParents=r;var g;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const P=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(l=>{const[o,c]=l.split(":");o&&c&&P.set(o,c)});const a=w.path.substring(0,w.path.indexOf(";"));return a&&P.set(p.META_DATA_MIME,a),P}p.parseMetaData=h})(g=e.DataUri||(e.DataUri={}));function E(p,h,w){if(h){let P=p.path;return P&&P[0]!==A.posix.sep&&(P=A.posix.sep+P),p.with({scheme:w,authority:h,path:P})}return p.with({scheme:w})}e.toLocalResource=E}),define(X[9],J([0,1,25,17,5,2,78,15]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(N){return!!N&&typeof N.then=="function"}e.isThenable=S;function y(N){const T=new m.CancellationTokenSource,R=N(T.token),W=new Promise((k,F)=>{T.token.onCancellationRequested(()=>{F((0,A.canceled)())}),Promise.resolve(R).then(B=>{T.dispose(),k(B)},B=>{T.dispose(),F(B)})});return new class{cancel(){T.cancel()}then(k,F){return W.then(k,F)}catch(k){return this.then(void 0,k)}finally(k){return W.finally(k)}}}e.createCancelablePromise=y;function r(N,T,R){return Promise.race([N,new Promise(W=>T.onCancellationRequested(()=>W(R)))])}e.raceCancellation=r;async function g(N){let T=-1;const R=N.map((k,F)=>k.then(B=>(T=F,B))),W=await Promise.race(R);return N.forEach((k,F)=>{F!==T&&k.cancel()}),W}e.raceCancellablePromises=g;function E(N,T,R){let W;const k=setTimeout(()=>{W==null||W(void 0),R==null||R()},T);return Promise.race([N.finally(()=>clearTimeout(k)),new Promise(F=>W=F)])}e.raceTimeout=E;function p(N){return new Promise((T,R)=>{const W=N();S(W)?W.then(T,R):T(W)})}e.asPromise=p;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(R,R).then(W)})}return new Promise((R,W)=>{this.queuedPromise.then(R,W)})}return this.activePromise=T(),new Promise((R,W)=>{this.activePromise.then(k=>{this.activePromise=null,R(k)},k=>{this.activePromise=null,W(k)})})}}e.Throttler=h;class w{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=w;class P{constructor(){this.promiseMap=new Map}queue(T,R){var W;const F=((W=this.promiseMap.get(T))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(T)===F&&this.promiseMap.delete(T)});return this.promiseMap.set(T,F),F}}e.SequencerByKey=P;class I{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,R=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,k)=>{this.doResolve=W,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=I;class a{constructor(T){this.delayer=new I(T),this.throttler=new h}trigger(T,R){return this.delayer.trigger(()=>this.throttler.queue(T),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class l{constructor(){this._isOpen=!1,this._promise=new Promise((T,R)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class o extends l{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function c(N,T){return T?new Promise((R,W)=>{const k=setTimeout(R,N);T.onCancellationRequested(()=>{clearTimeout(k),W((0,A.canceled)())})}):y(R=>c(N,R))}e.timeout=c;function t(N,T=0){const R=setTimeout(N,T);return(0,b.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=t;function i(N){return N.then(void 0,T=>{})}e.ignoreErrors=i;function s(N){const T=[];let R=0;const W=N.length;function k(){return R<W?N[R++]():null}function F(B){B!=null&&T.push(B);const V=k();return V?V.then(F):Promise.resolve(T)}return Promise.resolve(null).then(F)}e.sequence=s;function u(N,T=W=>!!W,R=null){let W=0;const k=N.length,F=()=>{if(W>=k)return Promise.resolve(R);const B=N[W++];return Promise.resolve(B()).then(G=>T(G)?Promise.resolve(G):F())};return F()}e.first=u;function d(N,T=W=>!!W,R=null){if(N.length===0)return Promise.resolve(R);let W=N.length;const k=()=>{var F,B;W=-1;for(const V of N)(B=(F=V).cancel)===null||B===void 0||B.call(F)};return new Promise((F,B)=>{for(const V of N)V.then(G=>{--W>=0&&T(G)?(k(),F(G)):W===0&&F(R)}).catch(G=>{--W>=0&&(k(),B(G))})})}e.firstParallel=d;class f{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((R,W)=>{this.outstandingPromises.push({factory:T,c:R,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const R=T.factory();R.then(T.c,T.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class D{constructor(){this.queues=new Map}queueFor(T,R=n.extUri){const W=R.getComparisonKey(T);let k=this.queues.get(W);return k||(k=new v,L.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(W)}),this.queues.set(W,k)),k}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=D;class _{constructor(T,R){this._token=-1,typeof T=="function"&&typeof R=="number"&&this.setIfNotSet(T,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},R)}setIfNotSet(T,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},R))}}e.TimeoutTimer=_;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,R){this.cancel(),this._token=setInterval(()=>{T()},R)}}e.IntervalTimer=U;class H{constructor(T,R){this.timeoutToken=-1,this.runner=T,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class Q extends H{constructor(T,R){super(T,R);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const R=setTimeout(()=>T(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,T)=>{const R=requestIdleCallback(N,typeof T=="number"?{timeout:T}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(R))}}}}();class ie{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ie;async function ae(N,T,R){let W;for(let k=0;k<R;k++)try{return await N()}catch(F){W=F,await c(T)}throw W}e.retry=ae;class O{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,R,W){return this._pending={taskId:T,cancel:()=>W==null?void 0:W(),promise:R},R.then(()=>this.donePending(T),()=>this.donePending(T)),R}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let R,W;const k=new Promise((F,B)=>{R=F,W=B});this._next={run:T,promise:k,promiseResolve:R,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=O;class ${constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,R)=>{this.completeCallback=T,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(R=>{this.completeCallback(T),this.resolved=!0,R()})}error(T){return new Promise(R=>{this.errorCallback(T),this.rejected=!0,R()})}cancel(){new Promise(T=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=z;class C extends L.Emitter{async fireAsync(T,R,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,T]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[k,F]=this._asyncDeliveryQueue.shift(),B=[],V=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof k=="function"?k:k[0])),B.push(G)}});try{typeof k=="function"?k.call(void 0,V):k[0].call(k[1],V)}catch(G){(0,A.onUnexpectedError)(G);continue}Object.freeze(B),await j.settled(B).catch(G=>(0,A.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var j;(function(N){async function T(F){return typeof Promise.allSettled=="function"?R(F):W(F)}N.allSettled=T;async function R(F){return Promise.allSettled(F)}async function W(F){return Promise.all(F.map(B=>B.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function k(F){let B;const V=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{B||(B=Y)})));if(typeof B!="undefined")throw B;return V}N.settled=k})(j=e.Promises||(e.Promises={}))}),define(X[108],J([0,1,22,30,8,36,9]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const S="**",y="/",r="[/\\\\]",g="[^/\\\\]",E=/\//g;function p(R){switch(R){case 0:return"";case 1:return`${g}*?`;default:return`(?:${r}|${g}+${r}|${r}${g}+)*?`}}function h(R,W){if(!R)return[];const k=[];let F=!1,B=!1,V="";for(const G of R){switch(G){case W:if(!F&&!B){k.push(V),V="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":B=!0;break;case"]":B=!1;break}V+=G}return V&&k.push(V),k}e.splitGlobAware=h;function w(R){if(!R)return"";let W="";const k=h(R,y);if(k.every(F=>F===S))W=".*";else{let F=!1;k.forEach((B,V)=>{if(B===S){F||(W+=p(2),F=!0);return}let G=!1,Y="",Z=!1,re="";for(const se of B){if(se!=="}"&&G){Y+=se;continue}if(Z&&(se!=="]"||!re)){let x;se==="-"?x=se:(se==="^"||se==="!")&&!re?x="^":se===y?x="":x=m.escapeRegExpCharacters(se),re+=x;continue}switch(se){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":W+=`(?:${h(Y,",").map(ue=>w(ue)).join("|")})`,G=!1,Y="";break;case"]":W+="["+re+"]",Z=!1,re="";break;case"?":W+=g;continue;case"*":W+=p(1);continue;default:W+=m.escapeRegExpCharacters(se)}}V<k.length-1&&(k[V+1]!==S||V+2<k.length)&&(W+=r),F=!1})}return W}const P=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),i=function(){return!1},s=function(){return null};function u(R,W){if(!R)return s;let k;typeof R!="string"?k=R.pattern:k=R,k=k.trim();const F=`${k}_${!!W.trimForExclusions}`;let B=t.get(F);if(B)return d(B,R);let V;if(P.test(k)){const G=k.substr(4);B=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?k:null}}else(V=I.exec(f(k,W)))?B=v(V[1],k):(W.trimForExclusions?l:a).test(k)?B=D(k,W):(V=o.exec(f(k,W)))?B=_(V[1].substr(1),k,!0):(V=c.exec(f(k,W)))?B=_(V[1],k,!1):B=U(k);return t.set(F,B),d(B,R)}function d(R,W){return typeof W=="string"?R:function(k,F){return A.isEqualOrParent(k,W.base)?R(L.relative(W.base,k),F):null}}function f(R,W){return W.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function v(R,W){const k=`/${R}`,F=`\\${R}`,B=function(G,Y){return typeof G!="string"?null:Y?Y===R?W:null:G===R||G.endsWith(k)||G.endsWith(F)?W:null},V=[R];return B.basenames=V,B.patterns=[W],B.allBasenames=V,B}function D(R,W){const k=T(R.slice(1,-1).split(",").map(Y=>u(Y,W)).filter(Y=>Y!==s),R),F=k.length;if(!F)return s;if(F===1)return k[0];const B=function(Y,Z){for(let re=0,se=k.length;re<se;re++)if(k[re](Y,Z))return R;return null},V=k.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function _(R,W,k){const F=L.sep===L.posix.sep,B=F?R:R.replace(E,L.sep),V=L.sep+B,G=L.posix.sep+R,Y=k?function(Z,re){return typeof Z=="string"&&(Z===B||Z.endsWith(V)||!F&&(Z===R||Z.endsWith(G)))?W:null}:function(Z,re){return typeof Z=="string"&&(Z===B||!F&&Z===R)?W:null};return Y.allPaths=[(k?"*/":"./")+R],Y}function U(R){try{const W=new RegExp(`^${w(R)}$`);return function(k){return W.lastIndex=0,typeof k=="string"&&W.test(k)?R:null}}catch(W){return s}}function H(R,W,k){return!R||typeof W!="string"?!1:Q(R)(W,void 0,k)}e.match=H;function Q(R,W={}){if(!R)return i;if(typeof R=="string"||$(R)){const k=u(R,W);if(k===s)return i;const F=function(B,V){return!!k(B,V)};return k.allBasenames&&(F.allBasenames=k.allBasenames),k.allPaths&&(F.allPaths=k.allPaths),F}return j(R,W)}e.parse=Q;function ie(R){if(!!R){let W;return k=>(W||(W=(R()||Promise.resolve([])).then(F=>F?O(F):{})),W.then(F=>!!F[k]))}}e.hasSiblingPromiseFn=ie;function ae(R){if(!!R){let W;return k=>{if(!W){const F=R();W=F?O(F):{}}return!!W[k]}}}e.hasSiblingFn=ae;function O(R){const W={};for(const k of R)W[k]=!0;return W}function $(R){const W=R;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function z(R){return R.allBasenames||[]}e.getBasenameTerms=z;function C(R){return R.allPaths||[]}e.getPathTerms=C;function j(R,W){const k=T(Object.getOwnPropertyNames(R).map(Y=>N(Y,R[Y],W)).filter(Y=>Y!==s)),F=k.length;if(!F)return s;if(!k.some(Y=>!!Y.requiresSiblings)){if(F===1)return k[0];const Y=function(se,x){for(let ne=0,ue=k.length;ne<ue;ne++){const ye=k[ne](se,x);if(ye)return ye}return null},Z=k.find(se=>!!se.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const re=k.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return re.length&&(Y.allPaths=re),Y}const B=function(Y,Z,re){let se;for(let x=0,ne=k.length;x<ne;x++){const ue=k[x];ue.requiresSiblings&&re&&(Z||(Z=L.basename(Y)),se||(se=Z.substr(0,Z.length-L.extname(Y).length)));const ye=ue(Y,Z,se,re);if(ye)return ye}return null},V=k.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function N(R,W,k){if(W===!1)return s;const F=u(R,k);if(F===s)return s;if(typeof W=="boolean")return F;if(W){const B=W.when;if(typeof B=="string"){const V=(G,Y,Z,re)=>{if(!re||!F(G,Y))return null;const se=B.replace("$(basename)",Z),x=re(se);return(0,M.isThenable)(x)?x.then(ne=>ne?R:null):x?R:null};return V.requiresSiblings=!0,V}}return F}function T(R,W){const k=R.filter(Y=>!!Y.basenames);if(k.length<2)return R;const F=k.reduce((Y,Z)=>{const re=Z.basenames;return re?Y.concat(re):Y},[]);let B;if(W){B=[];for(let Y=0,Z=F.length;Y<Z;Y++)B.push(W)}else B=k.reduce((Y,Z)=>{const re=Z.patterns;return re?Y.concat(re):Y},[]);const V=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let se;for(se=Y.length;se>0;se--){const x=Y.charCodeAt(se-1);if(x===47||x===92)break}Z=Y.substr(se)}const re=F.indexOf(Z);return re!==-1?B[re]:null};V.basenames=F,V.patterns=B,V.allBasenames=F;const G=R.filter(Y=>!Y.basenames);return G.push(V),G}}),define(X[39],J([0,1,7,8,22,10,3,15,30]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(u,d,f){if(typeof u=="string"&&(u=m.URI.file(u)),f){const D=f.getWorkspaceFolder(u);if(D){const _=f.getWorkspace().folders.length>1;let U;if((0,n.isEqual)(D.uri,u)?U="":U=(0,n.relativePath)(D.uri,u),_){const H=D.name?D.name:(0,n.basename)(D.uri);U=U?H+" \u2022 "+U:H}return U}}if(u.scheme!==b.Schemas.file&&u.scheme!==b.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(u.fsPath))return(0,A.normalize)(g(u.fsPath));let v=(0,A.normalize)(u.fsPath);return!M.isWindows&&(d==null?void 0:d.userHome)&&(v=p(v,d.userHome.fsPath)),v}e.getPathLabel=y;function r(u){if(!!u){typeof u=="string"&&(u=m.URI.file(u));const d=(0,n.basename)(u)||(u.scheme===b.Schemas.file?u.fsPath:u.path);return M.isWindows&&(0,S.isRootOrDriveLetter)(d)?g(d):d}}e.getBaseLabel=r;function g(u){return(0,S.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=g;let E=Object.create(null);function p(u,d){if(M.isWindows||!u||!d)return u;let f=E.original===d?E.normalized:void 0;return f||(f=`${(0,L.rtrim)(d,A.posix.sep)}${A.posix.sep}`,E={original:d,normalized:f}),(M.isLinux?u.startsWith(f):(0,L.startsWithIgnoreCase)(u,f))&&(u=`~/${u.substr(f.length)}`),u}e.tildify=p;function h(u,d){return u.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=h;const w="\u2026",P="\\\\",I="~";function a(u,d=A.sep){const f=new Array(u.length);let v=!1;for(let D=0;D<u.length;D++){let _=u[D];if(_===""){f[D]=`.${d}`;continue}if(!_){f[D]=_;continue}v=!0;let U="";_.indexOf(P)===0?(U=_.substr(0,_.indexOf(P)+P.length),_=_.substr(_.indexOf(P)+P.length)):_.indexOf(d)===0?(U=_.substr(0,_.indexOf(d)+d.length),_=_.substr(_.indexOf(d)+d.length)):_.indexOf(I)===0&&(U=_.substr(0,_.indexOf(I)+I.length),_=_.substr(_.indexOf(I)+I.length));const H=_.split(d);for(let Q=1;v&&Q<=H.length;Q++)for(let ie=H.length-Q;v&&ie>=0;ie--){v=!1;let ae=H.slice(ie,ie+Q).join(d);for(let O=0;!v&&O<u.length;O++)if(O!==D&&u[O]&&u[O].indexOf(ae)>-1){const $=ie+Q===H.length,z=ie>0&&u[O].indexOf(d)>-1?d+ae:ae,C=u[O].endsWith(z);v=!$||C}if(!v){let O="";(H[0].endsWith(":")||U!=="")&&(ie===1&&(ie=0,Q++,ae=H[0]+d+ae),ie>0&&(O=H[0]+d),O=U+O),ie>0&&(O=O+w+d),O=O+ae,ie+Q<H.length&&(O=O+d+w),f[D]=O}}v&&(f[D]=_)}return f}e.shorten=a;var l;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function o(u,d=Object.create(null)){const f=[];let v=!1,D="";for(const _ of u)if(_==="$"||v&&_==="{")D&&f.push({value:D,type:l.TEXT}),D="",v=!0;else if(_==="}"&&v){const U=d[D];if(typeof U=="string")U.length&&f.push({value:U,type:l.VARIABLE});else if(U){const H=f[f.length-1];(!H||H.type!==l.SEPARATOR)&&f.push({value:U.label,type:l.SEPARATOR})}D="",v=!1}else D+=_;return D&&!v&&f.push({value:D,type:l.TEXT}),f.filter((_,U)=>{if(_.type===l.SEPARATOR){const H=f[U-1],Q=f[U+1];return[H,Q].every(ie=>ie&&(ie.type===l.VARIABLE||ie.type===l.TEXT)&&ie.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=o;function c(u,d){return M.isMacintosh||d?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):u.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(u,d){return M.isMacintosh||d?u.replace(/\(&&\w\)|&&/g,""):M.isWindows?u.replace(/&&|&/g,f=>f==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(u){const d=u.indexOf("/")!==-1?A.posix:A.win32,f=d.basename(u),v=d.dirname(u);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(X[28],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(S){return m.test(S)}e.isUUID=A;const L=new Uint8Array(16),b=[];for(let S=0;S<256;S++)b.push(S.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(S){for(let y=0;y<S.length;y++)S[y]=Math.floor(Math.random()*256);return S};function n(){M(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,y="";return y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y}e.generateUuid=n}),define(X[109],J([0,1,18,58,42]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(M,n){if(await new Promise((r,g)=>{const E=m.createReadStream(M),p=A.createHash("sha1");E.pipe(p);const h=(0,L.once)((w,P)=>{E.removeAllListeners(),p.removeAllListeners(),w?g(w):r(P)});E.once("error",h),E.once("end",h),p.once("error",h),p.once("data",w=>h(void 0,w.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=b}),define(X[81],J([0,1,231]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(b="utf8"){this.stringDecoder=new m.StringDecoder(b),this.remaining=null}write(b){const M=[],n=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(n.length<1)return M;let S=0,y,r=S;for(;r<n.length;)if(y=n.charCodeAt(r),y===13||y===10){if(M.push(n.substring(S,r)),r++,r<n.length){const g=y;y=n.charCodeAt(r),(g===13&&y===10||g===10&&y===13)&&r++}S=r}else r++;return this.remaining=S<n.length?n.substr(S):null,M}end(){return this.remaining}}e.LineDecoder=A}),define(X[110],J([0,1,27]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(n){const S=n.replace(/\-/g,":").toLowerCase();return!A.has(S)}function b(){return new Promise(async(n,S)=>{const y=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await M())}catch(r){S(r)}finally{clearTimeout(y)}})}e.getMac=b;function M(){return new Promise((n,S)=>{try{const y=(0,m.networkInterfaces)();for(let r in y){const g=y[r];if(g){for(const{mac:E}of g)if(L(E))return n(E)}}S("Unable to retrieve mac address (unexpected format)")}catch(y){S(y)}})}}),define(X[65],J([0,1,17,28,27,36,110]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(r){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(r)}value(){if(this._value===void 0){let r=0,g=0;const E=(0,L.networkInterfaces)();for(let p in E){const h=E[p];if(h)for(const{mac:w,internal:P}of h)P||(g+=1,this._isVirtualMachineMacAdress(w.toUpperCase())&&(r+=1))}this._value=g>0?r/g:0}return this._value}};let n;async function S(){return n||(n=(async()=>await y()||A.generateUuid())()),n}e.getMachineId=S;async function y(){try{const r=await new Promise((E,p)=>{q(["crypto"],E,p)}),g=await(0,M.getMac)();return r.createHash("sha256").update(g,"utf8").digest("hex")}catch(r){m.onUnexpectedError(r);return}}}),define(X[19],J([0,1,18,27,8,9,3,30,28,64,15,7]),function(q,e,m,A,L,b,M,n,S,y,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function p(z,C=E.UNLINK){if((0,n.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return C===E.UNLINK?w(z):h(z)}e.rimraf=p;async function h(z){try{const C=(0,L.join)((0,A.tmpdir)(),(0,S.generateUuid)());try{await m.promises.rename(z,C)}catch(j){return w(z)}w(C).catch(j=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function w(z){return m.promises.rmdir(z,{recursive:!0,maxRetries:3})}function P(z){if((0,n.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(z,{recursive:!0})}e.rimrafSync=P;async function I(z,C){return o(await(C?a(z):m.promises.readdir(z)))}e.readdir=I;async function a(z){try{return await m.promises.readdir(z,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const C=[],j=await I(z);for(const N of j){let T=!1,R=!1,W=!1;try{const k=await m.promises.lstat((0,L.join)(z,N));T=k.isFile(),R=k.isDirectory(),W=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}C.push({name:N,isFile:()=>T,isDirectory:()=>R,isSymbolicLink:()=>W})}return C}function l(z){return o(m.readdirSync(z))}e.readdirSync=l;function o(z){return z.map(C=>typeof C=="string"?M.isMacintosh?(0,y.normalizeNFC)(C):C:(C.name=M.isMacintosh?(0,y.normalizeNFC)(C.name):C.name,C))}async function c(z){const C=await I(z),j=[];for(const N of C)await i.existsDirectory((0,L.join)(z,N))&&j.push(N);return j}e.readDirsInDir=c;function t(z,C=1e3){return new Promise(j=>{let N=!1;const T=setInterval(()=>{N||(N=!0,m.access(z,R=>{N=!1,R&&(clearInterval(T),j(void 0))}))},C)})}e.whenDeleted=t;var i;(function(z){async function C(T){let R;try{if(R=await m.promises.lstat(T),!R.isSymbolicLink())return{stat:R}}catch(W){}try{return{stat:await m.promises.stat(T),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(M.isWindows&&W.code==="EACCES")try{return{stat:await m.promises.stat(await m.promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw k}throw W}}z.stat=C;async function j(T){try{const{stat:R,symbolicLink:W}=await z.stat(T);return R.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsFile=j;async function N(T){try{const{stat:R,symbolicLink:W}=await z.stat(T);return R.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsDirectory=N})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new b.ResourceQueue;function u(z,C,j){return s.queueFor(g.URI.file(z),r.extUriBiasedIgnorePathCase).queue(()=>{const N=D(j);return new Promise((T,R)=>f(z,C,N,W=>W?R(W):T()))})}e.writeFile=u;let d=!0;function f(z,C,j,N){if(!d)return m.writeFile(z,C,{mode:j.mode,flag:j.flag},N);m.open(z,j.flag,j.mode,(T,R)=>{if(T)return N(T);m.writeFile(R,C,W=>{if(W)return m.close(R,()=>N(W));m.fdatasync(R,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),d=!1),m.close(R,F=>N(F))))})})}function v(z,C,j){const N=D(j);if(!d)return m.writeFileSync(z,C,{mode:N.mode,flag:N.flag});const T=m.openSync(z,N.flag,N.mode);try{m.writeFileSync(T,C);try{m.fdatasyncSync(T)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),d=!1}}finally{m.closeSync(T)}}e.writeFileSync=v;function D(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function _(z,C){if(z!==C){async function j(N){try{const T=await m.promises.lstat(N);if(T.isDirectory()||T.isSymbolicLink())return;const R=await m.promises.open(N,"a");try{await R.utimes(T.atime,new Date)}finally{await R.close()}}catch(T){}}try{await m.promises.rename(z,C),await j(C)}catch(N){if(z.toLowerCase()!==C.toLowerCase()&&N.code==="EXDEV"||z.endsWith("."))await U(z,C,{preserveSymlinks:!1}),await p(z,E.MOVE),await j(C);else throw N}}}e.move=_;async function U(z,C,j){return Q(z,C,{root:{source:z,target:C},options:j,handledSourcePaths:new Set})}e.copy=U;const H=511;async function Q(z,C,j){if(!j.handledSourcePaths.has(z)){j.handledSourcePaths.add(z);const{stat:N,symbolicLink:T}=await i.stat(z);if(T){if(j.options.preserveSymlinks)try{return await O(z,C,j)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(T.dangling)return}return N.isDirectory()?ie(z,C,N.mode&H,j):ae(z,C,N.mode&H)}}async function ie(z,C,j,N){await m.promises.mkdir(C,{recursive:!0,mode:j});const T=await I(z);for(const R of T)await Q((0,L.join)(z,R),(0,L.join)(C,R),N)}async function ae(z,C,j){await m.promises.copyFile(z,C),await m.promises.chmod(C,j)}async function O(z,C,j){let N=await m.promises.readlink(z);(0,n.isEqualOrParent)(N,j.root.source,!M.isLinux)&&(N=(0,L.join)(j.root.target,N.substr(j.root.source.length+1))),await m.promises.symlink(N,C)}async function $(z){try{return await m.promises.access(z),!0}catch(C){return!1}}e.exists=$}),define(X[111],J([0,1,18,112,22,8,19]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(g){const E=(0,b.dirname)(g);if(g===E)return g;const p=((0,b.basename)(g)||g).toLowerCase();try{const w=(0,M.readdirSync)(E).filter(P=>P.toLowerCase()===p);if(w.length===1){const P=n(E);if(P)return(0,b.join)(P,w[0])}else if(w.length>1){const P=w.indexOf(p);if(P>=0){const I=n(E);if(I)return(0,b.join)(I,w[P])}}}catch(h){}return null}e.realcaseSync=n;async function S(g){try{return await(0,A.promisify)(m.realpath)(g)}catch(E){const p=r(g);return await m.promises.access(p,m.constants.R_OK),p}}e.realpath=S;function y(g){try{return m.realpathSync(g)}catch(E){const p=r(g);return m.accessSync(p,m.constants.R_OK),p}}e.realpathSync=y;function r(g){return(0,L.rtrim)((0,b.normalize)(g),b.sep)}}),define(X[113],J([0,1,59]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function A(){const S=1025;return S+Math.floor((65535-S)*Math.random())}e.randomPort=A;function L(S,y,r){let g=!1;return new Promise(E=>{const p=setTimeout(()=>{if(!g)return g=!0,E(0)},r);b(S,y,h=>{if(!g)return g=!0,clearTimeout(p),E(h)})})}e.findFreePort=L;function b(S,y,r){if(y===0)return r(0);const g=new m.Socket;g.once("connect",()=>(n(g),b(S+1,y-1,r))),g.once("data",()=>{}),g.once("error",E=>(n(g),E.code!=="ECONNREFUSED"?b(S+1,y-1,r):r(S))),g.connect(S,"127.0.0.1")}function M(S,y,r){let g=!1,E,p=1;const h=m.createServer({pauseOnConnect:!0});function w(P,I){g||(g=!0,h.removeAllListeners(),h.close(),E&&clearTimeout(E),I(P))}return new Promise(P=>{E=setTimeout(()=>{w(0,P)},r),h.on("listening",()=>{w(S,P)}),h.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&p<y?(S++,p++,h.listen(S,"127.0.0.1")):w(0,P)}),h.on("close",()=>{w(0,P)}),h.listen(S,"127.0.0.1")})}e.findFreePortFaster=M;function n(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(y){console.error(y)}}});var Fe=this&&this.__await||function(q){return this instanceof Fe?(this.v=q,this):new Fe(q)},ft=this&&this.__asyncGenerator||function(q,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=m.apply(q,e||[]),L,b=[];return L={},M("next"),M("throw"),M("return"),L[Symbol.asyncIterator]=function(){return this},L;function M(E){A[E]&&(L[E]=function(p){return new Promise(function(h,w){b.push([E,p,h,w])>1||n(E,p)})})}function n(E,p){try{S(A[E](p))}catch(h){g(b[0][3],h)}}function S(E){E.value instanceof Fe?Promise.resolve(E.value.v).then(y,r):g(b[0][2],E)}function y(E){n("next",E)}function r(E){n("throw",E)}function g(E,p){E(p),b.shift(),b.length&&n(b[0][0],b[0][1])}},gt=this&&this.__asyncValues||function(q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=q[Symbol.asyncIterator],m;return e?e.call(q):(q=typeof __values=="function"?__values(q):q[Symbol.iterator](),m={},A("next"),A("throw"),A("return"),m[Symbol.asyncIterator]=function(){return this},m);function A(b){m[b]=q[b]&&function(M){return new Promise(function(n,S){M=q[b](M),L(n,S,M.done,M.value)})}}function L(b,M,n,S){Promise.resolve(S).then(function(y){b({value:y,done:n})},M)}};define(X[114],J([0,1,19,27,8]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,M=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var S;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(S||(S={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let r;process.env.PROCESSOR_ARCHITEW6432?r=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?r=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?r=1:r=0;class g{constructor(c,t,i){this.exePath=c,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?y===0?process.env["ProgramFiles(x86)"]||null:r===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:c=!1}={}){const t=E({useAlternateBitness:o});if(!t)return null;const i=L.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let s=-1,u=null;for(const v of await m.readdir(i)){let D=-1;if(c){const U=v.indexOf("-");if(U<0)continue;const H=v.substring(0,U);if(!b.test(H)||v.substring(U+1)!=="preview")continue;D=parseInt(H,10)}else{if(!b.test(v))continue;D=parseInt(v,10)}if(!(D<=s)){const _=L.join(i,v,"pwsh.exe");!await m.SymlinkSupport.existsFile(_)||(u=_,s=D)}}if(!u)return null;const d=t.includes("x86")?" (x86)":"",f=c?" Preview":"";return new g(u,`PowerShell${f}${d}`,!0)}async function h({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await m.readdir(c))if(t.test(s)){const u=L.join(c,s,"pwsh.exe");return new g(u,i)}return null}function w(){const o=L.join(A.homedir(),".dotnet","tools","pwsh.exe");return new g(o,".NET Core PowerShell Global Tool")}function P(){const o=L.join(process.env.windir,y===1&&r!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(o,"Windows PowerShell",!0)}function I(){return ft(this,arguments,function*(){let c=yield Fe(p());c&&(yield yield Fe(c)),c=yield Fe(p({useAlternateBitness:!0})),c&&(yield yield Fe(c)),c=yield Fe(h()),c&&(yield yield Fe(c)),c=w(),c&&(yield yield Fe(c)),c=yield Fe(p({findPreview:!0})),c&&(yield yield Fe(c)),c=yield Fe(h({findPreview:!0})),c&&(yield yield Fe(c)),c=yield Fe(p({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield Fe(c)),c=P(),c&&(yield yield Fe(c))})}function a(){return ft(this,arguments,function*(){var c,t;try{for(var i=gt(I()),s;s=yield Fe(i.next()),!s.done;){const u=s.value;(yield Fe(u.exists()))&&(yield yield Fe(u))}}catch(u){c={error:u}}finally{try{s&&!s.done&&(t=i.return)&&(yield Fe(t.call(i)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=a;async function l(){var o,c;try{for(var t=gt(a()),i;i=await t.next(),!i.done;)return i.value}catch(s){o={error:s}}finally{try{i&&!i.done&&(c=t.return)&&await c.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=l}),define(X[82],J([0,1,45,10]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(M){return new Promise((n,S)=>{let y;const r=new Map;function g(h,w,P,I,a){const l=r.get(w);if(h===M||l){const o={name:E(P),cmd:P,pid:h,ppid:w,load:I,mem:a};r.set(h,o),h===M&&(y=o),l&&(l.children||(l.children=[]),l.children.push(o),l.children.length>1&&(l.children=l.children.sort((c,t)=>c.pid-t.pid)))}}function E(h){const w=/--disable-blink-features=Auxclick/,P=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,a=/\\pipe\\winpty-control/,l=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(P.exec(h))return"watcherService ";if(I.exec(h))return"electron-crash-reporter";if(a.exec(h))return"winpty-process";if(l.exec(h))return"console-window-host (Windows internal process)";let c=o.exec(h);if(c&&c.length===2)return c[1]==="renderer"?w.exec(h)?"shared-process":"window":c[1];const t=/[a-zA-Z-]+\.js/g;let i="";do c=t.exec(h),c&&(i+=c+" ");while(c);return i&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${i}`:h}if(process.platform==="win32"){const h=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,P)=>{q(["windows-process-tree"],w,P)}).then(w=>{w.getProcessList(M,P=>{w.getProcessCpuUsage(P,I=>{const a=new Map;I.forEach(l=>{const o=h(l.commandLine||"");a.set(l.pid,{name:E(o),cmd:o,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),y=a.get(M),y?(a.forEach(l=>{const o=a.get(l.ppid);o&&(o.children||(o.children=[]),o.children.push(l))}),a.forEach(l=>{l.children&&(l.children=l.children.sort((o,c)=>o.pid-c.pid))}),n(y)):S(new Error(`Root process ${M} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{function p(){let h=[y];const w=[];for(;h.length;){const I=h.shift();I&&(w.push(I.pid),I.children&&(h=h.concat(I.children)))}let P=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);P+=" "+w.join(" "),(0,m.exec)(P,{},(I,a,l)=>{if(I||l)S(I||new Error(l.toString()));else{const o=a.toString().split(`
`);for(let c=0;c<w.length;c++){const t=r.get(w[c]);t.load=parseFloat(o[c])}if(!y){S(new Error(`Root process ${M} not found`));return}n(y)}})}(0,m.exec)("which ps",{},(h,w,P)=>{if(h||P)if(process.platform!=="linux")S(h||new Error(P.toString()));else{const I=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,m.exec)(I,{},(a,l,o)=>{a||o?S(a||new Error(o.toString())):(b(l,g),p())})}else{const I=w.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${I} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,o,c)=>{l||c&&!c.includes("screen size is bogus")?S(l||new Error(c.toString())):(b(o,g),process.platform==="linux"?p():y?n(y):S(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=L;function b(M,n){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=M.toString().split(`
`);for(const r of y){const g=S.exec(r.trim());g&&g.length===6&&n(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(X[115],J([0,1,8,18,3,64,2,19]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(g,E,p){return r({path:g,isDirectory:!1},E,p)}e.watchFile=S;function y(g,E,p){return r({path:g,isDirectory:!0},E,p)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function r(g,E,p){const h=(0,m.basename)(g.path),w=new Map;let P=!1,I=[(0,M.toDisposable)(()=>{w.forEach(a=>(0,M.dispose)(a)),w.clear()})];try{const a=(0,A.watch)(g.path);I.push((0,M.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const l=new Set;g.isDirectory&&(0,n.readdir)(g.path).then(o=>o.forEach(c=>l.add(c))),a.on("error",(o,c)=>{P||p(`Failed to watch ${g.path} for changes using fs.watch() (${o}, ${c})`)}),a.on("change",(o,c)=>{if(!P){let t="";if(c&&(t=c.toString(),L.isMacintosh&&(t=(0,b.normalizeNFC)(t))),!(!t||o!=="change"&&o!=="rename")){const i=g.isDirectory?(0,m.join)(g.path,t):g.path;if(g.isDirectory)if(o==="rename"){const s=w.get(i);s&&(0,M.dispose)(s);const u=setTimeout(async()=>{w.delete(i);const d=await(0,n.exists)(i);if(!P){let f;d?l.has(t)?f="changed":(f="added",l.add(t)):(l.delete(t),f="deleted"),E(f,i)}},e.CHANGE_BUFFER_DELAY);w.set(i,(0,M.toDisposable)(()=>clearTimeout(u)))}else{let s;l.has(t)?s="changed":(s="added",l.add(t)),E(s,i)}else if(o==="rename"||t!==h){const s=setTimeout(async()=>{const u=await(0,n.exists)(i);P||(u?(E("changed",i),I=[r(g,E,p)]):E("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(I),I=[(0,M.toDisposable)(()=>clearTimeout(s))]}else E("changed",i)}}})}catch(a){(0,n.exists)(g.path).then(l=>{l&&!P&&p(`Failed to watch ${g.path} for changes using fs.watch() (${a.toString()})`)})}return(0,M.toDisposable)(()=>{P=!0,I=(0,M.dispose)(I)})}}),define(X[116],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[117],J([0,1,13,116,12]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){m.ipcMain.on(A.CONTEXT_MENU_CHANNEL,(n,S,y,r,g)=>{const E=M(n,r,y);E.popup({window:(0,L.withNullAsUndefined)(m.BrowserWindow.fromWebContents(n.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{E&&n.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}e.registerContextMenuListener=b;function M(n,S,y){const r=new m.Menu;return y.forEach(g=>{let E;g.type==="separator"?E=new m.MenuItem({type:g.type}):Array.isArray(g.submenu)?E=new m.MenuItem({submenu:M(n,S,g.submenu),label:g.label}):E=new m.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(p,h,w)=>n.sender.send(S,g.id,w)}),r.append(E)}),r}}),define(X[33],J([0,1,5,2,9,25,17,23,35,12,107,22]),function(q,e,m,A,L,b,M,n,S,y,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function p(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function w(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(P||(P={}));class I{constructor(T){this.buffer=T,this.pos=0}read(T){const R=this.buffer.slice(this.pos,this.pos+T);return this.pos+=R.byteLength,R}}class a{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var l;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(l||(l={}));function o(N){const T=n.VSBuffer.alloc(4);return T.writeUInt32BE(N,0),T}function c(N){return N.read(4).readUInt32BE(0)}function t(N){const T=n.VSBuffer.alloc(1);return T.writeUInt8(N,0),T}const i={Undefined:t(l.Undefined),String:t(l.String),Buffer:t(l.Buffer),VSBuffer:t(l.VSBuffer),Array:t(l.Array),Object:t(l.Object)},s=typeof Buffer!="undefined";function u(N,T){if(typeof T=="undefined")N.write(i.Undefined);else if(typeof T=="string"){const R=n.VSBuffer.fromString(T);N.write(i.String),N.write(o(R.byteLength)),N.write(R)}else if(s&&Buffer.isBuffer(T)){const R=n.VSBuffer.wrap(T);N.write(i.Buffer),N.write(o(R.byteLength)),N.write(R)}else if(T instanceof n.VSBuffer)N.write(i.VSBuffer),N.write(o(T.byteLength)),N.write(T);else if(Array.isArray(T)){N.write(i.Array),N.write(o(T.length));for(const R of T)u(N,R)}else{const R=n.VSBuffer.fromString(JSON.stringify(T));N.write(i.Object),N.write(o(R.byteLength)),N.write(R)}}function d(N){switch(N.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return N.read(c(N)).toString();case l.Buffer:return N.read(c(N)).buffer;case l.VSBuffer:return N.read(c(N));case l.Array:{const R=c(N),W=[];for(let k=0;k<R;k++)W.push(d(N));return W}case l.Object:return JSON.parse(N.read(c(N)).toString())}}class f{constructor(T,R,W=null,k=1e3){this.protocol=T,this.ctx=R,this.logger=W,this.timeoutDelay=k,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(T,R){this.channels.set(T,R),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const R=this.send([T.type]);this.logger&&this.logger.logOutgoing(R,0,1,w(T.type));return}case 201:case 202:case 204:case 203:{const R=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(R,T.id,1,w(T.type),T.data);return}}}send(T,R=void 0){const W=new a;return u(W,T),u(W,R),this.sendBuffer(W.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(R){return 0}}onRawMessage(T){const R=new I(T),W=d(R),k=d(R),F=W[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}: ${W[2]}.${W[3]}`,k),this.onPromise({type:F,id:W[1],channelName:W[2],name:W[3],arg:k});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}: ${W[2]}.${W[3]}`,k),this.onEventListen({type:F,id:W[1],channelName:W[2],name:W[3],arg:k});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}`),this.disposeActiveRequest({type:F,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}`),this.disposeActiveRequest({type:F,id:W[1]})}}onPromise(T){const R=this.channels.get(T.channelName);if(!R){this.collectPendingRequest(T);return}const W=new b.CancellationTokenSource;let k;try{k=R.call(this.ctx,T.name,T.arg,W.token)}catch(V){k=Promise.reject(V)}const F=T.id;k.then(V=>{this.sendResponse({id:F,data:V,type:201}),this.activeRequests.delete(T.id)},V=>{V instanceof Error?this.sendResponse({id:F,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:F,data:V,type:203}),this.activeRequests.delete(T.id)});const B=(0,A.toDisposable)(()=>W.cancel());this.activeRequests.set(T.id,B)}onEventListen(T){const R=this.channels.get(T.channelName);if(!R){this.collectPendingRequest(T);return}const W=T.id,F=R.listen(this.ctx,T.name,T.arg)(B=>this.sendResponse({id:W,data:B,type:204}));this.activeRequests.set(T.id,F)}disposeActiveRequest(T){const R=this.activeRequests.get(T.id);R&&(R.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let R=this.pendingRequests.get(T.channelName);R||(R=[],this.pendingRequests.set(T.channelName,R));const W=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);R.push({request:T,timeoutTimer:W})}flushPendingRequests(T){const R=this.pendingRequests.get(T);if(R){for(const W of R)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var v;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(T,R=null){this.protocol=T,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=R}getChannel(T){const R=this;return{call(W,k,F){return R.isDisposed?Promise.reject(M.canceled()):R.requestPromise(T,W,k,F)},listen(W,k){return R.isDisposed?Promise.reject(M.canceled()):R.requestEvent(T,W,k)}}}requestPromise(T,R,W,k=b.CancellationToken.None){const F=this.lastRequestId++,V={id:F,type:100,channelName:T,name:R,arg:W};if(k.isCancellationRequested)return Promise.reject(M.canceled());let G;return new Promise((Z,re)=>{if(k.isCancellationRequested)return re(M.canceled());const se=()=>{const ye=ge=>{switch(ge.type){case 201:this.handlers.delete(F),Z(ge.data);break;case 202:this.handlers.delete(F);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,re(Ee);break;case 203:this.handlers.delete(F),re(ge.data);break}};this.handlers.set(F,ye),this.sendRequest(V)};let x=null;this.state===P.Idle?se():(x=(0,L.createCancelablePromise)(ye=>this.whenInitialized()),x.then(()=>{x=null,se()}));const ne=()=>{x?(x.cancel(),x=null):this.sendRequest({id:F,type:101}),re(M.canceled())},ue=k.onCancellationRequested(ne);G=(0,A.combinedDisposable)((0,A.toDisposable)(ne),ue),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(T,R,W){const k=this.lastRequestId++,B={id:k,type:102,channelName:T,name:R,arg:W};let V=null;const G=new m.Emitter({onFirstListenerAdd:()=>{V=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(G),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(G),this.sendRequest({id:k,type:103}))}}),Y=Z=>G.fire(Z.data);return this.handlers.set(k,Y),G.event}sendRequest(T){switch(T.type){case 100:case 102:{const R=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(R,T.id,0,`${p(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const R=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(R,T.id,0,p(T.type));return}}}send(T,R=void 0){const W=new a;return u(W,T),u(W,R),this.sendBuffer(W.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(R){return 0}}onBuffer(T){const R=new I(T),W=d(R),k=d(R),F=W[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,w(F)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],0,w(F),k),this.onResponse({type:W[0],id:W[1],data:k})}}onResponse(T){if(T.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const R=this.handlers.get(T.id);R&&R(T)}whenInitialized(){return this.state===P.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelClient=D;class _{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:R,onDidClientDisconnect:W})=>{m.Event.once(R.onMessage)(F=>{const B=new I(F),V=d(B),G=new f(R,V),Y=new D(R);this.channels.forEach((re,se)=>G.registerChannel(se,re));const Z={channelServer:G,channelClient:Y,ctx:V};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{G.dispose(),Y.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const T=[];return this._connections.forEach(R=>T.push(R)),T}getChannel(T,R){const W=this;return{call(k,F,B){let V;if((0,y.isFunction)(R)){let Y=(0,S.getRandomElement)(W.connections.filter(R));V=Y?Promise.resolve(Y):m.Event.toPromise(m.Event.filter(W.onDidAddConnection,R))}else V=R.routeCall(W,k,F);const G=V.then(Y=>Y.channelClient.getChannel(T));return H(G).call(k,F,B)},listen(k,F){if((0,y.isFunction)(R))return W.getMulticastEvent(T,R,k,F);const B=R.routeEvent(W,k,F).then(V=>V.channelClient.getChannel(T));return H(B).listen(k,F)}}}getMulticastEvent(T,R,W,k){const F=this;let B=new A.DisposableStore;const V=new m.Emitter({onFirstListenerAdd:()=>{B=new A.DisposableStore;const G=new m.EventMultiplexer,Y=new Map,Z=se=>{const ne=se.channelClient.getChannel(T).listen(W,k),ue=G.add(ne);Y.set(se,ue)},re=se=>{const x=Y.get(se);!x||(x.dispose(),Y.delete(se))};F.connections.filter(R).forEach(Z),m.Event.filter(F.onDidAddConnection,R)(Z,void 0,B),F.onDidRemoveConnection(re,void 0,B),G.event(V.fire,V,B),B.add(G)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(T,R){this.channels.set(T,R),this._connections.forEach(W=>{W.channelServer.registerChannel(T,R)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class U{constructor(T,R,W=null){const k=new a;u(k,R),T.send(k.buffer),this.channelClient=new D(T,W),this.channelServer=new f(T,R,W)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,R){this.channelServer.registerChannel(T,R)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function H(N){return{call(T,R,W){return N.then(k=>k.call(T,R,W))},listen(T,R){const W=new m.Relay;return N.then(k=>W.input=k.listen(T,R)),W.event}}}e.getDelayedChannel=H;function Q(N){let T=!1;return{call(R,W,k){return T?N.call(R,W,k):(0,L.timeout)(0).then(()=>T=!0).then(()=>N.call(R,W,k))},listen(R,W){if(T)return N.listen(R,W);const k=new m.Relay;return(0,L.timeout)(0).then(()=>T=!0).then(()=>k.input=N.listen(R,W)),k.event}}}e.getNextTickChannel=Q;class ie{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const R of T.connections)if(await Promise.resolve(this.fn(R.ctx)))return Promise.resolve(R);return await m.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=ie;var ae;(function(N){function T(k,F){const B=k,V=F&&F.disableMarshalling,G=new Map;for(const Y in B)W(Y)&&G.set(Y,m.Event.buffer(B[Y],!0));return new class{listen(Y,Z){const re=G.get(Z);if(re)return re;throw new Error(`Event not found: ${Z}`)}call(Y,Z,re){const se=B[Z];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,r.revive)(re[x]);return se.apply(B,re)}throw new Error(`Method not found: ${Z}`)}}}N.fromService=T;function R(k,F){const B=F&&F.disableMarshalling;return new Proxy({},{get(V,G){var Y;if(typeof G=="string")return((Y=F==null?void 0:F.properties)===null||Y===void 0?void 0:Y.has(G))?F.properties.get(G):W(G)?k.listen(G):async function(...Z){let re;F&&!(0,y.isUndefinedOrNull)(F.context)?re=[F.context,...Z]:re=Z;const se=await k.call(G,re);return B?se:(0,r.revive)(se)};throw new Error(`Property not found: ${String(G)}`)}})}N.toService=R;function W(k){return k[0]==="o"&&k[1]==="n"&&g.isUpperAsciiLetter(k.charCodeAt(2))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let T=N.toString();if(T!=="[object Object]")return T}return N}function z(N){return Array.isArray(N)?N.map($):$(N)}function C(N,T,R,W,k,F,B){B=z(B);const V=O[k],G=V[W%V.length];let Y=[`%c[${N}]%c[${String(T).padStart(7," ")}]%c[len: ${String(R).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(F)?(Y=Y.concat(B),Y.push(")")):Y.push(B),console.log.apply(console,Y)}e.logWithColors=C;class j{constructor(T,R){this._outgoingPrefix=T,this._incomingPrefix=R,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,R,W,k,F){this._totalOutgoing+=T,C(this._outgoingPrefix,this._totalOutgoing,T,R,W,k,F)}logIncoming(T,R,W,k,F){this._totalIncoming+=T,C(this._incomingPrefix,this._totalIncoming,T,R,W,k,F)}}e.IPCLogger=j}),define(X[118],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(L,b){this.sender=L,this.onMessage=b}send(L){try{this.sender.send("vscode:message",L.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(X[119],J([0,1,5,33,23]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(S){this.port=S,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",y=>L.VSBuffer.wrap(y.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class M extends A.IPCClient{constructor(S,y){const r=new b(S);super(r,y);this.protocol=r}dispose(){this.protocol.disconnect()}}e.Client=M}),define(X[83],J([0,1,5,33,2,23,3,32]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let S=null;function y(){return S||(S=b.VSBuffer.alloc(0)),S}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return y();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const D=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),D}if(this._chunks[0].byteLength>s){const D=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),D}let d=b.VSBuffer.alloc(s),f=0,v=0;for(;s>0;){const D=this._chunks[v];if(D.byteLength>s){const _=D.slice(0,s);d.set(_,f),f+=s,u&&(this._chunks[v]=D.slice(s),this._totalLength-=s),s-=s}else d.set(D,f),f+=D.byteLength,u?(this._chunks.shift(),this._totalLength-=D.byteLength):v++,s-=D.byteLength}return d}}e.ChunkStream=r;var g;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,u,d,f){this.type=s,this.id=u,this.ack=d,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends L.Disposable{constructor(s){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const d=this._state.messageType,f=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(d,f,v,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=b.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._writeSoon(u,s.data)}}_bufferAdd(s,u){const d=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,d}_bufferTake(){const s=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends L.Disposable{constructor(s){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=P;class I extends A.IPCClient{constructor(s,u,d=null){super(s,u,d);this.protocol=s}static fromSocket(s,u){return new I(new P(s),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=I;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],u=0,d=this._first;for(;d;)s[u++]=d.data,d=d.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new l(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<c._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=c._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),u=(1+c._HISTORY_LENGTH)*1e3;let d=0;for(let f=0;f<c._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=u&&d++;return 1-d/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,u=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,y());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const u=new p(4,0,0,y());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let u=0,d=s.length;u<d;u++)this._socketWriter.write(s[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,y())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const u=this._outgoingUnackMsg.toArray();for(let d=0,f=u.length;d<f;d++)this._socketWriter.write(u[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new p(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(s){const u=new p(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,y());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(X[120],J([0,1,13,5,33,118,2,23]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function S(r,g){const E=A.Event.fromNodeEventEmitter(m.ipcMain,g,(h,w)=>({event:h,message:w})),p=A.Event.filter(E,({event:h})=>h.sender.id===r);return A.Event.map(p,({message:h})=>h&&n.VSBuffer.wrap(h))}class y extends L.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const g=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:E})=>E);return A.Event.map(g,E=>{const p=E.id,h=y.Clients.get(p);h&&h.dispose();const w=new A.Emitter;y.Clients.set(p,(0,M.toDisposable)(()=>w.fire()));const P=S(p,"vscode:message"),I=A.Event.any(A.Event.signal(S(p,"vscode:disconnect")),w.event);return{protocol:new b.Protocol(E,P),onDidClientDisconnect:I}})}}e.Server=y,y.Clients=new Map}),define(X[84],J([0,1,13,5,28,119]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends b.Client{constructor(y,r){super({addEventListener:(g,E)=>y.addListener(g,E),removeEventListener:(g,E)=>y.removeListener(g,E),postMessage:g=>y.postMessage(g),start:()=>y.start(),close:()=>y.close()},r)}}e.Client=M;async function n(S){if(S.isDestroyed()||S.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,L.generateUuid)();S.webContents.send("vscode:createMessageChannel",y);const r=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(E,p)=>({nonce:p,port:E.ports[0]})),{port:g}=await A.Event.toPromise(A.Event.once(A.Event.filter(r,E=>E.nonce===y)));return g}e.connect=n}),define(X[85],J([0,1,2,5,9,12]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var M;(function(r){r[r.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));var n;(function(r){r[r.None=0]="None",r[r.Initialized=1]="Initialized",r[r.Closed=2]="Closed"})(n||(n={}));class S extends m.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var E,p;(E=g.changed)===null||E===void 0||E.forEach((h,w)=>this.accept(w,h)),(p=g.deleted)===null||p===void 0||p.forEach(h=>this.accept(h,void 0))}accept(g,E){if(this.state!==n.Closed){let p=!1;(0,b.isUndefinedOrNull)(E)?p=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),p=!0),p&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const p=this.cache.get(g);return(0,b.isUndefinedOrNull)(p)?E:p}getBoolean(g,E){const p=this.get(g);return(0,b.isUndefinedOrNull)(p)?E:p==="true"}getNumber(g,E){const p=this.get(g);return(0,b.isUndefinedOrNull)(p)?E:parseInt(p,10)}async set(g,E){if(this.state!==n.Closed){if((0,b.isUndefinedOrNull)(E))return this.delete(g);const p=String(E);if(this.cache.get(g)!==p)return this.cache.set(g,p),this.pendingInserts.set(g,p),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==n.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,p)=>this.items.set(p,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=y}),define(X[121],J([0,1,18,5,9,36,8,19]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(g,E=Object.create(null)){this.path=g,this.options=E,this.name=(0,M.basename)(this.path),this.logger=new y(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return A.Event.None}async getItems(){const g=await this.whenConnected,E=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(h=>E.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(g){const E=await this.whenConnected;return this.doUpdateItems(E,g)}doUpdateItems(g,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,b.mapToString)(E.insert):"0"}), delete(${E.delete?(0,b.setToString)(E.delete):"0"})`),this.transaction(g,()=>{const p=E.insert,h=E.delete;if(p&&p.size>0){const w=[];w.push([]);let P=0;p.forEach((I,a)=>{let l=w[P];l.length>S.MAX_HOST_PARAMETERS&&(P++,l=[],w.push(l)),l.push(a,I)}),w.forEach(I=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,a=>a.run(I),()=>{const a=[];let l=0;return p.forEach((o,c)=>{a.push(c),l+=o.length}),`Keys: ${a.join(", ")} Length: ${l}`})})}if(h&&h.size){const w=[];w.push([]);let P=0;h.forEach(I=>{let a=w[P];a.length>S.MAX_HOST_PARAMETERS&&(P++,a=[],w.push(a)),a.push(I)}),w.forEach(I=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,a=>a.run(I),()=>{const a=[];return h.forEach(l=>{a.push(l)}),`Keys: ${a.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,g)}doClose(g,E){return new Promise((p,h)=>{g.db.close(w=>(w&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${w}`),this.path===S.IN_MEMORY_PATH?p():!g.isErroneous&&!g.isInMemory?this.backup().then(p,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),p())):typeof E=="function"?m.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const I=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:E()}).then(()=>I(),a=>(I(),Promise.reject(a)))})).then(p,h):h(w||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,n.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const E=await this.whenConnected,p=await this.get(E,g?"PRAGMA integrity_check":"PRAGMA quick_check"),h=g?p.integrity_check:p.quick_check;return E.isErroneous?`${h} (last error: ${E.lastError})`:E.isInMemory?`${h} (in-memory!)`:h}async connect(g,E=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${E})`);try{return await this.doConnect(g)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&E)return await(0,L.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await m.promises.unlink(g);try{await m.promises.rename(this.toBackupPath(g),g)}catch(h){}return await this.doConnect(g)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(g,E){g.isErroneous=!0,g.lastError=E,this.logger.error(E)}doConnect(g){return new Promise((E,p)=>{new Promise((h,w)=>{q(["vscode-sqlite3"],h,w)}).then(h=>{const w={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(g,P=>P?w.db?w.db.close(()=>p(P)):p(P):this.exec(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(w),I=>w.db.close(()=>p(I)))),isInMemory:g===S.IN_MEMORY_PATH};w.db.on("error",P=>this.handleSQLiteError(w,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&w.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},p)})}exec(g,E){return new Promise((p,h)=>{g.db.exec(E,w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${w}`),h(w)):p())})}get(g,E){return new Promise((p,h)=>{g.db.get(E,(w,P)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${w}`),h(w)):p(P))})}all(g,E){return new Promise((p,h)=>{g.db.all(E,(w,P)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${w}`),h(w)):p(P))})}transaction(g,E){return new Promise((p,h)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),E(),g.db.run("END TRANSACTION",w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${w}`),h(w)):p())})})}prepare(g,E,p,h){const w=g.db.prepare(E),P=I=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${I} (${E}). Details: ${h()}`)};w.on("error",P),p(w),w.finalize(I=>{I&&P(I),w.removeListener("error",P)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class y{constructor(g){g&&typeof g.logTrace=="function"&&process.env[y.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}y.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[122],J([14,11]),function(q,e){return q.create("vs/base/common/date",e)}),define(X[123],J([0,1,122]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,L=A*60,b=L*24,M=b*7,n=b*30,S=b*365;function y(g,E){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,m.localize)(0,null,y(new Date().getTime()+p*1e3,!1));if(p<30)return(0,m.localize)(1,null);let h;return p<A?(h=p,E?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):p<L?(h=Math.floor(p/A),E?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):p<b?(h=Math.floor(p/L),E?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):p<M?(h=Math.floor(p/b),E?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):p<n?(h=Math.floor(p/M),E?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):p<S?(h=Math.floor(p/n),E?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(p/S),E?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=y;function r(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(X[124],J([14,11]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(X[66],J([0,1,124,12,35]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(y,r){return r&&(y.stack||y.stacktrace)?m.localize(0,null,n(y),M(y.stack)||M(y.stacktrace)):n(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function n(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?m.localize(1,null,y.message):y.message||m.localize(2,null)}function S(y=null,r=!1){if(!y)return m.localize(3,null);if(Array.isArray(y)){const g=L.coalesce(y),E=S(g[0],r);return g.length>1?m.localize(4,null,E,g.length):E}if(A.isString(y))return y;if(y.detail){const g=y.detail;if(g.error)return b(g.error,r);if(g.exception)return b(g.exception,r)}return y.stack?b(y,r):y.message?y.message:m.localize(5,null)}e.toErrorMessage=S}),define(X[125],J([14,11]),function(q,e){return q.create("vs/base/common/keybindingLabels",e)}),define(X[126],J([0,1,125]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(M,n,S=n){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=n,this.modifierLabels[3]=S}toLabel(M,n,S){if(n.length===0)return null;const y=[];for(let r=0,g=n.length;r<g;r++){const E=n[r],p=S(E);if(p===null)return null;y[r]=L(E,p,this.modifierLabels[M])}return y.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(b,M,n){if(M===null)return"";const S=[];return b.ctrlKey&&S.push(n.ctrlKey),b.shiftKey&&S.push(n.shiftKey),b.altKey&&S.push(n.altKey),b.metaKey&&S.push(n.metaKey),M!==""&&S.push(M),S.join(n.separator)}}),define(X[127],J([14,11]),function(q,e){return q.create("vs/base/node/processes",e)}),define(X[86],J([0,1,8,18,19,45,127,32,12,44,30,3,81,10]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(c,t){if(g.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const s=b.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],i);return new Promise(u=>{s.once("error",d=>{u({success:!1,error:d})}),s.once("exit",(d,f)=>{u(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(g.isLinux||g.isMacintosh)try{const i=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(s=>{b.execFile(i,[c.pid.toString()],{encoding:"utf8",shell:!0},(u,d,f)=>{s(u?{success:!1,error:u}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function P(c=n.env){return c.comspec||"cmd.exe"}e.getWindowsShell=P;class I{constructor(t,i,s,u){if(i!==void 0&&s!==void 0&&u!==void 0)this.cmd=t,this.args=i,this.shell=s,this.options=u;else{const d=t;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(n.env).forEach(f=>{d[f]=n.env[f]}),Object.keys(this.options.env).forEach(f=>{d[f]=this.options.env[f]}),this.options.env=d}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(m.sep);return i!==-1&&(t=t.substring(i+1)),I.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(n.cwd()))?Promise.reject(new Error(M.localize(0,null))):this.useExec().then(i=>{let s,u;const d=new Promise((f,v)=>{s=f,u=v});if(i){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=b.exec(f,this.options,(v,D,_)=>{this.childProcess=null;const U=v;U&&U.killed?u({killed:this.terminateRequested,stdout:D.toString(),stderr:_.toString()}):this.handleExec(s,t,v,D,_)})}else{let f=null;const v=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,s,t,u);const _={terminated:this.terminateRequested};S.isNumber(D)&&(_.cmdCode=D),s(_)};if(this.shell&&g.isWindows){const D=y.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let _=!1,U=!1;const H=[];let Q=this.ensureQuotes(this.cmd);H.push(Q.value),_=Q.quoted,this.args&&this.args.forEach(ae=>{Q=this.ensureQuotes(ae),H.push(Q.value),U=U&&Q.quoted});const ie=["/s","/c"];_?U?ie.push('"'+H.join(" ")+'"'):H.length>1?ie.push('"'+H[0]+'" '+H.slice(1).join(" ")):ie.push('"'+H[0]+'"'):ie.push(H.join(" ")),f=b.spawn(P(),ie,D)}else this.cmd&&(f=b.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(S.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",D=>{this.childProcess=null,u({terminated:this.terminateRequested,error:D})}),f.pid&&(this.childProcess.on("close",v),this.handleSpawn(f,s,t,u,!0)))}return d})}handleClose(t,i,s,u){}ensureQuotes(t){return I.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const i=b.spawn(P(),["/s","/c"]);i.on("error",s=>t(!0)),i.on("exit",s=>t(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class a extends I{constructor(t,i,s,u){super(t,i,s,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,s,u,d){[u,d].forEach((f,v)=>{const D=new E.LineDecoder;D.write(f).forEach(H=>{i({line:H,source:v===0?0:1})});const U=D.end();U&&i({line:U,source:v===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,i,s,u,d){const f=new E.LineDecoder,v=new E.LineDecoder;t.stdout.on("data",D=>{f.write(D).forEach(U=>s({line:U,source:0}))}),t.stderr.on("data",D=>{v.write(D).forEach(U=>s({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=v}handleClose(t,i,s,u){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&s({line:d,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=a;function l(c){let t=[],i=!1;const s=function(u){if(i){t.push(u);return}(!c.send(u,f=>{if(f&&console.error(f),i=!1,t.length>0){const v=t.slice(0);t=[],v.forEach(D=>s(D))}})||g.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=l;var o;(function(c){async function t(i,s,u){if(m.isAbsolute(i))return i;if(s===void 0&&(s=n.cwd()),m.dirname(i)!=="."||(u===void 0&&S.isString(n.env.PATH)&&(u=n.env.PATH.split(m.delimiter)),u===void 0||u.length===0))return m.join(s,i);async function f(v){return await L.exists(v)?!(await A.promises.stat(v)).isDirectory():!1}for(let v of u){let D;if(m.isAbsolute(v)?D=m.join(v,i):D=m.join(s,v,i),await f(D))return D;let _=D+".com";if(await f(_)||(_=D+".exe",await f(_)))return _}return m.join(s,i)}c.findExecutable=t})(o=e.win32||(e.win32={}))}),define(X[128],J([0,1,27,3,114,86]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(p,h){return p===1?A.isWindows?g():b.getWindowsShell(h):y(p,h)}e.getSystemShell=M;function n(p,h){return p===1?A.isWindows?E(h):b.getWindowsShell(h):y(p,h)}e.getSystemShellSync=n;let S=null;function y(p,h){if(A.isLinux&&p===2||A.isMacintosh&&p===3)return"/bin/bash";if(!S){let w;if(A.isWindows)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,m.userInfo)().shell}catch(P){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let r=null;async function g(){return r||(r=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),r}function E(p){if(r)return r;const h=A.isWindows&&parseFloat((0,m.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?P:b.getWindowsShell(p)}}),define(X[87],J([0,1,45,2,9,44,5,86,33,106,25,17,23,3]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends S.ChannelServer{constructor(I){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch(l){}},onMessage:M.Event.fromNodeEventEmitter(process,"message",a=>E.VSBuffer.wrap(Buffer.from(a,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=h;class w{constructor(I,a){this.modulePath=I,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new M.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new L.Delayer(l),this.child=null,this._client=null}getChannel(I){const a=this;return{call(l,o,c){return a.requestPromise(I,l,o,c)},listen(l,o){return a.requestEvent(I,l,o)}}}requestPromise(I,a,l,o=r.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(I),t=(0,L.createCancelablePromise)(u=>c.call(a,l,u)),i=o.onCancellationRequested(()=>t.cancel()),s=(0,A.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,a,l){if(!this.disposeDelayer)return M.Event.None;this.disposeDelayer.cancel();let o;const c=new M.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(I).listen(a,l)(c.fire,c),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(a.env=Object.assign(Object.assign({},a.env),this.options.env)),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d))),p.isMacintosh&&a.env&&delete a.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,I,a);const l=new M.Emitter;M.Event.fromNodeEventEmitter(this.child,"message",d=>d)(d=>{if((0,y.isRemoteConsoleLog)(d)){(0,y.log)(d,`IPC Library: ${this.options.serverName}`);return}l.fire(E.VSBuffer.wrap(Buffer.from(d,"base64")))});const c=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=d=>this.child&&this.child.connected&&c.send(d.buffer.toString("base64")),i=l.event,s={send:t,onMessage:i};this._client=new S.ChannelClient(s);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",d=>console.warn('IPC "'+this.options.serverName+'" errored with '+d)),this.child.on("exit",(d,f)=>{process.removeListener("exit",u),this.activeRequests.forEach(v=>(0,A.dispose)(v)),this.activeRequests.clear(),d!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+d+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:d,signal:f})})}return this._client}getCachedChannel(I){let a=this.channels.get(I);return a||(a=this.client.getChannel(I),this.channels.set(I,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(X[129],J([14,11]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(X[130],J([14,11]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[131],J([14,11]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[132],J([14,11]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(X[133],J([14,11]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(X[134],J([14,11]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[135],J([14,11]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[136],J([14,11]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(X[137],J([14,11]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(X[138],J([14,11]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(X[139],J([14,11]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[140],J([14,11]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[141],J([14,11]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[142],J([14,11]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(X[143],J([14,11]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[144],J([14,11]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(X[145],J([14,11]),function(q,e){return q.create("vs/platform/windows/electron-main/window",e)}),define(X[146],J([14,11]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[147],J([14,11]),function(q,e){return q.create("vs/platform/workspaces/common/workspaces",e)}),define(X[148],J([14,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[149],J([14,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[150],J([0,1,5,2]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,S,y){switch(S){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(n,S,y){switch(S){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class b extends A.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,S,y){this.channel.call("attach",[n,S,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,S){this.channel.call("terminate",[n,S])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,S,y){return this.channel.call("openExtensionDevelopmentHostWindow",[n,S||{},y])}}e.ExtensionHostDebugChannelClient=b});var ce=this&&this.__decorate||function(q,e,m,A){var L=arguments.length,b=L<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,m):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(q,e,m,A);else for(var n=q.length-1;n>=0;n--)(M=q[n])&&(b=(L<3?M(b):L>3?M(e,m,b):M(e,m))||b);return L>3&&b&&Object.defineProperty(e,m,b),b};define(X[151],J([0,1,8,15,53,123,10,7,32]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(h,w,P){this._args=h,this.paths=w,this.productService=P}get appRoot(){return(0,m.dirname)(M.FileAccess.asFileUri("",q).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(n.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=S.env.VSCODE_PORTABLE;return h?n.URI.file((0,m.join)(h,"argv.json")):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,A.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,m.resolve)(h):(0,m.normalize)((0,m.join)(M.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,m.resolve)(h):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,m.resolve)(h);const w=S.env.VSCODE_EXTENSIONS;if(w)return w;const P=S.env.VSCODE_PORTABLE;return P?(0,m.join)(P,"extensions"):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(w=>/^[^:/?#]+?:\/\//.test(w)?n.URI.parse(w):n.URI.file((0,m.normalize)(w)))}get extensionDevelopmentKind(){var h;return(h=this.args.extensionDevelopmentKind)===null||h===void 0?void 0:h.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?n.URI.parse(h):n.URI.file((0,m.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return r(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,A.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([L.memoize],y.prototype,"appRoot",null),ce([L.memoize],y.prototype,"userHome",null),ce([L.memoize],y.prototype,"userDataPath",null),ce([L.memoize],y.prototype,"appSettingsHome",null),ce([L.memoize],y.prototype,"tmpDir",null),ce([L.memoize],y.prototype,"userRoamingDataHome",null),ce([L.memoize],y.prototype,"settingsResource",null),ce([L.memoize],y.prototype,"userDataSyncHome",null),ce([L.memoize],y.prototype,"userDataSyncLogResource",null),ce([L.memoize],y.prototype,"sync",null),ce([L.memoize],y.prototype,"machineSettingsResource",null),ce([L.memoize],y.prototype,"globalStorageHome",null),ce([L.memoize],y.prototype,"workspaceStorageHome",null),ce([L.memoize],y.prototype,"keybindingsResource",null),ce([L.memoize],y.prototype,"keyboardLayoutResource",null),ce([L.memoize],y.prototype,"argvResource",null),ce([L.memoize],y.prototype,"snippetsHome",null),ce([L.memoize],y.prototype,"isExtensionDevelopment",null),ce([L.memoize],y.prototype,"untitledWorkspacesHome",null),ce([L.memoize],y.prototype,"installSourcePath",null),ce([L.memoize],y.prototype,"builtinExtensionsPath",null),ce([L.memoize],y.prototype,"extensionsPath",null),ce([L.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ce([L.memoize],y.prototype,"extensionDevelopmentKind",null),ce([L.memoize],y.prototype,"extensionTestsLocationURI",null),ce([L.memoize],y.prototype,"debugExtensionHost",null),ce([L.memoize],y.prototype,"serviceMachineIdResource",null),ce([L.memoize],y.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=y;function r(p,h){return E(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId)}e.parseExtensionHostPort=r;function g(p,h){return E(p["inspect-search"],p["inspect-brk-search"],5876,h)}e.parseSearchPort=g;function E(p,h,w,P,I){const l=Number(h||p)||(P?null:w),o=l?Boolean(!!h):!1;return{port:l,break:o,debugId:I}}}),define(X[88],J([0,1,232,132,3]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:(0,A.localize)(0,null),e:(0,A.localize)(1,null),t:(0,A.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,A.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(14,null)},category:{type:"string",cat:"e",description:(0,A.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,A.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,A.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,A.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,A.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,A.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,A.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,A.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,A.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(h,w,P=M){const I={},a=[],l=[];for(let i in w){const s=w[i];s.alias&&(I[i]=s.alias),s.type==="string"||s.type==="string[]"?(a.push(i),s.deprecates&&a.push(s.deprecates)):s.type==="boolean"&&(l.push(i),s.deprecates&&l.push(s.deprecates))}const o=m(h,{string:a,boolean:l,alias:I}),c={},t=o;c._=o._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in w){const s=w[i];s.alias&&delete t[s.alias];let u=t[i];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(u||(u=t[s.deprecates]),delete t[s.deprecates]),typeof u!="undefined"&&(s.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):s.type==="string"&&Array.isArray(u)&&(u=u.pop(),P.onMultipleValues(i,u)),c[i]=u),delete t[i]}for(let i in t)P.onUnknownOption(i);return c}e.parseArgs=n;function S(h,w){let P="";return w.args&&(Array.isArray(w.args)?P=` <${w.args.join("> <")}>`:P=` <${w.args}>`),w.alias?`-${w.alias} --${h}${P}`:`--${h}${P}`}function y(h,w){let P=0,I=[];for(const c in h){const t=h[c],i=S(c,t);P=Math.max(P,i.length),I.push([i,t.description])}let a=P+2+1;if(w-a<25)return I.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let l=w-a-1,o=[];for(const c of I){let t=c[0],i=g(c[1],l),s=r(a-t.length-2);o.push("  "+t+s+i[0]);for(let u=1;u<i.length;u++)o.push(r(a)+i[u])}return o}e.formatOptions=y;function r(h){return" ".repeat(h)}function g(h,w){let P=[];for(;h.length;){let I=h.length<w?h.length:h.lastIndexOf(" ",w),a=h.slice(0,I).trim();h=h.slice(I),P.push(a)}return P}function E(h,w,P,I,a=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${h} ${P}`];o.push(""),o.push(`${(0,A.localize)(32,null)}: ${w} [${(0,A.localize)(33,null)}][${(0,A.localize)(34,null)}...]`),o.push(""),a&&(L.isWindows?o.push((0,A.localize)(35,null,w)):o.push((0,A.localize)(36,null,w)),o.push(""));const c={};for(const t in I){const i=I[t];if(i.description&&i.cat){let s=c[i.cat];s||(c[i.cat]=s={}),s[t]=i}}for(let t in c){const i=t;let s=c[i];s&&(o.push(b[i]),o.push(...y(s,l)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function p(h,w){return`${h||(0,A.localize)(37,null)}
${w||(0,A.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(X[152],J([0,1,88,59,150]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,S,y){return S==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(n,S,y)}async openExtensionDevelopmentHostWindow(n,S,y){const r=(0,m.parseArgs)(n,m.OPTIONS);r.debugRenderer=y;const g=r.extensionDevelopmentPath;if(!g)return{success:!1};let E;const p=Object.keys(S);for(let l of p){let o=S[l];o===null||(E||(E=Object.create(null)),E[l]=o)}const[h]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:r,userEnv:E});if(!y)return{success:!0};const w=h.win;if(!w)return{success:!0};const P=w.webContents.debugger;let I=P.isAttached()?Infinity:0;const a=(0,A.createServer)(l=>{I++==0&&P.attach();let o=!1;const c=s=>{o||l.write(JSON.stringify(s)+"\0")},t=(s,u,d,f)=>c({method:u,params:d,sessionId:f});w.on("close",()=>{P.removeListener("message",t),l.end(),o=!0}),P.addListener("message",t);let i=Buffer.alloc(0);l.on("data",s=>{i=Buffer.concat([i,s]);for(let u=i.indexOf(0);u!==-1;u=i.indexOf(0)){let d;try{const f=i.slice(0,u).toString("utf8");i=i.slice(u+1),d=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}P.sendCommand(d.method,d.params,d.sessionId).then(f=>c({id:d.id,sessionId:d.sessionId,result:f})).catch(f=>c({id:d.id,sessionId:d.sessionId,error:{code:0,message:f.message}}))}}),l.on("error",s=>{console.error("error on cdp pipe:",s)}),l.on("close",()=>{o=!0,--I==0&&P.detach()})});return await new Promise(l=>a.listen(0,l)),w.on("close",()=>a.close()),{rendererDebugPort:a.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function q(e,m,A,L){function b(n){const S=M(n),y=[S];return e.isAbsolute(S)||y.unshift(L),e.resolve(...y)}function M(n){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");const y=n["user-data-dir"];if(y)return y;let r=process.env.VSCODE_APPDATA;if(!r)switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(g,"AppData","Roaming")}break;case"darwin":r=e.join(m.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,A)}return{getUserDataPath:b}}if(typeof define=="function")define(X[153],J([0,154,27,10,15,32]),function(e,m,A,L,b,M){const n=b.dirname(L.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(b.joinPath(n,"package.json").fsPath);return q(m,A,S.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),A=require("os");module.exports=q(m,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[155],J([0,1,27,153,151]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends L.AbstractNativeEnvironmentService{constructor(n,S){super(n,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,A.getUserDataPath)(n)},S)}}e.NativeEnvironmentService=b}),define(X[156],J([0,1,18,27,8]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(M){const n=(0,L.join)((0,A.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),M&&console.log(`Marker file for --wait created: ${n}`),n}catch(S){M&&console.error(`Failed to create marker file for --wait: ${S}`);return}}e.createWaitMarkerFile=b}),define(X[157],J([0,1,135]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function L(g){return g=g.trim(),g==="*"||A.test(g)}e.isValidVersionStr=L;function b(g){if(!L(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(A);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=b;function M(g){if(!g)return null;let E=g.majorBase,p=g.majorMustEqual,h=g.minorBase,w=g.minorMustEqual,P=g.patchBase,I=g.patchMustEqual;return g.hasCaret&&(E===0||(w=!1),I=!1),{majorBase:E,majorMustEqual:p,minorBase:h,minorMustEqual:w,patchBase:P,patchMustEqual:I,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=M;function n(g,E){let p;typeof g=="string"?p=M(b(g)):p=g;let h;if(typeof E=="string"?h=M(b(E)):h=E,!p||!h)return!1;let w=p.majorBase,P=p.minorBase,I=p.patchBase,a=h.majorBase,l=h.minorBase,o=h.patchBase,c=h.majorMustEqual,t=h.minorMustEqual,i=h.patchMustEqual;return h.isMinimum?w>a?!0:w<a?!1:P>l?!0:P<l?!1:I>=o:(w===1&&a===0&&(!c||!t||!i)&&(a=1,l=0,o=0,c=!0,t=!1,i=!1),w<a?!1:w>a?!c:P<l?!1:P>l?!t:I<o?!1:I>o?!i:!0)}e.isValidVersion=n;function S(g,E,p){return E.isBuiltin||typeof E.main=="undefined"?!0:r(g,E.engines.vscode,p)}e.isValidExtensionVersion=S;function y(g,E){return g==="*"||r(E,g)}e.isEngineValid=y;function r(g,E,p=[]){let h=M(b(E));if(!h)return p.push(m.localize(0,null,E)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return p.push(m.localize(1,null,E)),!1}else if(!h.majorMustEqual)return p.push(m.localize(2,null,E)),!1;return n(g,h)?!0:(p.push(m.localize(3,null,g,E)),!1)}e.isVersionValid=r}),define(X[158],J([0,1,33,87,2,10]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends L.Disposable{constructor(S,y,r,g){super();this.folders=S,this.onDidFilesChange=y,this.onLogMessage=r,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(X[159],J([0,1,33,87,2,10]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends L.Disposable{constructor(S,y,r,g,E={}){super();this.folders=S,this.onDidFilesChange=y,this.onLogMessage=r,this.verboseLogging=g,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(S.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(X[160],J([0,1,45,81,108,10]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class M{constructor(S,y,r,g,E){this.watchedFolder=S,this.eventCallback=r,this.logCallback=g,this.verboseLogging=E,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(p=>L.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=m.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,S);const y=new A.LineDecoder;this.handle.stdout.on("data",r=>{const g=[];y.write(r).forEach(E=>{const p=E.split("|");if(p.length===2){const h=Number(p[0]),w=p[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(P=>P(w))){this.verboseLogging&&this.log(w);return}g.push({type:M.changeTypeMap[h],path:w})}else this.log(p[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",r=>this.onError(r)),this.handle.stderr.on("data",r=>this.onError(r)),this.handle.on("exit",(r,g)=>this.onExit(r,g))}onError(S){this.error("process error: "+S.toString())}onExit(S,y){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${y})`),this.restartCounter<=M.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=M,M.MAX_RESTARTS=5,M.changeTypeMap=[0,1,2]}),define(X[161],J([0,1,160,8,22]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(n,S,y,r){this.onDidFilesChange=S,this.onLogMessage=y,this.verboseLogging=r,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(X[67],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(b,M=[],n=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m;const A=(L,...b)=>new m(L,b);e.createSyncDescriptor=A}),define(X[162],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=m;class A{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let M of this._nodes.values())M.outgoing.size===0&&b.push(M);return b}insertEdge(b,M){const n=this.lookupOrInsertNode(b),S=this.lookupOrInsertNode(M);n.outgoing.set(this._hashFn(M),S),S.incoming.set(this._hashFn(b),n)}removeNode(b){const M=this._hashFn(b);this._nodes.delete(M);for(let n of this._nodes.values())n.outgoing.delete(M),n.incoming.delete(M)}lookupOrInsertNode(b){const M=this._hashFn(b);let n=this._nodes.get(M);return n||(n=new m(b),this._nodes.set(M,n)),n}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[M,n]of this._nodes)b.push(`${M}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return b.join(`
`)}findCycleSlow(){for(let[b,M]of this._nodes){const n=new Set([b]),S=this._findCycle(M,n);if(S)return S}}_findCycle(b,M){for(let[n,S]of b.outgoing){if(M.has(n))return[...M,n].join(" -> ");M.add(n);const y=this._findCycle(S,M);if(y)return y;M.delete(n)}}}e.Graph=A}),define(X[4],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function S(y){return y[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=S})(m=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function A(n,S,y,r){S[m.DI_TARGET]===S?S[m.DI_DEPENDENCIES].push({id:n,index:y,optional:r}):(S[m.DI_DEPENDENCIES]=[{id:n,index:y,optional:r}],S[m.DI_TARGET]=S)}function L(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const S=function(y,r,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,y,g,!1)};return S.toString=()=>n,m.serviceIds.set(n,S),S}e.createDecorator=L;function b(n){return n}e.refineServiceDecorator=b;function M(n){return function(S,y,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(n,S,r,!0)}}e.optional=M}),define(X[68],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=A}),define(X[89],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class A{constructor(b){this.machineId=b}encryption(){return new Promise((b,M)=>q(["vscode-encrypt"],b,M))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(M){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(M){return b}}}e.EncryptionMainService=A}),define(X[46],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(X[163],J([0,1,134,4,10]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=b;var M;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(M=e.SortBy||(e.SortBy={}));var n;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var S;(function(g){g.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var y;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(E,p){super(E);this.code=p}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(X[164],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(X[165],J([0,1,22,4]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class M{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,g){if(typeof r=="undefined"||r===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof r=="string"||typeof g=="string"){let E=typeof r=="string"?r:r.value,p=typeof g=="string"?g:g.value;return m.equalsIgnoreCase(E,p)}return r._lower===g._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=M;function n(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=n;function S(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[166],J([0,1,22,165]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(p,h){return p.uuid&&h.uuid?p.uuid===h.uuid:p.id===h.id?!0:(0,m.compareIgnoreCase)(p.id,h.id)===0}e.areSameExtensions=L;class b{constructor(h,w){this.version=w,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof b?L(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=b;function M(p,h){return`${p}.${h}`}e.getExtensionId=M;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function S(p,h){return n(M(p,h))}e.getGalleryExtensionId=S;function y(p,h){const w=[],P=I=>{for(const a of w)if(a.some(l=>L(h(l),h(I))))return a;return null};for(const I of p){const a=P(I);a?a.push(I):w.push([I])}return w}e.groupByExtension=y;function r(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function g(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function E(p){const h=new Set;for(const w of p)w.malicious&&h.add(w.id.id);return h}e.getMaliciousExtensionsSet=E}),define(X[24],J([0,1,137,8,7,4,22,12,36]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function y(O){return O.create===!0}e.isFileOpenForWriteOptions=y;var r;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var g;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=E;function p(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=p;function h(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function w(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=w;var P;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=I;function a(O,$){const z=new I(O.toString(),$);return o(z,$),z}e.createFileSystemProviderError=a;function l(O){return O||a((0,m.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=l;function o(O,$){return O.name=$?`${$} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=o;function c(O){if(!O)return P.Unknown;if(O instanceof I)return O.code;const $=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!$)return P.Unknown;switch($[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=c;function t(O){if(O instanceof v)return O.fileOperationResult;switch(c(O)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor($,z,C){this.resource=$,this.operation=z,this.target=C}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var u;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor($,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const C of $)switch(C.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...C){var j,N,T,R,W,k;if(!$)return!1;const F=C.length>0;return!!((!F||C.includes(1))&&(((j=this.added)===null||j===void 0?void 0:j.get($))||z.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr($)))||(!F||C.includes(0))&&(((T=this.updated)===null||T===void 0?void 0:T.get($))||z.includeChildren&&((R=this.updated)===null||R===void 0?void 0:R.findSuperstr($)))||(!F||C.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr($))||z.includeChildren&&((k=this.deleted)===null||k===void 0?void 0:k.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const z=[],C=$===1?this.added:$===0?this.updated:this.deleted;if(C)for(const[,j]of C)z.push(j);return z}filter($){return new d(this.changes.filter(z=>$(z)),this.ignorePathCasing)}}e.FileChangesEvent=d;function f(O,$,z){return!O||!$||O===$||$.length>O.length?!1:($.charAt($.length-1)!==A.sep&&($+=A.sep),z?(0,M.startsWithIgnoreCase)(O,$):O.indexOf($)===0)}e.isParent=f;class v extends Error{constructor($,z,C){super($);this.fileOperationResult=z,this.options=C}static isFileOperationError($){return $ instanceof Error&&!(0,n.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=v;var D;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=U;async function H(O,$){if(!$.canHandleResource(L.URI.from({scheme:O.scheme})))return new Promise(z=>{const C=$.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===O.scheme&&j.added&&(C.dispose(),z())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize($){return(0,n.isNumber)($)||($=0),$<Q.KB?(0,m.localize)(1,null,$.toFixed(0)):$<Q.MB?(0,m.localize)(2,null,($/Q.KB).toFixed(2)):$<Q.GB?(0,m.localize)(3,null,($/Q.MB).toFixed(2)):$<Q.TB?(0,m.localize)(4,null,($/Q.GB).toFixed(2)):(0,m.localize)(5,null,($/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var ie;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function ae(O){return{maxFileSize:O===0?300*Q.MB:16*Q.GB,maxHeapSize:O===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=ae}),define(X[54],J([0,1,233,133,24,88]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(E,p){const h={onUnknownOption:P=>{console.warn((0,A.localize)(0,null,P))},onMultipleValues:(P,I)=>{console.warn((0,A.localize)(1,null,P,I))}},w=(0,b.parseArgs)(E,b.OPTIONS,p?h:void 0);return w.goto&&w._.forEach(P=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,A.localize)(2,null))),w["max-memory"]&&m(parseInt(w["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function n(E){const p=E.findIndex(h=>!/^-/.test(h));if(p>-1)return[...E.slice(0,p),...E.slice(p+1)]}function S(E){let[,...p]=E;process.env.VSCODE_DEV&&(p=n(p)||[]);const h=!g(process.env);return M(p,h)}e.parseMainProcessArgv=S;function y(E){const[,,...p]=E;return M(p,!0)}e.parseCLIProcessArgv=y;function r(E,...p){const h=E.indexOf("--");return h===-1?E.push(...p):E.splice(h,0,...p),E}e.addArg=r;function g(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(X[69],J([0,1,154,45,28,3,54,66,128]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(E,p,h){return p["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,M.isLaunchedFromCli)(h)&&!p["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,M.isLaunchedFromCli)(h)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),r||(r=g(E)),r)}e.resolveShellEnv=y;let r;async function g(E){const p=new Promise(async(h,w)=>{const P=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",P);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",I);const a=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(a+"(.*)"+a),o=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});E.trace("getUnixShellEnvironment#env",o);const c=await(0,S.getSystemShell)(b.OS,o);E.trace("getUnixShellEnvironment#shell",c);let t=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,i=["-ilc"];const s=m.basename(c);/^pwsh(-preview)?$/.test(s)&&(t=`& ${t}`,i=["-Login","-Command"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(i),t);const u=(0,A.spawn)(c,[...i,t],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});u.on("error",v=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(v)),h({})});const d=[];u.stdout.on("data",v=>d.push(v));const f=[];u.stderr.on("data",v=>f.push(v)),u.on("close",(v,D)=>{const _=Buffer.concat(d).toString("utf8");E.trace("getUnixShellEnvironment#raw",_);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&E.trace("getUnixShellEnvironment#stderr",U),v||D)return w(new Error(`Failed to get environment (code ${v}, signal ${D})`));const H=l.exec(_),Q=H?H[1]:"{}";try{const ie=JSON.parse(Q);P?ie.ELECTRON_RUN_AS_NODE=P:delete ie.ELECTRON_RUN_AS_NODE,I?ie.ELECTRON_NO_ATTACH_CONSOLE=I:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",ie),h(ie)}catch(ie){E.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(ie)),w(ie)}})});try{return await p}catch(h){return E.error("getUnixShellEnvironment#error",(0,n.toErrorMessage)(h)),{}}}}),define(X[90],J([0,1,7,24,3]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(S){return S.map(y=>({type:y.type,resource:m.URI.file(y.path)}))}e.toFileChanges=b;function M(S){const y=new n;for(const r of S)y.processEvent(r);return y.normalize()}e.normalizeFileChanges=M;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const r=this.mapPathToChange.get(y.path);if(r){const g=r.type,E=y.type;g===1&&E===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(r),1)):g===2&&E===1?r.type=0:g===1&&E===0||(r.type=E)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],r=[];return this.normalized.filter(g=>g.type!==2?(y.push(g),!1):!0).sort((g,E)=>g.path.length-E.path.length).filter(g=>r.some(E=>(0,A.isParent)(g.path,E,!L.isLinux))?!1:(r.push(g.path),!0)).concat(y)}}}),define(X[167],J([0,1,90,2,19,111,115,9,8]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends A.Disposable{constructor(g,E,p,h){super();this.path=g,this.onDidFilesChange=E,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(M.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:E}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(E)try{p=await(0,b.realpath)(p)}catch(h){if(this.onError(h),E.dangling)return}g.isDirectory()?this._register((0,M.watchFolder)(p,(h,w)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(w))})},h=>this.onError(h))):this._register((0,M.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,m.normalizeFileChanges)(E);this.verboseLogging&&p.forEach(h=>{this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(X[70],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...L){this._entries=new Map;for(let[b,M]of L)this.set(b,M)}set(L,b){const M=this._entries.get(L);return this._entries.set(L,b),M}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=m}),define(X[168],J([0,1,17,162,67,4,70,9]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class y extends Error{constructor(h){var w;super("cyclic dependency between services");this.message=(w=h.findCycleSlow())!==null&&w!==void 0?w:`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class r{constructor(h=new M.ServiceCollection,w=!1,P){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=P,this._services.set(b.IInstantiationService,this)}createChild(h){return new r(h,this._strict,this)}invokeFunction(h,...w){let P=E.traceInvocation(h),I=!1;try{return h({get:(l,o)=>{if(I)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(l,P);if(!c&&o!==b.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return c}},...w)}finally{I=!0,P.stop()}}createInstance(h,...w){let P,I;return h instanceof L.SyncDescriptor?(P=E.traceCreation(h.ctor),I=this._createInstance(h.ctor,h.staticArguments.concat(w),P)):(P=E.traceCreation(h),I=this._createInstance(h,w,P)),P.stop(),I}_createInstance(h,w=[],P){let I=b._util.getServiceDependencies(h).sort((o,c)=>o.index-c.index),a=[];for(const o of I){let c=this._getOrCreateServiceInstance(o.id,P);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);a.push(c)}let l=I.length>0?I[0].index:w.length;if(w.length!==l){console.warn(`[createInstance] First service dependency of ${h.name} at position ${l+1} conflicts with ${w.length} static arguments`);let o=l-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,l)}return new h(...[...w,...a])}_setServiceInstance(h,w){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let P=this._getServiceInstanceOrDescriptor(h);return P instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,w.branch(h,!0)):(w.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,w,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,P){const I=new A.Graph(o=>o.id.toString());let a=0;const l=[{id:h,desc:w,_trace:P}];for(;l.length;){const o=l.pop();if(I.lookupOrInsertNode(o),a++>1e3)throw new y(I);for(let c of b._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const i={id:c.id,desc:t,_trace:o._trace.branch(c.id,!0)};I.insertEdge(o,i),l.push(i)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new y(I);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,i)}I.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,P=[],I,a){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(w,P,I,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,P,I,a);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],P,I){if(P){const a=new n.IdleValue(()=>this._createInstance(h,w,I));return new Proxy(Object.create(null),{get(l,o){if(o in l)return l[o];let c=a.value,t=c[o];return typeof t!="function"||(t=t.bind(c),l[o]=t),t},set(l,o,c){return a.value[o]=c,!0}})}else return this._createInstance(h,w,I)}}e.InstantiationService=r;var g;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(g||(g={}));class E{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new E(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(h){return S?new E(0,h.name):E._None}branch(h,w){let P=new E(2,h.toString());return this._dep.push([h,w,P]),P}stop(){let h=Date.now()-this._start;E._totals+=h;let w=!1;function P(a,l){let o=[],c=new Array(a+1).join("	");for(const[t,i,s]of l._dep)if(i&&s){w=!0,o.push(`${c}CREATES -> ${t}`);let u=P(a+1,s);u&&o.push(u)}else o.push(`${c}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(I.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(X[169],J([0,1,17,126,57]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends L.ResolvedKeybinding{constructor(n,S){super();if(S.length===0)throw(0,m.illegalArgument)("parts");this._os=n,this._parts=S}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new L.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=b}),define(X[170],J([0,1,57,169]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class L extends A.BaseResolvedKeybinding{constructor(M,n){super(n,M.parts)}_keyCodeToUILabel(M){if(this._os===2)switch(M){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(M)}_getLabel(M){return M.isDuplicateModifierCase()?"":this._keyCodeToUILabel(M.keyCode)}_getAriaLabel(M){return M.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(M.keyCode)}_keyCodeToElectronAccelerator(M){if(M>=93&&M<=108)return null;switch(M){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(M)}_getElectronAccelerator(M){return M.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(M.keyCode)}_getUserSettingsLabel(M){if(M.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(M.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(M){return L.getDispatchStr(M)}static getDispatchStr(M){if(M.isModifierKey())return null;let n="";return M.ctrlKey&&(n+="ctrl+"),M.shiftKey&&(n+="shift+"),M.altKey&&(n+="alt+"),M.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(M.keyCode),n}_getSingleModifierDispatchPart(M){return M.keyCode===5&&!M.shiftKey&&!M.altKey&&!M.metaKey?"ctrl":M.keyCode===4&&!M.ctrlKey&&!M.altKey&&!M.metaKey?"shift":M.keyCode===6&&!M.ctrlKey&&!M.shiftKey&&!M.metaKey?"alt":M.keyCode===57&&!M.ctrlKey&&!M.shiftKey&&!M.altKey?"meta":null}}e.USLayoutResolvedKeybinding=L}),define(X[171],J([0,1,9]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(L,b){if(L.length===0)return Promise.resolve(!1);const M=[];let n=!1;for(let S of L){if(S===!0)return Promise.resolve(!0);(0,m.isThenable)(S)&&M.push(S.then(y=>{y&&(n=!0)},y=>{b(y),n=!0}))}return m.Promises.settled(M).then(()=>n)}e.handleVetos=A}),define(X[6],J([0,1,4,2,3,5,66]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function n(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class y extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class r extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let u=t[s];if(typeof u=="object")try{u=JSON.stringify(u)}catch(d){}i+=(s>0?" ":"")+u}return i}}e.AbstractMessageLogger=r;class g extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...i):console.log(`[main ${n()}]`,t,...i))}debug(t,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...i):console.log(`[main ${n()}]`,t,...i))}info(t,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...i):console.log(`[main ${n()}]`,t,...i))}warn(t,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...i):console.warn(`[main ${n()}]`,t,...i))}error(t,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...i):console.error(`[main ${n()}]`,t,...i))}critical(t,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...i):console.error(`[main ${n()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class E extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends y{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,M.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class h extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class w extends A.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=w;class P extends A.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?S.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class I{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=I;function a(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=l(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function o(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(X[91],J([0,1,6]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(b,M){switch(M){case m.LogLevel.Trace:return b.trace;case m.LogLevel.Debug:return b.debug;case m.LogLevel.Info:return b.info;case m.LogLevel.Warning:return b.warn;case m.LogLevel.Error:return b.error;case m.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class L extends m.AbstractLogger{constructor(M=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(M){this._logger=M;for(const{level:n,args:S}of this.buffer)A(M,n).apply(M,S);this.buffer=[]}_log(M,...n){this._logger?A(this._logger,M).apply(this._logger,n):this.getLevel()<=M&&this.buffer.push({level:M,args:n})}trace(M,...n){this._log(m.LogLevel.Trace,M,...n)}debug(M,...n){this._log(m.LogLevel.Debug,M,...n)}info(M,...n){this._log(m.LogLevel.Info,M,...n)}warn(M,...n){this._log(m.LogLevel.Warning,M,...n)}error(M,...n){this._log(m.LogLevel.Error,M,...n)}critical(M,...n){this._log(m.LogLevel.Critical,M,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L});var ee=this&&this.__param||function(q,e){return function(m,A){e(m,A,q)}};define(X[172],J([0,1,6,24,9,23,15,4,91]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*A.ByteSize.MB;let r=class extends m.AbstractLogger{constructor(p,h,w,P){super();this.name=p,this.resource=h,this.fileService=P,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new L.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=p.stack,this._log(m.LogLevel.Error,this.format(h))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(p,h){this._log(p,this.format(h))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,h){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>y&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(w)),w=""),w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${h}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(w))})}getCurrentTimestamp(){const p=P=>P<10?`0${P}`:P,h=P=>P<10?`00${P}`:P<100?`0${P}`:P,w=new Date;return`${w.getFullYear()}-${p(w.getMonth()+1)}-${p(w.getDate())} ${p(w.getHours())}:${p(w.getMinutes())}:${p(w.getSeconds())}.${h(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(p){let h="";for(let w=0;w<p.length;w++){let P=p[w];if(typeof P=="object")try{P=JSON.stringify(P)}catch(I){}h+=(w>0?" ":"")+P}return h}};r=ce([ee(3,A.IFileService)],r),e.FileLogger=r;let g=class extends m.AbstractLoggerService{constructor(p,h,w){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=h,this.fileService=w}doCreateLogger(p,h){const w=new S.BufferLogService(h);return(0,A.whenProviderRegistered)(p,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(r,(0,M.basename)(p),p,w.getLevel())),w}};g=ce([ee(0,m.ILogService),ee(1,n.IInstantiationService),ee(2,A.IFileService)],g),e.FileLoggerService=g}),define(X[173],J([0,1,6,5,7]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(E){this.service=E,this.onDidChangeLogLevel=A.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(E,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=b;class M{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){M.setLevel(this.channel,E)}static setLevel(E,p){return E.call("setLevel",p)}}e.LogLevelChannelClient=M;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,p){throw new Error(`Event not found: ${p}`)}async call(E,p,h){switch(p){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(E,p){this.loggers.set(E.toString(),this.loggerService.createLogger(E,p))}consoleLog(E,p){let h=console.log;switch(E){case m.LogLevel.Error:h=console.error;break;case m.LogLevel.Warning:h=console.warn;break;case m.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(E,p){const h=this.loggers.get(E.toString());if(!h)throw new Error("Create the logger before logging");for(const[w,P]of p)switch(w){case m.LogLevel.Trace:h.trace(P);break;case m.LogLevel.Debug:h.debug(P);break;case m.LogLevel.Info:h.info(P);break;case m.LogLevel.Warning:h.warn(P);break;case m.LogLevel.Error:h.error(P);break;case m.LogLevel.Critical:h.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class S extends m.AbstractLoggerService{constructor(E,p,h){super(E,p);this.channel=h}createConsoleMainLogger(){return new m.AdapterLogger({log:(E,p)=>{this.channel.call("consoleLog",[E,p])}})}doCreateLogger(E,p,h){return new y(this.channel,E,p,h)}}e.LoggerChannelClient=S;class y extends m.AbstractMessageLogger{constructor(E,p,h,w){super(w==null?void 0:w.always);this.channel=E,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,p){const h=[[E,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(E){this.channel.call("log",[this.file,E])}}class r extends m.LogService{constructor(E,p){super(p);this.parent=E,this._register(E.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=r}),define(X[92],J([0,1,6,24]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function L(S,y,r,g){try{const E=await new Promise((p,h)=>{q(["spdlog"],p,h)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(S,y,r,g)}catch(E){console.error(E)}return null}function b(S,y,r,g){return q.__$__nodeRequire("spdlog").createRotatingLogger(S,y,r,g)}e.createRotatingLogger=b;function M(S,y,r){switch(y){case m.LogLevel.Trace:S.trace(r);break;case m.LogLevel.Debug:S.debug(r);break;case m.LogLevel.Info:S.info(r);break;case m.LogLevel.Warning:S.warn(r);break;case m.LogLevel.Error:S.error(r);break;case m.LogLevel.Critical:S.critical(r);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(y,r,g,E){super();this.name=y,this.filepath=r,this.rotating=g,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const y=this.rotating?6:1,r=30/y*A.ByteSize.MB;return L(this.name,this.filepath,r,y).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:E,message:p}of this.buffer)M(this._logger,E,p);this.buffer=[]}})}log(y,r){this._logger?M(this._logger,y,r):this.getLevel()<=y&&this.buffer.push({level:y,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(X[174],J([0,1,6,15,10,172,92,24,28]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends m.AbstractLoggerService{constructor(g,E){super(g.getLevel(),g.onDidChangeLogLevel);this.fileService=E}doCreateLogger(g,E,p){var h;if(g.scheme===L.Schemas.file){const w=new M.SpdLogLogger((p==null?void 0:p.name)||(0,S.generateUuid)(),g.fsPath,!(p==null?void 0:p.donotRotate),E);return(p==null?void 0:p.donotUseFormatters)&&w.clearFormatters(),w}else return new b.FileLogger((h=p==null?void 0:p.name)!==null&&h!==void 0?h:(0,A.basename)(g),g,E,this.fileService)}};y=ce([ee(0,m.ILogService),ee(1,n.IFileService)],y),e.LoggerService=y}),define(X[175],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function A(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function L(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function b(M){return!m(M)&&!A(M)&&!L(M)}e.isMenubarMenuItemAction=b}),define(X[47],J([0,1,10,3,32,15]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof A.globals.vscode!="undefined"){const n=A.globals.vscode.context.configuration();if(n)M=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(q==null?void 0:q.__$__nodeRequire)=="function"){const n=(0,b.dirname)(m.FileAccess.asFileUri("",q));M=q.__$__nodeRequire((0,b.joinPath)(n,"product.json").fsPath);const S=q.__$__nodeRequire((0,b.joinPath)(n,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`}),Object.assign(M,{version:S.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.56.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=M}),define(X[93],J([0,1,138,23,24,17,47]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(g,E,p,h,w,P){let I;try{await S(g,E,p,h,w,P)}catch(a){I=a}finally{I&&w.errorTransformer&&(I=w.errorTransformer(I)),typeof I!="undefined"&&p.error(I),p.end()}}e.readFileIntoStream=n;async function S(g,E,p,h,w,P){y(P);const I=await g.open(E,{create:!1});try{y(P);let a=0,l=0,o=w&&typeof w.length=="number"?w.length:void 0,c=A.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,i=0;do l=await g.read(I,t,c.buffer,i,c.byteLength-i),t+=l,i+=l,a+=l,typeof o=="number"&&(o-=l),i===c.byteLength&&(await p.write(h(c)),c=A.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),i=0);while(l>0&&(typeof o!="number"||o>0)&&y(P)&&r(a,w));if(i>0){let s=i;typeof o=="number"&&(s=Math.min(i,o)),p.write(h(c.slice(0,s)))}}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await g.close(I)}}function y(g){if(g.isCancellationRequested)throw(0,b.canceled)();return!0}function r(g,E){if(E==null?void 0:E.limits){if(typeof E.limits.memory=="number"&&g>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,m.localize)(0,null,M.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&g>E.limits.size)throw(0,L.createFileSystemProviderError)((0,m.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[176],J([0,1,136,71,2,24,5,15,36,35,6,23,63,9,25,10,93,62]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends L.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const t=new L.DisposableStore;return t.add(c.onDidChangeFile(i=>this._onDidFilesChange.fire(new b.FileChangesEvent(i,!this.isPathCaseSensitive(c))))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,L.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){c.push(t)}}),!this.provider.has(o)&&await p.Promises.settled(c)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,c){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return I.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,n.isAbsolutePath)(o))throw new b.FileOperationError((0,m.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,o.toString()),t}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasReadWriteCapability)(c)||(0,b.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(t){throw(0,b.toFileSystemProviderErrorCode)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,m.localize)(2,null,this.resourceForError(o)),1):(0,b.ensureFileSystemProviderError)(t)}}async doResolveFile(o,c){const t=await this.withProvider(o),i=this.isPathCaseSensitive(t),s=c==null?void 0:c.resolveTo,u=c==null?void 0:c.resolveSingleChildDescendants,d=c==null?void 0:c.resolveMetadata,f=await t.stat(o);let v;return this.toFileStat(t,o,f,void 0,!!d,(D,_)=>(v||(v=S.TernarySearchTree.forUris(()=>!i),v.set(o,!0),(0,y.isNonEmptyArray)(s)&&s.forEach(U=>v.set(U,!0))),Boolean(v.findSuperstr(D.resource)||v.get(D.resource))?!0:D.isDirectory&&u?_===1:!1))}async toFileStat(o,c,t,i,s,u){const{providerExtUri:d}=this.getExtUri(o),f={resource:c,name:d.basename(c),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,b.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&u(f,i)){try{const v=await o.readdir(c),D=await p.Promises.settled(v.map(async([_,U])=>{try{const H=d.joinPath(c,_),Q=s?await o.stat(H):{type:U};return await this.toFileStat(o,H,Q,v.length,s,u)}catch(H){return this.logService.trace(H),null}}));f.children=(0,y.coalesce)(D)}catch(v){this.logService.trace(v),f.children=[]}return f}return f}async resolveAll(o){return p.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(t){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(t){return t}return!0}async doValidateCreateFile(o,c){if(!(c==null?void 0:c.overwrite)&&await this.exists(o))throw new b.FileOperationError((0,m.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const i=await this.writeFile(o,c);return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,i)),i}async writeFile(o,c,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,o,t)||await this.mkdirp(i,s.dirname(o));let d;if((0,b.hasReadWriteCapability)(i)&&!(c instanceof g.VSBuffer))if((0,E.isReadableStream)(c)){const f=await(0,E.peekStream)(c,3);f.ended?d=g.VSBuffer.concat(f.buffer):d=f}else d=(0,E.peekReadable)(c,f=>g.VSBuffer.concat(f),3);else d=c;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&d instanceof g.VSBuffer?await this.doWriteUnbuffered(i,o,t,d):await this.doWriteBuffered(i,o,t,d instanceof g.VSBuffer?(0,g.bufferToReadable)(d):d)}catch(u){throw new b.FileOperationError((0,m.localize)(4,null,this.resourceForError(o),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(c)));let s;try{s=await o.stat(c)}catch(u){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,m.localize)(6,null,this.resourceForError(c)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,b.etag)({mtime:t.mtime,size:s.size}))throw new b.FileOperationError((0,m.localize)(7,null),3,t);return s}async readFile(o,c){const t=await this.withReadProvider(o);return(c==null?void 0:c.atomic)?this.doReadFileAtomic(t,o,c):this.doReadFile(t,o,c)}async doReadFileAtomic(o,c,t){return new Promise((i,s)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(o,c,t);i(u)}catch(u){s(u)}})})}async doReadFile(o,c,t){const i=await this.doReadFileStream(o,c,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,g.streamToBuffer)(i.value)})}async readFileStream(o,c){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,c)}async doReadFileStream(o,c,t){const i=new h.CancellationTokenSource,s=this.validateReadFile(c,t).then(d=>d,d=>{throw i.cancel(),d});let u;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await s,!((0,b.hasOpenReadWriteCloseCapability)(o)||(0,b.hasFileReadStreamCapability)(o))||(0,b.hasReadWriteCapability)(o)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(o,c,t):(0,b.hasFileReadStreamCapability)(o)?u=this.readFileStreamed(o,c,i.token,t):u=this.readFileBuffered(o,c,i.token,t);const d=await s;return Object.assign(Object.assign({},d),{value:u})}catch(d){throw u&&await(0,E.consumeStream)(u),new b.FileOperationError((0,m.localize)(8,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(d).toString()),(0,b.toFileOperationResult)(d),t)}}readFileStreamed(o,c,t,i=Object.create(null)){const s=o.readFileStream(c,i,t);return(0,E.transform)(s,{data:u=>u instanceof g.VSBuffer?u:g.VSBuffer.wrap(u),error:u=>new b.FileOperationError((0,m.localize)(9,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),i)},u=>g.VSBuffer.concat(u))}readFileBuffered(o,c,t,i=Object.create(null)){const s=(0,g.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,c,s,u=>u,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new b.FileOperationError((0,m.localize)(10,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),i)}),t),s}readFileUnbuffered(o,c,t){const i=(0,E.newWriteableStream)(s=>g.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(c);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(c,s.byteLength,t),i.end(g.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(o,c){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError((0,m.localize)(11,null,this.resourceForError(o)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==b.ETAG_DISABLED&&c.etag===t.etag)throw new b.FileOperationError((0,m.localize)(12,null),2,c);return this.validateReadFileLimits(o,t.size,c),t}validateReadFileLimits(o,c,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&c>t.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,m.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,c,t){return this.doCanMoveCopy(o,c,"move",t)}async canCopy(o,c,t){return this.doCanMoveCopy(o,c,"copy",t)}async doCanMoveCopy(o,c,t,i){if(o.toString()!==c.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(s,o,u,c,t,i)}catch(s){return s}return!0}async move(o,c,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),u=await this.doMoveCopy(i,o,s,c,"move",!!t),d=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,u==="move"?2:3,d)),d}async copy(o,c,t){const i=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),u=await this.doMoveCopy(i,o,s,c,"copy",!!t),d=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,u==="copy"?3:2,d)),d}async doMoveCopy(o,c,t,i,s,u){if(c.toString()===i.toString())return s;const{exists:d,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,c,t,i,s,u);if(d&&!f&&u&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),s==="copy"){if(o===t&&(0,b.hasFileFolderCopyCapability)(o))await o.copy(c,i,{overwrite:u});else{const v=await this.resolve(c);v.isDirectory?await this.doCopyFolder(o,v,t,i):await this.doCopyFile(o,c,t,i)}return s}else return o===t?(await o.rename(c,i,{overwrite:u}),s):(await this.doMoveCopy(o,c,t,i,"copy",u),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,t,i){if((0,b.hasOpenReadWriteCloseCapability)(o)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,c,t,i);if((0,b.hasOpenReadWriteCloseCapability)(o)&&(0,b.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,c,t,i);if((0,b.hasReadWriteCapability)(o)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,c,t,i);if((0,b.hasReadWriteCapability)(o)&&(0,b.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,c,t,i)}async doCopyFolder(o,c,t,i){await t.mkdir(i),Array.isArray(c.children)&&await p.Promises.settled(c.children.map(async s=>{const u=this.getExtUri(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,u):this.doCopyFile(o,s.resource,t,u)}))}async doValidateMoveCopy(o,c,t,i,s,u){let d=!1;if(o===t){const{providerExtUri:v,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(d=v.isEqual(c,i)),d&&s==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(c),this.resourceForError(i)));if(!d&&v.isEqualOrParent(i,c))throw new Error((0,m.localize)(15,null,this.resourceForError(c),this.resourceForError(i)))}const f=await this.exists(i);if(f&&!d){if(!u)throw new b.FileOperationError((0,m.localize)(16,null,this.resourceForError(c),this.resourceForError(i)),4);if(o===t){const{providerExtUri:v}=this.getExtUri(o);if(v.isEqualOrParent(c,i))throw new Error((0,m.localize)(17,null,this.resourceForError(c),this.resourceForError(i)))}}return{exists:f,isSameResourceWithDifferentPathCase:d}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,t)),t}async mkdirp(o,c){const t=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(c,i.dirname(c));)try{if(((await o.stat(c)).type&b.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(c)));break}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(c)),c=i.dirname(c)}for(let s=t.length-1;s>=0;s--){c=i.joinPath(c,t[s]);try{await o.mkdir(c)}catch(u){if((0,b.toFileSystemProviderErrorCode)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(t){return t}return!0}async doValidateDelete(o,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(c==null?void 0:c.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(o)));const s=await this.exists(o);if(!s)throw new b.FileOperationError((0,m.localize)(20,null,this.resourceForError(o)),1);if(!!!(c==null?void 0:c.recursive)&&s){const d=await this.resolve(o);if(d.isDirectory&&Array.isArray(d.children)&&d.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(o)))}return t}async del(o,c){const t=await this.doValidateDelete(o,c),i=!!(c==null?void 0:c.useTrash),s=!!(c==null?void 0:c.recursive);await t.delete(o,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new b.FileOperationEvent(o,1))}watch(o,c={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(o,c).then(s=>{t?(0,L.dispose)(s):i=()=>(0,L.dispose)(s)},s=>this.logService.error(s)),(0,L.toDisposable)(()=>i())}async doWatch(o,c){const t=await this.withProvider(o),i=this.toWatchKey(t,o,c),s=this.activeWatchers.get(i)||{count:0,disposable:t.watch(o,c)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,s),s.count+=1,(0,L.toDisposable)(()=>{s.count--,s.count===0&&((0,L.dispose)(s.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,c,t){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,L.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,c,t,i){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{var s;const u=await o.open(c,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,u,i):await this.doWriteReadableBufferedQueued(o,u,i)}catch(d){throw(0,b.ensureFileSystemProviderError)(d)}finally{await o.close(u)}})}async doWriteStreamBufferedQueued(o,c,t){let i=0,s;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,c,u,u.byteLength,i,0),i+=u.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(u,d)=>{(0,E.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,c,f,f.byteLength,i,0)}catch(v){return d(v)}i+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>d(f),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(o,c,t){let i=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,c,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(o,c,t,i,s,u){let d=0;for(;d<i;)d+=await o.write(c,s+d,t.buffer,u+d,i-d)}async doWriteUnbuffered(o,c,t,i){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,t,i))}async doWriteUnbufferedQueued(o,c,t,i){var s;let u;i instanceof g.VSBuffer?u=i:(0,E.isReadableStream)(i)?u=await(0,g.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?u=await(0,g.bufferedStreamToBuffer)(i):u=(0,g.readableToBuffer)(i),await o.writeFile(c,u.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(o,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,t,i))}async doPipeBufferedQueued(o,c,t,i){let s,u;try{s=await o.open(c,{create:!1}),u=await t.open(i,{create:!0,unlock:!1});const d=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,v=0,D=0;do D=await o.read(s,f,d.buffer,v,d.byteLength-v),await this.doWriteBuffer(t,u,d,D,f,v),f+=D,v+=D,v===d.byteLength&&(v=0);while(D>0)}catch(d){throw(0,b.ensureFileSystemProviderError)(d)}finally{await p.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(o,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,t,i))}async doPipeUnbufferedQueued(o,c,t,i){return t.writeFile(i,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,t,i))}async doPipeUnbufferedToBufferedQueued(o,c,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const u=await o.readFile(c);await this.doWriteBuffer(t,s,g.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,b.ensureFileSystemProviderError)(u)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,c,t,i){const s=await(0,g.streamToBuffer)(this.readFileBuffered(o,c,h.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,s)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new b.FileOperationError((0,m.localize)(22,null,this.resourceForError(c)),6);return o}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};a=ce([ee(0,r.ILogService)],a),e.FileService=a}),define(X[177],J([0,1,18,112,2,24,5,3,19,8,15,30,9,6,139,90,159,161,158,167,63,93,35,23]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends L.Disposable{constructor(d,f){var v;super();this.logService=d,this.options=f,this.BUFFER_SIZE=((v=this.options)===null||v===void 0?void 0:v.bufferSize)||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,n.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(d){try{const{stat:f,symbolicLink:v}=await S.SymlinkSupport.stat(this.toFilePath(d));return{type:this.toType(f,v),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(d){try{const f=await(0,S.readdir)(this.toFilePath(d),{withFileTypes:!0}),v=[];return await Promise.all(f.map(async D=>{try{let _;D.isSymbolicLink()?_=(await this.stat((0,r.joinPath)(d,D.name))).type:_=this.toType(D),v.push([D.name,_])}catch(_){this.logService.trace(_)}})),v}catch(f){throw this.toFileSystemProviderError(f)}}toType(d,f){let v;return(f==null?void 0:f.dangling)?v=b.FileType.Unknown:d.isFile()?v=b.FileType.File:d.isDirectory()?v=b.FileType.Directory:v=b.FileType.Unknown,f&&(v|=b.FileType.SymbolicLink),v}async readFile(d){try{const f=this.toFilePath(d);return await m.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(d,f,v){const D=(0,o.newWriteableStream)(_=>i.VSBuffer.concat(_.map(U=>i.VSBuffer.wrap(U))).buffer);return(0,c.readFileIntoStream)(this,d,D,_=>_.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),v),D}async writeFile(d,f,v){let D;try{const _=this.toFilePath(d);if(!v.create||!v.overwrite){if(await(0,S.exists)(_)){if(!v.overwrite)throw(0,b.createFileSystemProviderError)((0,h.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!v.create)throw(0,b.createFileSystemProviderError)((0,h.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(d,{create:!0,unlock:v.unlock}),await this.write(D,0,f,0,f.byteLength)}catch(_){throw await this.toFileSystemProviderWriteError(d,_)}finally{typeof D=="number"&&await this.close(D)}}async open(d,f){try{const v=this.toFilePath(d);if((0,b.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await S.SymlinkSupport.stat(v);U.mode&128||await m.promises.chmod(v,U.mode|128)}catch(U){this.logService.trace(U)}let D;if((0,b.isFileOpenForWriteOptions)(f)){if(n.isWindows)try{await m.promises.truncate(v,0),D="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}D||(D="w")}else D="r";const _=await(0,A.promisify)(m.open)(v,D);return this.mapHandleToPos.set(_,0),(0,b.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(_,d),_}catch(v){throw(0,b.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(d,v):this.toFileSystemProviderError(v)}}async close(d){try{if(this.mapHandleToPos.delete(d),this.writeHandles.delete(d)&&this.canFlush)try{await(0,A.promisify)(m.fdatasync)(d)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,A.promisify)(m.close)(d)}catch(f){throw this.toFileSystemProviderError(f)}}async read(d,f,v,D,_){const U=this.normalizePos(d,f);let H=null;try{const Q=await(0,A.promisify)(m.read)(d,v,D,_,U);return typeof Q=="number"?H=Q:H=Q.bytesRead,H}catch(Q){throw this.toFileSystemProviderError(Q)}finally{this.updatePos(d,U,H)}}normalizePos(d,f){return f===this.mapHandleToPos.get(d)?null:f}updatePos(d,f,v){const D=this.mapHandleToPos.get(d);typeof D=="number"&&(typeof f=="number"||(typeof v=="number"?this.mapHandleToPos.set(d,D+v):this.mapHandleToPos.delete(d)))}async write(d,f,v,D,_){return(0,E.retry)(()=>this.doWrite(d,f,v,D,_),100,3)}async doWrite(d,f,v,D,_){const U=this.normalizePos(d,f);let H=null;try{const Q=await(0,A.promisify)(m.write)(d,v,D,_,U);return typeof Q=="number"?H=Q:H=Q.bytesWritten,H}catch(Q){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(d),Q)}finally{this.updatePos(d,U,H)}}async mkdir(d){try{await m.promises.mkdir(this.toFilePath(d))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(d,f){try{const v=this.toFilePath(d);await this.doDelete(v,f)}catch(v){throw this.toFileSystemProviderError(v)}}async doDelete(d,f){f.recursive?await(0,S.rimraf)(d,S.RimRafMode.MOVE):await m.promises.unlink(d)}async rename(d,f,v){const D=this.toFilePath(d),_=this.toFilePath(f);if(D!==_)try{await this.validateTargetDeleted(d,f,"move",v.overwrite),await(0,S.move)(D,_)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,h.localize)(2,null,(0,y.basename)(D),(0,y.basename)((0,y.dirname)(_)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(d,f,v){const D=this.toFilePath(d),_=this.toFilePath(f);if(D!==_)try{await this.validateTargetDeleted(d,f,"copy",v.overwrite),await(0,S.copy)(D,_,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,h.localize)(3,null,(0,y.basename)(D),(0,y.basename)((0,y.dirname)(_)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(d,f,v,D){const _=this.toFilePath(d),U=this.toFilePath(f);let H=!1;if(!!(this.capabilities&1024)||(H=(0,g.isEqual)(_,U,!0)),H&&v==="copy")throw(0,b.createFileSystemProviderError)((0,h.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!H&&await(0,S.exists)(U)){if(!D)throw(0,b.createFileSystemProviderError)((0,h.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(d,f){return f.recursive?this.watchRecursive(d,f.excludes):this.watchNonRecursive(d)}watchRecursive(d,f){const v={path:this.toFilePath(d),excludes:f},D=(0,t.insert)(this.recursiveFoldersToWatch,v);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{D(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var d,f,v;if(this.recursiveWatcher instanceof a.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let D,_;((f=(d=this.options)===null||d===void 0?void 0:d.watcher)===null||f===void 0?void 0:f.usePolling)?(D=P.FileWatcher,_=(v=this.options)===null||v===void 0?void 0:v.watcher):this.recursiveFoldersToWatch.length===1?n.isWindows?D=I.FileWatcher:D=P.FileWatcher:D=a.FileWatcher,this.recursiveWatcher=new D(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,w.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===p.LogLevel.Trace,_),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(d){const f=new l.FileWatcher(this.toFilePath(d),D=>this._onDidChangeFile.fire((0,w.toFileChanges)(D)),D=>{D.type==="error"&&this._onDidWatchErrorOccur.fire(D.message),this.logService[D.type](D.message)},this.logService.getLevel()===p.LogLevel.Trace),v=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,L.combinedDisposable)(f,v)}toFilePath(d){return(0,y.normalize)(d.fsPath)}toFileSystemProviderError(d){if(d instanceof b.FileSystemProviderError)return d;let f;switch(d.code){case"ENOENT":f=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=b.FileSystemProviderErrorCode.NoPermissions;break;default:f=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(d,f)}async toFileSystemProviderWriteError(d,f){let v=this.toFileSystemProviderError(f);if(d&&v.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:D}=await S.SymlinkSupport.stat(this.toFilePath(d));D.mode&128||(v=(0,b.createFileSystemProviderError)(f,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(D){this.logService.trace(D)}return v}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(X[20],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(X[178],J([0,1,58,6,20]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(n,S){this.productService=n,this.logService=S,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,S){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(S);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",S),!1;const[,r,g]=y;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const p=Buffer.from(decodeURIComponent(g),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",S),!1;const h=p.slice(0,6),w=p.readUIntBE(0,6),P=Date.now()-w;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",S),!1;const I=p.slice(6),a=m.createVerify("SHA256");a.write(h),a.write(Buffer.from(r)),a.end();for(let l=0;l<E.length;l++){let o=E[l];if(o!==null){if(typeof o=="string")try{o=m.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[l]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${l+1} for ${n}:`,c),E[l]=null;continue}if(a.verify(o,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",S),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",S),!1}};b=ce([ee(0,L.IProductService),ee(1,A.ILogService)],b),e.ExtensionUrlTrustService=b}),define(X[55],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(X[179],J([0,1,2,10,7,46,13,6,36,3,15,28]),function(q,e,m,A,L,b,M,n,S,y,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends m.Disposable{constructor(h,w){super();this.logService=w,this.validRoots=S.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(L.URI.file(h.appRoot)),this.addValidFileRoot(L.URI.file(h.extensionsPath)),this.addValidFileRoot(h.globalStorageHome),this.addValidFileRoot(h.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=M.session;h.protocol.registerFileProtocol(A.Schemas.vscodeFileResource,(w,P)=>this.handleResourceRequest(w,P)),h.protocol.interceptFileProtocol(A.Schemas.file,(w,P)=>this.handleFileRequest(w,P)),this._register((0,m.toDisposable)(()=>{h.protocol.unregisterProtocol(A.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(A.Schemas.file)}))}addValidFileRoot(h){return this.validRoots.get(h)?m.Disposable.None:(this.validRoots.set(h,!0),(0,m.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(h,w){const P=L.URI.parse(h.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${P.fsPath} from ${A.Schemas.file}: protocol (original URL: ${h.url})`),w({error:-3})):this.validRoots.findSubstr(P)?w({path:P.fsPath}):this.validExtensions.has((0,r.extname)(P))?w({path:P.fsPath}):(this.logService.error(`${A.Schemas.file}: Refused to load resource ${P.fsPath} from ${A.Schemas.file}: protocol (original URL: ${h.url})`),w({error:-3}))}handleResourceRequest(h,w){const P=L.URI.parse(h.url),I=A.FileAccess.asFileUri(P);return this.validRoots.findSubstr(I)?w({path:I.fsPath}):this.validExtensions.has((0,r.extname)(I))?w({path:I.fsPath}):(this.logService.error(`${A.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${A.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),w({error:-3}))}createIPCObjectUrl(h){const w=L.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),P=w.toString(),I=async()=>h;return M.ipcMain.handle(P,I),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:w,update:a=>h=a,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),M.ipcMain.removeHandler(P)}}}};E=ce([ee(0,b.INativeEnvironmentService),ee(1,n.ILogService)],E),e.ProtocolMainService=E}),define(X[37],J([0,1,12,100]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(M,n){A.ok(m.isString(M)),A.ok(m.isObject(n)),A.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,n)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new L}),define(X[180],J([0,1,37,5]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class b{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,y){this.schemasById[L(S)]=y,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new b;m.Registry.add(e.Extensions.JSONContribution,M)}),define(X[48],J([0,1,130,5,37,12,180]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=L.Registry.as(M.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,a=!0){this.registerConfigurations([I],a)}registerConfigurations(I,a=!0){const l=[];I.forEach(o=>{l.push(...this.validateAndRegisterProperties(o,a,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(I){const a=[],l=o=>{if(o.properties)for(const c in o.properties)a.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,o.properties[c]);o.allOf&&o.allOf.forEach(c=>l(c))};for(const o of I){l(o);const c=this.configurationContributors.indexOf(o);c!==-1&&this.configurationContributors.splice(c,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(I){const a=[],l=[];for(const o of I)for(const c in o)if(a.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),o[c]);const t={type:"object",default:this.defaultValues[c],description:m.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};l.push(g(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=o[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(I){const a=[];for(const l of I)for(const o in l)if(a.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const a of I)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,a=!0,l,o=3){var c;o=b.isUndefinedOrNull(I.scope)?o:I.scope;let t=[],i=I.properties;if(i)for(let u in i){if(a&&h(u)){delete i[u];continue}const d=i[u];if(this.updatePropertyDefaultValue(u,d),e.OVERRIDE_PROPERTY_PATTERN.test(u)?d.scope=void 0:(d.scope=b.isUndefinedOrNull(d.scope)?o:d.scope,d.requireTrust=b.isUndefinedOrNull(d.requireTrust)?!!((c=l==null?void 0:l.requireTrustForConfigurations)===null||c===void 0?void 0:c.includes(u)):d.requireTrust),i[u].hasOwnProperty("included")&&!i[u].included){this.excludedConfigurationProperties[u]=i[u],delete i[u];continue}else this.configurationProperties[u]=i[u];!i[u].deprecationMessage&&i[u].markdownDeprecationMessage&&(i[u].deprecationMessage=i[u].markdownDeprecationMessage),t.push(u)}let s=I.allOf;if(s)for(let u of s)t.push(...this.validateAndRegisterProperties(u,a,l,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const a=l=>{let o=l.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let c=l.allOf;c&&c.forEach(a)};a(I)}updateSchema(I,a){switch(e.allSettings.properties[I]=a,a.scope){case 1:e.applicationSettings.properties[I]=a;break;case 2:e.machineSettings.properties[I]=a;break;case 6:e.machineOverridableSettings.properties[I]=a;break;case 3:e.windowSettings.properties[I]=a;break;case 4:e.resourceSettings.properties[I]=a;break;case 5:e.resourceSettings.properties[I]=a,this.resourceLanguageSettingsSchema.properties[I]=a;break}}removeFromSchema(I,a){switch(delete e.allSettings.properties[I],a.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const a=`[${I}]`,l={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,l),e.allSettings.properties[a]=l,e.applicationSettings.properties[a]=l,e.machineSettings.properties[a]=l,e.machineOverridableSettings.properties[a]=l,e.windowSettings.properties[a]=l,e.resourceSettings.properties[a]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,a){let l=this.defaultValues[I];b.isUndefined(l)&&(l=a.default),b.isUndefined(l)&&(l=E(a.type)),a.default=l}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function g(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=g;function E(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const p=new y;L.Registry.add(e.Extensions.Configuration,p);function h(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?m.localize(5,null,P):p.getConfigurationProperties()[P]!==void 0?m.localize(6,null,P):null:m.localize(4,null)}e.validateProperty=h;function w(){const P=[],I=p.getConfigurationProperties();for(const a of Object.keys(I))P.push([a,I[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=w}),define(X[21],J([0,1,44,12,7,37,4,48]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,M.createDecorator)("configurationService");function S(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.isConfigurationOverrides=S;var y;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function g(i,s){const u=s?i?s.keys.filter(H=>i.keys.indexOf(H)===-1):[...s.keys]:[],d=i?s?i.keys.filter(H=>s.keys.indexOf(H)===-1):[...i.keys]:[],f=[];if(s&&i){for(const H of i.keys)if(s.keys.indexOf(H)!==-1){const Q=I(i.contents,H),ie=I(s.contents,H);m.equals(Q,ie)||f.push(H)}}const v=[],D=H=>{const Q={};for(const ie of H)for(const ae of ie.identifiers)Q[c(ae)]=ie;return Q},_=s?D(s.overrides):{},U=i?D(i.overrides):{};if(Object.keys(_).length)for(const H of u){const Q=_[H];Q&&v.push([(0,n.overrideIdentifierFromKey)(H),Q.keys])}if(Object.keys(U).length)for(const H of d){const Q=U[H];Q&&v.push([(0,n.overrideIdentifierFromKey)(H),Q.keys])}if(Object.keys(_).length&&Object.keys(U).length)for(const H of f){const Q=U[H],ie=_[H];if(Q&&ie){const ae=g({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:ie.contents,keys:ie.keys,overrides:[]});v.push([(0,n.overrideIdentifierFromKey)(H),[...ae.added,...ae.removed,...ae.updated]])}}return{added:u,removed:d,updated:f,overrides:v}}e.compare=g;function E(i,s){const u=[];for(const d of Object.keys(i))if(n.OVERRIDE_PROPERTY_PATTERN.test(d)){const f={};for(const v in i[d])f[v]=i[d][v];u.push({identifiers:[(0,n.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(f),contents:p(f,s)})}return u}e.toOverrides=E;function p(i,s){const u=Object.create(null);for(let d in i)h(u,d,i[d],s);return u}e.toValuesTree=p;function h(i,s,u,d){const f=s.split("."),v=f.pop();let D=i;for(let _=0;_<f.length;_++){let U=f[_],H=D[U];switch(typeof H){case"undefined":H=D[U]=Object.create(null);break;case"object":break;default:d(`Ignoring ${s} as ${f.slice(0,_+1).join(".")} is ${JSON.stringify(H)}`);return}D=H}if(typeof D=="object"&&D!==null)try{D[v]=u}catch(_){d(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}else d(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=h;function w(i,s){const u=s.split(".");P(i,u)}e.removeFromValueTree=w;function P(i,s){const u=s.shift();if(s.length===0){delete i[u];return}if(Object.keys(i).indexOf(u)!==-1){const d=i[u];typeof d=="object"&&!Array.isArray(d)&&(P(d,s),Object.keys(d).length===0&&delete i[u])}}function I(i,s,u){function d(D,_){let U=D;for(const H of _){if(typeof U!="object"||U===null)return;U=U[H]}return U}const f=s.split("."),v=d(i,f);return typeof v=="undefined"?u:v}e.getConfigurationValue=I;function a(i,s,u){Object.keys(s).forEach(d=>{d!=="__proto__"&&(d in i?A.isObject(i[d])&&A.isObject(s[d])?a(i[d],s[d],u):u&&(i[d]=s[d]):i[d]=s[d])})}e.merge=a;function l(){const i=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=l;function o(){const i=Object.create(null),s=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let u in s){let d=s[u].default;h(i,u,d,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=o;function c(i){return`[${i}]`}e.keyFromOverrideIdentifier=c;function t(i,s,u){const d=i.inspect(s),f=i.inspect(u);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:d.defaultValue}e.getMigratedSettingValue=t}),define(X[181],J([0,1,43,36,35,12,44,7,48,21,37,2,5]),function(q,e,m,A,L,b,M,n,S,y,r,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,y.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const u of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let d=this.contents[u],f=i[u];f&&(typeof d=="object"&&typeof f=="object"?(d=M.deepClone(d),this.mergeContents(d,f)):d=f),s[u]=d}return new p(s,this.keys,this.overrides)}merge(...t){const i=M.deepClone(this.contents),s=M.deepClone(this.overrides),u=[...this.keys];for(const d of t){this.mergeContents(i,d.contents);for(const f of d.overrides){const[v]=s.filter(D=>L.equals(D.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):s.push(M.deepClone(f))}for(const f of d.keys)u.indexOf(f)===-1&&u.push(f)}return new p(i,u,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&b.isObject(t[s])&&b.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=M.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?M.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,y.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,y.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const t=(0,y.getDefaultValues)(),i=(0,y.getConfigurationKeys)(),s=[];for(const u of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(u)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,y.toValuesTree)(t[u],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,i,s)}}e.DefaultConfigurationModel=h;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!b.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:u,overrides:d,untrusted:f}=this.doParseRaw(t,i);this._configurationModel=new p(s,u,d),this._untrustedConfigurations=f||[]}doParseContent(t){let i={},s=null,u=[],d=[],f=[];function v(_){Array.isArray(u)?u.push(_):s&&(u[s]=_)}let D={onObjectBegin:()=>{let _={};v(_),d.push(u),u=_,s=null},onObjectProperty:_=>{s=_},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{let _=[];v(_),d.push(u),u=_,s=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:v,onError:(_,U,H)=>{f.push({error:_,offset:U,length:H})}};if(t)try{m.visit(t,D),i=u[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return i}doParseRaw(t,i){const s=r.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),u=this.filter(t,s,!0,i);t=u.raw;const d=(0,y.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),v=(0,y.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:d,keys:f,overrides:v,untrusted:u.untrusted}}filter(t,i,s,u){if(!(u==null?void 0:u.scopes)&&!(u==null?void 0:u.isUntrusted))return{raw:t,untrusted:[]};const d={},f=[];for(let v in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const D=this.filter(t[v],i,!1,u);d[v]=D.raw,f.push(...D.untrusted)}else{const D=i[v],_=D?typeof D.scope!="undefined"?D.scope:3:void 0;(_===void 0||u.scopes===void 0||u.scopes.includes(_))&&(u.isUntrusted&&(D==null?void 0:D.requireTrust)?f.push(v):d[v]=t[v])}return{raw:d,untrusted:f}}}e.ConfigurationModelParser=w;class P extends g.Disposable{constructor(t,i,s,u){super();this.userSettingsResource=t,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=P;class I{constructor(t,i,s=new p,u=new p,d=new A.ResourceMap,f=new p,v=new A.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=d,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new p,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(t):u.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const u=this.getConsolidateConfigurationModel(i,s),d=this.getFolderConfigurationModelForResource(i.resource,s),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),_=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=d?i.overrideIdentifier?d.freeze().override(i.overrideIdentifier).getValue(t):d.freeze().getValue(t):void 0,ie=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),ae=u.getValue(t),O=L.distinct(L.flatten(u.overrides.map($=>$.identifiers))).filter($=>u.getOverrideValue(t,$)!==void 0);return{defaultValue:v,userValue:D,userLocalValue:_,userRemoteValue:U,workspaceValue:H,workspaceFolderValue:Q,memoryValue:ie,value:ae,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:d==null?void 0:d.freeze().getValue(t),override:i.overrideIdentifier?d==null?void 0:d.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(u=>S.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const d=(0,S.overrideIdentifierFromKey)(u),f=this._defaultConfiguration.getKeysForOverrideIdentifier(d),v=t.getKeysForOverrideIdentifier(d),D=[...v.filter(_=>f.indexOf(_)===-1),...f.filter(_=>v.indexOf(_)===-1),...f.filter(_=>!M.equals(this._defaultConfiguration.override(d).getValue(_),t.override(d).getValue(_)))];return[d,D]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:u,overrides:d}=(0,y.compare)(this.localUserConfiguration,t),f=[...i,...s,...u];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:u,overrides:d}=(0,y.compare)(this.remoteUserConfiguration,t);let f=[...i,...s,...u];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:u,overrides:d}=(0,y.compare)(this.workspaceConfiguration,t);let f=[...i,...s,...u];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:d}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:u,updated:d,removed:f,overrides:v}=(0,y.compare)(s,i);let D=[...u,...d,...f];return(D.length||!s)&&this.updateFolderConfiguration(t,i),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:u,removed:d,overrides:f}=(0,y.compare)(i,void 0);return{keys:[...s,...u,...d],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const u=i.getFolder(t);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const d=this._memoryConfigurationByResource.get(t);d&&(s=s.merge(d))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(i=s.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:u,keys:d}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:u,keys:d}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),d=t.folders.reduce((f,v)=>(f.set(n.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new A.ResourceMap);return new I(i,s,new p,u,d,new p,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function a(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,i=new Map;for(const u of c)u.keys.forEach(d=>t.add(d)),u.overrides.forEach(([d,f])=>{const v=(0,A.getOrSet)(i,d,new Set);f.forEach(D=>v.add(D))});const s=[];return i.forEach((u,d)=>s.push([d,[...u.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=a;class l{constructor(t,i,s,u){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const d=new Set;t.keys.forEach(v=>d.add(v)),t.overrides.forEach(([,v])=>v.forEach(D=>d.add(D))),this.affectedKeys=[...d.values()];const f=new p;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,d=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!M.equals(u,d)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,y.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(t=t[u],!t)return!1;s=s[u]}return!0}}e.ConfigurationChangeEvent=l;class o extends l{constructor(t,i,s,u){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=o}),define(X[182],J([0,1,37,48,2,21,181,5,9,15]),function(q,e,m,A,L,b,M,n,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class r extends L.Disposable{constructor(E,p){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new M.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,p)),this.configuration=new M.Configuration(new M.DefaultConfigurationModel,new M.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new M.Configuration(new M.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,p){const h=typeof E=="string"?E:void 0,w=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,w,void 0)}updateValue(E,p,h,w){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(h,p,1)}onDidDefaultConfigurationChange(E){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new M.DefaultConfigurationModel,E);this.trigger(h,p,6)}trigger(E,p,h){const w=new M.ConfigurationChangeEvent(E,{data:p},this.configuration);w.source=h,w.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=r}),define(X[183],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var A;(function(M){M[M.Unknown=0]="Unknown",M[M.DisableTrust=1]="DisableTrust",M[M.MachineTrusted=2]="MachineTrusted"})(A=e.RemoteTrustOption||(e.RemoteTrustOption={}));var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(n,S=L.Unknown,y){super(n);this._message=n,this._code=S,this._detail=y,this.isHandled=S===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(n){return n instanceof b&&n._code===L.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof b&&n._code===L.NoResolverFound}static isHandled(n){return n instanceof b&&n.isHandled}}e.RemoteAuthorityResolverError=b}),define(X[184],J([0,1,83,28,2,23,5,183,17,9,25]),function(q,e,m,A,L,b,M,n,S,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var E;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function p(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(k){const F=new r.CancellationTokenSource;return setTimeout(()=>F.cancel(),k),F.token}function w(k,F){if(k.isCancellationRequested||F.isCancellationRequested)return r.CancellationToken.Cancelled;const B=new r.CancellationTokenSource;return k.onCancellationRequested(()=>B.cancel()),F.onCancellationRequested(()=>B.cancel()),B.token}class P{constructor(F){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((B,V)=>{this._resolvePromise=B,this._rejectPromise=V}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function I(k,F){const B=new P(F);return B.registerDisposable(k.onControlMessage(V=>{const G=JSON.parse(V.toString()),Y=j(G);Y?B.reject(Y):B.resolve(G)})),B.promise}function a(k,F,B,V,G,Y){const Z=new P(Y);return F.connect(B,V,G,(re,se)=>{Z.didTimeout?(re&&k.error(re),se==null||se.dispose()):re||!se?Z.reject(re):Z.resolve(se)}),Z.promise}function l(k,F){const B=new P(F);return k.then(V=>{B.didTimeout||B.resolve(V)},V=>{B.didTimeout||B.reject(V)}),B.promise}async function o(k,F,B,V){const G=R(k,F);k.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,V)}catch(x){throw k.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),k.logService.error(x),x}k.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,re;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=k.reconnectionProtocol,re=!1):(Z=new m.PersistentProtocol(Y,null),re=!0),k.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:k.connectionToken||"00000000000000000000"};Z.sendControl(b.VSBuffer.fromString(JSON.stringify(se)));try{const x=await I(Z,w(V,h(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}k.logService.trace(`${G} 4/6. received SignRequest control message.`);const ne=await l(k.signService.sign(x.data),V),ue={type:"connectionType",commit:k.commit,signedData:ne,desiredConnectionType:F};return B&&(ue.args=B),k.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(b.VSBuffer.fromString(JSON.stringify(ue))),{protocol:Z,ownsProtocol:re}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(k.logService.error(`${G} the handshake timed out. Error:`),k.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${G} received error control message when negotiating connection. Error:`),k.logService.error(x)),re&&C(Z),x}}async function c(k,F,B,V){const G=Date.now(),Y=R(k,F),{protocol:Z,ownsProtocol:re}=await o(k,F,B,V),se=new P(V);return se.registerDisposable(Z.onControlMessage(x=>{const ne=JSON.parse(x.toString()),ue=j(ne);ue?(k.logService.error(`${Y} received error control message when negotiating connection. Error:`),k.logService.error(ue),re&&C(Z),se.reject(ue)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),se.resolve({protocol:Z,firstMessage:ne}))})),se.promise}async function t(k,F){const{protocol:B}=await c(k,1,void 0,F);return{protocol:B}}async function i(k,F,B){const{protocol:V,firstMessage:G}=await c(k,2,F,B),Y=G&&G.debugPort;return{protocol:V,debugPort:Y}}async function s(k,F,B){const V=Date.now(),G=R(k,3),{protocol:Y}=await o(k,3,F,B);return k.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(V)}!`),Y}async function u(k,F,B){const{host:V,port:G,connectionToken:Y}=await k.addressProvider.getAddress();return{commit:k.commit,host:V,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:B,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function d(k,F,B){try{const V=(0,A.generateUuid)(),G=await u(k,V,null),{protocol:Y}=await t(G,r.CancellationToken.None);return new $(k,F,B,V,Y)}catch(V){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(V),O.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=d;async function f(k,F){try{const B=(0,A.generateUuid)(),V=await u(k,B,null),{protocol:G,debugPort:Y}=await i(V,F,r.CancellationToken.None);return new z(k,F,B,G,Y)}catch(B){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(B),O.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function v(k,F){const B=await u(k,(0,A.generateUuid)(),null);return await s(B,{port:F},r.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function D(k){return(0,y.createCancelablePromise)(F=>new Promise((B,V)=>{const G=setTimeout(B,k*1e3);F.onCancellationRequested(()=>{clearTimeout(G),B()})}))}var _;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(F,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=U;class H{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.durationSeconds=V,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class Q{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=Q;class ie{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=4}}e.ConnectionGainEvent=ie;class ae{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class O extends L.Disposable{constructor(F,B,V,G){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=V,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new ie(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),O._instances.push(this),O._permanentFailure&&this._gotoPermanentFailure(O._permanentFailureMillisSinceLastIncomingData,O._permanentFailureAttempt,O._permanentFailureHandled)}static triggerPermanentFailure(F,B,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=B,this._permanentFailureHandled=V,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!O._permanentFailure){const F=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],V=Date.now();let G=-1;do{G++;const Y=G<B.length?B[G]:B[B.length-1];try{if(Y>0){const re=D(Y);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(se){}}if(O._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,h(g)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-V>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,S.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,n.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!O._permanentFailure)}}_gotoPermanentFailure(F,B,V){this._onDidStateChange.fire(new ae(this.reconnectionToken,F,B,V)),C(this.protocol)}}O._permanentFailure=!1,O._permanentFailureMillisSinceLastIncomingData=0,O._permanentFailureAttempt=0,O._permanentFailureHandled=!1,O._instances=[];class $ extends O{constructor(F,B,V,G,Y){super(1,F,G,Y);this.client=this._register(new m.Client(Y,{remoteAuthority:B,clientId:V},F.ipcLogger))}async _reconnect(F,B){await t(F,B)}}e.ManagementPersistentConnection=$;class z extends O{constructor(F,B,V,G,Y){super(2,F,V,G);this._startArguments=B,this.debugPort=Y}async _reconnect(F,B){await i(F,this._startArguments,B)}}e.ExtensionHostPersistentConnection=z;function C(k){try{k.acceptDisconnect();const F=k.getSocket();k.dispose(),F.dispose()}catch(F){(0,S.onUnexpectedError)(F)}}function j(k){if(k&&k.type==="error"){const F=new Error(`Connection error: ${k.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function N(k,F){for(;k.length<F;)k+=" ";return k}function T(k,F,B){return`[remote-connection][${N(p(k),13)}][${F.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function R(k,F){return`${T(F,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function W(k){return`${Date.now()-k} ms`}}),define(X[72],J([0,1,10]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function A(S){return S.scheme===m.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=A;function L(S){if(!!S){const y=S.indexOf("+");return y<0?S:S.substr(0,y)}}e.getRemoteName=L;function b(S){return S.scheme!==m.Schemas.file&&S.scheme!==m.Schemas.vscodeRemote}function M(S){if(S.folders.length)return S.folders.every(y=>b(y.uri))?S.folders[0].uri:void 0;if(S.configuration&&b(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=M;function n(S){var y;return(y=M(S))===null||y===void 0?void 0:y.scheme}e.getVirtualWorkspaceScheme=n}),define(X[73],J([0,1,5,3,4,6]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService");var M;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(M=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!p)return{address:p[1],port:+p[2]}}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=y;function r(E,p){return p?p!==1&&E<1024:!A.isWindows&&E<1024}e.isPortPrivileged=r;let g=class{constructor(p){this.logService=p,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(p,h){return this._tunnelProvider=p,p?(this._canElevate=h.elevation,this._canMakePublic=h.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const h=[],w=Array.from(this._tunnels.values());for(let P of w){const I=Array.from(P.values());for(let a of I){const l=await a.value;l&&h.push(l)}}p(h)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:h}of p.values())await h.then(w=>w==null?void 0:w.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,h,w,P,I=!1,a=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${w} on local port ${P}.`),!!p){h||(h="localhost");const l=this.retainOrCreateTunnel(p,h,w,P,I,a);return l?l.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemotePort} `);const h=this._tunnels.get(p.tunnelRemoteHost);if(h){const w=h.get(p.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,w))}}}}async tryDisposeTunnel(p,h,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${h}.`);const P=w.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(h),P}}async closeTunnel(p,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h} `);const w=this._tunnels.get(p);if(w&&w.has(h)){const P=w.get(h);P.refcount=0,await this.tryDisposeTunnel(p,h,P)}}addTunnelToMap(p,h,w){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(h,{refcount:1,value:w})}async removeEmptyTunnelFromMap(p,h){const w=this._tunnels.get(p);w&&(await w.get(h)||w.delete(h),w.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,h){let w=[p];S(p)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):y(p)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const P=w.map(I=>this._tunnels.get(I));for(const I of P){const a=I==null?void 0:I.get(h);if(a)return a}}canTunnel(p){return!!n(p)}createWithProvider(p,h,w,P,I,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${w} on local port ${P}.`);const o={elevationRequired:I?r(P===void 0?w:P):!1},c={remoteAddress:{host:h,port:w},localAddressPort:P,public:a},t=p.forwardPort(c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(h,w,t),t}};g=ce([ee(0,b.ILogService)],g),e.AbstractTunnelService=g}),define(X[49],J([0,1,142,4,48,37,23]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function n(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=n;function S(h){return h.res.statusCode===204}async function y(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,M.streamToBuffer)(h.stream)).toString()}e.asText=y;async function r(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const P=(await(0,M.streamToBuffer)(h.stream)).toString();try{return JSON.parse(P)}catch(I){throw I.message+=`:
`+P,I}}e.asJson=r;function g(h){p(h)}e.updateProxyConfigurationsScope=g;let E;function p(h){const w=b.Registry.as(L.Extensions.Configuration);E&&w.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),requireTrust:!0}}},w.registerConfiguration(E)}p(2)}),define(X[185],J([0,1,186,12]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(M,n){return M.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:M.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function b(M,n,S={}){const y=(0,m.parse)(M),r=S.proxyUrl||L(y,n);if(!r)return null;const g=(0,m.parse)(r);if(!/^https?:$/.test(g.protocol||""))return null;const E={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,A.isBoolean)(S.strictSSL)?S.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,h)=>{q(["http-proxy-agent"],p,h)}))(E):new(await new Promise((p,h)=>{q(["https-proxy-agent"],p,h)}))(E)}e.getProxyAgent=b}),define(X[187],J([0,1,28,23]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(b,M,n){let S=n&&n.get("storage.serviceMachineId",0)||null;if(S)return S;try{const r=(await M.readFile(b.serviceMachineIdResource)).value.toString();S=(0,m.isUUID)(r)?r:null}catch(y){S=null}if(!S){S=(0,m.generateUuid)();try{await M.writeFile(b.serviceMachineIdResource,A.VSBuffer.fromString(S))}catch(y){}}return n&&n.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=L}),define(X[74],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[188],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((L,b)=>q(["vsda"],L,b))}async sign(L){try{const b=await this.vsda(),M=new b.signer;if(M)return M.sign(L)}catch(b){}return L}}e.SignService=m}),define(X[38],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,m.createDecorator)("stateService")}),define(X[16],J([0,1,13,6,38,5,4,171,3,2,9,12,32]),function(q,e,m,A,L,b,M,n,S,y,r,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,M.createDecorator)("lifecycleMainService");var p;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var h;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen"})(h=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class it extends y.Disposable{constructor(I,a){super();this.logService=I,this.stateService=a,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(it.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(it.QUIT_FROM_RESTART_MARKER)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",I);const a=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",a),m.app.once("will-quit",l=>{this.logService.trace("Lifecycle#app.on(will-quit)"),l.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",I),m.app.removeListener("window-all-closed",a),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(a){I.push(a)}}),this.pendingWillShutdownPromise=r.Promises.settled(I).then(()=>{},a=>this.logService.error(a)),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==I){this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const a=this.phaseWhen.get(this._phase);a&&(a.open(),this.phaseWhen.delete(this._phase))}}async when(I){if(!(I<=this._phase)){let a=this.phaseWhen.get(I);a||(a=new r.Barrier,this.phaseWhen.set(I,a)),await a.wait()}}registerWindow(I){const a=new y.DisposableStore;this.windowCounter++,a.add(I.onWillLoad(o=>this._onWillLoadWindow.fire({window:I,workspace:o.workspace})));const l=(0,g.assertIsDefined)(I.win);l.on("close",o=>{const c=I.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),o.preventDefault(),this.unload(I,1).then(t=>{if(t){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(I),I.close()})}),l.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,a.dispose(),this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,a){await this.unload(I,3)||I.reload(a)}async unload(I,a){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const l=this._quitRequested?2:a;let o=await this.onBeforeUnloadWindowInRenderer(I,l);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(I,l),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,l),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(I,a){return new Promise(l=>{const o=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${o}`,t=`vscode:cancel${o}`;m.ipcMain.once(c,()=>{l(!1)}),m.ipcMain.once(t,()=>{l(!0)}),I.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:t,reason:a})})}onBeforeUnloadWindowInMain(I,a){const l=[];return this._onBeforeUnloadWindow.fire({reason:a,window:I,veto(o){l.push(o)}}),(0,n.handleVetos)(l,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(I,a){return new Promise(l=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(c,()=>l()),I.send("vscode:onWillUnload",{replyChannel:c,reason:a})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${I}`),I&&this.stateService.setItem(it.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(a=>{this.pendingQuitPromiseResolve=a,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}relaunch(I){this.logService.trace("Lifecycle#relaunch()");const a=process.argv.slice(1);if((I==null?void 0:I.addArgs)&&a.push(...I.addArgs),I==null?void 0:I.removeArgs)for(const o of I.removeArgs){const c=a.indexOf(o);c>=0&&a.splice(c,1)}let l=!1;m.app.once("quit",()=>{if(!l){this.stateService.setItem(it.QUIT_FROM_RESTART_MARKER,!0);try{if(S.isWindows){const o=(0,E.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:a})}}),this.quit().then(o=>l=o)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const a of m.BrowserWindow.getAllWindows())if(a&&!a.isDestroyed()){let l;a.webContents&&!a.webContents.isDestroyed()?l=new Promise(o=>a.once("closed",o)):l=Promise.resolve(),a.destroy(),await l}})()]),m.app.exit(I)}};w.QUIT_FROM_RESTART_MARKER="quit.from.restart",w=ce([ee(0,A.ILogService),ee(1,L.IStateService)],w),e.LifecycleMainService=w}),define(X[189],J([0,1,4,5,2,16]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let M=class extends L.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((r,g)=>{q(["native-keymap"],r,g)});this._keyboardLayoutData=n(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ce([ee(0,b.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function n(S){const y=S.getKeyMap(),r=S.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:r}}}),define(X[190],J([0,1,8,18,46,19,12,6]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class S{constructor(g,E){this.dbPath=g,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=A.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await A.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,E){const p=this.database[g];return(0,M.isUndefinedOrNull)(p)?E:p}setItem(g,E){if((0,M.isUndefinedOrNull)(E))return this.removeItem(g);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[g]===E||(this.database[g]=E,this.saveSync())}removeItem(g){(0,M.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,b.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(E){this.onError(E)}}}e.FileStorage=S;let y=class wt{constructor(g,E){this.fileStorage=new S(m.join(g.userDataPath,wt.STATE_FILE),p=>E.error(p))}init(){return this.fileStorage.init()}getItem(g,E){return this.fileStorage.getItem(g,E)}setItem(g,E){this.fileStorage.setItem(g,E)}removeItem(g){this.fileStorage.removeItem(g)}};y.STATE_FILE="storage.json",y=ce([ee(0,L.INativeEnvironmentService),ee(1,n.ILogService)],y),e.StateService=y}),define(X[94],J([0,1,4,5,2,12,85,9]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var y;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var r;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(r=e.StorageScope||(e.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class E extends L.Disposable{constructor(P={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,I){I===S?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:I,target:this.getKeyTargets(P)[I]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,I,a){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.get(P,a)}getBoolean(P,I,a){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.getBoolean(P,a)}getNumber(P,I,a){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.getNumber(P,a)}store(P,I,a,l){if((0,b.isUndefinedOrNull)(I)){this.remove(P,a);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(P,a,l),(o=this.getStorage(a))===null||o===void 0||o.set(P,I)})}remove(P,I){this.withPausedEmitters(()=>{var a;this.updateKeyTarget(P,I,void 0),(a=this.getStorage(I))===null||a===void 0||a.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,I){const a=[],l=this.getKeyTargets(P);for(const o of Object.keys(l))l[o]===I&&a.push(o);return a}updateKeyTarget(P,I,a){var l,o;const c=this.getKeyTargets(I);typeof a=="number"?c[P]!==a&&(c[P]=a,(l=this.getStorage(I))===null||l===void 0||l.set(S,JSON.stringify(c))):typeof c[P]=="number"&&(delete c[P],(o=this.getStorage(I))===null||o===void 0||o.set(S,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const I=this.get(S,P);if(I)try{return JSON.parse(I)}catch(a){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){var P,I,a,l;this._onWillSaveState.fire({reason:y.NONE}),await n.Promises.settled([(I=(P=this.getStorage(0))===null||P===void 0?void 0:P.whenFlushed())!==null&&I!==void 0?I:Promise.resolve(),(l=(a=this.getStorage(1))===null||a===void 0?void 0:a.whenFlushed())!==null&&l!==void 0?l:Promise.resolve()])}async logStorage(){var P,I,a,l,o,c;const t=(I=(P=this.getStorage(0))===null||P===void 0?void 0:P.items)!==null&&I!==void 0?I:new Map,i=(l=(a=this.getStorage(1))===null||a===void 0?void 0:a.items)!==null&&l!==void 0?l:new Map;return h(t,i,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(c=this.getLogDetails(1))!==null&&c!==void 0?c:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends E{constructor(){super();this.globalStorage=new M.Storage(new M.InMemoryStorageDatabase),this.workspaceStorage=new M.Storage(new M.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=p;async function h(w,P,I,a){const l=d=>{try{return JSON.parse(d)}catch(f){return d}},o=new Map,c=new Map;w.forEach((d,f)=>{o.set(f,d),c.set(f,l(d))});const t=new Map,i=new Map;P.forEach((d,f)=>{t.set(f,d),i.set(f,l(d))}),console.group(`Storage: Global (path: ${I})`);let s=[];o.forEach((d,f)=>{s.push({key:f,value:d})}),console.table(s),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${a})`);let u=[];t.forEach((d,f)=>{u.push({key:f,value:d})}),console.table(u),console.groupEnd(),console.log(i)}e.logStorage=h}),define(X[191],J([0,1,3,32,28,7]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function M(y){if(m.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function n(y,r,g,E,p,h,w,P,I,a){const l=Object.create(null);l["common.machineId"]=w,l.sessionID=(0,L.generateUuid)()+Date.now(),l.commitHash=p,l.version=h,l["common.platformVersion"]=(r||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,m.PlatformToString)(m.platform),l["common.nodePlatform"]=A.platform,l["common.nodeArch"]=E,l["common.product"]=a||"desktop";const o=S(P||[]);o&&(l["common.msftInternal"]=o);let c=0;const t=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),m.isLinuxSnap&&(l["common.snap"]="true");const i=M(g);i&&(l["common.platformDetail"]=i);try{const s=await y.readFile(b.URI.file(I));l["common.source"]=s.value.toString().slice(0,30)}catch(s){}return l}e.resolveCommonProperties=n;function S(y){const r=A.env.USERDNSDOMAIN;if(!r)return!1;const g=r.toLowerCase();return y.some(E=>g===E)}}),define(X[31],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[192],J([0,1,27,65,68,18,8,43,82,20,3,7,31,62,10,24,19]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(t,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,d=new Map,f=2e4;function v(U,H,Q,ie){const ae=H.substring(U.length+1);return new Promise(async O=>{var $,z,C;let j;try{j=await(0,P.readdir)(H,{withFileTypes:!0})}catch(R){O();return}if(ie.count>=f){ie.count+=j.length,ie.maxReached=!0,O();return}let N=j.length;if(N===0){O();return}let T=j;ie.count+j.length>f&&(ie.maxReached=!0,N=f-ie.count,T=j.slice(0,N)),ie.count+=j.length;for(const R of T)if(R.isDirectory()){if(Q.includes(R.name)||await v(U,(0,M.join)(H,R.name),Q,ie),--N==0){O();return}}else{const W=R.name.lastIndexOf(".");if(W>=0){const k=R.name.substring(W+1);k&&u.set(k,(($=u.get(k))!==null&&$!==void 0?$:0)+1)}for(const k of s)((z=k.relativePathPattern)===null||z===void 0?void 0:z.test(ae))!==!1&&k.filePattern.test(R.name)&&d.set(k.tag,((C=d.get(k.tag))!==null&&C!==void 0?C:0)+1);if(--N==0){O();return}}})}const D={count:0,maxReached:!1};await v(t,t,i,D);const _=await o(t);return{configFiles:a(d),fileTypes:a(u),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=I;function a(t){return[...p.Iterable.map(t.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function l(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},i=m.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=l;function o(t){let i=new Map,s=(0,M.join)(t,".vscode","launch.json");return new Promise((u,d)=>{(0,b.exists)(s,f=>{if(f)(0,b.readFile)(s,(v,D)=>{if(v)return u([]);const _=[],U=(0,n.parse)(D.toString(),_);if(_.length)return console.log(`Unable to parse ${s}`),u([]);if((0,n.getNodeType)(U)==="object"&&U.configurations)for(const H of U.configurations){const Q=H.type;Q&&(i.has(Q)?i.set(Q,i.get(Q)+1):i.set(Q,1))}return u(a(i))});else return u([])})})}e.collectLaunchConfigs=o;let c=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const u=m.cpus();return u&&u.length>0&&s.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),s.push(`Memory (System):  ${(m.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),r.isWindows||s.push(`Load (avg):       ${m.loadavg().map(d=>Math.round(d)).join(", ")}`),s.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async u=>{let[d,f]=u,v=this.formatProcessList(i,d);return s.forEach(D=>{if((0,L.isRemoteDiagnosticError)(D))v+=`
${D.errorMessage}`,f+=`
${D.errorMessage}`;else if(v+=`

Remote: ${D.hostName}`,D.processes&&(v+=`
${this.formatProcessList(i,D.processes)}`),D.workspaceMetadata){f+=`
|  Remote: ${D.hostName}`;for(const _ of Object.keys(D.workspaceMetadata)){const U=D.workspaceMetadata[_];let H=`${U.fileCount} files`;U.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${_}): ${H}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:v,workspaceInfo:f}})}async getSystemInfo(i,s){const{memory:u,vmHint:d,os:f,cpus:v}=l(),D={os:f,memory:u,cpus:v,vmHint:d,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return r.isWindows||(D.load=`${m.loadavg().map(_=>Math.round(_)).join(", ")}`),r.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(i,s){const u=[];return(0,S.listProcesses)(i.mainPID).then(async d=>(u.push(""),u.push(this.formatEnvironment(i)),u.push(""),u.push(this.formatProcessList(i,d)),i.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(i))),s.forEach(f=>{if((0,L.isRemoteDiagnosticError)(f))u.push(`
${f.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${f.hostName}`),u.push(this.formatMachineInfo(f.machineInfo)),f.processes&&u.push(this.formatProcessList(i,f.processes)),f.workspaceMetadata)for(const v of Object.keys(f.workspaceMetadata)){const D=f.workspaceMetadata[v];let _=`${D.fileCount} files`;D.maxFilesReached&&(_=`more than ${_}`),u.push(`Folder (${v}): ${_}`),u.push(this.formatWorkspaceStats(D))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(i){const s=[],u=60;let d=0;const f=(U,H)=>{const Q=` ${U}(${H})`;d+Q.length>u?(s.push(v),v="|                 ",d=v.length):d+=Q.length,v+=Q};let v="|      File types:";const D=10;let _=i.fileTypes.length>D?D:i.fileTypes.length;for(let U=0;U<_;U++){const H=i.fileTypes[U];f(H.name,H.count)}if(s.push(v),i.configFiles.length>=0&&(v="|      Conf files:",d=0,i.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(v)),i.launchConfigFiles.length>0){let U="|      Launch Configs:";i.launchConfigFiles.forEach(H=>{U+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(u=>u.length));return Object.keys(i).map(u=>`${u}:  ${" ".repeat(s-u.length)}  ${i[u]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],u=[];return i.windows.forEach(d=>{d.folderURIs.length===0||!!d.remoteAuthority||(s.push(`|  Window (${d.title})`),d.folderURIs.forEach(f=>{const v=g.URI.revive(f);if(v.scheme===h.Schemas.file){const D=v.fsPath;u.push(I(D,["node_modules",".git"]).then(_=>{let U=`${_.fileCount} files`;_.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,M.basename)(D)}): ${U}`),s.push(this.formatWorkspaceStats(_))}).catch(_=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${_.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(d=>s.join(`
`)).catch(d=>`Unable to collect workspace stats: ${d}`)}formatProcessList(i,s){const u=new Map;i.windows.forEach(f=>u.set(f.pid,f.title));const d=[];return d.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,u,d,s,0),d.join(`
`)}formatProcessItem(i,s,u,d,f){const v=f===0;let D;v?D=d.pid===i?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(f)} ${d.name}`,d.name==="window"&&(D=`${D} (${s.get(d.pid)})`));const _=process.platform==="win32"?d.mem:m.totalmem()*(d.mem/100);u.push(`${d.load.toFixed(0).padStart(5," ")}	${(_/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${d.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(d.children)&&d.children.forEach(U=>this.formatProcessItem(i,s,u,U,f+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const u=g.URI.revive(s);if(u.scheme===h.Schemas.file){const d=u.fsPath;try{const f=await I(d,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),f.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),f.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),f.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})})}catch(f){}}}}};c=ce([ee(0,E.ITelemetryService),ee(1,y.IProductService)],c),e.DiagnosticsService=c}),define(X[193],J([0,1,17,163,166,44,31,49,157,46,25,6,24,7,20,94,187,4,15]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(l||(l={}));function o(...T){return String(T.reduce((R,W)=>R|W,0))}var c;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class d{constructor(R=u){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,W=this.state.pageSize){return new d(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:W}))}withFilter(R,...W){const k=[...this.state.criteria,...W.length?W.map(F=>({filterType:R,value:F})):[{filterType:R}]];return new d(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(R){return new d(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new d(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new d(Object.assign(Object.assign({},this.state),{flags:R.reduce((W,k)=>W|k,0)}))}withAssetTypes(...R){return new d(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:W,pageSize:k,sortBy:F,sortOrder:B,flags:V,assetTypes:G}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:k,sortBy:F,sortOrder:B}],assetTypes:G,flags:V}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===c.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(T,R){const W=(T||[]).filter(k=>k.statisticName===R)[0];return W?W.value:0}function v(T){const R="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(k=>k.assetType.indexOf(R)===0).reduce((k,F)=>{const B=H(T,F.assetType);return B&&k.push([F.assetType.substring(R.length),B]),k},[])}function D(T){if(T.properties){const R=T.properties.filter(F=>F.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),k=R.filter(F=>W.test(F.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return H(T,t.Repository)}function _(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function U(T){const R=H(T,t.Icon);if(R)return R;const W=A.DefaultIconPath;return{uri:W,fallbackUri:W}}function H(T,R){return T.files.filter(k=>k.assetType===R)[0]?{uri:`${T.assetUri}/${R}`,fallbackUri:`${T.fallbackAssetUri}/${R}`}:null}function Q(T,R){const W=T.properties?T.properties.filter(F=>F.key===R):[],k=W.length>0&&W[0].value;return k?k.split(",").map(F=>(0,L.adoptToGalleryExtensionId)(F)):[]}function ie(T){const R=T.properties?T.properties.filter(W=>W.key===i.Engine):[];return R.length>0&&R[0].value||""}function ae(T){const R=T.properties?T.properties.filter(k=>k.key===i.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function O(T){return T.indexOf("preview")!==-1}function $(T){const R=T.properties?T.properties.find(W=>W.key===i.WebExtension):void 0;return!!R&&R.value==="true"}function z(T){return T.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,a.joinPath)(p.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(T,R,W,k,F){const B={manifest:H(R,t.Manifest),readme:H(R,t.Details),changelog:H(R,t.Changelog),license:H(R,t.License),repository:D(R),download:_(R),icon:U(R),coreTranslations:v(R)};return{identifier:{id:(0,L.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:R.version,date:R.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:f(T.statistics,"install"),rating:f(T.statistics,"averagerating"),ratingCount:f(T.statistics,"ratingcount"),assetUri:p.URI.parse(R.assetUri),webResource:z(R),assetTypes:R.files.map(({assetType:V})=>V),assets:B,properties:{dependencies:Q(R,i.Dependency),extensionPack:Q(R,i.ExtensionPack),engine:ie(R),localizedLanguages:ae(R),webExtension:$(R)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+W,searchText:k.searchText,querySource:F},preview:O(T.flags)}}let j=class{constructor(R,W,k,F,B,V,G){this.requestService=R,this.logService=W,this.environmentService=k,this.telemetryService=F,this.fileService=B,this.productService=V;const Y=V.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,G)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W){const k=[];let{total:F,firstPage:B,getPage:V}=await this.query({names:R,pageSize:R.length},W);k.push(...B);for(let G=1;k.length<F&&(B=await V(G,W),B.length);G++)k.push(...B);return k}async getCompatibleExtension(R,W){const k=await this.getCompatibleExtensionByEngine(R,W);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(R,W){const k=(0,A.isIExtensionIdentifier)(R)?null:R;if(k&&k.properties.engine&&(0,S.isEngineValid)(k.properties.engine,this.productService.version))return k;const{id:F,uuid:B}=k?k.identifier:R;let V=new d().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");B?V=V.withFilter(c.ExtensionId,B):V=V.withFilter(c.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(V,r.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const re=Y.versions.filter(se=>se.version===W)[0];if(re){const se=C(Y,re,0,V);if(se.properties.engine&&(0,S.isEngineValid)(se.properties.engine,this.productService.version))return se}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?C(Y,Z,0,V):null}async query(R,W){const k=r.CancellationToken.isCancellationToken(R)?{}:R,F=r.CancellationToken.isCancellationToken(R)?R:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=k.text||"";const V=(0,b.getOrDefault)(k,x=>x.pageSize,50);let G=new d().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,V).withFilter(c.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(c.Category,ue||ne),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(c.Tag,ue||ne),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(c.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),G=G.withFilter(c.SearchText,B)),G=G.withSortBy(0)):k.ids?G=G.withFilter(c.ExtensionId,...k.ids):k.names?G=G.withFilter(c.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),re=Y.map((x,ne)=>C(x,x.versions[0],ne,G,k.source)),se=async(x,ne)=>{if(ne.isCancellationRequested)throw(0,m.canceled)();const ue=G.withPage(x+1),{galleryExtensions:ye}=await this.queryGallery(ue,ne);return ye.map((ge,Ee)=>C(ge,ge.versions[0],Ee,ue,k.source))};return{firstPage:re,total:Z,pageSize:G.pageSize,getPage:se}}async queryGallery(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,l.ExcludeNonValidated).withFilter(c.ExcludeWithFlags,o(l.Unpublished));const k=await this.commonHeadersPromise,F=JSON.stringify(R.raw),B=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),V=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:B},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const re=await(0,n.asJson)(G);if(re){const se=re.results[0],x=se.extensions,ne=se.resultMetadata&&se.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Z=ne&&ne.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:Z}}return{galleryExtensions:[],total:Z}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-V,success:!!G&&(0,n.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,m.isPromiseCanceledError)(Y)?"canceled":(0,m.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(R,W,k,F){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,V=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${W}/${k}/stats?statType=${F}`),headers:V},r.CancellationToken.None)}catch(G){}}}async download(R,W,k){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const F=(0,L.getGalleryExtensionTelemetryData)(R),B=new Date().getTime(),V=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=k===1?"install":k===2?"update":"",Y=G?{uri:`${R.assets.download.uri}&${G}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${G}=true`}:R.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(W,Z.stream),V(new Date().getTime()-B)}async getReadme(R,W){if(R.assets.readme){const k=await this.getAsset(R.assets.readme,{},W);return await(0,n.asText)(k)||""}return""}async getManifest(R,W){if(R.assets.manifest){const k=await this.getAsset(R.assets.manifest,{},W),F=await(0,n.asText)(k);return F?JSON.parse(F):null}return null}async getCoreTranslation(R,W){const k=R.assets.coreTranslations.filter(F=>F[0]===W.toUpperCase())[0];if(k){const F=await this.getAsset(k[1]),B=await(0,n.asText)(F);return B?JSON.parse(B):null}return null}async getChangelog(R,W){if(R.assets.changelog){const k=await this.getAsset(R.assets.changelog,{},W);return await(0,n.asText)(k)||""}return""}async getAllVersions(R,W){let k=new d().withFlags(l.IncludeVersions,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?k=k.withFilter(c.ExtensionId,R.identifier.uuid):k=k.withFilter(c.ExtensionName,R.identifier.id);const F=[],{galleryExtensions:B}=await this.queryGallery(k,r.CancellationToken.None);return B.length&&(W?await Promise.all(B[0].versions.map(async V=>{let G;try{G=await this.getEngine(V)}catch(Y){}G&&(0,S.isEngineValid)(G,this.productService.version)&&F.push({version:V.version,date:V.lastUpdated})})):F.push(...B[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),F}async getAsset(R,W={},k=r.CancellationToken.None){const F=await this.commonHeadersPromise,B={type:"GET"},V=Object.assign(Object.assign({},F),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),B),{headers:V});const G=R.uri,Y=R.fallbackUri,Z=Object.assign(Object.assign({},W),{url:G});try{const re=await this.requestService.request(Z,k);if(re.res.statusCode===200)return re;const se=await(0,n.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${se}`)}catch(re){if((0,m.isPromiseCanceledError)(re))throw re;const se=(0,m.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const x=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(x,k)}}async getLastValidExtensionVersion(R,W){const k=this.getLastValidExtensionVersionFromProperties(R,W);return k||this.getLastValidExtensionVersionRecursively(R,W)}getLastValidExtensionVersionFromProperties(R,W){for(const k of W){const F=ie(k);if(!F)return null;if((0,S.isEngineValid)(F,this.productService.version))return k}return null}async getEngine(R){const W=ie(R);if(W)return W;const k=H(R,t.Manifest);if(!k)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},B=await this.getAsset(k,{headers:F}),V=await(0,n.asJson)(B);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,W){if(!W.length)return null;const k=W[0],F=await this.getEngine(k);return(0,S.isEngineValid)(F,this.productService.version)?(k.properties=k.properties||[],k.properties.push({key:i.Engine,value:F}),k):this.getLastValidExtensionVersionRecursively(R,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,n.asJson)(R),k=new Map;if(W)for(const F of W.malicious){const B=k.get(F)||{id:{id:F},malicious:!0,slow:!1};B.malicious=!0,k.set(F,B)}return[...k.values()]}};j=ce([ee(0,n.IRequestService),ee(1,g.ILogService),ee(2,y.IEnvironmentService),ee(3,M.ITelemetryService),ee(4,E.IFileService),ee(5,h.IProductService),ee(6,(0,I.optional)(w.IStorageService))],j),e.ExtensionGalleryService=j;async function N(T,R,W,k){const F={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},B=await(0,P.getServiceMachineId)(R,W,k);return F["X-Market-User-Id"]=B,F}e.resolveMarketplaceHeaders=N}),define(X[194],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(b){this.appender=b}listen(b,M){throw new Error(`Event not found: ${M}`)}call(b,M,{eventName:n,data:S}){return this.appender.log(n,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class A{constructor(b){this.channel=b}log(b,M){return this.channel.call("log",{eventName:b,data:M}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(X[195],J([0,1,47,143,22,4,21,48,2,44,37]),function(q,e,m,A,L,b,M,n,S,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(h,w){this._configurationService=w,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const I=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(h,w){this._experimentProperties[h]=w}setEnabled(h){this._enabled=h}_updateUserOptIn(){var h;const w=(h=this._configurationService)===null||h===void 0?void 0:h.getValue(E);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let w=h.sessionID,P=h["common.instanceId"],I=h["common.machineId"],a=h["common.firstSessionDate"],l=h["common.msftInternal"];return{sessionId:w,instanceId:P,machineId:I,firstSessionDate:a,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(h,w,P){return this.isOptedIn?this._commonProperties.then(I=>{w=(0,y.mixin)(w,I),w=(0,y.mixin)(w,this._experimentProperties),w=(0,y.cloneAndChange)(w,a=>{if(typeof a=="string")return this._cleanupInfo(a,P)}),this._appender.log(h,w)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(h,w,P){return this.publicLog(h,w,P)}publicLogError(h,w){return this.sendErrorTelemetry?this.publicLog(h,w,!0):Promise.resolve(void 0)}publicLogError2(h,w){return this.publicLogError(h,w)}_cleanupInfo(h,w){let P=h;if(w){const I=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(h);if(!t)break;I.push([t.index,c.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const c=l.exec(h);if(!c)break;!a.test(c[0])&&I.every(([t,i])=>c.index<t||c.index>=i)&&(P+=h.substring(o,c.index)+"<REDACTED: user-file-path>",o=l.lastIndex)}o<h.length&&(P+=h.substr(o))}for(let I of this._cleanupPatterns)P=P.replace(I,"");return P}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ce([ee(1,(0,b.optional)(M.IConfigurationService))],g),e.TelemetryService=g;const E="telemetry";r.Registry.as(n.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(2,null,m.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(X[95],J([0,1,21,44,12,9]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,w){return Promise.resolve(void 0)}publicLog2(h,w){return this.publicLog(h,w)}publicLogError(h,w){return Promise.resolve(void 0)}publicLogError2(h,w){return this.publicLogError(h,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class M{async publicLog(w,P,I){}async publicLogError(w,P,I){}}e.NullEndpointTelemetryService=M;function n(...h){return{log:(w,P)=>h.forEach(I=>I.log(w,P)),flush:()=>b.Promises.settled(h.map(w=>w.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(h,w){return w.onDidChangeConfiguration(P=>{P.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(P.source),configurationKeys:E(P.sourceConfig)})})}e.configurationTelemetry=S;function y(h){const w=Object.create(null),P=Object.create(null),I=Object.create(null);g(h,I);for(let a in I){a=a.length>150?a.substr(a.length-149):a;const l=I[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?w[a]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(w[a]=l)}return{properties:w,measurements:P}}e.validateTelemetryData=y;function r(h){if(!h)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{h.indexOf(`${I}+`)===0&&(w=I)}),w}e.cleanRemoteAuthority=r;function g(h,w,P=0,I){if(!!h)for(let a of Object.getOwnPropertyNames(h)){const l=h[a],o=I?I+a:a;Array.isArray(l)?w[o]=(0,A.safeStringify)(l):l instanceof Date?w[o]=l.toISOString():(0,L.isObject)(l)?P<2?g(l,w,P+1,o+"."):w[o]=(0,A.safeStringify)(l):w[o]=l}}function E(h){if(!h)return[];const w=[];return p(w,"",h),w}function p(h,w,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(I=>p(h,w?`${w}.${I}`:I,P[I])):h.push(w)}}),define(X[196],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(X[197],J([0,1,4,2,37,5,196,105]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var S;(function(P){function I(a){return a&&typeof a=="object"&&typeof a.id=="string"}P.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function y(P){return{id:P}}e.themeColorFromId=y;var r;(function(P){function I(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}P.isThemeIcon=I;const a=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function l(t){const i=a.exec(t);if(!!i){let[,s]=i;return{id:s}}}P.fromString=l;function o(t,i){let s=t.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),i&&(s=`${s}~${i}`),{id:s}}P.modify=o;function c(t,i){var s,u;return t.id===i.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((u=i.color)===null||u===void 0?void 0:u.id)}P.isEqual=c,P.asClassNameArray=n.CSSIcon.asClassNameArray,P.asClassName=n.CSSIcon.asClassName,P.asCSSSelector=n.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function g(P){switch(P){case M.ColorScheme.DARK:return"vs-dark";case M.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,A.toDisposable)(()=>{const a=this.themingParticipants.indexOf(I);this.themingParticipants.splice(a,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new E;L.Registry.add(e.Extensions.ThemingContribution,p);function h(P){return p.onColorThemeChange(P)}e.registerThemingParticipant=h;class w extends A.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(a=>this.onThemeChange(a)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,a){let l=this.theme.getColor(I);return l&&a&&(l=a(l,this.theme)),l?l.toString():null}}e.Themable=w}),define(X[75],J([0,1,3,13,38,4]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",n="#1E1E1E",S="#000000",y="theme",r="themeBackground";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let g=class{constructor(p){this.stateService=p,A.ipcMain.on("vscode:changeColorTheme",(h,w,P)=>{typeof P=="string"&&this.storeBackgroundColor(JSON.parse(P))})}storeBackgroundColor(p){this.stateService.setItem(y,p.baseTheme),this.stateService.setItem(r,p.background)}getBackgroundColor(){if((m.isWindows||m.isMacintosh)&&A.nativeTheme.shouldUseInvertedColorScheme)return S;let p=this.stateService.getItem(r,null);if(!p){let h;(m.isWindows||m.isMacintosh)&&A.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateService.getItem(y,"vs-dark").split(" ")[0],p=h==="hc-black"?S:h==="vs"?M:n}return m.isMacintosh&&p.toUpperCase()===n&&(p="#171717"),p}};g=ce([ee(0,L.IStateService)],g),e.ThemeMainService=g}),define(X[40],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(A=e.StateType||(e.StateType={}));var L;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,M)=>({type:"idle",updateType:b,error:M}),CheckingForUpdates:b=>({type:"checking for updates",explicit:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(X[198],J([0,1,37,48,144,3]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[199],J([0,1,5,40]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(n){this.service=n}listen(n,S){switch(S){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${S}`)}call(n,S,y){switch(S){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${S}`)}}e.UpdateChannel=L;class b{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(S=>this.state=S),this.channel.call("_getInitialState").then(S=>this.state=S)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(X[96],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(X[200],J([0,1,7]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(n){this.handler=n}listen(n,S){throw new Error(`Event not found: ${S}`)}call(n,S,y){switch(S){case"handleURL":return this.handler.handleURL(m.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${S}`)}}e.URLHandlerChannel=A;class L{constructor(n){this.channel=n}handleURL(n,S){return this.channel.call("handleURL",[n.toJSON(),S])}}e.URLHandlerChannelClient=L;class b{constructor(n){this.next=n}async routeCall(n,S,y,r){if(S!=="handleURL")throw new Error(`Call not found: ${S}`);if(y){const g=m.URI.revive(y);if(g&&g.query){const E=/\bwindowId=(\d+)/.exec(g.query);if(E){const p=E[1],h=new RegExp(`window:${p}`),w=n.connections.find(P=>h.test(P.ctx));if(w)return w}}}return this.next.routeCall(n,S,y,r)}routeEvent(n,S){throw new Error(`Event not found: ${S}`)}}e.URLHandlerRouter=b}),define(X[201],J([0,1,7,9,2,20]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,r){const g=[...this.handlers.values()];return(0,A.first)(g.map(E=>()=>E.handleURL(y,r)),void 0,!1).then(E=>E||!1)}registerHandler(y){return this.handlers.add(y),(0,L.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=M;let n=class extends M{constructor(y){super();this.productService=y}create(y){let{authority:r,path:g,query:E,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return r&&g&&g.indexOf("/")!==0&&(g=`/${g}`),m.URI.from({scheme:this.productService.urlProtocol,authority:r,path:g,query:E,fragment:p})}};n=ce([ee(0,b.IProductService)],n),e.NativeURLService=n}),define(X[202],J([0,1,5,13,7,2,3,9]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function S(r){try{return L.URI.parse(r)}catch(g){return null}}class y{constructor(g,E,p,h,w){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=g,M.isWindows){const a=h.isBuilt?[]:[`"${h.appRoot}"`];a.push("--open-url","--"),A.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,a)}const P=m.Event.map(m.Event.fromNodeEventEmitter(A.app,"open-url",(a,l)=>({event:a,url:l})),({event:a,url:l})=>(a.preventDefault(),l));this.disposables.add(P(a=>{const l=S(a);!l||this.urlService.open(l,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?this.flush():m.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||g.push(E);g.length!==0&&(this.uris=g,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(X[76],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(X[203],J([0,1,13,2,10,7,76]),function(q,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends A.Disposable{constructor(){super();const y=m.session.fromPartition(M.webviewPartitionId),r=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(L.Schemas.vscodeWebview,r),y.protocol.registerFileProtocol(L.Schemas.vscodeWebview,r)}async handleWebviewRequest(y,r){try{const g=b.URI.parse(y.url),E=n.validWebviewFilePaths.get(g.path);if(typeof E=="string"){const p=g.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${E}`:`vs/workbench/contrib/webview/browser/pre/${E}`,h=L.FileAccess.asFileUri(p,q);return r(decodeURIComponent(h.fsPath))}}catch(g){}r({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(X[60],J([0,1,3]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(y){return!!y.workspaceUri}e.isWorkspaceToOpen=A;function L(y){return!!y.folderUri}e.isFolderToOpen=L;function b(y){return!!y.fileUri}e.isFileToOpen=b;function M(y){const r=n(y),g=y.getValue("window.menuBarVisibility");return g==="default"||r==="native"&&g==="compact"||m.isMacintosh&&m.isNative?"classic":g}e.getMenuBarVisibility=M;function n(y){if(m.isWeb)return"custom";const r=y.getValue("window");if(r){if(m.isMacintosh&&r.nativeTabs===!0||m.isMacintosh&&r.nativeFullScreen===!1)return"native";const p=r.titleBarStyle;if(p==="native"||p==="custom")return p}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function S(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=S}),define(X[34],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var A;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}));const L=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=L;var b;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var M;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(X[204],J([0,1,13,2,73,76,203,34]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends A.Disposable{constructor(r,g){super();this.windowsMainService=g,this._register(new M.WebviewProtocolProvider);const E=m.session.fromPartition(b.webviewPartitionId);E.setPermissionRequestHandler((p,h,w)=>w(h==="clipboard-read")),E.setPermissionCheckHandler((p,h)=>h==="clipboard-read")}async setIgnoreMenuShortcuts(r,g){let E;if(typeof r.windowId=="number"){const{windowId:p}=r,h=this.windowsMainService.getWindowById(p);if(!(h==null?void 0:h.win))throw new Error(`Invalid windowId: ${p}`);E=h.win.webContents}else{const{webContentsId:p}=r;if(E=m.webContents.fromId(p),!E)throw new Error(`Invalid webContentsId: ${p}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(g)}};S=ce([ee(0,L.ITunnelService),ee(1,n.IWindowsMainService)],S),e.WebviewMainService=S}),define(X[205],J([0,1,5,2,9]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends A.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:S,getActiveWindowId:y}){super();this.disposables=this._register(new A.DisposableStore),m.Event.latch(m.Event.any(n,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>y()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(X[206],J([0,1,7,15,4,36]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");var M;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const p=E;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function S(E){const p=E;return!!(p&&typeof p=="object"&&m.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=S;class y{constructor(p,h,w,P){this._id=p,this._configuration=w,this._ignorePathCasing=P,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class r{constructor(p,h){this.raw=h,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,A.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function g(E){return new r({uri:E,index:0,name:(0,A.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=g}),define(X[29],J([0,1,4,147,206,7,3,8,15,102,43,10,39,30,72]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(z){return(typeof z=="string"?(0,n.extname)(z):(0,S.extname)(z))===w}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function I(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function a(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=a;function l(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=l;function o(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&b.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&b.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function i(z){const C=z;if(C==null?void 0:C.uri)return{id:C.id,uri:b.URI.revive(C.uri)};const j=z;if(j==null?void 0:j.configPath)return{id:j.id,configPath:b.URI.revive(j.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=i;function s(z,C){return S.extUriBiasedIgnorePathCase.isEqualOrParent(z,C.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function u(z){return d(z)||f(z)}e.isStoredWorkspaceFolder=u;function d(z){const C=z;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=d;function f(z){const C=z;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=f;function v(z,C,j,N,T=!M.isWindows,R){if(z.scheme!==N.scheme)return{name:j,uri:z.toString(!0)};let W=C?void 0:R.relativePath(N,z);if(W!==void 0)W.length===0?W=".":M.isWindows&&z.scheme===g.Schemas.file&&!T&&(W=W.replace(/\//g,"\\"));else if(z.scheme===g.Schemas.file)W=z.fsPath,M.isWindows&&(W=(0,E.normalizeDriveLetter)(W),T&&(W=(0,p.toSlashes)(W)));else{if(!R.isEqualAuthority(z.authority,N.authority))return{name:j,uri:z.toString(!0)};W=z.path}return{name:j,path:W}}e.getStoredWorkspaceFolder=v;function D(z,C,j){let N=[],T=new Set;const R=j.dirname(C);for(let W of z){let k=null;if(d(W))W.path&&(k=j.resolvePath(R,W.path));else if(f(W))try{k=b.URI.parse(W.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(F){console.warn(F)}if(k){let F=j.getComparisonKey(k);if(!T.has(F)){T.add(F);const B=W.name||j.basenameOrAuthority(k);N.push(new L.WorkspaceFolder({uri:k,name:B,index:N.length},W))}}}return N}e.toWorkspaceFolders=D;function _(z,C,j,N,T){let R=U(C,z);const W=T.dirname(C),k=T.dirname(N),F=[],B=H(R.folders);for(const Z of R.folders){const re=d(Z)?T.resolvePath(W,Z.path):b.URI.parse(Z.uri);let se;j?se=!1:se=!d(Z)||(0,n.isAbsolute)(Z.path),F.push(v(re,se,Z.name,k,B,T))}const V={insertSpaces:!1,tabSize:4,eol:M.isLinux||M.isMacintosh?`
`:`\r
`},G=y.setProperty(z,["folders"],F,V);let Y=y.applyEdits(z,G);return R.remoteAuthority===(0,h.getRemoteAuthority)(N)&&(Y=y.applyEdits(Y,y.removeProperty(Y,["remoteAuthority"],V))),Y}e.rewriteWorkspaceFileForNewLocation=_;function U(z,C){let j=r.parse(C);if(j&&Array.isArray(j.folders))j.folders=j.folders.filter(N=>u(N));else throw new Error(`${z} looks like an invalid workspace file.`);return j}function H(z){return M.isWindows?z.some(C=>d(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function Q(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function ie(z){return typeof z.folderUri=="string"}function ae(z){return typeof z.fileUri=="string"}function O(z,C){const j={workspaces:[],files:[]};if(z){const N=function(R,W){for(let k=0;k<R.length;k++)try{W(R[k],k)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(R[k])}: ${F.toString()}. Skip entry.`)}},T=z;if(Array.isArray(T.entries))N(T.entries,R=>{const W=R.label,k=R.remoteAuthority;Q(R)?j.workspaces.push({label:W,remoteAuthority:k,workspace:{id:R.workspace.id,configPath:b.URI.parse(R.workspace.configPath)}}):ie(R)?j.workspaces.push({label:W,remoteAuthority:k,folderUri:b.URI.parse(R.folderUri)}):ae(R)&&j.files.push({label:W,remoteAuthority:k,fileUri:b.URI.parse(R.fileUri)})});else{const R=z;Array.isArray(R.workspaces3)&&N(R.workspaces3,(W,k)=>{const F=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[k]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?j.workspaces.push({label:F,workspace:{id:W.id,configPath:b.URI.parse(W.configURIPath)}}):typeof W=="string"&&j.workspaces.push({label:F,folderUri:b.URI.parse(W)})}),Array.isArray(R.files2)&&N(R.files2,(W,k)=>{const F=Array.isArray(R.fileLabels)&&R.fileLabels[k]||void 0;typeof W=="string"&&j.files.push({label:F,fileUri:b.URI.parse(W)})})}}return j}e.restoreRecentlyOpened=O;function $(z){const C={entries:[]};for(const j of z.workspaces)a(j)?C.entries.push({folderUri:j.folderUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority}):C.entries.push({workspace:{id:j.workspace.id,configPath:j.workspace.configPath.toString()},label:j.label,remoteAuthority:j.remoteAuthority});for(const j of z.files)C.entries.push({fileUri:j.fileUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority});return C}e.toStoreData=$}),define(X[50],J([0,1,4,29]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function L(b){const M=b;return M&&(0,A.isWorkspaceIdentifier)(M.workspace)}e.isWorkspaceBackupInfo=L}),define(X[51],J([0,1,4,13,9,38,3,8,64,19,12,131,29,39,2,80]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let P=class ut{constructor(a){this.stateService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(a,l){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),l)}pickFolder(a,l){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,title:(0,g.localize)(1,null)}),l)}pickFile(a,l){return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:(0,g.localize)(2,null)}),l)}pickWorkspace(a,l){const o=(0,g.localize)(3,null),c=(0,p.mnemonicButtonLabel)((0,g.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:o,filters:t,buttonLabel:c}),l)}async doPick(a,l){const o={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};o.defaultPath=a.defaultPath||this.stateService.getItem(ut.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(o.properties=void 0,a.pickFiles&&a.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),M.isMacintosh&&o.properties.push("treatPackageAsDirectory");const c=l||A.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,(0,r.withNullAsUndefined)(c));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ut.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(a){if(a){let l=this.windowDialogQueues.get(a.id);return l||(l=new L.Queue,this.windowDialogQueues.set(a.id,l)),l}else return this.noWindowDialogueQueue}showMessageBox(a,l){return this.getWindowDialogQueue(l).queue(async()=>l?A.dialog.showMessageBox(l,a):A.dialog.showMessageBox(a))}async showSaveDialog(a,l){const o=this.acquireFileDialogLock(a,l);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(l).queue(async()=>{let c;return l?c=await A.dialog.showSaveDialog(l,a):c=await A.dialog.showSaveDialog(a),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,h.dispose)(o)}}normalizePath(a){return a&&M.isMacintosh&&(a=(0,S.normalizeNFC)(a)),a}normalizePaths(a){return a.map(l=>this.normalizePath(l))}async showOpenDialog(a,l){a.defaultPath&&(await(0,y.exists)(a.defaultPath)||(a.defaultPath=void 0));const o=this.acquireFileDialogLock(a,l);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(l).queue(async()=>{let c;return l?c=await A.dialog.showOpenDialog(l,a):c=await A.dialog.showOpenDialog(a),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,h.dispose)(o)}}acquireFileDialogLock(a,l){if(!l)return h.Disposable.None;let o=this.windowFileDialogLocks.get(l.id);o||(o=new Set,this.windowFileDialogLocks.set(l.id,o));const c=(0,w.hash)(a);if(!o.has(c))return o.add(c),(0,h.toDisposable)(()=>{o==null||o.delete(c),(o==null?void 0:o.size)===0&&this.windowFileDialogLocks.delete(l.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=ce([ee(0,b.IStateService)],P),e.DialogMainService=P}),define(X[207],J([0,1,5,2,29]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends A.Disposable{constructor(n,S){super();this.logService=n,this.storageMainService=S,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,S)=>(n?n.push(S):n=[S],n),b.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const S=new Map,y=new Set;return n.forEach(r=>{const g=this.storageMainService.globalStorage.get(r.key);typeof g=="string"?S.set(r.key,g):y.add(r.key)}),{changed:Array.from(S.entries()),deleted:Array.from(y.values())}}listen(n,S){switch(S){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${S}`)}async call(n,S,y){const r=(0,L.reviveIdentifier)(y.workspace),g=await this.withStorageInitialized(r);switch(S){case"getItems":return Array.from(g.items.entries());case"updateItems":{const E=y;if(E.insert)for(const[p,h]of E.insert)g.set(p,h);E.delete&&E.delete.forEach(p=>g.delete(p));break}case"close":{if(r)return g.close();break}default:throw new Error(`Call not found: ${S}`)}}async withStorageInitialized(n){const S=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await S.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${y}`)}return S}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[208],J([0,1,18,19,5,2,6,121,85,8,94,31,28,29]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class h extends b.Disposable{constructor(a){super();this.logService=a,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new S.Storage(new S.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const a=await this.doCreate();this.storage.dispose(),this.storage=a,this._register(a.onDidChangeStorage(o=>this._onDidChangeStorage.fire({key:o}))),await this.doInit(a);const l=a.getBoolean(r.IS_NEW_KEY);l===void 0?a.set(r.IS_NEW_KEY,!0):l&&a.set(r.IS_NEW_KEY,!1)}catch(a){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${a}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===M.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this.storage.items}get(a,l){return this.storage.get(a,l)}set(a,l){return this.storage.set(a,l)}delete(a){return this.storage.delete(a)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class w extends h{constructor(a,l,o){super(l);this.options=a,this.environmentService=o}async doCreate(){let a;return this.options.useInMemoryStorage?a=n.SQLiteStorageDatabase.IN_MEMORY_PATH:a=(0,y.join)(this.environmentService.globalStorageHome.fsPath,w.STORAGE_NAME),new S.Storage(new n.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}))}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(g.instanceStorageKey,void 0)===void 0&&a.set(g.instanceStorageKey,(0,E.generateUuid)()),a.get(g.firstSessionDateStorageKey,void 0)===void 0&&a.set(g.firstSessionDateStorageKey,new Date().toUTCString());const c=a.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();a.set(g.lastSessionDateStorageKey,typeof c=="undefined"?null:c),a.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=w,w.STORAGE_NAME="state.vscdb";class P extends h{constructor(a,l,o,c){super(o);this.workspace=a,this.options=l,this.environmentService=c}async doCreate(){const{storageFilePath:a,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new S.Storage(new n.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}),{hint:l?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:n.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,y.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=(0,y.join)(a,P.WORKSPACE_STORAGE_NAME);return await(0,A.exists)(a)?{storageFilePath:l,wasCreated:!1}:(await m.promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let l;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?l={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const o=(0,y.join)(a,P.WORKSPACE_META_NAME);await(0,A.exists)(o)||await(0,A.writeFile)(o,JSON.stringify(l,void 0,2))}catch(o){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=P,P.WORKSPACE_STORAGE_NAME="state.vscdb",P.WORKSPACE_META_NAME="workspace.json"}),define(X[97],J([0,1,42,2,46,4,16,6,208]),function(q,e,m,A,L,b,M,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let y=class extends A.Disposable{constructor(g,E,p){super();this.logService=g,this.environmentService=E,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)g.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new S.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new S.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let E=this.mapWorkspaceToStorage.get(g.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),E=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,E),(0,m.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),E}};y=ce([ee(0,n.ILogService),ee(1,L.IEnvironmentService),ee(2,M.ILifecycleMainService)],y),e.StorageMainService=y}),define(X[98],J([0,1,7,29,15]),function(q,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(S,y,r){for(const E of S){const p=E.openedWorkspace;if((0,A.isWorkspaceIdentifier)(p)){const h=r(p);if(h){if(h.folders.some(w=>L.extUriBiasedIgnorePathCase.isEqualOrParent(y,w.uri)))return E}else if(L.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return E}}const g=S.filter(E=>(0,A.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqualOrParent(y,E.openedWorkspace.uri));if(g.length)return g.sort((E,p)=>-(E.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function M(S,y){for(const r of S)if((0,A.isWorkspaceIdentifier)(r.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,y)||(0,A.isSingleFolderWorkspaceIdentifier)(r.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.uri,y))return r}e.findWindowOnWorkspaceOrFolder=M;function n(S,y){var r,g;const E=p=>y.some(h=>L.extUriBiasedIgnorePathCase.isEqual(m.URI.file(h),m.URI.file(p)));for(const p of S)if((g=(r=p.config)===null||r===void 0?void 0:r.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(h=>E(h)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(X[209],J([0,1,13,2,3,15,7,21,16,6,38,34,29]),function(q,e,m,A,L,b,M,n,S,y,r,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class ht extends A.Disposable{constructor(l,o,c,t,i){super();this.windowsMainService=l,this.stateService=o,this.lifecycleMainService=c,this.logService=t,this.configurationService=i,this._state=h(this.stateService.getItem(ht.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),t&&(l.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const c=P(l);this.stateService.setItem(ht.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(l){if(!this.lifecycleMainService.quitRequested){const o=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(c=>{var t;const i=(0,E.isWorkspaceIdentifier)(l.openedWorkspace)&&((t=c.workspace)===null||t===void 0?void 0:t.id)===l.openedWorkspace.id,s=(0,E.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&c.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(c.folderUri,l.openedWorkspace.uri);(i||s)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}}toWindowState(l){return{workspace:(0,E.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const o=this.doGetNewWindowState(l),c=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!((c==null?void 0:c.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(c==null?void 0:c.restoreFullscreen)),t&&L.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(l){const o=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const d=l.workspace;if((0,E.isWorkspaceIdentifier)(d)){const v=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===d.id).map(D=>D.uiState);if(v.length)return v[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(d)){const v=this.state.openedWindows.filter(D=>D.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(D.folderUri,d.uri)).map(D=>D.uiState);if(v.length)return v[0]}else if(l.backupPath){const v=this.state.openedWindows.filter(D=>D.backupPath===l.backupPath).map(D=>D.uiState);if(v.length)return v[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let c;const t=m.screen.getAllDisplays();if(t.length===1)c=t[0];else{if(L.isMacintosh){const d=m.screen.getCursorScreenPoint();c=m.screen.getDisplayNearestPoint(d)}!c&&o&&(c=m.screen.getDisplayMatching(o.getBounds())),c||(c=m.screen.getPrimaryDisplay()||t[0])}let i=(0,g.defaultWindowState)();i.x=Math.round(c.bounds.x+c.bounds.width/2-i.width/2),i.y=Math.round(c.bounds.y+c.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let u=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const d=o.serializeWindowState();d.mode===3?i.mode=3:i=d,u=i.mode!==3&&s.newWindowDimensions==="offset"}}return u&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===l.x||c.y===l.y);)l.x+=30,l.y+=30;return l}};p.windowsStateStorageKey="windowsState",p=ce([ee(0,g.IWindowsMainService),ee(1,r.IStateService),ee(2,S.ILifecycleMainService),ee(3,y.ILogService),ee(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function h(a){const l={openedWindows:[]},o=a||{openedWindows:[]};return o.lastActiveWindow&&(l.lastActiveWindow=w(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=w(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(l.openedWindows=o.openedWindows.map(c=>w(c))),l}e.restoreWindowsState=h;function w(a){const l={uiState:a.uiState};return a.backupPath&&(l.backupPath=a.backupPath),a.remoteAuthority&&(l.remoteAuthority=a.remoteAuthority),a.folder&&(l.folderUri=M.URI.parse(a.folder)),a.workspaceIdentifier&&(l.workspace={id:a.workspaceIdentifier.id,configPath:M.URI.parse(a.workspaceIdentifier.configURIPath)}),l}function P(a){return{lastActiveWindow:a.lastActiveWindow&&I(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&I(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(l=>I(l))}}e.getWindowsStateStoreData=P;function I(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(X[56],J([0,1,58,59,210,5,33,8,27,28,2,23,83,17,3]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(v){this.socket=v,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,p.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const D=_=>v(g.VSBuffer.wrap(_));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(v){return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,p.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,p.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((v,D)=>{if(this.socket.bufferSize===0){v();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),v()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=w;var P;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var I;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(I||(I={}));class a extends r.Disposable{constructor(v,D,_,U){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=U,D?(this._zlibInflate=L.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),(0,p.onUnexpectedError)(H),this._onClose.fire()}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),_&&(this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=L.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),(0,p.onUnexpectedError)(H),this._onClose.fire()}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(g.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,D){let _=2;v.byteLength<126?_+=0:v.byteLength<2**16?_+=2:_+=8;const U=g.VSBuffer.alloc(_);if(D?U.writeUInt8(194,0):U.writeUInt8(130,0),v.byteLength<126)U.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){U.writeUInt8(126,1);let H=1;U.writeUInt8(v.byteLength>>>8&255,++H),U.writeUInt8(v.byteLength>>>0&255,++H)}else{U.writeUInt8(127,1);let H=1;U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(v.byteLength>>>24&255,++H),U.writeUInt8(v.byteLength>>>16&255,++H),U.writeUInt8(v.byteLength>>>8&255,++H),U.writeUInt8(v.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=U.byteLength+v.byteLength,this.socket.write(g.VSBuffer.concat([U,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),U=(D.readUInt8(0)&128)>>>7,H=D.readUInt8(1),Q=(H&128)>>>7,ie=H&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(ie===126?2:0)+(ie===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),_=D.readUInt8(1),U=(_&128)>>>7;let H=_&127,Q=1;H===126?H=D.readUInt8(++Q)*2**8+D.readUInt8(++Q):H===127&&(H=D.readUInt8(++Q)*0+D.readUInt8(++Q)*0+D.readUInt8(++Q)*0+D.readUInt8(++Q)*0+D.readUInt8(++Q)*2**24+D.readUInt8(++Q)*2**16+D.readUInt8(++Q)*2**8+D.readUInt8(++Q));let ie=0;U&&(ie=D.readUInt8(++Q)*2**24+D.readUInt8(++Q)*2**16+D.readUInt8(++Q)*2**8+D.readUInt8(++Q)),this._state.state=3,this._state.readLen=H,this._state.mask=ie}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);l(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const _=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=_.length,this._onData.fire(g.VSBuffer.wrap(_))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=a;function l(f,v){if(v!==0){let D=f.byteLength>>>2;for(let ae=0;ae<D;ae++){const O=f.readUInt32BE(ae*4);f.writeUInt32BE(O^v,ae*4)}let _=D*4,U=f.byteLength-_;const H=v>>>24&255,Q=v>>>16&255,ie=v>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(_)^H,_),U>=2&&f.writeUInt8(f.readUInt8(_+1)^Q,_+1),U>=3&&f.writeUInt8(f.readUInt8(_+2)^ie,_+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const f=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):v=(0,n.join)((0,S.tmpdir)(),`vscode-ipc-${f}.sock`),i(v),v}e.createRandomIPCHandle=c;function t(f,v,D){const _=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${D}-${v}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${D}-${v}.sock`):U=(0,n.join)(f,`${D}-${v}.sock`),i(U),U}e.createStaticIPCHandle=t;function i(f){const v=o[h.platform];typeof v=="number"&&f.length>=v&&console.warn(`WARNING: IPC handle "${f}" is longer than ${v} chars, try a shorter --user-data-dir`)}class s extends M.IPCServer{constructor(v){super(s.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const D=b.Event.fromNodeEventEmitter(v,"connection");return b.Event.map(D,_=>({protocol:new E.Protocol(new w(_)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function u(f){return new Promise((v,D)=>{const _=(0,A.createServer)();_.on("error",D),_.listen(f,()=>{_.removeListener("error",D),v(new s(_))})})}e.serve=u;function d(f,v){return new Promise((D,_)=>{const U=(0,A.createConnection)(f,()=>{U.removeListener("error",_),D(E.Client.fromSocket(new w(U),v))});U.once("error",_)})}e.connect=d}),define(X[211],J([0,1,56]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(g){this.driver=g}listen(g,E){throw new Error("No event found")}call(g,E,p){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(p);case"reloadWindow":return this.driver.reloadWindow(p);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(p[0],p[1]);case"click":return this.driver.click(p[0],p[1],p[2],p[3]);case"doubleClick":return this.driver.doubleClick(p[0],p[1]);case"setValue":return this.driver.setValue(p[0],p[1],p[2]);case"getTitle":return this.driver.getTitle(p[0]);case"isActiveElement":return this.driver.isActiveElement(p[0],p[1]);case"getElements":return this.driver.getElements(p[0],p[1],p[2]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1],p[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p[0],p[1]);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1],p[2])}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=A;class L{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,E){return this.channel.call("dispatchKeybinding",[g,E])}click(g,E,p,h){return this.channel.call("click",[g,E,p,h])}doubleClick(g,E){return this.channel.call("doubleClick",[g,E])}setValue(g,E,p){return this.channel.call("setValue",[g,E,p])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,E){return this.channel.call("isActiveElement",[g,E])}getElements(g,E,p){return this.channel.call("getElements",[g,E,p])}getElementXY(g,E,p,h){return this.channel.call("getElementXY",[g,E,p,h])}typeInEditor(g,E,p){return this.channel.call("typeInEditor",[g,E,p])}getTerminalBuffer(g,E){return this.channel.call("getTerminalBuffer",[g,E])}writeInTerminal(g,E,p){return this.channel.call("writeInTerminal",[g,E,p])}}e.DriverChannelClient=L;class b{constructor(g){this.registry=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,p){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(p);case"reloadWindowDriver":return this.registry.reloadWindowDriver(p)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=b;class M{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=M;class n{constructor(g){this.driver=g}listen(g,E){throw new Error(`No event found: ${E}`)}call(g,E,p){switch(E){case"click":return this.driver.click(p[0],p[1],p[2]);case"doubleClick":return this.driver.doubleClick(p);case"setValue":return this.driver.setValue(p[0],p[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(p);case"getElements":return this.driver.getElements(p[0],p[1]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1])}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=n;class S{constructor(g){this.channel=g}click(g,E,p){return this.channel.call("click",[g,E,p])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,E){return this.channel.call("setValue",[g,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,E){return this.channel.call("getElements",[g,E])}getElementXY(g,E,p){return this.channel.call("getElementXY",[g,E,p])}typeInEditor(g,E){return this.channel.call("typeInEditor",[g,E])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,E){return this.channel.call("writeInTerminal",[g,E])}}e.WindowDriverChannelClient=S;async function y(r){const g=await(0,m.connect)(r,"driverClient"),E=g.getChannel("driver"),p=new L(E);return{client:g,driver:p}}e.connect=y}),define(X[26],J([0,1,8,53,4,46,155,56]),function(q,e,m,A,L,b,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,L.refineServiceDecorator)(b.IEnvironmentService);class S extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,m.join)(this.userDataPath,"Code Cache")}}ce([A.memoize],S.prototype,"cachedLanguagesPath",null),ce([A.memoize],S.prototype,"backupHome",null),ce([A.memoize],S.prototype,"backupWorkspacesPath",null),ce([A.memoize],S.prototype,"mainIPCHandle",null),ce([A.memoize],S.prototype,"sandbox",null),ce([A.memoize],S.prototype,"driverVerbose",null),ce([A.memoize],S.prototype,"disableUpdates",null),ce([A.memoize],S.prototype,"disableKeytar",null),ce([A.memoize],S.prototype,"nodeCachedDataDir",null),ce([A.memoize],S.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=S}),define(X[212],J([0,1,18,58,8,3,19,50,26,21,24,6,29,7,30,10,15]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(l,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,i)=>(0,h.isEqual)(t,i,!b.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await m.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){l=Object.create(null)}l.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos));let o=[];try{Array.isArray(l.rootURIWorkspaces)&&(o=l.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(l.folderURIWorkspaces)&&(c=l.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==r.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===r.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var l;const o=this.configurationService.getValue();return((l=o==null?void 0:o.files)===null||l===void 0?void 0:l.hotExit)||r.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,o){this.workspaces.some(t=>l.workspace.id===t.workspace.id)||(this.workspaces.push(l),this.saveSync());const c=this.getBackupPath(l.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(l,o){if(m.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),m.existsSync(o))try{m.renameSync(o,l)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(l){const o=l.id,c=this.workspaces.findIndex(t=>t.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(o=>this.backupUriComparer.isEqual(l,o))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(l,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(l,o){const c=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(l){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,l));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(l){return(0,L.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const o=new Set,c=[];for(let t of l){const i=t.workspace;if(!(0,E.isWorkspaceIdentifier)(i))return[];if(!o.has(i.id)){o.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==w.Schemas.file||await(0,M.exists)(i.configPath.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(l){if(!Array.isArray(l))return[];const o=[],c=new Set;for(let t of l){const i=this.backupUriComparer.getComparisonKey(t);if(!c.has(i)){c.add(i);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==w.Schemas.file||await(0,M.exists)(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const o=[],c=new Set;for(let t of l){const i=t.backupFolder;if(typeof i!="string")return[];if(!c.has(i)){c.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?o.push(t):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(l){try{await(0,M.exists)(l)&&await(0,M.rimraf)(l,M.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(l){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await m.promises.rename(l,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(l){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{m.renameSync(l,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const l=[];for(const o of this.workspaces)await this.hasBackups(o)&&l.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&l.push(o);return l}hasBackups(l){let o;return p.URI.isUri(l)?o=this.getBackupPath(this.getFolderHash(l)):(0,n.isWorkspaceBackupInfo)(l)?o=this.getBackupPath(l.workspace.id):o=l.backupFolder,this.doHasBackups(o)}async doHasBackups(l){try{const o=await(0,M.readdir)(l);for(const c of o)try{if((await(0,M.readdir)((0,L.join)(l,c))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{(0,M.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await(0,M.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderURIWorkspaces:this.folders.map(l=>l.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){let o;return l.scheme===w.Schemas.file?o=b.isLinux?l.fsPath:l.fsPath.toLowerCase():o=l.toString().toLowerCase(),(0,A.createHash)("md5").update(o).digest("hex")}};I=ce([ee(0,S.IEnvironmentMainService),ee(1,y.IConfigurationService),ee(2,g.ILogService)],I),e.BackupMainService=I}),define(X[41],J([0,1,5,34,13,16,3,26,51,19,7,31,4,27,65,6,8,20,53,2]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let o=class st extends l.Disposable{constructor(t,i,s,u,d,f,v,D){super();this.sharedProcess=t,this.windowsMainService=i,this.dialogMainService=s,this.lifecycleMainService=u,this.environmentMainService=d,this.telemetryService=f,this.logService=v,this.productService=D,this.onDidOpenWindow=m.Event.map(this.windowsMainService.onDidOpenWindow,_=>_.id),this.onDidMaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidUnmaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidBlurWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidFocusWindow=m.Event.any(m.Event.map(m.Event.filter(m.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),_=>!!_),_=>_.id),m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_))),this.onDidResumeOS=m.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new m.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new m.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=m.Event.debounce(m.Event.any(m.Event.filter(m.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(_,U,H)=>H),_=>!(Array.isArray(_)&&_.length===1&&_[0]==="workArea")),m.Event.fromNodeEventEmitter(L.screen,"display-added"),m.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(i=>{var s,u;return{id:i.id,workspace:i.openedWorkspace,title:(u=(s=i.win)===null||s===void 0?void 0:s.getTitle())!==null&&u!==void 0?u:"",filename:i.getRepresentedFilename(),dirty:i.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const i=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(i)return i.id}openWindow(t,i,s){return Array.isArray(i)?this.doOpenWindow(t,i,s):this.doOpenEmptyWindow(t,i)}async doOpenWindow(t,i,s=Object.create(null)){i.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:i,cli:this.environmentMainService.args,forceNewWindow:s.forceNewWindow,forceReuseWindow:s.forceReuseWindow,preferNewWindow:s.preferNewWindow,diffMode:s.diffMode,addMode:s.addMode,gotoLineMode:s.gotoLineMode,noRecentEntry:s.noRecentEntry,waitMarkerFileURI:s.waitMarkerFileURI,remoteAuthority:s.remoteAuthority||void 0})}async doOpenEmptyWindow(t,i){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},i)}async toggleFullScreen(t){const i=this.windowById(t);i&&i.toggleFullScreen()}async handleTitleDoubleClick(t){const i=this.windowById(t);i&&i.handleTitleDoubleClick()}async isMaximized(t){const i=this.windowById(t);return(i==null?void 0:i.win)?i.win.isMaximized():!1}async maximizeWindow(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.maximize()}async unmaximizeWindow(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.unmaximize()}async minimizeWindow(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.minimize()}async focusWindow(t,i){var s;i&&typeof i.windowId=="number"&&(t=i.windowId);const u=this.windowById(t);u&&u.focus({force:(s=i==null?void 0:i.force)!==null&&s!==void 0?s:!1})}async setMinimumSize(t,i,s){const u=this.windowById(t);if(u==null?void 0:u.win){const[d,f]=u.win.getSize(),[v,D]=u.win.getMinimumSize(),[_,U]=[i!=null?i:v,s!=null?s:D],[H,Q]=[Math.max(d,_),Math.max(f,U)];(v!==_||D!==U)&&u.win.setMinimumSize(_,U),(d!==H||f!==Q)&&u.win.setSize(H,Q)}}async showMessageBox(t,i){return this.dialogMainService.showMessageBox(i,this.toBrowserWindow(t))}async showSaveDialog(t,i){return this.dialogMainService.showSaveDialog(i,this.toBrowserWindow(t))}async showOpenDialog(t,i){return this.dialogMainService.showOpenDialog(i,this.toBrowserWindow(t))}toBrowserWindow(t){const i=this.windowById(t);if(i==null?void 0:i.win)return i.win}async pickFileFolderAndOpen(t,i){const s=await this.dialogMainService.pickFileFolder(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openFileFolder",i.telemetryExtraData),this.doOpenPicked(await Promise.all(s.map(async u=>await y.SymlinkSupport.existsDirectory(u)?{folderUri:r.URI.file(u)}:{fileUri:r.URI.file(u)})),i,t))}async pickFolderAndOpen(t,i){const s=await this.dialogMainService.pickFolder(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openFolder",i.telemetryExtraData),this.doOpenPicked(s.map(u=>({folderUri:r.URI.file(u)})),i,t))}async pickFileAndOpen(t,i){const s=await this.dialogMainService.pickFile(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openFile",i.telemetryExtraData),this.doOpenPicked(s.map(u=>({fileUri:r.URI.file(u)})),i,t))}async pickWorkspaceAndOpen(t,i){const s=await this.dialogMainService.pickWorkspace(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openWorkspace",i.telemetryExtraData),this.doOpenPicked(s.map(u=>({workspaceUri:r.URI.file(u)})),i,t))}doOpenPicked(t,i,s){this.windowsMainService.open({context:3,contextWindowId:s,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:i.forceNewWindow})}sendPickerTelemetry(t,i,s){const u=t?t.length:0;this.telemetryService.publicLog(i,Object.assign(Object.assign({},s),{outcome:u?"success":"canceled",numberOfPaths:u}))}async showItemInFolder(t,i){L.shell.showItemInFolder(i)}async setRepresentedFilename(t,i){const s=this.windowById(t);s&&s.setRepresentedFilename(i)}async setDocumentEdited(t,i){const s=this.windowById(t);s&&s.setDocumentEdited(i)}async openExternal(t,i){return M.isLinuxSnap?this.safeSnapOpenExternal(i):L.shell.openExternal(i),!0}safeSnapOpenExternal(t){const i=process.env.GDK_PIXBUF_MODULE_FILE,s=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=i,process.env.GDK_PIXBUF_MODULEDIR=s}async moveItemToTrash(t,i){return L.shell.moveItemToTrash(i)}async isAdmin(){let t;return M.isWindows?t=(await new Promise((i,s)=>{q(["native-is-elevated"],i,s)}))():t=process.getuid()===0,t}async writeElevated(t,i,s,u){const d=await new Promise((f,v)=>{q(["sudo-prompt"],f,v)});return new Promise((f,v)=>{const D=[`"${this.cliPath}"`];(u==null?void 0:u.unlock)&&D.push("--file-chmod"),D.push("--file-write",`"${i.fsPath}"`,`"${s.fsPath}"`);const _={name:this.productService.nameLong.replace("-",""),icns:M.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};d.exec(D.join(" "),_,(U,H,Q)=>{H&&this.logService.trace(`[sudo-prompt] received stdout: ${H}`),Q&&this.logService.trace(`[sudo-prompt] received stderr: ${Q}`),U?v(U):f(void 0)})})}get cliPath(){return M.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):M.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,p.totalmem)(),freemem:(0,p.freemem)(),loadavg:(0,p.loadavg)()}}async getOSProperties(){return{arch:(0,p.arch)(),platform:(0,p.platform)(),release:(0,p.release)(),type:(0,p.type)(),cpus:(0,p.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async killProcess(t,i,s){process.kill(i,s)}async readClipboardText(t,i){return L.clipboard.readText(i)}async writeClipboardText(t,i,s){return L.clipboard.writeText(i,s)}async readClipboardFindText(t){return L.clipboard.readFindText()}async writeClipboardFindText(t,i){return L.clipboard.writeFindText(i)}async writeClipboardBuffer(t,i,s,u){return L.clipboard.writeBuffer(i,Buffer.from(s),u)}async readClipboardBuffer(t,i){return L.clipboard.readBuffer(i)}async hasClipboard(t,i,s){return L.clipboard.has(i,s)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,i){const s=this.windowById(t);s&&s.updateTouchBar(i)}async notifyReady(t){const i=this.windowById(t);i&&i.setReady()}async relaunch(t,i){return this.lifecycleMainService.relaunch(i)}async reload(t,i){const s=this.windowById(t);if(s)return this.lifecycleMainService.reload(s,(i==null?void 0:i.disableExtensions)!==void 0?{_:[],"disable-extensions":i==null?void 0:i.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,i){const s=this.windowById(i);if(s==null?void 0:s.win)return s.win.close()}async quit(t){const i=this.windowsMainService.getLastActiveWindow();(i==null?void 0:i.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&i.win?i.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,i){await this.lifecycleMainService.kill(i)}async resolveProxy(t,i){var s,u;const d=this.windowById(t),f=(u=(s=d==null?void 0:d.win)===null||s===void 0?void 0:s.webContents)===null||u===void 0?void 0:u.session;if(f)return f.resolveProxy(i)}async openDevTools(t,i){const s=this.windowById(t);(s==null?void 0:s.win)&&s.win.webContents.openDevTools(i)}async toggleDevTools(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.webContents.toggleDevTools()}async sendInputEvent(t,i){const s=this.windowById(t);(s==null?void 0:s.win)&&(i.type==="mouseDown"||i.type==="mouseUp")&&s.win.webContents.sendInputEvent(i)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,i,s,u){if(!!M.isWindows){const d=await new Promise((f,v)=>{q(["vscode-windows-registry"],f,v)});try{return d.GetStringRegKey(i,s,u)}catch(f){return}}}async getPassword(t,i,s){const u=await this.withKeytar(),d=await u.getPassword(i,s);if(d)try{let{content:f,hasNextChunk:v}=JSON.parse(d);if(!f||!v)return d;let D=1;for(;v;){const _=await u.getPassword(i,`${s}-${D}`),U=JSON.parse(_);f+=U.content,v=U.hasNextChunk}return f}catch(f){return d}return d}async setPassword(t,i,s,u){const d=await this.withKeytar();if(M.isWindows&&u.length>st.MAX_PASSWORD_LENGTH){let f=0,v=0,D=!0;for(;D;){const _=u.substring(f,f+st.PASSWORD_CHUNK_SIZE);f+=st.PASSWORD_CHUNK_SIZE,D=u.length-f>0;const U={content:_,hasNextChunk:D};await d.setPassword(i,v?`${s}-${v}`:s,JSON.stringify(U)),v++}}else await d.setPassword(i,s,u);this._onDidChangePassword.fire({service:i,account:s})}async deletePassword(t,i,s){const d=await(await this.withKeytar()).deletePassword(i,s);return d&&this._onDidChangePassword.fire({service:i,account:s}),d}async findPassword(t,i){return(await this.withKeytar()).findPassword(i)}async findCredentials(t,i){return(await this.withKeytar()).findCredentials(i)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,i)=>{q(["keytar"],t,i)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};o.MAX_PASSWORD_LENGTH=2500,o.PASSWORD_CHUNK_SIZE=o.MAX_PASSWORD_LENGTH-100,ce([a.memoize],o.prototype,"cliPath",null),o=ce([ee(1,A.IWindowsMainService),ee(2,S.IDialogMainService),ee(3,b.ILifecycleMainService),ee(4,n.IEnvironmentMainService),ee(5,g.ITelemetryService),ee(6,w.ILogService),ee(7,I.IProductService)],o),e.NativeHostMainService=o}),define(X[213],J([0,1,2,5,80,13,6,34,41,89,28,20,25]),function(q,e,m,A,L,b,M,n,S,y,r,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let h=class extends m.Disposable{constructor(P,I,a,l,o){super();this.logService=P,this.windowsMainService=I,this.nativeHostMainService=a,this.encryptionMainService=l,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=A.Event.fromNodeEventEmitter(b.app,"login",(I,a,l,o,c)=>({event:I,webContents:a,req:l,authInfo:o,callback:c}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:I,req:a,callback:l}){if(!!I.isProxy){if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}l(o==null?void 0:o.username,o==null?void 0:o.password)}}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(P);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){var I,a,l,o;this.logService.trace("auth#doResolveProxyCredentials - enter",P);const c=String((0,L.hash)({scheme:P.scheme,host:P.host,port:P.port}));let t,i;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c);if(f){const v=JSON.parse(await this.encryptionMainService.decrypt(f));t=v.username,i=v.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof i=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:i};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const u={authInfo:P,username:(a=(I=this.sessionCredentials)===null||I===void 0?void 0:I.username)!==null&&a!==void 0?a:t,password:(o=(l=this.sessionCredentials)===null||l===void 0?void 0:l.password)!==null&&o!==void 0?o:i,replyChannel:`vscode:proxyAuthResponse:${(0,r.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,u),this.state=p.LoginDialogShown;const d=await new Promise(f=>{var v;const D=async(_,U,H)=>{var Q;if(U===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(Q=s.win)===null||Q===void 0||Q.webContents.off("ipc-message",D),H){const ie={username:H.username,password:H.password};try{if(H.remember){const ae=await this.encryptionMainService.encrypt(JSON.stringify(ie));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c,ae)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c)}catch(ae){this.logService.error(ae)}f({username:ie.username,password:ie.password})}else f(void 0)};(v=s.win)===null||v===void 0||v.webContents.on("ipc-message",D)});return this.sessionCredentials=d,d}};h=ce([ee(0,M.ILogService),ee(1,n.IWindowsMainService),ee(2,S.INativeHostMainService),ee(3,y.IEncryptionMainService),ee(4,g.IProductService)],h),e.ProxyAuthHandler=h}),define(X[214],J([0,1,211,34,56,2,33,57,170,3,5,79,103,9,16,41]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(l){return l<21}let I=class{constructor(o,c,t,i,s){this.windowServer=o,this.options=c,this.windowsMainService=t,this.lifecycleMainService=i,this.nativeHostMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new r.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!(c==null?void 0:c.win))throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(c)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(o,c){await this.whenUnfrozen(o);const t=E.KeybindingParser.parseUserBinding(c);for(let i of t)await this._dispatchKeybinding(o,i)}async _dispatchKeybinding(o,c){if(c instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(o);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const i=t.win.webContents,s=new n.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),d=new S.USLayoutResolvedKeybinding(s.toChord(),y.OS).getElectronAccelerator(),f=[];c.ctrlKey&&f.push("ctrl"),c.metaKey&&f.push("meta"),c.shiftKey&&f.push("shift"),c.altKey&&f.push("alt"),i.sendInputEvent({type:"keyDown",keyCode:d,modifiers:f}),P(c.keyCode)||i.sendInputEvent({type:"char",keyCode:d,modifiers:f}),i.sendInputEvent({type:"keyUp",keyCode:d,modifiers:f}),await(0,p.timeout)(100)}async click(o,c,t,i){await(await this.getWindowDriver(o)).click(c,t,i)}async doubleClick(o,c){await(await this.getWindowDriver(o)).doubleClick(c)}async setValue(o,c,t){await(await this.getWindowDriver(o)).setValue(c,t)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,c){return await(await this.getWindowDriver(o)).isActiveElement(c)}async getElements(o,c,t){return await(await this.getWindowDriver(o)).getElements(c,t)}async getElementXY(o,c,t,i){return await(await this.getWindowDriver(o)).getElementXY(c,t,i)}async typeInEditor(o,c,t){await(await this.getWindowDriver(o)).typeInEditor(c,t)}async getTerminalBuffer(o,c){return await(await this.getWindowDriver(o)).getTerminalBuffer(c)}async writeInTerminal(o,c,t){await(await this.getWindowDriver(o)).writeInTerminal(c,t)}async getWindowDriver(o){await this.whenUnfrozen(o);const c=`window:${o}`,t=new M.StaticRouter(s=>s===c),i=this.windowServer.getChannel("windowDriver",t);return new m.WindowDriverChannelClient(i)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await r.Event.toPromise(this.onDidReloadingChange.event)}};I=ce([ee(2,A.IWindowsMainService),ee(3,h.ILifecycleMainService),ee(4,w.INativeHostMainService)],I),e.Driver=I;async function a(l,o,c,t){const i=c.driverVerbose,s=t.createInstance(I,l,{verbose:i}),u=new m.WindowDriverRegistryChannel(s);l.registerChannel("windowDriverRegistry",u);const d=await(0,L.serve)(o),f=new m.DriverChannel(s);return d.registerChannel("driver",f),(0,b.combinedDisposable)(d,l)}e.serve=a}),define(X[215],J([0,1,59,56]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,b,M,n){const S=r=>n(r,void 0),y=m.createConnection({host:L,port:b},()=>{y.removeListener("error",S);const r=Buffer.alloc(16);for(let h=0;h<16;h++)r[h]=Math.round(Math.random()*256);const g=r.toString("base64");let E=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${b}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];y.write(E.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),n(void 0,new A.NodeSocket(y)))};y.on("data",p)});y.once("error",S)}}}),define(X[216],J([0,1,59,9,2,113,6,20,184,73,215,74]),function(q,e,m,A,L,b,M,n,S,y,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(P,I,a,l){return new p(P,I,a,l).waitForReady()}class p extends L.Disposable{constructor(I,a,l,o){super();this.suggestedLocalPort=o,this.public=!1,this._socketsDispose=new Map,this._options=I,this._server=m.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=c=>this._onConnection(c),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){var I;let a=await(0,b.findFreePortFaster)((I=this.suggestedLocalPort)!==null&&I!==void 0?I:this.tunnelRemotePort,2,1e3),l=null;return l=this._server.listen(a).address(),l||(a=0,l=this._server.listen(a).address()),this.tunnelLocalPort=l.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(I){I.pause();const a=await(0,S.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),l=a.getSocket().socket,o=a.readEntireBuffer();a.dispose(),o.byteLength>0&&I.write(o.buffer),I.on("end",()=>{this._socketsDispose.delete(I.localAddress),l.end()}),I.on("close",()=>l.end()),I.on("error",()=>{this._socketsDispose.delete(I.localAddress),l.destroy()}),l.on("end",()=>I.end()),l.on("close",()=>I.end()),l.on("error",()=>{I.destroy()}),I.pipe(l),l.pipe(I),this._socketsDispose.set(I.localAddress,()=>{I.end(),l.end()})}}let h=class extends y.AbstractTunnelService{constructor(I,a,l,o){super(a);this.socketFactory=I,this.signService=l,this.productService=o}retainOrCreateTunnel(I,a,l,o,c,t){const i=this.getTunnelFromMap(a,l);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,o,c,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${o}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:I,signService:this.signService,logService:this.logService,ipcLogger:null},u=E(s,a,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,u),u}}};h=ce([ee(1,M.ILogService),ee(2,g.ISignService),ee(3,n.IProductService)],h),e.BaseTunnelService=h;let w=class extends h{constructor(I,a,l){super(r.nodeSocketFactory,I,a,l)}};w=ce([ee(0,M.ILogService),ee(1,g.ISignService),ee(2,n.IProductService)],w),e.TunnelService=w}),define(X[217],J([0,1,210,186,2,12,17,185,21,6,23,46,69]),function(q,e,m,A,L,b,M,n,S,y,r,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends L.Disposable{constructor(w,P,I){super();this.environmentService=P,this.logService=I,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,P){this.logService.trace("RequestService#request",w.url);const{proxyUrl:I,strictSSL:a}=this,l=Object.assign(Object.assign({},process.env),await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),o=w.agent?w.agent:await(0,n.getProxyAgent)(w.url||"",l,{proxyUrl:I,strictSSL:a});return w.agent=o,w.strictSSL=a,this.authorization&&(w.headers=Object.assign(Object.assign({},w.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(w,P)}async getNodeRequest(w){return((0,A.parse)(w.url).protocol==="https:"?await new Promise((a,l)=>{q(["https"],a,l)}):await new Promise((a,l)=>{q(["http"],a,l)})).request}_request(w,P){return new Promise(async(I,a)=>{let l;const o=(0,A.parse)(w.url),c=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,b.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(t.auth=w.user+":"+w.password),l=c(t,i=>{const s=(0,b.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request(Object.assign(Object.assign({},w),{url:i.headers.location,followRedirects:s-1}),P).then(I,a);else{let u=i;i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,m.createGunzip)())),I({res:i,stream:(0,r.streamToBufferReadableStream)(u)})}}),l.on("error",a),w.timeout&&l.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&l.write(w.data),l.end(),P.onCancellationRequested(()=>{l.abort(),a((0,M.canceled)())})})}async resolveProxy(w){}};p=ce([ee(0,S.IConfigurationService),ee(1,g.INativeEnvironmentService),ee(2,y.ILogService)],p),e.RequestService=p}),define(X[218],J([0,1,217,13]),function(q,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(M){return A.net.request}class b extends m.RequestService{request(n,S){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:L}),S)}}e.RequestMainService=b}),define(X[219],J([0,1,47,13,26,9,6,16,75,10,3,2,84,12,5,69,55]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let I=class extends g.Disposable{constructor(l,o,c,t,i,s,u){super();this.machineId=l,this.userEnv=o,this.environmentMainService=c,this.lifecycleMainService=t,this.logService=i,this.themeMainService=s,this.protocolMainService=u,this.firstWindowConnectionBarrier=new b.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new h.Emitter),this.onDidError=h.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),A.ipcMain.on("vscode:createSharedProcessMessageChannel",async(l,o)=>this.onWindowConnection(l,o))}async onWindowConnection(l,o){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(l.sender.isDestroyed())return c.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[c])}onWillShutdown(){const l=this.window;!l||(!l.isDestroyed()&&!l.webContents.isDestroyed()&&l.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch(o){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>A.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>A.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new A.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`],v8CacheOptions:r.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{var o;this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),((o=this.window)===null||o===void 0?void 0:o.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,o)=>this._onDidError.fire({type:2,details:o})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(l,o,c)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${c}`})))}async connect(){await this.whenIpcReady;const l=(0,p.assertIsDefined)(this.window);return(0,E.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var l,o;return(o=(l=this.window)===null||l===void 0?void 0:l.isVisible())!==null&&o!==void 0?o:!1}};I=ce([ee(2,L.IEnvironmentMainService),ee(3,n.ILifecycleMainService),ee(4,M.ILogService),ee(5,S.IThemeMainService),ee(6,P.IProtocolMainService)],I),e.SharedProcess=I}),define(X[77],J([0,1,5,9,21,16,20,40,26,6,49,25]),function(q,e,m,A,L,b,M,n,S,y,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(h,w,P){return`${P.updateUrl}/api/update/${h}/${w}/${P.commit}`}e.createUpdateURL=E;let p=class{constructor(w,P,I,a,l,o){this.lifecycleMainService=w,this.configurationService=P,this.environmentMainService=I,this.requestService=a,this.logService=l,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(w);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,A.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(w=>w.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=ce([ee(0,b.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,S.IEnvironmentMainService),ee(3,r.IRequestService),ee(4,y.ILogService),ee(5,M.IProductService)],p),e.AbstractUpdateService=p}),define(X[220],J([0,1,13,2,5,53,21,16,40,31,26,6,77,49,20]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends E.AbstractUpdateService{constructor(I,a,l,o,c,t,i){super(I,a,o,c,t,i);this.telemetryService=l,this.disposables=new A.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"error",(I,a)=>a)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(I,a,l)=>({url:a,version:l,productVersion:l}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(I,a,l,o)=>({releaseNotes:a,version:l,productVersion:l,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const l=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(S.State.Idle(1,l))}buildUpdateFeedUrl(I){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,E.createUpdateURL)(a,I,this.productService);try{m.autoUpdater.setFeedURL({url:l})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return l}doCheckForUpdates(I){this.setState(S.State.CheckingForUpdates(I)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(S.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([b.memoize],w.prototype,"onRawError",null),ce([b.memoize],w.prototype,"onRawUpdateNotAvailable",null),ce([b.memoize],w.prototype,"onRawUpdateAvailable",null),ce([b.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ce([ee(0,n.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,y.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,g.ILogService),ee(6,h.IProductService)],w),e.DarwinUpdateService=w}),define(X[221],J([0,1,20,21,16,40,31,26,6,77,49,25,41]),function(q,e,m,A,L,b,M,n,S,y,r,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends y.AbstractUpdateService{constructor(w,P,I,a,l,o,c,t){super(w,P,a,l,o,t);this.telemetryService=I,this.nativeHostMainService=c}buildUpdateFeedUrl(w){return(0,y.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(b.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},g.CancellationToken.None).then(r.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const I=w?P.message||P:void 0;this.setState(b.State.Idle(1,I))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(b.State.Idle(1))}};p=ce([ee(0,L.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,M.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,r.IRequestService),ee(5,S.ILogService),ee(6,E.INativeHostMainService),ee(7,m.IProductService)],p),e.LinuxUpdateService=p}),define(X[222],J([0,1,5,9,16,40,26,6,8,18,45,31]),function(q,e,m,A,L,b,M,n,S,y,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(w,P,I){if(this.lifecycleMainService=w,this.logService=I,this._state=b.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,A.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ce([ee(0,L.ILifecycleMainService),ee(1,M.IEnvironmentMainService),ee(2,n.ILogService)],E);let p=class extends E{constructor(w,P,I,a,l,o){super(I,a,l);this.snap=w,this.snapRevision=P,this.telemetryService=o;const c=(0,y.watch)(S.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(c,"change",(d,f)=>f),i=m.Event.filter(t,d=>d==="current"),u=m.Event.debounce(i,(d,f)=>f,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{u.dispose(),c.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,r.spawn)("sleep 3 && "+S.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((I,a)=>(0,y.realpath)(`${S.dirname(this.snap)}/current`,(l,o)=>l?a(l):I(o))),P=S.basename(w);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ce([ee(2,L.ILifecycleMainService),ee(3,M.IEnvironmentMainService),ee(4,n.ILogService),ee(5,g.ITelemetryService)],p),e.SnapUpdateService=p}),define(X[223],J([0,1,18,8,19,53,21,16,20,40,31,26,6,77,49,109,27,45,25,9,24,7,41]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function i(f,v=1e3){for(;!f();)await(0,l.timeout)(v)}let s;function u(){return typeof s=="undefined"&&(s=m.existsSync(A.join(A.dirname(process.execPath),"unins000.exe"))?0:1),s}let d=class extends p.AbstractUpdateService{constructor(v,D,_,U,H,Q,ie,ae,O){super(v,D,U,H,Q,O);this.telemetryService=_,this.fileService=ie,this.nativeHostMainService=ae}get cachePath(){const v=A.join((0,P.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return m.promises.mkdir(v,{recursive:!0}).then(()=>v)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(v){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),u()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,p.createUpdateURL)(D,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(y.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},a.CancellationToken.None).then(h.asJson).then(D=>{const _=u();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(y.State.Idle(_)),Promise.resolve(null)):_===1?(this.setState(y.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(y.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(U=>L.exists(U).then(H=>{if(H)return Promise.resolve(U);const Q=D.url,ie=D.hash,ae=`${U}.tmp`;return this.requestService.request({url:Q},a.CancellationToken.None).then(O=>this.fileService.writeFile(c.URI.file(ae),O.stream)).then(ie?()=>(0,w.checksum)(ae,D.hash):()=>{}).then(()=>m.promises.rename(ae,U)).then(()=>U)})).then(U=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},H&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(D)):this.setState(y.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const _=v?D.message||D:void 0;this.setState(y.State.Idle(u(),_))}))}async doDownloadUpdate(v){v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(y.State.Idle(u()))}async getUpdatePackagePath(v){const D=await this.cachePath;return A.join(D,`CodeSetup-${this.productService.quality}-${v}.exe`)}async cleanup(v=null){const D=v?Q=>!new RegExp(`${this.productService.quality}-${v}\\.exe$`).test(Q):()=>!0,_=await this.cachePath,H=(await L.readdir(_)).filter(D).map(async Q=>{try{await m.promises.unlink(A.join(_,Q))}catch(ie){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const v=this.state.update;this.setState(y.State.Updating(v));const D=await this.cachePath;this.availableUpdate.updateFilePath=A.join(D,`CodeSetup-${this.productService.quality}-${v.version}.flag`),await L.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(u()))});const U=`${this.productService.win32MutexName}-ready`,H=await new Promise((Q,ie)=>{q(["windows-mutex"],Q,ie)});i(()=>H.isActive(U)).then(()=>this.setState(y.State.Ready(v)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};ce([b.memoize],d.prototype,"cachePath",null),d=ce([ee(0,n.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,r.ITelemetryService),ee(3,g.IEnvironmentMainService),ee(4,h.IRequestService),ee(5,E.ILogService),ee(6,o.IFileService),ee(7,t.INativeHostMainService),ee(8,S.IProductService)],d),e.Win32UpdateService=d}),define(X[52],J([0,1,29,26,8,19,18,3,5,6,58,43,10,2,15,4,149,20,13,12,50,51,98]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let i=class extends p.Disposable{constructor(f,v,D,_,U){super();this.environmentMainService=f,this.logService=v,this.backupMainService=D,this.dialogMainService=_,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new S.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new S.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==E.Schemas.file)return null;let v;try{v=(0,M.readFileSync)(f.fsPath,"utf8")}catch(D){return null}return this.doResolveWorkspace(f,v)}isWorkspacePath(f){return(0,m.isUntitledWorkspace)(f,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,v){try{const D=this.doParseStoredWorkspace(f,v),_=s(f);return{id:_.id,configPath:_.configPath,folders:(0,m.toWorkspaceFolders)(D.folders,_.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:D.remoteAuthority}}catch(D){this.logService.warn(D.toString())}return null}doParseStoredWorkspace(f,v){const D=(0,g.parse)(v);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(_=>(0,m.isStoredWorkspaceFolder)(_));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return D}async createUntitledWorkspace(f,v){const{workspace:D,storedWorkspace:_}=this.newUntitledWorkspace(f,v),U=D.configPath.fsPath;return await M.promises.mkdir((0,L.dirname)(U),{recursive:!0}),await(0,b.writeFile)(U,JSON.stringify(_,null,"	")),D}createUntitledWorkspaceSync(f,v){const{workspace:D,storedWorkspace:_}=this.newUntitledWorkspace(f,v),U=D.configPath.fsPath;return(0,M.mkdirSync)((0,L.dirname)(U),{recursive:!0}),(0,b.writeFileSync)(U,JSON.stringify(_,null,"	")),D}newUntitledWorkspace(f=[],v){const D=(Date.now()+Math.round(Math.random()*1e3)).toString(),_=(0,h.joinPath)(this.untitledWorkspacesHome,D),U=(0,h.joinPath)(_,m.UNTITLED_WORKSPACE_NAME),H=[];for(const Q of f)H.push((0,m.getStoredWorkspaceFolder)(Q.uri,!0,Q.name,_,!n.isWindows,h.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:H,remoteAuthority:v}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,m.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const v=(0,h.originalFSPath)(f.configPath);try{(0,b.rimrafSync)((0,L.dirname)(v));const D=(0,L.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,M.existsSync)(D)&&(0,b.writeFileSync)((0,L.join)(D,"obsolete"),"")}catch(D){this.logService.warn(`Unable to delete untitled workspace ${v} (${D}).`)}}getUntitledWorkspacesSync(){const f=[];try{const v=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(D=>(0,h.joinPath)(this.untitledWorkspacesHome,D,m.UNTITLED_WORKSPACE_NAME));for(const D of v){const _=s(D),U=this.resolveLocalWorkspaceSync(D);U?f.push({workspace:_,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(_)}}catch(v){v.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${v}).`)}return f}async enterWorkspace(f,v,D){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,v,D))return null;const U=this.doEnterWorkspace(f,s(D));return U?(this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U):null}async isValidTargetWorkspacePath(f,v,D){if(!D)return!0;if((0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,D))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(v,D)){const _={title:this.productService.nameLong,type:"info",buttons:[(0,P.localize)(0,null)],message:(0,P.localize)(1,null,(0,h.basename)(D)),detail:(0,P.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(_,(0,l.withNullAsUndefined)(a.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,v){if(!f.config)return null;f.focus();let D;return f.config.extensionDevelopmentPath||(D=this.backupMainService.registerWorkspaceBackupSync({workspace:v,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=v,f.config.backupPath=D,{workspace:v,backupPath:D}}};i=ce([ee(0,A.IEnvironmentMainService),ee(1,y.ILogService),ee(2,o.IBackupMainService),ee(3,c.IDialogMainService),ee(4,I.IProductService)],i),e.WorkspacesManagementMainService=i;function s(d){function f(){let v=d.scheme===E.Schemas.file?(0,h.originalFSPath)(d):d.toString();return n.isLinux||(v=v.toLowerCase()),(0,r.createHash)("md5").update(v).digest("hex")}return{id:f(),configPath:d}}e.getWorkspaceIdentifier=s;function u(d,f){function v(){if(d.scheme!==E.Schemas.file)return(0,r.createHash)("md5").update(d.toString()).digest("hex");if(!f)try{f=(0,M.statSync)(d.fsPath)}catch(U){return}let _;return n.isLinux?_=f.ino:n.isMacintosh?_=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?_=Math.floor(f.birthtimeMs):_=f.birthtime.getTime()),(0,r.createHash)("md5").update(d.fsPath).update(_?String(_):"").digest("hex")}const D=v();if(typeof D=="string")return{id:D,uri:d}}e.getSingleFolderWorkspaceIdentifier=u}),define(X[99],J([0,1,6,96,3,4,34,19,52,21,7,13,35,54,25,29,12]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let I=class{constructor(l,o,c,t,i){this.logService=l,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=t,this.configurationService=i}async start(l,o){this.logService.trace("Received data from other instance: ",l,o),L.isMacintosh&&g.app.focus({steal:!0});const c=this.parseOpenUrl(l);if(c.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:i,url:s}of c)this.urlService.open(i,{originalUrl:s})})}else return this.startOpenWindow(l,o)}parseOpenUrl(l){return l["open-url"]&&l._urls&&l._urls.length>0?(0,E.coalesce)(l._urls.map(o=>{try{return{uri:r.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(l,o){const c=(0,p.isLaunchedFromCli)(o)?0:4;let t=[];const i=l.wait&&l.waitMarkerFilePath?r.URI.file(l.waitMarkerFilePath):void 0,s=l.remote||void 0;if(l.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(l.extensionDevelopmentPath,{context:c,cli:l,userEnv:o,waitMarkerFileURI:i,remoteAuthority:s});else if(!l._.length&&!l["folder-uri"]&&!l["file-uri"]){let u=!1;if(l["new-window"]||l["unity-launch"])u=!0;else if(l["reuse-window"])u=!1;else{const d=this.configurationService.getValue("window");switch((d==null?void 0:d.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!L.isMacintosh}}if(u)t=this.windowsMainService.open({context:c,cli:l,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:i,remoteAuthority:s});else{const d=this.windowsMainService.getLastActiveWindow();d?(d.focus(),t=[d]):t=this.windowsMainService.open({context:c,cli:l,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:c,cli:l,userEnv:o,forceNewWindow:l["new-window"],preferNewWindow:!l["reuse-window"]&&!l.wait,forceReuseWindow:l["reuse-window"],diffMode:l.diff,addMode:l.add,noRecentEntry:!!l["skip-add-to-recently-opened"],waitMarkerFileURI:i,gotoLineMode:l.goto,remoteAuthority:s});if(i&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(i.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const l=[];return g.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?l.push(this.codeWindowToInfo(c)):l.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(l){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(i=>{const s=t.remoteAuthority;if(s){const u=`vscode:getDiagnosticInfoResponse${t.id}`,d={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",h.CancellationToken.None,{replyChannel:u,args:d}),g.ipcMain.once(u,(f,v)=>{v||i({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),i(v)}),setTimeout(()=>{i({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else i(void 0)})))).filter(t=>!!t)}getFolderURIs(l){const o=[],c=l.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,w.isWorkspaceIdentifier)(c)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);t&&t.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(l){const o=this.getFolderURIs(l),c=(0,P.assertIsDefined)(l.win);return this.browserWindowToInfo(c,o,l.remoteAuthority)}browserWindowToInfo(l,o=[],c){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:o,remoteAuthority:c}}};I=ce([ee(0,m.ILogService),ee(1,M.IWindowsMainService),ee(2,A.IURLService),ee(3,S.IWorkspacesManagementMainService),ee(4,y.IConfigurationService)],I),e.LaunchMainService=I}),define(X[224],J([0,1,140,27,47,13,99,68,26,3,6,82,51,4,60,10,41,55,2]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let l=class pt{constructor(c,t,i,s,u,d,f,v){this.userEnv=c,this.environmentMainService=t,this.launchMainService=i,this.logService=s,this.diagnosticsService=u,this.dialogMainService=d,this.nativeHostMainService=f,this.protocolMainService=v,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){b.ipcMain.on("vscode:issueSystemInfoRequest",async c=>{const[t,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,i);this.safeSend(c,"vscode:issueSystemInfoResponse",s)}),b.ipcMain.on("vscode:listProcesses",async c=>{const t=[];try{const i=await this.launchMainService.getMainProcessId();t.push({name:(0,m.localize)(0,null),rootProcess:await(0,g.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,n.isRemoteDiagnosticError)(u)?t.push({name:u.hostName,rootProcess:u}):u.processes&&t.push({name:u.hostName,rootProcess:u.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(c,"vscode:listProcessesResponse",t)}),b.ipcMain.on("vscode:issueReporterClipboard",async c=>{const t={message:(0,m.localize)(1,null),type:"warning",buttons:[(0,m.localize)(2,null),(0,m.localize)(3,null)]};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",i.response===0)}}),b.ipcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const t=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",t)}),b.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const c={message:(0,m.localize)(4,null),type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(c,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),b.ipcMain.on("vscode:workbenchCommand",(c,t)=>{const{id:i,from:s,args:u}=t;let d;switch(s){case"issueReporter":d=this.issueReporterParentWindow;break;case"processExplorer":d=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}d&&d.webContents.send("vscode:runAction",{id:i,from:s,args:u})}),b.ipcMain.on("vscode:openExternal",(c,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),b.ipcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),b.ipcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),b.ipcMain.on("vscode:windowsInfoRequest",async c=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(c,"vscode:windowsInfoResponse",t.windows)})}safeSend(c,t,...i){c.sender.isDestroyed()||c.sender.send(t,...i)}async openReporter(c){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new a.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,s,c.styles.backgroundColor,(0,m.localize)(7,null),c.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:L.default}),this.issueReporterWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(c){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new a.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,s,c.styles.backgroundColor,(0,m.localize)(8,null),c.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:L.default}),this.processExplorerWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(c,t,i,s,u){const d=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:s,backgroundColor:i||pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,h.zoomLevelToZoomFactor)(u),sandbox:!0,contextIsolation:!0}});return d.setMenuBarVisibility(!1),d}async getSystemStatus(){const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,t)}getWindowPosition(c,t,i){let s;const u=b.screen.getAllDisplays();if(u.length===1)s=u[0];else{if(y.isMacintosh){const v=b.screen.getCursorScreenPoint();s=b.screen.getDisplayNearestPoint(v)}!s&&c&&(s=b.screen.getDisplayMatching(c.getBounds())),s||(s=b.screen.getPrimaryDisplay()||u[0])}const d={width:t,height:i},f=s.bounds;return d.x=f.x+f.width/2-d.width/2,d.y=f.y+f.height/2-d.height/2,f.width>0&&f.height>0&&(d.x<f.x&&(d.x=f.x),d.y<f.y&&(d.y=f.y),d.x>f.x+f.width&&(d.x=f.x),d.y>f.y+f.height&&(d.y=f.y),d.width>f.width&&(d.width=f.width),d.height>f.height&&(d.height=f.height)),d}async getPerformanceInfo(){try{const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,t)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=ce([ee(1,S.IEnvironmentMainService),ee(2,M.ILaunchMainService),ee(3,r.ILogService),ee(4,n.IDiagnosticsService),ee(5,E.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,I.IProtocolMainService)],l),e.IssueMainService=l}),define(X[225],J([0,1,8,145,71,5,7,13,26,6,21,20,60,2,3,34,29,52,50,193,75,31,51,39,197,16,97,24,10,54,25,41,55]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t,i,s,u,d,f,v,D,_,U,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(Q||(Q={}));let ie=class extends p.Disposable{constructor(O,$,z,C,j,N,T,R,W,k,F,B,V,G,Y){super();this.logService=$,this.environmentMainService=z,this.fileService=C,this.configurationService=N,this.themeMainService=T,this.workspacesManagementMainService=R,this.backupMainService=W,this.telemetryService=k,this.dialogMainService=F,this.lifecycleMainService=B,this.nativeHostMainService=V,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new b.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new b.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new b.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new b.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,re]=this.restoreWindowState(O.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const se=this.windowState.mode===0||this.windowState.mode===3,x=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:E.WindowMinimumSize.WIDTH,minHeight:E.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:Object.assign({preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:h.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,E.zoomLevelToZoomFactor)(x==null?void 0:x.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};h.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${h.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),h.isLinux?ne.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):h.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),h.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),h.isMacintosh&&(ne.acceptFirstMouse=!0,(x==null?void 0:x.clickThroughInactive)===!1&&(ne.acceptFirstMouse=!1));const ue=h.isMacintosh&&(x==null?void 0:x.nativeTabs)===!0;ue&&(ne.tabbingIdentifier=this.productService.nameShort);const ye=(0,E.getTitleBarStyle)(this.configurationService)==="custom";if(ye&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,h.isMacintosh||(ne.frame=!1)),(0,L.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(ne),(0,L.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),h.isMacintosh&&ye&&this._win.setSheetOffset(22),h.isMacintosh&&re&&(!ue||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ge=>typeof ge=="number")){const ge=this.windowState;this._win.setBounds({width:ge.width,height:ge.height,x:ge.x,y:ge.y})}se&&((0,L.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,L.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,l.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>j.globalStorage.get(Z),store:(Z,re)=>j.globalStorage.set(Z,re)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.backupPath}get openedWorkspace(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.workspace}get remoteAuthority(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionDevelopmentPath)}get isExtensionTestHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var O;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((O=this.currentConfig)===null||O===void 0?void 0:O.debugId)}setRepresentedFilename(O){h.isMacintosh?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return h.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){h.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return h.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){h.isMacintosh&&(O==null?void 0:O.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(O=>{function $(){z.dispose(),C.dispose(),O()}const z=this.onDidClose(()=>$()),C=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(C,j)=>this.onWindowError(2,j)),this._win.webContents.on("did-fail-load",(C,j,N)=>this.onWindowError(3,N)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const O=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,"devtools"]),$=C=>{for(let j=C;j;j=j.parent)if(j.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1};this._win.webContents.session.webRequest.onBeforeRequest((C,j)=>{const N=M.URI.parse(C.url);if(N.path.endsWith(".svg")&&!(O.has(N.scheme)||N.path.includes(v.Schemas.vscodeRemoteResource))){const R=$(C.frame);return j({cancel:!R})}return j({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((C,j)=>{const N=C.responseHeaders,T=N["content-type"]||N["Content-Type"];if(T&&Array.isArray(T)){const R=M.URI.parse(C.url);if(R.path.endsWith(".svg")&&O.has(R.scheme))return N["Content-Type"]=["image/svg+xml"],j({cancel:!1,responseHeaders:N});if(!R.path.includes(v.Schemas.vscodeRemoteResource)&&T.some(W=>W.toLowerCase().includes("image/svg"))){const W=$(C.frame);return j({cancel:!W})}}return j({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),h.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",C,this._win)}),this._win.on("unmaximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",C,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",_.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",_.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(C=>this.onDidDeleteUntitledWorkspace(C)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(C,j)=>{const N=await this.marketplaceHeadersPromise;j({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,N)})})}async onWindowError(O,$){switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof $=="string"?$:$==null?void 0:$.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof $=="string"?$:$==null?void 0:$.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:O,reason:typeof $!="string"?$==null?void 0:$.reason:void 0}),O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,A.localize)(0,null)),(0,i.mnemonicButtonLabel)((0,A.localize)(1,null)),(0,i.mnemonicButtonLabel)((0,A.localize)(2,null))],message:(0,A.localize)(3,null),detail:(0,A.localize)(4,null),noLink:!0},this._win);if(!this._win)return;z.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):z.response===2&&this.destroyWindow()}else if(O===2){let z;typeof $=="string"||!$?z=(0,A.localize)(5,null):z=(0,A.localize)(6,null,$.reason);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,A.localize)(7,null)),(0,i.mnemonicButtonLabel)((0,A.localize)(8,null))],message:z,detail:(0,A.localize)(9,null),noLink:!0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(O){var $;(($=this.openedWorkspace)===null||$===void 0?void 0:$.id)===O.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;($==null?void 0:$.endsWith("/"))&&($=$.substr(0,$.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=z;const C=$||"",j=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(O){h.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,$=Object.create(null)){this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,$),this.readyState===0?this.currentConfig=O:(this.pendingLoadConfig=O,this.readyState=2),this._win.loadURL(v.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",q).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:O.workspace})}updateConfiguration(O,$){var z,C;const j=(C=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;j&&(0,D.isLaunchedFromCli)(j)&&!(0,D.isLaunchedFromCli)(O.userEnv)&&(O.userEnv=Object.assign(Object.assign({},j),O.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(O["disable-extensions"]=$.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),(0,L.mark)("code/willOpenNewWindow"),O.perfMarks=(0,L.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const $=Object.assign({},this.currentConfig);$.workspace=await this.validateWorkspace($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToWait,this.isExtensionDevelopmentHost&&O&&($.verbose=O.verbose,$.debugId=O.debugId,$["inspect-extensions"]=O["inspect-extensions"],$["inspect-brk-extensions"]=O["inspect-brk-extensions"],$["extensions-dir"]=O["extensions-dir"]),$.isInitialStartup=!1,this.load($,{isReload:!0,disableExtensions:O==null?void 0:O["disable-extensions"]})}async validateWorkspace(O){if((0,P.isWorkspaceIdentifier)(O.workspace)){const $=O.workspace.configPath;if($.scheme===v.Schemas.file&&!await this.fileService.exists($))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(O.workspace)){const $=O.workspace.uri;if($.scheme===v.Schemas.file&&!await this.fileService.exists($))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,w.defaultWindowState)();if(this.isFullScreen){let z;try{z=n.screen.getDisplayMatching(this.getBounds())}catch(N){}const C=(0,w.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let $;if(!h.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?O.mode=0:O.mode=1,$===1||$===0){let z;$===1?z=this.getBounds():z=this._win.getNormalBounds(),O.x=z.x,O.y=z.y,O.width=z.width,O.height=z.height}return O}restoreWindowState(O){(0,L.mark)("code/willRestoreCodeWindowState");let $=!1;if(O)try{const z=n.screen.getAllDisplays();$=z.length>1,O=this.validateWindowState(O,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,L.mark)("code/didRestoreCodeWindowState"),[O||(0,w.defaultWindowState)(),$]}validateWindowState(O,$){var z,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const R=this.getWorkingArea($[0]);if(R){this.logService.trace("window#validateWindowState: 1 monitor working area",R);function j(){!O||typeof O.x!="number"||typeof O.y!="number"||!R||(O.x<R.x&&(O.x=R.x),O.y<R.y&&(O.y=R.y))}j(),O.width>R.width&&(O.width=R.width),O.height>R.height&&(O.height=R.height),O.x>R.x+R.width-128&&(O.x=R.x+R.width-O.width),O.y>R.y+R.height-128&&(O.y=R.y+R.height-O.height),j()}return O}if(O.display&&O.mode===3){const R=$.find(W=>W.id===O.display);if(R&&typeof((z=R.bounds)===null||z===void 0?void 0:z.x)=="number"&&typeof((C=R.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,w.defaultWindowState)(3);return W.x=R.bounds.x,W.y=R.bounds.y,W}}let N,T;try{N=n.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),T=this.getWorkingArea(N)}catch(R){}if(N&&T&&O.x+O.width>T.x&&O.y+O.height>T.y&&O.x<T.x+T.width&&O.y<T.y+T.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",T),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,$]=this._win.getPosition(),[z,C]=this._win.getSize();return{x:O,y:$,width:z,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",_.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,E.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,$=!0){h.isMacintosh||(O==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,A.localize)(10,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const $=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(h.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(O,$,...z){this.isReady?this.send(O,...z):this.ready().then(()=>{$.isCancellationRequested||this.send(O,...z)})}send(O,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${O} for window that is destroyed`);return}this._win.webContents.send(O,...$)}}updateTouchBar(O){!h.isMacintosh||this.touchBarGroups.forEach(($,z)=>{const C=O[z];$.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!h.isMacintosh){for(let O=0;O<10;O++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const $=this.createTouchBarGroupSegments(O),z=new n.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",_.CancellationToken.None,{id:z.segments[C].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(O=[]){return O.map(z=>{var C,j;let N;z.icon&&!s.ThemeIcon.isThemeIcon(z.icon)&&((j=(C=z.icon)===null||C===void 0?void 0:C.dark)===null||j===void 0?void 0:j.scheme)===v.Schemas.file&&(N=n.nativeImage.createFromPath(M.URI.revive(z.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let T;return typeof z.title=="string"?T=z.title:T=z.title.value,{id:z.id,label:N?void 0:T,icon:N}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};ie=ce([ee(1,y.ILogService),ee(2,S.IEnvironmentMainService),ee(3,f.IFileService),ee(4,d.IStorageMainService),ee(5,r.IConfigurationService),ee(6,o.IThemeMainService),ee(7,I.IWorkspacesManagementMainService),ee(8,a.IBackupMainService),ee(9,c.ITelemetryService),ee(10,t.IDialogMainService),ee(11,u.ILifecycleMainService),ee(12,U.INativeHostMainService),ee(13,g.IProductService),ee(14,H.IProtocolMainService)],ie),e.CodeWindow=ie}),define(X[61],J([0,1,148,35,38,13,6,39,5,3,29,52,9,15,7,10,19,16,4,2]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,a.createDecorator)("workspacesHistoryMainService");let o=class Ve extends l.Disposable{constructor(f,v,D,_){super();this.stateService=f,this.logService=v,this.workspacesManagementMainService=D,this.lifecycleMainService=_,this._onDidChangeRecentlyOpened=this._register(new S.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const v=[],D=[];for(let _ of f)if((0,r.isRecentWorkspace)(_))!this.workspacesManagementMainService.isUntitledWorkspace(_.workspace)&&i(v,_.workspace)===-1&&v.push(_);else if((0,r.isRecentFolder)(_))s(v,_.folderUri)===-1&&v.push(_);else{const U=u(D,_.fileUri)>=0,H=_.fileUri.scheme===w.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf((0,p.basename)(_.fileUri))>=0;!U&&!H&&(D.push(_),y.isWindows&&_.fileUri.scheme===w.Schemas.file&&b.app.addRecentDocument(_.fileUri.fsPath))}this.addEntriesFromStorage(v,D),v.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(v.length=Ve.MAX_TOTAL_RECENT_ENTRIES),D.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(D.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:v,files:D}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const v=H=>{const Q=t(H);for(const ie of f)if(p.extUriBiasedIgnorePathCase.isEqual(ie,Q))return!1;return!0},D=this.getRecentlyOpened(),_=D.workspaces.filter(v),U=D.files.filter(v);(_.length!==D.workspaces.length||U.length!==D.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:_}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!y.isMacintosh){b.app.clearRecentDocuments();const f=this.getRecentlyOpened(),v=[];let D=0;for(let U=0;U<f.workspaces.length&&D<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const H=t(f.workspaces[U]);if(H.scheme===w.Schemas.file){const Q=(0,p.originalFSPath)(H);await(0,P.exists)(Q)&&(v.push(Q),D++)}}const _=[];for(let U=0;U<f.files.length&&D<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const H=t(f.files[U]);if(H.scheme===w.Schemas.file){const Q=(0,p.originalFSPath)(H);if(Ve.COMMON_FILES_FILTER.includes((0,p.basename)(H))||v.includes(Q))continue;await(0,P.exists)(Q)&&(_.push(Q),D++)}}_.reverse().forEach(U=>b.app.addRecentDocument(U)),v.reverse().forEach(U=>b.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var v,D;const _=[],U=[],H=(v=f==null?void 0:f.config)===null||v===void 0?void 0:v.workspace;(0,r.isWorkspaceIdentifier)(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?_.push({workspace:H}):(0,r.isSingleFolderWorkspaceIdentifier)(H)&&_.push({folderUri:H.uri});const Q=(D=f==null?void 0:f.config)===null||D===void 0?void 0:D.filesToOpenOrCreate;if(Q)for(let ie of Q){const ae=ie.fileUri;ae&&u(U,ae)===-1&&U.push({fileUri:ae})}return this.addEntriesFromStorage(_,U),{workspaces:_,files:U}}addEntriesFromStorage(f,v){let D=this.getRecentlyOpenedFromStorage();for(let _ of D.workspaces){let U=(0,r.isRecentFolder)(_)?s(f,_.folderUri):i(f,_.workspace);U>=0?f[U].label=f[U].label||_.label:f.push(_)}for(let _ of D.files){let U=u(v,_.fileUri);U>=0?v[U].label=v[U].label||_.label:v.push(_)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem(Ve.recentlyOpenedStorageKey);return(0,r.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const v=(0,r.toStoreData)(f);this.stateService.setItem(Ve.recentlyOpenedStorageKey,v)}updateWindowsJumpList(){if(!!y.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let v=[];for(let U of b.app.getJumpListSettings().removedItems){const H=U.args;if(H){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);Q&&v.push(h.URI.parse(Q[2]))}}this.removeRecentlyOpened(v);let D=!1;const _=(0,A.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const H=(0,r.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:Q,description:ie}=this.getWindowsJumpListLabel(H,U.label);let ae;return h.URI.isUri(H)?ae=`--folder-uri "${H.toString()}"`:(D=!0,ae=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:ie.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));_.length>0&&f.push({type:"custom",name:D?(0,m.localize)(2,null):(0,m.localize)(3,null),items:_})}f.push({type:"recent"});try{b.app.setJumpList(f)}catch(v){this.logService.warn("updateWindowsJumpList#setJumpList",v)}}}getWindowsJumpListLabel(f,v){if(v)return{title:(0,n.splitName)(v).name,description:v};if(h.URI.isUri(f))return{title:(0,p.basename)(f),description:c(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let D=(0,p.basename)(f.configPath);return D.endsWith(r.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-r.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,D),description:c(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ce([ee(0,L.IStateService),ee(1,M.ILogService),ee(2,g.IWorkspacesManagementMainService),ee(3,I.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(d){return d.scheme==="file"?(0,n.normalizeDriveLetter)(d.fsPath):d.toString()}function t(d){return(0,r.isRecentFolder)(d)?d.folderUri:(0,r.isRecentFile)(d)?d.fileUri:d.workspace.configPath}function i(d,f){return d.findIndex(v=>(0,r.isRecentWorkspace)(v)&&v.workspace.id===f.id)}function s(d,f){return d.findIndex(v=>(0,r.isRecentFolder)(v)&&p.extUriBiasedIgnorePathCase.isEqual(v.folderUri,f))}function u(d,f){return d.findIndex(v=>p.extUriBiasedIgnorePathCase.isEqual(v.fileUri,f))}}),define(X[226],J([0,1,141,3,26,13,60,21,31,40,20,9,6,39,34,61,175,7,38,16,41,25]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let i=class dt{constructor(d,f,v,D,_,U,H,Q,ie,ae,O){this.updateService=d,this.configurationService=f,this.windowsMainService=v,this.environmentMainService=D,this.telemetryService=_,this.workspacesHistoryMainService=U,this.stateService=H,this.lifecycleMainService=Q,this.logService=ie,this.nativeHostMainService=ae,this.productService=O,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||(0,M.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const d=this.stateService.getItem(dt.lastKnownMenubarStorageKey);d&&(d.menus&&(this.menubarMenus=d.menus),d.keybindings&&(this.keybindings=d.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,H,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,H,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const d=this.productService.twitterUrl;d&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(d,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const v=this.productService.reportIssueUrl;v&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(v,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const U=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${U}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const _=this.productService.privacyStatementUrl;_&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(A.language){const U=D.indexOf("?")>0?"&":"?";this.openUrl(`${_}${U}lang=${A.language}`,"openPrivacyStatement")}else this.openUrl(_,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(d=>this.onDidChangeWindowsCount(d)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let d=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof d!="boolean"&&(d=!0),d}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;let d=this.configurationService.getValue("window.nativeTabs");return typeof d!="boolean"&&(d=!1),d}updateMenu(d,f){this.menubarMenus=d.menus,this.keybindings=d.keybindings,this.stateService.setItem(dt.lastKnownMenubarStorageKey,d),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(d){!A.isMacintosh||(d.oldCount===0&&d.newCount>0||d.oldCount>0&&d.newCount===0)&&(this.closedLastWindow=d.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!A.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const d=b.Menu.getApplicationMenu();if(d&&this.oldMenus.push(d),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(A.isMacintosh?new b.Menu:null);return}const f=new b.Menu;let v;if(A.isMacintosh){const F=new b.Menu;v=new b.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(v)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new b.Menu;F.append(new b.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(F)}const D=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:D});this.setMenuById(D,"File"),f.append(_);const U=new b.Menu,H=new b.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(H);const Q=new b.Menu,ie=new b.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:Q});this.setMenuById(Q,"Selection"),f.append(ie);const ae=new b.Menu,O=new b.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:ae});this.setMenuById(ae,"View"),f.append(O);const $=new b.Menu,z=new b.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:$});this.setMenuById($,"Go"),f.append(z);const C=new b.Menu,j=new b.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),f.append(j);const N=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:N});this.setMenuById(N,"Terminal"),f.append(T);let R;if(this.shouldDrawMenu("Window")){const F=new b.Menu;R=new b.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}R&&f.append(R);const W=new b.Menu,k=new b.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),f.append(k),f.items&&f.items.length>0?b.Menu.setApplicationMenu(f):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(d){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),v=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const $=new b.Menu;this.setMenuById($,"Preferences"),D=new b.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:$})}const _=new b.Menu,U=new b.MenuItem({label:m.localize(12,null),role:"services",submenu:_}),H=new b.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new b.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ie=new b.MenuItem({label:m.localize(15,null),role:"unhide"}),ae=new b.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const $=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||($==null?void 0:$.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),O=[f];O.push(...v),D&&O.push(s(),D),O.push(s(),U,s(),H,Q,ie,s(),ae),O.forEach($=>d.append($))}shouldDrawMenu(d){if(!A.isMacintosh&&(0,M.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(d){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[d];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[d]}}setMenu(d,f){f.forEach(v=>{if((0,P.isMenubarMenuItemSeparator)(v))d.append(s());else if((0,P.isMenubarMenuItemSubmenu)(v)){const D=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(v.label),submenu:D});this.setMenu(D,v.submenu.items),d.append(_)}else(0,P.isMenubarMenuItemRecentAction)(v)?d.append(this.createOpenRecentMenuItem(v)):(0,P.isMenubarMenuItemAction)(v)&&(v.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(d),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[v.id]?d.append(new b.MenuItem(this.likeAction(v.id,{label:this.mnemonicLabel(v.label),click:this.fallbackMenuHandlers[v.id]}))):d.append(this.createMenuItem(v.label,v.id,!1,v.checked)):d.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)):d.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)))})}setMenuById(d,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(d,this.menubarMenus[f].items)}insertCheckForUpdatesItems(d){const f=this.getUpdateMenuItems();f.length&&(f.forEach(v=>d.append(v)),d.append(s()))}createOpenRecentMenuItem(d){const f=I.URI.revive(d.uri),v=d.id,D=v==="openRecentFile"?{fileUri:f}:v==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new b.MenuItem(this.likeAction(v,{label:d.label,click:(_,U,H)=>{const Q=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:d.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(d){return!!(d&&(!A.isMacintosh&&(d.ctrlKey||d.shiftKey)||A.isMacintosh&&(d.metaKey||d.altKey)))}createRoleMenuItem(d,f,v){const D={label:this.mnemonicLabel(d),role:v,enabled:!0};return new b.MenuItem(this.withKeybinding(f,D))}setMacWindowMenu(d){const f=new b.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),v=new b.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new b.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),_=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,v,s(),_,...U,s(),D].forEach(H=>d.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(d,f,v,D){const _=this.mnemonicLabel(d),U=typeof f=="function"?f:(O,$,z)=>{const C=O?O.userSettingsLabel:null;let j=f;Array.isArray(f)&&(j=this.isOptionClick(z)?f[1]:f[0]),C&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:j})},H=typeof v=="boolean"?v:this.windowsMainService.getWindowCount()>0,Q=typeof D=="boolean"?D:!1,ie={label:_,click:U,enabled:H};Q&&(ie.type="checkbox",ie.checked=Q);let ae;return typeof f=="string"?ae=f:Array.isArray(f)&&(ae=f[0]),A.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ie.role="cut":ae==="editor.action.clipboardCopyAction"?ie.role="copy":ae==="editor.action.clipboardPasteAction"&&(ie.role="paste"),ae==="undo"?ie.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ie.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ie.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(ae,ie))}makeContextAwareClickHandler(d,f){return(v,D,_)=>{const U=b.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);d(v,D||U,_)}}runActionInRenderer(d){let f=b.BrowserWindow.getFocusedWindow();if(!f){const D=this.windowsMainService.getLastActiveWindow();(D==null?void 0:D.isMinimized())&&(f=D.win)}const v=f?this.windowsMainService.getWindowById(f.id):void 0;if(v){if(this.logService.trace("menubar#runActionInRenderer",d),A.isMacintosh&&!this.environmentMainService.isBuilt&&!v.isReady&&(d.type==="commandId"&&d.commandId==="workbench.action.toggleDevTools"||d.type!=="commandId"&&d.userSettingsLabel==="alt+cmd+i"))return;if(d.type==="commandId"){const D={id:d.commandId,from:"menu"};v.sendWhenReady("vscode:runAction",c.CancellationToken.None,D)}else{const D={userSettingsLabel:d.userSettingsLabel};v.sendWhenReady("vscode:runKeybinding",c.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",d)}withKeybinding(d,f){const v=typeof d=="string"?this.keybindings[d]:void 0;if(v==null?void 0:v.label){if(v.isNative!==!1)f.accelerator=v.label,f.userSettingsLabel=v.userSettingsLabel;else if(typeof f.label=="string"){const D=f.label.indexOf("[");D>=0?f.label=`${f.label.substr(0,D)} [${v.label}]`:f.label=`${f.label} [${v.label}]`}}else f.accelerator=void 0;return f}likeAction(d,f,v=!f.accelerator){v&&(f=this.withKeybinding(d,f));const D=f.click;return f.click=(_,U,H)=>{this.reportMenuActionTelemetry(d),D&&D(_,U,H)},f}openUrl(d,f){this.nativeHostMainService.openExternal(void 0,d),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(d){this.telemetryService.publicLog2("workbenchActionExecuted",{id:d,from:t})}mnemonicLabel(d){return(0,p.mnemonicMenuLabel)(d,!this.currentEnableMenuBarMnemonics)}};i.lastKnownMenubarStorageKey="lastKnownMenubarData",i=ce([ee(0,y.IUpdateService),ee(1,n.IConfigurationService),ee(2,h.IWindowsMainService),ee(3,L.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,w.IWorkspacesHistoryMainService),ee(6,a.IStateService),ee(7,l.ILifecycleMainService),ee(8,E.ILogService),ee(9,o.INativeHostMainService),ee(10,r.IProductService)],i),e.Menubar=i;function s(){return new b.MenuItem({type:"separator"})}}),define(X[227],J([0,1,226,6,4,16]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,L.createDecorator)("menubarMainService");let M=class{constructor(S,y,r){this.instantiationService=S,this.lifecycleMainService=y,this.logService=r,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(S,y){this.logService.trace("menubarService#updateMenubar",S),(await this.menubar).updateMenu(y,S)}};M=ce([ee(0,L.IInstantiationService),ee(1,b.ILifecycleMainService),ee(2,A.ILogService)],M),e.MenubarMainService=M}),define(X[228],J([0,1,18,27,47,71,8,146,35,50,26,38,225,13,16,21,6,60,98,5,20,61,3,29,4,10,7,15,72,209,52,42,2,51,12,30,39,25,24,32,55]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t,i,s,u,d,f,v,D,_,U,H,Q,ie,ae,O,$,z,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(W){return(0,i.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function T(W){return(0,i.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let R=class et extends H.Disposable{constructor(k,F,B,V,G,Y,Z,re,se,x,ne,ue,ye,ge,Ee){super();this.machineId=k,this.initialUserEnv=F,this.logService=B,this.stateService=V,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=re,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=x,this.instantiationService=ne,this.dialogMainService=ue,this.fileService=ye,this.productService=ge,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new l.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new l.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new l.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new l.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new D.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var F,B;if(((F=k.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((B=k.config)===null||B===void 0?void 0:B.extensionTestsPath)){const V=new H.DisposableStore;if(V.add(l.Event.any(k.onDidClose,k.onDidDestroy)(()=>V.dispose())),k.config.extensionDevelopmentPath)for(const G of k.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(d.URI.file(G)));k.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(d.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,F){let B=this.environmentMainService.args;const V=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},k),{cli:B,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:V}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const F=[],B=[],V=[],G=[],Y=[];let Z,re=0;const se=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",se);for(const ge of se)T(ge)?k.addMode?F.push(ge):B.push(ge):N(ge)?V.push(ge):ge.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ge.remoteAuthority}),Z.filesToOpenOrCreate.push(ge)):ge.backupPath?Y.push({backupFolder:(0,M.basename)(ge.backupPath),remoteAuthority:ge.remoteAuthority}):re++;k.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&k.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:x,filesOpenedInWindow:ne}=this.doOpen(k,V,B,Y,re,Z,F);if(this.logService.trace(`windowsManager#open used window count ${x.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),x.length>1)if(ne)ne.focus();else{const ge=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Ee=!0,Ae=!0;if(ge){const ve=x.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Ee=!1,Ae=!1)}if(Ee)for(let ve=x.length-1;ve>=0;ve--){const me=x[ve];if(!(me.openedWorkspace&&G.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(be=>me.backupPath&&be.backupFolder===(0,M.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&x[x.length-1].focus()}const ue=Z&&Z.filesToDiff.length>0;if(!x.some(ge=>ge.isExtensionDevelopmentHost)&&!ue&&!k.noRecentEntry){const ge=[];for(const Ee of se)N(Ee)?ge.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):T(Ee)?ge.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ge.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ge)}const ye=k.waitMarkerFileURI;return k.context===0&&ye&&x.length===1&&x[0]&&(async()=>{await x[0].whenClosedOrLoaded;try{await this.fileService.del(ye)}catch(ge){}})(),x}doOpen(k,F,B,V,G,Y,Z){const re=[];let se;function x(ve,me){re.push(ve),me&&(se=ve,Y=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&Z.length>0){const ve=Z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ve);me&&x(this.doAddFoldersToExistingWindow(me,Z.map(be=>be.workspace.uri)))}const ye=B.length+F.length+V.length;if(Y&&ye===0){const ve=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(Te=>Y&&Te.remoteAuthority===Y.remoteAuthority);let be;(ve==null?void 0:ve.fileUri)&&!ue&&((k.context===4||k.context===0||k.context===1)&&(be=(0,a.findWindowOnFile)(me,ve.fileUri,Te=>Te.configPath.scheme===u.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Te.configPath):null)),be||(be=this.doGetLastActiveWindow(me))),be?(0,i.isWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,i.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):x(this.doOpenFilesInExistingWindow(k,be,Y),!0):x(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const ge=(0,S.distinct)(F,ve=>ve.workspace.id);if(ge.length>0){const ve=(0,S.coalesce)(ge.map(me=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(k,me,be),!!be),ne=!0}ge.forEach(me=>{if(!ve.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===me.workspace.id)){const be=me.remoteAuthority,Te=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(k,me,ne,Te),!!Te),ne=!0}})}const Ee=(0,S.distinct)(B,ve=>f.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Ee.length>0){const ve=(0,S.coalesce)(Ee.map(me=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(k,me,be),!!be),ne=!0}Ee.forEach(me=>{if(!ve.some(_e=>(0,i.isSingleFolderWorkspaceIdentifier)(_e.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,me.workspace.uri))){const be=me.remoteAuthority,Te=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(k,me,ne,Te),!!Te),ne=!0}})}const Ae=(0,S.distinct)(V,ve=>ve.backupFolder);if(Ae.length>0&&Ae.forEach(ve=>{const me=ve.remoteAuthority,be=(Y==null?void 0:Y.remoteAuthority)===me?Y:void 0;x(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!be),ne=!0}),re.length===0||Y){Y&&!G&&G++;const ve=Y?Y.remoteAuthority:k.remoteAuthority;for(let me=0;me<G;me++)x(this.doOpenEmpty(k,ne,ve,Y),!!Y),ne=!0}return{windows:(0,S.distinct)(re),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(k,F,B){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:B==null?void 0:B.filesToOpenOrCreate,filesToDiff:B==null?void 0:B.filesToDiff,filesToWait:B==null?void 0:B.filesToWait,termProgram:(V=k==null?void 0:k.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",$.CancellationToken.None,G),F}doAddFoldersToExistingWindow(k,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const B={foldersToAdd:F};return k.sendWhenReady("vscode:addFolders",$.CancellationToken.None,B),k}doOpenEmpty(k,F,B,V,G){return!F&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}doOpenFolderOrWorkspace(k,F,B,V,G){return!B&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}getPathsToOpen(k){var F;let B,V=!1,G=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(B=this.doExtractPathsFromAPI(k),V=!0):k.forceEmpty?B=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(B=this.doExtractPathsFromCLI(k.cli),B.length===0&&B.push(Object.create(null)),V=!0):(B=this.doGetPathsFromLastSession(),B.length===0&&B.push(Object.create(null)),G=!0),!k.addMode&&V){const Y=B.filter(Z=>T(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===Z)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));B.push({workspace:re,remoteAuthority:Z}),B=B.filter(se=>!T(se))}}}return k.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&B.unshift(...this.doGetPathsFromLastSession().filter(Y=>N(Y)||T(Y)||Y.backupPath)),B}doExtractPathsFromAPI(k){const F=[],B={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const V of(0,S.coalesce)(k.urisToOpen||[])){const G=this.resolveOpenable(V,B);if(G)G.label=V.label,F.push(G);else{const Y=this.resourceFromOpenable(V),Z={title:this.productService.nameLong,type:"info",buttons:[(0,n.localize)(0,null)],message:Y.scheme===u.Schemas.file?(0,n.localize)(1,null):(0,n.localize)(2,null),detail:Y.scheme===u.Schemas.file?(0,n.localize)(3,null,(0,O.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,n.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,ie.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(k){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},V=k["folder-uri"];if(V)for(const Z of V){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable({folderUri:re},B);se&&F.push(se)}}const G=k["file-uri"];if(G)for(const Z of G){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable((0,i.hasWorkspaceFileExtension)(Z)?{workspaceUri:re}:{fileUri:re},B);se&&F.push(se)}}const Y=k._;for(const Z of Y){const re=B.remoteAuthority?this.doResolvePathRemote(Z,B):this.doResolveFilePath(Z,B);re&&F.push(re)}return F}cliArgToUri(k){try{const F=d.URI.parse(k);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${k}, ${F.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];k!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of F)if(V.workspace){const G=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(G)&&B.push(G)}else if(V.folderUri){const G=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});T(G)&&B.push(G)}else k!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const F=this.configurationService.getValue("window");k=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,F={}){let B=this.resourceFromOpenable(k);return B.scheme===u.Schemas.file?((0,I.isFileToOpen)(k)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(k,F)}doResolveRemoteOpenable(k,F){let B=this.resourceFromOpenable(k);const V=(0,v.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(B)),(0,I.isFileToOpen)(k)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,ae.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,I.isWorkspaceToOpen)(k))return{workspace:(0,_.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(k){return(0,I.isWorkspaceToOpen)(k)?k.workspaceUri:(0,I.isFolderToOpen)(k)?k.folderUri:k.fileUri}doResolveFilePath(k,F){let B,V;F.gotoLineMode&&({path:k,line:B,column:V}=(0,ae.parseLineAndColumnAware)(k)),k=(0,ae.sanitizeFilePath)((0,M.normalize)(k),(0,C.cwd)());try{const G=(0,m.statSync)(k);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(k));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:d.URI.file(k),lineNumber:B,columnNumber:V,exists:!0}}else if(G.isDirectory())return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(d.URI.file(k),G),exists:!0}}catch(G){const Y=d.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(k,F){const B=k.charCodeAt(0),V=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:k,line:G,column:Y}=(0,ae.parseLineAndColumnAware)(k)),B!==47&&((0,ae.isWindowsDriveLetter)(B)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=(0,ae.toSlashes)(k)),k=`/${k}`);const Z=d.URI.from({scheme:u.Schemas.vscodeRemote,authority:V,path:k});if(k.charCodeAt(k.length-1)!==47){if((0,i.hasWorkspaceFileExtension)(k))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,_.getWorkspaceIdentifier)(Z),remoteAuthority:V};if(F.gotoLineMode||M.posix.basename(k).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:V}}return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:V}}shouldOpenNewWindow(k){const F=this.configurationService.getValue("window"),B=(F==null?void 0:F.openFoldersInNewWindow)||"default",V=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(B==="on"||B==="off")&&(G=B==="on");let Y=!1;return k.forceNewWindow||k.forceReuseWindow?Y=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(Y=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!k.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(Y=V==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(k,F){const B=(0,a.findWindowOnExtensionDevelopmentPath)(this.getWindows(),k);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let V=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!V.length&&!G.length&&!F.cli.extensionTestsPath){const x=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=x&&(x.workspace||x.folderUri);ne&&(d.URI.isUri(ne)?ne.scheme===u.Schemas.file?Y=[ne.fsPath]:V=[ne.toString()]:ne.configPath.scheme===u.Schemas.file?Y=[(0,f.originalFSPath)(ne.configPath)]:G=[ne.configPath.toString()])}let Z=F.remoteAuthority;for(const x of k)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=d.URI.parse(x),ue=(0,v.getRemoteAuthority)(ne);ue&&(Z?ue!==Z&&this.logService.error("more than one extension development path authority"):Z=ue)}Y=Y.filter(x=>{const ne=d.URI.file(x);return(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,v.getRemoteAuthority)(ne)===Z}),V=V.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.getRemoteAuthority)(ne)===Z:!1}),G=G.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.getRemoteAuthority)(ne)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=V,F.cli["file-uri"]=G;const re=!Y.length&&!V.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(se)}openInBrowserWindow(k){var F,B,V,G,Y;const Z=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,partsSplashPath:(0,M.join)(this.environmentMainService.userDataPath,"rapid_render.json"),backupPath:k.emptyWindowBackupInfo?(0,M.join)(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(F=k.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(B=k.filesToOpen)===null||B===void 0?void 0:B.filesToDiff,filesToWait:(V=k.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:L.default,isInitialStartup:k.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}});let se;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(se=k.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const x=se.config;!re.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(re.extensionDevelopmentPath=x.extensionDevelopmentPath,re.verbose=x.verbose,re["inspect-brk-extensions"]=x["inspect-brk-extensions"],re.debugId=x.debugId,re["inspect-extensions"]=x["inspect-extensions"],re["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(re);(0,b.mark)("code/willCreateCodeWindow");const ne=se=this.instantiationService.createInstance(E.CodeWindow,{state:x,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,b.mark)("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ye=this.getLastActiveWindow();ye&&ye.addTabbedWindow(ne)}et.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,U.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,U.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne));const ue=(0,ie.assertIsDefined)((Y=ne.win)===null||Y===void 0?void 0:Y.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return re.windowId=se.id,se.isReady?this.lifecycleMainService.unload(se,4).then(x=>{x||this.doOpenInBrowserWindow(se,re,k)}):this.doOpenInBrowserWindow(se,re,k),se}doOpenInBrowserWindow(k,F,B){if(!F.extensionDevelopmentPath)if((0,i.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,i.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,F.remoteAuthority)}k.load(F)}onWindowClosed(k){const F=et.WINDOWS.indexOf(k);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=p.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===k))}doGetLastActiveWindow(k){const F=Math.max.apply(Math,k.map(B=>B.lastFocusTime));return k.find(B=>B.lastFocusTime===F)}sendToFocused(k,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(k,$.CancellationToken.None,...F)}sendToAll(k,F,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(k,$.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(k){const F=this.getWindows().filter(B=>B.id===k);return(0,S.firstOrDefault)(F)}getWindowByWebContents(k){const F=p.BrowserWindow.fromWebContents(k);if(!!F)return this.getWindowById(F.id)}};R.WINDOWS=[],R=ce([ee(2,P.ILogService),ee(3,g.IStateService),ee(4,r.IEnvironmentMainService),ee(5,h.ILifecycleMainService),ee(6,y.IBackupMainService),ee(7,w.IConfigurationService),ee(8,c.IWorkspacesHistoryMainService),ee(9,_.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,Q.IDialogMainService),ee(12,z.IFileService),ee(13,o.IProductService),ee(14,j.IProtocolMainService)],R),e.WindowsMainService=R}),define(X[229],J([0,1,52,34,61,50]),function(q,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(S,y,r,g){this.workspacesManagementMainService=S,this.windowsMainService=y,this.workspacesHistoryMainService=r,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(S,y){const r=this.windowsMainService.getWindowById(S);return r?this.workspacesManagementMainService.enterWorkspace(r,this.windowsMainService.getWindows(),y):null}createUntitledWorkspace(S,y,r){return this.workspacesManagementMainService.createUntitledWorkspace(y,r)}deleteUntitledWorkspace(S,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(S,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(S){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(S))}async addRecentlyOpened(S,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(S,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(S){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ce([ee(0,m.IWorkspacesManagementMainService),ee(1,A.IWindowsMainService),ee(2,L.IWorkspacesHistoryMainService),ee(3,b.IBackupMainService)],M),e.WorkspacesMainService=M}),define(X[230],J([0,1,27,18,13,3,228,16,69,40,199,33,120,84,219,99,4,70,67,6,38,26,21,96,200,31,95,194,195,191,20,213,2,34,7,29,229,65,223,221,220,224,173,17,202,214,227,117,8,15,129,10,222,97,207,212,50,61,201,52,68,152,41,51,12,39,204,76,24,43,28,23,89,205,189,54,30,25,164,178,42,72,74]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t,i,s,u,d,f,v,D,_,U,H,Q,ie,ae,O,$,z,C,j,N,T,R,W,k,F,B,V,G,Y,Z,re,se,x,ne,ue,ye,ge,Ee,Ae,ve,me,be,Te,_e,Ye,xe,Ke,ot,ze,nt,K,te,oe,le,de,pe,Ie,Oe,Ce,Ne,qe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let at=class extends H.Disposable{constructor(fe,we,Le,he,Me,Se,Pe,De,ke,We){super();this.mainProcessNodeIpcServer=fe,this.userEnv=we,this.mainInstantiationService=Le,this.logService=he,this.environmentMainService=Me,this.lifecycleMainService=Se,this.configurationService=Pe,this.stateService=De,this.fileService=ke,this.productService=We,this.registerListeners()}registerListeners(){(0,R.setUnexpectedErrorHandler)(he=>this.onUnexpectedError(he)),process.on("uncaughtException",he=>this.onUnexpectedError(he)),process.on("unhandledRejection",he=>(0,R.onUnexpectedError)(he)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),L.app.on("accessibility-support-changed",(he,Me)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",Me)}),L.app.on("activate",(he,Me)=>{var Se;this.logService.trace("app#activate"),Me||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),L.app.on("remote-require",(he,Me,Se)=>{this.logService.trace("app#on(remote-require): prevented"),he.preventDefault()}),L.app.on("remote-get-global",(he,Me,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),he.preventDefault()}),L.app.on("remote-get-builtin",(he,Me,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&he.preventDefault()}),L.app.on("remote-get-current-window",he=>{this.logService.trace("app#on(remote-get-current-window): prevented"),he.preventDefault()}),L.app.on("remote-get-current-web-contents",he=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),he.preventDefault())}),L.app.on("web-contents-created",(he,Me)=>{Me.on("will-attach-webview",(Pe,De,ke)=>{const We=$e=>{if(!$e)return!1;const Ue=ie.URI.parse($e);if(Ue.scheme===Z.Schemas.vscodeWebview)return Ue.path==="/index.html"||Ue.path==="/electron-browser-index.html";const Je=Ue.fsPath.toLowerCase(),Re=ie.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Je.startsWith(Re+V.sep)};delete De.preload,De.nodeIntegration=!1,!(We(ke.src)&&We(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Pe.preventDefault())}),Me.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Me.on("new-window",(Pe,De)=>{var ke;Pe.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,De)});const Se=Pe=>Pe.startsWith(`${Z.Schemas.vscodeWebview}://`);L.session.defaultSession.setPermissionRequestHandler((Pe,De,ke,We)=>Se(We.requestingUrl)?ke(De==="clipboard-read"):ke(!1)),L.session.defaultSession.setPermissionCheckHandler((Pe,De,ke,We)=>Se(We.requestingUrl)?De==="clipboard-read":!1)});let fe=[],we=null;L.app.on("open-file",(he,Me)=>{this.logService.trace("app#open-file: ",Me),he.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(Me)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],we=null},100)}),L.app.on("new-window-for-tab",()=>{var he;(he=this.windowsMainService)===null||he===void 0||he.openEmptyWindow({context:4})});let Le=!1;L.ipcMain.handle("vscode:fetchShellEnv",he=>new Promise(async Me=>{var Se;const Pe=he.sender;let De=!1;function ke(je){clearTimeout($e),clearTimeout(Je),De||(De=!0,Pe.isDestroyed()||Me(je))}const We=new pe.CancellationTokenSource,$e=setTimeout(()=>{var je;Le||((je=this.windowsMainService)===null||je===void 0||je.sendToFocused("vscode:showShellEnvSlowWarning",We.token),Le=!0)},3e3),Ue=(Se=this.windowsMainService)===null||Se===void 0?void 0:Se.getWindowByWebContents(he.sender),Je=setTimeout(()=>{We.dispose(!0),Ue==null||Ue.sendWhenReady("vscode:showShellEnvTimeoutError",pe.CancellationToken.None),ke({})},1e4);let Re,Qe;(Ue==null?void 0:Ue.config)?(Re=Ue.config,Qe=Object.assign(Object.assign({},process.env),Ue.config.userEnv)):(Re=this.environmentMainService.args,Qe=process.env);const Xe=await(0,S.resolveShellEnv)(this.logService,Re,Qe);ke(Xe)})),L.ipcMain.handle("vscode:writeNlsFile",(he,Me,Se)=>{const Pe=this.validateNlsPath([Me]);if(!Pe||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Pe,nt.VSBuffer.fromString(Se))}),L.ipcMain.handle("vscode:readNlsFile",async(he,...Me)=>{const Se=this.validateNlsPath(Me);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),L.ipcMain.on("vscode:toggleDevTools",he=>he.sender.toggleDevTools()),L.ipcMain.on("vscode:openDevTools",he=>he.sender.openDevTools()),L.ipcMain.on("vscode:reloadWindow",he=>he.sender.reload())}validateNlsPath(fe){let we;for(const Le of fe)typeof Le=="string"&&(typeof we!="string"?we=Le:we=(0,V.join)(we,Le));if(!(typeof we!="string"||!(0,V.isAbsolute)(we)||!(0,de.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return ie.URI.file(we)}onUnexpectedError(fe){var we;if(fe){const Le={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const ke=ie.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${ke.fsPath}`),await this.fileService.del(ke,{recursive:!0})}catch(ke){ke.fileOperationResult!==1&&this.logService.error(ke)}const fe=this.productService.win32AppUserModelId;b.isWindows&&fe&&L.app.setAppUserModelId(fe);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!L.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&L.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const we=new E.Server;this.logService.trace("Resolving machine identifier...");const Le=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcess:he,sharedProcessReady:Me,sharedProcessClient:Se}=this.setupSharedProcess(Le),Pe=await this.initServices(Le,he,Me);if(this.environmentMainService.driverHandle){const ke=await(0,k.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Pe.createInstance(U.ProxyAuthHandler)),Pe.invokeFunction(ke=>this.initChannels(ke,we,Se));const De=Pe.invokeFunction(ke=>this.openFirstWindow(ke,we));Pe.invokeFunction(ke=>this.afterWindowOpen(ke,he)),this.environmentMainService.args.trace&&Pe.invokeFunction(ke=>this.stopTracingEventually(ke,De))}async resolveMachineId(){let fe=this.stateService.getItem(u.machineIdKey);return(!fe||b.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,$.getMachineId)(),this.stateService.setItem(u.machineIdKey,fe)),fe}setupSharedProcess(fe){const we=this._register(this.mainInstantiationService.createInstance(h.SharedProcess,fe,this.userEnv)),Le=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Me,"main")})(),he=(async()=>(await we.whenReady(),Le))();return{sharedProcess:we,sharedProcessReady:he,sharedProcessClient:Le}}async initServices(fe,we,Le){const he=new I.ServiceCollection;switch(process.platform){case"win32":he.set(y.IUpdateService,new a.SyncDescriptor(z.Win32UpdateService));break;case"linux":b.isLinuxSnap?he.set(y.IUpdateService,new a.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):he.set(y.IUpdateService,new a.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":he.set(y.IUpdateService,new a.SyncDescriptor(j.DarwinUpdateService));break}he.set(Q.IWindowsMainService,new a.SyncDescriptor(M.WindowsMainService,[fe,this.userEnv])),he.set(be.IDialogMainService,new a.SyncDescriptor(be.DialogMainService)),he.set(w.ILaunchMainService,new a.SyncDescriptor(w.LaunchMainService)),he.set(Ae.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Le.then(Se=>Se.getChannel("diagnostics"))))),he.set(N.IIssueMainService,new a.SyncDescriptor(N.IssueMainService,[this.userEnv])),he.set(K.IEncryptionMainService,new a.SyncDescriptor(K.EncryptionMainService,[fe])),he.set(oe.IKeyboardLayoutMainService,new a.SyncDescriptor(oe.KeyboardLayoutMainService)),he.set(me.INativeHostMainService,new a.SyncDescriptor(me.NativeHostMainService,[we])),he.set(xe.IWebviewManagerService,new a.SyncDescriptor(Ye.WebviewMainService)),he.set(ae.IWorkspacesService,new a.SyncDescriptor(O.WorkspacesMainService)),he.set(Ee.IWorkspacesManagementMainService,new a.SyncDescriptor(Ee.WorkspacesManagementMainService)),he.set(ye.IWorkspacesHistoryMainService,new a.SyncDescriptor(ye.WorkspacesHistoryMainService)),he.set(F.IMenubarMainService,new a.SyncDescriptor(F.MenubarMainService)),he.set(Ie.IExtensionUrlTrustService,new a.SyncDescriptor(Oe.ExtensionUrlTrustService)),he.set(se.IStorageMainService,new a.SyncDescriptor(se.StorageMainService));const Me=new ne.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(he.set(ue.IBackupMainService,Me),he.set(i.IURLService,new a.SyncDescriptor(ge.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Se=(0,g.getDelayedChannel)(Le.then($e=>$e.getChannel("telemetryAppender"))),Pe=new f.TelemetryAppenderClient(Se),De=(0,D.resolveCommonProperties)(this.fileService,(0,m.release)(),(0,m.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appender:Pe,commonProperties:De,piiPaths:ke,sendErrorTelemetry:!0};he.set(u.ITelemetryService,new a.SyncDescriptor(v.TelemetryService,[We]))}else he.set(u.ITelemetryService,d.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(he)}initChannels(fe,we,Le){const he=g.ProxyChannel.fromService(fe.get(w.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",he);const Me=new r.UpdateChannel(fe.get(y.IUpdateService));we.registerChannel("update",Me);const Se=g.ProxyChannel.fromService(fe.get(N.IIssueMainService));we.registerChannel("issue",Se);const Pe=g.ProxyChannel.fromService(fe.get(K.IEncryptionMainService));we.registerChannel("encryption",Pe);const De=g.ProxyChannel.fromService(fe.get(qe.ISignService));we.registerChannel("sign",De);const ke=g.ProxyChannel.fromService(fe.get(oe.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",ke),this.nativeHostMainService=fe.get(me.INativeHostMainService);const We=g.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",We),Le.then(He=>He.registerChannel("nativeHost",We));const $e=g.ProxyChannel.fromService(fe.get(ae.IWorkspacesService));we.registerChannel("workspaces",$e);const Ue=g.ProxyChannel.fromService(fe.get(F.IMenubarMainService));we.registerChannel("menubar",Ue);const Je=g.ProxyChannel.fromService(fe.get(i.IURLService));we.registerChannel("url",Je);const Re=g.ProxyChannel.fromService(fe.get(Ie.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",Re);const Qe=g.ProxyChannel.fromService(fe.get(xe.IWebviewManagerService));we.registerChannel("webview",Qe);const Xe=this._register(new x.StorageDatabaseChannel(this.logService,fe.get(se.IStorageMainService)));we.registerChannel("storage",Xe),Le.then(He=>He.registerChannel("storage",Xe));const je=new T.LogLevelChannel(fe.get(l.ILogService));we.registerChannel("logLevel",je),Le.then(He=>He.registerChannel("logLevel",je));const tt=new T.LoggerChannel(fe.get(l.ILoggerService));we.registerChannel("logger",tt),Le.then(He=>He.registerChannel("logger",tt));const rt=new ve.ElectronExtensionHostDebugBroadcastChannel(fe.get(Q.IWindowsMainService));we.registerChannel("extensionhostdebugservice",rt)}openFirstWindow(fe,we){const Le=this.windowsMainService=fe.get(Q.IWindowsMainService),he=fe.get(i.IURLService),Me=fe.get(me.INativeHostMainService);this.lifecycleMainService.phase=2;const Se=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Be=>{try{return{uri:ie.URI.parse(Be),url:Be}}catch(Ze){return null}}).filter(Be=>{if(!Be||this.shouldBlockURI(Be.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(Be.uri);return Ze?(Se.push(Ze),!1):!0}),De=this,ke=this.environmentMainService;he.registerHandler({async handleURL(Be,Ze){if(De.shouldBlockURI(Be))return!0;const vt=De.getWindowOpenableFromProtocolLink(Be);if(vt){const[ct]=Le.open({context:5,cli:Object.assign({},ke.args),urisToOpen:[vt],gotoLineMode:!0});return ct.focus(),!0}if(b.isMacintosh&&Le.getWindowCount()===0){const[ct]=Le.open({context:5,cli:Object.assign({},ke.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ne.getRemoteAuthority)(Be)});return await ct.ready(),he.open(Be,Ze)}return!1}});const We=this._register(new te.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),$e=new g.StaticRouter(Be=>We.getActiveClientId().then(Ze=>Be===Ze)),Ue=new s.URLHandlerRouter($e),Je=we.getChannel("urlHandler",Ue);he.registerHandler(new s.URLHandlerChannelClient(Je)),this._register(new W.ElectronURLListener(Pe,he,Le,this.environmentMainService,this.productService));const Re=this.environmentMainService.args,Qe=global.macOpenFiles,Xe=(0,le.isLaunchedFromCli)(process.env)?0:4,je=Re._.length,tt=!!Re["folder-uri"],rt=!!Re["file-uri"],He=Re["skip-add-to-recently-opened"]===!0,lt=Re.wait&&Re.waitMarkerFilePath?ie.URI.file(Re.waitMarkerFilePath):void 0,mt=Re.remote||void 0;return Se.length>0?Le.open({context:Xe,cli:Re,urisToOpen:Se,gotoLineMode:!0,initialStartup:!0}):Re["new-window"]&&!je&&!tt&&!rt?Le.open({context:Xe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:mt}):Qe.length&&!je&&!tt&&!rt?Le.open({context:1,cli:Re,urisToOpen:Qe.map(Be=>this.getWindowOpenableFromPathSync(Be)),noRecentEntry:He,waitMarkerFileURI:lt,initialStartup:!0}):Le.open({context:Xe,cli:Re,forceNewWindow:Re["new-window"]||!je&&Re["unity-launch"],diffMode:Re.diff,noRecentEntry:He,waitMarkerFileURI:lt,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:mt})}shouldBlockURI(fe){return!!(fe.authority===Z.Schemas.file&&b.isWindows&&L.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,_e.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,_e.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,_e.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===Z.Schemas.file)return{fileUri:ie.URI.file(fe.fsPath)};if(fe.authority===Z.Schemas.vscodeRemote){const we=fe.path.indexOf(V.posix.sep,1);if(we!==-1){const Le=fe.path.substring(1,we),he=fe.path.substring(we),Me=ie.URI.from({scheme:Z.Schemas.vscodeRemote,authority:Le,path:he,query:fe.query,fragment:fe.fragment});return(0,ae.hasWorkspaceFileExtension)(he)?{workspaceUri:Me}:/:[\d]+$/.test(he)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(fe){try{if((0,A.statSync)(fe).isDirectory())return{folderUri:ie.URI.file(fe)};if((0,ae.hasWorkspaceFileExtension)(fe))return{workspaceUri:ie.URI.file(fe)}}catch(we){}return{fileUri:ie.URI.file(fe)}}async afterWindowOpen(fe,we){var Le;this.lifecycleMainService.phase=3;const he=fe.get(u.ITelemetryService);this._register(we.onDidError(({type:Pe,details:De})=>{let ke;typeof De=="string"?ke=De:ke=`SharedProcess: crashed (detail: ${De.reason})`,(0,R.onUnexpectedError)(new Error(ke)),he.publicLog2("sharedprocesserror",{type:Pe,reason:typeof De!="string"?De==null?void 0:De.reason:void 0,visible:we.isVisible()})}));const Me=this.productService.win32MutexName;if(b.isWindows&&Me)try{const Pe=q.__$__nodeRequire("windows-mutex").Mutex,De=new Pe(Me);(0,Ce.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}L.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(Pe,De)=>{De({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const Se=fe.get(y.IUpdateService);(Se instanceof z.Win32UpdateService||Se instanceof C.LinuxUpdateService||Se instanceof j.DarwinUpdateService)&&Se.initialize(),(0,S.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const De=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,ot.stripComments)(De))["enable-crash-reporter"]===void 0){const We=(Le=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Le!==void 0?Le:!0,$e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ze.generateUuid)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,nt.VSBuffer.fromString(Ue))}}catch(Pe){this.logService.error(Pe)}}stopTracingEventually(fe,we){this.logService.info("Tracing: waiting for windows to get ready...");const Le=fe.get(be.IDialogMainService);let he=!1;const Me=async Pe=>{if(!he){he=!0;const De=await L.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):Le.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,Te.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}},Se=setTimeout(()=>Me(!0),3e4);Promise.all(we.map(Pe=>Pe.ready())).then(()=>{clearTimeout(Se),Me(!1)})}};at=ce([ee(2,P.IInstantiationService),ee(3,l.ILogService),ee(4,c.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,o.IStateService),ee(8,Ke.IFileService),ee(9,_.IProductService)],at),e.CodeApplication=at}),define(X[234],J([0,1,13,18,11,3,71,47,54,156,16,33,56,168,70,67,6,190,38,21,182,49,218,230,39,92,91,17,75,42,74,188,192,176,177,10,24,73,216,20,30,22,8,35,26,66,95,174,32,55,179,198]),function(q,e,m,A,L,b,M,n,S,y,r,g,E,p,h,w,P,I,a,l,o,c,t,i,s,u,d,f,v,D,_,U,H,Q,ie,ae,O,$,z,C,j,N,T,R,W,k,F,B,V,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(x){console.error(x.message),m.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(ve=>console.error(ve));const[x,ne,ue,ye,ge,Ee,Ae]=this.createServices();try{try{await this.initServices(ue,ye,ge)}catch(ve){throw this.handleStartupDataDirError(ue,Ae.nameLong,ve),ve}await x.invokeFunction(async ve=>{const me=ve.get(P.ILogService),be=ve.get(r.ILifecycleMainService),Te=ve.get(O.IFileService),_e=await this.claimInstance(me,ue,be,x,Ae,!0);return Ee.logger=new u.SpdLogLogger("main",(0,T.join)(ue.logsPath,"main.log"),!0,Ee.getLevel()),(0,D.once)(be.onWillShutdown)(()=>{Te.dispose(),ye.dispose()}),x.createInstance(i.CodeApplication,_e,ne).startup()})}catch(ve){x.invokeFunction(this.quit,ve)}}createServices(){const x=new h.ServiceCollection,ne=Object.assign({_serviceBrand:void 0},n.default);x.set(C.IProductService,ne);const ue=new W.EnvironmentMainService(this.resolveArgs(),ne),ye=this.patchEnvironment(ue);x.set(W.IEnvironmentMainService,ue);const ge=new d.BufferLogService,Ee=new P.MultiplexLogService([new P.ConsoleMainLogger((0,P.getLogLevel)(ue)),ge]);process.once("exit",()=>Ee.dispose()),x.set(P.ILogService,Ee);const Ae=new Q.FileService(Ee);x.set(O.IFileService,Ae);const ve=new ie.DiskFileSystemProvider(Ee);Ae.registerProvider(ae.Schemas.file,ve),x.set(P.ILoggerService,new B.LoggerService(Ee,Ae));const me=new o.ConfigurationService(ue.settingsResource,Ae);x.set(l.IConfigurationService,me),x.set(r.ILifecycleMainService,new w.SyncDescriptor(r.LifecycleMainService));const be=new I.StateService(ue,Ee);return x.set(a.IStateService,be),x.set(c.IRequestService,new w.SyncDescriptor(t.RequestMainService)),x.set(v.IThemeMainService,new w.SyncDescriptor(v.ThemeMainService)),x.set(_.ISignService,new w.SyncDescriptor(U.SignService)),x.set($.ITunnelService,new w.SyncDescriptor(z.TunnelService)),x.set(G.IProtocolMainService,new w.SyncDescriptor(Y.ProtocolMainService)),[new p.InstantiationService(x,!0),ye,ue,me,be,ge,ne]}patchEnvironment(x){const ne={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const ye=process.env[ue];typeof ye=="string"&&(ne[ue]=ye)}),Object.assign(process.env,ne),ne}initServices(x,ne,ue){const ye=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(Ae=>Ae?A.promises.mkdir(Ae,{recursive:!0}):void 0)),ge=ne.initialize(),Ee=ue.init();return Promise.all([ye,ge,Ee])}async claimInstance(x,ne,ue,ye,ge,Ee){let Ae;try{(0,M.mark)("code/willStartMainServer"),Ae=await(0,E.serve)(ne.mainIPCHandle),(0,M.mark)("code/didStartMainServer"),(0,D.once)(ue.onWillShutdown)(()=>Ae.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ne,ge.nameLong,ve),ve;let me;try{me=await(0,E.connect)(ne.mainIPCHandle,"main")}catch(_e){if(!Ee||b.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,L.localize)(0,null,ge.nameShort),(0,L.localize)(1,null),ge.nameLong),_e;try{(0,A.unlinkSync)(ne.mainIPCHandle)}catch(Ye){throw x.warn("Could not delete obsolete instance handle",Ye),Ye}return this.claimInstance(x,ne,ue,ye,ge,!1)}if(ne.extensionTestsLocationURI&&!ne.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(_e),me.dispose(),new Error(_e)}let be;!ne.args.wait&&!ne.args.status&&(be=setTimeout(()=>{this.showStartupWarningDialog((0,L.localize)(2,null,ge.nameShort),(0,L.localize)(3,null),ge.nameLong)},1e4));const Te=g.ProxyChannel.toService(me.getChannel("launch"),{disableMarshalling:!0});if(ne.args.status)return ye.invokeFunction(async()=>{const _e=new H.DiagnosticsService(F.NullTelemetryService,ge),Ye=await Te.getMainProcessInfo(),xe=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await _e.getDiagnostics(Ye,xe);throw console.log(Ke),new f.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Te,x),x.trace("Sending env to running instance..."),await Te.start(ne.args,process.env),me.dispose(),be&&clearTimeout(be),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ne.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(x,ne,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const ye=(0,R.coalesce)([x.userDataPath,x.extensionsPath,E.XDG_RUNTIME_DIR]).map(ge=>(0,s.getPathLabel)(ge,x));this.showStartupWarningDialog((0,L.localize)(4,null),(0,L.localize)(5,null,(0,k.toErrorMessage)(ue),ye.join(`
`)),ne)}}showStartupWarningDialog(x,ne,ue){m.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,L.localize)(6,null))],message:x,detail:ne,noLink:!0})}async windowsAllowSetForegroundWindow(x,ne){if(b.isWindows){const ue=await x.getMainProcessId();ne.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((ye,ge)=>{q(["windows-foreground-love"],ye,ge)})).allowSetForegroundWindow(ue)}catch(ye){ne.error(ye)}}}quit(x,ne){const ue=x.get(P.ILogService),ye=x.get(r.ILifecycleMainService);let ge=0;ne&&(ne.isExpected?ne.message&&ue.trace(ne.message):(ge=1,ne.stack?ue.error(ne.stack):ue.error(`Startup error: ${ne.toString()}`))),ye.kill(ge)}resolveArgs(){const x=this.validatePaths((0,S.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ne=(0,y.createWaitMarkerFile)(x.verbose);ne&&((0,S.addArg)(process.argv,"--waitMarkerFilePath",ne),x.waitMarkerFilePath=ne)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ne=this.doValidatePaths(x._,x.goto);x._=ne}return x}doValidatePaths(x,ne){const ue=(0,V.cwd)(),ye=x.map(Ae=>{let ve=String(Ae),me;ne&&(me=(0,j.parseLineAndColumnAware)(ve),ve=me.path),ve&&(ve=this.preparePath(ue,ve));const be=(0,j.sanitizeFilePath)(ve,ue),Te=(0,T.basename)(be);return Te&&!(0,j.isValidBasename)(Te)?null:ne&&me?(me.path=be,this.toPath(me)):be}),ge=b.isWindows||b.isMacintosh,Ee=(0,R.distinct)(ye,Ae=>Ae&&ge?Ae.toLowerCase():Ae||"");return(0,R.coalesce)(Ee)}preparePath(x,ne){return b.isWindows&&(ne=(0,N.rtrim)(ne,'"')),ne=(0,N.trim)((0,N.trim)(ne," "),"	"),b.isWindows&&(ne=(0,T.resolve)(x,ne),ne=(0,N.rtrim)(ne,".")),ne}toPath(x){const ne=[x.path];return typeof x.line=="number"&&ne.push(String(x.line)),typeof x.column=="number"&&ne.push(String(x.column)),ne.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5080d21c0b538b996c83fb7b14a746f656eaef15/core/vs/code/electron-main/main.js.map
