/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/platform","fs","vs/base/common/buffer","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function($){for(var t=[],p=0,C=$.length;p<C;p++)t[p]=Q[$[p]];return t};define(Q[56],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function p(C,b){if(!C)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=p}),define(Q[57],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function p(h){return(f,R,d)=>{let y=null,I=null;if(typeof d.value=="function"?(y="value",I=d.value):typeof d.get=="function"&&(y="get",I=d.get),!I)throw new Error("not supported");d[y]=h(I,R)}}t.createDecorator=p;let C=0;function b(){const h=`$memoize${C++}`;let f;const R=function(y,I,a){let m=null,S=null;if(typeof a.value=="function"?(m="value",S=a.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(m="get",S=a.get),!S)throw new Error("not supported");const O=`${h}:${I}`;a[m]=function(...T){return f=this,this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,T)}),this[O]}};return R.clear=()=>{typeof f!="undefined"&&Object.getOwnPropertyNames(f).forEach(d=>{d.indexOf(h)===0&&delete f[d]})},R}t.createMemoizer=b;function w(h,f,R){return b()(h,f,R)}t.memoize=w;function F(h,f,R){return p((d,y)=>{const I=`$debounce$${y}`,a=`$debounce$result$${y}`;return function(...m){this[a]||(this[a]=R?R():void 0),clearTimeout(this[I]),f&&(this[a]=f(this[a],...m),m=[this[a]]),this[I]=setTimeout(()=>{d.apply(this,m),this[a]=R?R():void 0},h)}})}t.debounce=F;function L(h,f,R){return p((d,y)=>{const I=`$throttle$timer$${y}`,a=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,S=`$throttle$pending$${y}`;return function(...O){if(this[a]||(this[a]=R?R():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),f&&(this[a]=f(this[a],...O)),!this[S]){const T=this[m]+h;T<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[a]]),this[a]=R?R():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),d.apply(this,[this[a]]),this[a]=R?R():void 0},T-Date.now()))}}})}t.throttle=L}),define(Q[23],Z([0,1,14]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function C(W,G=0){return W[W.length-(1+G)]}t.tail=C;function b(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=b;function w(W,G,_=(l,c)=>l===c){if(W===G)return!0;if(!W||!G||W.length!==G.length)return!1;for(let l=0,c=W.length;l<c;l++)if(!_(W[l],G[l]))return!1;return!0}t.equals=w;function F(W,G,_){let l=0,c=W.length-1;for(;l<=c;){const P=(l+c)/2|0,D=_(W[P],G);if(D<0)l=P+1;else if(D>0)c=P-1;else return P}return-(l+1)}t.binarySearch=F;function L(W,G){let _=0,l=W.length;if(l===0)return 0;for(;_<l;){const c=Math.floor((_+l)/2);G(W[c])?l=c:_=c+1}return _}t.findFirstInSorted=L;function h(W,G,_){if(W=W|0,W>=G.length)throw new TypeError("invalid index");let l=G[Math.floor(G.length*Math.random())],c=[],P=[],D=[];for(let N of G){const M=_(N,l);M<0?c.push(N):M>0?P.push(N):D.push(N)}return W<c.length?h(W,c,_):W<c.length+D.length?D[0]:h(W-(c.length+D.length),P,_)}t.quickSelect=h;function f(W,G){const _=[];let l;for(const c of W.slice(0).sort(G))!l||G(l[0],c)!==0?(l=[c],_.push(l)):l.push(c);return _}t.groupBy=f;function R(W,G,_){const l=[];function c(N,M,z){if(!(M===0&&z.length===0)){const B=l[l.length-1];B&&B.start+B.deleteCount===N?(B.deleteCount+=M,B.toInsert.push(...z)):l.push({start:N,deleteCount:M,toInsert:z})}}let P=0,D=0;for(;;){if(P===W.length){c(P,0,G.slice(D));break}if(D===G.length){c(P,W.length-P,[]);break}const N=W[P],M=G[D],z=_(N,M);z===0?(P+=1,D+=1):z<0?(c(P,1,[]),P+=1):z>0&&(c(P,0,[M]),D+=1)}return l}t.sortedDiff=R;function d(W,G,_){const l=R(W,G,_),c=[],P=[];for(const D of l)c.push(...W.slice(D.start,D.start+D.deleteCount)),P.push(...D.toInsert);return{removed:c,added:P}}t.delta=d;function y(W,G,_){if(_===0)return[];const l=W.slice(0,_).sort(G);return a(W,G,l,_,W.length),l}t.top=y;function I(W,G,_,l,c){return _===0?Promise.resolve([]):new Promise((P,D)=>{(async()=>{const N=W.length,M=W.slice(0,_).sort(G);for(let z=_,B=Math.min(_+l,N);z<N;z=B,B=Math.min(B+l,N)){if(z>_&&await new Promise(q=>setTimeout(q)),c&&c.isCancellationRequested)throw(0,p.canceled)();a(W,G,M,z,B)}return M})().then(P,D)})}t.topAsync=I;function a(W,G,_,l,c){for(const P=_.length;l<c;l++){const D=W[l];if(G(D,_[P-1])<0){_.pop();const N=L(_,M=>G(D,M)<0);_.splice(N,0,D)}}}function m(W){return W.filter(G=>!!G)}t.coalesce=m;function S(W){let G=0;for(let _=0;_<W.length;_++)W[_]&&(W[G]=W[_],G+=1);W.length=G}t.coalesceInPlace=S;function O(W,G,_){W.splice(_,0,W.splice(G,1)[0])}t.move=O;function T(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=T;function v(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=v;function s(W,G){if(!G)return W.filter((l,c)=>W.indexOf(l)===c);const _=Object.create(null);return W.filter(l=>{const c=G(l);return _[c]?!1:(_[c]=!0,!0)})}t.distinct=s;function r(W){const G=new Set;return W.filter(_=>G.has(_)?!1:(G.add(_),!0))}t.distinctES6=r;function e(W){const G=Object.create(null);return _=>{const l=W(_);return G[l]?!1:(G[l]=!0,!0)}}t.uniqueFilter=e;function i(W,G){for(let _=W.length-1;_>=0;_--){const l=W[_];if(G(l))return _}return-1}t.lastIndex=i;function n(W,G){return W.length>0?W[0]:G}t.firstOrDefault=n;function o(W,G,_=(l,c)=>l===c){let l=0;for(let c=0,P=Math.min(W.length,G.length);c<P&&_(W[c],G[c]);c++)l++;return l}t.commonPrefixLength=o;function u(W){return[].concat(...W)}t.flatten=u;function g(W,G){let _=typeof G=="number"?W:0;typeof G=="number"?_=W:(_=0,G=W);const l=[];if(_<=G)for(let c=_;c<G;c++)l.push(c);else for(let c=_;c>G;c--)l.push(c);return l}t.range=g;function E(W,G,_){return W.reduce((l,c)=>(l[G(c)]=_?_(c):c,l),Object.create(null))}t.index=E;function k(W,G){return W.push(G),()=>j(W,G)}t.insert=k;function j(W,G){const _=W.indexOf(G);if(_>-1)return W.splice(_,1),G}t.remove=j;function A(W,G,_){const l=W.slice(0,G),c=W.slice(G);return l.concat(_,c)}t.arrayInsert=A;function U(W,G){let _;if(typeof G=="number"){let l=G;_=()=>{const c=Math.sin(l++)*179426549;return c-Math.floor(c)}}else _=Math.random;for(let l=W.length-1;l>0;l-=1){const c=Math.floor(_()*(l+1)),P=W[l];W[l]=W[c],W[c]=P}}t.shuffle=U;function x(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.unshift(G))}t.pushToStart=x;function X(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.push(G))}t.pushToEnd=X;function ne(W,G){return Array.isArray(W)?W.map(G):G(W)}t.mapArrayOrNot=ne;function ee(W){return Array.isArray(W)?W:[W]}t.asArray=ee;function te(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=te;function ae(W,G){for(const _ of W){const l=G(_);if(l!==void 0)return l}}t.mapFind=ae}),define(Q[58],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var p;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(p=t.ScanError||(t.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var w;(function(e){e.DEFAULT={allowTrailingComma:!0}})(w=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,o=e.length,u="",g=0,E=16,k=0;function j(te){let ae=0,W=0;for(;ae<te;){const G=e.charCodeAt(n);if(G>=48&&G<=57)W=W*16+G-48;else if(G>=65&&G<=70)W=W*16+G-65+10;else if(G>=97&&G<=102)W=W*16+G-97+10;else break;n++,ae++}return ae<te&&(W=-1),W}function A(te){n=te,u="",g=0,E=16,k=0}function U(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&f(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&f(e.charCodeAt(n)))for(n++;n<e.length&&f(e.charCodeAt(n));)n++;else return k=3,e.substring(te,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&f(e.charCodeAt(n))){for(n++;n<e.length&&f(e.charCodeAt(n));)n++;ae=n}else k=3;return e.substring(te,ae)}function x(){let te="",ae=n;for(;;){if(n>=o){te+=e.substring(ae,n),k=2;break}const W=e.charCodeAt(n);if(W===34){te+=e.substring(ae,n),n++;break}if(W===92){if(te+=e.substring(ae,n),n++,n>=o){k=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const _=j(4);_>=0?te+=String.fromCharCode(_):k=4;break;default:k=5}ae=n;continue}if(W>=0&&W<=31)if(h(W)){te+=e.substring(ae,n),k=2;break}else k=6;n++}return te}function X(){if(u="",k=0,g=n,n>=o)return g=o,E=17;let te=e.charCodeAt(n);if(L(te)){do n++,u+=String.fromCharCode(te),te=e.charCodeAt(n);while(L(te));return E=15}if(h(te))return n++,u+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,u+=`
`),E=14;switch(te){case 123:return n++,E=1;case 125:return n++,E=2;case 91:return n++,E=3;case 93:return n++,E=4;case 58:return n++,E=6;case 44:return n++,E=5;case 34:return n++,u=x(),E=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<o&&!h(e.charCodeAt(n));)n++;return u=e.substring(ae,n),E=12}if(e.charCodeAt(n+1)===42){n+=2;const W=o-1;let G=!1;for(;n<W;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,k=1),u=e.substring(ae,n),E=13}return u+=String.fromCharCode(te),n++,E=16;case 45:if(u+=String.fromCharCode(te),n++,n===o||!f(e.charCodeAt(n)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=U(),E=11;default:for(;n<o&&ne(te);)n++,te=e.charCodeAt(n);if(g!==n){switch(u=e.substring(g,n),u){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return u+=String.fromCharCode(te),n++,E=16}}function ne(te){if(L(te)||h(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let te;do te=X();while(te>=12&&te<=15);return te}return{setPosition:A,getPosition:()=>n,scan:i?ee:X,getToken:()=>E,getTokenValue:()=>u,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>k}}t.createScanner=F;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function h(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var R;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(R||(R={}));function d(e,i){const n=[],o=new Object;let u;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function k(j,A,U,x){g.value=j,g.offset=A,g.length=U,g.type=x,g.colonOffset=void 0,u=g}try{v(e,{onObjectBegin:(j,A)=>{if(i<=j)throw o;u=void 0,E=i>j,n.push("")},onObjectProperty:(j,A,U)=>{if(i<A||(k(j,A,U,"property"),n[n.length-1]=j,i<=A+U))throw o},onObjectEnd:(j,A)=>{if(i<=j)throw o;u=void 0,n.pop()},onArrayBegin:(j,A)=>{if(i<=j)throw o;u=void 0,n.push(0)},onArrayEnd:(j,A)=>{if(i<=j)throw o;u=void 0,n.pop()},onLiteralValue:(j,A,U)=>{if(i<A||(k(j,A,U,r(j)),i<=A+U))throw o},onSeparator:(j,A,U)=>{if(i<=A)throw o;if(j===":"&&u&&u.type==="property")u.colonOffset=A,E=!1,u=void 0;else if(j===","){const x=n[n.length-1];typeof x=="number"?n[n.length-1]=x+1:(E=!0,n[n.length-1]=""),u=void 0}}})}catch(j){if(j!==o)throw j}return{path:n,previousNode:u,isAtPropertyKey:E,matches:j=>{let A=0;for(let U=0;A<j.length&&U<n.length;U++)if(j[A]===n[U]||j[A]==="*")A++;else if(j[A]!=="**")return!1;return A===j.length}}}t.getLocation=d;function y(e,i=[],n=w.DEFAULT){let o=null,u=[];const g=[];function E(j){Array.isArray(u)?u.push(j):o!==null&&(u[o]=j)}return v(e,{onObjectBegin:()=>{const j={};E(j),g.push(u),u=j,o=null},onObjectProperty:j=>{o=j},onObjectEnd:()=>{u=g.pop()},onArrayBegin:()=>{const j=[];E(j),g.push(u),u=j,o=null},onArrayEnd:()=>{u=g.pop()},onLiteralValue:E,onError:(j,A,U)=>{i.push({error:j,offset:A,length:U})}},n),u[0]}t.parse=y;function I(e,i=[],n=w.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(j){o.type==="property"&&(o.length=j-o.offset,o=o.parent)}function g(j){return o.children.push(j),j}v(e,{onObjectBegin:j=>{o=g({type:"object",offset:j,length:-1,parent:o,children:[]})},onObjectProperty:(j,A,U)=>{o=g({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:j,offset:A,length:U,parent:o})},onObjectEnd:(j,A)=>{o.length=j+A-o.offset,o=o.parent,u(j+A)},onArrayBegin:(j,A)=>{o=g({type:"array",offset:j,length:-1,parent:o,children:[]})},onArrayEnd:(j,A)=>{o.length=j+A-o.offset,o=o.parent,u(j+A)},onLiteralValue:(j,A,U)=>{g({type:r(j),offset:A,length:U,parent:o,value:j}),u(A+U)},onSeparator:(j,A,U)=>{o.type==="property"&&(j===":"?o.colonOffset=A:j===","&&u(A))},onError:(j,A,U)=>{i.push({error:j,offset:A,length:U})}},n);const k=o.children[0];return k&&delete k.parent,k}t.parseTree=I;function a(e,i){if(!!e){let n=e;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===o){n=g.children[1],u=!0;break}if(!u)return}else{const u=o;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}}t.findNodeAtLocation=a;function m(e){if(!e.parent||!e.parent.children)return[];const i=m(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=m;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":const i=Object.create(null);for(let n of e.children){const o=n.children[1];o&&(i[n.children[0].value]=S(o))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function O(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=O;function T(e,i,n=!1){if(O(e,i,n)){const o=e.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=i;u++){const g=T(o[u],i,n);if(g)return g}return e}}t.findNodeAtOffset=T;function v(e,i,n=w.DEFAULT){const o=F(e,!1);function u(M){return M?()=>M(o.getTokenOffset(),o.getTokenLength()):()=>!0}function g(M){return M?z=>M(z,o.getTokenOffset(),o.getTokenLength()):()=>!0}const E=u(i.onObjectBegin),k=g(i.onObjectProperty),j=u(i.onObjectEnd),A=u(i.onArrayBegin),U=u(i.onArrayEnd),x=g(i.onLiteralValue),X=g(i.onSeparator),ne=u(i.onComment),ee=g(i.onError),te=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function W(){for(;;){const M=o.scan();switch(o.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(M){case 12:case 13:te?G(10):ne();break;case 16:G(1);break;case 15:case 14:break;default:return M}}}function G(M,z=[],B=[]){if(ee(M),z.length+B.length>0){let q=o.getToken();for(;q!==17;){if(z.indexOf(q)!==-1){W();break}else if(B.indexOf(q)!==-1)break;q=W()}}}function _(M){const z=o.getTokenValue();return M?x(z):k(z),W(),!0}function l(){switch(o.getToken()){case 11:let M=0;try{M=JSON.parse(o.getTokenValue()),typeof M!="number"&&(G(2),M=0)}catch(z){G(2)}x(M);break;case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return W(),!0}function c(){return o.getToken()!==10?(G(3,[],[2,5]),!1):(_(!1),o.getToken()===6?(X(":"),W(),N()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function P(){E(),W();let M=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(M||G(4,[],[]),X(","),W(),o.getToken()===2&&ae)break}else M&&G(6,[],[]);c()||G(4,[],[2,5]),M=!0}return j(),o.getToken()!==2?G(7,[2],[]):W(),!0}function D(){A(),W();let M=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(M||G(4,[],[]),X(","),W(),o.getToken()===4&&ae)break}else M&&G(6,[],[]);N()||G(4,[],[4,5]),M=!0}return U(),o.getToken()!==4?G(8,[4],[]):W(),!0}function N(){switch(o.getToken()){case 3:return D();case 1:return P();case 10:return _(!0);default:return l()}}return W(),o.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):N()?(o.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=v;function s(e,i){let n=F(e),o=[],u,g=0,E;do switch(E=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:g!==E&&o.push(e.substring(g,E)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),g=n.getPosition();break}while(u!==17);return o.join("")}t.stripComments=s;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r});"use strict";(function(){function $(b){const w=[];typeof b=="number"&&w.push("code/timeOrigin",b);function F(h){w.push(h,Date.now())}function L(){const h=[];for(let f=0;f<w.length;f+=2)h.push({name:w[f],startTime:w[f+1]});return h}return{mark:F,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const w=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const F of performance.getEntriesByType("mark"))w.push({name:F.name,startTime:Math.round(b+F.startTime)});return w}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function p(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=p(C))})(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var p=t();for(var C in p)(typeof exports=="object"?exports:$)[C]=p[C]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function p(C){if(t[C])return t[C].exports;var b=t[C]={i:C,l:!1,exports:{}};return $[C].call(b.exports,b,b.exports,p),b.l=!0,b.exports}return p.m=$,p.c=t,p.d=function(C,b,w){p.o(C,b)||Object.defineProperty(C,b,{enumerable:!0,get:w})},p.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},p.t=function(C,b){if(1&b&&(C=p(C)),8&b||4&b&&typeof C=="object"&&C&&C.__esModule)return C;var w=Object.create(null);if(p.r(w),Object.defineProperty(w,"default",{enumerable:!0,value:C}),2&b&&typeof C!="string")for(var F in C)p.d(w,F,function(L){return C[L]}.bind(null,F));return w},p.n=function(C){var b=C&&C.__esModule?function(){return C.default}:function(){return C};return p.d(b,"a",b),b},p.o=function(C,b){return Object.prototype.hasOwnProperty.call(C,b)},p.p="",p(p.s=0)}([function($,t,p){(function(C){var b;t=$.exports=B,b=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var w=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],h=t.src=[],f=0,R=f++;h[R]="0|[1-9]\\d*";var d=f++;h[d]="[0-9]+";var y=f++;h[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=f++;h[I]="("+h[R]+")\\.("+h[R]+")\\.("+h[R]+")";var a=f++;h[a]="("+h[d]+")\\.("+h[d]+")\\.("+h[d]+")";var m=f++;h[m]="(?:"+h[R]+"|"+h[y]+")";var S=f++;h[S]="(?:"+h[d]+"|"+h[y]+")";var O=f++;h[O]="(?:-("+h[m]+"(?:\\."+h[m]+")*))";var T=f++;h[T]="(?:-?("+h[S]+"(?:\\."+h[S]+")*))";var v=f++;h[v]="[0-9A-Za-z-]+";var s=f++;h[s]="(?:\\+("+h[v]+"(?:\\."+h[v]+")*))";var r=f++,e="v?"+h[I]+h[O]+"?"+h[s]+"?";h[r]="^"+e+"$";var i="[v=\\s]*"+h[a]+h[T]+"?"+h[s]+"?",n=f++;h[n]="^"+i+"$";var o=f++;h[o]="((?:<|>)?=?)";var u=f++;h[u]=h[d]+"|x|X|\\*";var g=f++;h[g]=h[R]+"|x|X|\\*";var E=f++;h[E]="[v=\\s]*("+h[g]+")(?:\\.("+h[g]+")(?:\\.("+h[g]+")(?:"+h[O]+")?"+h[s]+"?)?)?";var k=f++;h[k]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[T]+")?"+h[s]+"?)?)?";var j=f++;h[j]="^"+h[o]+"\\s*"+h[E]+"$";var A=f++;h[A]="^"+h[o]+"\\s*"+h[k]+"$";var U=f++;h[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=f++;h[x]="(?:~>?)";var X=f++;h[X]="(\\s*)"+h[x]+"\\s+",L[X]=new RegExp(h[X],"g");var ne=f++;h[ne]="^"+h[x]+h[E]+"$";var ee=f++;h[ee]="^"+h[x]+h[k]+"$";var te=f++;h[te]="(?:\\^)";var ae=f++;h[ae]="(\\s*)"+h[te]+"\\s+",L[ae]=new RegExp(h[ae],"g");var W=f++;h[W]="^"+h[te]+h[E]+"$";var G=f++;h[G]="^"+h[te]+h[k]+"$";var _=f++;h[_]="^"+h[o]+"\\s*("+i+")$|^$";var l=f++;h[l]="^"+h[o]+"\\s*("+e+")$|^$";var c=f++;h[c]="(\\s*)"+h[o]+"\\s*("+i+"|"+h[E]+")",L[c]=new RegExp(h[c],"g");var P=f++;h[P]="^\\s*("+h[E]+")\\s+-\\s+("+h[E]+")\\s*$";var D=f++;h[D]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var N=f++;h[N]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)b(M,h[M]),L[M]||(L[M]=new RegExp(h[M]));function z(V,H){if(V instanceof B)return V;if(typeof V!="string"||V.length>w||!(H?L[n]:L[r]).test(V))return null;try{return new B(V,H)}catch(K){return null}}function B(V,H){if(V instanceof B){if(V.loose===H)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>w)throw new TypeError("version is longer than "+w+" characters");if(!(this instanceof B))return new B(V,H);b("SemVer",V,H),this.loose=H;var K=V.trim().match(H?L[n]:L[r]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<F)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=z,t.valid=function(V,H){var K=z(V,H);return K?K.version:null},t.clean=function(V,H){var K=z(V.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(V){return b("SemVer.compare",this.version,this.loose,V),V instanceof B||(V=new B(V,this.loose)),this.compareMain(V)||this.comparePre(V)},B.prototype.compareMain=function(V){return V instanceof B||(V=new B(V,this.loose)),J(this.major,V.major)||J(this.minor,V.minor)||J(this.patch,V.patch)},B.prototype.comparePre=function(V){if(V instanceof B||(V=new B(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=V.prerelease[H];if(b("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++H)},B.prototype.inc=function(V,H){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new B(V,K).inc(H,se).version}catch(oe){return null}},t.diff=function(V,H){if(he(V,H))return null;var K=z(V),se=z(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var q=/^[0-9]+$/;function J(V,H){var K=q.test(V),se=q.test(H);return K&&se&&(V=+V,H=+H),K&&!se?-1:se&&!K?1:V<H?-1:V>H?1:0}function Y(V,H,K){return new B(V,K).compare(new B(H,K))}function ie(V,H,K){return Y(V,H,K)>0}function re(V,H,K){return Y(V,H,K)<0}function he(V,H,K){return Y(V,H,K)===0}function ge(V,H,K){return Y(V,H,K)!==0}function Se(V,H,K){return Y(V,H,K)>=0}function be(V,H,K){return Y(V,H,K)<=0}function Fe(V,H,K,se){var oe;switch(H){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V!==K;break;case"":case"=":case"==":oe=he(V,K,se);break;case"!=":oe=ge(V,K,se);break;case">":oe=ie(V,K,se);break;case">=":oe=Se(V,K,se);break;case"<":oe=re(V,K,se);break;case"<=":oe=be(V,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function Re(V,H){if(V instanceof Re){if(V.loose===H)return V;V=V.value}if(!(this instanceof Re))return new Re(V,H);b("comparator",V,H),this.loose=H,this.parse(V),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(V,H){return J(H,V)},t.major=function(V,H){return new B(V,H).major},t.minor=function(V,H){return new B(V,H).minor},t.patch=function(V,H){return new B(V,H).patch},t.compare=Y,t.compareLoose=function(V,H){return Y(V,H,!0)},t.rcompare=function(V,H,K){return Y(H,V,K)},t.sort=function(V,H){return V.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(V,H){return V.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ie,t.lt=re,t.eq=he,t.neq=ge,t.gte=Se,t.lte=be,t.cmp=Fe,t.Comparator=Re;var Ne={};function pe(V,H){if(V instanceof pe)return V.loose===H?V:new pe(V.raw,H);if(V instanceof Re)return new pe(V.value,H);if(!(this instanceof pe))return new pe(V,H);if(this.loose=H,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Oe(V){return!V||V.toLowerCase()==="x"||V==="*"}function xe(V,H,K,se,oe,Ie,de,Ce,Ee,Le,ke,we,Pe){return((H=Oe(K)?"":Oe(se)?">="+K+".0.0":Oe(oe)?">="+K+"."+se+".0":">="+H)+" "+(Ce=Oe(Ee)?"":Oe(Le)?"<"+(+Ee+1)+".0.0":Oe(ke)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+ke+"-"+we:"<="+Ce)).trim()}function $e(V,H){for(var K=0;K<V.length;K++)if(!V[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<V.length;K++)if(b(V[K].semver),V[K].semver!==Ne&&V[K].semver.prerelease.length>0){var se=V[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ue(V,H,K){try{H=new pe(H,K)}catch(se){return!1}return H.test(V)}function ze(V,H,K,se){var oe,Ie,de,Ce,Ee;switch(V=new B(V,se),H=new pe(H,se),K){case">":oe=ie,Ie=be,de=re,Ce=">",Ee=">=";break;case"<":oe=re,Ie=Se,de=ie,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(V,H,se))return!1;for(var Le=0;Le<H.set.length;++Le){var ke=H.set[Le],we=null,Pe=null;if(ke.forEach(function(Te){Te.semver===Ne&&(Te=new Re(">=0.0.0")),we=we||Te,Pe=Pe||Te,oe(Te.semver,we.semver,se)?we=Te:de(Te.semver,Pe.semver,se)&&(Pe=Te)}),we.operator===Ce||we.operator===Ee||(!Pe.operator||Pe.operator===Ce)&&Ie(V,Pe.semver)||Pe.operator===Ee&&de(V,Pe.semver))return!1}return!0}Re.prototype.parse=function(V){var H=this.loose?L[_]:L[l],K=V.match(H);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new B(K[2],this.loose):this.semver=Ne},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(V){return b("Comparator.test",V,this.loose),this.semver===Ne||(typeof V=="string"&&(V=new B(V,this.loose)),Fe(V,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(V,H){if(!(V instanceof Re))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(V.value,H),Ue(this.value,K,H);if(V.operator==="")return K=new pe(this.value,H),Ue(V.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ie=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=Fe(this.semver,"<",V.semver,H)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ee=Fe(this.semver,">",V.semver,H)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return se||oe||Ie&&de||Ce||Ee},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(V){var H=this.loose;V=V.trim(),b("range",V,H);var K=H?L[D]:L[P];V=V.replace(K,xe),b("hyphen replace",V),V=V.replace(L[c],"$1$2$3"),b("comparator trim",V,L[c]),V=(V=(V=V.replace(L[X],"$1~")).replace(L[ae],"$1^")).split(/\s+/).join(" ");var se=H?L[_]:L[l],oe=V.split(" ").map(function(Ie){return function(de,Ce){return b("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Pe){b("caret",we,Pe);var Te=Pe?L[G]:L[W];return we.replace(Te,function(Ae,le,fe,me,ve){var De;return b("caret",we,Ae,le,fe,me,ve),Oe(le)?De="":Oe(fe)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Oe(me)?De=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":ve?(b("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+ve+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+ve+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+ve+" <"+(+le+1)+".0.0"):(b("no pr"),De=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+" <"+(+le+1)+".0.0"),b("caret return",De),De})}(ke,Le)}).join(" ")}(de,Ce),b("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Pe){var Te=Pe?L[ee]:L[ne];return we.replace(Te,function(Ae,le,fe,me,ve){var De;return b("tilde",we,Ae,le,fe,me,ve),Oe(le)?De="":Oe(fe)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Oe(me)?De=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":ve?(b("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=">="+le+"."+fe+"."+me+ve+" <"+le+"."+(+fe+1)+".0"):De=">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0",b("tilde return",De),De})}(ke,Le)}).join(" ")}(de,Ce),b("tildes",de),de=function(Ee,Le){return b("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(ke){return function(we,Pe){we=we.trim();var Te=Pe?L[A]:L[j];return we.replace(Te,function(Ae,le,fe,me,ve,De){b("xRange",we,Ae,le,fe,me,ve,De);var Be=Oe(fe),Me=Be||Oe(me),je=Me||Oe(ve);return le==="="&&je&&(le=""),Be?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Me&&(me=0),je&&(ve=0),le===">"?(le=">=",Me?(fe=+fe+1,me=0,ve=0):je&&(me=+me+1,ve=0)):le==="<="&&(le="<",Me?fe=+fe+1:me=+me+1),Ae=le+fe+"."+me+"."+ve):Me?Ae=">="+fe+".0.0 <"+(+fe+1)+".0.0":je&&(Ae=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0"),b("xRange return",Ae),Ae})}(ke,Le)}).join(" ")}(de,Ce),b("xrange",de),de=function(Ee,Le){return b("replaceStars",Ee,Le),Ee.trim().replace(L[N],"")}(de,Ce),b("stars",de),de}(Ie,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Ie){return!!Ie.match(se)})),oe=oe.map(function(Ie){return new Re(Ie,H)})},pe.prototype.intersects=function(V,H){if(!(V instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return V.set.some(function(oe){return oe.every(function(Ie){return se.intersects(Ie,H)})})})})},t.toComparators=function(V,H){return new pe(V,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new B(V,this.loose));for(var H=0;H<this.set.length;H++)if($e(this.set[H],V))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(V,H,K){var se=null,oe=null;try{var Ie=new pe(H,K)}catch(de){return null}return V.forEach(function(de){Ie.test(de)&&(se&&oe.compare(de)!==-1||(oe=new B(se=de,K)))}),se},t.minSatisfying=function(V,H,K){var se=null,oe=null;try{var Ie=new pe(H,K)}catch(de){return null}return V.forEach(function(de){Ie.test(de)&&(se&&oe.compare(de)!==1||(oe=new B(se=de,K)))}),se},t.validRange=function(V,H){try{return new pe(V,H).range||"*"}catch(K){return null}},t.ltr=function(V,H,K){return ze(V,H,"<",K)},t.gtr=function(V,H,K){return ze(V,H,">",K)},t.outside=ze,t.prerelease=function(V,H){var K=z(V,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,H,K){return V=new pe(V,K),H=new pe(H,K),V.intersects(H)},t.coerce=function(V){if(V instanceof B)return V;if(typeof V!="string")return null;var H=V.match(L[U]);return H==null?null:z((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,p(1))},function($,t){var p,C,b=$.exports={};function w(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function L(S){if(p===setTimeout)return setTimeout(S,0);if((p===w||!p)&&setTimeout)return p=setTimeout,setTimeout(S,0);try{return p(S,0)}catch(O){try{return p.call(null,S,0)}catch(T){return p.call(this,S,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:w}catch(S){p=w}try{C=typeof clearTimeout=="function"?clearTimeout:F}catch(S){C=F}})();var h,f=[],R=!1,d=-1;function y(){R&&h&&(R=!1,h.length?f=h.concat(f):d=-1,f.length&&I())}function I(){if(!R){var S=L(y);R=!0;for(var O=f.length;O;){for(h=f,f=[];++d<O;)h&&h[d].run();d=-1,O=f.length}h=null,R=!1,function(T){if(C===clearTimeout)return clearTimeout(T);if((C===F||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(T);try{C(T)}catch(v){try{return C.call(null,T)}catch(s){return C.call(this,T)}}}(S)}}function a(S,O){this.fun=S,this.array=O}function m(){}b.nextTick=function(S){var O=new Array(arguments.length-1);if(arguments.length>1)for(var T=1;T<arguments.length;T++)O[T-1]=arguments[T];f.push(new a(S,O)),f.length!==1||R||L(I)},a.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=m,b.addListener=m,b.once=m,b.off=m,b.removeListener=m,b.removeAllListeners=m,b.emit=m,b.prependListener=m,b.prependOnceListener=m,b.listeners=function(S){return[]},b.binding=function(S){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(S){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Q[35],Z([0,1,14,2]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(v){const s=v;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=b;function w(v){const s=v;return s?b(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=w;function F(v,s){return new L(v,s)}t.newWriteableStream=F;class L{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,p.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(v,s){const r=[];let e;for(;(e=v.read())!==null;)r.push(e);return s(r)}t.consumeReadable=h;function f(v,s,r){const e=[];let i;for(;(i=v.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return v.read()}}}t.peekReadable=f;function R(v,s){return new Promise((r,e)=>{const i=[];d(v,{onData:n=>{s&&i.push(n)},onError:n=>{s?e(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}t.consumeStream=R;function d(v,s){v.on("error",r=>s.onError(r)),v.on("end",()=>s.onEnd()),v.on("data",r=>s.onData(r))}t.listenStream=d;function y(v,s){return new Promise((r,e)=>{const i=new C.DisposableStore,n=[],o=E=>{if(n.push(E),n.length>s)return i.dispose(),v.pause(),r({stream:v,buffer:n,ended:!1})},u=E=>e(E),g=()=>r({stream:v,buffer:n,ended:!0});i.add((0,C.toDisposable)(()=>v.removeListener("error",u))),v.on("error",u),i.add((0,C.toDisposable)(()=>v.removeListener("end",g))),v.on("end",g),i.add((0,C.toDisposable)(()=>v.removeListener("data",o))),v.on("data",o)})}t.peekStream=y;function I(v,s){const r=F(s);return r.end(v),r}t.toStream=I;function a(){const v=F(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=a;function m(v){let s=!1;return{read:()=>s?null:(s=!0,v)}}t.toReadable=m;function S(v,s,r){const e=F(r);return d(v,{onData:i=>e.write(s.data(i)),onError:i=>e.error(s.error?s.error(i):i),onEnd:()=>e.end()}),e}t.transform=S;function O(v,s,r){let e=!1;return{read:()=>{const i=s.read();return e?i:(e=!0,i!==null?r([v,i]):v)}}}t.prefixedReadable=O;function T(v,s,r){let e=!1;const i=F(r);return d(s,{onData:n=>e?i.write(n):(e=!0,i.write(r([v,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(v)),i.end()}}),i}t.prefixedStream=T}),define(Q[17],Z([0,1,21,35]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined",w=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let L,h;class f{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return b?new f(Buffer.allocUnsafe(E)):new f(new Uint8Array(E))}static wrap(E){return b&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new f(E)}static fromString(E,k){return!((k==null?void 0:k.dontUseNodeBuffer)||!1)&&b?new f(Buffer.from(E)):w?(L||(L=new TextEncoder),new f(L.encode(E))):new f(p.encodeUTF8(E))}static concat(E,k){if(typeof k=="undefined"){k=0;for(let U=0,x=E.length;U<x;U++)k+=E[U].byteLength}const j=f.alloc(k);let A=0;for(let U=0,x=E.length;U<x;U++){const X=E[U];j.set(X,A),A+=X.byteLength}return j}toString(){return b?this.buffer.toString():F?(h||(h=new TextDecoder),h.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(E,k){return new f(this.buffer.subarray(E,k))}set(E,k){E instanceof f?this.buffer.set(E.buffer,k):this.buffer.set(E,k)}readUInt32BE(E){return y(this.buffer,E)}writeUInt32BE(E,k){I(this.buffer,E,k)}readUInt32LE(E){return a(this.buffer,E)}writeUInt32LE(E,k){m(this.buffer,E,k)}readUInt8(E){return S(this.buffer,E)}writeUInt8(E,k){O(this.buffer,E,k)}}t.VSBuffer=f;function R(g,E){return g[E+0]<<0>>>0|g[E+1]<<8>>>0}t.readUInt16LE=R;function d(g,E,k){g[k+0]=E&255,E=E>>>8,g[k+1]=E&255}t.writeUInt16LE=d;function y(g,E){return g[E]*2**24+g[E+1]*2**16+g[E+2]*2**8+g[E+3]}t.readUInt32BE=y;function I(g,E,k){g[k+3]=E,E=E>>>8,g[k+2]=E,E=E>>>8,g[k+1]=E,E=E>>>8,g[k]=E}t.writeUInt32BE=I;function a(g,E){return g[E+0]<<0>>>0|g[E+1]<<8>>>0|g[E+2]<<16>>>0|g[E+3]<<24>>>0}t.readUInt32LE=a;function m(g,E,k){g[k+0]=E&255,E=E>>>8,g[k+1]=E&255,E=E>>>8,g[k+2]=E&255,E=E>>>8,g[k+3]=E&255}t.writeUInt32LE=m;function S(g,E){return g[E]}t.readUInt8=S;function O(g,E,k){g[k]=E}t.writeUInt8=O;function T(g){return C.consumeReadable(g,E=>f.concat(E))}t.readableToBuffer=T;function v(g){return C.toReadable(g)}t.bufferToReadable=v;function s(g){return C.consumeStream(g,E=>f.concat(E))}t.streamToBuffer=s;async function r(g){return g.ended?f.concat(g.buffer):f.concat([...g.buffer,await s(g.stream)])}t.bufferedStreamToBuffer=r;function e(g){return C.toStream(g,E=>f.concat(E))}t.bufferToStream=e;function i(g){return C.transform(g,{data:E=>typeof E=="string"?f.fromString(E):f.wrap(E)},E=>f.concat(E))}t.streamToBufferReadableStream=i;function n(g){return C.newWriteableStream(E=>f.concat(E),g)}t.newWriteableBufferStream=n;function o(g,E){return C.prefixedReadable(g,E,k=>f.concat(k))}t.prefixedBufferReadable=o;function u(g,E){return C.prefixedStream(g,E,k=>f.concat(k))}t.prefixedBufferStream=u}),define(Q[22],Z([0,1,8]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const m=Array.isArray(a)?[]:{};return Object.keys(a).forEach(S=>{a[S]&&typeof a[S]=="object"?m[S]=C(a[S]):m[S]=a[S]}),m}t.deepClone=C;function b(a){if(!a||typeof a!="object")return a;const m=[a];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const O in S)if(w.call(S,O)){const T=S[O];typeof T=="object"&&!Object.isFrozen(T)&&m.push(T)}}return a}t.deepFreeze=b;const w=Object.prototype.hasOwnProperty;function F(a,m){return L(a,m,new Set)}t.cloneAndChange=F;function L(a,m,S){if((0,p.isUndefinedOrNull)(a))return a;const O=m(a);if(typeof O!="undefined")return O;if((0,p.isArray)(a)){const T=[];for(const v of a)T.push(L(v,m,S));return T}if((0,p.isObject)(a)){if(S.has(a))throw new Error("Cannot clone recursive data-structure");S.add(a);const T={};for(let v in a)w.call(a,v)&&(T[v]=L(a[v],m,S));return S.delete(a),T}return a}function h(a,m,S=!0){return(0,p.isObject)(a)?((0,p.isObject)(m)&&Object.keys(m).forEach(O=>{O in a?S&&((0,p.isObject)(a[O])&&(0,p.isObject)(m[O])?h(a[O],m[O],S):a[O]=m[O]):a[O]=m[O]}),a):m}t.mixin=h;function f(a,m){if(a===m)return!0;if(a==null||m===null||m===void 0||typeof a!=typeof m||typeof a!="object"||Array.isArray(a)!==Array.isArray(m))return!1;let S,O;if(Array.isArray(a)){if(a.length!==m.length)return!1;for(S=0;S<a.length;S++)if(!f(a[S],m[S]))return!1}else{const T=[];for(O in a)T.push(O);T.sort();const v=[];for(O in m)v.push(O);if(v.sort(),!f(T,v))return!1;for(S=0;S<T.length;S++)if(!f(a[T[S]],m[T[S]]))return!1}return!0}t.equals=f;function R(a){const m=new Set;return JSON.stringify(a,(S,O)=>{if((0,p.isObject)(O)||Array.isArray(O)){if(m.has(O))return"[Circular]";m.add(O)}return O})}t.safeStringify=R;function d(a,m,S){const O=m(a);return typeof O=="undefined"?S:O}t.getOrDefault=d;function y(a,m){const S=Object.create(null);return!a||!m||Object.keys(m).forEach(T=>{const v=a[T],s=m[T];f(v,s)||(S[T]=s)}),S}t.distinct=y;function I(a,m){const S=m.toLowerCase(),O=Object.keys(a).find(T=>T.toLowerCase()===S);return O?a[O]:a[m]}t.getCaseInsensitive=I}),define(Q[59],Z([0,1,9]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(f){const R=f;return R&&typeof R.type=="string"&&typeof R.severity=="string"}t.isRemoteConsoleLog=C;function b(f){const R=[];let d;try{const y=JSON.parse(f.arguments),I=y[y.length-1];I&&I.__$stack&&(y.pop(),d=I.__$stack),R.push(...y)}catch(y){R.push("Unable to log remote console arguments",f.arguments)}return{args:R,stack:d}}t.parse=b;function w(f){if(typeof f!="string")return w(b(f).stack);const R=f;if(R){const d=F(R),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(y&&y.length===4)return{uri:p.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}t.getFirstFrame=w;function F(f){if(!f)return f;const R=f.indexOf(`
`);return R===-1?f:f.substring(0,R)}function L(f,R){const{args:d,stack:y}=b(f),I=typeof d[0]=="string"&&d.length===1;let a=F(y);a&&(a=`(${a.trim()})`);let m=[];if(typeof d[0]=="string"?a&&I?m=[`%c[${R}] %c${d[0]} %c${a}`,h("blue"),h(""),h("grey")]:m=[`%c[${R}] %c${d[0]}`,h("blue"),h(""),...d.slice(1)]:m=[`%c[${R}]%`,h("blue"),...d],a&&!I&&m.push(a),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,m)}t.log=L;function h(f){return`color: ${f}`}}),define(Q[60],Z([0,1,17,21,9]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function w(f){return JSON.stringify(f,L)}t.stringify=w;function F(f){let R=JSON.parse(f);return R=h(R),R}t.parse=F;function L(f,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,C.regExpFlags)(R)}:R}function h(f,R=0){if(!f||R>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return b.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof p.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let d=0;d<f.length;++d)f[d]=h(f[d],R+1);else for(const d in f)Object.hasOwnProperty.call(f,d)&&(f[d]=h(f[d],R+1))}return f}t.revive=h}),define(Q[61],Z([0,1,21,36,3,44,4]),function($,t,p,C,b,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const h="**",f="/",R="[/\\\\]",d="[^/\\\\]",y=/\//g;function I(c){switch(c){case 0:return"";case 1:return`${d}*?`;default:return`(?:${R}|${d}+${R}|${R}${d}+)*?`}}function a(c,P){if(!c)return[];const D=[];let N=!1,M=!1,z="";for(const B of c){switch(B){case P:if(!N&&!M){D.push(z),z="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":M=!0;break;case"]":M=!1;break}z+=B}return z&&D.push(z),D}t.splitGlobAware=a;function m(c){if(!c)return"";let P="";const D=a(c,f);if(D.every(N=>N===h))P=".*";else{let N=!1;D.forEach((M,z)=>{if(M===h){N||(P+=I(2),N=!0);return}let B=!1,q="",J=!1,Y="";for(const ie of M){if(ie!=="}"&&B){q+=ie;continue}if(J&&(ie!=="]"||!Y)){let re;ie==="-"?re=ie:(ie==="^"||ie==="!")&&!Y?re="^":ie===f?re="":re=p.escapeRegExpCharacters(ie),Y+=re;continue}switch(ie){case"{":B=!0;continue;case"[":J=!0;continue;case"}":P+=`(?:${a(q,",").map(ge=>m(ge)).join("|")})`,B=!1,q="";break;case"]":P+="["+Y+"]",J=!1,Y="";break;case"?":P+=d;continue;case"*":P+=I(1);continue;default:P+=p.escapeRegExpCharacters(ie)}}z<D.length-1&&(D[z+1]!==h||z+2<D.length)&&(P+=R),N=!1})}return P}const S=/^\*\*\/\*\.[\w\.-]+$/,O=/^\*\*\/([\w\.-]+)\/?$/,T=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(c,P){if(!c)return n;let D;typeof c!="string"?D=c.pattern:D=c,D=D.trim();const N=`${D}_${!!P.trimForExclusions}`;let M=e.get(N);if(M)return u(M,c);let z;if(S.test(D)){const B=D.substr(4);M=function(q,J){return typeof q=="string"&&q.endsWith(B)?D:null}}else(z=O.exec(g(D,P)))?M=E(z[1],D):(P.trimForExclusions?v:T).test(D)?M=k(D,P):(z=s.exec(g(D,P)))?M=j(z[1].substr(1),D,!0):(z=r.exec(g(D,P)))?M=j(z[1],D,!1):M=A(D);return e.set(N,M),u(M,c)}function u(c,P){return typeof P=="string"?c:function(D,N){return C.isEqualOrParent(D,P.base)?c(b.relative(P.base,D),N):null}}function g(c,P){return P.trimForExclusions&&c.endsWith("/**")?c.substr(0,c.length-2):c}function E(c,P){const D=`/${c}`,N=`\\${c}`,M=function(B,q){return typeof B!="string"?null:q?q===c?P:null:B===c||B.endsWith(D)||B.endsWith(N)?P:null},z=[c];return M.basenames=z,M.patterns=[P],M.allBasenames=z,M}function k(c,P){const D=l(c.slice(1,-1).split(",").map(q=>o(q,P)).filter(q=>q!==n),c),N=D.length;if(!N)return n;if(N===1)return D[0];const M=function(q,J){for(let Y=0,ie=D.length;Y<ie;Y++)if(D[Y](q,J))return c;return null},z=D.find(q=>!!q.allBasenames);z&&(M.allBasenames=z.allBasenames);const B=D.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function j(c,P,D){const N=b.sep===b.posix.sep,M=N?c:c.replace(y,b.sep),z=b.sep+M,B=b.posix.sep+c,q=D?function(J,Y){return typeof J=="string"&&(J===M||J.endsWith(z)||!N&&(J===c||J.endsWith(B)))?P:null}:function(J,Y){return typeof J=="string"&&(J===M||!N&&J===c)?P:null};return q.allPaths=[(D?"*/":"./")+c],q}function A(c){try{const P=new RegExp(`^${m(c)}$`);return function(D){return P.lastIndex=0,typeof D=="string"&&P.test(D)?c:null}}catch(P){return n}}function U(c,P,D){return!c||typeof P!="string"?!1:x(c)(P,void 0,D)}t.match=U;function x(c,P={}){if(!c)return i;if(typeof c=="string"||te(c)){const D=o(c,P);if(D===n)return i;const N=function(M,z){return!!D(M,z)};return D.allBasenames&&(N.allBasenames=D.allBasenames),D.allPaths&&(N.allPaths=D.allPaths),N}return G(c,P)}t.parse=x;function X(c){if(!!c){let P;return D=>(P||(P=(c()||Promise.resolve([])).then(N=>N?ee(N):{})),P.then(N=>!!N[D]))}}t.hasSiblingPromiseFn=X;function ne(c){if(!!c){let P;return D=>{if(!P){const N=c();P=N?ee(N):{}}return!!P[D]}}}t.hasSiblingFn=ne;function ee(c){const P={};for(const D of c)P[D]=!0;return P}function te(c){const P=c;return P&&typeof P.base=="string"&&typeof P.pattern=="string"}t.isRelativePattern=te;function ae(c){return c.allBasenames||[]}t.getBasenameTerms=ae;function W(c){return c.allPaths||[]}t.getPathTerms=W;function G(c,P){const D=l(Object.getOwnPropertyNames(c).map(q=>_(q,c[q],P)).filter(q=>q!==n)),N=D.length;if(!N)return n;if(!D.some(q=>!!q.requiresSiblings)){if(N===1)return D[0];const q=function(ie,re){for(let he=0,ge=D.length;he<ge;he++){const Se=D[he](ie,re);if(Se)return Se}return null},J=D.find(ie=>!!ie.allBasenames);J&&(q.allBasenames=J.allBasenames);const Y=D.reduce((ie,re)=>re.allPaths?ie.concat(re.allPaths):ie,[]);return Y.length&&(q.allPaths=Y),q}const M=function(q,J,Y){let ie;for(let re=0,he=D.length;re<he;re++){const ge=D[re];ge.requiresSiblings&&Y&&(J||(J=b.basename(q)),ie||(ie=J.substr(0,J.length-b.extname(q).length)));const Se=ge(q,J,ie,Y);if(Se)return Se}return null},z=D.find(q=>!!q.allBasenames);z&&(M.allBasenames=z.allBasenames);const B=D.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function _(c,P,D){if(P===!1)return n;const N=o(c,D);if(N===n)return n;if(typeof P=="boolean")return N;if(P){const M=P.when;if(typeof M=="string"){const z=(B,q,J,Y)=>{if(!Y||!N(B,q))return null;const ie=M.replace("$(basename)",J),re=Y(ie);return(0,F.isThenable)(re)?re.then(he=>he?c:null):re?c:null};return z.requiresSiblings=!0,z}}return N}function l(c,P){const D=c.filter(q=>!!q.basenames);if(D.length<2)return c;const N=D.reduce((q,J)=>{const Y=J.basenames;return Y?q.concat(Y):q},[]);let M;if(P){M=[];for(let q=0,J=N.length;q<J;q++)M.push(P)}else M=D.reduce((q,J)=>{const Y=J.patterns;return Y?q.concat(Y):q},[]);const z=function(q,J){if(typeof q!="string")return null;if(!J){let ie;for(ie=q.length;ie>0;ie--){const re=q.charCodeAt(ie-1);if(re===47||re===92)break}J=q.substr(ie)}const Y=N.indexOf(J);return Y!==-1?M[Y]:null};z.basenames=N,z.patterns=M,z.allBasenames=N;const B=c.filter(q=>!q.basenames);return B.push(z),B}}),define(Q[62],Z([0,1,9,3,21,10,15,18,36]),function($,t,p,C,b,w,F,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(o,u,g){if(typeof o=="string"&&(o=p.URI.file(o)),g){const k=g.getWorkspaceFolder(o);if(k){const j=g.getWorkspace().folders.length>1;let A;if((0,L.isEqual)(k.uri,o)?A="":A=(0,L.relativePath)(k.uri,o),j){const U=k.name?k.name:(0,L.basename)(k.uri);A=A?U+" \u2022 "+A:U}return A}}if(o.scheme!==w.Schemas.file&&o.scheme!==w.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(o.fsPath))return(0,C.normalize)(d(o.fsPath));let E=(0,C.normalize)(o.fsPath);return!F.isWindows&&(u==null?void 0:u.userHome)&&(E=I(E,u.userHome.fsPath)),E}t.getPathLabel=f;function R(o){if(!!o){typeof o=="string"&&(o=p.URI.file(o));const u=(0,L.basename)(o)||(o.scheme===w.Schemas.file?o.fsPath:o.path);return F.isWindows&&(0,h.isRootOrDriveLetter)(u)?d(u):u}}t.getBaseLabel=R;function d(o){return(0,h.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=d;let y=Object.create(null);function I(o,u){if(F.isWindows||!o||!u)return o;let g=y.original===u?y.normalized:void 0;return g||(g=`${(0,b.rtrim)(u,C.posix.sep)}${C.posix.sep}`,y={original:u,normalized:g}),(F.isLinux?o.startsWith(g):(0,b.startsWithIgnoreCase)(o,g))&&(o=`~/${o.substr(g.length)}`),o}t.tildify=I;function a(o,u){return o.replace(/^~($|\/|\\)/,`${u}$1`)}t.untildify=a;const m="\u2026",S="\\\\",O="~";function T(o,u=C.sep){const g=new Array(o.length);let E=!1;for(let k=0;k<o.length;k++){let j=o[k];if(j===""){g[k]=`.${u}`;continue}if(!j){g[k]=j;continue}E=!0;let A="";j.indexOf(S)===0?(A=j.substr(0,j.indexOf(S)+S.length),j=j.substr(j.indexOf(S)+S.length)):j.indexOf(u)===0?(A=j.substr(0,j.indexOf(u)+u.length),j=j.substr(j.indexOf(u)+u.length)):j.indexOf(O)===0&&(A=j.substr(0,j.indexOf(O)+O.length),j=j.substr(j.indexOf(O)+O.length));const U=j.split(u);for(let x=1;E&&x<=U.length;x++)for(let X=U.length-x;E&&X>=0;X--){E=!1;let ne=U.slice(X,X+x).join(u);for(let ee=0;!E&&ee<o.length;ee++)if(ee!==k&&o[ee]&&o[ee].indexOf(ne)>-1){const te=X+x===U.length,ae=X>0&&o[ee].indexOf(u)>-1?u+ne:ne,W=o[ee].endsWith(ae);E=!te||W}if(!E){let ee="";(U[0].endsWith(":")||A!=="")&&(X===1&&(X=0,x++,ne=U[0]+u+ne),X>0&&(ee=U[0]+u),ee=A+ee),X>0&&(ee=ee+m+u),ee=ee+ne,X+x<U.length&&(ee=ee+u+m),g[k]=ee}}E&&(g[k]=j)}return g}t.shorten=T;var v;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function s(o,u=Object.create(null)){const g=[];let E=!1,k="";for(const j of o)if(j==="$"||E&&j==="{")k&&g.push({value:k,type:v.TEXT}),k="",E=!0;else if(j==="}"&&E){const A=u[k];if(typeof A=="string")A.length&&g.push({value:A,type:v.VARIABLE});else if(A){const U=g[g.length-1];(!U||U.type!==v.SEPARATOR)&&g.push({value:A.label,type:v.SEPARATOR})}k="",E=!1}else k+=j;return k&&!E&&g.push({value:k,type:v.TEXT}),g.filter((j,A)=>{if(j.type===v.SEPARATOR){const U=g[A-1],x=g[A+1];return[U,x].every(X=>X&&(X.type===v.VARIABLE||X.type===v.TEXT)&&X.value.length>0)}return!0}).map(j=>j.value).join("")}t.template=s;function r(o,u){return F.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(o,u){return F.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,""):F.isWindows?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(o){const u=o.indexOf("/")!==-1?C.posix:C.win32,g=u.basename(o),E=u.dirname(o);return g.length?{name:g,parentPath:E}:{name:E,parentPath:""}}t.splitName=n}),define(Q[45],Z([0,1,127]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class C{constructor(w="utf8"){this.stringDecoder=new p.StringDecoder(w),this.remaining=null}write(w){const F=[],L=this.remaining?this.remaining+this.stringDecoder.write(w):this.stringDecoder.write(w);if(L.length<1)return F;let h=0,f,R=h;for(;R<L.length;)if(f=L.charCodeAt(R),f===13||f===10){if(F.push(L.substring(h,R)),R++,R<L.length){const d=f;f=L.charCodeAt(R),(d===13&&f===10||d===10&&f===13)&&R++}h=R}else R++;return this.remaining=h<L.length?L.substr(h):null,F}end(){return this.remaining}}t.LineDecoder=C}),define(Q[63],Z([0,1,16,64,21,3,12]),function($,t,p,C,b,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function L(d){const y=(0,w.dirname)(d);if(d===y)return d;const I=((0,w.basename)(d)||d).toLowerCase();try{const m=(0,F.readdirSync)(y).filter(S=>S.toLowerCase()===I);if(m.length===1){const S=L(y);if(S)return(0,w.join)(S,m[0])}else if(m.length>1){const S=m.indexOf(I);if(S>=0){const O=L(y);if(O)return(0,w.join)(O,m[S])}}}catch(a){}return null}t.realcaseSync=L;async function h(d){try{return await(0,C.promisify)(p.realpath)(d)}catch(y){const I=R(d);return await p.promises.access(I,p.constants.R_OK),I}}t.realpath=h;function f(d){try{return p.realpathSync(d)}catch(y){const I=R(d);return p.accessSync(I,p.constants.R_OK),I}}t.realpathSync=f;function R(d){return(0,b.rtrim)((0,w.normalize)(d),w.sep)}});var ye=this&&this.__await||function($){return this instanceof ye?(this.v=$,this):new ye($)},Ve=this&&this.__asyncGenerator||function($,t,p){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var C=p.apply($,t||[]),b,w=[];return b={},F("next"),F("throw"),F("return"),b[Symbol.asyncIterator]=function(){return this},b;function F(y){C[y]&&(b[y]=function(I){return new Promise(function(a,m){w.push([y,I,a,m])>1||L(y,I)})})}function L(y,I){try{h(C[y](I))}catch(a){d(w[0][3],a)}}function h(y){y.value instanceof ye?Promise.resolve(y.value.v).then(f,R):d(w[0][2],y)}function f(y){L("next",y)}function R(y){L("throw",y)}function d(y,I){y(I),w.shift(),w.length&&L(w[0][0],w[0][1])}},_e=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=$[Symbol.asyncIterator],p;return t?t.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),p={},C("next"),C("throw"),C("return"),p[Symbol.asyncIterator]=function(){return this},p);function C(w){p[w]=$[w]&&function(F){return new Promise(function(L,h){F=$[w](F),b(L,h,F.done,F.value)})}}function b(w,F,L,h){Promise.resolve(h).then(function(f){w({value:f,done:L})},F)}};define(Q[65],Z([0,1,12,32,3]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const w=/^\d+$/,F=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var h;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(h||(h={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class d{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:s=!1}={}){return s?f===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:s=!1,findPreview:r=!1}={}){const e=y({useAlternateBitness:s});if(!e)return null;const i=b.join(e,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(i))return null;let n=-1,o=null;for(const E of await p.readdir(i)){let k=-1;if(r){const A=E.indexOf("-");if(A<0)continue;const U=E.substring(0,A);if(!w.test(U)||E.substring(A+1)!=="preview")continue;k=parseInt(U,10)}else{if(!w.test(E))continue;k=parseInt(E,10)}if(!(k<=n)){const j=b.join(i,E,"pwsh.exe");!await p.SymlinkSupport.existsFile(j)||(o=j,n=k)}}if(!o)return null;const u=e.includes("x86")?" (x86)":"",g=r?" Preview":"";return new d(o,`PowerShell${g}${u}`,!0)}async function a({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const r=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=s?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await p.readdir(r))if(e.test(n)){const o=b.join(r,n,"pwsh.exe");return new d(o,i)}return null}function m(){const s=b.join(C.homedir(),".dotnet","tools","pwsh.exe");return new d(s,".NET Core PowerShell Global Tool")}function S(){const s=b.join(process.env.windir,f===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(s,"Windows PowerShell",!0)}function O(){return Ve(this,arguments,function*(){let r=yield ye(I());r&&(yield yield ye(r)),r=yield ye(I({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(a()),r&&(yield yield ye(r)),r=m(),r&&(yield yield ye(r)),r=yield ye(I({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(a({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(I({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=S(),r&&(yield yield ye(r))})}function T(){return Ve(this,arguments,function*(){var r,e;try{for(var i=_e(O()),n;n=yield ye(i.next()),!n.done;){const o=n.value;(yield ye(o.exists()))&&(yield yield ye(o))}}catch(o){r={error:o}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=T;async function v(){var s,r;try{for(var e=_e(T()),i;i=await e.next(),!i.done;)return i.value}catch(n){s={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(s)throw s.error}}return null}t.getFirstAvailablePowerShellInstallation=v}),define(Q[66],Z([0,1,3,16,15,128,2,12]),function($,t,p,C,b,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(d,y,I){return R({path:d,isDirectory:!1},y,I)}t.watchFile=h;function f(d,y,I){return R({path:d,isDirectory:!0},y,I)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function R(d,y,I){const a=(0,p.basename)(d.path),m=new Map;let S=!1,O=[(0,F.toDisposable)(()=>{m.forEach(T=>(0,F.dispose)(T)),m.clear()})];try{const T=(0,C.watch)(d.path);O.push((0,F.toDisposable)(()=>{T.removeAllListeners(),T.close()}));const v=new Set;d.isDirectory&&(0,L.readdir)(d.path).then(s=>s.forEach(r=>v.add(r))),T.on("error",(s,r)=>{S||I(`Failed to watch ${d.path} for changes using fs.watch() (${s}, ${r})`)}),T.on("change",(s,r)=>{if(!S){let e="";if(r&&(e=r.toString(),b.isMacintosh&&(e=(0,w.normalizeNFC)(e))),!(!e||s!=="change"&&s!=="rename")){const i=d.isDirectory?(0,p.join)(d.path,e):d.path;if(d.isDirectory)if(s==="rename"){const n=m.get(i);n&&(0,F.dispose)(n);const o=setTimeout(async()=>{m.delete(i);const u=await(0,L.exists)(i);if(!S){let g;u?v.has(e)?g="changed":(g="added",v.add(e)):(v.delete(e),g="deleted"),y(g,i)}},t.CHANGE_BUFFER_DELAY);m.set(i,(0,F.toDisposable)(()=>clearTimeout(o)))}else{let n;v.has(e)?n="changed":(n="added",v.add(e)),y(n,i)}else if(s==="rename"||e!==a){const n=setTimeout(async()=>{const o=await(0,L.exists)(i);S||(o?(y("changed",i),O=[R(d,y,I)]):y("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,F.dispose)(O),O=[(0,F.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(T){(0,L.exists)(d.path).then(v=>{v&&!S&&I(`Failed to watch ${d.path} for changes using fs.watch() (${T.toString()})`)})}return(0,F.toDisposable)(()=>{S=!0,O=(0,F.dispose)(O)})}}),define(Q[37],Z([0,1,11,2,4,28,14,17,23,8,60,21]),function($,t,p,C,b,w,F,L,h,f,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function I(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(a=t.ResponseType||(t.ResponseType={}));function m(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(S||(S={}));class O{constructor(l){this.buffer=l,this.pos=0}read(l){const c=this.buffer.slice(this.pos,this.pos+l);return this.pos+=c.byteLength,c}}class T{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(l){this.buffers.push(l)}}var v;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(v||(v={}));function s(_){const l=L.VSBuffer.alloc(4);return l.writeUInt32BE(_,0),l}function r(_){return _.read(4).readUInt32BE(0)}function e(_){const l=L.VSBuffer.alloc(1);return l.writeUInt8(_,0),l}const i={Undefined:e(v.Undefined),String:e(v.String),Buffer:e(v.Buffer),VSBuffer:e(v.VSBuffer),Array:e(v.Array),Object:e(v.Object)},n=typeof Buffer!="undefined";function o(_,l){if(typeof l=="undefined")_.write(i.Undefined);else if(typeof l=="string"){const c=L.VSBuffer.fromString(l);_.write(i.String),_.write(s(c.byteLength)),_.write(c)}else if(n&&Buffer.isBuffer(l)){const c=L.VSBuffer.wrap(l);_.write(i.Buffer),_.write(s(c.byteLength)),_.write(c)}else if(l instanceof L.VSBuffer)_.write(i.VSBuffer),_.write(s(l.byteLength)),_.write(l);else if(Array.isArray(l)){_.write(i.Array),_.write(s(l.length));for(const c of l)o(_,c)}else{const c=L.VSBuffer.fromString(JSON.stringify(l));_.write(i.Object),_.write(s(c.byteLength)),_.write(c)}}function u(_){switch(_.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return _.read(r(_)).toString();case v.Buffer:return _.read(r(_)).buffer;case v.VSBuffer:return _.read(r(_));case v.Array:{const c=r(_),P=[];for(let D=0;D<c;D++)P.push(u(_));return P}case v.Object:return JSON.parse(_.read(r(_)).toString())}}class g{constructor(l,c,P=null,D=1e3){this.protocol=l,this.ctx=c,this.logger=P,this.timeoutDelay=D,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(l,c){this.channels.set(l,c),setTimeout(()=>this.flushPendingRequests(l),0)}sendResponse(l){switch(l.type){case 200:{const c=this.send([l.type]);this.logger&&this.logger.logOutgoing(c,0,1,m(l.type));return}case 201:case 202:case 204:case 203:{const c=this.send([l.type,l.id],l.data);this.logger&&this.logger.logOutgoing(c,l.id,1,m(l.type),l.data);return}}}send(l,c=void 0){const P=new T;return o(P,l),o(P,c),this.sendBuffer(P.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(c){return 0}}onRawMessage(l){const c=new O(l),P=u(c),D=u(c),N=P[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(l.byteLength,P[1],1,`${I(N)}: ${P[2]}.${P[3]}`,D),this.onPromise({type:N,id:P[1],channelName:P[2],name:P[3],arg:D});case 102:return this.logger&&this.logger.logIncoming(l.byteLength,P[1],1,`${I(N)}: ${P[2]}.${P[3]}`,D),this.onEventListen({type:N,id:P[1],channelName:P[2],name:P[3],arg:D});case 101:return this.logger&&this.logger.logIncoming(l.byteLength,P[1],1,`${I(N)}`),this.disposeActiveRequest({type:N,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(l.byteLength,P[1],1,`${I(N)}`),this.disposeActiveRequest({type:N,id:P[1]})}}onPromise(l){const c=this.channels.get(l.channelName);if(!c){this.collectPendingRequest(l);return}const P=new w.CancellationTokenSource;let D;try{D=c.call(this.ctx,l.name,l.arg,P.token)}catch(z){D=Promise.reject(z)}const N=l.id;D.then(z=>{this.sendResponse({id:N,data:z,type:201}),this.activeRequests.delete(l.id)},z=>{z instanceof Error?this.sendResponse({id:N,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:N,data:z,type:203}),this.activeRequests.delete(l.id)});const M=(0,C.toDisposable)(()=>P.cancel());this.activeRequests.set(l.id,M)}onEventListen(l){const c=this.channels.get(l.channelName);if(!c){this.collectPendingRequest(l);return}const P=l.id,N=c.listen(this.ctx,l.name,l.arg)(M=>this.sendResponse({id:P,data:M,type:204}));this.activeRequests.set(l.id,N)}disposeActiveRequest(l){const c=this.activeRequests.get(l.id);c&&(c.dispose(),this.activeRequests.delete(l.id))}collectPendingRequest(l){let c=this.pendingRequests.get(l.channelName);c||(c=[],this.pendingRequests.set(l.channelName,c));const P=setTimeout(()=>{console.error(`Unknown channel: ${l.channelName}`),l.type===100&&this.sendResponse({id:l.id,data:{name:"Unknown channel",message:`Channel name '${l.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);c.push({request:l,timeoutTimer:P})}flushPendingRequests(l){const c=this.pendingRequests.get(l);if(c){for(const P of c)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(l)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var E;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(E=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(l,c=null){this.protocol=l,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=c}getChannel(l){const c=this;return{call(P,D,N){return c.isDisposed?Promise.reject(F.canceled()):c.requestPromise(l,P,D,N)},listen(P,D){return c.isDisposed?Promise.reject(F.canceled()):c.requestEvent(l,P,D)}}}requestPromise(l,c,P,D=w.CancellationToken.None){const N=this.lastRequestId++,z={id:N,type:100,channelName:l,name:c,arg:P};if(D.isCancellationRequested)return Promise.reject(F.canceled());let B;return new Promise((J,Y)=>{if(D.isCancellationRequested)return Y(F.canceled());const ie=()=>{const Se=be=>{switch(be.type){case 201:this.handlers.delete(N),J(be.data);break;case 202:this.handlers.delete(N);const Fe=new Error(be.data.message);Fe.stack=be.data.stack,Fe.name=be.data.name,Y(Fe);break;case 203:this.handlers.delete(N),Y(be.data);break}};this.handlers.set(N,Se),this.sendRequest(z)};let re=null;this.state===S.Idle?ie():(re=(0,b.createCancelablePromise)(Se=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const he=()=>{re?(re.cancel(),re=null):this.sendRequest({id:N,type:101}),Y(F.canceled())},ge=D.onCancellationRequested(he);B=(0,C.combinedDisposable)((0,C.toDisposable)(he),ge),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(l,c,P){const D=this.lastRequestId++,M={id:D,type:102,channelName:l,name:c,arg:P};let z=null;const B=new p.Emitter({onFirstListenerAdd:()=>{z=(0,b.createCancelablePromise)(J=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(B),this.sendRequest(M)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(B),this.sendRequest({id:D,type:103}))}}),q=J=>B.fire(J.data);return this.handlers.set(D,q),B.event}sendRequest(l){switch(l.type){case 100:case 102:{const c=this.send([l.type,l.id,l.channelName,l.name],l.arg);this.logger&&this.logger.logOutgoing(c,l.id,0,`${I(l.type)}: ${l.channelName}.${l.name}`,l.arg);return}case 101:case 103:{const c=this.send([l.type,l.id]);this.logger&&this.logger.logOutgoing(c,l.id,0,I(l.type));return}}}send(l,c=void 0){const P=new T;return o(P,l),o(P,c),this.sendBuffer(P.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(c){return 0}}onBuffer(l){const c=new O(l),P=u(c),D=u(c),N=P[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(l.byteLength,0,0,m(N)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(l.byteLength,P[1],0,m(N),D),this.onResponse({type:P[0],id:P[1],data:D})}}onResponse(l){if(l.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const c=this.handlers.get(l.id);c&&c(l)}whenInitialized(){return this.state===S.Idle?Promise.resolve():p.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}t.ChannelClient=k;class j{constructor(l){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,l(({protocol:c,onDidClientDisconnect:P})=>{p.Event.once(c.onMessage)(N=>{const M=new O(N),z=u(M),B=new g(c,z),q=new k(c);this.channels.forEach((Y,ie)=>B.registerChannel(ie,Y));const J={channelServer:B,channelClient:q,ctx:z};this._connections.add(J),this._onDidAddConnection.fire(J),P(()=>{B.dispose(),q.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const l=[];return this._connections.forEach(c=>l.push(c)),l}getChannel(l,c){const P=this;return{call(D,N,M){let z;if((0,f.isFunction)(c)){let q=(0,h.getRandomElement)(P.connections.filter(c));z=q?Promise.resolve(q):p.Event.toPromise(p.Event.filter(P.onDidAddConnection,c))}else z=c.routeCall(P,D,N);const B=z.then(q=>q.channelClient.getChannel(l));return U(B).call(D,N,M)},listen(D,N){if((0,f.isFunction)(c))return P.getMulticastEvent(l,c,D,N);const M=c.routeEvent(P,D,N).then(z=>z.channelClient.getChannel(l));return U(M).listen(D,N)}}}getMulticastEvent(l,c,P,D){const N=this;let M=new C.DisposableStore;const z=new p.Emitter({onFirstListenerAdd:()=>{M=new C.DisposableStore;const B=new p.EventMultiplexer,q=new Map,J=ie=>{const he=ie.channelClient.getChannel(l).listen(P,D),ge=B.add(he);q.set(ie,ge)},Y=ie=>{const re=q.get(ie);!re||(re.dispose(),q.delete(ie))};N.connections.filter(c).forEach(J),p.Event.filter(N.onDidAddConnection,c)(J,void 0,M),N.onDidRemoveConnection(Y,void 0,M),B.event(z.fire,z,M),M.add(B)},onLastListenerRemove:()=>{M.dispose()}});return z.event}registerChannel(l,c){this.channels.set(l,c),this._connections.forEach(P=>{P.channelServer.registerChannel(l,c)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=j;class A{constructor(l,c,P=null){const D=new T;o(D,c),l.send(D.buffer),this.channelClient=new k(l,P),this.channelServer=new g(l,c,P)}getChannel(l){return this.channelClient.getChannel(l)}registerChannel(l,c){this.channelServer.registerChannel(l,c)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function U(_){return{call(l,c,P){return _.then(D=>D.call(l,c,P))},listen(l,c){const P=new p.Relay;return _.then(D=>P.input=D.listen(l,c)),P.event}}}t.getDelayedChannel=U;function x(_){let l=!1;return{call(c,P,D){return l?_.call(c,P,D):(0,b.timeout)(0).then(()=>l=!0).then(()=>_.call(c,P,D))},listen(c,P){if(l)return _.listen(c,P);const D=new p.Relay;return(0,b.timeout)(0).then(()=>l=!0).then(()=>D.input=_.listen(c,P)),D.event}}}t.getNextTickChannel=x;class X{constructor(l){this.fn=l}routeCall(l){return this.route(l)}routeEvent(l){return this.route(l)}async route(l){for(const c of l.connections)if(await Promise.resolve(this.fn(c.ctx)))return Promise.resolve(c);return await p.Event.toPromise(l.onDidAddConnection),await this.route(l)}}t.StaticRouter=X;var ne;(function(_){function l(D,N){const M=D,z=N&&N.disableMarshalling,B=new Map;for(const q in M)P(q)&&B.set(q,p.Event.buffer(M[q],!0));return new class{listen(q,J){const Y=B.get(J);if(Y)return Y;throw new Error(`Event not found: ${J}`)}call(q,J,Y){const ie=M[J];if(typeof ie=="function"){if(!z&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,R.revive)(Y[re]);return ie.apply(M,Y)}throw new Error(`Method not found: ${J}`)}}}_.fromService=l;function c(D,N){const M=N&&N.disableMarshalling;return new Proxy({},{get(z,B){var q;if(typeof B=="string")return((q=N==null?void 0:N.properties)===null||q===void 0?void 0:q.has(B))?N.properties.get(B):P(B)?D.listen(B):async function(...J){let Y;N&&!(0,f.isUndefinedOrNull)(N.context)?Y=[N.context,...J]:Y=J;const ie=await D.call(B,Y);return M?ie:(0,R.revive)(ie)};throw new Error(`Property not found: ${String(B)}`)}})}_.toService=c;function P(D){return D[0]==="o"&&D[1]==="n"&&d.isUpperAsciiLetter(D.charCodeAt(2))}})(ne=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let l=_.toString();if(l!=="[object Object]")return l}return _}function ae(_){return Array.isArray(_)?_.map(te):te(_)}function W(_,l,c,P,D,N,M){M=ae(M);const z=ee[D],B=z[P%z.length];let q=[`%c[${_}]%c[${String(l).padStart(7," ")}]%c[len: ${String(c).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(N)?(q=q.concat(M),q.push(")")):q.push(M),console.log.apply(console,q)}t.logWithColors=W;class G{constructor(l,c){this._outgoingPrefix=l,this._incomingPrefix=c,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(l,c,P,D,N){this._totalOutgoing+=l,W(this._outgoingPrefix,this._totalOutgoing,l,c,P,D,N)}logIncoming(l,c,P,D,N){this._totalIncoming+=l,W(this._incomingPrefix,this._totalIncoming,l,c,P,D,N)}}t.IPCLogger=G}),define(Q[67],Z([0,1,2,11,4,8]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var L;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(L||(L={}));class h extends p.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var y,I;(y=d.changed)===null||y===void 0||y.forEach((a,m)=>this.accept(m,a)),(I=d.deleted)===null||I===void 0||I.forEach(a=>this.accept(a,void 0))}accept(d,y){if(this.state!==L.Closed){let I=!1;(0,w.isUndefinedOrNull)(y)?I=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),I=!0),I&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const I=this.cache.get(d);return(0,w.isUndefinedOrNull)(I)?y:I}getBoolean(d,y){const I=this.get(d);return(0,w.isUndefinedOrNull)(I)?y:I==="true"}getNumber(d,y){const I=this.get(d);return(0,w.isUndefinedOrNull)(I)?y:parseInt(I,10)}async set(d,y){if(this.state!==L.Closed){if((0,w.isUndefinedOrNull)(y))return this.delete(d);const I=String(y);if(this.cache.get(d)!==I)return this.cache.set(d,I),this.pendingInserts.set(d,I),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==L.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,I)=>this.items.set(I,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=f}),define(Q[68],Z([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,b=C*60,w=b*24,F=w*7,L=w*30,h=w*365;function f(d,y){typeof d!="number"&&(d=d.getTime());const I=Math.round((new Date().getTime()-d)/1e3);if(I<-30)return(0,p.localize)(0,null,f(new Date().getTime()+I*1e3,!1));if(I<30)return(0,p.localize)(1,null);let a;return I<C?(a=I,y?a===1?(0,p.localize)(2,null,a):(0,p.localize)(3,null,a):a===1?(0,p.localize)(4,null,a):(0,p.localize)(5,null,a)):I<b?(a=Math.floor(I/C),y?a===1?(0,p.localize)(6,null,a):(0,p.localize)(7,null,a):a===1?(0,p.localize)(8,null,a):(0,p.localize)(9,null,a)):I<w?(a=Math.floor(I/b),y?a===1?(0,p.localize)(10,null,a):(0,p.localize)(11,null,a):a===1?(0,p.localize)(12,null,a):(0,p.localize)(13,null,a)):I<F?(a=Math.floor(I/w),y?a===1?(0,p.localize)(14,null,a):(0,p.localize)(15,null,a):a===1?(0,p.localize)(16,null,a):(0,p.localize)(17,null,a)):I<L?(a=Math.floor(I/F),y?a===1?(0,p.localize)(18,null,a):(0,p.localize)(19,null,a):a===1?(0,p.localize)(20,null,a):(0,p.localize)(21,null,a)):I<h?(a=Math.floor(I/L),y?a===1?(0,p.localize)(22,null,a):(0,p.localize)(23,null,a):a===1?(0,p.localize)(24,null,a):(0,p.localize)(25,null,a)):(a=Math.floor(I/h),y?a===1?(0,p.localize)(26,null,a):(0,p.localize)(27,null,a):a===1?(0,p.localize)(28,null,a):(0,p.localize)(29,null,a))}t.fromNow=f;function R(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=R}),define(Q[70],Z([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,8,23]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function w(f,R){return R&&(f.stack||f.stacktrace)?p.localize(0,null,L(f),F(f.stack)||F(f.stacktrace)):L(f)}function F(f){return Array.isArray(f)?f.join(`
`):f}function L(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?p.localize(1,null,f.message):f.message||p.localize(2,null)}function h(f=null,R=!1){if(!f)return p.localize(3,null);if(Array.isArray(f)){const d=b.coalesce(f),y=h(d[0],R);return d.length>1?p.localize(4,null,y,d.length):y}if(C.isString(f))return f;if(f.detail){const d=f.detail;if(d.error)return w(d.error,R);if(d.exception)return w(d.exception,R)}return f.stack?w(f,R):f.message?f.message:p.localize(5,null)}t.toErrorMessage=h}),define(Q[71],Z([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Q[46],Z([0,1,3,16,12,33,71,34,8,22,36,15,45,10]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function a(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(r,e){if(d.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=w.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{n.once("error",u=>{o({success:!1,error:u})}),n.once("exit",(u,g)=>{o(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?a(i.status):1})}else if(d.isLinux||d.isMacintosh)try{const i=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{w.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,u,g)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function S(r=L.env){return r.comspec||"cmd.exe"}t.getWindowsShell=S;class O{constructor(e,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=o;else{const u=e;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(L.env).forEach(g=>{u[g]=L.env[g]}),Object.keys(this.options.env).forEach(g=>{u[g]=this.options.env[g]}),this.options.env=u}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(p.sep);return i!==-1&&(e=e.substring(i+1)),O.WellKnowCommands[e]?e:"other"}start(e){return d.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(L.cwd()))?Promise.reject(new Error(F.localize(0,null))):this.useExec().then(i=>{let n,o;const u=new Promise((g,E)=>{n=g,o=E});if(i){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=w.exec(g,this.options,(E,k,j)=>{this.childProcess=null;const A=E;A&&A.killed?o({killed:this.terminateRequested,stdout:k.toString(),stderr:j.toString()}):this.handleExec(n,e,E,k,j)})}else{let g=null;const E=k=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(k,n,e,o);const j={terminated:this.terminateRequested};h.isNumber(k)&&(j.cmdCode=k),n(j)};if(this.shell&&d.isWindows){const k=f.deepClone(this.options);k.windowsVerbatimArguments=!0,k.detached=!1;let j=!1,A=!1;const U=[];let x=this.ensureQuotes(this.cmd);U.push(x.value),j=x.quoted,this.args&&this.args.forEach(ne=>{x=this.ensureQuotes(ne),U.push(x.value),A=A&&x.quoted});const X=["/s","/c"];j?A?X.push('"'+U.join(" ")+'"'):U.length>1?X.push('"'+U[0]+'" '+U.slice(1).join(" ")):X.push('"'+U[0]+'"'):X.push(U.join(" ")),g=w.spawn(S(),X,k)}else this.cmd&&(g=w.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(h.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",k=>{this.childProcess=null,o({terminated:this.terminateRequested,error:k})}),g.pid&&(this.childProcess.on("close",E),this.handleSpawn(g,n,e,o,!0)))}return u})}handleClose(e,i,n,o){}ensureQuotes(e){return O.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,m(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!d.isWindows)return e(!1);const i=w.spawn(S(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=O,O.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},O.regexp=/^[^"].* .*[^"]/;class T extends O{constructor(e,i,n,o){super(e,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,o,u){[o,u].forEach((g,E)=>{const k=new y.LineDecoder;k.write(g).forEach(U=>{i({line:U,source:E===0?0:1})});const A=k.end();A&&i({line:A,source:E===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,o,u){const g=new y.LineDecoder,E=new y.LineDecoder;e.stdout.on("data",k=>{g.write(k).forEach(A=>n({line:A,source:0}))}),e.stderr.on("data",k=>{E.write(k).forEach(A=>n({line:A,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=E}handleClose(e,i,n,o){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&n({line:u,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&n({line:g,source:1})}}t.LineProcess=T;function v(r){let e=[],i=!1;const n=function(o){if(i){e.push(o);return}(!r.send(o,g=>{if(g&&console.error(g),i=!1,e.length>0){const E=e.slice(0);e=[],E.forEach(k=>n(k))}})||d.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=v;var s;(function(r){async function e(i,n,o){if(p.isAbsolute(i))return i;if(n===void 0&&(n=L.cwd()),p.dirname(i)!=="."||(o===void 0&&h.isString(L.env.PATH)&&(o=L.env.PATH.split(p.delimiter)),o===void 0||o.length===0))return p.join(n,i);async function g(E){return await b.exists(E)?!(await C.promises.stat(E)).isDirectory():!1}for(let E of o){let k;if(p.isAbsolute(E)?k=p.join(E,i):k=p.join(n,E,i),await g(k))return k;let j=k+".com";if(await g(j)||(j=k+".exe",await g(j)))return j}return p.join(n,i)}r.findExecutable=e})(s=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,15,65,46]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(I,a){return I===1?C.isWindows?d():w.getWindowsShell(a):f(I,a)}t.getSystemShell=F;function L(I,a){return I===1?C.isWindows?y(a):w.getWindowsShell(a):f(I,a)}t.getSystemShellSync=L;let h=null;function f(I,a){if(C.isLinux&&I===2||C.isMacintosh&&I===3)return"/bin/bash";if(!h){let m;if(C.isWindows)m="/bin/bash";else{if(m=a.SHELL,!m)try{m=(0,p.userInfo)().shell}catch(S){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}h=m}return h}let R=null;async function d(){return R||(R=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),R}function y(I){if(R)return R;const a=C.isWindows&&parseFloat((0,p.release)())>=10,m=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${I.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:w.getWindowsShell(I)}}),define(Q[47],Z([0,1,33,2,4,22,11,46,37,59,28,14,17,15]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends h.ChannelServer{constructor(O){super({send:T=>{try{process.send&&process.send(T.buffer.toString("base64"))}catch(v){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",T=>y.VSBuffer.wrap(Buffer.from(T,"base64")))},O);process.once("disconnect",()=>this.dispose())}}t.Server=a;class m{constructor(O,T){this.modulePath=O,this.options=T,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=T&&T.timeout?T.timeout:6e4;this.disposeDelayer=new b.Delayer(v),this.child=null,this._client=null}getChannel(O){const T=this;return{call(v,s,r){return T.requestPromise(O,v,s,r)},listen(v,s){return T.requestEvent(O,v,s)}}}requestPromise(O,T,v,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(O),e=(0,b.createCancelablePromise)(o=>r.call(T,v,o)),i=s.onCancellationRequested(()=>e.cancel()),n=(0,C.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(O,T,v){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let s;const r=new F.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(O).listen(T,v)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const O=this.options&&this.options.args?this.options.args:[],T=Object.create(null);T.env=Object.assign(Object.assign({},(0,w.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(T.env=Object.assign(Object.assign({},T.env),this.options.env)),this.options&&this.options.freshExecArgv&&(T.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(T.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(T.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),T.execArgv===void 0&&(T.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),I.isMacintosh&&T.env&&delete T.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,O,T);const v=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,f.isRemoteConsoleLog)(u)){(0,f.log)(u,`IPC Library: ${this.options.serverName}`);return}v.fire(y.VSBuffer.wrap(Buffer.from(u,"base64")))});const r=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,e=u=>this.child&&this.child.connected&&r.send(u.buffer.toString("base64")),i=v.event,n={send:e,onMessage:i};this._client=new h.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,g)=>{process.removeListener("exit",o),this.activeRequests.forEach(E=>(0,C.dispose)(E)),this.activeRequests.clear(),u!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:g})})}return this._client}getCachedChannel(O){let T=this.channels.get(O);return T||(T=this.client.getChannel(O),this.channels.set(O,T)),T}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=m}),define(Q[73],Z([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)});var ce=this&&this.__decorate||function($,t,p,C){var b=arguments.length,w=b<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,p):C,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate($,t,p,C);else for(var L=$.length-1;L>=0;L--)(F=$[L])&&(w=(b<3?F(w):b>3?F(t,p,w):F(t,p))||w);return b>3&&w&&Object.defineProperty(t,p,w),w};define(Q[86],Z([0,1,3,18,57,69,10,9,34]),function($,t,p,C,b,w,F,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(a,m,S){this._args=a,this.paths=m,this.productService=S}get appRoot(){return(0,p.dirname)(F.FileAccess.asFileUri("",$).fsPath)}get userHome(){return L.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return L.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return L.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(L.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return L.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return L.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=h.env.VSCODE_PORTABLE;return a?L.URI.file((0,p.join)(a,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,p.resolve)(a):(0,p.normalize)((0,p.join)(F.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,p.resolve)(a):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,p.resolve)(a);const m=h.env.VSCODE_EXTENSIONS;if(m)return m;const S=h.env.VSCODE_PORTABLE;return S?(0,p.join)(S,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(m=>/^[^:/?#]+?:\/\//.test(m)?L.URI.parse(m):L.URI.file((0,p.normalize)(m)))}get extensionDevelopmentKind(){var a;return(a=this.args.extensionDevelopmentKind)===null||a===void 0?void 0:a.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?L.URI.parse(a):L.URI.file((0,p.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!h.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return L.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([b.memoize],f.prototype,"appRoot",null),ce([b.memoize],f.prototype,"userHome",null),ce([b.memoize],f.prototype,"userDataPath",null),ce([b.memoize],f.prototype,"appSettingsHome",null),ce([b.memoize],f.prototype,"tmpDir",null),ce([b.memoize],f.prototype,"userRoamingDataHome",null),ce([b.memoize],f.prototype,"settingsResource",null),ce([b.memoize],f.prototype,"userDataSyncHome",null),ce([b.memoize],f.prototype,"userDataSyncLogResource",null),ce([b.memoize],f.prototype,"sync",null),ce([b.memoize],f.prototype,"machineSettingsResource",null),ce([b.memoize],f.prototype,"globalStorageHome",null),ce([b.memoize],f.prototype,"workspaceStorageHome",null),ce([b.memoize],f.prototype,"keybindingsResource",null),ce([b.memoize],f.prototype,"keyboardLayoutResource",null),ce([b.memoize],f.prototype,"argvResource",null),ce([b.memoize],f.prototype,"snippetsHome",null),ce([b.memoize],f.prototype,"isExtensionDevelopment",null),ce([b.memoize],f.prototype,"untitledWorkspacesHome",null),ce([b.memoize],f.prototype,"installSourcePath",null),ce([b.memoize],f.prototype,"builtinExtensionsPath",null),ce([b.memoize],f.prototype,"extensionsPath",null),ce([b.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ce([b.memoize],f.prototype,"extensionDevelopmentKind",null),ce([b.memoize],f.prototype,"extensionTestsLocationURI",null),ce([b.memoize],f.prototype,"debugExtensionHost",null),ce([b.memoize],f.prototype,"serviceMachineIdResource",null),ce([b.memoize],f.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=f;function R(I,a){return y(I["inspect-extensions"],I["inspect-brk-extensions"],5870,a,I.debugId)}t.parseExtensionHostPort=R;function d(I,a){return y(I["inspect-search"],I["inspect-brk-search"],5876,a)}t.parseSearchPort=d;function y(I,a,m,S,O){const v=Number(a||I)||(S?null:m),s=v?Boolean(!!a):!1;return{port:v,break:s,debugId:O}}}),function(){"use strict";function $(t,p,C,b){function w(L){const h=F(L),f=[h];return t.isAbsolute(h)||f.unshift(b),t.resolve(...f)}function F(L){const h=process.env.VSCODE_PORTABLE;if(h)return t.join(h,"user-data");const f=L["user-data-dir"];if(f)return f;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=t.join(d,"AppData","Roaming")}break;case"darwin":R=t.join(p.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||t.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(R,C)}return{getUserDataPath:w}}if(typeof define=="function")define(Q[87],Z([0,88,32,10,18,34]),function(t,p,C,b,w,F){const L=w.dirname(b.FileAccess.asFileUri("",t)),h=t.__$__nodeRequire(w.joinPath(L,"package.json").fsPath);return $(p,C,h.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),p=require("path"),C=require("os");module.exports=$(p,C,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,32,87,86]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class w extends b.AbstractNativeEnvironmentService{constructor(L,h){super(L,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,C.getUserDataPath)(L)},h)}}t.NativeEnvironmentService=w}),define(Q[90],Z([0,1,22]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const C=/^%([\w\d.-]+)%$/i;function b(w,F){const L=h=>{if(typeof h=="string"){const f=C.exec(h);if(!!f)return F[f[1]]||h}};return(0,p.cloneAndChange)(w,L)}t.localizeManifest=b}),define(Q[48],Z([0,1,80]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function b(d){return d=d.trim(),d==="*"||C.test(d)}t.isValidVersionStr=b;function w(d){if(!b(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(C);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=w;function F(d){if(!d)return null;let y=d.majorBase,I=d.majorMustEqual,a=d.minorBase,m=d.minorMustEqual,S=d.patchBase,O=d.patchMustEqual;return d.hasCaret&&(y===0||(m=!1),O=!1),{majorBase:y,majorMustEqual:I,minorBase:a,minorMustEqual:m,patchBase:S,patchMustEqual:O,isMinimum:d.hasGreaterEquals}}t.normalizeVersion=F;function L(d,y){let I;typeof d=="string"?I=F(w(d)):I=d;let a;if(typeof y=="string"?a=F(w(y)):a=y,!I||!a)return!1;let m=I.majorBase,S=I.minorBase,O=I.patchBase,T=a.majorBase,v=a.minorBase,s=a.patchBase,r=a.majorMustEqual,e=a.minorMustEqual,i=a.patchMustEqual;return a.isMinimum?m>T?!0:m<T?!1:S>v?!0:S<v?!1:O>=s:(m===1&&T===0&&(!r||!e||!i)&&(T=1,v=0,s=0,r=!0,e=!1,i=!1),m<T?!1:m>T?!r:S<v?!1:S>v?!e:O<s?!1:O>s?!i:!0)}t.isValidVersion=L;function h(d,y,I){return y.isBuiltin||typeof y.main=="undefined"?!0:R(d,y.engines.vscode,I)}t.isValidExtensionVersion=h;function f(d,y){return d==="*"||R(y,d)}t.isEngineValid=f;function R(d,y,I=[]){let a=F(w(y));if(!a)return I.push(p.localize(0,null,y)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return I.push(p.localize(1,null,y)),!1}else if(!a.majorMustEqual)return I.push(p.localize(2,null,y)),!1;return L(d,a)?!0:(I.push(p.localize(3,null,d,y)),!1)}t.isVersionValid=R}),define(Q[91],Z([0,1,37,47,2,10]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends b.Disposable{constructor(h,f,R,d){super();this.folders=h,this.onDidFilesChange=f,this.onLogMessage=R,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new C.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(h){this.verboseLogging=h,!this.isDisposed&&this.service&&this.service.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[92],Z([0,1,37,47,2,10]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends b.Disposable{constructor(h,f,R,d,y={}){super();this.folders=h,this.onDidFilesChange=f,this.onLogMessage=R,this.verboseLogging=d,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new C.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(h.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}setVerboseLogging(h){this.verboseLogging=h,this.service&&this.service.setVerboseLogging(h)}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[93],Z([0,1,33,45,61,10]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(h,f,R,d,y){this.watchedFolder=h,this.eventCallback=R,this.logCallback=d,this.verboseLogging=y,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(I=>b.parse(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${h}`),this.startWatcher()}startWatcher(){const h=[this.watchedFolder];this.verboseLogging&&h.push("-verbose"),this.handle=p.spawn(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,h);const f=new C.LineDecoder;this.handle.stdout.on("data",R=>{const d=[];f.write(R).forEach(y=>{const I=y.split("|");if(I.length===2){const a=Number(I[0]),m=I[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(S=>S(m))){this.verboseLogging&&this.log(m);return}d.push({type:F.changeTypeMap[a],path:m})}else this.log(I[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,d)=>this.onExit(R,d))}onError(h){this.error("process error: "+h.toString())}onExit(h,f){this.handle&&(this.error(`terminated unexpectedly (code: ${h}, signal: ${f})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(h){this.logCallback({type:"error",message:`[File Watcher (C#)] ${h}`})}log(h){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${h}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Q[94],Z([0,1,93,3,21]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class w{constructor(L,h,f,R){this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=R,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=w}),define(Q[49],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class p{constructor(w,F=[],L=!1){this.ctor=w,this.staticArguments=F,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=p;const C=(b,...w)=>new p(b,w);t.createSyncDescriptor=C}),define(Q[95],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class p{constructor(w){this.incoming=new Map,this.outgoing=new Map,this.data=w}}t.Node=p;class C{constructor(w){this._hashFn=w,this._nodes=new Map}roots(){const w=[];for(let F of this._nodes.values())F.outgoing.size===0&&w.push(F);return w}insertEdge(w,F){const L=this.lookupOrInsertNode(w),h=this.lookupOrInsertNode(F);L.outgoing.set(this._hashFn(F),h),h.incoming.set(this._hashFn(w),L)}removeNode(w){const F=this._hashFn(w);this._nodes.delete(F);for(let L of this._nodes.values())L.outgoing.delete(F),L.incoming.delete(F)}lookupOrInsertNode(w){const F=this._hashFn(w);let L=this._nodes.get(F);return L||(L=new p(w),this._nodes.set(F,L)),L}lookup(w){return this._nodes.get(this._hashFn(w))}isEmpty(){return this._nodes.size===0}toString(){let w=[];for(let[F,L]of this._nodes)w.push(`${F}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return w.join(`
`)}findCycleSlow(){for(let[w,F]of this._nodes){const L=new Set([w]),h=this._findCycle(F,L);if(h)return h}}_findCycle(w,F){for(let[L,h]of w.outgoing){if(F.has(L))return[...F,L].join(" -> ");F.add(L);const f=this._findCycle(h,F);if(f)return f;F.delete(L)}}}t.Graph=C}),define(Q[96],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Q[19],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,p.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,p.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,7,10]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function w(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=w;var F;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var L;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var h;(function(d){d.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var f;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(y,I){super(y);this.code=I}}t.ExtensionManagementError=R,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=b.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,p.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,p.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,21,7]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=b,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(w=t.ExtensionType||(t.ExtensionType={}));class F{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,d){if(typeof R=="undefined"||R===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof R=="string"||typeof d=="string"){let y=typeof R=="string"?R:R.value,I=typeof d=="string"?d:d.value;return p.equalsIgnoreCase(y,I)}return R._lower===d._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}t.ExtensionIdentifier=F;function L(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=L;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,21,38]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(I,a){return I.uuid&&a.uuid?I.uuid===a.uuid:I.id===a.id?!0:(0,p.compareIgnoreCase)(I.id,a.id)===0}t.areSameExtensions=b;class w{constructor(a,m){this.version=m,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof w?b(this,a)&&this.version===a.version:!1}}t.ExtensionIdentifierWithVersion=w;function F(I,a){return`${I}.${a}`}t.getExtensionId=F;function L(I){return I.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function h(I,a){return L(F(I,a))}t.getGalleryExtensionId=h;function f(I,a){const m=[],S=O=>{for(const T of m)if(T.some(v=>b(a(v),a(O))))return T;return null};for(const O of I){const T=S(O);T?T.push(O):m.push([O])}return m}t.groupByExtension=f;function R(I){return{id:I.identifier.id,name:I.manifest.name,galleryId:null,publisherId:I.publisherId,publisherName:I.manifest.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:I.manifest.extensionDependencies&&I.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=R;function d(I){return Object.assign({id:I.identifier.id,name:I.name,galleryId:I.identifier.uuid,publisherId:I.publisherId,publisherName:I.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:!!(I.properties.dependencies&&I.properties.dependencies.length>0)},I.telemetryData)}t.getGalleryExtensionTelemetryData=d,t.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function y(I){const a=new Set;for(const m of I)m.malicious&&a.add(m.id.id);return a}t.getMaliciousExtensionsSet=y});var ue=this&&this.__param||function($,t){return function(p,C){t(p,C,$)}};define(Q[97],Z([0,1,76,14,9,39,24,25,38,62,28,10]),function($,t,p,C,b,w,F,L,h,f,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const y=T=>(0,p.localize)(0,null,T),I=(0,p.localize)(1,null,"ms-dotnettools.csharp");function a(T,v){return v?`${T.publisher}.${T.name}@${T.version}`:`${T.publisher}.${T.name}`}const m=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(T){const v=m.exec(T);return v&&v[1]?[(0,L.adoptToGalleryExtensionId)(v[1]),v[2]]:[(0,L.adoptToGalleryExtensionId)(T),void 0]}t.getIdAndVersion=S;let O=class{constructor(v,s){this.extensionManagementService=v,this.extensionGalleryService=s}get location(){}async listExtensions(v,s,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=h.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(g=>g.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){r.log("Possible Categories: "),i.forEach(o=>{r.log(o)});return}this.location&&r.log((0,p.localize)(2,null,this.location)),e=e.sort((o,u)=>o.identifier.id.localeCompare(u.identifier.id));let n;for(let o of e)n!==o.identifier.id&&(n=o.identifier.id,r.log(a(o.manifest,v)))}async installExtensions(v,s,r,e,i=console){const n=[],o=[];v.length&&i.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const u=await this.extensionManagementService.getInstalled(1),g=(j,A)=>{const U=u.find(x=>(0,L.areSameExtensions)(x.identifier,{id:j}));if(U){if(!A&&!e)return i.log((0,p.localize)(5,null,j,U.manifest.version,j)),!1;if(A&&U.manifest.version===A)return i.log((0,p.localize)(6,null,`${j}@${A}`)),!1}return!0},E=[],k=[];for(const j of v)if(j instanceof b.URI)E.push(j);else{const[A,U]=S(j);g(A,U)&&k.push({id:A,version:U,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const j of s){const[A,U]=S(j);g(A,U)&&k.push({id:A,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(E.length&&await Promise.all(E.map(async j=>{try{const A=await this.installVSIX(j,{isBuiltin:!1,isMachineScoped:r},e,i);A&&o.push(A)}catch(A){i.error(A.message||A.stack||A),n.push(j.toString())}})),k.length){const j=await this.getGalleryExtensions(k);await Promise.all(k.map(async A=>{const U=j.get(A.id.toLowerCase());if(U)try{const x=await this.installFromGallery(A,U,u,e,i);x&&o.push(x)}catch(x){i.error(x.message||x.stack||x),n.push(A.id)}else i.error(`${y(A.version?`${A.id}@${A.version}`:A.id)}
${I}`),n.push(A.id)}))}if(n.length)throw new Error((0,p.localize)(7,null,n.join(", ")))}async installVSIX(v,s,r,e){const i=await this.extensionManagementService.getManifest(v);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(v,s),e.log((0,p.localize)(8,null,(0,f.getBaseLabel)(v))),i}catch(o){if((0,C.isPromiseCanceledError)(o))return e.log((0,p.localize)(9,null,(0,f.getBaseLabel)(v))),null;throw o}return null}async getGalleryExtensions(v){const s=v.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=v.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,R.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:i},n);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:v,version:s,installOptions:r},e,i,n,o){const u=await this.extensionGalleryService.getManifest(e,R.CancellationToken.None);if(u&&!this.validateExtensionKind(u,o))return null;const g=i.find(E=>(0,L.areSameExtensions)(E.identifier,e.identifier));if(g){if(e.version===g.manifest.version)return o.log((0,p.localize)(10,null,s?`${v}@${s}`:v)),null;o.log((0,p.localize)(11,null,v,e.version))}try{return r.isBuiltin?o.log((0,p.localize)(12,null,v,e.version)):o.log((0,p.localize)(13,null,v,e.version)),await this.extensionManagementService.installFromGallery(e,r),o.log((0,p.localize)(14,null,v,e.version)),u}catch(E){if((0,C.isPromiseCanceledError)(E))return o.log((0,p.localize)(15,null,v)),null;throw E}}validateExtensionKind(v,s){return!0}async validateVSIX(v,s,r){const e={id:(0,L.getGalleryExtensionId)(v.publisher,v.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,L.areSameExtensions)(e,o.identifier)&&(0,w.gt)(o.manifest.version,v.version));return n&&!s?(r.log((0,p.localize)(16,null,n.identifier.id,n.manifest.version,v.version)),!1):this.validateExtensionKind(v,r)}async uninstallExtensions(v,s,r=console){const e=async n=>{if(n instanceof b.URI){const o=await this.extensionManagementService.getManifest(n);return a(o)}return n},i=[];for(const n of v){const o=await e(n),g=(await this.extensionManagementService.getInstalled()).filter(E=>(0,L.areSameExtensions)(E.identifier,{id:o}));if(!g.length)throw new Error(`${this.notInstalled(o)}
${I}`);if(g.some(E=>E.type===0)){r.log((0,p.localize)(17,null,o));return}if(!s&&g.some(E=>E.isBuiltin)){r.log((0,p.localize)(18,null,o));return}r.log((0,p.localize)(19,null,o));for(const E of g)await this.extensionManagementService.uninstall(E),i.push(E);this.location?r.log((0,p.localize)(20,null,o,this.location)):r.log((0,p.localize)(21,null,o))}}async locateExtension(v,s=console){const r=await this.extensionManagementService.getInstalled();v.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===d.Schemas.file){s.log(i.location.fsPath);return}})})}notInstalled(v){return this.location?(0,p.localize)(22,null,v,this.location):(0,p.localize)(23,null,v)}};O=ce([ue(0,F.IExtensionManagementService),ue(1,F.IExtensionGalleryService)],O),t.ExtensionManagementCLIService=O}),define(Q[98],Z([0,1,2,3,38,12]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends p.Disposable{constructor(h,f){super();this.environmentService=h,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,b.MANIFEST_CACHE_FOLDER,b.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(f.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(h){h.error||this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){w.rimraf(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Q[99],Z([0,1,88,33,30,15,129,29,72]),function($,t,p,C,b,w,F,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function f(y,I,a){return I["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,F.isLaunchedFromCli)(a)&&!I["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,F.isLaunchedFromCli)(a)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),R||(R=d(y)),R)}t.resolveShellEnv=f;let R;async function d(y){const I=new Promise(async(a,m)=>{const S=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",S);const O=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",O);const T=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),v=new RegExp(T+"(.*)"+T),s=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});y.trace("getUnixShellEnvironment#env",s);const r=await(0,h.getSystemShell)(w.OS,s);y.trace("getUnixShellEnvironment#shell",r);let e=`'${process.execPath}' -p '"${T}" + JSON.stringify(process.env) + "${T}"'`,i=["-ilc"];const n=p.basename(r);/^pwsh(-preview)?$/.test(n)&&(e=`& ${e}`,i=["-Login","-Command"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(i),e);const o=(0,C.spawn)(r,[...i,e],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});o.on("error",E=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(E)),a({})});const u=[];o.stdout.on("data",E=>u.push(E));const g=[];o.stderr.on("data",E=>g.push(E)),o.on("close",(E,k)=>{const j=Buffer.concat(u).toString("utf8");y.trace("getUnixShellEnvironment#raw",j);const A=Buffer.concat(g).toString("utf8");if(A.trim()&&y.trace("getUnixShellEnvironment#stderr",A),E||k)return m(new Error(`Failed to get environment (code ${E}, signal ${k})`));const U=v.exec(j),x=U?U[1]:"{}";try{const X=JSON.parse(x);S?X.ELECTRON_RUN_AS_NODE=S:delete X.ELECTRON_RUN_AS_NODE,O?X.ELECTRON_NO_ATTACH_CONSOLE=O:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",X),a(X)}catch(X){y.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(X)),m(X)}})});try{return await I}catch(a){return y.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(a)),{}}}}),define(Q[50],Z([0,1,9,20,15]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function w(h){return h.map(f=>({type:f.type,resource:p.URI.file(f.path)}))}t.toFileChanges=w;function F(h){const f=new L;for(const R of h)f.processEvent(R);return f.normalize()}t.normalizeFileChanges=F;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const R=this.mapPathToChange.get(f.path);if(R){const d=R.type,y=f.type;d===1&&y===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(R),1)):d===2&&y===1?R.type=0:d===1&&y===0||(R.type=y)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],R=[];return this.normalized.filter(d=>d.type!==2?(f.push(d),!1):!0).sort((d,y)=>d.path.length-y.path.length).filter(d=>R.some(y=>(0,C.isParent)(d.path,y,!b.isLinux))?!1:(R.push(d.path),!0)).concat(f)}}}),define(Q[100],Z([0,1,50,2,12,63,66,4,3]),function($,t,p,C,b,w,F,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends C.Disposable{constructor(d,y,I,a){super();this.path=d,this.onDidFilesChange=y,this.onLogMessage=I,this.verboseLogging=a,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:y}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(y)try{I=await(0,w.realpath)(I)}catch(a){if(this.onError(a),y.dangling)return}d.isDirectory()?this._register((0,F.watchFolder)(I,(a,m)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,h.join)(this.path,(0,h.basename)(m))})},a=>this.onError(a))):this._register((0,F.watchFile)(I,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,p.normalizeFileChanges)(y);this.verboseLogging&&I.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),I.length>0&&this.onDidFilesChange(I)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(Q[51],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class p{constructor(...b){this._entries=new Map;for(let[w,F]of b)this.set(w,F)}set(b,w){const F=this._entries.get(b);return this._entries.set(b,w),F}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=p}),define(Q[101],Z([0,1,14,95,49,7,51,4]),function($,t,p,C,b,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const h=!1;class f extends Error{constructor(a){var m;super("cyclic dependency between services");this.message=(m=a.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class R{constructor(a=new F.ServiceCollection,m=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=m,this._parent=S,this._services.set(w.IInstantiationService,this)}createChild(a){return new R(a,this._strict,this)}invokeFunction(a,...m){let S=y.traceInvocation(a),O=!1;try{return a({get:(v,s)=>{if(O)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(v,S);if(!r&&s!==w.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...m)}finally{O=!0,S.stop()}}createInstance(a,...m){let S,O;return a instanceof b.SyncDescriptor?(S=y.traceCreation(a.ctor),O=this._createInstance(a.ctor,a.staticArguments.concat(m),S)):(S=y.traceCreation(a),O=this._createInstance(a,m,S)),S.stop(),O}_createInstance(a,m=[],S){let O=w._util.getServiceDependencies(a).sort((s,r)=>s.index-r.index),T=[];for(const s of O){let r=this._getOrCreateServiceInstance(s.id,S);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${s.id}.`);T.push(r)}let v=O.length>0?O[0].index:m.length;if(m.length!==v){console.warn(`[createInstance] First service dependency of ${a.name} at position ${v+1} conflicts with ${m.length} static arguments`);let s=v-m.length;s>0?m=m.concat(new Array(s)):m=m.slice(0,v)}return new a(...[...m,...T])}_setServiceInstance(a,m){if(this._services.get(a)instanceof b.SyncDescriptor)this._services.set(a,m);else if(this._parent)this._parent._setServiceInstance(a,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let m=this._services.get(a);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):m}_getOrCreateServiceInstance(a,m){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,m.branch(a,!0)):(m.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,m,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,m,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,m,S){const O=new C.Graph(s=>s.id.toString());let T=0;const v=[{id:a,desc:m,_trace:S}];for(;v.length;){const s=v.pop();if(O.lookupOrInsertNode(s),T++>1e3)throw new f(O);for(let r of w._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const i={id:r.id,desc:e,_trace:s._trace.branch(r.id,!0)};O.insertEdge(s,i),v.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new f(O);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof b.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}O.removeNode(r)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,m,S=[],O,T){if(this._services.get(a)instanceof b.SyncDescriptor)return this._createServiceInstance(m,S,O,T);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,m,S,O,T);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(a,m=[],S,O){if(S){const T=new L.IdleValue(()=>this._createInstance(a,m,O));return new Proxy(Object.create(null),{get(v,s){if(s in v)return v[s];let r=T.value,e=r[s];return typeof e!="function"||(e=e.bind(r),v[s]=e),e},set(v,s,r){return T.value[s]=r,!0}})}else return this._createInstance(a,m,O)}}t.InstantiationService=R;var d;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(d||(d={}));class y{constructor(a,m){this.type=a,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return h?new y(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(a){return h?new y(0,a.name):y._None}branch(a,m){let S=new y(2,a.toString());return this._dep.push([a,m,S]),S}stop(){let a=Date.now()-this._start;y._totals+=a;let m=!1;function S(T,v){let s=[],r=new Array(T+1).join("	");for(const[e,i,n]of v._dep)if(i&&n){m=!0,s.push(`${r}CREATES -> ${e}`);let o=S(T+1,n);o&&s.push(o)}else s.push(`${r}uses -> ${e}`);return s.join(`
`)}let O=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(a>2||m)&&console.log(O.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Q[52],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,p.createDecorator)("localizationsService");function C(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const w of b.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=C}),define(Q[13],Z([0,1,7,2,15,11,29]),function($,t,p,C,b,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,p.createDecorator)("logService"),t.ILoggerService=(0,p.createDecorator)("loggerService");function L(){return new Date().toISOString()}var h;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(h=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=h.Info;class f extends C.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new w.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class R extends f{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(h.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(h.Error,this.format(n))}else this.log(h.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let o=e[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}i+=(n>0?" ":"")+o}return i}}t.AbstractMessageLogger=R;class d extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!b.isWindows}trace(e,...i){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=d;class y extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=y;class I extends f{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,F.toErrorMessage)(e,this.getLevel()<=h.Trace)}dispose(){}flush(){}}t.AdapterLogger=I;class a extends f{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class m extends C.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=m;class S extends C.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?h.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=S;class O{constructor(){this.onDidChangeLogLevel=new w.Emitter().event}setLevel(e){}getLevel(){return h.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=O;function T(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const e=v(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=T;function v(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}t.parseLogLevel=v;function s(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}t.LogLevelToString=s}),define(Q[102],Z([0,1,16,2,20,24,19,9,18,25,13,30,39,15,4,14]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let O=class extends C.Disposable{constructor(v,s,r,e){super();this.fileService=s,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=L.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,s){await this.cleanUpPromise;const r=this.getName(v),e=(0,h.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,h.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(v,i,s);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,m.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(v){}async rename(v,s,r){try{await p.promises.rename(v.fsPath,s.fsPath)}catch(e){if(I.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${v} to ${s} with 'EPERM' error. Trying again...`),this.rename(v,s,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const s=[],r=[];for(const n of v.children){const o=this.parse(n.name);o&&r.push([o,n])}const e=(0,f.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((o,u)=>y.rcompare(o[0].version,u[0].version)),s.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new f.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,d.generateUuid)()}parse(v){const s=S.exec(v);return s&&s[1]&&s[2]?new f.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};O=ce([ue(0,F.INativeEnvironmentService),ue(1,b.IFileService),ue(2,w.IExtensionGalleryService),ue(3,R.ILogService)],O),t.ExtensionsDownloader=O}),define(Q[103],Z([0,1,2,13,33,29,3,4,11,10,12,19]),function($,t,p,C,b,w,F,L,h,f,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let y=class extends p.Disposable{constructor(a,m){super();this.environmentService=a,this.logService=m,this.processesLimiter=new L.Limiter(5)}async postUninstall(a){const m=this.parseScript(a,"uninstall");return m&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${S}`)))),(0,R.rimraf)(this.getExtensionStoragePath(a)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(a,m){const S=`vscode:${m}`;if(a.location.scheme===f.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[S]=="string"){const O=a.manifest.scripts[S].split(" ");return O.length<2||O[0]!=="node"||!O[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${S} should be a node script`),null):{script:(0,F.join)(a.location.fsPath,O[1]),args:O.slice(2)||[]}}return null}runLifecycleHook(a,m,S,O,T){return new Promise((v,s)=>{const r=this.start(a,m,S,T);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?s(n):v(void 0)};r.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,o)=>{i(n?`post-${m} process exited with code ${n}`:void 0)}),O&&(e=setTimeout(()=>{e=null,r.kill(),s("timed out")},5e3))})}start(a,m,S,O){const T={silent:!0,execArgv:void 0},v=(0,b.fork)(a,[`--type=extension-post-${m}`,...S],T);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const s=h.Event.fromNodeEventEmitter(v.stdout,"data"),r=h.Event.fromNodeEventEmitter(v.stderr,"data");s(n=>this.logService.info(O.identifier.id,O.manifest.version,`post-${m}`,n)),r(n=>this.logService.error(O.identifier.id,O.manifest.version,`post-${m}`,n));const e=h.Event.any(h.Event.map(s,n=>({data:`%c${n}`,format:[""]})),h.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return h.Event.debounce(e,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(O.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(a){return(0,F.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};y=ce([ue(0,d.IEnvironmentService),ue(1,C.ILogService)],y),t.ExtensionsLifecycle=y}),define(Q[104],Z([0,1,2,19,11,20,9,25,18,13]),function($,t,p,C,b,w,F,L,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let R=class extends p.Disposable{constructor(y,I,a,m){super();this.extensionsManagementService=y,this.logService=m,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(T=>{this.installedExtensions=T.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(T=>this.onInstallExtension(T))),this._register(y.onDidInstallExtension(T=>this.onDidInstallExtension(T))),this._register(y.onDidUninstallExtension(T=>this.onDidUninstallExtension(T)));const S=F.URI.file(a.extensionsPath),O=new h.ExtUri(T=>!I.hasCapability(T,1024));this._register(I.watch(S)),this._register(b.Event.filter(I.onDidFilesChange,T=>T.changes.some(v=>this.doesChangeAffects(v,S,O)))(()=>this.onDidChange()))}doesChangeAffects(y,I,a){return a.isEqual(a.dirname(y.resource),I)?a.isEqual(y.resource,a.joinPath(I,".obsolete"))?!0:!(y.type!==1&&y.type!==2||a.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(I=>!(0,L.areSameExtensions)(I,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,L.areSameExtensions)(I,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),I=y.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,L.areSameExtensions)(S,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),a=this.installedExtensions.filter(m=>this.installingExtensions.some(S=>(0,L.areSameExtensions)(S,m))?!1:y.every(S=>!(0,L.areSameExtensions)(S.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=y.map(m=>m.identifier),(I.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:a})}}};R=ce([ue(1,w.IFileService),ue(2,C.INativeEnvironmentService),ue(3,f.ILogService)],R),t.ExtensionsWatcher=R}),define(Q[105],Z([0,1,12,16,130,24,2,19,4,25,13,52,23,11,10,3]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let S=class extends F.Disposable{constructor(v,s,r){super();this.extensionManagementService=v,this.logService=r,this._onDidLanguagesChange=this._register(new I.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new O(s,r)),this._register(v.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(v.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(v=>{const s=["en",...Object.keys(v)];return(0,y.distinct)(s)})}onDidInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",v.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(v){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(e=>(0,f.areSameExtensions)(e.extensionIdentifier,v)))&&(this.logService.debug("Removing language packs from the extension",v.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[v,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,y.equals)(Object.keys(v),Object.keys(r))}};S=ce([ue(0,w.IExtensionManagementService),ue(1,L.INativeEnvironmentService),ue(2,R.ILogService)],S),t.LocalizationsService=S;let O=class extends F.Disposable{constructor(v,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,m.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new h.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,r);Object.keys(v).forEach(r=>this.updateHash(v[r]))}createLanguagePacksFromExtension(v,s){const r=s.identifier,e=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of e)if(s.location.scheme===a.Schemas.file&&(0,d.isValidLocalization)(i)){let n=v[i.languageId];n||(n={hash:"",extensions:[],translations:{}},v[i.languageId]=n);let o=n.extensions.filter(u=>(0,f.areSameExtensions)(u.extensionIdentifier,r))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const u of i.translations)n.translations[u.id]=(0,m.join)(s.location.fsPath,u.path)}}updateHash(v){if(v){const s=(0,b.createHash)("md5");for(const r of v.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);v.hash=s.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return C.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(e){return{}}}).then(r=>(s=v(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,p.writeFile)(this.languagePacksFilePath,e)}).then(()=>s,r=>this.logService.error(r))})}};O=ce([ue(0,L.INativeEnvironmentService),ue(1,R.ILogService)],O)}),define(Q[106],Z([0,1,13,20]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(h,f,R,d){try{const y=await new Promise((I,a)=>{$(["spdlog"],I,a)});return y.setAsyncMode(8192,500),y.createRotatingLoggerAsync(h,f,R,d)}catch(y){console.error(y)}return null}function w(h,f,R,d){return $.__$__nodeRequire("spdlog").createRotatingLogger(h,f,R,d)}t.createRotatingLogger=w;function F(h,f,R){switch(f){case p.LogLevel.Trace:h.trace(R);break;case p.LogLevel.Debug:h.debug(R);break;case p.LogLevel.Info:h.info(R);break;case p.LogLevel.Warning:h.warn(R);break;case p.LogLevel.Error:h.error(R);break;case p.LogLevel.Critical:h.critical(R);break;default:throw new Error("Invalid log level")}}class L extends p.AbstractMessageLogger{constructor(f,R,d,y){super();this.name=f,this.filepath=R,this.rotating=d,this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}_createSpdLogLogger(){const f=this.rotating?6:1,R=30/f*C.ByteSize.MB;return b(this.name,this.filepath,R,f).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:y,message:I}of this.buffer)F(this._logger,y,I);this.buffer=[]}})}log(f,R){this._logger?F(this._logger,f,R):this.getLevel()<=f&&this.buffer.push({level:f,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Q[53],Z([0,1,82,17,20,14,40]),function($,t,p,C,b,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(d,y,I,a,m,S){let O;try{await h(d,y,I,a,m,S)}catch(T){O=T}finally{O&&m.errorTransformer&&(O=m.errorTransformer(O)),typeof O!="undefined"&&I.error(O),I.end()}}t.readFileIntoStream=L;async function h(d,y,I,a,m,S){f(S);const O=await d.open(y,{create:!1});try{f(S);let T=0,v=0,s=m&&typeof m.length=="number"?m.length:void 0,r=C.VSBuffer.alloc(Math.min(m.bufferSize,typeof s=="number"?s:m.bufferSize)),e=m&&typeof m.position=="number"?m.position:0,i=0;do v=await d.read(O,e,r.buffer,i,r.byteLength-i),e+=v,i+=v,T+=v,typeof s=="number"&&(s-=v),i===r.byteLength&&(await I.write(a(r)),r=C.VSBuffer.alloc(Math.min(m.bufferSize,typeof s=="number"?s:m.bufferSize)),i=0);while(v>0&&(typeof s!="number"||s>0)&&f(S)&&R(T,m));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),I.write(a(r.slice(0,n)))}}catch(T){throw(0,b.ensureFileSystemProviderError)(T)}finally{await d.close(O)}}function f(d){if(d.isCancellationRequested)throw(0,w.canceled)();return!0}function R(d,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&d>y.limits.memory)throw(0,b.createFileSystemProviderError)((0,p.localize)(0,null,F.default.nameShort),b.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&d>y.limits.size)throw(0,b.createFileSystemProviderError)((0,p.localize)(1,null),b.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,81,131,2,20,11,18,44,23,13,17,35,4,28,10,53,132]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m,S,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let T=class extends b.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const e=new b.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,b.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){r.push(e)}}),!this.provider.has(s)&&await I.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return O.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,L.isAbsolutePath)(s))throw new w.FileOperationError((0,p.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,p.localize)(1,null,s.toString()),e}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(e){throw(0,w.toFileSystemProviderErrorCode)(e)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,p.localize)(2,null,this.resourceForError(s)),1):(0,w.ensureFileSystemProviderError)(e)}}async doResolveFile(s,r){const e=await this.withProvider(s),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,o=r==null?void 0:r.resolveSingleChildDescendants,u=r==null?void 0:r.resolveMetadata,g=await e.stat(s);let E;return this.toFileStat(e,s,g,void 0,!!u,(k,j)=>(E||(E=h.TernarySearchTree.forUris(()=>!i),E.set(s,!0),(0,f.isNonEmptyArray)(n)&&n.forEach(A=>E.set(A,!0))),Boolean(E.findSuperstr(k.resource)||E.get(k.resource))?!0:k.isDirectory&&o?j===1:!1))}async toFileStat(s,r,e,i,n,o){const{providerExtUri:u}=this.getExtUri(s),g={resource:r,name:u.basename(r),isFile:(e.type&w.FileType.File)!=0,isDirectory:(e.type&w.FileType.Directory)!=0,isSymbolicLink:(e.type&w.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,w.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&o(g,i)){try{const E=await s.readdir(r),k=await I.Promises.settled(E.map(async([j,A])=>{try{const U=u.joinPath(r,j),x=n?await s.stat(U):{type:A};return await this.toFileStat(s,U,x,E.length,n,o)}catch(U){return this.logService.trace(U),null}}));g.children=(0,f.coalesce)(k)}catch(E){this.logService.trace(E),g.children=[]}return g}return g}async resolveAll(s){return I.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(e){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(e){return e}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new w.FileOperationError((0,p.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=d.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,i)),i}async writeFile(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,e)||await this.mkdirp(i,n.dirname(s));let u;if((0,w.hasReadWriteCapability)(i)&&!(r instanceof d.VSBuffer))if((0,y.isReadableStream)(r)){const g=await(0,y.peekStream)(r,3);g.ended?u=d.VSBuffer.concat(g.buffer):u=g}else u=(0,y.peekReadable)(r,g=>d.VSBuffer.concat(g),3);else u=r;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&u instanceof d.VSBuffer?await this.doWriteUnbuffered(i,s,e,u):await this.doWriteBuffered(i,s,e,u instanceof d.VSBuffer?(0,d.bufferToReadable)(u):u)}catch(o){throw new w.FileOperationError((0,p.localize)(4,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,e){if(!!(e==null?void 0:e.unlock)&&!(s.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(o){return}if((n.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,w.etag)({mtime:e.mtime,size:n.size}))throw new w.FileOperationError((0,p.localize)(7,null),3,e);return n}async readFile(s,r){const e=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,s,r):this.doReadFile(e,s,r)}async doReadFileAtomic(s,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,r,e);i(o)}catch(o){n(o)}})})}async doReadFile(s,r,e){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,d.streamToBuffer)(i.value)})}async readFileStream(s,r){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,r)}async doReadFileStream(s,r,e){const i=new a.CancellationTokenSource,n=this.validateReadFile(r,e).then(u=>u,u=>{throw i.cancel(),u});let o;try{e&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&await n,!((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasFileReadStreamCapability)(s))||(0,w.hasReadWriteCapability)(s)&&(e==null?void 0:e.preferUnbuffered)?o=this.readFileUnbuffered(s,r,e):(0,w.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,r,i.token,e):o=this.readFileBuffered(s,r,i.token,e);const u=await n;return Object.assign(Object.assign({},u),{value:o})}catch(u){throw o&&await(0,y.consumeStream)(o),new w.FileOperationError((0,p.localize)(8,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(u).toString()),(0,w.toFileOperationResult)(u),e)}}readFileStreamed(s,r,e,i=Object.create(null)){const n=s.readFileStream(r,i,e);return(0,y.transform)(n,{data:o=>o instanceof d.VSBuffer?o:d.VSBuffer.wrap(o),error:o=>new w.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),i)},o=>d.VSBuffer.concat(o))}readFileBuffered(s,r,e,i=Object.create(null)){const n=(0,d.newWriteableBufferStream)();return(0,S.readFileIntoStream)(s,r,n,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new w.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),i)}),e),n}readFileUnbuffered(s,r,e){const i=(0,y.newWriteableStream)(n=>d.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(d.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new w.FileOperationError((0,p.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===e.etag)throw new w.FileOperationError((0,p.localize)(12,null),2,r);return this.validateReadFileLimits(s,e.size,r),e}validateReadFileLimits(s,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,p.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,e){return this.doCanMoveCopy(s,r,"move",e)}async canCopy(s,r,e){return this.doCanMoveCopy(s,r,"copy",e)}async doCanMoveCopy(s,r,e,i){if(s.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,o,r,e,i)}catch(n){return n}return!0}async move(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"move",!!e),u=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,r,e){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"copy",!!e),u=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,r,e,i,n,o){if(r.toString()===i.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(s,r,e,i,n,o);if(u&&!g&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(s===e&&(0,w.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:o});else{const E=await this.resolve(r);E.isDirectory?await this.doCopyFolder(s,E,e,i):await this.doCopyFile(s,r,e,i)}return n}else return s===e?(await s.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(s,r,e,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,e,i){if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,r,e,i);if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,r,e,i);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,r,e,i);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,r,e,i)}async doCopyFolder(s,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await I.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),e,o):this.doCopyFile(s,n.resource,e,o)}))}async doValidateMoveCopy(s,r,e,i,n,o){let u=!1;if(s===e){const{providerExtUri:E,isPathCaseSensitive:k}=this.getExtUri(s);if(k||(u=E.isEqual(r,i)),u&&n==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!u&&E.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const g=await this.exists(i);if(g&&!u){if(!o)throw new w.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===e){const{providerExtUri:E}=this.getExtUri(s);if(E.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,e)),e}async mkdirp(s,r){const e=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&w.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await s.mkdir(r)}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(e){return e}return!0}async doValidateDelete(s,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new w.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(s)))}return e}async del(s,r){const e=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(s,r).then(n=>{e?(0,b.dispose)(n):i=()=>(0,b.dispose)(n)},n=>this.logService.error(n)),(0,b.toDisposable)(()=>i())}async doWatch(s,r){const e=await this.withProvider(s),i=this.toWatchKey(e,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,b.toDisposable)(()=>{n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,e){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,b.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const o=await s.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,o,i):await this.doWriteReadableBufferedQueued(s,o,i)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await s.close(o)}})}async doWriteStreamBufferedQueued(s,r,e){let i=0,n;if((0,y.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=d.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,r,o,o.byteLength,i,0),i+=o.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(o,u)=>{(0,y.listenStream)(n,{onData:async g=>{n.pause();try{await this.doWriteBuffer(s,r,g,g.byteLength,i,0)}catch(E){return u(E)}i+=g.byteLength,setTimeout(()=>n.resume())},onError:g=>u(g),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,e,i,n,o){let u=0;for(;u<i;)u+=await s.write(r,n+u,e.buffer,o+u,i-u)}async doWriteUnbuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,e,i))}async doWriteUnbufferedQueued(s,r,e,i){var n;let o;i instanceof d.VSBuffer?o=i:(0,y.isReadableStream)(i)?o=await(0,d.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?o=await(0,d.bufferedStreamToBuffer)(i):o=(0,d.readableToBuffer)(i),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,e,i))}async doPipeBufferedQueued(s,r,e,i){let n,o;try{n=await s.open(r,{create:!1}),o=await e.open(i,{create:!0,unlock:!1});const u=d.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,E=0,k=0;do k=await s.read(n,g,u.buffer,E,u.byteLength-E),await this.doWriteBuffer(e,o,u,k,g,E),g+=k,E+=k,E===u.byteLength&&(E=0);while(k>0)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await I.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,e,i))}async doPipeUnbufferedQueued(s,r,e,i){return e.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,e,i))}async doPipeUnbufferedToBufferedQueued(s,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(r);await this.doWriteBuffer(e,n,d.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(s,r,e,i){const n=await(0,d.streamToBuffer)(this.readFileBuffered(s,r,a.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new w.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===m.Schemas.file?s.fsPath:s.toString(!0)}};T=ce([ue(0,R.ILogService)],T),t.FileService=T}),define(Q[108],Z([0,1,16,64,2,20,11,15,12,3,18,36,4,13,83,50,92,94,91,100,35,53,23,17]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m,S,O,T,v,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class n extends b.Disposable{constructor(u,g){var E;super();this.logService=u,this.options=g,this.BUFFER_SIZE=((E=this.options)===null||E===void 0?void 0:E.bufferSize)||64*1024,this.onDidChangeCapabilities=F.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new F.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new F.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:g,symbolicLink:E}=await h.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(g,E),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(u){try{const g=await(0,h.readdir)(this.toFilePath(u),{withFileTypes:!0}),E=[];return await Promise.all(g.map(async k=>{try{let j;k.isSymbolicLink()?j=(await this.stat((0,R.joinPath)(u,k.name))).type:j=this.toType(k),E.push([k.name,j])}catch(j){this.logService.trace(j)}})),E}catch(g){throw this.toFileSystemProviderError(g)}}toType(u,g){let E;return(g==null?void 0:g.dangling)?E=w.FileType.Unknown:u.isFile()?E=w.FileType.File:u.isDirectory()?E=w.FileType.Directory:E=w.FileType.Unknown,g&&(E|=w.FileType.SymbolicLink),E}async readFile(u){try{const g=this.toFilePath(u);return await p.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(u,g,E){const k=(0,s.newWriteableStream)(j=>i.VSBuffer.concat(j.map(A=>i.VSBuffer.wrap(A))).buffer);return(0,r.readFileIntoStream)(this,u,k,j=>j.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),E),k}async writeFile(u,g,E){let k;try{const j=this.toFilePath(u);if(!E.create||!E.overwrite){if(await(0,h.exists)(j)){if(!E.overwrite)throw(0,w.createFileSystemProviderError)((0,a.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,w.createFileSystemProviderError)((0,a.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(u,{create:!0,unlock:E.unlock}),await this.write(k,0,g,0,g.byteLength)}catch(j){throw await this.toFileSystemProviderWriteError(u,j)}finally{typeof k=="number"&&await this.close(k)}}async open(u,g){try{const E=this.toFilePath(u);if((0,w.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:A}=await h.SymlinkSupport.stat(E);A.mode&128||await p.promises.chmod(E,A.mode|128)}catch(A){this.logService.trace(A)}let k;if((0,w.isFileOpenForWriteOptions)(g)){if(L.isWindows)try{await p.promises.truncate(E,0),k="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}k||(k="w")}else k="r";const j=await(0,C.promisify)(p.open)(E,k);return this.mapHandleToPos.set(j,0),(0,w.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(j,u),j}catch(E){throw(0,w.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(u,E):this.toFileSystemProviderError(E)}}async close(u){try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&this.canFlush)try{await(0,C.promisify)(p.fdatasync)(u)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,C.promisify)(p.close)(u)}catch(g){throw this.toFileSystemProviderError(g)}}async read(u,g,E,k,j){const A=this.normalizePos(u,g);let U=null;try{const x=await(0,C.promisify)(p.read)(u,E,k,j,A);return typeof x=="number"?U=x:U=x.bytesRead,U}catch(x){throw this.toFileSystemProviderError(x)}finally{this.updatePos(u,A,U)}}normalizePos(u,g){return g===this.mapHandleToPos.get(u)?null:g}updatePos(u,g,E){const k=this.mapHandleToPos.get(u);typeof k=="number"&&(typeof g=="number"||(typeof E=="number"?this.mapHandleToPos.set(u,k+E):this.mapHandleToPos.delete(u)))}async write(u,g,E,k,j){return(0,y.retry)(()=>this.doWrite(u,g,E,k,j),100,3)}async doWrite(u,g,E,k,j){const A=this.normalizePos(u,g);let U=null;try{const x=await(0,C.promisify)(p.write)(u,E,k,j,A);return typeof x=="number"?U=x:U=x.bytesWritten,U}catch(x){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),x)}finally{this.updatePos(u,A,U)}}async mkdir(u){try{await p.promises.mkdir(this.toFilePath(u))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(u,g){try{const E=this.toFilePath(u);await this.doDelete(E,g)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(u,g){g.recursive?await(0,h.rimraf)(u,h.RimRafMode.MOVE):await p.promises.unlink(u)}async rename(u,g,E){const k=this.toFilePath(u),j=this.toFilePath(g);if(k!==j)try{await this.validateTargetDeleted(u,g,"move",E.overwrite),await(0,h.move)(k,j)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,a.localize)(2,null,(0,f.basename)(k),(0,f.basename)((0,f.dirname)(j)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(u,g,E){const k=this.toFilePath(u),j=this.toFilePath(g);if(k!==j)try{await this.validateTargetDeleted(u,g,"copy",E.overwrite),await(0,h.copy)(k,j,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,a.localize)(3,null,(0,f.basename)(k),(0,f.basename)((0,f.dirname)(j)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(u,g,E,k){const j=this.toFilePath(u),A=this.toFilePath(g);let U=!1;if(!!(this.capabilities&1024)||(U=(0,d.isEqual)(j,A,!0)),U&&E==="copy")throw(0,w.createFileSystemProviderError)((0,a.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!U&&await(0,h.exists)(A)){if(!k)throw(0,w.createFileSystemProviderError)((0,a.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(u,g){return g.recursive?this.watchRecursive(u,g.excludes):this.watchNonRecursive(u)}watchRecursive(u,g){const E={path:this.toFilePath(u),excludes:g},k=(0,e.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,b.toDisposable)(()=>{k(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var u,g,E;if(this.recursiveWatcher instanceof T.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let k,j;((g=(u=this.options)===null||u===void 0?void 0:u.watcher)===null||g===void 0?void 0:g.usePolling)?(k=S.FileWatcher,j=(E=this.options)===null||E===void 0?void 0:E.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?k=O.FileWatcher:k=S.FileWatcher:k=T.FileWatcher,this.recursiveWatcher=new k(this.recursiveFoldersToWatch,A=>this._onDidChangeFile.fire((0,m.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===I.LogLevel.Trace,j),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(u){const g=new v.FileWatcher(this.toFilePath(u),k=>this._onDidChangeFile.fire((0,m.toFileChanges)(k)),k=>{k.type==="error"&&this._onDidWatchErrorOccur.fire(k.message),this.logService[k.type](k.message)},this.logService.getLevel()===I.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,b.combinedDisposable)(g,E)}toFilePath(u){return(0,f.normalize)(u.fsPath)}toFileSystemProviderError(u){if(u instanceof w.FileSystemProviderError)return u;let g;switch(u.code){case"ENOENT":g=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=w.FileSystemProviderErrorCode.NoPermissions;break;default:g=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(u,g)}async toFileSystemProviderWriteError(u,g){let E=this.toFileSystemProviderError(g);if(u&&E.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:k}=await h.SymlinkSupport.stat(this.toFilePath(u));k.mode&128||(E=(0,w.createFileSystemProviderError)(g,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(k){this.logService.trace(k)}return E}dispose(){super.dispose(),(0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,b.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=n}),define(Q[41],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,p.createDecorator)("productService")}),define(Q[26],Z([0,1,8,56]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(F,L){C.ok(p.isString(F)),C.ok(p.isObject(L)),C.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,L)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new b}),define(Q[109],Z([0,1,26,11]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class w{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,f){this.schemasById[b(h)]=f,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new w;p.Registry.add(t.Extensions.JSONContribution,F)}),define(Q[31],Z([0,1,74,11,26,8,109]),function($,t,p,C,b,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var L;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=b.Registry.as(F.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(O,T=!0){this.registerConfigurations([O],T)}registerConfigurations(O,T=!0){const v=[];O.forEach(s=>{v.push(...this.validateAndRegisterProperties(s,T,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(O){const T=[],v=s=>{if(s.properties)for(const r in s.properties)T.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>v(r))};for(const s of O){v(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(T)}registerDefaultConfigurations(O){const T=[],v=[];for(const s of O)for(const r in s)if(T.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const e={type:"object",default:this.defaultValues[r],description:p.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};v.push(d(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=s[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(T)}deregisterDefaultConfigurations(O){const T=[];for(const v of O)for(const s in v)if(T.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(T)}notifyConfigurationSchemaUpdated(...O){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(O){for(const T of O)this.overrideIdentifiers.add(T);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(O,T=!0,v,s=3){var r;s=w.isUndefinedOrNull(O.scope)?s:O.scope;let e=[],i=O.properties;if(i)for(let o in i){if(T&&a(o)){delete i[o];continue}const u=i[o];if(this.updatePropertyDefaultValue(o,u),t.OVERRIDE_PROPERTY_PATTERN.test(o)?u.scope=void 0:(u.scope=w.isUndefinedOrNull(u.scope)?s:u.scope,u.requireTrust=w.isUndefinedOrNull(u.requireTrust)?!!((r=v==null?void 0:v.requireTrustForConfigurations)===null||r===void 0?void 0:r.includes(o)):u.requireTrust),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),e.push(o)}let n=O.allOf;if(n)for(let o of n)e.push(...this.validateAndRegisterProperties(o,T,v,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(O){const T=v=>{let s=v.properties;if(s)for(const e in s)this.updateSchema(e,s[e]);let r=v.allOf;r&&r.forEach(T)};T(O)}updateSchema(O,T){switch(t.allSettings.properties[O]=T,T.scope){case 1:t.applicationSettings.properties[O]=T;break;case 2:t.machineSettings.properties[O]=T;break;case 6:t.machineOverridableSettings.properties[O]=T;break;case 3:t.windowSettings.properties[O]=T;break;case 4:t.resourceSettings.properties[O]=T;break;case 5:t.resourceSettings.properties[O]=T,this.resourceLanguageSettingsSchema.properties[O]=T;break}}removeFromSchema(O,T){switch(delete t.allSettings.properties[O],T.scope){case 1:delete t.applicationSettings.properties[O];break;case 2:delete t.machineSettings.properties[O];break;case 6:delete t.machineOverridableSettings.properties[O];break;case 3:delete t.windowSettings.properties[O];break;case 4:case 5:delete t.resourceSettings.properties[O];break}}updateOverridePropertyPatternKey(){for(const O of this.overrideIdentifiers.values()){const T=`[${O}]`,v={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(T,v),t.allSettings.properties[T]=v,t.applicationSettings.properties[T]=v,t.machineSettings.properties[T]=v,t.machineOverridableSettings.properties[T]=v,t.windowSettings.properties[T]=v,t.resourceSettings.properties[T]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(O,T){let v=this.defaultValues[O];w.isUndefined(v)&&(v=T.default),w.isUndefined(v)&&(v=y(T.type)),T.default=v}}const R="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function d(S){return S.substring(1,S.length-1)}t.overrideIdentifierFromKey=d;function y(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=y;const I=new f;b.Registry.add(t.Extensions.Configuration,I);function a(S){return S.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(S)?p.localize(5,null,S):I.getConfigurationProperties()[S]!==void 0?p.localize(6,null,S):null:p.localize(4,null)}t.validateProperty=a;function m(){const S=[],O=I.getConfigurationProperties();for(const T of Object.keys(O))S.push([T,O[T].scope]);return S.push(["launch",4]),S.push(["task",4]),S}t.getScopes=m}),define(Q[27],Z([0,1,22,8,9,26,7,31]),function($,t,p,C,b,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function h(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof b.URI)}t.isConfigurationOverrides=h;var f;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=R;function d(i,n){const o=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],u=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],g=[];if(n&&i){for(const U of i.keys)if(n.keys.indexOf(U)!==-1){const x=O(i.contents,U),X=O(n.contents,U);p.equals(x,X)||g.push(U)}}const E=[],k=U=>{const x={};for(const X of U)for(const ne of X.identifiers)x[r(ne)]=X;return x},j=n?k(n.overrides):{},A=i?k(i.overrides):{};if(Object.keys(j).length)for(const U of o){const x=j[U];x&&E.push([(0,L.overrideIdentifierFromKey)(U),x.keys])}if(Object.keys(A).length)for(const U of u){const x=A[U];x&&E.push([(0,L.overrideIdentifierFromKey)(U),x.keys])}if(Object.keys(j).length&&Object.keys(A).length)for(const U of g){const x=A[U],X=j[U];if(x&&X){const ne=d({contents:x.contents,keys:x.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});E.push([(0,L.overrideIdentifierFromKey)(U),[...ne.added,...ne.removed,...ne.updated]])}}return{added:o,removed:u,updated:g,overrides:E}}t.compare=d;function y(i,n){const o=[];for(const u of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(u)){const g={};for(const E in i[u])g[E]=i[u][E];o.push({identifiers:[(0,L.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(g),contents:I(g,n)})}return o}t.toOverrides=y;function I(i,n){const o=Object.create(null);for(let u in i)a(o,u,i[u],n);return o}t.toValuesTree=I;function a(i,n,o,u){const g=n.split("."),E=g.pop();let k=i;for(let j=0;j<g.length;j++){let A=g[j],U=k[A];switch(typeof U){case"undefined":U=k[A]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${g.slice(0,j+1).join(".")} is ${JSON.stringify(U)}`);return}k=U}if(typeof k=="object"&&k!==null)try{k[E]=o}catch(j){u(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(k)}`)}else u(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(k)}`)}t.addToValueTree=a;function m(i,n){const o=n.split(".");S(i,o)}t.removeFromValueTree=m;function S(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const u=i[o];typeof u=="object"&&!Array.isArray(u)&&(S(u,n),Object.keys(u).length===0&&delete i[o])}}function O(i,n,o){function u(k,j){let A=k;for(const U of j){if(typeof A!="object"||A===null)return;A=A[U]}return A}const g=n.split("."),E=u(i,g);return typeof E=="undefined"?o:E}t.getConfigurationValue=O;function T(i,n,o){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in i?C.isObject(i[u])&&C.isObject(n[u])?T(i[u],n[u],o):o&&(i[u]=n[u]):i[u]=n[u])})}t.merge=T;function v(){const i=w.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=v;function s(){const i=Object.create(null),n=w.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let o in n){let u=n[o].default;a(i,o,u,g=>console.error(`Conflict in default settings: ${g}`))}return i}t.getDefaultValues=s;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,o){const u=i.inspect(n),g=i.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:u.defaultValue}t.getMigratedSettingValue=e}),define(Q[110],Z([0,1,58,44,23,8,22,9,31,27,26,2,11]),function($,t,p,C,b,w,F,L,h,f,R,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class I{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,f.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of b.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[o],g=i[o];g&&(typeof u=="object"&&typeof g=="object"?(u=F.deepClone(u),this.mergeContents(u,g)):u=g),n[o]=u}return new I(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),o=[...this.keys];for(const u of e){this.mergeContents(i,u.contents);for(const g of u.overrides){const[E]=n.filter(k=>b.equals(k.identifiers,g.identifiers));E?this.mergeContents(E.contents,g.contents):n.push(F.deepClone(g))}for(const g of u.keys)o.indexOf(g)===-1&&o.push(g)}return new I(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&w.isObject(e[n])&&w.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,f.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=I;class a extends I{constructor(){const e=(0,f.getDefaultValues)(),i=(0,f.getConfigurationKeys)(),n=[];for(const o of Object.keys(e))h.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,h.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,f.toValuesTree)(e[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(e,i,n)}}t.DefaultConfigurationModel=a;class m{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!w.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:o,overrides:u,untrusted:g}=this.doParseRaw(e,i);this._configurationModel=new I(n,o,u),this._untrustedConfigurations=g||[]}doParseContent(e){let i={},n=null,o=[],u=[],g=[];function E(j){Array.isArray(o)?o.push(j):n&&(o[n]=j)}let k={onObjectBegin:()=>{let j={};E(j),u.push(o),o=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let j=[];E(j),u.push(o),o=j,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:E,onError:(j,A,U)=>{g.push({error:j,offset:A,length:U})}};if(e)try{p.visit(e,k),i=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this._name}: ${j}`),this._parseErrors=[j]}return i}doParseRaw(e,i){const n=R.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,n,!0,i);e=o.raw;const u=(0,f.toValuesTree)(e,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),g=Object.keys(e),E=(0,f.toOverrides)(e,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:u,keys:g,overrides:E,untrusted:o.untrusted}}filter(e,i,n,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.isUntrusted))return{raw:e,untrusted:[]};const u={},g=[];for(let E in e)if(h.OVERRIDE_PROPERTY_PATTERN.test(E)&&n){const k=this.filter(e[E],i,!1,o);u[E]=k.raw,g.push(...k.untrusted)}else{const k=i[E],j=k?typeof k.scope!="undefined"?k.scope:3:void 0;(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&(o.isUntrusted&&(k==null?void 0:k.requireTrust)?g.push(E):u[E]=e[E])}return{raw:u,untrusted:g}}}t.ConfigurationModelParser=m;class S extends d.Disposable{constructor(e,i,n,o){super();this.userSettingsResource=e,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}t.UserSettings=S;class O{constructor(e,i,n=new I,o=new I,u=new C.ResourceMap,g=new I,E=new C.ResourceMap,k=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=g,this._memoryConfigurationByResource=E,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new I,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(e):o.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const o=this.getConsolidateConfigurationModel(i,n),u=this.getFolderConfigurationModelForResource(i.resource,n),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,x=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,X=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(e):g.getValue(e),ne=o.getValue(e),ee=b.distinct(b.flatten(o.overrides.map(te=>te.identifiers))).filter(te=>o.getOverrideValue(e,te)!==void 0);return{defaultValue:E,userValue:k,userLocalValue:j,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:x,memoryValue:X,value:ne,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:j!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:u==null?void 0:u.freeze().getValue(e),override:i.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:g.getValue(e),override:i.overrideIdentifier?g.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(o=>h.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=(0,h.overrideIdentifierFromKey)(o),g=this._defaultConfiguration.getKeysForOverrideIdentifier(u),E=e.getKeysForOverrideIdentifier(u),k=[...E.filter(j=>g.indexOf(j)===-1),...g.filter(j=>E.indexOf(j)===-1),...g.filter(j=>!F.equals(this._defaultConfiguration.override(u).getValue(j),e.override(u).getValue(j)))];return[u,k]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:u}=(0,f.compare)(this.localUserConfiguration,e),g=[...i,...n,...o];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:u}=(0,f.compare)(this.remoteUserConfiguration,e);let g=[...i,...n,...o];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:o,overrides:u}=(0,f.compare)(this.workspaceConfiguration,e);let g=[...i,...n,...o];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:u}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:o,updated:u,removed:g,overrides:E}=(0,f.compare)(n,i);let k=[...o,...u,...g];return(k.length||!n)&&this.updateFolderConfiguration(e,i),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:o,removed:u,overrides:g}=(0,f.compare)(i,void 0);return{keys:[...n,...o,...u],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const o=i.getFolder(e);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const u=this._memoryConfigurationByResource.get(e);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:o,keys:u}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:o,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(o=>i.add(o))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((g,E)=>(g.set(L.URI.revive(E[0]),this.parseConfigurationModel(E[1])),g),new C.ResourceMap);return new O(i,n,new I,o,u,new I,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new I(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=O;function T(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const o of r)o.keys.forEach(u=>e.add(u)),o.overrides.forEach(([u,g])=>{const E=(0,C.getOrSet)(i,u,new Set);g.forEach(k=>E.add(k))});const n=[];return i.forEach((o,u)=>n.push([u,[...o.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=T;class v{constructor(e,i,n,o){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(E=>u.add(E)),e.overrides.forEach(([,E])=>E.forEach(k=>u.add(k))),this.affectedKeys=[...u.values()];const g=new I;this.affectedKeys.forEach(E=>g.setValue(E,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=O.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,u=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(o,u)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,f.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(e=e[o],!e)return!1;n=n[o]}return!0}}t.ConfigurationChangeEvent=v;class s extends v{constructor(e,i,n,o){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=s}),define(Q[111],Z([0,1,26,31,2,27,110,11,4,18]),function($,t,p,C,b,w,F,L,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class R extends b.Disposable{constructor(y,I){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,I)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new h.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,I){const a=typeof y=="string"?y:void 0,m=(0,w.isConfigurationOverrides)(y)?y:(0,w.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(a,m,void 0)}updateValue(y,I,a,m){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const I=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(a,I,1)}onDidDefaultConfigurationChange(y){const I=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,y);this.trigger(a,I,6)}trigger(y,I,a){const m=new F.ConfigurationChangeEvent(y,{data:I},this.configuration);m.source=a,m.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=R}),define(Q[54],Z([0,1,84,7,31,26,17]),function($,t,p,C,b,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function L(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=L;function h(a){return a.res.statusCode===204}async function f(a){if(!L(a))throw new Error("Server returned "+a.res.statusCode);return h(a)?null:(await(0,F.streamToBuffer)(a.stream)).toString()}t.asText=f;async function R(a){if(!L(a))throw new Error("Server returned "+a.res.statusCode);if(h(a))return null;const S=(await(0,F.streamToBuffer)(a.stream)).toString();try{return JSON.parse(S)}catch(O){throw O.message+=`:
`+S,O}}t.asJson=R;function d(a){I(a)}t.updateProxyConfigurationsScope=d;let y;function I(a){const m=w.Registry.as(b.Extensions.Configuration);y&&m.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),requireTrust:!0}}},m.registerConfiguration(y)}I(2)}),define(Q[112],Z([0,1,113,8]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(F,L){return F.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:F.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function w(F,L,h={}){const f=(0,p.parse)(F),R=h.proxyUrl||b(f,L);if(!R)return null;const d=(0,p.parse)(R);if(!/^https?:$/.test(d.protocol||""))return null;const y={host:d.hostname||"",port:d.port||(d.protocol==="https"?"443":"80"),auth:d.auth,rejectUnauthorized:(0,C.isBoolean)(h.strictSSL)?h.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((I,a)=>{$(["http-proxy-agent"],I,a)}))(y):new(await new Promise((I,a)=>{$(["https-proxy-agent"],I,a)}))(y)}t.getProxyAgent=w}),define(Q[114],Z([0,1,30,17]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(w,F,L){let h=L&&L.get("storage.serviceMachineId",0)||null;if(h)return h;try{const R=(await F.readFile(w.serviceMachineIdResource)).value.toString();h=(0,p.isUUID)(R)?R:null}catch(f){h=null}if(!h){h=(0,p.generateUuid)();try{await F.writeFile(w.serviceMachineIdResource,C.VSBuffer.fromString(h))}catch(f){}}return L&&L.store("storage.serviceMachineId",h,0,1),h}t.getServiceMachineId=b}),define(Q[115],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,p.createDecorator)("stateService")}),define(Q[116],Z([0,1,3,16,19,12,8,13]),function($,t,p,C,b,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class h{constructor(d,y){this.dbPath=d,this.onError=y,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const d=await this.loadAsync();this._database||(this._database=d)}}loadSync(){try{return this.lastFlushedSerializedDatabase=C.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await C.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}getItem(d,y){const I=this.database[d];return(0,F.isUndefinedOrNull)(I)?y:I}setItem(d,y){if((0,F.isUndefinedOrNull)(y))return this.removeItem(d);(typeof y=="string"||typeof y=="number"||typeof y=="boolean")&&this.database[d]===y||(this.database[d]=y,this.saveSync())}removeItem(d){(0,F.isUndefined)(this.database[d])||(this.database[d]=void 0,this.saveSync())}saveSync(){const d=JSON.stringify(this.database,null,4);if(d!==this.lastFlushedSerializedDatabase)try{(0,w.writeFileSync)(this.dbPath,d),this.lastFlushedSerializedDatabase=d}catch(y){this.onError(y)}}}t.FileStorage=h;let f=class We{constructor(d,y){this.fileStorage=new h(p.join(d.userDataPath,We.STATE_FILE),I=>y.error(I))}init(){return this.fileStorage.init()}getItem(d,y){return this.fileStorage.getItem(d,y)}setItem(d,y){this.fileStorage.setItem(d,y)}removeItem(d){this.fileStorage.removeItem(d)}};f.STATE_FILE="storage.json",f=ce([ue(0,b.INativeEnvironmentService),ue(1,L.ILogService)],f),t.StateService=f}),define(Q[117],Z([0,1,7,11,2,8,67,4]),function($,t,p,C,b,w,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";t.IStorageService=(0,p.createDecorator)("storageService");var f;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var R;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(R=t.StorageScope||(t.StorageScope={}));var d;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(d=t.StorageTarget||(t.StorageTarget={}));class y extends b.Disposable{constructor(S={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,O){O===h?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:O,target:this.getKeyTargets(S)[O]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,O,T){var v;return(v=this.getStorage(O))===null||v===void 0?void 0:v.get(S,T)}getBoolean(S,O,T){var v;return(v=this.getStorage(O))===null||v===void 0?void 0:v.getBoolean(S,T)}getNumber(S,O,T){var v;return(v=this.getStorage(O))===null||v===void 0?void 0:v.getNumber(S,T)}store(S,O,T,v){if((0,w.isUndefinedOrNull)(O)){this.remove(S,T);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(S,T,v),(s=this.getStorage(T))===null||s===void 0||s.set(S,O)})}remove(S,O){this.withPausedEmitters(()=>{var T;this.updateKeyTarget(S,O,void 0),(T=this.getStorage(O))===null||T===void 0||T.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,O){const T=[],v=this.getKeyTargets(S);for(const s of Object.keys(v))v[s]===O&&T.push(s);return T}updateKeyTarget(S,O,T){var v,s;const r=this.getKeyTargets(O);typeof T=="number"?r[S]!==T&&(r[S]=T,(v=this.getStorage(O))===null||v===void 0||v.set(h,JSON.stringify(r))):typeof r[S]=="number"&&(delete r[S],(s=this.getStorage(O))===null||s===void 0||s.set(h,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const O=this.get(h,S);if(O)try{return JSON.parse(O)}catch(T){}return Object.create(null)}isNew(S){return this.getBoolean(t.IS_NEW_KEY,S)===!0}async flush(){var S,O,T,v;this._onWillSaveState.fire({reason:f.NONE}),await L.Promises.settled([(O=(S=this.getStorage(0))===null||S===void 0?void 0:S.whenFlushed())!==null&&O!==void 0?O:Promise.resolve(),(v=(T=this.getStorage(1))===null||T===void 0?void 0:T.whenFlushed())!==null&&v!==void 0?v:Promise.resolve()])}async logStorage(){var S,O,T,v,s,r;const e=(O=(S=this.getStorage(0))===null||S===void 0?void 0:S.items)!==null&&O!==void 0?O:new Map,i=(v=(T=this.getStorage(1))===null||T===void 0?void 0:T.items)!==null&&v!==void 0?v:new Map;return a(e,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends y{constructor(){super();this.globalStorage=new F.Storage(new F.InMemoryStorageDatabase),this.workspaceStorage=new F.Storage(new F.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}t.InMemoryStorageService=I;async function a(m,S,O,T){const v=u=>{try{return JSON.parse(u)}catch(g){return u}},s=new Map,r=new Map;m.forEach((u,g)=>{s.set(g,u),r.set(g,v(u))});const e=new Map,i=new Map;S.forEach((u,g)=>{e.set(g,u),i.set(g,v(u))}),console.group(`Storage: Global (path: ${O})`);let n=[];s.forEach((u,g)=>{n.push({key:g,value:u})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${T})`);let o=[];e.forEach((u,g)=>{o.push({key:g,value:u})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=a}),define(Q[118],Z([0,1,15,34,30,9]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;function F(f){if(p.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function L(f,R,d,y,I,a,m,S,O,T){const v=Object.create(null);v["common.machineId"]=m,v.sessionID=(0,b.generateUuid)()+Date.now(),v.commitHash=I,v.version=a,v["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,p.PlatformToString)(p.platform),v["common.nodePlatform"]=C.platform,v["common.nodeArch"]=y,v["common.product"]=T||"desktop";const s=h(S||[]);s&&(v["common.msftInternal"]=s);let r=0;const e=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),p.isLinuxSnap&&(v["common.snap"]="true");const i=F(d);i&&(v["common.platformDetail"]=i);try{const n=await f.readFile(w.URI.file(O));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}t.resolveCommonProperties=L;function h(f){const R=C.env.USERDNSDOMAIN;if(!R)return!1;const d=R.toLowerCase();return f.some(y=>d===y)}}),define(Q[42],Z([0,1,7]),function($,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,p.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[119],Z([0,1,14,24,25,22,42,54,48,19,28,13,20,9,41,117,114,7,18]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m,S,O,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var v;(function(l){l[l.None=0]="None",l[l.IncludeVersions=1]="IncludeVersions",l[l.IncludeFiles=2]="IncludeFiles",l[l.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",l[l.IncludeSharedAccounts=8]="IncludeSharedAccounts",l[l.IncludeVersionProperties=16]="IncludeVersionProperties",l[l.ExcludeNonValidated=32]="ExcludeNonValidated",l[l.IncludeInstallationTargets=64]="IncludeInstallationTargets",l[l.IncludeAssetUri=128]="IncludeAssetUri",l[l.IncludeStatistics=256]="IncludeStatistics",l[l.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",l[l.Unpublished=4096]="Unpublished"})(v||(v={}));function s(...l){return String(l.reduce((c,P)=>c|P,0))}var r;(function(l){l[l.Tag=1]="Tag",l[l.ExtensionId=4]="ExtensionId",l[l.Category=5]="Category",l[l.ExtensionName=7]="ExtensionName",l[l.Target=8]="Target",l[l.Featured=9]="Featured",l[l.SearchText=10]="SearchText",l[l.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class u{constructor(c=o){this.state=c}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(c,P=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:c,pageSize:P}))}withFilter(c,...P){const D=[...this.state.criteria,...P.length?P.map(N=>({filterType:c,value:N})):[{filterType:c}]];return new u(Object.assign(Object.assign({},this.state),{criteria:D}))}withSortBy(c){return new u(Object.assign(Object.assign({},this.state),{sortBy:c}))}withSortOrder(c){return new u(Object.assign(Object.assign({},this.state),{sortOrder:c}))}withFlags(...c){return new u(Object.assign(Object.assign({},this.state),{flags:c.reduce((P,D)=>P|D,0)}))}withAssetTypes(...c){return new u(Object.assign(Object.assign({},this.state),{assetTypes:c}))}get raw(){const{criteria:c,pageNumber:P,pageSize:D,sortBy:N,sortOrder:M,flags:z,assetTypes:B}=this.state;return{filters:[{criteria:c,pageNumber:P,pageSize:D,sortBy:N,sortOrder:M}],assetTypes:B,flags:z}}get searchText(){const c=this.state.criteria.filter(P=>P.filterType===r.SearchText)[0];return c&&c.value?c.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(c=>String(c.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(l,c){const P=(l||[]).filter(D=>D.statisticName===c)[0];return P?P.value:0}function E(l){const c="Microsoft.VisualStudio.Code.Translation.";return l.files.filter(D=>D.assetType.indexOf(c)===0).reduce((D,N)=>{const M=U(l,N.assetType);return M&&D.push([N.assetType.substring(c.length),M]),D},[])}function k(l){if(l.properties){const c=l.properties.filter(N=>N.key===e.Repository),P=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),D=c.filter(N=>P.test(N.value))[0];return D?{uri:D.value,fallbackUri:D.value}:null}return U(l,e.Repository)}function j(l){return{uri:`${l.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${l.fallbackAssetUri}/${e.VSIX}`}}function A(l){const c=U(l,e.Icon);if(c)return c;const P=C.DefaultIconPath;return{uri:P,fallbackUri:P}}function U(l,c){return l.files.filter(D=>D.assetType===c)[0]?{uri:`${l.assetUri}/${c}`,fallbackUri:`${l.fallbackAssetUri}/${c}`}:null}function x(l,c){const P=l.properties?l.properties.filter(N=>N.key===c):[],D=P.length>0&&P[0].value;return D?D.split(",").map(N=>(0,b.adoptToGalleryExtensionId)(N)):[]}function X(l){const c=l.properties?l.properties.filter(P=>P.key===i.Engine):[];return c.length>0&&c[0].value||""}function ne(l){const c=l.properties?l.properties.filter(D=>D.key===i.LocalizedLanguages):[],P=c.length>0&&c[0].value||"";return P?P.split(","):[]}function ee(l){return l.indexOf("preview")!==-1}function te(l){const c=l.properties?l.properties.find(P=>P.key===i.WebExtension):void 0;return!!c&&c.value==="true"}function ae(l){return l.files.some(c=>c.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,T.joinPath)(I.URI.parse(l.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(l,c,P,D,N){const M={manifest:U(c,e.Manifest),readme:U(c,e.Details),changelog:U(c,e.Changelog),license:U(c,e.License),repository:k(c),download:j(c),icon:A(c),coreTranslations:E(c)};return{identifier:{id:(0,b.getGalleryExtensionId)(l.publisher.publisherName,l.extensionName),uuid:l.extensionId},name:l.extensionName,version:c.version,date:c.lastUpdated,displayName:l.displayName,publisherId:l.publisher.publisherId,publisher:l.publisher.publisherName,publisherDisplayName:l.publisher.displayName,description:l.shortDescription||"",installCount:g(l.statistics,"install"),rating:g(l.statistics,"averagerating"),ratingCount:g(l.statistics,"ratingcount"),assetUri:I.URI.parse(c.assetUri),webResource:ae(c),assetTypes:c.files.map(({assetType:z})=>z),assets:M,properties:{dependencies:x(c,i.Dependency),extensionPack:x(c,i.ExtensionPack),engine:X(c),localizedLanguages:ne(c),webExtension:te(c)},telemetryData:{index:(D.pageNumber-1)*D.pageSize+P,searchText:D.searchText,querySource:N},preview:ee(l.flags)}}let G=class{constructor(c,P,D,N,M,z,B){this.requestService=c,this.logService=P,this.environmentService=D,this.telemetryService=N,this.fileService=M,this.productService=z;const q=z.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=_(z.version,this.environmentService,this.fileService,B)}api(c=""){return`${this.extensionsGalleryUrl}${c}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(c,P){const D=[];let{total:N,firstPage:M,getPage:z}=await this.query({names:c,pageSize:c.length},P);D.push(...M);for(let B=1;D.length<N&&(M=await z(B,P),M.length);B++)D.push(...M);return D}async getCompatibleExtension(c,P){const D=await this.getCompatibleExtensionByEngine(c,P);return(D==null?void 0:D.properties.webExtension)?D.webResource?D:null:D}async getCompatibleExtensionByEngine(c,P){const D=(0,C.isIExtensionIdentifier)(c)?null:c;if(D&&D.properties.engine&&(0,h.isEngineValid)(D.properties.engine,this.productService.version))return D;const{id:N,uuid:M}=D?D.identifier:c;let z=new u().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?z=z.withFilter(r.ExtensionId,M):z=z.withFilter(r.ExtensionName,N);const{galleryExtensions:B}=await this.queryGallery(z,R.CancellationToken.None),[q]=B;if(!q||!q.versions.length)return null;if(P){const Y=q.versions.filter(ie=>ie.version===P)[0];if(Y){const ie=W(q,Y,0,z);if(ie.properties.engine&&(0,h.isEngineValid)(ie.properties.engine,this.productService.version))return ie}return null}const J=await this.getLastValidExtensionVersion(q,q.versions);return J?W(q,J,0,z):null}async query(c,P){const D=R.CancellationToken.isCancellationToken(c)?{}:c,N=R.CancellationToken.isCancellationToken(c)?c:P;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=D.text||"";const z=(0,w.getOrDefault)(D,re=>re.pageSize,50);let B=new u().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,z).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(r.Category,ge||he),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(r.Tag,ge||he),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(r.SearchText,M)),B=B.withSortBy(0)):D.ids?B=B.withFilter(r.ExtensionId,...D.ids):D.names?B=B.withFilter(r.ExtensionName,...D.names):B=B.withSortBy(4),typeof D.sortBy=="number"&&(B=B.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(B=B.withSortOrder(D.sortOrder));const{galleryExtensions:q,total:J}=await this.queryGallery(B,N),Y=q.map((re,he)=>W(re,re.versions[0],he,B,D.source)),ie=async(re,he)=>{if(he.isCancellationRequested)throw(0,p.canceled)();const ge=B.withPage(re+1),{galleryExtensions:Se}=await this.queryGallery(ge,he);return Se.map((be,Fe)=>W(be,be.versions[0],Fe,ge,D.source))};return{firstPage:Y,total:J,pageSize:B.pageSize,getPage:ie}}async queryGallery(c,P){if(!this.isEnabled())throw new Error("No extension gallery service configured.");c=c.withFlags(c.flags,v.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(v.Unpublished));const D=await this.commonHeadersPromise,N=JSON.stringify(c.raw),M=Object.assign(Object.assign({},D),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)}),z=new Date().getTime();let B,q,J=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:M},P),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:J};const Y=await(0,L.asJson)(B);if(Y){const ie=Y.results[0],re=ie.extensions,he=ie.resultMetadata&&ie.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return J=he&&he.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:J}}return{galleryExtensions:[],total:J}}catch(Y){throw q=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},c.telemetryData),{requestBodySize:String(N.length),duration:new Date().getTime()-z,success:!!B&&(0,L.isSuccess)(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:q?(0,p.isPromiseCanceledError)(q)?"canceled":(0,p.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(c,P,D,N){if(!!this.isEnabled()){const M=await this.commonHeadersPromise,z=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${c}/extensions/${P}/${D}/stats?statType=${N}`),headers:z},R.CancellationToken.None)}catch(B){}}}async download(c,P,D){this.logService.trace("ExtensionGalleryService#download",c.identifier.id);const N=(0,b.getGalleryExtensionTelemetryData)(c),M=new Date().getTime(),z=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},N),{duration:Y})),B=D===1?"install":D===2?"update":"",q=B?{uri:`${c.assets.download.uri}&${B}=true`,fallbackUri:`${c.assets.download.fallbackUri}?${B}=true`}:c.assets.download,J=await this.getAsset(q);await this.fileService.writeFile(P,J.stream),z(new Date().getTime()-M)}async getReadme(c,P){if(c.assets.readme){const D=await this.getAsset(c.assets.readme,{},P);return await(0,L.asText)(D)||""}return""}async getManifest(c,P){if(c.assets.manifest){const D=await this.getAsset(c.assets.manifest,{},P),N=await(0,L.asText)(D);return N?JSON.parse(N):null}return null}async getCoreTranslation(c,P){const D=c.assets.coreTranslations.filter(N=>N[0]===P.toUpperCase())[0];if(D){const N=await this.getAsset(D[1]),M=await(0,L.asText)(N);return M?JSON.parse(M):null}return null}async getChangelog(c,P){if(c.assets.changelog){const D=await this.getAsset(c.assets.changelog,{},P);return await(0,L.asText)(D)||""}return""}async getAllVersions(c,P){let D=new u().withFlags(v.IncludeVersions,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");c.identifier.uuid?D=D.withFilter(r.ExtensionId,c.identifier.uuid):D=D.withFilter(r.ExtensionName,c.identifier.id);const N=[],{galleryExtensions:M}=await this.queryGallery(D,R.CancellationToken.None);return M.length&&(P?await Promise.all(M[0].versions.map(async z=>{let B;try{B=await this.getEngine(z)}catch(q){}B&&(0,h.isEngineValid)(B,this.productService.version)&&N.push({version:z.version,date:z.lastUpdated})})):N.push(...M[0].versions.map(z=>({version:z.version,date:z.lastUpdated})))),N}async getAsset(c,P={},D=R.CancellationToken.None){const N=await this.commonHeadersPromise,M={type:"GET"},z=Object.assign(Object.assign({},N),P.headers||{});P=Object.assign(Object.assign(Object.assign({},P),M),{headers:z});const B=c.uri,q=c.fallbackUri,J=Object.assign(Object.assign({},P),{url:B});try{const Y=await this.requestService.request(J,D);if(Y.res.statusCode===200)return Y;const ie=await(0,L.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ie}`)}catch(Y){if((0,p.isPromiseCanceledError)(Y))throw Y;const ie=(0,p.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ie});const re=Object.assign(Object.assign({},P),{url:q});return this.requestService.request(re,D)}}async getLastValidExtensionVersion(c,P){const D=this.getLastValidExtensionVersionFromProperties(c,P);return D||this.getLastValidExtensionVersionRecursively(c,P)}getLastValidExtensionVersionFromProperties(c,P){for(const D of P){const N=X(D);if(!N)return null;if((0,h.isEngineValid)(N,this.productService.version))return D}return null}async getEngine(c){const P=X(c);if(P)return P;const D=U(c,e.Manifest);if(!D)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},M=await this.getAsset(D,{headers:N}),z=await(0,L.asJson)(M);if(z)return z.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(c,P){if(!P.length)return null;const D=P[0],N=await this.getEngine(D);return(0,h.isEngineValid)(N,this.productService.version)?(D.properties=D.properties||[],D.properties.push({key:i.Engine,value:N}),D):this.getLastValidExtensionVersionRecursively(c,P.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const c=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(c.res.statusCode!==200)throw new Error("Could not get extensions report.");const P=await(0,L.asJson)(c),D=new Map;if(P)for(const N of P.malicious){const M=D.get(N)||{id:{id:N},malicious:!0,slow:!1};M.malicious=!0,D.set(N,M)}return[...D.values()]}};G=ce([ue(0,L.IRequestService),ue(1,d.ILogService),ue(2,f.IEnvironmentService),ue(3,F.ITelemetryService),ue(4,y.IFileService),ue(5,a.IProductService),ue(6,(0,O.optional)(m.IStorageService))],G),t.ExtensionGalleryService=G;async function _(l,c,P,D){const N={"X-Market-Client-Id":`VSCode ${l}`,"User-Agent":`VSCode ${l}`},M=await(0,S.getServiceMachineId)(c,P,D);return N["X-Market-User-Id"]=M,N}t.resolveMarketplaceHeaders=_}),define(Q[120],Z([0,1,40,85,21,7,27,31,2,22,26]),function($,t,p,C,b,w,F,L,h,f,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(a,m){this._configurationService=m,this._experimentProperties={},this._disposables=new h.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const O=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!O})}))}setExperimentProperty(a,m){this._experimentProperties[a]=m}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const m=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(y);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let m=a.sessionID,S=a["common.instanceId"],O=a["common.machineId"],T=a["common.firstSessionDate"],v=a["common.msftInternal"];return{sessionId:m,instanceId:S,machineId:O,firstSessionDate:T,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(a,m,S){return this.isOptedIn?this._commonProperties.then(O=>{m=(0,f.mixin)(m,O),m=(0,f.mixin)(m,this._experimentProperties),m=(0,f.cloneAndChange)(m,T=>{if(typeof T=="string")return this._cleanupInfo(T,S)}),this._appender.log(a,m)},O=>{console.error(O)}):Promise.resolve(void 0)}publicLog2(a,m,S){return this.publicLog(a,m,S)}publicLogError(a,m){return this.sendErrorTelemetry?this.publicLog(a,m,!0):Promise.resolve(void 0)}publicLogError2(a,m){return this.publicLogError(a,m)}_cleanupInfo(a,m){let S=a;if(m){const O=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(a);if(!e)break;O.push([e.index,r.lastIndex])}const T=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(S="";;){const r=v.exec(a);if(!r)break;!T.test(r[0])&&O.every(([e,i])=>r.index<e||r.index>=i)&&(S+=a.substring(s,r.index)+"<REDACTED: user-file-path>",s=v.lastIndex)}s<a.length&&(S+=a.substr(s))}for(let O of this._cleanupPatterns)S=S.replace(O,"");return S}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ce([ue(1,(0,w.optional)(F.IConfigurationService))],d),t.TelemetryService=d;const y="telemetry";R.Registry.as(L.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,C.localize)(2,null,p.default.privacyStatementUrl):(0,C.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[55],Z([0,1,27,22,8,4]),function($,t,p,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,m){return Promise.resolve(void 0)}publicLog2(a,m){return this.publicLog(a,m)}publicLogError(a,m){return Promise.resolve(void 0)}publicLogError2(a,m){return this.publicLogError(a,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(m,S,O){}async publicLogError(m,S,O){}}t.NullEndpointTelemetryService=F;function L(...a){return{log:(m,S)=>a.forEach(O=>O.log(m,S)),flush:()=>w.Promises.settled(a.map(m=>m.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(a,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(S.source),configurationKeys:y(S.sourceConfig)})})}t.configurationTelemetry=h;function f(a){const m=Object.create(null),S=Object.create(null),O=Object.create(null);d(a,O);for(let T in O){T=T.length>150?T.substr(T.length-149):T;const v=O[T];typeof v=="number"?S[T]=v:typeof v=="boolean"?S[T]=v?1:0:typeof v=="string"?m[T]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(m[T]=v)}return{properties:m,measurements:S}}t.validateTelemetryData=f;function R(a){if(!a)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(O=>{a.indexOf(`${O}+`)===0&&(m=O)}),m}t.cleanRemoteAuthority=R;function d(a,m,S=0,O){if(!!a)for(let T of Object.getOwnPropertyNames(a)){const v=a[T],s=O?O+T:T;Array.isArray(v)?m[s]=(0,C.safeStringify)(v):v instanceof Date?m[s]=v.toISOString():(0,b.isObject)(v)?S<2?d(v,m,S+1,s+"."):m[s]=(0,C.safeStringify)(v):m[s]=v}}function y(a){if(!a)return[];const m=[];return I(m,"",a),m}function I(a,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(O=>I(a,m?`${m}.${O}`:O,S[O])):a.push(m)}}),define(Q[121],Z([0,1,14,22,55]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function w(L){const h=await new Promise((R,d)=>{$(["applicationinsights"],R,d)});let f;return h.defaultClient?(f=new h.TelemetryClient(L),f.channel.setUseDiskRetryCaching(!0)):(h.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=h.defaultClient),L.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class F{constructor(h,f,R){this._eventPrefix=h,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=w(this._aiClient)),this._asyncAIClient.then(f=>{h(f)},f=>{(0,p.onUnexpectedError)(f),console.error(f)})}}log(h,f){!this._aiClient||(f=(0,C.mixin)(f,this._defaultData),f=(0,b.validateTelemetryData)(f),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+h,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Q[122],Z([0,1,12,16,3]),function($,t,p,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function w(F,L){const h=Object.create(null),f=(d,y)=>{const I=JSON.parse(d);h[y]=I};if(L){const d=(0,p.readdirSync)(L).filter(I=>{try{return(0,C.statSync)((0,b.join)(L,I)).isDirectory()}catch(a){return!1}}),y=[];d.forEach(I=>{(0,p.readdirSync)((0,b.join)(L,I)).filter(m=>m==="telemetry.json").length===1&&y.push(I)}),y.forEach(I=>{const a=(0,C.readFileSync)((0,b.join)(L,I,"telemetry.json")).toString();f(a,I)})}let R=(0,C.readFileSync)((0,b.join)(F,"telemetry-core.json")).toString();return f(R,"vscode-core"),R=(0,C.readFileSync)((0,b.join)(F,"telemetry-extensions.json")).toString(),f(R,"vscode-extensions"),JSON.stringify(h,null,4)}t.buildTelemetryMessage=w}),define(Q[43],Z([0,1,73,3,16,4,12,133,134,8]),function($,t,p,C,b,w,F,L,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class R extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=R;function d(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function y(r){if(r instanceof R)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new R(e,r)}function I(r,e,i,n,o,u){const g=C.dirname(e),E=C.join(n,g);if(!E.startsWith(n))return Promise.reject(new Error(p.localize(0,null,e)));const k=C.join(n,e);let j;return u.onCancellationRequested(()=>{j&&j.destroy()}),Promise.resolve(b.promises.mkdir(E,{recursive:!0})).then(()=>new Promise((A,U)=>{if(!u.isCancellationRequested)try{j=(0,b.createWriteStream)(k,{mode:i}),j.once("close",()=>A()),j.once("error",U),r.once("error",U),r.pipe(j)}catch(x){U(x)}}))}function a(r,e,i,n){let o=(0,w.createCancelablePromise)(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{o.cancel(),r.close()}),new Promise((g,E)=>{const k=new w.Sequencer,j=A=>{A.isCancellationRequested||(u++,r.readEntry())};r.once("error",E),r.once("close",()=>o.then(()=>{n.isCancellationRequested||r.entryCount===u?g():E(new R("Incomplete",new Error(p.localize(1,null,u,r.entryCount))))},E)),r.readEntry(),r.on("entry",A=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(A.fileName)){j(n);return}const U=A.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const ne=C.join(e,U);o=(0,w.createCancelablePromise)(ee=>b.promises.mkdir(ne,{recursive:!0}).then(()=>j(ee)).then(void 0,E));return}const x=S(r,A),X=d(A);o=(0,w.createCancelablePromise)(ne=>k.queue(()=>x.then(ee=>I(ee,U,X,e,i,ne).then(()=>j(ne)))).then(null,E))}})})}function m(r,e=!1){return new Promise((i,n)=>{(0,L.open)(r,e?{lazyEntries:!0}:void 0,(o,u)=>{o?n(y(o)):i((0,f.assertIsDefined)(u))})})}function S(r,e){return new Promise((i,n)=>{r.openReadStream(e,(o,u)=>{o?n(y(o)):i((0,f.assertIsDefined)(u))})})}function O(r,e){return new Promise((i,n)=>{const o=new h.ZipFile;e.forEach(g=>{g.contents?o.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&o.addFile(g.localPath,g.path)}),o.end();const u=(0,b.createWriteStream)(r);o.outputStream.pipe(u),o.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>i(r))})}t.zip=O;function T(r,e,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let u=m(r,!0);return i.overwrite&&(u=u.then(g=>(0,F.rimraf)(e).then(()=>g))),u.then(g=>a(g,e,{sourcePathRegex:o},n))}t.extract=T;function v(r,e){return m(r).then(i=>new Promise((n,o)=>{i.on("entry",u=>{u.fileName===e&&S(i,u).then(g=>n(g),g=>o(g))}),i.once("close",()=>o(new Error(p.localize(2,null,e))))}))}function s(r,e){return v(r,e).then(i=>new Promise((n,o)=>{const u=[];i.once("error",o),i.on("data",g=>u.push(g)),i.on("end",()=>n(Buffer.concat(u)))}))}t.buffer=s}),define(Q[123],Z([0,1,43,78]),function($,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(w){return(0,p.buffer)(w,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(L){throw new Error((0,C.localize)(0,null))}})}t.getManifest=b}),define(Q[124],Z([0,1,16,39,2,12,3,13,24,25,4,9,19,90,79,41,43,15,23,10,20,18,30,14]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m,S,O,T,v,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",o="scanningUser",u="extracting",g="deleting",E="renaming";let k=class extends b.Disposable{constructor(A,U,x,X,ne){super();this.beforeRemovingExtension=A,this.fileService=U,this.logService=x,this.environmentService=X,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=X.builtinExtensionsPath,this.extensionsPath=X.extensionsPath,this.uninstalledPath=F.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(A){const U=[];(A===null||A===0)&&U.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(x).message,n)))),(A===null||A===1)&&U.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(x).message,o))));try{const x=await Promise.all(U);return(0,T.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(A){this.logService.trace("Started scanning user extensions");let[U,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(X=>!U[new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]),A&&(x=(0,f.groupByExtension)(x,ne=>ne.identifier).map(ne=>ne.sort((ee,te)=>C.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(A,U,x){const X=A.key(),ne=F.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=F.join(this.extensionsPath,X);try{await w.rimraf(ee)}catch(ae){try{await w.rimraf(ee)}catch(W){}throw new h.ExtensionManagementError((0,a.localize)(0,null,ee,A.id),g)}await this.extractAtLocation(A,U,ne,x);let te=await this.scanExtension(d.URI.file(ne),1);if(!te)throw new Error((0,a.localize)(1,null,ne));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(A,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await w.rimraf(ne)}catch(W){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(ae)}. Deleted from extracted location`,ne),ae}try{te=await this.scanExtension(d.URI.file(ee),1)}catch(ae){}if(te)return te;throw new Error((0,a.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(A,U){return this.setMetadata(A,U),await this.storeMetadata(A,Object.assign(Object.assign({},U),{installedTimestamp:A.installedTimestamp})),A}async storeMetadata(A,U){U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0;const x=F.join(A.location.fsPath,"package.json"),X=await p.promises.readFile(x,"utf8"),{manifest:ne}=await this.parseManifest(X);return ne.__metadata=U,await w.writeFile(x,JSON.stringify(ne,null,"	")),A}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(x=>new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{U.forEach(X=>x[X.key()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(X=>delete X[A.key()]);const x=(await this.scanExtensions(1)).find(X=>new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).equals(A))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(X){if(X.code!=="ENOENT")throw X}let x={};if(U)try{x=JSON.parse(U)}catch(X){}return A&&(A(x),Object.keys(x).length?await w.writeFile(this.uninstalledPath,JSON.stringify(x)):await w.rimraf(this.uninstalledPath)),x})}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await w.rimraf(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).key()])}async extractAtLocation(A,U,x,X){this.logService.trace(`Started extracting the extension from ${U} to ${x}`);try{await w.rimraf(x)}catch(ne){throw new h.ExtensionManagementError(this.joinErrors(ne).message,g)}try{await(0,S.extract)(U,x,{sourcePath:"extension",overwrite:!0},X),this.logService.info(`Extracted extension to ${x}:`,A.id)}catch(ne){try{await w.rimraf(x)}catch(ee){}throw new h.ExtensionManagementError(ne.message,ne instanceof S.ExtractError&&ne.type?ne.type:u)}}async rename(A,U,x,X){try{await p.promises.rename(U,x)}catch(ne){if(O.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<X)return this.logService.info(`Failed renaming ${U} to ${x} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,x,X);throw new h.ExtensionManagementError(ne.message||(0,a.localize)(3,null,U,x),ne.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const A=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return A;const U=this.scanDevSystemExtensions(),[x,X]=await Promise.all([A,U]);return[...x,...X]}async scanExtensionsInDir(A,U){const x=new R.Limiter(10),X=await this.fileService.resolve(d.URI.file(A));return X.children?(await Promise.all(X.children.filter(ee=>ee.isDirectory).map(ee=>x.queue(async()=>U===1&&(0,r.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,U))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(A,U){var x,X;try{const ne=await this.fileService.resolve(A);if(ne.children){const{manifest:ee,metadata:te}=await this.readManifest(A.fsPath),ae=(x=ne.children.find(({name:l})=>/^readme(\.txt|\.md|)$/i.test(l)))===null||x===void 0?void 0:x.resource,W=(X=ne.children.find(({name:l})=>/^changelog(\.txt|\.md|)$/i.test(l)))===null||X===void 0?void 0:X.resource,G={id:(0,f.getGalleryExtensionId)(ee.publisher,ee.name)},_={type:U,identifier:G,manifest:ee,location:A,readmeUrl:ae,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:U===0};return te&&(this.setMetadata(_,te),_.installedTimestamp=te.installedTimestamp),_}}catch(ne){U!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const A=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(){const A=this.getDevSystemExtensionsList();if(A.length){const U=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",U.length),U.filter(x=>A.some(X=>(0,f.areSameExtensions)(x.identifier,{id:X})))}else return[]}setMetadata(A,U){A.publisherDisplayName=U.publisherDisplayName||null,A.publisherId=U.publisherId||null,A.identifier.uuid=U.id,A.isMachineScoped=!!U.isMachineScoped,A.isBuiltin=A.type===0||!!U.isBuiltin}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.scanAllUserExtensions(),x=new Set;for(const ee of U)A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||x.add(ee.identifier.id.toLowerCase());const X=(0,f.groupByExtension)(U,ee=>ee.identifier);await R.Promises.settled(X.map(async ee=>{const te=ee.sort((ae,W)=>C.rcompare(ae.manifest.version,W.manifest.version))[0];x.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const ne=U.filter(ee=>A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await R.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const A=await this.scanAllUserExtensions(),U=[],x=(0,f.groupByExtension)(A,X=>X.identifier);U.push(...(0,T.flatten)(x.map(X=>X.sort((ne,ee)=>C.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await R.Promises.settled(U.map(X=>this.removeExtension(X,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(A=>A.name)}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((x,X)=>new Error(`${x.message}${x.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=F.normalize(F.join(v.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(A){const U=[p.promises.readFile(F.join(A,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),p.promises.readFile(F.join(A,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:x,metadata:X},ne]=await Promise.all(U);return{manifest:(0,I.localizeManifest)(x,ne),metadata:X}}parseManifest(A){return new Promise((U,x)=>{try{const X=JSON.parse(A),ne=X.__metadata||null;U({manifest:X,metadata:ne})}catch(X){x(new Error((0,a.localize)(4,null)))}})}};k=ce([ue(1,s.IFileService),ue(2,L.ILogService),ue(3,y.INativeEnvironmentService),ue(4,m.IProductService)],k),t.ExtensionsScanner=k}),define(Q[125],Z([0,1,16,77,3,12,2,23,43,24,25,19,4,11,39,9,40,15,13,98,29,42,48,18,30,96,7,10,28,123,102,124,103,104,20]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m,S,O,T,v,s,r,e,i,n,o,u,g,E,k,j,A,U,x,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",te="validating",ae="local",W="unknown";let G=class extends F.Disposable{constructor(l,c,P,D,N,M,z){super();this.environmentService=l,this.galleryService=c,this.logService=P,this.downloadService=D,this.telemetryService=N,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new I.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const B=this._register(M.createInstance(U.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(A.ExtensionsScanner,J=>B.postUninstall(J))),this.manifestCache=this._register(new v.ExtensionsManifestCache(l,this)),this.extensionsDownloader=this._register(M.createInstance(j.ExtensionsDownloader));const q=this._register(new x.ExtensionsWatcher(this,z,l,P));this._register(q.onDidChangeExtensionsByAnotherSource(({added:J,removed:Y})=>{J.forEach(ie=>this._onDidInstallExtension.fire({identifier:ie.identifier,operation:0,local:ie})),Y.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))})),this._register((0,F.toDisposable)(()=>{this.installingExtensions.forEach(J=>J.cancel()),this.uninstallingExtensions.forEach(J=>J.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(l){this.logService.trace("ExtensionManagementService#zip",l.identifier.id);const c=await this.collectFiles(l),P=await(0,h.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,c);return m.URI.file(P)}async unzip(l){return this.logService.trace("ExtensionManagementService#unzip",l.toString()),(await this.install(l)).identifier}async getManifest(l){const c=await this.downloadVsix(l),P=b.resolve(c.fsPath);return(0,k.getManifest)(P)}async collectFiles(l){const c=async D=>{let N=await w.readdir(D);N=N.map(B=>b.join(D,B));const M=await Promise.all(N.map(B=>p.promises.stat(B)));let z=Promise.resolve([]);return M.forEach((B,q)=>{const J=N[q];B.isFile()&&(z=z.then(Y=>[...Y,J])),B.isDirectory()&&(z=z.then(Y=>c(J).then(ie=>[...Y,...ie])))}),z};return(await c(l.location.fsPath)).map(D=>({path:`extension/${b.relative(l.location.fsPath,D)}`,localPath:D}))}async install(l,c={}){return this.logService.trace("ExtensionManagementService#install",l.toString()),(0,y.createCancelablePromise)(async P=>{const D=await this.downloadVsix(l),N=b.resolve(D.fsPath),M=await(0,k.getManifest)(N),z={id:(0,R.getGalleryExtensionId)(M.publisher,M.name)};let B=1;if(M.engines&&M.engines.vscode&&!(0,e.isEngineValid)(M.engines.vscode,S.default.version))throw new Error(C.localize(0,null,z.id,S.default.version));const q=new R.ExtensionIdentifierWithVersion(z,M.version),Y=(await this.getInstalled(1)).find(re=>(0,R.areSameExtensions)(z,re.identifier));if(Y)if(c.isMachineScoped=c.isMachineScoped||Y.isMachineScoped,c.isBuiltin=c.isBuiltin||Y.isBuiltin,B=2,q.equals(new R.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(C.localize(1,null,M.displayName||M.name))}else a.gt(Y.manifest.version,M.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal(q);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(he){throw new Error(C.localize(2,null,M.displayName||M.name))}}this.logService.info("Installing the extension:",z.id),this._onInstallExtension.fire({identifier:z,zipPath:N});let ie;try{ie=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(M.publisher,M.name))}catch(re){}try{const re=await this.installFromZipPath(q,N,Object.assign(Object.assign({},ie||{}),c),c,B,P);return this.logService.info("Successfully installed the extension:",z.id),re}catch(re){throw this.logService.error("Failed to install the extension:",z.id,re.message),re}})}async downloadVsix(l){if(l.scheme===g.Schemas.file)return l;if(!this.downloadService)throw new Error("Download service is not available");const c=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(l,c),c}async installFromZipPath(l,c,P,D,N,M){try{const z=await this.installExtension({zipPath:c,identifierWithVersion:l,metadata:P},M);try{await this.installDependenciesAndPackExtensions(z,void 0,D)}catch(B){(0,L.isNonEmptyArray)(z.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",z.identifier.id,B.message),(0,L.isNonEmptyArray)(z.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",z.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:l,zipPath:c,local:z,operation:N}),z}catch(z){throw this._onDidInstallExtension.fire({identifier:l,zipPath:c,operation:N,error:z}),z}}async canInstall(l){return!0}async installFromGallery(l,c={}){if(!this.galleryService.isEnabled())throw new Error(C.localize(3,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(N){const M=N&&N.code?N.code:W;throw this.logService.error("Failed to install extension:",l.identifier.id,N?N.message:M),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(l),void 0,N),N instanceof Error&&(N.name=M),N}const P=new R.ExtensionIdentifierWithVersion(l.identifier,l.version).key();let D=this.installingExtensions.get(P);return D||(D=(0,y.createCancelablePromise)(N=>this.doInstallFromGallery(l,c,N)),this.installingExtensions.set(P,D),D.finally(()=>this.installingExtensions.delete(P))),D}async doInstallFromGallery(l,c,P){const D=new Date().getTime();let N=1;this.logService.info("Installing extension:",l.identifier.id),this._onInstallExtension.fire({identifier:l.identifier,gallery:l});try{const z=(await this.getInstalled(1)).find(J=>(0,R.areSameExtensions)(J.identifier,l.identifier));z&&(N=2);const B=await this.downloadInstallableExtension(l,N);B.metadata.isMachineScoped=c.isMachineScoped||(z==null?void 0:z.isMachineScoped),B.metadata.isBuiltin=c.isBuiltin||(z==null?void 0:z.isBuiltin);const q=await this.installExtension(B,P);try{await this.extensionsDownloader.delete(m.URI.file(B.zipPath))}catch(J){}if(!c.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(q,z,c)}catch(J){try{await this.uninstall(q)}catch(Y){}throw J}return z&&a.neq(z.manifest.version,l.version)&&await this.extensionsScanner.setUninstalled(z),this.logService.info("Extensions installed successfully:",l.identifier.id),this._onDidInstallExtension.fire({identifier:l.identifier,gallery:l,local:q,operation:N}),this.reportTelemetry(this.getTelemetryEvent(N),(0,R.getGalleryExtensionTelemetryData)(l),new Date().getTime()-D,void 0),q}catch(M){const z=M&&M.code?M.code:W;throw this.logService.error("Failed to install extension:",l.identifier.id,M?M.message:z),this._onDidInstallExtension.fire({identifier:l.identifier,gallery:l,operation:N,error:z}),this.reportTelemetry(this.getTelemetryEvent(N),(0,R.getGalleryExtensionTelemetryData)(l),new Date().getTime()-D,M),M instanceof Error&&(M.name=z),M}}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new f.ExtensionManagementError(C.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const c=await this.galleryService.getCompatibleExtension(l);if(!c)throw new f.ExtensionManagementError(C.localize(5,null,l.identifier.id,S.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return c}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(6,null));const c=await this.findGalleryExtension(l);if(!c)throw new Error(C.localize(7,null));await this.extensionsScanner.setUninstalled(l);try{await this.extensionsScanner.removeUninstalledExtension(l)}catch(P){throw new Error(C.localize(8,null,(0,s.toErrorMessage)(P)))}await this.installFromGallery(c)}getTelemetryEvent(l){return l===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(l){const c=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(c).has(l.identifier.id)}async downloadInstallableExtension(l,c){const P={id:l.identifier.uuid,publisherId:l.publisherId,publisherDisplayName:l.publisherDisplayName};let D;try{this.logService.trace("Started downloading extension:",l.identifier.id),D=(await this.extensionsDownloader.downloadExtension(l,c)).fsPath,this.logService.info("Downloaded extension:",l.identifier.id,D)}catch(N){throw new f.ExtensionManagementError(this.joinErrors(N).message,ee)}try{const N=await(0,k.getManifest)(D);return{zipPath:D,identifierWithVersion:new R.ExtensionIdentifierWithVersion(l.identifier,N.version),metadata:P}}catch(N){throw new f.ExtensionManagementError(this.joinErrors(N).message,te)}}async installExtension(l,c){try{const P=await this.unsetUninstalledAndGetLocal(l.identifierWithVersion);if(P)return l.metadata?this.extensionsScanner.saveMetadataForLocalExtension(P,l.metadata):P}catch(P){throw O.isMacintosh?new f.ExtensionManagementError(C.localize(9,null),ne):new f.ExtensionManagementError(C.localize(10,null),ne)}return this.extractAndInstall(l,c)}async unsetUninstalledAndGetLocal(l){if(!await this.isUninstalled(l))return null;this.logService.trace("Removing the extension from uninstalled list:",l.id);const P=await this.extensionsScanner.setInstalled(l);return this.logService.info("Removed the extension from uninstalled list:",l.id),P}async extractAndInstall({zipPath:l,identifierWithVersion:c,metadata:P},D){let N=await this.extensionsScanner.extractUserExtension(c,l,D);return this.logService.info("Installation completed.",c.id),P&&(N=await this.extensionsScanner.saveMetadataForLocalExtension(N,P)),N}async installDependenciesAndPackExtensions(l,c,P){if(!!this.galleryService.isEnabled()){const D=l.manifest.extensionDependencies||[];if(l.manifest.extensionPack)for(const N of l.manifest.extensionPack)c&&c.manifest.extensionPack&&c.manifest.extensionPack.some(M=>(0,R.areSameExtensions)({id:M},{id:N}))||D.every(M=>!(0,R.areSameExtensions)({id:M},{id:N}))&&D.push(N);if(D.length){const N=await this.getInstalled(),M=D.filter(z=>N.every(({identifier:B})=>!(0,R.areSameExtensions)(B,{id:z})));if(M.length){const B=(await this.galleryService.query({names:M,pageSize:D.length},E.CancellationToken.None)).firstPage;try{await y.Promises.settled(B.map(q=>this.installFromGallery(q,P)))}catch(q){try{await this.rollback(B)}catch(J){}throw q}}}}}async rollback(l){const P=(await this.getInstalled(1)).filter(D=>l.some(N=>new R.ExtensionIdentifierWithVersion(D.identifier,D.manifest.version).equals(new R.ExtensionIdentifierWithVersion(N.identifier,N.version))));await y.Promises.settled(P.map(D=>this.uninstall(D)))}async uninstall(l,c={}){this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id);const P=await this.getInstalled(1),D=P.find(N=>(0,R.areSameExtensions)(N.identifier,l.identifier));if(!D)throw new Error(C.localize(11,null,l.manifest.displayName||l.manifest.name));try{await this.checkForDependenciesAndUninstall(D,P,c)}catch(N){throw this.joinErrors(N)}}async updateMetadata(l,c){return this.logService.trace("ExtensionManagementService#updateMetadata",l.identifier.id),l=await this.extensionsScanner.saveMetadataForLocalExtension(l,Object.assign(Object.assign({},l.manifest.__metadata||{}),c)),this.manifestCache.invalidate(),l}async updateExtensionScope(l,c){return this.logService.trace("ExtensionManagementService#updateExtensionScope",l.identifier.id),l=await this.extensionsScanner.saveMetadataForLocalExtension(l,Object.assign(Object.assign({},l.manifest.__metadata||{}),{isMachineScoped:c})),this.manifestCache.invalidate(),l}async getGalleryMetadata(l){const c=await this.findGalleryExtensionByName(l);return c?{id:c.identifier.uuid,publisherDisplayName:c.publisherDisplayName,publisherId:c.publisherId}:void 0}async findGalleryExtension(l){if(l.identifier.uuid){const c=await this.findGalleryExtensionById(l.identifier.uuid);return c||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(l){const c=Array.isArray(l)?l:[l];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((P,D)=>new Error(`${P.message}${P.message?",":""}${D instanceof Error?D.message:D}`),new Error(""))}async checkForDependenciesAndUninstall(l,c,P){try{await this.preUninstallExtension(l);const D=P.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(l,c);await this.uninstallExtensions(l,D,c,P)}catch(D){throw await this.postUninstallExtension(l,new f.ExtensionManagementError(D instanceof Error?D.message:D,ae)),D}await this.postUninstallExtension(l)}async uninstallExtensions(l,c,P,D){const N=[l,...c];if(!D.donotCheckDependents)for(const M of N)this.checkForDependents(M,N,P,l);await y.Promises.settled([this.uninstallExtension(l),...c.map(M=>this.doUninstall(M))])}checkForDependents(l,c,P,D){const N=this.getDependents(l,P);if(N.length){const M=N.filter(z=>c.indexOf(z)===-1);if(M.length)throw new Error(this.getDependentsErrorMessage(l,M,D))}}getDependentsErrorMessage(l,c,P){return P===l?c.length===1?C.localize(12,null,P.manifest.displayName||P.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?C.localize(13,null,P.manifest.displayName||P.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):C.localize(14,null,P.manifest.displayName||P.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?C.localize(15,null,P.manifest.displayName||P.manifest.name,l.manifest.displayName||l.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?C.localize(16,null,P.manifest.displayName||P.manifest.name,l.manifest.displayName||l.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):C.localize(17,null,P.manifest.displayName||P.manifest.name,l.manifest.displayName||l.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}getAllPackExtensionsToUninstall(l,c,P=[]){if(P.indexOf(l)!==-1)return[];P.push(l);const D=l.manifest.extensionPack?l.manifest.extensionPack:[];if(D.length){const N=c.filter(z=>!z.isBuiltin&&D.some(B=>(0,R.areSameExtensions)({id:B},z.identifier))),M=[];for(const z of N)M.push(...this.getAllPackExtensionsToUninstall(z,c,P));return[...N,...M]}return[]}getDependents(l,c){return c.filter(P=>P.manifest.extensionDependencies&&P.manifest.extensionDependencies.some(D=>(0,R.areSameExtensions)({id:D},l.identifier)))}async doUninstall(l){try{await this.preUninstallExtension(l),await this.uninstallExtension(l)}catch(c){throw await this.postUninstallExtension(l,new f.ExtensionManagementError(c instanceof Error?c.message:c,ae)),c}await this.postUninstallExtension(l)}async preUninstallExtension(l){if(!await w.exists(l.location.fsPath))throw new Error(C.localize(18,null));this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier)}async uninstallExtension(l){let c=this.uninstallingExtensions.get(l.identifier.id);return c||(c=(0,y.createCancelablePromise)(async()=>{const P=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...P.filter(D=>(0,R.areSameExtensions)(D.identifier,l.identifier)))}),this.uninstallingExtensions.set(l.identifier.id,c),c.finally(()=>this.uninstallingExtensions.delete(l.identifier.id))),c}async postUninstallExtension(l,c){if(c)this.logService.error("Failed to uninstall extension:",l.identifier.id,c.message);else if(this.logService.info("Successfully uninstalled extension:",l.identifier.id),l.identifier.uuid)try{await this.galleryService.reportStatistic(l.manifest.publisher,l.manifest.name,l.manifest.version,"uninstall")}catch(D){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(l),void 0,c);const P=c?c instanceof f.ExtensionManagementError?c.code:W:void 0;this._onDidUninstallExtension.fire({identifier:l.identifier,error:P})}getInstalled(l=null){return this.extensionsScanner.scanExtensions(l)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(l){return(await this.filterUninstalled(l)).length===1}async filterUninstalled(...l){const c=[],P=await this.extensionsScanner.getUninstalledExtensions();for(const D of l)P[D.key()]&&c.push(D.key());return c}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(l,c,P,D){const N=D?D instanceof f.ExtensionManagementError?D.code:W:void 0;this.telemetryService.publicLogError(l,Object.assign(Object.assign({},c),{success:!D,duration:P,errorcode:N}))}};G=ce([ue(0,d.INativeEnvironmentService),ue(1,f.IExtensionGalleryService),ue(2,T.ILogService),ue(3,(0,u.optional)(o.IDownloadService)),ue(4,r.ITelemetryService),ue(5,u.IInstantiationService),ue(6,X.IFileService)],G),t.ExtensionManagementService=G}),define(Q[126],Z([0,1,135,113,2,8,14,112,27,13,17,19,99]),function($,t,p,C,b,w,F,L,h,f,R,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let I=class extends b.Disposable{constructor(m,S,O){super();this.environmentService=S,this.logService=O,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,S){this.logService.trace("RequestService#request",m.url);const{proxyUrl:O,strictSSL:T}=this,v=Object.assign(Object.assign({},process.env),await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),s=m.agent?m.agent:await(0,L.getProxyAgent)(m.url||"",v,{proxyUrl:O,strictSSL:T});return m.agent=s,m.strictSSL=T,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,S)}async getNodeRequest(m){return((0,C.parse)(m.url).protocol==="https:"?await new Promise((T,v)=>{$(["https"],T,v)}):await new Promise((T,v)=>{$(["http"],T,v)})).request}_request(m,S){return new Promise(async(O,T)=>{let v;const s=(0,C.parse)(m.url),r=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),e={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,w.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(e.auth=m.user+":"+m.password),v=r(e,i=>{const n=(0,w.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},m),{url:i.headers.location,followRedirects:n-1}),S).then(O,T);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,p.createGunzip)())),O({res:i,stream:(0,R.streamToBufferReadableStream)(o)})}}),v.on("error",T),m.timeout&&v.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&v.write(m.data),v.end(),S.onCancellationRequested(()=>{v.abort(),T((0,F.canceled)())})})}async resolveProxy(m){}};I=ce([ue(0,h.IConfigurationService),ue(1,d.INativeEnvironmentService),ue(2,f.ILogService)],I),t.RequestService=I}),define(Q[136],Z([0,1,32,16,137,3,4,40,51,49,101,19,89,24,125,119,42,55,120,118,54,126,27,111,121,115,116,13,10,106,122,107,20,108,2,41,97,9,105,52,14,29,17,34]),function($,t,p,C,b,w,F,L,h,f,R,d,y,I,a,m,S,O,T,v,s,r,e,i,n,o,u,g,E,k,j,A,U,x,X,ne,ee,te,ae,W,G,_,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class P extends X.Disposable{constructor(M){super();this.argv=M,(0,b.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[M,z]=await this.initServices();return M.invokeFunction(async B=>{const q=B.get(g.ILogService),J=B.get(U.IFileService),Y=B.get(d.INativeEnvironmentService),ie=B.get(I.IExtensionManagementCLIService);return q.info("CLI main",this.argv),this.registerErrorHandler(q),await this.doRun(Y,ie,J),(0,F.raceTimeout)((0,O.combinedAppender)(...z).flush(),1e3)})}async initServices(){const M=new h.ServiceCollection,z=Object.assign({_serviceBrand:void 0},L.default);M.set(ne.IProductService,z);const B=new y.NativeEnvironmentService(this.argv,z);M.set(d.INativeEnvironmentService,B),await Promise.all([B.appSettingsHome.fsPath,B.extensionsPath].map(be=>be?C.promises.mkdir(be,{recursive:!0}):void 0));const q=(0,g.getLogLevel)(B),J=[];J.push(new k.SpdLogLogger("cli",(0,w.join)(B.logsPath,"cli.log"),!0,q)),q===g.LogLevel.Trace&&J.push(new g.ConsoleLogger(q));const Y=this._register(new g.MultiplexLogService(J));M.set(g.ILogService,Y);const ie=this._register(new A.FileService(Y));M.set(U.IFileService,ie);const re=this._register(new x.DiskFileSystemProvider(Y));ie.registerProvider(E.Schemas.file,re);const he=this._register(new i.ConfigurationService(B.settingsResource,ie));M.set(e.IConfigurationService,he),await he.initialize();const ge=new u.StateService(B,Y);M.set(o.IStateService,ge),M.set(s.IRequestService,new f.SyncDescriptor(r.RequestService)),M.set(I.IExtensionManagementService,new f.SyncDescriptor(a.ExtensionManagementService)),M.set(I.IExtensionGalleryService,new f.SyncDescriptor(m.ExtensionGalleryService)),M.set(I.IExtensionManagementCLIService,new f.SyncDescriptor(ee.ExtensionManagementCLIService)),M.set(W.ILocalizationsService,new f.SyncDescriptor(ae.LocalizationsService));const Se=[];if(B.isBuilt&&!B.isExtensionDevelopment&&!B.disableTelemetry&&z.enableTelemetry){z.aiConfig&&z.aiConfig.asimovKey&&Se.push(new n.AppInsightsAppender("monacoworkbench",null,z.aiConfig.asimovKey));const{appRoot:be,extensionsPath:Fe,installSourcePath:Re}=B,Ne={appender:(0,O.combinedAppender)(...Se),sendErrorTelemetry:!1,commonProperties:(0,v.resolveCommonProperties)(ie,(0,p.release)(),(0,p.hostname)(),process.arch,z.commit,z.version,ge.getItem("telemetry.machineId"),z.msftInternalDomains,Re),piiPaths:[be,Fe]};M.set(S.ITelemetryService,new f.SyncDescriptor(T.TelemetryService,[Ne]))}else M.set(S.ITelemetryService,O.NullTelemetryService);return[new R.InstantiationService(M),Se]}registerErrorHandler(M){(0,G.setUnexpectedErrorHandler)(z=>{const B=(0,_.toErrorMessage)(z,!0);!B||M.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(M,z,B){if(this.argv["install-source"])return this.setInstallSource(M,B,this.argv["install-source"]);if(this.argv["list-extensions"])return z.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return z.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return z.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return z.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,j.buildTelemetryMessage)(M.appRoot,M.extensionsPath))}asExtensionIdOrVSIX(M){return M.map(z=>/\.vsix$/i.test(z)?te.URI.file((0,w.isAbsolute)(z)?z:(0,w.join)((0,c.cwd)(),z)):z)}async setInstallSource(M,z,B){await z.writeFile(te.URI.file(M.installSourcePath),l.VSBuffer.fromString(B.slice(0,30)))}}async function D(N){const M=new P(N);try{await M.run()}finally{M.dispose()}}t.main=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5080d21c0b538b996c83fb7b14a746f656eaef15/core/vs/code/node/cliProcessMain.js.map
