/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(G){for(var e=[],_=0,I=G.length;_<I;_++)e[_]=ge[G[_]];return e};define(ge[52],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=_}),define(ge[53],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function I(i){const C=[];for(let f in i)_.call(i,f)&&C.push(i[f]);return C}e.values=I;function T(i,C){for(let f in i)if(_.call(i,f)&&C({key:f,value:i[f]},function(){delete i[f]})===!1)return}e.forEach=T;function A(i,C){const f=Object.create(null);for(const g of i){const a=C(g);let u=f[a];u||(u=f[a]=[]),u.push(g)}return f}e.groupBy=A;function y(i){const C=Object.create(null);return i&&i.forEach((f,g)=>{C[g]=f}),C}e.fromMap=y;function P(i,C){const f=[],g=[];for(let a of i)C.has(a)||f.push(a);for(let a of C)i.has(a)||g.push(a);return{removed:f,added:g}}e.diffSets=P;function D(i,C){const f=[],g=[];for(let[a,u]of i)C.has(a)||f.push(u);for(let[a,u]of C)i.has(a)||g.push(u);return{removed:f,added:g}}e.diffMaps=D;class k{constructor(){this.map=new Map}add(C,f){let g=this.map.get(C);g||(g=new Set,this.map.set(C,g)),g.add(f)}delete(C,f){const g=this.map.get(C);!g||(g.delete(f),g.size===0&&this.map.delete(C))}forEach(C,f){const g=this.map.get(C);!g||g.forEach(f)}}e.SetMap=k}),define(ge[70],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(D){return(k,i,C)=>{let f=null,g=null;if(typeof C.value=="function"?(f="value",g=C.value):typeof C.get=="function"&&(f="get",g=C.get),!g)throw new Error("not supported");C[f]=D(g,i)}}e.createDecorator=_;let I=0;function T(){const D=`$memoize${I++}`;let k;const i=function(f,g,a){let u=null,E=null;if(typeof a.value=="function"?(u="value",E=a.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(u="get",E=a.get),!E)throw new Error("not supported");const b=`${D}:${g}`;a[u]=function(...S){return k=this,this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,S)}),this[b]}};return i.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(C=>{C.indexOf(D)===0&&delete k[C]})},i}e.createMemoizer=T;function A(D,k,i){return T()(D,k,i)}e.memoize=A;function y(D,k,i){return _((C,f)=>{const g=`$debounce$${f}`,a=`$debounce$result$${f}`;return function(...u){this[a]||(this[a]=i?i():void 0),clearTimeout(this[g]),k&&(this[a]=k(this[a],...u),u=[this[a]]),this[g]=setTimeout(()=>{C.apply(this,u),this[a]=i?i():void 0},D)}})}e.debounce=y;function P(D,k,i){return _((C,f)=>{const g=`$throttle$timer$${f}`,a=`$throttle$result$${f}`,u=`$throttle$lastRun$${f}`,E=`$throttle$pending$${f}`;return function(...b){if(this[a]||(this[a]=i?i():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...b)),!this[E]){const S=this[u]+D;S<=Date.now()?(this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=i?i():void 0):(this[E]=!0,this[g]=setTimeout(()=>{this[E]=!1,this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=i?i():void 0},S-Date.now()))}}})}e.throttle=P}),define(ge[18],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function I(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=I;function T(m){D(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=T;function A(m){D(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function y(m){if(m instanceof Error){let{name:t,message:n}=m;const s=m.stacktrace||m.stack;return{$isError:!0,name:t,message:n,stack:s}}return m}e.transformErrorForSerialization=y;const P="Canceled";function D(m){return m instanceof Error&&m.name===P&&m.message===P}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=k;function i(){const m=new Error(P);return m.name=m.message,m}e.canceled=i;function C(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=C;function f(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=f;function g(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function a(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function u(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=u;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function d(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function l(m,t=Object.create(null)){const n=new Error(m);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(ge[19],pe([0,1,18]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,F=0){return U[U.length-(1+F)]}e.tail=I;function T(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=T;function A(U,F,M=(L,O)=>L===O){if(U===F)return!0;if(!U||!F||U.length!==F.length)return!1;for(let L=0,O=U.length;L<O;L++)if(!M(U[L],F[L]))return!1;return!0}e.equals=A;function y(U,F,M){let L=0,O=U.length-1;for(;L<=O;){const B=(L+O)/2|0,q=M(U[B],F);if(q<0)L=B+1;else if(q>0)O=B-1;else return B}return-(L+1)}e.binarySearch=y;function P(U,F){let M=0,L=U.length;if(L===0)return 0;for(;M<L;){const O=Math.floor((M+L)/2);F(U[O])?L=O:M=O+1}return M}e.findFirstInSorted=P;function D(U,F,M){if(U=U|0,U>=F.length)throw new TypeError("invalid index");let L=F[Math.floor(F.length*Math.random())],O=[],B=[],q=[];for(let Q of F){const de=M(Q,L);de<0?O.push(Q):de>0?B.push(Q):q.push(Q)}return U<O.length?D(U,O,M):U<O.length+q.length?q[0]:D(U-(O.length+q.length),B,M)}e.quickSelect=D;function k(U,F){const M=[];let L;for(const O of U.slice(0).sort(F))!L||F(L[0],O)!==0?(L=[O],M.push(L)):L.push(O);return M}e.groupBy=k;function i(U,F,M){const L=[];function O(Q,de,be){if(!(de===0&&be.length===0)){const Ae=L[L.length-1];Ae&&Ae.start+Ae.deleteCount===Q?(Ae.deleteCount+=de,Ae.toInsert.push(...be)):L.push({start:Q,deleteCount:de,toInsert:be})}}let B=0,q=0;for(;;){if(B===U.length){O(B,0,F.slice(q));break}if(q===F.length){O(B,U.length-B,[]);break}const Q=U[B],de=F[q],be=M(Q,de);be===0?(B+=1,q+=1):be<0?(O(B,1,[]),B+=1):be>0&&(O(B,0,[de]),q+=1)}return L}e.sortedDiff=i;function C(U,F,M){const L=i(U,F,M),O=[],B=[];for(const q of L)O.push(...U.slice(q.start,q.start+q.deleteCount)),B.push(...q.toInsert);return{removed:O,added:B}}e.delta=C;function f(U,F,M){if(M===0)return[];const L=U.slice(0,M).sort(F);return a(U,F,L,M,U.length),L}e.top=f;function g(U,F,M,L,O){return M===0?Promise.resolve([]):new Promise((B,q)=>{(async()=>{const Q=U.length,de=U.slice(0,M).sort(F);for(let be=M,Ae=Math.min(M+L,Q);be<Q;be=Ae,Ae=Math.min(Ae+L,Q)){if(be>M&&await new Promise(Ce=>setTimeout(Ce)),O&&O.isCancellationRequested)throw(0,_.canceled)();a(U,F,de,be,Ae)}return de})().then(B,q)})}e.topAsync=g;function a(U,F,M,L,O){for(const B=M.length;L<O;L++){const q=U[L];if(F(q,M[B-1])<0){M.pop();const Q=P(M,de=>F(q,de)<0);M.splice(Q,0,q)}}}function u(U){return U.filter(F=>!!F)}e.coalesce=u;function E(U){let F=0;for(let M=0;M<U.length;M++)U[M]&&(U[F]=U[M],F+=1);U.length=F}e.coalesceInPlace=E;function b(U,F,M){U.splice(M,0,U.splice(F,1)[0])}e.move=b;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function d(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=d;function l(U,F){if(!F)return U.filter((L,O)=>U.indexOf(L)===O);const M=Object.create(null);return U.filter(L=>{const O=F(L);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=l;function m(U){const F=new Set;return U.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=m;function t(U){const F=Object.create(null);return M=>{const L=U(M);return F[L]?!1:(F[L]=!0,!0)}}e.uniqueFilter=t;function n(U,F){for(let M=U.length-1;M>=0;M--){const L=U[M];if(F(L))return M}return-1}e.lastIndex=n;function s(U,F){return U.length>0?U[0]:F}e.firstOrDefault=s;function r(U,F,M=(L,O)=>L===O){let L=0;for(let O=0,B=Math.min(U.length,F.length);O<B&&M(U[O],F[O]);O++)L++;return L}e.commonPrefixLength=r;function o(U){return[].concat(...U)}e.flatten=o;function c(U,F){let M=typeof F=="number"?U:0;typeof F=="number"?M=U:(M=0,F=U);const L=[];if(M<=F)for(let O=M;O<F;O++)L.push(O);else for(let O=M;O>F;O--)L.push(O);return L}e.range=c;function p(U,F,M){return U.reduce((L,O)=>(L[F(O)]=M?M(O):O,L),Object.create(null))}e.index=p;function v(U,F){return U.push(F),()=>h(U,F)}e.insert=v;function h(U,F){const M=U.indexOf(F);if(M>-1)return U.splice(M,1),F}e.remove=h;function w(U,F,M){const L=U.slice(0,F),O=U.slice(F);return L.concat(M,O)}e.arrayInsert=w;function R(U,F){let M;if(typeof F=="number"){let L=F;M=()=>{const O=Math.sin(L++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let L=U.length-1;L>0;L-=1){const O=Math.floor(M()*(L+1)),B=U[L];U[L]=U[O],U[O]=B}}e.shuffle=R;function N(U,F){const M=U.indexOf(F);M>-1&&(U.splice(M,1),U.unshift(F))}e.pushToStart=N;function j(U,F){const M=U.indexOf(F);M>-1&&(U.splice(M,1),U.push(F))}e.pushToEnd=j;function re(U,F){return Array.isArray(U)?U.map(F):F(U)}e.mapArrayOrNot=re;function V(U){return Array.isArray(U)?U:[U]}e.asArray=V;function W(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=W;function $(U,F){for(const M of U){const L=F(M);if(L!==void 0)return L}}e.mapFind=$}),define(ge[71],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(I){const T=this;let A=!1,y;return function(){return A||(A=!0,y=I.apply(T,arguments)),y}}e.once=_}),define(ge[72],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[54],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(I){function T(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}I.is=T;const A=Object.freeze([]);function y(){return A}I.empty=y;function*P(m){yield m}I.single=P;function D(m){return m||A}I.from=D;function k(m){return!m||m[Symbol.iterator]().next().done===!0}I.isEmpty=k;function i(m){return m[Symbol.iterator]().next().value}I.first=i;function C(m,t){for(const n of m)if(t(n))return!0;return!1}I.some=C;function f(m,t){for(const n of m)if(t(n))return n}I.find=f;function*g(m,t){for(const n of m)t(n)&&(yield n)}I.filter=g;function*a(m,t){for(const n of m)yield t(n)}I.map=a;function*u(...m){for(const t of m)for(const n of t)yield n}I.concat=u;function*E(m){for(const t of m)for(const n of t)yield n}I.concatNested=E;function b(m,t,n){let s=n;for(const r of m)s=t(s,r);return s}I.reduce=b;function*S(m,t,n=m.length){for(t<0&&(t+=m.length),n<0?n+=m.length:n>m.length&&(n=m.length);t<n;t++)yield m[t]}I.slice=S;function d(m,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,m];const s=m[Symbol.iterator]();for(let r=0;r<t;r++){const o=s.next();if(o.done)return[n,I.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}I.consume=d;function l(m,t,n=(s,r)=>s===r){const s=m[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=s.next(),c=r.next();if(o.done!==c.done)return!1;if(o.done)return!0;if(!n(o.value,c.value))return!1}}I.equals=l})(_=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,o="",c=0,p=16,v=0;function h(W){let $=0,U=0;for(;$<W;){const F=t.charCodeAt(s);if(F>=48&&F<=57)U=U*16+F-48;else if(F>=65&&F<=70)U=U*16+F-65+10;else if(F>=97&&F<=102)U=U*16+F-97+10;else break;s++,$++}return $<W&&(U=-1),U}function w(W){s=W,o="",c=0,p=16,v=0}function R(){const W=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return v=3,t.substring(W,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;$=s}else v=3;return t.substring(W,$)}function N(){let W="",$=s;for(;;){if(s>=r){W+=t.substring($,s),v=2;break}const U=t.charCodeAt(s);if(U===34){W+=t.substring($,s),s++;break}if(U===92){if(W+=t.substring($,s),s++,s>=r){v=2;break}switch(t.charCodeAt(s++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const M=h(4);M>=0?W+=String.fromCharCode(M):v=4;break;default:v=5}$=s;continue}if(U>=0&&U<=31)if(D(U)){W+=t.substring($,s),v=2;break}else v=6;s++}return W}function j(){if(o="",v=0,c=s,s>=r)return c=r,p=17;let W=t.charCodeAt(s);if(P(W)){do s++,o+=String.fromCharCode(W),W=t.charCodeAt(s);while(P(W));return p=15}if(D(W))return s++,o+=String.fromCharCode(W),W===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),p=14;switch(W){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,o=N(),p=10;case 47:const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return o=t.substring($,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const U=r-1;let F=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,F=!0;break}s++}return F||(s++,v=1),o=t.substring($,s),p=13}return o+=String.fromCharCode(W),s++,p=16;case 45:if(o+=String.fromCharCode(W),s++,s===r||!k(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),p=11;default:for(;s<r&&re(W);)s++,W=t.charCodeAt(s);if(c!==s){switch(o=t.substring(c,s),o){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return o+=String.fromCharCode(W),s++,p=16}}function re(W){if(P(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let W;do W=j();while(W>=12&&W<=15);return W}return{setPosition:w,getPosition:()=>s,scan:n?V:j,getToken:()=>p,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>v}}e.createScanner=y;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,n){const s=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function v(h,w,R,N){c.value=h,c.offset=w,c.length=R,c.type=N,c.colonOffset=void 0,o=c}try{d(t,{onObjectBegin:(h,w)=>{if(n<=h)throw r;o=void 0,p=n>h,s.push("")},onObjectProperty:(h,w,R)=>{if(n<w||(v(h,w,R,"property"),s[s.length-1]=h,n<=w+R))throw r},onObjectEnd:(h,w)=>{if(n<=h)throw r;o=void 0,s.pop()},onArrayBegin:(h,w)=>{if(n<=h)throw r;o=void 0,s.push(0)},onArrayEnd:(h,w)=>{if(n<=h)throw r;o=void 0,s.pop()},onLiteralValue:(h,w,R)=>{if(n<w||(v(h,w,R,m(h)),n<=w+R))throw r},onSeparator:(h,w,R)=>{if(n<=w)throw r;if(h===":"&&o&&o.type==="property")o.colonOffset=w,p=!1,o=void 0;else if(h===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(p=!0,s[s.length-1]=""),o=void 0}}})}catch(h){if(h!==r)throw h}return{path:s,previousNode:o,isAtPropertyKey:p,matches:h=>{let w=0;for(let R=0;w<h.length&&R<s.length;R++)if(h[w]===s[R]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=C;function f(t,n=[],s=A.DEFAULT){let r=null,o=[];const c=[];function p(h){Array.isArray(o)?o.push(h):r!==null&&(o[r]=h)}return d(t,{onObjectBegin:()=>{const h={};p(h),c.push(o),o=h,r=null},onObjectProperty:h=>{r=h},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const h=[];p(h),c.push(o),o=h,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:p,onError:(h,w,R)=>{n.push({error:h,offset:w,length:R})}},s),o[0]}e.parse=f;function g(t,n=[],s=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(h){r.type==="property"&&(r.length=h-r.offset,r=r.parent)}function c(h){return r.children.push(h),h}d(t,{onObjectBegin:h=>{r=c({type:"object",offset:h,length:-1,parent:r,children:[]})},onObjectProperty:(h,w,R)=>{r=c({type:"property",offset:w,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:h,offset:w,length:R,parent:r})},onObjectEnd:(h,w)=>{r.length=h+w-r.offset,r=r.parent,o(h+w)},onArrayBegin:(h,w)=>{r=c({type:"array",offset:h,length:-1,parent:r,children:[]})},onArrayEnd:(h,w)=>{r.length=h+w-r.offset,r=r.parent,o(h+w)},onLiteralValue:(h,w,R)=>{c({type:m(h),offset:w,length:R,parent:r,value:h}),o(w+R)},onSeparator:(h,w,R)=>{r.type==="property"&&(h===":"?r.colonOffset=w:h===","&&o(w))},onError:(h,w,R)=>{n.push({error:h,offset:w,length:R})}},s);const v=r.children[0];return v&&delete v.parent,v}e.parseTree=g;function a(t,n){if(!!t){let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===r){s=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}}e.findNodeAtLocation=a;function u(t){if(!t.parent||!t.parent.children)return[];const n=u(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=u;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=E(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function b(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=b;function S(t,n,s=!1){if(b(t,n,s)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=S(r[o],n,s);if(c)return c}return t}}e.findNodeAtOffset=S;function d(t,n,s=A.DEFAULT){const r=y(t,!1);function o(de){return de?()=>de(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(de){return de?be=>de(be,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=o(n.onObjectBegin),v=c(n.onObjectProperty),h=o(n.onObjectEnd),w=o(n.onArrayBegin),R=o(n.onArrayEnd),N=c(n.onLiteralValue),j=c(n.onSeparator),re=o(n.onComment),V=c(n.onError),W=s&&s.disallowComments,$=s&&s.allowTrailingComma;function U(){for(;;){const de=r.scan();switch(r.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:W||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(de){case 12:case 13:W?F(10):re();break;case 16:F(1);break;case 15:case 14:break;default:return de}}}function F(de,be=[],Ae=[]){if(V(de),be.length+Ae.length>0){let Ce=r.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){U();break}else if(Ae.indexOf(Ce)!==-1)break;Ce=U()}}}function M(de){const be=r.getTokenValue();return de?N(be):v(be),U(),!0}function L(){switch(r.getToken()){case 11:let de=0;try{de=JSON.parse(r.getTokenValue()),typeof de!="number"&&(F(2),de=0)}catch(be){F(2)}N(de);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return U(),!0}function O(){return r.getToken()!==10?(F(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(j(":"),U(),Q()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function B(){p(),U();let de=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(de||F(4,[],[]),j(","),U(),r.getToken()===2&&$)break}else de&&F(6,[],[]);O()||F(4,[],[2,5]),de=!0}return h(),r.getToken()!==2?F(7,[2],[]):U(),!0}function q(){w(),U();let de=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(de||F(4,[],[]),j(","),U(),r.getToken()===4&&$)break}else de&&F(6,[],[]);Q()||F(4,[],[4,5]),de=!0}return R(),r.getToken()!==4?F(8,[4],[]):U(),!0}function Q(){switch(r.getToken()){case 3:return q();case 1:return B();case 10:return M(!0);default:return L()}}return U(),r.getToken()===17?s.allowEmptyContent?!0:(F(4,[],[]),!1):Q()?(r.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=d;function l(t,n){let s=y(t),r=[],o,c=0,p;do switch(p=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:c!==p&&r.push(t.substring(c,p)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),c=s.getPosition();break}while(o!==17);return r.join("")}e.stripComments=l;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ge[132],pe([0,1,55]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,k,i){let C,f,g,a,u;if(k){for(a=k.offset,u=a+k.length,g=a;g>0&&!P(D,g-1);)g--;let c=u;for(;c<D.length&&!P(D,c);)c++;f=D.substring(g,c),C=A(f,i)}else f=D,C=0,g=0,a=0,u=D.length;const E=y(i,D);let b=!1,S=0,d;i.insertSpaces?d=T(" ",i.tabSize||4):d="	";const l=(0,_.createScanner)(f,!1);let m=!1;function t(){return E+T(d,C+S)}function n(){let c=l.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=l.scan();return m=c===16||l.getTokenError()!==0,c}const s=[];function r(c,p,v){!m&&p<u&&v>a&&D.substring(p,v)!==c&&s.push({offset:p,length:v-p,content:c})}let o=n();if(o!==17){const c=l.getTokenOffset()+g,p=T(d,C);r(p,g,c)}for(;o!==17;){let c=l.getTokenOffset()+l.getTokenLength()+g,p=n(),v="";for(;!b&&(p===12||p===13);){const w=l.getTokenOffset()+g;r(" ",c,w),c=l.getTokenOffset()+l.getTokenLength()+g,v=p===12?t():"",p=n()}if(p===2)o!==1&&(S--,v=t());else if(p===4)o!==3&&(S--,v=t());else{switch(o){case 3:case 1:S++,v=t();break;case 5:case 12:v=t();break;case 13:b?v=t():v=" ";break;case 6:v=" ";break;case 10:if(p===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?v=" ":p!==5&&p!==17&&(m=!0);break;case 16:m=!0;break}b&&(p===12||p===13)&&(v=t())}const h=l.getTokenOffset()+g;r(v,c,h),o=p}return s}e.format=I;function T(D,k){let i="";for(let C=0;C<k;C++)i+=D;return i}function A(D,k){let i=0,C=0;const f=k.tabSize||4;for(;i<D.length;){const g=D.charAt(i);if(g===" ")C++;else if(g==="	")C+=f;else break;i++}return Math.floor(C/f)}function y(D,k){for(let i=0;i<k.length;i++){const C=k.charAt(i);if(C==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function P(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=P}),define(ge[133],pe([0,1,55,132]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(k,i,C){return A(k,i,void 0,C)}e.removeProperty=T;function A(k,i,C,f,g){const a=i.slice(),u=[],E=(0,_.parseTree)(k,u);let b,S;for(;a.length>0&&(S=a.pop(),b=(0,_.findNodeAtLocation)(E,a),b===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(b)if(b.type==="object"&&typeof S=="string"&&Array.isArray(b.children)){const d=(0,_.findNodeAtLocation)(b,[S]);if(d!==void 0)if(C===void 0){if(!d.parent)throw new Error("Malformed AST");const l=b.children.indexOf(d.parent);let m,t=d.parent.offset+d.parent.length;if(l>0){const n=b.children[l-1];m=n.offset+n.length}else m=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return y(k,{offset:m,length:t-m,content:""},f)}else return y(k,{offset:d.offset,length:d.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const l=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,m=g?g(b.children.map(n=>n.children[0].value)):b.children.length;let t;if(m>0){const n=b.children[m-1];t={offset:n.offset+n.length,length:0,content:","+l}}else b.children.length===0?t={offset:b.offset+1,length:0,content:l}:t={offset:b.offset+1,length:0,content:l+","};return y(k,t,f)}}else if(b.type==="array"&&typeof S=="number"&&Array.isArray(b.children))if(C!==void 0){const d=`${JSON.stringify(C)}`;let l;if(b.children.length===0||S===0)l={offset:b.offset+1,length:0,content:b.children.length===0?d:d+","};else{const m=S===-1||S>b.children.length?b.children.length:S,t=b.children[m-1];l={offset:t.offset+t.length,length:0,content:","+d}}return y(k,l,f)}else{const d=S,l=b.children[d];let m;if(b.children.length===1)m={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===d){const t=b.children[d-1],n=t.offset+t.length,s=b.offset+b.length;m={offset:n,length:s-2-n,content:""}}else m={offset:l.offset,length:b.children[d+1].offset-l.offset,content:""};return y(k,m,f)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${b.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function y(k,i,C){let f=P(k,i),g=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,I.isEOL)(f,g-1);)g--;for(;a<f.length&&!(0,I.isEOL)(f,a);)a++}const u=(0,I.format)(f,{offset:g,length:a-g},C);for(let b=u.length-1;b>=0;b--){const S=u[b];f=P(f,S),g=Math.min(g,S.offset),a=Math.max(a,S.offset+S.length),a+=S.content.length-S.length}const E=k.length-(f.length-a)-g;return[{offset:g,length:E,content:f.substring(g,a)}]}e.withFormatting=y;function P(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=P;function D(k,i){let C=i.slice(0).sort((g,a)=>{const u=g.offset-a.offset;return u===0?g.length-a.length:u}),f=k.length;for(let g=C.length-1;g>=0;g--){let a=C[g];if(a.offset+a.length<=f)k=P(k,a);else throw new Error("Overlapping edit");f=a.offset}return k}e.applyEdits=D}),define(ge[134],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new _(()=>T(this.getValue()))}}e.Lazy=_}),define(ge[6],pe([0,1,71,54]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let A=null;function y(d){A=d}if(e.setDisposableTracker=y,T){const d="__is_disposable_tracked__";A=new class{trackDisposable(l){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[d]||console.log(m)},3e3)}markTracked(l){if(l&&l!==u.None)try{l[d]=!0}catch(m){}}}}function P(d){!A||A.markTracked(d)}function D(d){return A&&A.trackDisposable(d),d}e.trackDisposable=D;class k extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=k;function i(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=i;function C(d){if(I.Iterable.is(d)){let l=[];for(const m of d)if(m){P(m);try{m.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new k(l);return Array.isArray(d)?[]:d}else if(d)return P(d),d.dispose(),d}e.dispose=C;function f(...d){return d.forEach(P),g(()=>C(d))}e.combinedDisposable=f;function g(d){const l=D({dispose:()=>{P(l),d()}});return l}e.toDisposable=g;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return P(l),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new a,D(this)}dispose(){P(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var m;this._isDisposed||l===this._value||((m=this._value)===null||m===void 0||m.dispose(),l&&P(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,P(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=E;class b{constructor(){this.references=new Map}acquire(l,...m){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...m)},this.references.set(l,t));const{object:n}=t,s=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=b;class S{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=S}),define(ge[56],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(A){this.element=A,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class I{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const P=new _(A);if(this._first===_.Undefined)this._first=P,this._last=P;else if(y){const k=this._last;this._last=P,P.prev=k,k.next=P}else{const k=this._first;this._first=P,P.next=k,k.prev=P}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(P))}}shift(){if(this._first!==_.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==_.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==_.Undefined&&A.next!==_.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===_.Undefined&&A.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):A.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):A.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==_.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,se){for(var he=0;he<se.length;he++){var J=se[he];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(K,J.key,J)}}function e(K,se,he){return se&&G(K.prototype,se),he&&G(K,he),K}function _(K,se){if(!!K){if(typeof K=="string")return I(K,se);var he=Object.prototype.toString.call(K).slice(8,-1);if(he==="Object"&&K.constructor&&(he=K.constructor.name),he==="Map"||he==="Set")return Array.from(K);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(K,se)}}function I(K,se){(se==null||se>K.length)&&(se=K.length);for(var he=0,J=new Array(se);he<se;he++)J[he]=K[he];return J}function T(K,se){var he;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(he=_(K))||se&&K&&typeof K.length=="number"){he&&(K=he);var J=0;return function(){return J>=K.length?{done:!0}:{done:!1,value:K[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=K[Symbol.iterator](),he.next.bind(he)}function A(K){var se={exports:{}};return K(se,se.exports),se.exports}var y=A(function(K){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(J){K.exports.defaults=J}K.exports={defaults:se(),getDefaults:se,changeDefaults:he}}),P=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(se){return C[se]};function g(K,se){if(se){if(P.test(K))return K.replace(D,f)}else if(k.test(K))return K.replace(i,f);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(K){return K.replace(a,function(se,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var E=/(^|[^\[])\^/g;function b(K,se){K=K.source||K,se=se||"";var he={replace:function(ne,ce){return ce=ce.source||ce,ce=ce.replace(E,"$1"),K=K.replace(ne,ce),he},getRegex:function(){return new RegExp(K,se)}};return he}var S=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(K,se,he){if(K){var J;try{J=decodeURIComponent(u(he)).replace(S,"").toLowerCase()}catch(ne){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}se&&!d.test(he)&&(he=r(se,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ne){return null}return he}var m={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,se){m[" "+K]||(t.test(K)?m[" "+K]=K+"/":m[" "+K]=v(K,"/",!0)),K=m[" "+K];var he=K.indexOf(":")===-1;return se.substring(0,2)==="//"?he?se:K.replace(n,"$1")+se:se.charAt(0)==="/"?he?se:K.replace(s,"$1")+se:K+se}var o={exec:function(){}};function c(K){for(var se=1,he,J;se<arguments.length;se++){he=arguments[se];for(J in he)Object.prototype.hasOwnProperty.call(he,J)&&(K[J]=he[J])}return K}function p(K,se){var he=K.replace(/\|/g,function(ce,ve,ye){for(var je=!1,He=ve;--He>=0&&ye[He]==="\\";)je=!je;return je?"|":" |"}),J=he.split(/ \|/),ne=0;if(J.length>se)J.splice(se);else for(;J.length<se;)J.push("");for(;ne<J.length;ne++)J[ne]=J[ne].trim().replace(/\\\|/g,"|");return J}function v(K,se,he){var J=K.length;if(J===0)return"";for(var ne=0;ne<J;){var ce=K.charAt(J-ne-1);if(ce===se&&!he)ne++;else if(ce!==se&&he)ne++;else break}return K.substr(0,J-ne)}function h(K,se){if(K.indexOf(se[1])===-1)return-1;for(var he=K.length,J=0,ne=0;ne<he;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===se[0])J++;else if(K[ne]===se[1]&&(J--,J<0))return ne;return-1}function w(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(K,se){if(se<1)return"";for(var he="";se>1;)se&1&&(he+=K),se>>=1,K+=K;return he+K}var N={escape:g,unescape:u,edit:b,cleanUrl:l,resolveUrl:r,noopTest:o,merge:c,splitCells:p,rtrim:v,findClosingBracket:h,checkSanitizeDeprecation:w,repeatString:R},j=y.defaults,re=N.rtrim,V=N.splitCells,W=N.escape,$=N.findClosingBracket;function U(K,se,he){var J=se.href,ne=se.title?W(se.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:he,href:J,title:ne,text:ce}:{type:"image",raw:he,href:J,title:ne,text:W(ce)}}function F(K,se){var he=K.match(/^(\s+)(?:```)/);if(he===null)return se;var J=he[1];return se.split(`
`).map(function(ne){var ce=ne.match(/^\s+/);if(ce===null)return ne;var ve=ce[0];return ve.length>=J.length?ne.slice(J.length):ne}).join(`
`)}var M=function(){function K(he){this.options=he||j}var se=K.prototype;return se.space=function(J){var ne=this.rules.block.newline.exec(J);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},se.code=function(J){var ne=this.rules.block.code.exec(J);if(ne){var ce=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:re(ce,`
`)}}},se.fences=function(J){var ne=this.rules.block.fences.exec(J);if(ne){var ce=ne[0],ve=F(ce,ne[3]||"");return{type:"code",raw:ce,lang:ne[2]?ne[2].trim():ne[2],text:ve}}},se.heading=function(J){var ne=this.rules.block.heading.exec(J);if(ne){var ce=ne[2].trim();if(/#$/.test(ce)){var ve=re(ce,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(ce=ve.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:ce}}},se.nptable=function(J){var ne=this.rules.block.nptable.exec(J);if(ne){var ce={type:"table",header:V(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(ce.header.length===ce.align.length){var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=V(ce.cells[ye],ce.header.length);return ce}}},se.hr=function(J){var ne=this.rules.block.hr.exec(J);if(ne)return{type:"hr",raw:ne[0]}},se.blockquote=function(J){var ne=this.rules.block.blockquote.exec(J);if(ne){var ce=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:ce}}},se.list=function(J){var ne=this.rules.block.list.exec(J);if(ne){var ce=ne[0],ve=ne[2],ye=ve.length>1,je={type:"list",raw:ce,ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]},He=ne[0].match(this.rules.block.item),We=!1,Ge,nt,dt,it,Ye,mt,wt,Ee,fe=He.length;dt=this.rules.block.listItemStart.exec(He[0]);for(var ae=0;ae<fe;ae++){if(Ge=He[ae],ce=Ge,ae!==fe-1){if(it=this.rules.block.listItemStart.exec(He[ae+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){He.splice(ae,2,He[ae]+`
`+He[ae+1]),ae--,fe--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==ve[ve.length-1]:ye===(it[2].length===1))&&(Ye=He.slice(ae+1).join(`
`),je.raw=je.raw.substring(0,je.raw.length-Ye.length),ae=fe-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=We||/\n\n(?!\s*$)/.test(Ge),ae!==fe-1&&(We=Ge.charAt(Ge.length-1)===`
`,mt||(mt=We)),mt&&(je.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Ge),Ee=void 0,wt&&(Ee=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:ce,task:wt,checked:Ee,loose:mt,text:Ge})}return je}},se.html=function(J){var ne=this.rules.block.html.exec(J);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]):ne[0]}},se.def=function(J){var ne=this.rules.block.def.exec(J);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ce=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ne[0],href:ne[2],title:ne[3]}}},se.table=function(J){var ne=this.rules.block.table.exec(J);if(ne){var ce={type:"table",header:V(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ne[0];var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=V(ce.cells[ye].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},se.lheading=function(J){var ne=this.rules.block.lheading.exec(J);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},se.paragraph=function(J){var ne=this.rules.block.paragraph.exec(J);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},se.text=function(J){var ne=this.rules.block.text.exec(J);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},se.escape=function(J){var ne=this.rules.inline.escape.exec(J);if(ne)return{type:"escape",raw:ne[0],text:W(ne[1])}},se.tag=function(J,ne,ce){var ve=this.rules.inline.tag.exec(J);if(ve)return!ne&&/^<a /i.test(ve[0])?ne=!0:ne&&/^<\/a>/i.test(ve[0])&&(ne=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:ne,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):W(ve[0]):ve[0]}},se.link=function(J){var ne=this.rules.inline.link.exec(J);if(ne){var ce=ne[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var ve=re(ce.slice(0,-1),"\\");if((ce.length-ve.length)%2==0)return}else{var ye=$(ne[2],"()");if(ye>-1){var je=ne[0].indexOf("!")===0?5:4,He=je+ne[1].length+ye;ne[2]=ne[2].substring(0,ye),ne[0]=ne[0].substring(0,He).trim(),ne[3]=""}}var We=ne[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);nt&&(We=nt[1],Ge=nt[3])}else Ge=ne[3]?ne[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(ce)?We=We.slice(1):We=We.slice(1,-1)),U(ne,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},ne[0])}},se.reflink=function(J,ne){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var ve=(ce[2]||ce[1]).replace(/\s+/g," ");if(ve=ne[ve.toLowerCase()],!ve||!ve.href){var ye=ce[0].charAt(0);return{type:"text",raw:ye,text:ye}}return U(ce,ve,ce[0])}},se.emStrong=function(J,ne,ce){ce===void 0&&(ce="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(!!ve&&!(ve[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=ve[1]||ve[2]||"";if(!ye||ye&&(ce===""||this.rules.inline.punctuation.exec(ce))){var je=ve[0].length-1,He,We,Ge=je,nt=0,dt=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,ne=ne.slice(-1*J.length+je);(ve=dt.exec(ne))!=null;)if(He=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!He){if(We=He.length,ve[3]||ve[4]){Ge+=We;continue}else if((ve[5]||ve[6])&&je%3&&!((je+We)%3)){nt+=We;continue}if(Ge-=We,!(Ge>0)){if(Ge+nt-We<=0&&!ne.slice(dt.lastIndex).match(dt)&&(We=Math.min(We,We+Ge+nt)),Math.min(je,We)%2)return{type:"em",raw:J.slice(0,je+ve.index+We+1),text:J.slice(1,je+ve.index+We)};if(Math.min(je,We)%2==0)return{type:"strong",raw:J.slice(0,je+ve.index+We+1),text:J.slice(2,je+ve.index+We-1)}}}}}},se.codespan=function(J){var ne=this.rules.inline.code.exec(J);if(ne){var ce=ne[2].replace(/\n/g," "),ve=/[^ ]/.test(ce),ye=/^ /.test(ce)&&/ $/.test(ce);return ve&&ye&&(ce=ce.substring(1,ce.length-1)),ce=W(ce,!0),{type:"codespan",raw:ne[0],text:ce}}},se.br=function(J){var ne=this.rules.inline.br.exec(J);if(ne)return{type:"br",raw:ne[0]}},se.del=function(J){var ne=this.rules.inline.del.exec(J);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},se.autolink=function(J,ne){var ce=this.rules.inline.autolink.exec(J);if(ce){var ve,ye;return ce[2]==="@"?(ve=W(this.options.mangle?ne(ce[1]):ce[1]),ye="mailto:"+ve):(ve=W(ce[1]),ye=ve),{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},se.url=function(J,ne){var ce;if(ce=this.rules.inline.url.exec(J)){var ve,ye;if(ce[2]==="@")ve=W(this.options.mangle?ne(ce[0]):ce[0]),ye="mailto:"+ve;else{var je;do je=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(je!==ce[0]);ve=W(ce[0]),ce[1]==="www."?ye="http://"+ve:ye=ve}return{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},se.inlineText=function(J,ne,ce){var ve=this.rules.inline.text.exec(J);if(ve){var ye;return ne?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):W(ve[0]):ve[0]:ye=W(this.options.smartypants?ce(ve[0]):ve[0]),{type:"text",raw:ve[0],text:ye}}},K}(),L=N.noopTest,O=N.edit,B=N.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=B({},q),q.gfm=B({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=B({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:q,inline:Q},be=y.defaults,Ae=de.block,Ce=de.inline,Le=N.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(K){var se="",he,J,ne=K.length;for(he=0;he<ne;he++)J=K.charCodeAt(he),Math.random()>.5&&(J="x"+J.toString(16)),se+="&#"+J+";";return se}var ee=function(){function K(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||be,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var J={block:Ae.normal,inline:Ce.normal};this.options.pedantic?(J.block=Ae.pedantic,J.inline=Ce.pedantic):this.options.gfm&&(J.block=Ae.gfm,this.options.breaks?J.inline=Ce.breaks:J.inline=Ce.gfm),this.tokenizer.rules=J}K.lex=function(J,ne){var ce=new K(ne);return ce.lex(J)},K.lexInline=function(J,ne){var ce=new K(ne);return ce.inlineTokens(J)};var se=K.prototype;return se.lex=function(J){return J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(J,ne,ce){ne===void 0&&(ne=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var ve,ye,je,He;J;){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.type&&ne.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),He=ne[ne.length-1],He&&He.type==="paragraph"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):ne.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.nptable(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],ce),ne.push(ve);continue}if(ve=this.tokenizer.list(J)){for(J=J.substring(ve.raw.length),je=ve.items.length,ye=0;ye<je;ye++)ve.items[ye].tokens=this.blockTokens(ve.items[ye].text,[],!1);ne.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ce&&(ve=this.tokenizer.def(J))){J=J.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ce&&(ve=this.tokenizer.paragraph(J))){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):ne.push(ve);continue}if(J){var We="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return ne},se.inline=function(J){var ne,ce,ve,ye,je,He,We=J.length;for(ne=0;ne<We;ne++)switch(He=J[ne],He.type){case"paragraph":case"text":case"heading":{He.tokens=[],this.inlineTokens(He.text,He.tokens);break}case"table":{for(He.tokens={header:[],cells:[]},ye=He.header.length,ce=0;ce<ye;ce++)He.tokens.header[ce]=[],this.inlineTokens(He.header[ce],He.tokens.header[ce]);for(ye=He.cells.length,ce=0;ce<ye;ce++)for(je=He.cells[ce],He.tokens.cells[ce]=[],ve=0;ve<je.length;ve++)He.tokens.cells[ce][ve]=[],this.inlineTokens(je[ve],He.tokens.cells[ce][ve]);break}case"blockquote":{this.inline(He.tokens);break}case"list":{for(ye=He.items.length,ce=0;ce<ye;ce++)this.inline(He.items[ce].tokens);break}}return J},se.inlineTokens=function(J,ne,ce,ve){ne===void 0&&(ne=[]),ce===void 0&&(ce=!1),ve===void 0&&(ve=!1);var ye,je,He=J,We,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)dt.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,We.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.tag(J,ce,ve)){J=J.substring(ye.raw.length),ce=ye.inLink,ve=ye.inRawBlock;var it=ne[ne.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):ne.push(ye);continue}if(ye=this.tokenizer.link(J)){J=J.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,ve)),ne.push(ye);continue}if(ye=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ye.raw.length);var Ye=ne[ne.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,ve),ne.push(ye)):Ye&&ye.type==="text"&&Ye.type==="text"?(Ye.raw+=ye.raw,Ye.text+=ye.text):ne.push(ye);continue}if(ye=this.tokenizer.emStrong(J,He,nt)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),ne.push(ye);continue}if(ye=this.tokenizer.codespan(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.br(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.del(J)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),ne.push(ye);continue}if(ye=this.tokenizer.autolink(J,Y)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(!ce&&(ye=this.tokenizer.url(J,Y))){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.inlineText(J,ve,z)){J=J.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,je=ne[ne.length-1],je&&je.type==="text"?(je.raw+=ye.raw,je.text+=ye.text):ne.push(ye);continue}if(J){var mt="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Ce}}}]),K}(),le=y.defaults,me=N.cleanUrl,De=N.escape,Oe=function(){function K(he){this.options=he||le}var se=K.prototype;return se.code=function(J,ne,ce){var ve=(ne||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(J,ve);ye!=null&&ye!==J&&(ce=!0,J=ye)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+De(ve,!0)+'">'+(ce?J:De(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:De(J,!0))+`</code></pre>
`},se.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},se.html=function(J){return J},se.heading=function(J,ne,ce,ve){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+ve.slug(ce)+'">'+J+"</h"+ne+`>
`:"<h"+ne+">"+J+"</h"+ne+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(J,ne,ce){var ve=ne?"ol":"ul",ye=ne&&ce!==1?' start="'+ce+'"':"";return"<"+ve+ye+`>
`+J+"</"+ve+`>
`},se.listitem=function(J){return"<li>"+J+`</li>
`},se.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(J){return"<p>"+J+`</p>
`},se.table=function(J,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ne+`</table>
`},se.tablerow=function(J){return`<tr>
`+J+`</tr>
`},se.tablecell=function(J,ne){var ce=ne.header?"th":"td",ve=ne.align?"<"+ce+' align="'+ne.align+'">':"<"+ce+">";return ve+J+"</"+ce+`>
`},se.strong=function(J){return"<strong>"+J+"</strong>"},se.em=function(J){return"<em>"+J+"</em>"},se.codespan=function(J){return"<code>"+J+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(J){return"<del>"+J+"</del>"},se.link=function(J,ne,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<a href="'+De(J)+'"';return ne&&(ve+=' title="'+ne+'"'),ve+=">"+ce+"</a>",ve},se.image=function(J,ne,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<img src="'+J+'" alt="'+ce+'"';return ne&&(ve+=' title="'+ne+'"'),ve+=this.options.xhtml?"/>":">",ve},se.text=function(J){return J},K}(),we=function(){function K(){}var se=K.prototype;return se.strong=function(J){return J},se.em=function(J){return J},se.codespan=function(J){return J},se.del=function(J){return J},se.html=function(J){return J},se.text=function(J){return J},se.link=function(J,ne,ce){return""+ce},se.image=function(J,ne,ce){return""+ce},se.br=function(){return""},K}(),Pe=function(){function K(){this.seen={}}var se=K.prototype;return se.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(J,ne){var ce=J,ve=0;if(this.seen.hasOwnProperty(ce)){ve=this.seen[J];do ve++,ce=J+"-"+ve;while(this.seen.hasOwnProperty(ce))}return ne||(this.seen[J]=ve,this.seen[ce]=0),ce},se.slug=function(J,ne){ne===void 0&&(ne={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,ne.dryrun)},K}(),Re=y.defaults,Be=N.unescape,Se=function(){function K(he){this.options=he||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new Pe}K.parse=function(J,ne){var ce=new K(ne);return ce.parse(J)},K.parseInline=function(J,ne){var ce=new K(ne);return ce.parseInline(J)};var se=K.prototype;return se.parse=function(J,ne){ne===void 0&&(ne=!0);var ce="",ve,ye,je,He,We,Ge,nt,dt,it,Ye,mt,wt,Ee,fe,ae,Z,Fe,Te,Qe=J.length;for(ve=0;ve<Qe;ve++)switch(Ye=J[ve],Ye.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Be(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(dt="",nt="",He=Ye.header.length,ye=0;ye<He;ye++)nt+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ye]),{header:!0,align:Ye.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",He=Ye.cells.length,ye=0;ye<He;ye++){for(Ge=Ye.tokens.cells[ye],nt="",We=Ge.length,je=0;je<We;je++)nt+=this.renderer.tablecell(this.parseInline(Ge[je]),{header:!1,align:Ye.align[je]});it+=this.renderer.tablerow(nt)}ce+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Ye.tokens),ce+=this.renderer.blockquote(it);continue}case"list":{for(mt=Ye.ordered,wt=Ye.start,Ee=Ye.loose,He=Ye.items.length,it="",ye=0;ye<He;ye++)ae=Ye.items[ye],Z=ae.checked,Fe=ae.task,fe="",ae.task&&(Te=this.renderer.checkbox(Z),Ee?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Te+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Te+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Te}):fe+=Te),fe+=this.parse(ae.tokens,Ee),it+=this.renderer.listitem(fe,Fe,Z);ce+=this.renderer.list(it,mt,wt);continue}case"html":{ce+=this.renderer.html(Ye.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(it=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;ve+1<Qe&&J[ve+1].type==="text";)Ye=J[++ve],it+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);ce+=ne?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ce},se.parseInline=function(J,ne){ne=ne||this.renderer;var ce="",ve,ye,je=J.length;for(ve=0;ve<je;ve++)switch(ye=J[ve],ye.type){case"escape":{ce+=ne.text(ye.text);break}case"html":{ce+=ne.html(ye.text);break}case"link":{ce+=ne.link(ye.href,ye.title,this.parseInline(ye.tokens,ne));break}case"image":{ce+=ne.image(ye.href,ye.title,ye.text);break}case"strong":{ce+=ne.strong(this.parseInline(ye.tokens,ne));break}case"em":{ce+=ne.em(this.parseInline(ye.tokens,ne));break}case"codespan":{ce+=ne.codespan(ye.text);break}case"br":{ce+=ne.br();break}case"del":{ce+=ne.del(this.parseInline(ye.tokens,ne));break}case"text":{ce+=ne.text(ye.text);break}default:{var He='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}return ce},K}(),qe=N.merge,X=N.checkSanitizeDeprecation,ie=N.escape,_e=y.getDefaults,Ne=y.changeDefaults,ze=y.defaults;function $e(K,se,he){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof se=="function"&&(he=se,se=null),se=qe({},$e.defaults,se||{}),X(se),he){var J=se.highlight,ne;try{ne=ee.lex(K,se)}catch(je){return he(je)}var ce=function(He){var We;if(!He)try{We=Se.parse(ne,se)}catch(Ge){He=Ge}return se.highlight=J,He?he(He):he(null,We)};if(!J||J.length<3||(delete se.highlight,!ne.length))return ce();var ve=0;$e.walkTokens(ne,function(je){je.type==="code"&&(ve++,setTimeout(function(){J(je.text,je.lang,function(He,We){if(He)return ce(He);We!=null&&We!==je.text&&(je.text=We,je.escaped=!0),ve--,ve===0&&ce()})},0))}),ve===0&&ce();return}try{var ye=ee.lex(K,se);return se.walkTokens&&$e.walkTokens(ye,se.walkTokens),Se.parse(ye,se)}catch(je){if(je.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(je.message+"",!0)+"</pre>";throw je}}$e.options=$e.setOptions=function(K){return qe($e.defaults,K),Ne($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(K){var se=qe({},K);if(K.renderer&&function(){var J=$e.defaults.renderer||new Oe,ne=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ge=0;Ge<He;Ge++)We[Ge]=arguments[Ge];var nt=K.renderer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in K.renderer)ne(ce);se.renderer=J}(),K.tokenizer&&function(){var J=$e.defaults.tokenizer||new M,ne=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ge=0;Ge<He;Ge++)We[Ge]=arguments[Ge];var nt=K.tokenizer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in K.tokenizer)ne(ce);se.tokenizer=J}(),K.walkTokens){var he=$e.defaults.walkTokens;se.walkTokens=function(J){K.walkTokens(J),he&&he(J)}}$e.setOptions(se)},$e.walkTokens=function(K,se){for(var he=T(K),J;!(J=he()).done;){var ne=J.value;switch(se(ne),ne.type){case"table":{for(var ce=T(ne.tokens.header),ve;!(ve=ce()).done;){var ye=ve.value;$e.walkTokens(ye,se)}for(var je=T(ne.tokens.cells),He;!(He=je()).done;)for(var We=He.value,Ge=T(We),nt;!(nt=Ge()).done;){var dt=nt.value;$e.walkTokens(dt,se)}break}case"list":{$e.walkTokens(ne.items,se);break}default:ne.tokens&&$e.walkTokens(ne.tokens,se)}}},$e.parseInline=function(K,se){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");se=qe({},$e.defaults,se||{}),X(se);try{var he=ee.lexInline(K,se);return se.walkTokens&&$e.walkTokens(he,se.walkTokens),Se.parseInline(he,se)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(J.message+"",!0)+"</pre>";throw J}},$e.Parser=Se,$e.parser=Se.parse,$e.Renderer=Oe,$e.TextRenderer=we,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=M,$e.Slugger=Pe,$e.parse=$e;var Je=$e;return Je}),define(ge[73],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(y,P,D){return Math.min(Math.max(y,P),D)}e.clamp=_;function I(y,P){return(P+y%P)%P}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function G(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function y(D){A.push(D,Date.now())}function P(){const D=[];for(let k=0;k<A.length;k+=2)D.push({name:A[k],startTime:A[k+1]});return D}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(T+y.startTime)});return A}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function _(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=_(I))})(),define(ge[10],pe([0,1]),function(G,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,A=!1,y=!1,P=!1,D=!1,k=!1,i=!1,C,f=I,g,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const E=typeof((_=u==null?void 0:u.versions)===null||_===void 0?void 0:_.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=E&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,T=a.indexOf("Windows")>=0,A=a.indexOf("Macintosh")>=0,i=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,k=!0,C=navigator.language,f=C;else if(typeof u=="object"){T=u.platform==="win32",A=u.platform==="darwin",y=u.platform==="linux",P=y&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,C=I,f=I;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),c=o.availableLanguages["*"];C=o.locale,f=c||I,g=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let d=0;A?d=1:T?d=3:y&&(d=2),e.isWindows=T,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=P,e.isNative=D,e.isWeb=k,e.isIOS=i,e.platform=d,e.userAgent=a,e.language=f;var l;(function(r){function o(){return e.language}r.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=c;function p(){return e.language==="en"}r.isDefault=p})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let h=0,w=c.length;h<w;h++){const R=c[h];if(R.id===v.data.vscodeSetImmediateId){c.splice(h,1),R.callback();return}}});let p=0;return v=>{const h=++p;c.push({id:h,callback:v}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const o=Promise.resolve();return c=>o.then(c)}();var m;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||i?2:T?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(ge[36],pe([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof _.globals.vscode!="undefined"){const T=_.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(A){return(0,_.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(T){return(0,_.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(ge[8],pe([0,1,36]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,A=90,y=122,P=46,D=47,k=92,i=58,C=63;class f extends Error{constructor(l,m,t){let n;typeof m=="string"&&m.indexOf("not ")===0?(n="must not be",m=m.replace(/^not /,"")):n="must be";const s=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${s} ${n} of type ${m}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(d,l){if(typeof d!="string")throw new f(l,"string",d)}function a(d){return d===D||d===k}function u(d){return d===D}function E(d){return d>=I&&d<=A||d>=T&&d<=y}function b(d,l,m,t){let n="",s=0,r=-1,o=0,c=0;for(let p=0;p<=d.length;++p){if(p<d.length)c=d.charCodeAt(p);else{if(t(c))break;c=D}if(t(c)){if(!(r===p-1||o===1))if(o===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const v=n.lastIndexOf(m);v===-1?(n="",s=0):(n=n.slice(0,v),s=n.length-1-n.lastIndexOf(m)),r=p,o=0;continue}else if(n.length!==0){n="",s=0,r=p,o=0;continue}}l&&(n+=n.length>0?`${m}..`:"..",s=2)}else n.length>0?n+=`${m}${d.slice(r+1,p)}`:n=d.slice(r+1,p),s=p-r-1;r=p,o=0}else c===P&&o!==-1?++o:o=-1}return n}function S(d,l){if(l===null||typeof l!="object")throw new f("pathObject","Object",l);const m=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return m?m===l.root?`${m}${t}`:`${m}${d}${t}`:t}e.win32={resolve(...d){let l="",m="",t=!1;for(let n=d.length-1;n>=-1;n--){let s;if(n>=0){if(s=d[n],g(s,"path"),s.length===0)continue}else l.length===0?s=_.cwd():(s=_.env[`=${l}`]||_.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${l}\\`));const r=s.length;let o=0,c="",p=!1;const v=s.charCodeAt(0);if(r===1)a(v)&&(o=1,p=!0);else if(a(v))if(p=!0,a(s.charCodeAt(1))){let h=2,w=h;for(;h<r&&!a(s.charCodeAt(h));)h++;if(h<r&&h!==w){const R=s.slice(w,h);for(w=h;h<r&&a(s.charCodeAt(h));)h++;if(h<r&&h!==w){for(w=h;h<r&&!a(s.charCodeAt(h));)h++;(h===r||h!==w)&&(c=`\\\\${R}\\${s.slice(w,h)}`,o=h)}}}else o=1;else E(v)&&s.charCodeAt(1)===i&&(c=s.slice(0,2),o=2,r>2&&a(s.charCodeAt(2))&&(p=!0,o=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(t){if(l.length>0)break}else if(m=`${s.slice(o)}\\${m}`,t=p,p&&l.length>0)break}return m=b(m,!t,"\\",a),t?`${l}\\${m}`:`${l}${m}`||"."},normalize(d){g(d,"path");const l=d.length;if(l===0)return".";let m=0,t,n=!1;const s=d.charCodeAt(0);if(l===1)return u(s)?"\\":d;if(a(s))if(n=!0,a(d.charCodeAt(1))){let o=2,c=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==c){const p=d.slice(c,o);for(c=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return`\\\\${p}\\${d.slice(c)}\\`;o!==c&&(t=`\\\\${p}\\${d.slice(c,o)}`,m=o)}}}else m=1;else E(s)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),m=2,l>2&&a(d.charCodeAt(2))&&(n=!0,m=3));let r=m<l?b(d.slice(m),!n,"\\",a):"";return r.length===0&&!n&&(r="."),r.length>0&&a(d.charCodeAt(l-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(d){g(d,"path");const l=d.length;if(l===0)return!1;const m=d.charCodeAt(0);return a(m)||l>2&&E(m)&&d.charCodeAt(1)===i&&a(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,m;for(let s=0;s<d.length;++s){const r=d[s];g(r,"path"),r.length>0&&(l===void 0?l=m=r:l+=`\\${r}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof m=="string"&&a(m.charCodeAt(0))){++n;const s=m.length;s>1&&a(m.charCodeAt(1))&&(++n,s>2&&(a(m.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&a(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(d,l){if(g(d,"from"),g(l,"to"),d===l)return"";const m=e.win32.resolve(d),t=e.win32.resolve(l);if(m===t||(d=m.toLowerCase(),l=t.toLowerCase(),d===l))return"";let n=0;for(;n<d.length&&d.charCodeAt(n)===k;)n++;let s=d.length;for(;s-1>n&&d.charCodeAt(s-1)===k;)s--;const r=s-n;let o=0;for(;o<l.length&&l.charCodeAt(o)===k;)o++;let c=l.length;for(;c-1>o&&l.charCodeAt(c-1)===k;)c--;const p=c-o,v=r<p?r:p;let h=-1,w=0;for(;w<v;w++){const N=d.charCodeAt(n+w);if(N!==l.charCodeAt(o+w))break;N===k&&(h=w)}if(w!==v){if(h===-1)return t}else{if(p>v){if(l.charCodeAt(o+w)===k)return t.slice(o+w+1);if(w===2)return t.slice(o+w)}r>v&&(d.charCodeAt(n+w)===k?h=w:w===2&&(h=3)),h===-1&&(h=0)}let R="";for(w=n+h+1;w<=s;++w)(w===s||d.charCodeAt(w)===k)&&(R+=R.length===0?"..":"\\..");return o+=h,R.length>0?`${R}${t.slice(o,c)}`:(t.charCodeAt(o)===k&&++o,t.slice(o,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===k){if(l.charCodeAt(1)===k){const m=l.charCodeAt(2);if(m!==C&&m!==P)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(E(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===k)return`\\\\?\\${l}`;return d},dirname(d){g(d,"path");const l=d.length;if(l===0)return".";let m=-1,t=0;const n=d.charCodeAt(0);if(l===1)return a(n)?d:".";if(a(n)){if(m=t=1,a(d.charCodeAt(1))){let o=2,c=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return d;o!==c&&(m=t=o+1)}}}}else E(n)&&d.charCodeAt(1)===i&&(m=l>2&&a(d.charCodeAt(2))?3:2,t=m);let s=-1,r=!0;for(let o=l-1;o>=t;--o)if(a(d.charCodeAt(o))){if(!r){s=o;break}}else r=!1;if(s===-1){if(m===-1)return".";s=m}return d.slice(0,s)},basename(d,l){l!==void 0&&g(l,"ext"),g(d,"path");let m=0,t=-1,n=!0,s;if(d.length>=2&&E(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(m=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let r=l.length-1,o=-1;for(s=d.length-1;s>=m;--s){const c=d.charCodeAt(s);if(a(c)){if(!n){m=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(c===l.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return m===t?t=o:t===-1&&(t=d.length),d.slice(m,t)}for(s=d.length-1;s>=m;--s)if(a(d.charCodeAt(s))){if(!n){m=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":d.slice(m,t)},extname(d){g(d,"path");let l=0,m=-1,t=0,n=-1,s=!0,r=0;d.length>=2&&d.charCodeAt(1)===i&&E(d.charCodeAt(0))&&(l=t=2);for(let o=d.length-1;o>=l;--o){const c=d.charCodeAt(o);if(a(c)){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),c===P?m===-1?m=o:r!==1&&(r=1):m!==-1&&(r=-1)}return m===-1||n===-1||r===0||r===1&&m===n-1&&m===t+1?"":d.slice(m,n)},format:S.bind(null,"\\"),parse(d){g(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const m=d.length;let t=0,n=d.charCodeAt(0);if(m===1)return a(n)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(a(n)){if(t=1,a(d.charCodeAt(1))){let h=2,w=h;for(;h<m&&!a(d.charCodeAt(h));)h++;if(h<m&&h!==w){for(w=h;h<m&&a(d.charCodeAt(h));)h++;if(h<m&&h!==w){for(w=h;h<m&&!a(d.charCodeAt(h));)h++;h===m?t=h:h!==w&&(t=h+1)}}}}else if(E(n)&&d.charCodeAt(1)===i){if(m<=2)return l.root=l.dir=d,l;if(t=2,a(d.charCodeAt(2))){if(m===3)return l.root=l.dir=d,l;t=3}}t>0&&(l.root=d.slice(0,t));let s=-1,r=t,o=-1,c=!0,p=d.length-1,v=0;for(;p>=t;--p){if(n=d.charCodeAt(p),a(n)){if(!c){r=p+1;break}continue}o===-1&&(c=!1,o=p+1),n===P?s===-1?s=p:v!==1&&(v=1):s!==-1&&(v=-1)}return o!==-1&&(s===-1||v===0||v===1&&s===o-1&&s===r+1?l.base=l.name=d.slice(r,o):(l.name=d.slice(r,s),l.base=d.slice(r,o),l.ext=d.slice(s,o))),r>0&&r!==t?l.dir=d.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",m=!1;for(let t=d.length-1;t>=-1&&!m;t--){const n=t>=0?d[t]:_.cwd();g(n,"path"),n.length!==0&&(l=`${n}/${l}`,m=n.charCodeAt(0)===D)}return l=b(l,!m,"/",u),m?`/${l}`:l.length>0?l:"."},normalize(d){if(g(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===D,m=d.charCodeAt(d.length-1)===D;return d=b(d,!l,"/",u),d.length===0?l?"/":m?"./":".":(m&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return g(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let l;for(let m=0;m<d.length;++m){const t=d[m];g(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(g(d,"from"),g(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const m=1,t=d.length,n=t-m,s=1,r=l.length-s,o=n<r?n:r;let c=-1,p=0;for(;p<o;p++){const h=d.charCodeAt(m+p);if(h!==l.charCodeAt(s+p))break;h===D&&(c=p)}if(p===o)if(r>o){if(l.charCodeAt(s+p)===D)return l.slice(s+p+1);if(p===0)return l.slice(s+p)}else n>o&&(d.charCodeAt(m+p)===D?c=p:p===0&&(c=0));let v="";for(p=m+c+1;p<=t;++p)(p===t||d.charCodeAt(p)===D)&&(v+=v.length===0?"..":"/..");return`${v}${l.slice(s+c)}`},toNamespacedPath(d){return d},dirname(d){if(g(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===D;let m=-1,t=!0;for(let n=d.length-1;n>=1;--n)if(d.charCodeAt(n)===D){if(!t){m=n;break}}else t=!1;return m===-1?l?"/":".":l&&m===1?"//":d.slice(0,m)},basename(d,l){l!==void 0&&g(l,"ext"),g(d,"path");let m=0,t=-1,n=!0,s;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let r=l.length-1,o=-1;for(s=d.length-1;s>=0;--s){const c=d.charCodeAt(s);if(c===D){if(!n){m=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(c===l.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return m===t?t=o:t===-1&&(t=d.length),d.slice(m,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===D){if(!n){m=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":d.slice(m,t)},extname(d){g(d,"path");let l=-1,m=0,t=-1,n=!0,s=0;for(let r=d.length-1;r>=0;--r){const o=d.charCodeAt(r);if(o===D){if(!n){m=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===P?l===-1?l=r:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||t===-1||s===0||s===1&&l===t-1&&l===m+1?"":d.slice(l,t)},format:S.bind(null,"/"),parse(d){g(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const m=d.charCodeAt(0)===D;let t;m?(l.root="/",t=1):t=0;let n=-1,s=0,r=-1,o=!0,c=d.length-1,p=0;for(;c>=t;--c){const v=d.charCodeAt(c);if(v===D){if(!o){s=c+1;break}continue}r===-1&&(o=!1,r=c+1),v===P?n===-1?n=c:p!==1&&(p=1):n!==-1&&(p=-1)}if(r!==-1){const v=s===0&&m?1:s;n===-1||p===0||p===1&&n===r-1&&n===s+1?l.base=l.name=d.slice(v,r):(l.name=d.slice(v,n),l.base=d.slice(v,r),l.ext=d.slice(n,r))}return s>0?l.dir=d.slice(0,s-1):m&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[135],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var I;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(A,...y){const P=y.reduce((i,C)=>(i[C]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(i=>!P[i]).forEach(i=>{for(let C=0;C<D.length;C++)if(i.search(D[C])!==-1){delete A[i];break}})}e.sanitizeProcessEnvironment=T}),define(ge[47],pe([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=_.globals.performance&&typeof _.globals.performance.now=="function";class T{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new T(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],pe([0,1,18,71,6,56,47]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(b){b.None=()=>T.Disposable.None;function S(V){return(W,$=null,U)=>{let F=!1,M;return M=V(L=>{if(!F)return M?M.dispose():F=!0,W.call($,L)},null,U),F&&M.dispose(),M}}b.once=S;function d(V,W){return r(($,U=null,F)=>V(M=>$.call(U,W(M)),null,F))}b.map=d;function l(V,W){return r(($,U=null,F)=>V(M=>{W(M),$.call(U,M)},null,F))}b.forEach=l;function m(V,W){return r(($,U=null,F)=>V(M=>W(M)&&$.call(U,M),null,F))}b.filter=m;function t(V){return V}b.signal=t;function n(...V){return(W,$=null,U)=>(0,T.combinedDisposable)(...V.map(F=>F(M=>W.call($,M),null,U)))}b.any=n;function s(V,W,$){let U=$;return d(V,F=>(U=W(U,F),U))}b.reduce=s;function r(V){let W;const $=new f({onFirstListenerAdd(){W=V($.fire,$)},onLastListenerRemove(){W.dispose()}});return $.event}b.snapshot=r;function o(V,W,$=100,U=!1,F){let M,L,O,B=0;const q=new f({leakWarningThreshold:F,onFirstListenerAdd(){M=V(Q=>{B++,L=W(L,Q),U&&!O&&(q.fire(L),L=void 0),clearTimeout(O),O=setTimeout(()=>{const de=L;L=void 0,O=void 0,(!U||B>1)&&q.fire(de),B=0},$)})},onLastListenerRemove(){M.dispose()}});return q.event}b.debounce=o;function c(V){const W=new Date().getTime();return d(S(V),$=>new Date().getTime()-W)}b.stopwatch=c;function p(V){let W=!0,$;return m(V,U=>{const F=W||U!==$;return W=!1,$=U,F})}b.latch=p;function v(V,W=!1,$=[]){let U=$.slice(),F=V(O=>{U?U.push(O):L.fire(O)});const M=()=>{U&&U.forEach(O=>L.fire(O)),U=null},L=new f({onFirstListenerAdd(){F||(F=V(O=>L.fire(O)))},onFirstListenerDidAdd(){U&&(W?setTimeout(M):M())},onLastListenerRemove(){F&&F.dispose(),F=null}});return L.event}b.buffer=v;class h{constructor(W){this.event=W}map(W){return new h(d(this.event,W))}forEach(W){return new h(l(this.event,W))}filter(W){return new h(m(this.event,W))}reduce(W,$){return new h(s(this.event,W,$))}latch(){return new h(p(this.event))}debounce(W,$=100,U=!1,F){return new h(o(this.event,W,$,U,F))}on(W,$,U){return this.event(W,$,U)}once(W,$,U){return S(this.event)(W,$,U)}}function w(V){return new h(V)}b.chain=w;function R(V,W,$=U=>U){const U=(...O)=>L.fire($(...O)),F=()=>V.on(W,U),M=()=>V.removeListener(W,U),L=new f({onFirstListenerAdd:F,onLastListenerRemove:M});return L.event}b.fromNodeEventEmitter=R;function N(V,W,$=U=>U){const U=(...O)=>L.fire($(...O)),F=()=>V.addEventListener(W,U),M=()=>V.removeEventListener(W,U),L=new f({onFirstListenerAdd:F,onLastListenerRemove:M});return L.event}b.fromDOMEventEmitter=N;function j(V){const W=new f;let $=!1;return V.then(void 0,()=>null).then(()=>{$?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),$=!0,W.event}b.fromPromise=j;function re(V){return new Promise(W=>S(V)(W))}b.toPromise=re})(P=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function i(b){const S=k;return k=b,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(S,d=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let d=k;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||S<d)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),m=this._stacks.get(l)||0;if(this._stacks.set(l,m+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class f{constructor(S){var d;this._disposed=!1,this._options=S,this._leakageMon=k>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,d,l)=>{var m;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(d?[S,d]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,d);const s=(m=this._leakageMon)===null||m===void 0?void 0:m.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=f._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof T.DisposableStore?l.add(r):Array.isArray(l)&&l.push(r),r}),this._event}fire(S){var d,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,S]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,t]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,t):m[0].call(m[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var S,d,l;(S=this._listeners)===null||S===void 0||S.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class g extends f{constructor(S){super(S);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=g;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const d={event:S,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const l=()=>{this.hasListeners&&this.unhook(d);const m=this.events.indexOf(d);this.events.splice(m,1)};return(0,T.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(d=>this.emitter.fire(d))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.buffers=[]}wrapEvent(S){return(d,l,m)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>d.call(l,t)):d.call(l,t)},void 0,m)}bufferEvents(S){const d=[];this.buffers.push(d);const l=S();return this.buffers.pop(),d.forEach(m=>m()),l}}e.EventBufferer=u;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(P,D){const k=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(k)}}});var T;(function(P){function D(k){return k===P.None||k===P.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=y}),define(ge[43],pe([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function A(i,C){return new P(i,C)}e.registerCodicon=A;function y(i){return i?i.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=y;class P{constructor(C,f,g){this.id=C,this.definition=f,this.description=g,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(i,C){const f=["codicon","codicon-"+i];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=D;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(u){if(u instanceof P)return["codicon","codicon-"+u.id];const E=C.exec(u.id);if(!E)return f(P.error);let[,b,S]=E;const d=["codicon","codicon-"+b];return S&&d.push("codicon-modifier-"+S.substr(1)),d}i.asClassNameArray=f;function g(u){return f(u).join(" ")}i.asClassName=g;function a(u){return"."+f(u).join(".")}i.asCSSSelector=a})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(ge[95],pe([0,1,18,6]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=T;function A(d){const l=d;return l?T(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(d,l){return new P(d,l)}e.newWriteableStream=y;class P{constructor(l,m){this.reducer=l,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(m=>m(l))}emitError(l){this.listeners.error.length===0?(0,_.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(m=>m(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,m){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(l,m){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(m);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,l){const m=[];let t;for(;(t=d.read())!==null;)m.push(t);return l(m)}e.consumeReadable=D;function k(d,l,m){const t=[];let n;for(;(n=d.read())!==null&&t.length<m;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return d.read()}}}e.peekReadable=k;function i(d,l){return new Promise((m,t)=>{const n=[];C(d,{onData:s=>{l&&n.push(s)},onError:s=>{l?t(s):m(void 0)},onEnd:()=>{m(l?l(n):void 0)}})})}e.consumeStream=i;function C(d,l){d.on("error",m=>l.onError(m)),d.on("end",()=>l.onEnd()),d.on("data",m=>l.onData(m))}e.listenStream=C;function f(d,l){return new Promise((m,t)=>{const n=new I.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>l)return n.dispose(),d.pause(),m({stream:d,buffer:s,ended:!1})},o=p=>t(p),c=()=>m({stream:d,buffer:s,ended:!0});n.add((0,I.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,I.toDisposable)(()=>d.removeListener("end",c))),d.on("end",c),n.add((0,I.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=f;function g(d,l){const m=y(l);return m.end(d),m}e.toStream=g;function a(){const d=y(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function u(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=u;function E(d,l,m){const t=y(m);return C(d,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function b(d,l,m){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?m([d,n]):d)}}}e.prefixedReadable=b;function S(d,l,m){let t=!1;const n=y(m);return C(l,{onData:s=>t?n.write(s):(t=!0,n.write(m([d,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(d)),n.end()}}),n}e.prefixedStream=S}),define(ge[9],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const I=/{(\d+)}/g;function T(K,...se){return se.length===0?K:K.replace(I,function(he,J){const ne=parseInt(J,10);return isNaN(ne)||ne<0||ne>=se.length?he:se[ne]})}e.format=T;function A(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=A;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(K,se){let he=0;const J=se.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===J&&he++;return he}e.count=P;function D(K,se,he="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${he}`}e.truncate=D;function k(K,se=" "){const he=i(K,se);return C(he,se)}e.trim=k;function i(K,se){if(!K||!se)return K;const he=se.length;if(he===0||K.length===0)return K;let J=0;for(;K.indexOf(se,J)===J;)J=J+he;return K.substring(J)}e.ltrim=i;function C(K,se){if(!K||!se)return K;const he=se.length,J=K.length;if(he===0||J===0)return K;let ne=J,ce=-1;for(;ce=K.lastIndexOf(se,ne-1),!(ce===-1||ce+he!==ne);){if(ce===0)return"";ne=ce}return K.substring(0,ne)}e.rtrim=C;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function a(K,se,he={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=y(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let J="";return he.global&&(J+="g"),he.matchCase||(J+="i"),he.multiline&&(J+="m"),he.unicode&&(J+="u"),new RegExp(K,J)}e.createRegExp=a;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function E(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function b(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=b;function S(K){return K.split(/\r\n|\r|\n/)}e.splitLines=S;function d(K){for(let se=0,he=K.length;se<he;se++){const J=K.charCodeAt(se);if(J!==32&&J!==9)return se}return-1}e.firstNonWhitespaceIndex=d;function l(K,se=0,he=K.length){for(let J=se;J<he;J++){const ne=K.charCodeAt(J);if(ne!==32&&ne!==9)return K.substring(se,J)}return K.substring(se,he)}e.getLeadingWhitespace=l;function m(K,se=K.length-1){for(let he=se;he>=0;he--){const J=K.charCodeAt(he);if(J!==32&&J!==9)return he}return-1}e.lastNonWhitespaceIndex=m;function t(K,se){return K<se?-1:K>se?1:0}e.compare=t;function n(K,se,he=0,J=K.length,ne=0,ce=se.length){for(;he<J&&ne<ce;he++,ne++){let je=K.charCodeAt(he),He=se.charCodeAt(ne);if(je<He)return-1;if(je>He)return 1}const ve=J-he,ye=ce-ne;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function s(K,se){return r(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=s;function r(K,se,he=0,J=K.length,ne=0,ce=se.length){for(;he<J&&ne<ce;he++,ne++){let je=K.charCodeAt(he),He=se.charCodeAt(ne);if(je!==He){const We=je-He;if(!(We===32&&c(He))&&!(We===-32&&c(je)))return o(je)&&o(He)?We:n(K.toLowerCase(),se.toLowerCase(),he,J,ne,ce)}}const ve=J-he,ye=ce-ne;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=r;function o(K){return K>=97&&K<=122}e.isLowerAsciiLetter=o;function c(K){return K>=65&&K<=90}e.isUpperAsciiLetter=c;function p(K){return o(K)||c(K)}function v(K,se){return K.length===se.length&&h(K,se)}e.equalsIgnoreCase=v;function h(K,se,he=K.length){for(let J=0;J<he;J++){const ne=K.charCodeAt(J),ce=se.charCodeAt(J);if(ne!==ce){if(p(ne)&&p(ce)){const ve=Math.abs(ne-ce);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function w(K,se){const he=se.length;return se.length>K.length?!1:h(K,se,he)}e.startsWithIgnoreCase=w;function R(K,se){let he,J=Math.min(K.length,se.length);for(he=0;he<J;he++)if(K.charCodeAt(he)!==se.charCodeAt(he))return he;return J}e.commonPrefixLength=R;function N(K,se){let he,J=Math.min(K.length,se.length);const ne=K.length-1,ce=se.length-1;for(he=0;he<J;he++)if(K.charCodeAt(ne-he)!==se.charCodeAt(ce-he))return he;return J}e.commonSuffixLength=N;function j(K){return 55296<=K&&K<=56319}e.isHighSurrogate=j;function re(K){return 56320<=K&&K<=57343}e.isLowSurrogate=re;function V(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=V;function W(K,se,he){const J=K.charCodeAt(he);if(j(J)&&he+1<se){const ne=K.charCodeAt(he+1);if(re(ne))return V(J,ne)}return J}e.getNextCodePoint=W;function $(K,se){const he=K.charCodeAt(se-1);if(re(he)&&se>1){const J=K.charCodeAt(se-2);if(j(J))return V(J,he)}return he}function U(K,se){const he=$e.getInstance(),J=se,ne=K.length,ce=W(K,ne,se);se+=ce>=65536?2:1;let ve=he.getGraphemeBreakType(ce);for(;se<ne;){const ye=W(K,ne,se),je=he.getGraphemeBreakType(ye);if(Ne(ve,je))break;se+=ye>=65536?2:1,ve=je}return se-J}e.nextCharLength=U;function F(K,se){const he=$e.getInstance(),J=se,ne=$(K,se);se-=ne>=65536?2:1;let ce=he.getGraphemeBreakType(ne);for(;se>0;){const ve=$(K,se),ye=he.getGraphemeBreakType(ve);if(Ne(ye,ce))break;se-=ve>=65536?2:1,ce=ye}return J-se}e.prevCharLength=F;function M(K,se){const he=$e.getInstance(),J=K.length,ne=se,ce=W(K,J,se),ve=he.getGraphemeBreakType(ce);se+=ce>=65536?2:1;let ye=ve;for(;se<J;){const He=W(K,J,se),We=he.getGraphemeBreakType(He);if(Ne(ye,We))break;se+=He>=65536?2:1,ye=We}const je=se;for(se=ne,ye=ve;se>0;){const He=$(K,se),We=he.getGraphemeBreakType(He);if(Ne(We,ye))break;se-=He>=65536?2:1,ye=We}return[se,je]}function L(K,se){return se>0&&re(K.charCodeAt(se))?M(K,se-1):M(K,se)}e.getCharContainingOffset=L;function O(K){const se=K.length;let he=0,J=0;for(;J<se;){const ve=W(K,se,J);J+=ve>=65536?2:1,ve<128?he+=1:ve<2048?he+=2:ve<65536?he+=3:he+=4}const ne=new Uint8Array(he);J=0;let ce=0;for(;J<se;){const ve=W(K,se,J);J+=ve>=65536?2:1,ve<128?ne[ce++]=ve:ve<2048?(ne[ce++]=192|(ve&1984)>>>6,ne[ce++]=128|(ve&63)>>>0):ve<65536?(ne[ce++]=224|(ve&61440)>>>12,ne[ce++]=128|(ve&4032)>>>6,ne[ce++]=128|(ve&63)>>>0):(ne[ce++]=240|(ve&1835008)>>>18,ne[ce++]=128|(ve&258048)>>>12,ne[ce++]=128|(ve&4032)>>>6,ne[ce++]=128|(ve&63)>>>0)}return ne}e.encodeUTF8=O;function B(K){const se=K.byteLength,he=[];let J=0;for(;J<se;){const ne=K[J];let ce;if(ne>=240&&J+3<se?ce=(K[J++]&7)<<18>>>0|(K[J++]&63)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:ne>=224&&J+2<se?ce=(K[J++]&15)<<12>>>0|(K[J++]&63)<<6>>>0|(K[J++]&63)<<0>>>0:ne>=192&&J+1<se?ce=(K[J++]&31)<<6>>>0|(K[J++]&63)<<0>>>0:ce=K[J++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)he.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const ve=ce-65536,ye=55296+((ve&1047552)>>>10),je=56320+((ve&1023)>>>0);he.push(String.fromCharCode(ye)),he.push(String.fromCharCode(je))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=B;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const de=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(K){return de.test(K)}e.containsEmoji=be;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ce(K){return Ae.test(K)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Le;function z(K){for(let se=0,he=K.length;se<he;se++)if(Y(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Y;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function le(K,se){if(K.length<se)return K;const he=/\b/g;let J=0;for(;he.test(K)&&!(K.length-he.lastIndex<se);)J=he.lastIndex,he.lastIndex+=1;return K.substring(J).replace(/^\s/,"")}e.lcut=le;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function we(K){return K&&(K=K.replace(me,""),K=K.replace(De,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Re(K){return Pe(K)?K.substr(1):K}e.stripUTF8BOM=Re;function Be(K,se){if(!K||!se||K.length<se.length)return!1;const he=se.length,J=K.toLowerCase();let ne=0,ce=-1;for(;ne<he;){const ve=J.indexOf(se[ne],ce+1);if(ve<0)return!1;ce=ve,ne++}return!0}e.fuzzyContains=Be;function Se(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function qe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=qe;function X(K,se=1){if(se===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),se--;while(se>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=X;function ie(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ie;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function Ne(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Je()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const he=this._data,J=he.length/3;let ne=1;for(;ne<=J;)if(se<he[3*ne])ne=2*ne;else if(se>he[3*ne+1])ne=2*ne+1;else return he[3*ne+2];return 0}}$e._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],pe([0,1,9,95]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let P,D;class k{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return T?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return T&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,v){return!((v==null?void 0:v.dontUseNodeBuffer)||!1)&&T?new k(Buffer.from(p)):A?(P||(P=new TextEncoder),new k(P.encode(p))):new k(_.encodeUTF8(p))}static concat(p,v){if(typeof v=="undefined"){v=0;for(let R=0,N=p.length;R<N;R++)v+=p[R].byteLength}const h=k.alloc(v);let w=0;for(let R=0,N=p.length;R<N;R++){const j=p[R];h.set(j,w),w+=j.byteLength}return h}toString(){return T?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(p,v){return new k(this.buffer.subarray(p,v))}set(p,v){p instanceof k?this.buffer.set(p.buffer,v):this.buffer.set(p,v)}readUInt32BE(p){return f(this.buffer,p)}writeUInt32BE(p,v){g(this.buffer,p,v)}readUInt32LE(p){return a(this.buffer,p)}writeUInt32LE(p,v){u(this.buffer,p,v)}readUInt8(p){return E(this.buffer,p)}writeUInt8(p,v){b(this.buffer,p,v)}}e.VSBuffer=k;function i(c,p){return c[p+0]<<0>>>0|c[p+1]<<8>>>0}e.readUInt16LE=i;function C(c,p,v){c[v+0]=p&255,p=p>>>8,c[v+1]=p&255}e.writeUInt16LE=C;function f(c,p){return c[p]*2**24+c[p+1]*2**16+c[p+2]*2**8+c[p+3]}e.readUInt32BE=f;function g(c,p,v){c[v+3]=p,p=p>>>8,c[v+2]=p,p=p>>>8,c[v+1]=p,p=p>>>8,c[v]=p}e.writeUInt32BE=g;function a(c,p){return c[p+0]<<0>>>0|c[p+1]<<8>>>0|c[p+2]<<16>>>0|c[p+3]<<24>>>0}e.readUInt32LE=a;function u(c,p,v){c[v+0]=p&255,p=p>>>8,c[v+1]=p&255,p=p>>>8,c[v+2]=p&255,p=p>>>8,c[v+3]=p&255}e.writeUInt32LE=u;function E(c,p){return c[p]}e.readUInt8=E;function b(c,p,v){c[v]=p}e.writeUInt8=b;function S(c){return I.consumeReadable(c,p=>k.concat(p))}e.readableToBuffer=S;function d(c){return I.toReadable(c)}e.bufferToReadable=d;function l(c){return I.consumeStream(c,p=>k.concat(p))}e.streamToBuffer=l;async function m(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=m;function t(c){return I.toStream(c,p=>k.concat(p))}e.bufferToStream=t;function n(c){return I.transform(c,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.streamToBufferReadableStream=n;function s(c){return I.newWriteableStream(p=>k.concat(p),c)}e.newWriteableBufferStream=s;function r(c,p){return I.prefixedReadable(c,p,v=>k.concat(v))}e.prefixedBufferReadable=r;function o(c,p){return I.prefixedStream(c,p,v=>k.concat(v))}e.prefixedBufferStream=o}),define(ge[74],pe([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(b){return T(b,0)}e.hash=I;function T(b,S){switch(typeof b){case"object":return b===null?A(349,S):Array.isArray(b)?D(b,S):k(b,S);case"string":return P(b,S);case"boolean":return y(b,S);case"number":return A(b,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=T;function A(b,S){return(S<<5)-S+b|0}function y(b,S){return A(b?433:863,S)}function P(b,S){S=A(149417,S);for(let d=0,l=b.length;d<l;d++)S=A(b.charCodeAt(d),S);return S}e.stringHash=P;function D(b,S){return S=A(104579,S),b.reduce((d,l)=>T(l,d),S)}function k(b,S){return S=A(181387,S),Object.keys(b).sort().reduce((d,l)=>(d=P(l,d),T(b[l],d)),S)}class i{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=T(S,this._value),this._value}}e.Hasher=i;var C;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(b,S,d=32){const l=d-S,m=~((1<<l)-1);return(b<<S|(m&b)>>>l)>>>0}function g(b,S=0,d=b.byteLength,l=0){for(let m=0;m<d;m++)b[S+m]=l}function a(b,S,d="0"){for(;b.length<S;)b=d+b;return b}function u(b,S=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((b>>>0).toString(16),S/4)}e.toHexString=u;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const d=S.length;if(d!==0){const l=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=S.charCodeAt(0),s=0);;){let r=n;if(_.isHighSurrogate(n))if(s+1<d){const o=S.charCodeAt(s+1);_.isLowSurrogate(o)?(s++,r=_.computeCodePoint(n,o)):r=65533}else{t=n;break}else _.isLowSurrogate(n)&&(r=65533);if(m=this._push(l,m,r),s++,s<d)n=S.charCodeAt(s);else break}this._buffLen=m,this._leftoverHighSurrogate=t}}_push(S,d,l){return l<128?S[d++]=l:l<2048?(S[d++]=192|(l&1984)>>>6,S[d++]=128|(l&63)>>>0):l<65536?(S[d++]=224|(l&61440)>>>12,S[d++]=128|(l&4032)>>>6,S[d++]=128|(l&63)>>>0):(S[d++]=240|(l&1835008)>>>18,S[d++]=128|(l&258048)>>>12,S[d++]=128|(l&4032)>>>6,S[d++]=128|(l&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,d=this._buffDV;for(let p=0;p<64;p+=4)S.setUint32(p,d.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)S.setUint32(p,f(S.getUint32(p-12,!1)^S.getUint32(p-32,!1)^S.getUint32(p-56,!1)^S.getUint32(p-64,!1),1),!1);let l=this._h0,m=this._h1,t=this._h2,n=this._h3,s=this._h4,r,o,c;for(let p=0;p<80;p++)p<20?(r=m&t|~m&n,o=1518500249):p<40?(r=m^t^n,o=1859775393):p<60?(r=m&t|m&n|t&n,o=2400959708):(r=m^t^n,o=3395469782),c=f(l,5)+r+s+o+S.getUint32(p*4,!1)&4294967295,s=n,n=t,t=f(m,30),m=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const A="error",y="warning",P="warn",D="info",k="ignore";function i(f){return f?_.equalsIgnoreCase(A,f)?T.Error:_.equalsIgnoreCase(y,f)||_.equalsIgnoreCase(P,f)?T.Warning:_.equalsIgnoreCase(D,f)?T.Info:T.Ignore:T.Ignore}T.fromValue=i;function C(f){switch(f){case T.Error:return A;case T.Warning:return y;case T.Info:return D;default:return k}}T.toString=C}(I||(I={})),e.default=I}),define(ge[11],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(p){return Array.isArray(p)}e.isArray=_;function I(p){return typeof p=="string"}e.isString=I;function T(p){return Array.isArray(p)&&p.every(v=>I(v))}e.isStringArray=T;function A(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=A;function y(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=y;function P(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=P;function D(p){return p===!0||p===!1}e.isBoolean=D;function k(p){return typeof p=="undefined"}e.isUndefined=k;function i(p){return!C(p)}e.isDefined=i;function C(p){return k(p)||p===null}e.isUndefinedOrNull=C;function f(p,v){if(!p)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=f;function g(p){if(C(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=g;function a(...p){const v=[];for(let h=0;h<p.length;h++){const w=p[h];if(C(w))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);v.push(w)}return v}e.assertAllDefined=a;const u=Object.prototype.hasOwnProperty;function E(p){if(!A(p))return!1;for(let v in p)if(u.call(p,v))return!1;return!0}e.isEmptyObject=E;function b(p){return typeof p=="function"}e.isFunction=b;function S(...p){return p.length>0&&p.every(b)}e.areFunctions=S;function d(p,v){const h=Math.min(p.length,v.length);for(let w=0;w<h;w++)l(p[w],v[w])}e.validateConstraints=d;function l(p,v){if(I(v)){if(typeof p!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(b(v)){try{if(p instanceof v)return}catch(h){}if(!C(p)&&p.constructor===v||v.length===1&&v.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function m(p){let v=[],h=Object.getPrototypeOf(p);for(;Object.prototype!==h;)v=v.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return v}e.getAllPropertyNames=m;function t(p){const v=[];for(const h of m(p))typeof p[h]=="function"&&v.push(h);return v}e.getAllMethodNames=t;function n(p,v){const h=R=>function(){const N=Array.prototype.slice.call(arguments,0);return v(R,N)};let w={};for(const R of p)w[R]=h(R);return w}e.createProxyObject=n;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function r(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=r;function o(p){return class{constructor(){return new Proxy({},{get(v,h){if(v[h])return v[h];throw new Error(`Not Implemented: ${p}->${String(h)}`)}})}}}e.NotImplementedProxy=o;function c(p){throw new Error("Unreachable")}e.assertNever=c}),define(ge[29],pe([0,1,10,9,8,11]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function P(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=P;function D(n,s=T.posix.sep){if(!n)return"";const r=n.length,o=n.charCodeAt(0);if(y(o)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let p=3;const v=p;for(;p<r&&!y(n.charCodeAt(p));p++);if(v!==p&&!y(n.charCodeAt(p+1))){for(p+=1;p<r;p++)if(y(n.charCodeAt(p)))return n.slice(0,p+1).replace(/[\\/]/g,s)}}return s}else if(E(o)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<r;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function k(n){if(!_.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let r=2;const o=r;for(;r<n.length&&(s=n.charCodeAt(r),s!==92);r++);return!(o===r||(s=n.charCodeAt(r+1),isNaN(s)||s===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,s=_.isWindows){const r=s?i:C;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||s&&f.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function a(n,s,r){const o=n===s;return!r||o?o:!n||!s?!1:(0,I.equalsIgnoreCase)(n,s)}e.isEqual=a;function u(n,s,r,o=T.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(r){if(!(0,I.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let p=s.length;return s.charAt(s.length-1)===o&&p--,n.charAt(p)===o}return s.charAt(s.length-1)!==o&&(s+=o),n.indexOf(s)===0}e.isEqualOrParent=u;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function b(n,s){return _.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(s,n)),n=(0,T.normalize)(n),_.isWindows?(n=(0,I.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,I.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=b;function S(n){const s=(0,T.normalize)(n);return _.isWindows?n.length>3?!1:d(s)&&(n.length===2||s.charCodeAt(2)===92):s===T.posix.sep}e.isRootOrDriveLetter=S;function d(n){return _.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(n){return d(n)?n[0]:void 0}e.getDriveLetter=l;function m(n,s,r){return s.length>n.length?-1:n===s?0:(r&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=m;function t(n){const s=n.split(":");let r,o,c;if(s.forEach(p=>{const v=Number(p);(0,A.isNumber)(v)?o===void 0?o=v:c===void 0&&(c=v):r=r?[r,p].join(":"):p}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:o!==void 0?o:void 0,column:c!==void 0?c:o!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],pe([0,1,11]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const u=Array.isArray(a)?[]:{};return Object.keys(a).forEach(E=>{a[E]&&typeof a[E]=="object"?u[E]=I(a[E]):u[E]=a[E]}),u}e.deepClone=I;function T(a){if(!a||typeof a!="object")return a;const u=[a];for(;u.length>0;){const E=u.shift();Object.freeze(E);for(const b in E)if(A.call(E,b)){const S=E[b];typeof S=="object"&&!Object.isFrozen(S)&&u.push(S)}}return a}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function y(a,u){return P(a,u,new Set)}e.cloneAndChange=y;function P(a,u,E){if((0,_.isUndefinedOrNull)(a))return a;const b=u(a);if(typeof b!="undefined")return b;if((0,_.isArray)(a)){const S=[];for(const d of a)S.push(P(d,u,E));return S}if((0,_.isObject)(a)){if(E.has(a))throw new Error("Cannot clone recursive data-structure");E.add(a);const S={};for(let d in a)A.call(a,d)&&(S[d]=P(a[d],u,E));return E.delete(a),S}return a}function D(a,u,E=!0){return(0,_.isObject)(a)?((0,_.isObject)(u)&&Object.keys(u).forEach(b=>{b in a?E&&((0,_.isObject)(a[b])&&(0,_.isObject)(u[b])?D(a[b],u[b],E):a[b]=u[b]):a[b]=u[b]}),a):u}e.mixin=D;function k(a,u){if(a===u)return!0;if(a==null||u===null||u===void 0||typeof a!=typeof u||typeof a!="object"||Array.isArray(a)!==Array.isArray(u))return!1;let E,b;if(Array.isArray(a)){if(a.length!==u.length)return!1;for(E=0;E<a.length;E++)if(!k(a[E],u[E]))return!1}else{const S=[];for(b in a)S.push(b);S.sort();const d=[];for(b in u)d.push(b);if(d.sort(),!k(S,d))return!1;for(E=0;E<S.length;E++)if(!k(a[S[E]],u[S[E]]))return!1}return!0}e.equals=k;function i(a){const u=new Set;return JSON.stringify(a,(E,b)=>{if((0,_.isObject)(b)||Array.isArray(b)){if(u.has(b))return"[Circular]";u.add(b)}return b})}e.safeStringify=i;function C(a,u,E){const b=u(a);return typeof b=="undefined"?E:b}e.getOrDefault=C;function f(a,u){const E=Object.create(null);return!a||!u||Object.keys(u).forEach(S=>{const d=a[S],l=u[S];k(d,l)||(E[S]=l)}),E}e.distinct=f;function g(a,u){const E=u.toLowerCase(),b=Object.keys(a).find(S=>S.toLowerCase()===E);return b?a[b]:a[u]}e.getCaseInsensitive=g}),define(ge[96],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function T(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=T}),define(ge[2],pe([0,1,10,8]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function P(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!T.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function k(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const i="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,o,c,p,v,h=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,h),this.authority=o||i,this.path=k(this.scheme,c||i),this.query=p||i,this.fragment=v||i,P(this,h))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:c,path:p,query:v,fragment:h}=r;return o===void 0?o=this.scheme:o===null&&(o=i),c===void 0?c=this.authority:c===null&&(c=i),p===void 0?p=this.path:p===null&&(p=i),v===void 0?v=this.query:v===null&&(v=i),h===void 0?h=this.fragment:h===null&&(h=i),o===this.scheme&&c===this.authority&&p===this.path&&v===this.query&&h===this.fragment?this:new u(o,c,p,v,h)}static parse(r,o=!1){const c=f.exec(r);return c?new u(c[2]||i,n(c[4]||i),n(c[5]||i),n(c[7]||i),n(c[9]||i),o):new u(i,i,i,i,i)}static file(r){let o=i;if(_.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const c=r.indexOf(C,2);c===-1?(o=r.substring(2),r=C):(o=r.substring(2,c),r=r.substring(c)||C)}return new u("file",o,r,i,i)}static from(r){return new u(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return _.isWindows&&r.scheme==="file"?c=g.file(I.win32.join(d(r,!0),...o)).path:c=I.posix.join(r.path,...o),r.with({path:c})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const o=new u(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=g;const a=_.isWindows?1:void 0;class u extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,r){let o,c=-1;for(let p=0;p<s.length;p++){const v=s.charCodeAt(p);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||r&&v===47)c!==-1&&(o+=encodeURIComponent(s.substring(c,p)),c=-1),o!==void 0&&(o+=s.charAt(p));else{o===void 0&&(o=s.substr(0,p));const h=E[v];h!==void 0?(c!==-1&&(o+=encodeURIComponent(s.substring(c,p)),c=-1),o+=h):c===-1&&(c=p)}}return c!==-1&&(o+=encodeURIComponent(s.substring(c))),o!==void 0?o:s}function S(s){let r;for(let o=0;o<s.length;o++){const c=s.charCodeAt(o);c===35||c===63?(r===void 0&&(r=s.substr(0,o)),r+=E[c]):r!==void 0&&(r+=s[o])}return r!==void 0?r:s}function d(s,r){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,_.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function l(s,r){const o=r?S:b;let c="",{scheme:p,authority:v,path:h,query:w,fragment:R}=s;if(p&&(c+=p,c+=":"),(v||p==="file")&&(c+=C,c+=C),v){let N=v.indexOf("@");if(N!==-1){const j=v.substr(0,N);v=v.substr(N+1),N=j.indexOf(":"),N===-1?c+=o(j,!1):(c+=o(j.substr(0,N),!1),c+=":",c+=o(j.substr(N+1),!1)),c+="@"}v=v.toLowerCase(),N=v.indexOf(":"),N===-1?c+=o(v,!1):(c+=o(v.substr(0,N),!1),c+=v.substr(N))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const N=h.charCodeAt(1);N>=65&&N<=90&&(h=`/${String.fromCharCode(N+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const N=h.charCodeAt(0);N>=65&&N<=90&&(h=`${String.fromCharCode(N+32)}:${h.substr(2)}`)}c+=o(h,!0)}return w&&(c+="?",c+=o(w,!1)),R&&(c+="#",c+=r?R:b(R,!1)),c}function m(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>m(r)):s}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[24],pe([0,1,2,9]),function(G,e,_,I){"use strict";var T,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=P;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new f)}static forStrings(){return new E(new i)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let o;for(this._root||(this._root=new u,this._root.segment=r.value()),o=this._root;;){const p=r.cmp(o.segment);if(p>0)o.left||(o.left=new u,o.left.segment=r.value()),o=o.left;else if(p<0)o.right||(o.right=new u,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new u,o.mid.segment=r.value()),o=o.mid;else break}const c=o.value;return o.value=s,o.key=n,c}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),o=[];let c=this._root;for(;c;){const p=r.cmp(c.segment);if(p>0)o.push([1,c]),c=c.left;else if(p<0)o.push([-1,c]),c=c.right;else if(r.hasNext())r.next(),o.push([0,c]),c=c.mid;else{for(s?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;o.length>0&&c.isEmpty();){let[v,h]=o.pop();switch(v){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}c=h}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,o;for(;r;){const c=s.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(s.hasNext())s.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class b{constructor(n,s){this[T]="ResourceMap",n instanceof b?(this.map=new Map(n.map),this.toKey=s!=null?s:b.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:b.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,o]of this.map)n(o,_.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield _.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[_.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[_.URI.parse(n[0]),n[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class d{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let o=this._map.get(n);if(o)o.value=s,r!==0&&this.touch(o,r);else{switch(o={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const r=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const c={value:r.key,done:!1};return r=r.next,c}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const c={value:r.value,done:!1};return r=r.next,c}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const c={value:[r.key,r.value],done:!1};return r=r.next,c}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=d;class l extends d{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class m{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,s){Ue(this,y,"f").forEach(n,s)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=m}),define(ge[97],pe([0,1,24,9]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...we){return function(Pe,Re){for(let Be=0,Se=we.length;Be<Se;Be++){const qe=we[Be](Pe,Re);if(qe)return qe}return null}}e.or=T,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(we,Pe,Re){if(!Re||Re.length<Pe.length)return null;let Be;return we?Be=I.startsWithIgnoreCase(Re,Pe):Be=Re.indexOf(Pe)===0,Be?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function y(we,Pe){const Re=Pe.toLowerCase().indexOf(we.toLowerCase());return Re===-1?null:[{start:Re,end:Re+we.length}]}e.matchesContiguousSubString=y;function P(we,Pe){return D(we.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=P;function D(we,Pe,Re,Be){if(Re===we.length)return[];if(Be===Pe.length)return null;if(we[Re]===Pe[Be]){let Se=null;return(Se=D(we,Pe,Re+1,Be+1))?b({start:Be,end:Be+1},Se):null}return D(we,Pe,Re,Be+1)}function k(we){return 97<=we&&we<=122}function i(we){return 65<=we&&we<=90}e.isUpper=i;function C(we){return 48<=we&&we<=57}function f(we){return we===32||we===9||we===10||we===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>g.add(we.charCodeAt(0)));function a(we){return f(we)||g.has(we)}function u(we,Pe){return we===Pe||a(we)&&a(Pe)}function E(we){return k(we)||i(we)||C(we)}function b(we,Pe){return Pe.length===0?Pe=[we]:we.end===Pe[0].start?Pe[0].start=we.start:Pe.unshift(we),Pe}function S(we,Pe){for(let Re=Pe;Re<we.length;Re++){const Be=we.charCodeAt(Re);if(i(Be)||C(Be)||Re>0&&!E(we.charCodeAt(Re-1)))return Re}return we.length}function d(we,Pe,Re,Be){if(Re===we.length)return[];if(Be===Pe.length)return null;if(we[Re]!==Pe[Be].toLowerCase())return null;{let Se=null,qe=Be+1;for(Se=d(we,Pe,Re+1,Be+1);!Se&&(qe=S(Pe,qe))<Pe.length;)Se=d(we,Pe,Re+1,qe),qe++;return Se===null?null:b({start:Be,end:Be+1},Se)}}function l(we){let Pe=0,Re=0,Be=0,Se=0,qe=0;for(let ze=0;ze<we.length;ze++)qe=we.charCodeAt(ze),i(qe)&&Pe++,k(qe)&&Re++,E(qe)&&Be++,C(qe)&&Se++;const X=Pe/we.length,ie=Re/we.length,_e=Be/we.length,Ne=Se/we.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:_e,numericPercent:Ne}}function m(we){const{upperPercent:Pe,lowerPercent:Re}=we;return Re===0&&Pe>.6}function t(we){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:Be,numericPercent:Se}=we;return Re>.2&&Pe<.8&&Be>.6&&Se<.2}function n(we){let Pe=0,Re=0,Be=0,Se=0;for(let qe=0;qe<we.length;qe++)Be=we.charCodeAt(qe),i(Be)&&Pe++,k(Be)&&Re++,f(Be)&&Se++;return(Pe===0||Re===0)&&Se===0?we.length<=30:Pe<=5}function s(we,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!n(we)||Pe.length>60)return null;const Re=l(Pe);if(!t(Re)){if(!m(Re))return null;Pe=Pe.toLowerCase()}let Be=null,Se=0;for(we=we.toLowerCase();Se<Pe.length&&(Be=d(we,Pe,0,Se))===null;)Se=S(Pe,Se+1);return Be}e.matchesCamelCase=s;function r(we,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let Be=null,Se=0;for(we=we.toLowerCase(),Pe=Pe.toLowerCase();Se<Pe.length&&(Be=o(we,Pe,0,Se,Re))===null;)Se=c(Pe,Se+1);return Be}e.matchesWords=r;function o(we,Pe,Re,Be,Se){if(Re===we.length)return[];if(Be===Pe.length)return null;if(u(we.charCodeAt(Re),Pe.charCodeAt(Be))){let qe=null,X=Be+1;if(qe=o(we,Pe,Re+1,Be+1,Se),!Se)for(;!qe&&(X=c(Pe,X))<Pe.length;)qe=o(we,Pe,Re+1,X,Se),X++;return qe===null?null:b({start:Be,end:Be+1},qe)}else return null}function c(we,Pe){for(let Re=Pe;Re<we.length;Re++)if(a(we.charCodeAt(Re))||Re>0&&a(we.charCodeAt(Re-1)))return Re;return we.length}const p=T(e.matchesPrefix,s,y),v=T(e.matchesPrefix,s,P),h=new _.LRUCache(1e4);function w(we,Pe,Re=!1){if(typeof we!="string"||typeof Pe!="string")return null;let Be=h.get(we);Be||(Be=new RegExp(I.convertSimple2RegExpPattern(we),"i"),h.set(we,Be));const Se=Be.exec(Pe);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Re?v(we,Pe):p(we,Pe)}e.matchesFuzzy=w;function R(we,Pe){const Re=z(we,we.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Re?j(Re):null}e.matchesFuzzy2=R;function N(we,Pe,Re,Be,Se,qe){const X=Math.min(13,we.length);for(;Re<X;Re++){const ie=z(we,Pe,Re,Be,Se,qe,!1);if(ie)return ie}return[0,qe]}e.anyScore=N;function j(we){if(typeof we=="undefined")return[];const Pe=[],Re=we[1];for(let Be=we.length-1;Be>1;Be--){const Se=we[Be]+Re,qe=Pe[Pe.length-1];qe&&qe.end===Se?qe.end=Se+1:Pe.push({start:Se,end:Se+1})}return Pe}e.createMatches=j;const re=128;function V(){const we=[],Pe=[];for(let Re=0;Re<=re;Re++)Pe[Re]=0;for(let Re=0;Re<=re;Re++)we.push(Pe.slice(0));return we}function W(we){const Pe=[];for(let Re=0;Re<=we;Re++)Pe[Re]=0;return Pe}const $=W(2*re),U=W(2*re),F=V(),M=V(),L=V(),O=!1;function B(we,Pe,Re,Be,Se){function qe(ie,_e,Ne=" "){for(;ie.length<_e;)ie=Ne+ie;return ie}let X=` |   |${Be.split("").map(ie=>qe(ie,3)).join("|")}
`;for(let ie=0;ie<=Re;ie++)ie===0?X+=" |":X+=`${Pe[ie-1]}|`,X+=we[ie].slice(0,Se+1).map(_e=>qe(_e.toString(),3)).join("|")+`
`;return X}function q(we,Pe,Re,Be){we=we.substr(Pe),Re=Re.substr(Be),console.log(B(M,we,we.length,Re,Re.length)),console.log(B(L,we,we.length,Re,Re.length)),console.log(B(F,we,we.length,Re,Re.length))}function Q(we,Pe){if(Pe<0||Pe>=we.length)return!1;const Re=we.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Re)}}function de(we,Pe){if(Pe<0||Pe>=we.length)return!1;switch(we.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function be(we,Pe,Re){return Pe[we]!==Re[we]}function Ae(we,Pe,Re,Be,Se,qe,X=!1){for(;Pe<Re&&Se<qe;)we[Pe]===Be[Se]&&(X&&($[Pe]=Se),Pe+=1),Se+=1;return Pe===Re}e.isPatternInWord=Ae;var Ce;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Le;(function(we){we.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}we.isDefault=Pe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function z(we,Pe,Re,Be,Se,qe,X){const ie=we.length>re?re:we.length,_e=Be.length>re?re:Be.length;if(!(Re>=ie||qe>=_e||ie-Re>_e-qe)&&!!Ae(Pe,Re,ie,Se,qe,_e,!0)){Y(ie,_e,Re,qe,Pe,Se);let Ne=1,ze=1,$e=Re,Je=qe;const K=[!1];for(Ne=1,$e=Re;$e<ie;Ne++,$e++){const ce=$[$e],ve=U[$e],ye=$e+1<ie?U[$e+1]:_e;for(ze=ce-qe+1,Je=ce;Je<ye;ze++,Je++){let je=Number.MIN_SAFE_INTEGER,He=!1;Je<=ve&&(je=ee(we,Pe,$e,Re,Be,Se,Je,_e,qe,F[Ne-1][ze-1]===0,K));let We=0;je!==Number.MAX_SAFE_INTEGER&&(He=!0,We=je+M[Ne-1][ze-1]);const Ge=Je>ce,nt=Ge?M[Ne][ze-1]+(F[Ne][ze-1]>0?-5:0):0,dt=Je>ce+1&&F[Ne][ze-1]>0,it=dt?M[Ne][ze-2]+(F[Ne][ze-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!He||it>=We))M[Ne][ze]=it,L[Ne][ze]=3,F[Ne][ze]=0;else if(Ge&&(!He||nt>=We))M[Ne][ze]=nt,L[Ne][ze]=2,F[Ne][ze]=0;else if(He)M[Ne][ze]=We,L[Ne][ze]=1,F[Ne][ze]=F[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(we,Re,Be,qe),!(!K[0]&&!X)){Ne--,ze--;const se=[M[Ne][ze],qe];let he=0,J=0;for(;Ne>=1;){let ce=ze;do{const ve=L[Ne][ce];if(ve===3)ce=ce-2;else if(ve===2)ce=ce-1;else break}while(ce>=1);he>1&&Pe[Re+Ne-1]===Se[qe+ze-1]&&!be(ce+qe-1,Be,Se)&&he+1>F[Ne][ce]&&(ce=ze),ce===ze?he++:he=1,J||(J=ce),Ne--,ze=ce-1,se.push(ze)}_e===ie&&(se[0]+=2);const ne=J-ie;return se[0]-=ne,se}}}e.fuzzyScore=z;function Y(we,Pe,Re,Be,Se,qe){let X=we-1,ie=Pe-1;for(;X>=Re&&ie>=Be;)Se[X]===qe[ie]&&(U[X]=ie,X--),ie--}function ee(we,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze){if(Pe[Re]!==qe[X])return Number.MIN_SAFE_INTEGER;let $e=1,Je=!1;return X===Re-Be?$e=we[Re]===Se[X]?7:5:be(X,Se,qe)&&(X===0||!be(X-1,Se,qe))?($e=we[Re]===Se[X]?7:5,Je=!0):Q(qe,X)&&(X===0||!Q(qe,X-1))?$e=5:(Q(qe,X-1)||de(qe,X-1))&&($e=5,Je=!0),$e>1&&Re===Be&&(ze[0]=!0),Je||(Je=be(X,Se,qe)||Q(qe,X-1)||de(qe,X-1)),Re===Be?X>_e&&($e-=Je?3:5):Ne?$e+=Je?2:0:$e+=Je?0:1,X+1===ie&&($e-=Je?3:5),$e}function le(we,Pe,Re,Be,Se,qe,X){return De(we,Pe,Re,Be,Se,qe,!0,X)}e.fuzzyScoreGracefulAggressive=le;function me(we,Pe,Re,Be,Se,qe,X){return De(we,Pe,Re,Be,Se,qe,!1,X)}e.fuzzyScoreGraceful=me;function De(we,Pe,Re,Be,Se,qe,X,ie){let _e=z(we,Pe,Re,Be,Se,qe,ie);if(_e&&!X)return _e;if(we.length>=3){const Ne=Math.min(7,we.length-1);for(let ze=Re+1;ze<Ne;ze++){const $e=Oe(we,ze);if($e){const Je=z($e,$e.toLowerCase(),Re,Be,Se,qe,ie);Je&&(Je[0]-=3,(!_e||Je[0]>_e[0])&&(_e=Je))}}}return _e}function Oe(we,Pe){if(!(Pe+1>=we.length)){const Re=we[Pe],Be=we[Pe+1];if(Re!==Be)return we.slice(0,Pe)+Be+Re+we.slice(Pe+2)}}}),define(ge[136],pe([0,1,43,97,9]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function P(u){return u.replace(y,(E,b)=>b?E:`\\${E}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${A.source}`,"g");function k(u){return u.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(i,(E,b,S,d)=>S?E:b||d||"")}e.stripIcons=C;function f(u){const E=u.indexOf(e.iconStartMarker);return E===-1?{text:u}:g(u,E)}e.parseLabelWithIcons=f;function g(u,E){const b=[];let S="";function d(c){if(c){S+=c;for(const p of c)b.push(t)}}let l=-1,m="",t=0,n,s,r=E;const o=u.length;for(d(u.substr(0,E));r<o;)n=u[r],s=u[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(l=r,d(m),m=e.iconStartMarker,r++):n===")"&&l!==-1?(t+=r-l+1,l=-1,m=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?m+=n:(d(m),l=-1,m=""):d(n),r++;return d(m),{text:S,iconOffsets:b}}function a(u,E,b=!1){const{text:S,iconOffsets:d}=E;if(!d||d.length===0)return(0,I.matchesFuzzy)(u,S,b);const l=(0,T.ltrim)(S," "),m=S.length-l.length,t=(0,I.matchesFuzzy)(u,l,b);if(t)for(const n of t){const s=d[n.start+m]+m;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(ge[98],pe([0,1,19,136,18]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",E=!1){var b,S;if(this.value=u,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(b=E.isTrusted)!==null&&b!==void 0?b:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(u,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(u):u).replace(/([ \t]+)/g,(b,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,E){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function P(a){return D(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(a,u){return!a&&!u?!0:!a||!u?!1:Array.isArray(a)&&Array.isArray(u)?(0,_.equals)(a,u,i):D(a)&&D(u)?i(a,u):!1}e.markedStringsEquals=k;function i(a,u){return a===u?!0:!a||!u?!1:a.value===u.value&&a.isTrusted===u.isTrusted&&a.supportThemeIcons===u.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function f(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function g(a){const u=[],E=a.split("|").map(S=>S.trim());a=E[0];const b=E[1];if(b){const S=/height=(\d+)/.exec(b),d=/width=(\d+)/.exec(b),l=S?S[1]:"",m=d?d[1]:"",t=isFinite(parseInt(m)),n=isFinite(parseInt(l));t&&u.push(`width="${m}"`),n&&u.push(`height="${l}"`)}return{href:a,dimensions:u}}e.parseHrefAndDimensions=g}),define(ge[58],pe([0,1,22,9,2]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,P)}e.stringify=A;function y(k){let i=JSON.parse(k);return i=D(i),i}e.parse=y;function P(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,I.regExpFlags)(i)}:i}function D(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return T.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof _.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=D(k[C],i+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=D(k[C],i+1))}return k}e.revive=D}),define(ge[12],pe([0,1,2,10]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,i){this._hosts[D]=k,this._ports[D]=i}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[k],f=this._connectionTokens[k];let g=`path=${encodeURIComponent(D.path)}`;return typeof f=="string"&&(g+=`&tkn=${encodeURIComponent(f)}`),_.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,i){const C=this.toUri(D,k);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(i||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,k){const i=this.toUri(D,k);return i.scheme===T.vscodeFileResource?i.with({scheme:T.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,k){return _.URI.isUri(D)?D:_.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(ge[75],pe([0,1,24]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new _.LRUCache(1e4);function T(k){return D(k,"NFC",I)}e.normalizeNFC=T;const A=new _.LRUCache(1e4);function y(k){return D(k,"NFD",A)}e.normalizeNFD=y;const P=/[^\u0000-\u0080]/;function D(k,i,C){if(!e.canNormalize||!k)return k;const f=C.get(k);if(f)return f;let g;return P.test(k)?g=k.normalize(i):g=k,C.set(k,g),g}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(i){return y(i).replace(k,"")}}else return function(k){return k}}()}),define(ge[25],pe([0,1,29,8,2,9,12,10]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=D;class k{constructor(a){this._ignorePathCasing=a}compare(a,u,E=!1){return a===u?0:(0,A.compare)(this.getComparisonKey(a,E),this.getComparisonKey(u,E))}isEqual(a,u,E=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,E)===this.getComparisonKey(u,E)}getComparisonKey(a,u=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,u,E=!1){if(a.scheme===u.scheme){if(a.scheme===y.Schemas.file)return _.isEqualOrParent(D(a),D(u),this._ignorePathCasing(a))&&a.query===u.query&&(E||a.fragment===u.fragment);if((0,e.isEqualAuthority)(a.authority,u.authority))return _.isEqualOrParent(a.path,u.path,this._ignorePathCasing(a),"/")&&a.query===u.query&&(E||a.fragment===u.fragment)}return!1}joinPath(a,...u){return T.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return I.posix.basename(a.path)}extname(a){return I.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===y.Schemas.file?u=T.URI.file(I.dirname(D(a))).path:(u=I.posix.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===y.Schemas.file?u=T.URI.file(I.normalize(D(a))).path:u=I.posix.normalize(a.path),a.with({path:u})}relativePath(a,u){if(!(a.scheme!==u.scheme||!(0,e.isEqualAuthority)(a.authority,u.authority))){if(a.scheme===y.Schemas.file){const S=I.relative(D(a),D(u));return P.isWindows?_.toSlashes(S):S}let E=a.path||"/",b=u.path||"/";if(this._ignorePathCasing(a)){let S=0;for(const d=Math.min(E.length,b.length);S<d&&!(E.charCodeAt(S)!==b.charCodeAt(S)&&E.charAt(S).toLowerCase()!==b.charAt(S).toLowerCase());S++);E=b.substr(0,S)+E.substr(S)}return I.posix.relative(E,b)}}resolvePath(a,u){if(a.scheme===y.Schemas.file){const E=T.URI.file(I.resolve(D(a),u));return a.with({authority:E.authority,path:E.path})}return u.indexOf("/")===-1&&(u=_.toSlashes(u),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u)),a.with({path:I.posix.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||(0,A.equalsIgnoreCase)(a,u)}hasTrailingPathSeparator(a,u=I.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>_.getRoot(E).length&&E[E.length-1]===u}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=I.sep){return(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=I.sep){let E=!1;if(a.scheme===y.Schemas.file){const b=D(a);E=b!==void 0&&b.length===_.getRoot(b).length&&b[b.length-1]===u}else{u="/";const b=a.path;E=b.length===1&&b.charCodeAt(b.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===y.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,a){const u=[];for(let E=0;E<g.length;E++){const b=a(g[E]);g.some((S,d)=>d===E?!1:(0,e.isEqualOrParent)(b,a(S)))||u.push(g[E])}return u}e.distinctParents=i;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function a(u){const E=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,m]=d.split(":");l&&m&&E.set(l,m)});const S=u.path.substring(0,u.path.indexOf(";"));return S&&E.set(g.META_DATA_MIME,S),E}g.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function f(g,a,u){if(a){let E=g.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),g.with({scheme:u,authority:a,path:E})}return g.with({scheme:u})}e.toLocalResource=f}),define(ge[13],pe([0,1,21,18,3,6,56,25]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(M){return!!M&&typeof M.then=="function"}e.isThenable=D;function k(M){const L=new _.CancellationTokenSource,O=M(L.token),B=new Promise((q,Q)=>{L.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(O).then(de=>{L.dispose(),q(de)},de=>{L.dispose(),Q(de)})});return new class{cancel(){L.cancel()}then(q,Q){return B.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return B.finally(q)}}}e.createCancelablePromise=k;function i(M,L,O){return Promise.race([M,new Promise(B=>L.onCancellationRequested(()=>B(O)))])}e.raceCancellation=i;async function C(M){let L=-1;const O=M.map((q,Q)=>q.then(de=>(L=Q,de))),B=await Promise.race(O);return M.forEach((q,Q)=>{Q!==L&&q.cancel()}),B}e.raceCancellablePromises=C;function f(M,L,O){let B;const q=setTimeout(()=>{B==null||B(void 0),O==null||O()},L);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(Q=>B=Q)])}e.raceTimeout=f;function g(M){return new Promise((L,O)=>{const B=M();D(B)?B.then(L,O):L(B)})}e.asPromise=g;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(O,O).then(B)})}return new Promise((O,B)=>{this.queuedPromise.then(O,B)})}return this.activePromise=L(),new Promise((O,B)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,B(q)})})}}e.Throttler=a;class u{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=u;class E{constructor(){this.promiseMap=new Map}queue(L,O){var B;const Q=((B=this.promiseMap.get(L))!==null&&B!==void 0?B:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===Q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,Q),Q}}e.SequencerByKey=E;class b{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,q)=>{this.doResolve=B,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=b;class S{constructor(L){this.delayer=new b(L),this.throttler=new a}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class d{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class l extends d{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function m(M,L){return L?new Promise((O,B)=>{const q=setTimeout(O,M);L.onCancellationRequested(()=>{clearTimeout(q),B((0,I.canceled)())})}):k(O=>m(M,O))}e.timeout=m;function t(M,L=0){const O=setTimeout(M,L);return(0,A.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(M){return M.then(void 0,L=>{})}e.ignoreErrors=n;function s(M){const L=[];let O=0;const B=M.length;function q(){return O<B?M[O++]():null}function Q(de){de!=null&&L.push(de);const be=q();return be?be.then(Q):Promise.resolve(L)}return Promise.resolve(null).then(Q)}e.sequence=s;function r(M,L=B=>!!B,O=null){let B=0;const q=M.length,Q=()=>{if(B>=q)return Promise.resolve(O);const de=M[B++];return Promise.resolve(de()).then(Ae=>L(Ae)?Promise.resolve(Ae):Q())};return Q()}e.first=r;function o(M,L=B=>!!B,O=null){if(M.length===0)return Promise.resolve(O);let B=M.length;const q=()=>{var Q,de;B=-1;for(const be of M)(de=(Q=be).cancel)===null||de===void 0||de.call(Q)};return new Promise((Q,de)=>{for(const be of M)be.then(Ae=>{--B>=0&&L(Ae)?(q(),Q(Ae)):B===0&&Q(O)}).catch(Ae=>{--B>=0&&(q(),de(Ae))})})}e.firstParallel=o;class c{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,B)=>{this.outstandingPromises.push({factory:L,c:O,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class p extends c{constructor(){super(1)}}e.Queue=p;class v{constructor(){this.queues=new Map}queueFor(L,O=P.extUri){const B=O.getComparisonKey(L);let q=this.queues.get(B);return q||(q=new p,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(B)}),this.queues.set(B,q)),q}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=v;class h{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=h;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=w;class R{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class N extends R{constructor(L,O){super(L,O);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const O=setTimeout(()=>L(M));let B=!1;return{dispose(){B||(B=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,L)=>{const O=requestIdleCallback(M,typeof L=="number"?{timeout:L}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class j{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function re(M,L,O){let B;for(let q=0;q<O;q++)try{return await M()}catch(Q){B=Q,await m(L)}throw B}e.retry=re;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,O,B){return this._pending={taskId:L,cancel:()=>B==null?void 0:B(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,B;const q=new Promise((Q,de)=>{O=Q,B=de});this._next={run:L,promise:q,promiseResolve:O,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=V;class W{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=$;class U extends T.Emitter{async fireAsync(L,O,B){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,L]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),de=[],be=Object.assign(Object.assign({},Q),{waitUntil:Ae=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");B&&(Ae=B(Ae,typeof q=="function"?q:q[0])),de.push(Ae)}});try{typeof q=="function"?q.call(void 0,be):q[0].call(q[1],be)}catch(Ae){(0,I.onUnexpectedError)(Ae);continue}Object.freeze(de),await F.settled(de).catch(Ae=>(0,I.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=U;var F;(function(M){async function L(Q){return typeof Promise.allSettled=="function"?O(Q):B(Q)}M.allSettled=L;async function O(Q){return Promise.allSettled(Q)}async function B(Q){return Promise.all(Q.map(de=>de.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function q(Q){let de;const be=await Promise.all(Q.map(Ae=>Ae.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de!="undefined")throw de;return be}M.settled=q})(F=e.Promises||(e.Promises={}))}),define(ge[99],pe([0,1,8,13]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(l,m,t=!1){const n=l||"",s=m||"",r=T.value.collator.compare(n,s);return T.value.collatorIsNumeric&&r===0&&n!==s?n<s?-1:1:r}e.compareFileNames=P;function D(l,m){const t=A.value.collator;return l=l||"",m=m||"",u(t,l,m)}e.compareFileNamesDefault=D;function k(l,m,t=!1){t||(l=l&&l.toLowerCase(),m=m&&m.toLowerCase());const[n,s]=g(l),[r,o]=g(m);return n!==r?n<r?-1:1:s===o?0:s<o?-1:1}e.noIntlCompareFileNames=k;function i(l,m){const[t,n]=g(l),[s,r]=g(m);let o=T.value.collator.compare(n,r);if(o===0){if(T.value.collatorIsNumeric&&n!==r)return n<r?-1:1;if(o=T.value.collator.compare(t,s),T.value.collatorIsNumeric&&o===0&&t!==s)return t<s?-1:1}return o}e.compareFileExtensions=i;function C(l,m){l=l||"",m=m||"";const t=a(l),n=a(m),s=A.value.collator,r=y.value.collator;let o;return o=u(r,t,n),o!==0?o:u(s,l,m)}e.compareFileExtensionsDefault=C;const f=/^(.*?)(\.([^.]*))?$/;function g(l,m=!1){const t=l?f.exec(l):[];let n=[t&&t[1]||"",t&&t[3]||""];return m&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function a(l){const m=l?f.exec(l):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function u(l,m,t){let n=l.compare(m,t);return n!==0?n:m.length!==t.length?m.length<t.length?-1:1:0}function E(l,m,t=!1){return t||(l=l&&l.toLowerCase(),m=m&&m.toLowerCase()),l===m?0:l<m?-1:1}function b(l,m,t=!1){const n=l.split(_.sep),s=m.split(_.sep),r=n.length-1,o=s.length-1;let c,p;for(let v=0;;v++){if(c=r===v,p=o===v,c&&p)return P(n[v],s[v],t);if(c)return-1;if(p)return 1;const h=E(n[v],s[v],t);if(h!==0)return h}}e.comparePaths=b;function S(l,m,t){const n=l.toLowerCase(),s=m.toLowerCase(),r=d(l,m,t);if(r)return r;const o=n.endsWith(t),c=s.endsWith(t);if(o!==c)return o?-1:1;const p=P(n,s);return p!==0?p:n.localeCompare(s)}e.compareAnything=S;function d(l,m,t){const n=l.toLowerCase(),s=m.toLowerCase(),r=n.startsWith(t),o=s.startsWith(t);if(r!==o)return r?-1:1;if(r&&o){if(n.length<s.length)return-1;if(n.length>s.length)return 1}return 0}e.compareByPrefix=d}),define(ge[100],pe([0,1,99,97,8,10,9]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,D=[P,[]];function k(W,$,U,F){if(!W||!$)return D;const M=W.length,L=$.length;if(M<L)return D;const O=W.toLowerCase();return!F&&!O.includes(U)?D:i($,U,L,W,O,M)}e.scoreFuzzy=k;function i(W,$,U,F,M,L){const O=[],B=[];for(let be=0;be<U;be++){const Ae=be*L,Ce=Ae-L,Le=be>0,z=W[be],Y=$[be];for(let ee=0;ee<L;ee++){const le=ee>0,me=Ae+ee,De=me-1,Oe=Ce+ee-1,we=le?O[De]:0,Pe=Le&&le?O[Oe]:0,Re=Le&&le?B[Oe]:0;let Be;!Pe&&Le?Be=0:Be=C(z,Y,F,M,ee,Re),Be&&Pe+Be>=we?(B[me]=Re+1,O[me]=Pe+Be):(B[me]=P,O[me]=we)}}const q=[];let Q=U-1,de=L-1;for(;Q>=0&&de>=0;){const be=Q*L+de;B[be]===P||(q.push(de),Q--),de--}return[O[U*L-1],q.reverse()]}function C(W,$,U,F,M,L){let O=0;if(!f($,F[M]))return O;if(O+=1,L>0&&(O+=L*5),W===U[M]&&(O+=1),M===0)O+=8;else{const B=g(U.charCodeAt(M-1));B?O+=B:(0,I.isUpper)(U.charCodeAt(M))&&(O+=2)}return O}function f(W,$){return W===$?!0:W==="/"||W==="\\"?$==="/"||$==="\\":!1}function g(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function u(W,$,U=0,F=0){const M=$;return M.values&&M.values.length>1?E(W,M.values,U,F):b(W,$,U,F)}e.scoreFuzzy2=u;function E(W,$,U,F){let M=0;const L=[];for(const O of $){const[B,q]=b(W,O,U,F);if(typeof B!="number")return a;M+=B,L.push(...q)}return[M,c(L)]}function b(W,$,U,F){const M=(0,I.fuzzyScore)($.original,$.originalLowercase,U,W,W.toLowerCase(),F,!0);return M?[M[0],(0,I.createMatches)(M)]:a}const S=Object.freeze({score:0}),d=1<<18,l=1<<17,m=1<<16;function t(W,$,U,F,M){if(!W||!$.normalized)return S;const L=F.getItemLabel(W);if(!L)return S;const O=F.getItemDescription(W);let B;O?B=`${L}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`:B=`${L}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`;const q=M[B];if(q)return q;const Q=n(L,O,F.getItemPath(W),$,U);return M[B]=Q,Q}e.scoreItemFuzzy=t;function n(W,$,U,F,M){const L=!U||!F.containsPathSeparator;return U&&(A.isLinux?F.pathNormalized===U:(0,y.equalsIgnoreCase)(F.pathNormalized,U))?{score:d,labelMatch:[{start:0,end:W.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:F.values&&F.values.length>1?s(W,$,U,F.values,L,M):r(W,$,U,F,L,M)}function s(W,$,U,F,M,L){let O=0;const B=[],q=[];for(const Q of F){const{score:de,labelMatch:be,descriptionMatch:Ae}=r(W,$,U,Q,M,L);if(de===P)return S;O+=de,be&&B.push(...be),Ae&&q.push(...Ae)}return{score:O,labelMatch:c(B),descriptionMatch:c(q)}}function r(W,$,U,F,M,L){if(M||!$){const[O,B]=k(W,F.normalized,F.normalizedLowercase,L);if(O){const q=(0,I.matchesPrefix)(F.normalized,W);let Q;return q?(Q=l,Q+=Math.round(F.normalized.length/W.length*100)):Q=m,{score:Q+O,labelMatch:q||o(B)}}}if($){let O=$;U&&(O=`${$}${T.sep}`);const B=O.length,q=`${O}${W}`,[Q,de]=k(q,F.normalized,F.normalizedLowercase,L);if(Q){const be=o(de),Ae=[],Ce=[];return be.forEach(Le=>{Le.start<B&&Le.end>B?(Ae.push({start:0,end:Le.end-B}),Ce.push({start:Le.start,end:B})):Le.start>=B?Ae.push({start:Le.start-B,end:Le.end-B}):Ce.push(Le)}),{score:Q,labelMatch:Ae,descriptionMatch:Ce}}}return S}function o(W){const $=[];if(!W)return $;let U;for(const F of W)U&&U.end===F?U.end+=1:(U={start:F,end:F+1},$.push(U));return $}function c(W){const $=W.sort((M,L)=>M.start-L.start),U=[];let F;for(const M of $)!F||!p(F,M)?(F=M,U.push(M)):(F.start=Math.min(F.start,M.start),F.end=Math.max(F.end,M.end));return U}function p(W,$){return!(W.end<$.start||$.end<W.start)}function v(W,$,U,F,M,L){const O=t(W,U,F,M,L),B=t($,U,F,M,L),q=O.score,Q=B.score;if((q===d||Q===d)&&q!==Q)return q===d?-1:1;if(q>m||Q>m){if(q!==Q)return q>Q?-1:1;if(q<l&&Q<l){const Y=w(O.labelMatch,B.labelMatch);if(Y!==0)return Y}const Le=M.getItemLabel(W)||"",z=M.getItemLabel($)||"";if(Le.length!==z.length)return Le.length-z.length}if(q!==Q)return q>Q?-1:1;const de=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,be=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ae=h(W,O,M),Ce=h($,B,M);return Ae&&Ce&&Ae!==Ce?Ce>Ae?-1:1:R(W,$,U,M)}e.compareItemsByFuzzyScore=v;function h(W,$,U){let F=-1,M=-1;if($.descriptionMatch&&$.descriptionMatch.length?F=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(F=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(M=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const L=U.getItemDescription(W);L&&(M+=L.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(M=$.descriptionMatch[$.descriptionMatch.length-1].end);return M-F}function w(W,$){if(!W&&!$||(!W||!W.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!W||!W.length)return 1;const U=W[0].start,M=W[W.length-1].end-U,L=$[0].start,B=$[$.length-1].end-L;return M===B?0:B<M?1:-1}function R(W,$,U,F){const M=F.getItemLabel(W)||"",L=F.getItemLabel($)||"",O=F.getItemDescription(W),B=F.getItemDescription($),q=M.length+(O?O.length:0),Q=L.length+(B?B.length:0);if(q!==Q)return q-Q;const de=F.getItemPath(W),be=F.getItemPath($);return de&&be&&de.length!==be.length?de.length-be.length:M!==L?(0,_.compareAnything)(M,L,U.normalized):O&&B&&O!==B?(0,_.compareAnything)(O,B,U.normalized):de&&be&&de!==be?(0,_.compareAnything)(de,be,U.normalized):0}const N=" ";function j(W){typeof W!="string"&&(W="");const $=W.toLowerCase(),{pathNormalized:U,normalized:F,normalizedLowercase:M}=re(W),L=U.indexOf(T.sep)>=0;let O;const B=W.split(N);if(B.length>1)for(const q of B){const{pathNormalized:Q,normalized:de,normalizedLowercase:be}=re(q);de&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:de,normalizedLowercase:be}))}return{original:W,originalLowercase:$,pathNormalized:U,normalized:F,normalizedLowercase:M,values:O,containsPathSeparator:L}}e.prepareQuery=j;function re(W){let $;A.isWindows?$=W.replace(/\//g,T.sep):$=W.replace(/\\/g,T.sep);const U=(0,y.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:U,normalizedLowercase:U.toLowerCase()}}function V(W){return Array.isArray(W)?j(W.map($=>$.original).join(N)):j(W.original)}e.pieceToQuery=V}),define(ge[33],pe([0,1,9,29,8,24,13]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",k="/",i="[/\\\\]",C="[^/\\\\]",f=/\//g;function g(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function a(O,B){if(!O)return[];const q=[];let Q=!1,de=!1,be="";for(const Ae of O){switch(Ae){case B:if(!Q&&!de){q.push(be),be="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":de=!0;break;case"]":de=!1;break}be+=Ae}return be&&q.push(be),q}e.splitGlobAware=a;function u(O){if(!O)return"";let B="";const q=a(O,k);if(q.every(Q=>Q===D))B=".*";else{let Q=!1;q.forEach((de,be)=>{if(de===D){Q||(B+=g(2),Q=!0);return}let Ae=!1,Ce="",Le=!1,z="";for(const Y of de){if(Y!=="}"&&Ae){Ce+=Y;continue}if(Le&&(Y!=="]"||!z)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!z?ee="^":Y===k?ee="":ee=_.escapeRegExpCharacters(Y),z+=ee;continue}switch(Y){case"{":Ae=!0;continue;case"[":Le=!0;continue;case"}":B+=`(?:${a(Ce,",").map(me=>u(me)).join("|")})`,Ae=!1,Ce="";break;case"]":B+="["+z+"]",Le=!1,z="";break;case"?":B+=C;continue;case"*":B+=g(1);continue;default:B+=_.escapeRegExpCharacters(Y)}}be<q.length-1&&(q[be+1]!==D||be+2<q.length)&&(B+=i),Q=!1})}return B}const E=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(O,B){if(!O)return s;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Q=`${q}_${!!B.trimForExclusions}`;let de=t.get(Q);if(de)return o(de,O);let be;if(E.test(q)){const Ae=q.substr(4);de=function(Ce,Le){return typeof Ce=="string"&&Ce.endsWith(Ae)?q:null}}else(be=b.exec(c(q,B)))?de=p(be[1],q):(B.trimForExclusions?d:S).test(q)?de=v(q,B):(be=l.exec(c(q,B)))?de=h(be[1].substr(1),q,!0):(be=m.exec(c(q,B)))?de=h(be[1],q,!1):de=w(q);return t.set(Q,de),o(de,O)}function o(O,B){return typeof B=="string"?O:function(q,Q){return I.isEqualOrParent(q,B.base)?O(T.relative(B.base,q),Q):null}}function c(O,B){return B.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function p(O,B){const q=`/${O}`,Q=`\\${O}`,de=function(Ae,Ce){return typeof Ae!="string"?null:Ce?Ce===O?B:null:Ae===O||Ae.endsWith(q)||Ae.endsWith(Q)?B:null},be=[O];return de.basenames=be,de.patterns=[B],de.allBasenames=be,de}function v(O,B){const q=L(O.slice(1,-1).split(",").map(Ce=>r(Ce,B)).filter(Ce=>Ce!==s),O),Q=q.length;if(!Q)return s;if(Q===1)return q[0];const de=function(Ce,Le){for(let z=0,Y=q.length;z<Y;z++)if(q[z](Ce,Le))return O;return null},be=q.find(Ce=>!!Ce.allBasenames);be&&(de.allBasenames=be.allBasenames);const Ae=q.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ae.length&&(de.allPaths=Ae),de}function h(O,B,q){const Q=T.sep===T.posix.sep,de=Q?O:O.replace(f,T.sep),be=T.sep+de,Ae=T.posix.sep+O,Ce=q?function(Le,z){return typeof Le=="string"&&(Le===de||Le.endsWith(be)||!Q&&(Le===O||Le.endsWith(Ae)))?B:null}:function(Le,z){return typeof Le=="string"&&(Le===de||!Q&&Le===O)?B:null};return Ce.allPaths=[(q?"*/":"./")+O],Ce}function w(O){try{const B=new RegExp(`^${u(O)}$`);return function(q){return B.lastIndex=0,typeof q=="string"&&B.test(q)?O:null}}catch(B){return s}}function R(O,B,q){return!O||typeof B!="string"?!1:N(O)(B,void 0,q)}e.match=R;function N(O,B={}){if(!O)return n;if(typeof O=="string"||W(O)){const q=r(O,B);if(q===s)return n;const Q=function(de,be){return!!q(de,be)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return F(O,B)}e.parse=N;function j(O){if(!!O){let B;return q=>(B||(B=(O()||Promise.resolve([])).then(Q=>Q?V(Q):{})),B.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=j;function re(O){if(!!O){let B;return q=>{if(!B){const Q=O();B=Q?V(Q):{}}return!!B[q]}}}e.hasSiblingFn=re;function V(O){const B={};for(const q of O)B[q]=!0;return B}function W(O){const B=O;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=W;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function U(O){return O.allPaths||[]}e.getPathTerms=U;function F(O,B){const q=L(Object.getOwnPropertyNames(O).map(Ce=>M(Ce,O[Ce],B)).filter(Ce=>Ce!==s)),Q=q.length;if(!Q)return s;if(!q.some(Ce=>!!Ce.requiresSiblings)){if(Q===1)return q[0];const Ce=function(Y,ee){for(let le=0,me=q.length;le<me;le++){const De=q[le](Y,ee);if(De)return De}return null},Le=q.find(Y=>!!Y.allBasenames);Le&&(Ce.allBasenames=Le.allBasenames);const z=q.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return z.length&&(Ce.allPaths=z),Ce}const de=function(Ce,Le,z){let Y;for(let ee=0,le=q.length;ee<le;ee++){const me=q[ee];me.requiresSiblings&&z&&(Le||(Le=T.basename(Ce)),Y||(Y=Le.substr(0,Le.length-T.extname(Ce).length)));const De=me(Ce,Le,Y,z);if(De)return De}return null},be=q.find(Ce=>!!Ce.allBasenames);be&&(de.allBasenames=be.allBasenames);const Ae=q.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ae.length&&(de.allPaths=Ae),de}function M(O,B,q){if(B===!1)return s;const Q=r(O,q);if(Q===s)return s;if(typeof B=="boolean")return Q;if(B){const de=B.when;if(typeof de=="string"){const be=(Ae,Ce,Le,z)=>{if(!z||!Q(Ae,Ce))return null;const Y=de.replace("$(basename)",Le),ee=z(Y);return(0,y.isThenable)(ee)?ee.then(le=>le?O:null):ee?O:null};return be.requiresSiblings=!0,be}}return Q}function L(O,B){const q=O.filter(Ce=>!!Ce.basenames);if(q.length<2)return O;const Q=q.reduce((Ce,Le)=>{const z=Le.basenames;return z?Ce.concat(z):Ce},[]);let de;if(B){de=[];for(let Ce=0,Le=Q.length;Ce<Le;Ce++)de.push(B)}else de=q.reduce((Ce,Le)=>{const z=Le.patterns;return z?Ce.concat(z):Ce},[]);const be=function(Ce,Le){if(typeof Ce!="string")return null;if(!Le){let Y;for(Y=Ce.length;Y>0;Y--){const ee=Ce.charCodeAt(Y-1);if(ee===47||ee===92)break}Le=Ce.substr(Y)}const z=Q.indexOf(Le);return z!==-1?de[z]:null};be.basenames=Q,be.patterns=de,be.allBasenames=Q;const Ae=O.filter(Ce=>!Ce.basenames);return Ae.push(be),Ae}}),define(ge[76],pe([0,1,2,8,9,12,10,25,29]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(r,o,c){if(typeof r=="string"&&(r=_.URI.file(r)),c){const v=c.getWorkspaceFolder(r);if(v){const h=c.getWorkspace().folders.length>1;let w;if((0,P.isEqual)(v.uri,r)?w="":w=(0,P.relativePath)(v.uri,r),h){const R=v.name?v.name:(0,P.basename)(v.uri);w=w?R+" \u2022 "+w:R}return w}}if(r.scheme!==A.Schemas.file&&r.scheme!==A.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,I.normalize)(C(r.fsPath));let p=(0,I.normalize)(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(p=g(p,o.userHome.fsPath)),p}e.getPathLabel=k;function i(r){if(!!r){typeof r=="string"&&(r=_.URI.file(r));const o=(0,P.basename)(r)||(r.scheme===A.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?C(o):o}}e.getBaseLabel=i;function C(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let f=Object.create(null);function g(r,o){if(y.isWindows||!r||!o)return r;let c=f.original===o?f.normalized:void 0;return c||(c=`${(0,T.rtrim)(o,I.posix.sep)}${I.posix.sep}`,f={original:o,normalized:c}),(y.isLinux?r.startsWith(c):(0,T.startsWithIgnoreCase)(r,c))&&(r=`~/${r.substr(c.length)}`),r}e.tildify=g;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const u="\u2026",E="\\\\",b="~";function S(r,o=I.sep){const c=new Array(r.length);let p=!1;for(let v=0;v<r.length;v++){let h=r[v];if(h===""){c[v]=`.${o}`;continue}if(!h){c[v]=h;continue}p=!0;let w="";h.indexOf(E)===0?(w=h.substr(0,h.indexOf(E)+E.length),h=h.substr(h.indexOf(E)+E.length)):h.indexOf(o)===0?(w=h.substr(0,h.indexOf(o)+o.length),h=h.substr(h.indexOf(o)+o.length)):h.indexOf(b)===0&&(w=h.substr(0,h.indexOf(b)+b.length),h=h.substr(h.indexOf(b)+b.length));const R=h.split(o);for(let N=1;p&&N<=R.length;N++)for(let j=R.length-N;p&&j>=0;j--){p=!1;let re=R.slice(j,j+N).join(o);for(let V=0;!p&&V<r.length;V++)if(V!==v&&r[V]&&r[V].indexOf(re)>-1){const W=j+N===R.length,$=j>0&&r[V].indexOf(o)>-1?o+re:re,U=r[V].endsWith($);p=!W||U}if(!p){let V="";(R[0].endsWith(":")||w!=="")&&(j===1&&(j=0,N++,re=R[0]+o+re),j>0&&(V=R[0]+o),V=w+V),j>0&&(V=V+u+o),V=V+re,j+N<R.length&&(V=V+o+u),c[v]=V}}p&&(c[v]=h)}return c}e.shorten=S;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(r,o=Object.create(null)){const c=[];let p=!1,v="";for(const h of r)if(h==="$"||p&&h==="{")v&&c.push({value:v,type:d.TEXT}),v="",p=!0;else if(h==="}"&&p){const w=o[v];if(typeof w=="string")w.length&&c.push({value:w,type:d.VARIABLE});else if(w){const R=c[c.length-1];(!R||R.type!==d.SEPARATOR)&&c.push({value:w.label,type:d.SEPARATOR})}v="",p=!1}else v+=h;return v&&!p&&c.push({value:v,type:d.TEXT}),c.filter((h,w)=>{if(h.type===d.SEPARATOR){const R=c[w-1],N=c[w+1];return[R,N].every(j=>j&&(j.type===d.VARIABLE||j.type===d.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=l;function m(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const o=r.indexOf("/")!==-1?I.posix:I.win32,c=o.basename(r),p=o.dirname(r);return c.length?{name:c,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(ge[101],pe([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(i){return i.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:I(_.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:I(_.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:_.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,C,f){if(!i||f>200)return null;if(typeof i=="object"){if(i instanceof _.URI)return C.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const a=A(i[g],C,f+1);a!==null&&(i[g]=a)}}return null}function y(i,C){const f=A(i,C,0);return f===null?i:f}e.transformOutgoingURIs=y;function P(i,C,f,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return f?_.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const u=P(i[a],C,f,g+1);u!==null&&(i[a]=u)}}return null}function D(i,C){const f=P(i,C,!1,0);return f===null?i:f}e.transformIncomingURIs=D;function k(i,C){const f=P(i,C,!0,0);return f===null?i:f}e.transformAndReviveIncomingURIs=k}),define(ge[30],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return _.test(D)}e.isUUID=I;const T=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function P(){y(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,k="";return k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k}e.generateUuid=P}),define(ge[137],pe([0,1,102]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(A="utf8"){this.stringDecoder=new _.StringDecoder(A),this.remaining=null}write(A){const y=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return y;let D=0,k,i=D;for(;i<P.length;)if(k=P.charCodeAt(i),k===13||k===10){if(y.push(P.substring(D,i)),i++,i<P.length){const C=k;k=P.charCodeAt(i),(C===13&&k===10||C===10&&k===13)&&i++}D=i}else i++;return this.remaining=D<P.length?P.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(ge[26],pe([0,1,37,48,8,13,10,29,30,75,25,2]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function g($,U=f.UNLINK){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return U===f.UNLINK?u($):a($)}e.rimraf=g;async function a($){try{const U=(0,T.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await _.promises.rename($,U)}catch(F){return u($)}u(U).catch(F=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function u($){return _.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function b($,U){return l(await(U?S($):_.promises.readdir($)))}e.readdir=b;async function S($){try{return await _.promises.readdir($,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const U=[],F=await b($);for(const M of F){let L=!1,O=!1,B=!1;try{const q=await _.promises.lstat((0,T.join)($,M));L=q.isFile(),O=q.isDirectory(),B=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}U.push({name:M,isFile:()=>L,isDirectory:()=>O,isSymbolicLink:()=>B})}return U}function d($){return l(_.readdirSync($))}e.readdirSync=d;function l($){return $.map(U=>typeof U=="string"?y.isMacintosh?(0,k.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,k.normalizeNFC)(U.name):U.name,U))}async function m($){const U=await b($),F=[];for(const M of U)await n.existsDirectory((0,T.join)($,M))&&F.push(M);return F}e.readDirsInDir=m;function t($,U=1e3){return new Promise(F=>{let M=!1;const L=setInterval(()=>{M||(M=!0,_.access($,O=>{M=!1,O&&(clearInterval(L),F(void 0))}))},U)})}e.whenDeleted=t;var n;(function($){async function U(L){let O;try{if(O=await _.promises.lstat(L),!O.isSymbolicLink())return{stat:O}}catch(B){}try{return{stat:await _.promises.stat(L),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(y.isWindows&&B.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw B}}$.stat=U;async function F(L){try{const{stat:O,symbolicLink:B}=await $.stat(L);return O.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(O){}return!1}$.existsFile=F;async function M(L){try{const{stat:O,symbolicLink:B}=await $.stat(L);return O.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(O){}return!1}$.existsDirectory=M})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function r($,U,F){return s.queueFor(C.URI.file($),i.extUriBiasedIgnorePathCase).queue(()=>{const M=v(F);return new Promise((L,O)=>c($,U,M,B=>B?O(B):L()))})}e.writeFile=r;let o=!0;function c($,U,F,M){if(!o)return _.writeFile($,U,{mode:F.mode,flag:F.flag},M);_.open($,F.flag,F.mode,(L,O)=>{if(L)return M(L);_.writeFile(O,U,B=>{if(B)return _.close(O,()=>M(B));_.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),o=!1),_.close(O,Q=>M(Q))))})})}function p($,U,F){const M=v(F);if(!o)return _.writeFileSync($,U,{mode:M.mode,flag:M.flag});const L=_.openSync($,M.flag,M.mode);try{_.writeFileSync(L,U);try{_.fdatasyncSync(L)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),o=!1}}finally{_.closeSync(L)}}e.writeFileSync=p;function v($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function h($,U){if($!==U){async function F(M){try{const L=await _.promises.lstat(M);if(L.isDirectory()||L.isSymbolicLink())return;const O=await _.promises.open(M,"a");try{await O.utimes(L.atime,new Date)}finally{await O.close()}}catch(L){}}try{await _.promises.rename($,U),await F(U)}catch(M){if($.toLowerCase()!==U.toLowerCase()&&M.code==="EXDEV"||$.endsWith("."))await w($,U,{preserveSymlinks:!1}),await g($,f.MOVE),await F(U);else throw M}}}e.move=h;async function w($,U,F){return N($,U,{root:{source:$,target:U},options:F,handledSourcePaths:new Set})}e.copy=w;const R=511;async function N($,U,F){if(!F.handledSourcePaths.has($)){F.handledSourcePaths.add($);const{stat:M,symbolicLink:L}=await n.stat($);if(L){if(F.options.preserveSymlinks)try{return await V($,U,F)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(L.dangling)return}return M.isDirectory()?j($,U,M.mode&R,F):re($,U,M.mode&R)}}async function j($,U,F,M){await _.promises.mkdir(U,{recursive:!0,mode:F});const L=await b($);for(const O of L)await N((0,T.join)($,O),(0,T.join)(U,O),M)}async function re($,U,F){await _.promises.copyFile($,U),await _.promises.chmod(U,F)}async function V($,U,F){let M=await _.promises.readlink($);(0,P.isEqualOrParent)(M,F.root.source,!y.isLinux)&&(M=(0,T.join)(F.root.target,M.substr(F.root.source.length+1))),await _.promises.symlink(M,U)}async function W($){try{return await _.promises.access($),!0}catch(U){return!1}}e.exists=W}),define(ge[103],pe([0,1,37,285,9,8,26]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(C){const f=(0,A.dirname)(C);if(C===f)return C;const g=((0,A.basename)(C)||C).toLowerCase();try{const u=(0,y.readdirSync)(f).filter(E=>E.toLowerCase()===g);if(u.length===1){const E=P(f);if(E)return(0,A.join)(E,u[0])}else if(u.length>1){const E=u.indexOf(g);if(E>=0){const b=P(f);if(b)return(0,A.join)(b,u[E])}}}catch(a){}return null}e.realcaseSync=P;async function D(C){try{return await(0,I.promisify)(_.realpath)(C)}catch(f){const g=i(C);return await _.promises.access(g,_.constants.R_OK),g}}e.realpath=D;function k(C){try{return _.realpathSync(C)}catch(f){const g=i(C);return _.accessSync(g,_.constants.R_OK),g}}e.realpathSync=k;function i(C){return(0,T.rtrim)((0,A.normalize)(C),A.sep)}});var Et=this&&this.__await||function(G){return this instanceof Et?(this.v=G,this):new Et(G)},Fn=this&&this.__asyncGenerator||function(G,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=_.apply(G,e||[]),T,A=[];return T={},y("next"),y("throw"),y("return"),T[Symbol.asyncIterator]=function(){return this},T;function y(f){I[f]&&(T[f]=function(g){return new Promise(function(a,u){A.push([f,g,a,u])>1||P(f,g)})})}function P(f,g){try{D(I[f](g))}catch(a){C(A[0][3],a)}}function D(f){f.value instanceof Et?Promise.resolve(f.value.v).then(k,i):C(A[0][2],f)}function k(f){P("next",f)}function i(f){P("throw",f)}function C(f,g){f(g),A.shift(),A.length&&P(A[0][0],A[0][1])}},fn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(A){_[A]=G[A]&&function(y){return new Promise(function(P,D){y=G[A](y),T(P,D,y.done,y.value)})}}function T(A,y,P,D){Promise.resolve(D).then(function(k){A({value:k,done:P})},y)}};define(ge[104],pe([0,1,26,48,8]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,y=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var D;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(D||(D={}));let k;switch(process.arch){case"ia32":case"x32":k=1;break;case"arm":case"arm64":k=2;break;default:k=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(m,t,n){this.exePath=m,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:l=!1}={}){return l?k===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:l=!1,findPreview:m=!1}={}){const t=f({useAlternateBitness:l});if(!t)return null;const n=T.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(n))return null;let s=-1,r=null;for(const p of await _.readdir(n)){let v=-1;if(m){const w=p.indexOf("-");if(w<0)continue;const R=p.substring(0,w);if(!A.test(R)||p.substring(w+1)!=="preview")continue;v=parseInt(R,10)}else{if(!A.test(p))continue;v=parseInt(p,10)}if(!(v<=s)){const h=T.join(n,p,"pwsh.exe");!await _.SymlinkSupport.existsFile(h)||(r=h,s=v)}}if(!r)return null;const o=t.includes("x86")?" (x86)":"",c=m?" Preview":"";return new C(r,`PowerShell${c}${o}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const m=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=l?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const s of await _.readdir(m))if(t.test(s)){const r=T.join(m,s,"pwsh.exe");return new C(r,n)}return null}function u(){const l=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(l,".NET Core PowerShell Global Tool")}function E(){const l=T.join(process.env.windir,k===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(l,"Windows PowerShell",!0)}function b(){return Fn(this,arguments,function*(){let m=yield Et(g());m&&(yield yield Et(m)),m=yield Et(g({useAlternateBitness:!0})),m&&(yield yield Et(m)),m=yield Et(a()),m&&(yield yield Et(m)),m=u(),m&&(yield yield Et(m)),m=yield Et(g({findPreview:!0})),m&&(yield yield Et(m)),m=yield Et(a({findPreview:!0})),m&&(yield yield Et(m)),m=yield Et(g({useAlternateBitness:!0,findPreview:!0})),m&&(yield yield Et(m)),m=E(),m&&(yield yield Et(m))})}function S(){return Fn(this,arguments,function*(){var m,t;try{for(var n=fn(b()),s;s=yield Et(n.next()),!s.done;){const r=s.value;(yield Et(r.exists()))&&(yield yield Et(r))}}catch(r){m={error:r}}finally{try{s&&!s.done&&(t=n.return)&&(yield Et(t.call(n)))}finally{if(m)throw m.error}}})}e.enumeratePowerShellInstallations=S;async function d(){var l,m;try{for(var t=fn(S()),n;n=await t.next(),!n.done;)return n.value}catch(s){l={error:s}}finally{try{n&&!n.done&&(m=t.return)&&await m.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(ge[105],pe([0,1,3,6,13,21,18,22,19,11,58,9]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function g(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function u(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(E||(E={}));class b{constructor(L){this.buffer=L,this.pos=0}read(L){const O=this.buffer.slice(this.pos,this.pos+L);return this.pos+=O.byteLength,O}}class S{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var d;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(d||(d={}));function l(M){const L=P.VSBuffer.alloc(4);return L.writeUInt32BE(M,0),L}function m(M){return M.read(4).readUInt32BE(0)}function t(M){const L=P.VSBuffer.alloc(1);return L.writeUInt8(M,0),L}const n={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},s=typeof Buffer!="undefined";function r(M,L){if(typeof L=="undefined")M.write(n.Undefined);else if(typeof L=="string"){const O=P.VSBuffer.fromString(L);M.write(n.String),M.write(l(O.byteLength)),M.write(O)}else if(s&&Buffer.isBuffer(L)){const O=P.VSBuffer.wrap(L);M.write(n.Buffer),M.write(l(O.byteLength)),M.write(O)}else if(L instanceof P.VSBuffer)M.write(n.VSBuffer),M.write(l(L.byteLength)),M.write(L);else if(Array.isArray(L)){M.write(n.Array),M.write(l(L.length));for(const O of L)r(M,O)}else{const O=P.VSBuffer.fromString(JSON.stringify(L));M.write(n.Object),M.write(l(O.byteLength)),M.write(O)}}function o(M){switch(M.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return M.read(m(M)).toString();case d.Buffer:return M.read(m(M)).buffer;case d.VSBuffer:return M.read(m(M));case d.Array:{const O=m(M),B=[];for(let q=0;q<O;q++)B.push(o(M));return B}case d.Object:return JSON.parse(M.read(m(M)).toString())}}class c{constructor(L,O,B=null,q=1e3){this.protocol=L,this.ctx=O,this.logger=B,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(L,O){this.channels.set(L,O),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const O=this.send([L.type]);this.logger&&this.logger.logOutgoing(O,0,1,u(L.type));return}case 201:case 202:case 204:case 203:{const O=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(O,L.id,1,u(L.type),L.data);return}}}send(L,O=void 0){const B=new S;return r(B,L),r(B,O),this.sendBuffer(B.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(O){return 0}}onRawMessage(L){const O=new b(L),B=o(O),q=o(O),Q=B[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${g(Q)}: ${B[2]}.${B[3]}`,q),this.onPromise({type:Q,id:B[1],channelName:B[2],name:B[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${g(Q)}: ${B[2]}.${B[3]}`,q),this.onEventListen({type:Q,id:B[1],channelName:B[2],name:B[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${g(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],1,`${g(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]})}}onPromise(L){const O=this.channels.get(L.channelName);if(!O){this.collectPendingRequest(L);return}const B=new A.CancellationTokenSource;let q;try{q=O.call(this.ctx,L.name,L.arg,B.token)}catch(be){q=Promise.reject(be)}const Q=L.id;q.then(be=>{this.sendResponse({id:Q,data:be,type:201}),this.activeRequests.delete(L.id)},be=>{be instanceof Error?this.sendResponse({id:Q,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:202}):this.sendResponse({id:Q,data:be,type:203}),this.activeRequests.delete(L.id)});const de=(0,I.toDisposable)(()=>B.cancel());this.activeRequests.set(L.id,de)}onEventListen(L){const O=this.channels.get(L.channelName);if(!O){this.collectPendingRequest(L);return}const B=L.id,Q=O.listen(this.ctx,L.name,L.arg)(de=>this.sendResponse({id:B,data:de,type:204}));this.activeRequests.set(L.id,Q)}disposeActiveRequest(L){const O=this.activeRequests.get(L.id);O&&(O.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let O=this.pendingRequests.get(L.channelName);O||(O=[],this.pendingRequests.set(L.channelName,O));const B=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:L,timeoutTimer:B})}flushPendingRequests(L){const O=this.pendingRequests.get(L);if(O){for(const B of O)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var p;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(L,O=null){this.protocol=L,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=O}getChannel(L){const O=this;return{call(B,q,Q){return O.isDisposed?Promise.reject(y.canceled()):O.requestPromise(L,B,q,Q)},listen(B,q){return O.isDisposed?Promise.reject(y.canceled()):O.requestEvent(L,B,q)}}}requestPromise(L,O,B,q=A.CancellationToken.None){const Q=this.lastRequestId++,be={id:Q,type:100,channelName:L,name:O,arg:B};if(q.isCancellationRequested)return Promise.reject(y.canceled());let Ae;return new Promise((Le,z)=>{if(q.isCancellationRequested)return z(y.canceled());const Y=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const we=new Error(Oe.data.message);we.stack=Oe.data.stack,we.name=Oe.data.name,z(we);break;case 203:this.handlers.delete(Q),z(Oe.data);break}};this.handlers.set(Q,De),this.sendRequest(be)};let ee=null;this.state===E.Idle?Y():(ee=(0,T.createCancelablePromise)(De=>this.whenInitialized()),ee.then(()=>{ee=null,Y()}));const le=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),z(y.canceled())},me=q.onCancellationRequested(le);Ae=(0,I.combinedDisposable)((0,I.toDisposable)(le),me),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(L,O,B){const q=this.lastRequestId++,de={id:q,type:102,channelName:L,name:O,arg:B};let be=null;const Ae=new _.Emitter({onFirstListenerAdd:()=>{be=(0,T.createCancelablePromise)(Le=>this.whenInitialized()),be.then(()=>{be=null,this.activeRequests.add(Ae),this.sendRequest(de)})},onLastListenerRemove:()=>{be?(be.cancel(),be=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Ce=Le=>Ae.fire(Le.data);return this.handlers.set(q,Ce),Ae.event}sendRequest(L){switch(L.type){case 100:case 102:{const O=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(O,L.id,0,`${g(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const O=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(O,L.id,0,g(L.type));return}}}send(L,O=void 0){const B=new S;return r(B,L),r(B,O),this.sendBuffer(B.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(O){return 0}}onBuffer(L){const O=new b(L),B=o(O),q=o(O),Q=B[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,u(Q)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,B[1],0,u(Q),q),this.onResponse({type:B[0],id:B[1],data:q})}}onResponse(L){if(L.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(L.id);O&&O(L)}whenInitialized(){return this.state===E.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelClient=v;class h{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:O,onDidClientDisconnect:B})=>{_.Event.once(O.onMessage)(Q=>{const de=new b(Q),be=o(de),Ae=new c(O,be),Ce=new v(O);this.channels.forEach((z,Y)=>Ae.registerChannel(Y,z));const Le={channelServer:Ae,channelClient:Ce,ctx:be};this._connections.add(Le),this._onDidAddConnection.fire(Le),B(()=>{Ae.dispose(),Ce.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const L=[];return this._connections.forEach(O=>L.push(O)),L}getChannel(L,O){const B=this;return{call(q,Q,de){let be;if((0,k.isFunction)(O)){let Ce=(0,D.getRandomElement)(B.connections.filter(O));be=Ce?Promise.resolve(Ce):_.Event.toPromise(_.Event.filter(B.onDidAddConnection,O))}else be=O.routeCall(B,q,Q);const Ae=be.then(Ce=>Ce.channelClient.getChannel(L));return R(Ae).call(q,Q,de)},listen(q,Q){if((0,k.isFunction)(O))return B.getMulticastEvent(L,O,q,Q);const de=O.routeEvent(B,q,Q).then(be=>be.channelClient.getChannel(L));return R(de).listen(q,Q)}}}getMulticastEvent(L,O,B,q){const Q=this;let de=new I.DisposableStore;const be=new _.Emitter({onFirstListenerAdd:()=>{de=new I.DisposableStore;const Ae=new _.EventMultiplexer,Ce=new Map,Le=Y=>{const le=Y.channelClient.getChannel(L).listen(B,q),me=Ae.add(le);Ce.set(Y,me)},z=Y=>{const ee=Ce.get(Y);!ee||(ee.dispose(),Ce.delete(Y))};Q.connections.filter(O).forEach(Le),_.Event.filter(Q.onDidAddConnection,O)(Le,void 0,de),Q.onDidRemoveConnection(z,void 0,de),Ae.event(be.fire,be,de),de.add(Ae)},onLastListenerRemove:()=>{de.dispose()}});return be.event}registerChannel(L,O){this.channels.set(L,O),this._connections.forEach(B=>{B.channelServer.registerChannel(L,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=h;class w{constructor(L,O,B=null){const q=new S;r(q,O),L.send(q.buffer),this.channelClient=new v(L,B),this.channelServer=new c(L,O,B)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,O){this.channelServer.registerChannel(L,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function R(M){return{call(L,O,B){return M.then(q=>q.call(L,O,B))},listen(L,O){const B=new _.Relay;return M.then(q=>B.input=q.listen(L,O)),B.event}}}e.getDelayedChannel=R;function N(M){let L=!1;return{call(O,B,q){return L?M.call(O,B,q):(0,T.timeout)(0).then(()=>L=!0).then(()=>M.call(O,B,q))},listen(O,B){if(L)return M.listen(O,B);const q=new _.Relay;return(0,T.timeout)(0).then(()=>L=!0).then(()=>q.input=M.listen(O,B)),q.event}}}e.getNextTickChannel=N;class j{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const O of L.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(L.onDidAddConnection),await this.route(L)}}e.StaticRouter=j;var re;(function(M){function L(q,Q){const de=q,be=Q&&Q.disableMarshalling,Ae=new Map;for(const Ce in de)B(Ce)&&Ae.set(Ce,_.Event.buffer(de[Ce],!0));return new class{listen(Ce,Le){const z=Ae.get(Le);if(z)return z;throw new Error(`Event not found: ${Le}`)}call(Ce,Le,z){const Y=de[Le];if(typeof Y=="function"){if(!be&&Array.isArray(z))for(let ee=0;ee<z.length;ee++)z[ee]=(0,i.revive)(z[ee]);return Y.apply(de,z)}throw new Error(`Method not found: ${Le}`)}}}M.fromService=L;function O(q,Q){const de=Q&&Q.disableMarshalling;return new Proxy({},{get(be,Ae){var Ce;if(typeof Ae=="string")return((Ce=Q==null?void 0:Q.properties)===null||Ce===void 0?void 0:Ce.has(Ae))?Q.properties.get(Ae):B(Ae)?q.listen(Ae):async function(...Le){let z;Q&&!(0,k.isUndefinedOrNull)(Q.context)?z=[Q.context,...Le]:z=Le;const Y=await q.call(Ae,z);return de?Y:(0,i.revive)(Y)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function B(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let L=M.toString();if(L!=="[object Object]")return L}return M}function $(M){return Array.isArray(M)?M.map(W):W(M)}function U(M,L,O,B,q,Q,de){de=$(de);const be=V[q],Ae=be[B%be.length];let Ce=[`%c[${M}]%c[${String(L).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(Q)?(Ce=Ce.concat(de),Ce.push(")")):Ce.push(de),console.log.apply(console,Ce)}e.logWithColors=U;class F{constructor(L,O){this._outgoingPrefix=L,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,O,B,q,Q){this._totalOutgoing+=L,U(this._outgoingPrefix,this._totalOutgoing,L,O,B,q,Q)}logIncoming(L,O,B,q,Q){this._totalIncoming+=L,U(this._incomingPrefix,this._totalIncoming,L,O,B,q,Q)}}e.IPCLogger=F}),define(ge[106],pe([0,1,3,105,6,22,10,36]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function k(){return D||(D=A.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return k();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const v=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),v}if(this._chunks[0].byteLength>s){const v=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),v}let o=A.VSBuffer.alloc(s),c=0,p=0;for(;s>0;){const v=this._chunks[p];if(v.byteLength>s){const h=v.slice(0,s);o.set(h,c),c+=s,r&&(this._chunks[p]=v.slice(s),this._totalLength-=s),s-=s}else o.set(v,c),c+=v.byteLength,r?(this._chunks.shift(),this._totalLength-=v.byteLength):p++,s-=v.byteLength}return o}}e.ChunkStream=i;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,r,o,c){this.type=s,this.id=r,this.ack=o,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends T.Disposable{constructor(s){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,c=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(o,c,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=A.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends T.Disposable{constructor(s){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(1,0,0,s))}}e.Protocol=E;class b extends I.IPCClient{constructor(s,r,o=null){super(s,r,o);this.protocol=s}static fromSocket(s,r){return new b(new E(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=b;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class d{constructor(s){this.data=s,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new d(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class m{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<m._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=m._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return m._INSTANCE||(m._INSTANCE=new m),m._INSTANCE}load(){const s=Date.now(),r=(1+m._HISTORY_LENGTH)*1e3;let o=0;for(let c=0;c<m._HISTORY_LENGTH;c++)s-this.lastRuns[c]<=r&&o++;return 1-o/m._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}m._HISTORY_LENGTH=10,m._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=m.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new g(5,0,0,k());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new g(4,0,0,k());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,o=s.length;r<o;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,k())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,c=r.length;o<c;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new g(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,k());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(ge[107],pe([0,1,96]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(P){let D=(0,_.toUint8)(P);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(P){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=P;return D}set(P,D){let k=(0,_.toUint8)(D);P>=0&&P<256?this._asciiMap[P]=k:this._map.set(P,k)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(T||(T={}));class A{constructor(){this._actual=new I(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=A}),define(ge[138],pe([0,1,107]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends _.CharacterClassifier{constructor(P){super(0);for(let D=0,k=P.length;D<k;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function A(y){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=y(D)),P[D])}e.getMapForWordSeparators=A(y=>new T(y))}),define(ge[49],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(T,A){this.lineNumber=T,this.column=A}with(T=this.lineNumber,A=this.column){return T===this.lineNumber&&A===this.column?this:new _(T,A)}delta(T=0,A=0){return this.with(this.lineNumber+T,this.column+A)}equals(T){return _.equals(this,T)}static equals(T,A){return!T&&!A?!0:!!T&&!!A&&T.lineNumber===A.lineNumber&&T.column===A.column}isBefore(T){return _.isBefore(this,T)}static isBefore(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<A.column}isBeforeOrEqual(T){return _.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<=A.column}static compare(T,A){let y=T.lineNumber|0,P=A.lineNumber|0;if(y===P){let D=T.column|0,k=A.column|0;return D-k}return y-P}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new _(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=_}),define(ge[44],pe([0,1,49]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,y,P,D){A>P||A===P&&y>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,y){let P,D,k,i;return y.startLineNumber<A.startLineNumber?(P=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(P=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(P=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===A.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,A.endColumn)):(k=A.endLineNumber,i=A.endColumn),new I(P,D,k,i)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,y){let P=A.startLineNumber,D=A.startColumn,k=A.endLineNumber,i=A.endColumn,C=y.startLineNumber,f=y.startColumn,g=y.endLineNumber,a=y.endColumn;return P<C?(P=C,D=f):P===C&&(D=Math.max(D,f)),k>g?(k=g,i=a):k===g&&(i=Math.min(i,a)),P>k||P===k&&D>i?null:new I(P,D,k,i)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new _.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new _.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new I(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new I(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new I(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const k=A.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const C=A.startColumn|0,f=y.startColumn|0;if(C===f){const g=A.endLineNumber|0,a=y.endLineNumber|0;if(g===a){const u=A.endColumn|0,E=y.endColumn|0;return u-E}return g-a}return C-f}return k-i}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(ge[139],pe([0,1,49,44]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(P,D,k,i){super(P,D,k,i);this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,D):new A(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,D){return this.getDirection()===0?new A(P,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new A(P.lineNumber,P.column,D.lineNumber,D.column)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let k=0,i=P.length;k<i;k++)if(!this.selectionsEqual(P[k],D[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,k,i,C){return C===0?new A(P,D,k,i):new A(k,i,P,D)}}e.Selection=A}),define(ge[108],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class D{constructor(a,u){this.range=a,this.matches=u}}e.FindMatch=D;var k;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,u,E,b,S,d){this.identifier=a,this.range=u,this.text=E,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=S,this._isTracked=d}}e.ValidAnnotatedEditOperation=C;class f{constructor(a,u,E){this.reverseEdits=a,this.changes=u,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=f}),define(ge[140],pe([0,1,9,138,49,44,108]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(d,l,m,t){this.searchString=d,this.isRegex=l,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=k(this.searchString):d=this.searchString.indexOf(`
`)>=0;let l=null;try{l=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let m=!this.isRegex&&!d;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new i(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let d=0,l=S.length;d<l;d++)if(S.charCodeAt(d)===92){if(d++,d>=l)break;const t=S.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(d,l,m){this.regex=d,this.wordSeparators=l,this.simpleSearch=m}}e.SearchData=i;function C(S,d,l){if(!l)return new y.FindMatch(S,null);let m=[];for(let t=0,n=d.length;t<n;t++)m[t]=d[t];return new y.FindMatch(S,m)}e.createFindMatch=C;class f{constructor(d){let l=[],m=0;for(let t=0,n=d.length;t<n;t++)d.charCodeAt(t)===10&&(l[m++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(d){const l=this._lineFeedsOffsets;let m=0,t=l.length-1;if(t===-1||d<=l[0])return 0;for(;m<t;){const n=m+((t-m)/2>>0);l[n]>=d?t=n-1:l[n+1]>=d?(m=n,t=n):m=n+1}return m+1}}class g{static findMatches(d,l,m,t,n){const s=l.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,m,new b(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(d,m,s,t,n):[]}static _getMultilineMatchRange(d,l,m,t,n,s){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=l+n+o):r=l+n;let c;if(t){let w=t.findLineFeedCountBeforeOffset(n+s.length)-o;c=r+s.length+w}else c=r+s.length;const p=d.getPositionAt(r),v=d.getPositionAt(c);return new A.Range(p.lineNumber,p.column,v.lineNumber,v.column)}static _doFindMatchesMultiline(d,l,m,t,n){const s=d.getOffsetAt(l.getStartPosition()),r=d.getValueInRange(l,1),o=d.getEOL()===`\r
`?new f(r):null,c=[];let p=0,v;for(m.reset(0);v=m.next(r);)if(c[p++]=C(this._getMultilineMatchRange(d,s,r,o,v.index,v[0]),v,t),p>=n)return c;return c}static _doFindMatchesLineByLine(d,l,m,t,n){const s=[];let r=0;if(l.startLineNumber===l.endLineNumber){const c=d.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return r=this._findMatchesInLine(m,c,l.startLineNumber,l.startColumn-1,r,s,t,n),s}const o=d.getLineContent(l.startLineNumber).substring(l.startColumn-1);r=this._findMatchesInLine(m,o,l.startLineNumber,l.startColumn-1,r,s,t,n);for(let c=l.startLineNumber+1;c<l.endLineNumber&&r<n;c++)r=this._findMatchesInLine(m,d.getLineContent(c),c,0,r,s,t,n);if(r<n){const c=d.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);r=this._findMatchesInLine(m,c,l.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(d,l,m,t,n,s,r,o){const c=d.wordSeparators;if(!r&&d.simpleSearch){const h=d.simpleSearch,w=h.length,R=l.length;let N=-w;for(;(N=l.indexOf(h,N+w))!==-1;)if((!c||E(c,l,R,N,w))&&(s[n++]=new y.FindMatch(new A.Range(m,N+1+t,m,N+1+w+t),null),n>=o))return n;return n}const p=new b(d.wordSeparators,d.regex);let v;p.reset(0);do if(v=p.next(l),v&&(s[n++]=C(new A.Range(m,v.index+1+t,m,v.index+1+v[0].length+t),v,r),n>=o))return n;while(v);return n}static findNextMatch(d,l,m,t){const n=l.parseSearchRequest();if(!n)return null;const s=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(d,m,s,t):this._doFindNextMatchLineByLine(d,m,s,t)}static _doFindNextMatchMultiline(d,l,m,t){const n=new T.Position(l.lineNumber,1),s=d.getOffsetAt(n),r=d.getLineCount(),o=d.getValueInRange(new A.Range(n.lineNumber,n.column,r,d.getLineMaxColumn(r)),1),c=d.getEOL()===`\r
`?new f(o):null;m.reset(l.column-1);let p=m.next(o);return p?C(this._getMultilineMatchRange(d,s,o,c,p.index,p[0]),p,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(d,new T.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(d,l,m,t){const n=d.getLineCount(),s=l.lineNumber,r=d.getLineContent(s),o=this._findFirstMatchInLine(m,r,s,l.column,t);if(o)return o;for(let c=1;c<=n;c++){const p=(s+c-1)%n,v=d.getLineContent(p+1),h=this._findFirstMatchInLine(m,v,p+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(d,l,m,t,n){d.reset(t-1);const s=d.next(l);return s?C(new A.Range(m,s.index+1,m,s.index+1+s[0].length),s,n):null}static findPreviousMatch(d,l,m,t){const n=l.parseSearchRequest();if(!n)return null;const s=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(d,m,s,t):this._doFindPreviousMatchLineByLine(d,m,s,t)}static _doFindPreviousMatchMultiline(d,l,m,t){const n=this._doFindMatchesMultiline(d,new A.Range(1,1,l.lineNumber,l.column),m,t,10*P);if(n.length>0)return n[n.length-1];const s=d.getLineCount();return l.lineNumber!==s||l.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new T.Position(s,d.getLineMaxColumn(s)),m,t):null}static _doFindPreviousMatchLineByLine(d,l,m,t){const n=d.getLineCount(),s=l.lineNumber,r=d.getLineContent(s).substring(0,l.column-1),o=this._findLastMatchInLine(m,r,s,t);if(o)return o;for(let c=1;c<=n;c++){const p=(n+s-c-1)%n,v=d.getLineContent(p+1),h=this._findLastMatchInLine(m,v,p+1,t);if(h)return h}return null}static _findLastMatchInLine(d,l,m,t){let n=null,s;for(d.reset(0);s=d.next(l);)n=C(new A.Range(m,s.index+1,m,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=g;function a(S,d,l,m,t){if(m===0)return!0;const n=d.charCodeAt(m-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=d.charCodeAt(m);if(S.get(s)!==0)return!0}return!1}function u(S,d,l,m,t){if(m+t===l)return!0;const n=d.charCodeAt(m+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=d.charCodeAt(m+t-1);if(S.get(s)!==0)return!0}return!1}function E(S,d,l,m,t){return a(S,d,l,m,t)&&u(S,d,l,m,t)}e.isValidMatch=E;class b{constructor(d,l){this._wordSeparators=d,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const l=d.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(m=this._searchRegex.exec(d),!m))return null;const t=m.index,n=m[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(d,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,d,l,t,n))return m}while(m);return null}}e.Searcher=b}),define(ge[109],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(P=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=_();function I(P){let D=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)D=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),D=new RegExp(P.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function A(P,D,k,i,C=T){if(k.length>C.maxLen){let E=P-C.maxLen/2;return E<0?E=0:i+=E,k=k.substring(E,P+C.maxLen/2),A(P,D,k,i,C)}const f=Date.now(),g=P-1-i;let a=-1,u=null;for(let E=1;!(Date.now()-f>=C.timeBudget);E++){const b=g-C.windowSize*E;D.lastIndex=Math.max(0,b);const S=y(D,k,g,a);if(!S&&u||(u=S,b<=0))break;a=b}if(u){let E={word:u[0],startColumn:i+1+u.index,endColumn:i+1+u.index+u[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=A;function y(P,D,k,i){let C;for(;C=P.exec(D);){const f=C.index||0;if(f<=k&&P.lastIndex>=k)return C;if(i>0&&f>i)return null}return null}}),define(ge[141],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class I{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,k=P.notIn.length;D<k;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=T;function A(y,P,D){y.has(P)?y.get(P).push(D):y.set(P,[D])}}),define(ge[77],pe([0,1,33,8]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(A,y,P,D){if(Array.isArray(A)){let k=0;for(const i of A){const C=T(i,y,P,D);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof A=="string")return D?A==="*"?5:A===P?10:0:0;if(A){const{language:k,pattern:i,scheme:C,hasAccessToAllModels:f}=A;if(!D&&!f)return 0;let g=0;if(C)if(C===y.scheme)g=10;else if(C==="*")g=5;else return 0;if(k)if(k===P)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a=Object.assign(Object.assign({},i),{base:(0,I.normalize)(i.base)}),a===y.fsPath||(0,_.match)(a,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=T}),define(ge[142],pe([0,1,107]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(a,u,E){const b=new Uint8Array(a*u);for(let S=0,d=a*u;S<d;S++)b[S]=E;this._data=b,this.rows=a,this.cols=u}get(a,u){return this._data[a*this.cols+u]}set(a,u,E){this._data[a*this.cols+u]=E}}e.Uint8Matrix=T;class A{constructor(a){let u=0,E=0;for(let S=0,d=a.length;S<d;S++){let[l,m,t]=a[S];m>u&&(u=m),l>E&&(E=l),t>E&&(E=t)}u++,E++;let b=new T(E,u,0);for(let S=0,d=a.length;S<d;S++){let[l,m,t]=a[S];b.set(l,m,t)}this._states=b,this._maxCharCode=u}nextState(a,u){return u<0||u>=this._maxCharCode?0:this._states.get(a,u)}}e.StateMachine=A;let y=null;function P(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function i(){if(k===null){k=new _.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<g.length;u++)k.set(g.charCodeAt(u),1);const a=".,;";for(let u=0;u<a.length;u++)k.set(a.charCodeAt(u),2)}return k}class C{static _createLink(a,u,E,b,S){let d=S-1;do{const l=u.charCodeAt(d);if(a.get(l)!==2)break;d--}while(d>b);if(b>0){const l=u.charCodeAt(b-1),m=u.charCodeAt(d);(l===40&&m===41||l===91&&m===93||l===123&&m===125)&&d--}return{range:{startLineNumber:E,startColumn:b+1,endLineNumber:E,endColumn:d+2},url:u.substring(b,d+1)}}static computeLinks(a,u=P()){const E=i();let b=[];for(let S=1,d=a.getLineCount();S<=d;S++){const l=a.getLineContent(S),m=l.length;let t=0,n=0,s=0,r=1,o=!1,c=!1,p=!1,v=!1;for(;t<m;){let h=!1;const w=l.charCodeAt(t);if(r===13){let R;switch(w){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:p=!0,c=!0,R=0;break;case 93:p=!1,R=c?0:1;break;case 123:v=!0,R=0;break;case 125:R=v?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=p?0:1;break;default:R=E.get(w)}R===1&&(b.push(C._createLink(E,l,S,n,t)),h=!0)}else if(r===12){let R;w===91?(c=!0,R=0):R=E.get(w),R===1?h=!0:r=13}else r=u.nextState(r,w),r===0&&(h=!0);h&&(r=1,o=!1,c=!1,v=!1,n=t+1,s=w),t++}r===13&&b.push(C._createLink(E,l,S,n,m))}return b}}e.LinkComputer=C;function f(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:C.computeLinks(g)}e.computeLinks=f}),define(ge[143],pe([0,1,3,6]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,P){return this._map.set(y,P),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===P&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,P){let D=null,k=!1;return this._promises.set(y,P.then(i=>{this._promises.delete(y),!(k||!i)&&(D=this.register(y,i))})),(0,I.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const P=this.get(y);if(P)return Promise.resolve(P);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[110],pe([0,1,22,10]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function A(C){for(let f=0,g=C.length;f<g;f+=4){const a=C[f+0],u=C[f+1],E=C[f+2],b=C[f+3];C[f+0]=b,C[f+1]=E,C[f+2]=u,C[f+3]=a}}function y(C){const f=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||A(f),_.VSBuffer.wrap(f)}function P(C){const f=C.buffer;if(I.isLittleEndian()||A(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const g=new Uint8Array(f.byteLength);return g.set(f),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(C){const f=new Uint32Array(k(C));let g=0;if(f[g++]=C.id,C.type==="full")f[g++]=1,f[g++]=C.data.length,f.set(C.data,g),g+=C.data.length;else{f[g++]=2,f[g++]=C.deltas.length;for(const a of C.deltas)f[g++]=a.start,f[g++]=a.deleteCount,a.data?(f[g++]=a.data.length,f.set(a.data,g),g+=a.data.length):f[g++]=0}return y(f)}e.encodeSemanticTokensDto=D;function k(C){let f=0;if(f+=1+1,C.type==="full")f+=1+C.data.length;else{f+=1,f+=(1+1+1)*C.deltas.length;for(const g of C.deltas)g.data&&(f+=g.data.length)}return f}function i(C){const f=P(C);let g=0;const a=f[g++];if(f[g++]===1){const S=f[g++],d=f.subarray(g,g+S);return g+=S,{id:a,type:"full",data:d}}const E=f[g++];let b=[];for(let S=0;S<E;S++){const d=f[g++],l=f[g++],m=f[g++];let t;m>0&&(t=f.subarray(g,g+m),g+=m),b[S]={start:d,deleteCount:l,data:t}}return{id:a,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(ge[111],pe([0,1,96]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,P){this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=I;class T{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,_.toUint32)(y);const D=this.values,k=this.prefixSum,i=P.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,P){return y=(0,_.toUint32)(y),P=(0,_.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,_.toUint32)(y),P=(0,_.toUint32)(P);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return P>=i&&(P=i),P===0?!1:(this.values=new Uint32Array(D.length-P),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,_.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let D=P;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let P=0,D=this.values.length-1,k=0,i=0,C=0;for(;P<=D;)if(k=P+(D-P)/2|0,i=this.prefixSum[k],C=i-this.values[k],y<C)D=k-1;else if(y>=i)P=k+1;else break;return new I(k,y-C)}}e.PrefixSumComputer=T}),define(ge[144],pe([0,1,9,49,111]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,D,k,i){this._uri=P,this._lines=D,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const D=P.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let i=0;i<D;i++)k[i]=this._lines[i].length+P;this._lineStarts=new T.PrefixSumComputer(k)}}_setLineText(P,D){this._lines[P]=D,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,D){if(D.length!==0){let k=(0,_.splitLines)(D);if(k.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(P.lineNumber+C-1,0,k[C]),i[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,i)}}}e.MirrorTextModel=A}),define(ge[145],pe([16,17]),function(G,e){return G.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,A=T*24,y=A*7,P=A*30,D=A*365;function k(C,f){typeof C!="number"&&(C=C.getTime());const g=Math.round((new Date().getTime()-C)/1e3);if(g<-30)return(0,_.localize)(0,null,k(new Date().getTime()+g*1e3,!1));if(g<30)return(0,_.localize)(1,null);let a;return g<I?(a=g,f?a===1?(0,_.localize)(2,null,a):(0,_.localize)(3,null,a):a===1?(0,_.localize)(4,null,a):(0,_.localize)(5,null,a)):g<T?(a=Math.floor(g/I),f?a===1?(0,_.localize)(6,null,a):(0,_.localize)(7,null,a):a===1?(0,_.localize)(8,null,a):(0,_.localize)(9,null,a)):g<A?(a=Math.floor(g/T),f?a===1?(0,_.localize)(10,null,a):(0,_.localize)(11,null,a):a===1?(0,_.localize)(12,null,a):(0,_.localize)(13,null,a)):g<y?(a=Math.floor(g/A),f?a===1?(0,_.localize)(14,null,a):(0,_.localize)(15,null,a):a===1?(0,_.localize)(16,null,a):(0,_.localize)(17,null,a)):g<P?(a=Math.floor(g/y),f?a===1?(0,_.localize)(18,null,a):(0,_.localize)(19,null,a):a===1?(0,_.localize)(20,null,a):(0,_.localize)(21,null,a)):g<D?(a=Math.floor(g/P),f?a===1?(0,_.localize)(22,null,a):(0,_.localize)(23,null,a):a===1?(0,_.localize)(24,null,a):(0,_.localize)(25,null,a)):(a=Math.floor(g/D),f?a===1?(0,_.localize)(26,null,a):(0,_.localize)(27,null,a):a===1?(0,_.localize)(28,null,a):(0,_.localize)(29,null,a))}e.fromNow=k;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(ge[147],pe([16,17]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ge[59],pe([0,1,147,11,19]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,i){return i&&(k.stack||k.stacktrace)?_.localize(0,null,P(k),y(k.stack)||y(k.stacktrace)):P(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?_.localize(1,null,k.message):k.message||_.localize(2,null)}function D(k=null,i=!1){if(!k)return _.localize(3,null);if(Array.isArray(k)){const C=T.coalesce(k),f=D(C[0],i);return C.length>1?_.localize(4,null,f,C.length):f}if(I.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return A(C.error,i);if(C.exception)return A(C.exception,i)}return k.stack?A(k,i):k.message?k.message:_.localize(5,null)}e.toErrorMessage=D}),define(ge[148],pe([16,17]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ge[78],pe([0,1,8,37,26,38,148,36,11,23,29,10,137,12]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(m,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=A.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],n);return new Promise(r=>{s.once("error",o=>{r({success:!1,error:o})}),s.once("exit",(o,c)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(s=>{A.execFile(n,[m.pid.toString()],{encoding:"utf8",shell:!0},(r,o,c)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function E(m=P.env){return m.comspec||"cmd.exe"}e.getWindowsShell=E;class b{constructor(t,n,s,r){if(n!==void 0&&s!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=r;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(P.env).forEach(c=>{o[c]=P.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(_.sep);return n!==-1&&(t=t.substring(n+1)),b.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(P.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let s,r;const o=new Promise((c,p)=>{s=c,r=p});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=A.exec(c,this.options,(p,v,h)=>{this.childProcess=null;const w=p;w&&w.killed?r({killed:this.terminateRequested,stdout:v.toString(),stderr:h.toString()}):this.handleExec(s,t,p,v,h)})}else{let c=null;const p=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,s,t,r);const h={terminated:this.terminateRequested};D.isNumber(v)&&(h.cmdCode=v),s(h)};if(this.shell&&C.isWindows){const v=k.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let h=!1,w=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),h=N.quoted,this.args&&this.args.forEach(re=>{N=this.ensureQuotes(re),R.push(N.value),w=w&&N.quoted});const j=["/s","/c"];h?w?j.push('"'+R.join(" ")+'"'):R.length>1?j.push('"'+R[0]+'" '+R.slice(1).join(" ")):j.push('"'+R[0]+'"'):j.push(R.join(" ")),c=A.spawn(E(),j,v)}else this.cmd&&(c=A.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(D.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",v=>{this.childProcess=null,r({terminated:this.terminateRequested,error:v})}),c.pid&&(this.childProcess.on("close",p),this.handleSpawn(c,s,t,r,!0)))}return o})}handleClose(t,n,s,r){}ensureQuotes(t){return b.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,u(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=A.spawn(E(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class S extends b{constructor(t,n,s,r){super(t,n,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,r,o){[r,o].forEach((c,p)=>{const v=new f.LineDecoder;v.write(c).forEach(R=>{n({line:R,source:p===0?0:1})});const w=v.end();w&&n({line:w,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,r,o){const c=new f.LineDecoder,p=new f.LineDecoder;t.stdout.on("data",v=>{c.write(v).forEach(w=>s({line:w,source:0}))}),t.stderr.on("data",v=>{p.write(v).forEach(w=>s({line:w,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=p}handleClose(t,n,s,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&s({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&s({line:c,source:1})}}e.LineProcess=S;function d(m){let t=[],n=!1;const s=function(r){if(n){t.push(r);return}(!m.send(r,c=>{if(c&&console.error(c),n=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(v=>s(v))}})||C.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=d;var l;(function(m){async function t(n,s,r){if(_.isAbsolute(n))return n;if(s===void 0&&(s=P.cwd()),_.dirname(n)!=="."||(r===void 0&&D.isString(P.env.PATH)&&(r=P.env.PATH.split(_.delimiter)),r===void 0||r.length===0))return _.join(s,n);async function c(p){return await T.exists(p)?!(await I.promises.stat(p)).isDirectory():!1}for(let p of r){let v;if(_.isAbsolute(p)?v=_.join(p,n):v=_.join(s,p,n),await c(v))return v;let h=v+".com";if(await c(h)||(h=v+".exe",await c(h)))return h}return _.join(s,n)}m.findExecutable=t})(l=e.win32||(e.win32={}))}),define(ge[149],pe([0,1,48,10,104,78]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(g,a){return g===1?I.isWindows?C():A.getWindowsShell(a):k(g,a)}e.getSystemShell=y;function P(g,a){return g===1?I.isWindows?f(a):A.getWindowsShell(a):k(g,a)}e.getSystemShellSync=P;let D=null;function k(g,a){if(I.isLinux&&g===2||I.isMacintosh&&g===3)return"/bin/bash";if(!D){let u;if(I.isWindows)u="/bin/bash";else{if(u=a.SHELL,!u)try{u=(0,_.userInfo)().shell}catch(E){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}D=u}return D}let i=null;async function C(){return i||(i=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),i}function f(g){if(i)return i;const a=I.isWindows&&parseFloat((0,_.release)())>=10,u=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${g.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?E:A.getWindowsShell(g)}}),define(ge[150],pe([16,17]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(ge[151],pe([0,1,150,10,109]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}compute(ie,_e,Ne){return Ne}}class i{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class C{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,Ne){return Ne}}function f(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=f;class g extends C{constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return f(ie,this.defaultValue)}}class a extends C{constructor(ie,_e,Ne,ze,$e,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Ne,Je.minimum=ze,Je.maximum=$e),super(ie,_e,Ne,Je),this.minimum=ze,this.maximum=$e}static clampedInt(ie,_e,Ne,ze){if(typeof ie=="undefined")return _e;let $e=parseInt(ie,10);return isNaN($e)?_e:($e=Math.max(Ne,$e),$e=Math.min(ze,$e),$e|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class u extends C{constructor(ie,_e,Ne,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ie,_e,Ne,$e),this.validationFn=ze}static clamp(ie,_e,Ne){return ie<_e?_e:ie>Ne?Ne:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const Ne=parseFloat(ie);return isNaN(Ne)?_e:Ne}validate(ie){return this.validationFn(u.float(ie,this.defaultValue))}}class E extends C{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return E.string(ie,this.defaultValue)}}function b(X,ie,_e){return typeof X!="string"||_e.indexOf(X)===-1?ie:X}e.stringSet=b;class S extends C{constructor(ie,_e,Ne,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=Ne),super(ie,_e,Ne,$e),this._allowedValues=ze}validate(ie){return b(ie,this.defaultValue,this._allowedValues)}}class d extends k{constructor(ie,_e,Ne,ze,$e,Je,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(ie,_e,Ne,K),this._allowedValues=$e,this._convert=Je}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends k{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:_.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:f(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(X){switch(X){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function c(X){switch(X){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends i{constructor(){super(123,[62,31])}compute(ie,_e,Ne){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class v extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(ie,_e,Ne){return Ne&&ie.emptySelectionClipboard}}class h extends k{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:_.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:_.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:f(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":b(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(_e.loop,this.defaultValue.loop)}}}class w extends k{constructor(){super(41,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?w.OFF:ie==="true"?w.ON:ie:Boolean(ie)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(ie,_e,Ne){return ie.fontInfo}}class N extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(ie){let _e=u.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(_e,6,100)}compute(ie,_e,Ne){return ie.fontInfo.fontSize}}class j extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class re extends k{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ne,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ne,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ne,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ne,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ne,description:_.localize(35,null)}})}validate(ie){var _e,Ne,ze,$e,Je;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:b(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:b(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:b(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:b(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:b(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=K.multipleReferences)!==null&&Je!==void 0?Je:b(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends k{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:_.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:f(_e.sticky,this.defaultValue.sticky)}}}var W;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class $ extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,_e,Ne){return $.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?_e-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),$e=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(ie,_e){const Ne=ie.outerWidth,ze=ie.outerHeight,$e=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Je=_e.stableMinimapLayoutInput,K=Je&&ie.outerHeight===Je.outerHeight&&ie.lineHeight===Je.lineHeight&&ie.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Je.pixelRatio&&ie.scrollBeyondLastLine===Je.scrollBeyondLastLine&&ie.minimap.enabled===Je.minimap.enabled&&ie.minimap.side===Je.minimap.side&&ie.minimap.size===Je.minimap.size&&ie.minimap.showSlider===Je.minimap.showSlider&&ie.minimap.renderCharacters===Je.minimap.renderCharacters&&ie.minimap.maxColumn===Je.minimap.maxColumn&&ie.minimap.scale===Je.minimap.scale&&ie.verticalScrollbarWidth===Je.verticalScrollbarWidth&&ie.isViewportWrapping===Je.isViewportWrapping,se=ie.lineHeight,he=ie.typicalHalfwidthCharacterWidth,J=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let ce=$e>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ve=ie.minimap.maxColumn,ye=ie.minimap.size,je=ie.minimap.side,He=ie.verticalScrollbarWidth,We=ie.viewLineCount,Ge=ie.remainingWidth,nt=ie.isViewportWrapping,dt=ne?2:3;let it=Math.floor($e*ze);const Ye=it/$e;let mt=!1,wt=!1,Ee=dt*ce,fe=ce/$e,ae=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:ft}=$.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:J,height:ze,lineHeight:se,pixelRatio:$e});if(We/ft>1)mt=!0,wt=!0,ce=1,Ee=1,fe=ce/$e;else{let St=!1,vt=ce+1;if(ye==="fit"){const kt=Math.ceil((We+Xe)*Ee);nt&&K&&Ge<=_e.stableFitRemainingWidth?(St=!0,vt=_e.stableFitMaxMinimapScale):(St=kt>it,nt&&St?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=Ge):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ye==="fill"||St){mt=!0;const kt=ce;Ee=Math.min(se*$e,Math.max(1,Math.floor(1/ot))),ce=Math.min(vt,Math.max(1,Math.floor(Ee/dt))),ce>kt&&(ae=Math.min(2,ce/kt)),fe=ce/$e/ae,it=Math.ceil(Math.max(ht,We+Xe)*Ee),nt&&St&&(_e.stableFitMaxMinimapScale=ce)}}}const Z=Math.floor(ve*fe),Fe=Math.min(Z,Math.max(0,Math.floor((Ge-He-2)*fe/(he+fe)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Fe);const Qe=Te/$e;Te=Math.floor(Te*ae);const Ze=ne?1:2,ct=je==="left"?0:Ne-Fe-He;return{renderMinimap:Ze,minimapLeft:ct,minimapWidth:Fe,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:ce,minimapLineHeight:Ee,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Ye}}static computeLayout(ie,_e){const Ne=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Je=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,se=_e.maxDigitWidth,he=_e.pixelRatio,J=_e.viewLineCount,ne=ie.get(118),ce=ne==="inherit"?ie.get(117):ne,ve=ce==="inherit"?ie.get(113):ce,ye=ie.get(116),je=ie.get(2),He=_e.isDominatedByLongLines,We=ie.get(46),Ge=ie.get(56).renderType!==0,nt=ie.get(57),dt=ie.get(91),it=ie.get(61),Ye=ie.get(89),mt=Ye.verticalScrollbarSize,wt=Ye.verticalHasArrows,Ee=Ye.arrowSize,fe=Ye.horizontalScrollbarSize,ae=ie.get(54),Z=ie.get(35);let Fe;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const _t=parseFloat(ae.substr(0,ae.length-2));Fe=a.clampedInt(_t*K,0,0,1e3)}else Fe=a.clampedInt(ae,0,0,1e3);Z&&(Fe+=16);let Te=0;if(Ge){const _t=Math.max(Je,nt);Te=Math.round(_t*se)}let Qe=0;We&&(Qe=$e);let Ze=0,ct=Ze+Qe,ht=ct+Te,Xe=ht+Fe;const ot=Ne-Qe-Te-Fe;let ft=!1,at=!1,St=-1;je!==2&&(ce==="inherit"&&He?(ft=!0,at=!0):ve==="on"||ve==="bounded"?at=!0:ve==="wordWrapColumn"&&(St=ye));const vt=$._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:he,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:J,remainingWidth:ot,isViewportWrapping:at},_e.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ct+=vt.minimapWidth,ht+=vt.minimapWidth,Xe+=vt.minimapWidth);const kt=ot-vt.minimapWidth,At=Math.max(1,Math.floor((kt-mt-2)/K)),Tt=wt?Ee:0;return at&&(St=Math.max(1,At),ve==="bounded"&&(St=Math.min(St,ye))),{width:Ne,height:ze,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ct,lineNumbersWidth:Te,decorationsLeft:ht,decorationsWidth:Fe,contentLeft:Xe,contentWidth:kt,minimap:vt,viewportColumn:At,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:St,verticalScrollbarWidth:mt,horizontalScrollbarHeight:fe,overviewRuler:{top:Tt,width:mt,height:ze-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=$;class U extends k{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:_.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:f(ie.enabled,this.defaultValue.enabled)}}}class F extends k{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:_.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class M extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(ie,_e,Ne){return ie.fontInfo.lineHeight}}class L extends k{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:ie.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:_.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),size:b(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(_e.side,this.defaultValue.side,["right","left"]),showSlider:b(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class q extends k{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:_.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),cycle:f(_e.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(124)}compute(ie,_e,Ne){return ie.pixelRatio}}class de extends k{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:_.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:_.localize(59,null)},other:{type:"boolean",default:ie.other,description:_.localize(60,null)}}}],default:ie,description:_.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,Ne={other:f(_e.other,this.defaultValue.other),comments:f(_e.comments,this.defaultValue.comments),strings:f(_e.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var be;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(ie){let _e=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,Ne=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ne}}}function Ce(X){const ie=X.get(84);return ie==="editable"?X.get(77):ie!=="on"}e.filterValidationDecorations=Ce;class Le extends k{constructor(){const ie=[],_e={type:"number",description:_.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:ie,description:_.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let Ne of ie)if(typeof Ne=="number")_e.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((Ne,ze)=>Ne.column-ze.column),_e}return this.defaultValue}}function z(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,Ne=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(_e.vertical,this.defaultValue.vertical),horizontal:z(_e.horizontal,this.defaultValue.horizontal),useShadows:f(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:f(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:ie.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:b(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(_e.showIcons,this.defaultValue.showIcons),showStatusBar:f(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(_e.showMethods,this.defaultValue.showMethods),showFunctions:f(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:f(_e.showConstructors,this.defaultValue.showConstructors),showFields:f(_e.showFields,this.defaultValue.showFields),showVariables:f(_e.showVariables,this.defaultValue.showVariables),showClasses:f(_e.showClasses,this.defaultValue.showClasses),showStructs:f(_e.showStructs,this.defaultValue.showStructs),showInterfaces:f(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:f(_e.showModules,this.defaultValue.showModules),showProperties:f(_e.showProperties,this.defaultValue.showProperties),showEvents:f(_e.showEvents,this.defaultValue.showEvents),showOperators:f(_e.showOperators,this.defaultValue.showOperators),showUnits:f(_e.showUnits,this.defaultValue.showUnits),showValues:f(_e.showValues,this.defaultValue.showValues),showConstants:f(_e.showConstants,this.defaultValue.showConstants),showEnums:f(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:f(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(_e.showKeywords,this.defaultValue.showKeywords),showWords:f(_e.showWords,this.defaultValue.showWords),showColors:f(_e.showColors,this.defaultValue.showColors),showFiles:f(_e.showFiles,this.defaultValue.showFiles),showReferences:f(_e.showReferences,this.defaultValue.showReferences),showFolders:f(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:f(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(_e.showSnippets,this.defaultValue.showSnippets),showUsers:f(_e.showUsers,this.defaultValue.showUsers),showIssues:f(_e.showIssues,this.defaultValue.showIssues)}}}class le extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends i{constructor(){super(125,[77])}compute(ie,_e,Ne){return _e.get(77)?!0:ie.tabFocusMode}}var De;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends i{constructor(){super(127,[126])}compute(ie,_e,Ne){const ze=_e.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Re:I.isLinux?Be:Pe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(X){return e.editorOptionsRegistry[X.id]=X,X}var qe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Se(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Se(new m),accessibilityPageSize:Se(new a(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Se(new E(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Se(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:Se(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:Se(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:Se(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:Se(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:Se(new g(10,"automaticLayout",!1)),autoSurround:Se(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:Se(new g(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:Se(new g(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:Se(new E(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:Se(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:Se(new g(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:Se(new g(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:Se(new t),contextmenu:Se(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new g(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:Se(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:Se(new g(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:Se(new d(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:_.localize(145,null)})),cursorSurroundingLines:Se(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:Se(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:Se(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:Se(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new g(28,"domReadOnly",!1)),dragAndDrop:Se(new g(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:Se(new v),extraEditorClassName:Se(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new u(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:_.localize(152,null)})),find:Se(new h),fixedOverflowWidgets:Se(new g(34,"fixedOverflowWidgets",!1)),folding:Se(new g(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:Se(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:Se(new g(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:Se(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:Se(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:Se(new R),fontLigatures2:Se(new w),fontSize:Se(new N),fontWeight:Se(new j),formatOnPaste:Se(new g(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:Se(new g(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:Se(new g(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:Se(new re),hideCursorInOverviewRuler:Se(new g(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:Se(new g(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:Se(new V),inDiffEditor:Se(new g(51,"inDiffEditor",!1)),letterSpacing:Se(new u(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:_.localize(165,null)})),lightbulb:Se(new U),lineDecorationsWidth:Se(new C(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new g(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:Se(new g(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:Se(new S(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:Se(new L),mouseStyle:Se(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new u(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:Se(new g(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:Se(new g(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:Se(new d(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:Se(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:Se(new g(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:Se(new g(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:Se(new a(70,"overviewRulerLanes",3,0,3)),padding:Se(new B),parameterHints:Se(new q),peekWidgetDefaultFocus:Se(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:Se(new g(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:Se(new de),quickSuggestionsDelay:Se(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:Se(new g(77,"readOnly",!1)),renameOnType:Se(new g(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:Se(new g(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:Se(new g(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:Se(new g(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:Se(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Se(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:Se(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:Se(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new g(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:Se(new Le),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:Se(new g(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:Se(new g(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:Se(new g(93,"selectionClipboard",!0,{description:_.localize(201,null),included:I.isLinux})),selectionHighlight:Se(new g(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:Se(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:Se(new g(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:Se(new g(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:Se(new F),snippetSuggestions:Se(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:Se(new le),smoothScrolling:Se(new g(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:Se(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),suggestFontSize:Se(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:Se(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:Se(new g(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:Se(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:Se(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:Se(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:Se(new g(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:Se(new E(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:Se(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:Se(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:Se(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new d(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:Se(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:Se(new p),pixelRatio:Se(new Q),tabFocusMode:Se(new me),layoutInfo:Se(new $),wrappingInfo:Se(new we)}}),define(ge[152],pe([16,17]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[153],pe([16,17]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[154],pe([16,17]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[155],pe([16,17]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ge[156],pe([16,17]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([16,17]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[158],pe([16,17]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[159],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[160],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[161],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[162],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[163],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[164],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[165],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[166],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[167],pe([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[168],pe([16,17]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[169],pe([16,17]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(ge[170],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[171],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[172],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[173],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[174],pe([16,17]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[175],pe([16,17]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[176],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[177],pe([0,1,154]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function A(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=C.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function y(C){if(!C)return null;let f=C.majorBase,g=C.majorMustEqual,a=C.minorBase,u=C.minorMustEqual,E=C.patchBase,b=C.patchMustEqual;return C.hasCaret&&(f===0||(u=!1),b=!1),{majorBase:f,majorMustEqual:g,minorBase:a,minorMustEqual:u,patchBase:E,patchMustEqual:b,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function P(C,f){let g;typeof C=="string"?g=y(A(C)):g=C;let a;if(typeof f=="string"?a=y(A(f)):a=f,!g||!a)return!1;let u=g.majorBase,E=g.minorBase,b=g.patchBase,S=a.majorBase,d=a.minorBase,l=a.patchBase,m=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?u>S?!0:u<S?!1:E>d?!0:E<d?!1:b>=l:(u===1&&S===0&&(!m||!t||!n)&&(S=1,d=0,l=0,m=!0,t=!1,n=!1),u<S?!1:u>S?!m:E<d?!1:E>d?!t:b<l?!1:b>l?!n:!0)}e.isValidVersion=P;function D(C,f,g){return f.isBuiltin||typeof f.main=="undefined"?!0:i(C,f.engines.vscode,g)}e.isValidExtensionVersion=D;function k(C,f){return C==="*"||i(f,C)}e.isEngineValid=k;function i(C,f,g=[]){let a=y(A(f));if(!a)return g.push(_.localize(0,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(_.localize(1,null,f)),!1}else if(!a.majorMustEqual)return g.push(_.localize(2,null,f)),!1;return P(C,a)?!0:(g.push(_.localize(3,null,C,f)),!1)}e.isVersionValid=i}),define(ge[112],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(A,y=[],P=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=_;const I=(T,...A)=>new _(T,A);e.createSyncDescriptor=I}),define(ge[79],pe([0,1,112]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(y,P,D){P instanceof _.SyncDescriptor||(P=new _.SyncDescriptor(P,[],D)),I.push([y,P])}e.registerSingleton=T;function A(){return I}e.getSingletonServiceDescriptors=A}),define(ge[178],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=_;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const P=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),P)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let P=this._nodes.get(y);return P||(P=new _(A),this._nodes.set(y,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,P]of this._nodes)A.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const P=new Set([A]),D=this._findCycle(y,P);if(D)return D}}_findCycle(A,y){for(let[P,D]of A.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const k=this._findCycle(D,y);if(k)return k;y.delete(P)}}}e.Graph=I}),define(ge[4],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(P,D,k,i){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:P,index:k,optional:i}):(D[_.DI_DEPENDENCIES]=[{id:P,index:k,optional:i}],D[_.DI_TARGET]=D)}function T(P){if(_.serviceIds.has(P))return _.serviceIds.get(P);const D=function(k,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,k,C,!1)};return D.toString=()=>P,_.serviceIds.set(P,D),D}e.createDecorator=T;function A(P){return P}e.refineServiceDecorator=A;function y(P){return function(D,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(P,D,i,!0)}}e.optional=y}),define(ge[179],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ge[180],pe([0,1,3,74,6,24,73,77,179]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(k):!!f.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(g,a){let u={selector:g,provider:a,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(u){let E=this._entries.indexOf(u);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const a=[];for(let u of this._entries)u._score>0&&a.push(u.provider);return a}ordered(g){const a=[];return this._orderedForEach(g,u=>a.push(u.provider)),a}orderedGroups(g){const a=[];let u,E;return this._orderedForEach(g,b=>{u&&E===b._score?u.push(b.provider):(E=b._score,u=[b.provider],a.push(u))}),a}_orderedForEach(g,a){if(!!g){this._updateScores(g);for(const u of this._entries)u._score>0&&a(u)}}_updateScores(g){let a={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let u of this._entries)if(u._score=(0,P.score)(u.selector,g.uri,g.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(g)),k(u.selector)&&u._score>0){for(let E of this._entries)E._score=0;u._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(g,a){return g._score<a._score?1:g._score>a._score?-1:g._time<a._time?1:g._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class C{constructor(g,a,u=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=a,this.max=u,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+(0,I.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const a=this._key(g),u=this._cache.get(a);return this._clamp(u==null?void 0:u.value)}update(g,a){const u=this._key(g);let E=this._cache.get(u);return E||(E=new y.MovingAverage,this._cache.set(u,E)),E.update(a),this.get(g)}}e.LanguageFeatureRequestDelays=C}),define(ge[80],pe([0,1,2,44,180,143,43]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class D{constructor(w,R){this.language=w,this.id=R}}e.LanguageIdentifier=D;var k;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var C;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let R=this.getForeground(w),N="mtk"+R,j=this.getFontStyle(w);return j&1&&(N+=" mtki"),j&2&&(N+=" mtkb"),j&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(w,R){const N=this.getForeground(w),j=this.getFontStyle(w);let re=`color: ${R[N]};`;return j&1&&(re+="font-style: italic;"),j&2&&(re+="font-weight: bold;"),j&4&&(re+="text-decoration: underline;"),re}}e.TokenMetadata=g;var a;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(w){const R=h[w];let N=R&&y.iconRegistry.get(R);return N||(console.info("No codicon found for CompletionItemKind "+w),N=y.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(w,R){let N=h[w];return typeof N=="undefined"&&!R&&(N=9),N}}();var u;(function(h){h[h.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(h){return h&&_.URI.isUri(h.uri)&&I.Range.isIRange(h.range)&&(I.Range.isIRange(h.originSelectionRange)||I.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=m;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(h){h[h.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(h){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function N(V){return w.get(V)}h.fromString=N;function j(V){return R.get(V)}h.toString=j;function re(V,W){const $=R.get(V);let U=$&&y.iconRegistry.get("symbol-"+$);return U||(console.info("No codicon found for SymbolKind "+V),U=y.Codicon.symbolProperty),`${W?"inline":"block"} ${U.classNames}`}h.toCssClassName=re})(s=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(w){this.value=w}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var p;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(p=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var v;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[181],pe([0,1,6,11,4,3,56,54]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const u=D.handler;D.handler=function(E,...b){return(0,I.validateConstraints)(b,a),u(E,...b)}}const{id:i}=D;let C=this._commands.get(i);C||(C=new y.LinkedList,this._commands.set(i,C));let f=C.unshift(D),g=(0,_.toDisposable)(()=>{f();const a=this._commands.get(i);(a==null?void 0:a.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),g}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(i,...C)=>i.get(e.ICommandService).executeCommand(k,...C))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return P.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&D.set(k,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[81],pe([0,1,9,4,10]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=T.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",T.isMacintosh),y.set("isLinux",T.isLinux),y.set("isWindows",T.isWindows),y.set("isWeb",T.isWeb),y.set("isMacNative",T.isMacintosh&&!T.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0),y.set("isIPad",A.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(w){return g.create(w)}static equals(w,R){return a.create(w,R)}static notEquals(w,R){return b.create(w,R)}static regex(w,R){return n.create(w,R)}static in(w,R){return u.create(w,R)}static not(w){return S.create(w)}static and(...w){return r.create(w)}static or(...w){return o.create(w)}static greater(w,R){return d.create(w,R)}static less(w,R){return m.create(w,R)}static deserialize(w,R=!1){if(!!w)return this._deserializeOrExpression(w,R)}static _deserializeOrExpression(w,R){let N=w.split("||");return o.create(N.map(j=>this._deserializeAndExpression(j,R)))}static _deserializeAndExpression(w,R){let N=w.split("&&");return r.create(N.map(j=>this._deserializeOne(j,R)))}static _deserializeOne(w,R){if(w=w.trim(),w.indexOf("!=")>=0){let N=w.split("!=");return b.create(N[0].trim(),this._deserializeValue(N[1],R))}if(w.indexOf("==")>=0){let N=w.split("==");return a.create(N[0].trim(),this._deserializeValue(N[1],R))}if(w.indexOf("=~")>=0){let N=w.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],R))}if(w.indexOf(" in ")>=0){let N=w.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const N=w.split(">=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const N=w.split(">");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const N=w.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const N=w.split("<");return m.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(w)?S.create(w.substr(1).trim()):g.create(w)}static _deserializeValue(w,R){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let N=/^'([^']*)'$/.exec(w);return N?N[1].trim():w}static _deserializeRegexValue(w,R){if((0,_.isFalsyOrWhitespace)(w)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=w.indexOf("/"),j=w.lastIndexOf("/");if(N===j||N<0){if(R)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let re=w.slice(N+1,j),V=w[j+1]==="i"?"i":"";try{return new RegExp(re,V)}catch(W){if(R)throw new Error(`bad regexp-value '${w}', parse error: ${W}`);return console.warn(`bad regexp-value '${w}', parse error: ${W}`),null}}}e.ContextKeyExpr=k;function i(h,w){return h.cmp(w)}class C{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class g{constructor(w){this.key=w,this.type=2}static create(w){const R=y.get(w);return typeof R=="boolean"?R?f.INSTANCE:C.INSTANCE:new g(w)}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=g;class a{constructor(w,R){this.key=w,this.value=R,this.type=4}static create(w,R){if(typeof R=="boolean")return R?g.create(w):S.create(w);const N=y.get(w);return typeof N=="boolean"?R===(N?"true":"false")?f.INSTANCE:C.INSTANCE:new a(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class u{constructor(w,R){this.key=w,this.valueKey=R,this.type=10}static create(w,R){return new u(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const R=w.getValue(this.valueKey),N=w.getValue(this.key);return Array.isArray(R)?R.indexOf(N)>=0:typeof N=="string"&&typeof R=="object"&&R!==null?P.call(R,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=u;class E{constructor(w){this._actual=w,this.type=11}static create(w){return new E(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new E(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class b{constructor(w,R){this.key=w,this.value=R,this.type=5}static create(w,R){if(typeof R=="boolean")return R?S.create(w):g.create(w);const N=y.get(w);return typeof N=="boolean"?R===(N?"true":"false")?C.INSTANCE:f.INSTANCE:new b(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class S{constructor(w){this.key=w,this.type=3}static create(w){const R=y.get(w);return typeof R=="boolean"?R?C.INSTANCE:f.INSTANCE:new S(w)}cmp(w){return w.type!==this.type?this.type-w.type:p(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=S;class d{constructor(w,R){this.key=w,this.value=R,this.type=12}static create(w,R){return new d(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class l{constructor(w,R){this.key=w,this.value=R,this.type=13}static create(w,R){return new l(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class m{constructor(w,R){this.key=w,this.value=R,this.type=14}static create(w,R){return new m(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(w,R){this.key=w,this.value=R,this.type=15}static create(w,R){return new t(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:v(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(w,R){this.key=w,this.regexp=R,this.type=7}static create(w,R){return new n(w,R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const R=this.regexp?this.regexp.source:"",N=w.regexp?w.regexp.source:"";return R<N?-1:R>N?1:0}equals(w){if(w.type===this.type){const R=this.regexp?this.regexp.source:"",N=w.regexp?w.regexp.source:"";return this.key===w.key&&R===N}return!1}evaluate(w){let R=w.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(w){this._actual=w,this.type=8}static create(w){return new s(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new s(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(w){this.expr=w,this.type=6}static create(w){return r._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const j=i(this.expr[R],w.expr[R]);if(j!==0)return j}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].evaluate(w))return!1;return!0}static _normalizeArr(w){const R=[];let N=!1;for(const j of w)if(!!j){if(j.type===1){N=!0;continue}if(j.type===0)return C.INSTANCE;if(j.type===6){R.push(...j.expr);continue}R.push(j)}if(R.length===0&&N)return f.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const j=R[R.length-1];if(j.type!==9)break;R.pop();const re=R.pop(),V=o.create(j.expr.map(W=>r.create([W,re])));V&&(R.push(V),R.sort(i))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new r(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let R of this.expr)w.push(R.negate());return o.create(w)}}e.ContextKeyAndExpr=r;class o{constructor(w){this.expr=w,this.type=9}static create(w){const R=o._normalizeArr(w);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const j=i(this.expr[R],w.expr[R]);if(j!==0)return j}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,N=this.expr.length;R<N;R++)if(this.expr[R].evaluate(w))return!0;return!1}static _normalizeArr(w){let R=[],N=!1;if(w){for(let j=0,re=w.length;j<re;j++){const V=w[j];if(!!V){if(V.type===0){N=!0;continue}if(V.type===1)return[f.INSTANCE];if(V.type===9){R=R.concat(V.expr);continue}R.push(V)}}if(R.length===0&&N)return[C.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new o(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let N of this.expr)w.push(N.negate());const R=N=>N.type===9?N.expr:[N];for(;w.length>1;){const N=w.shift(),j=w.shift(),re=[];for(const V of R(N))for(const W of R(j))re.push(k.and(V,W));w.unshift(k.or(...re))}return w[0]}}e.ContextKeyOrExpr=o;class c extends g{constructor(w,R,N){super(w);this._defaultValue=R,typeof N=="object"?c._info.push(Object.assign(Object.assign({},N),{key:w})):N!==!0&&c._info.push({key:w,description:N,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(w){return k.equals(this.key,w)}notEqualsTo(w){return k.notEquals(this.key,w)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(h,w){return h<w?-1:h>w?1:0}function v(h,w,R,N){return h<R?-1:h>R?1:w<N?-1:w>N?1:0}}),define(ge[182],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[183],pe([0,1,153,4,12]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var P;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var k;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(f,g){super(f);this.code=g}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ge[28],pe([0,1,9,4]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,C){if(typeof i=="undefined"||i===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof i=="string"||typeof C=="string"){let f=typeof i=="string"?i:i.value,g=typeof C=="string"?C:C.value;return _.equalsIgnoreCase(f,g)}return i._lower===C._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function P(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[184],pe([0,1,9,28]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(g,a){return g.uuid&&a.uuid?g.uuid===a.uuid:g.id===a.id?!0:(0,_.compareIgnoreCase)(g.id,a.id)===0}e.areSameExtensions=T;class A{constructor(a,u){this.version=u,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?T(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(g,a){return`${g}.${a}`}e.getExtensionId=y;function P(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(g,a){return P(y(g,a))}e.getGalleryExtensionId=D;function k(g,a){const u=[],E=b=>{for(const S of u)if(S.some(d=>T(a(d),a(b))))return S;return null};for(const b of g){const S=E(b);S?S.push(b):u.push([b])}return u}e.groupByExtension=k;function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(g){const a=new Set;for(const u of g)u.malicious&&a.add(u.id.id);return a}e.getMaliciousExtensionsSet=f}),define(ge[45],pe([0,1,155,8,2,4,9,11,24]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=f;function g(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=g;function a(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function u(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=u;var E;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(W,$){super(W);this.code=$}}e.FileSystemProviderError=b;function S(V,W){const $=new b(V.toString(),W);return l($,W),$}e.createFileSystemProviderError=S;function d(V){return V||S((0,_.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=d;function l(V,W){return V.name=W?`${W} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function m(V){if(!V)return E.Unknown;if(V instanceof b)return V.code;const W=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!W)return E.Unknown;switch(W[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=m;function t(V){if(V instanceof p)return V.fileOperationResult;switch(m(V)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(W,$,U){this.resource=W,this.operation=$,this.target=U}isOperation(W){return this.operation===W}}e.FileOperationEvent=s;var r;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class o{constructor(W,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const U of W)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(W,...$){return this.doContains(W,{includeChildren:!1},...$)}affects(W,...$){return this.doContains(W,{includeChildren:!0},...$)}doContains(W,$,...U){var F,M,L,O,B,q;if(!W)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(W))||$.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(W)))||(!Q||U.includes(0))&&(((L=this.updated)===null||L===void 0?void 0:L.get(W))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(W)))||(!Q||U.includes(2))&&(((B=this.deleted)===null||B===void 0?void 0:B.findSubstr(W))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const $=[],U=W===1?this.added:W===0?this.updated:this.deleted;if(U)for(const[,F]of U)$.push(F);return $}filter(W){return new o(this.changes.filter($=>W($)),this.ignorePathCasing)}}e.FileChangesEvent=o;function c(V,W,$){return!V||!W||V===W||W.length>V.length?!1:(W.charAt(W.length-1)!==I.sep&&(W+=I.sep),$?(0,y.startsWithIgnoreCase)(V,W):V.indexOf(W)===0)}e.isParent=c;class p extends Error{constructor(W,$,U){super(W);this.fileOperationResult=$,this.options=U}static isFileOperationError(W){return W instanceof Error&&!(0,P.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=p;var v;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=w;async function R(V,W){if(!W.canHandleResource(T.URI.from({scheme:V.scheme})))return new Promise($=>{const U=W.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(U.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(W){return(0,P.isNumber)(W)||(W=0),W<N.KB?(0,_.localize)(1,null,W.toFixed(0)):W<N.MB?(0,_.localize)(2,null,(W/N.KB).toFixed(2)):W<N.GB?(0,_.localize)(3,null,(W/N.MB).toFixed(2)):W<N.TB?(0,_.localize)(4,null,(W/N.GB).toFixed(2)):(0,_.localize)(5,null,(W/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var j;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function re(V){return{maxFileSize:V===0?300*N.MB:16*N.GB,maxHeapSize:V===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=re}),define(ge[82],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...T){this._entries=new Map;for(let[A,y]of T)this.set(A,y)}set(T,A){const y=this._entries.get(T);return this._entries.set(T,A),y}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=_}),define(ge[185],pe([0,1,18,178,112,4,82,13]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(a){var u;super("cyclic dependency between services");this.message=(u=a.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new y.ServiceCollection,u=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=u,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...u){let E=f.traceInvocation(a),b=!1;try{return a({get:(d,l)=>{if(b)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(d,E);if(!m&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return m}},...u)}finally{b=!0,E.stop()}}createInstance(a,...u){let E,b;return a instanceof T.SyncDescriptor?(E=f.traceCreation(a.ctor),b=this._createInstance(a.ctor,a.staticArguments.concat(u),E)):(E=f.traceCreation(a),b=this._createInstance(a,u,E)),E.stop(),b}_createInstance(a,u=[],E){let b=A._util.getServiceDependencies(a).sort((l,m)=>l.index-m.index),S=[];for(const l of b){let m=this._getOrCreateServiceInstance(l.id,E);if(!m&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);S.push(m)}let d=b.length>0?b[0].index:u.length;if(u.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${u.length} static arguments`);let l=d-u.length;l>0?u=u.concat(new Array(l)):u=u.slice(0,d)}return new a(...[...u,...S])}_setServiceInstance(a,u){if(this._services.get(a)instanceof T.SyncDescriptor)this._services.set(a,u);else if(this._parent)this._parent._setServiceInstance(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let u=this._services.get(a);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):u}_getOrCreateServiceInstance(a,u){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,u.branch(a,!0)):(u.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,u,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,u,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,u,E){const b=new I.Graph(l=>l.id.toString());let S=0;const d=[{id:a,desc:u,_trace:E}];for(;d.length;){const l=d.pop();if(b.lookupOrInsertNode(l),S++>1e3)throw new k(b);for(let m of A._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${a} depends on ${m.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:m.id,desc:t,_trace:l._trace.branch(m.id,!0)};b.insertEdge(l,n),d.push(n)}}}for(;;){const l=b.roots();if(l.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:m}of l){if(this._getServiceInstanceOrDescriptor(m.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,n)}b.removeNode(m)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,u,E=[],b,S){if(this._services.get(a)instanceof T.SyncDescriptor)return this._createServiceInstance(u,E,b,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,u,E,b,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(a,u=[],E,b){if(E){const S=new P.IdleValue(()=>this._createInstance(a,u,b));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let m=S.value,t=m[l];return typeof t!="function"||(t=t.bind(m),d[l]=t),t},set(d,l,m){return S.value[l]=m,!0}})}else return this._createInstance(a,u,b)}}e.InstantiationService=i;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class f{constructor(a,u){this.type=a,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new f(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(a){return D?new f(0,a.name):f._None}branch(a,u){let E=new f(2,a.toString());return this._dep.push([a,u,E]),E}stop(){let a=Date.now()-this._start;f._totals+=a;let u=!1;function E(S,d){let l=[],m=new Array(S+1).join("	");for(const[t,n,s]of d._dep)if(n&&s){u=!0,l.push(`${m}CREATES -> ${t}`);let r=E(S+1,s);r&&l.push(r)}else l.push(`${m}uses -> ${t}`);return l.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(a>2||u)&&console.log(b.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ge[14],pe([0,1,4,6,10,3,59]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class C extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class g extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class a extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class u extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=u;class E extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class b{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=b;function S(m){if(m.verbose)return D.Trace;if(typeof m.logLevel=="string"){const t=d(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function d(m){switch(m){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function l(m){switch(m){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(ge[113],pe([0,1,14,45]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(D,k,i,C){try{const f=await new Promise((g,a)=>{G(["spdlog"],g,a)});return f.setAsyncMode(8192,500),f.createRotatingLoggerAsync(D,k,i,C)}catch(f){console.error(f)}return null}function A(D,k,i,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,k,i,C)}e.createRotatingLogger=A;function y(D,k,i){switch(k){case _.LogLevel.Trace:D.trace(i);break;case _.LogLevel.Debug:D.debug(i);break;case _.LogLevel.Info:D.info(i);break;case _.LogLevel.Warning:D.warn(i);break;case _.LogLevel.Error:D.error(i);break;case _.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class P extends _.AbstractMessageLogger{constructor(k,i,C,f){super();this.name=k,this.filepath=i,this.rotating=C,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const k=this.rotating?6:1,i=30/k*I.ByteSize.MB;return T(this.name,this.filepath,i,k).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:f,message:g}of this.buffer)y(this._logger,f,g);this.buffer=[]}})}log(k,i){this._logger?y(this._logger,k,i):this.getLevel()<=k&&this.buffer.push({level:k,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[114],pe([0,1,4,156,57]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(a,u){return u-a}D.compare=k;const i=Object.create(null);i[D.Error]=(0,I.localize)(0,null),i[D.Warning]=(0,I.localize)(1,null),i[D.Info]=(0,I.localize)(2,null);function C(a){return i[a]||""}D.toString=C;function f(a){switch(a){case T.default.Error:return D.Error;case T.default.Warning:return D.Warning;case T.default.Info:return D.Info;case T.default.Ignore:return D.Hint}}D.fromSeverity=f;function g(a){switch(a){case D.Error:return T.default.Error;case D.Warning:return T.default.Warning;case D.Info:return T.default.Info;case D.Hint:return T.default.Ignore}}D.toSeverity=g}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const k="";function i(f){return C(f,!0)}D.makeKey=i;function C(f,g){let a=[k];return f.source?a.push(f.source.replace("\xA6","\\\xA6")):a.push(k),f.code?typeof f.code=="string"?a.push(f.code.replace("\xA6","\\\xA6")):a.push(f.code.value.replace("\xA6","\\\xA6")):a.push(k),f.severity!==void 0&&f.severity!==null?a.push(y.toString(f.severity)):a.push(k),f.message&&g?a.push(f.message.replace("\xA6","\\\xA6")):a.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?a.push(f.startLineNumber.toString()):a.push(k),f.startColumn!==void 0&&f.startColumn!==null?a.push(f.startColumn.toString()):a.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?a.push(f.endLineNumber.toString()):a.push(k),f.endColumn!==void 0&&f.endColumn!==null?a.push(f.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}D.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ge[186],pe([0,1,57,4,3]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(ge[187],pe([0,1,12,10,36,25]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const P=I.globals.vscode.context.configuration();if(P)y=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const P=(0,A.dirname)(_.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const D=G.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var Ve=this&&this.__decorate||function(G,e,_,I){var T=arguments.length,A=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,_):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,_,I);else for(var P=G.length-1;P>=0;P--)(y=G[P])&&(A=(T<3?y(A):T>3?y(e,_,A):y(e,_))||A);return T>3&&A&&Object.defineProperty(e,_,A),A},xe=this&&this.__param||function(G,e){return function(_,I){e(_,I,G)}};define(ge[115],pe([0,1,4,21,6,13]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends T.Disposable{constructor(C,f){super();this.deferred=new A.DeferredPromise,f.withProgress(C,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=Ve([xe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const f=++this.currentOperationId,g=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:g.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,11,52]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(y,P){I.ok(_.isString(y)),I.ok(_.isObject(P)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new T}),define(ge[116],pe([0,1,40,3]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[T(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;_.Registry.add(e.Extensions.JSONContribution,y)}),define(ge[83],pe([0,1,152,3,40,11,116]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=T.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,S=!0){this.registerConfigurations([b],S)}registerConfigurations(b,S=!0){const d=[];b.forEach(l=>{d.push(...this.validateAndRegisterProperties(l,S,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(b){const S=[],d=l=>{if(l.properties)for(const m in l.properties)S.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,l.properties[m]);l.allOf&&l.allOf.forEach(m=>d(m))};for(const l of b){d(l);const m=this.configurationContributors.indexOf(l);m!==-1&&this.configurationContributors.splice(m,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(b){const S=[],d=[];for(const l of b)for(const m in l)if(S.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]=Object.assign(Object.assign({},this.defaultValues[m]||{}),l[m]);const t={type:"object",default:this.defaultValues[m],description:_.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};d.push(C(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=l[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(b){const S=[];for(const d of b)for(const l in d)if(S.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const m=this.configurationProperties[l];m&&(this.updatePropertyDefaultValue(l,m),this.updateSchema(l,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const S of b)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,S=!0,d,l=3){var m;l=A.isUndefinedOrNull(b.scope)?l:b.scope;let t=[],n=b.properties;if(n)for(let r in n){if(S&&a(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=A.isUndefinedOrNull(o.scope)?l:o.scope,o.requireTrust=A.isUndefinedOrNull(o.requireTrust)?!!((m=d==null?void 0:d.requireTrustForConfigurations)===null||m===void 0?void 0:m.includes(r)):o.requireTrust),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=b.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,S,d,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const S=d=>{let l=d.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let m=d.allOf;m&&m.forEach(S)};S(b)}updateSchema(b,S){switch(e.allSettings.properties[b]=S,S.scope){case 1:e.applicationSettings.properties[b]=S;break;case 2:e.machineSettings.properties[b]=S;break;case 6:e.machineOverridableSettings.properties[b]=S;break;case 3:e.windowSettings.properties[b]=S;break;case 4:e.resourceSettings.properties[b]=S;break;case 5:e.resourceSettings.properties[b]=S,this.resourceLanguageSettingsSchema.properties[b]=S;break}}removeFromSchema(b,S){switch(delete e.allSettings.properties[b],S.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const S=`[${b}]`,d={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,d),e.allSettings.properties[S]=d,e.applicationSettings.properties[S]=d,e.machineSettings.properties[S]=d,e.machineOverridableSettings.properties[S]=d,e.windowSettings.properties[S]=d,e.resourceSettings.properties[S]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,S){let d=this.defaultValues[b];A.isUndefined(d)&&(d=S.default),A.isUndefined(d)&&(d=f(S.type)),S.default=d}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const g=new k;T.Registry.add(e.Extensions.Configuration,g);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?_.localize(5,null,E):g.getConfigurationProperties()[E]!==void 0?_.localize(6,null,E):null:_.localize(4,null)}e.validateProperty=a;function u(){const E=[],b=g.getConfigurationProperties();for(const S of Object.keys(b))E.push([S,b[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=u}),define(ge[84],pe([0,1,23,11,2,40,4,83]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(n,s){const r=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],o=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],c=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const N=b(n.contents,R),j=b(s.contents,R);_.equals(N,j)||c.push(R)}}const p=[],v=R=>{const N={};for(const j of R)for(const re of j.identifiers)N[m(re)]=j;return N},h=s?v(s.overrides):{},w=n?v(n.overrides):{};if(Object.keys(h).length)for(const R of r){const N=h[R];N&&p.push([(0,P.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(w).length)for(const R of o){const N=w[R];N&&p.push([(0,P.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(h).length&&Object.keys(w).length)for(const R of c){const N=w[R],j=h[R];if(N&&j){const re=C({contents:N.contents,keys:N.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});p.push([(0,P.overrideIdentifierFromKey)(R),[...re.added,...re.removed,...re.updated]])}}return{added:r,removed:o,updated:c,overrides:p}}e.compare=C;function f(n,s){const r=[];for(const o of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const c={};for(const p in n[o])c[p]=n[o][p];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(c),contents:g(c,s)})}return r}e.toOverrides=f;function g(n,s){const r=Object.create(null);for(let o in n)a(r,o,n[o],s);return r}e.toValuesTree=g;function a(n,s,r,o){const c=s.split("."),p=c.pop();let v=n;for(let h=0;h<c.length;h++){let w=c[h],R=v[w];switch(typeof R){case"undefined":R=v[w]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}v=R}if(typeof v=="object"&&v!==null)try{v[p]=r}catch(h){o(`Ignoring ${s} as ${c.join(".")} is ${JSON.stringify(v)}`)}else o(`Ignoring ${s} as ${c.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=a;function u(n,s){const r=s.split(".");E(n,r)}e.removeFromValueTree=u;function E(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(E(o,s),Object.keys(o).length===0&&delete n[r])}}function b(n,s,r){function o(v,h){let w=v;for(const R of h){if(typeof w!="object"||w===null)return;w=w[R]}return w}const c=s.split("."),p=o(n,c);return typeof p=="undefined"?r:p}e.getConfigurationValue=b;function S(n,s,r){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in n?I.isObject(n[o])&&I.isObject(s[o])?S(n[o],s[o],r):r&&(n[o]=s[o]):n[o]=s[o])})}e.merge=S;function d(){const n=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=d;function l(){const n=Object.create(null),s=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in s){let o=s[r].default;a(n,r,o,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=l;function m(n){return`[${n}]`}e.keyFromOverrideIdentifier=m;function t(n,s,r){const o=n.inspect(s),c=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[188],pe([0,1,55,24,19,11,23,2,83,84,40,6,3]),function(G,e,_,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],c=n[r];c&&(typeof o=="object"&&typeof c=="object"?(o=y.deepClone(o),this.mergeContents(o,c)):o=c),s[r]=o}return new g(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const c of o.overrides){const[p]=s.filter(v=>T.equals(v.identifiers,c.identifiers));p?this.mergeContents(p.contents,c.contents):s.push(y.deepClone(c))}for(const c of o.keys)r.indexOf(c)===-1&&r.push(c)}return new g(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&A.isObject(t[s])&&A.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class a extends g{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,k.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:o,untrusted:c}=this.doParseRaw(t,n);this._configurationModel=new g(s,r,o),this._untrustedConfigurations=c||[]}doParseContent(t){let n={},s=null,r=[],o=[],c=[];function p(h){Array.isArray(r)?r.push(h):s&&(r[s]=h)}let v={onObjectBegin:()=>{let h={};p(h),o.push(r),r=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let h=[];p(h),o.push(r),r=h,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:p,onError:(h,w,R)=>{c.push({error:h,offset:w,length:R})}};if(t)try{_.visit(t,v),n=r[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return n}doParseRaw(t,n){const s=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const o=(0,k.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),c=Object.keys(t),p=(0,k.toOverrides)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:o,keys:c,overrides:p,untrusted:r.untrusted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const o={},c=[];for(let p in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const v=this.filter(t[p],n,!1,r);o[p]=v.raw,c.push(...v.untrusted)}else{const v=n[p],h=v?typeof v.scope!="undefined"?v.scope:3:void 0;(h===void 0||r.scopes===void 0||r.scopes.includes(h))&&(r.isUntrusted&&(v==null?void 0:v.requireTrust)?c.push(p):o[p]=t[p])}return{raw:o,untrusted:c}}}e.ConfigurationModelParser=u;class E extends C.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=E;class b{constructor(t,n,s=new g,r=new g,o=new I.ResourceMap,c=new g,p=new I.ResourceMap,v=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=c,this._memoryConfigurationByResource=p,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new g,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),o=this.getFolderConfigurationModelForResource(n.resource,s),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,j=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),re=r.getValue(t),V=T.distinct(T.flatten(r.overrides.map(W=>W.identifiers))).filter(W=>r.getOverrideValue(t,W)!==void 0);return{defaultValue:p,userValue:v,userLocalValue:h,userRemoteValue:w,workspaceValue:R,workspaceFolderValue:N,memoryValue:j,value:re,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,D.overrideIdentifierFromKey)(r),c=this._defaultConfiguration.getKeysForOverrideIdentifier(o),p=t.getKeysForOverrideIdentifier(o),v=[...p.filter(h=>c.indexOf(h)===-1),...c.filter(h=>p.indexOf(h)===-1),...c.filter(h=>!y.equals(this._defaultConfiguration.override(o).getValue(h),t.override(o).getValue(h)))];return[o,v]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,k.compare)(this.localUserConfiguration,t),c=[...n,...s,...r];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,k.compare)(this.remoteUserConfiguration,t);let c=[...n,...s,...r];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,k.compare)(this.workspaceConfiguration,t);let c=[...n,...s,...r];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:o,removed:c,overrides:p}=(0,k.compare)(s,n);let v=[...r,...o,...c];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:p}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:o,overrides:c}=(0,k.compare)(n,void 0);return{keys:[...s,...r,...o],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((c,p)=>(c.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),c),new I.ResourceMap);return new b(n,s,new g,r,o,new g,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function S(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,n=new Map;for(const r of m)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,c])=>{const p=(0,I.getOrSet)(n,o,new Set);c.forEach(v=>p.add(v))});const s=[];return n.forEach((r,o)=>s.push([o,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=S;class d{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(p=>o.add(p)),t.overrides.forEach(([,p])=>p.forEach(v=>o.add(v))),this.affectedKeys=[...o.values()];const c=new g;this.affectedKeys.forEach(p=>c.setValue(p,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=d;class l extends d{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=l}),define(ge[85],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(P,D=T.Unknown,k){super(P);this._message=P,this._code=D,this._detail=k,this.isHandled=D===T.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===T.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===T.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}}e.RemoteAuthorityResolverError=A}),define(ge[117],pe([0,1,12]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===_.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function T(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=T;function A(D){return D.scheme!==_.Schemas.file&&D.scheme!==_.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>A(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function P(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=P}),define(ge[189],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((T,A)=>G(["vsda"],T,A))}async sign(T){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(T)}catch(A){}return T}}e.SignService=_}),define(ge[190],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,A,y=5){let P;return P=A(D=>{const k=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(T);if(i){i.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(T),y);i={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),P.dispose()}},this._terminalBufferMap.set(T,i)}),P}stopBuffering(T){const A=this._terminalBufferMap.get(T);A&&A.dispose()}flushBuffer(T){const A=this._terminalBufferMap.get(T);A&&(this._terminalBufferMap.delete(T),this._callback(T,A.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[191],pe([0,1,48,8,36,26,11,23,10]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=k;async function i(C,f,g,a=T.env,u=A.exists){if(I.isAbsolute(C))return await u(C)?C:void 0;if(f===void 0&&(f=T.cwd()),I.dirname(C)!=="."){const d=I.join(f,C);return await u(d)?d:void 0}const b=(0,P.getCaseInsensitive)(a,"PATH");if(g===void 0&&(0,y.isString)(b)&&(g=b.split(I.delimiter)),g===void 0||g.length===0){const d=I.join(f,C);return await u(d)?d:void 0}for(let d of g){let l;if(I.isAbsolute(d)?l=I.join(d,C):l=I.join(f,d,C),await u(l))return l;if(D.isWindows){let m=l+".com";if(await u(m)||(m=l+".exe",await u(m)))return m}}const S=I.join(f,C);return await u(S)?S:void 0}e.findExecutable=i}),define(ge[192],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[193],pe([0,1,4,6,40,3,192,43]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var D;(function(E){function b(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=b})(D=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var i;(function(E){function b(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=b;const S=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const n=S.exec(t);if(!!n){let[,s]=n;return{id:s}}}E.fromString=d;function l(t,n){let s=t.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),n&&(s=`${s}~${n}`),{id:s}}E.modify=l;function m(t,n){var s,r;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((r=n.color)===null||r===void 0?void 0:r.id)}E.isEqual=m,E.asClassNameArray=P.CSSIcon.asClassNameArray,E.asClassName=P.CSSIcon.asClassName,E.asCSSSelector=P.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(b);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new f;T.Registry.add(e.Extensions.ThemingContribution,g);function a(E){return g.onColorThemeChange(E)}e.registerThemingParticipant=a;class u extends I.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,S){let d=this.theme.getColor(b);return d&&S&&(d=S(d,this.theme)),d?d.toString():null}}e.Themable=u}),define(ge[194],pe([0,1,40,193,3,157,116,13,43]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,S,d,l){const m=this.iconsById[b];if(m){if(d&&!m.description){m.description=d,this.iconSchema.properties[b].markdownDescription=`${d} $(${b})`;const s=this.iconReferenceSchema.enum.indexOf(b);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=d),this._onDidChange.fire()}return m}let t={id:b,description:d,defaults:S,deprecationMessage:l};this.iconsById[b]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),d&&(n.markdownDescription=`${d}: $(${b})`),this.iconSchema.properties[b]=n,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const S=this.iconReferenceSchema.enum.indexOf(b);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,S){const d=this.iconFontsById[b];if(d)return d;let l={id:b,definition:S};return this.iconFontsById[b]=l,this._onDidChange.fire(),l}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(m,t)=>m.id.localeCompare(t.id),S=m=>{for(;I.ThemeIcon.isThemeIcon(m.defaults);)m=this.iconsById[m.defaults.id];return`codicon codicon-${m?m.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(m=>this.iconsById[m]);for(const m of l.filter(t=>!!t.description).sort(b))d.push(`|<i class="${S(m)}"></i>|${m.id}|${I.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const m of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(b))d.push(`|<i class="${S(m)}"></i>|${m.id}|`);return d.join(`
`)}}const i=new k;_.Registry.add(e.Extensions.IconContribution,i);function C(E,b,S,d){return i.registerIcon(E,b,S,d)}e.registerIcon=C;function f(){return i}e.getIconRegistry=f;function g(){for(const E of D.iconRegistry.all)i.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>i.registerIcon(E.id,E.definition,E.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let a=_.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,i.getIconSchema());const u=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(ge[60],pe([0,1,2,25,4,24]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var y;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function P(f){const g=f;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=P;function D(f){const g=f;return!!(g&&typeof g=="object"&&_.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(g,a,u,E){this._id=g,this._configuration=u,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(g,a){this.raw=a,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,I.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function C(f){return new i({uri:f,index:0,name:(0,I.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C}),define(ge[118],pe([0,1,4,158,60,2,10,8,25,133,55,12,76,29,117]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,P.extname)($):(0,D.extname)($))===u}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function b($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function S($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=S;function d($){return $.hasOwnProperty("fileUri")}e.isRecentFile=d;function l($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function m($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=m;function t($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n($){const U=$;if(U==null?void 0:U.uri)return{id:U.id,uri:A.URI.revive(U.uri)};const F=$;if(F==null?void 0:F.configPath)return{id:F.id,configPath:A.URI.revive(F.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function s($,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,U.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r($){return o($)||c($)}e.isStoredWorkspaceFolder=r;function o($){const U=$;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=o;function c($){const U=$;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=c;function p($,U,F,M,L=!y.isWindows,O){if($.scheme!==M.scheme)return{name:F,uri:$.toString(!0)};let B=U?void 0:O.relativePath(M,$);if(B!==void 0)B.length===0?B=".":y.isWindows&&$.scheme===C.Schemas.file&&!L&&(B=B.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)B=$.fsPath,y.isWindows&&(B=(0,f.normalizeDriveLetter)(B),L&&(B=(0,g.toSlashes)(B)));else{if(!O.isEqualAuthority($.authority,M.authority))return{name:F,uri:$.toString(!0)};B=$.path}return{name:F,path:B}}e.getStoredWorkspaceFolder=p;function v($,U,F){let M=[],L=new Set;const O=F.dirname(U);for(let B of $){let q=null;if(o(B))B.path&&(q=F.resolvePath(O,B.path));else if(c(B))try{q=A.URI.parse(B.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=F.getComparisonKey(q);if(!L.has(Q)){L.add(Q);const de=B.name||F.basenameOrAuthority(q);M.push(new T.WorkspaceFolder({uri:q,name:de,index:M.length},B))}}}return M}e.toWorkspaceFolders=v;function h($,U,F,M,L){let O=w(U,$);const B=L.dirname(U),q=L.dirname(M),Q=[],de=R(O.folders);for(const Le of O.folders){const z=o(Le)?L.resolvePath(B,Le.path):A.URI.parse(Le.uri);let Y;F?Y=!1:Y=!o(Le)||(0,P.isAbsolute)(Le.path),Q.push(p(z,Y,Le.name,q,de,L))}const be={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Ae=k.setProperty($,["folders"],Q,be);let Ce=k.applyEdits($,Ae);return O.remoteAuthority===(0,a.getRemoteAuthority)(M)&&(Ce=k.applyEdits(Ce,k.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=h;function w($,U){let F=i.parse(U);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(M=>r(M));else throw new Error(`${$} looks like an invalid workspace file.`);return F}function R($){return y.isWindows?$.some(U=>o(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function N($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function j($){return typeof $.folderUri=="string"}function re($){return typeof $.fileUri=="string"}function V($,U){const F={workspaces:[],files:[]};if($){const M=function(O,B){for(let q=0;q<O.length;q++)try{B(O[q],q)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Q.toString()}. Skip entry.`)}},L=$;if(Array.isArray(L.entries))M(L.entries,O=>{const B=O.label,q=O.remoteAuthority;N(O)?F.workspaces.push({label:B,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:A.URI.parse(O.workspace.configPath)}}):j(O)?F.workspaces.push({label:B,remoteAuthority:q,folderUri:A.URI.parse(O.folderUri)}):re(O)&&F.files.push({label:B,remoteAuthority:q,fileUri:A.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&M(O.workspaces3,(B,q)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?F.workspaces.push({label:Q,workspace:{id:B.id,configPath:A.URI.parse(B.configURIPath)}}):typeof B=="string"&&F.workspaces.push({label:Q,folderUri:A.URI.parse(B)})}),Array.isArray(O.files2)&&M(O.files2,(B,q)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof B=="string"&&F.files.push({label:Q,fileUri:A.URI.parse(B)})})}}return F}e.restoreRecentlyOpened=V;function W($){const U={entries:[]};for(const F of $.workspaces)S(F)?U.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):U.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of $.files)U.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return U}e.toStoreData=W}),define(ge[86],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const A=this._idPool++;return this._data.set(A,T),this.logDebugInfo(),A}get(T,A){return this._data.has(T)?this._data.get(T)[A]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[195],pe([0,1,2,3]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(P=>({name:P.name,group:P.group,resource:_.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[61],pe([0,1,12,4]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,P){P===null?this._providerInfo.delete(y):this._providerInfo.set(y,P)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ge[196],pe([0,1,13]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,P,D){this._deferredPromises=new Map,this._id=y,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new _.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const C of k.values())C.error(i)}})()},0)}get whenReady(){return this._init}get(y,P){let D=this._value[y];return typeof D=="undefined"&&(D=P),D}update(y,P){this._value[y]=P;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new _.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class T extends I{constructor(y,P){super(y.identifier.value,!0,P);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=T}),define(ge[15],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[197],pe([0,1,28,3]),function(G,e,_,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,D){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(P.identifier),tt(this,T,D,"f"),Ue(this,T,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return Ue(this,T,"f").get(this._id,P)}store(P,D){return Ue(this,T,"f").store(this._id,P,D)}delete(P){return Ue(this,T,"f").delete(this._id,P)}}e.ExtensionSecrets=A,T=new WeakMap}),define(ge[119],pe([0,1,4,3]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ge[87],pe([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const T=new WeakMap,A=y=>{let P=T.get(y);return P||(P={children:new Map,bus:new _.Emitter},T.set(y,P)),P};e.getPrivateApiFor=A}),define(ge[50],pe([0,1,4,3,15]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(P){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}P.fromApiTunnel=D;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}P.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,i,C,f){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([xe(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)},qt=this&&this.__rest||function(G,e){var _={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(_[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(_[I[T]]=G[I[T]]);return _};define(ge[7],pe([0,1,19,18,98,24,9,11,2,30,45,85,87]),function(G,e,_,I,T,A,y,P,D,k,i,C,f){"use strict";var g,a,u,E,b,S,d,l,m,t,n,s,r,o,c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function v(H){function x(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(x,H),Object.setPrototypeOf(x.prototype,H.prototype),x}let h=u=class{constructor(x){g.set(this,void 0),tt(this,g,x,"f")}static from(...x){let oe=x;return new u(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,h=u=Ve([v],h),e.Disposable=h;let w=E=class{constructor(x,oe){if(x<0)throw(0,I.illegalArgument)("line must be non-negative");if(oe<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=x,this._character=oe}static Min(...x){if(x.length===0)throw new TypeError;let oe=x[0];for(let ke=1;ke<x.length;ke++){const Ke=x[ke];Ke.isBefore(oe)&&(oe=Ke)}return oe}static Max(...x){if(x.length===0)throw new TypeError;let oe=x[0];for(let ke=1;ke<x.length;ke++){const Ke=x[ke];Ke.isAfter(oe)&&(oe=Ke)}return oe}static isPosition(x){if(!x)return!1;if(x instanceof E)return!0;let{line:oe,character:ke}=x;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,oe=0){if(x===null||oe===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=0:typeof x=="number"?ke=x:(ke=typeof x.lineDelta=="number"?x.lineDelta:0,oe=typeof x.characterDelta=="number"?x.characterDelta:0),ke===0&&oe===0?this:new E(this.line+ke,this.character+oe)}with(x,oe=this.character){if(x===null||oe===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=this.line:typeof x=="number"?ke=x:(ke=typeof x.line=="number"?x.line:this.line,oe=typeof x.character=="number"?x.character:this.character),ke===this.line&&oe===this.character?this:new E(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};w=E=Ve([v],w),e.Position=w;let R=b=class{constructor(x,oe,ke,Ke){let et,st;if(typeof x=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new w(x,oe),st=new w(ke,Ke)):x instanceof w&&oe instanceof w&&(et=x,st=oe),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(x){return x instanceof b?!0:x?w.isPosition(x.start)&&w.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof b?this.contains(x._start)&&this.contains(x._end):x instanceof w?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const oe=w.Max(x.start,this._start),ke=w.Min(x.end,this._end);if(!oe.isAfter(ke))return new b(oe,ke)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const oe=w.Min(x.start,this._start),ke=w.Max(x.end,this.end);return new b(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,oe=this.end){if(x===null||oe===null)throw(0,I.illegalArgument)();let ke;return x?w.isPosition(x)?ke=x:(ke=x.start||this.start,oe=x.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new b(ke,oe)}toJSON(){return[this.start,this.end]}};R=b=Ve([v],R),e.Range=R;let N=S=class extends R{constructor(x,oe,ke,Ke){let et,st;if(typeof x=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new w(x,oe),st=new w(ke,Ke)):x instanceof w&&oe instanceof w&&(et=x,st=oe),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(x){return x instanceof S?!0:x?R.isRange(x)&&w.isPosition(x.anchor)&&w.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=S=Ve([v],N),e.Selection=N;class j{constructor(x,oe,ke){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,I.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,I.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=j;class re extends Error{constructor(x,oe=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super(x);this._message=x,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(x,oe){return new re(x,C.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(x){return new re(x,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var V;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var W;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=d=class{constructor(x,oe){this._range=x,this._newText=oe}static isTextEdit(x){return x instanceof d?!0:x?R.isRange(x)&&typeof x.newText=="string":!1}static replace(x,oe){return new d(x,oe)}static insert(x,oe){return d.replace(new R(x,x),oe)}static delete(x){return d.replace(x,"")}static setEndOfLine(x){const oe=new d(new R(new w(0,0),new w(0,0)),"");return oe.newEol=x,oe}get range(){return this._range}set range(x){if(x&&!R.isRange(x))throw(0,I.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,I.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,I.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=d=Ve([v],$),e.TextEdit=$;var U;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,oe,ke,Ke){this._edits.push({_type:1,from:x,to:oe,options:ke,metadata:Ke})}createFile(x,oe,ke){this._edits.push({_type:1,from:void 0,to:x,options:oe,metadata:ke})}deleteFile(x,oe,ke){this._edits.push({_type:1,from:x,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(x,oe,ke){this._edits.push({_type:3,metadata:ke,uri:x,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(x,oe,ke,Ke,et){let st,ut,yt=[],Ct;if(Wt.isNotebookRange(oe)&&Ft.isNotebookCellDataArray(ke)&&!Ft.isNotebookCellDataArray(Ke)?(st=oe.start,ut=oe.end,yt=ke,Ct=Ke):typeof oe=="number"&&typeof ke=="number"&&Ft.isNotebookCellDataArray(Ke)&&(st=oe,ut=ke,yt=Ke,Ct=et),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||yt.length>0)&&this._edits.push({_type:5,uri:x,index:st,count:ut-st,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(x,oe,ke,Ke){this._edits.push({_type:3,metadata:Ke,uri:x,edit:{editType:8,index:oe,metadata:ke}})}replace(x,oe,ke,Ke){this._edits.push({_type:2,uri:x,edit:new $(oe,ke),metadata:Ke})}insert(x,oe,ke,Ke){this.replace(x,new R(oe,oe),ke,Ke)}delete(x,oe,ke){this.replace(x,oe,"",ke)}has(x){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===x.toString())}set(x,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:x,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ke=this._edits[ke];Ke._type===2&&Ke.uri.toString()===x.toString()&&(this._edits[ke]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(x){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===x.toString()&&oe.push(ke.edit);return oe}entries(){const x=new A.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=x.get(oe.uri);ke||(ke=[oe.uri,[]],x.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([v],F),e.WorkspaceEdit=F;let M=l=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof l?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=l._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,oe=this._tabstop++){if(typeof x=="function"){const ke=new l;ke._tabstop=this._tabstop,x(ke),this._tabstop=ke._tabstop,x=ke.value}else x=l._escape(x);return this.value+="${",this.value+=oe,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,oe=this._tabstop++){const ke=x.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(x,oe){if(typeof oe=="function"){const ke=new l;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};M=l=Ve([v],M),e.SnippetString=M;var L;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(L=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let B=m=class{constructor(x,oe){if(this.uri=x,oe)if(oe instanceof R)this.range=oe;else if(oe instanceof w)this.range=new R(oe,oe);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof m?!0:x?R.isRange(x.range)&&D.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};B=m=Ve([v],B),e.Location=B;let q=class{constructor(x,oe){this.location=x,this.message=oe}static is(x){return x?typeof x.message=="string"&&x.location&&R.isRange(x.location.range)&&D.URI.isUri(x.location.uri):!1}static isEqual(x,oe){return x===oe?!0:!x||!oe?!1:x.message===oe.message&&x.location.range.isEqual(oe.location.range)&&x.location.uri.toString()===oe.location.uri.toString()}};q=Ve([v],q),e.DiagnosticRelatedInformation=q;let Q=class{constructor(x,oe,ke=O.Error){if(!R.isRange(x))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=x,this.message=oe,this.severity=ke}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,oe){return x===oe?!0:!x||!oe?!1:x.message===oe.message&&x.severity===oe.severity&&x.code===oe.code&&x.severity===oe.severity&&x.source===oe.source&&x.range.isEqual(oe.range)&&(0,_.equals)(x.tags,oe.tags)&&(0,_.equals)(x.relatedInformation,oe.relatedInformation,q.isEqual)}};Q=Ve([v],Q),e.Diagnostic=Q;let de=class{constructor(x,oe){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,T.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=oe}};de=Ve([v],de),e.Hover=de;var be;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(x,oe=be.Text){this.range=x,this.kind=oe}toJSON(){return{range:this.range,kind:be[this.kind]}}};Ae=Ve([v],Ae),e.DocumentHighlight=Ae;var Ce;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Ce=e.SymbolKind||(e.SymbolKind={}));var Le;(function(H){H[H.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(x,oe,ke,Ke,et){this.name=x,this.kind=oe,this.containerName=et,typeof ke=="string"&&(this.containerName=ke),Ke instanceof B?this.location=Ke:ke instanceof R&&(this.location=new B(Ke,ke)),t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};z=t=Ve([v],z),e.SymbolInformation=z;let Y=n=class{constructor(x,oe,ke,Ke,et){this.name=x,this.detail=oe,this.kind=ke,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};Y=n=Ve([v],Y),e.DocumentSymbol=Y;var ee;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(x,oe){this.title=x,this.kind=oe}};le=Ve([v],le),e.CodeAction=le;let me=s=class{constructor(x){this.value=x}append(x){return new s(this.value?this.value+s.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+s.sep)}};me.sep=".",me=s=Ve([v],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let De=class{constructor(x,oe){if(this.range=x,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=Ve([v],De),e.SelectionRange=De;class Oe{constructor(x,oe,ke,Ke,et,st){this.kind=x,this.name=oe,this.detail=ke,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class we{constructor(x,oe){this.fromRanges=oe,this.from=x}}e.CallHierarchyIncomingCall=we;class Pe{constructor(x,oe){this.fromRanges=oe,this.to=x}}e.CallHierarchyOutgoingCall=Pe;let Re=class{constructor(x,oe){this.range=x,this.command=oe}get isResolved(){return!!this.command}};Re=Ve([v],Re),e.CodeLens=Re;let Be=r=class{constructor(x,oe=!1){a.set(this,void 0),tt(this,a,new T.MarkdownString(x,{supportThemeIcons:oe}),"f")}static isMarkdownString(x){return x instanceof r?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Ue(this,a,"f").value}set value(x){Ue(this,a,"f").value=x}get isTrusted(){return Ue(this,a,"f").isTrusted}set isTrusted(x){Ue(this,a,"f").isTrusted=x}get supportThemeIcons(){return Ue(this,a,"f").supportThemeIcons}appendText(x){return Ue(this,a,"f").appendText(x),this}appendMarkdown(x){return Ue(this,a,"f").appendMarkdown(x),this}appendCodeblock(x,oe){return Ue(this,a,"f").appendCodeblock(oe!=null?oe:"",x),this}};a=new WeakMap,Be=r=Ve([v],Be),e.MarkdownString=Be;let Se=class{constructor(x,oe){this.label=x,this.documentation=oe}};Se=Ve([v],Se),e.ParameterInformation=Se;let qe=class{constructor(x,oe){this.label=x,this.documentation=oe,this.parameters=[]}};qe=Ve([v],qe),e.SignatureInformation=qe;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=Ve([v],X),e.SignatureHelp=X;var ie;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(_e=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(x,oe,ke){this.text=x,this.range=oe,this.kind=ke}};Ne=Ve([v],Ne),e.InlineHint=Ne;var ze;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(H){H[H.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(x,oe){this.label=x,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=Ve([v],K),e.CompletionItem=K;let se=class{constructor(x=[],oe=!1){this.items=x,this.isIncomplete=oe}};se=Ve([v],se),e.CompletionList=se;var he;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var J;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(J=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var je;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function x(oe){switch(oe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=x}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let He=class{constructor(x,oe){if(oe&&!D.URI.isUri(oe))throw(0,I.illegalArgument)("target");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.target=oe}};He=Ve([v],He),e.DocumentLink=He;let We=class{constructor(x,oe,ke,Ke){this.red=x,this.green=oe,this.blue=ke,this.alpha=Ke}};We=Ve([v],We),e.Color=We;let Ge=class{constructor(x,oe){if(oe&&!(oe instanceof We))throw(0,I.illegalArgument)("color");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.color=oe}};Ge=Ve([v],Ge),e.ColorInformation=Ge;let nt=class{constructor(x){if(!x||typeof x!="string")throw(0,I.illegalArgument)("label");this.label=x}};nt=Ve([v],nt),e.ColorPresentation=nt;var dt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ye;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ye=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=o=class{constructor(x,oe){if(typeof x!="string"||typeof oe!="string")throw(0,I.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};wt.Clean=new o("clean","Clean"),wt.Build=new o("build","Build"),wt.Rebuild=new o("rebuild","Rebuild"),wt.Test=new o("test","Test"),wt=o=Ve([v],wt),e.TaskGroup=wt;function Ee(H){let x="";for(let oe=0;oe<H.length;oe++)x+=H[oe].replace(/,/g,",,")+",";return x}let fe=class{constructor(x,oe,ke){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=x,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)x.push(oe);return Ee(x)}};fe=Ve([v],fe),e.ProcessExecution=fe;let ae=class{constructor(x,oe,ke){if(this._args=[],Array.isArray(oe)){if(!x)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x,this._args=oe,this._options=ke}else{if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)x.push(typeof oe=="string"?oe:oe.value);return Ee(x)}};ae=Ve([v],ae),e.ShellExecution=ae;var Z;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Z=e.ShellQuoting||(e.ShellQuoting={}));var Fe;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Fe=e.TaskScope||(e.TaskScope={}));class Te{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Te;let Qe=c=class{constructor(x,oe,ke,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=x;let ut;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Ke,ut=et,this.__deprecated=!0):oe===Fe.Global||oe===Fe.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,ut=st):(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof fe?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const oe=this._definition.type;(c.EmptyType===oe||c.ProcessType===oe||c.ShellType===oe||c.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=c=Ve([v],Qe),e.Task=Qe;var Ze;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(x,oe=ht.None){this.collapsibleState=oe,D.URI.isUri(x)?this.resourceUri=x:this.label=x}};ct=Ve([v],ct),e.TreeItem=ct;var ht;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Xe=class{constructor(x,oe){this.id=x,this.color=oe}};Xe=Ve([v],Xe),e.ThemeIcon=Xe,Xe.File=new Xe("file"),Xe.Folder=new Xe("folder");let ot=class{constructor(x){this.id=x}};ot=Ve([v],ot),e.ThemeColor=ot;var ft;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(x,oe){if(typeof x!="string"&&(!x||!D.URI.isUri(x)&&!D.URI.isUri(x.uri)))throw(0,I.illegalArgument)("base");if(typeof oe!="string")throw(0,I.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=D.URI.file(x),this.base=x):D.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=oe}};at=Ve([v],at),e.RelativePattern=at;let St=class{constructor(x,oe,ke,Ke){this.enabled=typeof x=="boolean"?x:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};St=Ve([v],St),e.Breakpoint=St;let vt=class extends St{constructor(x,oe,ke,Ke,et){super(oe,ke,Ke,et);if(x===null)throw(0,I.illegalArgument)("location");this.location=x}};vt=Ve([v],vt),e.SourceBreakpoint=vt;let kt=class extends St{constructor(x,oe,ke,Ke,et){super(oe,ke,Ke,et);this.functionName=x}};kt=Ve([v],kt),e.FunctionBreakpoint=kt;let At=class extends St{constructor(x,oe,ke,Ke,et,st,ut){super(Ke,et,st,ut);if(!oe)throw(0,I.illegalArgument)("dataId");this.label=x,this.dataId=oe,this.canPersist=ke}};At=Ve([v],At),e.DataBreakpoint=At;let Tt=class{constructor(x,oe,ke){this.command=x,this.args=oe||[],this.options=ke}};Tt=Ve([v],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(x,oe){this.port=x,this.host=oe}};_t=Ve([v],_t),e.DebugAdapterServer=_t;let Jt=class{constructor(x){this.path=x}};Jt=Ve([v],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(x){this.implementation=x}};Zt=Ve([v],Zt),e.DebugAdapterInlineImplementation=Zt;let gt=class{constructor(x,oe){this.range=x,this.expression=oe}};gt=Ve([v],gt),e.EvaluatableExpression=gt;let en=class{constructor(x,oe){this.range=x,this.text=oe}};en=Ve([v],en),e.InlineValueText=en;let Dt=class{constructor(x,oe,ke=!0){this.range=x,this.variableName=oe,this.caseSensitiveLookup=ke}};Dt=Ve([v],Dt),e.InlineValueVariableLookup=Dt;let Kt=class{constructor(x,oe){this.range=x,this.expression=oe}};Kt=Ve([v],Kt),e.InlineValueEvaluatableExpression=Kt;let tn=class{constructor(x,oe){this.frameId=x,this.stoppedLocation=oe}};tn=Ve([v],tn),e.InlineValueContext=tn;var Gt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Gt=e.FileChangeType||(e.FileChangeType={}));let lt=p=class extends Error{constructor(x,oe=i.FileSystemProviderErrorCode.Unknown,ke){var Ke;super(D.URI.isUri(x)?x.toString(!0):x);this.code=(Ke=ke==null?void 0:ke.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(x){return new p(x,i.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(x){return new p(x,i.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(x){return new p(x,i.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(x){return new p(x,i.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(x){return new p(x,i.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(x){return new p(x,i.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};lt=p=Ve([v],lt),e.FileSystemError=lt;let nn=class{constructor(x,oe,ke){this.start=x,this.end=oe,this.kind=ke}};nn=Ve([v],nn),e.FoldingRange=nn;var Rt;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bt;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Bt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(mn=e.CommentMode||(e.CommentMode={}));class Sn{constructor(x,oe=[]){this.tokenTypes=x,this.tokenModifiers=oe}}e.SemanticTokensLegend=Sn;function gn(H){return typeof H=="undefined"||(0,P.isStringArray)(H)}class rn{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let oe=0,ke=x.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(x.tokenTypes[oe],oe);for(let oe=0,ke=x.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(x.tokenModifiers[oe],oe)}}push(x,oe,ke,Ke,et){if(typeof x=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(x,oe,ke,Ke,et);if(R.isRange(x)&&typeof oe=="string"&&gn(ke))return this._push(x,oe,ke);throw(0,I.illegalArgument)()}_push(x,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ke=x.start.line,et=x.start.character,st=x.end.character-x.start.character,ut=this._tokenTypeStrToInt.get(oe);let yt=0;if(ke)for(const Ct of ke){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(Ct);yt|=1<<Pt>>>0}this._pushEncoded(Ke,et,st,ut,yt)}_pushEncoded(x,oe,ke,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,Pt=0;for(let It=0;It<yt;It++){let Mt=this._data[5*It],dn=this._data[5*It+1];Mt===0?(Mt=Ct,dn+=Pt):Mt+=Ct,this._data[5*It]=Mt,this._data[5*It+1]=dn,Ct=Mt,Pt=dn}}let st=x,ut=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=x,this._prevChar=oe}static _sortAndDeltaEncode(x){let oe=[];const ke=x.length/5|0;for(let ut=0;ut<ke;ut++)oe[ut]=ut;oe.sort((ut,yt)=>{const Ct=x[5*ut],Pt=x[5*yt];if(Ct===Pt){const It=x[5*ut+1],Mt=x[5*yt+1];return It-Mt}return Ct-Pt});const Ke=new Uint32Array(x.length);let et=0,st=0;for(let ut=0;ut<ke;ut++){const yt=5*oe[ut],Ct=x[yt+0],Pt=x[yt+1],It=x[yt+2],Mt=x[yt+3],dn=x[yt+4],Mn=Ct-et,Bn=Mn===0?Pt-st:Pt,hn=5*ut;Ke[hn+0]=Mn,Ke[hn+1]=Bn,Ke[hn+2]=It,Ke[hn+3]=Mt,Ke[hn+4]=dn,et=Ct,st=Pt}return Ke}build(x){return this._dataIsSortedAndDeltaEncoded?new Qt(new Uint32Array(this._data),x):new Qt(rn._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=rn;class Qt{constructor(x,oe){this.resultId=oe,this.data=x}}e.SemanticTokens=Qt;class Nt{constructor(x,oe,ke){this.start=x,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=Nt;class yn{constructor(x,oe){this.resultId=oe,this.edits=x}}e.SemanticTokensEdits=yn;var sn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var on;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(on=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Xe("arrow-left")},Xt=Ve([v],Xt),e.QuickInputButtons=Xt;var Dn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Lt{constructor(x,oe,ke){this.badge=x,this.tooltip=oe,this.color=ke}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Lt;let an=class{constructor(x){this.kind=x}};an=Ve([v],an),e.ColorTheme=an;var Cn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(Cn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(x,oe){if(x<0)throw(0,I.illegalArgument)("start must be positive");if(oe<0)throw(0,I.illegalArgument)("end must be positive");x<=oe?(this._start=x,this._end=oe):(this._start=oe,this._end=x)}static isNotebookRange(x){return x instanceof Wt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let oe=this._start,ke=this._end;return x.start!==void 0&&(oe=x.start),x.end!==void 0&&(ke=x.end),oe===this._start&&ke===this._end?this:new Wt(oe,ke)}}e.NotebookRange=Wt;class ln{constructor(x,oe){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=oe)}with(x){let{inputCollapsed:oe,outputCollapsed:ke}=x,Ke=qt(x,["inputCollapsed","outputCollapsed"]);return oe===void 0?oe=this.inputCollapsed:oe===null&&(oe=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),oe===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ke).length===0?this:new ln(Object.assign({inputCollapsed:oe,outputCollapsed:ke},Ke))}}e.NotebookCellMetadata=ln;class Ut{constructor(x=!0){var oe;typeof x=="object"?(Object.assign(this,x),this.trusted=(oe=x.trusted)!==null&&oe!==void 0?oe:!0):this.trusted=x}with(x){let{trusted:oe}=x,ke=qt(x,["trusted"]);return oe===void 0?oe=this.trusted:oe===null&&(oe=void 0),oe===this.trusted&&Object.keys(ke).length===0?this:new Ut(Object.assign({trusted:oe},ke))}}e.NotebookDocumentMetadata=Ut;class Ft{constructor(x,oe,ke,Ke,et,st){this.kind=x,this.source=oe,this.language=ke,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(oe=>Ft.isNotebookCellData(oe))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Ft;class pn{constructor(x,oe){this.cells=x,this.metadata=oe!=null?oe:new Ut}}e.NotebookData=pn;class $t{constructor(x,oe,ke){if(this.mime=x,this.value=oe,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(x){return x instanceof $t}}e.NotebookCellOutputItem=$t;class Me{constructor(x,oe,ke){this.outputs=x,typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,k.generateUuid)(),this.metadata=oe!=null?oe:ke)}}e.NotebookCellOutput=Me;var cn;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(cn=e.NotebookCellKind||(e.NotebookCellKind={}));var un;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var kn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(x,oe,ke,Ke,et,st){this.text=x,this.alignment=oe,this.command=ke,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=Pn;var vn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));let Yt=class{constructor(x,oe){this.label=x,this.timestamp=oe}};Yt=Ve([v],Yt),e.TimelineItem=Yt;var In;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(In=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Tn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Tn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(x,oe){this.ranges=x,this.wordPattern=oe}}e.LinkedEditingRanges=Rn;var wn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(wn=e.TestResultState||(e.TestResultState={}));var bn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var _n;(function(H){H[H.Pending=0]="Pending",H[H.Resolved=1]="Resolved"})(_n=e.TestItemStatus||(e.TestItemStatus={}));const xt=(H,x,oe,ke)=>{let Ke=oe;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){ke(Ke,et)||(Ke=et,H.bus.fire([3,x,et]))}}},Ht=(H,x)=>H===x,Ln=(H,x)=>H===x?!0:!H||!x?!1:H.isEqual(x);class te{constructor(x,oe,ke,Ke){this.label=oe,this.data=Ke;const et=(0,f.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new A.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:xt(et,"range",void 0,Ln),description:xt(et,"description",void 0,Ht),runnable:xt(et,"runnable",!0,Ht),debuggable:xt(et,"debuggable",!0,Ht),status:xt(et,"status",_n.Resolved,Ht),error:xt(et,"error",void 0,Ht)})}invalidate(){(0,f.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,f.getPrivateApiFor)(this);x.parent&&(0,f.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof te))throw new Error("Test child must be created through vscode.test.createTestItem()");const oe=(0,f.getPrivateApiFor)(this);if(oe.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);oe.children.set(x.id,x),oe.bus.fire([0,x])}}e.TestItemImpl=te;class ue{constructor(x){this.message=x,this.severity=bn.Error}static diff(x,oe,ke){const Ke=new ue(x);return Ke.expectedOutput=oe,Ke.actualOutput=ke,Ke}}e.TestMessage=ue;var Ie;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ie=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var rt;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(rt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[120],pe([0,1,52,12,9,144,109,7,19]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(a,u){u?k.set(a,u):k.delete(a)}e.setWordDefinitionFor=i;function C(a){return k.get(a)}e.getWordDefinitionFor=C;class f extends A.MirrorTextModel{constructor(u,E,b,S,d,l,m,t){super(E,b,S,d);this._proxy=u,this._languageId=l,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===I.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(E){return E?u._getTextInRange(E):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(E){return u._lineAt(E)},offsetAt(E){return u._offsetAt(E)},positionAt(E){return u._positionAt(E)},validateRange(E){return u._validateRange(E)},validatePosition(E){return u._validatePosition(E)},getWordRangeAtPosition(E,b){return u._getWordRangeAtPosition(E,b)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,_.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,_.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const E=this._validateRange(u);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const b=this._eol,S=E.start.line,d=E.end.line,l=[];l.push(this._lines[S].substring(E.start.character));for(let m=S+1;m<d;m++)l.push(this._lines[m]);return l.push(this._lines[d].substring(0,E.end.character)),l.join(b)}_lineAt(u){let E;if(u instanceof P.Position?E=u.line:typeof u=="number"&&(E=u),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new g(E,this._lines[E],E===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(u),b=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,b))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(u.start),b=this._validatePosition(u.end);return E===u.start&&b===u.end?u:new P.Range(E.line,E.character,b.line,b.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:E,character:b}=u,S=!1;if(E<0)E=0,b=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,b=this._lines[E].length,S=!0;else{const d=this._lines[E].length;b<0?(b=0,S=!0):b>d&&(b=d,S=!0)}return S?new P.Position(E,b):u}_getWordRangeAtPosition(u,E){const b=this._validatePosition(u);if(!E)E=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(b.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[b.line],0);if(S)return new P.Range(b.line,S.startColumn-1,b.line,S.endColumn-1)}}e.ExtHostDocumentData=f;class g{constructor(u,E,b){this._line=u,this._text=E,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[198],pe([0,1,7,3,111,6,77,24,2,30]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(f,g,a,u){this._notebook=a,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(b=>{const S=this._cellUris.get(b.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(b=>E(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const f=[],g=[];for(const a of this._notebook.getCells())a.kind===_.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),f.push(a.document.getText().length+1),g.push(a.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(f){var g,a;if(!f){let d="";for(const l of this._cells)d+=l.document.getText()+`
`;return d=d.slice(0,-1),d}if(f.isEmpty)return"";const u=this.locationAt(f.start),E=this.locationAt(f.end),b=this._cells[(g=this._cellUris.get(u.uri))!==null&&g!==void 0?g:-1],S=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!b||!S)return"";if(b===S)return b.document.getText(new _.Range(u.range.start,E.range.end));{const d=b.document.getText(new _.Range(u.range.start,new _.Position(b.document.lineCount,0))),l=S.document.getText(new _.Range(new _.Position(0,0),E.range.end));return d+`
`+l}}offsetAt(f){const g=this._cellLines.getIndexOf(f.line),a=this._cellLengths.getAccumulatedValue(g.index-1),u=this._cells[g.index].document.offsetAt(f.with(g.remainder));return a+u}positionAt(f){if(typeof f=="number"){const a=this._cellLengths.getIndexOf(f),u=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(u)}const g=this._cellUris.get(f.uri);if(g!==void 0){const a=this._cellLines.getAccumulatedValue(g-1);return new _.Position(a+f.range.start.line,f.range.start.character)}return new _.Position(0,0)}locationAt(f){_.Range.isRange(f)||(f=new _.Range(f,f));const g=this._cellLines.getIndexOf(f.start.line);let a=g;f.isEmpty||(a=this._cellLines.getIndexOf(f.end.line));const u=new _.Position(g.remainder,f.start.character),E=new _.Position(a.remainder,f.end.character),b=new _.Range(u,E),S=this._cells[g.index];return new _.Location(S.document.uri,S.document.validateRange(b))}contains(f){return this._cellUris.has(f)}validateRange(f){const g=this.validatePosition(f.start),a=this.validatePosition(f.end);return f.with(g,a)}validatePosition(f){const g=this._cellLines.getIndexOf(f.line),a=new _.Position(g.remainder,f.character),u=this._cells[g.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(g.index-1);return new _.Position(E+u.line,u.character)}}e.ExtHostNotebookConcatDocument=i}),define(ge[199],pe([0,1,7,15,3]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?_.ColorThemeKind.Light:P==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ve([xe(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ge[62],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(ge[200],pe([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function T(P,D){if(D){const k=new I,i=(g,a)=>{if(a instanceof ArrayBuffer){const u=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(a)){const u=A(a);if(u){const E=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:u,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(P,i),f=k.buffers.map(g=>{const a=new Uint8Array(g);return _.VSBuffer.wrap(a)});return{message:C,buffers:f}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=T;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,D){const k=D.map(f=>{const g=new ArrayBuffer(f.byteLength);return new Uint8Array(g).set(f.buffer),g}),i=D.length?(f,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const a=g,{index:u}=a,E=k[u];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return g}:void 0;return{message:JSON.parse(P,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(ge[88],pe([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,y,P){const D=A.webviewResourceRoot.replace("{{resource}}",P.scheme+T(P)).replace("{{uuid}}",y);return _.URI.parse(D)}e.asWebviewUri=I;function T(A){return A.toString().replace(/^\S+?:/,"")}}),define(ge[201],pe([0,1,3,6,88,30]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,i){this._proxy=D,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const C=k.getVisibleTextEditors();for(const f of this._insets.values())C.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,i,C,f){let g;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){g=l;break}if(!g)throw new Error("not a visible editor");const a=this,u=this._handlePool++,E=new _.Emitter,b=new _.Emitter,S=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,T.asWebviewUri)(a._initData,this._uuid,l)}get cspSource(){return a._initData.webviewCspSource}set options(l){this._options=l,a._proxy.$setOptions(u,l)}get options(){return this._options}set html(l){this._html=l,a._proxy.$setHtml(u,l)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(l){return a._proxy.$postMessage(u,l)}},d=new class{constructor(){this.editor=D,this.line=k,this.height=i,this.webview=S,this.onDidDispose=b.event}dispose(){a._insets.has(u)&&(a._insets.delete(u),a._proxy.$disposeEditorInset(u),b.fire(),b.dispose(),E.dispose())}};return this._proxy.$createEditorInset(u,g.id,g.value.document.uri,k+1,i,C||{},f.identifier,f.extensionLocation),this._insets.set(u,{editor:D,inset:d,onDidReceiveMessage:E}),d}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const i=this._insets.get(D);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(ge[202],pe([0,1,3,81,169,4,6,24,40,19,53,23,43,194]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",f.Codicon.window,(0,T.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function b(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=b;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(c,p,v){var h;const w=this.get(c.id);if(w)return w;const R=c;return R.openCommandActionDescriptor=(v==null?void 0:v.donotRegisterOpenCommand)?void 0:(h=R.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:R.id},(0,P.getOrSet)(this.viewContainers,p,[]).push(R),(v==null?void 0:v.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:p}),R}deregisterViewContainer(c){for(const p of this.viewContainers.keys()){const v=this.viewContainers.get(p),h=v==null?void 0:v.indexOf(c);if(h!==-1){v==null||v.splice(h,1),v.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:p});return}}}get(c){return this.all.filter(p=>p.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(v=>(v==null?void 0:v.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===c)}}D.Registry.add(a.ViewContainersRegistry,new S);var d;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function l(o,c){var p,v,h,w;const R=(p=o.group)!==null&&p!==void 0?p:d.More,N=(v=c.group)!==null&&v!==void 0?v:d.More;return R!==N?R.localeCompare(N):((h=o.order)!==null&&h!==void 0?h:5)-((w=c.order)!==null&&w!==void 0?w:5)}class m extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(c,p){this.registerViews2([{views:c,viewContainer:p}])}registerViews2(c){c.forEach(({views:p,viewContainer:v})=>this.addViews(p,v)),this._onViewsRegistered.fire(c)}deregisterViews(c,p){const v=this.removeViews(c,p);v.length&&this._onViewsDeregistered.fire({views:v,viewContainer:p})}moveViews(c,p){for(const v of this._views.keys())if(v!==p){const h=this.removeViews(c,v);h.length&&(this.addViews(h,p),this._onDidChangeContainer.fire({views:h,from:v,to:p}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const p of this._viewContainers){const v=(this._views.get(p)||[]).filter(h=>h.id===c)[0];if(v)return v}return null}getViewContainer(c){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(h=>h.id===c)[0])return p;return null}registerViewWelcomeContent(c,p){return this._viewWelcomeContents.add(c,p),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,p){const v=new Map;for(const[h,w]of p)this._viewWelcomeContents.add(c,w),v.set(h,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,w),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),v}getViewWelcomeContent(c){const p=[];return this._viewWelcomeContents.forEach(c,v=>p.push(v)),p.sort(l)}addViews(c,p){let v=this._views.get(p);v||(v=[],this._views.set(p,v),this._viewContainers.push(p));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(1,null,h.id));v.push(h)}}removeViews(c,p){const v=this._views.get(p);if(!v)return[];const h=[],w=[];for(const R of v)c.includes(R)?h.push(R):w.push(R);return h.length&&(w.length?this._views.set(p,w):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),h}}D.Registry.add(a.ViewsRegistry,new m),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(c,p){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,c),this._hasResolve=!!p,this.resolve=async v=>{var h,w;if(p&&!this.resolved){const R=await p(v);R&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:R.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:R.command)}v.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[203],pe([0,1,2,181,118,14,182,202]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(u){return(E,...b)=>u(E.get(I.ICommandService),...b)}class k{static execute(E,b){const S={forceReuseWindow:b&&b.reuseWindow,remoteAuthority:b&&b.remoteAuthority};return E.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(u,E){return u.get(T.IWorkspacesService).removeRecentlyOpened([E])});class i{static execute(E,b){return typeof b=="string"?b=b.match(/^[^:/?#]+:\/\//)?_.URI.parse(b):_.URI.file(b):b=_.URI.revive(b),E.executeCommand("_workbench.removeFromRecentlyOpened",b)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(i.ID,D(i.execute));class C{static execute(E,b){const S=typeof b=="string"?{extensionId:b}:b;return E.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(u,E){const b=u.get(T.IWorkspacesService);let S;const d=E.uri,l=E.label,m=E.remoteAuthority;return E.type==="workspace"?S={workspace:await b.getWorkspaceIdentifier(d),label:l,remoteAuthority:m}:E.type==="folder"?S={folderUri:d,label:l,remoteAuthority:m}:S={fileUri:d,label:l,remoteAuthority:m},b.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(u){return u.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(u,E){const b=u.get(A.ILogService),S=u.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&b.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(u){return u.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(u,E){const b=u.get(P.IViewDescriptorService),S=b.getViewContainerById(E.destinationId);if(!!S){for(const d of E.viewIds){const l=b.getViewDescriptorById(d);(l==null?void 0:l.canMoveView)&&b.moveViewsToContainer([l],S,P.ViewVisibilityState.Default)}await u.get(P.IViewsService).openViewContainer(S.id,!0)}});class f{static execute(E,b){return!Array.isArray(b==null?void 0:b.viewIds)||typeof(b==null?void 0:b.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",b)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:f.ID,handler:D(f.execute),description:{description:"Move Views",args:[]}});class g{static execute(E,b){return E.executeCommand("_workbench.open",b)}}g.ID="vscode.open",I.CommandsRegistry.registerCommand(g.ID,D(g.execute));class a{static execute(E,b,S,d,l){return E.executeCommand("_workbench.diff",[b,S,d])}}a.ID="vscode.diff",I.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(ge[121],pe([0,1,3,13,170]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,k,i){const C={command:P};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof i=="number"){const f=setTimeout(()=>{clearTimeout(f);const g=this.pendingRequests.get(C.seq);if(g){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,T.localize)(0,null,i,P)};g(a)}},i)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,I.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,k)=>P.set(k,D)),await(0,I.timeout)(500),P.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ge[204],pe([0,1,9,2,8,23,12]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(n,s,r){return n.replace(P,function(o,c){return s&&c.length>0&&c[0]!=="_"?o:r&&r.hasOwnProperty(c)?r[c]:o})}e.formatPII=D;function k(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=i;function C(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(s,"extensionhost")||(0,_.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function g(n,s,r){let o,c=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,v=null;for(;v=p.exec(n);){let h=v.index+1,w=h+v[0].length;if(h<=s&&w>=r){o=v[0],c=h;break}}if(o){let h=/\w+/g,w=null;for(;(w=h.exec(o))&&!(w.index+1+c+w[0].length>=r););w&&(o=o.substring(0,h.lastIndex))}return o?{start:c,end:c+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(n){return!!(n&&n.match(a))}e.isUri=u;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(u(n.path))return I.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function b(n){if(typeof n.path=="object"){const s=I.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function S(n,s){const r=s?E:b,o=(0,A.deepClone)(n);return l(o,(c,p)=>{c&&p&&(p.path=r(p))}),o}e.convertToDAPaths=S;function d(n,s){const r=s?E:b,o=(0,A.deepClone)(n);return l(o,(c,p)=>{!c&&p&&(p.path=r(p))}),o}e.convertToVSCPaths=d;function l(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":c.body.sources.forEach(p=>s(!1,p));break;case"scopes":c.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":c.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function m(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=m;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(ge[205],pe([0,1,26,38,171,122,8,9,23,10,183,121]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",l=>this.handleData(l))}sendMessage(S){if(this.outputStream){const d=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${f.TWO_CRLF}${d}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+d))}continue}}else{const d=this.rawData.indexOf(f.TWO_CRLF);if(d!==-1){const m=this.rawData.toString("utf8",0,d).split(f.HEADER_LINESEPARATOR);for(const t of m){const n=t.split(f.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(d+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class g extends f{startSession(){return new Promise((S,d)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",m=>{l?this._onError.fire(m):d(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class a extends g{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=a;class u extends g{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=u;class E extends f{constructor(S,d,l){super();this.adapterExecutable=S,this.debugType=d,this.outputService=l}async startSession(){const S=this.adapterExecutable.command,d=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,_.exists)(S))throw new Error(T.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let m=process.env;if(l.env&&Object.keys(l.env).length>0&&(m=D.mixin(D.deepClone(process.env),l.env)),S==="node")if(Array.isArray(d)&&d.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:m,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(s.cwd=l.cwd);const r=I.fork(d[0],d.slice(1),s);if(!r.pid)throw new Error(T.localize(2,null,d[0]));this.serverProcess=r}else throw new Error(T.localize(3,null));else{const n={env:m};l.cwd&&(n.cwd=l.cwd),this.serverProcess=I.spawn(S,d,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((S,d)=>{const l=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,t,n){if(m)return d(m)});l.on("exit",S),l.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,d){if(!!S){const l=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?l.runtime=y.join(d,S.runtime):l.runtime=S.runtime),S.runtimeArgs&&(l.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?l.program=S.program:l.program=y.join(d,S.program)),S.args&&(l.args=S.args);const m=S;return m.win&&(l.win=E.extract(m.win,d)),m.winx86&&(l.winx86=E.extract(m.winx86,d)),m.windows&&(l.windows=E.extract(m.windows,d)),m.osx&&(l.osx=E.extract(m.osx,d)),m.linux&&(l.linux=E.extract(m.linux,d)),l}}static platformAdapterExecutable(S,d){let l=Object.create(null);d=d.toLowerCase();for(const o of S)if(o.contributes){const c=o.contributes.debuggers;c&&c.length>0&&c.filter(p=>typeof p.type=="string"&&P.equalsIgnoreCase(p.type,d)).forEach(p=>{const v=E.extract(p,o.extensionLocation.fsPath);l=D.mixin(l,v,o.isBuiltin)})}let m;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=l.winx86||l.win||l.windows:k.isWindows?m=l.win||l.windows:k.isMacintosh?m=l.osx:k.isLinux&&(m=l.linux),m=m||l;let t=m.program||l.program;const n=m.args||l.args;let s=m.runtime||l.runtime;const r=m.runtimeArgs||l.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(ge[206],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[207],pe([0,1,38,8,78,172,26,10,84,4,206,12]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const f=A.localize(0,null);let g=class zt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,T.getWindowsShell(),d)}}runInTerminal(d,l,m,t,n){const s=n.windowsExec||zt.getDefaultTerminalWindows();return new Promise((r,o)=>{const c=`"${l} - ${f}"`,p=`""${m.join('" "')}" & pause"`,v=["/c","start",c,"/wait",s,"/c",p],h=Object.assign({},process.env,t);Object.keys(h).filter(N=>h[N]===null).forEach(N=>delete h[N]);const w={cwd:l,env:h,windowsVerbatimArguments:!0};_.spawn(zt.CMD,v,w).on("error",N=>{o(E(N))}),r(void 0)})}spawnTerminal(d,l,m,t){const s=l.terminal.external.windowsExec||zt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=I.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return d.spawn(s,t?[t]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(r==="wt"||r==="wt.exe")&&o.push("-d ."),new Promise((c,p)=>{const v=t?{cwd:t}:void 0,h=d.spawn(m,o,v);h.on("error",p),h.on("exit",()=>c())})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=Ve([xe(0,(0,k.optional)(D.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let a=class On{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,d)}}runInTerminal(d,l,m,t,n){const s=n.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{if(s===i.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",v=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,G).fsPath,"-t",d||f,"-w",l];for(let R of m)v.push("-a"),v.push(R);if(t)for(let R in t){const N=t[R];N===null?(v.push("-u"),v.push(R)):(v.push("-e"),v.push(`${R}=${N}`))}let h="";const w=_.spawn(On.OSASCRIPT,v);w.on("error",R=>{o(E(R))}),w.stderr.on("data",R=>{h+=R.toString()}),w.on("exit",R=>{if(R===0)r(void 0);else if(h){const N=h.split(`
`,1);o(new Error(N[0]))}else o(new Error(A.localize(1,null,c,R)))})}else o(new Error(A.localize(2,null,s)))})}spawnTerminal(d,l,m){const n=l.terminal.external.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const o=["-a",n];m&&o.push(m);const c=d.spawn("/usr/bin/open",o);c.on("error",r),c.on("exit",()=>s())})}};a.OSASCRIPT="/usr/bin/osascript",a=Ve([xe(0,(0,k.optional)(D.IConfigurationService))],a),e.MacExternalTerminalService=a;let u=class Vt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,d)}}runInTerminal(d,l,m,t,n){const s=n.linuxExec?Promise.resolve(n.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{let c=[];s.then(p=>{p.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const v=`${b(m)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;c.push(`''${v}''`);const h=Object.assign({},process.env,t);Object.keys(h).filter(j=>h[j]===null).forEach(j=>delete h[j]);const w={cwd:l,env:h};let R="";const N=_.spawn(p,c,w);N.on("error",j=>{o(E(j))}),N.stderr.on("data",j=>{R+=j.toString()}),N.on("exit",j=>{if(j===0)r(void 0);else if(R){const re=R.split(`
`,1);o(new Error(re[0]))}else o(new Error(A.localize(4,null,p,j)))})})})}spawnTerminal(d,l,m){const t=l.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{n.then(o=>{const c=m?{cwd:m}:void 0,p=d.spawn(o,[],c);p.on("error",r),p.on("exit",()=>s())})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{P.isLinux?await y.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}};u.WAIT_MESSAGE=A.localize(3,null),u=Ve([xe(0,(0,k.optional)(D.IConfigurationService))],u),e.LinuxExternalTerminalService=u;function E(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(A.localize(5,null,S.path)):S}function b(S){let d="";for(let l of S)l.indexOf(" ")>=0?d+='"'+l+'"':d+=l,d+=" ";return d}}),define(ge[208],pe([0,1,38,10,207,29]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let y;function P(f,g){if(!y)if(I.isWindows)y=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)y=new T.MacExternalTerminalService(void 0);else if(I.isLinux)y=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=g.getConfiguration("terminal");return y.runInTerminal(f.title,f.cwd,f.args,f.env||{},a.external||{})}e.runInExternalTerminal=P;function D(f,g){return new Promise((a,u)=>{let E="";const b=_.spawn(f,g);b.pid&&b.stdout.on("data",S=>{E+=S.toString()}),b.on("error",S=>{u(S)}),b.on("close",S=>{a(E)})})}function k(f){return f?I.isWindows?D("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(u=>parseInt(u)===f),g=>!0):D("/usr/bin/pgrep",["-lP",String(f)]).then(g=>{const a=g.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var i;(function(f){f[f.cmd=0]="cmd",f[f.powershell=1]="powershell",f[f.bash=2]="bash"})(i||(i={}));function C(f,g,a,u){f=f.trim().toLowerCase();let E;f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0?E=1:f.indexOf("cmd.exe")>=0?E=0:f.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let b,S=" ";switch(E){case 1:if(b=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),a){const l=(0,A.getDriveLetter)(a);l&&(S+=`${l}:; `),S+=`cd ${b(a)}; `}if(u)for(let l in u){const m=u[l];m===null?S+=`Remove-Item env:${l}; `:S+=`\${env:${l}}='${m}'; `}if(g.length>0){const l=b(g.shift());S+=l[0]==="'"?`& ${l} `:`${l} `;for(let m of g)S+=`${b(m)} `}break;case 0:if(b=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),a){const l=(0,A.getDriveLetter)(a);l&&(S+=`${l}: && `),S+=`cd ${b(a)} && `}if(u){S+='cmd /C "';for(let l in u){let m=u[l];m===null?S+=`set "${l}=" && `:(m=m.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${l}=${m}" && `)}}for(let l of g)S+=`${b(l)} `;u&&(S+='"');break;case 2:b=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const d=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(a&&(S+=`cd ${b(a)} ; `),u){S+="/usr/bin/env";for(let l in u){const m=u[l];m===null?S+=` -u ${d(l)}`:S+=` ${d(`${l}=${m}`)}`}S+=" "}for(let l of g)S+=`${b(l)} `;break}return S}e.prepareCommand=C}),define(ge[89],pe([0,1,33,12,8,10,81]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(v){v[v.Markdown=1]="Markdown",v[v.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var k;(function(v){v[v.Idle=1]="Idle",v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.CellClearOutput=3]="CellClearOutput",v[v.CellsClearOutput=4]="CellsClearOutput",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata"})(g=e.CellEditType||(e.CellEditType={}));function a(v){const h=u.parse(v);return h?h.notebook.toString():v.toString()}e.getCellUndoRedoComparisonKey=a;var u;(function(v){v.scheme=I.Schemas.vscodeNotebookCell;const h=/^ch(\d{7,})/;function w(re,V){return re.with({scheme:v.scheme,fragment:`ch${V.toString().padStart(7,"0")}${re.scheme!==I.Schemas.file?re.scheme:""}`})}v.generate=w;function R(re){if(re.scheme===v.scheme){const V=h.exec(re.fragment);if(!!V)return{handle:Number(V[1]),notebook:re.with({scheme:re.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}v.parse=R;function N(re,V){return re.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${V.toString().padStart(7,"0")}${re.scheme!==I.Schemas.file?re.scheme:""}`})}v.generateCellMetadataUri=N;function j(re){if(re.scheme===I.Schemas.vscodeNotebookCellMetadata){const V=h.exec(re.fragment);if(!!V)return{handle:Number(V[1]),notebook:re.with({scheme:re.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}v.parseCellMetadataUri=j})(u=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(v){var h,w;return(w=(h=E.get(v))===null||h===void 0?void 0:h.alwaysSecure)!==null&&w!==void 0?w:!1}e.mimeTypeIsAlwaysSecure=b;function S(v){var h,w;return(w=(h=E.get(v))===null||h===void 0?void 0:h.supportedByCore)!==null&&w!==void 0?w:!1}e.mimeTypeSupportedByCore=S;function d(v){var h,w;return(w=(h=E.get(v))===null||h===void 0?void 0:h.mergeable)!==null&&w!==void 0?w:!1}e.mimeTypeIsMergeable=d;function l(v,h){return A.isWindows&&(v=v.replace(/\//g,"\\"),h=h.replace(/\//g,"\\")),_.match(v,h)}function m(v,h,w){let R=0;for(let N=0;N<h.length;N++){if(l(h[N],v))return R;R++}for(let N=0;N<w.length;N++){if(l(w[N],v))return R;R++}return R}function t(v,h,w){return v.sort((R,N)=>m(R,h,w)-m(N,h,w))}e.sortMimeTypes=t;function n(v,h,w,R=(N,j)=>N===j){const N=[];function j(W,$,U){if(!($===0&&U.length===0)){const F=N[N.length-1];F&&F.start+F.deleteCount===W?(F.deleteCount+=$,F.toInsert.push(...U)):N.push({start:W,deleteCount:$,toInsert:U})}}let re=0,V=0;for(;;){if(re===v.length){j(re,0,h.slice(V));break}if(V===h.length){j(re,v.length-re,[]);break}const W=v[re],$=h[V];if(R(W,$)){re+=1,V+=1;continue}w($)?(j(re,1,[]),re+=1):(j(re,0,[$]),V+=1)}return N}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(v){v.default="default",v.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(v){const h=v;return!!((typeof h.include=="string"||_.isRelativePattern(h.include))&&(typeof h.exclude=="string"||_.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=r;function o(v,h,w){if(Array.isArray(v.viewType)&&v.viewType.indexOf(h)>=0||v.viewType===h)return!0;if(v.filenamePattern){let R=r(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,N=r(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(_.match(R,(0,T.basename)(w.fsPath).toLowerCase()))return!(N&&_.match(N,(0,T.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class c{constructor(h){this.textModel=h}getElements(){const h=new Int32Array(this.textModel.cells.length);for(let w=0;w<this.textModel.cells.length;w++)h[w]=this.textModel.cells[w].getHashValue();return h}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var p;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={})),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX="notebook/"}),define(ge[209],pe([0,1,174,4,81]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[210],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=_;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(ge[211],pe([0,1,8,135,10]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(m,t){if(!!t)if(T.isWindows)for(const n in t){let s=n;for(const o in m)if(n.toLowerCase()===o.toLowerCase()){s=o;break}const r=t[n];r!==void 0&&y(m,s,r)}else Object.keys(t).forEach(n=>{const s=t[n];s!==void 0&&y(m,n,s)})}e.mergeEnvironments=A;function y(m,t,n){typeof n=="string"?m[t]=n:delete m[t]}function P(m,t,n,s){m.TERM_PROGRAM="vscode",t&&(m.TERM_PROGRAM_VERSION=t),i(m,s)&&(m.LANG=C(n)),m.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function D(m,t){if(!!t)for(const n of Object.keys(t)){const s=t[n];s&&(m[n]=s)}}function k(m,t){return Object.keys(t).forEach(n=>{const s=t[n];if(typeof s=="string")try{t[n]=m(s)}catch(r){t[n]=s}}),t}function i(m,t){if(t==="on")return!0;if(t==="auto"){const n=m.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=i;function C(m){const t=m?m.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in s&&t.push(s[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function f(m,t,n,s,r,o){if(m.cwd){const p=typeof m.cwd=="object"?m.cwd.fsPath:m.cwd,v=g(p,n);return a(v||p)}let c;return!m.ignoreConfigurationCwd&&r&&(n&&(r=g(r,n,o)),r&&(_.isAbsolute(r)?c=r:s&&(c=_.join(s.fsPath,r)))),c||(c=s?s.fsPath:t||""),a(c)}e.getCwd=f;function g(m,t,n){if(t)try{return t(m)}catch(s){n==null||n.error("Could not resolve terminal cwd",s);return}return m}function a(m){return T.OS===1&&m&&m[1]===":"?m[0].toUpperCase()+m.substr(1):m}function u(m){let t=m;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=u;function E(m,t,n){if(!!n)return s=>n.resolveWithEnvironment(t,m,s)}e.createVariableResolver=E;function b(m,t,n,s,r,o,c,p=T.platform){let v;c&&(v=d(m,"automationShell",p)),v||(v=d(m,"shell",p));let h=v||t;if(p===3&&!n&&s){const w=_.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(w)===0&&(h=_.join(s,"System32",h.substr(w.length+1)))}if(h&&p===3&&(h=h.replace(/\//g,"\\")),r)try{h=r(h)}catch(w){o.error("Could not resolve shell",w)}return h}e.getDefaultShell=b;function S(m,t,n,s,r=T.platform){if(t&&d(m,"automationShell",r))return[];const o=r===3?"windows":r===1?"osx":"linux";let c=m(`terminal.integrated.shellArgs.${o}`);if(!c)return[];if(typeof c=="string"&&r===3)return n?n(c):c;if(n){const p=[];for(const v of c)try{p.push(n(v))}catch(h){s.error(`Could not resolve terminal.integrated.shellArgs.${o}`,h),p.push(v)}c=p}return c}e.getDefaultShellArgs=S;function d(m,t,n=T.platform){return m(`terminal.integrated.${t}.${n===3?"windows":n===1?"osx":"linux"}`)}function l(m,t,n,s,r,o){let c={};if(m.strictEnv)D(c,m.env);else{D(c,o);const p=Object.assign({},t);n&&(p&&k(n,p),m.env&&k(n,m.env)),(0,I.sanitizeProcessEnvironment)(c,"VSCODE_IPC_HOOK_CLI"),A(c,p),A(c,m.env),P(c,s,T.locale,r)}return c}e.createTerminalEnvironment=l});var fn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(A){_[A]=G[A]&&function(y){return new Promise(function(P,D){y=G[A](y),T(P,D,y.done,y.value)})}}function T(A,y,P,D){Promise.resolve(D).then(function(k){A({value:k,done:P})},y)}};define(ge[212],pe([0,1,37,8,104,191,38,26,43,10]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(l,m,t,n,s,r,o){return m=m||{existsFile:P.SymlinkSupport.existsFile,readFile:_.promises.readFile},k.isWindows?f(l,m,t,n==null?void 0:n.useWslProfiles,n==null?void 0:n.profiles.windows,s,r):b(m,t,l,k.isMacintosh?n==null?void 0:n.profiles.osx:n==null?void 0:n.profiles.linux,o,s,r)}e.detectAvailableProfiles=C;async function f(l,m,t,n,s,r,o){const c=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${process.env.windir}\\${c?"Sysnative":"System32"}`;let v=!1;(0,A.getWindowsBuildNumber)()>=16299&&(v=!0),await a();const h=new Map;l||(h.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),h.set("Windows PowerShell",{path:`${p}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),h.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),h.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),h.set("Command Prompt",{path:`${p}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),S(s,h);const w=await g(h.entries(),m,t,r,o);if(!l||l&&n)try{const R=await E(`${p}\\${v?"wsl.exe":"bash.exe"}`,n);R&&w.push(...R)}catch(R){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return w}async function g(l,m,t,n,s){const r=[];for(const[o,c]of l)if(c!==null){let p,v,h;if("source"in c){const N=i==null?void 0:i.get(c.source);if(!N)continue;p=N.paths,v=c.args||N.args,h=c.icon||N.icon}else p=Array.isArray(c.path)?c.path:[c.path],v=k.isWindows||Array.isArray(c.args)?c.args:void 0,h=c.icon;const w=p.slice();for(let N=0;N<w.length;N++)w[N]=await(n==null?void 0:n.resolveAsync(s,w[N]))||w[N];const R=await d(o,w,m,v,c.env,c.overrideName,c.isAutoDetected,t);R?(R.isAutoDetected=c.isAutoDetected,R.icon=h,r.push(R)):t==null||t.trace("profile not validated",o,p)}return r}async function a(){i||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:await u(),icon:"terminal-powershell"}))}async function u(){var l,m;const t=[];try{for(var n=fn((0,T.enumeratePowerShellInstallations)()),s;s=await n.next(),!s.done;){const r=s.value;t.push(r.exePath)}}catch(r){l={error:r}}finally{try{s&&!s.done&&(m=n.return)&&await m.call(n)}finally{if(l)throw l.error}}return t}async function E(l,m){const t=[];if(m){const n=await new Promise((s,r)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(o,c)=>{if(o)return r("Problem occurred when getting wsl distros");s(c)})});if(n){const s=new RegExp(/[\r?\n]/),r=n.split(s).filter(o=>o.trim().length>0&&o!=="");for(let o of r)if(o!==""&&!o.startsWith("docker-desktop")){const c={profileName:`${o} (WSL)`,path:l,args:["-d",`${o}`]};o.includes("Ubuntu")?c.icon="terminal-ubuntu":o.includes("Debian")?c.icon="terminal-debian":c.icon="terminal-linux",t.push(c)}return t}}return[]}async function b(l,m,t,n,s,r,o){const c=new Map;if(!t){const p=await l.readFile("/etc/shells","utf8"),v=s||p.split(`
`).filter(w=>w.trim().indexOf("#")!==0&&w.trim().length>0),h=new Map;for(const w of v){let R=(0,I.basename)(w),N=h.get(R)||0;N++,N>1&&(R=`${R} (${N})`),h.set(R,N),c.set(R,{path:w,isAutoDetected:!0})}}return S(n,c),await g(c.entries(),l,m,r,o)}function S(l,m){if(!!l)for(const[t,n]of Object.entries(l))n===null||!("path"in n)&&!("source"in n)?m.delete(t):m.set(t,n)}async function d(l,m,t,n,s,r,o,c){if(m.length===0)return Promise.resolve(void 0);const p=m.shift();if(p==="")return d(l,m,t,n,s,r,o);const v={profileName:l,path:p,args:n,env:s,overrideName:r,isAutoDetected:o};if((0,I.basename)(p)===p){const w=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,A.findExecutable)(p,void 0,w,void 0,t.existsFile)?v:d(l,m,t,n)}return await t.existsFile((0,I.normalize)(p))?v:d(l,m,t,n,s,r,o)}}),define(ge[123],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=I;var T;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=A;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const C of k)switch(C[0]){case 0:{const f=C[1];if(f.parent){if(this.items.has(f.parent)){const g=this.items.get(f.parent);g.children.add(f.item.extId);const a=this.createItem(f,g);this.items.set(f.item.extId,a),i.add(a)}}else{this.roots.add(f.item.extId);const g=this.createItem(f);this.items.set(f.item.extId,g),i.add(g)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=C[1],g=this.items.get(f.extId);if(!g)break;f.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,f),i.update(g);break}case 2:{const f=this.items.get(C[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const g=[[C[1]]];for(;g.length;)for(const a of g.pop()){const u=this.items.get(a);u&&(g.push(u.children),this.items.delete(a),i.remove(u,u!==f),u.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=P}),define(ge[213],pe([0,1,8,36,11,23,10,76,175]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,f,g){this._contributedVariables=new Map,this._context=C,this._labelService=f,g&&(this._envVariablesPromise=g.then(a=>this.prepareEnv(a)))}prepareEnv(C){if(y.isWindows){const f=Object.create(null);return Object.keys(C).forEach(g=>{f[g.toLowerCase()]=C[g]}),f}return C}resolveWithEnvironment(C,f,g){return this.recursiveResolve(this.prepareEnv(C),f?f.uri:void 0,g)}async resolveAsync(C,f){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,f)}async resolveAnyBase(C,f,g,a){const u=A.deepClone(f);return y.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):y.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):y.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,u,g,a)}async resolveAnyAsync(C,f,g){return this.resolveAnyBase(C,f,g)}async resolveAnyMap(C,f,g){const a=new Map;return{newConfig:await this.resolveAnyBase(C,f,g,a),resolvedVariables:a}}resolveWithInteractionReplace(C,f,g,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,f,g,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,f){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,f)}recursiveResolve(C,f,g,a,u){if(T.isString(g))return this.resolveString(C,f,g,a,u);if(T.isArray(g))return g.map(E=>this.recursiveResolve(C,f,E,a,u));if(T.isObject(g)){let E=Object.create(null);return Object.keys(g).forEach(b=>{const S=this.resolveString(C,f,b,a,u);E[S]=this.recursiveResolve(C,f,g[b],a,u)}),E}return g}resolveString(C,f,g,a,u){return g.replace(k.VARIABLE_REGEXP,(b,S)=>{if(S.includes(k.VARIABLE_LHS))return b;let d=this.evaluateSingleVariable(C,b,S,f,a);return u&&u.set(S,d),d})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,f,g,a,u){let E;const b=g.split(":");b.length>1&&(g=b[0],E=b[1]);const S=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,D.localize)(0,null,f))},d=()=>{const m=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,f,_.basename(m)))},l=()=>{if(E){const m=this._context.getFolderUri(E);if(m)return m;throw new Error((0,D.localize)(2,null,f,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,f)):new Error((0,D.localize)(4,null,f))};switch(g){case"env":if(E){if(C){const m=C[y.isWindows?E.toLowerCase():E];if(T.isString(m))return m}return""}throw new Error((0,D.localize)(5,null,f));case"config":if(E){const m=this._context.getConfigurationValue(a,E);if(T.isUndefinedOrNull(m))throw new Error((0,D.localize)(6,null,f,E));if(T.isObject(m))throw new Error((0,D.localize)(7,null,f,E));return m}throw new Error((0,D.localize)(8,null,f));case"command":return this.resolveFromMap(f,E,u,"command");case"input":return this.resolveFromMap(f,E,u,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return a||E?(0,P.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(l()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error((0,D.localize)(9,null,f));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,f));case"file":return S();case"fileWorkspaceFolder":return d();case"relativeFile":return a||E?_.relative(this.fsPath(l()),S()):S();case"relativeFileDirname":const n=_.dirname(S());if(a||E){const c=_.relative(this.fsPath(l()),n);return c.length===0?".":c}return n;case"fileDirname":return _.dirname(S());case"fileExtname":return _.extname(S());case"fileBasename":return _.basename(S());case"fileBasenameNoExtension":const s=_.basename(S());return s.slice(0,s.length-_.extname(s).length);case"fileDirnameBasename":return _.basename(_.dirname(S()));case"execPath":const r=this._context.getExecPath();return r||f;case"execInstallFolder":const o=this._context.getAppRoot();return o||f;case"pathSeparator":return _.sep;default:try{const c=E?`${g}:${E}`:g;return this.resolveFromMap(f,c,u,void 0)}catch(c){return f}}}}resolveFromMap(C,f,g,a){if(f&&g){const u=a===void 0?g[f]:g[a+":"+f];if(typeof u=="string")return u;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[214],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var I;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function C(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[215],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,19,98,286,58,23,11,2,44,80,176,114,89,215,7]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(Ee){function fe(Z){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:Qe,positionColumn:Ze}=Z,ct=new u.Position(Fe-1,Te-1),ht=new u.Position(Qe-1,Ze-1);return new u.Selection(ct,ht)}Ee.to=fe;function ae(Z){const{anchor:Fe,active:Te}=Z;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}Ee.from=ae})(E=e.Selection||(e.Selection={}));var b;(function(Ee){function fe(Z){if(!!Z){const{start:Fe,end:Te}=Z;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}Ee.from=fe;function ae(Z){if(!!Z){const{startLineNumber:Fe,startColumn:Te,endLineNumber:Qe,endColumn:Ze}=Z;return new u.Range(Fe-1,Te-1,Qe-1,Ze-1)}}Ee.to=ae})(b=e.Range||(e.Range={}));var S;(function(Ee){function fe(ae){switch(ae){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ee.to=fe})(S=e.TokenType||(e.TokenType={}));var d;(function(Ee){function fe(Z){return new u.Position(Z.lineNumber-1,Z.column-1)}Ee.to=fe;function ae(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Ee.from=ae})(d=e.Position||(e.Position={}));var l;(function(Ee){function fe(Z){switch(Z){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ee.from=fe;function ae(Z){switch(Z){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ee.to=ae})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Ee){function fe(Z){let Fe;return Z.code&&((0,P.isString)(Z.code)||(0,P.isNumber)(Z.code)?Fe=String(Z.code):Fe={value:String(Z.code.value),target:Z.code.target}),Object.assign(Object.assign({},b.from(Z.range)),{message:Z.message,source:Z.source,code:Fe,severity:n.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(t.from),tags:Array.isArray(Z.tags)?(0,_.coalesce)(Z.tags.map(l.from)):void 0})}Ee.from=fe;function ae(Z){var Fe;const Te=new u.Diagnostic(b.to(Z),Z.message,n.to(Z.severity));return Te.source=Z.source,Te.code=(0,P.isString)(Z.code)?Z.code:(Fe=Z.code)===null||Fe===void 0?void 0:Fe.value,Te.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(t.to),Te.tags=Z.tags&&(0,_.coalesce)(Z.tags.map(l.to)),Te}Ee.to=ae})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function fe(Z){return Object.assign(Object.assign({},b.from(Z.location.range)),{message:Z.message,resource:Z.location.uri})}Ee.from=fe;function ae(Z){return new u.DiagnosticRelatedInformation(new u.Location(Z.resource,b.to(Z)),Z.message)}Ee.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Ee){function fe(Z){switch(Z){case u.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Ee.from=fe;function ae(Z){switch(Z){case f.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ee.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(Ee){function fe(Z){return typeof Z=="number"&&Z>=u.ViewColumn.One?Z-1:Z===u.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}Ee.from=fe;function ae(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function r(Ee){return typeof Ee.range!="undefined"}function o(Ee){return Ee.length===0?!0:!!r(Ee[0])}e.isDecorationOptionsArr=o;var c;(function(Ee){function fe(Ze){return Ze.map(Ee.from)}Ee.fromMany=fe;function ae(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function Z(Ze){let ct;if(ae(Ze)){const{language:ft,value:at}=Ze;ct={value:"```"+ft+`
`+at+"\n```\n"}}else u.MarkdownString.isMarkdownString(Ze)?ct={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ct={value:Ze}:ct={value:""};const ht=Object.create(null);ct.uris=ht;const Xe=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Fe(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new T.Renderer;return ot.link=Xe,ot.image=ft=>Xe(I.parseHrefAndDimensions(ft).href),T(ct.value,{renderer:ot}),ct}Ee.from=Z;function Fe(Ze,ct){if(!Ze)return Ze;let ht;try{ht=(0,A.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Xe=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ot,Xe=!0,ft}else return}),Xe?JSON.stringify(ht):Ze}function Te(Ze){const ct=new u.MarkdownString(Ze.value,Ze.supportThemeIcons);return ct.isTrusted=Ze.isTrusted,ct}Ee.to=Te;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Ee.from(Ze)}Ee.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function p(Ee){return o(Ee)?Ee.map(fe=>({range:b.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?c.fromMany(fe.hoverMessage):fe.hoverMessage?c.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):Ee.map(fe=>({range:b.from(fe)}))}e.fromRangeOrRangeWithMessage=p;function v(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=v;var h;(function(Ee){function fe(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?v(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}Ee.from=fe})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(Ee){function fe(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?v(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?h.from(ae.before):void 0,after:ae.after?h.from(ae.after):void 0}}Ee.from=fe})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(Ee){function fe(ae){if(typeof ae=="undefined")return ae;switch(ae){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=fe})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(Ee){function fe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?w.from(ae.light):void 0,dark:ae.dark?w.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?v(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?h.from(ae.before):void 0,after:ae.after?h.from(ae.after):void 0}}Ee.from=fe})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(Ee){function fe(Z){return{text:Z.newText,eol:Z.newEol&&ie.from(Z.newEol),range:b.from(Z.range)}}Ee.from=fe;function ae(Z){const Fe=new u.TextEdit(b.to(Z.range),Z.text);return Fe.newEol=typeof Z.eol=="undefined"?void 0:ie.to(Z.eol),Fe}Ee.to=ae})(j=e.TextEdit||(e.TextEdit={}));var re;(function(Ee){function fe(Z,Fe,Te){var Qe,Ze,ct;const ht={edits:[]};if(Z instanceof u.WorkspaceEdit)for(let Xe of Z._allEntries())if(Xe._type===1)ht.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Fe==null?void 0:Fe.getDocument(Xe.uri);ht.edits.push({_type:2,resource:Xe.uri,edit:j.from(Xe.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Xe.metadata})}else Xe._type===3?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Qe=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Xe._type===4?(Xe.newOutputs&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(je.from)}}),Xe.newMetadata&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:8,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Ze=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(ve.from)}}):Xe._type===6&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:7,outputId:Xe.outputId,items:((ct=Xe.newOutputItems)===null||ct===void 0?void 0:ct.map(ye.from))||[],append:Xe.append}});return ht}Ee.from=fe;function ae(Z){const Fe=new u.WorkspaceEdit;for(const Te of Z.edits)Te.edit?Fe.replace(D.URI.revive(Te.resource),b.to(Te.edit.range),Te.edit.text):Fe.renameFile(D.URI.revive(Te.oldUri),D.URI.revive(Te.newUri),Te.options);return Fe}Ee.to=ae})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ee){const fe=Object.create(null);fe[u.SymbolKind.File]=0,fe[u.SymbolKind.Module]=1,fe[u.SymbolKind.Namespace]=2,fe[u.SymbolKind.Package]=3,fe[u.SymbolKind.Class]=4,fe[u.SymbolKind.Method]=5,fe[u.SymbolKind.Property]=6,fe[u.SymbolKind.Field]=7,fe[u.SymbolKind.Constructor]=8,fe[u.SymbolKind.Enum]=9,fe[u.SymbolKind.Interface]=10,fe[u.SymbolKind.Function]=11,fe[u.SymbolKind.Variable]=12,fe[u.SymbolKind.Constant]=13,fe[u.SymbolKind.String]=14,fe[u.SymbolKind.Number]=15,fe[u.SymbolKind.Boolean]=16,fe[u.SymbolKind.Array]=17,fe[u.SymbolKind.Object]=18,fe[u.SymbolKind.Key]=19,fe[u.SymbolKind.Null]=20,fe[u.SymbolKind.EnumMember]=21,fe[u.SymbolKind.Struct]=22,fe[u.SymbolKind.Event]=23,fe[u.SymbolKind.Operator]=24,fe[u.SymbolKind.TypeParameter]=25;function ae(Fe){return typeof fe[Fe]=="number"?fe[Fe]:6}Ee.from=ae;function Z(Fe){for(const Te in fe)if(fe[Te]===Fe)return Number(Te);return u.SymbolKind.Property}Ee.to=Z})(V=e.SymbolKind||(e.SymbolKind={}));var W;(function(Ee){function fe(Z){switch(Z){case u.SymbolTag.Deprecated:return 1}}Ee.from=fe;function ae(Z){switch(Z){case 1:return u.SymbolTag.Deprecated}}Ee.to=ae})(W=e.SymbolTag||(e.SymbolTag={}));var $;(function(Ee){function fe(Z){return{name:Z.name,kind:V.from(Z.kind),tags:Z.tags&&Z.tags.map(W.from),containerName:Z.containerName,location:O.from(Z.location)}}Ee.from=fe;function ae(Z){const Fe=new u.SymbolInformation(Z.name,V.to(Z.kind),Z.containerName,O.to(Z.location));return Fe.tags=Z.tags&&Z.tags.map(W.to),Fe}Ee.to=ae})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(Ee){function fe(Z){var Fe,Te;const Qe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:b.from(Z.range),selectionRange:b.from(Z.selectionRange),kind:V.from(Z.kind),tags:(Te=(Fe=Z.tags)===null||Fe===void 0?void 0:Fe.map(W.from))!==null&&Te!==void 0?Te:[]};return Z.children&&(Qe.children=Z.children.map(fe)),Qe}Ee.from=fe;function ae(Z){const Fe=new u.DocumentSymbol(Z.name,Z.detail,V.to(Z.kind),b.to(Z.range),b.to(Z.selectionRange));return(0,_.isNonEmptyArray)(Z.tags)&&(Fe.tags=Z.tags.map(W.to)),Z.children&&(Fe.children=Z.children.map(ae)),Fe}Ee.to=ae})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(Ee){function fe(ae){const Z=new u.CallHierarchyItem(V.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),b.to(ae.range),b.to(ae.selectionRange));return Z._sessionId=ae._sessionId,Z._itemId=ae._itemId,Z}Ee.to=fe})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(Ee){function fe(ae){return new u.CallHierarchyIncomingCall(F.to(ae.from),ae.fromRanges.map(Z=>b.to(Z)))}Ee.to=fe})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Ee){function fe(ae){return new u.CallHierarchyOutgoingCall(F.to(ae.to),ae.fromRanges.map(Z=>b.to(Z)))}Ee.to=fe})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(Ee){function fe(Z){return{range:Z.range&&b.from(Z.range),uri:Z.uri}}Ee.from=fe;function ae(Z){return new u.Location(D.URI.revive(Z.uri),b.to(Z.range))}Ee.to=ae})(O=e.location||(e.location={}));var B;(function(Ee){function fe(Z){const Fe=Z,Te=Z;return{originSelectionRange:Fe.originSelectionRange?b.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:b.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?b.from(Fe.targetSelectionRange):void 0}}Ee.from=fe;function ae(Z){return{targetUri:D.URI.revive(Z.uri),targetRange:b.to(Z.range),targetSelectionRange:Z.targetSelectionRange?b.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?b.to(Z.originSelectionRange):void 0}}Ee.to=ae})(B=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(Ee){function fe(Z){return{range:b.from(Z.range),contents:c.fromMany(Z.contents)}}Ee.from=fe;function ae(Z){return new u.Hover(Z.contents.map(c.to),b.to(Z.range))}Ee.to=ae})(q=e.Hover||(e.Hover={}));var Q;(function(Ee){function fe(Z){return{range:b.from(Z.range),expression:Z.expression}}Ee.from=fe;function ae(Z){return new u.EvaluatableExpression(b.to(Z.range),Z.expression)}Ee.to=ae})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(Ee){function fe(Z){if(Z instanceof u.InlineValueText)return{type:"text",range:b.from(Z.range),text:Z.text};if(Z instanceof u.InlineValueVariableLookup)return{type:"variable",range:b.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=fe;function ae(Z){switch(Z.type){case"text":return{range:b.to(Z.range),text:Z.text};case"variable":return{range:b.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:b.to(Z.range),expression:Z.expression}}}Ee.to=ae})(de=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function fe(Z){return{frameId:Z.frameId,stoppedLocation:b.from(Z.stoppedLocation)}}Ee.from=fe;function ae(Z){return new u.InlineValueContext(Z.frameId,b.to(Z.stoppedLocation))}Ee.to=ae})(be=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(Ee){function fe(Z){return{range:b.from(Z.range),kind:Z.kind}}Ee.from=fe;function ae(Z){return new u.DocumentHighlight(b.to(Z.range),Z.kind)}Ee.to=ae})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(Ee){function fe(ae){switch(ae){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ee.to=fe})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(Ee){function fe(ae){return{triggerKind:Ce.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}Ee.to=fe})(Le=e.CompletionContext||(e.CompletionContext={}));var z;(function(Ee){function fe(Z){switch(Z){case u.CompletionItemTag.Deprecated:return 1}}Ee.from=fe;function ae(Z){switch(Z){case 1:return u.CompletionItemTag.Deprecated}}Ee.to=ae})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(Ee){const fe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ae(Te){var Qe;return(Qe=fe.get(Te))!==null&&Qe!==void 0?Qe:9}Ee.from=ae;const Z=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Fe(Te){var Qe;return(Qe=Z.get(Te))!==null&&Qe!==void 0?Qe:u.CompletionItemKind.Property}Ee.to=Fe})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(Ee){function fe(ae,Z){var Fe;const Te=new u.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Te.label2=ae.label),Te.insertText=ae.insertText,Te.kind=Y.to(ae.kind),Te.tags=(Fe=ae.tags)===null||Fe===void 0?void 0:Fe.map(z.to),Te.detail=ae.detail,Te.documentation=I.isMarkdownString(ae.documentation)?c.to(ae.documentation):ae.documentation,Te.sortText=ae.sortText,Te.filterText=ae.filterText,Te.preselect=ae.preselect,Te.commitCharacters=ae.commitCharacters,k.Range.isIRange(ae.range)?Te.range=b.to(ae.range):typeof ae.range=="object"&&(Te.range={inserting:b.to(ae.range.insert),replacing:b.to(ae.range.replace)}),Te.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Te.insertText=new u.SnippetString(ae.insertText):(Te.insertText=ae.insertText,Te.textEdit=Te.range instanceof u.Range?new u.TextEdit(Te.range,Te.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Qe=>j.to(Qe))),Te.command=Z&&ae.command?Z.fromInternal(ae.command):void 0,Te}Ee.to=fe})(ee=e.CompletionItem||(e.CompletionItem={}));var le;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?c.fromStrict(Z.documentation):void 0}}Ee.from=fe;function ae(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation}}Ee.to=ae})(le=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?c.fromStrict(Z.documentation):void 0,parameters:Array.isArray(Z.parameters)?Z.parameters.map(le.from):[],activeParameter:Z.activeParameter}}Ee.from=fe;function ae(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(le.to):[],activeParameter:Z.activeParameter}}Ee.to=ae})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(Ee){function fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.from):[]}}Ee.from=fe;function ae(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.to):[]}}Ee.to=ae})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(Ee){function fe(Z){var Fe;return{text:Z.text,range:b.from(Z.range),kind:we.from((Fe=Z.kind)!==null&&Fe!==void 0?Fe:u.InlineHintKind.Other),description:Z.description&&c.fromStrict(Z.description),whitespaceBefore:Z.whitespaceBefore,whitespaceAfter:Z.whitespaceAfter}}Ee.from=fe;function ae(Z){const Fe=new u.InlineHint(Z.text,b.to(Z.range),we.to(Z.kind));return Fe.whitespaceAfter=Z.whitespaceAfter,Fe.whitespaceBefore=Z.whitespaceBefore,Fe.description=I.isMarkdownString(Z.description)?c.to(Z.description):Z.description,Fe}Ee.to=ae})(Oe=e.InlineHint||(e.InlineHint={}));var we;(function(Ee){function fe(Z){return Z}Ee.from=fe;function ae(Z){return Z}Ee.to=ae})(we=e.InlineHintKind||(e.InlineHintKind={}));var Pe;(function(Ee){function fe(Z){return{range:b.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Ee.from=fe;function ae(Z){let Fe;if(Z.url)try{Fe=typeof Z.url=="string"?D.URI.parse(Z.url,!0):D.URI.revive(Z.url)}catch(Te){}return new u.DocumentLink(b.to(Z.range),Fe)}Ee.to=ae})(Pe=e.DocumentLink||(e.DocumentLink={}));var Re;(function(Ee){function fe(Z){const Fe=new u.ColorPresentation(Z.label);return Z.textEdit&&(Fe.textEdit=j.to(Z.textEdit)),Z.additionalTextEdits&&(Fe.additionalTextEdits=Z.additionalTextEdits.map(Te=>j.to(Te))),Fe}Ee.to=fe;function ae(Z){return{label:Z.label,textEdit:Z.textEdit?j.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Fe=>j.from(Fe)):void 0}}Ee.from=ae})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Ee){function fe(Z){return new u.Color(Z[0],Z[1],Z[2],Z[3])}Ee.to=fe;function ae(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Ee.from=ae})(Be=e.Color||(e.Color={}));var Se;(function(Ee){function fe(Z){return{range:b.from(Z.range)}}Ee.from=fe;function ae(Z){return new u.SelectionRange(b.to(Z.range))}Ee.to=ae})(Se=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Ee){function fe(ae){switch(ae){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ee.to=fe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(Ee){function fe(Z){switch(Z){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=fe;function ae(Z){switch(Z){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ee.to=ae})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(Ee){function fe(Z){if(Z===u.EndOfLine.CRLF)return 1;if(Z===u.EndOfLine.LF)return 0}Ee.from=fe;function ae(Z){if(Z===1)return u.EndOfLine.CRLF;if(Z===0)return u.EndOfLine.LF}Ee.to=ae})(ie=e.EndOfLine||(e.EndOfLine={}));var _e;(function(Ee){function fe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=fe})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(Ee){function fe(ae){const Z={start:ae.start+1,end:ae.end+1};return ae.kind&&(Z.kind=ze.from(ae.kind)),Z}Ee.from=fe})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(Ee){function fe(ae){if(ae)switch(ae){case u.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Ee.from=fe})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(Ee){function fe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?b.from(ae.selection):void 0,override:typeof ae.override=="boolean"?C.EditorOverride.DISABLED:void 0}}Ee.from=fe})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(Ee){function fe(Z){return Z instanceof u.RelativePattern||typeof Z=="string"?Z:ae(Z)?new u.RelativePattern(Z.base,Z.pattern):Z}Ee.from=fe;function ae(Z){const Fe=Z;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var K;(function(Ee){function fe(ae){if(ae){if(Array.isArray(ae))return ae.map(fe);if(typeof ae=="string")return ae;{const Z=ae;return{language:Z.language,scheme:Z.scheme,pattern:typeof Z.pattern=="undefined"?void 0:Je.from(Z.pattern),exclusive:Z.exclusive}}}else return}Ee.from=fe})(K=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(Ee){function fe(Z){return{start:Z.start,end:Z.end}}Ee.from=fe;function ae(Z){return new u.NotebookRange(Z.start,Z.end)}Ee.to=ae})(se=e.NotebookRange||(e.NotebookRange={}));var he;(function(Ee){function fe(ae){return new u.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}Ee.to=fe})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var J;(function(Ee){function fe(Z){return Z}Ee.from=fe;function ae(Z){return new u.NotebookDocumentMetadata().with(Z)}Ee.to=ae})(J=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(Ee){function fe(Z){return{startTime:Z.runStartTime,endTime:Z.runEndTime,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Ee.to=fe;function ae(Z){return{lastRunSuccess:Z.success,runStartTime:Z.startTime,runEndTime:Z.endTime,executionOrder:Z.executionOrder}}Ee.from=ae})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(Ee){function fe(Z){switch(Z){case u.NotebookCellKind.Markdown:return g.CellKind.Markdown;case u.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=fe;function ae(Z){switch(Z){case g.CellKind.Markdown:return u.NotebookCellKind.Markdown;case g.CellKind.Code:default:return u.NotebookCellKind.Code}}Ee.to=ae})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(Ee){function fe(Z){var Fe;return{cellKind:ce.from(Z.kind),language:Z.language,source:Z.source,metadata:Object.assign(Object.assign({},Z.metadata),ne.from((Fe=Z.latestExecutionSummary)!==null&&Fe!==void 0?Fe:{})),outputs:Z.outputs?Z.outputs.map(je.from):[]}}Ee.from=fe;function ae(Z){return new u.NotebookCellData(ce.to(Z.cellKind),Z.source,Z.language,Z.outputs?Z.outputs.map(je.to):void 0,Z.metadata?he.to(Z.metadata):void 0)}Ee.to=ae})(ve=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(Ee){function fe(Z){return{mime:Z.mime,value:Z.value,metadata:Z.metadata}}Ee.from=fe;function ae(Z){return new u.NotebookCellOutputItem(Z.mime,Z.value,Z.metadata)}Ee.to=ae})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(Ee){function fe(Z){return{outputId:Z.id,outputs:Z.outputs.map(ye.from),metadata:Z.metadata}}Ee.from=fe;function ae(Z){const Fe=Z.outputs.map(ye.to);return new u.NotebookCellOutput(Fe,Z.outputId,Z.metadata)}Ee.to=ae})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(Ee){function fe(Te){if(Te!=null){if(Te instanceof u.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new u.RelativePattern(Te.base,Te.pattern);if(Z(Te))return{include:Je.from(Te.include)||void 0,exclude:Je.from(Te.exclude)||void 0}}}Ee.from=fe;function ae(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}Ee.to=ae;function Z(Te){const Qe=Te,Ze=Je.from(Qe.include);if(!(Ze&&Ze instanceof u.RelativePattern||typeof Ze=="string"))return!1;const ct=Je.from(Qe.exclude);return!!(ct&&ct instanceof u.RelativePattern||typeof ct=="string")}function Fe(Te){const Qe=Te;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(Ee){function fe(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?h.from(ae.top):void 0}}Ee.from=fe})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(Ee){function fe(ae,Z,Fe){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Te,Fe),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}Ee.from=fe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(Ee){function fe(ae){var Z,Fe;return{transientOutputs:(Z=ae==null?void 0:ae.transientOutputs)!==null&&Z!==void 0?Z:!1,transientCellMetadata:Object.assign(Object.assign({},ae==null?void 0:ae.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Fe=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}Ee.from=fe})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(Ee){function fe(Z){var Fe;return{uri:Z.uri,provides:typeof Z.provides=="string"?[Z.provides]:(Fe=Z.provides)!==null&&Fe!==void 0?Fe:[]}}Ee.from=fe;function ae(Z){return{uri:D.URI.revive(Z.uri),provides:Z.provides}}Ee.to=ae})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(Ee){function fe(Z){return{message:c.fromStrict(Z.message)||"",severity:Z.severity,expectedOutput:Z.expectedOutput,actualOutput:Z.actualOutput,location:Z.location?O.from(Z.location):void 0}}Ee.from=fe;function ae(Z){const Fe=new u.TestMessage(typeof Z.message=="string"?Z.message:c.to(Z.message));return Fe.severity=Z.severity,Fe.actualOutput=Z.actualOutput,Fe.expectedOutput=Z.expectedOutput,Fe}Ee.to=ae})(it=e.TestMessage||(e.TestMessage={}));var Ye;(function(Ee){function fe(Te){var Qe,Ze;return{extId:Te.id,label:Te.label,uri:Te.uri,range:b.from(Te.range)||null,debuggable:(Qe=Te.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Te.description||null,runnable:(Ze=Te.runnable)!==null&&Ze!==void 0?Ze:!0,error:Te.error&&c.fromStrict(Te.error)||null}}Ee.from=fe;function ae(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:b.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=ae;function Z(Te){return{id:Te.extId,label:Te.label,uri:D.URI.revive(Te.uri),range:b.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:u.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}Ee.toPlain=Z;function Fe(Te){const Qe=new u.TestItemImpl(Te.extId,Te.label,D.URI.revive(Te.uri),void 0);return Qe.range=b.to(Te.range||void 0),Qe.debuggable=Te.debuggable,Qe.description=Te.description||void 0,Qe.runnable=Te.runnable,Qe}Ee.to=Fe})(Ye=e.TestItem||(e.TestItem={}));var mt;(function(Ee){const fe=(Z,Fe)=>Object.assign(Object.assign({},Ye.toPlain(Z.item)),{taskStates:Z.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(it.to)})),children:Z.children.map(Te=>Fe.get(Te)).filter(P.isDefined).map(Te=>fe(Te,Fe))});function ae(Z){const Fe=[],Te=new Map;for(const Qe of Z.items)Te.set(Qe.item.extId,Qe),Qe.direct&&Fe.push(Qe);return{completedAt:Z.completedAt,results:Fe.map(Qe=>fe(Qe,Te))}}Ee.to=ae})(mt=e.TestResults||(e.TestResults={}));var wt;(function(Ee){function fe(ae){switch(ae){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ee.to=fe})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[216],pe([0,1,2,18,7,20,56]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,i,C,f={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=C,this._thresholds=f,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,C,f)=>{const a={dispose:this._callbacks.push([i,C,k])};return Array.isArray(f)&&f.push(a),a}}async $participateInSave(k,i){const C=_.URI.revive(k);let f=!1;const g=setTimeout(()=>f=!0,this._thresholds.timeout),a=[];try{for(let u of[...this._callbacks]){if(f)break;const E=this._documents.getDocument(C),b=await this._deliverEventAsyncAndBlameBadListeners(u,{document:E,reason:A.TextDocumentSaveReason.to(i)});a.push(b)}}finally{clearTimeout(g)}return a}_deliverEventAsyncAndBlameBadListeners([k,i,C],f){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,i,f).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const u=this._badListeners.get(k);this._badListeners.set(k,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,C,f){const g=[],a=Date.now(),{document:u,reason:E}=f,{version:b}=u,S=Object.freeze({document:u,reason:E,waitUntil(d){if(Object.isFrozen(g))throw(0,I.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(d))}});try{i.apply(C,[S])}catch(d){return Promise.reject(d)}return Object.freeze(g),new Promise((d,l)=>{const m=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(m),d(t)}).catch(t=>{clearTimeout(m),l(t)})}).then(d=>{const l={edits:[]};for(const m of d)if(Array.isArray(m)&&m.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:s}of m)l.edits.push({_type:2,resource:u.uri,edit:{range:s&&A.Range.from(s),text:t,eol:n&&A.EndOfLine.from(n)}});if(l.edits.length!==0)return b===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[217],pe([0,1,3,13,33,2,20,7]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,f,g,a,u){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,g&&(this._config+=1),a&&(this._config+=2),u&&(this._config+=4);const E=(0,T.parse)(f),b=C(S=>{if(!g)for(let d of S.created){const l=A.URI.revive(d);E(l.fsPath)&&this._onDidCreate.fire(l)}if(!a)for(let d of S.changed){const l=A.URI.revive(d);E(l.fsPath)&&this._onDidChange.fire(l)}if(!u)for(let d of S.deleted){const l=A.URI.revive(d);E(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(C,f,g){this._logService=f,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,f,g,a){return new D(this._onFileSystemEvent.event,C,f,g,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,f){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(g=>A.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,f){return(g,a,u)=>{const E=function(S){g.call(a,S)};return E.extension=C,f.event(E,void 0,u)}}async $onWillRunFileOperation(C,f,g,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(u=>({oldUri:A.URI.revive(u.source),newUri:A.URI.revive(u.target)}))},g,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(u=>A.URI.revive(u.target))},g,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(u=>A.URI.revive(u.target))},g,a)}}async _fireWillEvent(C,f,g,a){const u=new Set,E=[];if(await C.fireAsync(f,a,async(S,d)=>{var l;const m=Date.now(),t=await Promise.resolve(S);t instanceof P.WorkspaceEdit&&(E.push(t),u.add((l=d.extension.displayName)!==null&&l!==void 0?l:d.extension.identifier.value)),Date.now()-m>g&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!a.isCancellationRequested&&E.length!==0){const b={edits:[]};for(let S of E){let{edits:d}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(d)}return{edit:b,extensionNames:Array.from(u)}}}}e.ExtHostFileSystemEventService=k}),define(ge[218],pe([0,1,12,23,2,20,7,89]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(f,g,a,u){this.start=f,this.deletedCount=g,this.deletedItems=a,this.items=u}static asApiEvents(f){return f.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(a=>a.apiCell)}))}}class k{constructor(f,g,a){var u;this._notebook=f,this._extHostDocument=g,this._cellData=a,this.handle=a.handle,this.uri=T.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(u=a.metadata)!==null&&u!==void 0?u:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(f,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const f=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get latestExecutionSummary(){return f._previousResult}})}return this._cell}setOutputs(f){this._outputs=f.map(A.NotebookCellOutput.to)}setOutputItems(f,g,a){const u=a.map(A.NotebookCellOutputItem.to),E=this._outputs.find(b=>b.id===f);E&&(g||(E.outputs.length=0),E.outputs.push(...u))}setMetadata(f){this._internalMetadata=f,this._metadata=A.NotebookCellMetadata.to(f),this._previousResult=A.NotebookCellPreviousExecutionResult.to(f)}}e.ExtHostCell=k;class i{constructor(f,g,a,u,E,b,S){this._proxy=f,this._textDocumentsAndEditors=g,this._textDocuments=a,this._emitter=u,this._viewType=E,this._metadata=b,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===_.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(g){return g=f._validateIndex(g),f._cells[g].apiCell},getCells(g){return(g?f._getCells(g):f._cells).map(u=>u.apiCell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,g){this._versionId=f.versionId,this._isDirty=g;for(const a of f.rawEvents)a.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===P.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(f){return f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){return f.start<0&&(f=f.with({start:0})),f.end>this._cells.length&&(f=f.with({end:this._cells.length})),f}_getCells(f){f=this._validateRange(f);const g=[];for(let a=f.start;a<f.end;a++)g.push(this._cells[a]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,g){if(!this._disposed){const a=[],u=[],E=[];f.reverse().forEach(b=>{const d=b[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return g||u.push(k.asModelAddData(this.apiNotebook,t)),n}),l=new D(b[0],b[1],[],d),m=this._cells.splice(b[0],b[1],...d);for(let t of m)E.push(t.uri),l.deletedItems.push(t.apiCell);a.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:E}),g||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}}_moveCell(f,g){const a=this._cells.splice(f,1);this._cells.splice(g,0,...a);const u=[new D(f,1,a.map(E=>E.apiCell),[]),new D(g,0,[],a)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(u)}))}_setCellOutputs(f,g){const a=this._cells[f];a.setOutputs(g),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(f,g,a,u){const E=this._cells[f];E.setOutputItems(g,a,u),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(f,g){const a=this._cells[f];a.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(a.uri,g)}_changeCellMetadata(f,g){var a;const u=this._cells[f],E=u.internalMetadata,b=u.apiCell.metadata;u.setMetadata(g);const S=u.apiCell.metadata;if((0,I.equals)(b,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:u.apiCell})),E.runState!==g.runState){const d=(a=g.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,executionState:d}))}}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(g=>g.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ge[219],pe([0,1,7,20]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:D})}replaceCells(P,D,k){this._throwIfFinalized(),!(P===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:P,count:D-P,cells:k.map(I.NotebookCellData.from)})}}class A{constructor(P,D,k,i,C,f){this.id=P,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=i,this._viewColumn=f}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(D,k){P._proxy.$tryRevealRange(P.id,I.NotebookRange.from(D),k!=null?k:_.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(D){const k=new T(this.document.version);return D(k),P._applyEdit(k.finalize())},setDecorations(D,k){return P.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let i=0;i<P.cellEdits.length;i++){if(k<0){D.push(P.cellEdits[i]),k++;continue}const f=D[k],g=P.cellEdits[i];if(f.editType===1&&g.editType===1&&f.index===g.index){f.cells.push(...P.cellEdits[i].cells),f.count+=P.cellEdits[i].count;continue}D.push(P.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,D)}setDecorations(P,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return D.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),P.key)}}e.ExtHostNotebookEditor=A}),define(ge[220],pe([0,1,20,115,163,21,70]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,f,g){const a=this._handles++,{title:u,location:E,cancellable:b}=f,S={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:_.ProgressLocation.from(E),title:u,source:S,cancellable:b},C),this._withProgress(a,g,!!b)}_withProgress(C,f,g){let a;g&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const u=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),a&&a.dispose()};let E;try{E=f(new k(this._proxy,C),g&&a?a.token:A.CancellationToken.None)}catch(b){throw u(C),b}return E.then(b=>u(C),b=>u(C)),E}$acceptProgressCanceled(C){const f=this._mapHandleToCancellationSource.get(C);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=P;function D(i,C){return i.message=C.message,typeof C.increment=="number"&&(typeof i.increment=="number"?i.increment+=C.increment:i.increment=C.increment),i}class k extends I.Progress{constructor(C,f){super(g=>this.throttledReport(g));this._proxy=C,this._handle=f}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}Ve([(0,y.throttle)(100,(i,C)=>D(i,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ge[124],pe([0,1,52,18,72,20,7]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(f,g){const a=P._Keys.nextId();f.$registerTextEditorDecorationType(a,A.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new T.IdGenerator("TextEditorDecorationType");class D{constructor(f,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,g){this._throwIfFinalized();let a=null;if(f instanceof y.Position)a=new y.Range(f,f);else if(f instanceof y.Range)a=f;else throw new Error("Unrecognized location");this._pushEdit(a,g,!1)}insert(f,g){this._throwIfFinalized(),this._pushEdit(new y.Range(f,f),g,!0)}delete(f){this._throwIfFinalized();let g=null;if(f instanceof y.Range)g=f;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(f,g,a){const u=this._document.validateRange(f);this._collectedEdits.push({range:u,text:g,forceMoveMarkers:a})}setEndOfLine(f){if(this._throwIfFinalized(),f!==y.EndOfLine.LF&&f!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=D;class k{constructor(f,g,a,u){this._proxy=f,this._id=g,this._accept(a),this._logService=u;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(b){E._setTabSize(b)},get insertSpaces(){return E._insertSpaces},set insertSpaces(b){E._setInsertSpaces(b)},get cursorStyle(){return E._cursorStyle},set cursorStyle(b){E._setCursorStyle(b)},get lineNumbers(){return E._lineNumbers},set lineNumbers(b){E._setLineNumbers(b)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const g=Math.floor(f);return g>0?g:null}if(typeof f=="string"){const g=parseInt(f,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(f){const g=this._validateTabSize(f);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const g=this._validateInsertSpaces(f);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const g={};let a=!1;if(typeof f.tabSize!="undefined"){const u=this._validateTabSize(f.tabSize);u==="auto"?(a=!0,g.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,a=!0,g.tabSize=u)}if(typeof f.insertSpaces!="undefined"){const u=this._validateInsertSpaces(f.insertSpaces);u==="auto"?(a=!0,g.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,a=!0,g.insertSpaces=u)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,a=!0,g.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,a=!0,g.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(f){f.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class i{constructor(f,g,a,u,E,b,S,d){this.id=f,this._proxy=g,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,b,a),this._visibleRanges=S,this._viewColumn=d;const l=this;this.value=Object.freeze({get document(){return u.getValue()},set document(m){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(m){if(!(m instanceof y.Selection))throw(0,I.illegalArgument)("selection");l._selections=[m],l._trySetSelection()},get selections(){return l._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");l._selections=m,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(m){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(m){l._disposed||l._options.assign(m)},get viewColumn(){return l._viewColumn},set viewColumn(m){throw(0,I.readonly)("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(u.getValue(),t);return m(n),l._applyEdit(n)},insertSnippet(m,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=l._selections.map(r=>A.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=A.Position.from(t);s=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)s=[A.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(A.Range.from(r));else{const{lineNumber:o,column:c}=A.Position.from(r);s.push({startLineNumber:o,startColumn:c,endLineNumber:o,endColumn:c})}}return g.$tryInsertSnippet(f,m.value,s,n)},setDecorations(m,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(m.key)||(n?l._hasDecorationsForKey.delete(m.key):l._hasDecorationsForKey.add(m.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return g.$trySetDecorations(f,m.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const c=t[r];s[4*r]=c.start.line+1,s[4*r+1]=c.start.character+1,s[4*r+2]=c.end.line+1,s[4*r+3]=c.end.character+1}return g.$trySetDecorationsFast(f,m.key,s)}}))},revealRange(m,t){l._runOnProxy(()=>g.$tryRevealRange(f,A.Range.from(m),t||y.TextEditorRevealType.Default))},show(m){g.$tryShowEditor(f,A.ViewColumn.from(m))},hide(){g.$tryHideEditor(f)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,_.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,_.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,_.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,_.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const g=f.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const a=g.edits.map(E=>E.range);a.sort((E,b)=>E.end.line===b.end.line?E.end.character===b.end.character?E.start.line===b.start.line?E.start.character-b.start.character:E.start.line-b.start.line:E.end.character-b.end.character:E.end.line-b.end.line);for(let E=0,b=a.length-1;E<b;E++){const S=a[E].end;if(a[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=g.edits.map(E=>({range:A.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,u,{setEndOfLine:typeof g.setEndOfLine=="number"?A.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(ge[221],pe([0,1,166,25,2,3,6,13,7,11,19,20,21]),function(G,e,_,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(E,b){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class a{constructor(b,S,d){this._proxy=b,this.commands=S,this.logService=d,this.treeViews=new Map;function l(m){return m&&m.$treeViewId&&m.$treeItemHandle}S.registerArgumentProcessor({processArgument:m=>l(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>l(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(b,S,d){const l=this.createTreeView(b,{treeDataProvider:S},d);return{dispose:()=>l.dispose()}}createTreeView(b,S,d){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany}),m=this.createExtHostTreeView(b,S,d);return{get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get message(){return m.message},set message(t){m.message=t},get title(){return m.title},set title(t){m.title=t},get description(){return m.description},set description(t){m.description=t},reveal:(t,n)=>m.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(b),m.dispose()}}}$getChildren(b,S){const d=this.treeViews.get(b);return d?d.getChildren(S):Promise.reject(new Error((0,_.localize)(0,null,b)))}async $hasResolve(b){const S=this.treeViews.get(b);if(!S)throw new Error((0,_.localize)(1,null,b));return S.hasResolve}$resolve(b,S,d){const l=this.treeViews.get(b);if(!l)throw new Error((0,_.localize)(2,null,b));return l.resolveTreeItem(S,d)}$setExpanded(b,S,d){const l=this.treeViews.get(b);if(!l)throw new Error((0,_.localize)(3,null,b));l.setExpanded(S,d)}$setSelection(b,S){const d=this.treeViews.get(b);if(!d)throw new Error((0,_.localize)(4,null,b));d.setSelection(S)}$setVisible(b,S){const d=this.treeViews.get(b);if(!d)throw new Error((0,_.localize)(5,null,b));d.setVisible(S)}createExtHostTreeView(b,S,d){const l=new u(b,S,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(b,l),l}convertArgument(b){const S=this.treeViews.get(b.$treeViewId);return S?S.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=a;class u extends y.Disposable{constructor(b,S,d,l,m,t){super();if(this.viewId=b,this.proxy=d,this.commands=l,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===b&&(this._title=o.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(A.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(c=>s=c),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=s;return n=null,this.refresh(o).then(()=>c())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,k.isUndefinedOrNull)(b))}getChildren(b){const S=b?this.getExtensionElement(b):void 0;if(b&&!S)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(b);return(d?Promise.resolve(d):this.fetchChildrenNodes(S)).then(l=>l.map(m=>m.item))}getExtensionElement(b){return this.elements.get(b)}reveal(b,S){S=S||{select:!0,focus:!1};const d=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,l=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,m=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:d,focus:l,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:l,expand:m})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,S){const d=this.getExtensionElement(b);d&&(S?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(b){(0,i.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,S){var d;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(b);if(l){const m=this.nodes.get(l);if(m){const t=(d=await this.dataProvider.resolveTreeItem(m.extensionItem,l,S))!==null&&d!==void 0?d:m.extensionItem;return m.item.tooltip=this.getTooltip(t.tooltip),m.item.command=this.getCommand(m.disposableStore,t.command),m.item}}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(S=>S?this.resolveUnknownParentChain(S).then(d=>this.resolveTreeNode(S,d[d.length-1]).then(l=>(d.push(l),d))):Promise.resolve([]))}resolveParent(b){const S=this.nodes.get(b);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,S){const d=this.nodes.get(b);return d?Promise.resolve(d):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(l=>this.createHandle(b,l,S,!0)).then(l=>this.getChildren(S?S.item.handle:void 0).then(()=>{const m=this.getExtensionElement(l);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(b){if(b){let S;if(typeof b=="string"){const d=this.getExtensionElement(b);S=d?this.nodes.get(d):void 0}else S=b;return S&&S.children||null}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const S=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=b?this.nodes.get(b):void 0,l=await this.dataProvider.getChildren(b);if(S.token.isCancellationRequested)return[];const m=await Promise.all((0,i.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,d):null}));return S.token.isCancellationRequested?[]:(0,i.coalesce)(m)}finally{S.dispose()}}refresh(b){if(b.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(b);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const S=new Set,d=b.map(m=>this.nodes.get(m));for(const m of d)if(m&&!S.has(m.item.handle)){let t=m;for(;t&&t.parent&&d.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(m.item.handle)}const l=[];return S.forEach(m=>{const t=this.elements.get(m);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&l.push(m)}}),l}refreshHandles(b){const S={};return Promise.all(b.map(d=>this.refreshNode(d).then(l=>{l&&(S[d]=l.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(b){const S=this.getExtensionElement(b);if(S){const d=this.nodes.get(S);if(d)return this.clearChildren(S),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(l=>{if(l){const m=this.createTreeNode(S,l,d.parent);return this.updateNodeCache(S,m,d,d.parent),d.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,S,d){const l=this.createTreeNode(b,S,d);if(S.id&&this.elements.has(l.item.handle))throw new Error((0,_.localize)(6,null,S.id));return this.addNodeToCache(b,l),this.addNodeToParentCache(l,d),l}getTooltip(b){return D.MarkdownString.isMarkdownString(b)?C.MarkdownString.from(b):b}getCommand(b,S){return S?this.commands.toInternal(S,b):void 0}createTreeNode(b,S,d){const l=new y.DisposableStore,m=this.createHandle(b,S,d),t=this.getLightIconPath(S);return{item:{handle:m,parentHandle:d?d.item.handle:void 0,label:g(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(l,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:d,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(b){return b.iconPath instanceof D.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:S,label:d,resourceUri:l},m,t){if(S)return`${u.ID_HANDLE_PREFIX}/${S}`;const n=g(d,this.extension),s=m?m.item.handle:u.LABEL_HANDLE_PREFIX;let r=n?n.label:l?(0,I.basename)(l):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,c=this.getChildrenNodes(m)||[];let p,v=0;do{if(p=`${s}/${v}:${r}`,t||!this.elements.has(p)||o===p)break;v++}while(v<=c.length);return p}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon))return typeof b.iconPath=="string"||T.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return T.URI.isUri(b)?b:T.URI.file(b)}addNodeToCache(b,S){this.elements.set(S.item.handle,b),this.nodes.set(b,S)}updateNodeCache(b,S,d,l){this.elements.delete(S.item.handle),this.nodes.delete(b),S.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(b,S);const m=this.getChildrenNodes(l)||[],t=m.filter(n=>n.item.handle===d.item.handle)[0];t&&m.splice(m.indexOf(t),1,S)}addNodeToParentCache(b,S){S?(S.children||(S.children=[]),S.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const S=this.nodes.get(b);if(S){if(S.children)for(const d of S.children){const l=this.elements.get(d.item.handle);l&&this.clear(l)}S.children=void 0}}else this.clearAll()}clear(b){const S=this.nodes.get(b);if(S){if(S.children)for(const d of S.children){const l=this.elements.get(d.item.handle);l&&this.clear(l)}this.nodes.delete(b),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(ge[222],pe([0,1,19,13,21,11,87,20,7,123]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(E,b){if(b!==void 0){const S=this.testIdsToInternal.get(b),d=S==null?void 0:S.get(E);if(d)return[S,d]}return(0,_.mapFind)(this.testIdsToInternal.values(),S=>{const d=S.get(E);return d&&[S,d]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(f++),E)}createIdMap(E){const b=new g(E);return this.testIdsToInternal.set(b.id,b),{object:b,dispose:()=>this.testIdsToInternal.delete(b.id)}}}e.OwnedTestCollection=i;var C;(function(u){u[u.Disconnected=0]="Disconnected",u[u.IsChild=1]="IsChild",u[u.IsParent=2]="IsParent",u[u.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let f=0;class g{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const b=this.map.get(E);return b?(this.map.delete(E),this._roots.delete(b),!0):!1}get(E){return this.map.get(E)}comparePositions(E,b){const S=typeof E=="string"?this.map.get(E):E,d=typeof b=="string"?this.map.get(b):b;if(!S||!d)return 0;if(S===d)return 3;for(let l=this.map.get(d.parent);l;l=this.map.get(l.parent))if(l===S)return 1;for(let l=this.map.get(S.parent);l;l=this.map.get(l.parent))if(l===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class a{constructor(E,b){this.testIdToInternal=E,this.publishDiff=b,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,b){this.addItem(E,b,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const b=this.diff[this.diff.length-1];if(b&&E[0]===1){if(b[0]===1&&b[1].extId===E[1].extId){(0,k.applyTestItemUpdate)(b[1],E[1]);return}if(b[0]===0&&b[1].item.extId===E[1].extId){(0,k.applyTestItemUpdate)(b[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,b){var S;const d=this.testIdToInternal.object.get(E);if(!!d){if((d.expandLevels===void 0||b>d.expandLevels)&&(d.expandLevels=b),d.expand===1){const l=this.refreshChildren(d);return l.isSettled?this.expandChildren(d,b-1):l.p.then(()=>this.expandChildren(d,b-1))}else if(d.expand===3)return((S=d.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,b-1)):this.expandChildren(d,b-1)}}dispose(){var E;for(const b of this.testItemToInternal.values())(E=b.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(b.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,b){const S=E==null?void 0:E.actual.id;switch(b[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(b[1],E.src.controller,E);break;case 3:const[d,l,m]=b;switch(l){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:P.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:P.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[l]:m!=null?m:null}}]);break}break;default:(0,A.assertNever)(b[0])}}addItem(E,b,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const d=S?S.item.extId:null,l=E.resolveHandler?1:0,m=S==null?void 0:S.expandLevels,t={controller:b,tree:this.testIdToInternal.object.id},n={actual:E,parent:d,item:P.TestItem.from(E),expandLevels:m?m-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:d,src:t,expand:l,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=S==null?void 0:S.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,b,n)}updateExpandability(E){var b;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((b=E.initialExpand)===null||b===void 0||b.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,b){if(!(b<0)){const S=[...E.actual.children.values()].map(d=>this.expand(d.id,b)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const b=new I.DeferredPromise;return b.complete(),b}return E.expand=2,E.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var b;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const d=S.pop();if(!!d){(b=d.discoverCts)===null||b===void 0||b.dispose(!0),this.testIdToInternal.object.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const l of d.actual.children.values())S.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(ge[223],pe([0,1,28,3,8]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class y{constructor(i){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let C of i.activationEvents)C==="onUri"&&(C=`onUri:${_.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(i)}}keepOnly(i){const C=new Set;i.forEach(f=>C.add(_.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>C.has(_.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,C){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const f=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(f.map(g=>g.identifier)),C.length>0){const g=new Set;C.forEach(a=>g.add(_.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!g.has(_.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(f)}static _findLoopingExtensions(i){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,b){this.addNode(E),this.addNode(b),this._arcs.has(E)?this._arcs.get(E).push(b):this._arcs.set(E,[b])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,b){const S=C.getArcs(E);for(let d=0;d<S.length;d++)if(!b.has(S[d]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let E of i){const b=_.ExtensionIdentifier.toKey(E.identifier);if(f.set(b,E),E.extensionDependencies)for(let S of E.extensionDependencies){const d=_.ExtensionIdentifier.toKey(S);C.addArc(b,d)}}let g=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>g.add(E));let a=C.getNodes().filter(E=>!g.has(E)),u;do{u=!1;for(let E=0;E<a.length;E++){const b=a[E];C.hasOnlyGoodArcs(b,g)&&(a.splice(E,1),E--,g.add(b),u=!0)}}while(u);return a.map(E=>f.get(E))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const C=this._activationMap.get(i);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const C=this._extensionsMap.get(_.ExtensionIdentifier.toKey(i));return C||void 0}}e.ExtensionDescriptionRegistry=y;var P;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(P||(P={}));function D(k,i){const C=k.isBuiltin?0:k.isUnderDevelopment?2:1,f=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(C!==f)return C-f;const g=T.posix.basename(k.extensionLocation.path),a=T.posix.basename(i.extensionLocation.path);return g<a?-1:g>a?1:0}}),define(ge[224],pe([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function A(P){const D=_.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(ge[41],pe([0,1,3,2,4,28,184]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class P{constructor(S){this.dependency=S}}e.MissingDependencyError=P;var D;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,d,l,m){this.codeLoadingTime=S,this.activateCallTime=d,this.activateResolvedTime=l,this.activationReason=m}}e.ActivationTimes=k;class i{constructor(S,d){this.description=S,this.value=d}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var C;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function f(b){b.enableProposedApi||g(b)}e.checkProposedApiEnabled=f;function g(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=g;function a(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=a;function u(b){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!1,extensionLocation:b.location},b.manifest),{uuid:b.identifier.uuid})}e.toExtensionDescription=u;class E{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(S,d){}_activateById(S,d){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,d,l,m,t){}_onExtensionRuntimeError(S,d){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(ge[225],pe([0,1,161,28,41,14]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class P{constructor(u,E,b,S){this.startup=u,this.codeLoadingTime=E,this.activateCallTime=b,this.activateResolvedTime=S}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class D{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,E){return u===-1||E===-1?-1:E-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class k{constructor(u,E,b,S,d,l){this.activationFailed=u,this.activationFailedError=E,this.activationTimes=b,this.module=S,this.exports=d,this.subscriptions=l}}e.ActivatedExtension=k;class i extends k{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=i;class C extends k{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class f extends k{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=f;let g=class{constructor(u,E,b,S,d){this._logService=d,this._registry=u,this._resolvedExtensionsSet=new Set,E.forEach(l=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,b.forEach(l=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(l),l)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const E=I.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(E)}getActivatedExtension(u){const E=I.ExtensionIdentifier.toKey(u),b=this._activatedExtensions.get(E);if(!b)throw new Error("Extension `"+u.value+"` is not known or not activated");return b}activateByEvent(u,E){if(this._alreadyActivatedEvents[u])return y;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(b.map(S=>({id:S.identifier,reason:{startup:E,extensionId:S.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,E){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:b.identifier,reason:E}])}_handleActivateRequest(u,E,b){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(u.id))){E[I.ExtensionIdentifier.toKey(u.id)]=u;return}const S=this._registry.getExtensionDescription(u.id);if(!S){this._host.onExtensionActivationError(u.id,new T.MissingDependencyError(u.id.value));const m=new Error(`Unknown dependency '${u.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(u.id),new f(m));return}const d=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let l=!0;for(let m=0,t=d.length;m<t;m++){const n=d[m];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(n))){const s=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(n));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(S.identifier,_.localize(0,null,S.displayName||S.identifier.value,n));const c=new Error(`Dependency ${n} failed to activate`);c.detail=s.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new f(c));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n))){l=!1,E[I.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(n)),reason:u.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){l=!1,E[I.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:u.reason};continue}this._host.onExtensionActivationError(S.identifier,new T.MissingDependencyError(n));const o=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new f(o));return}}}l?E[I.ExtensionIdentifier.toKey(S.identifier)]=u:b.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(d=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(d.id))),u.length===0))return Promise.resolve(void 0);const E=Object.create(null),b=[];for(let d=0,l=u.length;d<l;d++)this._handleActivateRequest(u[d],E,b);for(let d=0,l=b.length;d<l;d++){const m=I.ExtensionIdentifier.toKey(b[d].id);E[m]&&delete E[m]}const S=Object.keys(E).map(d=>E[d]);return b.length===0?Promise.all(S.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(S).then(d=>this._activateExtensions(b))}_activateExtension(u,E){const b=I.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const S=this._activatingExtensions.get(b);if(S)return S;const d=this._host.actualActivateExtension(u,E).then(void 0,l=>(this._host.onExtensionActivationError(u,_.localize(1,null,u.value,l.message)),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(l),new f(l))).then(l=>{this._activatedExtensions.set(b,l),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,d),d}};g=Ve([xe(4,A.ILogService)],g),e.ExtensionsActivator=g}),define(ge[226],pe([0,1,14,41,27,12,113]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends _.LogService{constructor(k){if(k.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};P=Ve([xe(0,T.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[227],pe([0,1,18]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,_.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(ge[125],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const I=[];function T(P){const D=new _(!0,P);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=T;function A(P){const D=new _(!1,P);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(P){return I[P].sid}e.getStringIdentifierForProxy=y}),define(ge[5],pe([0,1,2,125,58]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var i;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var f;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(f=e.CandidatePortSource||(e.CandidatePortSource={}));var g;(function(l){l.name="$ident";function m(n,s){return Object.defineProperty(n,l.name,{value:s,enumerable:!0}),n}l.mixin=m;function t(n){return n[l.name]}l.of=t})(g=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(m){return m._id=a._n++,m}}e.IdObject=a,a._n=0;var u;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(l){if(l&&l.edits)for(const m of l.edits)typeof m.resource=="object"?m.resource=_.URI.revive(m.resource):(m.newUri=_.URI.revive(m.newUri),m.oldUri=_.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,T.revive)(m.metadata));return l}e.reviveWorkspaceEditDto=S;var d;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[90],pe([0,1,5,3,4]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,k){return this._proxy.$setPassword(P,D,k)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[63],pe([0,1,4,14,5,15]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(T.MainContext.MainThreadTelemetry)}report(D,k,i){const C=this.getUsageKey(D,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=Ve([xe(0,A.IExtHostRpcService),xe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,k){}})}),define(ge[228],pe([0,1,3,5,7,28]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,i,C={}){const f=A.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(f)||[],a=i.sort().join(" ");let u=g.find(E=>E.scopes===a);if(u)return u.result;{const E=this._getSession(D,f,k,i,C);u={scopes:a,result:E},g.push(u),this._inFlightRequests.set(f,g);try{await E}finally{const b=g.findIndex(S=>S.scopes===a);b>-1&&(g.splice(b),this._inFlightRequests.set(f,g))}return E}}async _getSession(D,k,i,C,f={}){await this._proxy.$ensureProvider(i);const g=D.displayName||D.name;return this._proxy.$getSession(i,C,k,g,f)}async removeSession(D,k){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,i,C){var f;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:i,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:k});const g=i.onDidChangeSessions(a=>{var u,E,b;this._proxy.$sendDidChangeSessions(D,{added:(u=a.added)!==null&&u!==void 0?u:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(b=a.removed)!==null&&b!==void 0?b:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(f=C==null?void 0:C.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new T.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(u=>u.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(i=>{this._providers.some(C=>C.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const C=this._providers.findIndex(f=>f.id===i.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ge[229],pe([0,1,5,15,20]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=T.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=Ve([xe(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ge[230],pe([0,1,5]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const y=A.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=I}),define(ge[51],pe([0,1,11,7,20,23,5,19,14,58,44,49,2,6,4,15]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new b(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===d.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,A.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return T.Range.to(r);if(C.Position.isIPosition(r))return T.Position.to(r);if(i.Range.isIRange(r.range)&&f.URI.isUri(r.uri))return T.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((c,p)=>{if(!c.validate(s[p]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${s[p]}`);return c.convert(s[p])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,A.cloneAndChange)(n,function(o){if(o instanceof I.Position)return T.Position.from(o);if(o instanceof I.Range)return T.Range.from(o);if(o instanceof I.Location)return T.location.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,s);return(0,k.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:o,description:c}=s;if(c)for(let p=0;p<c.args.length;p++)try{(0,_.validateConstraint)(n[p],c.args[p].constraint)}catch(v){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[p].name}' - ${c.args[p].description}`)}try{return await r.apply(o,n)}catch(p){if(t===this.converter.delegatingCommandId){const v=this.converter.getActualCommand(...n);v&&(t=v.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};E=Ve([xe(0,u.IExtHostRpcService),xe(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class b{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((o,c)=>o.convert(t.arguments&&t.arguments[c]));else if((0,P.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class S{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",m=>f.URI.isUri(m),m=>m),S.Position=new S("position","A position in a text document",m=>I.Position.isPosition(m),T.Position.from),S.Range=new S("range","A range in a text document",m=>I.Range.isRange(m),T.Range.from),S.Selection=new S("selection","A selection in a text document",m=>I.Selection.isSelection(m),T.Selection.from),S.Number=new S("number","",m=>typeof m=="number",m=>m),S.String=new S("string","",m=>typeof m=="string",m=>m),S.CallHierarchyItem=new S("item","A call hierarchy item",m=>m instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class d{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=d,d.Void=new d("no result",m=>m);class l{constructor(t,n,s,r,o){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=o}}e.ApiCommand=l}),define(ge[231],pe([0,1,6,20,7,80,51,203,19,110]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",f(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if(!(0,D.isFalsyOrEmpty)(a)){class E extends T.SymbolInformation{static to(S){const d=new E(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new T.Location(u[0],I.Range.to(S.range)));return d.detail=S.detail,d.range=d.location.range,d.selectionRange=I.Range.to(S.selectionRange),d.children=S.children?S.children.map(E.to):[],d}}return a.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>T.Position.isPosition(u)),a=>a.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(u=>{let E;for(const b of u.reverse())E=new T.SelectionRange(I.Range.to(b),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const u=[];if(Array.isArray(a))for(let E of a)u.push(...E[1].map(I.WorkspaceSymbol.to));return u})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,k.decodeSemanticTokensDto)(a);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,k.decodeSemanticTokensDto)(a);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,u,E)=>{if(!a)return new T.CompletionList([]);const b=a.suggestions.map(S=>I.CompletionItem.to(S,E));return new T.CompletionList(b,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,u,E)=>f(b=>new T.CodeLens(I.Range.to(b.range),b.command&&E.fromInternal(b.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>T.Range.isRange(a),a=>T.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,u,E)=>f(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(b.command)}else{const S=new T.CodeAction(b.title,b.kind?new T.CodeActionKind(b.kind):void 0);return b.edit&&(S.edit=I.WorkspaceEdit.to(b.edit)),b.command&&(S.command=E.fromInternal(b.command)),S.isPreferred=b.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new T.ColorInformation(I.Range.to(u.range),I.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof T.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>I.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class C{constructor(u){this._disposables=new _.DisposableStore,this._commands=u}static register(u){return i.forEach(u.registerApiCommand,u),new C(u).registerCommands()}registerCommands(){const u=E=>(...b)=>E(this._commands,...b);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,u(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(P.OpenIssueReporter.ID,u(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(u,E,b){const S=this._commands.registerCommand(!1,u,E,this,b);this._disposables.add(S)}}e.ExtHostApiCommands=C;function f(a){return u=>{if(Array.isArray(u))return u.map(a)}}function g(a){if(!!Array.isArray(a)){const u=[];for(const E of a)A.isLocationLink(E)?u.push(I.DefinitionLink.to(E)):u.push(I.location.to(E));return u}}}),define(ge[232],pe([0,1,13,70,3,6,2,80,28,20,7,5]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(l,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,c=r.getCommentByUniqueId(o);return c||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,c=n.commentUniqueId,p=r.getCommentByUniqueId(c);return p?(p.body=o,p):n}return n}})}createCommentController(l,m,t){const n=f.handlePool++,s=new a(l,n,this._proxy,m,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(l.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(l.identifier),r),s}$createCommentThreadTemplate(l,m,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(l,m,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(l,m){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(l,m,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(m));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(o=>k.Range.from(o)):void 0)}$toggleReaction(l,m,t,n,s){const r=this._commentControllers.get(l);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const o=r.getCommentThread(m);if(o){const c=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&c&&r.reactionHandler)return r.reactionHandler(c,b(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class g{constructor(l,m,t,n,s,r,o){this._proxy=l,this._commentController=m,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};l("range")&&(m.range=k.Range.from(this._range)),l("label")&&(m.label=this.label),l("contextValue")&&(m.contextValue=this.contextValue),l("comments")&&(m.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(m.collapseState=S(this._collapseState)),l("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}}getCommentByUniqueId(l){for(let m of this._commentsMap){let t=m[0],n=m[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,Ve([(0,I.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class a{constructor(l,m,t,n,s){this._extension=l,this._handle=m,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,m,t,n){if(typeof l=="string"){const s=new g(this._proxy,this,l,m,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new g(this._proxy,this,void 0,l,m,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(l,m){const t=new g(this._proxy,this,void 0,y.URI.revive(l),k.Range.to(m),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,m){let t=this._threads.get(l);t&&(t.range=k.Range.to(m))}$deleteCommentThread(l){let m=this._threads.get(l);m&&m.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(d,l,m,t){let n=t.get(m);n||(n=++d.commentHandle,t.set(m,n));const s=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(m.body),userName:m.author.name,userIconPath:s,label:m.label,commentReactions:m.reactions?m.reactions.map(r=>E(r)):void 0}}function E(d){return{label:d.label,iconPath:d.iconPath?k.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function b(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?y.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function S(d){if(d!==void 0)switch(d){case i.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[126],pe([0,1,2,5,7,4,15,14,19,9,8]),function(G,e,_,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class En{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const u=En._handlePool++;this._provider.set(u,{provider:g,extensionId:a}),this._proxy.$registerDecorationProvider(u,a.value);const E=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(u,null);return}let S=(0,D.asArray)(b);if(S.length<=En._maxEventSize){this._proxy.$onDidChange(u,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,S.length);const d=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),l=(0,D.groupBy)(d,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let m=[];e:for(let t of l){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,m.push(s.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(u,m)});return new T.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(g,a,u){if(!this._provider.has(g))return Object.create(null);const E=Object.create(null),{provider:b,extensionId:S}=this._provider.get(g);return await Promise.all(a.map(async d=>{try{const{uri:l,id:m}=d,t=await Promise.resolve(b.provideFileDecoration(_.URI.revive(l),u));if(!t)return;try{T.FileDecoration.validate(t),E[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(l){this._logService.error(l)}})),E}};C._handlePool=0,C._maxEventSize=250,C=Ve([xe(0,y.IExtHostRpcService),xe(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ge[233],pe([0,1,160,114,2,5,7,20,3,14,24]),function(G,e,_,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,u,E,b,S){this._name=a,this._owner=u,this._maxDiagnosticsPerFile=E,this._proxy=b,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,u){if(!a){this.clear();return}this._checkDisposed();let E=[];if(T.URI.isUri(a)){if(!u){this.delete(a);return}this._data.set(a,u.slice()),E=[a]}else if(Array.isArray(a)){E=[];let S;a=[...a].sort(C._compareIndexedTuplesByUri);for(const d of a){const[l,m]=d;if((!S||l.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=l,E.push(l),this._data.set(l,[])),m){const t=this._data.get(l);t&&t.push(...m)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const b=[];for(let S of E){let d=[];const l=this._data.get(S);if(l)if(l.length>this._maxDiagnosticsPerFile){d=[];const m=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===m[t]&&d.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;d.push({severity:I.MarkerSeverity.Info,message:(0,_.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=l.map(m=>P.Diagnostic.from(m));b.push([S,d])}this._proxy.$changeMany(this._owner,b)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,u){this._checkDisposed();for(let E of this._data.keys())a.apply(u,[E,this.get(E),this])}get(a){this._checkDisposed();const u=this._data.get(a);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,u){return a[0].toString()<u[0].toString()?-1:a[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=C;let f=class jt{constructor(a,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(a,u){return a?a.concat(u):u}static _mapper(a){const u=[],E=new Set;for(const b of a)typeof b=="string"?E.has(b)||(E.add(b),u.push(T.URI.parse(b))):E.has(b.toString())||(E.add(b.toString()),u.push(b));return Object.freeze(u),{uris:u}}createDiagnosticCollection(a,u){const{_collections:E,_proxy:b,_onDidChangeDiagnostics:S,_logService:d}=this,l=new class{$changeMany(n,s){b.$changeMany(n,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){b.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){b.dispose()}};let m;if(!u)u="_generated_diagnostic_collection_name_#"+jt._idPool++,m=u;else if(!E.has(u))m=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do m=u+jt._idPool++;while(E.has(m))}return new class extends C{constructor(){super(u,m,jt._maxDiagnosticsPerFile,l,S);E.set(m,this)}dispose(){super.dispose(),E.delete(m)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const u=new Map,E=[];for(const b of this._collections.values())b.forEach((S,d)=>{let l=u.get(S.toString());typeof l=="undefined"&&(l=E.length,u.set(S.toString(),l),E.push([S,[]])),E[l][1]=E[l][1].concat(...d)});return E}}_getDiagnostics(a){let u=[];for(let E of this._collections.values())E.has(a)&&(u=u.concat(E.get(a)));return u}$acceptMarkersChange(a){if(!this._mirrorCollection){const u="_generated_mirror",E=new C(u,u,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,E),this._mirrorCollection=E}for(const[u,E]of a)this._mirrorCollection.set(T.URI.revive(u),E.map(P.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=Ve([xe(1,k.ILogService)],f),e.ExtHostDiagnostics=f}),define(ge[234],pe([0,1,2,5]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(D=>_.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?_.URI.revive(P):void 0)}}e.ExtHostDialogs=T}),define(ge[235],pe([0,1,18,2,7,5,12,21,9]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,f,g){this._documentsAndEditors=f,this._logService=g,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,f){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,f),this._proxy.$registerTextContentProvider(g,C);let a;return typeof f.onDidChange=="function"&&(a=f.onDidChange(u=>{if(u.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(g,u).then(E=>{if(!(!E&&typeof E!="string")){const b=this._documentsAndEditors.getDocument(u);if(!!b){const S=(0,D.splitLines)(E);if(!b.equalLines(S))return this._proxy.$onVirtualDocumentChange(u,E)}}},_.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,f){const g=this._documentContentProviders.get(C);return g?Promise.resolve(g.provideTextDocumentContent(I.URI.revive(f),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ge[236],pe([0,1,3,6,2,5,120,20,11,23]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(f,g){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const u of a)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const u of a)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const g=this._documentsAndEditors.getDocument(f);if(g)return g}}getDocument(f){const g=this.getDocumentData(f);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return g.document}ensureDocumentData(f){const g=this._documentsAndEditors.getDocument(f);if(g)return Promise.resolve(g);let a=this._documentLoader.get(f.toString());return a||(a=this._proxy.$tryOpenDocument(f).then(u=>{this._documentLoader.delete(f.toString());const E=T.URI.revive(u);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},u=>(this._documentLoader.delete(f.toString()),Promise.reject(u))),this._documentLoader.set(f.toString(),a)),a}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(g=>T.URI.revive(g))}$acceptModelModeChanged(f,g){const a=T.URI.revive(f),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(g),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(f){const g=T.URI.revive(f),a=this._documentsAndEditors.getDocument(g);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(f,g){const a=T.URI.revive(f),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(g),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(f,g,a){const u=T.URI.revive(f),E=this._documentsAndEditors.getDocument(u);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:E.document,contentChanges:g.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text}))}))}setWordDefinitionFor(f,g){(0,y.setWordDefinitionFor)(f,g)}}e.ExtHostDocuments=i}),define(ge[39],pe([0,1,52,3,6,2,4,5,120,15,124,20,14,24,12,54,134]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(l,m){this._extHostRpc=l,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const m=[],t=[],n=[];if(l.removedDocuments)for(const s of l.removedDocuments){const r=A.URI.revive(s),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),m.push(o.value))}if(l.addedDocuments)for(const s of l.addedDocuments){const r=A.URI.revive(s.uri);let o=this._documents.get(r);if(o&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new b(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(l.removedEditors)for(const s of l.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(l.addedEditors)for(const s of l.addedEditors){const r=A.URI.revive(s.documentUri);_.ok(this._documents.has(r),`document '${r}' does not exist`),_.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(r).value,c=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(p=>C.Range.to(p)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,c)}l.newActiveEditor!==void 0&&(_.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,T.dispose)(m),(0,T.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(m),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var m;return(m=this._documents.get(l))===null||m===void 0?void 0:m.value}allDocuments(){return u.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const m=this._editors.get(this._activeEditorId);return l?m:m==null?void 0:m.value}}allEditors(){return[...this._editors.values()]}};S=Ve([xe(0,k.IExtHostRpcService),xe(1,f.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[237],pe([0,1,2,5,6,7,20,142,9,22]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const a=this._schemes.indexOf(g);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),a=[];let u,E,b=14,S=14;for(const d of g){let l=u?(0,D.commonPrefixLength)(u,d):0;for(l===0?E=1:E=S;l<d.length;l++)l+1===d.length?(b=S,S=9):S+=1,a.push([E,d.toUpperCase().charCodeAt(l),S]),a.push([E,d.toLowerCase().charCodeAt(l),S]),E=S;u=d,S=b}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(g){this._initStateMachine();const a=[],u=P.LinkComputer.computeLinks({getLineContent(E){return g.lineAt(E-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const E of u){const b=y.DocumentLink.to(E);b.target&&a.push(b)}return a}}class C{constructor(g,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,a,u,E={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(b,u);let S=2;E.isCaseSensitive&&(S+=1024),E.isReadonly&&(S+=2048),typeof u.copy=="function"&&(S+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(b,a,S).catch(l=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${a}`),console.error(l)});const d=u.onDidChangeFile(l=>{const m=[];for(const t of l){let{uri:n,type:s}=t;if(n.scheme===a){let r;switch(s){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}m.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(b,m)});return(0,T.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(g){const{type:a,ctime:u,mtime:E,size:b}=g;return{type:a,ctime:u,mtime:E,size:b}}$stat(g,a){return Promise.resolve(this._getFsProvider(g).stat(_.URI.revive(a))).then(C._asIStat)}$readdir(g,a){return Promise.resolve(this._getFsProvider(g).readDirectory(_.URI.revive(a)))}$readFile(g,a){return Promise.resolve(this._getFsProvider(g).readFile(_.URI.revive(a))).then(u=>k.VSBuffer.wrap(u))}$writeFile(g,a,u,E){return Promise.resolve(this._getFsProvider(g).writeFile(_.URI.revive(a),u.buffer,E))}$delete(g,a,u){return Promise.resolve(this._getFsProvider(g).delete(_.URI.revive(a),u))}$rename(g,a,u,E){return Promise.resolve(this._getFsProvider(g).rename(_.URI.revive(a),_.URI.revive(u),E))}$copy(g,a,u,E){const b=this._getFsProvider(g);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(_.URI.revive(a),_.URI.revive(u),E))}$mkdir(g,a){return Promise.resolve(this._getFsProvider(g).createDirectory(_.URI.revive(a)))}$watch(g,a,u,E){const b=this._getFsProvider(g).watch(_.URI.revive(u),E);this._watches.set(a,b)}$unwatch(g,a){const u=this._watches.get(a);u&&(u.dispose(),this._watches.delete(a))}$open(g,a,u){const E=this._getFsProvider(g);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(_.URI.revive(a),u))}$close(g,a){const u=this._getFsProvider(g);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(a))}$read(g,a,u,E){const b=this._getFsProvider(g);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(E);return Promise.resolve(b.read(a,u,S.buffer,0,E)).then(d=>S.slice(0,d))}$write(g,a,u,E){const b=this._getFsProvider(g);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(a,u,E.buffer,0,E.byteLength))}_getFsProvider(g){const a=this._fsProvider.get(g);if(!a){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return a}}e.ExtHostFileSystem=C}),define(ge[91],pe([0,1,5,45,7,22,4,15,61]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ot{constructor(C,f){const g=C.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return g.$stat(a).catch(Ot._handleError)},readDirectory(a){return g.$readdir(a).catch(Ot._handleError)},createDirectory(a){return g.$mkdir(a).catch(Ot._handleError)},async readFile(a){return g.$readFile(a).then(u=>u.buffer).catch(Ot._handleError)},writeFile(a,u){return g.$writeFile(a,A.VSBuffer.wrap(u)).catch(Ot._handleError)},delete(a,u){return g.$delete(a,Object.assign({recursive:!1,useTrash:!1},u)).catch(Ot._handleError)},rename(a,u,E){return g.$rename(a,u,Object.assign({overwrite:!1},E)).catch(Ot._handleError)},copy(a,u,E){return g.$copy(a,u,Object.assign({overwrite:!1},E)).catch(Ot._handleError)},isWritableFileSystem(a){const u=f.getCapabilities(a);if(typeof u=="number")return!(u&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};k=Ve([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,6,5]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=T}),define(ge[239],pe([0,1,2,23,20,7,13,5,9,44,19,11,139,6,110,72,86,47,18]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(le=>{if(!(0,i.isFalsyOrEmpty)(le))return le[0]instanceof A.DocumentSymbol?le.map(T.DocumentSymbol.from):d._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((me,De)=>{let Oe=me.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(me.location.range.end)),Oe});const ee=[],le=[];for(const me of z){const De={name:me.name||"!!MISSING: name!!",kind:T.SymbolKind.from(me.kind),tags:((Y=me.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:T.Range.from(me.location.range),selectionRange:T.Range.from(me.location.range),children:[]};for(;;){if(le.length===0){le.push(De),ee.push(De);break}const Oe=le[le.length-1];if(k.Range.containsRange(Oe.range,De.range)&&!k.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),le.push(De);break}le.pop()}}return ee}}class l{constructor(z,Y,ee){this._documents=z,this._commands=Y,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const ee=this._documents.getDocument(z),le=await this._provider.provideCodeLenses(ee,Y);if(!(!le||Y.isCancellationRequested)){const me=this._cache.add(le),De=new g.DisposableStore;this._disposables.set(me,De);const Oe={cacheId:me,lenses:[]};for(let we=0;we<le.length;we++)Oe.lenses.push({cacheId:[me,we],range:T.Range.from(le[we].range),command:this._commands.toInternal(le[we].command,De)});return Oe}}async resolveCodeLens(z,Y){var ee;const le=z.cacheId&&this._cache.get(...z.cacheId);if(!!le){let me;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?me=le:me=await this._provider.resolveCodeLens(le,Y),me||(me=le),!Y.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((ee=me.command)!==null&&ee!==void 0?ee:l._badCmd,De),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function m(Le){return Array.isArray(Le)?Le.map(T.DefinitionLink.from):Le?[T.DefinitionLink.from(Le)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(le,me,ee)).then(m)}}class n{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(le,me,ee)).then(m)}}class s{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(le,me,ee)).then(m)}}class r{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(le,me,ee)).then(m)}}class o{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(le,me,ee)).then(De=>{if(!(!De||(0,i.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=le.getWordRangeAtPosition(me)),De.range||(De.range=new A.Range(me,me)),T.Hover.from(De)})}}class c{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(le,me,ee)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class p{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,ee,le){const me=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineValues(me,T.Range.to(Y),T.InlineValueContext.to(ee),le)).then(De=>{if(Array.isArray(De))return De.map(Oe=>T.InlineValue.from(Oe))})}}class v{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(le,me,ee)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class h{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,me,ee)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,i.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class w{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(me,De,ee,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class R{constructor(z,Y,ee,le,me,De,Oe){this._documents=z,this._commands=Y,this._diagnostics=ee,this._provider=le,this._logService=me,this._extension=De,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,ee,le){const me=this._documents.getDocument(z),De=f.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Oe=[];for(const Pe of this._diagnostics.getDiagnostics(z))if(De.intersection(Pe.range)&&Oe.push(Pe)>R._maxCodeActionsPerFile)break;const we={diagnostics:Oe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(me,De,we,le)).then(Pe=>{var Re;if(!(!(0,i.isNonEmptyArray)(Pe)||le.isCancellationRequested)){const Be=this._cache.add(Pe),Se=new g.DisposableStore;this._disposables.set(Be,Se);const qe=[];for(let X=0;X<Pe.length;X++){const ie=Pe[X];!ie||(R._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(we.only&&(ie.kind?we.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(T.Diagnostic.from),edit:ie.edit&&T.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Re=ie.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction(z,Y){var ee;const[le,me]=z,De=this._cache.get(le,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(De,Y))!==null&&ee!==void 0?ee:De;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class N{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,Y,ee)).then(me=>{if(Array.isArray(me))return me.map(T.TextEdit.from)})}}class j{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,ee,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class re{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,ee,le,me){const De=this._documents.getDocument(z),Oe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,ee,le,me)).then(we=>{if(Array.isArray(we))return we.map(T.TextEdit.from)})}}class V{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const ee=P.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(le=>{if((0,i.isNonEmptyArray)(le)){for(const me of le)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=P.IdObject.mixin(T.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),ee.symbols.push(De)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const ee=this._symbolCache.get(z._id);if(ee){const le=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return le&&(0,I.mixin)(z,T.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[ee,le]=Y;ee<=le;ee++)this._symbolCache.delete(ee);this._resultCache.delete(z)}}}class W{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(me,De,ee,le)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const we=W._asMessage(Oe);return we?{rejectReason:we,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(z,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(le,me,ee)).then(De=>{let Oe,we;if(A.Range.isRange(De)?(Oe=De,we=le.getText(De)):(0,C.isObject)(De)&&(Oe=De.range,we=De.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:we}}},De=>{const Oe=W._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Y){this.resultId=z,this.tokens=Y}}class U{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,ee){const le=this._documents.getDocument(z),me=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,me.resultId,ee):this._provider.provideDocumentSemanticTokens(le,ee)).then(De=>(me&&this._previousResults.delete(Y),De?(De=U._fixProvidedSemanticTokens(De),this._send(U._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(Y=>new A.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!U._isSemanticTokens(Y)||!z||!z.tokens)return Y;const ee=z.tokens,le=ee.length,me=Y.data,De=me.length;let Oe=0;const we=Math.min(le,De);for(;Oe<we&&ee[Oe]===me[Oe];)Oe++;if(Oe===le&&Oe===De)return new A.SemanticTokensEdits([],Y.resultId);let Pe=0;const Re=we-Oe;for(;Pe<Re&&ee[le-Pe-1]===me[De-Pe-1];)Pe++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Pe,data:me.subarray(Oe,De-Pe)}],Y.resultId)}_send(z,Y){if(U._isSemanticTokens(z)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(z.resultId,z.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const ee=this._nextResultId++;return U._isSemanticTokens(Y)?this._previousResults.set(ee,new $(Y.resultId,Y.data)):this._previousResults.set(ee,new $(z.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(z.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class F{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,T.Range.to(Y),ee)).then(me=>me?this._send(me):null)}_send(z){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=F;class M{constructor(z,Y,ee,le,me){this._documents=z,this._commands=Y,this._provider=ee,this._apiDeprecation=le,this._extension=me,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y),Oe=me.getWordRangeAtPosition(De)||new A.Range(De,De),we=Oe.with({end:De}),Pe=new b.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(me,De,le,T.CompletionContext.to(ee)));if(!!Re&&!le.isCancellationRequested){const Be=Array.isArray(Re)?new A.CompletionList(Re):Re,Se=M.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new g.DisposableStore;this._disposables.set(Se,qe);const X=[],ie={x:Se,b:X,a:{replace:T.Range.from(Oe),insert:T.Range.from(we)},c:Be.isIncomplete||void 0,d:Pe.elapsed()};for(let _e=0;_e<Be.items.length;_e++){const Ne=Be.items[_e],ze=this._convertCompletionItem(Ne,[Se,_e],we,Oe);X.push(ze)}return ie}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...z);if(!!ee){const le=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!le)return this._convertCompletionItem(le,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,ee,le){var me;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(me=z.label)!==null&&me!==void 0?me:"",o:z.label2,b:z.kind!==void 0?T.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(T.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof A.SnippetString&&(Oe.h=z.insertText.value,Oe.i|=4);let we;return z.textEdit?we=z.textEdit.range:z.range&&(we=z.range),A.Range.isRange(we)?Oe.j=T.Range.from(we):we&&(!(ee==null?void 0:ee.isEqual(we.inserting))||!(le==null?void 0:le.isEqual(we.replacing)))&&(Oe.j={insert:T.Range.from(we.inserting),replace:T.Range.from(we.replacing)}),Oe}}class L{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y),Oe=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(me,De,le,Oe)).then(we=>{if(we){const Pe=this._cache.add([we]);return Object.assign(Object.assign({},T.SignatureHelp.from(we)),{id:Pe})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const ee=T.SignatureHelp.to(z.activeSignatureHelp),le=this._cache.get(z.activeSignatureHelp.id,0);le?(Y=le,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineHints(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineHints(le,T.Range.to(Y),ee)).then(me=>me?{hints:me.map(T.InlineHint.from)}:void 0)}}class B{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("DocumentLink")}provideLinks(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(T.DocumentLink.from)};{const me=this._cache.add(le),De={links:[],id:me};for(let Oe=0;Oe<le.length;Oe++){const we=T.DocumentLink.from(le[Oe]);we.cacheId=[me,Oe],De.links.push(we)}return De}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...z);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(le=>le&&T.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(le=>Array.isArray(le)?le.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(z,Y,ee){const le=this._documents.getDocument(z),me=T.Range.to(Y.range),De=T.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(De,{document:le,range:me},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class Q{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(le,Y,ee)).then(me=>{if(!!Array.isArray(me))return me.map(T.FoldingRange.from)})}}class de{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}provideSelectionRanges(z,Y,ee){const le=this._documents.getDocument(z),me=Y.map(T.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(le,me,ee)).then(De=>{if(!(0,i.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let we=0;we<me.length;we++){const Pe=[];Oe.push(Pe);let Re=me[we],Be=De[we];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(T.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Oe})}}class be{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y),De=await this._provider.prepareCallHierarchy(le,me,ee);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(we=>this._cacheAndConvertItem(Oe,we)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(z,Y,ee){const le=this._itemFromCache(z,Y);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(le,ee);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(z,Y,ee){const le=this._itemFromCache(z,Y);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(le,ee);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var ee;const le=this._cache.get(z),me={_sessionId:z,_itemId:le.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return le.set(me._itemId,Y),me}_itemFromCache(z,Y){const ee=this._cache.get(z);return ee==null?void 0:ee.get(Y)}}class Ae{constructor(z,Y){this.adapter=z,this.extension=Y}}class Ce{constructor(z,Y,ee,le,me,De,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=le,this._diagnostics=me,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(z){return(0,i.coalesce)((0,i.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:T.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ce._handlePool++}_withAdapter(z,Y,ee,le,me=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(le);if(De.adapter instanceof Y){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const we=ee(De.adapter,De.extension),Pe=De.extension;return Pe&&Promise.resolve(we).then(()=>this._logService.trace(`[${Pe.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{me&&Re instanceof S.CancellationError||(this._logService.error(`[${Pe.identifier.value}] provider FAILED`),this._logService.error(Re))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ae(z,Y)),ee}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,ee,le){const me=this._addNewAdapter(new d(this._documents,ee),z),De=le&&le.label||Ce._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(Y),De),this._createDisposable(me)}$provideDocumentSymbols(z,Y,ee){return this._withAdapter(z,d,le=>le.provideDocumentSymbols(_.URI.revive(Y),ee),void 0)}registerCodeLensProvider(z,Y,ee){const le=this._nextHandle(),me=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ae(new l(this._documents,this._commands.converter,ee),z)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Y),me);let De=this._createDisposable(le);if(me!==void 0){const Oe=ee.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideCodeLenses(z,Y,ee){return this._withAdapter(z,l,le=>le.provideCodeLenses(_.URI.revive(Y),ee),void 0)}$resolveCodeLens(z,Y,ee){return this._withAdapter(z,l,le=>le.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,l,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,ee){const le=this._addNewAdapter(new t(this._documents,ee),z);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDefinition(z,Y,ee,le){return this._withAdapter(z,t,me=>me.provideDefinition(_.URI.revive(Y),ee,le),[])}registerDeclarationProvider(z,Y,ee){const le=this._addNewAdapter(new n(this._documents,ee),z);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDeclaration(z,Y,ee,le){return this._withAdapter(z,n,me=>me.provideDeclaration(_.URI.revive(Y),ee,le),[])}registerImplementationProvider(z,Y,ee){const le=this._addNewAdapter(new s(this._documents,ee),z);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideImplementation(z,Y,ee,le){return this._withAdapter(z,s,me=>me.provideImplementation(_.URI.revive(Y),ee,le),[])}registerTypeDefinitionProvider(z,Y,ee){const le=this._addNewAdapter(new r(this._documents,ee),z);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideTypeDefinition(z,Y,ee,le){return this._withAdapter(z,r,me=>me.provideTypeDefinition(_.URI.revive(Y),ee,le),[])}registerHoverProvider(z,Y,ee,le){const me=this._addNewAdapter(new o(this._documents,ee),z);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideHover(z,Y,ee,le){return this._withAdapter(z,o,me=>me.provideHover(_.URI.revive(Y),ee,le),void 0)}registerEvaluatableExpressionProvider(z,Y,ee,le){const me=this._addNewAdapter(new c(this._documents,ee),z);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideEvaluatableExpression(z,Y,ee,le){return this._withAdapter(z,c,me=>me.provideEvaluatableExpression(_.URI.revive(Y),ee,le),void 0)}registerInlineValuesProvider(z,Y,ee,le){const me=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new p(this._documents,ee),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),me);let Oe=this._createDisposable(De);if(me!==void 0){const we=ee.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(me));Oe=A.Disposable.from(Oe,we)}return Oe}$provideInlineValues(z,Y,ee,le,me){return this._withAdapter(z,p,De=>De.provideInlineValues(_.URI.revive(Y),ee,le,me),void 0)}registerDocumentHighlightProvider(z,Y,ee){const le=this._addNewAdapter(new v(this._documents,ee),z);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDocumentHighlights(z,Y,ee,le){return this._withAdapter(z,v,me=>me.provideDocumentHighlights(_.URI.revive(Y),ee,le),void 0)}registerLinkedEditingRangeProvider(z,Y,ee){const le=this._addNewAdapter(new h(this._documents,ee),z);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideLinkedEditingRanges(z,Y,ee,le){return this._withAdapter(z,h,async me=>{const De=await me.provideLinkedEditingRanges(_.URI.revive(Y),ee,le);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ce._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,ee){const le=this._addNewAdapter(new w(this._documents,ee),z);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideReferences(z,Y,ee,le,me){return this._withAdapter(z,w,De=>De.provideReferences(_.URI.revive(Y),ee,le,me),void 0)}registerCodeActionProvider(z,Y,ee,le){var me,De;const Oe=new g.DisposableStore,we=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(Y),{providedKinds:(me=le==null?void 0:le.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Pe=>Pe.value),documentation:(De=le==null?void 0:le.documentation)===null||De===void 0?void 0:De.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,Oe)}))},Ce._extLabel(z),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(we)),Oe}$provideCodeActions(z,Y,ee,le,me){return this._withAdapter(z,R,De=>De.provideCodeActions(_.URI.revive(Y),ee,le,me),void 0)}$resolveCodeAction(z,Y,ee){return this._withAdapter(z,R,le=>le.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,R,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,ee){const le=this._addNewAdapter(new N(this._documents,ee),z);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentFormattingEdits(z,Y,ee,le){return this._withAdapter(z,N,me=>me.provideDocumentFormattingEdits(_.URI.revive(Y),ee,le),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,ee){const le=this._addNewAdapter(new j(this._documents,ee),z);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(z,Y,ee,le,me){return this._withAdapter(z,j,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(Y),ee,le,me),void 0)}registerOnTypeFormattingEditProvider(z,Y,ee,le){const me=this._addNewAdapter(new re(this._documents,ee),z);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(Y),le,z.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(z,Y,ee,le,me,De){return this._withAdapter(z,re,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(Y),ee,le,me,De),void 0)}registerWorkspaceSymbolProvider(z,Y){const ee=this._addNewAdapter(new V(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(z,Y,ee){return this._withAdapter(z,V,le=>le.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,ee){return this._withAdapter(z,V,le=>le.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,V,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,ee){const le=this._addNewAdapter(new W(this._documents,ee,this._logService),z);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Y),W.supportsResolving(ee)),this._createDisposable(le)}$provideRenameEdits(z,Y,ee,le,me){return this._withAdapter(z,W,De=>De.provideRenameEdits(_.URI.revive(Y),ee,le,me),void 0)}$resolveRenameLocation(z,Y,ee,le){return this._withAdapter(z,W,me=>me.resolveRenameLocation(_.URI.revive(Y),ee,le),void 0)}registerDocumentSemanticTokensProvider(z,Y,ee,le){const me=this._nextHandle(),De=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Ae(new U(this._documents,ee),z)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(Y),le,De);let Oe=this._createDisposable(me);if(De){const we=ee.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=A.Disposable.from(Oe,we)}return Oe}$provideDocumentSemanticTokens(z,Y,ee,le){return this._withAdapter(z,U,me=>me.provideDocumentSemanticTokens(_.URI.revive(Y),ee,le),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,U,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,ee,le){const me=this._addNewAdapter(new F(this._documents,ee),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(Y),le),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(z,Y,ee,le){return this._withAdapter(z,F,me=>me.provideDocumentRangeSemanticTokens(_.URI.revive(Y),ee,le),null,!0)}registerCompletionItemProvider(z,Y,ee,le){const me=this._addNewAdapter(new M(this._documents,this._commands.converter,ee,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(Y),le,M.supportsResolving(ee),`${z.identifier.value}(${le.join("")})`),this._createDisposable(me)}$provideCompletionItems(z,Y,ee,le,me){return this._withAdapter(z,M,De=>De.provideCompletionItems(_.URI.revive(Y),ee,le,me),void 0)}$resolveCompletionItem(z,Y,ee){return this._withAdapter(z,M,le=>le.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,M,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,ee,le){const me=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,De=this._addNewAdapter(new L(this._documents,ee),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),me),this._createDisposable(De)}$provideSignatureHelp(z,Y,ee,le,me){return this._withAdapter(z,L,De=>De.provideSignatureHelp(_.URI.revive(Y),ee,le,me),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,L,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(z,Y,ee){const le=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new O(this._documents,ee),z);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(Y),le);let De=this._createDisposable(me);if(le!==void 0){const Oe=ee.onDidChangeInlineHints(we=>this._proxy.$emitInlineHintsEvent(le));De=A.Disposable.from(De,Oe)}return De}$provideInlineHints(z,Y,ee,le){return this._withAdapter(z,O,me=>me.provideInlineHints(_.URI.revive(Y),ee,le),void 0)}registerDocumentLinkProvider(z,Y,ee){const le=this._addNewAdapter(new B(this._documents,ee),z);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(z,Y,ee){return this._withAdapter(z,B,le=>le.provideLinks(_.URI.revive(Y),ee),void 0)}$resolveDocumentLink(z,Y,ee){return this._withAdapter(z,B,le=>le.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,B,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(z,Y,ee){const le=this._addNewAdapter(new q(this._documents,ee),z);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDocumentColors(z,Y,ee){return this._withAdapter(z,q,le=>le.provideColors(_.URI.revive(Y),ee),[])}$provideColorPresentations(z,Y,ee,le){return this._withAdapter(z,q,me=>me.provideColorPresentations(_.URI.revive(Y),ee,le),void 0)}registerFoldingRangeProvider(z,Y,ee){const le=this._nextHandle(),me=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ae(new Q(this._documents,ee),z)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Y),me);let De=this._createDisposable(le);if(me!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideFoldingRanges(z,Y,ee,le){return this._withAdapter(z,Q,me=>me.provideFoldingRanges(_.URI.revive(Y),ee,le),void 0)}registerSelectionRangeProvider(z,Y,ee){const le=this._addNewAdapter(new de(this._documents,ee,this._logService),z);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideSelectionRanges(z,Y,ee,le){return this._withAdapter(z,de,me=>me.provideSelectionRanges(_.URI.revive(Y),ee,le),[])}registerCallHierarchyProvider(z,Y,ee){const le=this._addNewAdapter(new be(this._documents,ee),z);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$prepareCallHierarchy(z,Y,ee,le){return this._withAdapter(z,be,me=>Promise.resolve(me.prepareSession(_.URI.revive(Y),ee,le)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,ee,le){return this._withAdapter(z,be,me=>me.provideCallsTo(Y,ee,le),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,ee,le){return this._withAdapter(z,be,me=>me.provideCallsFrom(Y,ee,le),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,be,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ce._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ce._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ce._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ce._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ce._serializeRegExp(z.beforeText),afterText:z.afterText?Ce._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ce._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ce._serializeOnEnterRule)}setLanguageConfiguration(z,Y,ee){let{wordPattern:le}=ee;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Y,le):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const me=this._nextHandle(),De={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Ce._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Ce._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Ce._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,Y,De),this._createDisposable(me)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ce,Ce._handlePool=0}),define(ge[240],pe([0,1,5,20,7]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(P,D){this._proxy=P.getProxy(_.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,D){var k;const i=P.version,C=I.Position.from(D),f=await this._proxy.$tokensAtPosition(P.uri,C),g={type:T.StandardTokenType.Other,range:(k=P.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new T.Range(D.line,D.character,D.line,D.character)};if(!f)return g;const a={range:I.Range.to(f.range),type:I.TokenType.to(f.type)};return!a.range.contains(D)||i!==P.version?g:a}}e.ExtHostLanguages=A}),define(ge[241],pe([0,1,5,14,41]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(_.MainContext.MainThreadMessageService)}showMessage(D,k,i,C,f){const g={extension:D};let a;typeof C=="string"||A(C)?a=[C,...f]:(g.modal=C&&C.modal,g.useCustom=C&&C.useCustom,a=f),g.useCustom&&(0,T.checkProposedApiEnabled)(D);const u=[];for(let E=0;E<a.length;E++){const b=a[E];if(typeof b=="string")u.push({title:b,handle:E,isCloseAffordance:!1});else if(typeof b=="object"){let{title:S,isCloseAffordance:d}=b;u.push({title:S,isCloseAffordance:!!d,handle:E})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(k,i,g,u).then(E=>{if(typeof E=="number")return a[E]})}};y=Ve([xe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(ge[242],pe([0,1,13,22,21,3,74,72,6,24,9,11,2,86,5,20,7,89,218,219]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class l{constructor(o,c){const p=l._Keys.nextId();o.$registerNotebookEditorDecorationType(p,u.NotebookDecorationRenderOptions.from(c)),this.value={key:p,dispose(){o.$removeNotebookEditorDecorationType(p)}}}}e.NotebookEditorDecorationType=l,l._Keys=new P.IdGenerator("NotebookEditorDecorationType");class m{constructor(o,c,p,v,h,w){this._textDocumentsAndEditors=p,this._textDocuments=v,this.logService=h,this._extensionStoragePaths=w,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new A.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new A.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new A.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new A.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new A.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new A.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new A.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new g.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:R=>{var N;if(R&&R.$mid===12){const j=(N=R.notebookEditor)===null||N===void 0?void 0:N.notebookUri,re=R.cell.handle,V=this._documents.get(j),W=V==null?void 0:V.getCell(re);if(W)return W.apiCell}return R}})}get activeNotebookEditor(){var o;return(o=this._activeNotebookEditor)===null||o===void 0?void 0:o.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){return this._editors.get(o)}getIdByEditor(o){for(const[c,p]of this._editors)if(p.apiEditor===o)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(o){return this._documents.get(o)}_getNotebookDocument(o){const c=this._documents.get(o);if(!c)throw new Error(`NO notebook document for '${o}'`);return c}_getProviderData(o){const c=this._notebookContentProviders.get(o);if(!c)throw new Error(`NO provider for '${o}'`);return c}registerNotebookContentProvider(o,c,p,v){var h,w,R;if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:o,provider:p});let N;p.onDidChangeNotebookContentOptions&&(N=p.onDidChangeNotebookContentOptions(()=>{const V=u.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(c,V)}));const j=(h=v==null?void 0:v.viewOptions)===null||h===void 0?void 0:h.filenamePattern.map(V=>u.NotebookExclusiveDocumentPattern.from(V)).filter(V=>V!==void 0);((w=v==null?void 0:v.viewOptions)===null||w===void 0?void 0:w.filenamePattern)&&!j&&console.warn(`Notebook content provider view options file name pattern is invalid ${(R=v==null?void 0:v.viewOptions)===null||R===void 0?void 0:R.filenamePattern}`);const re=u.NotebookDocumentContentOptions.from(v);return this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation,description:o.description},c,{transientOutputs:re.transientOutputs,transientCellMetadata:re.transientCellMetadata,transientDocumentMetadata:re.transientDocumentMetadata,viewOptions:(v==null?void 0:v.viewOptions)&&j?{displayName:v.viewOptions.displayName,filenamePattern:j,exclusive:v.viewOptions.exclusive||!1}:void 0}),new E.Disposable(()=>{N==null||N.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}registerNotebookCellStatusBarItemProvider(o,c,p){const v=m._notebookStatusBarItemProviderHandlePool++,h=typeof p.onDidChangeCellStatusBarItems=="function"?m._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,h,c);let w;return h!==void 0&&(w=p.onDidChangeCellStatusBarItems(R=>this._notebookProxy.$emitCellStatusBarEvent(h))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,h),w&&w.dispose()})}createNotebookEditorDecorationType(o){return new l(this._notebookEditorsProxy,o).value}async openNotebookDocument(o){const c=this._documents.get(o);if(c)return c.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenDocument(o),v=this._documents.get(f.URI.revive(p));return(0,C.assertIsDefined)(v==null?void 0:v.apiNotebook)}async showNotebookDocument(o,c){var p;f.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let v;typeof c=="object"?v={position:u.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(u.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:v={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.viewType,v),w=h&&((p=this._editors.get(h))===null||p===void 0?void 0:p.apiEditor);if(w)return w;throw h?new Error(`Could NOT open editor for "${o.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.toString()}".`)}async $provideNotebookCellStatusBarItems(o,c,p,v){var h;const w=this._notebookStatusBarItemProviders.get(o),R=f.URI.revive(c),N=this._documents.get(R);if(!(!N||!w)){const j=N.getCellFromIndex(p);if(!!j){const re=await w.provideCellStatusBarItems(j.apiCell,v);if(!!re){const V=new D.DisposableStore,W=this._statusBarCache.add([V]),$=(h=re&&re.map(U=>u.NotebookStatusBarItem.from(U,this._commandsConverter,V)))!==null&&h!==void 0?h:void 0;return{cacheId:W,items:$}}}}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,c,p,v){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const h=this._handlePool++;this._notebookSerializer.set(h,p);const w=u.NotebookDocumentContentOptions.from(v);return this._notebookProxy.$registerNotebookSerializer(h,{id:o.identifier,location:o.extensionLocation,description:o.description},c,w),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(h)})}async $dataToNotebook(o,c,p){const v=this._notebookSerializer.get(o);if(!v)throw new Error("NO serializer found");const h=await v.deserializeNotebook(c.buffer,p);return{metadata:u.NotebookDocumentMetadata.from(h.metadata),cells:h.cells.map(u.NotebookCellData.from)}}async $notebookToData(o,c,p){const v=this._notebookSerializer.get(o);if(!v)throw new Error("NO serializer found");const h=await v.serializeNotebook({metadata:u.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(u.NotebookCellData.to)},p);return I.VSBuffer.wrap(h)}cancelOneNotebookCellExecution(o){const c=this._activeExecutions.get(o.uri);c==null||c.cancel()}async $openNotebook(o,c,p,v,h){const{provider:w}=this._getProviderData(o),R=await w.openNotebook(f.URI.revive(c),{backupId:p,untitledDocumentData:v==null?void 0:v.buffer},h);return{metadata:u.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(u.NotebookCellData.from)}}async $saveNotebook(o,c,p){const v=this._getNotebookDocument(f.URI.revive(c)),{provider:h}=this._getProviderData(o);return await h.saveNotebook(v.apiNotebook,p),!0}async $saveNotebookAs(o,c,p,v){const h=this._getNotebookDocument(f.URI.revive(c)),{provider:w}=this._getProviderData(o);return await w.saveNotebookAs(f.URI.revive(p),h.apiNotebook,v),!0}async $backupNotebook(o,c,p){var v;const h=this._getNotebookDocument(f.URI.revive(c)),w=this._getProviderData(o),R=(v=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(w.extension),N=String((0,y.hash)([h.uri.toString(),this._backupIdPool++])),j=f.URI.joinPath(R,N),re=await w.provider.backupNotebook(h.apiNotebook,{destination:j},p);return h.updateBackup(re),re.id}$acceptModelChanged(o,c,p){this._getNotebookDocument(f.URI.revive(o)).acceptModelChanged(c,p)}$acceptDirtyStateChanged(o,c){const p=this._getNotebookDocument(f.URI.revive(o));p.acceptModelChanged({rawEvents:[],versionId:p.apiNotebook.version},c)}$acceptModelSaved(o){const c=this._getNotebookDocument(f.URI.revive(o));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(o,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",o,c);const p=this._editors.get(o);if(!p)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&p._acceptVisibleRanges(c.visibleRanges.ranges.map(u.NotebookRange.to)),c.selections&&p._acceptSelections(c.selections.selections.map(u.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(o){for(const c in o){const p=this._editors.get(c);if(!p)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);p._acceptViewColumn(u.ViewColumn.to(o[c]))}}$acceptDocumentPropertiesChanged(o,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",o.path,c);const p=this._getNotebookDocument(f.URI.revive(o));p.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:p.apiNotebook})}_createExtHostEditor(o,c,p){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const v=new d.ExtHostNotebookEditor(c,this._notebookEditorsProxy,o,p.visibleRanges.map(u.NotebookRange.to),p.selections.map(u.NotebookRange.to),typeof p.viewColumn=="number"?u.ViewColumn.to(p.viewColumn):void 0);this._editors.set(c,v)}$acceptDocumentAndEditorsDelta(o){var c,p,v;if(o.removedDocuments)for(const w of o.removedDocuments){const R=f.URI.revive(w),N=this._documents.get(R);N&&(N.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:N.apiNotebook.getCells().map(j=>j.document.uri)}),this._onDidCloseNotebookDocument.fire(N.apiNotebook));for(const j of this._editors.values())j.notebookData.uri.toString()===R.toString()&&this._editors.delete(j.id)}if(o.addedDocuments){const w=[];for(const R of o.addedDocuments){const N=f.URI.revive(R.uri),j=R.viewType;if(this._documents.has(N))throw new Error(`adding EXISTING notebook ${N} `);const re=this,V=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(W){re._onDidChangeNotebookCells.fire(W)},emitCellOutputsChange(W){re._onDidChangeCellOutputs.fire(W)},emitCellMetadataChange(W){re._onDidChangeCellMetadata.fire(W)},emitCellExecutionStateChange(W){re._onDidChangeCellExecutionState.fire(W)}},j,R.metadata?u.NotebookDocumentMetadata.to(R.metadata):new E.NotebookDocumentMetadata,N);V.acceptModelChanged({versionId:R.versionId,rawEvents:[{kind:b.NotebookCellsChangeType.Initialize,changes:[[0,0,R.cells]]}]},!1),w.push(...R.cells.map(W=>S.ExtHostCell.asModelAddData(V.apiNotebook,W))),(c=this._documents.get(N))===null||c===void 0||c.dispose(),this._documents.set(N,V),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(V.apiNotebook)}}if(o.addedEditors)for(const w of o.addedEditors){if(this._editors.has(w.id))return;const R=f.URI.revive(w.documentUri),N=this._documents.get(R);N&&this._createExtHostEditor(N,w.id,w)}const h=[];if(o.removedEditors)for(const w of o.removedEditors){const R=this._editors.get(w);R&&(this._editors.delete(w),((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.id)===R.id&&(this._activeNotebookEditor=void 0),h.push(R))}if(o.visibleEditors){this._visibleNotebookEditors=o.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const w=new Set;this._visibleNotebookEditors.forEach(R=>w.add(R.id));for(const R of this._editors.values()){const N=w.has(R.id);R._acceptVisibility(N)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.newActiveEditor===null?this._activeNotebookEditor=void 0:o.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.newActiveEditor)),o.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((v=this._activeNotebookEditor)===null||v===void 0?void 0:v.apiEditor)}createNotebookCellExecution(o,c,p){const v=this.lookupNotebookDocument(o);if(!v)throw new Error(`Invalid uri: ${o} `);const h=v.getCellFromIndex(c);if(!h)throw new Error(`Invalid cell index: ${o}, ${c} `);if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new n(o,v,h,this._notebookDocumentsProxy);this._activeExecutions.set(h.uri,w);const R=w.onDidChangeState(()=>{w.state===t.Resolved&&(w.dispose(),R.dispose(),this._activeExecutions.delete(h.uri))});return w.asApiObject()}}e.ExtHostNotebookController=m,m._notebookStatusBarItemProviderHandlePool=0;var t;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(t||(t={}));class n extends D.Disposable{constructor(o,c,p,v){super();this._uri=o,this._document=c,this._cell=p,this._proxy=v,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._collector=new s(10,h=>this.applyEdits(h)),this._executionOrder=p.internalMetadata.executionOrder,this.mixinMetadata({runState:E.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(o){await this._collector.addItem(o)}async applyEdits(o){return this._proxy.$applyEdits(this._uri,o,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(o){const c={editType:8,handle:this._cell.handle,metadata:o};this.applyEdits([c])}cellIndexToHandle(o){const c=typeof o=="number"?this._document.getCellFromIndex(o):this._cell;if(!!c)return c.handle}asApiObject(){const o=this;return Object.freeze({get document(){return o._document.apiNotebook},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(c){o._executionOrder=c,o.mixinMetadata({executionOrder:c})},start(c){var p;if(o._state===t.Resolved||o._state===t.Started)throw new Error("Cannot call start again");o._state=t.Started,o._onDidChangeState.fire(),o.mixinMetadata({runState:E.NotebookCellExecutionState.Executing,runStartTime:(p=c==null?void 0:c.startTime)!==null&&p!==void 0?p:null})},end(c){var p,v;if(o._state===t.Resolved)throw new Error("Cannot call resolve twice");o._state=t.Resolved,o._onDidChangeState.fire(),o.mixinMetadata({runState:E.NotebookCellExecutionState.Idle,lastRunSuccess:(p=c==null?void 0:c.success)!==null&&p!==void 0?p:null,runEndTime:(v=c==null?void 0:c.endTime)!==null&&v!==void 0?v:null})},clearOutput(c){return o.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,p){o.verifyStateForOutput();const v=o.cellIndexToHandle(p);if(typeof v=="number")return c=Array.isArray(c)?c:[c],o.applyEditSoon({editType:2,handle:v,append:!0,outputs:c.map(u.NotebookCellOutput.from)})},async replaceOutput(c,p){o.verifyStateForOutput();const v=o.cellIndexToHandle(p);if(typeof v=="number")return c=Array.isArray(c)?c:[c],o.applyEditSoon({editType:2,handle:v,outputs:c.map(u.NotebookCellOutput.from)})},async appendOutputItems(c,p){return o.verifyStateForOutput(),c=Array.isArray(c)?c:[c],o.applyEditSoon({editType:7,append:!0,items:c.map(u.NotebookCellOutputItem.from),outputId:p})},async replaceOutputItems(c,p){return o.verifyStateForOutput(),c=Array.isArray(c)?c:[c],o.applyEditSoon({editType:7,items:c.map(u.NotebookCellOutputItem.from),outputId:p})},token:o._tokenSource.token})}}class s{constructor(o,c){this.delay=o,this.callback=c,this.batch=[]}addItem(o){return this.batch.push(o),this.waitPromise||(this.waitPromise=(0,_.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(ge[243],pe([0,1,3,6,5,2,20,88]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class D{constructor(i,C,f){this._initData=C,this._extHostNotebook=f,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(i,C,f,g,a,u){for(let v of this._kernelData.values())if(v.controller.id===C)throw new Error(`notebook controller with id '${C}' ALREADY exist`);const E=this._handlePool++,b=this,S=()=>console.warn(`NO execute handler from notebook controller '${n.id}' of extension: '${i.identifier}'`);let d=!1;const l=new I.DisposableStore,m=new _.Emitter,t=new _.Emitter,n={id:C,viewType:f,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:g||i.identifier.value,preloads:u?u.map(y.NotebookKernelPreload.from):[]};let s=a!=null?a:S,r;this._proxy.$addKernel(E,n).catch(v=>{console.log(v),d=!0});let o=0;const c=()=>{if(!d){const v=++o;Promise.resolve().then(()=>{v===o&&this._proxy.$updateKernel(E,n)})}},p={get id(){return n.id},get viewType(){return n.viewType},onDidChangeNotebookAssociation:m.event,get label(){return n.label},set label(v){var h;n.label=(h=v!=null?v:i.displayName)!==null&&h!==void 0?h:i.name,c()},get detail(){var v;return(v=n.detail)!==null&&v!==void 0?v:""},set detail(v){n.detail=v,c()},get description(){var v;return(v=n.description)!==null&&v!==void 0?v:""},set description(v){n.description=v,c()},get supportedLanguages(){return n.supportedLanguages},set supportedLanguages(v){n.supportedLanguages=v,c()},get hasExecutionOrder(){var v;return(v=n.hasExecutionOrder)!==null&&v!==void 0?v:!1},set hasExecutionOrder(v){n.hasExecutionOrder=v,c()},get preloads(){return n.preloads?n.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return s},set executeHandler(v){s=v!=null?v:S},get interruptHandler(){return r},set interruptHandler(v){r=v,n.supportsInterrupt=Boolean(v),c()},createNotebookCellExecutionTask(v){if(d)throw new Error("notebook controller is DISPOSED");return b._extHostNotebook.createNotebookCellExecution(v.notebook.uri,v.index,n.id)},dispose:()=>{d||(d=!0,this._kernelData.delete(E),l.dispose(),m.dispose(),t.dispose(),this._proxy.$removeKernel(E))},onDidReceiveMessage:t.event,postMessage(v,h){return b._proxy.$postMessage(E,h&&b._extHostNotebook.getIdByEditor(h),v)},asWebviewUri(v){return(0,P.asWebviewUri)(b._initData.environment,String(E),v)},updateNotebookAffinity(v,h){b._proxy.$updateNotebookPriority(E,v.uri,h)}};return this._kernelData.set(E,{extensionId:i.identifier,controller:p,onDidChangeSelection:m,onDidReceiveMessage:t}),p}$acceptSelection(i,C,f){const g=this._kernelData.get(i);g&&g.onDidChangeSelection.fire({selected:f,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C)).apiNotebook})}async $executeCells(i,C,f){const g=this._kernelData.get(i);if(!!g){const a=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C));if(!a)throw new Error("MISSING notebook");const u=[];for(let E of f){const b=a.getCell(E);b&&u.push(b.apiCell)}try{await g.controller.executeHandler.call(g.controller,u,a.apiNotebook,g.controller)}catch(E){console.error(E)}}}async $cancelCells(i,C,f){const g=this._kernelData.get(i);if(!!g){const a=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C));if(!a)throw new Error("MISSING notebook");g.controller.interruptHandler&&await g.controller.interruptHandler.call(g.controller,a.apiNotebook);for(let u of f){const E=a.getCell(u);E&&this._extHostNotebook.cancelOneNotebookCellExecution(E)}}}$acceptRendererMessage(i,C,f){const g=this._kernelData.get(i);if(!!g){const a=this._extHostNotebook.getEditorById(C);if(!a)throw new Error(`send message for UNKNOWN editor: ${C}`);g.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:f}))}}}e.ExtHostNotebookKernels=D}),define(ge[64],pe([0,1,5,3,6,22,4,15]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends T.Disposable{constructor(a,u,E,b){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=b,this._id=b.$register(this.name,u,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(u=>this._proxy.$clear(u,a))}show(a,u){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:u)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(a,u){super(a,!1,void 0,u)}append(a){super.append(a),this._id.then(u=>this._proxy.$append(u,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends D{constructor(a,u,E){super(a,!0,u,E)}append(a){throw new Error("Not supported")}}class C{constructor(a,u){this.name=a,this._channel=u}append(a){this._channel.then(u=>u.append(a))}appendLine(a){this._channel.then(u=>u.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,u){this._channel.then(E=>E.show(a,u))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let f=class{constructor(a){this._proxy=a.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new k(a,this._proxy)}createOutputChannelFromLogFile(a,u){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new i(a,u,this._proxy)}};f=Ve([xe(0,P.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ge[244],pe([0,1,13,21,3,6,5,2,7,18,19,57]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(g,a,u){const E=g.getProxy(y.MainContext.MainThreadQuickOpen);class b{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,c,p=I.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(r),h=++this._instances,w=E.$show(h,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},p),R={},N=w.then(()=>R);return Promise.race([N,v]).then(j=>{if(j!==R)return v.then(re=>{const V=[];for(let W=0;W<re.length;W++){const $=re[W];let U,F,M,L,O;typeof $=="string"?U=$:(U=$.label,F=$.description,M=$.detail,L=$.picked,O=$.alwaysShow),V.push({label:U,description:F,handle:W,detail:M,picked:L,alwaysShow:O})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{c.onDidSelectItem(re[W])}),E.$setItems(h,V),w.then(W=>{if(typeof W=="number")return re[W];if(Array.isArray(W))return W.map($=>re[$])})})}).then(void 0,j=>{if(!(0,k.isPromiseCanceledError)(j))return E.$setError(h,j),Promise.reject(j)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=I.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",o).then(void 0,c=>{if(!(0,k.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(r){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!c){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(v=>v.uri.toString()===c.uri.toString())}}createQuickPick(r,o){const c=new t(r,o,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const c=this._sessions.get(r);c&&c._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const c=this._sessions.get(r);c instanceof t&&c._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const c=this._sessions.get(r);c instanceof t&&c._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const c=this._sessions.get(r);c&&c._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class S{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,c)=>{const p=o===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(p,o)}),this.update({buttons:r.map((o,c)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const c=r[o];this._pendingUpdate[o]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function d(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=m(s),o=l(s);return{dark:typeof r=="string"?P.URI.file(r):r,light:typeof o=="string"?P.URI.file(o):o}}function l(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends S{constructor(r,o,c){super(r,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,c)=>{this._handlesToItems.set(c,o),this._itemsToHandles.set(o,c)}),this.update({items:r.map((o,c)=>({label:o.label,description:o.description,handle:c,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=(0,i.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=(0,i.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends S{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new b(a,u)}e.createExtHostQuickOpen=f}),define(ge[245],pe([0,1,2,3,70,6,13,5,19,99,14,28,41]),function(G,e,_,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?_.URI.file(r.iconPath):r.iconPath}function a(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const c=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,k.comparePaths)(c,p)}function u(r,o){let c=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(c=a(r,o),c!==0)return c;if(r.light&&o.light)c=a(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(c!==0)return c;if(r.dark&&o.dark)c=a(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return c}function E(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let c=0;c<r.arguments.length;c++){const p=r.arguments[c],v=o.arguments[c];if(p!==v)return p<v?-1:1}return 0}function b(r,o){let c=(0,k.comparePaths)(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(c!==0)return c;if(r.command&&o.command)c=E(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(c!==0)return c;if(r.decorations&&o.decorations)c=u(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return c}function S(r,o){for(let c=0;c<r.length;c++)if(r[c]!==o[c])return!1;return!0}function d(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?S(r.arguments,o.arguments):r.arguments===o.arguments)}function l(r,o){return(0,D.equals)(r,o,d)}class m{constructor(o,c,p){this._extension=o,this._proxy=c,this._sourceControlHandle=p,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,f.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,c){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,c)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=m;class t{constructor(o,c,p,v,h){this._proxy=o,this._commands=c,this._sourceControlHandle=p,this._id=v,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,c){const p=this._resourceStatesCommandsMap.get(o);return p?(0,y.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const c=[...this._resourceStates].sort(b),v=(0,D.sortedDiff)(this._resourceSnapshot,c,b).map(R=>{const N=R.toInsert.map(j=>{const re=this._resourceHandlePool++;this._resourceStatesMap.set(re,j);const V=j.resourceUri,W=g(j.decorations),$=j.decorations&&g(j.decorations.light)||W,U=j.decorations&&g(j.decorations.dark)||W,F=[];let M;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const de=new A.DisposableStore;M=this._commands.converter.toInternal(j.command,de),this._resourceStatesDisposablesMap.set(re,de)}else this._resourceStatesCommandsMap.set(re,j.command);$&&F.push($),U&&U.toString()!==($==null?void 0:$.toString())&&F.push(U);const L=j.decorations&&j.decorations.tooltip||"",O=j.decorations&&!!j.decorations.strikeThrough,B=j.decorations&&!!j.decorations.faded,q=j.contextValue||"";return{rawResource:[re,V,F,L,O,B,q,M],handle:re}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),h=v.map(({start:R,deleteCount:N,toInsert:j})=>[R,N,j.map(re=>re.rawResource)]),w=v.reverse();for(const{start:R,deleteCount:N,toInsert:j}of w){const re=j.map(W=>W.handle),V=this._handlesSnapshot.splice(R,N,...re);for(const W of V)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(o=this._resourceStatesDisposablesMap.get(W))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=c,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,c,p,v,h,w){this._proxy=c,this._commands=p,this._id=v,this._label=h,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,v,h,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=o;const c=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(!(this._statusBarCommands&&o&&l(this._statusBarCommands,o))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=o;const c=(o||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(o,c){const p=new t(this._proxy,this._commands,this.handle,o,c),v=I.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,v),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const o=[],c=[];for(const[p,v]of this.createdResourceGroups){v.dispose();const h=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});I.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),h.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),o.push([p.handle,p.id,p.label,p.features]);const w=p._takeResourceStateSnapshot();w.length>0&&c.push([p.handle,w]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,o,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(c=>{const p=c._takeResourceStateSnapshot();p.length!==0&&o.push([c.handle,p])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Nn{constructor(o,c,p){this._commands=c,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===3){const h=this._sourceControls.get(v.sourceControlHandle);if(!h)return v;const w=h.getResourceGroup(v.groupHandle);return w?w.getResourceState(v.handle):v}else if(v&&v.$mid===4){const h=this._sourceControls.get(v.sourceControlHandle);return h?h.getResourceGroup(v.groupHandle):v}else if(v&&v.$mid===5){const h=this._sourceControls.get(v.handle);return h||v}return v}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,c,p,v){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,c,p,v),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const h=Nn._handlePool++,w=new n(o,this._proxy,this._commands,c,p,v);this._sourceControls.set(h,w);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(w),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(o.identifier),R),w}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const c=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier)),p=c&&c[c.length-1];return p&&p.inputBox}$provideOriginalResource(o,c,p){const v=_.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,v.toString());const h=this._sourceControls.get(o);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(v,p)).then(w=>w||null)}$onInputBoxValueChange(o,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const p=this._sourceControls.get(o);return p&&p.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(o,c,p,v){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,c,p);const h=this._sourceControls.get(o);if(!h)return Promise.resolve(void 0);const w=h.getResourceGroup(c);return w?w.$executeResourceCommand(p,v):Promise.resolve(void 0)}$validateInput(o,c,p){this.logService.trace("ExtHostSCM#$validateInput",o);const v=this._sourceControls.get(o);return!v||!v.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>v.inputBox.validateInput(c,p)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var c,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((c=this._sourceControls.get(o))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([xe(2,i.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[246],pe([0,1,7,5,164,6]),function(G,e,_,I,T,A){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(f,g,a,u,E=_.StatusBarAlignment.Left,b,S){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,y,f,"f"),tt(this,P,g,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=u,this._alignment=E,this._priority=b,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!D.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ue(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ue(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,g,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,P=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const g={message:f};return this._messages.unshift(g),this._update(),new _.Disposable(()=>{const a=this._messages.indexOf(g);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(f,g){this._proxy=f.getProxy(I.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(f,g,a,u,E){return new D(this._proxy,this._commands,f,g,a,u,E)}setStatusBarMessage(f,g){const a=this._statusMessage.setMessage(f);let u;return typeof g=="number"?u=setTimeout(()=>a.dispose(),g):typeof g!="undefined"&&g.then(()=>a.dispose(),()=>a.dispose()),new _.Disposable(()=>{a.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=i}),define(ge[92],pe([0,1,5,3,4]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,k){return this._proxy.$getValue(P,D).then(i=>i||k)}setValue(P,D,k){return this._proxy.$setValue(P,D,k)}$acceptValue(P,D,k){this._onDidChangeStorage.fire({shared:P,key:D,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[93],pe([0,1,4,27,14,91,2]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,i,C){var f;this._logService=i,this._extHostFileSystem=C,this._workspace=(f=k.workspace)!==null&&f!==void 0?f:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),C}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};P=Ve([xe(0,I.IExtHostInitDataService),xe(1,T.ILogService),xe(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[34],pe([0,1,3,5,4,2,15,6,7,165,18,210,21,30,190]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class u{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(c,p=!0){o._checkDisposed(),o._proxy.$sendText(o._id,c,p)},show(c){o._checkDisposed(),o._proxy.$show(o._id,c)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,s,r,o,c,p,v,h,w,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:o,initialText:c,waitOnExit:p,strictEnv:v,hideFromUser:h,isFeatureTerminal:w,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=u;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let b=1,S=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new u(this._proxy,(0,g.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal().then(r=>{const o=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new E(n),o=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const p=this._getTerminalObjectIndexById(this._terminals,n);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const o={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:A.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},c=new u(this._proxy,t,o,s);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(o=>{const c=this.onDidOpenTerminal(async p=>{p===s.value&&(c.dispose(),o())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new P.DisposableStore;s.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),s.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof E&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const o=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const c=[],p={terminal:s.value,line:n},v=[];for(const R of this._linkProviders)v.push(new Promise(async N=>{o.token.onCancellationRequested(()=>N({provider:R,links:[]}));const j=await R.provideTerminalLinks(p,o.token)||[];o.token.isCancellationRequested||N({provider:R,links:j})}));const h=await Promise.all(v);if(o.token.isCancellationRequested)return[];const w=new Map;for(const R of h)R&&R.links.length>0&&c.push(...R.links.map(N=>{const j={id:b++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return w.set(j.id,{provider:R.provider,link:N}),j}));return this._terminalLinkCache.set(t,w),c}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,o)=>r._id===n?(s=o,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new d(n[1]);this._setEnvironmentVariableCollection(s,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=Ve([xe(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let l=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}async $getDefaultShellAndArgs(t){throw new i.NotSupportedError}};l=Ve([xe(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(ge[247],pe([0,1,3,19,5,124,20,7]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const C=this._extHostDocumentsAndEditors.allEditors();return i?C:C.map(f=>f.value)}async showTextDocument(i,C,f){let g;typeof C=="number"?g={position:y.ViewColumn.from(C),preserveFocus:f}:typeof C=="object"?g={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:g={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,g),u=a&&this._extHostDocumentsAndEditors.getEditor(a);if(u)return u.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new A.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,C){const f=this._extHostDocumentsAndEditors.getEditor(i);if(!f)throw new Error("unknown text editor");if(C.options&&f._acceptOptions(C.options),C.selections){const g=C.selections.selections.map(y.Selection.to);f._acceptSelections(g)}if(C.visibleRanges){const g=I.coalesce(C.visibleRanges.map(y.Range.to));f._acceptVisibleRanges(g)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const g=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:a,kind:g})}if(C.visibleRanges){const g=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const C in i){const f=this._extHostDocumentsAndEditors.getEditor(C);if(!f)throw new Error("Unknown text editor");const g=y.ViewColumn.to(i[C]);f.value.viewColumn!==g&&(f._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var qt=this&&this.__rest||function(G,e){var _={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(_[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(_[I[T]]=G[I[T]]);return _};define(ge[248],pe([0,1,2,4,5,6,7]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class P{constructor(i,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:f=>{var g,a;if(f&&f.$mid===11){const u=f.uri===void 0?void 0:_.URI.revive(f.uri);return(a=(g=this._itemsBySourceAndUriMap.get(f.source))===null||g===void 0?void 0:g.get(D(u)))===null||a===void 0?void 0:a.get(f.handle)}return f}})}async $getTimeline(i,C,f,g,a){const u=this._providers.get(i);return u==null?void 0:u.provideTimeline(_.URI.revive(C),f,g,a)}registerTimelineProvider(i,C,f,g){const a=new A.DisposableStore,u=this.convertTimelineItem(C.id,g,a).bind(this);let E;C.onDidChange&&(E=C.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:C.id})),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:i,onDidChange:void 0,async provideTimeline(S,d,l,m){var t;(m==null?void 0:m.resetCache)&&(a.clear(),(t=b.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(S,d,l);if(n!=null){const s=u(S,m);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(s)})}},dispose(){var S;for(const d of b.values())(S=d.get(C.id))===null||S===void 0||S.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(i,C,f){return(g,a)=>{let u;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(i);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(i,E));const b=D(g);u=E.get(b),u===void 0&&(u=new Map,E.set(b,u))}return E=>{var b,S;const{iconPath:d}=E,l=qt(E,["iconPath"]),m=`${i}|${(b=E.id)!==null&&b!==void 0?b:E.timestamp}`;u==null||u.set(m,E);let t,n,s;return E.iconPath&&(d instanceof y.ThemeIcon?s={id:d.id}:_.URI.isUri(d)?(t=d,n=d):{light:t,dark:n}=d),Object.assign(Object.assign({},l),{id:(S=l.id)!==null&&S!==void 0?S:void 0,handle:m,source:i,command:E.command?C.toInternal(E.command,f):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,A.toDisposable)(()=>{var f;for(const g of this._itemsBySourceAndUriMap.values())(f=g.get(i.id))===null||f===void 0||f.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=P;function D(k){return k==null?void 0:k.toString()}}),define(ge[249],pe([0,1,6,12,2,5]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,i,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=C.schemes.find(g=>!y.supportedSchemes.has(g));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,C.schemes,D,C.label),(0,_.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,i){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const f=T.URI.revive(k);return C.canOpenExternalUri(f,i)}async $openUri(D,k,i){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(T.URI.revive(k.resolvedUri),{sourceUri:T.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ge[250],pe([0,1,5,2,6,18,28]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(C,i),this._proxy.$registerUriHandler(C,k),(0,T.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,i){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(i))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[65],pe([0,1,22,3,2,177,200,88,5]),function(G,e,_,I,T,A,y,P,D){"use strict";var k,i,C,f,g,a,u,E,b,S,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(h,w,R,N,j,re,V){k.set(this,void 0),i.set(this,void 0),C.set(this,void 0),f.set(this,void 0),g.set(this,void 0),a.set(this,void 0),u.set(this,""),E.set(this,void 0),b.set(this,!1),S.set(this,!1),d.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new I.Emitter),this._onDidDispose=Ue(this,l,"f").event,tt(this,k,h,"f"),tt(this,i,w,"f"),tt(this,E,R,"f"),tt(this,f,N,"f"),tt(this,g,j,"f"),tt(this,a,re,"f"),tt(this,d,t(re),"f"),tt(this,C,V,"f")}dispose(){tt(this,b,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return tt(this,S,!0,"f"),(0,P.asWebviewUri)(Ue(this,f,"f"),Ue(this,k,"f"),h)}get cspSource(){return Ue(this,f,"f").webviewCspSource.replace("{{uuid}}",Ue(this,k,"f"))}get html(){return this.assertNotDisposed(),Ue(this,u,"f")}set html(h){this.assertNotDisposed(),Ue(this,u,"f")!==h&&(tt(this,u,h,"f"),!Ue(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(tt(this,S,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,i,"f").$setHtml(Ue(this,k,"f"),h))}get options(){return this.assertNotDisposed(),Ue(this,E,"f")}set options(h){this.assertNotDisposed(),Ue(this,i,"f").$setOptions(Ue(this,k,"f"),o(Ue(this,a,"f"),Ue(this,g,"f"),h)),tt(this,E,h,"f")}async postMessage(h){if(Ue(this,b,"f"))return!1;const w=n(h,{serializeBuffersForPostMessage:Ue(this,d,"f")});return Ue(this,i,"f").$postMessage(Ue(this,k,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,k=new WeakMap,i=new WeakMap,C=new WeakMap,f=new WeakMap,g=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,b=new WeakMap,S=new WeakMap,d=new WeakMap,l=new WeakMap;function t(v){if(!v.enableProposedApi)return!1;try{const h=(0,A.normalizeVersion)((0,A.parseVersion)(v.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=56}catch(h){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(v,h){if(h.serializeBuffersForPostMessage){const w=[],R=(j,re)=>{if(re&&re instanceof ArrayBuffer){let V=w.findIndex(W=>W.original===re);if(V===-1){const W=new Uint8Array(re),$=_.VSBuffer.wrap(W);V=w.length,w.push({original:re,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:V}}return re};return{message:JSON.stringify(v,R),buffers:w.map(j=>j.vsBuffer)}}else return{message:JSON.stringify(v),buffers:[]}}e.serializeMessage=n;class s{constructor(h,w,R,N,j){this.initData=w,this.workspace=R,this._logService=N,this._deprecationService=j,this._webviews=new Map,this._webviewProxy=h.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(h,w,...R){const N=this.getWebview(h);if(N){const{message:j}=(0,y.deserializeWebviewMessage)(w,R);N._onMessageEmitter.fire(j)}}$onMissingCsp(h,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,w,R){const N=new m(h,this._webviewProxy,c(w),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(h,N),N._onDidDispose(()=>{this._webviews.delete(h)}),N}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=s;function r(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=r;function o(v,h,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||p(v,h)}}e.serializeWebviewOptions=o;function c(v){var h;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(h=v.localResourceRoots)===null||h===void 0?void 0:h.map(w=>T.URI.from(w))}}e.reviveOptions=c;function p(v,h){return[...((h==null?void 0:h.getWorkspaceFolders())||[]).map(w=>w.uri),v.extensionLocation]}}),define(ge[251],pe([0,1,21,74,6,12,25,2,20,65,86,5,7]),function(G,e,_,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new g(n,s);return this._documents.set(r,o),o}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var u;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(u||(u={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new f.Disposable(()=>this._providers.delete(n))}}class b{constructor(t,n,s,r,o){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const o=new T.DisposableStore;return S(s)?(o.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(c=>{const p=this.getCustomDocumentEntry(n,c.document.uri);if(d(c)){const v=p.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,v,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),f.Disposable.from(o,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,o){var c;const p=this._editorProviders.get(n);if(!p)throw new Error(`No provider found for '${n}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${n}'`);const v=P.URI.revive(t),h=await p.provider.openCustomDocument(v,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},o);let w;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(w=(c=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(n,h,w),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,s,r,o,c){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const v=D.ViewColumn.to(o),h=this._extHostWebview.createNewWebview(n,r.webviewOptions,p.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,v,r.panelOptions,h),R=P.URI.revive(t);switch(p.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,R);return p.provider.resolveCustomEditor(N,w,c)}case 0:{const N=this._extHostDocuments.getDocument(R);return p.provider.resolveCustomTextEditor(N,w,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const c=P.URI.revive(n),p=this._extHostDocuments.getDocument(c);await r.provider.moveCustomTextEditor(p,o,_.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,P.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,P.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function S(m){return typeof m.resolveCustomTextEditor=="function"}function d(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function l(m){const t=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[252],pe([0,1,3,6,2,30,20,65,5,7]),function(G,e,_,I,T,A,y,P,D,k){"use strict";var i,C,f,g,a,u,E,b,S,d,l,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(c,p,v,h,w,R,N){super();i.set(this,void 0),C.set(this,void 0),f.set(this,void 0),g.set(this,void 0),a.set(this,void 0),u.set(this,void 0),E.set(this,void 0),b.set(this,void 0),S.set(this,!0),d.set(this,!0),l.set(this,!1),m.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,m,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,i,c,"f"),tt(this,C,p,"f"),tt(this,f,v,"f"),tt(this,a,R,"f"),tt(this,b,w,"f"),tt(this,u,h,"f"),tt(this,g,N,"f")}dispose(){Ue(this,l,"f")||(tt(this,l,!0,"f"),Ue(this,m,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,f,"f")}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(c){this.assertNotDisposed(),Ue(this,u,"f")!==c&&(tt(this,u,c,"f"),Ue(this,C,"f").$setTitle(Ue(this,i,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(c){this.assertNotDisposed(),Ue(this,E,"f")!==c&&(tt(this,E,c,"f"),Ue(this,C,"f").$setIconPath(Ue(this,i,"f"),T.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,b,"f")=="number"&&Ue(this,b,"f")<0))return Ue(this,b,"f")}get active(){return this.assertNotDisposed(),Ue(this,d,"f")}get visible(){return this.assertNotDisposed(),Ue(this,S,"f")}_updateViewState(c){Ue(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,d,c.active,"f"),tt(this,S,c.visible,"f"),tt(this,b,c.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(c,p){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,i,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,C=new WeakMap,f=new WeakMap,g=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,b=new WeakMap,S=new WeakMap,d=new WeakMap,l=new WeakMap,m=new WeakMap,t=new WeakMap;class s{constructor(c,p,v){this.webviews=p,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(c,p,v,h,w={}){const R=typeof h=="object"?h.viewColumn:h,N={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},j=(0,P.shouldSerializeBuffersForPostMessage)(c),re=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(c),re,p,{title:v,panelOptions:r(w),webviewOptions:(0,P.serializeWebviewOptions)(c,this.workspace,w),serializeBuffersForPostMessage:j},N);const V=this.webviews.createNewWebview(re,w,c);return this.createNewWebviewPanel(re,p,v,R,w,V)}$onDidChangeWebviewPanelViewStates(c){const p=Object.keys(c);p.sort((v,h)=>{const w=c[v],R=c[h];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const v of p){const h=this.getWebviewPanel(v);if(!!h){const w=c[v];h._updateViewState({active:w.active,visible:w.visible,viewColumn:y.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(c){const p=this.getWebviewPanel(c);p==null||p.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,p,v){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:v,extension:c}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(c)}),new k.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(c,p,v,h){const w=this._serializers.get(p);if(!w)throw new Error(`No serializer found for '${p}'`);const{serializer:R,extension:N}=w,j=this.webviews.createNewWebview(c,v.webviewOptions,N),re=this.createNewWebviewPanel(c,p,v.title,h,v.panelOptions,j);await R.deserializeWebviewPanel(re,v.state)}createNewWebviewPanel(c,p,v,h,w,R){const N=new n(c,this._proxy,p,v,h,w,R);return this._webviewPanels.set(c,N),N}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=s;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[253],pe([0,1,3,6,65,5,7]),function(G,e,_,I,T,A,y){"use strict";var P,D,k,i,C,f,g,a,u,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends I.Disposable{constructor(l,m,t,n,s,r){super();P.set(this,void 0),D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),C.set(this,!1),f.set(this,void 0),g.set(this,void 0),a.set(this,void 0),u.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,E.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,E,"f").event,tt(this,k,t,"f"),tt(this,g,n,"f"),tt(this,P,l,"f"),tt(this,D,m,"f"),tt(this,i,s,"f"),tt(this,f,r,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,E,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(l){this.assertNotDisposed(),Ue(this,g,"f")!==l&&(tt(this,g,l,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,P,"f"),l))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(l){this.assertNotDisposed(),Ue(this,a,"f")!==l&&(tt(this,a,l,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,P,"f"),l))}get visible(){return Ue(this,f,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(l){l===Ue(this,f,"f")||Ue(this,C,"f")||(tt(this,f,l,"f"),Ue(this,u,"f").fire())}show(l){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,P,"f"),!!l)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,k=new WeakMap,i=new WeakMap,C=new WeakMap,f=new WeakMap,g=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap;class S{constructor(l,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,m,t,n){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(l),m,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(l,m,t,n,s){const r=this._viewProviders.get(m);if(!r)throw new Error(`No view provider found for '${m}'`);const{provider:o,extension:c}=r,p=this._extHostWebview.createNewWebview(l,{},c),v=new b(l,this._proxy,m,t,p,!0);this._webviewViews.set(l,v),await o.resolveWebviewView(v,{state:n},s)}async $onDidChangeWebviewViewVisibility(l,m){this.getWebviewView(l)._setVisible(m)}async $disposeWebviewView(l){const m=this.getWebviewView(l);this._webviewViews.delete(l),m.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const m=this._webviewViews.get(l);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=S}),define(ge[127],pe([0,1,3,5,2,12,9,4,15]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Un{constructor(C){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,f){let g;if(typeof C=="string"){g=C;try{C=T.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,g,f)}async asExternalUri(C,f){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const g=await this._proxy.$asExternalUri(C,f);return T.URI.from(g)}};k.InitialState={focused:!0},k=Ve([xe(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ge[254],pe([0,1,8,48,30,51,6,5,2,15]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(f,g){super();const a=f.getProxy(P.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async u=>{const E=D.URI.file((0,_.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await a.$download(u,E),E})}};i=Ve([xe(0,k.IExtHostRpcService),xe(1,A.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(ge[255],pe([0,1,2,8,146,26,37,64,27,15,6,14,113,45]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(S,d){this.file=d,this.appender=(0,f.createRotatingLogger)(S,d,30*g.ByteSize.MB,1),this.appender.clearFormatters()}append(S){this.appender.critical(S)}flush(){this.appender.flush()}}class u extends P.AbstractExtHostOutputChannel{constructor(S,d,l){super(S,!1,_.URI.file(d.file),l);this._appender=d}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,d){this._appender.flush(),super.show(S,d)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=u;let E=class extends P.ExtHostOutputService{constructor(S,d,l){super(S);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new i.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(S){if(S){const d=this._channels.get(S);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(S);return d.then(l=>l._id.then(m=>this._channels.set(m,l))),new P.LazyOutputChannel(S,d)}async _doCreateOutChannel(S){try{const d=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(d)||await y.promises.mkdir(d,{recursive:!0});const m=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,I.join)(d,`${m}.log`)),n=new a(m,t.fsPath);return new u(S,n,this._proxy)}catch(d){return this.logService.error(d),new P.ExtHostPushOutputChannel(S,this._proxy)}}};E=Ve([xe(0,k.IExtHostRpcService),xe(1,C.ILogService),xe(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(ge[256],pe([0,1,5,15,6,27,2,38,25,37,26,7,10,50,3,73,14]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(p,v,h){this.remoteAddress=p,this.localAddress=v,this._dispose=h,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(c){const p=c.trim().split(`
`),v=[];return p.forEach(w=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);R&&R.length>=3&&v.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),v.reduce((w,R)=>(w[R.socket]=R,w),{})}e.getSockets=S;function d(...c){const p=[].concat(...c.map(m));return[...new Map(p.filter(v=>v.st==="0A").map(v=>{const h=v.local_address.split(":");return{socket:parseInt(v.inode,10),ip:l(h[0]),port:parseInt(h[1],16)}}).map(v=>[v.ip+":"+v.port,v])).values()]}e.loadListeningPorts=d;function l(c){let p="";if(c.length===8)for(let v=c.length-2;v>=0;v-=2)p+=parseInt(c.substr(v,2),16),v!==0&&(p+=".");else for(let v=c.length-4;v>=0;v-=4)p+=parseInt(c.substr(v,4),16).toString(16),v!==0&&(p+=":");return p}e.parseIpAddress=l;function m(c){const p=c.trim().split(`
`),v=p.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return p.map(w=>w.trim().split(/\s+/).reduce((R,N,j)=>(R[v[j]||j]=N,R),{}))}e.loadConnectionTable=m;function t(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const p=c.trim().split(`
`),v=[];return p.forEach(h=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(h);w&&w.length>=4&&v.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),v}e.getRootProcesses=n;async function s(c,p,v){const h=v.reduce((R,N)=>(R[N.pid]=N,R),{}),w=[];return c.forEach(({socket:R,ip:N,port:j})=>{var re;const V=p[R]?p[R].pid:void 0,W=V?(re=h[V])===null||re===void 0?void 0:re.cmd:void 0;V&&W&&!t(W)&&w.push({host:N,port:j,detail:W,pid:V})}),w}e.findPorts=s;function r(c,p,v){const h=new Map,w=n(p);for(const R of c){const N=v.get(R.port);if(N){h.set(R.port,N);continue}const j=w.find(re=>re.cmd.includes(`${R.port}`));if(j){let re=j,V;do V=w.find(W=>W.ppid===re.pid),V&&(re=V);while(V);h.set(R.port,{host:R.ip,port:R.port,pid:re.pid,detail:re.cmd,ppid:re.ppid})}else h.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return h}e.tryFindRootPorts=r;let o=class extends T.Disposable{constructor(p,v,h){super();this.logService=h,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadTunnelService),f.isLinux&&v.remote.isRemote&&v.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,v){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${v.remoteAddress.port}.`);const h=await this._proxy.$openTunnel(v,p.displayName);if(h){const w=new b(h.remoteAddress,h.localAddress,()=>this._proxy.$closeTunnel(h.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,v){const h=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(h,{selector:p,provider:v}),this._proxy.$registerPortsAttributesProvider(p,h),new C.Disposable(()=>{this._portAttributesProviders.delete(h),this._proxy.$unregisterPortsAttributesProvider(h)})}async $providePortAttributes(p,v,h,w,R){const N=[];for(const re of p){const V=this._portAttributesProviders.get(re);if(!V)return[];N.push(...await Promise.all(v.map(async W=>V.provider.providePortAttributes(W,h,w,R))))}const j=N.filter(re=>!!re);return j.length>0?j.map(re=>({autoForwardAction:re.autoForwardAction,port:re.port})):[]}async $registerCandidateFinder(p){if(!(p&&this._candidateFindingEnabled)){this._candidateFindingEnabled=p;let v=new u.MovingAverage,h;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(j=>j.port).join(", ")}`);const N=new Date().getTime()-w;v.update(N),(!h||JSON.stringify(h)!==JSON.stringify(R))&&(h=R,await this._proxy.$onFoundNewCandidates(h)),await new Promise(j=>setTimeout(()=>j(),this.calculateDelay(v.value)))}}}async setTunnelExtensionFunctions(p){var v;return p?(p.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,await this._proxy.$setCandidateFilter()),p.tunnelFactory&&(this._forwardPortProvider=p.tunnelFactory,await this._proxy.$setTunnelProvider((v=p.tunnelFeatures)!==null&&v!==void 0?v:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,v){if(this._extensionTunnels.has(p.host)){const h=this._extensionTunnels.get(p.host);h.has(p.port)&&(v&&h.get(p.port).disposeListener.dispose(),await h.get(p.port).tunnel.dispose(),h.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,v){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const h=this._forwardPortProvider(p,v);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),h!==void 0){const w=await h;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const R=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:w,disposeListener:R}),g.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(h){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const v=await Promise.all(p.map(w=>{var R;return this._showCandidatePort(w.host,w.port,(R=w.detail)!==null&&R!==void 0?R:"")})),h=p.filter((w,R)=>v[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(w=>w.port).join(", ")} to ${h.map(w=>w.port).join(", ")}`),h}async findCandidatePorts(){let p="",v="";try{p=await k.promises.readFile("/proc/net/tcp","utf8"),v=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const h=d(p,v),w=await new Promise(U=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,M,L)=>{U(M)})}),R=S(w),N=await i.readdir("/proc"),j=[];for(let U of N)try{const F=Number(U),M=D.joinPath(y.URI.file("/proc"),U);if((await k.promises.stat(M.fsPath)).isDirectory()&&!isNaN(F)){const O=await k.promises.readlink(D.joinPath(M,"cwd").fsPath),B=await k.promises.readFile(D.joinPath(M,"cmdline").fsPath,"utf8");j.push({pid:F,cwd:O,cmd:B})}}catch(F){}const re=[],V=h.filter(U=>{const F=R[U.socket];return F||re.push(U),F}),W=s(V,R,j);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${re.length}`),re.length>0){const U=await new Promise(F=>{(0,P.exec)("ps -F -A -l | grep root",(M,L,O)=>{F(L)})});this._foundRootPorts=r(re,U,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return W.then(U=>$?U.concat($):U)}};o=Ve([xe(0,I.IExtHostRpcService),xe(1,A.IExtHostInitDataService),xe(2,E.ILogService)],o),e.ExtHostTunnelService=o}),define(ge[257],pe([0,1,13,21,18,3,6,101,227,125,22]),function(G,e,_,I,T,A,y,P,D,k,i){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(r,o){try{return JSON.stringify(r,o)}catch(c){return"null"}}function g(r,o){return JSON.stringify(r,o)}function a(r){return r?(o,c)=>c&&c.$mid===1?r.transformOutgoing(c):c:null}var u;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},S=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(o,c=null,p=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=c,this._uriTransformer=p,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let v=0,h=k.ProxyIdentifier.count;v<h;v++)this._locals[v]=null,this._proxies[v]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(v=>this._receiveOneMessage(v))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,P.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:c,sid:p}=o;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,p)),this._proxies[c]}_createProxy(o,c){let p={get:(v,h)=>(typeof h=="string"&&!v[h]&&h.charCodeAt(0)===36&&(v[h]=(...w)=>this._remoteCall(o,h,w)),h===d?c:v[h])};return new Proxy(Object.create(null),p)}set(o,c){return this._locals[o.nid]=c,c}assertRegistered(o){for(let c=0,p=o.length;c<p;c++){const v=o[c];if(!this._locals[v.nid])throw new Error(`Missing actor ${v.sid} (isMain: ${v.isMain})`)}}_receiveOneMessage(o){if(!this._isDisposed){const c=o.byteLength,p=m.read(o,0),v=p.readUInt8(),h=p.readUInt32();switch(v){case 1:case 2:{let{rpcId:w,method:R,args:N}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(N=(0,P.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(c,h,w,R,N,v===2);break}case 3:case 4:{let{rpcId:w,method:R,args:N}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(N=(0,P.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(c,h,w,R,N,v===4);break}case 5:{this._logger&&this._logger.logIncoming(c,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(c,h);break}case 7:{this._receiveReply(c,h,void 0);break}case 9:{let w=t.deserializeReplyOKJSON(p);this._uriTransformer&&(w=(0,P.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(c,h,w);break}case 8:{let w=t.deserializeReplyOKVSBuffer(p);this._receiveReply(c,h,w);break}case 10:{let w=t.deserializeReplyErrError(p);this._uriTransformer&&(w=(0,P.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(c,h,w);break}case 11:{this._receiveReplyErr(c,h,void 0);break}default:console.error("received unexpected message"),console.error(o)}}}_receiveRequest(o,c,p,v,h,w){this._logger&&this._logger.logIncoming(o,c,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(p)}.${v}(`,h);const R=String(c);let N,j;if(w){const V=new I.CancellationTokenSource;h.push(V.token),N=this._invokeHandler(p,v,h),j=()=>V.cancel()}else N=this._invokeHandler(p,v,h),j=b;this._cancelInvokedHandlers[R]=j;const re=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(re.byteLength,c,1,"ack"),this._protocol.send(re),N.then(V=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyOK(c,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,c,1,"reply:",V),this._protocol.send(W)},V=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyErr(c,V);this._logger&&this._logger.logOutgoing(W.byteLength,c,1,"replyErr:",V),this._protocol.send(W)})}_receiveCancel(o,c){this._logger&&this._logger.logIncoming(o,c,1,"receiveCancel");const p=String(c);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(o,c,p){this._logger&&this._logger.logIncoming(o,c,0,"receiveReply:",p);const v=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(v)){const h=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v],h.resolveOk(p)}}_receiveReplyErr(o,c,p){this._logger&&this._logger.logIncoming(o,c,0,"receiveReplyErr:",p);const v=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(v)){const h=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v];let w;p&&(p.$isError?(w=new Error,w.name=p.name,w.message=p.message,w.stack=p.stack):w=p),h.resolveErr(w)}}_invokeHandler(o,c,p){try{return Promise.resolve(this._doInvokeHandler(o,c,p))}catch(v){return Promise.reject(v)}}_doInvokeHandler(o,c,p){const v=this._locals[o];if(!v)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(o));let h=v[c];if(typeof h!="function")throw new Error("Unknown method "+c+" on actor "+(0,k.getStringIdentifierForProxy)(o));return h.apply(v,p)}_remoteCall(o,c,p){if(this._isDisposed)return Promise.reject(T.canceled());let v=null;if(p.length>0&&I.CancellationToken.isCancellationToken(p[p.length-1])&&(v=p.pop()),v&&v.isCancellationRequested)return Promise.reject(T.canceled());const h=t.serializeRequestArguments(p,this._uriReplacer),w=++this._lastMessageId,R=String(w),N=new D.LazyPromise;v&&v.onCancellationRequested(()=>{const re=t.serializeCancel(w);this._logger&&this._logger.logOutgoing(re.byteLength,w,0,"cancel"),this._protocol.send(t.serializeCancel(w))}),this._pendingRPCReplies[R]=N,this._onWillSendRequest(w);const j=t.serializeRequest(w,o,c,h,!!v);return this._logger&&this._logger.logOutgoing(j.byteLength,w,0,`request: ${(0,k.getStringIdentifierForProxy)(o)}.${c}(`,p),this._protocol.send(j),N}}e.RPCProtocol=l,C=S,l.UNRESPONSIVE_TIME=3*1e3;class m{constructor(o,c){this._buff=o,this._offset=c}static alloc(o,c,p){let v=new m(i.VSBuffer.alloc(p+1+4),0);return v.writeUInt8(o),v.writeUInt32(c),v}static read(o,c){return new m(o,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,p}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,p}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,c}static sizeMixedArray(o,c){let p=0;p+=1;for(let v=0,h=o.length;v<h;v++){const w=o[v],R=c[v];switch(p+=1,R){case 1:p+=this.sizeLongString(w);break;case 2:p+=this.sizeVSBuffer(w);break;case 3:break}}return p}writeMixedArray(o,c){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let p=0,v=o.length;p<v;p++){const h=o[p];switch(c[p]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(o);for(let p=0;p<o;p++)switch(this.readUInt8()){case 1:c[p]=this.readLongString();break;case 2:c[p]=this.readVSBuffer();break;case 3:c[p]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(o){for(let c=0,p=o.length;c<p;c++)if(o[c]instanceof i.VSBuffer||typeof o[c]=="undefined")return!0;return!1}static serializeRequestArguments(o,c){if(this._arrayContainsBufferOrUndefined(o)){let p=[],v=[];for(let h=0,w=o.length;h<w;h++){const R=o[h];R instanceof i.VSBuffer?(p[h]=R,v[h]=2):typeof R=="undefined"?(p[h]=i.VSBuffer.alloc(0),v[h]=3):(p[h]=i.VSBuffer.fromString(g(R,c)),v[h]=1)}return{type:"mixed",args:p,argsType:v}}return{type:"simple",args:g(o,c)}}static serializeRequest(o,c,p,v,h){return v.type==="mixed"?this._requestMixedArgs(o,c,p,v.args,v.argsType,h):this._requestJSONArgs(o,c,p,v.args,h)}static _requestJSONArgs(o,c,p,v,h){const w=i.VSBuffer.fromString(p),R=i.VSBuffer.fromString(v);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(w),N+=m.sizeLongString(R);let j=m.alloc(h?2:1,o,N);return j.writeUInt8(c),j.writeShortString(w),j.writeLongString(R),j.buffer}static deserializeRequestJSONArgs(o){const c=o.readUInt8(),p=o.readShortString(),v=o.readLongString();return{rpcId:c,method:p,args:JSON.parse(v)}}static _requestMixedArgs(o,c,p,v,h,w){const R=i.VSBuffer.fromString(p);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(R),N+=m.sizeMixedArray(v,h);let j=m.alloc(w?4:3,o,N);return j.writeUInt8(c),j.writeShortString(R),j.writeMixedArray(v,h),j.buffer}static deserializeRequestMixedArgs(o){const c=o.readUInt8(),p=o.readShortString(),v=o.readMixedArray(),h=new Array(v.length);for(let w=0,R=v.length;w<R;w++){const N=v[w];typeof N=="string"?h[w]=JSON.parse(N):h[w]=N}return{rpcId:c,method:p,args:h}}static serializeAcknowledged(o){return m.alloc(5,o,0).buffer}static serializeCancel(o){return m.alloc(6,o,0).buffer}static serializeReplyOK(o,c,p){return typeof c=="undefined"?this._serializeReplyOKEmpty(o):c instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(o,c):this._serializeReplyOKJSON(o,f(c,p))}static _serializeReplyOKEmpty(o){return m.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,c){let p=0;p+=m.sizeVSBuffer(c);let v=m.alloc(8,o,p);return v.writeVSBuffer(c),v.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,c){const p=i.VSBuffer.fromString(c);let v=0;v+=m.sizeLongString(p);let h=m.alloc(9,o,v);return h.writeLongString(p),h.buffer}static deserializeReplyOKJSON(o){const c=o.readLongString();return JSON.parse(c)}static serializeReplyErr(o,c){return c?this._serializeReplyErrEror(o,c):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,c){const p=i.VSBuffer.fromString(f(T.transformErrorForSerialization(c),null));let v=0;v+=m.sizeLongString(p);let h=m.alloc(10,o,v);return h.writeLongString(p),h.buffer}static deserializeReplyErrError(o){const c=o.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(o){return m.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(ge[258],pe([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ge[259],pe([0,1,12,8,10,2,4,258]),function(G,e,_,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,C){this.localUserHome=i,this.remoteAgentService=C,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||T.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?I.win32:I.posix)}async fileURI(i){let C="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(C=i.substring(2),i="/"):(C=i.substring(2,g),i=i.substring(g)||"/")}return A.URI.from({scheme:_.Schemas.file,authority:C,path:i,query:"",fragment:""})}};D=Ve([xe(1,P.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[66],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class _{constructor(y,P){this.line=y,this.character=P}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,P){return new _(0,0)}with(y){return new _(0,0)}}e.Position=_;class I{constructor(y,P,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(y,P),this.end=new _(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var T;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,19,33,23,29,9,4,8,18,66]),function(G,e,_,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",f=" characters skipped \u27EB",g=(C.length+f.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var a;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function E(F){return!!F.preview}e.resultIsMatch=E;function b(F){return!!F.resource}e.isFileMatch=b;function S(F){return!!F.message}e.isProgressMessage=S;var d;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(M){this.resource=M,this.results=[]}}e.FileMatch=l;class m{constructor(M,L,O){this.ranges=L;const B=Array.isArray(L)?L:[L];if(O&&O.matchLines===1&&t(B)){M=(0,y.getNLines)(M,O.matchLines);let q="",Q=0,de=0;const be=Math.floor(O.charsPerLine/5),Ae=[];for(const Ce of B){const Le=Math.max(Ce.startColumn-be,0),z=Ce.startColumn+O.charsPerLine;if(Le>de+be+g){const Y=C+(Le-de)+f;q+=Y+M.slice(Le,z),Q+=Le-(de+Y.length)}else q+=M.slice(de,z);Ae.push(new s(0,Ce.startColumn-Q,Ce.endColumn-Q)),de=z}this.preview={text:q,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const q=Array.isArray(L)?L[0].startLineNumber:L.startLineNumber;this.preview={text:M,matches:(0,_.mapArrayOrNot)(L,Q=>new n(Q.startLineNumber-q,Q.startColumn,Q.endLineNumber-q,Q.endColumn))}}}}e.TextSearchMatch=m;function t(F){const M=F[0].startLineNumber;for(const L of F)if(L.startLineNumber!==M||L.endLineNumber!==M)return!1;return!0}class n{constructor(M,L,O,B){this.startLineNumber=M,this.startColumn=L,this.endLineNumber=O,this.endColumn=B}}e.SearchRange=n;class s extends n{constructor(M,L,O){super(M,L,M,O)}}e.OneLineRange=s;var r;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(F,M=!0){const L=F&&F.files&&F.files.exclude,O=M&&F&&F.search&&F.search.exclude;if(!(!L&&!O)){if(!L||!O)return L||O;let B=Object.create(null);return B=T.mixin(B,T.deepClone(L)),B=T.mixin(B,T.deepClone(O),!0),B}}e.getExcludes=o;function c(F,M){return F.excludePattern&&I.match(F.excludePattern,M)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&I.match(F.includePattern,M)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(L=>{const O=L.folder.fsPath;if(A.isEqualOrParent(M,O)){const B=D.relative(O,M);return!L.includePattern||!!I.match(L.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var p;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(M,L){super(M);this.code=L}}e.SearchError=v;function h(F){const M=F.message;if((0,k.isPromiseCanceledError)(F))return new v(M,p.canceled);try{const L=JSON.parse(M);return new v(L.message,L.code)}catch(L){return new v(M,p.other)}}e.deserializeSearchError=h;function w(F){const M={message:F.message,code:F.code};return new Error(JSON.stringify(M))}e.serializeSearchError=w;function R(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=R;function N(F){return F.type==="success"}e.isSerializedSearchSuccess=N;function j(F){return!!F.path}e.isSerializedFileMatch=j;function re(F,M){const L=F.searchPath?F.searchPath:F.relativePath;return(0,y.fuzzyContains)(L,M)}e.isFilePatternMatch=re;class V{constructor(M){this.path=M,this.results=[]}addMatch(M){this.results.push(M)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function W(F,M){const L=Object.assign(Object.assign({},F||{}),M||{});return Object.keys(L).filter(O=>{const B=L[O];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=W;class ${constructor(M,L){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},M.excludePattern||{}),L.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let O=M.includePattern;L.includePattern&&(O?O=Object.assign(Object.assign({},O),L.includePattern):O=L.includePattern),O&&(this._parsedIncludeExpression=I.parse(O))}includedInQuerySync(M,L,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(M,L,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(M,L,O))}includedInQuery(M,L,O){return Promise.resolve(this._parsedExcludeExpression(M,L,O)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(M,L,O)).then(Q=>!!Q):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=$;function U(F){for(const M in F)if(typeof F[M]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,19,13,21,3,24,12,73,25,9,11,2,167,4,14,186,60,61,27,15,7,31,5]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d,l,m,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,N,j){return new k.ExtUri(re=>p(re,j)).isEqual(R,N)}function r(R,N,j){return s(R.uri,N.uri,j)?0:(0,i.compare)(R.uri.toString(),N.uri.toString())}function o(R,N,j){return R.index!==N.index?R.index<N.index?-1:1:s(R.uri,N.uri,j)?(0,i.compare)(R.name,N.name):(0,i.compare)(R.uri.toString(),N.uri.toString())}function c(R,N,j,re){const V=R.slice(0).sort(($,U)=>j($,U,re)),W=N.slice(0).sort(($,U)=>j($,U,re));return(0,_.delta)(V,W,($,U)=>j($,U,re))}function p(R,N){const j=N.getCapabilities(R.scheme);return!(j&&j&1024)}class v extends b.Workspace{constructor(N,j,re,V,W,$){super(N,re.map(U=>new b.WorkspaceFolder(U)),V,$);this._name=j,this._isUntitled=W,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris($),re.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(N,j,re,V){if(!N)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:U,configuration:F,isUntitled:M}=N,L=[],O=j;j?U.forEach((de,be)=>{const Ae=f.URI.revive(de.uri),Ce=v._findFolder(re||j,Ae,V);Ce?(Ce.name=de.name,Ce.index=de.index,L.push(Ce)):L.push({uri:Ae,name:de.name,index:be})}):L.push(...U.map(({uri:de,name:be,index:Ae})=>({uri:f.URI.revive(de),name:be,index:Ae}))),L.sort((de,be)=>de.index<be.index?-1:1);const B=new v(W,$,L,F?f.URI.revive(F):null,!!M,de=>p(de,V)),{added:q,removed:Q}=c(O?O.workspaceFolders:[],B.workspaceFolders,r,V);return{workspace:B,added:q,removed:Q}}static _findFolder(N,j,re){for(let V=0;V<N.folders.length;V++){const W=N.workspaceFolders[V];if(s(W.uri,j,re))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,j){return j&&this._structure.get(N)&&(N=(0,k.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let h=class{constructor(N,j,re,V){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=re,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const W=j.workspace;this._confirmedWorkspace=W?new v(W.id,W.name,[],W.configuration?f.URI.revive(W.configuration):null,!!W.isUntitled,$=>p($,re)):void 0}$initializeWorkspace(N,j){this._trusted=j,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:P.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,j,re,...V){const W=[];if(Array.isArray(V)&&V.forEach(L=>{f.URI.isUri(L.uri)&&!W.some(O=>s(O.uri,L.uri,this._extHostFileSystemInfo))&&W.push({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri)})}),this._unconfirmedWorkspace||[j,re].some(L=>typeof L!="number"||L<0)||re===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(j+re>$.length)return!1;const U=$.slice(0);U.splice(j,re,...W.map(L=>({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri),index:void 0})));for(let L=0;L<U.length;L++){const O=U[L];if(U.some((B,q)=>q!==L&&s(O.uri,B.uri,this._extHostFileSystemInfo)))return!1}U.forEach((L,O)=>L.index=O);const{added:F,removed:M}=c($,U,o,this._extHostFileSystemInfo);if(F.length===0&&M.length===0)return!1;if(this._proxy){const L=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(L,j,re,W).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,g.localize)(0,null,L,O.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(N,j){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,j)}async getWorkspaceFolder2(N,j){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,j)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!!this._actualWorkspace){const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}}getRelativePath(N,j){let re,V="";if(typeof N=="string"?(re=f.URI.file(N),V=N):typeof N!="undefined"&&(re=N,V=N.fsPath),!re)return V;const W=this.getWorkspaceFolder(re,!0);if(!W)return V;typeof j=="undefined"&&this._actualWorkspace&&(j=this._actualWorkspace.folders.length>1);let $=(0,k.relativePath)(W.uri,re);return j&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:j,added:re,removed:V}=v.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=j||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:re,removed:V}))}findFiles(N,j,re,V,W=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let $;if(j===null?$=!1:j&&(typeof j=="string"?$=j:$=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:F}=w(N);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(re),W).then(M=>Array.isArray(M)?M.map(L=>f.URI.revive(L)):[])}async findTextInFiles(N,j,re,V,W=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),U=typeof j.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:F,folder:M}=w(j.include),L=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,O={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:U,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:F,excludePattern:L},B=!1;if(this._activeSearchCallbacks[$]=q=>{if(!B){const Q=f.URI.revive(q.resource);q.results.forEach(de=>{(0,t.resultIsMatch)(de)?re({uri:Q,preview:{text:de.preview.text,matches:(0,_.mapArrayOrNot)(de.preview.matches,be=>new m.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,_.mapArrayOrNot)(de.ranges,be=>new m.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):re({uri:Q,text:de.text,lineNumber:de.lineNumber})})}},W.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(N,(0,C.withUndefinedAsNull)(M),O,$,W);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(N,j){this._activeSearchCallbacks[j]&&this._activeSearchCallbacks[j](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){const j=this._proxy.$requestWorkspaceTrust(N);return(N==null?void 0:N.modal)?j:Promise.resolve(this._trusted)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=Ve([xe(0,l.IExtHostRpcService),xe(1,d.IExtHostInitDataService),xe(2,S.IExtHostFileSystemInfo),xe(3,u.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function w(R){let N,j;return R&&(typeof R=="string"?N=R:(N=R.pattern,j=R.baseFolder||f.URI.file(R.base))),{includePattern:N,folder:j}}}),define(ge[35],pe([0,1,23,3,32,5,7,188,83,11,13,4,15,14,2]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(n,s){if(s){const r=s.split(".");let o=n;for(let c=0;o&&c<r.length;c++)o=o[r[c]];return o}}function E(n){return n instanceof a.URI}function b(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function d(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(E(n))return{resource:n};if(b(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(d(n))return{resource:n.uri};if(n===null)return{resource:null}}let m=class{constructor(s,r,o){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,r))}};m=Ve([xe(0,f.IExtHostRpcService),xe(1,T.IExtHostWorkspace),xe(2,g.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(s,r,o,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=s,this._logService=c,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(s,r,o){const c=l(r)||{},p=this._toReadonlyValue(s?u(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,c,o==null?void 0:o.identifier);function v(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(w){return typeof u(p,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(s?`${s}.${w}`:w,c,o==null?void 0:o.identifier);let N=u(p,w);if(typeof N=="undefined")N=R;else{let j;const re=(V,W)=>{let $;const U=()=>{j=j||(0,_.deepClone)(p),$=$||u(j,W)};return(0,k.isObject)(V)?new Proxy(V,{get:(F,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return U(),()=>$;if(j)return $=$||u(j,W),$[M];const L=F[M];return typeof M=="string"?re(L,`${W}.${M}`):L},set:(F,M,L)=>(U(),$&&($[M]=L),!0),deleteProperty:(F,M)=>(U(),$&&delete $[M],!0),defineProperty:(F,M,L)=>(U(),$&&Object.defineProperty($,M,L),!0)}):V};N=re(N,w)}return N},update:(w,R,N,j)=>{w=s?`${s}.${w}`:w;const re=v(N);return R!==void 0?this._proxy.$updateConfigurationOption(re,w,R,c,j):this._proxy.$removeConfigurationOption(re,w,c,j)},inspect:w=>{var R,N,j,re,V,W,$,U;w=s?`${s}.${w}`:w;const F=(0,_.deepClone)(this._configuration.inspect(w,c,this._extHostWorkspace.workspace));if(F)return{key:w,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(N=F.user)===null||N===void 0?void 0:N.value,workspaceValue:(j=F.workspace)===null||j===void 0?void 0:j.value,workspaceFolderValue:(re=F.workspaceFolder)===null||re===void 0?void 0:re.value,defaultLanguageValue:(V=F.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(W=F.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:($=F.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(U=F.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:F.overrideIdentifiers}}};return typeof p=="object"&&(0,_.mixin)(h,p,!1),Object.freeze(h)}_toReadonlyValue(s){const r=o=>(0,k.isObject)(o)?new Proxy(o,{get:(c,p)=>r(c[p]),set:(c,p,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(c,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(c,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(s)}_validateConfigurationAccess(s,r,o){const c=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=o?`[${o.value}] `:"";if(c===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const o=new P.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,p)=>o.affectsConfiguration(c,l(p))})}_toMap(s){return s.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[67],pe([0,1,2,13,3,5,7,32,39,35,21,34,15,27,4,12,10,14,63,209,18]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d,l){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(V){function W(F){if(F){const M=F;return M&&!!M.process}else return!1}V.is=W;function $(F){if(F!=null){const M={process:F.process,args:F.args};return F.options&&(M.options=s.from(F.options)),M}}V.from=$;function U(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}V.to=U})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(V){function W(U){if(U!=null)return U}V.from=W;function $(U){if(U!=null)return U}V.to=$})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(V){function W(F){if(F){const M=F;return M&&(!!M.commandLine||!!M.command)}else return!1}V.is=W;function $(F){if(F!=null){const M={};return F.commandLine!==void 0?M.commandLine=F.commandLine:(M.command=F.command,M.args=F.args),F.options&&(M.options=o.from(F.options)),M}}V.from=$;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}V.to=U})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(V){function W(F){if(F){let M=F;return M&&M.customExecution==="customExecution"}else return!1}V.is=W;function $(F){return{customExecution:"customExecution"}}V.from=$;function U(F,M){return M.get(F)}V.to=U})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(V){function W($,U){let F;return $.scope!==void 0&&typeof $.scope!="number"?F=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=d.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:F}}V.from=W})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(V){function W(F,M){if(F==null)return[];const L=[];for(let O of F){const B=$(O,M);B&&L.push(B)}return L}V.fromMany=W;function $(F,M){if(F!=null){let L;F.execution instanceof y.ProcessExecution?L=r.from(F.execution):F.execution instanceof y.ShellExecution?L=c.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(L=p.from(F.execution));const O=t.from(F.definition);let B;if(F.scope?typeof F.scope=="number"?B=F.scope:B=F.scope.uri:B=y.TaskScope.Workspace,!(!O||!B)){const q=F.group?F.group.id:void 0;return{_id:F._id,definition:O,name:F.name,source:{extensionId:M.identifier.value,label:F.source,scope:B},execution:L,isBackground:F.isBackground,group:q,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}V.from=$;async function U(F,M,L){if(F!=null){let O;r.is(F.execution)?O=r.to(F.execution):c.is(F.execution)?O=c.to(F.execution):p.is(F.execution)&&(O=p.to(F._id,L));const B=t.to(F.definition);let q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?q=F.source.scope:q=await M.resolveWorkspaceFolder(_.URI.revive(F.source.scope)):q=y.TaskScope.Workspace),!(!B||!q)){const Q=new y.Task(B,q,F.name,F.source.label,O,F.problemMatchers);return F.isBackground!==void 0&&(Q.isBackground=F.isBackground),F.group!==void 0&&(Q.group=y.TaskGroup.from(F.group)),F.presentationOptions&&(Q.presentationOptions=n.to(F.presentationOptions)),F._id&&(Q._id=F._id),F.detail&&(Q.detail=F.detail),Q}}}V.to=U})(h=e.TaskDTO||(e.TaskDTO={}));var w;(function(V){function W(U){return U}V.from=W;function $(U){if(!!U)return Object.assign(Object.create(null),U)}V.to=$})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,$,U){this._id=$,this._task=U,m.set(this,void 0),tt(this,m,W,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}m=new WeakMap;var N;(function(V){function W($){return{id:$._id,task:void 0}}V.from=W})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let j=class{constructor(W,$,U,F,M,L,O,B){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=M,this._terminalService=L,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,$,U){if(!U)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:$,provider:U,extension:W}),this._proxy.$registerTaskProvider(F,$),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(W,$){this._proxy.$registerTaskSystem(W,$)}fetchTasks(W){return this._proxy.$fetchTasks(w.from(W)).then(async $=>{const U=[];for(let F of $){const M=await h.to(F,this._workspaceProvider,this._providedCustomExecutions2);M&&U.push(M)}return U})}get taskExecutions(){const W=[];return this._taskExecutions.forEach($=>W.push($)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,$,U){const F=this._providedCustomExecutions2.get(W.id);if(F){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,F),this._terminalService.attachPtyToTerminal($,await F.callback(U))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const $=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const $=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:$,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const $=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:W.exitCode})}$provideTasks(W,$){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));const F=[],M=(0,I.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(L=>this.provideTasksInternal($,F,U,L));return new Promise(L=>{M.then(O=>{Promise.all(F).then(()=>{L(O)})})})}async $resolveTask(W,$){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));if($.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await h.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const M=await U.provider.resolveTask(F,i.CancellationToken.None);if(!!M){this.checkDeprecation(M,U);const L=h.from(M,U.extension);if(!L)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(L.execution)&&await this.addCustomExecution(L,M,!0),await this.resolveTaskInternal(L)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,$,U){const F=await this._proxy.$createTaskId(W);!U&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,$.execution)}async getTaskExecution(W,$){if(typeof W=="string"){const M=this._taskExecutionPromises.get(W);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let U=this._taskExecutionPromises.get(W.id);if(U)return U;const F=new Promise(async(M,L)=>{const O=$||await h.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new R(this,W.id,O)):L("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,F),F.then(M=>(this._taskExecutions.set(W.id,M),M),M=>Promise.reject(M))}checkDeprecation(W,$){W._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let U=this._notProvidedCustomExecutions.values(),F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};j=Ve([xe(0,f.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,b.ILogService),xe(7,S.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let re=class extends j{constructor(W,$,U,F,M,L,O,B){super(W,$,U,F,M,L,O,B);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(W,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const U=h.from($,W);if(U===void 0)throw new Error("Task is not valid");if(p.is(U.execution))await this.addCustomExecution(U,$,!1);else throw new l.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),$);return this._proxy.$executeTask(U).catch(M=>{throw new Error(M)}),F}provideTasksInternal(W,$,U,F){const M=[];if(F)for(let L of F){this.checkDeprecation(L,U),(!L.definition||!W[L.definition.type])&&this._logService.warn(`The task [${L.source}, ${L.name}] uses an undefined task type. The task will be ignored in the future.`);const O=h.from(L,U.extension);O&&p.is(O.execution)?(M.push(O),$.push(this.addCustomExecution(O,L,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:U.extension}}async resolveTaskInternal(W){if(p.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,$,U){}};re=Ve([xe(0,f.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,b.ILogService),xe(7,S.IExtHostApiDeprecationService)],re),e.WorkerExtHostTask=re,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)},qt=this&&this.__rest||function(G,e){var _={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(_[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(_[I[T]]=G[I[T]]);return _};define(ge[260],pe([0,1,19,13,22,21,3,71,54,6,23,11,2,30,5,39,15,87,20,7,32,222,123]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d,l,m,t){"use strict";var n,s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(U,F)=>`${U}:${F.toString()}`;let p=class{constructor(F,M,L){this.documents=M,this.workspace=L,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new m.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new v(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new $(this.proxy,M)}registerTestController(F,M){const L=(0,g.generateUuid)();this.controllers.set(L,{instance:M,extensionId:F}),this.proxy.$registerTestController(L);const O=[...this.testControllers.keys()];return setTimeout(()=>{var B;for(const q of O)(B=this.testControllers.get(q))===null||B===void 0||B.subscribeFn(L,M)},0),new d.Disposable(()=>{this.controllers.delete(L),this.proxy.$unregisterTestController(L)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,M=A.CancellationToken.None){const L=O=>O.map(this.getInternalTestForReference,this).filter(C.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:F.exclude?L(F.exclude).map(O=>O.testId):void 0,tests:L(F.tests),debug:F.debug},M)}createTestRunTask(F,M,L,O=!0){return this.runQueue.createTestRunTask(F,M,L,O)}$publishTestResults(F){this.results=Object.freeze(F.map(M=>(0,i.deepFreeze)(S.TestResults.to(M))).concat(this.results).sort((M,L)=>L.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,M){const L=f.URI.revive(M),O=c(F,L);if(!this.testControllers.has(O)){const B=new A.CancellationTokenSource;let q;if(F===1){let Ce=this.documents.getDocument(L);if(!Ce){const Le=new k.DisposableStore;Ce=await new Promise(z=>{Le.add((0,I.disposableTimeout)(()=>z(void 0),5e3)),Le.add(this.documents.onDidAddDocuments(Y=>{const ee=Y.find(le=>le.document.uri.toString()===L.toString());ee&&z(ee)}))}).finally(()=>Le.dispose())}if(Ce){const Le=await this.workspace.getWorkspaceFolder2(L,!1);q=z=>z.createDocumentTestRoot?z.createDocumentTestRoot(Ce.document,B.token):(0,e.createDefaultDocumentTestRoot)(z,Ce.document,Le,B.token)}}else{const Ce=await this.workspace.getWorkspaceFolder2(L,!1);Ce&&(q=Le=>Le.createWorkspaceTestRoot(Ce,B.token))}if(!!q){const Q=async(Ce,Le)=>{try{const z=await q(Le);z&&be.addRoot(z,Ce)}catch(z){console.error(z)}},de=new k.DisposableStore,be=de.add(this.ownedTests.createForHierarchy(Ce=>this.proxy.$publishDiff(F,M,Ce)));de.add((0,k.toDisposable)(()=>B.dispose(!0)));const Ae=[];for(const[Ce,Le]of this.controllers)Ae.push(Q(Ce,Le.instance));Promise.all(Ae).then(()=>be.pushDiff([3,-1])),this.testControllers.set(O,{store:de,collection:be,subscribeFn:Q})}}}async $expandTest(F,M){const L=(0,_.mapFind)(this.testControllers.values(),O=>O.collection.treeId===F.src.tree?O:void 0);await(L==null?void 0:L.collection.expand(F.testId,M<0?Infinity:M)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,M){var L;const O=f.URI.revive(M),B=c(F,O);(L=this.testControllers.get(B))===null||L===void 0||L.store.dispose(),this.testControllers.delete(B)}$acceptDiff(F,M,L){F===1?this.textDocumentObservers.acceptDiff(f.URI.revive(M),L):this.workspaceObservers.acceptDiff(f.URI.revive(M),L)}async $runTestsForProvider(F,M){const L=this.controllers.get(F.tests[0].src.controller);if(!!L){const O=F.tests.map(({testId:Q,src:de})=>this.ownedTests.getTestById(Q,de==null?void 0:de.tree)).filter(C.isDefined).map(([Q,de])=>de),B=F.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,de])=>O.some(be=>Q.comparePositions(be,de)===1));if(!!O.length){const q={tests:O.map(Q=>N.unwrap(Q.actual)),exclude:B.map(([,Q])=>N.unwrap(Q.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:h.fromInternal(F),token:M,extensionId:L.extensionId,req:q,doRun:()=>L.instance.runTests(q,M)})}}}$lookupTest(F){const M=this.ownedTests.getTestById(F.testId);if(!M)return Promise.resolve(void 0);const L=M[1],{actual:O,discoverCts:B,expandLevels:q}=L,Q=qt(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var M,L;return(L=(M=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&M!==void 0?M:(0,_.mapFind)(this.testControllers.values(),O=>O.collection.getTestByReference(F)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(F)}};p=Ve([xe(0,E.IExtHostRpcService),xe(1,u.IExtHostDocumentsAndEditors),xe(2,l.IExtHostWorkspace)],p),e.ExtHostTesting=p;class v{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let M=this.state.get(F.extensionId);M||(M={queue:[],current:void 0},this.state.set(F.extensionId,M));const L=new I.DeferredPromise,O=()=>{const B=[],q=new Set;M.current={publicReq:F.req,factory:Q=>{const de=new w(Q,F.dto,q,this.proxy);return B.push(de),F.token.onCancellationRequested(()=>de.end()),de}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,B).finally(()=>L.complete())};return M.queue.push(O),M.queue.length===1&&O(),L.p}createTestRunTask(F,M,L,O){var B,q;const Q=this.state.get(F);if((Q==null?void 0:Q.current.publicReq)===M)return Q.current.factory(L);const de=h.fromPublic(M),be=new w(L,de,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:M.debug,exclude:(q=(B=M.exclude)===null||B===void 0?void 0:B.map(Ae=>Ae.id))!==null&&q!==void 0?q:[],id:de.id,tests:M.tests.map(Ae=>Ae.id),persist:O}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(de.id)),be}invokeRunner(F,M,L,O){try{const B=L();return(0,I.isThenable)(B)?B.then(()=>this.handleInvokeResult(F,M,O,void 0)).catch(q=>this.handleInvokeResult(F,M,O,q)):this.handleInvokeResult(F,M,O,void 0)}catch(B){return this.handleInvokeResult(F,M,O,B)}}async handleInvokeResult(F,M,L,O){const B=this.state.get(F);!B||(B.queue.shift(),B.queue.length>0?B.queue[0]():this.state.delete(F),await Promise.all(L.map(q=>q.onEnd.wait())))}}class h{constructor(F,M,L){this.id=F,this.include=M,this.exclude=L}static fromPublic(F){var M,L;return new h((0,g.generateUuid)(),new Set(F.tests.map(O=>O.id)),new Set((L=(M=F.exclude)===null||M===void 0?void 0:M.map(O=>O.id))!==null&&L!==void 0?L:D.Iterable.empty()))}static fromInternal(F){return new h(F.runId,new Set(F.tests.map(M=>M.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let M=F;M;M=M.parent){if(this.include.has(M.id))return!0;if(this.exclude.has(M.id))return!1}return!0}}class w{constructor(F,M,L,O){this.name=F,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,g.generateUuid)()),o.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,O,"f"),tt(this,s,M,"f"),tt(this,o,L,"f"),O.$startedTestRunTask(M.id,{id:Ue(this,r,"f"),name:F,running:!0})}setState(F,M,L){Ue(this,s,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$updateTestStateInRun(Ue(this,s,"f").id,Ue(this,r,"f"),F.id,M,L))}appendMessage(F,M){Ue(this,s,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,s,"f").id,Ue(this,r,"f"),F.id,S.TestMessage.from(M)))}appendOutput(F){Ue(this,n,"f").$appendOutputToRun(Ue(this,s,"f").id,Ue(this,r,"f"),T.VSBuffer.fromString(F))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,s,"f").id,Ue(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(F){const M=Ue(this,o,"f");if(!M.has(F.id)){const L=[];for(;L.unshift(S.TestItem.from(F)),!(M.has(F.id)||(M.add(F.id),!F.parent));)F=F.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,s,"f").id,L)}}}n=new WeakMap,s=new WeakMap,r=new WeakMap,o=new WeakMap;const R=async(U,F,M,L)=>{if(!!M){const O=await U.createWorkspaceTestRoot(M,L);if(!!O){L.onCancellationRequested(()=>{N.removeFilter(F)});const B=N.getWrapperForTestItem(O,F);return B.refreshMatch(),B}}};e.createDefaultDocumentTestRoot=R;class N extends d.TestItemImpl{constructor(F,M,L){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=M,this.actualParent=L,!(F instanceof d.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status,this.range=F.range,this.resolveHandler=F.resolveHandler;const O=(0,b.getPrivateApiFor)(this);(0,b.getPrivateApiFor)(F).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=N.getWrapperForTestItem(q[1],this.filterDocument,this);(0,b.getPrivateApiFor)(Q).parent=F,Q.refreshMatch();break;default:O.bus.fire(q)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,M,L){let O=this.wrapperMap.get(M);if(O==null?void 0:O.has(F))return O.get(F);O||(O=new WeakMap,this.wrapperMap.set(M,O));const B=new N(F,M,L);return O.set(F,B),B}static unwrap(F){return F instanceof N?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F;const M=this._cachedMatchesFilter;for(const O of this.actual.children.values()){const B=N.getWrapperForTestItem(O,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.has(B.id)||this.addChild(B):B.dispose()}const L=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=L,L!==M&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,b.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,b.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class j extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,S.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:M,removed:L}=this;return{get added(){return[...F].map(O=>O.revived)},get updated(){return[...M].map(O=>O.revived)},get removed(){return[...L].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class re extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let M=[];for(const L of F){const O=this.items.get(L);O&&M.push(O.revived)}return M}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,M){return Object.assign(Object.assign({},F),{revived:S.TestItem.toPlain(F.item),depth:M?M.depth+1:0,children:new Set})}createChangeCollector(){return new j(this.changeEmitter)}}e.MirroredTestCollection=re;class V{constructor(){this.resources=new Map}checkout(F){var M,L;const O=F.toString(),B=(M=this.resources.get(O))!==null&&M!==void 0?M:this.createObserverData(F);return(L=B.pendingDeletion)===null||L===void 0||L.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,P.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:M}of this.resources.values()){const L=M.getMirroredTestDataByReference(F);if(L)return L}}eventuallyDispose(F){return(0,I.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const M=new re,L=this.listen(F,B=>M.apply(B)),O={observers:0,tests:M,listener:L};return this.resources.set(F.toString(),O),O}unlisten(F){var M;const L=F.toString(),O=this.resources.get(L);O&&(O.observers=-1,(M=O.pendingDeletion)===null||M===void 0||M.dispose(),O.listener.dispose(),this.resources.delete(L))}}class W extends V{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,M){var L;(L=this.diffListeners.get(F.toString()))===null||L===void 0||L(M)}listen(F,M){this.proxy.$subscribeToDiffs(0,F);const L=F.toString();return this.diffListeners.set(L,M),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(L)})}}class $ extends V{constructor(F,M){super();this.proxy=F,this.documents=M,this.diffListeners=new Map}acceptDiff(F,M){var L;(L=this.diffListeners.get(F.toString()))===null||L===void 0||L(M)}listen(F,M){if(!this.documents.getDocument(F))return new d.Disposable(()=>{});const O=F.toString();return this.diffListeners.set(O,M),this.proxy.$subscribeToDiffs(1,F),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(O)})}}}),define(ge[261],pe([0,1,19,53,33,76,24,12,8,25,9,11,2,140,173,84,60,214,259,31]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(v,h,w,R){this.configurationService=v,this.workspaceContextService=h,this.editorGroupsService=w,this.pathService=R}text(v,h,w={}){v=this.getContentPattern(v,w);const R=this.configurationService.getValue(),N=h&&h.some(re=>!this.configurationService.getValue({resource:re}).search.useRipgrep),j=this.commonQuery(h==null?void 0:h.map(E.toWorkspaceFolder),w);return Object.assign(Object.assign({},j),{type:2,contentPattern:v,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:R.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(v,h){const w=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},v),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(v,h)&&(R.isCaseSensitive=!0),this.isMultiline(v)&&(R.isMultiline=!0),R}file(v,h={}){const w=this.commonQuery(v,h);return Object.assign(Object.assign({},w),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(v,h){return v?(v=Array.isArray(v)?v.map(r):r(v),h?this.parseSearchPaths(v):{pattern:t(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],h={}){const w=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),N=v.length>1,j=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,h,R)):v.map(W=>this.getFolderQueryForRoot(W,h,R,N))).filter(W=>!!W),re={_reason:h._reason,folderQueries:j,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:w.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(M=>M.resource)))).filter(F=>(0,d.pathIncludedInQuery)(re,F.fsPath)),U=this.commonQueryFromFileList($);return Object.assign(Object.assign({},re),U)}const V=h.extraFileResources&&h.extraFileResources.filter(W=>(0,d.pathIncludedInQuery)(re,W.fsPath));return re.extraFileResources=V&&V.length?V:void 0,re}commonQueryFromFileList(v){const h=[],w=new y.ResourceMap,R={};let N=!1;return v.forEach(j=>{var re,V;if(j.scheme!==P.Schemas.walkThrough)if((0,k.isAbsolutePath)(j)){const $=(V=(re=this.workspaceContextService.getWorkspaceFolder(j))===null||re===void 0?void 0:re.uri)!==null&&V!==void 0?V:j.with({path:D.dirname(j.fsPath)});let U=w.get($);U||(N=!0,U={folder:$,includePattern:{}},h.push(U),w.set($,U));const F=D.relative($.fsPath,j.fsPath);(0,C.assertIsDefined)(U.includePattern)[F.replace(/\\/g,"/")]=!0}else j.fsPath&&(N=!0,R[j.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(v,h){if(h.isSmartCase){if(v.isRegExp){if(i.containsUppercaseCharacter(v.pattern,!0))return!0}else if(i.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,g.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const h=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(v)?v:n(v)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,A.untildify)(U,F.scheme===P.Schemas.file?F.fsPath:F.path):U}),N=I.groupBy(R,U=>h(U)?"searchPaths":"exprSegments"),j=(N.exprSegments||[]).map(U=>i.rtrim(U,"/")).map(U=>i.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),s(U))),re={},V=this.expandSearchPathPatterns(N.searchPaths||[]);V&&V.length&&(re.searchPaths=V);const W=_.flatten(j),$=t(...W);return $&&(re.pattern=$),re}getExcludesForFolder(v,h){return h.disregardExcludeSettings?void 0:(0,d.getExcludes)(v,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const h=_.flatten(v.map(R=>{let{pathPortion:N,globPortion:j}=m(R);j&&(j=o(j));const re=this.expandOneSearchPath(N);return _.flatten(re.map(V=>this.resolveOneSearchPathPattern(V,j)))})),w=new Map;return h.forEach(R=>{const N=R.searchPath.toString(),j=w.get(N);j?R.pattern&&(j.pattern=j.pattern||{},j.pattern[R.pattern]=!0):w.set(N,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(v){if(D.isAbsolute(v)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==P.Schemas.file?[{searchPath:h[0].uri.with({path:v})}]:[{searchPath:f.URI.file(D.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=r(v),v.startsWith("../")||v===".."){const R=D.posix.resolve(h.path,v);return[{searchPath:h.with({path:R})}]}const w=o(v);return[{searchPath:h,pattern:w}]}else{if(v==="./"||v===".\\")return[];{const h=v.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(h){const w=h[1],R=this.workspaceContextService.getWorkspace().folders.filter(N=>N.name===w);if(R.length)return R.map(N=>{const j=h[2];return{searchPath:N.uri,pattern:j&&o(j)}});{const N=a.localize(0,null,w);throw new Error(N)}}}}return[]}resolveOneSearchPathPattern(v,h){const w=v.pattern&&h?`${v.pattern}/${h}`:v.pattern||h,R=[{searchPath:v.searchPath,pattern:w}];return w&&!w.endsWith("**")&&R.push({searchPath:v.searchPath,pattern:w+"/**"}),R}getFolderQueryForSearchPath(v,h,w){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(v.searchPath),h,w,!1);return R?Object.assign(Object.assign({},R),{includePattern:v.pattern}):null}getFolderQueryForRoot(v,h,w,R){let N;const j=f.URI.isUri(v)?v:v.uri;if(w.searchPaths){const U=w.searchPaths.filter(F=>(0,k.isEqual)(F.searchPath,j))[0];if(U&&!U.pattern)return null;U&&(N=U.pattern)}const re=this.configurationService.getValue({resource:j}),V=this.getExcludesForFolder(re,h),W=Object.assign(Object.assign({},V||{}),N||{}),$=f.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:j,folderName:R?$:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:re.files&&re.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!re.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!re.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!re.search.followSymlinks}}};l=Ve([xe(0,u.IConfigurationService),xe(1,E.IWorkspaceContextService),xe(2,b.IEditorGroupsService),xe(3,S.IPathService)],l),e.QueryBuilder=l;function m(p){const v=p.match(/[\*\{\}\(\)\[\]\?]/);if(v){const h=v.index,w=p.substr(0,h).match(/[/|\\][^/\\]*$/);if(w){let R=p.substr(0,w.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:p.substr((w.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((v,h)=>(v[h]=!0,v),Object.create(null)):void 0}function n(p){return T.splitGlobAware(p,",").map(v=>v.trim()).filter(v=>!!v.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function o(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(p,v){p=_.distinct(p,R=>R.toString());const h=[],w=v.getWorkspace();return p&&p.forEach(R=>{let N;if(v.getWorkbenchState()===2)N=(0,k.relativePath)(w.folders[0].uri,R),N&&N!=="."&&(N="./"+N);else{const j=v.getWorkspaceFolder(R);if(j){const re=j.name;if(w.folders.filter(W=>W.name===re).length===1){const W=(0,k.relativePath)(j.uri,R);W===""?N=`./${j.name}`:N=`./${j.name}/${W}`}else N=R.fsPath}}N&&h.push(N)}),h}e.resolveResourcesForSearchIncludes=c}),define(ge[262],pe([0,1,25,2,21,18,4,261,31,60]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function C(u,E){const b=E.activationEvents;if(!b)return Promise.resolve(void 0);const S=[],d=[];for(const r of b)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||u.forceUsingSearch?d.push(o):S.push(o)}if(S.length===0&&d.length===0)return Promise.resolve(void 0);let l;const m=new Promise((r,o)=>{l=r}),t=r=>l({activationEvent:r}),n=Promise.all(S.map(r=>f(u,r,t))).then(()=>{}),s=g(u,E.identifier,d,t);return Promise.all([n,s]).then(()=>{l(void 0)}),m}e.checkActivateWorkspaceContainsExtension=C;async function f(u,E,b){for(const S of u.folders)if(await u.exists(_.joinPath(I.URI.revive(S),E))){b(`workspaceContains:${E}`);return}}async function g(u,E,b,S){if(b.length===0)return Promise.resolve(void 0);const d=new T.CancellationTokenSource,l=u.checkExists(u.folders,b,d.token),m=setTimeout(async()=>{d.cancel(),S(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await l}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}d.dispose(),clearTimeout(m),t&&S(`workspaceContains:${b.join(",")}`)}function a(u,E,b,S){const d=u.get(y.IInstantiationService),l=u.get(D.ISearchService),t=d.createInstance(P.QueryBuilder).file(E.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:b,exists:!0});return l.fileSearch(t,S).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,_):T?T.value=_:e.set(G,_),_},Ue=this&&this.__classPrivateFieldGet||function(G,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(G):I?I.value:e.get(G)};define(ge[42],pe([0,1,162,8,68,25,13,6,24,2,14,5,35,225,92,32,41,223,18,28,22,196,7,85,4,27,93,15,82,50,34,3,262,90,197]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d,l,m,t,n,s,r,o,c,p,v,h,w,R,N,j){"use strict";var re,V,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let $=class xn extends P.Disposable{constructor(L,O,B,q,Q,de,be,Ae,Ce,Le){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=B,this._initData=be,this._extHostWorkspace=q,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Ce,this._extHostTerminalService=Le,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=L.createChild(new p.ServiceCollection([a.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const z=new Set;this._initData.hostExtensions.forEach(Y=>z.add(d.ExtensionIdentifier.toKey(Y))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Y,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,ee)},actualActivateExtension:async(Y,ee)=>{if(z.has(d.ExtensionIdentifier.toKey(Y)))return await this._mainThreadExtensionsProxy.$activateExtension(Y,ee),new g.HostExtension;const le=this._registry.getExtensionDescription(Y);return this._activateExtension(le,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(L){S.onUnexpectedError(L)}}async deactivateAll(){let L=[];try{L=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(O){}await Promise.all(L)}isActivated(L){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(L):!1}_activateByEvent(L,O){return this._activator.activateByEvent(L,O)}_activateById(L,O){return this._activator.activateById(L,O)}activateByIdWithErrors(L,O){return this._activateById(L,O).then(()=>{const B=this._activator.getActivatedExtension(L);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(L=>this._registry)}getExtensionExports(L){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(L).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const L=D.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then(q=>L.set(k.URI.file(q).fsPath,B))});this._extensionPathIndex=Promise.all(O).then(()=>L)}return this._extensionPathIndex}_deactivate(L){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(L))return O;const B=this._activator.getActivatedExtension(L);if(!B)return O;try{typeof B.module.deactivate=="function"&&(O=Promise.resolve(B.module.deactivate()).then(void 0,q=>Promise.resolve(void 0)))}catch(q){}try{(0,P.dispose)(B.subscriptions)}catch(q){}return O}async _activateExtension(L,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier),this._doActivateExtension(L,O).then(B=>{const q=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(L.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,O),this._logExtensionActivationTimes(L,O,"success",q),B},B=>{throw this._logExtensionActivationTimes(L,O,"failure"),B})}_logExtensionActivationTimes(L,O,B,q){const Q=U(L,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),q||{}),{outcome:B}))}_doActivateExtension(L,O){const B=U(L,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const q=this._getEntryPoint(L);if(!q)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${L.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const Q=new g.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(L.identifier,(0,A.joinPath)(L.extensionLocation,q),Q),this._loadExtensionContext(L)]).then(de=>(T.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),xn._callActivate(this._logService,L.identifier,de[0],de[1],Q))).then(de=>(T.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),de))}_loadExtensionContext(L){const O=new m.ExtensionGlobalMemento(L,this._storage),B=new m.ExtensionMemento(L.identifier.value,!1,this._storage),q=new j.ExtensionSecrets(L,this._secretState),Q=L.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([O.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Ae;return Object.freeze({globalState:O,workspaceState:B,secrets:q,subscriptions:[],get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ce){return I.join(L.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(L))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(L).fsPath},get logPath(){return I.join(be._initData.logsLocation.fsPath,L.identifier.value)},get logUri(){return k.URI.joinPath(be._initData.logsLocation,L.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(L)},get globalStorageUri(){return be._storagePath.globalValue(L)},get extensionMode(){return Q},get extension(){return Ae===void 0&&(Ae=new F(be,L.identifier,L,de)),Ae},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(L),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(L)}})})}static _callActivate(L,O,B,q,Q){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(L,O,B,q,Q).then(de=>new g.ActivatedExtension(!1,null,Q.build(),B,de,q.subscriptions))}static _callActivateOptional(L,O,B,q,Q){if(typeof B.activate=="function")try{Q.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${O.value}`);const de=typeof global=="object"?global:self,be=B.activate.apply(de,[q]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(be).then(Ae=>(Q.activateResolveStop(),Ae))}catch(de){return Promise.reject(de)}else return Promise.resolve(B)}_activateOneStartupFinished(L,O){this._activateById(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:O}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const L of this._registry.getAllExtensionDescriptions())if(L.activationEvents)for(const O of L.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(L,O)}_handleEagerExtensions(){const L=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(O),q=Promise.all([L,B]).then(()=>{});return Promise.race([q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(L){return L.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(L,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(L,O){if(!this.isActivated(O.identifier)){const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:L.map(de=>de.uri),forceUsingSearch:B,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,be,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(de,be,Ae)},Q=await(0,R.checkActivateWorkspaceContainsExtension)(q,O);if(!!Q)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(L){throw console.error(L),L}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:O}=this._initData.environment;if(!L||!O)throw new Error(_.localize(0,null));const B=await this._loadCommonJSModule(null,O,new g.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(_.localize(1,null,O.toString()));return new Promise((q,Q)=>{const de=(Ce,Le)=>{Ce?Q(Ce):q(typeof Le=="number"&&Le>0?1:0)},be=(0,A.originalFSPath)(O),Ae=B.run(be,de);Ae&&Ae.then&&Ae.then(()=>{q(0)}).catch(Ce=>{Q(Ce.toString())})})}async $extensionTestsExit(L){this._logService.info(`extension host terminating: test runner requested exit with code ${L}`),this._logService.info(`exiting with code ${L}`),this._logService.flush(),this._hostUtils.exit(L)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(L,O){return this._resolvers[L]=O,(0,P.toDisposable)(()=>{delete this._resolvers[L]})}async $resolveAuthority(L,O){const B=L.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const q=L.substr(0,B);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const Q=this._resolvers[q];if(!Q)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${q}`);const de=await Q.resolve(L,{resolveAttempt:O});T.mark(`code/extHost/didResolveAuthorityOK/${q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Q));const be={authority:L,host:de.host,port:de.port,connectionToken:de.connectionToken},Ae={extensionHostEnv:de.extensionHostEnv,trust:de.trust};return{type:"ok",value:{authority:be,options:Ae,tunnelInformation:{environmentTunnels:de.environmentTunnels}}}}catch(de){if(T.mark(`code/extHost/didResolveAuthorityError/${q}`),de instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de}}$startExtensionHost(L){return this._registry.keepOnly(L),this._startExtensionHost()}$activateByEvent(L,O){return O===1?this._activateByEvent(L,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(L,!1))}async $activate(L,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(L)?(await this._activateById(L,O),!0):!1}async $deltaExtensions(L,O){L.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(O.map(async q=>{const Q=this._registry.getExtensionDescription(q);if(!!Q){const de=await this._hostUtils.realpath(Q.extensionLocation.fsPath);B.delete(k.URI.file(de).fsPath)}})),await Promise.all(L.map(async q=>{const Q=await this._hostUtils.realpath(q.extensionLocation.fsPath);B.set(k.URI.file(Q).fsPath,q)})),this._registry.deltaExtensions(L,O),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){let O=l.VSBuffer.alloc(L),B=Math.random()%256;for(let q=0;q<L;q++)O.writeUInt8(B,q);return O}async $updateRemoteConnectionData(L){this._remoteConnectionData=L,this._onDidChangeRemoteConnectionData.fire()}};$=Ve([xe(0,s.IInstantiationService),xe(1,e.IHostUtils),xe(2,c.IExtHostRpcService),xe(3,u.IExtHostWorkspace),xe(4,f.IExtHostConfiguration),xe(5,i.ILogService),xe(6,r.IExtHostInitDataService),xe(7,o.IExtensionStoragePaths),xe(8,v.IExtHostTunnelService),xe(9,h.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function U(M,L){return{id:M.identifier.value,name:M.name,extensionVersion:M.version,publisherDisplayName:M.publisher,activationEvents:M.activationEvents?M.activationEvents.join(","):null,isBuiltin:M.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class F{constructor(L,O,B,q){re.set(this,void 0),V.set(this,void 0),W.set(this,void 0),tt(this,re,L,"f"),tt(this,V,O,"f"),tt(this,W,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)(B.extensionLocation)),this.packageJSON=B,this.extensionKind=q}get isActive(){return Ue(this,re,"f").isActivated(Ue(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,re,"f").getExtensionExports(Ue(this,W,"f"))}activate(){return Ue(this,re,"f").activateByIdWithErrors(Ue(this,W,"f"),{startup:!1,extensionId:Ue(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,re=new WeakMap,V=new WeakMap,W=new WeakMap}),define(ge[46],pe([0,1,8,2,3,13,5,7,121,32,42,39,213,35,204,15,4,11,36]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let d=class{constructor(c,p,v,h,w){this._workspaceService=p,this._extensionService=v,this._editorsService=h,this._configurationService=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(N=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,p){const v=c;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let h=`debug:${encodeURIComponent(v.path||"")}`,w="?";return p&&(h+=`${w}session=${encodeURIComponent(p.id)}`,w="&"),h+=`${w}ref=${v.sourceReference}`,I.URI.parse(h)}else{if(v.path)return I.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const p=[];for(const v of c.getAllExtensionDescriptions())if(v.contributes){const h=v.contributes.debuggers;if(h&&h.length>0)for(const w of h)(0,a.isDebuggerMainContribution)(w)&&p.push(w.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(p=>c.push(p)),c}addBreakpoints(c){this.startBreakpoints();const p=c.filter(w=>{const R=w.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,w),!0)});this.fireBreakpointChanges(p,[],[]);const v=[],h=new Map;for(const w of p)if(w instanceof P.SourceBreakpoint){let R=h.get(w.location.uri.toString());R||(R={type:"sourceMulti",uri:w.location.uri,lines:[]},h.set(w.location.uri.toString(),R),v.push(R)),R.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof P.FunctionBreakpoint&&v.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(c){this.startBreakpoints();const p=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],p,[]);const v=p.filter(R=>R instanceof P.SourceBreakpoint).map(R=>R.id),h=p.filter(R=>R instanceof P.FunctionBreakpoint).map(R=>R.id),w=p.filter(R=>R instanceof P.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(v,h,w)}startDebugging(c,p,v){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,repl:v.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,p,v){if(!p)return new P.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:h,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,h),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(c,p,v){if(!v)return new P.Disposable(()=>{});if(!this.definesDebugType(c,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:h,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,h),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(c,p){if(!p)return new P.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:v,factory:p}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==p)})}async $runInTerminal(c,p){return Promise.resolve(void 0)}async $substituteVariables(c,p){if(!this._variableResolver){const[w,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,R)}let v;const h=await this.getFolder(c);return h&&(v={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(v,p)}createDebugAdapter(c,p){if(c.type==="implementation")return new s(c.implementation)}createSignService(){}async $startDASession(c,p){const v=this,h=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const R=this.convertToDto(w),N=this.createDebugAdapter(R,h);if(!N)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const j=N;return this._debugAdapters.set(c,j),this.getDebugAdapterTrackers(h).then(re=>(re&&this._debugAdaptersTrackers.set(c,re),j.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const W=V,$={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(W.arguments.value);$.body={signature:U},j.sendResponse($)}else throw new Error("no signer")}catch(U){$.success=!1,$.message=U.message,j.sendResponse($)}}else re&&re.onDidSendMessage&&re.onDidSendMessage(V),V=(0,a.convertToVSCPaths)(V,!0),v._debugServiceProxy.$acceptDAMessage(c,V)}),j.onError(V=>{re&&re.onError&&re.onError(V),this._debugServiceProxy.$acceptDAError(c,V.name,V.message,V.stack)}),j.onExit(V=>{re&&re.onExit&&re.onExit((0,b.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,b.withNullAsUndefined)(V),void 0)}),re&&re.onWillStartSession&&re.onWillStartSession(),j.startSession()))})}$sendDAMessage(c,p){p=(0,a.convertToDAPaths)(p,!1);const v=this._debugAdaptersTrackers.get(c);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p);const h=this._debugAdapters.get(c);h&&h.sendMessage(p)}$stopDASession(c){const p=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),p&&p.onWillStopSession&&p.onWillStopSession();const v=this._debugAdapters.get(c);return this._debugAdapters.delete(c),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const p=[],v=[],h=[];if(c.added)for(const w of c.added){const R=w.id;if(R&&!this._breakpoints.has(R)){let N;if(w.type==="function")N=new P.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")N=new P.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const j=I.URI.revive(w.uri);N=new P.SourceBreakpoint(new P.Location(j,new P.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}N._id=R,this._breakpoints.set(R,N),p.push(N)}}if(c.removed)for(const w of c.removed){const R=this._breakpoints.get(w);R&&(this._breakpoints.delete(w),v.push(R))}if(c.changed){for(const w of c.changed)if(w.id){const R=this._breakpoints.get(w.id);if(R){if(R instanceof P.FunctionBreakpoint&&w.type==="function"){const N=R;N.enabled=w.enabled,N.condition=w.condition,N.hitCondition=w.hitCondition,N.logMessage=w.logMessage,N.functionName=w.functionName}else if(R instanceof P.SourceBreakpoint&&w.type==="source"){const N=R;N.enabled=w.enabled,N.condition=w.condition,N.hitCondition=w.hitCondition,N.logMessage=w.logMessage,N.location=new P.Location(I.URI.revive(w.uri),new P.Position(w.line,w.character))}h.push(R)}}}this.fireBreakpointChanges(p,v,h)}$provideDebugConfigurations(c,p,v){return(0,A.asPromise)(async()=>{const h=this.getConfigProviderByHandle(c);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(p);return h.provideDebugConfigurations(w,v)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(c,p,v,h){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(p);return w.resolveDebugConfiguration(R,v,h)})}$resolveDebugConfigurationWithSubstitutedVariables(c,p,v,h){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(p);return w.resolveDebugConfigurationWithSubstitutedVariables(R,v,h)})}async $provideDebugAdapter(c,p){const v=this.getAdapterDescriptorFactoryByHandle(c);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(p);return this.getAdapterDescriptor(v,h).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(c){const p=await this.getSession(c);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(c){const p=await this.getSession(c);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,p){const v=await this.getSession(c);v&&v._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(c,p){const h={session:await this.getSession(c),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const p=this._adapterFactories.filter(v=>v.type===c);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(c){const p=this._adapterFactories.filter(v=>v.handle===c);if(p.length>0)return p[0].factory}getConfigProviderByHandle(c){const p=this._configProviders.filter(v=>v.handle===c);if(p.length>0)return p[0].provider}definesDebugType(c,p){if(c.contributes){const v=c.contributes.debuggers;if(v&&v.length>0){for(const h of v)if(h.label&&h.type&&h.type===p)return!0}}return!1}getDebugAdapterTrackers(c){const v=c.configuration.type,h=this._trackerFactories.filter(w=>w.type===v||w.type==="*").map(w=>(0,A.asPromise)(()=>w.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(h).then(w=>{const R=w.filter(N=>!!N);if(R.length>0)return new n(R)}),new Promise((w,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(c,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new P.DebugAdapterServer(v));if(c){const w=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,w))).then(R=>{if(R)return R})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,h))}daExecutableFromPackage(c,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,p,v){(c.length>0||p.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:p,changed:v}))}async getSession(c){if(c)if(typeof c=="string"){const p=this._debugSessions.get(c);if(p)return p}else{let p=this._debugSessions.get(c.id);if(!p){const v=await this.getFolder(c.folderUri);p=new l(this._debugServiceProxy,c.id,c.type,c.name,v,c.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(c){if(c){const p=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};d=Ve([xe(0,u.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,i.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,g.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class l{constructor(c,p,v,h,w,R){this._debugServiceProxy=c,this._id=p,this._type=v,this._name=h,this._workspaceFolder=w,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,p)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=l;class m{constructor(c){this.value=Object.freeze({append(p){c.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=m;class t extends f.AbstractVariableResolverService{constructor(c,p,v,h){super({getFolderUri:w=>{const R=c.filter(N=>N.name===w);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(w,R)=>v.getConfiguration(void 0,w).get(R),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const w=p.activeEditor();if(w)return _.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&h){const w=p.activeEditor();if(w){const R=h.getWorkspaceFolder(w.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(p){const w=p.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(p){const w=p.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(p=>p.onError?p.onError(c):void 0)}onExit(c,p){this.trackers.forEach(v=>v.onExit?v.onExit(c,p):void 0)}}class s extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends d{constructor(c,p,v,h,w){super(c,p,v,h,w)}createVariableResolver(c,p,v){return new t(c,p,v)}};r=Ve([xe(0,u.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,i.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,g.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(ge[263],pe([0,1,68,2,5,35,41,28,15,27,4,42,36,14]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(d,l,m,t,n,s,r){this._apiFactory=d,this._extensionRegistry=l,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,l,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,l,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let l of d.nodeModuleName)this._factories.set(l,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(l=>d.alternativeModuleName(l))}};a=Ve([xe(2,i.IInstantiationService),xe(3,A.IExtHostConfiguration),xe(4,C.IExtHostExtensionService),xe(5,k.IExtHostInitDataService),xe(6,g.ILogService)],a),e.RequireInterceptor=a;class u{constructor(d,l,m,t,n){this._apiFactory=d,this._extensionPaths=l,this._extensionRegistry=m,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,l){const m=this._extensionPaths.findSubstr(l.fsPath);if(m){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(d,l){this.nodeModuleName="keytar";const{environment:m}=l,t=d.getProxy(T.MainContext.MainThreadKeytar);if(m.appRoot){let n=m.appRoot.fsPath;f.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(d,l){return this._impl}alternativeModuleName(d){const l=d.length;if(!(l<=7||!this.alternativeNames)){const m=l-7;if((d.charAt(m)==="/"||d.charAt(m)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};E=Ve([xe(0,D.IExtHostRpcService),xe(1,k.IExtHostInitDataService)],E);let b=class{constructor(d,l,m){this._extensionPaths=d,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(T.MainContext.MainThreadTelemetry);const t=m.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=I.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(d,l,m){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(d),this._impl}callOriginal(d,l){return this.sendNoForwardTelemetry(),this._original(d,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([xe(2,D.IExtHostRpcService)],b)}),define(ge[264],pe([0,1,168,10,7,205,32,42,39,35,34,15,46,189,208,13]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends f.ExtHostDebugServiceBase{constructor(d,l,m,t,n,s){super(d,l,m,t,n);this._terminalService=s,this._integratedTerminalInstances=new b}createDebugAdapter(d,l){switch(d.type){case"server":return new A.SocketDebugAdapter(d);case"pipeServer":return new A.NamedPipeDebugAdapter(d);case"executable":return new A.ExecutableDebugAdapter(d,l.type)}return super.createDebugAdapter(d,l)}daExecutableFromPackage(d,l){const m=A.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),d.type);if(m)return new T.DebugAdapterExecutable(m.command,m.args,m.options)}createSignService(){return new g.SignService}async $runInTerminal(d,l){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(w=>{this._integratedTerminalInstances.onTerminalClosed(w)}));const m=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,m),n=this._terminalService.getDefaultShellArgs(!0,m),s=JSON.stringify({shell:t,shellArgs:n});let r=await this._integratedTerminalInstances.checkout(s),o,c=!1;if(r)o=d.cwd;else{const w={shellPath:t,shellArgs:n,cwd:d.cwd,name:d.title||_.localize(0,null)};c=!0,r=this._terminalService.createTerminalFromOptions(w,!0),this._integratedTerminalInstances.insert(r,s)}r.show(!0);const p=await r.processId;c?await new Promise(w=>setTimeout(w,1e3)):m.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):I.isWindows?r.sendText("cls"):r.sendText("clear"));const v=(0,a.prepareCommand)(t,d.args,o,d.env);r.sendText(v);const h=this.onDidTerminateDebugSession(w=>{w.id===l&&(this._integratedTerminalInstances.free(r),h.dispose())});return p}else if(d.kind==="external")return(0,a.runInExternalTerminal)(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,l)}createVariableResolver(d,l,m){return new f.ExtHostVariableResolverService(d,l,m,this._workspaceService)}};E=Ve([xe(0,C.IExtHostRpcService),xe(1,y.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,D.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,i.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class b{constructor(){this._terminalInstances=new Map}async checkout(d){const m=[...this._terminalInstances.entries()].map(([t,n])=>(0,u.createCancelablePromise)(async s=>{if(n.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const r=Date.now();return n.lastUsedAt+b.minUseDelay>r||s.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=r,t)}));return await(0,u.firstParallel)(m,t=>!!t)}insert(d,l){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:l})}free(d){const l=this._terminalInstances.get(d);l&&(l.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}b.minUseDelay=1e3}),define(ge[265],pe([0,1,8,2,78,32,46,39,35,34,15,27,67,12,14,63]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends f.ExtHostTaskBase{constructor(S,d,l,m,t,n,s,r){super(S,d,l,m,t,n,s,r);this.workspaceService=l,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(S,d){const l=d;if(!d.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const m=f.TaskHandleDTO.from(l,this.workspaceService),t=await this._proxy.$getTaskExecution(m);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,d);return this._proxy.$executeTask(m).catch(()=>{}),n}else{const m=f.TaskDTO.from(d,S);if(m===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(m.execution)&&await this.addCustomExecution(m,d,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(m),d);return this._proxy.$executeTask(m).catch(()=>{}),t}}provideTasksInternal(S,d,l,m){const t=[];if(m)for(let n of m){this.checkDeprecation(n,l),(!n.definition||!S[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const s=f.TaskDTO.from(n,l.extension);s&&(t.push(s),f.CustomExecutionDTO.is(s.execution)&&d.push(this.addCustomExecution(s,n,!0)))}return{tasks:t,extension:l.extension}}async resolveTaskInternal(S){return S}async getVariableResolver(S){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(S,this._editorService,d,this.workspaceService)}return this._variableResolver}async $resolveVariables(S,d){const l=I.URI.revive(S),m={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(l),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const s=await this.getVariableResolver(n),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let o of d.variables)m.variables[o]=await s.resolveAsync(r,o);if(d.process!==void 0){let o;if(d.process.path!==void 0){o=d.process.path.split(_.delimiter);for(let c=0;c<o.length;c++)o[c]=await s.resolveAsync(r,o[c])}m.process=await T.win32.findExecutable(await s.resolveAsync(r,d.process.name),d.process.cwd!==void 0?await s.resolveAsync(r,d.process.cwd):void 0,o)}return m}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(S,d,l){return T.win32.findExecutable(S,d,l)}};E=Ve([xe(0,i.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,P.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,a.ILogService),xe(7,u.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(ge[266],pe([0,1,10,11,30,149,14,35,46,39,15,34,32,211,212]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let u=class extends C.BaseExtHostTerminalService{constructor(b,S,d,l,m){super(!0,b);this._extHostConfiguration=S,this._extHostWorkspace=d,this._extHostDocumentsAndEditors=l,this._logService=m,(0,A.getSystemShell)(_.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(b,S,d){const l=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:b,shellPath:S,shellArgs:d},b);return this._terminals.push(l),l.create(S,d),l.value}createTerminalFromOptions(b,S){const d=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),b,b.name);return this._terminals.push(d),d.create((0,I.withNullAsUndefined)(b.shellPath),(0,I.withNullAsUndefined)(b.shellArgs),(0,I.withNullAsUndefined)(b.cwd),(0,I.withNullAsUndefined)(b.env),(0,I.withNullAsUndefined)(b.icon),(0,I.withNullAsUndefined)(b.message),void 0,(0,I.withNullAsUndefined)(b.strictEnv),(0,I.withNullAsUndefined)(b.hideFromUser),(0,I.withNullAsUndefined)(S),!0),d.value}getDefaultShell(b,S){var d;const l=m=>S.getConfiguration(m.substr(0,m.lastIndexOf("."))).get(m.substr(m.lastIndexOf(".")+1));return g.getDefaultShell(l,(d=this._defaultShell)!==null&&d!==void 0?d:(0,A.getSystemShellSync)(_.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,g.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService,b)}getDefaultShellArgs(b,S){const d=l=>S.getConfiguration(l.substr(0,l.lastIndexOf("."))).get(l.substr(l.lastIndexOf(".")+1));return g.getDefaultShellArgs(d,b,g.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const b=this._extHostDocumentsAndEditors.activeEditor();b&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(b.document.uri))}async _updateVariableResolver(){const b=await this._extHostConfiguration.getConfigProvider(),S=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(S||[],this._extHostDocumentsAndEditors,b),this._variableResolver}async $getAvailableProfiles(b){const S=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(b,void 0,this._logService,S,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(b){const S=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(b,S),args:this.getDefaultShellArgs(b,S)}}};u=Ve([xe(0,i.IExtHostRpcService),xe(1,P.IExtHostConfiguration),xe(2,f.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,y.ILogService)],u),e.ExtHostTerminalService=u}),define(ge[267],pe([0,1,13,18,68,6,2,5,257,14,79,82,27,185,15,62,42,34]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(l,m,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new D.RPCProtocol(l,null,n);m=S._transform(m,s);const r=new C.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},m)),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(s)),r.set(u.IURITransformerService,new u.URITransformerService(n)),r.set(E.IHostUtils,t);const o=new g.InstantiationService(r,!0),c=o.invokeFunction(w=>w.get(b.IExtHostTerminalService));this._disposables.add(c),this._logService=o.invokeFunction(w=>w.get(k.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=o.invokeFunction(w=>w.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(R,N)=>{let j="",re,V;for(const W of N)j+=`
	at ${W.toString()}`,V=W.getFileName(),!re&&V&&(re=w.findSubstr(V));return p.set(R,re),`${R.name||"Error"}: ${R.message||""}${j}`}});const v=s.getProxy(P.MainContext.MainThreadExtensionService),h=s.getProxy(P.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(w=>{const R=I.transformErrorForSerialization(w),N=p.get(w);N?v.$onExtensionRuntimeError(N.identifier,R):h.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,m){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(m.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(m.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(m.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(m.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(m.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(m.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(m.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(m.transformIncomingURIs(l.logFile)),l.workspace=m.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=S}),define(ge[268],pe([0,1,8,21,59,33,25,47,31]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,g,a){this.config=f,this.provider=g,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&A.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&A.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const g=this.config.folderQueries||[];return new Promise((a,u)=>{const E=b=>{this.resultCount++,f(b)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const S=b.toString(),d=_.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,d)||this.matchFile(E,{base:b,basename:d})}),Promise.all(g.map(b=>this.searchInFolder(b,E))).then(b=>{a({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{u(new Error((0,T.toErrorMessage)(b)))})})}async searchInFolder(f,g){const a=new I.CancellationTokenSource,u=this.getSearchOptionsForFolder(f),E=this.initDirectoryTree(),b=new D.QueryGlobTester(this.config,f),S=!b.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(a),d=P.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,a.token),m=d.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const s=_.posix.relative(f.folder.path,n.path);if(S){const r=_.basename(n.path);this.matchFile(g,{base:f.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(E,f.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,b,g),{providerTime:m,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(f){const g=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:a,includes:g,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},g,a,u){if(a===this.filePattern){const b=_.basename(this.filePattern);this.matchFile(u,{base:g,relativePath:this.filePattern,basename:b})}function E(b){const S=_.basename(b),d=_.dirname(b);let l=f[d];l||(l=f[d]=[],E(d)),l.push({base:g,relativePath:b,basename:S})}E(a)}matchDirectoryTree({rootEntries:f,pathToEntries:g},a,u){const E=this,b=this.filePattern;function S(d){const l=A.hasSiblingFn(()=>d.map(m=>m.basename));for(let m=0,t=d.length;m<t;m++){const n=d[m],{relativePath:s,basename:r}=n;if(!!a.includedInQuerySync(s,r,b!==r?l:void 0)){const o=g[s];if(o)S(o);else{if(s===b)continue;E.matchFile(u,n)}if(E.isLimitHit)break}}}S(f)}matchFile(f,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(g))}}class i{constructor(){this.sessions=new Map}fileSearch(f,g,a,u){const E=this.getSessionTokenSource(f.cacheKey),b=new k(f,g,E&&E.token);let S=0;const d=l=>{S+=l.length,a(l.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(b,i.BATCH_SIZE,d,u).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:l.stats}}))}clearCache(f){const g=this.getSessionTokenSource(f);g&&g.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new I.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,g,a,u){u.onCancellationRequested(()=>{f.cancel()});const E=S=>{S&&(b.push(S),g>0&&b.length>=g&&(a(b),b=[]))};let b=[];return f.search(E).then(S=>(b.length&&a(b),S),S=>(b.length&&a(b),Promise.reject(S)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ge[128],pe([0,1,8,19,21,59,25,33,2,31,12,11]),function(G,e,_,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class f{constructor(d,l,m){this.query=d,this.provider=l,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,l){const m=this.query.folderQueries||[],t=new T.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new a(d);let r=!1;const o=(c,p)=>{if(!r&&!this.isLimitHit){const v=this.resultSize(c);E(c)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const h=this.resultSize(c);this.resultCount+=h,(h>0||!E(c))&&this.collector.add(c,p)}};Promise.all(m.map((c,p)=>this.searchInFolder(c,v=>o(v,p),t.token))).then(c=>{t.dispose(),this.collector.flush();const p=c.some(v=>!!v&&!!v.limitHit);n({limitHit:this.isLimitHit||p,messages:(0,I.flatten)(c.map(v=>(v==null?void 0:v.message)?(0,C.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const p=(0,A.toErrorMessage)(c);s(new Error(p))})})}resultSize(d){return E(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,l){const m=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:m.slice(0,l),preview:{matches:t.slice(0,l),text:d.preview.text},uri:d.uri}}async searchInFolder(d,l,m){const t=new k.QueryGlobTester(this.query,d),n=[],s={report:c=>{if(!!this.validateProviderResult(c)){const p=d.folder.scheme===i.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,v=y.relativePath(d.folder,c.uri);v&&n.push(t.includedInQuery(v,_.basename(v),p).then(h=>{h&&l(c)}))}}},r=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,s,m);return await Promise.all(n),o}validateProviderResult(d){if(E(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const l=(0,k.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),m=(0,k.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:m,includes:l,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=f;function g(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class a{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,l=>this.sendItems(l))}add(d,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(u(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=a;function u(S){return E(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class b{constructor(d,l){this.maxBatchSize=d,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,l){!d||this.addItemToBatch(d,l)}addItems(d,l){!d||this.addItemsToBatch(d,l)}addItemToBatch(d,l){this.batch.push(d),this.batchSize+=l,this.onUpdate()}addItemsToBatch(d,l){this.batch=this.batch.concat(d),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(ge[69],pe([0,1,6,5,4,268,15,62,14,2,128]),function(G,e,_,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(u,E,b){this.extHostRpc=u,this._uriTransformer=E,this._logService=b,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,E){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const b=this._handlePool++;return this._textSearchProvider.set(b,E),this._proxy.$registerTextSearchProvider(b,this._transformScheme(u)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(u,E){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const b=this._handlePool++;return this._fileSearchProvider.set(b,E),this._proxy.$registerFileSearchProvider(b,this._transformScheme(u)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(u,E,b,S){const d=f(b),l=this._fileSearchProvider.get(u);if(l)return this._fileSearchManager.fileSearch(d,l,m=>{this._proxy.$handleFileMatch(u,E,m.map(t=>t.resource))},S);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,E,b,S){const d=this._textSearchProvider.get(u);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const l=f(b);return this.createTextSearchManager(l,d).search(t=>this._proxy.$handleTextMatch(u,E,t),S)}createTextSearchManager(u,E){return new i.TextSearchManager(u,E,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};C=Ve([xe(0,y.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,D.ILogService)],C),e.ExtHostSearch=C;function f(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(g),extraFileResources:a.extraFileResources&&a.extraFileResources.map(u=>k.URI.revive(u))})}e.reviveQuery=f;function g(a){return Object.assign(Object.assign({},a),{folder:k.URI.revive(a.folder)})}}),define(ge[269],pe([0,1,159,21,18,3,57,2,151,108,141,77,45,5,231,230,51,232,35,233,234,235,216,236,39,42,237,217,239,240,241,64,220,244,245,246,92,34,247,221,20,7,250,65,127,32,41,53,201,238,117,126,67,46,69,14,62,15,27,242,199,50,63,228,248,198,93,91,253,251,252,229,61,260,249,90,195,119,243,85,66]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d,l,m,t,n,s,r,o,c,p,v,h,w,R,N,j,re,V,W,$,U,F,M,L,O,B,q,Q,de,be,Ae,Ce,Le,z,Y,ee,le,me,De,Oe,we,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze,$e,Je,K,se,he,J,ne,ce,ve,ye,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function He(We){const Ge=We.get(Oe.IExtHostInitDataService),nt=We.get(K.IExtHostFileSystemInfo),dt=We.get(_e.IExtHostConsumerFileSystem),it=We.get(r.IExtHostExtensionService),Ye=We.get(q.IExtHostWorkspace),mt=We.get(ce.IExtHostTelemetry),wt=We.get(S.IExtHostConfiguration),Ee=We.get(me.IURITransformerService),fe=We.get(De.IExtHostRpcService),ae=We.get(V.IExtHostStorage),Z=We.get(ie.IExtensionStoragePaths),Fe=We.get(le.ILogService),Te=We.get(Re.IExtHostTunnelService),Qe=We.get(Be.IExtHostApiDeprecationService),Ze=We.get(B.IExtHostWindow),ct=We.get(J.IExtHostSecretState);fe.set(g.ExtHostContext.ExtHostFileSystemInfo,nt),fe.set(g.ExtHostContext.ExtHostLogService,Fe),fe.set(g.ExtHostContext.ExtHostWorkspace,Ye),fe.set(g.ExtHostContext.ExtHostConfiguration,wt),fe.set(g.ExtHostContext.ExtHostExtensionService,it),fe.set(g.ExtHostContext.ExtHostStorage,ae),fe.set(g.ExtHostContext.ExtHostTunnelService,Te),fe.set(g.ExtHostContext.ExtHostWindow,Ze),fe.set(g.ExtHostContext.ExtHostSecretState,ct),fe.set(g.ExtHostContext.ExtHostTelemetry,mt);const ht=fe.set(g.ExtHostContext.ExtHostDecorations,We.get(Le.IExtHostDecorations)),Xe=fe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,We.get(s.IExtHostDocumentsAndEditors)),ot=fe.set(g.ExtHostContext.ExtHostCommands,We.get(E.IExtHostCommands)),ft=fe.set(g.ExtHostContext.ExtHostTerminalService,We.get(W.IExtHostTerminalService)),at=fe.set(g.ExtHostContext.ExtHostDebugService,We.get(Y.IExtHostDebugService)),St=fe.set(g.ExtHostContext.ExtHostSearch,We.get(ee.IExtHostSearch)),vt=fe.set(g.ExtHostContext.ExtHostTask,We.get(z.IExtHostTask)),kt=fe.set(g.ExtHostContext.ExtHostOutputService,We.get(w.IExtHostOutputService)),At=fe.set(g.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),Tt=fe.set(g.ExtHostContext.ExtHostUrls,new L.ExtHostUrls(fe)),_t=fe.set(g.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(fe,Xe)),Jt=fe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(fe,Xe,Fe)),Zt=fe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Fe,_t,fe.getProxy(g.MainContext.MainThreadBulkEdits))),gt=fe.set(g.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(fe,ot,Xe,_t,Fe,Z)),en=fe.set(g.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(fe,Ge,gt)),Dt=fe.set(g.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(fe,Xe)),Kt=fe.set(g.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(fe.getProxy(g.MainContext.MainThreadTreeViews),ot,Fe)),tn=fe.set(g.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(fe.getProxy(g.MainContext.MainThreadEditorInsets),Dt,Ge.environment)),Gt=fe.set(g.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(fe,Fe)),lt=fe.set(g.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(fe,Ee,_t,ot,Gt,Fe,Qe)),nn=fe.set(g.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(fe,lt)),Rt=fe.set(g.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(fe,Fe,Xe)),Bt=fe.set(g.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(fe,Ye,ot)),mn=fe.set(g.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(fe,ot,Fe)),Sn=fe.set(g.ExtHostContext.ExtHostComments,new b.ExtHostComments(fe,ot,_t)),gn=fe.set(g.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(fe.getProxy(g.MainContext.MainThreadProgress))),rn=fe.set(g.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(fe)),Qt=fe.set(g.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(fe)),Nt=fe.set(g.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(fe)),yn=fe.set(g.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(fe,ot)),sn=fe.set(g.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(fe,Ge.environment,Ye,Fe,Qe)),on=fe.set(g.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,sn,Ye)),Xt=fe.set(g.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(fe,_t,Z,sn,on)),Dn=fe.set(g.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(fe,sn)),Lt=fe.set(g.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(fe,Xe,Ye)),an=fe.set(g.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(fe)),Cn=(0,de.values)(g.ExtHostContext);fe.assertRegistered(Cn);const Wt=new Je.ExtHostBulkEdits(fe,Xe),ln=new u.ExtHostClipboard(fe),Ut=new h.ExtHostMessageService(fe,Fe),Ft=new l.ExtHostDialogs(fe),pn=new re.ExtHostStatusBar(fe,ot.converter),$t=new v.ExtHostLanguages(fe,_t);return a.ExtHostApiCommands.register(ot),function(Me,cn,un){const pt=function(){let te=!Me.isUnderDevelopment;function ue(Ie){te||(Fe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ie(rt){if(Array.isArray(rt))rt.forEach(Ie);else if(typeof rt=="string")ue(rt);else{const bt=rt;typeof bt.scheme=="undefined"&&ue(rt),!Me.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Me)}return rt}}(),kn={getSession(te,ue,Ie){return Nt.getSession(Me,te,ue,Ie)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(te,ue,Ie,rt){return Nt.registerAuthenticationProvider(te,ue,Ie,rt)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Me),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Me),Nt.providers},logout(te,ue){return(0,Q.checkProposedApiEnabled)(Me),Nt.removeSession(te,ue)}},Pn={registerCommand(te,ue,Ie){return ot.registerCommand(!0,te,ue,Ie)},registerTextEditorCommand(te,ue,Ie){return ot.registerCommand(!0,te,(...rt)=>{const bt=Dt.getActiveTextEditor();if(!bt){Fe.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(H=>{ue.apply(Ie,[bt,H,...rt])}).then(H=>{H||Fe.warn("Edits from command "+te+" were not applied.")},H=>{Fe.warn("An error occurred while running command "+te,H)})})},registerDiffInformationCommand:(te,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),ot.registerCommand(!0,te,async(...rt)=>{const bt=Xe.activeEditor(!0);if(!bt){Fe.warn("Cannot execute "+te+" because there is no active text editor.");return}const H=await Dt.getDiffInformation(bt.id);ue.apply(Ie,[H,...rt])})),executeCommand(te,...ue){return ot.executeCommand(te,...ue)},getCommands(te=!1){return ot.getCommands(te)}},vn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var te,ue;return(ue=(te=Ge.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return ft.getDefaultShell(!1,un)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,ue){return Ze.openUri(te,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(te){return te.scheme===Ge.environment.appUriScheme?Tt.createAppUri(te):Ze.asExternalUri(te,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ce.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(vn);const Yt=Ge.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,In={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.registerTestController(Me.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Me),Lt.runTests(te)},createTestItem(te,ue){return new M.TestItemImpl(te.id,te.label,te.uri,ue)},createTestRunTask(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),Lt.createTestRunTask(Me.identifier.value,te,ue,Ie)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Me),Lt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Me),Lt.results}},An={getExtension(te){const ue=cn.getExtensionDescription(te);if(ue)return new r.Extension(it,Me.identifier,ue,Yt)},get all(){return cn.getAllExtensionDescriptions().map(te=>new r.Extension(it,Me.identifier,te,Yt))},get onDidChange(){return cn.onDidChange}},Tn={createDiagnosticCollection(te){return Gt.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:te=>Gt.getDiagnostics(te),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(te,ue){return $t.changeLanguage(te.uri,ue)},match(te,ue){return(0,C.score)(F.LanguageSelector.from(te),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(te,ue,Ie){return lt.registerCodeActionProvider(Me,pt(te),ue,Ie)},registerCodeLensProvider(te,ue){return lt.registerCodeLensProvider(Me,pt(te),ue)},registerDefinitionProvider(te,ue){return lt.registerDefinitionProvider(Me,pt(te),ue)},registerDeclarationProvider(te,ue){return lt.registerDeclarationProvider(Me,pt(te),ue)},registerImplementationProvider(te,ue){return lt.registerImplementationProvider(Me,pt(te),ue)},registerTypeDefinitionProvider(te,ue){return lt.registerTypeDefinitionProvider(Me,pt(te),ue)},registerHoverProvider(te,ue){return lt.registerHoverProvider(Me,pt(te),ue,Me.identifier)},registerEvaluatableExpressionProvider(te,ue){return lt.registerEvaluatableExpressionProvider(Me,pt(te),ue,Me.identifier)},registerInlineValuesProvider(te,ue){return lt.registerInlineValuesProvider(Me,pt(te),ue,Me.identifier)},registerDocumentHighlightProvider(te,ue){return lt.registerDocumentHighlightProvider(Me,pt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return lt.registerLinkedEditingRangeProvider(Me,pt(te),ue)},registerReferenceProvider(te,ue){return lt.registerReferenceProvider(Me,pt(te),ue)},registerRenameProvider(te,ue){return lt.registerRenameProvider(Me,pt(te),ue)},registerDocumentSymbolProvider(te,ue,Ie){return lt.registerDocumentSymbolProvider(Me,pt(te),ue,Ie)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,ue){return lt.registerDocumentFormattingEditProvider(Me,pt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return lt.registerDocumentRangeFormattingEditProvider(Me,pt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Ie,...rt){return lt.registerOnTypeFormattingEditProvider(Me,pt(te),ue,[Ie].concat(rt))},registerDocumentSemanticTokensProvider(te,ue,Ie){return lt.registerDocumentSemanticTokensProvider(Me,pt(te),ue,Ie)},registerDocumentRangeSemanticTokensProvider(te,ue,Ie){return lt.registerDocumentRangeSemanticTokensProvider(Me,pt(te),ue,Ie)},registerSignatureHelpProvider(te,ue,Ie,...rt){return typeof Ie=="object"?lt.registerSignatureHelpProvider(Me,pt(te),ue,Ie):lt.registerSignatureHelpProvider(Me,pt(te),ue,typeof Ie=="undefined"?[]:[Ie,...rt])},registerCompletionItemProvider(te,ue,...Ie){return lt.registerCompletionItemProvider(Me,pt(te),ue,Ie)},registerDocumentLinkProvider(te,ue){return lt.registerDocumentLinkProvider(Me,pt(te),ue)},registerColorProvider(te,ue){return lt.registerColorProvider(Me,pt(te),ue)},registerFoldingRangeProvider(te,ue){return lt.registerFoldingRangeProvider(Me,pt(te),ue)},registerSelectionRangeProvider(te,ue){return lt.registerSelectionRangeProvider(Me,te,ue)},registerCallHierarchyProvider(te,ue){return lt.registerCallHierarchyProvider(Me,te,ue)},setLanguageConfiguration:(te,ue)=>lt.setLanguageConfiguration(Me,te,ue),getTokenInformationAtPosition(te,ue){return(0,Q.checkProposedApiEnabled)(Me),$t.tokenAtPosition(te,ue)},registerInlineHintsProvider(te,ue){return(0,Q.checkProposedApiEnabled)(Me),lt.registerInlineHintsProvider(Me,te,ue)}},Rn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,ue,Ie){const rt=await(P.URI.isUri(te)?Promise.resolve(wn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(rt,ue,Ie)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,ue,Ie){return Dt.onDidChangeActiveTextEditor(te,ue,Ie)},onDidChangeVisibleTextEditors(te,ue,Ie){return Dt.onDidChangeVisibleTextEditors(te,ue,Ie)},onDidChangeTextEditorSelection(te,ue,Ie){return Dt.onDidChangeTextEditorSelection(te,ue,Ie)},onDidChangeTextEditorOptions(te,ue,Ie){return Dt.onDidChangeTextEditorOptions(te,ue,Ie)},onDidChangeTextEditorVisibleRanges(te,ue,Ie){return Dt.onDidChangeTextEditorVisibleRanges(te,ue,Ie)},onDidChangeTextEditorViewColumn(te,ue,Ie){return Dt.onDidChangeTextEditorViewColumn(te,ue,Ie)},onDidCloseTerminal(te,ue,Ie){return ft.onDidCloseTerminal(te,ue,Ie)},onDidOpenTerminal(te,ue,Ie){return ft.onDidOpenTerminal(te,ue,Ie)},onDidChangeActiveTerminal(te,ue,Ie){return ft.onDidChangeActiveTerminal(te,ue,Ie)},onDidChangeTerminalDimensions(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(te,ue,Ie)},onDidWriteTerminalData(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(te,ue,Ie)},get state(){return Ze.state},onDidChangeWindowState(te,ue,Ie){return Ze.onDidChangeWindowState(te,ue,Ie)},showInformationMessage(te,...ue){return Ut.showMessage(Me,y.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Ut.showMessage(Me,y.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Ut.showMessage(Me,y.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Ie){return Bt.showQuickPick(te,!!Me.enableProposedApi,ue,Ie)},showWorkspaceFolderPick(te){return Bt.showWorkspaceFolderPick(te)},showInputBox(te,ue){return Bt.showInput(te,ue)},showOpenDialog(te){return Ft.showOpenDialog(te)},showSaveDialog(te){return Ft.showSaveDialog(te)},createStatusBarItem(te,ue){let Ie,rt,bt,H;return te&&typeof te!="number"?(Ie=te.id,rt=te.name,bt=te.alignment,ue=te.priority,H=te.accessibilityInformation):(Ie=Me.identifier.value,rt=_.localize(0,null,Me.displayName||Me.name),bt=te),pn.createStatusBarEntry(Ie,rt,bt,ue,H)},setStatusBarMessage(te,ue){return pn.setStatusBarMessage(te,ue)},withScmProgress(te){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),gn.withProgress(Me,{location:M.ProgressLocation.SourceControl},(ue,Ie)=>te({report(rt){}}))},withProgress(te,ue){return gn.withProgress(Me,te,ue)},createOutputChannel(te){return kt.createOutputChannel(te)},createWebviewPanel(te,ue,Ie,rt){return on.createWebviewPanel(Me,te,ue,Ie,rt)},createWebviewTextEditorInset(te,ue,Ie,rt){return(0,Q.checkProposedApiEnabled)(Me),tn.createWebviewEditorInset(te,ue,Ie,rt,Me)},createTerminal(te,ue,Ie){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):(te.message&&(0,Q.checkProposedApiEnabled)(Me),te.icon&&(0,Q.checkProposedApiEnabled)(Me),ft.createTerminalFromOptions(te)):ft.createTerminal(te,ue,Ie)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTreeDataProvider(te,ue){return Kt.registerTreeDataProvider(te,ue,Me)},createTreeView(te,ue){return Kt.createTreeView(te,ue,Me)},registerWebviewPanelSerializer:(te,ue)=>on.registerWebviewPanelSerializer(Me,te,ue),registerCustomEditorProvider:(te,ue,Ie={})=>Xt.registerCustomEditorProvider(Me,te,ue,Ie),registerFileDecorationProvider(te){return ht.registerFileDecorationProvider(te,Me.identifier)},registerUriHandler(te){return Tt.registerUriHandler(Me.identifier,te)},createQuickPick(){return Bt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Bt.createInputBox(Me.identifier)},get activeColorTheme(){return Qt.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Ie){return Qt.onDidChangeActiveColorTheme(te,ue,Ie)},registerWebviewViewProvider(te,ue,Ie){return Dn.registerWebviewViewProvider(Me,te,ue,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(te,ue,Ie)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorSelection(te,ue,Ie)},onDidChangeNotebookEditorVisibleRanges(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorVisibleRanges(te,ue,Ie)},showNotebookDocument(te,ue){return(0,Q.checkProposedApiEnabled)(Me),gt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),an.registerExternalUriOpener(Me.identifier,te,ue,Ie)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Me),At.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Me),At.onDidChangeTabs}},wn={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ye.getPath()},set rootPath(te){throw T.readonly()},getWorkspaceFolder(te){return Ye.getWorkspaceFolder(te)},get workspaceFolders(){return Ye.getWorkspaceFolders()},get name(){return Ye.name},set name(te){throw T.readonly()},get workspaceFile(){return Ye.workspaceFile},set workspaceFile(te){throw T.readonly()},updateWorkspaceFolders:(te,ue,...Ie)=>Ye.updateWorkspaceFolders(Me,te,ue||0,...Ie),onDidChangeWorkspaceFolders:function(te,ue,Ie){return Ye.onDidChangeWorkspace(te,ue,Ie)},asRelativePath:(te,ue)=>Ye.getRelativePath(te,ue),findFiles:(te,ue,Ie,rt)=>Ye.findFiles(F.GlobPattern.from(te),F.GlobPattern.from(ue),Ie,Me.identifier,rt),findTextInFiles:(te,ue,Ie,rt)=>{let bt,H;return typeof ue=="object"?(bt=ue,H=Ie):(bt={},H=ue,rt=Ie),Ye.findTextInFiles(te,bt||{},H,Me.identifier,rt)},saveAll:te=>Ye.saveAll(te),applyEdit(te){return Wt.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,ue,Ie,rt)=>Rt.createFileSystemWatcher(F.GlobPattern.from(te),ue,Ie,rt),get textDocuments(){return _t.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.readonly()},openTextDocument(te){let ue;const Ie=te;if(typeof te=="string")ue=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))ue=Promise.resolve(te);else if(!Ie||typeof Ie=="object")ue=_t.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(bt=>bt.document))},onDidOpenTextDocument:(te,ue,Ie)=>_t.onDidAddDocument(te,ue,Ie),onDidCloseTextDocument:(te,ue,Ie)=>_t.onDidRemoveDocument(te,ue,Ie),onDidChangeTextDocument:(te,ue,Ie)=>_t.onDidChangeDocument(te,ue,Ie),onDidSaveTextDocument:(te,ue,Ie)=>_t.onDidSaveDocument(te,ue,Ie),onWillSaveTextDocument:(te,ue,Ie)=>Zt.getOnWillSaveTextDocumentEvent(Me)(te,ue,Ie),onDidChangeConfiguration:(te,ue,Ie)=>un.onDidChangeConfiguration(te,ue,Ie),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,un.getConfiguration(te,ue,Me)},registerTextDocumentContentProvider(te,ue){return Jt.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,te,ue)),registerFileSystemProvider(te,ue,Ie){return nn.registerFileSystemProvider(Me.identifier,te,ue,Ie)},get fs(){return dt.value},registerFileSearchProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),St.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),St.registerTextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),it.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Me),rn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,ue,Ie)=>Rt.onDidCreateFile(te,ue,Ie),onDidDeleteFiles:(te,ue,Ie)=>Rt.onDidDeleteFile(te,ue,Ie),onDidRenameFiles:(te,ue,Ie)=>Rt.onDidRenameFile(te,ue,Ie),onWillCreateFiles:(te,ue,Ie)=>Rt.getOnWillCreateFileEvent(Me)(te,ue,Ie),onWillDeleteFiles:(te,ue,Ie)=>Rt.getOnWillDeleteFileEvent(Me)(te,ue,Ie),onWillRenameFiles:(te,ue,Ie)=>Rt.getOnWillRenameFileEvent(Me)(te,ue,Ie),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Me),Te.openTunnel(Me,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Me),Te.getTunnels()},onDidChangeTunnels:(te,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),Te.onDidChangeTunnels(te,ue,Ie)),registerPortAttributesProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Te.registerPortsAttributesProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),yn.registerTimelineProvider(te,ue,Me.identifier,ot.converter)),get isTrusted(){return Ye.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Me),Ye.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Ie)=>Ye.onDidGrantWorkspaceTrust(te,ue,Ie)},bn={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),mn.getLastInputBox(Me)},createSourceControl(te,ue,Ie){return mn.createSourceControl(Me,te,ue,Ie)}},_n={createCommentController(te,ue){return Sn.createCommentController(Me,te,ue)}},xt={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(te,ue,Ie){return at.onDidStartDebugSession(te,ue,Ie)},onDidTerminateDebugSession(te,ue,Ie){return at.onDidTerminateDebugSession(te,ue,Ie)},onDidChangeActiveDebugSession(te,ue,Ie){return at.onDidChangeActiveDebugSession(te,ue,Ie)},onDidReceiveDebugSessionCustomEvent(te,ue,Ie){return at.onDidReceiveDebugSessionCustomEvent(te,ue,Ie)},onDidChangeBreakpoints(te,ue,Ie){return at.onDidChangeBreakpoints(te,ue,Ie)},registerDebugConfigurationProvider(te,ue,Ie){return at.registerDebugConfigurationProvider(te,ue,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return at.registerDebugAdapterDescriptorFactory(Me,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return at.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?at.startDebugging(te,ue,{parentSession:Ie}):at.startDebugging(te,ue,Ie||{})},stopDebugging(te){return at.stopDebugging(te)},addBreakpoints(te){return at.addBreakpoints(te)},removeBreakpoints(te){return at.removeBreakpoints(te)},asDebugSourceUri(te,ue){return at.asDebugSourceUri(te,ue)}},Ht={registerTaskProvider:(te,ue)=>vt.registerTaskProvider(Me,te,ue),fetchTasks:te=>vt.fetchTasks(te),executeTask:te=>vt.executeTask(Me,te),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(te,ue,Ie)=>vt.onDidStartTask(te,ue,Ie),onDidEndTask:(te,ue,Ie)=>vt.onDidEndTask(te,ue,Ie),onDidStartTaskProcess:(te,ue,Ie)=>vt.onDidStartTaskProcess(te,ue,Ie),onDidEndTaskProcess:(te,ue,Ie)=>vt.onDidEndTaskProcess(te,ue,Ie)},Ln={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Me),gt.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Me),gt.notebookDocuments.map(te=>te.apiNotebook)},registerNotebookSerializer(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookSerializer(Me,te,ue,Ie)},registerNotebookContentProvider:(te,ue,Ie)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,te,ue,Ie)),registerNotebookCellStatusBarItemProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookCellStatusBarItemProvider(Me,te,ue)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookDocumentMetadata(te,ue,Ie)},onDidChangeNotebookCells(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(te,ue,Ie)},onDidChangeCellExecutionState(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(te,ue,Ie)},onDidChangeCellOutputs(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(te,ue,Ie)},onDidChangeCellMetadata(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(te,ue,Ie)},createConcatTextDocument(te,ue){return(0,Q.checkProposedApiEnabled)(Me),new X.ExtHostNotebookConcatDocument(gt,_t,te,ue)},createNotebookCellExecutionTask(te,ue,Ie){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookCellExecution(te,ue,Ie)},createNotebookController(te,ue,Ie,rt,bt){return(0,Q.checkProposedApiEnabled)(Me),en.createNotebookController(Me,te,ue,Ie,rt,bt)}};return{version:Ge.version,authentication:kn,commands:Pn,comments:_n,debug:xt,env:vn,extensions:An,languages:Tn,notebook:Ln,scm:bn,tasks:Ht,test:In,window:Rn,workspace:wn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:f.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:i.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,LinkedEditingRanges:M.LinkedEditingRanges,TestItemStatus:M.TestItemStatus,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TextSearchCompleteMessageType:je.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=He}),define(ge[270],pe([0,1,79,64,32,126,35,51,39,34,67,46,69,93,92,50,63,127,91,61,90,119]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S,d,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,_.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,_.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,_.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,_.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,_.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,_.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,_.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,_.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,_.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,_.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,_.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,_.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,_.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,_.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,_.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,_.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,_.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry)}),define(ge[94],pe([0,1,19,14,31,66]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function P(C,f,g,a){const u=(0,_.mapArrayOrNot)(g,D),E=new T.TextSearchMatch(f,u,a),b=E.preview.matches;return{ranges:(0,_.mapArrayOrNot)(u,k),uri:C,preview:{text:E.preview.text,matches:(0,_.mapArrayOrNot)(b,k)}}}e.createTextSearchResult=P;function D(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let i=class{constructor(f,g){this.prefix=f,this.logService=g}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};i=Ve([xe(1,I.ILogService)],i),e.OutputChannel=i}),define(ge[271],pe([0,1,95,22]),function(G,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,P=512*8,D=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((o,c)=>{G(["iconv-lite-umd"],o,c)})).getDecoder(g(n));else{const r=new TextDecoder;s={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new k(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?P:y;return new Promise((o,c)=>{const p=(0,_.newWriteableStream)(N=>N.join("")),v=[];let h=0,w;const R=async()=>{try{const N=await m({buffer:I.VSBuffer.concat(v),bytesRead:h},n.guessEncoding);N.encoding=await n.overwriteEncoding(N.encoding),w=await k.create(N.encoding);const j=w.write(I.VSBuffer.concat(v).buffer);p.write(j),v.length=0,h=0,o({stream:p,detected:N})}catch(N){c(N)}};(0,_.listenStream)(t,{onData:async N=>{w?p.write(w.write(N.buffer)):(v.push(N),h+=N.byteLength,h>=r&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:N=>p.error(N),onEnd:async()=>{w||await R(),p.end(w==null?void 0:w.end())}})})}e.toDecodeStream=i;async function C(t,n,s){const o=(await new Promise((v,h)=>{G(["iconv-lite-umd"],v,h)})).getEncoder(g(n),s);let c=!1,p=!1;return{read(){if(p)return null;const v=t.read();if(typeof v!="string"){if(p=!0,!c&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const h=o.end();return h&&h.length>0?(c=!0,I.VSBuffer.wrap(h)):null}return c=!0,I.VSBuffer.wrap(o.write(v))}}}e.toEncodeReadable=C;async function f(t){return(await new Promise((s,r)=>{G(["iconv-lite-umd"],s,r)})).encodingExists(g(t))}e.encodingExists=f;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const u=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((p,v)=>{G(["jschardet"],p,v)}),s=t.slice(0,D),r=d(s.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const c=o.encoding.toLowerCase();return 0<=u.indexOf(c)?null:S(o.encoding)}const b={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[n]||n}function d(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=l;function m({buffer:t,bytesRead:n},s){let r=a(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let c=!0,p=!0,v=!1;for(let h=0;h<n&&h<A;h++){const w=h%2==1,R=t.readUInt8(h)===0;if(R&&(v=!0),c&&(w&&!R||!w&&R)&&(c=!1),p&&(w&&R||!w&&!R)&&(p=!1),R&&!c&&!p)break}v&&(c?r=e.UTF16le:p?r=e.UTF16be:o=!0)}return s&&!o&&!r&&t?E(t.slice(0,n)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=m,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[129],pe([0,1,271,26,128]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends T.TextSearchManager{constructor(P,D,k=I){super(P,D,{readdir:i=>k.readdir(i.fsPath),toCanonicalName:i=>(0,_.toCanonicalName)(i)})}}e.NativeTextSearchManager=A}),define(ge[272],pe([0,1,273,287,288,2,289]),function(G,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,f,g,a,u,E){const b=E.environment.useHostProxy,S=typeof b=="boolean"?b:!E.remote.isRemote,d=(0,y.createProxyResolver)({resolveProxy:m=>C.resolveProxy(m),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(m,t,...n)=>{switch(m){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:s(m,t,n);break}function s(r,o,...c){a.error("Unknown log level",r),a.error(o,...c)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:m=>{u.$publicLog2("resolveProxy",m)},useHostProxy:S,env:process.env}),l=D(f,d);return i(g,l)}e.connectProxyResolver=P;function D(C,f){const g={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(u=>{g.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(u=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,y.createHttpPatch)(_,f,{config:"off"},a,!0)),on:Object.assign({},_,(0,y.createHttpPatch)(_,f,{config:"on"},a,!0)),override:Object.assign({},_,(0,y.createHttpPatch)(_,f,{config:"override"},a,!0)),onRequest:Object.assign({},_,(0,y.createHttpPatch)(_,f,g,a,!0)),default:Object.assign(_,(0,y.createHttpPatch)(_,f,g,a,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"off"},a,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"on"},a,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"override"},a,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,f,g,a,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,f,g,a,!1))},tls:Object.assign(T,(0,y.createTlsPatch)(T))}}const k=new Map;function i(C,f){return C.getExtensionPathIndex().then(g=>{const a=G.__$__nodeRequire("module"),u=a._load;a._load=function(b,S,d){if(b==="tls")return f.tls;if(b!=="http"&&b!=="https")return u.apply(this,arguments);const l=f[b],m=g.findSubstr(A.URI.file(S.filename).fsPath);let t=k.get(m);if(t||k.set(m,t={}),!t[b]){let n=l.default;m&&m.enableProposedApi&&(n=l[m.proxySupport]||l.onRequest),t[b]=Object.assign({},n)}return t[b]}})}}),define(ge[274],pe([0,1,38,8,75,29,10,9,94,275]),function(G,e,_,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(d,l,m,t){const n=f(d,l,m,t),s=l.folder.fsPath;return{cmd:_.spawn(i,n.args,{cwd:s}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=C;function f(d,l,m,t){const n=["--files","--hidden","--case-sensitive"];a([l],m,!1).forEach(r=>{const o=(0,D.anchorGlob)(r);if(n.push("-g",o),y.isMacintosh){const c=(0,T.normalizeNFD)(o);c!==o&&n.push("-g",c)}});const s=g([l],t,void 0,!1);return s.globArgs.forEach(r=>{const o=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",o),y.isMacintosh){const c=(0,T.normalizeNFD)(o);c!==o&&n.push("-g",c)}}),l.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),l.ignoreSymlinks||n.push("--follow"),d.exists&&n.push("--quiet"),n.push("--no-config"),l.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function g(d,l,m,t=!0){const n=[];let s={};return d.forEach(r=>{const o=Object.assign({},r.excludePattern||{},l||{}),c=u(o,t?r.folder.fsPath:void 0,m);n.push(...c.globArgs),c.siblingClauses&&(s=Object.assign(s,c.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=g;function a(d,l,m=!0){const t=[];return d.forEach(n=>{const s=Object.assign({},l||{},n.includePattern||{}),r=u(s,m?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function u(d,l,m){const t=[],n={};return Object.keys(d).forEach(s=>{if(!(m&&m.has(s))&&!!s){const r=d[s];s=b(l?E(l,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(S(s))):r&&r.when&&(n[s]=r)}}),{globArgs:t,siblingClauses:n}}function E(d,l){return I.isAbsolute(l)?l:I.join(d,l)}e.getAbsoluteGlob=E;function b(d){return d=P.rtrim(d,"\\"),P.rtrim(d,"/")}function S(d){return A.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=S}),define(ge[276],pe([0,1,38,37,8,102,19,59,33,75,29,10,47,9,11,26,31,274,100]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class l{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const c=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),p=o.folder.fsPath;r.folderQueries.map(v=>v.folder.fsPath).filter(v=>v!==p).forEach(v=>{(0,i.isEqualOrParent)(v,p)&&(c[T.relative(p,v)]=!0)}),this.folderExcludePatterns.set(p,new t(c,p))})}cancel(){this.isCanceled=!0}walk(r,o,c,p,v){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return v(null,this.isLimitHit);o.forEach(h=>{const w=T.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,w)||this.matchFile(c,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(r,(h,w)=>{this.call(this.cmdTraversal,this,h,c,p,R=>{if(R){const N=(0,P.toErrorMessage)(R);console.error(N),this.errors.push(N),w(R,void 0)}else w(null,void 0)})},(h,w)=>{this.fileWalkSW.stop();const R=h?y.coalesce(h)[0]:null;v(R,this.isLimitHit)})}parallel(r,o,c){const p=new Array(r.length),v=new Array(r.length);let h=!1,w=0;if(r.length===0)return c(null,[]);r.forEach((R,N)=>{o(R,(j,re)=>{if(j?(h=!0,p[N]=null,v[N]=j):(p[N]=re,v[N]=null),++w===r.length)return c(h?v:null,p)})})}call(r,o,...c){try{r.apply(o,c)}catch(p){c[c.length-1](p)}}cmdTraversal(r,o,c,p){const v=r.folder.fsPath,h=C.isMacintosh;let w;const R=()=>w&&w.kill();d.add(R);let N=F=>{d.delete(R),N=()=>{},p(F)},j="";const re=this.initDirectoryTree();let V;const W=(0,b.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);w=W.cmd,V=!Object.keys(W.siblingClauses).length;const $=W.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let U=`${W.rgDiskPath} ${$}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),c({message:U}),this.cmdResultCount=0,this.collectStdout(w,"utf8",c,(F,M,L)=>{if(F){N(F);return}if(this.isLimitHit){N();return}const B=(j+(h?k.normalizeNFC(M||""):M)).split(`
`);if(L){const q=B.length;B[q-1]=B[q-1].trim(),B[q-1]||B.pop()}else j=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){N(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,V){for(const q of B)if(this.matchFile(o,{base:v,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){R();break}(L||this.isLimitHit)&&N();return}this.addDirectoryEntries(r,re,v,B,o),L&&(this.matchDirectoryTree(re,v,o),N())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),c=o.getBasenameTerms(),p=o.getPathTerms(),v=["-L","."];if(c.length||p.length){v.push("-not","(","(");for(const h of c)v.push("-name",h),v.push("-o");for(const h of p)v.push("-path",h),v.push("-o");v.pop(),v.push(")","-prune",")")}return v.push("-type","f"),_.spawn("find",v,{cwd:r.folder.fsPath})}readStdout(r,o,c){let p="";this.collectStdout(r,o,()=>{},(v,h,w)=>{if(v){c(v);return}p+=h,w&&c(null,p)})}collectStdout(r,o,c,p){let v=(R,N,j)=>{(R||j)&&(v=()=>{},this.cmdSW&&this.cmdSW.stop()),p(R,N,j)},h=!1;r.stdout?(this.forwardData(r.stdout,o,v),r.stdout.once("data",()=>h=!0)):c({message:"stdout is null"});let w;r.stderr?w=this.collectData(r.stderr):c({message:"stderr is null"}),r.on("error",R=>{v(R)}),r.on("close",R=>{let N;!h&&(N=this.decodeData(w,o))&&n(N)?v(new Error(`command failed with error code ${R}: ${this.decodeData(w,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),v(null,"",!0))})}forwardData(r,o,c){const p=new A.StringDecoder(o);return r.on("data",v=>{c(null,p.write(v))}),p}collectData(r){const o=[];return r.on("data",c=>{o.push(c)}),o}decodeData(r,o){const c=new A.StringDecoder(o);return r.map(p=>c.write(p)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},c,p,v){p.indexOf(this.filePattern)!==-1&&this.matchFile(v,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const h=w=>{const R=T.basename(w),N=T.dirname(w);let j=o[N];j||(j=o[N]=[],h(N)),j.push({base:c,relativePath:w,basename:R,searchPath:this.getSearchPath(r,w)})};p.forEach(h)}matchDirectoryTree({rootEntries:r,pathToEntries:o},c,p){const v=this,h=this.folderExcludePatterns.get(c),w=this.filePattern;function R(N){v.directoriesWalked++;const j=D.hasSiblingFn(()=>N.map(re=>re.basename));for(let re=0,V=N.length;re<V;re++){const W=N[re],{relativePath:$,basename:U}=W;if(!h.test($,U,w!==U?j:void 0)){const F=o[$];if(F)R(F);else{if(v.filesWalked++,$===w)continue;v.matchFile(p,W)}if(v.isLimitHit)break}}}R(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,c,p,v){const h=r.folder,w=D.hasSiblingFn(()=>c);this.parallel(c,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const j=o?[o,R].join(T.sep):R;if(this.folderExcludePatterns.get(r.folder.fsPath).test(j,R,this.config.filePattern!==R?w:void 0))return N(null);const re=[h.fsPath,j].join(T.sep);I.lstat(re,(V,W)=>{if(V||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(re,W,($,U)=>$||this.isCanceled||this.isLimitHit?N(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(re,W,(F,M)=>F||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?N(null):(this.walkedPaths[M]=!0,(0,u.readdir)(re).then(L=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(r,j,L,p,O=>N(O||null))},L=>{N(null)})))):(this.filesWalked++,j===this.filePattern||this.maxFilesize&&a.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(p,{base:h.fsPath,relativePath:j,searchPath:this.getSearchPath(r,j)}),N(null,void 0)))})},R=>{const N=R&&y.coalesce(R);return v(N&&N.length>0?N[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,T.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,c){return o.isSymbolicLink()?I.stat(r,c):c(null,o)}realPathIfNeeded(r,o,c){return o.isSymbolicLink()?I.realpath(r,(p,v)=>p?c(p):c(null,v)):c(null,r)}getSearchPath(r,o){return r.folderName?T.join(r.folderName,o):o}}e.FileWalker=l;class m{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new l(r)}search(r,o,c){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(p,v)=>{c(p,{limitHit:v,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,c;Object.keys(r).filter(p=>r[p]).forEach(p=>{T.isAbsolute(p)?(o=o||D.getEmptyExpression(),o[p]=r[p]):(c=c||D.getEmptyExpression(),c[p]=r[p])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(r,o,c){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,r),o,c)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(ge[130],pe([0,1,38,290,102,19,53,33,8,9,2,31,66,291,275,94]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(h){this.outputChannel=h}provideTextSearchResults(h,w,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify(Object.assign(Object.assign({},w),{folder:w.folder.toString()}))}`),new Promise((j,re)=>{N.onCancellationRequested(()=>O());const V=n(h,w),W=w.folder.fsPath,$=V.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${W}`);let U=_.spawn(E,V,{cwd:W});U.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),re((0,C.serializeSearchError)(new C.SearchError(be&&be.message,C.SearchErrorCode.rgProcessError)))});let F=!1;const M=new l(w.maxResults,W,w.previewOptions);M.on("result",be=>{F=!0,q="",R.report(be)});let L=!1;const O=()=>{L=!0,U&&U.kill(),M&&M.cancel()};let B=!1;M.on("hitLimit",()=>{B=!0,O()});let q="";U.stdout.on("data",be=>{M.handleData(be),F||(q+=be)});let Q=!1;U.stdout.once("data",()=>Q=!0);let de="";U.stderr.on("data",be=>{const Ae=be.toString();this.outputChannel.appendLine(Ae),de+=Ae}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),L)j({limitHit:B});else{M.flush(),U=null;let be;de&&!Q&&(be=S(de))?re((0,C.serializeSearchError)(new C.SearchError(be.message,be.code))):j({limitHit:B})}})})}}e.RipgrepTextSearchEngine=b;function S(v){const h=v.split(`
`),w=h[0].trim();if(h.some(N=>N.startsWith("regex parse error")))return new C.SearchError(d(h),C.SearchErrorCode.regexParseError);const R=w.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new C.SearchError(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new C.SearchError(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(w,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function d(v){const h=["Regex parse error"],w=v.filter(R=>R.startsWith("PCRE2:"));if(w.length>=1){const R=w[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];h.push(":"+N)}}return h.join("")}e.buildRegexParseError=d;class l extends I.EventEmitter{constructor(h,w,R){super();this.maxResults=h,this.rootFolder=w,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,w){return super.on(h,w),this}handleData(h){if(!this.isDone){const w=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(w)}}handleDecodedData(h){let w=h.indexOf(`
`);const R=this.remainder+h;if(w>=0)w+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;w>=0;)this.handleLine(R.substring(N,w).trim()),N=w+1,w=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(h){if(!(this.isDone||!h)){let w;try{w=JSON.parse(h)}catch(R){throw new Error(`malformed line from rg: ${h}`)}if(w.type==="match"){const R=m(w.data.path),N=i.URI.file(D.join(this.rootFolder,R)),j=this.createTextSearchMatch(w.data,N);this.onResult(j),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const R=m(w.data.path),N=i.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(w.data,N).forEach(re=>this.onResult(re))}}}createTextSearchMatch(h,w){const R=h.line_number-1;let N=!1,j=m(h.lines);R===0&&(0,k.startsWithUTF8BOM)(j)&&(N=!0,j=(0,k.stripUTF8BOM)(j));const re=Buffer.from(j);let V=0,W=0,$=R;h.submatches.length===0&&h.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const U=(0,A.coalesce)(h.submatches.map((F,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let L=m(F.match);R===0&&M===0&&N&&(L=(0,k.stripUTF8BOM)(L),F.start=F.start<=3?0:F.start-3,F.end=F.end<=3?0:F.end-3);const O=re.slice(V,F.start).toString().length,B=W+O,q=t(L),Q=$,de=q.numLines+Q,be=q.numLines>0?q.lastLineLength:q.lastLineLength+B;return V=F.end,W=be,$=de,new f.Range(Q,B,de,be)}));return(0,u.createTextSearchResult)(w,j,U,this.previewOptions)}createTextSearchContext(h,w){const R=m(h.lines),N=h.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((j,re)=>({text:j,uri:w,lineNumber:N+re}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=l;function m(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function t(v){const h=/\n/g;let w=0,R=-1,N;for(;N=h.exec(v);)w++,R=N.index;const j=R>=0?v.length-R-1:v.length;return{numLines:w,lastLineLength:j}}function n(v,h){const w=["--hidden"];w.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,y.groupBy)(h.includes,re=>re.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const re=new Set;N.forEach(V=>{re.add(V)}),w.push("-g","!*"),re.forEach(V=>{s(V).map(u.anchorGlob).forEach(W=>{w.push("-g",W)})})}R&&R.length&&R.forEach(re=>{w.push("-g",re)}),h.excludes.map(u.anchorGlob).forEach(re=>w.push("-g",`!${re}`)),h.maxFileSize&&w.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?w.push("--no-ignore-parent"):w.push("--no-ignore"),h.followSymlinks&&w.push("--follow"),h.encoding&&h.encoding!=="utf8"&&w.push("--encoding",h.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,k.escapeRegExpCharacters)(v.pattern),v.isRegExp=!0),h.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),v.isRegExp&&(v.pattern=r(v.pattern),w.push("--auto-hybrid-regex"));let j;if(v.isWordMatch){const V=(0,k.createRegExp)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",V)}else if(v.isRegExp){let re=c(v.pattern);re=p(re),w.push("--regexp",re)}else j=v.pattern,w.push("--fixed-strings");return w.push("--no-config"),h.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),v.isMultiline&&w.push("--multiline"),h.beforeContext&&w.push("--before-context",h.beforeContext+""),h.afterContext&&w.push("--after-context",h.afterContext+""),w.push("--"),j&&w.push(j),w.push("."),w}function s(v){const h=(0,P.splitGlobAware)(v,"/");return h.map((w,R)=>h.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function r(v){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(h);)v=v.replace(h,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(w);)v=v.replace(w,"$1\\x{$2}");return v}e.unicodeEscapesToPCRE2=r;const o=v=>v.type==="Assertion"&&v.kind==="lookbehind";function c(v){let h;try{h=new g.RegExpParser().parsePattern(v)}catch(V){return v}let w="",R=0;const N=(V,W,$)=>{w+=v.slice(R,V)+$,R=W},j=[];return new g.RegExpVisitor({onCharacterEnter(V){if(V.raw==="\\n"){const W=j[0];if(!W)N(V.start,V.end,"\\r?\\n");else if(!j.some(o))if(W.type==="CharacterClass"){const $=v.slice(W.start+1,V.start)+v.slice(V.end,W.end-1);N(W.start,W.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else W.type==="Quantifier"&&N(V.start,V.end,"(?:\\r?\\n)")}},onQuantifierEnter(V){j.unshift(V)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(V){j.unshift(V)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(V){j.unshift(V)},onCharacterClassLeave(){j.shift()},onAssertionEnter(V){o(V)&&j.push(V)},onAssertionLeave(V){j[0]===V&&j.shift()}}).visit(h),w+=v.slice(R),w}e.fixRegexNewline=c;function p(v){return v.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(ge[277],pe([0,1,21,130,115,12]),function(G,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,i,C,f){const g=new I.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===A.Schemas.userData){const a=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:A.Schemas.file})}),u=new T.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:i.folder.scheme})})));return this.withToken(f,E=>g.provideTextSearchResults(k,a,u,E))}else return this.withToken(f,a=>g.provideTextSearchResults(k,i,C,a))}async withToken(k,i){const C=P(k);this.inProgress.add(C);const f=await i(C.token);return this.inProgress.delete(C),f}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function P(D){const k=new _.CancellationTokenSource;return D.onCancellationRequested(()=>k.cancel()),k}}),define(ge[278],pe([0,1,26,130,129]),function(G,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,k,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(g){i({message:g})}},f=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),_);return new Promise((g,a)=>f.search(u=>{k(u.map(y))},D).then(u=>g({limitHit:u.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=A;function y(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,k)=>{if(k.ranges){const i=k;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(ge[279],pe([0,1,37,292,19,13,18,3,100,8,47,2,45,31,276,278]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(_);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=d(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,s,c=>r.fire(c),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=d(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(o=>this.ripgrepTextSearch(s,c=>r.fire(c),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,f.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new u.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,o=E.BATCH_SIZE){let c=0;const p=h=>{Array.isArray(h)?(c+=h.length,s(h.map(w=>this.rawMatchToSearchItem(w)))):h.relativePath?(c++,s(this.rawMatchToSearchItem(h))):s(h)};if(n.sortByScore){let h=this.trySortedSearchFromCache(n,p,r);if(!h){const w=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(w);h=this.doSortedSearch(R,n,s,p,r)}return new Promise((w,R)=>{h.then(([N,j])=>{const re=j.map(V=>this.rawMatchToSearchItem(V));this.sendProgress(re,s,o),w(N)},R)})}const v=new t(n);return this.doSearch(v,p,o,r).then(h=>({limitHit:h.limitHit,type:"success",stats:{detailStats:h.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,o){const c=new P.Emitter;let p=(0,A.createCancelablePromise)(h=>{let w=[];const R=N=>{Array.isArray(N)?w=N:(r(N),c.fire(N))};return this.doSearch(t,R,-1,h).then(N=>[N,w])}),v;if(n.cacheKey){v=this.getOrCreateCache(n.cacheKey);const h={promise:p,event:c.event,resolved:!1};v.resultsToSearchCache[n.filePattern||""]=h,p.then(()=>{h.resolved=!0},w=>{delete v.resultsToSearchCache[n.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([h,w])=>{const R=v?v.scorerCache:Object.create(null),N=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,w,R,o).then(j=>{const re=N?N.elapsed():-1;return[{type:"success",stats:{detailStats:h.stats,sortingTime:re,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:j.length},messages:h.messages,limitHit:h.limitHit||typeof n.maxResults=="number"&&w.length>n.maxResults},j]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new b)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const o=this.getResultsFromCache(r,t.filePattern||"",n,s);if(o)return o.then(([c,p,v])=>{const h=i.StopWatch.create(!1);return this.sortResults(t,p,r.scorerCache,s).then(w=>{const R=h.elapsed(),N={fromCache:!0,detailStats:v,type:"searchProcess",resultCount:p.length,sortingTime:R};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:N},w]})})}}sortResults(t,n,s,r){const o=(0,D.prepareQuery)(t.filePattern||""),c=(v,h)=>(0,D.compareItemsByFuzzyScore)(v,h,o,!0,S,s),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,c,p,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const o=i.StopWatch.create(!1),c=n.indexOf(k.sep)>=0;let p;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(c&&R.indexOf(k.sep)<0&&R!=="")continue;const N=t.resultsToSearchCache[R];p={promise:this.preventCancellation(N.promise),event:N.event,resolved:N.resolved};break}if(!p)return null;const v=o.elapsed(),h=i.StopWatch.create(!1),w=p.event(s);return r&&r.onCancellationRequested(()=>{w.dispose()}),p.promise.then(([R,N])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const j=[],re=(0,D.prepareQuery)(n).normalizedLowercase;for(const V of N)!(0,g.isFilePatternMatch)(V,re)||j.push(V);return[R,j,{cacheWasResolved:p.resolved,cacheLookupTime:v,cacheFilterTime:h.elapsed(),cacheEntryCount:N.length}]})}doSearch(t,n,s,r){return new Promise((o,c)=>{let p=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(v=>{v&&(s?(p.push(v),s>0&&p.length>=s&&(n(p),p=[])):n(v))},v=>{n(v)},(v,h)=>{p.length&&n(p),v?c(v):o(h)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(m){return(0,k.basename)(m.relativePath)}getItemDescription(m){return(0,k.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function d(m){return Object.assign(Object.assign({},m),{folderQueries:m.folderQueries&&m.folderQueries.map(l),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>C.URI.revive(t))})}function l(m){return Object.assign(Object.assign({},m),{folder:C.URI.revive(m.folder)})}}),define(ge[280],pe([0,1,6,2,26,14,31,279,277,94,15,62,27,69,12,129]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends g.ExtHostSearch{constructor(S,d,l,m){super(S,l,m);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(S,d){const l=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(S)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(S,d,l,m){const t=(0,g.reviveQuery)(l);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,d,t,m):super.$provideFileSearchResults(S,d,l,m)}doInternalFileSearch(S,d,l,m){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,d,n.map(s=>I.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,m)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,d){return new u.NativeTextSearchManager(S,d)}};E=Ve([xe(0,i.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,C.IURITransformerService),xe(3,A.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[131],pe([0,1,293,122,294,3,105,8,48,30,6,22,106,18,10]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(p){this.socket=p,this._errorListener=v=>{if(v){if(v.code==="EPIPE")return;(0,g.onUnexpectedError)(v)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const v=h=>p(C.VSBuffer.wrap(h));return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,g.onUnexpectedError)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,g.onUnexpectedError)(v)}}end(){this.socket.end()}drain(){return new Promise((p,v)=>{if(this.socket.bufferSize===0){p();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),p()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=u;var E;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var b;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(b||(b={}));class S extends i.Disposable{constructor(p,v,h,w){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=v,this._recordInflateBytes=w,v?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,g.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),h&&(this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,g.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let v=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,v=v.slice(0,v.length-4),this._isEnded||this._write(C.VSBuffer.wrap(v),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,v){let h=2;p.byteLength<126?h+=0:p.byteLength<2**16?h+=2:h+=8;const w=C.VSBuffer.alloc(h);if(v?w.writeUInt8(194,0):w.writeUInt8(130,0),p.byteLength<126)w.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){w.writeUInt8(126,1);let R=1;w.writeUInt8(p.byteLength>>>8&255,++R),w.writeUInt8(p.byteLength>>>0&255,++R)}else{w.writeUInt8(127,1);let R=1;w.writeUInt8(0,++R),w.writeUInt8(0,++R),w.writeUInt8(0,++R),w.writeUInt8(0,++R),w.writeUInt8(p.byteLength>>>24&255,++R),w.writeUInt8(p.byteLength>>>16&255,++R),w.writeUInt8(p.byteLength>>>8&255,++R),w.writeUInt8(p.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=w.byteLength+p.byteLength,this.socket.write(C.VSBuffer.concat([w,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const v=this._incomingData.peek(this._state.readLen),w=(v.readUInt8(0)&128)>>>7,R=v.readUInt8(1),N=(R&128)>>>7,j=R&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=w,this._state.mask=0}else if(this._state.state===2){const v=this._incomingData.read(this._state.readLen),h=v.readUInt8(1),w=(h&128)>>>7;let R=h&127,N=1;R===126?R=v.readUInt8(++N)*2**8+v.readUInt8(++N):R===127&&(R=v.readUInt8(++N)*0+v.readUInt8(++N)*0+v.readUInt8(++N)*0+v.readUInt8(++N)*0+v.readUInt8(++N)*2**24+v.readUInt8(++N)*2**16+v.readUInt8(++N)*2**8+v.readUInt8(++N));let j=0;w&&(j=v.readUInt8(++N)*2**24+v.readUInt8(++N)*2**16+v.readUInt8(++N)*2**8+v.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=j}else if(this._state.state===3){const v=this._incomingData.read(this._state.readLen);d(v,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(v.buffer)),this._zlibInflate.write(v.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const h=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=h.length,this._onData.fire(C.VSBuffer.wrap(h))})):(this._totalIncomingDataBytes+=v.byteLength,this._onData.fire(v))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function d(c,p){if(p!==0){let v=c.byteLength>>>2;for(let re=0;re<v;re++){const V=c.readUInt32BE(re*4);c.writeUInt32BE(V^p,re*4)}let h=v*4,w=c.byteLength-h;const R=p>>>24&255,N=p>>>16&255,j=p>>>8&255;w>=1&&c.writeUInt8(c.readUInt8(h)^R,h),w>=2&&c.writeUInt8(c.readUInt8(h+1)^N,h+1),w>=3&&c.writeUInt8(c.readUInt8(h+2)^j,h+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function m(){const c=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):p=(0,P.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),n(p),p}e.createRandomIPCHandle=m;function t(c,p,v){const h=(0,_.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${v}-${p}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${v}-${p}.sock`):w=(0,P.join)(c,`${v}-${p}.sock`),n(w),w}e.createStaticIPCHandle=t;function n(c){const p=l[a.platform];typeof p=="number"&&c.length>=p&&console.warn(`WARNING: IPC handle "${c}" is longer than ${p} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(p){super(s.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const v=A.Event.fromNodeEventEmitter(p,"connection");return A.Event.map(v,h=>({protocol:new f.Protocol(new u(h)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(c){return new Promise((p,v)=>{const h=(0,I.createServer)();h.on("error",v),h.listen(c,()=>{h.removeListener("error",v),p(new s(h))})})}e.serve=r;function o(c,p){return new Promise((v,h)=>{const w=(0,I.createConnection)(c,()=>{w.removeListener("error",h),v(f.Client.fromSocket(new u(w),p))});w.once("error",h)})}e.connect=o}),define(ge[281],pe([0,1,131,273,37,51,2,118,14]),function(G,e,_,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(f,g,a){this._commands=f,this.logService=g,this._ipcHandlePath=a,this._server=I.createServer((u,E)=>this.onRequest(u,E)),this.setup().catch(u=>(g.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch(f){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,g){const a=[];f.setEncoding("utf8"),f.on("data",u=>a.push(u)),f.on("end",()=>{const u=JSON.parse(a.join(""));switch(u.type){case"open":this.open(u,g);break;case"openExternal":this.openExternal(u,g);break;case"status":this.getStatus(u,g);break;case"extensionManagement":this.manageExtensions(u,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${u.type}`,E=>{E&&this.logService.error(E)}),g.end();break}})}open(f,g){let{fileURIs:a,folderURIs:u,forceNewWindow:E,diffMode:b,addMode:S,forceReuseWindow:d,gotoLineMode:l,waitMarkerFilePath:m}=f;const t=[];if(Array.isArray(u))for(const n of u)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,P.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=m?y.URI.file(m):void 0,r={forceNewWindow:E,diffMode:b,addMode:S,gotoLineMode:l,forceReuseWindow:d,preferNewWindow:!d&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(f,g){for(const a of f.uris){const u=y.URI.parse(a),E=u.scheme==="file"?u:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}g.writeHead(200),g.end()}async manageExtensions(f,g){try{const a=b=>b==null?void 0:b.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),u={list:f.list,install:a(f.install),uninstall:a(f.uninstall),force:f.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",u);g.writeHead(200),g.write(E)}catch(a){g.writeHead(500),g.write(String(a),u=>{u&&this.logService.error(u)})}g.end()}async getStatus(f,g){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(a),g.end()}catch(a){g.writeHead(500),g.write(String(a),u=>{u&&this.logService.error(u)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let i=class extends k{constructor(f,g){super(f,g,(0,_.createRandomIPCHandle)())}};i=Ve([xe(0,A.IExtHostCommands),xe(1,D.ILogService)],i),e.CLIServer=i}),define(ge[282],pe([0,1,68,269,263,5,272,42,254,2,12,7,281,103]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends T.RequireInterceptor{_installInterceptor(){const b=this,S=G.__$__nodeRequire("module"),d=S._load;S._load=function(m,t,n){for(let s of b._alternatives){let r=s(m);if(r){m=r;break}}return b._factories.has(m)?b._factories.get(m).load(m,k.URI.file((0,g.realpathSync)(t.filename)),s=>d.apply(this,[s,t,n])):d.apply(this,arguments)}}}class u extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,b,this._registry).install(),_.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const l=process.send,m=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(m.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,S,d){if(S.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let l=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{b&&_.mark(`code/extHost/willLoadExtensionCode/${b.value}`),l=G.__$__nodeRequire(S.fsPath)}catch(m){return Promise.reject(m)}finally{b&&_.mark(`code/extHost/didLoadExtensionCode/${b.value}`),d.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const S in b){const d=b[S];d===null?delete process.env[S]:process.env[S]=d}}}e.ExtHostExtensionService=u}),define(ge[283],pe([0,1,79,255,266,265,264,280,282,226,256,46,42,64,69,67,34,50,14]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtHostExtensionService,D.ExtHostExtensionService),(0,_.registerSingleton)(S.ILogService,k.ExtHostLogService),(0,_.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,_.registerSingleton)(g.IExtHostOutputService,I.ExtHostOutputService2),(0,_.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,_.registerSingleton)(u.IExtHostTask,A.ExtHostTask),(0,_.registerSingleton)(E.IExtHostTerminalService,T.ExtHostTerminalService),(0,_.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(ge[284],pe([0,1,122,295,68,18,106,131,187,224,267,22,101,26,103,13,270,283]),function(G,e,_,I,T,A,y,P,D,k,i,C,f,g,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const E=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=G.__$__nodeRequire("module"),r=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function S(s){process.exit=function(r){if(s)b(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let d=function(s){b()};function l(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let o=null,c=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const p=108e5,v=3e5,h=new u.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),p),w=new u.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),v);process.on("message",(N,j)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){const re=C.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let V;if(N.skipWebSocketFrames)V=new P.NodeSocket(j);else{const W=C.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));V=new P.WebSocketNodeSocket(new P.NodeSocket(j),N.permessageDeflate,W,!1)}o?(h.cancel(),w.cancel(),o.beginAcceptReconnection(V,re),o.endAcceptReconnection()):(clearTimeout(c),o=new y.PersistentProtocol(V,re),o.onDidDispose(()=>d("renderer disconnected")),s(o),o.onSocketClose(()=>{h.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;h.isScheduled()&&w.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const c=_.createConnection(s,()=>{c.removeListener("error",o),r(new y.PersistentProtocol(new P.NodeSocket(c)))});c.once("error",o)})}}async function m(){const s=await l();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,k.isMessageOfType)(r,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const o=s.onMessage(c=>{o.dispose();const p=JSON.parse(c.toString()),v=p.commit,h=D.default.commit;v&&h&&v!==h&&b(55);const w=[];process.on("unhandledRejection",(j,re)=>{w.push(re),setTimeout(()=>{const V=w.indexOf(re);V>=0&&re.catch(W=>{w.splice(V,1),console.warn(`rejected promise not handled within 1 second: ${W}`),W&&W.stack&&console.warn(`stack trace: ${W.stack}`),(0,A.onUnexpectedError)(j)})},1e3)}),process.on("rejectionHandled",j=>{const re=w.indexOf(j);re>=0&&w.splice(re,1)}),process.on("uncaughtException",function(j){(0,A.onUnexpectedError)(j)});let R=0;setInterval(function(){try{process.kill(p.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&d(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):d(`parent process ${p.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let N;try{N=G.__$__nodeRequire("native-watchdog"),N.start(p.parentPid)}catch(j){(0,A.onUnexpectedError)(j)}s.send((0,k.createMessageOfType)(0)),r({protocol:s,initData:p})});s.send((0,k.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const s=await m();T.mark("code/extHost/didConnectToRenderer");const r=await t(s);T.mark("code/extHost/didWaitForInitData");const{initData:o}=r;S(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const c=new class{exit(w){b(w)}exists(w){return(0,g.exists)(w)}realpath(w){return(0,a.realpath)(w)}};let p=null;if(o.remote.authority&&E.uriTransformerPath)try{const w=G.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);p=new f.URITransformer(w)}catch(h){console.error(h)}const v=new i.ExtensionHostMain(r.protocol,o,c,p);d=h=>v.terminate(h)}e.startExtensionHostProcess=n}),define(ge[296],pe([0,1,284]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5080d21c0b538b996c83fb7b14a746f656eaef15/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
