/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Q){for(var e=[],w=0,I=Q.length;w<I;w++)e[w]=we[Q[w]];return e};define(we[42],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(I,A){if(!I)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=w}),define(we[51],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function I(i){const P=[];for(let d in i)w.call(i,d)&&P.push(i[d]);return P}e.values=I;function A(i,P){for(let d in i)if(w.call(i,d)&&P({key:d,value:i[d]},function(){delete i[d]})===!1)return}e.forEach=A;function T(i,P){const d=Object.create(null);for(const h of i){const r=P(h);let a=d[r];a||(a=d[r]=[]),a.push(h)}return d}e.groupBy=T;function y(i){const P=Object.create(null);return i&&i.forEach((d,h)=>{P[h]=d}),P}e.fromMap=y;function C(i,P){const d=[],h=[];for(let r of i)P.has(r)||d.push(r);for(let r of P)i.has(r)||h.push(r);return{removed:d,added:h}}e.diffSets=C;function D(i,P){const d=[],h=[];for(let[r,a]of i)P.has(r)||d.push(a);for(let[r,a]of P)i.has(r)||h.push(a);return{removed:d,added:h}}e.diffMaps=D;class k{constructor(){this.map=new Map}add(P,d){let h=this.map.get(P);h||(h=new Set,this.map.set(P,h)),h.add(d)}delete(P,d){const h=this.map.get(P);!h||(h.delete(d),h.size===0&&this.map.delete(P))}forEach(P,d){const h=this.map.get(P);!h||h.forEach(d)}}e.SetMap=k}),define(we[52],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(D){return(k,i,P)=>{let d=null,h=null;if(typeof P.value=="function"?(d="value",h=P.value):typeof P.get=="function"&&(d="get",h=P.get),!h)throw new Error("not supported");P[d]=D(h,i)}}e.createDecorator=w;let I=0;function A(){const D=`$memoize${I++}`;let k;const i=function(d,h,r){let a=null,g=null;if(typeof r.value=="function"?(a="value",g=r.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(a="get",g=r.get),!g)throw new Error("not supported");const m=`${D}:${h}`;r[a]=function(...S){return k=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:g.apply(this,S)}),this[m]}};return i.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(P=>{P.indexOf(D)===0&&delete k[P]})},i}e.createMemoizer=A;function T(D,k,i){return A()(D,k,i)}e.memoize=T;function y(D,k,i){return w((P,d)=>{const h=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...a){this[r]||(this[r]=i?i():void 0),clearTimeout(this[h]),k&&(this[r]=k(this[r],...a),a=[this[r]]),this[h]=setTimeout(()=>{P.apply(this,a),this[r]=i?i():void 0},D)}})}e.debounce=y;function C(D,k,i){return w((P,d)=>{const h=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,g=`$throttle$pending$${d}`;return function(...m){if(this[r]||(this[r]=i?i():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),k&&(this[r]=k(this[r],...m)),!this[g]){const S=this[a]+D;S<=Date.now()?(this[a]=Date.now(),P.apply(this,[this[r]]),this[r]=i?i():void 0):(this[g]=!0,this[h]=setTimeout(()=>{this[g]=!1,this[a]=Date.now(),P.apply(this,[this[r]]),this[r]=i?i():void 0},S-Date.now()))}}})}e.throttle=C}),define(we[12],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function I(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=I;function A(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=A;function T(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=T;function y(v){if(v instanceof Error){let{name:t,message:n}=v;const u=v.stacktrace||v.stack;return{$isError:!0,name:t,message:n,stack:u}}return v}e.transformErrorForSerialization=y;const C="Canceled";function D(v){return v instanceof Error&&v.name===C&&v.message===C}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const v=new Error(C);return v.name=v.message,v}e.canceled=i;function P(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=P;function d(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=d;function h(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function r(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function a(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=a;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function f(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function l(v,t=Object.create(null)){const n=new Error(v);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(we[15],_e([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I($,R=0){return $[$.length-(1+R)]}e.tail=I;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function T($,R,L=(M,U)=>M===U){if($===R)return!0;if(!$||!R||$.length!==R.length)return!1;for(let M=0,U=$.length;M<U;M++)if(!L($[M],R[M]))return!1;return!0}e.equals=T;function y($,R,L){let M=0,U=$.length-1;for(;M<=U;){const G=(M+U)/2|0,X=L($[G],R);if(X<0)M=G+1;else if(X>0)U=G-1;else return G}return-(M+1)}e.binarySearch=y;function C($,R){let L=0,M=$.length;if(M===0)return 0;for(;L<M;){const U=Math.floor((L+M)/2);R($[U])?M=U:L=U+1}return L}e.findFirstInSorted=C;function D($,R,L){if($=$|0,$>=R.length)throw new TypeError("invalid index");let M=R[Math.floor(R.length*Math.random())],U=[],G=[],X=[];for(let se of R){const pe=L(se,M);pe<0?U.push(se):pe>0?G.push(se):X.push(se)}return $<U.length?D($,U,L):$<U.length+X.length?X[0]:D($-(U.length+X.length),G,L)}e.quickSelect=D;function k($,R){const L=[];let M;for(const U of $.slice(0).sort(R))!M||R(M[0],U)!==0?(M=[U],L.push(M)):M.push(U);return L}e.groupBy=k;function i($,R,L){const M=[];function U(se,pe,Te){if(!(pe===0&&Te.length===0)){const xe=M[M.length-1];xe&&xe.start+xe.deleteCount===se?(xe.deleteCount+=pe,xe.toInsert.push(...Te)):M.push({start:se,deleteCount:pe,toInsert:Te})}}let G=0,X=0;for(;;){if(G===$.length){U(G,0,R.slice(X));break}if(X===R.length){U(G,$.length-G,[]);break}const se=$[G],pe=R[X],Te=L(se,pe);Te===0?(G+=1,X+=1):Te<0?(U(G,1,[]),G+=1):Te>0&&(U(G,0,[pe]),X+=1)}return M}e.sortedDiff=i;function P($,R,L){const M=i($,R,L),U=[],G=[];for(const X of M)U.push(...$.slice(X.start,X.start+X.deleteCount)),G.push(...X.toInsert);return{removed:U,added:G}}e.delta=P;function d($,R,L){if(L===0)return[];const M=$.slice(0,L).sort(R);return r($,R,M,L,$.length),M}e.top=d;function h($,R,L,M,U){return L===0?Promise.resolve([]):new Promise((G,X)=>{(async()=>{const se=$.length,pe=$.slice(0,L).sort(R);for(let Te=L,xe=Math.min(L+M,se);Te<se;Te=xe,xe=Math.min(xe+M,se)){if(Te>L&&await new Promise(Ae=>setTimeout(Ae)),U&&U.isCancellationRequested)throw(0,w.canceled)();r($,R,pe,Te,xe)}return pe})().then(G,X)})}e.topAsync=h;function r($,R,L,M,U){for(const G=L.length;M<U;M++){const X=$[M];if(R(X,L[G-1])<0){L.pop();const se=C(L,pe=>R(X,pe)<0);L.splice(se,0,X)}}}function a($){return $.filter(R=>!!R)}e.coalesce=a;function g($){let R=0;for(let L=0;L<$.length;L++)$[L]&&($[R]=$[L],R+=1);$.length=R}e.coalesceInPlace=g;function m($,R,L){$.splice(L,0,$.splice(R,1)[0])}e.move=m;function S($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=S;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function l($,R){if(!R)return $.filter((M,U)=>$.indexOf(M)===U);const L=Object.create(null);return $.filter(M=>{const U=R(M);return L[U]?!1:(L[U]=!0,!0)})}e.distinct=l;function v($){const R=new Set;return $.filter(L=>R.has(L)?!1:(R.add(L),!0))}e.distinctES6=v;function t($){const R=Object.create(null);return L=>{const M=$(L);return R[M]?!1:(R[M]=!0,!0)}}e.uniqueFilter=t;function n($,R){for(let L=$.length-1;L>=0;L--){const M=$[L];if(R(M))return L}return-1}e.lastIndex=n;function u($,R){return $.length>0?$[0]:R}e.firstOrDefault=u;function o($,R,L=(M,U)=>M===U){let M=0;for(let U=0,G=Math.min($.length,R.length);U<G&&L($[U],R[U]);U++)M++;return M}e.commonPrefixLength=o;function s($){return[].concat(...$)}e.flatten=s;function c($,R){let L=typeof R=="number"?$:0;typeof R=="number"?L=$:(L=0,R=$);const M=[];if(L<=R)for(let U=L;U<R;U++)M.push(U);else for(let U=L;U>R;U--)M.push(U);return M}e.range=c;function b($,R,L){return $.reduce((M,U)=>(M[R(U)]=L?L(U):U,M),Object.create(null))}e.index=b;function _($,R){return $.push(R),()=>p($,R)}e.insert=_;function p($,R){const L=$.indexOf(R);if(L>-1)return $.splice(L,1),R}e.remove=p;function E($,R,L){const M=$.slice(0,R),U=$.slice(R);return M.concat(L,U)}e.arrayInsert=E;function F($,R){let L;if(typeof R=="number"){let M=R;L=()=>{const U=Math.sin(M++)*179426549;return U-Math.floor(U)}}else L=Math.random;for(let M=$.length-1;M>0;M-=1){const U=Math.floor(L()*(M+1)),G=$[M];$[M]=$[U],$[U]=G}}e.shuffle=F;function B($,R){const L=$.indexOf(R);L>-1&&($.splice(L,1),$.unshift(R))}e.pushToStart=B;function Y($,R){const L=$.indexOf(R);L>-1&&($.splice(L,1),$.push(R))}e.pushToEnd=Y;function fe($,R){return Array.isArray($)?$.map(R):R($)}e.mapArrayOrNot=fe;function V($){return Array.isArray($)?$:[$]}e.asArray=V;function z($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=z;function ee($,R){for(const L of $){const M=R(L);if(M!==void 0)return M}}e.mapFind=ee}),define(we[53],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(I){const A=this;let T=!1,y;return function(){return T||(T=!0,y=I.apply(A,arguments)),y}}e.once=w}),define(we[54],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(we[43],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(I){function A(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}I.is=A;const T=Object.freeze([]);function y(){return T}I.empty=y;function*C(v){yield v}I.single=C;function D(v){return v||T}I.from=D;function k(v){return!v||v[Symbol.iterator]().next().done===!0}I.isEmpty=k;function i(v){return v[Symbol.iterator]().next().value}I.first=i;function P(v,t){for(const n of v)if(t(n))return!0;return!1}I.some=P;function d(v,t){for(const n of v)if(t(n))return n}I.find=d;function*h(v,t){for(const n of v)t(n)&&(yield n)}I.filter=h;function*r(v,t){for(const n of v)yield t(n)}I.map=r;function*a(...v){for(const t of v)for(const n of t)yield n}I.concat=a;function*g(v){for(const t of v)for(const n of t)yield n}I.concatNested=g;function m(v,t,n){let u=n;for(const o of v)u=t(u,o);return u}I.reduce=m;function*S(v,t,n=v.length){for(t<0&&(t+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);t<n;t++)yield v[t]}I.slice=S;function f(v,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,v];const u=v[Symbol.iterator]();for(let o=0;o<t;o++){const s=u.next();if(s.done)return[n,I.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return u}}]}I.consume=f;function l(v,t,n=(u,o)=>u===o){const u=v[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const s=u.next(),c=o.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!n(s.value,c.value))return!1}}I.equals=l})(w=e.Iterable||(e.Iterable={}))}),define(we[44],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let u=0,o=t.length,s="",c=0,b=16,_=0;function p(z){let ee=0,$=0;for(;ee<z;){const R=t.charCodeAt(u);if(R>=48&&R<=57)$=$*16+R-48;else if(R>=65&&R<=70)$=$*16+R-65+10;else if(R>=97&&R<=102)$=$*16+R-97+10;else break;u++,ee++}return ee<z&&($=-1),$}function E(z){u=z,s="",c=0,b=16,_=0}function F(){const z=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&k(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&k(t.charCodeAt(u)))for(u++;u<t.length&&k(t.charCodeAt(u));)u++;else return _=3,t.substring(z,u);let ee=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&k(t.charCodeAt(u))){for(u++;u<t.length&&k(t.charCodeAt(u));)u++;ee=u}else _=3;return t.substring(z,ee)}function B(){let z="",ee=u;for(;;){if(u>=o){z+=t.substring(ee,u),_=2;break}const $=t.charCodeAt(u);if($===34){z+=t.substring(ee,u),u++;break}if($===92){if(z+=t.substring(ee,u),u++,u>=o){_=2;break}switch(t.charCodeAt(u++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const L=p(4);L>=0?z+=String.fromCharCode(L):_=4;break;default:_=5}ee=u;continue}if($>=0&&$<=31)if(D($)){z+=t.substring(ee,u),_=2;break}else _=6;u++}return z}function Y(){if(s="",_=0,c=u,u>=o)return c=o,b=17;let z=t.charCodeAt(u);if(C(z)){do u++,s+=String.fromCharCode(z),z=t.charCodeAt(u);while(C(z));return b=15}if(D(z))return u++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(u)===10&&(u++,s+=`
`),b=14;switch(z){case 123:return u++,b=1;case 125:return u++,b=2;case 91:return u++,b=3;case 93:return u++,b=4;case 58:return u++,b=6;case 44:return u++,b=5;case 34:return u++,s=B(),b=10;case 47:const ee=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<o&&!D(t.charCodeAt(u));)u++;return s=t.substring(ee,u),b=12}if(t.charCodeAt(u+1)===42){u+=2;const $=o-1;let R=!1;for(;u<$;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,R=!0;break}u++}return R||(u++,_=1),s=t.substring(ee,u),b=13}return s+=String.fromCharCode(z),u++,b=16;case 45:if(s+=String.fromCharCode(z),u++,u===o||!k(t.charCodeAt(u)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),b=11;default:for(;u<o&&fe(z);)u++,z=t.charCodeAt(u);if(c!==u){switch(s=t.substring(c,u),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(z),u++,b=16}}function fe(z){if(C(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let z;do z=Y();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>u,scan:n?V:Y,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>u-c,getTokenError:()=>_}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const u=[],o=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function _(p,E,F,B){c.value=p,c.offset=E,c.length=F,c.type=B,c.colonOffset=void 0,s=c}try{f(t,{onObjectBegin:(p,E)=>{if(n<=p)throw o;s=void 0,b=n>p,u.push("")},onObjectProperty:(p,E,F)=>{if(n<E||(_(p,E,F,"property"),u[u.length-1]=p,n<=E+F))throw o},onObjectEnd:(p,E)=>{if(n<=p)throw o;s=void 0,u.pop()},onArrayBegin:(p,E)=>{if(n<=p)throw o;s=void 0,u.push(0)},onArrayEnd:(p,E)=>{if(n<=p)throw o;s=void 0,u.pop()},onLiteralValue:(p,E,F)=>{if(n<E||(_(p,E,F,v(p)),n<=E+F))throw o},onSeparator:(p,E,F)=>{if(n<=E)throw o;if(p===":"&&s&&s.type==="property")s.colonOffset=E,b=!1,s=void 0;else if(p===","){const B=u[u.length-1];typeof B=="number"?u[u.length-1]=B+1:(b=!0,u[u.length-1]=""),s=void 0}}})}catch(p){if(p!==o)throw p}return{path:u,previousNode:s,isAtPropertyKey:b,matches:p=>{let E=0;for(let F=0;E<p.length&&F<u.length;F++)if(p[E]===u[F]||p[E]==="*")E++;else if(p[E]!=="**")return!1;return E===p.length}}}e.getLocation=P;function d(t,n=[],u=T.DEFAULT){let o=null,s=[];const c=[];function b(p){Array.isArray(s)?s.push(p):o!==null&&(s[o]=p)}return f(t,{onObjectBegin:()=>{const p={};b(p),c.push(s),s=p,o=null},onObjectProperty:p=>{o=p},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const p=[];b(p),c.push(s),s=p,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:b,onError:(p,E,F)=>{n.push({error:p,offset:E,length:F})}},u),s[0]}e.parse=d;function h(t,n=[],u=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){o.type==="property"&&(o.length=p-o.offset,o=o.parent)}function c(p){return o.children.push(p),p}f(t,{onObjectBegin:p=>{o=c({type:"object",offset:p,length:-1,parent:o,children:[]})},onObjectProperty:(p,E,F)=>{o=c({type:"property",offset:E,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:p,offset:E,length:F,parent:o})},onObjectEnd:(p,E)=>{o.length=p+E-o.offset,o=o.parent,s(p+E)},onArrayBegin:(p,E)=>{o=c({type:"array",offset:p,length:-1,parent:o,children:[]})},onArrayEnd:(p,E)=>{o.length=p+E-o.offset,o=o.parent,s(p+E)},onLiteralValue:(p,E,F)=>{c({type:v(p),offset:E,length:F,parent:o,value:p}),s(E+F)},onSeparator:(p,E,F)=>{o.type==="property"&&(p===":"?o.colonOffset=E:p===","&&s(E))},onError:(p,E,F)=>{n.push({error:p,offset:E,length:F})}},u);const _=o.children[0];return _&&delete _.parent,_}e.parseTree=h;function r(t,n){if(!!t){let u=t;for(let o of n)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let s=!1;for(const c of u.children)if(Array.isArray(c.children)&&c.children[0].value===o){u=c.children[1],s=!0;break}if(!s)return}else{const s=o;if(u.type!=="array"||s<0||!Array.isArray(u.children)||s>=u.children.length)return;u=u.children[s]}return u}}e.findNodeAtLocation=r;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;n.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&n.push(u)}return n}e.getNodePath=a;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const n=Object.create(null);for(let u of t.children){const o=u.children[1];o&&(n[u.children[0].value]=g(o))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function m(t,n,u=!1){return n>=t.offset&&n<t.offset+t.length||u&&n===t.offset+t.length}e.contains=m;function S(t,n,u=!1){if(m(t,n,u)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=n;s++){const c=S(o[s],n,u);if(c)return c}return t}}e.findNodeAtOffset=S;function f(t,n,u=T.DEFAULT){const o=y(t,!1);function s(pe){return pe?()=>pe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(pe){return pe?Te=>pe(Te,o.getTokenOffset(),o.getTokenLength()):()=>!0}const b=s(n.onObjectBegin),_=c(n.onObjectProperty),p=s(n.onObjectEnd),E=s(n.onArrayBegin),F=s(n.onArrayEnd),B=c(n.onLiteralValue),Y=c(n.onSeparator),fe=s(n.onComment),V=c(n.onError),z=u&&u.disallowComments,ee=u&&u.allowTrailingComma;function $(){for(;;){const pe=o.scan();switch(o.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:z||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:z?R(10):fe();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Te=[],xe=[]){if(V(pe),Te.length+xe.length>0){let Ae=o.getToken();for(;Ae!==17;){if(Te.indexOf(Ae)!==-1){$();break}else if(xe.indexOf(Ae)!==-1)break;Ae=$()}}}function L(pe){const Te=o.getTokenValue();return pe?B(Te):_(Te),$(),!0}function M(){switch(o.getToken()){case 11:let pe=0;try{pe=JSON.parse(o.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Te){R(2)}B(pe);break;case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return $(),!0}function U(){return o.getToken()!==10?(R(3,[],[2,5]),!1):(L(!1),o.getToken()===6?(Y(":"),$(),se()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function G(){b(),$();let pe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(pe||R(4,[],[]),Y(","),$(),o.getToken()===2&&ee)break}else pe&&R(6,[],[]);U()||R(4,[],[2,5]),pe=!0}return p(),o.getToken()!==2?R(7,[2],[]):$(),!0}function X(){E(),$();let pe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(pe||R(4,[],[]),Y(","),$(),o.getToken()===4&&ee)break}else pe&&R(6,[],[]);se()||R(4,[],[4,5]),pe=!0}return F(),o.getToken()!==4?R(8,[4],[]):$(),!0}function se(){switch(o.getToken()){case 3:return X();case 1:return G();case 10:return L(!0);default:return M()}}return $(),o.getToken()===17?u.allowEmptyContent?!0:(R(4,[],[]),!1):se()?(o.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=f;function l(t,n){let u=y(t),o=[],s,c=0,b;do switch(b=u.getPosition(),s=u.scan(),s){case 12:case 13:case 17:c!==b&&o.push(t.substring(c,b)),n!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,n)),c=u.getPosition();break}while(s!==17);return o.join("")}e.stripComments=l;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(we[106],_e([0,1,44]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,k,i){let P,d,h,r,a;if(k){for(r=k.offset,a=r+k.length,h=r;h>0&&!C(D,h-1);)h--;let c=a;for(;c<D.length&&!C(D,c);)c++;d=D.substring(h,c),P=T(d,i)}else d=D,P=0,h=0,r=0,a=D.length;const g=y(i,D);let m=!1,S=0,f;i.insertSpaces?f=A(" ",i.tabSize||4):f="	";const l=(0,w.createScanner)(d,!1);let v=!1;function t(){return g+A(f,P+S)}function n(){let c=l.scan();for(m=!1;c===15||c===14;)m=m||c===14,c=l.scan();return v=c===16||l.getTokenError()!==0,c}const u=[];function o(c,b,_){!v&&b<a&&_>r&&D.substring(b,_)!==c&&u.push({offset:b,length:_-b,content:c})}let s=n();if(s!==17){const c=l.getTokenOffset()+h,b=A(f,P);o(b,h,c)}for(;s!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,b=n(),_="";for(;!m&&(b===12||b===13);){const E=l.getTokenOffset()+h;o(" ",c,E),c=l.getTokenOffset()+l.getTokenLength()+h,_=b===12?t():"",b=n()}if(b===2)s!==1&&(S--,_=t());else if(b===4)s!==3&&(S--,_=t());else{switch(s){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:m?_=t():_=" ";break;case 6:_=" ";break;case 10:if(b===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?_=" ":b!==5&&b!==17&&(v=!0);break;case 16:v=!0;break}m&&(b===12||b===13)&&(_=t())}const p=l.getTokenOffset()+h;o(_,c,p),s=b}return u}e.format=I;function A(D,k){let i="";for(let P=0;P<k;P++)i+=D;return i}function T(D,k){let i=0,P=0;const d=k.tabSize||4;for(;i<D.length;){const h=D.charAt(i);if(h===" ")P++;else if(h==="	")P+=d;else break;i++}return Math.floor(P/d)}function y(D,k){for(let i=0;i<k.length;i++){const P=k.charAt(i);if(P==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function C(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=C}),define(we[107],_e([0,1,44,106]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(k,i,P){return T(k,i,void 0,P)}e.removeProperty=A;function T(k,i,P,d,h){const r=i.slice(),a=[],g=(0,w.parseTree)(k,a);let m,S;for(;r.length>0&&(S=r.pop(),m=(0,w.findNodeAtLocation)(g,r),m===void 0&&P!==void 0);)typeof S=="string"?P={[S]:P}:P=[P];if(m)if(m.type==="object"&&typeof S=="string"&&Array.isArray(m.children)){const f=(0,w.findNodeAtLocation)(m,[S]);if(f!==void 0)if(P===void 0){if(!f.parent)throw new Error("Malformed AST");const l=m.children.indexOf(f.parent);let v,t=f.parent.offset+f.parent.length;if(l>0){const n=m.children[l-1];v=n.offset+n.length}else v=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return y(k,{offset:v,length:t-v,content:""},d)}else return y(k,{offset:f.offset,length:f.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const l=`${JSON.stringify(S)}: ${JSON.stringify(P)}`,v=h?h(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(v>0){const n=m.children[v-1];t={offset:n.offset+n.length,length:0,content:","+l}}else m.children.length===0?t={offset:m.offset+1,length:0,content:l}:t={offset:m.offset+1,length:0,content:l+","};return y(k,t,d)}}else if(m.type==="array"&&typeof S=="number"&&Array.isArray(m.children))if(P!==void 0){const f=`${JSON.stringify(P)}`;let l;if(m.children.length===0||S===0)l={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const v=S===-1||S>m.children.length?m.children.length:S,t=m.children[v-1];l={offset:t.offset+t.length,length:0,content:","+f}}return y(k,l,d)}else{const f=S,l=m.children[f];let v;if(m.children.length===1)v={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const t=m.children[f-1],n=t.offset+t.length,u=m.offset+m.length;v={offset:n,length:u-2-n,content:""}}else v={offset:l.offset,length:m.children[f+1].offset-l.offset,content:""};return y(k,v,d)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${m.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(P)},d)}}e.setProperty=T;function y(k,i,P){let d=C(k,i),h=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;h>0&&!(0,I.isEOL)(d,h-1);)h--;for(;r<d.length&&!(0,I.isEOL)(d,r);)r++}const a=(0,I.format)(d,{offset:h,length:r-h},P);for(let m=a.length-1;m>=0;m--){const S=a[m];d=C(d,S),h=Math.min(h,S.offset),r=Math.max(r,S.offset+S.length),r+=S.content.length-S.length}const g=k.length-(d.length-r)-h;return[{offset:h,length:g,content:d.substring(h,r)}]}e.withFormatting=y;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function D(k,i){let P=i.slice(0).sort((h,r)=>{const a=h.offset-r.offset;return a===0?h.length-r.length:a}),d=k.length;for(let h=P.length-1;h>=0;h--){let r=P[h];if(r.offset+r.length<=d)k=C(k,r);else throw new Error("Overlapping edit");d=r.offset}return k}e.applyEdits=D}),define(we[108],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new w(()=>A(this.getValue()))}}e.Lazy=w}),define(we[6],_e([0,1,53,43]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(f){T=f}if(e.setDisposableTracker=y,A){const f="__is_disposable_tracked__";T=new class{trackDisposable(l){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[f]||console.log(v)},3e3)}markTracked(l){if(l&&l!==a.None)try{l[f]=!0}catch(v){}}}}function C(f){!T||T.markTracked(f)}function D(f){return T&&T.trackDisposable(f),f}e.trackDisposable=D;class k extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=k;function i(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=i;function P(f){if(I.Iterable.is(f)){let l=[];for(const v of f)if(v){C(v);try{v.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new k(l);return Array.isArray(f)?[]:f}else if(f)return C(f),f.dispose(),f}e.dispose=P;function d(...f){return f.forEach(C),h(()=>P(f))}e.combinedDisposable=d;function h(f){const l=D({dispose:()=>{C(l),f()}});return l}e.toDisposable=h;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return C(l),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new r,D(this)}dispose(){C(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var v;this._isDisposed||l===this._value||((v=this._value)===null||v===void 0||v.dispose(),l&&C(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,C(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=g;class m{constructor(){this.references=new Map}acquire(l,...v){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...v)},this.references.set(l,t));const{object:n}=t,u=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:u}}}e.ReferenceCollection=m;class S{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=S}),define(we[45],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(T){this.element=T,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class I{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const C=new w(T);if(this._first===w.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==w.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==w.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==w.Undefined&&T.next!==w.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===w.Undefined&&T.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):T.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):T.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==w.Undefined;)yield T.element,T=T.next}}e.LinkedList=I}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(W,ie){for(var ce=0;ce<ie.length;ce++){var j=ie[ce];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(W,j.key,j)}}function e(W,ie,ce){return ie&&Q(W.prototype,ie),ce&&Q(W,ce),W}function w(W,ie){if(!!W){if(typeof W=="string")return I(W,ie);var ce=Object.prototype.toString.call(W).slice(8,-1);if(ce==="Object"&&W.constructor&&(ce=W.constructor.name),ce==="Map"||ce==="Set")return Array.from(W);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return I(W,ie)}}function I(W,ie){(ie==null||ie>W.length)&&(ie=W.length);for(var ce=0,j=new Array(ie);ce<ie;ce++)j[ce]=W[ce];return j}function A(W,ie){var ce;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(ce=w(W))||ie&&W&&typeof W.length=="number"){ce&&(W=ce);var j=0;return function(){return j>=W.length?{done:!0}:{done:!1,value:W[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=W[Symbol.iterator](),ce.next.bind(ce)}function T(W){var ie={exports:{}};return W(ie,ie.exports),ie.exports}var y=T(function(W){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(j){W.exports.defaults=j}W.exports={defaults:ie(),getDefaults:ie,changeDefaults:ce}}),C=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ie){return P[ie]};function h(W,ie){if(ie){if(C.test(W))return W.replace(D,d)}else if(k.test(W))return W.replace(i,d);return W}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(W){return W.replace(r,function(ie,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var g=/(^|[^\[])\^/g;function m(W,ie){W=W.source||W,ie=ie||"";var ce={replace:function(Z,ae){return ae=ae.source||ae,ae=ae.replace(g,"$1"),W=W.replace(Z,ae),ce},getRegex:function(){return new RegExp(W,ie)}};return ce}var S=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(W,ie,ce){if(W){var j;try{j=decodeURIComponent(a(ce)).replace(S,"").toLowerCase()}catch(Z){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ie&&!f.test(ce)&&(ce=o(ie,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(Z){return null}return ce}var v={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(W,ie){v[" "+W]||(t.test(W)?v[" "+W]=W+"/":v[" "+W]=_(W,"/",!0)),W=v[" "+W];var ce=W.indexOf(":")===-1;return ie.substring(0,2)==="//"?ce?ie:W.replace(n,"$1")+ie:ie.charAt(0)==="/"?ce?ie:W.replace(u,"$1")+ie:W+ie}var s={exec:function(){}};function c(W){for(var ie=1,ce,j;ie<arguments.length;ie++){ce=arguments[ie];for(j in ce)Object.prototype.hasOwnProperty.call(ce,j)&&(W[j]=ce[j])}return W}function b(W,ie){var ce=W.replace(/\|/g,function(ae,he,ye){for(var ze=!1,Be=he;--Be>=0&&ye[Be]==="\\";)ze=!ze;return ze?"|":" |"}),j=ce.split(/ \|/),Z=0;if(j.length>ie)j.splice(ie);else for(;j.length<ie;)j.push("");for(;Z<j.length;Z++)j[Z]=j[Z].trim().replace(/\\\|/g,"|");return j}function _(W,ie,ce){var j=W.length;if(j===0)return"";for(var Z=0;Z<j;){var ae=W.charAt(j-Z-1);if(ae===ie&&!ce)Z++;else if(ae!==ie&&ce)Z++;else break}return W.substr(0,j-Z)}function p(W,ie){if(W.indexOf(ie[1])===-1)return-1;for(var ce=W.length,j=0,Z=0;Z<ce;Z++)if(W[Z]==="\\")Z++;else if(W[Z]===ie[0])j++;else if(W[Z]===ie[1]&&(j--,j<0))return Z;return-1}function E(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(W,ie){if(ie<1)return"";for(var ce="";ie>1;)ie&1&&(ce+=W),ie>>=1,W+=W;return ce+W}var B={escape:h,unescape:a,edit:m,cleanUrl:l,resolveUrl:o,noopTest:s,merge:c,splitCells:b,rtrim:_,findClosingBracket:p,checkSanitizeDeprecation:E,repeatString:F},Y=y.defaults,fe=B.rtrim,V=B.splitCells,z=B.escape,ee=B.findClosingBracket;function $(W,ie,ce){var j=ie.href,Z=ie.title?z(ie.title):null,ae=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:ce,href:j,title:Z,text:ae}:{type:"image",raw:ce,href:j,title:Z,text:z(ae)}}function R(W,ie){var ce=W.match(/^(\s+)(?:```)/);if(ce===null)return ie;var j=ce[1];return ie.split(`
`).map(function(Z){var ae=Z.match(/^\s+/);if(ae===null)return Z;var he=ae[0];return he.length>=j.length?Z.slice(j.length):Z}).join(`
`)}var L=function(){function W(ce){this.options=ce||Y}var ie=W.prototype;return ie.space=function(j){var Z=this.rules.block.newline.exec(j);if(Z)return Z[0].length>1?{type:"space",raw:Z[0]}:{raw:`
`}},ie.code=function(j){var Z=this.rules.block.code.exec(j);if(Z){var ae=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:fe(ae,`
`)}}},ie.fences=function(j){var Z=this.rules.block.fences.exec(j);if(Z){var ae=Z[0],he=R(ae,Z[3]||"");return{type:"code",raw:ae,lang:Z[2]?Z[2].trim():Z[2],text:he}}},ie.heading=function(j){var Z=this.rules.block.heading.exec(j);if(Z){var ae=Z[2].trim();if(/#$/.test(ae)){var he=fe(ae,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ae=he.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:ae}}},ie.nptable=function(j){var Z=this.rules.block.nptable.exec(j);if(Z){var ae={type:"table",header:V(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[],raw:Z[0]};if(ae.header.length===ae.align.length){var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=V(ae.cells[ye],ae.header.length);return ae}}},ie.hr=function(j){var Z=this.rules.block.hr.exec(j);if(Z)return{type:"hr",raw:Z[0]}},ie.blockquote=function(j){var Z=this.rules.block.blockquote.exec(j);if(Z){var ae=Z[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Z[0],text:ae}}},ie.list=function(j){var Z=this.rules.block.list.exec(j);if(Z){var ae=Z[0],he=Z[2],ye=he.length>1,ze={type:"list",raw:ae,ordered:ye,start:ye?+he.slice(0,-1):"",loose:!1,items:[]},Be=Z[0].match(this.rules.block.item),Ne=!1,Ge,nt,dt,it,Je,mt,bt,be,de=Be.length;dt=this.rules.block.listItemStart.exec(Be[0]);for(var oe=0;oe<de;oe++){if(Ge=Be[oe],ae=Ge,oe!==de-1){if(it=this.rules.block.listItemStart.exec(Be[oe+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){Be.splice(oe,2,Be[oe]+`
`+Be[oe+1]),oe--,de--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==he[he.length-1]:ye===(it[2].length===1))&&(Je=Be.slice(oe+1).join(`
`),ze.raw=ze.raw.substring(0,ze.raw.length-Je.length),oe=de-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=Ne||/\n\n(?!\s*$)/.test(Ge),oe!==de-1&&(Ne=Ge.charAt(Ge.length-1)===`
`,mt||(mt=Ne)),mt&&(ze.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(Ge),be=void 0,bt&&(be=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:ae,task:bt,checked:be,loose:mt,text:Ge})}return ze}},ie.html=function(j){var Z=this.rules.block.html.exec(j);if(Z)return{type:this.options.sanitize?"paragraph":"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):z(Z[0]):Z[0]}},ie.def=function(j){var Z=this.rules.block.def.exec(j);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var ae=Z[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:Z[0],href:Z[2],title:Z[3]}}},ie.table=function(j){var Z=this.rules.block.table.exec(j);if(Z){var ae={type:"table",header:V(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=Z[0];var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=V(ae.cells[ye].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},ie.lheading=function(j){var Z=this.rules.block.lheading.exec(j);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1]}},ie.paragraph=function(j){var Z=this.rules.block.paragraph.exec(j);if(Z)return{type:"paragraph",raw:Z[0],text:Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1]}},ie.text=function(j){var Z=this.rules.block.text.exec(j);if(Z)return{type:"text",raw:Z[0],text:Z[0]}},ie.escape=function(j){var Z=this.rules.inline.escape.exec(j);if(Z)return{type:"escape",raw:Z[0],text:z(Z[1])}},ie.tag=function(j,Z,ae){var he=this.rules.inline.tag.exec(j);if(he)return!Z&&/^<a /i.test(he[0])?Z=!0:Z&&/^<\/a>/i.test(he[0])&&(Z=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:Z,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]}},ie.link=function(j){var Z=this.rules.inline.link.exec(j);if(Z){var ae=Z[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var he=fe(ae.slice(0,-1),"\\");if((ae.length-he.length)%2==0)return}else{var ye=ee(Z[2],"()");if(ye>-1){var ze=Z[0].indexOf("!")===0?5:4,Be=ze+Z[1].length+ye;Z[2]=Z[2].substring(0,ye),Z[0]=Z[0].substring(0,Be).trim(),Z[3]=""}}var Ne=Z[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);nt&&(Ne=nt[1],Ge=nt[3])}else Ge=Z[3]?Z[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(ae)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),$(Z,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},Z[0])}},ie.reflink=function(j,Z){var ae;if((ae=this.rules.inline.reflink.exec(j))||(ae=this.rules.inline.nolink.exec(j))){var he=(ae[2]||ae[1]).replace(/\s+/g," ");if(he=Z[he.toLowerCase()],!he||!he.href){var ye=ae[0].charAt(0);return{type:"text",raw:ye,text:ye}}return $(ae,he,ae[0])}},ie.emStrong=function(j,Z,ae){ae===void 0&&(ae="");var he=this.rules.inline.emStrong.lDelim.exec(j);if(!!he&&!(he[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=he[1]||he[2]||"";if(!ye||ye&&(ae===""||this.rules.inline.punctuation.exec(ae))){var ze=he[0].length-1,Be,Ne,Ge=ze,nt=0,dt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,Z=Z.slice(-1*j.length+ze);(he=dt.exec(Z))!=null;)if(Be=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Be){if(Ne=Be.length,he[3]||he[4]){Ge+=Ne;continue}else if((he[5]||he[6])&&ze%3&&!((ze+Ne)%3)){nt+=Ne;continue}if(Ge-=Ne,!(Ge>0)){if(Ge+nt-Ne<=0&&!Z.slice(dt.lastIndex).match(dt)&&(Ne=Math.min(Ne,Ne+Ge+nt)),Math.min(ze,Ne)%2)return{type:"em",raw:j.slice(0,ze+he.index+Ne+1),text:j.slice(1,ze+he.index+Ne)};if(Math.min(ze,Ne)%2==0)return{type:"strong",raw:j.slice(0,ze+he.index+Ne+1),text:j.slice(2,ze+he.index+Ne-1)}}}}}},ie.codespan=function(j){var Z=this.rules.inline.code.exec(j);if(Z){var ae=Z[2].replace(/\n/g," "),he=/[^ ]/.test(ae),ye=/^ /.test(ae)&&/ $/.test(ae);return he&&ye&&(ae=ae.substring(1,ae.length-1)),ae=z(ae,!0),{type:"codespan",raw:Z[0],text:ae}}},ie.br=function(j){var Z=this.rules.inline.br.exec(j);if(Z)return{type:"br",raw:Z[0]}},ie.del=function(j){var Z=this.rules.inline.del.exec(j);if(Z)return{type:"del",raw:Z[0],text:Z[2]}},ie.autolink=function(j,Z){var ae=this.rules.inline.autolink.exec(j);if(ae){var he,ye;return ae[2]==="@"?(he=z(this.options.mangle?Z(ae[1]):ae[1]),ye="mailto:"+he):(he=z(ae[1]),ye=he),{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.url=function(j,Z){var ae;if(ae=this.rules.inline.url.exec(j)){var he,ye;if(ae[2]==="@")he=z(this.options.mangle?Z(ae[0]):ae[0]),ye="mailto:"+he;else{var ze;do ze=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(ze!==ae[0]);he=z(ae[0]),ae[1]==="www."?ye="http://"+he:ye=he}return{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.inlineText=function(j,Z,ae){var he=this.rules.inline.text.exec(j);if(he){var ye;return Z?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]:ye=z(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:ye}}},W}(),M=B.noopTest,U=B.edit,G=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=U(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,X.item=U(X.item,"gm").replace(/bull/g,X.bullet).getRegex(),X.listItemStart=U(/^( *)(bull)/).replace("bull",X.bullet).getRegex(),X.list=U(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=U(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=U(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.blockquote=U(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=G({},X),X.gfm=G({},X.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.nptable=U(X.gfm.nptable).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.gfm.table=U(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.pedantic=G({},X.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:U(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=U(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=U(X._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=U(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=U(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=U(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=U(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=U(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=U(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=U(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=U(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=G({},se),se.pedantic=G({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=G({},se.normal,{escape:U(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=U(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=G({},se.gfm,{br:U(se.br).replace("{2,}","*").getRegex(),text:U(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:X,inline:se},Te=y.defaults,xe=pe.block,Ae=pe.inline,We=B.repeatString;function x(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(W){var ie="",ce,j,Z=W.length;for(ce=0;ce<Z;ce++)j=W.charCodeAt(ce),Math.random()>.5&&(j="x"+j.toString(16)),ie+="&#"+j+";";return ie}var ne=function(){function W(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Te,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:xe.normal,inline:Ae.normal};this.options.pedantic?(j.block=xe.pedantic,j.inline=Ae.pedantic):this.options.gfm&&(j.block=xe.gfm,this.options.breaks?j.inline=Ae.breaks:j.inline=Ae.gfm),this.tokenizer.rules=j}W.lex=function(j,Z){var ae=new W(Z);return ae.lex(j)},W.lexInline=function(j,Z){var ae=new W(Z);return ae.inlineTokens(j)};var ie=W.prototype;return ie.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(j,Z,ae){Z===void 0&&(Z=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var he,ye,ze,Be;j;){if(he=this.tokenizer.space(j)){j=j.substring(he.raw.length),he.type&&Z.push(he);continue}if(he=this.tokenizer.code(j)){j=j.substring(he.raw.length),Be=Z[Z.length-1],Be&&Be.type==="paragraph"?(Be.raw+=`
`+he.raw,Be.text+=`
`+he.text):Z.push(he);continue}if(he=this.tokenizer.fences(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.heading(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.nptable(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.hr(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.blockquote(j)){j=j.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],ae),Z.push(he);continue}if(he=this.tokenizer.list(j)){for(j=j.substring(he.raw.length),ze=he.items.length,ye=0;ye<ze;ye++)he.items[ye].tokens=this.blockTokens(he.items[ye].text,[],!1);Z.push(he);continue}if(he=this.tokenizer.html(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(ae&&(he=this.tokenizer.def(j))){j=j.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.lheading(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(ae&&(he=this.tokenizer.paragraph(j))){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.text(j)){j=j.substring(he.raw.length),Be=Z[Z.length-1],Be&&Be.type==="text"?(Be.raw+=`
`+he.raw,Be.text+=`
`+he.text):Z.push(he);continue}if(j){var Ne="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return Z},ie.inline=function(j){var Z,ae,he,ye,ze,Be,Ne=j.length;for(Z=0;Z<Ne;Z++)switch(Be=j[Z],Be.type){case"paragraph":case"text":case"heading":{Be.tokens=[],this.inlineTokens(Be.text,Be.tokens);break}case"table":{for(Be.tokens={header:[],cells:[]},ye=Be.header.length,ae=0;ae<ye;ae++)Be.tokens.header[ae]=[],this.inlineTokens(Be.header[ae],Be.tokens.header[ae]);for(ye=Be.cells.length,ae=0;ae<ye;ae++)for(ze=Be.cells[ae],Be.tokens.cells[ae]=[],he=0;he<ze.length;he++)Be.tokens.cells[ae][he]=[],this.inlineTokens(ze[he],Be.tokens.cells[ae][he]);break}case"blockquote":{this.inline(Be.tokens);break}case"list":{for(ye=Be.items.length,ae=0;ae<ye;ae++)this.inline(Be.items[ae].tokens);break}}return j},ie.inlineTokens=function(j,Z,ae,he){Z===void 0&&(Z=[]),ae===void 0&&(ae=!1),he===void 0&&(he=!1);var ye,ze,Be=j,Ne,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Be))!=null;)dt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Be=Be.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Be))!=null;)Be=Be.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Be))!=null;)Be=Be.slice(0,Ne.index)+"++"+Be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(j)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.tag(j,ae,he)){j=j.substring(ye.raw.length),ae=ye.inLink,he=ye.inRawBlock;var it=Z[Z.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):Z.push(ye);continue}if(ye=this.tokenizer.link(j)){j=j.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,he)),Z.push(ye);continue}if(ye=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(ye.raw.length);var Je=Z[Z.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,he),Z.push(ye)):Je&&ye.type==="text"&&Je.type==="text"?(Je.raw+=ye.raw,Je.text+=ye.text):Z.push(ye);continue}if(ye=this.tokenizer.emStrong(j,Be,nt)){j=j.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),Z.push(ye);continue}if(ye=this.tokenizer.codespan(j)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.br(j)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.del(j)){j=j.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),Z.push(ye);continue}if(ye=this.tokenizer.autolink(j,q)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(!ae&&(ye=this.tokenizer.url(j,q))){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.inlineText(j,he,x)){j=j.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,ze=Z[Z.length-1],ze&&ze.type==="text"?(ze.raw+=ye.raw,ze.text+=ye.text):Z.push(ye);continue}if(j){var mt="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return Z},e(W,null,[{key:"rules",get:function(){return{block:xe,inline:Ae}}}]),W}(),le=y.defaults,me=B.cleanUrl,Se=B.escape,Oe=function(){function W(ce){this.options=ce||le}var ie=W.prototype;return ie.code=function(j,Z,ae){var he=(Z||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(j,he);ye!=null&&ye!==j&&(ae=!0,j=ye)}return j=j.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+Se(he,!0)+'">'+(ae?j:Se(j,!0))+`</code></pre>
`:"<pre><code>"+(ae?j:Se(j,!0))+`</code></pre>
`},ie.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ie.html=function(j){return j},ie.heading=function(j,Z,ae,he){return this.options.headerIds?"<h"+Z+' id="'+this.options.headerPrefix+he.slug(ae)+'">'+j+"</h"+Z+`>
`:"<h"+Z+">"+j+"</h"+Z+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(j,Z,ae){var he=Z?"ol":"ul",ye=Z&&ae!==1?' start="'+ae+'"':"";return"<"+he+ye+`>
`+j+"</"+he+`>
`},ie.listitem=function(j){return"<li>"+j+`</li>
`},ie.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(j){return"<p>"+j+`</p>
`},ie.table=function(j,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+Z+`</table>
`},ie.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ie.tablecell=function(j,Z){var ae=Z.header?"th":"td",he=Z.align?"<"+ae+' align="'+Z.align+'">':"<"+ae+">";return he+j+"</"+ae+`>
`},ie.strong=function(j){return"<strong>"+j+"</strong>"},ie.em=function(j){return"<em>"+j+"</em>"},ie.codespan=function(j){return"<code>"+j+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(j){return"<del>"+j+"</del>"},ie.link=function(j,Z,ae){if(j=me(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<a href="'+Se(j)+'"';return Z&&(he+=' title="'+Z+'"'),he+=">"+ae+"</a>",he},ie.image=function(j,Z,ae){if(j=me(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<img src="'+j+'" alt="'+ae+'"';return Z&&(he+=' title="'+Z+'"'),he+=this.options.xhtml?"/>":">",he},ie.text=function(j){return j},W}(),ge=function(){function W(){}var ie=W.prototype;return ie.strong=function(j){return j},ie.em=function(j){return j},ie.codespan=function(j){return j},ie.del=function(j){return j},ie.html=function(j){return j},ie.text=function(j){return j},ie.link=function(j,Z,ae){return""+ae},ie.image=function(j,Z,ae){return""+ae},ie.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var ie=W.prototype;return ie.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(j,Z){var ae=j,he=0;if(this.seen.hasOwnProperty(ae)){he=this.seen[j];do he++,ae=j+"-"+he;while(this.seen.hasOwnProperty(ae))}return Z||(this.seen[j]=he,this.seen[ae]=0),ae},ie.slug=function(j,Z){Z===void 0&&(Z={});var ae=this.serialize(j);return this.getNextSafeSlug(ae,Z.dryrun)},W}(),Pe=y.defaults,$e=B.unescape,Ee=function(){function W(ce){this.options=ce||Pe,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}W.parse=function(j,Z){var ae=new W(Z);return ae.parse(j)},W.parseInline=function(j,Z){var ae=new W(Z);return ae.parseInline(j)};var ie=W.prototype;return ie.parse=function(j,Z){Z===void 0&&(Z=!0);var ae="",he,ye,ze,Be,Ne,Ge,nt,dt,it,Je,mt,bt,be,de,oe,K,Re,Ie,Qe=j.length;for(he=0;he<Qe;he++)switch(Je=j[he],Je.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,$e(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(dt="",nt="",Be=Je.header.length,ye=0;ye<Be;ye++)nt+=this.renderer.tablecell(this.parseInline(Je.tokens.header[ye]),{header:!0,align:Je.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",Be=Je.cells.length,ye=0;ye<Be;ye++){for(Ge=Je.tokens.cells[ye],nt="",Ne=Ge.length,ze=0;ze<Ne;ze++)nt+=this.renderer.tablecell(this.parseInline(Ge[ze]),{header:!1,align:Je.align[ze]});it+=this.renderer.tablerow(nt)}ae+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Je.tokens),ae+=this.renderer.blockquote(it);continue}case"list":{for(mt=Je.ordered,bt=Je.start,be=Je.loose,Be=Je.items.length,it="",ye=0;ye<Be;ye++)oe=Je.items[ye],K=oe.checked,Re=oe.task,de="",oe.task&&(Ie=this.renderer.checkbox(K),be?oe.tokens.length>0&&oe.tokens[0].type==="text"?(oe.tokens[0].text=Ie+" "+oe.tokens[0].text,oe.tokens[0].tokens&&oe.tokens[0].tokens.length>0&&oe.tokens[0].tokens[0].type==="text"&&(oe.tokens[0].tokens[0].text=Ie+" "+oe.tokens[0].tokens[0].text)):oe.tokens.unshift({type:"text",text:Ie}):de+=Ie),de+=this.parse(oe.tokens,be),it+=this.renderer.listitem(de,Re,K);ae+=this.renderer.list(it,mt,bt);continue}case"html":{ae+=this.renderer.html(Je.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(it=Je.tokens?this.parseInline(Je.tokens):Je.text;he+1<Qe&&j[he+1].type==="text";)Je=j[++he],it+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);ae+=Z?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ae},ie.parseInline=function(j,Z){Z=Z||this.renderer;var ae="",he,ye,ze=j.length;for(he=0;he<ze;he++)switch(ye=j[he],ye.type){case"escape":{ae+=Z.text(ye.text);break}case"html":{ae+=Z.html(ye.text);break}case"link":{ae+=Z.link(ye.href,ye.title,this.parseInline(ye.tokens,Z));break}case"image":{ae+=Z.image(ye.href,ye.title,ye.text);break}case"strong":{ae+=Z.strong(this.parseInline(ye.tokens,Z));break}case"em":{ae+=Z.em(this.parseInline(ye.tokens,Z));break}case"codespan":{ae+=Z.codespan(ye.text);break}case"br":{ae+=Z.br();break}case"del":{ae+=Z.del(this.parseInline(ye.tokens,Z));break}case"text":{ae+=Z.text(ye.text);break}default:{var Be='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}return ae},W}(),je=B.merge,H=B.checkSanitizeDeprecation,te=B.escape,ve=y.getDefaults,Le=y.changeDefaults,He=y.defaults;function Ue(W,ie,ce){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof ie=="function"&&(ce=ie,ie=null),ie=je({},Ue.defaults,ie||{}),H(ie),ce){var j=ie.highlight,Z;try{Z=ne.lex(W,ie)}catch(ze){return ce(ze)}var ae=function(Be){var Ne;if(!Be)try{Ne=Ee.parse(Z,ie)}catch(Ge){Be=Ge}return ie.highlight=j,Be?ce(Be):ce(null,Ne)};if(!j||j.length<3||(delete ie.highlight,!Z.length))return ae();var he=0;Ue.walkTokens(Z,function(ze){ze.type==="code"&&(he++,setTimeout(function(){j(ze.text,ze.lang,function(Be,Ne){if(Be)return ae(Be);Ne!=null&&Ne!==ze.text&&(ze.text=Ne,ze.escaped=!0),he--,he===0&&ae()})},0))}),he===0&&ae();return}try{var ye=ne.lex(W,ie);return ie.walkTokens&&Ue.walkTokens(ye,ie.walkTokens),Ee.parse(ye,ie)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+te(ze.message+"",!0)+"</pre>";throw ze}}Ue.options=Ue.setOptions=function(W){return je(Ue.defaults,W),Le(Ue.defaults),Ue},Ue.getDefaults=ve,Ue.defaults=He,Ue.use=function(W){var ie=je({},W);if(W.renderer&&function(){var j=Ue.defaults.renderer||new Oe,Z=function(ye){var ze=j[ye];j[ye]=function(){for(var Be=arguments.length,Ne=new Array(Be),Ge=0;Ge<Be;Ge++)Ne[Ge]=arguments[Ge];var nt=W.renderer[ye].apply(j,Ne);return nt===!1&&(nt=ze.apply(j,Ne)),nt}};for(var ae in W.renderer)Z(ae);ie.renderer=j}(),W.tokenizer&&function(){var j=Ue.defaults.tokenizer||new L,Z=function(ye){var ze=j[ye];j[ye]=function(){for(var Be=arguments.length,Ne=new Array(Be),Ge=0;Ge<Be;Ge++)Ne[Ge]=arguments[Ge];var nt=W.tokenizer[ye].apply(j,Ne);return nt===!1&&(nt=ze.apply(j,Ne)),nt}};for(var ae in W.tokenizer)Z(ae);ie.tokenizer=j}(),W.walkTokens){var ce=Ue.defaults.walkTokens;ie.walkTokens=function(j){W.walkTokens(j),ce&&ce(j)}}Ue.setOptions(ie)},Ue.walkTokens=function(W,ie){for(var ce=A(W),j;!(j=ce()).done;){var Z=j.value;switch(ie(Z),Z.type){case"table":{for(var ae=A(Z.tokens.header),he;!(he=ae()).done;){var ye=he.value;Ue.walkTokens(ye,ie)}for(var ze=A(Z.tokens.cells),Be;!(Be=ze()).done;)for(var Ne=Be.value,Ge=A(Ne),nt;!(nt=Ge()).done;){var dt=nt.value;Ue.walkTokens(dt,ie)}break}case"list":{Ue.walkTokens(Z.items,ie);break}default:Z.tokens&&Ue.walkTokens(Z.tokens,ie)}}},Ue.parseInline=function(W,ie){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");ie=je({},Ue.defaults,ie||{}),H(ie);try{var ce=ne.lexInline(W,ie);return ie.walkTokens&&Ue.walkTokens(ce,ie.walkTokens),Ee.parseInline(ce,ie)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+te(j.message+"",!0)+"</pre>";throw j}},Ue.Parser=Ee,Ue.parser=Ee.parse,Ue.Renderer=Oe,Ue.TextRenderer=ge,Ue.Lexer=ne,Ue.lexer=ne.lex,Ue.Tokenizer=L,Ue.Slugger=Ce,Ue.parse=Ue;var Xe=Ue;return Xe}),define(we[81],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(y,C,D){return Math.min(Math.max(y,C),D)}e.clamp=w;function I(y,C){return(C+y%C)%C}e.rot=I;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function Q(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(D){T.push(D,Date.now())}function C(){const D=[];for(let k=0;k<T.length;k+=2)D.push({name:T[k],startTime:T[k+1]});return D}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function w(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=w(I))})(),define(we[21],_e([0,1]),function(Q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let A=!1,T=!1,y=!1,C=!1,D=!1,k=!1,i=!1,P,d=I,h,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const g=typeof((w=a==null?void 0:a.versions)===null||w===void 0?void 0:w.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=g&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)r=navigator.userAgent,A=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,k=!0,P=navigator.language,d=P;else if(typeof a=="object"){A=a.platform==="win32",T=a.platform==="darwin",y=a.platform==="linux",C=y&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,P=I,d=I;const o=a.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),c=s.availableLanguages["*"];P=s.locale,d=c||I,h=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var m;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function S(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let f=0;T?f=1:A?f=3:y&&(f=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=C,e.isNative=D,e.isWeb=k,e.isIOS=i,e.platform=f,e.userAgent=r,e.language=d;var l;(function(o){function s(){return e.language}o.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function b(){return e.language==="en"}o.isDefault=b})(l=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let p=0,E=c.length;p<E;p++){const F=c[p];if(F.id===_.data.vscodeSetImmediateId){c.splice(p,1),F.callback();return}}});let b=0;return _=>{const p=++b;c.push({id:p,callback:_}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const s=Promise.resolve();return c=>s.then(c)}();var v;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(v=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:A?1:3;let t=!0,n=!1;function u(){if(!n){n=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=u}),define(we[46],_e([0,1,21]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof w.globals.vscode!="undefined"){const A=w.globals.vscode.process;I={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,w.setImmediate)(T)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:I={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(A){return(0,w.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(we[13],_e([0,1,46]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,A=97,T=90,y=122,C=46,D=47,k=92,i=58,P=63;class d extends Error{constructor(l,v,t){let n;typeof v=="string"&&v.indexOf("not ")===0?(n="must not be",v=v.replace(/^not /,"")):n="must be";const u=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${u} ${n} of type ${v}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,l){if(typeof f!="string")throw new d(l,"string",f)}function r(f){return f===D||f===k}function a(f){return f===D}function g(f){return f>=I&&f<=T||f>=A&&f<=y}function m(f,l,v,t){let n="",u=0,o=-1,s=0,c=0;for(let b=0;b<=f.length;++b){if(b<f.length)c=f.charCodeAt(b);else{if(t(c))break;c=D}if(t(c)){if(!(o===b-1||s===1))if(s===2){if(n.length<2||u!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const _=n.lastIndexOf(v);_===-1?(n="",u=0):(n=n.slice(0,_),u=n.length-1-n.lastIndexOf(v)),o=b,s=0;continue}else if(n.length!==0){n="",u=0,o=b,s=0;continue}}l&&(n+=n.length>0?`${v}..`:"..",u=2)}else n.length>0?n+=`${v}${f.slice(o+1,b)}`:n=f.slice(o+1,b),u=b-o-1;o=b,s=0}else c===C&&s!==-1?++s:s=-1}return n}function S(f,l){if(l===null||typeof l!="object")throw new d("pathObject","Object",l);const v=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${t}`:`${v}${f}${t}`:t}e.win32={resolve(...f){let l="",v="",t=!1;for(let n=f.length-1;n>=-1;n--){let u;if(n>=0){if(u=f[n],h(u,"path"),u.length===0)continue}else l.length===0?u=w.cwd():(u=w.env[`=${l}`]||w.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==l.toLowerCase()&&u.charCodeAt(2)===k)&&(u=`${l}\\`));const o=u.length;let s=0,c="",b=!1;const _=u.charCodeAt(0);if(o===1)r(_)&&(s=1,b=!0);else if(r(_))if(b=!0,r(u.charCodeAt(1))){let p=2,E=p;for(;p<o&&!r(u.charCodeAt(p));)p++;if(p<o&&p!==E){const F=u.slice(E,p);for(E=p;p<o&&r(u.charCodeAt(p));)p++;if(p<o&&p!==E){for(E=p;p<o&&!r(u.charCodeAt(p));)p++;(p===o||p!==E)&&(c=`\\\\${F}\\${u.slice(E,p)}`,s=p)}}}else s=1;else g(_)&&u.charCodeAt(1)===i&&(c=u.slice(0,2),s=2,o>2&&r(u.charCodeAt(2))&&(b=!0,s=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(t){if(l.length>0)break}else if(v=`${u.slice(s)}\\${v}`,t=b,b&&l.length>0)break}return v=m(v,!t,"\\",r),t?`${l}\\${v}`:`${l}${v}`||"."},normalize(f){h(f,"path");const l=f.length;if(l===0)return".";let v=0,t,n=!1;const u=f.charCodeAt(0);if(l===1)return a(u)?"\\":f;if(r(u))if(n=!0,r(f.charCodeAt(1))){let s=2,c=s;for(;s<l&&!r(f.charCodeAt(s));)s++;if(s<l&&s!==c){const b=f.slice(c,s);for(c=s;s<l&&r(f.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&!r(f.charCodeAt(s));)s++;if(s===l)return`\\\\${b}\\${f.slice(c)}\\`;s!==c&&(t=`\\\\${b}\\${f.slice(c,s)}`,v=s)}}}else v=1;else g(u)&&f.charCodeAt(1)===i&&(t=f.slice(0,2),v=2,l>2&&r(f.charCodeAt(2))&&(n=!0,v=3));let o=v<l?m(f.slice(v),!n,"\\",r):"";return o.length===0&&!n&&(o="."),o.length>0&&r(f.charCodeAt(l-1))&&(o+="\\"),t===void 0?n?`\\${o}`:o:n?`${t}\\${o}`:`${t}${o}`},isAbsolute(f){h(f,"path");const l=f.length;if(l===0)return!1;const v=f.charCodeAt(0);return r(v)||l>2&&g(v)&&f.charCodeAt(1)===i&&r(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let l,v;for(let u=0;u<f.length;++u){const o=f[u];h(o,"path"),o.length>0&&(l===void 0?l=v=o:l+=`\\${o}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof v=="string"&&r(v.charCodeAt(0))){++n;const u=v.length;u>1&&r(v.charCodeAt(1))&&(++n,u>2&&(r(v.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&r(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(f,l){if(h(f,"from"),h(l,"to"),f===l)return"";const v=e.win32.resolve(f),t=e.win32.resolve(l);if(v===t||(f=v.toLowerCase(),l=t.toLowerCase(),f===l))return"";let n=0;for(;n<f.length&&f.charCodeAt(n)===k;)n++;let u=f.length;for(;u-1>n&&f.charCodeAt(u-1)===k;)u--;const o=u-n;let s=0;for(;s<l.length&&l.charCodeAt(s)===k;)s++;let c=l.length;for(;c-1>s&&l.charCodeAt(c-1)===k;)c--;const b=c-s,_=o<b?o:b;let p=-1,E=0;for(;E<_;E++){const B=f.charCodeAt(n+E);if(B!==l.charCodeAt(s+E))break;B===k&&(p=E)}if(E!==_){if(p===-1)return t}else{if(b>_){if(l.charCodeAt(s+E)===k)return t.slice(s+E+1);if(E===2)return t.slice(s+E)}o>_&&(f.charCodeAt(n+E)===k?p=E:E===2&&(p=3)),p===-1&&(p=0)}let F="";for(E=n+p+1;E<=u;++E)(E===u||f.charCodeAt(E)===k)&&(F+=F.length===0?"..":"\\..");return s+=p,F.length>0?`${F}${t.slice(s,c)}`:(t.charCodeAt(s)===k&&++s,t.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const l=e.win32.resolve(f);if(l.length<=2)return f;if(l.charCodeAt(0)===k){if(l.charCodeAt(1)===k){const v=l.charCodeAt(2);if(v!==P&&v!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(g(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===k)return`\\\\?\\${l}`;return f},dirname(f){h(f,"path");const l=f.length;if(l===0)return".";let v=-1,t=0;const n=f.charCodeAt(0);if(l===1)return r(n)?f:".";if(r(n)){if(v=t=1,r(f.charCodeAt(1))){let s=2,c=s;for(;s<l&&!r(f.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&r(f.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&!r(f.charCodeAt(s));)s++;if(s===l)return f;s!==c&&(v=t=s+1)}}}}else g(n)&&f.charCodeAt(1)===i&&(v=l>2&&r(f.charCodeAt(2))?3:2,t=v);let u=-1,o=!0;for(let s=l-1;s>=t;--s)if(r(f.charCodeAt(s))){if(!o){u=s;break}}else o=!1;if(u===-1){if(v===-1)return".";u=v}return f.slice(0,u)},basename(f,l){l!==void 0&&h(l,"ext"),h(f,"path");let v=0,t=-1,n=!0,u;if(f.length>=2&&g(f.charCodeAt(0))&&f.charCodeAt(1)===i&&(v=2),l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let o=l.length-1,s=-1;for(u=f.length-1;u>=v;--u){const c=f.charCodeAt(u);if(r(c)){if(!n){v=u+1;break}}else s===-1&&(n=!1,s=u+1),o>=0&&(c===l.charCodeAt(o)?--o==-1&&(t=u):(o=-1,t=s))}return v===t?t=s:t===-1&&(t=f.length),f.slice(v,t)}for(u=f.length-1;u>=v;--u)if(r(f.charCodeAt(u))){if(!n){v=u+1;break}}else t===-1&&(n=!1,t=u+1);return t===-1?"":f.slice(v,t)},extname(f){h(f,"path");let l=0,v=-1,t=0,n=-1,u=!0,o=0;f.length>=2&&f.charCodeAt(1)===i&&g(f.charCodeAt(0))&&(l=t=2);for(let s=f.length-1;s>=l;--s){const c=f.charCodeAt(s);if(r(c)){if(!u){t=s+1;break}continue}n===-1&&(u=!1,n=s+1),c===C?v===-1?v=s:o!==1&&(o=1):v!==-1&&(o=-1)}return v===-1||n===-1||o===0||o===1&&v===n-1&&v===t+1?"":f.slice(v,n)},format:S.bind(null,"\\"),parse(f){h(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const v=f.length;let t=0,n=f.charCodeAt(0);if(v===1)return r(n)?(l.root=l.dir=f,l):(l.base=l.name=f,l);if(r(n)){if(t=1,r(f.charCodeAt(1))){let p=2,E=p;for(;p<v&&!r(f.charCodeAt(p));)p++;if(p<v&&p!==E){for(E=p;p<v&&r(f.charCodeAt(p));)p++;if(p<v&&p!==E){for(E=p;p<v&&!r(f.charCodeAt(p));)p++;p===v?t=p:p!==E&&(t=p+1)}}}}else if(g(n)&&f.charCodeAt(1)===i){if(v<=2)return l.root=l.dir=f,l;if(t=2,r(f.charCodeAt(2))){if(v===3)return l.root=l.dir=f,l;t=3}}t>0&&(l.root=f.slice(0,t));let u=-1,o=t,s=-1,c=!0,b=f.length-1,_=0;for(;b>=t;--b){if(n=f.charCodeAt(b),r(n)){if(!c){o=b+1;break}continue}s===-1&&(c=!1,s=b+1),n===C?u===-1?u=b:_!==1&&(_=1):u!==-1&&(_=-1)}return s!==-1&&(u===-1||_===0||_===1&&u===s-1&&u===o+1?l.base=l.name=f.slice(o,s):(l.name=f.slice(o,u),l.base=f.slice(o,s),l.ext=f.slice(u,s))),o>0&&o!==t?l.dir=f.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let l="",v=!1;for(let t=f.length-1;t>=-1&&!v;t--){const n=t>=0?f[t]:w.cwd();h(n,"path"),n.length!==0&&(l=`${n}/${l}`,v=n.charCodeAt(0)===D)}return l=m(l,!v,"/",a),v?`/${l}`:l.length>0?l:"."},normalize(f){if(h(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===D,v=f.charCodeAt(f.length-1)===D;return f=m(f,!l,"/",a),f.length===0?l?"/":v?"./":".":(v&&(f+="/"),l?`/${f}`:f)},isAbsolute(f){return h(f,"path"),f.length>0&&f.charCodeAt(0)===D},join(...f){if(f.length===0)return".";let l;for(let v=0;v<f.length;++v){const t=f[v];h(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(f,l){if(h(f,"from"),h(l,"to"),f===l||(f=e.posix.resolve(f),l=e.posix.resolve(l),f===l))return"";const v=1,t=f.length,n=t-v,u=1,o=l.length-u,s=n<o?n:o;let c=-1,b=0;for(;b<s;b++){const p=f.charCodeAt(v+b);if(p!==l.charCodeAt(u+b))break;p===D&&(c=b)}if(b===s)if(o>s){if(l.charCodeAt(u+b)===D)return l.slice(u+b+1);if(b===0)return l.slice(u+b)}else n>s&&(f.charCodeAt(v+b)===D?c=b:b===0&&(c=0));let _="";for(b=v+c+1;b<=t;++b)(b===t||f.charCodeAt(b)===D)&&(_+=_.length===0?"..":"/..");return`${_}${l.slice(u+c)}`},toNamespacedPath(f){return f},dirname(f){if(h(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===D;let v=-1,t=!0;for(let n=f.length-1;n>=1;--n)if(f.charCodeAt(n)===D){if(!t){v=n;break}}else t=!1;return v===-1?l?"/":".":l&&v===1?"//":f.slice(0,v)},basename(f,l){l!==void 0&&h(l,"ext"),h(f,"path");let v=0,t=-1,n=!0,u;if(l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let o=l.length-1,s=-1;for(u=f.length-1;u>=0;--u){const c=f.charCodeAt(u);if(c===D){if(!n){v=u+1;break}}else s===-1&&(n=!1,s=u+1),o>=0&&(c===l.charCodeAt(o)?--o==-1&&(t=u):(o=-1,t=s))}return v===t?t=s:t===-1&&(t=f.length),f.slice(v,t)}for(u=f.length-1;u>=0;--u)if(f.charCodeAt(u)===D){if(!n){v=u+1;break}}else t===-1&&(n=!1,t=u+1);return t===-1?"":f.slice(v,t)},extname(f){h(f,"path");let l=-1,v=0,t=-1,n=!0,u=0;for(let o=f.length-1;o>=0;--o){const s=f.charCodeAt(o);if(s===D){if(!n){v=o+1;break}continue}t===-1&&(n=!1,t=o+1),s===C?l===-1?l=o:u!==1&&(u=1):l!==-1&&(u=-1)}return l===-1||t===-1||u===0||u===1&&l===t-1&&l===v+1?"":f.slice(l,t)},format:S.bind(null,"/"),parse(f){h(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const v=f.charCodeAt(0)===D;let t;v?(l.root="/",t=1):t=0;let n=-1,u=0,o=-1,s=!0,c=f.length-1,b=0;for(;c>=t;--c){const _=f.charCodeAt(c);if(_===D){if(!s){u=c+1;break}continue}o===-1&&(s=!1,o=c+1),_===C?n===-1?n=c:b!==1&&(b=1):n!==-1&&(b=-1)}if(o!==-1){const _=u===0&&v?1:u;n===-1||b===0||b===1&&n===o-1&&n===u+1?l.base=l.name=f.slice(_,o):(l.name=f.slice(_,n),l.base=f.slice(_,o),l.ext=f.slice(n,o))}return u>0?l.dir=f.slice(0,u-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[55],_e([0,1,21]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=w.globals.performance&&typeof w.globals.performance.now=="function";class A{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=A}),define(we[3],_e([0,1,12,53,6,45,55]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(m){m.None=()=>A.Disposable.None;function S(V){return(z,ee=null,$)=>{let R=!1,L;return L=V(M=>{if(!R)return L?L.dispose():R=!0,z.call(ee,M)},null,$),R&&L.dispose(),L}}m.once=S;function f(V,z){return o((ee,$=null,R)=>V(L=>ee.call($,z(L)),null,R))}m.map=f;function l(V,z){return o((ee,$=null,R)=>V(L=>{z(L),ee.call($,L)},null,R))}m.forEach=l;function v(V,z){return o((ee,$=null,R)=>V(L=>z(L)&&ee.call($,L),null,R))}m.filter=v;function t(V){return V}m.signal=t;function n(...V){return(z,ee=null,$)=>(0,A.combinedDisposable)(...V.map(R=>R(L=>z.call(ee,L),null,$)))}m.any=n;function u(V,z,ee){let $=ee;return f(V,R=>($=z($,R),$))}m.reduce=u;function o(V){let z;const ee=new d({onFirstListenerAdd(){z=V(ee.fire,ee)},onLastListenerRemove(){z.dispose()}});return ee.event}m.snapshot=o;function s(V,z,ee=100,$=!1,R){let L,M,U,G=0;const X=new d({leakWarningThreshold:R,onFirstListenerAdd(){L=V(se=>{G++,M=z(M,se),$&&!U&&(X.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=M;M=void 0,U=void 0,(!$||G>1)&&X.fire(pe),G=0},ee)})},onLastListenerRemove(){L.dispose()}});return X.event}m.debounce=s;function c(V){const z=new Date().getTime();return f(S(V),ee=>new Date().getTime()-z)}m.stopwatch=c;function b(V){let z=!0,ee;return v(V,$=>{const R=z||$!==ee;return z=!1,ee=$,R})}m.latch=b;function _(V,z=!1,ee=[]){let $=ee.slice(),R=V(U=>{$?$.push(U):M.fire(U)});const L=()=>{$&&$.forEach(U=>M.fire(U)),$=null},M=new d({onFirstListenerAdd(){R||(R=V(U=>M.fire(U)))},onFirstListenerDidAdd(){$&&(z?setTimeout(L):L())},onLastListenerRemove(){R&&R.dispose(),R=null}});return M.event}m.buffer=_;class p{constructor(z){this.event=z}map(z){return new p(f(this.event,z))}forEach(z){return new p(l(this.event,z))}filter(z){return new p(v(this.event,z))}reduce(z,ee){return new p(u(this.event,z,ee))}latch(){return new p(b(this.event))}debounce(z,ee=100,$=!1,R){return new p(s(this.event,z,ee,$,R))}on(z,ee,$){return this.event(z,ee,$)}once(z,ee,$){return S(this.event)(z,ee,$)}}function E(V){return new p(V)}m.chain=E;function F(V,z,ee=$=>$){const $=(...U)=>M.fire(ee(...U)),R=()=>V.on(z,$),L=()=>V.removeListener(z,$),M=new d({onFirstListenerAdd:R,onLastListenerRemove:L});return M.event}m.fromNodeEventEmitter=F;function B(V,z,ee=$=>$){const $=(...U)=>M.fire(ee(...U)),R=()=>V.addEventListener(z,$),L=()=>V.removeEventListener(z,$),M=new d({onFirstListenerAdd:R,onLastListenerRemove:L});return M.event}m.fromDOMEventEmitter=B;function Y(V){const z=new d;let ee=!1;return V.then(void 0,()=>null).then(()=>{ee?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),ee=!0,z.event}m.fromPromise=Y;function fe(V){return new Promise(z=>S(V)(z))}m.toPromise=fe})(C=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function i(m){const S=k;return k=m,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(S,f=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let f=k;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||S<f)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),v=this._stacks.get(l)||0;if(this._stacks.set(l,v+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,n=0;for(const[u,o]of this._stacks)(!t||n<o)&&(t=u,n=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class d{constructor(S){var f;this._disposed=!1,this._options=S,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,f,l)=>{var v;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(f?[S,f]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,f);const u=(v=this._leakageMon)===null||v===void 0?void 0:v.check(this._listeners.size);let o;return o={dispose:()=>{u&&u(),o.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof A.DisposableStore?l.add(o):Array.isArray(l)&&l.push(o),o}),this._event}fire(S){var f,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,S]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(n){(0,w.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var S,f,l;(S=this._listeners)===null||S===void 0||S.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class h extends d{constructor(S){super(S);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const f={event:S,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const l=()=>{this.hasListeners&&this.unhook(f);const v=this.events.indexOf(f);this.events.splice(v,1)};return(0,A.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(f=>this.emitter.fire(f))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(S){return(f,l,v)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>f.call(l,t)):f.call(l,t)},void 0,v)}bufferEvents(S){const f=[];this.buffers.push(f);const l=S();return this.buffers.pop(),f.forEach(v=>v()),l}}e.EventBufferer=a;class g{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=A.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(we[20],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(C,D){const k=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(k)}}});var A;(function(C){function D(k){return k===C.None||k===C.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(we[36],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new I;e.iconRegistry=A;function T(i,P){return new C(i,P)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,d,h){this.id=P,this.definition=d,this.description=h,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(i,P){const d=["codicon","codicon-"+i];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=D;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(a){if(a instanceof C)return["codicon","codicon-"+a.id];const g=P.exec(a.id);if(!g)return d(C.error);let[,m,S]=g;const f=["codicon","codicon-"+m];return S&&f.push("codicon-modifier-"+S.substr(1)),f}i.asClassNameArray=d;function h(a){return d(a).join(" ")}i.asClassName=h;function r(a){return"."+d(a).join(".")}i.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(we[109],_e([0,1,12,6]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=A;function T(f){const l=f;return l?A(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(f,l){return new C(f,l)}e.newWriteableStream=y;class C{constructor(l,v){this.reducer=l,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(v=>v(l))}emitError(l){this.listeners.error.length===0?(0,w.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(v=>v(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,v){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(l,v){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(v);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(f,l){const v=[];let t;for(;(t=f.read())!==null;)v.push(t);return l(v)}e.consumeReadable=D;function k(f,l,v){const t=[];let n;for(;(n=f.read())!==null&&t.length<v;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const u=n;return n=void 0,u}return f.read()}}}e.peekReadable=k;function i(f,l){return new Promise((v,t)=>{const n=[];P(f,{onData:u=>{l&&n.push(u)},onError:u=>{l?t(u):v(void 0)},onEnd:()=>{v(l?l(n):void 0)}})})}e.consumeStream=i;function P(f,l){f.on("error",v=>l.onError(v)),f.on("end",()=>l.onEnd()),f.on("data",v=>l.onData(v))}e.listenStream=P;function d(f,l){return new Promise((v,t)=>{const n=new I.DisposableStore,u=[],o=b=>{if(u.push(b),u.length>l)return n.dispose(),f.pause(),v({stream:f,buffer:u,ended:!1})},s=b=>t(b),c=()=>v({stream:f,buffer:u,ended:!0});n.add((0,I.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),n.add((0,I.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),n.add((0,I.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=d;function h(f,l){const v=y(l);return v.end(f),v}e.toStream=h;function r(){const f=y(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=r;function a(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=a;function g(f,l,v){const t=y(v);return P(f,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=g;function m(f,l,v){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?v([f,n]):f)}}}e.prefixedReadable=m;function S(f,l,v){let t=!1;const n=y(v);return P(l,{onData:u=>t?n.write(u):(t=!0,n.write(v([f,u]))),onError:u=>n.error(u),onEnd:()=>{t||(t=!0,n.write(f)),n.end()}}),n}e.prefixedStream=S}),define(we[8],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=w;const I=/{(\d+)}/g;function A(W,...ie){return ie.length===0?W:W.replace(I,function(ce,j){const Z=parseInt(j,10);return isNaN(Z)||Z<0||Z>=ie.length?ce:ie[Z]})}e.format=A;function T(W){return W.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=T;function y(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(W,ie){let ce=0;const j=ie.charCodeAt(0);for(let Z=W.length-1;Z>=0;Z--)W.charCodeAt(Z)===j&&ce++;return ce}e.count=C;function D(W,ie,ce="\u2026"){return W.length<=ie?W:`${W.substr(0,ie)}${ce}`}e.truncate=D;function k(W,ie=" "){const ce=i(W,ie);return P(ce,ie)}e.trim=k;function i(W,ie){if(!W||!ie)return W;const ce=ie.length;if(ce===0||W.length===0)return W;let j=0;for(;W.indexOf(ie,j)===j;)j=j+ce;return W.substring(j)}e.ltrim=i;function P(W,ie){if(!W||!ie)return W;const ce=ie.length,j=W.length;if(ce===0||j===0)return W;let Z=j,ae=-1;for(;ae=W.lastIndexOf(ie,Z-1),!(ae===-1||ae+ce!==Z);){if(ae===0)return"";Z=ae}return W.substring(0,Z)}e.rtrim=P;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function r(W,ie,ce={}){if(!W)throw new Error("Cannot create regex from empty string");ie||(W=y(W)),ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let j="";return ce.global&&(j+="g"),ce.matchCase||(j+="i"),ce.multiline&&(j+="m"),ce.unicode&&(j+="u"),new RegExp(W,j)}e.createRegExp=r;function a(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function g(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function m(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=m;function S(W){return W.split(/\r\n|\r|\n/)}e.splitLines=S;function f(W){for(let ie=0,ce=W.length;ie<ce;ie++){const j=W.charCodeAt(ie);if(j!==32&&j!==9)return ie}return-1}e.firstNonWhitespaceIndex=f;function l(W,ie=0,ce=W.length){for(let j=ie;j<ce;j++){const Z=W.charCodeAt(j);if(Z!==32&&Z!==9)return W.substring(ie,j)}return W.substring(ie,ce)}e.getLeadingWhitespace=l;function v(W,ie=W.length-1){for(let ce=ie;ce>=0;ce--){const j=W.charCodeAt(ce);if(j!==32&&j!==9)return ce}return-1}e.lastNonWhitespaceIndex=v;function t(W,ie){return W<ie?-1:W>ie?1:0}e.compare=t;function n(W,ie,ce=0,j=W.length,Z=0,ae=ie.length){for(;ce<j&&Z<ae;ce++,Z++){let ze=W.charCodeAt(ce),Be=ie.charCodeAt(Z);if(ze<Be)return-1;if(ze>Be)return 1}const he=j-ce,ye=ae-Z;return he<ye?-1:he>ye?1:0}e.compareSubstring=n;function u(W,ie){return o(W,ie,0,W.length,0,ie.length)}e.compareIgnoreCase=u;function o(W,ie,ce=0,j=W.length,Z=0,ae=ie.length){for(;ce<j&&Z<ae;ce++,Z++){let ze=W.charCodeAt(ce),Be=ie.charCodeAt(Z);if(ze!==Be){const Ne=ze-Be;if(!(Ne===32&&c(Be))&&!(Ne===-32&&c(ze)))return s(ze)&&s(Be)?Ne:n(W.toLowerCase(),ie.toLowerCase(),ce,j,Z,ae)}}const he=j-ce,ye=ae-Z;return he<ye?-1:he>ye?1:0}e.compareSubstringIgnoreCase=o;function s(W){return W>=97&&W<=122}e.isLowerAsciiLetter=s;function c(W){return W>=65&&W<=90}e.isUpperAsciiLetter=c;function b(W){return s(W)||c(W)}function _(W,ie){return W.length===ie.length&&p(W,ie)}e.equalsIgnoreCase=_;function p(W,ie,ce=W.length){for(let j=0;j<ce;j++){const Z=W.charCodeAt(j),ae=ie.charCodeAt(j);if(Z!==ae){if(b(Z)&&b(ae)){const he=Math.abs(Z-ae);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(Z).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function E(W,ie){const ce=ie.length;return ie.length>W.length?!1:p(W,ie,ce)}e.startsWithIgnoreCase=E;function F(W,ie){let ce,j=Math.min(W.length,ie.length);for(ce=0;ce<j;ce++)if(W.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return j}e.commonPrefixLength=F;function B(W,ie){let ce,j=Math.min(W.length,ie.length);const Z=W.length-1,ae=ie.length-1;for(ce=0;ce<j;ce++)if(W.charCodeAt(Z-ce)!==ie.charCodeAt(ae-ce))return ce;return j}e.commonSuffixLength=B;function Y(W){return 55296<=W&&W<=56319}e.isHighSurrogate=Y;function fe(W){return 56320<=W&&W<=57343}e.isLowSurrogate=fe;function V(W,ie){return(W-55296<<10)+(ie-56320)+65536}e.computeCodePoint=V;function z(W,ie,ce){const j=W.charCodeAt(ce);if(Y(j)&&ce+1<ie){const Z=W.charCodeAt(ce+1);if(fe(Z))return V(j,Z)}return j}e.getNextCodePoint=z;function ee(W,ie){const ce=W.charCodeAt(ie-1);if(fe(ce)&&ie>1){const j=W.charCodeAt(ie-2);if(Y(j))return V(j,ce)}return ce}function $(W,ie){const ce=Ue.getInstance(),j=ie,Z=W.length,ae=z(W,Z,ie);ie+=ae>=65536?2:1;let he=ce.getGraphemeBreakType(ae);for(;ie<Z;){const ye=z(W,Z,ie),ze=ce.getGraphemeBreakType(ye);if(Le(he,ze))break;ie+=ye>=65536?2:1,he=ze}return ie-j}e.nextCharLength=$;function R(W,ie){const ce=Ue.getInstance(),j=ie,Z=ee(W,ie);ie-=Z>=65536?2:1;let ae=ce.getGraphemeBreakType(Z);for(;ie>0;){const he=ee(W,ie),ye=ce.getGraphemeBreakType(he);if(Le(ye,ae))break;ie-=he>=65536?2:1,ae=ye}return j-ie}e.prevCharLength=R;function L(W,ie){const ce=Ue.getInstance(),j=W.length,Z=ie,ae=z(W,j,ie),he=ce.getGraphemeBreakType(ae);ie+=ae>=65536?2:1;let ye=he;for(;ie<j;){const Be=z(W,j,ie),Ne=ce.getGraphemeBreakType(Be);if(Le(ye,Ne))break;ie+=Be>=65536?2:1,ye=Ne}const ze=ie;for(ie=Z,ye=he;ie>0;){const Be=ee(W,ie),Ne=ce.getGraphemeBreakType(Be);if(Le(Ne,ye))break;ie-=Be>=65536?2:1,ye=Ne}return[ie,ze]}function M(W,ie){return ie>0&&fe(W.charCodeAt(ie))?L(W,ie-1):L(W,ie)}e.getCharContainingOffset=M;function U(W){const ie=W.length;let ce=0,j=0;for(;j<ie;){const he=z(W,ie,j);j+=he>=65536?2:1,he<128?ce+=1:he<2048?ce+=2:he<65536?ce+=3:ce+=4}const Z=new Uint8Array(ce);j=0;let ae=0;for(;j<ie;){const he=z(W,ie,j);j+=he>=65536?2:1,he<128?Z[ae++]=he:he<2048?(Z[ae++]=192|(he&1984)>>>6,Z[ae++]=128|(he&63)>>>0):he<65536?(Z[ae++]=224|(he&61440)>>>12,Z[ae++]=128|(he&4032)>>>6,Z[ae++]=128|(he&63)>>>0):(Z[ae++]=240|(he&1835008)>>>18,Z[ae++]=128|(he&258048)>>>12,Z[ae++]=128|(he&4032)>>>6,Z[ae++]=128|(he&63)>>>0)}return Z}e.encodeUTF8=U;function G(W){const ie=W.byteLength,ce=[];let j=0;for(;j<ie;){const Z=W[j];let ae;if(Z>=240&&j+3<ie?ae=(W[j++]&7)<<18>>>0|(W[j++]&63)<<12>>>0|(W[j++]&63)<<6>>>0|(W[j++]&63)<<0>>>0:Z>=224&&j+2<ie?ae=(W[j++]&15)<<12>>>0|(W[j++]&63)<<6>>>0|(W[j++]&63)<<0>>>0:Z>=192&&j+1<ie?ae=(W[j++]&31)<<6>>>0|(W[j++]&63)<<0>>>0:ae=W[j++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)ce.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const he=ae-65536,ye=55296+((he&1047552)>>>10),ze=56320+((he&1023)>>>0);ce.push(String.fromCharCode(ye)),ce.push(String.fromCharCode(ze))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=G;const X=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(W){return X.test(W)}e.containsRTL=se;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(W){return pe.test(W)}e.containsEmoji=Te;const xe=/^[\t\n\r\x20-\x7E]*$/;function Ae(W){return xe.test(W)}e.isBasicASCII=Ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=We;function x(W){for(let ie=0,ce=W.length;ie<ce;ie++)if(q(W.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=x;function q(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=q;function ne(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ne;function le(W,ie){if(W.length<ie)return W;const ce=/\b/g;let j=0;for(;ce.test(W)&&!(W.length-ce.lastIndex<ie);)j=ce.lastIndex,ce.lastIndex+=1;return W.substring(j).replace(/^\s/,"")}e.lcut=le;const me=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function ge(W){return W&&(W=W.replace(me,""),W=W.replace(Se,""),W=W.replace(Oe,"")),W}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Pe;function $e(W,ie){if(!W||!ie||W.length<ie.length)return!1;const ce=ie.length,j=W.toLowerCase();let Z=0,ae=-1;for(;Z<ce;){const he=j.indexOf(ie[Z],ae+1);if(he<0)return!1;ae=he,Z++}return!0}e.fuzzyContains=$e;function Ee(W,ie=!1){return W?(ie&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ee;function je(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=je;function H(W,ie=1){if(ie===0)return"";let ce=-1;do ce=W.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?W:(W[ce-1]==="\r"&&ce--,W.substr(0,ce))}e.getNLines=H;function te(W){const ie=90-65+1;return W=W%(2*ie),W<ie?String.fromCharCode(97+W):String.fromCharCode(65+W-ie)}e.singleLetterHash=te;function ve(W){return Ue.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ve;function Le(W,ie){return W===0?ie!==5&&ie!==7:W===2&&ie===3?!1:W===4||W===2||W===3||ie===4||ie===2||ie===3?!0:!(W===8&&(ie===8||ie===9||ie===11||ie===12)||(W===11||W===9)&&(ie===9||ie===10)||(W===12||W===10)&&ie===10||ie===5||ie===13||ie===7||W===1||W===13&&ie===14||W===6&&ie===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Xe()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,j=ce.length/3;let Z=1;for(;Z<=j;)if(ie<ce[3*Z])Z=2*Z;else if(ie>ce[3*Z+1])Z=2*Z+1;else return ce[3*Z+2];return 0}}Ue._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[23],_e([0,1,8,109]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,D;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return A?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return A&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&A?new k(Buffer.from(b)):T?(C||(C=new TextEncoder),new k(C.encode(b))):new k(w.encodeUTF8(b))}static concat(b,_){if(typeof _=="undefined"){_=0;for(let F=0,B=b.length;F<B;F++)_+=b[F].byteLength}const p=k.alloc(_);let E=0;for(let F=0,B=b.length;F<B;F++){const Y=b[F];p.set(Y,E),E+=Y.byteLength}return p}toString(){return A?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(b,_){return new k(this.buffer.subarray(b,_))}set(b,_){b instanceof k?this.buffer.set(b.buffer,_):this.buffer.set(b,_)}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,_){h(this.buffer,b,_)}readUInt32LE(b){return r(this.buffer,b)}writeUInt32LE(b,_){a(this.buffer,b,_)}readUInt8(b){return g(this.buffer,b)}writeUInt8(b,_){m(this.buffer,b,_)}}e.VSBuffer=k;function i(c,b){return c[b+0]<<0>>>0|c[b+1]<<8>>>0}e.readUInt16LE=i;function P(c,b,_){c[_+0]=b&255,b=b>>>8,c[_+1]=b&255}e.writeUInt16LE=P;function d(c,b){return c[b]*2**24+c[b+1]*2**16+c[b+2]*2**8+c[b+3]}e.readUInt32BE=d;function h(c,b,_){c[_+3]=b,b=b>>>8,c[_+2]=b,b=b>>>8,c[_+1]=b,b=b>>>8,c[_]=b}e.writeUInt32BE=h;function r(c,b){return c[b+0]<<0>>>0|c[b+1]<<8>>>0|c[b+2]<<16>>>0|c[b+3]<<24>>>0}e.readUInt32LE=r;function a(c,b,_){c[_+0]=b&255,b=b>>>8,c[_+1]=b&255,b=b>>>8,c[_+2]=b&255,b=b>>>8,c[_+3]=b&255}e.writeUInt32LE=a;function g(c,b){return c[b]}e.readUInt8=g;function m(c,b,_){c[_]=b}e.writeUInt8=m;function S(c){return I.consumeReadable(c,b=>k.concat(b))}e.readableToBuffer=S;function f(c){return I.toReadable(c)}e.bufferToReadable=f;function l(c){return I.consumeStream(c,b=>k.concat(b))}e.streamToBuffer=l;async function v(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=v;function t(c){return I.toStream(c,b=>k.concat(b))}e.bufferToStream=t;function n(c){return I.transform(c,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=n;function u(c){return I.newWriteableStream(b=>k.concat(b),c)}e.newWriteableBufferStream=u;function o(c,b){return I.prefixedReadable(c,b,_=>k.concat(_))}e.prefixedBufferReadable=o;function s(c,b){return I.prefixedStream(c,b,_=>k.concat(_))}e.prefixedBufferStream=s}),define(we[56],_e([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(m){return A(m,0)}e.hash=I;function A(m,S){switch(typeof m){case"object":return m===null?T(349,S):Array.isArray(m)?D(m,S):k(m,S);case"string":return C(m,S);case"boolean":return y(m,S);case"number":return T(m,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=A;function T(m,S){return(S<<5)-S+m|0}function y(m,S){return T(m?433:863,S)}function C(m,S){S=T(149417,S);for(let f=0,l=m.length;f<l;f++)S=T(m.charCodeAt(f),S);return S}e.stringHash=C;function D(m,S){return S=T(104579,S),m.reduce((f,l)=>A(l,f),S)}function k(m,S){return S=T(181387,S),Object.keys(m).sort().reduce((f,l)=>(f=C(l,f),A(m[l],f)),S)}class i{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=A(S,this._value),this._value}}e.Hasher=i;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(m,S,f=32){const l=f-S,v=~((1<<l)-1);return(m<<S|(v&m)>>>l)>>>0}function h(m,S=0,f=m.byteLength,l=0){for(let v=0;v<f;v++)m[S+v]=l}function r(m,S,f="0"){for(;m.length<S;)m=f+m;return m}function a(m,S=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),S/4)}e.toHexString=a;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f!==0){const l=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,n,u;for(t!==0?(n=t,u=-1,t=0):(n=S.charCodeAt(0),u=0);;){let o=n;if(w.isHighSurrogate(n))if(u+1<f){const s=S.charCodeAt(u+1);w.isLowSurrogate(s)?(u++,o=w.computeCodePoint(n,s)):o=65533}else{t=n;break}else w.isLowSurrogate(n)&&(o=65533);if(v=this._push(l,v,o),u++,u<f)n=S.charCodeAt(u);else break}this._buffLen=v,this._leftoverHighSurrogate=t}}_push(S,f,l){return l<128?S[f++]=l:l<2048?(S[f++]=192|(l&1984)>>>6,S[f++]=128|(l&63)>>>0):l<65536?(S[f++]=224|(l&61440)>>>12,S[f++]=128|(l&4032)>>>6,S[f++]=128|(l&63)>>>0):(S[f++]=240|(l&1835008)>>>18,S[f++]=128|(l&258048)>>>12,S[f++]=128|(l&4032)>>>6,S[f++]=128|(l&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=g._bigBlock32,f=this._buffDV;for(let b=0;b<64;b+=4)S.setUint32(b,f.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)S.setUint32(b,d(S.getUint32(b-12,!1)^S.getUint32(b-32,!1)^S.getUint32(b-56,!1)^S.getUint32(b-64,!1),1),!1);let l=this._h0,v=this._h1,t=this._h2,n=this._h3,u=this._h4,o,s,c;for(let b=0;b<80;b++)b<20?(o=v&t|~v&n,s=1518500249):b<40?(o=v^t^n,s=1859775393):b<60?(o=v&t|v&n|t&n,s=2400959708):(o=v^t^n,s=3395469782),c=d(l,5)+o+u+s+S.getUint32(b*4,!1)&4294967295,u=n,n=t,t=d(v,30),v=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+u&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[47],_e([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(I||(I={})),function(A){const T="error",y="warning",C="warn",D="info",k="ignore";function i(d){return d?w.equalsIgnoreCase(T,d)?A.Error:w.equalsIgnoreCase(y,d)||w.equalsIgnoreCase(C,d)?A.Warning:w.equalsIgnoreCase(D,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=i;function P(d){switch(d){case A.Error:return T;case A.Warning:return y;case A.Info:return D;default:return k}}A.toString=P}(I||(I={})),e.default=I}),define(we[10],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(b){return Array.isArray(b)}e.isArray=w;function I(b){return typeof b=="string"}e.isString=I;function A(b){return Array.isArray(b)&&b.every(_=>I(_))}e.isStringArray=A;function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=T;function y(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=y;function C(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=C;function D(b){return b===!0||b===!1}e.isBoolean=D;function k(b){return typeof b=="undefined"}e.isUndefined=k;function i(b){return!P(b)}e.isDefined=i;function P(b){return k(b)||b===null}e.isUndefinedOrNull=P;function d(b,_){if(!b)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=d;function h(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=h;function r(...b){const _=[];for(let p=0;p<b.length;p++){const E=b[p];if(P(E))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);_.push(E)}return _}e.assertAllDefined=r;const a=Object.prototype.hasOwnProperty;function g(b){if(!T(b))return!1;for(let _ in b)if(a.call(b,_))return!1;return!0}e.isEmptyObject=g;function m(b){return typeof b=="function"}e.isFunction=m;function S(...b){return b.length>0&&b.every(m)}e.areFunctions=S;function f(b,_){const p=Math.min(b.length,_.length);for(let E=0;E<p;E++)l(b[E],_[E])}e.validateConstraints=f;function l(b,_){if(I(_)){if(typeof b!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(m(_)){try{if(b instanceof _)return}catch(p){}if(!P(b)&&b.constructor===_||_.length===1&&_.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function v(b){let _=[],p=Object.getPrototypeOf(b);for(;Object.prototype!==p;)_=_.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return _}e.getAllPropertyNames=v;function t(b){const _=[];for(const p of v(b))typeof b[p]=="function"&&_.push(p);return _}e.getAllMethodNames=t;function n(b,_){const p=F=>function(){const B=Array.prototype.slice.call(arguments,0);return _(F,B)};let E={};for(const F of b)E[F]=p(F);return E}e.createProxyObject=n;function u(b){return b===null?void 0:b}e.withNullAsUndefined=u;function o(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=o;function s(b){return class{constructor(){return new Proxy({},{get(_,p){if(_[p])return _[p];throw new Error(`Not Implemented: ${b}->${String(p)}`)}})}}}e.NotImplementedProxy=s;function c(b){throw new Error("Unreachable")}e.assertNever=c}),define(we[37],_e([0,1,21,8,13,10]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function C(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=C;function D(n,u=A.posix.sep){if(!n)return"";const o=n.length,s=n.charCodeAt(0);if(y(s)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let b=3;const _=b;for(;b<o&&!y(n.charCodeAt(b));b++);if(_!==b&&!y(n.charCodeAt(b+1))){for(b+=1;b<o;b++)if(y(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,u)}}return u}else if(g(s)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+u:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<o;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function k(n){if(!w.isWindows||!n||n.length<5)return!1;let u=n.charCodeAt(0);if(u!==92||(u=n.charCodeAt(1),u!==92))return!1;let o=2;const s=o;for(;o<n.length&&(u=n.charCodeAt(o),u!==92);o++);return!(s===o||(u=n.charCodeAt(o+1),isNaN(u)||u===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,u=w.isWindows){const o=u?i:P;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||u&&d.test(n)||n==="."||n===".."||u&&n[n.length-1]==="."||u&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function r(n,u,o){const s=n===u;return!o||s?s:!n||!u?!1:(0,I.equalsIgnoreCase)(n,u)}e.isEqual=r;function a(n,u,o,s=A.sep){if(n===u)return!0;if(!n||!u||u.length>n.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(n,u))return!1;if(u.length===n.length)return!0;let b=u.length;return u.charAt(u.length-1)===s&&b--,n.charAt(b)===s}return u.charAt(u.length-1)!==s&&(u+=s),n.indexOf(u)===0}e.isEqualOrParent=a;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function m(n,u){return w.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(u,n)),n=(0,A.normalize)(n),w.isWindows?(n=(0,I.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,I.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=m;function S(n){const u=(0,A.normalize)(n);return w.isWindows?n.length>3?!1:f(u)&&(n.length===2||u.charCodeAt(2)===92):u===A.posix.sep}e.isRootOrDriveLetter=S;function f(n){return w.isWindows?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function l(n){return f(n)?n[0]:void 0}e.getDriveLetter=l;function v(n,u,o){return u.length>n.length?-1:n===u?0:(o&&(n=n.toLowerCase(),u=u.toLowerCase()),n.indexOf(u))}e.indexOfPath=v;function t(n){const u=n.split(":");let o,s,c;if(u.forEach(b=>{const _=Number(b);(0,T.isNumber)(_)?s===void 0?s=_:c===void 0&&(c=_):o=o?[o,b].join(":"):b}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[24],_e([0,1,10]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const a=Array.isArray(r)?[]:{};return Object.keys(r).forEach(g=>{r[g]&&typeof r[g]=="object"?a[g]=I(r[g]):a[g]=r[g]}),a}e.deepClone=I;function A(r){if(!r||typeof r!="object")return r;const a=[r];for(;a.length>0;){const g=a.shift();Object.freeze(g);for(const m in g)if(T.call(g,m)){const S=g[m];typeof S=="object"&&!Object.isFrozen(S)&&a.push(S)}}return r}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(r,a){return C(r,a,new Set)}e.cloneAndChange=y;function C(r,a,g){if((0,w.isUndefinedOrNull)(r))return r;const m=a(r);if(typeof m!="undefined")return m;if((0,w.isArray)(r)){const S=[];for(const f of r)S.push(C(f,a,g));return S}if((0,w.isObject)(r)){if(g.has(r))throw new Error("Cannot clone recursive data-structure");g.add(r);const S={};for(let f in r)T.call(r,f)&&(S[f]=C(r[f],a,g));return g.delete(r),S}return r}function D(r,a,g=!0){return(0,w.isObject)(r)?((0,w.isObject)(a)&&Object.keys(a).forEach(m=>{m in r?g&&((0,w.isObject)(r[m])&&(0,w.isObject)(a[m])?D(r[m],a[m],g):r[m]=a[m]):r[m]=a[m]}),r):a}e.mixin=D;function k(r,a){if(r===a)return!0;if(r==null||a===null||a===void 0||typeof r!=typeof a||typeof r!="object"||Array.isArray(r)!==Array.isArray(a))return!1;let g,m;if(Array.isArray(r)){if(r.length!==a.length)return!1;for(g=0;g<r.length;g++)if(!k(r[g],a[g]))return!1}else{const S=[];for(m in r)S.push(m);S.sort();const f=[];for(m in a)f.push(m);if(f.sort(),!k(S,f))return!1;for(g=0;g<S.length;g++)if(!k(r[S[g]],a[S[g]]))return!1}return!0}e.equals=k;function i(r){const a=new Set;return JSON.stringify(r,(g,m)=>{if((0,w.isObject)(m)||Array.isArray(m)){if(a.has(m))return"[Circular]";a.add(m)}return m})}e.safeStringify=i;function P(r,a,g){const m=a(r);return typeof m=="undefined"?g:m}e.getOrDefault=P;function d(r,a){const g=Object.create(null);return!r||!a||Object.keys(a).forEach(S=>{const f=r[S],l=a[S];k(f,l)||(g[S]=l)}),g}e.distinct=d;function h(r,a){const g=a.toLowerCase(),m=Object.keys(r).find(S=>S.toLowerCase()===g);return m?r[m]:r[a]}e.getCaseInsensitive=h}),define(we[82],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function I(T){return T<0?0:T>255?255:T|0}e.toUint8=I;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(we[2],_e([0,1,21,13]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function C(u,o){if(!u.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!A.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!T.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(u,o){return!u&&!o?"file":u}function k(u,o){switch(u){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const i="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(o,s,c,b,_,p=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=D(o,p),this.authority=s||i,this.path=k(this.scheme,c||i),this.query=b||i,this.fragment=_||i,C(this,p))}static isUri(o){return o instanceof h?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:c,path:b,query:_,fragment:p}=o;return s===void 0?s=this.scheme:s===null&&(s=i),c===void 0?c=this.authority:c===null&&(c=i),b===void 0?b=this.path:b===null&&(b=i),_===void 0?_=this.query:_===null&&(_=i),p===void 0?p=this.fragment:p===null&&(p=i),s===this.scheme&&c===this.authority&&b===this.path&&_===this.query&&p===this.fragment?this:new a(s,c,b,_,p)}static parse(o,s=!1){const c=d.exec(o);return c?new a(c[2]||i,n(c[4]||i),n(c[5]||i),n(c[7]||i),n(c[9]||i),s):new a(i,i,i,i,i)}static file(o){let s=i;if(w.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const c=o.indexOf(P,2);c===-1?(s=o.substring(2),o=P):(s=o.substring(2,c),o=o.substring(c)||P)}return new a("file",s,o,i,i)}static from(o){return new a(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return w.isWindows&&o.scheme==="file"?c=h.file(I.win32.join(f(o,!0),...s)).path:c=I.posix.join(o.path,...s),o.with({path:c})}toString(o=!1){return l(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof h)return o;{const s=new a(o);return s._formatted=o.external,s._fsPath=o._sep===r?o.fsPath:null,s}}else return o}}e.URI=h;const r=w.isWindows?1:void 0;class a extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=r),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(u,o){let s,c=-1;for(let b=0;b<u.length;b++){const _=u.charCodeAt(b);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||o&&_===47)c!==-1&&(s+=encodeURIComponent(u.substring(c,b)),c=-1),s!==void 0&&(s+=u.charAt(b));else{s===void 0&&(s=u.substr(0,b));const p=g[_];p!==void 0?(c!==-1&&(s+=encodeURIComponent(u.substring(c,b)),c=-1),s+=p):c===-1&&(c=b)}}return c!==-1&&(s+=encodeURIComponent(u.substring(c))),s!==void 0?s:u}function S(u){let o;for(let s=0;s<u.length;s++){const c=u.charCodeAt(s);c===35||c===63?(o===void 0&&(o=u.substr(0,s)),o+=g[c]):o!==void 0&&(o+=u[s])}return o!==void 0?o:u}function f(u,o){let s;return u.authority&&u.path.length>1&&u.scheme==="file"?s=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?o?s=u.path.substr(1):s=u.path[1].toLowerCase()+u.path.substr(2):s=u.path,w.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function l(u,o){const s=o?S:m;let c="",{scheme:b,authority:_,path:p,query:E,fragment:F}=u;if(b&&(c+=b,c+=":"),(_||b==="file")&&(c+=P,c+=P),_){let B=_.indexOf("@");if(B!==-1){const Y=_.substr(0,B);_=_.substr(B+1),B=Y.indexOf(":"),B===-1?c+=s(Y,!1):(c+=s(Y.substr(0,B),!1),c+=":",c+=s(Y.substr(B+1),!1)),c+="@"}_=_.toLowerCase(),B=_.indexOf(":"),B===-1?c+=s(_,!1):(c+=s(_.substr(0,B),!1),c+=_.substr(B))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const B=p.charCodeAt(1);B>=65&&B<=90&&(p=`/${String.fromCharCode(B+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const B=p.charCodeAt(0);B>=65&&B<=90&&(p=`${String.fromCharCode(B+32)}:${p.substr(2)}`)}c+=s(p,!0)}return E&&(c+="?",c+=s(E,!1)),F&&(c+="#",c+=o?F:m(F,!1)),c}function v(u){try{return decodeURIComponent(u)}catch(o){return u.length>3?u.substr(0,3)+v(u.substr(3)):u}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(u){return u.match(t)?u.replace(t,o=>v(o)):u}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[22],_e([0,1,2,8]),function(Q,e,w,I){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,u){let o=t.get(n);return o===void 0&&(o=u,t.set(n,o)),o}e.getOrSet=C;function D(t){const n=[];return t.forEach((u,o)=>{n.push(`${o} => ${u}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(u=>{n.push(u)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const u=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return u-o}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(n=!0,u=!0){this._splitOnBackslash=n,this._caseSensitive=u}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new r(n))}static forPaths(){return new g(new d)}static forStrings(){return new g(new i)}static forConfigKeys(){return new g(new P)}clear(){this._root=void 0}set(n,u){const o=this._iter.reset(n);let s;for(this._root||(this._root=new a,this._root.segment=o.value()),s=this._root;;){const b=o.cmp(s.segment);if(b>0)s.left||(s.left=new a,s.left.segment=o.value()),s=s.left;else if(b<0)s.right||(s.right=new a,s.right.segment=o.value()),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new a,s.mid.segment=o.value()),s=s.mid;else break}const c=s.value;return s.value=u,s.key=n,c}get(n){var u;return(u=this._getNode(n))===null||u===void 0?void 0:u.value}_getNode(n){const u=this._iter.reset(n);let o=this._root;for(;o;){const s=u.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else break}return o}has(n){const u=this._getNode(n);return!((u==null?void 0:u.value)===void 0&&(u==null?void 0:u.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,u){const o=this._iter.reset(n),s=[];let c=this._root;for(;c;){const b=o.cmp(c.segment);if(b>0)s.push([1,c]),c=c.left;else if(b<0)s.push([-1,c]),c=c.right;else if(o.hasNext())o.next(),s.push([0,c]),c=c.mid;else{for(u?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[_,p]=s.pop();switch(_){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}c=p}break}}}findSubstr(n){const u=this._iter.reset(n);let o=this._root,s;for(;o;){const c=u.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(u.hasNext())u.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(n){const u=this._iter.reset(n);let o=this._root;for(;o;){const s=u.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[u,o]of this)n(o,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=g;class m{constructor(n,u){this[A]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=u!=null?u:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,u){return this.map.set(this.toKey(n),u),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,u){typeof u!="undefined"&&(n=n.bind(u));for(let[o,s]of this.map)n(s,w.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class f{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,u=0){const o=this._map.get(n);if(!!o)return u!==0&&this.touch(o,u),o.value}set(n,u,o=0){let s=this._map.get(n);if(s)s.value=u,o!==0&&this.touch(s,o);else{switch(s={key:n,value:u,next:void 0,previous:void 0},o){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this._map.get(n);if(!!u)return this._map.delete(n),this.removeItem(u),this._size--,u.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,u){const o=this._state;let s=this._head;for(;s;){if(u?n.bind(u)(s.value,s.key,this):n(s.value,s.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,u=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,u=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,u=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let u=this._head,o=this.size;for(;u&&o>n;)this._map.delete(u.key),u=u.next,o--;this._head=u,this._size=o,u&&(u.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const u=n.next,o=n.previous;if(!u||!o)throw new Error("Invalid list");u.previous=o,o.next=u}n.next=void 0,n.previous=void 0,this._state++}touch(n,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this._head)return;const o=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(o.previous=s,s.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(u===2){if(n===this._tail)return;const o=n.next,s=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=s,s.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((u,o)=>{n.push([o,u])}),n}fromJSON(n){this.clear();for(const[u,o]of n)this.set(u,o)}}e.LinkedMap=f;class l extends f{constructor(n,u=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class v{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Me(this,y,"f").size}forEach(n,u){Me(this,y,"f").forEach(n,u)}get(n){return Me(this,y,"f").get(n)}has(n){return Me(this,y,"f").has(n)}entries(){return Me(this,y,"f").entries()}keys(){return Me(this,y,"f").keys()}values(){return Me(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Me(this,y,"f").entries()}}e.ReadonlyMapView=v}),define(we[110],_e([0,1,22,8]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Pe){for(let $e=0,Ee=ge.length;$e<Ee;$e++){const je=ge[$e](Ce,Pe);if(je)return je}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let $e;return ge?$e=I.startsWithIgnoreCase(Pe,Ce):$e=Pe.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(ge,Ce){const Pe=Ce.toLowerCase().indexOf(ge.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ge.length}]}e.matchesContiguousSubString=y;function C(ge,Ce){return D(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]===Ce[$e]){let Ee=null;return(Ee=D(ge,Ce,Pe+1,$e+1))?m({start:$e,end:$e+1},Ee):null}return D(ge,Ce,Pe,$e+1)}function k(ge){return 97<=ge&&ge<=122}function i(ge){return 65<=ge&&ge<=90}e.isUpper=i;function P(ge){return 48<=ge&&ge<=57}function d(ge){return ge===32||ge===9||ge===10||ge===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>h.add(ge.charCodeAt(0)));function r(ge){return d(ge)||h.has(ge)}function a(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function g(ge){return k(ge)||i(ge)||P(ge)}function m(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function S(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++){const $e=ge.charCodeAt(Pe);if(i($e)||P($e)||Pe>0&&!g(ge.charCodeAt(Pe-1)))return Pe}return ge.length}function f(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]!==Ce[$e].toLowerCase())return null;{let Ee=null,je=$e+1;for(Ee=f(ge,Ce,Pe+1,$e+1);!Ee&&(je=S(Ce,je))<Ce.length;)Ee=f(ge,Ce,Pe+1,je),je++;return Ee===null?null:m({start:$e,end:$e+1},Ee)}}function l(ge){let Ce=0,Pe=0,$e=0,Ee=0,je=0;for(let He=0;He<ge.length;He++)je=ge.charCodeAt(He),i(je)&&Ce++,k(je)&&Pe++,g(je)&&$e++,P(je)&&Ee++;const H=Ce/ge.length,te=Pe/ge.length,ve=$e/ge.length,Le=Ee/ge.length;return{upperPercent:H,lowerPercent:te,alphaPercent:ve,numericPercent:Le}}function v(ge){const{upperPercent:Ce,lowerPercent:Pe}=ge;return Pe===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:$e,numericPercent:Ee}=ge;return Pe>.2&&Ce<.8&&$e>.6&&Ee<.2}function n(ge){let Ce=0,Pe=0,$e=0,Ee=0;for(let je=0;je<ge.length;je++)$e=ge.charCodeAt(je),i($e)&&Ce++,k($e)&&Pe++,d($e)&&Ee++;return(Ce===0||Pe===0)&&Ee===0?ge.length<=30:Ce<=5}function u(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(ge)||Ce.length>60)return null;const Pe=l(Ce);if(!t(Pe)){if(!v(Pe))return null;Ce=Ce.toLowerCase()}let $e=null,Ee=0;for(ge=ge.toLowerCase();Ee<Ce.length&&($e=f(ge,Ce,0,Ee))===null;)Ee=S(Ce,Ee+1);return $e}e.matchesCamelCase=u;function o(ge,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let $e=null,Ee=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();Ee<Ce.length&&($e=s(ge,Ce,0,Ee,Pe))===null;)Ee=c(Ce,Ee+1);return $e}e.matchesWords=o;function s(ge,Ce,Pe,$e,Ee){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(a(ge.charCodeAt(Pe),Ce.charCodeAt($e))){let je=null,H=$e+1;if(je=s(ge,Ce,Pe+1,$e+1,Ee),!Ee)for(;!je&&(H=c(Ce,H))<Ce.length;)je=s(ge,Ce,Pe+1,H,Ee),H++;return je===null?null:m({start:$e,end:$e+1},je)}else return null}function c(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++)if(r(ge.charCodeAt(Pe))||Pe>0&&r(ge.charCodeAt(Pe-1)))return Pe;return ge.length}const b=A(e.matchesPrefix,u,y),_=A(e.matchesPrefix,u,C),p=new w.LRUCache(1e4);function E(ge,Ce,Pe=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let $e=p.get(ge);$e||($e=new RegExp(I.convertSimple2RegExpPattern(ge),"i"),p.set(ge,$e));const Ee=$e.exec(Ce);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Pe?_(ge,Ce):b(ge,Ce)}e.matchesFuzzy=E;function F(ge,Ce){const Pe=x(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?Y(Pe):null}e.matchesFuzzy2=F;function B(ge,Ce,Pe,$e,Ee,je){const H=Math.min(13,ge.length);for(;Pe<H;Pe++){const te=x(ge,Ce,Pe,$e,Ee,je,!1);if(te)return te}return[0,je]}e.anyScore=B;function Y(ge){if(typeof ge=="undefined")return[];const Ce=[],Pe=ge[1];for(let $e=ge.length-1;$e>1;$e--){const Ee=ge[$e]+Pe,je=Ce[Ce.length-1];je&&je.end===Ee?je.end=Ee+1:Ce.push({start:Ee,end:Ee+1})}return Ce}e.createMatches=Y;const fe=128;function V(){const ge=[],Ce=[];for(let Pe=0;Pe<=fe;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=fe;Pe++)ge.push(Ce.slice(0));return ge}function z(ge){const Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;return Ce}const ee=z(2*fe),$=z(2*fe),R=V(),L=V(),M=V(),U=!1;function G(ge,Ce,Pe,$e,Ee){function je(te,ve,Le=" "){for(;te.length<ve;)te=Le+te;return te}let H=` |   |${$e.split("").map(te=>je(te,3)).join("|")}
`;for(let te=0;te<=Pe;te++)te===0?H+=" |":H+=`${Ce[te-1]}|`,H+=ge[te].slice(0,Ee+1).map(ve=>je(ve.toString(),3)).join("|")+`
`;return H}function X(ge,Ce,Pe,$e){ge=ge.substr(Ce),Pe=Pe.substr($e),console.log(G(L,ge,ge.length,Pe,Pe.length)),console.log(G(M,ge,ge.length,Pe,Pe.length)),console.log(G(R,ge,ge.length,Pe,Pe.length))}function se(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Pe=ge.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Pe)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Te(ge,Ce,Pe){return Ce[ge]!==Pe[ge]}function xe(ge,Ce,Pe,$e,Ee,je,H=!1){for(;Ce<Pe&&Ee<je;)ge[Ce]===$e[Ee]&&(H&&(ee[Ce]=Ee),Ce+=1),Ee+=1;return Ce===Pe}e.isPatternInWord=xe;var Ae;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var We;(function(ge){ge.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ge.isDefault=Ce})(We=e.FuzzyScore||(e.FuzzyScore={}));function x(ge,Ce,Pe,$e,Ee,je,H){const te=ge.length>fe?fe:ge.length,ve=$e.length>fe?fe:$e.length;if(!(Pe>=te||je>=ve||te-Pe>ve-je)&&!!xe(Ce,Pe,te,Ee,je,ve,!0)){q(te,ve,Pe,je,Ce,Ee);let Le=1,He=1,Ue=Pe,Xe=je;const W=[!1];for(Le=1,Ue=Pe;Ue<te;Le++,Ue++){const ae=ee[Ue],he=$[Ue],ye=Ue+1<te?$[Ue+1]:ve;for(He=ae-je+1,Xe=ae;Xe<ye;He++,Xe++){let ze=Number.MIN_SAFE_INTEGER,Be=!1;Xe<=he&&(ze=ne(ge,Ce,Ue,Pe,$e,Ee,Xe,ve,je,R[Le-1][He-1]===0,W));let Ne=0;ze!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ne=ze+L[Le-1][He-1]);const Ge=Xe>ae,nt=Ge?L[Le][He-1]+(R[Le][He-1]>0?-5:0):0,dt=Xe>ae+1&&R[Le][He-1]>0,it=dt?L[Le][He-2]+(R[Le][He-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!Be||it>=Ne))L[Le][He]=it,M[Le][He]=3,R[Le][He]=0;else if(Ge&&(!Be||nt>=Ne))L[Le][He]=nt,M[Le][He]=2,R[Le][He]=0;else if(Be)L[Le][He]=Ne,M[Le][He]=1,R[Le][He]=R[Le-1][He-1]+1;else throw new Error("not possible")}}if(U&&X(ge,Pe,$e,je),!(!W[0]&&!H)){Le--,He--;const ie=[L[Le][He],je];let ce=0,j=0;for(;Le>=1;){let ae=He;do{const he=M[Le][ae];if(he===3)ae=ae-2;else if(he===2)ae=ae-1;else break}while(ae>=1);ce>1&&Ce[Pe+Le-1]===Ee[je+He-1]&&!Te(ae+je-1,$e,Ee)&&ce+1>R[Le][ae]&&(ae=He),ae===He?ce++:ce=1,j||(j=ae),Le--,He=ae-1,ie.push(He)}ve===te&&(ie[0]+=2);const Z=j-te;return ie[0]-=Z,ie}}}e.fuzzyScore=x;function q(ge,Ce,Pe,$e,Ee,je){let H=ge-1,te=Ce-1;for(;H>=Pe&&te>=$e;)Ee[H]===je[te]&&($[H]=te,H--),te--}function ne(ge,Ce,Pe,$e,Ee,je,H,te,ve,Le,He){if(Ce[Pe]!==je[H])return Number.MIN_SAFE_INTEGER;let Ue=1,Xe=!1;return H===Pe-$e?Ue=ge[Pe]===Ee[H]?7:5:Te(H,Ee,je)&&(H===0||!Te(H-1,Ee,je))?(Ue=ge[Pe]===Ee[H]?7:5,Xe=!0):se(je,H)&&(H===0||!se(je,H-1))?Ue=5:(se(je,H-1)||pe(je,H-1))&&(Ue=5,Xe=!0),Ue>1&&Pe===$e&&(He[0]=!0),Xe||(Xe=Te(H,Ee,je)||se(je,H-1)||pe(je,H-1)),Pe===$e?H>ve&&(Ue-=Xe?3:5):Le?Ue+=Xe?2:0:Ue+=Xe?0:1,H+1===te&&(Ue-=Xe?3:5),Ue}function le(ge,Ce,Pe,$e,Ee,je,H){return Se(ge,Ce,Pe,$e,Ee,je,!0,H)}e.fuzzyScoreGracefulAggressive=le;function me(ge,Ce,Pe,$e,Ee,je,H){return Se(ge,Ce,Pe,$e,Ee,je,!1,H)}e.fuzzyScoreGraceful=me;function Se(ge,Ce,Pe,$e,Ee,je,H,te){let ve=x(ge,Ce,Pe,$e,Ee,je,te);if(ve&&!H)return ve;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let He=Pe+1;He<Le;He++){const Ue=Oe(ge,He);if(Ue){const Xe=x(Ue,Ue.toLowerCase(),Pe,$e,Ee,je,te);Xe&&(Xe[0]-=3,(!ve||Xe[0]>ve[0])&&(ve=Xe))}}}return ve}function Oe(ge,Ce){if(!(Ce+1>=ge.length)){const Pe=ge[Ce],$e=ge[Ce+1];if(Pe!==$e)return ge.slice(0,Ce)+$e+Pe+ge.slice(Ce+2)}}}),define(we[111],_e([0,1,36,110,8]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function C(a){return a.replace(y,(g,m)=>m?g:`\\${g}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${T.source}`,"g");function k(a){return a.replace(D,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(g,m,S,f)=>S?g:m||f||"")}e.stripIcons=P;function d(a){const g=a.indexOf(e.iconStartMarker);return g===-1?{text:a}:h(a,g)}e.parseLabelWithIcons=d;function h(a,g){const m=[];let S="";function f(c){if(c){S+=c;for(const b of c)m.push(t)}}let l=-1,v="",t=0,n,u,o=g;const s=a.length;for(f(a.substr(0,g));o<s;)n=a[o],u=a[o+1],n===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(l=o,f(v),v=e.iconStartMarker,o++):n===")"&&l!==-1?(t+=o-l+1,l=-1,v=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?v+=n:(f(v),l=-1,v=""):f(n),o++;return f(v),{text:S,iconOffsets:m}}function r(a,g,m=!1){const{text:S,iconOffsets:f}=g;if(!f||f.length===0)return(0,I.matchesFuzzy)(a,S,m);const l=(0,A.ltrim)(S," "),v=S.length-l.length,t=(0,I.matchesFuzzy)(a,l,m);if(t)for(const n of t){const u=f[n.start+v]+v;n.start+=u,n.end+=u}return t}e.matchesFuzzyIconAware=r}),define(we[83],_e([0,1,15,111,12]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(a="",g=!1){var m,S;if(this.value=a,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1):(this.isTrusted=(m=g.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(S=g.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(a,g=0){return this.value+=P(this.supportThemeIcons?(0,I.escapeIcons)(a):a).replace(/([ \t]+)/g,(m,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,g){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}}e.MarkdownString=y;function C(r){return D(r)?!r.value:Array.isArray(r)?r.every(C):!0}e.isEmptyMarkdownString=C;function D(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(r,a){return!r&&!a?!0:!r||!a?!1:Array.isArray(r)&&Array.isArray(a)?(0,w.equals)(r,a,i):D(r)&&D(a)?i(r,a):!1}e.markedStringsEquals=k;function i(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function h(r){const a=[],g=r.split("|").map(S=>S.trim());r=g[0];const m=g[1];if(m){const S=/height=(\d+)/.exec(m),f=/width=(\d+)/.exec(m),l=S?S[1]:"",v=f?f[1]:"",t=isFinite(parseInt(v)),n=isFinite(parseInt(l));t&&a.push(`width="${v}"`),n&&a.push(`height="${l}"`)}return{href:r,dimensions:a}}e.parseHrefAndDimensions=h}),define(we[57],_e([0,1,23,8,2]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,C)}e.stringify=T;function y(k){let i=JSON.parse(k);return i=D(i),i}e.parse=y;function C(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,I.regExpFlags)(i)}:i}function D(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof w.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=D(k[P],i+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=D(k[P],i+1))}return k}e.revive=D}),define(we[19],_e([0,1,2,21]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,i){this._hosts[D]=k,this._ports[D]=i}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[k],d=this._connectionTokens[k];let h=`path=${encodeURIComponent(D.path)}`;return typeof d=="string"&&(h+=`&tkn=${encodeURIComponent(d)}`),w.URI.from({scheme:I.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,i){const P=this.toUri(D,k);return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):I.isNative&&(i||I.isPreferringBrowserCodeLoad)&&P.scheme===A.file?P.with({scheme:A.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,k){const i=this.toUri(D,k);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,k){return w.URI.isUri(D)?D:w.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(we[25],_e([0,1,37,13,2,8,19,21]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,A.uriToFsPath)(h,!0)}e.originalFSPath=D;class k{constructor(r){this._ignorePathCasing=r}compare(r,a,g=!1){return r===a?0:(0,T.compare)(this.getComparisonKey(r,g),this.getComparisonKey(a,g))}isEqual(r,a,g=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,g)===this.getComparisonKey(a,g)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,g=!1){if(r.scheme===a.scheme){if(r.scheme===y.Schemas.file)return w.isEqualOrParent(D(r),D(a),this._ignorePathCasing(r))&&r.query===a.query&&(g||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return w.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(g||r.fragment===a.fragment)}return!1}joinPath(r,...a){return A.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return I.posix.basename(r.path)}extname(r){return I.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===y.Schemas.file?a=A.URI.file(I.dirname(D(r))).path:(a=I.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===y.Schemas.file?a=A.URI.file(I.normalize(D(r))).path:a=I.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(!(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))){if(r.scheme===y.Schemas.file){const S=I.relative(D(r),D(a));return C.isWindows?w.toSlashes(S):S}let g=r.path||"/",m=a.path||"/";if(this._ignorePathCasing(r)){let S=0;for(const f=Math.min(g.length,m.length);S<f&&!(g.charCodeAt(S)!==m.charCodeAt(S)&&g.charAt(S).toLowerCase()!==m.charAt(S).toLowerCase());S++);g=m.substr(0,S)+g.substr(S)}return I.posix.relative(g,m)}}resolvePath(r,a){if(r.scheme===y.Schemas.file){const g=A.URI.file(I.resolve(D(r),a));return r.with({authority:g.authority,path:g.path})}return a.indexOf("/")===-1&&(a=w.toSlashes(a),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a)),r.with({path:I.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||(0,T.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=I.sep){if(r.scheme===y.Schemas.file){const g=D(r);return g.length>w.getRoot(g).length&&g[g.length-1]===a}else{const g=r.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=I.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=I.sep){let g=!1;if(r.scheme===y.Schemas.file){const m=D(r);g=m!==void 0&&m.length===w.getRoot(m).length&&m[m.length-1]===a}else{a="/";const m=r.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(h=>h.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(h,r){const a=[];for(let g=0;g<h.length;g++){const m=r(h[g]);h.some((S,f)=>f===g?!1:(0,e.isEqualOrParent)(m,r(S)))||a.push(h[g])}return a}e.distinctParents=i;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(a){const g=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(f=>{const[l,v]=f.split(":");l&&v&&g.set(l,v)});const S=a.path.substring(0,a.path.indexOf(";"));return S&&g.set(h.META_DATA_MIME,S),g}h.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function d(h,r,a){if(r){let g=h.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),h.with({scheme:a,authority:r,path:g})}return h.with({scheme:a})}e.toLocalResource=d}),define(we[11],_e([0,1,20,12,3,6,45,25]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(L){return!!L&&typeof L.then=="function"}e.isThenable=D;function k(L){const M=new w.CancellationTokenSource,U=L(M.token),G=new Promise((X,se)=>{M.token.onCancellationRequested(()=>{se((0,I.canceled)())}),Promise.resolve(U).then(pe=>{M.dispose(),X(pe)},pe=>{M.dispose(),se(pe)})});return new class{cancel(){M.cancel()}then(X,se){return G.then(X,se)}catch(X){return this.then(void 0,X)}finally(X){return G.finally(X)}}}e.createCancelablePromise=k;function i(L,M,U){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(U)))])}e.raceCancellation=i;async function P(L){let M=-1;const U=L.map((X,se)=>X.then(pe=>(M=se,pe))),G=await Promise.race(U);return L.forEach((X,se)=>{se!==M&&X.cancel()}),G}e.raceCancellablePromises=P;function d(L,M,U){let G;const X=setTimeout(()=>{G==null||G(void 0),U==null||U()},M);return Promise.race([L.finally(()=>clearTimeout(X)),new Promise(se=>G=se)])}e.raceTimeout=d;function h(L){return new Promise((M,U)=>{const G=L();D(G)?G.then(M,U):M(G)})}e.asPromise=h;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(U,U).then(G)})}return new Promise((U,G)=>{this.queuedPromise.then(U,G)})}return this.activePromise=M(),new Promise((U,G)=>{this.activePromise.then(X=>{this.activePromise=null,U(X)},X=>{this.activePromise=null,G(X)})})}}e.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=a;class g{constructor(){this.promiseMap=new Map}queue(M,U){var G;const se=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(M)===se&&this.promiseMap.delete(M)});return this.promiseMap.set(M,se),se}}e.SequencerByKey=g;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,U=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,X)=>{this.doResolve=G,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class S{constructor(M){this.delayer=new m(M),this.throttler=new r}trigger(M,U){return this.delayer.trigger(()=>this.throttler.queue(M),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class f{constructor(){this._isOpen=!1,this._promise=new Promise((M,U)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class l extends f{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function v(L,M){return M?new Promise((U,G)=>{const X=setTimeout(U,L);M.onCancellationRequested(()=>{clearTimeout(X),G((0,I.canceled)())})}):k(U=>v(L,U))}e.timeout=v;function t(L,M=0){const U=setTimeout(L,M);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function u(L){const M=[];let U=0;const G=L.length;function X(){return U<G?L[U++]():null}function se(pe){pe!=null&&M.push(pe);const Te=X();return Te?Te.then(se):Promise.resolve(M)}return Promise.resolve(null).then(se)}e.sequence=u;function o(L,M=G=>!!G,U=null){let G=0;const X=L.length,se=()=>{if(G>=X)return Promise.resolve(U);const pe=L[G++];return Promise.resolve(pe()).then(xe=>M(xe)?Promise.resolve(xe):se())};return se()}e.first=o;function s(L,M=G=>!!G,U=null){if(L.length===0)return Promise.resolve(U);let G=L.length;const X=()=>{var se,pe;G=-1;for(const Te of L)(pe=(se=Te).cancel)===null||pe===void 0||pe.call(se)};return new Promise((se,pe)=>{for(const Te of L)Te.then(xe=>{--G>=0&&M(xe)?(X(),se(xe)):G===0&&se(U)}).catch(xe=>{--G>=0&&(X(),pe(xe))})})}e.firstParallel=s;class c{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((U,G)=>{this.outstandingPromises.push({factory:M,c:U,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const U=M.factory();U.then(M.c,M.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class b extends c{constructor(){super(1)}}e.Queue=b;class _{constructor(){this.queues=new Map}queueFor(M,U=C.extUri){const G=U.getComparisonKey(M);let X=this.queues.get(G);return X||(X=new b,A.Event.once(X.onFinished)(()=>{X==null||X.dispose(),this.queues.delete(G)}),this.queues.set(G,X)),X}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=_;class p{constructor(M,U){this._token=-1,typeof M=="function"&&typeof U=="number"&&this.setIfNotSet(M,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},U)}setIfNotSet(M,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},U))}}e.TimeoutTimer=p;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setInterval(()=>{M()},U)}}e.IntervalTimer=E;class F{constructor(M,U){this.timeoutToken=-1,this.runner=M,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class B extends F{constructor(M,U){super(M,U);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const U=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(U))}}}}else e.runWhenIdle=(L,M)=>{const U=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(U))}}}}();class Y{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=Y;async function fe(L,M,U){let G;for(let X=0;X<U;X++)try{return await L()}catch(se){G=se,await v(M)}throw G}e.retry=fe;class V{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,U,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:U},U.then(()=>this.donePending(M),()=>this.donePending(M)),U}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let U,G;const X=new Promise((se,pe)=>{U=se,G=pe});this._next={run:M,promise:X,promiseResolve:U,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class z{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,U)=>{this.completeCallback=M,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(U=>{this.completeCallback(M),this.resolved=!0,U()})}error(M){return new Promise(U=>{this.errorCallback(M),this.rejected=!0,U()})}cancel(){new Promise(M=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=ee;class $ extends A.Emitter{async fireAsync(M,U,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const X of this._listeners)this._asyncDeliveryQueue.push([X,M]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[X,se]=this._asyncDeliveryQueue.shift(),pe=[],Te=Object.assign(Object.assign({},se),{waitUntil:xe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");G&&(xe=G(xe,typeof X=="function"?X:X[0])),pe.push(xe)}});try{typeof X=="function"?X.call(void 0,Te):X[0].call(X[1],Te)}catch(xe){(0,I.onUnexpectedError)(xe);continue}Object.freeze(pe),await R.settled(pe).catch(xe=>(0,I.onUnexpectedError)(xe))}}}}e.AsyncEmitter=$;var R;(function(L){async function M(se){return typeof Promise.allSettled=="function"?U(se):G(se)}L.allSettled=M;async function U(se){return Promise.allSettled(se)}async function G(se){return Promise.all(se.map(pe=>pe.then(Te=>({status:"fulfilled",value:Te}),Te=>({status:"rejected",reason:Te}))))}async function X(se){let pe;const Te=await Promise.all(se.map(xe=>xe.then(Ae=>Ae,Ae=>{pe||(pe=Ae)})));if(typeof pe!="undefined")throw pe;return Te}L.settled=X})(R=e.Promises||(e.Promises={}))}),define(we[112],_e([0,1,13,11]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),T=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(l,v,t=!1){const n=l||"",u=v||"",o=A.value.collator.compare(n,u);return A.value.collatorIsNumeric&&o===0&&n!==u?n<u?-1:1:o}e.compareFileNames=C;function D(l,v){const t=T.value.collator;return l=l||"",v=v||"",a(t,l,v)}e.compareFileNamesDefault=D;function k(l,v,t=!1){t||(l=l&&l.toLowerCase(),v=v&&v.toLowerCase());const[n,u]=h(l),[o,s]=h(v);return n!==o?n<o?-1:1:u===s?0:u<s?-1:1}e.noIntlCompareFileNames=k;function i(l,v){const[t,n]=h(l),[u,o]=h(v);let s=A.value.collator.compare(n,o);if(s===0){if(A.value.collatorIsNumeric&&n!==o)return n<o?-1:1;if(s=A.value.collator.compare(t,u),A.value.collatorIsNumeric&&s===0&&t!==u)return t<u?-1:1}return s}e.compareFileExtensions=i;function P(l,v){l=l||"",v=v||"";const t=r(l),n=r(v),u=T.value.collator,o=y.value.collator;let s;return s=a(o,t,n),s!==0?s:a(u,l,v)}e.compareFileExtensionsDefault=P;const d=/^(.*?)(\.([^.]*))?$/;function h(l,v=!1){const t=l?d.exec(l):[];let n=[t&&t[1]||"",t&&t[3]||""];return v&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function r(l){const v=l?d.exec(l):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function a(l,v,t){let n=l.compare(v,t);return n!==0?n:v.length!==t.length?v.length<t.length?-1:1:0}function g(l,v,t=!1){return t||(l=l&&l.toLowerCase(),v=v&&v.toLowerCase()),l===v?0:l<v?-1:1}function m(l,v,t=!1){const n=l.split(w.sep),u=v.split(w.sep),o=n.length-1,s=u.length-1;let c,b;for(let _=0;;_++){if(c=o===_,b=s===_,c&&b)return C(n[_],u[_],t);if(c)return-1;if(b)return 1;const p=g(n[_],u[_],t);if(p!==0)return p}}e.comparePaths=m;function S(l,v,t){const n=l.toLowerCase(),u=v.toLowerCase(),o=f(l,v,t);if(o)return o;const s=n.endsWith(t),c=u.endsWith(t);if(s!==c)return s?-1:1;const b=C(n,u);return b!==0?b:n.localeCompare(u)}e.compareAnything=S;function f(l,v,t){const n=l.toLowerCase(),u=v.toLowerCase(),o=n.startsWith(t),s=u.startsWith(t);if(o!==s)return o?-1:1;if(o&&s){if(n.length<u.length)return-1;if(n.length>u.length)return 1}return 0}e.compareByPrefix=f}),define(we[28],_e([0,1,8,37,13,22,11]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",k="/",i="[/\\\\]",P="[^/\\\\]",d=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function r(U,G){if(!U)return[];const X=[];let se=!1,pe=!1,Te="";for(const xe of U){switch(xe){case G:if(!se&&!pe){X.push(Te),Te="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Te+=xe}return Te&&X.push(Te),X}e.splitGlobAware=r;function a(U){if(!U)return"";let G="";const X=r(U,k);if(X.every(se=>se===D))G=".*";else{let se=!1;X.forEach((pe,Te)=>{if(pe===D){se||(G+=h(2),se=!0);return}let xe=!1,Ae="",We=!1,x="";for(const q of pe){if(q!=="}"&&xe){Ae+=q;continue}if(We&&(q!=="]"||!x)){let ne;q==="-"?ne=q:(q==="^"||q==="!")&&!x?ne="^":q===k?ne="":ne=w.escapeRegExpCharacters(q),x+=ne;continue}switch(q){case"{":xe=!0;continue;case"[":We=!0;continue;case"}":G+=`(?:${r(Ae,",").map(me=>a(me)).join("|")})`,xe=!1,Ae="";break;case"]":G+="["+x+"]",We=!1,x="";break;case"?":G+=P;continue;case"*":G+=h(1);continue;default:G+=w.escapeRegExpCharacters(q)}}Te<X.length-1&&(X[Te+1]!==D||Te+2<X.length)&&(G+=i),se=!1})}return G}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},u=function(){return null};function o(U,G){if(!U)return u;let X;typeof U!="string"?X=U.pattern:X=U,X=X.trim();const se=`${X}_${!!G.trimForExclusions}`;let pe=t.get(se);if(pe)return s(pe,U);let Te;if(g.test(X)){const xe=X.substr(4);pe=function(Ae,We){return typeof Ae=="string"&&Ae.endsWith(xe)?X:null}}else(Te=m.exec(c(X,G)))?pe=b(Te[1],X):(G.trimForExclusions?f:S).test(X)?pe=_(X,G):(Te=l.exec(c(X,G)))?pe=p(Te[1].substr(1),X,!0):(Te=v.exec(c(X,G)))?pe=p(Te[1],X,!1):pe=E(X);return t.set(se,pe),s(pe,U)}function s(U,G){return typeof G=="string"?U:function(X,se){return I.isEqualOrParent(X,G.base)?U(A.relative(G.base,X),se):null}}function c(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function b(U,G){const X=`/${U}`,se=`\\${U}`,pe=function(xe,Ae){return typeof xe!="string"?null:Ae?Ae===U?G:null:xe===U||xe.endsWith(X)||xe.endsWith(se)?G:null},Te=[U];return pe.basenames=Te,pe.patterns=[G],pe.allBasenames=Te,pe}function _(U,G){const X=M(U.slice(1,-1).split(",").map(Ae=>o(Ae,G)).filter(Ae=>Ae!==u),U),se=X.length;if(!se)return u;if(se===1)return X[0];const pe=function(Ae,We){for(let x=0,q=X.length;x<q;x++)if(X[x](Ae,We))return U;return null},Te=X.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const xe=X.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return xe.length&&(pe.allPaths=xe),pe}function p(U,G,X){const se=A.sep===A.posix.sep,pe=se?U:U.replace(d,A.sep),Te=A.sep+pe,xe=A.posix.sep+U,Ae=X?function(We,x){return typeof We=="string"&&(We===pe||We.endsWith(Te)||!se&&(We===U||We.endsWith(xe)))?G:null}:function(We,x){return typeof We=="string"&&(We===pe||!se&&We===U)?G:null};return Ae.allPaths=[(X?"*/":"./")+U],Ae}function E(U){try{const G=new RegExp(`^${a(U)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?U:null}}catch(G){return u}}function F(U,G,X){return!U||typeof G!="string"?!1:B(U)(G,void 0,X)}e.match=F;function B(U,G={}){if(!U)return n;if(typeof U=="string"||z(U)){const X=o(U,G);if(X===u)return n;const se=function(pe,Te){return!!X(pe,Te)};return X.allBasenames&&(se.allBasenames=X.allBasenames),X.allPaths&&(se.allPaths=X.allPaths),se}return R(U,G)}e.parse=B;function Y(U){if(!!U){let G;return X=>(G||(G=(U()||Promise.resolve([])).then(se=>se?V(se):{})),G.then(se=>!!se[X]))}}e.hasSiblingPromiseFn=Y;function fe(U){if(!!U){let G;return X=>{if(!G){const se=U();G=se?V(se):{}}return!!G[X]}}}e.hasSiblingFn=fe;function V(U){const G={};for(const X of U)G[X]=!0;return G}function z(U){const G=U;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function ee(U){return U.allBasenames||[]}e.getBasenameTerms=ee;function $(U){return U.allPaths||[]}e.getPathTerms=$;function R(U,G){const X=M(Object.getOwnPropertyNames(U).map(Ae=>L(Ae,U[Ae],G)).filter(Ae=>Ae!==u)),se=X.length;if(!se)return u;if(!X.some(Ae=>!!Ae.requiresSiblings)){if(se===1)return X[0];const Ae=function(q,ne){for(let le=0,me=X.length;le<me;le++){const Se=X[le](q,ne);if(Se)return Se}return null},We=X.find(q=>!!q.allBasenames);We&&(Ae.allBasenames=We.allBasenames);const x=X.reduce((q,ne)=>ne.allPaths?q.concat(ne.allPaths):q,[]);return x.length&&(Ae.allPaths=x),Ae}const pe=function(Ae,We,x){let q;for(let ne=0,le=X.length;ne<le;ne++){const me=X[ne];me.requiresSiblings&&x&&(We||(We=A.basename(Ae)),q||(q=We.substr(0,We.length-A.extname(Ae).length)));const Se=me(Ae,We,q,x);if(Se)return Se}return null},Te=X.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const xe=X.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return xe.length&&(pe.allPaths=xe),pe}function L(U,G,X){if(G===!1)return u;const se=o(U,X);if(se===u)return u;if(typeof G=="boolean")return se;if(G){const pe=G.when;if(typeof pe=="string"){const Te=(xe,Ae,We,x)=>{if(!x||!se(xe,Ae))return null;const q=pe.replace("$(basename)",We),ne=x(q);return(0,y.isThenable)(ne)?ne.then(le=>le?U:null):ne?U:null};return Te.requiresSiblings=!0,Te}}return se}function M(U,G){const X=U.filter(Ae=>!!Ae.basenames);if(X.length<2)return U;const se=X.reduce((Ae,We)=>{const x=We.basenames;return x?Ae.concat(x):Ae},[]);let pe;if(G){pe=[];for(let Ae=0,We=se.length;Ae<We;Ae++)pe.push(G)}else pe=X.reduce((Ae,We)=>{const x=We.patterns;return x?Ae.concat(x):Ae},[]);const Te=function(Ae,We){if(typeof Ae!="string")return null;if(!We){let q;for(q=Ae.length;q>0;q--){const ne=Ae.charCodeAt(q-1);if(ne===47||ne===92)break}We=Ae.substr(q)}const x=se.indexOf(We);return x!==-1?pe[x]:null};Te.basenames=se,Te.patterns=pe,Te.allBasenames=se;const xe=U.filter(Ae=>!Ae.basenames);return xe.push(Te),xe}}),define(we[58],_e([0,1,2,13,8,19,21,25,37]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(o,s,c){if(typeof o=="string"&&(o=w.URI.file(o)),c){const _=c.getWorkspaceFolder(o);if(_){const p=c.getWorkspace().folders.length>1;let E;if((0,C.isEqual)(_.uri,o)?E="":E=(0,C.relativePath)(_.uri,o),p){const F=_.name?_.name:(0,C.basename)(_.uri);E=E?F+" \u2022 "+E:F}return E}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(o.fsPath))return(0,I.normalize)(P(o.fsPath));let b=(0,I.normalize)(o.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(b=h(b,s.userHome.fsPath)),b}e.getPathLabel=k;function i(o){if(!!o){typeof o=="string"&&(o=w.URI.file(o));const s=(0,C.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(s)?P(s):s}}e.getBaseLabel=i;function P(o){return(0,D.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let d=Object.create(null);function h(o,s){if(y.isWindows||!o||!s)return o;let c=d.original===s?d.normalized:void 0;return c||(c=`${(0,A.rtrim)(s,I.posix.sep)}${I.posix.sep}`,d={original:s,normalized:c}),(y.isLinux?o.startsWith(c):(0,A.startsWithIgnoreCase)(o,c))&&(o=`~/${o.substr(c.length)}`),o}e.tildify=h;function r(o,s){return o.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const a="\u2026",g="\\\\",m="~";function S(o,s=I.sep){const c=new Array(o.length);let b=!1;for(let _=0;_<o.length;_++){let p=o[_];if(p===""){c[_]=`.${s}`;continue}if(!p){c[_]=p;continue}b=!0;let E="";p.indexOf(g)===0?(E=p.substr(0,p.indexOf(g)+g.length),p=p.substr(p.indexOf(g)+g.length)):p.indexOf(s)===0?(E=p.substr(0,p.indexOf(s)+s.length),p=p.substr(p.indexOf(s)+s.length)):p.indexOf(m)===0&&(E=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const F=p.split(s);for(let B=1;b&&B<=F.length;B++)for(let Y=F.length-B;b&&Y>=0;Y--){b=!1;let fe=F.slice(Y,Y+B).join(s);for(let V=0;!b&&V<o.length;V++)if(V!==_&&o[V]&&o[V].indexOf(fe)>-1){const z=Y+B===F.length,ee=Y>0&&o[V].indexOf(s)>-1?s+fe:fe,$=o[V].endsWith(ee);b=!z||$}if(!b){let V="";(F[0].endsWith(":")||E!=="")&&(Y===1&&(Y=0,B++,fe=F[0]+s+fe),Y>0&&(V=F[0]+s),V=E+V),Y>0&&(V=V+a+s),V=V+fe,Y+B<F.length&&(V=V+s+a),c[_]=V}}b&&(c[_]=p)}return c}e.shorten=S;var f;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(o,s=Object.create(null)){const c=[];let b=!1,_="";for(const p of o)if(p==="$"||b&&p==="{")_&&c.push({value:_,type:f.TEXT}),_="",b=!0;else if(p==="}"&&b){const E=s[_];if(typeof E=="string")E.length&&c.push({value:E,type:f.VARIABLE});else if(E){const F=c[c.length-1];(!F||F.type!==f.SEPARATOR)&&c.push({value:E.label,type:f.SEPARATOR})}_="",b=!1}else _+=p;return _&&!b&&c.push({value:_,type:f.TEXT}),c.filter((p,E)=>{if(p.type===f.SEPARATOR){const F=c[E-1],B=c[E+1];return[F,B].every(Y=>Y&&(Y.type===f.VARIABLE||Y.type===f.TEXT)&&Y.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=l;function v(o,s){return y.isMacintosh||s?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):o.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(o,s){return y.isMacintosh||s?o.replace(/\(&&\w\)|&&/g,""):y.isWindows?o.replace(/&&|&/g,c=>c==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=n;function u(o){const s=o.indexOf("/")!==-1?I.posix:I.win32,c=s.basename(o),b=s.dirname(o);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}e.splitName=u}),define(we[113],_e([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(i){return i.toJSON()}class A{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:I(w.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:I(w.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:w.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,P,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof w.URI)return P.transformOutgoing(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const r=T(i[h],P,d+1);r!==null&&(i[h]=r)}}return null}function y(i,P){const d=T(i,P,0);return d===null?i:d}e.transformOutgoingURIs=y;function C(i,P,d,h){if(!i||h>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?w.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const a=C(i[r],P,d,h+1);a!==null&&(i[r]=a)}}return null}function D(i,P){const d=C(i,P,!1,0);return d===null?i:d}e.transformIncomingURIs=D;function k(i,P){const d=C(i,P,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=k}),define(we[31],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return w.test(D)}e.isUUID=I;const A=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function C(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let D=0,k="";return k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k}e.generateUuid=C}),define(we[84],_e([0,1,82]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(C){let D=(0,w.toUint8)(C);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=C;return D}set(C,D){let k=(0,w.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=I;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new I(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=T}),define(we[114],_e([0,1,84]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends w.CharacterClassifier{constructor(C){super(0);for(let D=0,k=C.length;D<k;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=y(D)),C[D])}e.getMapForWordSeparators=T(y=>new A(y))}),define(we[38],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new w(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return w.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return w.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return w.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,C=T.lineNumber|0;if(y===C){let D=A.column|0,k=T.column|0;return D-k}return y-C}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new w(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=w}),define(we[32],_e([0,1,38]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(T,y,C,D){T>C||T===C&&y>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return I.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return I.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return I.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return I.plusRange(this,T)}static plusRange(T,y){let C,D,k,i;return y.startLineNumber<T.startLineNumber?(C=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(C=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(C=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(k=T.endLineNumber,i=T.endColumn),new I(C,D,k,i)}intersectRanges(T){return I.intersectRanges(this,T)}static intersectRanges(T,y){let C=T.startLineNumber,D=T.startColumn,k=T.endLineNumber,i=T.endColumn,P=y.startLineNumber,d=y.startColumn,h=y.endLineNumber,r=y.endColumn;return C<P?(C=P,D=d):C===P&&(D=Math.max(D,d)),k>h?(k=h,i=r):k===h&&(i=Math.min(i,r)),C>k||C===k&&D>i?null:new I(C,D,k,i)}equalsRange(T){return I.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(T){return new w.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(T){return new w.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new I(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new I(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(T){return new I(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new I(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new I(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const k=T.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const P=T.startColumn|0,d=y.startColumn|0;if(P===d){const h=T.endLineNumber|0,r=y.endLineNumber|0;if(h===r){const a=T.endColumn|0,g=y.endColumn|0;return a-g}return h-r}return P-d}return k-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=I}),define(we[115],_e([0,1,38,32]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends I.Range{constructor(C,D,k,i){super(C,D,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return T.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,C,D):new T(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new T(C,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new T(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new T(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],D[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,k,i,P){return P===0?new T(C,D,k,i):new T(k,i,C,D)}}e.Selection=T}),define(we[85],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(r,a){this.range=r,this.matches=a}}e.FindMatch=D;var k;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class P{constructor(r,a,g,m,S,f){this.identifier=r,this.range=a,this.text=g,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=S,this._isTracked=f}}e.ValidAnnotatedEditOperation=P;class d{constructor(r,a,g){this.reverseEdits=r,this.changes=a,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=d}),define(we[116],_e([0,1,8,114,38,32,85]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(f,l,v,t){this.searchString=f,this.isRegex=l,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=k(this.searchString):f=this.searchString.indexOf(`
`)>=0;let l=null;try{l=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let v=!this.isRegex&&!f;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let f=0,l=S.length;f<l;f++)if(S.charCodeAt(f)===92){if(f++,f>=l)break;const t=S.charCodeAt(f);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(f,l,v){this.regex=f,this.wordSeparators=l,this.simpleSearch=v}}e.SearchData=i;function P(S,f,l){if(!l)return new y.FindMatch(S,null);let v=[];for(let t=0,n=f.length;t<n;t++)v[t]=f[t];return new y.FindMatch(S,v)}e.createFindMatch=P;class d{constructor(f){let l=[],v=0;for(let t=0,n=f.length;t<n;t++)f.charCodeAt(t)===10&&(l[v++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(f){const l=this._lineFeedsOffsets;let v=0,t=l.length-1;if(t===-1||f<=l[0])return 0;for(;v<t;){const n=v+((t-v)/2>>0);l[n]>=f?t=n-1:l[n+1]>=f?(v=n,t=n):v=n+1}return v+1}}class h{static findMatches(f,l,v,t,n){const u=l.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(f,v,new m(u.wordSeparators,u.regex),t,n):this._doFindMatchesLineByLine(f,v,u,t,n):[]}static _getMultilineMatchRange(f,l,v,t,n,u){let o,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),o=l+n+s):o=l+n;let c;if(t){let E=t.findLineFeedCountBeforeOffset(n+u.length)-s;c=o+u.length+E}else c=o+u.length;const b=f.getPositionAt(o),_=f.getPositionAt(c);return new T.Range(b.lineNumber,b.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(f,l,v,t,n){const u=f.getOffsetAt(l.getStartPosition()),o=f.getValueInRange(l,1),s=f.getEOL()===`\r
`?new d(o):null,c=[];let b=0,_;for(v.reset(0);_=v.next(o);)if(c[b++]=P(this._getMultilineMatchRange(f,u,o,s,_.index,_[0]),_,t),b>=n)return c;return c}static _doFindMatchesLineByLine(f,l,v,t,n){const u=[];let o=0;if(l.startLineNumber===l.endLineNumber){const c=f.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return o=this._findMatchesInLine(v,c,l.startLineNumber,l.startColumn-1,o,u,t,n),u}const s=f.getLineContent(l.startLineNumber).substring(l.startColumn-1);o=this._findMatchesInLine(v,s,l.startLineNumber,l.startColumn-1,o,u,t,n);for(let c=l.startLineNumber+1;c<l.endLineNumber&&o<n;c++)o=this._findMatchesInLine(v,f.getLineContent(c),c,0,o,u,t,n);if(o<n){const c=f.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);o=this._findMatchesInLine(v,c,l.endLineNumber,0,o,u,t,n)}return u}static _findMatchesInLine(f,l,v,t,n,u,o,s){const c=f.wordSeparators;if(!o&&f.simpleSearch){const p=f.simpleSearch,E=p.length,F=l.length;let B=-E;for(;(B=l.indexOf(p,B+E))!==-1;)if((!c||g(c,l,F,B,E))&&(u[n++]=new y.FindMatch(new T.Range(v,B+1+t,v,B+1+E+t),null),n>=s))return n;return n}const b=new m(f.wordSeparators,f.regex);let _;b.reset(0);do if(_=b.next(l),_&&(u[n++]=P(new T.Range(v,_.index+1+t,v,_.index+1+_[0].length+t),_,o),n>=s))return n;while(_);return n}static findNextMatch(f,l,v,t){const n=l.parseSearchRequest();if(!n)return null;const u=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(f,v,u,t):this._doFindNextMatchLineByLine(f,v,u,t)}static _doFindNextMatchMultiline(f,l,v,t){const n=new A.Position(l.lineNumber,1),u=f.getOffsetAt(n),o=f.getLineCount(),s=f.getValueInRange(new T.Range(n.lineNumber,n.column,o,f.getLineMaxColumn(o)),1),c=f.getEOL()===`\r
`?new d(s):null;v.reset(l.column-1);let b=v.next(s);return b?P(this._getMultilineMatchRange(f,u,s,c,b.index,b[0]),b,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(f,new A.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(f,l,v,t){const n=f.getLineCount(),u=l.lineNumber,o=f.getLineContent(u),s=this._findFirstMatchInLine(v,o,u,l.column,t);if(s)return s;for(let c=1;c<=n;c++){const b=(u+c-1)%n,_=f.getLineContent(b+1),p=this._findFirstMatchInLine(v,_,b+1,1,t);if(p)return p}return null}static _findFirstMatchInLine(f,l,v,t,n){f.reset(t-1);const u=f.next(l);return u?P(new T.Range(v,u.index+1,v,u.index+1+u[0].length),u,n):null}static findPreviousMatch(f,l,v,t){const n=l.parseSearchRequest();if(!n)return null;const u=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(f,v,u,t):this._doFindPreviousMatchLineByLine(f,v,u,t)}static _doFindPreviousMatchMultiline(f,l,v,t){const n=this._doFindMatchesMultiline(f,new T.Range(1,1,l.lineNumber,l.column),v,t,10*C);if(n.length>0)return n[n.length-1];const u=f.getLineCount();return l.lineNumber!==u||l.column!==f.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(f,new A.Position(u,f.getLineMaxColumn(u)),v,t):null}static _doFindPreviousMatchLineByLine(f,l,v,t){const n=f.getLineCount(),u=l.lineNumber,o=f.getLineContent(u).substring(0,l.column-1),s=this._findLastMatchInLine(v,o,u,t);if(s)return s;for(let c=1;c<=n;c++){const b=(n+u-c-1)%n,_=f.getLineContent(b+1),p=this._findLastMatchInLine(v,_,b+1,t);if(p)return p}return null}static _findLastMatchInLine(f,l,v,t){let n=null,u;for(f.reset(0);u=f.next(l);)n=P(new T.Range(v,u.index+1,v,u.index+1+u[0].length),u,t);return n}}e.TextModelSearch=h;function r(S,f,l,v,t){if(v===0)return!0;const n=f.charCodeAt(v-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const u=f.charCodeAt(v);if(S.get(u)!==0)return!0}return!1}function a(S,f,l,v,t){if(v+t===l)return!0;const n=f.charCodeAt(v+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const u=f.charCodeAt(v+t-1);if(S.get(u)!==0)return!0}return!1}function g(S,f,l,v,t){return r(S,f,l,v,t)&&a(S,f,l,v,t)}e.isValidMatch=g;class m{constructor(f,l){this._wordSeparators=f,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(f){this._searchRegex.lastIndex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(f){const l=f.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(v=this._searchRegex.exec(f),!v))return null;const t=v.index,n=v[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(f,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||g(this._wordSeparators,f,l,t,n))return v}while(v);return null}}e.Searcher=m}),define(we[86],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=w();function I(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),D=new RegExp(C.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(C,D,k,i,P=A){if(k.length>P.maxLen){let g=C-P.maxLen/2;return g<0?g=0:i+=g,k=k.substring(g,C+P.maxLen/2),T(C,D,k,i,P)}const d=Date.now(),h=C-1-i;let r=-1,a=null;for(let g=1;!(Date.now()-d>=P.timeBudget);g++){const m=h-P.windowSize*g;D.lastIndex=Math.max(0,m);const S=y(D,k,h,r);if(!S&&a||(a=S,m<=0))break;r=m}if(a){let g={word:a[0],startColumn:i+1+a.index,endColumn:i+1+a.index+a[0].length};return D.lastIndex=0,g}return null}e.getWordAtText=T;function y(C,D,k,i){let P;for(;P=C.exec(D);){const d=P.index||0;if(d<=k&&C.lastIndex>=k)return P;if(i>0&&d>i)return null}return null}}),define(we[117],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class I{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,k=C.notIn.length;D<k;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=I;class A{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=A;function T(y,C,D){y.has(C)?y.get(C).push(D):y.set(C,[D])}}),define(we[59],_e([0,1,28,13]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,C,D){if(Array.isArray(T)){let k=0;for(const i of T){const P=A(i,y,C,D);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===C?10:0:0;if(T){const{language:k,pattern:i,scheme:P,hasAccessToAllModels:d}=T;if(!D&&!d)return 0;let h=0;if(P)if(P===y.scheme)h=10;else if(P==="*")h=5;else return 0;if(k)if(k===C)h=10;else if(k==="*")h=Math.max(h,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,I.normalize)(i.base)}),r===y.fsPath||(0,w.match)(r,y.fsPath))h=10;else return 0}return h}else return 0}}e.score=A}),define(we[118],_e([0,1,84]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class A{constructor(r,a,g){const m=new Uint8Array(r*a);for(let S=0,f=r*a;S<f;S++)m[S]=g;this._data=m,this.rows=r,this.cols=a}get(r,a){return this._data[r*this.cols+a]}set(r,a,g){this._data[r*this.cols+a]=g}}e.Uint8Matrix=A;class T{constructor(r){let a=0,g=0;for(let S=0,f=r.length;S<f;S++){let[l,v,t]=r[S];v>a&&(a=v),l>g&&(g=l),t>g&&(g=t)}a++,g++;let m=new A(g,a,0);for(let S=0,f=r.length;S<f;S++){let[l,v,t]=r[S];m.set(l,v,t)}this._states=m,this._maxCharCode=a}nextState(r,a){return a<0||a>=this._maxCharCode?0:this._states.get(r,a)}}e.StateMachine=T;let y=null;function C(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function i(){if(k===null){k=new w.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<h.length;a++)k.set(h.charCodeAt(a),1);const r=".,;";for(let a=0;a<r.length;a++)k.set(r.charCodeAt(a),2)}return k}class P{static _createLink(r,a,g,m,S){let f=S-1;do{const l=a.charCodeAt(f);if(r.get(l)!==2)break;f--}while(f>m);if(m>0){const l=a.charCodeAt(m-1),v=a.charCodeAt(f);(l===40&&v===41||l===91&&v===93||l===123&&v===125)&&f--}return{range:{startLineNumber:g,startColumn:m+1,endLineNumber:g,endColumn:f+2},url:a.substring(m,f+1)}}static computeLinks(r,a=C()){const g=i();let m=[];for(let S=1,f=r.getLineCount();S<=f;S++){const l=r.getLineContent(S),v=l.length;let t=0,n=0,u=0,o=1,s=!1,c=!1,b=!1,_=!1;for(;t<v;){let p=!1;const E=l.charCodeAt(t);if(o===13){let F;switch(E){case 40:s=!0,F=0;break;case 41:F=s?0:1;break;case 91:b=!0,c=!0,F=0;break;case 93:b=!1,F=c?0:1;break;case 123:_=!0,F=0;break;case 125:F=_?0:1;break;case 39:F=u===34||u===96?0:1;break;case 34:F=u===39||u===96?0:1;break;case 96:F=u===39||u===34?0:1;break;case 42:F=u===42?1:0;break;case 124:F=u===124?1:0;break;case 32:F=b?0:1;break;default:F=g.get(E)}F===1&&(m.push(P._createLink(g,l,S,n,t)),p=!0)}else if(o===12){let F;E===91?(c=!0,F=0):F=g.get(E),F===1?p=!0:o=13}else o=a.nextState(o,E),o===0&&(p=!0);p&&(o=1,s=!1,c=!1,_=!1,n=t+1,u=E),t++}o===13&&m.push(P._createLink(g,l,S,n,v))}return m}}e.LinkComputer=P;function d(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:P.computeLinks(h)}e.computeLinks=d}),define(we[119],_e([0,1,3,6]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let D=null,k=!1;return this._promises.set(y,C.then(i=>{this._promises.delete(y),!(k||!i)&&(D=this.register(y,i))})),(0,I.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(we[87],_e([0,1,23,21]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(A||(A={}));function T(P){for(let d=0,h=P.length;d<h;d+=4){const r=P[d+0],a=P[d+1],g=P[d+2],m=P[d+3];P[d+0]=m,P[d+1]=g,P[d+2]=a,P[d+3]=r}}function y(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return I.isLittleEndian()||T(d),w.VSBuffer.wrap(d)}function C(P){const d=P.buffer;if(I.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const h=new Uint8Array(d.byteLength);return h.set(d),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(P){const d=new Uint32Array(k(P));let h=0;if(d[h++]=P.id,P.type==="full")d[h++]=1,d[h++]=P.data.length,d.set(P.data,h),h+=P.data.length;else{d[h++]=2,d[h++]=P.deltas.length;for(const r of P.deltas)d[h++]=r.start,d[h++]=r.deleteCount,r.data?(d[h++]=r.data.length,d.set(r.data,h),h+=r.data.length):d[h++]=0}return y(d)}e.encodeSemanticTokensDto=D;function k(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const h of P.deltas)h.data&&(d+=h.data.length)}return d}function i(P){const d=C(P);let h=0;const r=d[h++];if(d[h++]===1){const S=d[h++],f=d.subarray(h,h+S);return h+=S,{id:r,type:"full",data:f}}const g=d[h++];let m=[];for(let S=0;S<g;S++){const f=d[h++],l=d[h++],v=d[h++];let t;v>0&&(t=d.subarray(h,h+v),h+=v),m[S]={start:f,deleteCount:l,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(we[88],_e([0,1,82]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=I;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,w.toUint32)(y);const D=this.values,k=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,w.toUint32)(y),C=(0,w.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,w.toUint32)(y),C=(0,w.toUint32)(C);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,w.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let D=C;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,D=this.values.length-1,k=0,i=0,P=0;for(;C<=D;)if(k=C+(D-C)/2|0,i=this.prefixSum[k],P=i-this.values[k],y<P)D=k-1;else if(y>=i)C=k+1;else break;return new I(k,y-P)}}e.PrefixSumComputer=A}),define(we[120],_e([0,1,8,38,88]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(C,D,k,i){this._uri=C,this._lines=D,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let i=0;i<D;i++)k[i]=this._lines[i].length+C;this._lineStarts=new A.PrefixSumComputer(k)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length!==0){let k=(0,w.splitLines)(D);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),i[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}}e.MirrorTextModel=T}),define(we[121],_e([16,17]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(we[60],_e([0,1,121,10,15]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,i){return i&&(k.stack||k.stacktrace)?w.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?w.localize(1,null,k.message):k.message||w.localize(2,null)}function D(k=null,i=!1){if(!k)return w.localize(3,null);if(Array.isArray(k)){const P=A.coalesce(k),d=D(P[0],i);return P.length>1?w.localize(4,null,d,P.length):d}if(I.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,i);if(P.exception)return T(P.exception,i)}return k.stack?T(k,i):k.message?k.message:w.localize(5,null)}e.toErrorMessage=D}),define(we[122],_e([16,17]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(we[123],_e([0,1,122,21,86]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(te,ve,Le,He){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=He}compute(te,ve,Le){return Le}}class i{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class P{constructor(te,ve,Le,He){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=He}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Le){return Le}}function d(H,te){return typeof H=="undefined"?te:H==="false"?!1:Boolean(H)}e.boolean=d;class h extends P{constructor(te,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(te,ve,Le,He)}validate(te){return d(te,this.defaultValue)}}class r extends P{constructor(te,ve,Le,He,Ue,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Le,Xe.minimum=He,Xe.maximum=Ue),super(te,ve,Le,Xe),this.minimum=He,this.maximum=Ue}static clampedInt(te,ve,Le,He){if(typeof te=="undefined")return ve;let Ue=parseInt(te,10);return isNaN(Ue)?ve:(Ue=Math.max(Le,Ue),Ue=Math.min(He,Ue),Ue|0)}validate(te){return r.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class a extends P{constructor(te,ve,Le,He,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Le),super(te,ve,Le,Ue),this.validationFn=He}static clamp(te,ve,Le){return te<ve?ve:te>Le?Le:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Le=parseFloat(te);return isNaN(Le)?ve:Le}validate(te){return this.validationFn(a.float(te,this.defaultValue))}}class g extends P{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(te,ve,Le,He)}validate(te){return g.string(te,this.defaultValue)}}function m(H,te,ve){return typeof H!="string"||ve.indexOf(H)===-1?te:H}e.stringSet=m;class S extends P{constructor(te,ve,Le,He,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=He,Ue.default=Le),super(te,ve,Le,Ue),this._allowedValues=He}validate(te){return m(te,this.defaultValue,this._allowedValues)}}class f extends k{constructor(te,ve,Le,He,Ue,Xe,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=Ue,W.default=He),super(te,ve,Le,W),this._allowedValues=Ue,this._convert=Xe}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function l(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Le){return Le===0?te.accessibilitySupport:Le}}class t extends k{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:w.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:d(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(H){switch(H){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(H){switch(H){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class b extends i{constructor(){super(123,[62,31])}compute(te,ve,Le){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),te.extraEditorClassName&&He.push(te.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class _ extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(te,ve,Le){return Le&&te.emptySelectionClipboard}}class p extends k{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:w.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:w.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:d(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":m(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ve.loop,this.defaultValue.loop)}}}class E extends k{constructor(){super(41,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?E.OFF:te==="true"?E.ON:te:Boolean(te)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(te,ve,Le){return te.fontInfo}}class B extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(te){let ve=a.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ve,6,100)}compute(te,ve,Le){return te.fontInfo.fontSize}}class Y extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.MINIMUM_VALUE,maximum:Y.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(r.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.MINIMUM_VALUE,Y.MAXIMUM_VALUE))}}Y.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Y.MINIMUM_VALUE=1,Y.MAXIMUM_VALUE=1e3;class fe extends k{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Le,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Le,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Le,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Le,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Le,description:w.localize(35,null)}})}validate(te){var ve,Le,He,Ue,Xe;if(!te||typeof te!="object")return this.defaultValue;const W=te;return{multiple:m(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=W.multipleDefinitions)!==null&&ve!==void 0?ve:m(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=W.multipleTypeDefinitions)!==null&&Le!==void 0?Le:m(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:m(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=W.multipleImplementations)!==null&&Ue!==void 0?Ue:m(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=W.multipleReferences)!==null&&Xe!==void 0?Xe:m(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends k{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:w.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:d(ve.sticky,this.defaultValue.sticky)}}}var z;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class ee extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(te,ve,Le){return ee.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Le=te.scrollBeyondLastLine?ve-1:0,He=(te.viewLineCount+Le)/(te.pixelRatio*te.height),Ue=Math.floor(te.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:Ue}}static _computeMinimapLayout(te,ve){const Le=te.outerWidth,He=te.outerHeight,Ue=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=ve.stableMinimapLayoutInput,W=Xe&&te.outerHeight===Xe.outerHeight&&te.lineHeight===Xe.lineHeight&&te.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&te.pixelRatio===Xe.pixelRatio&&te.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&te.minimap.enabled===Xe.minimap.enabled&&te.minimap.side===Xe.minimap.side&&te.minimap.size===Xe.minimap.size&&te.minimap.showSlider===Xe.minimap.showSlider&&te.minimap.renderCharacters===Xe.minimap.renderCharacters&&te.minimap.maxColumn===Xe.minimap.maxColumn&&te.minimap.scale===Xe.minimap.scale&&te.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&te.isViewportWrapping===Xe.isViewportWrapping,ie=te.lineHeight,ce=te.typicalHalfwidthCharacterWidth,j=te.scrollBeyondLastLine,Z=te.minimap.renderCharacters;let ae=Ue>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const he=te.minimap.maxColumn,ye=te.minimap.size,ze=te.minimap.side,Be=te.verticalScrollbarWidth,Ne=te.viewLineCount,Ge=te.remainingWidth,nt=te.isViewportWrapping,dt=Z?2:3;let it=Math.floor(Ue*He);const Je=it/Ue;let mt=!1,bt=!1,be=dt*ae,de=ae/Ue,oe=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Ye,desiredRatio:ot,minimapLineCount:ft}=ee.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:j,height:He,lineHeight:ie,pixelRatio:Ue});if(Ne/ft>1)mt=!0,bt=!0,ae=1,be=1,de=ae/Ue;else{let Et=!1,vt=ae+1;if(ye==="fit"){const Ct=Math.ceil((Ne+Ye)*be);nt&&W&&Ge<=ve.stableFitRemainingWidth?(Et=!0,vt=ve.stableFitMaxMinimapScale):(Et=Ct>it,nt&&Et?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Ge):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ye==="fill"||Et){mt=!0;const Ct=ae;be=Math.min(ie*Ue,Math.max(1,Math.floor(1/ot))),ae=Math.min(vt,Math.max(1,Math.floor(be/dt))),ae>Ct&&(oe=Math.min(2,ae/Ct)),de=ae/Ue/oe,it=Math.ceil(Math.max(ht,Ne+Ye)*be),nt&&Et&&(ve.stableFitMaxMinimapScale=ae)}}}const K=Math.floor(he*de),Re=Math.min(K,Math.max(0,Math.floor((Ge-Be-2)*de/(ce+de)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Ue*Re);const Qe=Ie/Ue;Ie=Math.floor(Ie*oe);const Ze=Z?1:2,ut=ze==="left"?0:Le-Re-Be;return{renderMinimap:Ze,minimapLeft:ut,minimapWidth:Re,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:ae,minimapLineHeight:be,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Je}}static computeLayout(te,ve){const Le=ve.outerWidth|0,He=ve.outerHeight|0,Ue=ve.lineHeight|0,Xe=ve.lineNumbersDigitCount|0,W=ve.typicalHalfwidthCharacterWidth,ie=ve.maxDigitWidth,ce=ve.pixelRatio,j=ve.viewLineCount,Z=te.get(118),ae=Z==="inherit"?te.get(117):Z,he=ae==="inherit"?te.get(113):ae,ye=te.get(116),ze=te.get(2),Be=ve.isDominatedByLongLines,Ne=te.get(46),Ge=te.get(56).renderType!==0,nt=te.get(57),dt=te.get(91),it=te.get(61),Je=te.get(89),mt=Je.verticalScrollbarSize,bt=Je.verticalHasArrows,be=Je.arrowSize,de=Je.horizontalScrollbarSize,oe=te.get(54),K=te.get(35);let Re;if(typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)){const _t=parseFloat(oe.substr(0,oe.length-2));Re=r.clampedInt(_t*W,0,0,1e3)}else Re=r.clampedInt(oe,0,0,1e3);K&&(Re+=16);let Ie=0;if(Ge){const _t=Math.max(Xe,nt);Ie=Math.round(_t*ie)}let Qe=0;Ne&&(Qe=Ue);let Ze=0,ut=Ze+Qe,ht=ut+Ie,Ye=ht+Re;const ot=Le-Qe-Ie-Re;let ft=!1,at=!1,Et=-1;ze!==2&&(ae==="inherit"&&Be?(ft=!0,at=!0):he==="on"||he==="bounded"?at=!0:he==="wordWrapColumn"&&(Et=ye));const vt=ee._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:Ue,typicalHalfwidthCharacterWidth:W,pixelRatio:ce,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:j,remainingWidth:ot,isViewportWrapping:at},ve.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Ye+=vt.minimapWidth);const Ct=ot-vt.minimapWidth,Pt=Math.max(1,Math.floor((Ct-mt-2)/W)),At=bt?be:0;return at&&(Et=Math.max(1,Pt),he==="bounded"&&(Et=Math.min(Et,ye))),{width:Le,height:He,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ut,lineNumbersWidth:Ie,decorationsLeft:ht,decorationsWidth:Re,contentLeft:Ye,contentWidth:Ct,minimap:vt,viewportColumn:Pt,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:de,overviewRuler:{top:At,width:mt,height:He-2*At,right:0}}}}e.EditorLayoutInfoComputer=ee;class $ extends k{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:w.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:d(te.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",te,{"editor.inlineHints.enabled":{type:"boolean",default:te.enabled,description:w.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:te.fontSize,description:w.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:te.fontFamily,description:w.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(te,ve,Le){return te.fontInfo.lineHeight}}class M extends k{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:te.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:w.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),size:m(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ve.side,this.defaultValue.side,["right","left"]),showSlider:m(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(H){return H==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class X extends k{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:w.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),cycle:d(ve.cycle,this.defaultValue.cycle)}}}class se extends i{constructor(){super(124)}compute(te,ve,Le){return te.pixelRatio}}class pe extends k{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:w.localize(58,null)},comments:{type:"boolean",default:te.comments,description:w.localize(59,null)},other:{type:"boolean",default:te.other,description:w.localize(60,null)}}}],default:te,description:w.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Le={other:d(ve.other,this.defaultValue.other),comments:d(ve.comments,this.defaultValue.comments),strings:d(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Te;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Le=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Ae(H){const te=H.get(84);return te==="editable"?H.get(77):te!=="on"}e.filterValidationDecorations=Ae;class We extends k{constructor(){const te=[],ve={type:"number",description:w.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:te,description:w.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Le of te)if(typeof Le=="number")ve.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;ve.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Le,He)=>Le.column-He.column),ve}return this.defaultValue}}function x(H,te){if(typeof H!="string")return te;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Le=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:x(ve.vertical,this.defaultValue.vertical),horizontal:x(ve.horizontal,this.defaultValue.horizontal),useShadows:d(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:d(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends k{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:te.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:m(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ve.showIcons,this.defaultValue.showIcons),showStatusBar:d(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ve.showMethods,this.defaultValue.showMethods),showFunctions:d(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ve.showConstructors,this.defaultValue.showConstructors),showFields:d(ve.showFields,this.defaultValue.showFields),showVariables:d(ve.showVariables,this.defaultValue.showVariables),showClasses:d(ve.showClasses,this.defaultValue.showClasses),showStructs:d(ve.showStructs,this.defaultValue.showStructs),showInterfaces:d(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ve.showModules,this.defaultValue.showModules),showProperties:d(ve.showProperties,this.defaultValue.showProperties),showEvents:d(ve.showEvents,this.defaultValue.showEvents),showOperators:d(ve.showOperators,this.defaultValue.showOperators),showUnits:d(ve.showUnits,this.defaultValue.showUnits),showValues:d(ve.showValues,this.defaultValue.showValues),showConstants:d(ve.showConstants,this.defaultValue.showConstants),showEnums:d(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ve.showKeywords,this.defaultValue.showKeywords),showWords:d(ve.showWords,this.defaultValue.showWords),showColors:d(ve.showColors,this.defaultValue.showColors),showFiles:d(ve.showFiles,this.defaultValue.showFiles),showReferences:d(ve.showReferences,this.defaultValue.showReferences),showFolders:d(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ve.showSnippets,this.defaultValue.showSnippets),showUsers:d(ve.showUsers,this.defaultValue.showUsers),showIssues:d(ve.showIssues,this.defaultValue.showIssues)}}}class le extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends i{constructor(){super(125,[77])}compute(te,ve,Le){return ve.get(77)?!0:te.tabFocusMode}}var Se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Oe(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends i{constructor(){super(127,[126])}compute(te,ve,Le){const He=ve.get(126);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Pe:I.isLinux?$e:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(H){return e.editorOptionsRegistry[H.id]=H,H}var je;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.letterSpacing=52]="letterSpacing",H[H.lightbulb=53]="lightbulb",H[H.lineDecorationsWidth=54]="lineDecorationsWidth",H[H.lineHeight=55]="lineHeight",H[H.lineNumbers=56]="lineNumbers",H[H.lineNumbersMinChars=57]="lineNumbersMinChars",H[H.linkedEditing=58]="linkedEditing",H[H.links=59]="links",H[H.matchBrackets=60]="matchBrackets",H[H.minimap=61]="minimap",H[H.mouseStyle=62]="mouseStyle",H[H.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=64]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",H[H.multiCursorModifier=66]="multiCursorModifier",H[H.multiCursorPaste=67]="multiCursorPaste",H[H.occurrencesHighlight=68]="occurrencesHighlight",H[H.overviewRulerBorder=69]="overviewRulerBorder",H[H.overviewRulerLanes=70]="overviewRulerLanes",H[H.padding=71]="padding",H[H.parameterHints=72]="parameterHints",H[H.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",H[H.quickSuggestions=75]="quickSuggestions",H[H.quickSuggestionsDelay=76]="quickSuggestionsDelay",H[H.readOnly=77]="readOnly",H[H.renameOnType=78]="renameOnType",H[H.renderControlCharacters=79]="renderControlCharacters",H[H.renderIndentGuides=80]="renderIndentGuides",H[H.renderFinalNewline=81]="renderFinalNewline",H[H.renderLineHighlight=82]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=84]="renderValidationDecorations",H[H.renderWhitespace=85]="renderWhitespace",H[H.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",H[H.roundedSelection=87]="roundedSelection",H[H.rulers=88]="rulers",H[H.scrollbar=89]="scrollbar",H[H.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=91]="scrollBeyondLastLine",H[H.scrollPredominantAxis=92]="scrollPredominantAxis",H[H.selectionClipboard=93]="selectionClipboard",H[H.selectionHighlight=94]="selectionHighlight",H[H.selectOnLineNumbers=95]="selectOnLineNumbers",H[H.showFoldingControls=96]="showFoldingControls",H[H.showUnused=97]="showUnused",H[H.snippetSuggestions=98]="snippetSuggestions",H[H.smartSelect=99]="smartSelect",H[H.smoothScrolling=100]="smoothScrolling",H[H.stickyTabStops=101]="stickyTabStops",H[H.stopRenderingLineAfter=102]="stopRenderingLineAfter",H[H.suggest=103]="suggest",H[H.suggestFontSize=104]="suggestFontSize",H[H.suggestLineHeight=105]="suggestLineHeight",H[H.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",H[H.suggestSelection=107]="suggestSelection",H[H.tabCompletion=108]="tabCompletion",H[H.tabIndex=109]="tabIndex",H[H.unusualLineTerminators=110]="unusualLineTerminators",H[H.useTabStops=111]="useTabStops",H[H.wordSeparators=112]="wordSeparators",H[H.wordWrap=113]="wordWrap",H[H.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=116]="wordWrapColumn",H[H.wordWrapOverride1=117]="wordWrapOverride1",H[H.wordWrapOverride2=118]="wordWrapOverride2",H[H.wrappingIndent=119]="wrappingIndent",H[H.wrappingStrategy=120]="wrappingStrategy",H[H.showDeprecated=121]="showDeprecated",H[H.inlineHints=122]="inlineHints",H[H.editorClassName=123]="editorClassName",H[H.pixelRatio=124]="pixelRatio",H[H.tabFocusMode=125]="tabFocusMode",H[H.layoutInfo=126]="layoutInfo",H[H.wrappingInfo=127]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:Ee(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:Ee(new v),accessibilityPageSize:Ee(new r(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null)})),ariaLabel:Ee(new g(4,"ariaLabel",w.localize(115,null))),autoClosingBrackets:Ee(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(116,null),w.localize(117,null),""],description:w.localize(118,null)})),autoClosingDelete:Ee(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(119,null),""],description:w.localize(120,null)})),autoClosingOvertype:Ee(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(121,null),""],description:w.localize(122,null)})),autoClosingQuotes:Ee(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(123,null),w.localize(124,null),""],description:w.localize(125,null)})),autoIndent:Ee(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[w.localize(126,null),w.localize(127,null),w.localize(128,null),w.localize(129,null),w.localize(130,null)],description:w.localize(131,null)})),automaticLayout:Ee(new h(10,"automaticLayout",!1)),autoSurround:Ee(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null),""],description:w.localize(135,null)})),stickyTabStops:Ee(new h(101,"stickyTabStops",!1,{description:w.localize(136,null)})),codeLens:Ee(new h(12,"codeLens",!0,{description:w.localize(137,null)})),codeLensFontFamily:Ee(new g(13,"codeLensFontFamily","",{description:w.localize(138,null)})),codeLensFontSize:Ee(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(139,null)})),colorDecorators:Ee(new h(15,"colorDecorators",!0,{description:w.localize(140,null)})),columnSelection:Ee(new h(16,"columnSelection",!1,{description:w.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new h(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(142,null)})),cursorBlinking:Ee(new f(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:w.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new h(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(144,null)})),cursorStyle:Ee(new f(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:w.localize(145,null)})),cursorSurroundingLines:Ee(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(147,null),w.localize(148,null)],description:w.localize(149,null)})),cursorWidth:Ee(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(150,null)})),disableLayerHinting:Ee(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new h(28,"domReadOnly",!1)),dragAndDrop:Ee(new h(29,"dragAndDrop",!0,{description:w.localize(151,null)})),emptySelectionClipboard:Ee(new _),extraEditorClassName:Ee(new g(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new a(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:w.localize(152,null)})),find:Ee(new p),fixedOverflowWidgets:Ee(new h(34,"fixedOverflowWidgets",!1)),folding:Ee(new h(35,"folding",!0,{description:w.localize(153,null)})),foldingStrategy:Ee(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(154,null),w.localize(155,null)],description:w.localize(156,null)})),foldingHighlight:Ee(new h(37,"foldingHighlight",!0,{description:w.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(158,null)})),fontFamily:Ee(new g(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(159,null)})),fontInfo:Ee(new F),fontLigatures2:Ee(new E),fontSize:Ee(new B),fontWeight:Ee(new Y),formatOnPaste:Ee(new h(44,"formatOnPaste",!1,{description:w.localize(160,null)})),formatOnType:Ee(new h(45,"formatOnType",!1,{description:w.localize(161,null)})),glyphMargin:Ee(new h(46,"glyphMargin",!0,{description:w.localize(162,null)})),gotoLocation:Ee(new fe),hideCursorInOverviewRuler:Ee(new h(48,"hideCursorInOverviewRuler",!1,{description:w.localize(163,null)})),highlightActiveIndentGuide:Ee(new h(49,"highlightActiveIndentGuide",!0,{description:w.localize(164,null)})),hover:Ee(new V),inDiffEditor:Ee(new h(51,"inDiffEditor",!1)),letterSpacing:Ee(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>a.clamp(H,-5,20),{description:w.localize(165,null)})),lightbulb:Ee(new $),lineDecorationsWidth:Ee(new P(54,"lineDecorationsWidth",10)),lineHeight:Ee(new L),lineNumbers:Ee(new xe),lineNumbersMinChars:Ee(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new h(58,"linkedEditing",!1,{description:w.localize(166,null)})),links:Ee(new h(59,"links",!0,{description:w.localize(167,null)})),matchBrackets:Ee(new S(60,"matchBrackets","always",["always","near","never"],{description:w.localize(168,null)})),minimap:Ee(new M),mouseStyle:Ee(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new a(63,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:w.localize(169,null)})),mouseWheelZoom:Ee(new h(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(170,null)})),multiCursorMergeOverlapping:Ee(new h(65,"multiCursorMergeOverlapping",!0,{description:w.localize(171,null)})),multiCursorModifier:Ee(new f(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[w.localize(172,null),w.localize(173,null)],markdownDescription:w.localize(174,null)})),multiCursorPaste:Ee(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(175,null),w.localize(176,null)],markdownDescription:w.localize(177,null)})),occurrencesHighlight:Ee(new h(68,"occurrencesHighlight",!0,{description:w.localize(178,null)})),overviewRulerBorder:Ee(new h(69,"overviewRulerBorder",!0,{description:w.localize(179,null)})),overviewRulerLanes:Ee(new r(70,"overviewRulerLanes",3,0,3)),padding:Ee(new G),parameterHints:Ee(new X),peekWidgetDefaultFocus:Ee(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(180,null),w.localize(181,null)],description:w.localize(182,null)})),definitionLinkOpensInPeek:Ee(new h(74,"definitionLinkOpensInPeek",!1,{description:w.localize(183,null)})),quickSuggestions:Ee(new pe),quickSuggestionsDelay:Ee(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(184,null)})),readOnly:Ee(new h(77,"readOnly",!1)),renameOnType:Ee(new h(78,"renameOnType",!1,{description:w.localize(185,null),markdownDeprecationMessage:w.localize(186,null)})),renderControlCharacters:Ee(new h(79,"renderControlCharacters",!1,{description:w.localize(187,null)})),renderIndentGuides:Ee(new h(80,"renderIndentGuides",!0,{description:w.localize(188,null)})),renderFinalNewline:Ee(new h(81,"renderFinalNewline",!0,{description:w.localize(189,null)})),renderLineHighlight:Ee(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(190,null)],description:w.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(192,null)})),renderValidationDecorations:Ee(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(193,null),w.localize(194,null),w.localize(195,null),""],description:w.localize(196,null)})),revealHorizontalRightPadding:Ee(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new h(87,"roundedSelection",!0,{description:w.localize(197,null)})),rulers:Ee(new We),scrollbar:Ee(new q),scrollBeyondLastColumn:Ee(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(198,null)})),scrollBeyondLastLine:Ee(new h(91,"scrollBeyondLastLine",!0,{description:w.localize(199,null)})),scrollPredominantAxis:Ee(new h(92,"scrollPredominantAxis",!0,{description:w.localize(200,null)})),selectionClipboard:Ee(new h(93,"selectionClipboard",!0,{description:w.localize(201,null),included:I.isLinux})),selectionHighlight:Ee(new h(94,"selectionHighlight",!0,{description:w.localize(202,null)})),selectOnLineNumbers:Ee(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(203,null),w.localize(204,null)],description:w.localize(205,null)})),showUnused:Ee(new h(97,"showUnused",!0,{description:w.localize(206,null)})),showDeprecated:Ee(new h(121,"showDeprecated",!0,{description:w.localize(207,null)})),inlineHints:Ee(new R),snippetSuggestions:Ee(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(208,null),w.localize(209,null),w.localize(210,null),w.localize(211,null)],description:w.localize(212,null)})),smartSelect:Ee(new le),smoothScrolling:Ee(new h(100,"smoothScrolling",!1,{description:w.localize(213,null)})),stopRenderingLineAfter:Ee(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ne),suggestFontSize:Ee(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(214,null)})),suggestLineHeight:Ee(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(215,null)})),suggestOnTriggerCharacters:Ee(new h(106,"suggestOnTriggerCharacters",!0,{description:w.localize(216,null)})),suggestSelection:Ee(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(217,null),w.localize(218,null),w.localize(219,null)],description:w.localize(220,null)})),tabCompletion:Ee(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null)],description:w.localize(224,null)})),tabIndex:Ee(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(225,null),w.localize(226,null),w.localize(227,null)],description:w.localize(228,null)})),useTabStops:Ee(new h(111,"useTabStops",!0,{description:w.localize(229,null)})),wordSeparators:Ee(new g(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:w.localize(230,null)})),wordWrap:Ee(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(231,null),w.localize(232,null),w.localize(233,null),w.localize(234,null)],description:w.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new g(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new g(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(236,null)})),wordWrapOverride1:Ee(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new f(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[w.localize(237,null),w.localize(238,null),w.localize(239,null),w.localize(240,null)],description:w.localize(241,null)})),wrappingStrategy:Ee(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(242,null),w.localize(243,null)],description:w.localize(244,null)})),editorClassName:Ee(new b),pixelRatio:Ee(new se),tabFocusMode:Ee(new me),layoutInfo:Ee(new ee),wrappingInfo:Ee(new ge)}}),define(we[124],_e([16,17]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[125],_e([16,17]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[126],_e([16,17]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(we[127],_e([16,17]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(we[128],_e([16,17]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(we[129],_e([16,17]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(we[130],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[131],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[132],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(we[133],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[134],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(we[135],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[136],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[137],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[138],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[139],_e([16,17]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(we[140],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[141],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[142],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[143],_e([16,17]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[144],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[145],_e([0,1,125]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(P){return P=P.trim(),P==="*"||I.test(P)}e.isValidVersionStr=A;function T(P){if(!A(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=P.match(I);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function y(P){if(!P)return null;let d=P.majorBase,h=P.majorMustEqual,r=P.minorBase,a=P.minorMustEqual,g=P.patchBase,m=P.patchMustEqual;return P.hasCaret&&(d===0||(a=!1),m=!1),{majorBase:d,majorMustEqual:h,minorBase:r,minorMustEqual:a,patchBase:g,patchMustEqual:m,isMinimum:P.hasGreaterEquals}}e.normalizeVersion=y;function C(P,d){let h;typeof P=="string"?h=y(T(P)):h=P;let r;if(typeof d=="string"?r=y(T(d)):r=d,!h||!r)return!1;let a=h.majorBase,g=h.minorBase,m=h.patchBase,S=r.majorBase,f=r.minorBase,l=r.patchBase,v=r.majorMustEqual,t=r.minorMustEqual,n=r.patchMustEqual;return r.isMinimum?a>S?!0:a<S?!1:g>f?!0:g<f?!1:m>=l:(a===1&&S===0&&(!v||!t||!n)&&(S=1,f=0,l=0,v=!0,t=!1,n=!1),a<S?!1:a>S?!v:g<f?!1:g>f?!t:m<l?!1:m>l?!n:!0)}e.isValidVersion=C;function D(P,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:i(P,d.engines.vscode,h)}e.isValidExtensionVersion=D;function k(P,d){return P==="*"||i(d,P)}e.isEngineValid=k;function i(P,d,h=[]){let r=y(T(d));if(!r)return h.push(w.localize(0,null,d)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return h.push(w.localize(1,null,d)),!1}else if(!r.majorMustEqual)return h.push(w.localize(2,null,d)),!1;return C(P,r)?!0:(h.push(w.localize(3,null,P,d)),!1)}e.isVersionValid=i}),define(we[89],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(T,y=[],C=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=w;const I=(A,...T)=>new w(A,T);e.createSyncDescriptor=I}),define(we[61],_e([0,1,89]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function A(y,C,D){C instanceof w.SyncDescriptor||(C=new w.SyncDescriptor(C,[],D)),I.push([y,C])}e.registerSingleton=A;function T(){return I}e.getSingletonServiceDescriptors=T}),define(we[146],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=w;class I{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const C=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),C)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let C=this._nodes.get(y);return C||(C=new w(T),this._nodes.set(y,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,C]of this._nodes)T.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const C=new Set([T]),D=this._findCycle(y,C);if(D)return D}}_findCycle(T,y){for(let[C,D]of T.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(D,y);if(k)return k;y.delete(C)}}}e.Graph=I}),define(we[4],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(w=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function I(C,D,k,i){D[w.DI_TARGET]===D?D[w.DI_DEPENDENCIES].push({id:C,index:k,optional:i}):(D[w.DI_DEPENDENCIES]=[{id:C,index:k,optional:i}],D[w.DI_TARGET]=D)}function A(C){if(w.serviceIds.has(C))return w.serviceIds.get(C);const D=function(k,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,k,P,!1)};return D.toString=()=>C,w.serviceIds.set(C,D),D}e.createDecorator=A;function T(C){return C}e.refineServiceDecorator=T;function y(C){return function(D,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(C,D,i,!0)}}e.optional=y}),define(we[147],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function I(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(we[148],_e([0,1,3,56,6,22,81,59,147]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(h,r){let a={selector:h,provider:r,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(a){let g=this._entries.indexOf(a);g>=0&&(this._entries.splice(g,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const r=[];for(let a of this._entries)a._score>0&&r.push(a.provider);return r}ordered(h){const r=[];return this._orderedForEach(h,a=>r.push(a.provider)),r}orderedGroups(h){const r=[];let a,g;return this._orderedForEach(h,m=>{a&&g===m._score?a.push(m.provider):(g=m._score,a=[m.provider],r.push(a))}),r}_orderedForEach(h,r){if(!!h){this._updateScores(h);for(const a of this._entries)a._score>0&&r(a)}}_updateScores(h){let r={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let a of this._entries)if(a._score=(0,C.score)(a.selector,h.uri,h.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(h)),k(a.selector)&&a._score>0){for(let g of this._entries)g._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(h,r){return h._score<r._score?1:h._score>r._score?-1:h._time<r._time?1:h._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(h,r,a=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=r,this.max=a,this._cache=new T.LRUCache(50,.7)}_key(h){return h.id+(0,I.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const r=this._key(h),a=this._cache.get(r);return this._clamp(a==null?void 0:a.value)}update(h,r){const a=this._key(h);let g=this._cache.get(a);return g||(g=new y.MovingAverage,this._cache.set(a,g)),g.update(r),this.get(h)}}e.LanguageFeatureRequestDelays=P}),define(we[62],_e([0,1,2,32,148,119,36]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(E,F){this.language=E,this.id=F}}e.LanguageIdentifier=D;var k;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let F=this.getForeground(E),B="mtk"+F,Y=this.getFontStyle(E);return Y&1&&(B+=" mtki"),Y&2&&(B+=" mtkb"),Y&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(E,F){const B=this.getForeground(E),Y=this.getFontStyle(E);let fe=`color: ${F[B]};`;return Y&1&&(fe+="font-style: italic;"),Y&2&&(fe+="font-weight: bold;"),Y&4&&(fe+="text-decoration: underline;"),fe}}e.TokenMetadata=h;var r;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(E){const F=p[E];let B=F&&y.iconRegistry.get(F);return B||(console.info("No codicon found for CompletionItemKind "+E),B=y.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(E,F){let B=p[E];return typeof B=="undefined"&&!F&&(B=9),B}}();var a;(function(p){p[p.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(p){return p&&w.URI.isUri(p.uri)&&I.Range.isIRange(p.range)&&(I.Range.isIRange(p.originSelectionRange)||I.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=v;var t;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(p){p[p.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var u;(function(p){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function B(V){return E.get(V)}p.fromString=B;function Y(V){return F.get(V)}p.toString=Y;function fe(V,z){const ee=F.get(V);let $=ee&&y.iconRegistry.get("symbol-"+ee);return $||(console.info("No codicon found for SymbolKind "+V),$=y.Codicon.symbolProperty),`${z?"inline":"block"} ${$.classNames}`}p.toCssClassName=fe})(u=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(E){this.value=E}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var s;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var b;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(b=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var _;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[149],_e([0,1,6,10,4,3,45,43]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const r=[];for(let g of D.description.args)r.push(g.constraint);const a=D.handler;D.handler=function(g,...m){return(0,I.validateConstraints)(m,r),a(g,...m)}}const{id:i}=D;let P=this._commands.get(i);P||(P=new y.LinkedList,this._commands.set(i,P));let d=P.unshift(D),h=(0,w.toDisposable)(()=>{d();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),h}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(i,...P)=>i.get(e.ICommandService).executeCommand(k,...P))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&D.set(k,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(we[63],_e([0,1,8,4,21]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0),y.set("isIPad",T.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(E){return h.create(E)}static equals(E,F){return r.create(E,F)}static notEquals(E,F){return m.create(E,F)}static regex(E,F){return n.create(E,F)}static in(E,F){return a.create(E,F)}static not(E){return S.create(E)}static and(...E){return o.create(E)}static or(...E){return s.create(E)}static greater(E,F){return f.create(E,F)}static less(E,F){return v.create(E,F)}static deserialize(E,F=!1){if(!!E)return this._deserializeOrExpression(E,F)}static _deserializeOrExpression(E,F){let B=E.split("||");return s.create(B.map(Y=>this._deserializeAndExpression(Y,F)))}static _deserializeAndExpression(E,F){let B=E.split("&&");return o.create(B.map(Y=>this._deserializeOne(Y,F)))}static _deserializeOne(E,F){if(E=E.trim(),E.indexOf("!=")>=0){let B=E.split("!=");return m.create(B[0].trim(),this._deserializeValue(B[1],F))}if(E.indexOf("==")>=0){let B=E.split("==");return r.create(B[0].trim(),this._deserializeValue(B[1],F))}if(E.indexOf("=~")>=0){let B=E.split("=~");return n.create(B[0].trim(),this._deserializeRegexValue(B[1],F))}if(E.indexOf(" in ")>=0){let B=E.split(" in ");return a.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const B=E.split(">=");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const B=E.split(">");return f.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const B=E.split("<=");return t.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const B=E.split("<");return v.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(E)?S.create(E.substr(1).trim()):h.create(E)}static _deserializeValue(E,F){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let B=/^'([^']*)'$/.exec(E);return B?B[1].trim():E}static _deserializeRegexValue(E,F){if((0,w.isFalsyOrWhitespace)(E)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=E.indexOf("/"),Y=E.lastIndexOf("/");if(B===Y||B<0){if(F)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let fe=E.slice(B+1,Y),V=E[Y+1]==="i"?"i":"";try{return new RegExp(fe,V)}catch(z){if(F)throw new Error(`bad regexp-value '${E}', parse error: ${z}`);return console.warn(`bad regexp-value '${E}', parse error: ${z}`),null}}}e.ContextKeyExpr=k;function i(p,E){return p.cmp(E)}class P{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class h{constructor(E){this.key=E,this.type=2}static create(E){const F=y.get(E);return typeof F=="boolean"?F?d.INSTANCE:P.INSTANCE:new h(E)}cmp(E){return E.type!==this.type?this.type-E.type:b(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=h;class r{constructor(E,F){this.key=E,this.value=F,this.type=4}static create(E,F){if(typeof F=="boolean")return F?h.create(E):S.create(E);const B=y.get(E);return typeof B=="boolean"?F===(B?"true":"false")?d.INSTANCE:P.INSTANCE:new r(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class a{constructor(E,F){this.key=E,this.valueKey=F,this.type=10}static create(E,F){return new a(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}evaluate(E){const F=E.getValue(this.valueKey),B=E.getValue(this.key);return Array.isArray(F)?F.indexOf(B)>=0:typeof B=="string"&&typeof F=="object"&&F!==null?C.call(F,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}e.ContextKeyInExpr=a;class g{constructor(E){this._actual=E,this.type=11}static create(E){return new g(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new g(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class m{constructor(E,F){this.key=E,this.value=F,this.type=5}static create(E,F){if(typeof F=="boolean")return F?S.create(E):h.create(E);const B=y.get(E);return typeof B=="boolean"?F===(B?"true":"false")?P.INSTANCE:d.INSTANCE:new m(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class S{constructor(E){this.key=E,this.type=3}static create(E){const F=y.get(E);return typeof F=="boolean"?F?P.INSTANCE:d.INSTANCE:new S(E)}cmp(E){return E.type!==this.type?this.type-E.type:b(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=S;class f{constructor(E,F){this.key=E,this.value=F,this.type=12}static create(E,F){return new f(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class l{constructor(E,F){this.key=E,this.value=F,this.type=13}static create(E,F){return new l(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class v{constructor(E,F){this.key=E,this.value=F,this.type=14}static create(E,F){return new v(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(E,F){this.key=E,this.value=F,this.type=15}static create(E,F){return new t(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(E,F){this.key=E,this.regexp=F,this.type=7}static create(E,F){return new n(E,F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const F=this.regexp?this.regexp.source:"",B=E.regexp?E.regexp.source:"";return F<B?-1:F>B?1:0}equals(E){if(E.type===this.type){const F=this.regexp?this.regexp.source:"",B=E.regexp?E.regexp.source:"";return this.key===E.key&&F===B}return!1}evaluate(E){let F=E.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=n;class u{constructor(E){this._actual=E,this.type=8}static create(E){return new u(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new u(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class o{constructor(E){this.expr=E,this.type=6}static create(E){return o._normalizeArr(E)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Y=i(this.expr[F],E.expr[F]);if(Y!==0)return Y}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static _normalizeArr(E){const F=[];let B=!1;for(const Y of E)if(!!Y){if(Y.type===1){B=!0;continue}if(Y.type===0)return P.INSTANCE;if(Y.type===6){F.push(...Y.expr);continue}F.push(Y)}if(F.length===0&&B)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const Y=F[F.length-1];if(Y.type!==9)break;F.pop();const fe=F.pop(),V=s.create(Y.expr.map(z=>o.create([z,fe])));V&&(F.push(V),F.sort(i))}return F.length===1?F[0]:new o(F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new o(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let F of this.expr)E.push(F.negate());return s.create(E)}}e.ContextKeyAndExpr=o;class s{constructor(E){this.expr=E,this.type=9}static create(E){const F=s._normalizeArr(E);if(F.length!==0)return F.length===1?F[0]:new s(F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Y=i(this.expr[F],E.expr[F]);if(Y!==0)return Y}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(E))return!0;return!1}static _normalizeArr(E){let F=[],B=!1;if(E){for(let Y=0,fe=E.length;Y<fe;Y++){const V=E[Y];if(!!V){if(V.type===0){B=!0;continue}if(V.type===1)return[d.INSTANCE];if(V.type===9){F=F.concat(V.expr);continue}F.push(V)}}if(F.length===0&&B)return[P.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new s(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let B of this.expr)E.push(B.negate());const F=B=>B.type===9?B.expr:[B];for(;E.length>1;){const B=E.shift(),Y=E.shift(),fe=[];for(const V of F(B))for(const z of F(Y))fe.push(k.and(V,z));E.unshift(k.or(...fe))}return E[0]}}e.ContextKeyOrExpr=s;class c extends h{constructor(E,F,B){super(E);this._defaultValue=F,typeof B=="object"?c._info.push(Object.assign(Object.assign({},B),{key:E})):B!==!0&&c._info.push({key:E,description:B,type:F!=null?typeof F:void 0})}static all(){return c._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(E){return k.equals(this.key,E)}notEqualsTo(E){return k.notEquals(this.key,E)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(p,E){return p<E?-1:p>E?1:0}function _(p,E,F,B){return p<F?-1:p>F?1:E<B?-1:E>B?1:0}}),define(we[150],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(we[26],_e([0,1,8,4]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,P){if(typeof i=="undefined"||i===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof i=="string"||typeof P=="string"){let d=typeof i=="string"?i:i.value,h=typeof P=="string"?P:P.value;return w.equalsIgnoreCase(d,h)}return i._lower===P._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[151],_e([0,1,8,26]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,w.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=A;class T{constructor(r,a){this.version=a,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?A(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(h,r){return`${h}.${r}`}e.getExtensionId=y;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(h,r){return C(y(h,r))}e.getGalleryExtensionId=D;function k(h,r){const a=[],g=m=>{for(const S of a)if(S.some(f=>A(r(f),r(m))))return S;return null};for(const m of h){const S=g(m);S?S.push(m):a.push([m])}return a}e.groupByExtension=k;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(h){const r=new Set;for(const a of h)a.malicious&&r.add(a.id.id);return r}e.getMaliciousExtensionsSet=d}),define(we[64],_e([0,1,126,13,2,4,8,10,22]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function h(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=h;function r(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function a(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=a;var g;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(z,ee){super(z);this.code=ee}}e.FileSystemProviderError=m;function S(V,z){const ee=new m(V.toString(),z);return l(ee,z),ee}e.createFileSystemProviderError=S;function f(V){return V||S((0,w.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=f;function l(V,z){return V.name=z?`${z} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function v(V){if(!V)return g.Unknown;if(V instanceof m)return V.code;const z=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!z)return g.Unknown;switch(z[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=v;function t(V){if(V instanceof b)return V.fileOperationResult;switch(v(V)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class u{constructor(z,ee,$){this.resource=z,this.operation=ee,this.target=$}isOperation(z){return this.operation===z}}e.FileOperationEvent=u;var o;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class s{constructor(z,ee){this.ignorePathCasing=ee,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const $ of z)switch($.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(z,...ee){return this.doContains(z,{includeChildren:!1},...ee)}affects(z,...ee){return this.doContains(z,{includeChildren:!0},...ee)}doContains(z,ee,...$){var R,L,M,U,G,X;if(!z)return!1;const se=$.length>0;return!!((!se||$.includes(1))&&(((R=this.added)===null||R===void 0?void 0:R.get(z))||ee.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(z)))||(!se||$.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(z))||ee.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(z)))||(!se||$.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(z))||ee.includeChildren&&((X=this.deleted)===null||X===void 0?void 0:X.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const ee=[],$=z===1?this.added:z===0?this.updated:this.deleted;if($)for(const[,R]of $)ee.push(R);return ee}filter(z){return new s(this.changes.filter(ee=>z(ee)),this.ignorePathCasing)}}e.FileChangesEvent=s;function c(V,z,ee){return!V||!z||V===z||z.length>V.length?!1:(z.charAt(z.length-1)!==I.sep&&(z+=I.sep),ee?(0,y.startsWithIgnoreCase)(V,z):V.indexOf(z)===0)}e.isParent=c;class b extends Error{constructor(z,ee,$){super(z);this.fileOperationResult=ee,this.options=$}static isFileOperationError(z){return z instanceof Error&&!(0,C.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=b;var _;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=E;async function F(V,z){if(!z.canHandleResource(A.URI.from({scheme:V.scheme})))return new Promise(ee=>{const $=z.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===V.scheme&&R.added&&($.dispose(),ee())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<B.KB?(0,w.localize)(1,null,z.toFixed(0)):z<B.MB?(0,w.localize)(2,null,(z/B.KB).toFixed(2)):z<B.GB?(0,w.localize)(3,null,(z/B.MB).toFixed(2)):z<B.TB?(0,w.localize)(4,null,(z/B.GB).toFixed(2)):(0,w.localize)(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function fe(V){return{maxFileSize:V===0?300*B.MB:16*B.GB,maxHeapSize:V===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=fe}),define(we[65],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=w}),define(we[152],_e([0,1,12,146,89,4,65,11]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(r){var a;super("cyclic dependency between services");this.message=(a=r.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new y.ServiceCollection,a=!1,g){this._activeInstantiations=new Set,this._services=r,this._strict=a,this._parent=g,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...a){let g=d.traceInvocation(r),m=!1;try{return r({get:(f,l)=>{if(m)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(f,g);if(!v&&l!==T.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return v}},...a)}finally{m=!0,g.stop()}}createInstance(r,...a){let g,m;return r instanceof A.SyncDescriptor?(g=d.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(a),g)):(g=d.traceCreation(r),m=this._createInstance(r,a,g)),g.stop(),m}_createInstance(r,a=[],g){let m=T._util.getServiceDependencies(r).sort((l,v)=>l.index-v.index),S=[];for(const l of m){let v=this._getOrCreateServiceInstance(l.id,g);if(!v&&this._strict&&!l.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${l.id}.`);S.push(v)}let f=m.length>0?m[0].index:a.length;if(a.length!==f){console.warn(`[createInstance] First service dependency of ${r.name} at position ${f+1} conflicts with ${a.length} static arguments`);let l=f-a.length;l>0?a=a.concat(new Array(l)):a=a.slice(0,f)}return new r(...[...a,...S])}_setServiceInstance(r,a){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,a);else if(this._parent)this._parent._setServiceInstance(r,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let a=this._services.get(r);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):a}_getOrCreateServiceInstance(r,a){let g=this._getServiceInstanceOrDescriptor(r);return g instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,g,a.branch(r,!0)):(a.branch(r,!1),g)}_safeCreateAndCacheServiceInstance(r,a,g){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,a,g)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,a,g){const m=new I.Graph(l=>l.id.toString());let S=0;const f=[{id:r,desc:a,_trace:g}];for(;f.length;){const l=f.pop();if(m.lookupOrInsertNode(l),S++>1e3)throw new k(m);for(let v of T._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${r} depends on ${v.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:v.id,desc:t,_trace:l._trace.branch(v.id,!0)};m.insertEdge(l,n),f.push(n)}}}for(;;){const l=m.roots();if(l.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:v}of l){if(this._getServiceInstanceOrDescriptor(v.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,n)}m.removeNode(v)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,a,g=[],m,S){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(a,g,m,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,a,g,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(r,a=[],g,m){if(g){const S=new C.IdleValue(()=>this._createInstance(r,a,m));return new Proxy(Object.create(null),{get(f,l){if(l in f)return f[l];let v=S.value,t=v[l];return typeof t!="function"||(t=t.bind(v),f[l]=t),t},set(f,l,v){return S.value[l]=v,!0}})}else return this._createInstance(r,a,m)}}e.InstantiationService=i;var P;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(P||(P={}));class d{constructor(r,a){this.type=r,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return D?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return D?new d(0,r.name):d._None}branch(r,a){let g=new d(2,r.toString());return this._dep.push([r,a,g]),g}stop(){let r=Date.now()-this._start;d._totals+=r;let a=!1;function g(S,f){let l=[],v=new Array(S+1).join("	");for(const[t,n,u]of f._dep)if(n&&u){a=!0,l.push(`${v}CREATES -> ${t}`);let o=g(S+1,u);o&&l.push(o)}else l.push(`${v}uses -> ${t}`);return l.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||a)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(we[18],_e([0,1,4,6,21,3,60]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=t.stack,this.log(D.Error,this.format(u))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let u=0;u<t.length;u++){let o=t[u];if(typeof o=="object")try{o=JSON.stringify(o)}catch(s){}n+=(u>0?" ":"")+o}return n}}e.AbstractMessageLogger=i;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const u of this.logServices)u.trace(t,...n)}debug(t,...n){for(const u of this.logServices)u.debug(t,...n)}info(t,...n){for(const u of this.logServices)u.info(t,...n)}warn(t,...n){for(const u of this.logServices)u.warn(t,...n)}error(t,...n){for(const u of this.logServices)u.error(t,...n)}critical(t,...n){for(const u of this.logServices)u.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class a extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class g extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(u))}))}createLogger(t,n){let u=this.loggers.get(t.toString());return u||(u=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),u),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function S(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=f(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function f(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=f;function l(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(we[90],_e([0,1,4,127,47]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(r,a){return a-r}D.compare=k;const i=Object.create(null);i[D.Error]=(0,I.localize)(0,null),i[D.Warning]=(0,I.localize)(1,null),i[D.Info]=(0,I.localize)(2,null);function P(r){return i[r]||""}D.toString=P;function d(r){switch(r){case A.default.Error:return D.Error;case A.default.Warning:return D.Warning;case A.default.Info:return D.Info;case A.default.Ignore:return D.Hint}}D.fromSeverity=d;function h(r){switch(r){case D.Error:return A.default.Error;case D.Warning:return A.default.Warning;case D.Info:return A.default.Info;case D.Hint:return A.default.Ignore}}D.toSeverity=h}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const k="";function i(d){return P(d,!0)}D.makeKey=i;function P(d,h){let r=[k];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(k),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(k),d.severity!==void 0&&d.severity!==null?r.push(y.toString(d.severity)):r.push(k),d.message&&h?r.push(d.message.replace("\xA6","\\\xA6")):r.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(k),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(k),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}D.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[153],_e([0,1,47,4,3]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D});var Ve=this&&this.__decorate||function(Q,e,w,I){var A=arguments.length,T=A<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,w):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,w,I);else for(var C=Q.length-1;C>=0;C--)(y=Q[C])&&(T=(A<3?y(T):A>3?y(e,w,T):y(e,w))||T);return A>3&&T&&Object.defineProperty(e,w,T),T},qe=this&&this.__param||function(Q,e){return function(w,I){e(w,I,Q)}};define(we[154],_e([0,1,4,20,6,11]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends A.Disposable{constructor(P,d){super();this.deferred=new T.DeferredPromise,d.withProgress(P,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=Ve([qe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends A.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,h=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:h.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(we[29],_e([0,1,10,42]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,C){I.ok(w.isString(y)),I.ok(w.isObject(C)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(we[91],_e([0,1,29,3]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[A(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;w.Registry.add(e.Extensions.JSONContribution,y)}),define(we[66],_e([0,1,124,3,29,10,91]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=A.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,S=!0){this.registerConfigurations([m],S)}registerConfigurations(m,S=!0){const f=[];m.forEach(l=>{f.push(...this.validateAndRegisterProperties(l,S,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(m){const S=[],f=l=>{if(l.properties)for(const v in l.properties)S.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,l.properties[v]);l.allOf&&l.allOf.forEach(v=>f(v))};for(const l of m){f(l);const v=this.configurationContributors.indexOf(l);v!==-1&&this.configurationContributors.splice(v,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(m){const S=[],f=[];for(const l of m)for(const v in l)if(S.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]=Object.assign(Object.assign({},this.defaultValues[v]||{}),l[v]);const t={type:"object",default:this.defaultValues[v],description:w.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};f.push(P(v)),this.configurationProperties[v]=t,this.defaultLanguageConfigurationOverridesNode.properties[v]=t}else{this.defaultValues[v]=l[v];const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(m){const S=[];for(const f of m)for(const l in f)if(S.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const v=this.configurationProperties[l];v&&(this.updatePropertyDefaultValue(l,v),this.updateSchema(l,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const S of m)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,S=!0,f,l=3){var v;l=T.isUndefinedOrNull(m.scope)?l:m.scope;let t=[],n=m.properties;if(n)for(let o in n){if(S&&r(o)){delete n[o];continue}const s=n[o];if(this.updatePropertyDefaultValue(o,s),e.OVERRIDE_PROPERTY_PATTERN.test(o)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?l:s.scope,s.requireTrust=T.isUndefinedOrNull(s.requireTrust)?!!((v=f==null?void 0:f.requireTrustForConfigurations)===null||v===void 0?void 0:v.includes(o)):s.requireTrust),n[o].hasOwnProperty("included")&&!n[o].included){this.excludedConfigurationProperties[o]=n[o],delete n[o];continue}else this.configurationProperties[o]=n[o];!n[o].deprecationMessage&&n[o].markdownDeprecationMessage&&(n[o].deprecationMessage=n[o].markdownDeprecationMessage),t.push(o)}let u=m.allOf;if(u)for(let o of u)t.push(...this.validateAndRegisterProperties(o,S,f,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const S=f=>{let l=f.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let v=f.allOf;v&&v.forEach(S)};S(m)}updateSchema(m,S){switch(e.allSettings.properties[m]=S,S.scope){case 1:e.applicationSettings.properties[m]=S;break;case 2:e.machineSettings.properties[m]=S;break;case 6:e.machineOverridableSettings.properties[m]=S;break;case 3:e.windowSettings.properties[m]=S;break;case 4:e.resourceSettings.properties[m]=S;break;case 5:e.resourceSettings.properties[m]=S,this.resourceLanguageSettingsSchema.properties[m]=S;break}}removeFromSchema(m,S){switch(delete e.allSettings.properties[m],S.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const S=`[${m}]`,f={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,f),e.allSettings.properties[S]=f,e.applicationSettings.properties[S]=f,e.machineSettings.properties[S]=f,e.machineOverridableSettings.properties[S]=f,e.windowSettings.properties[S]=f,e.resourceSettings.properties[S]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,S){let f=this.defaultValues[m];T.isUndefined(f)&&(f=S.default),T.isUndefined(f)&&(f=d(S.type)),S.default=f}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=P;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new k;A.Registry.add(e.Extensions.Configuration,h);function r(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?w.localize(5,null,g):h.getConfigurationProperties()[g]!==void 0?w.localize(6,null,g):null:w.localize(4,null)}e.validateProperty=r;function a(){const g=[],m=h.getConfigurationProperties();for(const S of Object.keys(m))g.push([S,m[S].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=a}),define(we[92],_e([0,1,24,10,2,29,4,66]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,u){const o=u?n?u.keys.filter(F=>n.keys.indexOf(F)===-1):[...u.keys]:[],s=n?u?n.keys.filter(F=>u.keys.indexOf(F)===-1):[...n.keys]:[],c=[];if(u&&n){for(const F of n.keys)if(u.keys.indexOf(F)!==-1){const B=m(n.contents,F),Y=m(u.contents,F);w.equals(B,Y)||c.push(F)}}const b=[],_=F=>{const B={};for(const Y of F)for(const fe of Y.identifiers)B[v(fe)]=Y;return B},p=u?_(u.overrides):{},E=n?_(n.overrides):{};if(Object.keys(p).length)for(const F of o){const B=p[F];B&&b.push([(0,C.overrideIdentifierFromKey)(F),B.keys])}if(Object.keys(E).length)for(const F of s){const B=E[F];B&&b.push([(0,C.overrideIdentifierFromKey)(F),B.keys])}if(Object.keys(p).length&&Object.keys(E).length)for(const F of c){const B=E[F],Y=p[F];if(B&&Y){const fe=P({contents:B.contents,keys:B.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});b.push([(0,C.overrideIdentifierFromKey)(F),[...fe.added,...fe.removed,...fe.updated]])}}return{added:o,removed:s,updated:c,overrides:b}}e.compare=P;function d(n,u){const o=[];for(const s of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const b in n[s])c[b]=n[s][b];o.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:h(c,u)})}return o}e.toOverrides=d;function h(n,u){const o=Object.create(null);for(let s in n)r(o,s,n[s],u);return o}e.toValuesTree=h;function r(n,u,o,s){const c=u.split("."),b=c.pop();let _=n;for(let p=0;p<c.length;p++){let E=c[p],F=_[E];switch(typeof F){case"undefined":F=_[E]=Object.create(null);break;case"object":break;default:s(`Ignoring ${u} as ${c.slice(0,p+1).join(".")} is ${JSON.stringify(F)}`);return}_=F}if(typeof _=="object"&&_!==null)try{_[b]=o}catch(p){s(`Ignoring ${u} as ${c.join(".")} is ${JSON.stringify(_)}`)}else s(`Ignoring ${u} as ${c.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=r;function a(n,u){const o=u.split(".");g(n,o)}e.removeFromValueTree=a;function g(n,u){const o=u.shift();if(u.length===0){delete n[o];return}if(Object.keys(n).indexOf(o)!==-1){const s=n[o];typeof s=="object"&&!Array.isArray(s)&&(g(s,u),Object.keys(s).length===0&&delete n[o])}}function m(n,u,o){function s(_,p){let E=_;for(const F of p){if(typeof E!="object"||E===null)return;E=E[F]}return E}const c=u.split("."),b=s(n,c);return typeof b=="undefined"?o:b}e.getConfigurationValue=m;function S(n,u,o){Object.keys(u).forEach(s=>{s!=="__proto__"&&(s in n?I.isObject(n[s])&&I.isObject(u[s])?S(n[s],u[s],o):o&&(n[s]=u[s]):n[s]=u[s])})}e.merge=S;function f(){const n=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=f;function l(){const n=Object.create(null),u=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let o in u){let s=u[o].default;r(n,o,s,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=l;function v(n){return`[${n}]`}e.keyFromOverrideIdentifier=v;function t(n,u,o){const s=n.inspect(u),c=n.inspect(o);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(we[155],_e([0,1,44,22,15,10,24,2,66,92,29,6,3]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},n=[],u=[]){this._contents=t,this._keys=n,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const u=this.getContentsForOverrideIdentifer(n);return u?t?(0,k.getConfigurationValue)(u,t):u:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let u={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[o],c=n[o];c&&(typeof s=="object"&&typeof c=="object"?(s=y.deepClone(s),this.mergeContents(s,c)):s=c),u[o]=s}return new h(u,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),u=y.deepClone(this.overrides),o=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const c of s.overrides){const[b]=u.filter(_=>A.equals(_.identifiers,c.identifiers));b?this.mergeContents(b.contents,c.contents):u.push(y.deepClone(c))}for(const c of s.keys)o.indexOf(c)===-1&&o.push(c)}return new h(n,o,u)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const u of Object.keys(n)){if(u in t&&T.isObject(t[u])&&T.isObject(n[u])){this.mergeContents(t[u],n[u]);continue}t[u]=y.deepClone(n[u])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,u=>{throw new Error(u)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let u=0;u<n;u++)t.indexOf(this.keys[u])===0&&(n=u);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class r extends h{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),u=[];for(const o of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(o)&&u.push({identifiers:[(0,D.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,k.toValuesTree)(t[o],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,u)}}e.DefaultConfigurationModel=r;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const u=this.doParseContent(t);this.parseRaw(u,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:u,keys:o,overrides:s,untrusted:c}=this.doParseRaw(t,n);this._configurationModel=new h(u,o,s),this._untrustedConfigurations=c||[]}doParseContent(t){let n={},u=null,o=[],s=[],c=[];function b(p){Array.isArray(o)?o.push(p):u&&(o[u]=p)}let _={onObjectBegin:()=>{let p={};b(p),s.push(o),o=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{let p=[];b(p),s.push(o),o=p,u=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:b,onError:(p,E,F)=>{c.push({error:p,offset:E,length:F})}};if(t)try{w.visit(t,_),n=o[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return n}doParseRaw(t,n){const u=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,u,!0,n);t=o.raw;const s=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),c=Object.keys(t),b=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:s,keys:c,overrides:b,untrusted:o.untrusted}}filter(t,n,u,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.isUntrusted))return{raw:t,untrusted:[]};const s={},c=[];for(let b in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(b)&&u){const _=this.filter(t[b],n,!1,o);s[b]=_.raw,c.push(..._.untrusted)}else{const _=n[b],p=_?typeof _.scope!="undefined"?_.scope:3:void 0;(p===void 0||o.scopes===void 0||o.scopes.includes(p))&&(o.isUntrusted&&(_==null?void 0:_.requireTrust)?c.push(b):s[b]=t[b])}return{raw:s,untrusted:c}}}e.ConfigurationModelParser=a;class g extends P.Disposable{constructor(t,n,u,o){super();this.userSettingsResource=t,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=g;class m{constructor(t,n,u=new h,o=new h,s=new I.ResourceMap,c=new h,b=new I.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=u,this._workspaceConfiguration=o,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=b,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,u){return this.getConsolidateConfigurationModel(n,u).getValue(t)}updateValue(t,n,u={}){let o;u.resource?(o=this._memoryConfigurationByResource.get(u.resource),o||(o=new h,this._memoryConfigurationByResource.set(u.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(t):o.setValue(t,n),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,u){const o=this.getConsolidateConfigurationModel(n,u),s=this.getFolderConfigurationModelForResource(n.resource,u),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=u?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,B=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,Y=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),fe=o.getValue(t),V=A.distinct(A.flatten(o.overrides.map(z=>z.identifiers))).filter(z=>o.getOverrideValue(t,z)!==void 0);return{defaultValue:b,userValue:_,userLocalValue:p,userRemoteValue:E,workspaceValue:F,workspaceFolderValue:B,memoryValue:Y,value:fe,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const u=n.filter(o=>D.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const s=(0,D.overrideIdentifierFromKey)(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),b=t.getKeysForOverrideIdentifier(s),_=[...b.filter(p=>c.indexOf(p)===-1),...c.filter(p=>b.indexOf(p)===-1),...c.filter(p=>!y.equals(this._defaultConfiguration.override(s).getValue(p),t.override(s).getValue(p)))];return[s,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:u,removed:o,overrides:s}=(0,k.compare)(this.localUserConfiguration,t),c=[...n,...u,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:u,removed:o,overrides:s}=(0,k.compare)(this.remoteUserConfiguration,t);let c=[...n,...u,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:u,removed:o,overrides:s}=(0,k.compare)(this.workspaceConfiguration,t);let c=[...n,...u,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const u=this.folderConfigurations.get(t),{added:o,updated:s,removed:c,overrides:b}=(0,k.compare)(u,n);let _=[...o,...s,...c];return(_.length||!u)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:u,updated:o,removed:s,overrides:c}=(0,k.compare)(n,void 0);return{keys:[...u,...o,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let u=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?u.override(t.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:t},n){let u=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const o=n.getFolder(t);o&&(u=this.getFolderConsolidatedConfiguration(o.uri)||u);const s=this._memoryConfigurationByResource.get(t);s&&(u=u.merge(s))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const u=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(n=u.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=u}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const u=n.getFolder(t);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:u,overrides:o,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:u,overrides:o,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(u=>t.add(u))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),u=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,b)=>(c.set(C.URI.revive(b[0]),this.parseConfigurationModel(b[1])),c),new I.ResourceMap);return new m(n,u,new h,o,s,new h,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function S(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,n=new Map;for(const o of v)o.keys.forEach(s=>t.add(s)),o.overrides.forEach(([s,c])=>{const b=(0,I.getOrSet)(n,s,new Set);c.forEach(_=>b.add(_))});const u=[];return n.forEach((o,s)=>u.push([s,[...o.values()]])),{keys:[...t.values()],overrides:u}}e.mergeChanges=S;class f{constructor(t,n,u,o){this.change=t,this.previous=n,this.currentConfiguraiton=u,this.currentWorkspace=o,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(b=>s.add(b)),t.overrides.forEach(([,b])=>b.forEach(_=>s.add(_))),this.affectedKeys=[...s.values()];const c=new h;this.affectedKeys.forEach(b=>c.setValue(b,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var u;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(u=this.previous)===null||u===void 0?void 0:u.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let u=(0,k.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof u=="object"&&(o=Object.keys(u)[0]);){if(t=t[o],!t)return!1;u=u[o]}return!0}}e.ConfigurationChangeEvent=f;class l extends f{constructor(t,n,u,o){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=u,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l}),define(we[67],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(C,D=A.Unknown,k){super(C);this._message=C,this._code=D,this._detail=k,this.isHandled=D===A.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===A.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===A.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[93],_e([0,1,19]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===w.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function A(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=A;function T(D){return D.scheme!==w.Schemas.file&&D.scheme!==w.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>T(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function C(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(we[156],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let C;return C=T(D=>{const k=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(A);if(i){i.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(A),y);i={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(A),C.dispose()}},this._terminalBufferMap.set(A,i)}),C}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=w}),define(we[157],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(we[158],_e([0,1,4,6,29,3,157,36]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var D;(function(g){function m(S){return S&&typeof S=="object"&&typeof S.id=="string"}g.isThemeColor=m})(D=e.ThemeColor||(e.ThemeColor={}));function k(g){return{id:g}}e.themeColorFromId=k;var i;(function(g){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}g.isThemeIcon=m;const S=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function f(t){const n=S.exec(t);if(!!n){let[,u]=n;return{id:u}}}g.fromString=f;function l(t,n){let u=t.id;const o=u.lastIndexOf("~");return o!==-1&&(u=u.substring(0,o)),n&&(u=`${u}~${n}`),{id:u}}g.modify=l;function v(t,n){var u,o;return t.id===n.id&&((u=t.color)===null||u===void 0?void 0:u.id)===((o=n.color)===null||o===void 0?void 0:o.id)}g.isEqual=v,g.asClassNameArray=C.CSSIcon.asClassNameArray,g.asClassName=C.CSSIcon.asClassName,g.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(g){switch(g){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(m);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new d;A.Registry.add(e.Extensions.ThemingContribution,h);function r(g){return h.onColorThemeChange(g)}e.registerThemingParticipant=r;class a extends I.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,S){let f=this.theme.getColor(m);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=a}),define(we[159],_e([0,1,29,158,3,128,91,11,36]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,S,f,l){const v=this.iconsById[m];if(v){if(f&&!v.description){v.description=f,this.iconSchema.properties[m].markdownDescription=`${f} $(${m})`;const u=this.iconReferenceSchema.enum.indexOf(m);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=f),this._onDidChange.fire()}return v}let t={id:m,description:f,defaults:S,deprecationMessage:l};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),f&&(n.markdownDescription=`${f}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const S=this.iconReferenceSchema.enum.indexOf(m);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,S){const f=this.iconFontsById[m];if(f)return f;let l={id:m,definition:S};return this.iconFontsById[m]=l,this._onDidChange.fire(),l}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(v,t)=>v.id.localeCompare(t.id),S=v=>{for(;I.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of l.filter(t=>!!t.description).sort(m))f.push(`|<i class="${S(v)}"></i>|${v.id}|${I.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const v of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(m))f.push(`|<i class="${S(v)}"></i>|${v.id}|`);return f.join(`
`)}}const i=new k;w.Registry.add(e.Extensions.IconContribution,i);function P(g,m,S,f){return i.registerIcon(g,m,S,f)}e.registerIcon=P;function d(){return i}e.getIconRegistry=d;function h(){for(const g of D.iconRegistry.all)i.registerIcon(g.id,g.definition,g.description);D.iconRegistry.onDidRegister(g=>i.registerIcon(g.id,g.definition,g.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let r=w.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const a=new C.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=P("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(we[48],_e([0,1,2,25,4,22]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(d){const h=d;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=C;function D(d){const h=d;return!!(h&&typeof h=="object"&&w.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(h,r,a,g){this._id=h,this._configuration=a,this._ignorePathCasing=g,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(h,r){this.raw=r,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,I.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(d){return new i({uri:d,index:0,name:(0,I.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(we[160],_e([0,1,4,129,48,2,21,13,25,107,44,19,58,37,93]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(ee){return(typeof ee=="string"?(0,C.extname)(ee):(0,D.extname)(ee))===a}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function m(ee){return ee.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function S(ee){return ee.hasOwnProperty("folderUri")}e.isRecentFolder=S;function f(ee){return ee.hasOwnProperty("fileUri")}e.isRecentFile=f;function l(ee){const $=ee;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=l;function v(ee){if(ee.configuration)return{id:ee.id,configPath:ee.configuration};if(ee.folders.length===1)return{id:ee.id,uri:ee.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(ee){const $=ee;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function n(ee){const $=ee;if($==null?void 0:$.uri)return{id:$.id,uri:T.URI.revive($.uri)};const R=ee;if(R==null?void 0:R.configPath)return{id:R.id,configPath:T.URI.revive(R.configPath)};if(ee==null?void 0:ee.id)return{id:ee.id}}e.reviveIdentifier=n;function u(ee,$){return D.extUriBiasedIgnorePathCase.isEqualOrParent(ee,$.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function o(ee){return s(ee)||c(ee)}e.isStoredWorkspaceFolder=o;function s(ee){const $=ee;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=s;function c(ee){const $=ee;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=c;function b(ee,$,R,L,M=!y.isWindows,U){if(ee.scheme!==L.scheme)return{name:R,uri:ee.toString(!0)};let G=$?void 0:U.relativePath(L,ee);if(G!==void 0)G.length===0?G=".":y.isWindows&&ee.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(ee.scheme===P.Schemas.file)G=ee.fsPath,y.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,h.toSlashes)(G)));else{if(!U.isEqualAuthority(ee.authority,L.authority))return{name:R,uri:ee.toString(!0)};G=ee.path}return{name:R,path:G}}e.getStoredWorkspaceFolder=b;function _(ee,$,R){let L=[],M=new Set;const U=R.dirname($);for(let G of ee){let X=null;if(s(G))G.path&&(X=R.resolvePath(U,G.path));else if(c(G))try{X=T.URI.parse(G.uri),X.path[0]!=="/"&&(X=X.with({path:"/"+X.path}))}catch(se){console.warn(se)}if(X){let se=R.getComparisonKey(X);if(!M.has(se)){M.add(se);const pe=G.name||R.basenameOrAuthority(X);L.push(new A.WorkspaceFolder({uri:X,name:pe,index:L.length},G))}}}return L}e.toWorkspaceFolders=_;function p(ee,$,R,L,M){let U=E($,ee);const G=M.dirname($),X=M.dirname(L),se=[],pe=F(U.folders);for(const We of U.folders){const x=s(We)?M.resolvePath(G,We.path):T.URI.parse(We.uri);let q;R?q=!1:q=!s(We)||(0,C.isAbsolute)(We.path),se.push(b(x,q,We.name,X,pe,M))}const Te={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},xe=k.setProperty(ee,["folders"],se,Te);let Ae=k.applyEdits(ee,xe);return U.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Ae=k.applyEdits(Ae,k.removeProperty(Ae,["remoteAuthority"],Te))),Ae}e.rewriteWorkspaceFileForNewLocation=p;function E(ee,$){let R=i.parse($);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(L=>o(L));else throw new Error(`${ee} looks like an invalid workspace file.`);return R}function F(ee){return y.isWindows?ee.some($=>s($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function B(ee){return ee.workspace&&typeof ee.workspace=="object"&&typeof ee.workspace.id=="string"&&typeof ee.workspace.configPath=="string"}function Y(ee){return typeof ee.folderUri=="string"}function fe(ee){return typeof ee.fileUri=="string"}function V(ee,$){const R={workspaces:[],files:[]};if(ee){const L=function(U,G){for(let X=0;X<U.length;X++)try{G(U[X],X)}catch(se){$.warn(`Error restoring recent entry ${JSON.stringify(U[X])}: ${se.toString()}. Skip entry.`)}},M=ee;if(Array.isArray(M.entries))L(M.entries,U=>{const G=U.label,X=U.remoteAuthority;B(U)?R.workspaces.push({label:G,remoteAuthority:X,workspace:{id:U.workspace.id,configPath:T.URI.parse(U.workspace.configPath)}}):Y(U)?R.workspaces.push({label:G,remoteAuthority:X,folderUri:T.URI.parse(U.folderUri)}):fe(U)&&R.files.push({label:G,remoteAuthority:X,fileUri:T.URI.parse(U.fileUri)})});else{const U=ee;Array.isArray(U.workspaces3)&&L(U.workspaces3,(G,X)=>{const se=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[X]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?R.workspaces.push({label:se,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&R.workspaces.push({label:se,folderUri:T.URI.parse(G)})}),Array.isArray(U.files2)&&L(U.files2,(G,X)=>{const se=Array.isArray(U.fileLabels)&&U.fileLabels[X]||void 0;typeof G=="string"&&R.files.push({label:se,fileUri:T.URI.parse(G)})})}}return R}e.restoreRecentlyOpened=V;function z(ee){const $={entries:[]};for(const R of ee.workspaces)S(R)?$.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):$.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of ee.files)$.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return $}e.toStoreData=z}),define(we[68],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(we[161],_e([0,1,2,3]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(C=>({name:C.name,group:C.group,resource:w.URI.revive(C.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(we[49],_e([0,1,19,4]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(we[162],_e([0,1,11]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,C,D){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const P of k.values())P.error(i)}})()},0)}get whenReady(){return this._init}get(y,C){let D=this._value[y];return typeof D=="undefined"&&(D=C),D}update(y,C){this._value[y]=C;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new w.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class A extends I{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(we[14],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class I{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[163],_e([0,1,26,3]),function(Q,e,w,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(C,D){A.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(C.identifier),tt(this,A,D,"f"),Me(this,A,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Me(this,A,"f").get(this._id,C)}store(C,D){return Me(this,A,"f").store(this._id,C,D)}delete(C){return Me(this,A,"f").delete(this._id,C)}}e.ExtensionSecrets=T,A=new WeakMap}),define(we[94],_e([0,1,4,3]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(we[69],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let C=A.get(y);return C||(C={children:new Map,bus:new w.Emitter},A.set(y,C)),C};e.getPrivateApiFor=T}),define(we[70],_e([0,1,4,3,14]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}C.fromApiTunnel=D;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}C.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,i,P,d){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([qe(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)},zt=this&&this.__rest||function(Q,e){var w={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(w[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(w[I[A]]=Q[I[A]]);return w};define(we[7],_e([0,1,15,12,83,22,8,10,2,31,64,67,69]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d){"use strict";var h,r,a,g,m,S,f,l,v,t,n,u,o,s,c,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let p=a=class{constructor(O){h.set(this,void 0),tt(this,h,O,"f")}static from(...O){let re=O;return new a(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}dispose(){typeof Me(this,h,"f")=="function"&&(Me(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,p=a=Ve([_],p),e.Disposable=p;let E=g=class{constructor(O,re){if(O<0)throw(0,I.illegalArgument)("line must be non-negative");if(re<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=O,this._character=re}static Min(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(O){if(!O)return!1;if(O instanceof g)return!0;let{line:re,character:De}=O;return typeof re=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,re=0){if(O===null||re===null)throw(0,I.illegalArgument)();let De;return typeof O=="undefined"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,re=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&re===0?this:new g(this.line+De,this.character+re)}with(O,re=this.character){if(O===null||re===null)throw(0,I.illegalArgument)();let De;return typeof O=="undefined"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,re=typeof O.character=="number"?O.character:this.character),De===this.line&&re===this.character?this:new g(De,re)}toJSON(){return{line:this.line,character:this.character}}};E=g=Ve([_],E),e.Position=E;let F=m=class{constructor(O,re,De,Ke){let et,st;if(typeof O=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new E(O,re),st=new E(De,Ke)):O instanceof E&&re instanceof E&&(et=O,st=re),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(O){return O instanceof m?!0:O?E.isPosition(O.start)&&E.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof E?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const re=E.Max(O.start,this._start),De=E.Min(O.end,this._end);if(!re.isAfter(De))return new m(re,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const re=E.Min(O.start,this._start),De=E.Max(O.end,this.end);return new m(re,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,re=this.end){if(O===null||re===null)throw(0,I.illegalArgument)();let De;return O?E.isPosition(O)?De=O:(De=O.start||this.start,re=O.end||this.end):De=this.start,De.isEqual(this._start)&&re.isEqual(this.end)?this:new m(De,re)}toJSON(){return[this.start,this.end]}};F=m=Ve([_],F),e.Range=F;let B=S=class extends F{constructor(O,re,De,Ke){let et,st;if(typeof O=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new E(O,re),st=new E(De,Ke)):O instanceof E&&re instanceof E&&(et=O,st=re),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(O){return O instanceof S?!0:O?F.isRange(O)&&E.isPosition(O.anchor)&&E.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=S=Ve([_],B),e.Selection=B;class Y{constructor(O,re,De){if(typeof O!="string"||O.length===0)throw(0,I.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,I.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(re),this.connectionToken=De}}e.ResolvedAuthority=Y;class fe extends Error{constructor(O,re=P.RemoteAuthorityResolverErrorCode.Unknown,De){super(O);this._message=O,this._code=re,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,fe.prototype)}static NotAvailable(O,re){return new fe(O,P.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(O){return new fe(O,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=fe;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var z;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=f=class{constructor(O,re){this._range=O,this._newText=re}static isTextEdit(O){return O instanceof f?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,re){return new f(O,re)}static insert(O,re){return f.replace(new F(O,O),re)}static delete(O){return f.replace(O,"")}static setEndOfLine(O){const re=new f(new F(new E(0,0),new E(0,0)),"");return re.newEol=O,re}get range(){return this._range}set range(O){if(O&&!F.isRange(O))throw(0,I.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,I.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,I.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=f=Ve([_],ee),e.TextEdit=ee;var $;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellOutput=4]="CellOutput",N[N.CellReplace=5]="CellReplace",N[N.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let R=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,re,De,Ke){this._edits.push({_type:1,from:O,to:re,options:De,metadata:Ke})}createFile(O,re,De){this._edits.push({_type:1,from:void 0,to:O,options:re,metadata:De})}deleteFile(O,re,De){this._edits.push({_type:1,from:O,to:void 0,options:re,metadata:De})}replaceNotebookMetadata(O,re,De){this._edits.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(O,re,De,Ke,et){let st,ct,yt=[],Dt;if(xt.isNotebookRange(re)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(Ke)?(st=re.start,ct=re.end,yt=De,Dt=Ke):typeof re=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(Ke)&&(st=re,ct=De,yt=Ke,Dt=et),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||yt.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:ct-st,cells:yt,metadata:Dt})}replaceNotebookCellMetadata(O,re,De,Ke){this._edits.push({_type:3,metadata:Ke,uri:O,edit:{editType:8,index:re,metadata:De}})}replace(O,re,De,Ke){this._edits.push({_type:2,uri:O,edit:new ee(re,De),metadata:Ke})}insert(O,re,De,Ke){this.replace(O,new F(re,re),De,Ke)}delete(O,re,De){this.replace(O,re,"",De)}has(O){return this._edits.some(re=>re._type===2&&re.uri.toString()===O.toString())}set(O,re){if(re)for(const De of re)De&&this._edits.push({_type:2,uri:O,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ke=this._edits[De];Ke._type===2&&Ke.uri.toString()===O.toString()&&(this._edits[De]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(O){const re=[];for(let De of this._edits)De._type===2&&De.uri.toString()===O.toString()&&re.push(De.edit);return re}entries(){const O=new T.ResourceMap;for(let re of this._edits)if(re._type===2){let De=O.get(re.uri);De||(De=[re.uri,[]],O.set(re.uri,De)),De[1].push(re.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};R=Ve([_],R),e.WorkspaceEdit=R;let L=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,re=this._tabstop++){if(typeof O=="function"){const De=new l;De._tabstop=this._tabstop,O(De),this._tabstop=De._tabstop,O=De.value}else O=l._escape(O);return this.value+="${",this.value+=re,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,re=this._tabstop++){const De=O.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,re){if(typeof re=="function"){const De=new l;De._tabstop=this._tabstop,re(De),this._tabstop=De._tabstop,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,re&&(this.value+=":",this.value+=re),this.value+="}",this}};L=l=Ve([_],L),e.SnippetString=L;var M;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=v=class{constructor(O,re){if(this.uri=O,re)if(re instanceof F)this.range=re;else if(re instanceof E)this.range=new F(re,re);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof v?!0:O?F.isRange(O.range)&&D.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=v=Ve([_],G),e.Location=G;let X=class{constructor(O,re){this.location=O,this.message=re}static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&D.URI.isUri(O.location.uri):!1}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.location.range.isEqual(re.location.range)&&O.location.uri.toString()===re.location.uri.toString()}};X=Ve([_],X),e.DiagnosticRelatedInformation=X;let se=class{constructor(O,re,De=U.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=O,this.message=re,this.severity=De}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.severity===re.severity&&O.code===re.code&&O.severity===re.severity&&O.source===re.source&&O.range.isEqual(re.range)&&(0,w.equals)(O.tags,re.tags)&&(0,w.equals)(O.relatedInformation,re.relatedInformation,X.isEqual)}};se=Ve([_],se),e.Diagnostic=se;let pe=class{constructor(O,re){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,A.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=re}};pe=Ve([_],pe),e.Hover=pe;var Te;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(O,re=Te.Text){this.range=O,this.kind=re}toJSON(){return{range:this.range,kind:Te[this.kind]}}};xe=Ve([_],xe),e.DocumentHighlight=xe;var Ae;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var We;(function(N){N[N.Deprecated=1]="Deprecated"})(We=e.SymbolTag||(e.SymbolTag={}));let x=t=class{constructor(O,re,De,Ke,et){this.name=O,this.kind=re,this.containerName=et,typeof De=="string"&&(this.containerName=De),Ke instanceof G?this.location=Ke:De instanceof F&&(this.location=new G(Ke,De)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};x=t=Ve([_],x),e.SymbolInformation=x;let q=n=class{constructor(O,re,De,Ke,et){this.name=O,this.detail=re,this.kind=De,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};q=n=Ve([_],q),e.DocumentSymbol=q;var ne;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(O,re){this.title=O,this.kind=re}};le=Ve([_],le),e.CodeAction=le;let me=u=class{constructor(O){this.value=O}append(O){return new u(this.value?this.value+u.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+u.sep)}};me.sep=".",me=u=Ve([_],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Se=class{constructor(O,re){if(this.range=O,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=Ve([_],Se),e.SelectionRange=Se;class Oe{constructor(O,re,De,Ke,et,st){this.kind=O,this.name=re,this.detail=De,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class ge{constructor(O,re){this.fromRanges=re,this.from=O}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(O,re){this.fromRanges=re,this.to=O}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(O,re){this.range=O,this.command=re}get isResolved(){return!!this.command}};Pe=Ve([_],Pe),e.CodeLens=Pe;let $e=o=class{constructor(O,re=!1){r.set(this,void 0),tt(this,r,new A.MarkdownString(O,{supportThemeIcons:re}),"f")}static isMarkdownString(O){return O instanceof o?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Me(this,r,"f").value}set value(O){Me(this,r,"f").value=O}get isTrusted(){return Me(this,r,"f").isTrusted}set isTrusted(O){Me(this,r,"f").isTrusted=O}get supportThemeIcons(){return Me(this,r,"f").supportThemeIcons}appendText(O){return Me(this,r,"f").appendText(O),this}appendMarkdown(O){return Me(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,re){return Me(this,r,"f").appendCodeblock(re!=null?re:"",O),this}};r=new WeakMap,$e=o=Ve([_],$e),e.MarkdownString=$e;let Ee=class{constructor(O,re){this.label=O,this.documentation=re}};Ee=Ve([_],Ee),e.ParameterInformation=Ee;let je=class{constructor(O,re){this.label=O,this.documentation=re,this.parameters=[]}};je=Ve([_],je),e.SignatureInformation=je;let H=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};H=Ve([_],H),e.SignatureHelp=H;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(ve=e.InlineHintKind||(e.InlineHintKind={}));let Le=class{constructor(O,re,De){this.text=O,this.range=re,this.kind=De}};Le=Ve([_],Le),e.InlineHint=Le;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(N){N[N.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let W=class{constructor(O,re){this.label=O,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};W=Ve([_],W),e.CompletionItem=W;let ie=class{constructor(O=[],re=!1){this.items=O,this.isIncomplete=re}};ie=Ve([_],ie),e.CompletionList=ie;var ce;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ce=e.ViewColumn||(e.ViewColumn={}));var j;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(j=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Z;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ze;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(re){switch(re){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Be=class{constructor(O,re){if(re&&!D.URI.isUri(re))throw(0,I.illegalArgument)("target");if(!F.isRange(O)||O.isEmpty)throw(0,I.illegalArgument)("range");this.range=O,this.target=re}};Be=Ve([_],Be),e.DocumentLink=Be;let Ne=class{constructor(O,re,De,Ke){this.red=O,this.green=re,this.blue=De,this.alpha=Ke}};Ne=Ve([_],Ne),e.Color=Ne;let Ge=class{constructor(O,re){if(re&&!(re instanceof Ne))throw(0,I.illegalArgument)("color");if(!F.isRange(O)||O.isEmpty)throw(0,I.illegalArgument)("range");this.range=O,this.color=re}};Ge=Ve([_],Ge),e.ColorInformation=Ge;let nt=class{constructor(O){if(!O||typeof O!="string")throw(0,I.illegalArgument)("label");this.label=O}};nt=Ve([_],nt),e.ColorPresentation=nt;var dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Je;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Je=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=s=class{constructor(O,re){if(typeof O!="string"||typeof re!="string")throw(0,I.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};bt.Clean=new s("clean","Clean"),bt.Build=new s("build","Build"),bt.Rebuild=new s("rebuild","Rebuild"),bt.Test=new s("test","Test"),bt=s=Ve([_],bt),e.TaskGroup=bt;function be(N){let O="";for(let re=0;re<N.length;re++)O+=N[re].replace(/,/g,",,")+",";return O}let de=class{constructor(O,re,De){if(typeof O!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=O,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=De):this._options=re)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,I.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let re of this._args)O.push(re);return be(O)}};de=Ve([_],de),e.ProcessExecution=de;let oe=class{constructor(O,re,De){if(this._args=[],Array.isArray(re)){if(!O)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,I.illegalArgument)("command");this._command=O,this._args=re,this._options=De}else{if(typeof O!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=O,this._options=re}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,I.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)O.push(typeof re=="string"?re:re.value);return be(O)}};oe=Ve([_],oe),e.ShellExecution=oe;var K;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(K=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class Ie{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ie;let Qe=c=class{constructor(O,re,De,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof re=="string"?(this._name=this.name=re,this._source=this.source=De,this.execution=Ke,ct=et,this.__deprecated=!0):re===Re.Global||re===Re.Workspace?(this.target=re,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st):(this.target=re,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof de?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof oe?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const re=this._definition.type;(c.EmptyType===re||c.ProcessType===re||c.ShellType===re||c.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=c=Ve([_],Qe),e.Task=Qe;var Ze;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,re=ht.None){this.collapsibleState=re,D.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=Ve([_],ut),e.TreeItem=ut;var ht;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ye=class{constructor(O,re){this.id=O,this.color=re}};Ye=Ve([_],Ye),e.ThemeIcon=Ye,Ye.File=new Ye("file"),Ye.Folder=new Ye("folder");let ot=class{constructor(O){this.id=O}};ot=Ve([_],ot),e.ThemeColor=ot;var ft;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(O,re){if(typeof O!="string"&&(!O||!D.URI.isUri(O)&&!D.URI.isUri(O.uri)))throw(0,I.illegalArgument)("base");if(typeof re!="string")throw(0,I.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=D.URI.file(O),this.base=O):D.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=re}};at=Ve([_],at),e.RelativePattern=at;let Et=class{constructor(O,re,De,Ke){this.enabled=typeof O=="boolean"?O:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};Et=Ve([_],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(O,re,De,Ke,et){super(re,De,Ke,et);if(O===null)throw(0,I.illegalArgument)("location");this.location=O}};vt=Ve([_],vt),e.SourceBreakpoint=vt;let Ct=class extends Et{constructor(O,re,De,Ke,et){super(re,De,Ke,et);this.functionName=O}};Ct=Ve([_],Ct),e.FunctionBreakpoint=Ct;let Pt=class extends Et{constructor(O,re,De,Ke,et,st,ct){super(Ke,et,st,ct);if(!re)throw(0,I.illegalArgument)("dataId");this.label=O,this.dataId=re,this.canPersist=De}};Pt=Ve([_],Pt),e.DataBreakpoint=Pt;let At=class{constructor(O,re,De){this.command=O,this.args=re||[],this.options=De}};At=Ve([_],At),e.DebugAdapterExecutable=At;let _t=class{constructor(O,re){this.port=O,this.host=re}};_t=Ve([_],_t),e.DebugAdapterServer=_t;let Qt=class{constructor(O){this.path=O}};Qt=Ve([_],Qt),e.DebugAdapterNamedPipeServer=Qt;let Yt=class{constructor(O){this.implementation=O}};Yt=Ve([_],Yt),e.DebugAdapterInlineImplementation=Yt;let gt=class{constructor(O,re){this.range=O,this.expression=re}};gt=Ve([_],gt),e.EvaluatableExpression=gt;let Jt=class{constructor(O,re){this.range=O,this.text=re}};Jt=Ve([_],Jt),e.InlineValueText=Jt;let St=class{constructor(O,re,De=!0){this.range=O,this.variableName=re,this.caseSensitiveLookup=De}};St=Ve([_],St),e.InlineValueVariableLookup=St;let Vt=class{constructor(O,re){this.range=O,this.expression=re}};Vt=Ve([_],Vt),e.InlineValueEvaluatableExpression=Vt;let Xt=class{constructor(O,re){this.frameId=O,this.stoppedLocation=re}};Xt=Ve([_],Xt),e.InlineValueContext=Xt;var jt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let lt=b=class extends Error{constructor(O,re=i.FileSystemProviderErrorCode.Unknown,De){var Ke;super(D.URI.isUri(O)?O.toString(!0):O);this.code=(Ke=De==null?void 0:De.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,i.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(O){return new b(O,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(O){return new b(O,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(O){return new b(O,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(O){return new b(O,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(O){return new b(O,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(O){return new b(O,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};lt=b=Ve([_],lt),e.FileSystemError=lt;let Zt=class{constructor(O,re,De){this.start=O,this.end=re,this.kind=De}};Zt=Ve([_],Zt),e.FoldingRange=Zt;var Tt;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bt;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Bt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var cn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(cn=e.CommentMode||(e.CommentMode={}));class bn{constructor(O,re=[]){this.tokenTypes=O,this.tokenModifiers=re}}e.SemanticTokensLegend=bn;function dn(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class en{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let re=0,De=O.tokenTypes.length;re<De;re++)this._tokenTypeStrToInt.set(O.tokenTypes[re],re);for(let re=0,De=O.tokenModifiers.length;re<De;re++)this._tokenModifierStrToInt.set(O.tokenModifiers[re],re)}}push(O,re,De,Ke,et){if(typeof O=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(O,re,De,Ke,et);if(F.isRange(O)&&typeof re=="string"&&dn(De))return this._push(O,re,De);throw(0,I.illegalArgument)()}_push(O,re,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,et=O.start.character,st=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(re);let yt=0;if(De)for(const Dt of De){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);yt|=1<<kt>>>0}this._pushEncoded(Ke,et,st,ct,yt)}_pushEncoded(O,re,De,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Dt=0,kt=0;for(let It=0;It<yt;It++){let Lt=this._data[5*It],ln=this._data[5*It+1];Lt===0?(Lt=Dt,ln+=kt):Lt+=Dt,this._data[5*It]=Lt,this._data[5*It+1]=ln,Dt=Lt,kt=ln}}let st=O,ct=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=O,this._prevChar=re}static _sortAndDeltaEncode(O){let re=[];const De=O.length/5|0;for(let ct=0;ct<De;ct++)re[ct]=ct;re.sort((ct,yt)=>{const Dt=O[5*ct],kt=O[5*yt];if(Dt===kt){const It=O[5*ct+1],Lt=O[5*yt+1];return It-Lt}return Dt-kt});const Ke=new Uint32Array(O.length);let et=0,st=0;for(let ct=0;ct<De;ct++){const yt=5*re[ct],Dt=O[yt+0],kt=O[yt+1],It=O[yt+2],Lt=O[yt+3],ln=O[yt+4],An=Dt-et,Ln=An===0?kt-st:kt,un=5*ct;Ke[un+0]=An,Ke[un+1]=Ln,Ke[un+2]=It,Ke[un+3]=Lt,Ke[un+4]=ln,et=Dt,st=kt}return Ke}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(en._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=en;class qt{constructor(O,re){this.resultId=re,this.data=O}}e.SemanticTokens=qt;class Ot{constructor(O,re,De){this.start=O,this.deleteCount=re,this.data=De}}e.SemanticTokensEdit=Ot;class wn{constructor(O,re){this.resultId=re,this.edits=O}}e.SemanticTokensEdits=wn;var tn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var nn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(nn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new Ye("arrow-left")},Kt=Ve([_],Kt),e.QuickInputButtons=Kt;var _n;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(O,re,De){this.badge=O,this.tooltip=re,this.color=De}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let rn=class{constructor(O){this.kind=O}};rn=Ve([_],rn),e.ColorTheme=rn;var En;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(En=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(O,re){if(O<0)throw(0,I.illegalArgument)("start must be positive");if(re<0)throw(0,I.illegalArgument)("end must be positive");O<=re?(this._start=O,this._end=re):(this._start=re,this._end=O)}static isNotebookRange(O){return O instanceof xt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let re=this._start,De=this._end;return O.start!==void 0&&(re=O.start),O.end!==void 0&&(De=O.end),re===this._start&&De===this._end?this:new xt(re,De)}}e.NotebookRange=xt;class sn{constructor(O,re){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=re)}with(O){let{inputCollapsed:re,outputCollapsed:De}=O,Ke=zt(O,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),re===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Ke).length===0?this:new sn(Object.assign({inputCollapsed:re,outputCollapsed:De},Ke))}}e.NotebookCellMetadata=sn;class Nt{constructor(O=!0){var re;typeof O=="object"?(Object.assign(this,O),this.trusted=(re=O.trusted)!==null&&re!==void 0?re:!0):this.trusted=O}with(O){let{trusted:re}=O,De=zt(O,["trusted"]);return re===void 0?re=this.trusted:re===null&&(re=void 0),re===this.trusted&&Object.keys(De).length===0?this:new Nt(Object.assign({trusted:re},De))}}e.NotebookDocumentMetadata=Nt;class Ft{constructor(O,re,De,Ke,et,st){this.kind=O,this.source=re,this.language=De,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(re=>Ft.isNotebookCellData(re))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ft;class hn{constructor(O,re){this.cells=O,this.metadata=re!=null?re:new Nt}}e.NotebookData=hn;class $t{constructor(O,re,De){if(this.mime=O,this.value=re,this.metadata=De,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof $t}}e.NotebookCellOutputItem=$t;class Fe{constructor(O,re,De){this.outputs=O,typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,k.generateUuid)(),this.metadata=re!=null?re:De)}}e.NotebookCellOutput=Fe;var on;(function(N){N[N.Markdown=1]="Markdown",N[N.Code=2]="Code"})(on=e.NotebookCellKind||(e.NotebookCellKind={}));var an;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(an=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var yn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(yn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Sn{constructor(O,re,De,Ke,et,st){this.text=O,this.alignment=re,this.command=De,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=Sn;var fn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));let Gt=class{constructor(O,re){this.label=O,this.timestamp=re}};Gt=Ve([_],Gt),e.TimelineItem=Gt;var Dn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Dn=e.ExtensionMode||(e.ExtensionMode={}));var Cn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var kn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(kn=e.StandardTokenType||(e.StandardTokenType={}));class In{constructor(O,re){this.ranges=O,this.wordPattern=re}}e.LinkedEditingRanges=In;var mn;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(mn=e.TestResultState||(e.TestResultState={}));var gn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(gn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var pn;(function(N){N[N.Pending=0]="Pending",N[N.Resolved=1]="Resolved"})(pn=e.TestItemStatus||(e.TestItemStatus={}));const Ut=(N,O,re,De)=>{let Ke=re;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){De(Ke,et)||(Ke=et,N.bus.fire([3,O,et]))}}},Wt=(N,O)=>N===O,Pn=(N,O)=>N===O?!0:!N||!O?!1:N.isEqual(O);class J{constructor(O,re,De,Ke){this.label=re,this.data=Ke;const et=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new T.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Ut(et,"range",void 0,Pn),description:Ut(et,"description",void 0,Wt),runnable:Ut(et,"runnable",!0,Wt),debuggable:Ut(et,"debuggable",!0,Wt),status:Ut(et,"status",pn.Resolved,Wt),error:Ut(et,"error",void 0,Wt)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,d.getPrivateApiFor)(this);O.parent&&(0,d.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof J))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,d.getPrivateApiFor)(this);if(re.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);re.children.set(O.id,O),re.bus.fire([0,O])}}e.TestItemImpl=J;class ue{constructor(O){this.message=O,this.severity=gn.Error}static diff(O,re,De){const Ke=new ue(O);return Ke.expectedOutput=re,Ke.actualOutput=De,Ke}}e.TestMessage=ue;var ke;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(ke=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var rt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(rt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore"})(wt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[95],_e([0,1,42,19,8,120,86,7,15]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(r,a){a?k.set(r,a):k.delete(r)}e.setWordDefinitionFor=i;function P(r){return k.get(r)}e.getWordDefinitionFor=P;class d extends T.MirrorTextModel{constructor(a,g,m,S,f,l,v,t){super(g,m,S,f);this._proxy=a,this._languageId=l,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,D.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===I.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(g){return g?a._getTextInRange(g):a.getText()},get eol(){return a._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(g){return a._lineAt(g)},offsetAt(g){return a._offsetAt(g)},positionAt(g){return a._positionAt(g)},validateRange(g){return a._validateRange(g)},validatePosition(g){return a._validatePosition(g)},getWordRangeAtPosition(g,m){return a._getWordRangeAtPosition(g,m)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,w.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,w.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const g=this._validateRange(a);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const m=this._eol,S=g.start.line,f=g.end.line,l=[];l.push(this._lines[S].substring(g.start.character));for(let v=S+1;v<f;v++)l.push(this._lines[v]);return l.push(this._lines[f].substring(0,g.end.character)),l.join(m)}_lineAt(a){let g;if(a instanceof C.Position?g=a.line:typeof a=="number"&&(g=a),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new h(g,this._lines[g],g===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(a),m=this._lines[g.index].length;return new C.Position(g.index,Math.min(g.remainder,m))}_validateRange(a){if(!(a instanceof C.Range))throw new Error("Invalid argument");const g=this._validatePosition(a.start),m=this._validatePosition(a.end);return g===a.start&&m===a.end?a:new C.Range(g.line,g.character,m.line,m.character)}_validatePosition(a){if(!(a instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:g,character:m}=a,S=!1;if(g<0)g=0,m=0,S=!0;else if(g>=this._lines.length)g=this._lines.length-1,m=this._lines[g].length,S=!0;else{const f=this._lines[g].length;m<0?(m=0,S=!0):m>f&&(m=f,S=!0)}return S?new C.Position(g,m):a}_getWordRangeAtPosition(a,g){const m=this._validatePosition(a);if(!g)g=P(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[m.line],0);if(S)return new C.Range(m.line,S.startColumn-1,m.line,S.endColumn-1)}}e.ExtHostDocumentData=d;class h{constructor(a,g,m){this._line=a,this._text=g,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[164],_e([0,1,7,3,88,6,59,22,2,31]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,h,r,a){this._notebook=r,this._selector=a,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(m=>{const S=this._cellUris.get(m.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(m=>g(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const d=[],h=[];for(const r of this._notebook.getCells())r.kind===w.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),h.push(r.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(d){var h,r;if(!d){let f="";for(const l of this._cells)f+=l.document.getText()+`
`;return f=f.slice(0,-1),f}if(d.isEmpty)return"";const a=this.locationAt(d.start),g=this.locationAt(d.end),m=this._cells[(h=this._cellUris.get(a.uri))!==null&&h!==void 0?h:-1],S=this._cells[(r=this._cellUris.get(g.uri))!==null&&r!==void 0?r:-1];if(!m||!S)return"";if(m===S)return m.document.getText(new w.Range(a.range.start,g.range.end));{const f=m.document.getText(new w.Range(a.range.start,new w.Position(m.document.lineCount,0))),l=S.document.getText(new w.Range(new w.Position(0,0),g.range.end));return f+`
`+l}}offsetAt(d){const h=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(h.index-1),a=this._cells[h.index].document.offsetAt(d.with(h.remainder));return r+a}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),a=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(a)}const h=this._cellUris.get(d.uri);if(h!==void 0){const r=this._cellLines.getAccumulatedValue(h-1);return new w.Position(r+d.range.start.line,d.range.start.character)}return new w.Position(0,0)}locationAt(d){w.Range.isRange(d)||(d=new w.Range(d,d));const h=this._cellLines.getIndexOf(d.start.line);let r=h;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const a=new w.Position(h.remainder,d.start.character),g=new w.Position(r.remainder,d.end.character),m=new w.Range(a,g),S=this._cells[h.index];return new w.Location(S.document.uri,S.document.validateRange(m))}contains(d){return this._cellUris.has(d)}validateRange(d){const h=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(h,r)}validatePosition(d){const h=this._cellLines.getIndexOf(d.line),r=new w.Position(h.remainder,d.character),a=this._cells[h.index].document.validatePosition(r),g=this._cellLines.getAccumulatedValue(h.index-1);return new w.Position(g+a.line,a.character)}}e.ExtHostNotebookConcatDocument=i}),define(we[165],_e([0,1,7,14,3]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(C){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?w.ColorThemeKind.Light:C==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(we[71],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class I{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(we[166],_e([0,1,23]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function A(C,D){if(D){const k=new I,i=(h,r)=>{if(r instanceof ArrayBuffer){const a=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(r)){const a=T(r);if(a){const g=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(C,i),d=k.buffers.map(h=>{const r=new Uint8Array(h);return w.VSBuffer.wrap(r)});return{message:P,buffers:d}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=A;function T(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,D){const k=D.map(d=>{const h=new ArrayBuffer(d.byteLength);return new Uint8Array(h).set(d.buffer),h}),i=D.length?(d,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:a}=r,g=k[a];if(r.view)switch(r.view.type){case 1:return new Int8Array(g,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return h}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(we[72],_e([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(T,y,C){const D=T.webviewResourceRoot.replace("{{resource}}",C.scheme+A(C)).replace("{{uuid}}",y);return w.URI.parse(D)}e.asWebviewUri=I;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(we[167],_e([0,1,3,6,72,31]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,i){this._proxy=D,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const d of this._insets.values())P.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,i,P,d){let h;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){h=l;break}if(!h)throw new Error("not a visible editor");const r=this,a=this._handlePool++,g=new w.Emitter,m=new w.Emitter,S=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,A.asWebviewUri)(r._initData,this._uuid,l)}get cspSource(){return r._initData.webviewCspSource}set options(l){this._options=l,r._proxy.$setOptions(a,l)}get options(){return this._options}set html(l){this._html=l,r._proxy.$setHtml(a,l)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(l){return r._proxy.$postMessage(a,l)}},f=new class{constructor(){this.editor=D,this.line=k,this.height=i,this.webview=S,this.onDidDispose=m.event}dispose(){r._insets.has(a)&&(r._insets.delete(a),r._proxy.$disposeEditorInset(a),m.fire(),m.dispose(),g.dispose())}};return this._proxy.$createEditorInset(a,h.id,h.value.document.uri,k+1,i,P||{},d.identifier,d.extensionLocation),this._insets.set(a,{editor:D,inset:f,onDidReceiveMessage:g}),f}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const i=this._insets.get(D);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(we[168],_e([0,1,3,63,139,4,6,22,29,15,51,24,36,159]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",d.Codicon.window,(0,A.localize)(0,null));var r;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var a;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function m(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=m;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(c,b,_){var p;const E=this.get(c.id);if(E)return E;const F=c;return F.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(p=F.openCommandActionDescriptor)!==null&&p!==void 0?p:{id:F.id},(0,C.getOrSet)(this.viewContainers,b,[]).push(F),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(c){for(const b of this.viewContainers.keys()){const _=this.viewContainers.get(b),p=_==null?void 0:_.indexOf(c);if(p!==-1){_==null||_.splice(p,1),_.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:b});return}}}get(c){return this.all.filter(b=>b.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(_=>(_==null?void 0:_.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===c)}}D.Registry.add(r.ViewContainersRegistry,new S);var f;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function l(s,c){var b,_,p,E;const F=(b=s.group)!==null&&b!==void 0?b:f.More,B=(_=c.group)!==null&&_!==void 0?_:f.More;return F!==B?F.localeCompare(B):((p=s.order)!==null&&p!==void 0?p:5)-((E=c.order)!==null&&E!==void 0?E:5)}class v extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(c,b){this.registerViews2([{views:c,viewContainer:b}])}registerViews2(c){c.forEach(({views:b,viewContainer:_})=>this.addViews(b,_)),this._onViewsRegistered.fire(c)}deregisterViews(c,b){const _=this.removeViews(c,b);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:b})}moveViews(c,b){for(const _ of this._views.keys())if(_!==b){const p=this.removeViews(c,_);p.length&&(this.addViews(p,b),this._onDidChangeContainer.fire({views:p,from:_,to:b}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const b of this._viewContainers){const _=(this._views.get(b)||[]).filter(p=>p.id===c)[0];if(_)return _}return null}getViewContainer(c){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(p=>p.id===c)[0])return b;return null}registerViewWelcomeContent(c,b){return this._viewWelcomeContents.add(c,b),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,b),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,b){const _=new Map;for(const[p,E]of b)this._viewWelcomeContents.add(c,E),_.set(p,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,E),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),_}getViewWelcomeContent(c){const b=[];return this._viewWelcomeContents.forEach(c,_=>b.push(_)),b.sort(l)}addViews(c,b){let _=this._views.get(b);_||(_=[],this._views.set(b,_),this._viewContainers.push(b));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,A.localize)(1,null,p.id));_.push(p)}}removeViews(c,b){const _=this._views.get(b);if(!_)return[];const p=[],E=[];for(const F of _)c.includes(F)?p.push(F):E.push(F);return p.length&&(E.length?this._views.set(b,E):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),p}}D.Registry.add(r.ViewsRegistry,new v),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(c,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,c),this._hasResolve=!!b,this.resolve=async _=>{var p,E;if(b&&!this.resolved){const F=await b(_);F&&(this.tooltip=(p=this.tooltip)!==null&&p!==void 0?p:F.tooltip,this.command=(E=this.command)!==null&&E!==void 0?E:F.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(we[169],_e([0,1,2,149,160,18,150,168]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(a){return(g,...m)=>a(g.get(I.ICommandService),...m)}class k{static execute(g,m){const S={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return g.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,g){return a.get(A.IWorkspacesService).removeRecentlyOpened([g])});class i{static execute(g,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?w.URI.parse(m):w.URI.file(m):m=w.URI.revive(m),g.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(i.ID,D(i.execute));class P{static execute(g,m){const S=typeof m=="string"?{extensionId:m}:m;return g.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,g){const m=a.get(A.IWorkspacesService);let S;const f=g.uri,l=g.label,v=g.remoteAuthority;return g.type==="workspace"?S={workspace:await m.getWorkspaceIdentifier(f),label:l,remoteAuthority:v}:g.type==="folder"?S={folderUri:f,label:l,remoteAuthority:v}:S={fileUri:f,label:l,remoteAuthority:v},m.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(A.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,g){const m=a.get(T.ILogService),S=a.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&m.setLevel(g)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(T.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,g){const m=a.get(C.IViewDescriptorService),S=m.getViewContainerById(g.destinationId);if(!!S){for(const f of g.viewIds){const l=m.getViewDescriptorById(f);(l==null?void 0:l.canMoveView)&&m.moveViewsToContainer([l],S,C.ViewVisibilityState.Default)}await a.get(C.IViewsService).openViewContainer(S.id,!0)}});class d{static execute(g,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):g.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:d.ID,handler:D(d.execute),description:{description:"Move Views",args:[]}});class h{static execute(g,m){return g.executeCommand("_workbench.open",m)}}h.ID="vscode.open",I.CommandsRegistry.registerCommand(h.ID,D(h.execute));class r{static execute(g,m,S,f,l){return g.executeCommand("_workbench.diff",[m,S,f])}}r.ID="vscode.diff",I.CommandsRegistry.registerCommand(r.ID,D(r.execute))}),define(we[170],_e([0,1,3,11,140]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,k,i){const P={command:C};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const h=this.pendingRequests.get(P.seq);if(h){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,A.localize)(0,null,i,C)};h(r)}},i)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,I.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,k)=>C.set(k,D)),await(0,I.timeout)(500),C.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(we[171],_e([0,1,8,2,13,24,19]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(n,u,o){return n.replace(C,function(s,c){return u&&c.length>0&&c[0]!=="_"?s:o&&o.hasOwnProperty(c)?o[c]:s})}e.formatPII=D;function k(n){const u={};for(const o of Object.keys(n))o.startsWith("!")||(u[o]=n[o]);return u}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let u=n.configuration.type;if(!!u)return u==="vslsShare"&&(u=n.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(u,"extensionhost")||(0,w.equalsIgnoreCase)(u,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function h(n,u,o){let s,c=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=b.exec(n);){let p=_.index+1,E=p+_[0].length;if(p<=u&&E>=o){s=_[0],c=p;break}}if(s){let p=/\w+/g,E=null;for(;(E=p.exec(s))&&!(E.index+1+c+E[0].length>=o););E&&(s=s.substring(0,p.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(r))}e.isUri=a;function g(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return I.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const u=I.URI.revive(n.path);if(u)return u.scheme===y.Schemas.file?u.fsPath:u.toString()}return n.path}function S(n,u){const o=u?g:m,s=(0,T.deepClone)(n);return l(s,(c,b)=>{c&&b&&(b.path=o(b))}),s}e.convertToDAPaths=S;function f(n,u){const o=u?g:m,s=(0,T.deepClone)(n);return l(s,(c,b)=>{!c&&b&&(b.path=o(b))}),s}e.convertToVSCPaths=f;function l(n,u){switch(n.type){case"event":const o=n;switch(o.event){case"output":u(!1,o.body.source);break;case"loadedSource":u(!1,o.body.source);break;case"breakpoint":u(!1,o.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":u(!0,s.arguments.source);break;case"breakpointLocations":u(!0,s.arguments.source);break;case"source":u(!0,s.arguments.source);break;case"gotoTargets":u(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(b=>u(!1,b));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(b=>u(!1,b.source));break;case"loadedSources":c.body.sources.forEach(b=>u(!1,b));break;case"scopes":c.body.scopes.forEach(b=>u(!1,b.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(b=>u(!1,b.source));break;case"setBreakpoints":c.body.breakpoints.forEach(b=>u(!1,b.source));break;default:break}break}}function v(n){return n.filter(u=>{var o;return!((o=u.presentation)===null||o===void 0?void 0:o.hidden)}).sort((u,o)=>u.presentation?o.presentation?u.presentation.group?o.presentation.group?u.presentation.group!==o.presentation.group?u.presentation.group.localeCompare(o.presentation.group):t(u.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(u.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=v;function t(n,u){return typeof n!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:n-u}}),define(we[73],_e([0,1,28,19,13,21,63]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(_){_[_.Markdown=1]="Markdown",_[_.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var k;(function(_){_[_.Idle=1]="Idle",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.CellClearOutput=3]="CellClearOutput",_[_.CellsClearOutput=4]="CellsClearOutput",_[_.ChangeLanguage=5]="ChangeLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.Unknown=12]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata"})(h=e.CellEditType||(e.CellEditType={}));function r(_){const p=a.parse(_);return p?p.notebook.toString():_.toString()}e.getCellUndoRedoComparisonKey=r;var a;(function(_){_.scheme=I.Schemas.vscodeNotebookCell;const p=/^ch(\d{7,})/;function E(fe,V){return fe.with({scheme:_.scheme,fragment:`ch${V.toString().padStart(7,"0")}${fe.scheme!==I.Schemas.file?fe.scheme:""}`})}_.generate=E;function F(fe){if(fe.scheme===_.scheme){const V=p.exec(fe.fragment);if(!!V)return{handle:Number(V[1]),notebook:fe.with({scheme:fe.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}_.parse=F;function B(fe,V){return fe.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${V.toString().padStart(7,"0")}${fe.scheme!==I.Schemas.file?fe.scheme:""}`})}_.generateCellMetadataUri=B;function Y(fe){if(fe.scheme===I.Schemas.vscodeNotebookCellMetadata){const V=p.exec(fe.fragment);if(!!V)return{handle:Number(V[1]),notebook:fe.with({scheme:fe.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}_.parseCellMetadataUri=Y})(a=e.CellUri||(e.CellUri={}));const g=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(_){var p,E;return(E=(p=g.get(_))===null||p===void 0?void 0:p.alwaysSecure)!==null&&E!==void 0?E:!1}e.mimeTypeIsAlwaysSecure=m;function S(_){var p,E;return(E=(p=g.get(_))===null||p===void 0?void 0:p.supportedByCore)!==null&&E!==void 0?E:!1}e.mimeTypeSupportedByCore=S;function f(_){var p,E;return(E=(p=g.get(_))===null||p===void 0?void 0:p.mergeable)!==null&&E!==void 0?E:!1}e.mimeTypeIsMergeable=f;function l(_,p){return T.isWindows&&(_=_.replace(/\//g,"\\"),p=p.replace(/\//g,"\\")),w.match(_,p)}function v(_,p,E){let F=0;for(let B=0;B<p.length;B++){if(l(p[B],_))return F;F++}for(let B=0;B<E.length;B++){if(l(E[B],_))return F;F++}return F}function t(_,p,E){return _.sort((F,B)=>v(F,p,E)-v(B,p,E))}e.sortMimeTypes=t;function n(_,p,E,F=(B,Y)=>B===Y){const B=[];function Y(z,ee,$){if(!(ee===0&&$.length===0)){const R=B[B.length-1];R&&R.start+R.deleteCount===z?(R.deleteCount+=ee,R.toInsert.push(...$)):B.push({start:z,deleteCount:ee,toInsert:$})}}let fe=0,V=0;for(;;){if(fe===_.length){Y(fe,0,p.slice(V));break}if(V===p.length){Y(fe,_.length-fe,[]);break}const z=_[fe],ee=p[V];if(F(z,ee)){fe+=1,V+=1;continue}E(ee)?(Y(fe,1,[]),fe+=1):(Y(fe,0,[ee]),V+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(_){_.default="default",_.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(_){const p=_;return!!((typeof p.include=="string"||w.isRelativePattern(p.include))&&(typeof p.exclude=="string"||w.isRelativePattern(p.exclude)))}e.isDocumentExcludePattern=o;function s(_,p,E){if(Array.isArray(_.viewType)&&_.viewType.indexOf(p)>=0||_.viewType===p)return!0;if(_.filenamePattern){let F=o(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,B=o(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(w.match(F,(0,A.basename)(E.fsPath).toLowerCase()))return!(B&&w.match(B,(0,A.basename)(E.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(p){this.textModel=p}getElements(){const p=new Int32Array(this.textModel.cells.length);for(let E=0;E<this.textModel.cells.length;E++)p[E]=this.textModel.cells[E].getHashValue();return p}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var b;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={})),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX="notebook/"}),define(we[172],_e([0,1,142,4,63]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[173],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=w;function I(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=I}),define(we[96],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=I;var A;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=T;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const d=P[1];if(d.parent){if(this.items.has(d.parent)){const h=this.items.get(d.parent);h.children.add(d.item.extId);const r=this.createItem(d,h);this.items.set(d.item.extId,r),i.add(r)}}else{this.roots.add(d.item.extId);const h=this.createItem(d);this.items.set(d.item.extId,h),i.add(h)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=P[1],h=this.items.get(d.extId);if(!h)break;d.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(h,d),i.update(h);break}case 2:{const d=this.items.get(P[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const h=[[P[1]]];for(;h.length;)for(const r of h.pop()){const a=this.items.get(r);a&&(h.push(a.children),this.items.delete(r),i.remove(a,a!==d),a.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(we[174],_e([0,1,13,46,10,24,21,58,143]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,d,h){this._contributedVariables=new Map,this._context=P,this._labelService=d,h&&(this._envVariablesPromise=h.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(y.isWindows){const d=Object.create(null);return Object.keys(P).forEach(h=>{d[h.toLowerCase()]=P[h]}),d}return P}resolveWithEnvironment(P,d,h){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,h)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,h,r){const a=T.deepClone(d);return y.isWindows&&a.windows?Object.keys(a.windows).forEach(g=>a[g]=a.windows[g]):y.isMacintosh&&a.osx?Object.keys(a.osx).forEach(g=>a[g]=a.osx[g]):y.isLinux&&a.linux&&Object.keys(a.linux).forEach(g=>a[g]=a.linux[g]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,a,h,r)}async resolveAnyAsync(P,d,h){return this.resolveAnyBase(P,d,h)}async resolveAnyMap(P,d,h){const r=new Map;return{newConfig:await this.resolveAnyBase(P,d,h,r),resolvedVariables:r}}resolveWithInteractionReplace(P,d,h,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,h,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,h,r,a){if(A.isString(h))return this.resolveString(P,d,h,r,a);if(A.isArray(h))return h.map(g=>this.recursiveResolve(P,d,g,r,a));if(A.isObject(h)){let g=Object.create(null);return Object.keys(h).forEach(m=>{const S=this.resolveString(P,d,m,r,a);g[S]=this.recursiveResolve(P,d,h[m],r,a)}),g}return h}resolveString(P,d,h,r,a){return h.replace(k.VARIABLE_REGEXP,(m,S)=>{if(S.includes(k.VARIABLE_LHS))return m;let f=this.evaluateSingleVariable(P,m,S,d,r);return a&&a.set(S,f),f})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,h,r,a){let g;const m=h.split(":");m.length>1&&(h=m[0],g=m[1]);const S=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,d))},f=()=>{const v=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,d,w.basename(v)))},l=()=>{if(g){const v=this._context.getFolderUri(g);if(v)return v;throw new Error((0,D.localize)(2,null,d,g))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,d)):new Error((0,D.localize)(4,null,d))};switch(h){case"env":if(g){if(P){const v=P[y.isWindows?g.toLowerCase():g];if(A.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,d));case"config":if(g){const v=this._context.getConfigurationValue(r,g);if(A.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,d,g));if(A.isObject(v))throw new Error((0,D.localize)(7,null,d,g));return v}throw new Error((0,D.localize)(8,null,d));case"command":return this.resolveFromMap(d,g,a,"command");case"input":return this.resolveFromMap(d,g,a,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return r||g?(0,C.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(l()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,d));case"file":return S();case"fileWorkspaceFolder":return f();case"relativeFile":return r||g?w.relative(this.fsPath(l()),S()):S();case"relativeFileDirname":const n=w.dirname(S());if(r||g){const c=w.relative(this.fsPath(l()),n);return c.length===0?".":c}return n;case"fileDirname":return w.dirname(S());case"fileExtname":return w.extname(S());case"fileBasename":return w.basename(S());case"fileBasenameNoExtension":const u=w.basename(S());return u.slice(0,u.length-w.extname(u).length);case"fileDirnameBasename":return w.basename(w.dirname(S()));case"execPath":const o=this._context.getExecPath();return o||d;case"execInstallFolder":const s=this._context.getAppRoot();return s||d;case"pathSeparator":return w.sep;default:try{const c=g?`${h}:${g}`:h;return this.resolveFromMap(d,c,a,void 0)}catch(c){return d}}}}resolveFromMap(P,d,h,r){if(d&&h){const a=r===void 0?h[d]:h[r+":"+d];if(typeof a=="string")return a;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[175],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var I;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(we[176],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,15,83,230,57,24,10,2,32,62,144,90,73,176,7]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(be){function de(K){const{selectionStartLineNumber:Re,selectionStartColumn:Ie,positionLineNumber:Qe,positionColumn:Ze}=K,ut=new a.Position(Re-1,Ie-1),ht=new a.Position(Qe-1,Ze-1);return new a.Selection(ut,ht)}be.to=de;function oe(K){const{anchor:Re,active:Ie}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}be.from=oe})(g=e.Selection||(e.Selection={}));var m;(function(be){function de(K){if(!!K){const{start:Re,end:Ie}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}be.from=de;function oe(K){if(!!K){const{startLineNumber:Re,startColumn:Ie,endLineNumber:Qe,endColumn:Ze}=K;return new a.Range(Re-1,Ie-1,Qe-1,Ze-1)}}be.to=oe})(m=e.Range||(e.Range={}));var S;(function(be){function de(oe){switch(oe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}be.to=de})(S=e.TokenType||(e.TokenType={}));var f;(function(be){function de(K){return new a.Position(K.lineNumber-1,K.column-1)}be.to=de;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}be.from=oe})(f=e.Position||(e.Position={}));var l;(function(be){function de(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}be.from=de;function oe(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}be.to=oe})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(be){function de(K){let Re;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Re,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,w.coalesce)(K.tags.map(l.from)):void 0})}be.from=de;function oe(K){var Re;const Ie=new a.Diagnostic(m.to(K),K.message,n.to(K.severity));return Ie.source=K.source,Ie.code=(0,C.isString)(K.code)?K.code:(Re=K.code)===null||Re===void 0?void 0:Re.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Ie.tags=K.tags&&(0,w.coalesce)(K.tags.map(l.to)),Ie}be.to=oe})(v=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function de(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}be.from=de;function oe(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,m.to(K)),K.message)}be.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function de(K){switch(K){case a.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}be.from=de;function oe(K){switch(K){case d.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}be.to=oe})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(be){function de(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}be.from=de;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=oe})(u=e.ViewColumn||(e.ViewColumn={}));function o(be){return typeof be.range!="undefined"}function s(be){return be.length===0?!0:!!o(be[0])}e.isDecorationOptionsArr=s;var c;(function(be){function de(Ze){return Ze.map(be.from)}be.fromMany=de;function oe(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function K(Ze){let ut;if(oe(Ze)){const{language:ft,value:at}=Ze;ut={value:"```"+ft+`
`+at+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ze)?ut={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ut={value:Ze}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Ye=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Re(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new A.Renderer;return ot.link=Ye,ot.image=ft=>Ye(I.parseHrefAndDimensions(ft).href),A(ut.value,{renderer:ot}),ut}be.from=K;function Re(Ze,ut){if(!Ze)return Ze;let ht;try{ht=(0,T.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Ye=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=ot,Ye=!0,ft}else return}),Ye?JSON.stringify(ht):Ze}function Ie(Ze){const ut=new a.MarkdownString(Ze.value,Ze.supportThemeIcons);return ut.isTrusted=Ze.isTrusted,ut}be.to=Ie;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:be.from(Ze)}be.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function b(be){return s(be)?be.map(de=>({range:m.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?c.fromMany(de.hoverMessage):de.hoverMessage?c.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):be.map(de=>({range:m.from(de)}))}e.fromRangeOrRangeWithMessage=b;function _(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=_;var p;(function(be){function de(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?_(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}be.from=de})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(be){function de(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?_(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?p.from(oe.before):void 0,after:oe.after?p.from(oe.after):void 0}}be.from=de})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(be){function de(oe){if(typeof oe=="undefined")return oe;switch(oe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=de})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(be){function de(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?F.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?E.from(oe.light):void 0,dark:oe.dark?E.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?_(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?p.from(oe.before):void 0,after:oe.after?p.from(oe.after):void 0}}be.from=de})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(be){function de(K){return{text:K.newText,eol:K.newEol&&te.from(K.newEol),range:m.from(K.range)}}be.from=de;function oe(K){const Re=new a.TextEdit(m.to(K.range),K.text);return Re.newEol=typeof K.eol=="undefined"?void 0:te.to(K.eol),Re}be.to=oe})(Y=e.TextEdit||(e.TextEdit={}));var fe;(function(be){function de(K,Re,Ie){var Qe,Ze,ut;const ht={edits:[]};if(K instanceof a.WorkspaceEdit)for(let Ye of K._allEntries())if(Ye._type===1)ht.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const ot=Re==null?void 0:Re.getDocument(Ye.uri);ht.edits.push({_type:2,resource:Ye.uri,edit:Y.from(Ye.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Ye.metadata})}else Ye._type===3?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Qe=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Ye._type===4?(Ye.newOutputs&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(ze.from)}}),Ye.newMetadata&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:8,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Ze=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(he.from)}}):Ye._type===6&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:7,outputId:Ye.outputId,items:((ut=Ye.newOutputItems)===null||ut===void 0?void 0:ut.map(ye.from))||[],append:Ye.append}});return ht}be.from=de;function oe(K){const Re=new a.WorkspaceEdit;for(const Ie of K.edits)Ie.edit?Re.replace(D.URI.revive(Ie.resource),m.to(Ie.edit.range),Ie.edit.text):Re.renameFile(D.URI.revive(Ie.oldUri),D.URI.revive(Ie.newUri),Ie.options);return Re}be.to=oe})(fe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(be){const de=Object.create(null);de[a.SymbolKind.File]=0,de[a.SymbolKind.Module]=1,de[a.SymbolKind.Namespace]=2,de[a.SymbolKind.Package]=3,de[a.SymbolKind.Class]=4,de[a.SymbolKind.Method]=5,de[a.SymbolKind.Property]=6,de[a.SymbolKind.Field]=7,de[a.SymbolKind.Constructor]=8,de[a.SymbolKind.Enum]=9,de[a.SymbolKind.Interface]=10,de[a.SymbolKind.Function]=11,de[a.SymbolKind.Variable]=12,de[a.SymbolKind.Constant]=13,de[a.SymbolKind.String]=14,de[a.SymbolKind.Number]=15,de[a.SymbolKind.Boolean]=16,de[a.SymbolKind.Array]=17,de[a.SymbolKind.Object]=18,de[a.SymbolKind.Key]=19,de[a.SymbolKind.Null]=20,de[a.SymbolKind.EnumMember]=21,de[a.SymbolKind.Struct]=22,de[a.SymbolKind.Event]=23,de[a.SymbolKind.Operator]=24,de[a.SymbolKind.TypeParameter]=25;function oe(Re){return typeof de[Re]=="number"?de[Re]:6}be.from=oe;function K(Re){for(const Ie in de)if(de[Ie]===Re)return Number(Ie);return a.SymbolKind.Property}be.to=K})(V=e.SymbolKind||(e.SymbolKind={}));var z;(function(be){function de(K){switch(K){case a.SymbolTag.Deprecated:return 1}}be.from=de;function oe(K){switch(K){case 1:return a.SymbolTag.Deprecated}}be.to=oe})(z=e.SymbolTag||(e.SymbolTag={}));var ee;(function(be){function de(K){return{name:K.name,kind:V.from(K.kind),tags:K.tags&&K.tags.map(z.from),containerName:K.containerName,location:U.from(K.location)}}be.from=de;function oe(K){const Re=new a.SymbolInformation(K.name,V.to(K.kind),K.containerName,U.to(K.location));return Re.tags=K.tags&&K.tags.map(z.to),Re}be.to=oe})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(be){function de(K){var Re,Ie;const Qe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:V.from(K.kind),tags:(Ie=(Re=K.tags)===null||Re===void 0?void 0:Re.map(z.from))!==null&&Ie!==void 0?Ie:[]};return K.children&&(Qe.children=K.children.map(de)),Qe}be.from=de;function oe(K){const Re=new a.DocumentSymbol(K.name,K.detail,V.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,w.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map(z.to)),K.children&&(Re.children=K.children.map(oe)),Re}be.to=oe})($=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(be){function de(oe){const K=new a.CallHierarchyItem(V.to(oe.kind),oe.name,oe.detail||"",D.URI.revive(oe.uri),m.to(oe.range),m.to(oe.selectionRange));return K._sessionId=oe._sessionId,K._itemId=oe._itemId,K}be.to=de})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(be){function de(oe){return new a.CallHierarchyIncomingCall(R.to(oe.from),oe.fromRanges.map(K=>m.to(K)))}be.to=de})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function de(oe){return new a.CallHierarchyOutgoingCall(R.to(oe.to),oe.fromRanges.map(K=>m.to(K)))}be.to=de})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(be){function de(K){return{range:K.range&&m.from(K.range),uri:K.uri}}be.from=de;function oe(K){return new a.Location(D.URI.revive(K.uri),m.to(K.range))}be.to=oe})(U=e.location||(e.location={}));var G;(function(be){function de(K){const Re=K,Ie=K;return{originSelectionRange:Re.originSelectionRange?m.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ie.uri,range:m.from(Re.targetRange?Re.targetRange:Ie.range),targetSelectionRange:Re.targetSelectionRange?m.from(Re.targetSelectionRange):void 0}}be.from=de;function oe(K){return{targetUri:D.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}be.to=oe})(G=e.DefinitionLink||(e.DefinitionLink={}));var X;(function(be){function de(K){return{range:m.from(K.range),contents:c.fromMany(K.contents)}}be.from=de;function oe(K){return new a.Hover(K.contents.map(c.to),m.to(K.range))}be.to=oe})(X=e.Hover||(e.Hover={}));var se;(function(be){function de(K){return{range:m.from(K.range),expression:K.expression}}be.from=de;function oe(K){return new a.EvaluatableExpression(m.to(K.range),K.expression)}be.to=oe})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(be){function de(K){if(K instanceof a.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}be.from=de;function oe(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}be.to=oe})(pe=e.InlineValue||(e.InlineValue={}));var Te;(function(be){function de(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}be.from=de;function oe(K){return new a.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}be.to=oe})(Te=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(be){function de(K){return{range:m.from(K.range),kind:K.kind}}be.from=de;function oe(K){return new a.DocumentHighlight(m.to(K.range),K.kind)}be.to=oe})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ae;(function(be){function de(oe){switch(oe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}be.to=de})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(be){function de(oe){return{triggerKind:Ae.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}be.to=de})(We=e.CompletionContext||(e.CompletionContext={}));var x;(function(be){function de(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}be.from=de;function oe(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}be.to=oe})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(be){const de=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function oe(Ie){var Qe;return(Qe=de.get(Ie))!==null&&Qe!==void 0?Qe:9}be.from=oe;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Re(Ie){var Qe;return(Qe=K.get(Ie))!==null&&Qe!==void 0?Qe:a.CompletionItemKind.Property}be.to=Re})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(be){function de(oe,K){var Re;const Ie=new a.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Ie.label2=oe.label),Ie.insertText=oe.insertText,Ie.kind=q.to(oe.kind),Ie.tags=(Re=oe.tags)===null||Re===void 0?void 0:Re.map(x.to),Ie.detail=oe.detail,Ie.documentation=I.isMarkdownString(oe.documentation)?c.to(oe.documentation):oe.documentation,Ie.sortText=oe.sortText,Ie.filterText=oe.filterText,Ie.preselect=oe.preselect,Ie.commitCharacters=oe.commitCharacters,k.Range.isIRange(oe.range)?Ie.range=m.to(oe.range):typeof oe.range=="object"&&(Ie.range={inserting:m.to(oe.range.insert),replacing:m.to(oe.range.replace)}),Ie.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Ie.insertText=new a.SnippetString(oe.insertText):(Ie.insertText=oe.insertText,Ie.textEdit=Ie.range instanceof a.Range?new a.TextEdit(Ie.range,Ie.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Ie.additionalTextEdits=oe.additionalTextEdits.map(Qe=>Y.to(Qe))),Ie.command=K&&oe.command?K.fromInternal(oe.command):void 0,Ie}be.to=de})(ne=e.CompletionItem||(e.CompletionItem={}));var le;(function(be){function de(K){return{label:K.label,documentation:K.documentation?c.fromStrict(K.documentation):void 0}}be.from=de;function oe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?c.to(K.documentation):K.documentation}}be.to=oe})(le=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(be){function de(K){return{label:K.label,documentation:K.documentation?c.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(le.from):[],activeParameter:K.activeParameter}}be.from=de;function oe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?c.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(le.to):[],activeParameter:K.activeParameter}}be.to=oe})(me=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(be){function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(me.from):[]}}be.from=de;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(me.to):[]}}be.to=oe})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(be){function de(K){var Re;return{text:K.text,range:m.from(K.range),kind:ge.from((Re=K.kind)!==null&&Re!==void 0?Re:a.InlineHintKind.Other),description:K.description&&c.fromStrict(K.description),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}be.from=de;function oe(K){const Re=new a.InlineHint(K.text,m.to(K.range),ge.to(K.kind));return Re.whitespaceAfter=K.whitespaceAfter,Re.whitespaceBefore=K.whitespaceBefore,Re.description=I.isMarkdownString(K.description)?c.to(K.description):K.description,Re}be.to=oe})(Oe=e.InlineHint||(e.InlineHint={}));var ge;(function(be){function de(K){return K}be.from=de;function oe(K){return K}be.to=oe})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(be){function de(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}be.from=de;function oe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?D.URI.parse(K.url,!0):D.URI.revive(K.url)}catch(Ie){}return new a.DocumentLink(m.to(K.range),Re)}be.to=oe})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(be){function de(K){const Re=new a.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=Y.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(Ie=>Y.to(Ie))),Re}be.to=de;function oe(K){return{label:K.label,textEdit:K.textEdit?Y.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>Y.from(Re)):void 0}}be.from=oe})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(be){function de(K){return new a.Color(K[0],K[1],K[2],K[3])}be.to=de;function oe(K){return[K.red,K.green,K.blue,K.alpha]}be.from=oe})($e=e.Color||(e.Color={}));var Ee;(function(be){function de(K){return{range:m.from(K.range)}}be.from=de;function oe(K){return new a.SelectionRange(m.to(K.range))}be.to=oe})(Ee=e.SelectionRange||(e.SelectionRange={}));var je;(function(be){function de(oe){switch(oe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}be.to=de})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(be){function de(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}be.from=de;function oe(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}be.to=oe})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(be){function de(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}be.from=de;function oe(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}be.to=oe})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(be){function de(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(be){function de(oe){const K={start:oe.start+1,end:oe.end+1};return oe.kind&&(K.kind=He.from(oe.kind)),K}be.from=de})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(be){function de(oe){if(oe)switch(oe){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=de})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(be){function de(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?m.from(oe.selection):void 0,override:typeof oe.override=="boolean"?P.EditorOverride.DISABLED:void 0}}be.from=de})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(be){function de(K){return K instanceof a.RelativePattern||typeof K=="string"?K:oe(K)?new a.RelativePattern(K.base,K.pattern):K}be.from=de;function oe(K){const Re=K;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var W;(function(be){function de(oe){if(oe){if(Array.isArray(oe))return oe.map(de);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Xe.from(K.pattern),exclusive:K.exclusive}}}else return}be.from=de})(W=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(be){function de(K){return{start:K.start,end:K.end}}be.from=de;function oe(K){return new a.NotebookRange(K.start,K.end)}be.to=oe})(ie=e.NotebookRange||(e.NotebookRange={}));var ce;(function(be){function de(oe){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},oe),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=de})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(be){function de(K){return K}be.from=de;function oe(K){return new a.NotebookDocumentMetadata().with(K)}be.to=oe})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Z;(function(be){function de(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}be.to=de;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}be.from=oe})(Z=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(be){function de(K){switch(K){case a.NotebookCellKind.Markdown:return h.CellKind.Markdown;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=de;function oe(K){switch(K){case h.CellKind.Markdown:return a.NotebookCellKind.Markdown;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}be.to=oe})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(be){function de(K){var Re;return{cellKind:ae.from(K.kind),language:K.language,source:K.source,metadata:Object.assign(Object.assign({},K.metadata),Z.from((Re=K.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:K.outputs?K.outputs.map(ze.from):[]}}be.from=de;function oe(K){return new a.NotebookCellData(ae.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ze.to):void 0,K.metadata?ce.to(K.metadata):void 0)}be.to=oe})(he=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(be){function de(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}be.from=de;function oe(K){return new a.NotebookCellOutputItem(K.mime,K.value,K.metadata)}be.to=oe})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ze;(function(be){function de(K){return{outputId:K.id,outputs:K.outputs.map(ye.from),metadata:K.metadata}}be.from=de;function oe(K){const Re=K.outputs.map(ye.to);return new a.NotebookCellOutput(Re,K.outputId,K.metadata)}be.to=oe})(ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Be;(function(be){function de(Ie){if(Ie!=null){if(Ie instanceof a.RelativePattern||typeof Ie=="string")return Ie;if(Re(Ie))return new a.RelativePattern(Ie.base,Ie.pattern);if(K(Ie))return{include:Xe.from(Ie.include)||void 0,exclude:Xe.from(Ie.exclude)||void 0}}}be.from=de;function oe(Ie){return typeof Ie=="string"?Ie:Re(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}be.to=oe;function K(Ie){const Qe=Ie,Ze=Xe.from(Qe.include);if(!(Ze&&Ze instanceof a.RelativePattern||typeof Ze=="string"))return!1;const ut=Xe.from(Qe.exclude);return!!(ut&&ut instanceof a.RelativePattern||typeof ut=="string")}function Re(Ie){const Qe=Ie;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(Be=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(be){function de(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?p.from(oe.top):void 0}}be.from=de})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(be){function de(oe,K,Re){const Ie=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ie,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}be.from=de})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(be){function de(oe){var K,Re;return{transientOutputs:(K=oe==null?void 0:oe.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:Object.assign(Object.assign({},oe==null?void 0:oe.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Re=oe==null?void 0:oe.transientDocumentMetadata)!==null&&Re!==void 0?Re:{}}}be.from=de})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(be){function de(K){var Re;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Re=K.provides)!==null&&Re!==void 0?Re:[]}}be.from=de;function oe(K){return{uri:D.URI.revive(K.uri),provides:K.provides}}be.to=oe})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(be){function de(K){return{message:c.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?U.from(K.location):void 0}}be.from=de;function oe(K){const Re=new a.TestMessage(typeof K.message=="string"?K.message:c.to(K.message));return Re.severity=K.severity,Re.actualOutput=K.actualOutput,Re.expectedOutput=K.expectedOutput,Re}be.to=oe})(it=e.TestMessage||(e.TestMessage={}));var Je;(function(be){function de(Ie){var Qe,Ze;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:(Qe=Ie.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Ie.description||null,runnable:(Ze=Ie.runnable)!==null&&Ze!==void 0?Ze:!0,error:Ie.error&&c.fromStrict(Ie.error)||null}}be.from=de;function oe(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:!1,description:Ie.description||null,error:null,runnable:!0}}be.fromResultSnapshot=oe;function K(Ie){return{id:Ie.extId,label:Ie.label,uri:D.URI.revive(Ie.uri),range:m.to(Ie.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description||void 0,runnable:Ie.runnable}}be.toPlain=K;function Re(Ie){const Qe=new a.TestItemImpl(Ie.extId,Ie.label,D.URI.revive(Ie.uri),void 0);return Qe.range=m.to(Ie.range||void 0),Qe.debuggable=Ie.debuggable,Qe.description=Ie.description||void 0,Qe.runnable=Ie.runnable,Qe}be.to=Re})(Je=e.TestItem||(e.TestItem={}));var mt;(function(be){const de=(K,Re)=>Object.assign(Object.assign({},Je.toPlain(K.item)),{taskStates:K.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(it.to)})),children:K.children.map(Ie=>Re.get(Ie)).filter(C.isDefined).map(Ie=>de(Ie,Re))});function oe(K){const Re=[],Ie=new Map;for(const Qe of K.items)Ie.set(Qe.item.extId,Qe),Qe.direct&&Re.push(Qe);return{completedAt:K.completedAt,results:Re.map(Qe=>de(Qe,Ie))}}be.to=oe})(mt=e.TestResults||(e.TestResults={}));var bt;(function(be){function de(oe){switch(oe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}be.to=de})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[177],_e([0,1,2,12,7,9,45]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,P,d={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,P,d)=>{const r={dispose:this._callbacks.push([i,P,k])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(k,i){const P=w.URI.revive(k);let d=!1;const h=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let a of[...this._callbacks]){if(d)break;const g=this._documents.getDocument(P),m=await this._deliverEventAsyncAndBlameBadListeners(a,{document:g,reason:T.TextDocumentSaveReason.to(i)});r.push(m)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([k,i,P],d){const h=this._badListeners.get(k);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,i,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(k);this._badListeners.set(k,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,P,d){const h=[],r=Date.now(),{document:a,reason:g}=d,{version:m}=a,S=Object.freeze({document:a,reason:g,waitUntil(f){if(Object.isFrozen(h))throw(0,I.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(f))}});try{i.apply(P,[S])}catch(f){return Promise.reject(f)}return Object.freeze(h),new Promise((f,l)=>{const v=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(v),f(t)}).catch(t=>{clearTimeout(v),l(t)})}).then(f=>{const l={edits:[]};for(const v of f)if(Array.isArray(v)&&v.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:u}of v)l.edits.push({_type:2,resource:a.uri,edit:{range:u&&T.Range.from(u),text:t,eol:n&&T.EndOfLine.from(n)}});if(l.edits.length!==0)return m===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(we[178],_e([0,1,3,11,28,2,9,7]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(P,d,h,r,a){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,h&&(this._config+=1),r&&(this._config+=2),a&&(this._config+=4);const g=(0,A.parse)(d),m=P(S=>{if(!h)for(let f of S.created){const l=T.URI.revive(f);g(l.fsPath)&&this._onDidCreate.fire(l)}if(!r)for(let f of S.changed){const l=T.URI.revive(f);g(l.fsPath)&&this._onDidChange.fire(l)}if(!a)for(let f of S.deleted){const l=T.URI.revive(f);g(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,d,h){this._logService=d,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,d,h,r){return new D(this._onFileSystemEvent.event,P,d,h,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,d){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(h=>({oldUri:T.URI.revive(h.source),newUri:T.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,d){return(h,r,a)=>{const g=function(S){h.call(r,S)};return g.extension=P,d.event(g,void 0,a)}}async $onWillRunFileOperation(P,d,h,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(a=>({oldUri:T.URI.revive(a.source),newUri:T.URI.revive(a.target)}))},h,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(a=>T.URI.revive(a.target))},h,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(a=>T.URI.revive(a.target))},h,r)}}async _fireWillEvent(P,d,h,r){const a=new Set,g=[];if(await P.fireAsync(d,r,async(S,f)=>{var l;const v=Date.now(),t=await Promise.resolve(S);t instanceof C.WorkspaceEdit&&(g.push(t),a.add((l=f.extension.displayName)!==null&&l!==void 0?l:f.extension.identifier.value)),Date.now()-v>h&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),!r.isCancellationRequested&&g.length!==0){const m={edits:[]};for(let S of g){let{edits:f}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=k}),define(we[179],_e([0,1,19,24,2,9,7,73]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(d,h,r,a){this.start=d,this.deletedCount=h,this.deletedItems=r,this.items=a}static asApiEvents(d){return d.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(r=>r.apiCell)}))}}class k{constructor(d,h,r){var a;this._notebook=d,this._extHostDocument=h,this._cellData=r,this.handle=r.handle,this.uri=A.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(a=r.metadata)!==null&&a!==void 0?a:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const d=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._cell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,h,r){const a=r.map(T.NotebookCellOutputItem.to),g=this._outputs.find(m=>m.id===d);g&&(h||(g.outputs.length=0),g.outputs.push(...a))}setMetadata(d){this._internalMetadata=d,this._metadata=T.NotebookCellMetadata.to(d),this._previousResult=T.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=k;class i{constructor(d,h,r,a,g,m,S){this._proxy=d,this._textDocumentsAndEditors=h,this._textDocuments=r,this._emitter=a,this._viewType=g,this._metadata=m,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===w.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(h){return h=d._validateIndex(h),d._cells[h].apiCell},getCells(h){return(h?d._getCells(h):d._cells).map(a=>a.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,h){this._versionId=d.versionId,this._isDirty=h;for(const r of d.rawEvents)r.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===C.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){return d.start<0&&(d=d.with({start:0})),d.end>this._cells.length&&(d=d.with({end:this._cells.length})),d}_getCells(d){d=this._validateRange(d);const h=[];for(let r=d.start;r<d.end;r++)h.push(this._cells[r]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,h){if(!this._disposed){const r=[],a=[],g=[];d.reverse().forEach(m=>{const f=m[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return h||a.push(k.asModelAddData(this.apiNotebook,t)),n}),l=new D(m[0],m[1],[],f),v=this._cells.splice(m[0],m[1],...f);for(let t of v)g.push(t.uri),l.deletedItems.push(t.apiCell);r.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:g}),h||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(r)}))}}_moveCell(d,h){const r=this._cells.splice(d,1);this._cells.splice(h,0,...r);const a=[new D(d,1,r.map(g=>g.apiCell),[]),new D(h,0,[],r)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_setCellOutputs(d,h){const r=this._cells[d];r.setOutputs(h),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,h,r,a){const g=this._cells[d];g.setOutputItems(h,r,a),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(d,h){const r=this._cells[d];r.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(r.uri,h)}_changeCellMetadata(d,h){var r;const a=this._cells[d],g=a.internalMetadata,m=a.apiCell.metadata;a.setMetadata(h);const S=a.apiCell.metadata;if((0,I.equals)(m,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:a.apiCell})),g.runState!==h.runState){const f=(r=h.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,executionState:f}))}}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(h=>h.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(we[180],_e([0,1,7,9]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,k){this._throwIfFinalized(),!(C===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:k.map(I.NotebookCellData.from)})}}class T{constructor(C,D,k,i,P,d){this.id=C,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,k){C._proxy.$tryRevealRange(C.id,I.NotebookRange.from(D),k!=null?k:w.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const k=new A(this.document.version);return D(k),C._applyEdit(k.finalize())},setDecorations(D,k){return C.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let i=0;i<C.cellEdits.length;i++){if(k<0){D.push(C.cellEdits[i]),k++;continue}const d=D[k],h=C.cellEdits[i];if(d.editType===1&&h.editType===1&&d.index===h.index){d.cells.push(...C.cellEdits[i].cells),d.count+=C.cellEdits[i].count;continue}D.push(C.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=T}),define(we[181],_e([0,1,9,154,134,20,52]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,h){const r=this._handles++,{title:a,location:g,cancellable:m}=d,S={label:(0,A.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:w.ProgressLocation.from(g),title:a,source:S,cancellable:m},P),this._withProgress(r,h,!!m)}_withProgress(P,d,h){let r;h&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const a=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let g;try{g=d(new k(this._proxy,P),h&&r?r.token:T.CancellationToken.None)}catch(m){throw a(P),m}return g.then(m=>a(P),m=>a(P)),g}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function D(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class k extends I.Progress{constructor(P,d){super(h=>this.throttledReport(h));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,y.throttle)(100,(i,P)=>D(i,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(we[97],_e([0,1,42,12,54,9,7]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(d,h){const r=C._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=C,C._Keys=new A.IdGenerator("TextEditorDecorationType");class D{constructor(d,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,h){this._throwIfFinalized();let r=null;if(d instanceof y.Position)r=new y.Range(d,d);else if(d instanceof y.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,h,!1)}insert(d,h){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),h,!0)}delete(d){this._throwIfFinalized();let h=null;if(d instanceof y.Range)h=d;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(d,h,r){const a=this._document.validateRange(d);this._collectedEdits.push({range:a,text:h,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=D;class k{constructor(d,h,r,a){this._proxy=d,this._id=h,this._accept(r),this._logService=a;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(m){g._setTabSize(m)},get insertSpaces(){return g._insertSpaces},set insertSpaces(m){g._setInsertSpaces(m)},get cursorStyle(){return g._cursorStyle},set cursorStyle(m){g._setCursorStyle(m)},get lineNumbers(){return g._lineNumbers},set lineNumbers(m){g._setLineNumbers(m)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const h=Math.floor(d);return h>0?h:null}if(typeof d=="string"){const h=parseInt(d,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(d){const h=this._validateTabSize(d);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const h=this._validateInsertSpaces(d);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const h={};let r=!1;if(typeof d.tabSize!="undefined"){const a=this._validateTabSize(d.tabSize);a==="auto"?(r=!0,h.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,r=!0,h.tabSize=a)}if(typeof d.insertSpaces!="undefined"){const a=this._validateInsertSpaces(d.insertSpaces);a==="auto"?(r=!0,h.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,r=!0,h.insertSpaces=a)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,h.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,h.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(d){d.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=k;class i{constructor(d,h,r,a,g,m,S,f){this.id=d,this._proxy=h,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new k(this._proxy,this.id,m,r),this._visibleRanges=S,this._viewColumn=f;const l=this;this.value=Object.freeze({get document(){return a.getValue()},set document(v){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(v){if(!(v instanceof y.Selection))throw(0,I.illegalArgument)("selection");l._selections=[v],l._trySetSelection()},get selections(){return l._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");l._selections=v,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(v){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(v){l._disposed||l._options.assign(v)},get viewColumn(){return l._viewColumn},set viewColumn(v){throw(0,I.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(a.getValue(),t);return v(n),l._applyEdit(n)},insertSnippet(v,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=l._selections.map(o=>T.Range.from(o));else if(t instanceof y.Position){const{lineNumber:o,column:s}=T.Position.from(t);u=[{startLineNumber:o,startColumn:s,endLineNumber:o,endColumn:s}]}else if(t instanceof y.Range)u=[T.Range.from(t)];else{u=[];for(const o of t)if(o instanceof y.Range)u.push(T.Range.from(o));else{const{lineNumber:s,column:c}=T.Position.from(o);u.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return h.$tryInsertSnippet(d,v.value,u,n)},setDecorations(v,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(v.key)||(n?l._hasDecorationsForKey.delete(v.key):l._hasDecorationsForKey.add(v.key),l._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return h.$trySetDecorations(d,v.key,T.fromRangeOrRangeWithMessage(t));{const u=new Array(4*t.length);for(let o=0,s=t.length;o<s;o++){const c=t[o];u[4*o]=c.start.line+1,u[4*o+1]=c.start.character+1,u[4*o+2]=c.end.line+1,u[4*o+3]=c.end.character+1}return h.$trySetDecorationsFast(d,v.key,u)}}))},revealRange(v,t){l._runOnProxy(()=>h.$tryRevealRange(d,T.Range.from(v),t||y.TextEditorRevealType.Default))},show(v){h.$tryShowEditor(d,T.ViewColumn.from(v))},hide(){h.$tryHideEditor(d)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,w.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,w.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,w.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,w.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const h=d.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const r=h.edits.map(g=>g.range);r.sort((g,m)=>g.end.line===m.end.line?g.end.character===m.end.character?g.start.line===m.start.line?g.start.character-m.start.character:g.start.line-m.start.line:g.end.character-m.end.character:g.end.line-m.end.line);for(let g=0,m=r.length-1;g<m;g++){const S=r[g].end;if(r[g+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=h.edits.map(g=>({range:T.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,a,{setEndOfLine:typeof h.setEndOfLine=="number"?T.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=i}),define(we[182],_e([0,1,137,25,2,3,6,11,7,10,15,9,20]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(g,m){if((0,k.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let S;return Array.isArray(g.highlights)&&(S=g.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),S=S.length?S:void 0),{label:g.label,highlights:S}}}class r{constructor(m,S,f){this._proxy=m,this.commands=S,this.logService=f,this.treeViews=new Map;function l(v){return v&&v.$treeViewId&&v.$treeItemHandle}S.registerArgumentProcessor({processArgument:v=>l(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>l(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(m,S,f){const l=this.createTreeView(m,{treeDataProvider:S},f);return{dispose:()=>l.dispose()}}createTreeView(m,S,f){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany}),v=this.createExtHostTreeView(m,S,f);return{get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get message(){return v.message},set message(t){v.message=t},get title(){return v.title},set title(t){v.title=t},get description(){return v.description},set description(t){v.description=t},reveal:(t,n)=>v.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(m),v.dispose()}}}$getChildren(m,S){const f=this.treeViews.get(m);return f?f.getChildren(S):Promise.reject(new Error((0,w.localize)(0,null,m)))}async $hasResolve(m){const S=this.treeViews.get(m);if(!S)throw new Error((0,w.localize)(1,null,m));return S.hasResolve}$resolve(m,S,f){const l=this.treeViews.get(m);if(!l)throw new Error((0,w.localize)(2,null,m));return l.resolveTreeItem(S,f)}$setExpanded(m,S,f){const l=this.treeViews.get(m);if(!l)throw new Error((0,w.localize)(3,null,m));l.setExpanded(S,f)}$setSelection(m,S){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(4,null,m));f.setSelection(S)}$setVisible(m,S){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(5,null,m));f.setVisible(S)}createExtHostTreeView(m,S,f){const l=new a(m,S,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(m,l),l}convertArgument(m){const S=this.treeViews.get(m.$treeViewId);return S?S.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class a extends y.Disposable{constructor(m,S,f,l,v,t){super();if(this.viewId=m,this.proxy=f,this.commands=l,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const s of t.contributes.views[o])s.id===m&&(this._title=s.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let n,u;this._register(T.Event.debounce(this._onDidChangeData.event,(o,s)=>(o||(o={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(c=>u=c),this.refreshPromise=this.refreshPromise.then(()=>n)),o.elements.push(s.element)),s.message&&(o.message=!0),o),200,!0)(({message:o,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=u;return n=null,this.refresh(s).then(()=>c())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const S=m?this.getExtensionElement(m):void 0;if(m&&!S)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const f=this.getChildrenNodes(m);return(f?Promise.resolve(f):this.fetchChildrenNodes(S)).then(l=>l.map(v=>v.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,S){S=S||{select:!0,focus:!1};const f=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,l=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,v=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(u=>u.item)},{select:f,focus:l,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:l,expand:v})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,S){const f=this.getExtensionElement(m);f&&(S?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,S){var f;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(m);if(l){const v=this.nodes.get(l);if(v){const t=(f=await this.dataProvider.resolveTreeItem(v.extensionItem,l,S))!==null&&f!==void 0?f:v.extensionItem;return v.item.tooltip=this.getTooltip(t.tooltip),v.item.command=this.getCommand(v.disposableStore,t.command),v.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(S=>S?this.resolveUnknownParentChain(S).then(f=>this.resolveTreeNode(S,f[f.length-1]).then(l=>(f.push(l),f))):Promise.resolve([]))}resolveParent(m){const S=this.nodes.get(m);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,S){const f=this.nodes.get(m);return f?Promise.resolve(f):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(l=>this.createHandle(m,l,S,!0)).then(l=>this.getChildren(S?S.item.handle:void 0).then(()=>{const v=this.getExtensionElement(l);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(m){if(m){let S;if(typeof m=="string"){const f=this.getExtensionElement(m);S=f?this.nodes.get(f):void 0}else S=m;return S&&S.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const S=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=m?this.nodes.get(m):void 0,l=await this.dataProvider.getChildren(m);if(S.token.isCancellationRequested)return[];const v=await Promise.all((0,i.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,f):null}));return S.token.isCancellationRequested?[]:(0,i.coalesce)(v)}finally{S.dispose()}}refresh(m){if(m.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(m);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const S=new Set,f=m.map(v=>this.nodes.get(v));for(const v of f)if(v&&!S.has(v.item.handle)){let t=v;for(;t&&t.parent&&f.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(v.item.handle)}const l=[];return S.forEach(v=>{const t=this.elements.get(v);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&l.push(v)}}),l}refreshHandles(m){const S={};return Promise.all(m.map(f=>this.refreshNode(f).then(l=>{l&&(S[f]=l.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(m){const S=this.getExtensionElement(m);if(S){const f=this.nodes.get(S);if(f)return this.clearChildren(S),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(l=>{if(l){const v=this.createTreeNode(S,l,f.parent);return this.updateNodeCache(S,v,f,f.parent),f.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,S,f){const l=this.createTreeNode(m,S,f);if(S.id&&this.elements.has(l.item.handle))throw new Error((0,w.localize)(6,null,S.id));return this.addNodeToCache(m,l),this.addNodeToParentCache(l,f),l}getTooltip(m){return D.MarkdownString.isMarkdownString(m)?P.MarkdownString.from(m):m}getCommand(m,S){return S?this.commands.toInternal(S,m):void 0}createTreeNode(m,S,f){const l=new y.DisposableStore,v=this.createHandle(m,S,f),t=this.getLightIconPath(S);return{item:{handle:v,parentHandle:f?f.item.handle:void 0,label:h(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(l,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:f,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(m){return m.iconPath instanceof D.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:S,label:f,resourceUri:l},v,t){if(S)return`${a.ID_HANDLE_PREFIX}/${S}`;const n=h(f,this.extension),u=v?v.item.handle:a.LABEL_HANDLE_PREFIX;let o=n?n.label:l?(0,I.basename)(l):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const s=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,c=this.getChildrenNodes(v)||[];let b,_=0;do{if(b=`${u}/${_}:${o}`,t||!this.elements.has(b)||s===b)break;_++}while(_<=c.length);return b}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof D.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof D.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return A.URI.isUri(m)?m:A.URI.file(m)}addNodeToCache(m,S){this.elements.set(S.item.handle,m),this.nodes.set(m,S)}updateNodeCache(m,S,f,l){this.elements.delete(S.item.handle),this.nodes.delete(m),S.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(m,S);const v=this.getChildrenNodes(l)||[],t=v.filter(n=>n.item.handle===f.item.handle)[0];t&&v.splice(v.indexOf(t),1,S)}addNodeToParentCache(m,S){S?(S.children||(S.children=[]),S.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const S=this.nodes.get(m);if(S){if(S.children)for(const f of S.children){const l=this.elements.get(f.item.handle);l&&this.clear(l)}S.children=void 0}}else this.clearAll()}clear(m){const S=this.nodes.get(m);if(S){if(S.children)for(const f of S.children){const l=this.elements.get(f.item.handle);l&&this.clear(l)}this.nodes.delete(m),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(we[183],_e([0,1,15,11,20,10,69,9,7,96]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(g,m){if(m!==void 0){const S=this.testIdsToInternal.get(m),f=S==null?void 0:S.get(g);if(f)return[S,f]}return(0,w.mapFind)(this.testIdsToInternal.values(),S=>{const f=S.get(g);return f&&[S,f]})}createForHierarchy(g=()=>{}){return new r(this.createIdMap(d++),g)}createIdMap(g){const m=new h(g);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var P;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let d=0;class h{constructor(g){this.id=g,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(g){if(this.map.has(g.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${g.item.extId}`);this.map.set(g.item.extId,g),g.parent||this._roots.add(g)}has(g){return this.map.has(g)}delete(g){const m=this.map.get(g);return m?(this.map.delete(g),this._roots.delete(m),!0):!1}get(g){return this.map.get(g)}comparePositions(g,m){const S=typeof g=="string"?this.map.get(g):g,f=typeof m=="string"?this.map.get(m):m;if(!S||!f)return 0;if(S===f)return 3;for(let l=this.map.get(f.parent);l;l=this.map.get(l.parent))if(l===S)return 1;for(let l=this.map.get(S.parent);l;l=this.map.get(l.parent))if(l===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class r{constructor(g,m){this.testIdToInternal=g,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(g,m){this.addItem(g,m,null)}getTestByReference(g){return this.testItemToInternal.get(g)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const m=this.diff[this.diff.length-1];if(m&&g[0]===1){if(m[0]===1&&m[1].extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}if(m[0]===0&&m[1].item.extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,m){var S;const f=this.testIdToInternal.object.get(g);if(!!f){if((f.expandLevels===void 0||m>f.expandLevels)&&(f.expandLevels=m),f.expand===1){const l=this.refreshChildren(f);return l.isSettled?this.expandChildren(f,m-1):l.p.then(()=>this.expandChildren(f,m-1))}else if(f.expand===3)return((S=f.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?f.initialExpand.p.then(()=>this.expandChildren(f,m-1)):this.expandChildren(f,m-1)}}dispose(){var g;for(const m of this.testItemToInternal.values())(g=m.discoverCts)===null||g===void 0||g.dispose(!0),(0,y.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(g,m){const S=g==null?void 0:g.actual.id;switch(m[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(g);break;case 0:this.addItem(m[1],g.src.controller,g);break;case 3:const[f,l,v]=m;switch(l){case"status":this.updateExpandability(g);break;case"range":this.pushDiff([1,{extId:S,item:{range:C.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:C.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[l]:v!=null?v:null}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(g,m,S){if(!(g instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);if(this.testItemToInternal.has(g))throw new Error(`Attempted to add a single TestItem ${g.id} multiple times to the tree`);if(this.testIdToInternal.object.has(g.id))throw new Error(`Attempted to insert a duplicate test item ID ${g.id}`);const f=S?S.item.extId:null,l=g.resolveHandler?1:0,v=S==null?void 0:S.expandLevels,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:g,parent:f,item:C.TestItem.from(g),expandLevels:v?v-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(g,n),this.pushDiff([0,{parent:f,src:t,expand:l,item:n.item}]);const u=(0,y.getPrivateApiFor)(g);u.parent=S==null?void 0:S.actual,u.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const o of u.children.values())this.testItemToInternal.has(o)||this.addItem(o,m,n)}updateExpandability(g){var m;let S;g.actual.resolveHandler?g.actual.status===D.TestItemStatus.Pending?S=g.discoverCts?2:1:((m=g.initialExpand)===null||m===void 0||m.complete(),S=3):S=0,S!==g.expand&&(g.expand=S,this.pushDiff([1,{extId:g.actual.id,expand:S}]),S===1&&g.expandLevels!==void 0&&this.refreshChildren(g))}expandChildren(g,m){if(!(m<0)){const S=[...g.actual.children.values()].map(f=>this.expand(f.id,m)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(g){if(g.discoverCts&&g.discoverCts.dispose(!0),!g.actual.resolveHandler){const m=new I.DeferredPromise;return m.complete(),m}return g.expand=2,g.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(g),g.initialExpand=new I.DeferredPromise,g.actual.resolveHandler(g.discoverCts.token),g.initialExpand}pushExpandStateUpdate(g){this.pushDiff([1,{extId:g.actual.id,expand:g.expand}])}removeItem(g){var m;this.pushDiff([2,g.actual.id]);const S=[g];for(;S.length;){const f=S.pop();if(!!f){(m=f.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(f.item.extId),this.testItemToInternal.delete(f.actual);for(const l of f.actual.children.values())S.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const g=this.collectDiff();g.length&&this.publishDiff(g)}}e.SingleUseTestCollection=r}),define(we[184],_e([0,1,26,3,13]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(d=>P.add(w.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(w.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(h=>h.identifier)),P.length>0){const h=new Set;P.forEach(r=>h.add(w.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!h.has(w.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this._arcs.has(g)?this._arcs.get(g).push(m):this._arcs.set(g,[m])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,m){const S=P.getArcs(g);for(let f=0;f<S.length;f++)if(!m.has(S[f]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let g of i){const m=w.ExtensionIdentifier.toKey(g.identifier);if(d.set(m,g),g.extensionDependencies)for(let S of g.extensionDependencies){const f=w.ExtensionIdentifier.toKey(S);P.addArc(m,f)}}let h=new Set;P.getNodes().filter(g=>P.getArcs(g).length===0).forEach(g=>h.add(g));let r=P.getNodes().filter(g=>!h.has(g)),a;do{a=!1;for(let g=0;g<r.length;g++){const m=r[g];P.hasOnlyGoodArcs(m,h)&&(r.splice(g,1),g--,h.add(m),a=!0)}}while(a);return r.map(g=>d.get(g))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(w.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function D(k,i){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==d)return P-d;const h=A.posix.basename(k.extensionLocation.path),r=A.posix.basename(i.extensionLocation.path);return h<r?-1:h>r?1:0}}),define(we[185],_e([0,1,23]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(C){const D=w.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(we[33],_e([0,1,3,2,4,26,151]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class C{constructor(S){this.dependency=S}}e.MissingDependencyError=C;var D;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,f,l,v){this.codeLoadingTime=S,this.activateCallTime=f,this.activateResolvedTime=l,this.activationReason=v}}e.ActivationTimes=k;class i{constructor(S,f){this.description=S,this.value=f}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(m){m.enableProposedApi||h(m)}e.checkProposedApiEnabled=d;function h(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=h;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function a(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=a;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(S,f){}_activateById(S,f){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,f,l,v,t){}_onExtensionRuntimeError(S,f){}_onExtensionHostExit(S){}}e.NullExtensionService=g}),define(we[186],_e([0,1,132,26,33,18]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class C{constructor(a,g,m,S){this.startup=a,this.codeLoadingTime=g,this.activateCallTime=m,this.activateResolvedTime=S}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class D{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,g){return a===-1||g===-1?-1:g-a}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class k{constructor(a,g,m,S,f,l){this.activationFailed=a,this.activationFailedError=g,this.activationTimes=m,this.module=S,this.exports=f,this.subscriptions=l}}e.ActivatedExtension=k;class i extends k{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=i;class P extends k{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class d extends k{constructor(a){super(!0,a,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=d;let h=class{constructor(a,g,m,S,f){this._logService=f,this._registry=a,this._resolvedExtensionsSet=new Set,g.forEach(l=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,m.forEach(l=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(l),l)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const g=I.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(g)}getActivatedExtension(a){const g=I.ExtensionIdentifier.toKey(a),m=this._activatedExtensions.get(g);if(!m)throw new Error("Extension `"+a.value+"` is not known or not activated");return m}activateByEvent(a,g){if(this._alreadyActivatedEvents[a])return y;const m=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(m.map(S=>({id:S.identifier,reason:{startup:g,extensionId:S.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,g){const m=this._registry.getExtensionDescription(a);if(!m)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:m.identifier,reason:g}])}_handleActivateRequest(a,g,m){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(a.id))){g[I.ExtensionIdentifier.toKey(a.id)]=a;return}const S=this._registry.getExtensionDescription(a.id);if(!S){this._host.onExtensionActivationError(a.id,new A.MissingDependencyError(a.id.value));const v=new Error(`Unknown dependency '${a.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(a.id),new d(v));return}const f=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let l=!0;for(let v=0,t=f.length;v<t;v++){const n=f[v];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(n))){const u=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(n));if(!(u&&!u.activationFailed)){if(u&&u.activationFailed){this._host.onExtensionActivationError(S.identifier,w.localize(0,null,S.displayName||S.identifier.value,n));const c=new Error(`Dependency ${n} failed to activate`);c.detail=u.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new d(c));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n))){l=!1,g[I.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(n)),reason:a.reason};continue}const o=this._registry.getExtensionDescription(n);if(o){l=!1,g[I.ExtensionIdentifier.toKey(n)]={id:o.identifier,reason:a.reason};continue}this._host.onExtensionActivationError(S.identifier,new A.MissingDependencyError(n));const s=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new d(s));return}}}l?g[I.ExtensionIdentifier.toKey(S.identifier)]=a:m.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(f=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(f.id))),a.length===0))return Promise.resolve(void 0);const g=Object.create(null),m=[];for(let f=0,l=a.length;f<l;f++)this._handleActivateRequest(a[f],g,m);for(let f=0,l=m.length;f<l;f++){const v=I.ExtensionIdentifier.toKey(m[f].id);g[v]&&delete g[v]}const S=Object.keys(g).map(f=>g[f]);return m.length===0?Promise.all(S.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(S).then(f=>this._activateExtensions(m))}_activateExtension(a,g){const m=I.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const S=this._activatingExtensions.get(m);if(S)return S;const f=this._host.actualActivateExtension(a,g).then(void 0,l=>(this._host.onExtensionActivationError(a,w.localize(1,null,a.value,l.message)),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(l),new d(l))).then(l=>{this._activatedExtensions.set(m,l),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,f),f}};h=Ve([qe(4,T.ILogService)],h),e.ExtensionsActivator=h}),define(we[187],_e([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=I}),define(we[98],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const I=[];function A(C){const D=new w(!0,C);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=A;function T(C){const D=new w(!1,C);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(C){return I[C].sid}e.getStringIdentifierForProxy=y}),define(we[5],_e([0,1,2,98,57]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var i;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var d;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(d=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(l){l.name="$ident";function v(n,u){return Object.defineProperty(n,l.name,{value:u,enumerable:!0}),n}l.mixin=v;function t(n){return n[l.name]}l.of=t})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(v){return v._id=r._n++,v}}e.IdObject=r,r._n=0;var a;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(l){if(l&&l.edits)for(const v of l.edits)typeof v.resource=="object"?v.resource=w.URI.revive(v.resource):(v.newUri=w.URI.revive(v.newUri),v.oldUri=w.URI.revive(v.oldUri)),v.metadata&&v.metadata.iconPath&&(v.metadata=(0,A.revive)(v.metadata));return l}e.reviveWorkspaceEditDto=S;var f;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[74],_e([0,1,5,3,4]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(C){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,k){return this._proxy.$setPassword(C,D,k)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(we[75],_e([0,1,4,18,5,14]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(A.MainContext.MainThreadTelemetry)}report(D,k,i){const P=this.getUsageKey(D,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,k){}})}),define(we[188],_e([0,1,3,5,7,26]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,i,P={}){const d=T.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(d)||[],r=i.sort().join(" ");let a=h.find(g=>g.scopes===r);if(a)return a.result;{const g=this._getSession(D,d,k,i,P);a={scopes:r,result:g},h.push(a),this._inFlightRequests.set(d,h);try{await g}finally{const m=h.findIndex(S=>S.scopes===r);m>-1&&(h.splice(m),this._inFlightRequests.set(d,h))}return g}}async _getSession(D,k,i,P,d={}){await this._proxy.$ensureProvider(i);const h=D.displayName||D.name;return this._proxy.$getSession(i,P,k,h,d)}async removeSession(D,k){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,i,P){var d;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:i,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===D)||this._providers.push({id:D,label:k});const h=i.onDidChangeSessions(r=>{var a,g,m;this._proxy.$sendDidChangeSessions(D,{added:(a=r.added)!==null&&a!==void 0?a:[],changed:(g=r.changed)!==null&&g!==void 0?g:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(d=P==null?void 0:P.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new A.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(D);const r=this._providers.findIndex(a=>a.id===D);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const P=this._providers.findIndex(d=>d.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(we[189],_e([0,1,5,14,9]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(we[190],_e([0,1,5]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(T){const y=T.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=I}),define(we[76],_e([0,1,10,7,9,24,5,15,18,57,32,38,2,6,4,14]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,u=>{const o=this._apiCommands.get(u);return(o==null?void 0:o.result)===f.Void?o:void 0},n),this._argumentProcessors=[{processArgument(u){return(0,k.revive)(u)}},{processArgument(u){return(0,T.cloneAndChange)(u,function(o){if(i.Range.isIRange(o))return A.Range.to(o);if(P.Position.isIPosition(o))return A.Position.to(o);if(i.Range.isIRange(o.range)&&d.URI.isUri(o.uri))return A.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...u)=>{const o=t.args.map((c,b)=>{if(!c.validate(u[b]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${u[b]}`);return c.convert(u[b])}),s=await this.executeCommand(t.internalId,...o);return t.result.convert(s,u,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,u,o,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:u,thisArg:o,description:s}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,u){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const o=(0,T.cloneAndChange)(n,function(s){if(s instanceof I.Position)return A.Position.from(s);if(s instanceof I.Range)return A.Range.from(s);if(s instanceof I.Location)return A.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,o,u);return(0,k.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const u=this._commands.get(t);if(!u)throw new Error("Unknown command");let{callback:o,thisArg:s,description:c}=u;if(c)for(let b=0;b<c.args.length;b++)try{(0,w.validateConstraint)(n[b],c.args[b].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[b].name}' - ${c.args[b].description}`)}try{return await o.apply(s,n)}catch(b){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(u=>this._argumentProcessors.reduce((o,s)=>s.processArgument(o),u)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(u=>u[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,u]of this._commands){let{description:o}=u;o&&(t[n]=o)}return Promise.resolve(t)}};g=Ve([qe(0,a.IExtHostRpcService),qe(1,D.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,n,u){this._commands=t,this._lookupApiCommand=n,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const u={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return u;const o=this._lookupApiCommand(t.command);if(o)u.id=o.internalId,u.arguments=o.args.map((s,c)=>s.convert(t.arguments&&t.arguments[c]));else if((0,C.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,h.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),u.$ident=s,u.id=this.delegatingCommandId,u.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return u}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class S{constructor(t,n,u,o){this.name=t,this.description=n,this.validate=u,this.convert=o}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",v=>d.URI.isUri(v),v=>v),S.Position=new S("position","A position in a text document",v=>I.Position.isPosition(v),A.Position.from),S.Range=new S("range","A range in a text document",v=>I.Range.isRange(v),A.Range.from),S.Selection=new S("selection","A selection in a text document",v=>I.Selection.isSelection(v),A.Selection.from),S.Number=new S("number","",v=>typeof v=="number",v=>v),S.String=new S("string","",v=>typeof v=="string",v=>v),S.CallHierarchyItem=new S("item","A call hierarchy item",v=>v instanceof I.CallHierarchyItem,A.CallHierarchyItem.to);class f{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=f,f.Void=new f("no result",v=>v);class l{constructor(t,n,u,o,s){this.id=t,this.internalId=n,this.description=u,this.args=o,this.result=s}}e.ApiCommand=l}),define(we[191],_e([0,1,6,9,7,62,76,169,15,87]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if(!(0,D.isFalsyOrEmpty)(r)){class g extends A.SymbolInformation{static to(S){const f=new g(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new A.Location(a[0],I.Range.to(S.range)));return f.detail=S.detail,f.range=f.location.range,f.selectionRange=I.Range.to(S.selectionRange),f.children=S.children?S.children.map(g.to):[],f}}return r.map(g.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>A.Position.isPosition(a)),r=>r.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let g;for(const m of a.reverse())g=new A.SelectionRange(I.Range.to(m),g);return g}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const a=[];if(Array.isArray(r))for(let g of r)a.push(...g[1].map(I.WorkspaceSymbol.to));return a})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return I.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new A.SemanticTokens(a.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new A.SemanticTokens(a.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,g)=>{if(!r)return new A.CompletionList([]);const m=r.suggestions.map(S=>I.CompletionItem.to(S,g));return new A.CompletionList(m,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return I.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,g)=>d(m=>new A.CodeLens(I.Range.to(m.range),m.command&&g.fromInternal(m.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.Range.isRange(r),r=>A.Selection.isSelection(r)?I.Selection.from(r):I.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,g)=>d(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(m.command)}else{const S=new A.CodeAction(m.title,m.kind?new A.CodeActionKind(m.kind):void 0);return m.edit&&(S.edit=I.WorkspaceEdit.to(m.edit)),m.command&&(S.command=g.fromInternal(m.command)),S.isPreferred=m.isPreferred,S}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new A.ColorInformation(I.Range.to(a.range),I.Color.to(a.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof A.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:I.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>I.NotebookExclusiveDocumentPattern.to(a))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class P{constructor(a){this._disposables=new w.DisposableStore,this._commands=a}static register(a){return i.forEach(a.registerApiCommand,a),new P(a).registerCommands()}registerCommands(){const a=g=>(...m)=>g(this._commands,...m);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,a(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:g=>typeof g=="string"}]}),this._register(C.OpenIssueReporter.ID,a(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:g=>typeof g=="string"||typeof g=="object"&&typeof g.extensionId=="string"}]})}_register(a,g,m){const S=this._commands.registerCommand(!1,a,g,this,m);this._disposables.add(S)}}e.ExtHostApiCommands=P;function d(r){return a=>{if(Array.isArray(a))return a.map(r)}}function h(r){if(!!Array.isArray(r)){const a=[];for(const g of r)T.isLocationLink(g)?a.push(I.DefinitionLink.to(g)):a.push(I.location.to(g));return a}}}),define(we[192],_e([0,1,11,52,3,6,2,62,26,9,7,5]),function(Q,e,w,I,A,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(l,v,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(P.MainContext.MainThreadComments),v.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const u=this._commentControllers.get(n.handle);return u||n}else if(n&&n.$mid===7){const u=this._commentControllers.get(n.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.commentThreadHandle);return o||n}else if(n&&n.$mid===8){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);return o?{thread:o,text:n.text}:n}else if(n&&n.$mid===9){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let s=n.commentUniqueId,c=o.getCommentByUniqueId(s);return c||n}else if(n&&n.$mid===10){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let s=n.text,c=n.commentUniqueId,b=o.getCommentByUniqueId(c);return b?(b.body=s,b):n}return n}})}createCommentController(l,v,t){const n=d.handlePool++,u=new r(l,n,this._proxy,v,t);this._commentControllers.set(u.handle,u);const o=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(l.identifier))||[];return o.push(u),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(l.identifier),o),u}$createCommentThreadTemplate(l,v,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(v,t)}async $updateCommentThreadTemplate(l,v,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(v,t)}$deleteCommentThread(l,v){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(v)}$provideCommentingRanges(l,v,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const u=this._documents.getDocument(y.URI.revive(v));return(0,w.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(u,t)).then(o=>o?o.map(s=>k.Range.from(s)):void 0)}$toggleReaction(l,v,t,n,u){const o=this._commentControllers.get(l);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const s=o.getCommentThread(v);if(s){const c=s.getCommentByUniqueId(n.uniqueIdInThread);if(o!==void 0&&c&&o.reactionHandler)return o.reactionHandler(c,m(u))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class h{constructor(l,v,t,n,u,o,s){this._proxy=l,this._commentController=v,this._id=t,this._uri=n,this._range=u,this._comments=o,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${v.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),v={};l("range")&&(v.range=k.Range.from(this._range)),l("label")&&(v.label=this.label),l("contextValue")&&(v.contextValue=this.contextValue),l("comments")&&(v.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(v.collapseState=S(this._collapseState)),l("canReply")&&(v.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,v)}}getCommentByUniqueId(l){for(let v of this._commentsMap){let t=v[0],n=v[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([(0,I.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class r{constructor(l,v,t,n,u){this._extension=l,this._handle=v,this._proxy=t,this._id=n,this._label=u,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,u)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,v,t,n){if(typeof l=="string"){const u=new h(this._proxy,this,l,v,t,n,this._extension.identifier);return this._threads.set(u.handle,u),u}else{const u=new h(this._proxy,this,void 0,l,v,t,this._extension.identifier);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(l,v){const t=new h(this._proxy,this,void 0,y.URI.revive(l),k.Range.to(v),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,v){let t=this._threads.get(l);t&&(t.range=k.Range.to(v))}$deleteCommentThread(l){let v=this._threads.get(l);v&&v.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(f,l,v,t){let n=t.get(v);n||(n=++f.commentHandle,t.set(v,n));const u=v.author&&v.author.iconPath?v.author.iconPath.toString():void 0;return{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(v.body),userName:v.author.name,userIconPath:u,label:v.label,commentReactions:v.reactions?v.reactions.map(o=>g(o)):void 0}}function g(f){return{label:f.label,iconPath:f.iconPath?k.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function m(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?y.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function S(f){if(f!==void 0)switch(f){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(we[99],_e([0,1,2,5,7,4,14,18,15,8,13]),function(Q,e,w,I,A,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class vn{constructor(h,r){this._logService=r,this._provider=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,r){const a=vn._handlePool++;this._provider.set(a,{provider:h,extensionId:r}),this._proxy.$registerDecorationProvider(a,r.value);const g=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(a,null);return}let S=(0,D.asArray)(m);if(S.length<=vn._maxEventSize){this._proxy.$onDidChange(a,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,S.length);const f=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),l=(0,D.groupBy)(f,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let v=[];e:for(let t of l){let n;for(let u of t){let o=(0,i.dirname)(u.uri.path);if(n!==o&&(n=o,v.push(u.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(a,v)});return new A.Disposable(()=>{g==null||g.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(h,r,a){if(!this._provider.has(h))return Object.create(null);const g=Object.create(null),{provider:m,extensionId:S}=this._provider.get(h);return await Promise.all(r.map(async f=>{try{const{uri:l,id:v}=f,t=await Promise.resolve(m.provideFileDecoration(w.URI.revive(l),a));if(!t)return;try{A.FileDecoration.validate(t),g[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(l){this._logService.error(l)}})),g}};P._handlePool=0,P._maxEventSize=250,P=Ve([qe(0,y.IExtHostRpcService),qe(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(we[193],_e([0,1,131,90,2,5,7,9,3,18,22]),function(Q,e,w,I,A,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,a,g,m,S){this._name=r,this._owner=a,this._maxDiagnosticsPerFile=g,this._proxy=m,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,a){if(!r){this.clear();return}this._checkDisposed();let g=[];if(A.URI.isUri(r)){if(!a){this.delete(r);return}this._data.set(r,a.slice()),g=[r]}else if(Array.isArray(r)){g=[];let S;r=[...r].sort(P._compareIndexedTuplesByUri);for(const f of r){const[l,v]=f;if((!S||l.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=l,g.push(l),this._data.set(l,[])),v){const t=this._data.get(l);t&&t.push(...v)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!!this._proxy){const m=[];for(let S of g){let f=[];const l=this._data.get(S);if(l)if(l.length>this._maxDiagnosticsPerFile){f=[];const v=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===v[t]&&f.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;f.push({severity:I.MarkerSeverity.Info,message:(0,w.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=l.map(v=>C.Diagnostic.from(v));m.push([S,f])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,a){this._checkDisposed();for(let g of this._data.keys())r.apply(a,[g,this.get(g),this])}get(r){this._checkDisposed();const a=this._data.get(r);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,a){return r[0].toString()<a[0].toString()?-1:r[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class Ht{constructor(r,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Ht._debouncer,50),Ht._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,a){return r?r.concat(a):a}static _mapper(r){const a=[],g=new Set;for(const m of r)typeof m=="string"?g.has(m)||(g.add(m),a.push(A.URI.parse(m))):g.has(m.toString())||(g.add(m.toString()),a.push(m));return Object.freeze(a),{uris:a}}createDiagnosticCollection(r,a){const{_collections:g,_proxy:m,_onDidChangeDiagnostics:S,_logService:f}=this,l=new class{$changeMany(n,u){m.$changeMany(n,u),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,u.length===0?"CLEARING":u)}$clear(n){m.$clear(n),f.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){m.dispose()}};let v;if(!a)a="_generated_diagnostic_collection_name_#"+Ht._idPool++,v=a;else if(!g.has(a))v=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do v=a+Ht._idPool++;while(g.has(v))}return new class extends P{constructor(){super(a,v,Ht._maxDiagnosticsPerFile,l,S);g.set(v,this)}dispose(){super.dispose(),g.delete(v)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const a=new Map,g=[];for(const m of this._collections.values())m.forEach((S,f)=>{let l=a.get(S.toString());typeof l=="undefined"&&(l=g.length,a.set(S.toString(),l),g.push([S,[]])),g[l][1]=g[l][1].concat(...f)});return g}}_getDiagnostics(r){let a=[];for(let g of this._collections.values())g.has(r)&&(a=a.concat(g.get(r)));return a}$acceptMarkersChange(r){if(!this._mirrorCollection){const a="_generated_mirror",g=new P(a,a,Ht._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,g),this._mirrorCollection=g}for(const[a,g]of r)this._mirrorCollection.set(A.URI.revive(a),g.map(C.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Ve([qe(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(we[194],_e([0,1,2,5]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(D=>w.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?w.URI.revive(C):void 0)}}e.ExtHostDialogs=A}),define(we[195],_e([0,1,12,2,7,5,19,20,8]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,d,h){this._documentsAndEditors=d,this._logService=h,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const h=k._handlePool++;this._documentContentProviders.set(h,d),this._proxy.$registerTextContentProvider(h,P);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(a=>{if(a.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(h,a).then(g=>{if(!(!g&&typeof g!="string")){const m=this._documentsAndEditors.getDocument(a);if(!!m){const S=(0,D.splitLines)(g);if(!m.equalLines(S))return this._proxy.$onVirtualDocumentChange(a,g)}}},w.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,d){const h=this._documentContentProviders.get(P);return h?Promise.resolve(h.provideTextDocumentContent(I.URI.revive(d),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(we[196],_e([0,1,3,6,2,5,95,9,10,24]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,h){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const h=this._documentsAndEditors.getDocument(d);if(h)return h}}getDocument(d){const h=this.getDocumentData(d);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return h.document}ensureDocumentData(d){const h=this._documentsAndEditors.getDocument(d);if(h)return Promise.resolve(h);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(a=>{this._documentLoader.delete(d.toString());const g=A.URI.revive(a);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(g))},a=>(this._documentLoader.delete(d.toString()),Promise.reject(a))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(h=>A.URI.revive(h))}$acceptModelModeChanged(d,h){const r=A.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(h),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(d){const h=A.URI.revive(d),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,h){const r=A.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(d,h,r){const a=A.URI.revive(d),g=this._documentsAndEditors.getDocument(a);if(!g)throw new Error("unknown document");g._acceptIsDirty(r),g.onEvents(h),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:g.document,contentChanges:h.changes.map(m=>({range:C.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(d,h){(0,y.setWordDefinitionFor)(d,h)}}e.ExtHostDocuments=i}),define(we[39],_e([0,1,42,3,6,2,4,5,95,14,97,9,18,22,19,43,108]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(l,v){this._extHostRpc=l,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const v=[],t=[],n=[];if(l.removedDocuments)for(const u of l.removedDocuments){const o=T.URI.revive(u),s=this._documents.get(o);(s==null?void 0:s.unref())&&(this._documents.delete(o),v.push(s.value))}if(l.addedDocuments)for(const u of l.addedDocuments){const o=T.URI.revive(u.uri);let s=this._documents.get(o);if(s&&o.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);s||(s=new m(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(o,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const u of l.removedEditors){const o=this._editors.get(u);this._editors.delete(u),o&&n.push(o)}if(l.addedEditors)for(const u of l.addedEditors){const o=T.URI.revive(u.documentUri);w.ok(this._documents.has(o),`document '${o}' does not exist`),w.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const s=this._documents.get(o).value,c=new i.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>s.document),u.selections.map(P.Selection.to),u.options,u.visibleRanges.map(b=>P.Range.to(b)),typeof u.editorPosition=="number"?P.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,c)}l.newActiveEditor!==void 0&&(w.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,A.dispose)(v),(0,A.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(v),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var v;return(v=this._documents.get(l))===null||v===void 0?void 0:v.value}allDocuments(){return a.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const v=this._editors.get(this._activeEditorId);return l?v:v==null?void 0:v.value}}allEditors(){return[...this._editors.values()]}};S=Ve([qe(0,k.IExtHostRpcService),qe(1,d.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[197],_e([0,1,2,5,6,7,9,118,8,23]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const r=this._schemes.indexOf(h);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),r=[];let a,g,m=14,S=14;for(const f of h){let l=a?(0,D.commonPrefixLength)(a,f):0;for(l===0?g=1:g=S;l<f.length;l++)l+1===f.length?(m=S,S=9):S+=1,r.push([g,f.toUpperCase().charCodeAt(l),S]),r.push([g,f.toLowerCase().charCodeAt(l),S]),g=S;a=f,S=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new C.StateMachine(r)}}provideDocumentLinks(h){this._initStateMachine();const r=[],a=C.LinkComputer.computeLinks({getLineContent(g){return h.lineAt(g-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const g of a){const m=y.DocumentLink.to(g);m.target&&r.push(m)}return r}}class P{constructor(h,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,r,a,g={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,a);let S=2;g.isCaseSensitive&&(S+=1024),g.isReadonly&&(S+=2048),typeof a.copy=="function"&&(S+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(m,r,S).catch(l=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${r}`),console.error(l)});const f=a.onDidChangeFile(l=>{const v=[];for(const t of l){let{uri:n,type:u}=t;if(n.scheme===r){let o;switch(u){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:n,type:o})}}this._proxy.$onFileSystemChange(m,v)});return(0,A.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(h){const{type:r,ctime:a,mtime:g,size:m}=h;return{type:r,ctime:a,mtime:g,size:m}}$stat(h,r){return Promise.resolve(this._getFsProvider(h).stat(w.URI.revive(r))).then(P._asIStat)}$readdir(h,r){return Promise.resolve(this._getFsProvider(h).readDirectory(w.URI.revive(r)))}$readFile(h,r){return Promise.resolve(this._getFsProvider(h).readFile(w.URI.revive(r))).then(a=>k.VSBuffer.wrap(a))}$writeFile(h,r,a,g){return Promise.resolve(this._getFsProvider(h).writeFile(w.URI.revive(r),a.buffer,g))}$delete(h,r,a){return Promise.resolve(this._getFsProvider(h).delete(w.URI.revive(r),a))}$rename(h,r,a,g){return Promise.resolve(this._getFsProvider(h).rename(w.URI.revive(r),w.URI.revive(a),g))}$copy(h,r,a,g){const m=this._getFsProvider(h);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(r),w.URI.revive(a),g))}$mkdir(h,r){return Promise.resolve(this._getFsProvider(h).createDirectory(w.URI.revive(r)))}$watch(h,r,a,g){const m=this._getFsProvider(h).watch(w.URI.revive(a),g);this._watches.set(r,m)}$unwatch(h,r){const a=this._watches.get(r);a&&(a.dispose(),this._watches.delete(r))}$open(h,r,a){const g=this._getFsProvider(h);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(w.URI.revive(r),a))}$close(h,r){const a=this._getFsProvider(h);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(r))}$read(h,r,a,g){const m=this._getFsProvider(h);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(g);return Promise.resolve(m.read(r,a,S.buffer,0,g)).then(f=>S.slice(0,f))}$write(h,r,a,g){const m=this._getFsProvider(h);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,a,g.buffer,0,g.byteLength))}_getFsProvider(h){const r=this._fsProvider.get(h);if(!r){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return r}}e.ExtHostFileSystem=P}),define(we[77],_e([0,1,5,64,7,23,4,14,49]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Mt{constructor(P,d){const h=P.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return h.$stat(r).catch(Mt._handleError)},readDirectory(r){return h.$readdir(r).catch(Mt._handleError)},createDirectory(r){return h.$mkdir(r).catch(Mt._handleError)},async readFile(r){return h.$readFile(r).then(a=>a.buffer).catch(Mt._handleError)},writeFile(r,a){return h.$writeFile(r,T.VSBuffer.wrap(a)).catch(Mt._handleError)},delete(r,a){return h.$delete(r,Object.assign({recursive:!1,useTrash:!1},a)).catch(Mt._handleError)},rename(r,a,g){return h.$rename(r,a,Object.assign({overwrite:!1},g)).catch(Mt._handleError)},copy(r,a,g){return h.$copy(r,a,Object.assign({overwrite:!1},g)).catch(Mt._handleError)},isWritableFileSystem(r){const a=d.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new A.FileSystemError(String(P));if(P.name==="ENOPRO")throw A.FileSystemError.Unavailable(P.message);switch(P.name){case I.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(P.message);case I.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(P.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(P.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(P.message);case I.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(P.message);case I.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(P.message);default:throw new A.FileSystemError(P.message,P.name)}}};k=Ve([qe(0,C.IExtHostRpcService),qe(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(we[198],_e([0,1,6,5]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=A}),define(we[199],_e([0,1,2,24,9,7,11,5,8,32,15,10,115,6,87,54,68,55,12]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(x,q){this._documents=x,this._provider=q}provideDocumentSymbols(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ne,q)).then(le=>{if(!(0,i.isFalsyOrEmpty)(le))return le[0]instanceof T.DocumentSymbol?le.map(A.DocumentSymbol.from):f._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(x){var q;x=x.slice(0).sort((me,Se)=>{let Oe=me.location.range.start.compareTo(Se.location.range.start);return Oe===0&&(Oe=Se.location.range.end.compareTo(me.location.range.end)),Oe});const ne=[],le=[];for(const me of x){const Se={name:me.name||"!!MISSING: name!!",kind:A.SymbolKind.from(me.kind),tags:((q=me.tags)===null||q===void 0?void 0:q.map(A.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:A.Range.from(me.location.range),selectionRange:A.Range.from(me.location.range),children:[]};for(;;){if(le.length===0){le.push(Se),ne.push(Se);break}const Oe=le[le.length-1];if(k.Range.containsRange(Oe.range,Se.range)&&!k.Range.equalsRange(Oe.range,Se.range)){Oe.children&&Oe.children.push(Se),le.push(Se);break}le.pop()}}return ne}}class l{constructor(x,q,ne){this._documents=x,this._commands=q,this._provider=ne,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,q){const ne=this._documents.getDocument(x),le=await this._provider.provideCodeLenses(ne,q);if(!(!le||q.isCancellationRequested)){const me=this._cache.add(le),Se=new h.DisposableStore;this._disposables.set(me,Se);const Oe={cacheId:me,lenses:[]};for(let ge=0;ge<le.length;ge++)Oe.lenses.push({cacheId:[me,ge],range:A.Range.from(le[ge].range),command:this._commands.toInternal(le[ge].command,Se)});return Oe}}async resolveCodeLens(x,q){var ne;const le=x.cacheId&&this._cache.get(...x.cacheId);if(!!le){let me;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?me=le:me=await this._provider.resolveCodeLens(le,q),me||(me=le),!q.isCancellationRequested){const Se=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Se)return x.command=this._commands.toInternal((ne=me.command)!==null&&ne!==void 0?ne:l._badCmd,Se),x}}}releaseCodeLenses(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(We){return Array.isArray(We)?We.map(A.DefinitionLink.from):We?[A.DefinitionLink.from(We)]:[]}class t{constructor(x,q){this._documents=x,this._provider=q}provideDefinition(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDefinition(le,me,ne)).then(v)}}class n{constructor(x,q){this._documents=x,this._provider=q}provideDeclaration(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(le,me,ne)).then(v)}}class u{constructor(x,q){this._documents=x,this._provider=q}provideImplementation(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideImplementation(le,me,ne)).then(v)}}class o{constructor(x,q){this._documents=x,this._provider=q}provideTypeDefinition(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(le,me,ne)).then(v)}}class s{constructor(x,q){this._documents=x,this._provider=q}provideHover(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideHover(le,me,ne)).then(Se=>{if(!(!Se||(0,i.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=le.getWordRangeAtPosition(me)),Se.range||(Se.range=new T.Range(me,me)),A.Hover.from(Se)})}}class c{constructor(x,q){this._documents=x,this._provider=q}provideEvaluatableExpression(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(le,me,ne)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class b{constructor(x,q){this._documents=x,this._provider=q}provideInlineValues(x,q,ne,le){const me=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideInlineValues(me,A.Range.to(q),A.InlineValueContext.to(ne),le)).then(Se=>{if(Array.isArray(Se))return Se.map(Oe=>A.InlineValue.from(Oe))})}}class _{constructor(x,q){this._documents=x,this._provider=q}provideDocumentHighlights(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(le,me,ne)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class p{constructor(x,q){this._documents=x,this._provider=q}provideLinkedEditingRanges(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,me,ne)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,i.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class E{constructor(x,q){this._documents=x,this._provider=q}provideReferences(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideReferences(me,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.location.from)})}}class F{constructor(x,q,ne,le,me,Se,Oe){this._documents=x,this._commands=q,this._diagnostics=ne,this._provider=le,this._logService=me,this._extension=Se,this._apiDeprecation=Oe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,q,ne,le){const me=this._documents.getDocument(x),Se=d.Selection.isISelection(q)?A.Selection.to(q):A.Range.to(q),Oe=[];for(const Ce of this._diagnostics.getDiagnostics(x))if(Se.intersection(Ce.range)&&Oe.push(Ce)>F._maxCodeActionsPerFile)break;const ge={diagnostics:Oe,only:ne.only?new T.CodeActionKind(ne.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ne.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(me,Se,ge,le)).then(Ce=>{var Pe;if(!(!(0,i.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const $e=this._cache.add(Ce),Ee=new h.DisposableStore;this._disposables.set($e,Ee);const je=[];for(let H=0;H<Ce.length;H++){const te=Ce[H];!te||(F._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Ee)})):(ge.only&&(te.kind?ge.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[$e,H],title:te.title,command:te.command&&this._commands.toInternal(te.command,Ee),diagnostics:te.diagnostics&&te.diagnostics.map(A.Diagnostic.from),edit:te.edit&&A.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Pe=te.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:$e,actions:je}}})}async resolveCodeAction(x,q){var ne;const[le,me]=x,Se=this._cache.get(le,me);if(!(!Se||F._isCommand(Se))&&!!this._provider.resolveCodeAction){const Oe=(ne=await this._provider.resolveCodeAction(Se,q))!==null&&ne!==void 0?ne:Se;return(Oe==null?void 0:Oe.edit)?A.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}F._maxCodeActionsPerFile=1e3;class B{constructor(x,q){this._documents=x,this._provider=q}provideDocumentFormattingEdits(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,q,ne)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class Y{constructor(x,q){this._documents=x,this._provider=q}provideDocumentRangeFormattingEdits(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Range.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.TextEdit.from)})}}class fe{constructor(x,q){this._documents=x,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,q,ne,le,me){const Se=this._documents.getDocument(x),Oe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Oe,ne,le,me)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class V{constructor(x,q){this._provider=x,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,q){const ne=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(x,q)).then(le=>{if((0,i.isNonEmptyArray)(le)){for(const me of le)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const Se=C.IdObject.mixin(A.WorkspaceSymbol.from(me));this._symbolCache.set(Se._id,me),ne.symbols.push(Se)}}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(x,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ne=this._symbolCache.get(x._id);if(ne){const le=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,q));return le&&(0,I.mixin)(x,A.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(x){const q=this._resultCache.get(x);if(q){for(let[ne,le]=q;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(x)}}}class z{constructor(x,q,ne){this._documents=x,this._provider=q,this._logService=ne}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(me,Se,ne,le)).then(Oe=>{if(!!Oe)return A.WorkspaceEdit.from(Oe)},Oe=>{const ge=z._asMessage(Oe);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(x,q,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.prepareRename(le,me,ne)).then(Se=>{let Oe,ge;if(T.Range.isRange(Se)?(Oe=Se,ge=le.getText(Se)):(0,P.isObject)(Se)&&(Oe=Se.range,ge=Se.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Oe),text:ge}}},Se=>{const Oe=z._asMessage(Se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class ee{constructor(x,q){this.resultId=x,this.tokens=q}}class ${constructor(x,q){this._documents=x,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,q,ne){const le=this._documents.getDocument(x),me=q!==0?this._previousResults.get(q):null;return(0,y.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,me.resultId,ne):this._provider.provideDocumentSemanticTokens(le,ne)).then(Se=>(me&&this._previousResults.delete(q),Se?(Se=$._fixProvidedSemanticTokens(Se),this._send($._convertToEdits(me,Se),Se)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return $._isSemanticTokens(x)?$._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):$._isSemanticTokensEdits(x)?$._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(q=>new T.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const q of x.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,q){if(!$._isSemanticTokens(q)||!x||!x.tokens)return q;const ne=x.tokens,le=ne.length,me=q.data,Se=me.length;let Oe=0;const ge=Math.min(le,Se);for(;Oe<ge&&ne[Oe]===me[Oe];)Oe++;if(Oe===le&&Oe===Se)return new T.SemanticTokensEdits([],q.resultId);let Ce=0;const Pe=ge-Oe;for(;Ce<Pe&&ne[le-Ce-1]===me[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Ce,data:me.subarray(Oe,Se-Ce)}],q.resultId)}_send(x,q){if($._isSemanticTokens(x)){const ne=this._nextResultId++;return this._previousResults.set(ne,new ee(x.resultId,x.data)),(0,r.encodeSemanticTokensDto)({id:ne,type:"full",data:x.data})}if($._isSemanticTokensEdits(x)){const ne=this._nextResultId++;return $._isSemanticTokens(q)?this._previousResults.set(ne,new ee(q.resultId,q.data)):this._previousResults.set(ne,new ee(x.resultId)),(0,r.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(x.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class R{constructor(x,q){this._documents=x,this._provider=q}provideDocumentRangeSemanticTokens(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,A.Range.to(q),ne)).then(me=>me?this._send(me):null)}_send(x){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=R;class L{constructor(x,q,ne,le,me){this._documents=x,this._commands=q,this._provider=ne,this._apiDeprecation=le,this._extension=me,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q),Oe=me.getWordRangeAtPosition(Se)||new T.Range(Se,Se),ge=Oe.with({end:Se}),Ce=new m.StopWatch(!0),Pe=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(me,Se,le,A.CompletionContext.to(ne)));if(!!Pe&&!le.isCancellationRequested){const $e=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,Ee=L.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),je=new h.DisposableStore;this._disposables.set(Ee,je);const H=[],te={x:Ee,b:H,a:{replace:A.Range.from(Oe),insert:A.Range.from(ge)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Le=$e.items[ve],He=this._convertCompletionItem(Le,[Ee,ve],ge,Oe);H.push(He)}return te}}async resolveCompletionItem(x,q){if(typeof this._provider.resolveCompletionItem=="function"){const ne=this._cache.get(...x);if(!!ne){const le=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ne,q));if(!!le)return this._convertCompletionItem(le,x)}}}releaseCompletionItems(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,q,ne,le){var me;const Se=this._disposables.get(q[0]);if(!Se)throw Error("DisposableStore is missing...");const Oe={x:q,a:(me=x.label)!==null&&me!==void 0?me:"",o:x.label2,b:x.kind!==void 0?A.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(A.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(x.command,Se)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=x.textEdit.newText):typeof x.insertText=="string"?Oe.h=x.insertText:x.insertText instanceof T.SnippetString&&(Oe.h=x.insertText.value,Oe.i|=4);let ge;return x.textEdit?ge=x.textEdit.range:x.range&&(ge=x.range),T.Range.isRange(ge)?Oe.j=A.Range.from(ge):ge&&(!(ne==null?void 0:ne.isEqual(ge.inserting))||!(le==null?void 0:le.isEqual(ge.replacing)))&&(Oe.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Oe}}class M{constructor(x,q){this._documents=x,this._provider=q,this._cache=new g.Cache("SignatureHelp")}provideSignatureHelp(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q),Oe=this.reviveContext(ne);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(me,Se,le,Oe)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(x){let q;if(x.activeSignatureHelp){const ne=A.SignatureHelp.to(x.activeSignatureHelp),le=this._cache.get(x.activeSignatureHelp.id,0);le?(q=le,q.activeSignature=ne.activeSignature,q.activeParameter=ne.activeParameter):q=ne}return Object.assign(Object.assign({},x),{activeSignatureHelp:q})}releaseSignatureHelp(x){this._cache.delete(x)}}class U{constructor(x,q){this._documents=x,this._provider=q}provideInlineHints(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideInlineHints(le,A.Range.to(q),ne)).then(me=>me?{hints:me.map(A.InlineHint.from)}:void 0)}}class G{constructor(x,q){this._documents=x,this._provider=q,this._cache=new g.Cache("DocumentLink")}provideLinks(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ne,q)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(A.DocumentLink.from)};{const me=this._cache.add(le),Se={links:[],id:me};for(let Oe=0;Oe<le.length;Oe++){const ge=A.DocumentLink.from(le[Oe]);ge.cacheId=[me,Oe],Se.links.push(ge)}return Se}}})}resolveLink(x,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...x);return ne?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ne,q)).then(le=>le&&A.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class X{constructor(x,q){this._documents=x,this._provider=q}provideColors(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ne,q)).then(le=>Array.isArray(le)?le.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(x,q,ne){const le=this._documents.getDocument(x),me=A.Range.to(q.range),Se=A.Color.to(q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:le,range:me},ne)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(A.ColorPresentation.from)})}}class se{constructor(x,q){this._documents=x,this._provider=q}provideFoldingRanges(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(le,q,ne)).then(me=>{if(!!Array.isArray(me))return me.map(A.FoldingRange.from)})}}class pe{constructor(x,q,ne){this._documents=x,this._provider=q,this._logService=ne}provideSelectionRanges(x,q,ne){const le=this._documents.getDocument(x),me=q.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(le,me,ne)).then(Se=>{if(!(0,i.isNonEmptyArray)(Se))return[];if(Se.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Oe.push(Ce);let Pe=me[ge],$e=Se[ge];for(;;){if(!$e.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from($e)),!$e.parent)break;Pe=$e.range,$e=$e.parent}}return Oe})}}class Te{constructor(x,q){this._documents=x,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q),Se=await this._provider.prepareCallHierarchy(le,me,ne);if(!!Se){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Oe,ge)):[this._cacheAndConvertItem(Oe,Se)]}}async provideCallsTo(x,q,ne){const le=this._itemFromCache(x,q);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!me)return me.map(Se=>({from:this._cacheAndConvertItem(x,Se.from),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}async provideCallsFrom(x,q,ne){const le=this._itemFromCache(x,q);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!me)return me.map(Se=>({to:this._cacheAndConvertItem(x,Se.to),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,q){var ne;const le=this._cache.get(x),me={_sessionId:x,_itemId:le.size.toString(36),name:q.name,detail:q.detail,kind:A.SymbolKind.from(q.kind),uri:q.uri,range:A.Range.from(q.range),selectionRange:A.Range.from(q.selectionRange),tags:(ne=q.tags)===null||ne===void 0?void 0:ne.map(A.SymbolTag.from)};return le.set(me._itemId,q),me}_itemFromCache(x,q){const ne=this._cache.get(x);return ne==null?void 0:ne.get(q)}}class xe{constructor(x,q){this.adapter=x,this.extension=q}}class Ae{constructor(x,q,ne,le,me,Se,Oe){this._adapter=new Map,this._uriTransformer=q,this._proxy=x.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=me,this._logService=Se,this._apiDeprecation=Oe}_transformDocumentSelector(x){return(0,i.coalesce)((0,i.asArray)(x).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:A.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Ae._handlePool++}_withAdapter(x,q,ne,le,me=!1){const Se=this._adapter.get(x);if(!Se)return Promise.resolve(le);if(Se.adapter instanceof q){let Oe;Se.extension&&(Oe=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${q.name}'`));const ge=ne(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Pe=>{me&&Pe instanceof S.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,q){const ne=this._nextHandle();return this._adapter.set(ne,new xe(x,q)),ne}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,q,ne,le){const me=this._addNewAdapter(new f(this._documents,ne),x),Se=le&&le.label||Ae._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(q),Se),this._createDisposable(me)}$provideDocumentSymbols(x,q,ne){return this._withAdapter(x,f,le=>le.provideDocumentSymbols(w.URI.revive(q),ne),void 0)}registerCodeLensProvider(x,q,ne){const le=this._nextHandle(),me=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new l(this._documents,this._commands.converter,ne),x)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(q),me);let Se=this._createDisposable(le);if(me!==void 0){const Oe=ne.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));Se=T.Disposable.from(Se,Oe)}return Se}$provideCodeLenses(x,q,ne){return this._withAdapter(x,l,le=>le.provideCodeLenses(w.URI.revive(q),ne),void 0)}$resolveCodeLens(x,q,ne){return this._withAdapter(x,l,le=>le.resolveCodeLens(q,ne),void 0)}$releaseCodeLenses(x,q){this._withAdapter(x,l,ne=>Promise.resolve(ne.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(x,q,ne){const le=this._addNewAdapter(new t(this._documents,ne),x);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDefinition(x,q,ne,le){return this._withAdapter(x,t,me=>me.provideDefinition(w.URI.revive(q),ne,le),[])}registerDeclarationProvider(x,q,ne){const le=this._addNewAdapter(new n(this._documents,ne),x);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDeclaration(x,q,ne,le){return this._withAdapter(x,n,me=>me.provideDeclaration(w.URI.revive(q),ne,le),[])}registerImplementationProvider(x,q,ne){const le=this._addNewAdapter(new u(this._documents,ne),x);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideImplementation(x,q,ne,le){return this._withAdapter(x,u,me=>me.provideImplementation(w.URI.revive(q),ne,le),[])}registerTypeDefinitionProvider(x,q,ne){const le=this._addNewAdapter(new o(this._documents,ne),x);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideTypeDefinition(x,q,ne,le){return this._withAdapter(x,o,me=>me.provideTypeDefinition(w.URI.revive(q),ne,le),[])}registerHoverProvider(x,q,ne,le){const me=this._addNewAdapter(new s(this._documents,ne),x);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(q)),this._createDisposable(me)}$provideHover(x,q,ne,le){return this._withAdapter(x,s,me=>me.provideHover(w.URI.revive(q),ne,le),void 0)}registerEvaluatableExpressionProvider(x,q,ne,le){const me=this._addNewAdapter(new c(this._documents,ne),x);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(q)),this._createDisposable(me)}$provideEvaluatableExpression(x,q,ne,le){return this._withAdapter(x,c,me=>me.provideEvaluatableExpression(w.URI.revive(q),ne,le),void 0)}registerInlineValuesProvider(x,q,ne,le){const me=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new b(this._documents,ne),x);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(q),me);let Oe=this._createDisposable(Se);if(me!==void 0){const ge=ne.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Oe=T.Disposable.from(Oe,ge)}return Oe}$provideInlineValues(x,q,ne,le,me){return this._withAdapter(x,b,Se=>Se.provideInlineValues(w.URI.revive(q),ne,le,me),void 0)}registerDocumentHighlightProvider(x,q,ne){const le=this._addNewAdapter(new _(this._documents,ne),x);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentHighlights(x,q,ne,le){return this._withAdapter(x,_,me=>me.provideDocumentHighlights(w.URI.revive(q),ne,le),void 0)}registerLinkedEditingRangeProvider(x,q,ne){const le=this._addNewAdapter(new p(this._documents,ne),x);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideLinkedEditingRanges(x,q,ne,le){return this._withAdapter(x,p,async me=>{const Se=await me.provideLinkedEditingRanges(w.URI.revive(q),ne,le);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Ae._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(x,q,ne){const le=this._addNewAdapter(new E(this._documents,ne),x);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideReferences(x,q,ne,le,me){return this._withAdapter(x,E,Se=>Se.provideReferences(w.URI.revive(q),ne,le,me),void 0)}registerCodeActionProvider(x,q,ne,le){var me,Se;const Oe=new h.DisposableStore,ge=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(q),{providedKinds:(me=le==null?void 0:le.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(Se=le==null?void 0:le.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Oe)}))},Ae._extLabel(x),Boolean(ne.resolveCodeAction)),Oe.add(this._createDisposable(ge)),Oe}$provideCodeActions(x,q,ne,le,me){return this._withAdapter(x,F,Se=>Se.provideCodeActions(w.URI.revive(q),ne,le,me),void 0)}$resolveCodeAction(x,q,ne){return this._withAdapter(x,F,le=>le.resolveCodeAction(q,ne),void 0)}$releaseCodeActions(x,q){this._withAdapter(x,F,ne=>Promise.resolve(ne.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(x,q,ne){const le=this._addNewAdapter(new B(this._documents,ne),x);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentFormattingEdits(x,q,ne,le){return this._withAdapter(x,B,me=>me.provideDocumentFormattingEdits(w.URI.revive(q),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(x,q,ne){const le=this._addNewAdapter(new Y(this._documents,ne),x);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(x,q,ne,le,me){return this._withAdapter(x,Y,Se=>Se.provideDocumentRangeFormattingEdits(w.URI.revive(q),ne,le,me),void 0)}registerOnTypeFormattingEditProvider(x,q,ne,le){const me=this._addNewAdapter(new fe(this._documents,ne),x);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(q),le,x.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(x,q,ne,le,me,Se){return this._withAdapter(x,fe,Oe=>Oe.provideOnTypeFormattingEdits(w.URI.revive(q),ne,le,me,Se),void 0)}registerWorkspaceSymbolProvider(x,q){const ne=this._addNewAdapter(new V(q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(x,q,ne){return this._withAdapter(x,V,le=>le.provideWorkspaceSymbols(q,ne),{symbols:[]})}$resolveWorkspaceSymbol(x,q,ne){return this._withAdapter(x,V,le=>le.resolveWorkspaceSymbol(q,ne),void 0)}$releaseWorkspaceSymbols(x,q){this._withAdapter(x,V,ne=>ne.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(x,q,ne){const le=this._addNewAdapter(new z(this._documents,ne,this._logService),x);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(q),z.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(x,q,ne,le,me){return this._withAdapter(x,z,Se=>Se.provideRenameEdits(w.URI.revive(q),ne,le,me),void 0)}$resolveRenameLocation(x,q,ne,le){return this._withAdapter(x,z,me=>me.resolveRenameLocation(w.URI.revive(q),ne,le),void 0)}registerDocumentSemanticTokensProvider(x,q,ne,le){const me=this._nextHandle(),Se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new xe(new $(this._documents,ne),x)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(q),le,Se);let Oe=this._createDisposable(me);if(Se){const ge=ne.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Oe=T.Disposable.from(Oe,ge)}return Oe}$provideDocumentSemanticTokens(x,q,ne,le){return this._withAdapter(x,$,me=>me.provideDocumentSemanticTokens(w.URI.revive(q),ne,le),null,!0)}$releaseDocumentSemanticTokens(x,q){this._withAdapter(x,$,ne=>ne.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(x,q,ne,le){const me=this._addNewAdapter(new R(this._documents,ne),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(q),le),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(x,q,ne,le){return this._withAdapter(x,R,me=>me.provideDocumentRangeSemanticTokens(w.URI.revive(q),ne,le),null,!0)}registerCompletionItemProvider(x,q,ne,le){const me=this._addNewAdapter(new L(this._documents,this._commands.converter,ne,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(q),le,L.supportsResolving(ne),`${x.identifier.value}(${le.join("")})`),this._createDisposable(me)}$provideCompletionItems(x,q,ne,le,me){return this._withAdapter(x,L,Se=>Se.provideCompletionItems(w.URI.revive(q),ne,le,me),void 0)}$resolveCompletionItem(x,q,ne){return this._withAdapter(x,L,le=>le.resolveCompletionItem(q,ne),void 0)}$releaseCompletionItems(x,q){this._withAdapter(x,L,ne=>ne.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(x,q,ne,le){const me=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Se=this._addNewAdapter(new M(this._documents,ne),x);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(q),me),this._createDisposable(Se)}$provideSignatureHelp(x,q,ne,le,me){return this._withAdapter(x,M,Se=>Se.provideSignatureHelp(w.URI.revive(q),ne,le,me),void 0)}$releaseSignatureHelp(x,q){this._withAdapter(x,M,ne=>ne.releaseSignatureHelp(q),void 0)}registerInlineHintsProvider(x,q,ne){const le=typeof ne.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new U(this._documents,ne),x);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(q),le);let Se=this._createDisposable(me);if(le!==void 0){const Oe=ne.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(le));Se=T.Disposable.from(Se,Oe)}return Se}$provideInlineHints(x,q,ne,le){return this._withAdapter(x,U,me=>me.provideInlineHints(w.URI.revive(q),ne,le),void 0)}registerDocumentLinkProvider(x,q,ne){const le=this._addNewAdapter(new G(this._documents,ne),x);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(q),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(x,q,ne){return this._withAdapter(x,G,le=>le.provideLinks(w.URI.revive(q),ne),void 0)}$resolveDocumentLink(x,q,ne){return this._withAdapter(x,G,le=>le.resolveLink(q,ne),void 0)}$releaseDocumentLinks(x,q){this._withAdapter(x,G,ne=>ne.releaseLinks(q),void 0)}registerColorProvider(x,q,ne){const le=this._addNewAdapter(new X(this._documents,ne),x);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentColors(x,q,ne){return this._withAdapter(x,X,le=>le.provideColors(w.URI.revive(q),ne),[])}$provideColorPresentations(x,q,ne,le){return this._withAdapter(x,X,me=>me.provideColorPresentations(w.URI.revive(q),ne,le),void 0)}registerFoldingRangeProvider(x,q,ne){const le=this._nextHandle(),me=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new se(this._documents,ne),x)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(q),me);let Se=this._createDisposable(le);if(me!==void 0){const Oe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Se=T.Disposable.from(Se,Oe)}return Se}$provideFoldingRanges(x,q,ne,le){return this._withAdapter(x,se,me=>me.provideFoldingRanges(w.URI.revive(q),ne,le),void 0)}registerSelectionRangeProvider(x,q,ne){const le=this._addNewAdapter(new pe(this._documents,ne,this._logService),x);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideSelectionRanges(x,q,ne,le){return this._withAdapter(x,pe,me=>me.provideSelectionRanges(w.URI.revive(q),ne,le),[])}registerCallHierarchyProvider(x,q,ne){const le=this._addNewAdapter(new Te(this._documents,ne),x);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$prepareCallHierarchy(x,q,ne,le){return this._withAdapter(x,Te,me=>Promise.resolve(me.prepareSession(w.URI.revive(q),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(x,q,ne,le){return this._withAdapter(x,Te,me=>me.provideCallsTo(q,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(x,q,ne,le){return this._withAdapter(x,Te,me=>me.provideCallsFrom(q,ne,le),void 0)}$releaseCallHierarchy(x,q){this._withAdapter(x,Te,ne=>Promise.resolve(ne.releaseSession(q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,D.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Ae._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Ae._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Ae._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Ae._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Ae._serializeRegExp(x.beforeText),afterText:x.afterText?Ae._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Ae._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Ae._serializeOnEnterRule)}setLanguageConfiguration(x,q,ne){let{wordPattern:le}=ne;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(q,le):this._documents.setWordDefinitionFor(q,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const me=this._nextHandle(),Se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ae._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ae._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ae._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,q,Se),this._createDisposable(me)}$setWordDefinitions(x){for(const q of x)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Ae,Ae._handlePool=0}),define(we[200],_e([0,1,5,9,7]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(C,D){this._proxy=C.getProxy(w.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,D){var k;const i=C.version,P=I.Position.from(D),d=await this._proxy.$tokensAtPosition(C.uri,P),h={type:A.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new A.Range(D.line,D.character,D.line,D.character)};if(!d)return h;const r={range:I.Range.to(d.range),type:I.TokenType.to(d.type)};return!r.range.contains(D)||i!==C.version?h:r}}e.ExtHostLanguages=T}),define(we[201],_e([0,1,5,18,33]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(C){return C&&C.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(w.MainContext.MainThreadMessageService)}showMessage(D,k,i,P,d){const h={extension:D};let r;typeof P=="string"||T(P)?r=[P,...d]:(h.modal=P&&P.modal,h.useCustom=P&&P.useCustom,r=d),h.useCustom&&(0,A.checkProposedApiEnabled)(D);const a=[];for(let g=0;g<r.length;g++){const m=r[g];if(typeof m=="string")a.push({title:m,handle:g,isCloseAffordance:!1});else if(typeof m=="object"){let{title:S,isCloseAffordance:f}=m;a.push({title:S,isCloseAffordance:!!f,handle:g})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,i,h,a).then(g=>{if(typeof g=="number")return r[g]})}};y=Ve([qe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(we[202],_e([0,1,11,23,20,3,56,54,6,22,8,10,2,68,5,9,7,73,179,180]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class l{constructor(s,c){const b=l._Keys.nextId();s.$registerNotebookEditorDecorationType(b,a.NotebookDecorationRenderOptions.from(c)),this.value={key:b,dispose(){s.$removeNotebookEditorDecorationType(b)}}}}e.NotebookEditorDecorationType=l,l._Keys=new C.IdGenerator("NotebookEditorDecorationType");class v{constructor(s,c,b,_,p,E){this._textDocumentsAndEditors=b,this._textDocuments=_,this.logService=p,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new h.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(r.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(r.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(r.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:F=>{var B;if(F&&F.$mid===12){const Y=(B=F.notebookEditor)===null||B===void 0?void 0:B.notebookUri,fe=F.cell.handle,V=this._documents.get(Y),z=V==null?void 0:V.getCell(fe);if(z)return z.apiCell}return F}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[c,b]of this._editors)if(b.apiEditor===s)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const c=this._documents.get(s);if(!c)throw new Error(`NO notebook document for '${s}'`);return c}_getProviderData(s){const c=this._notebookContentProviders.get(s);if(!c)throw new Error(`NO provider for '${s}'`);return c}registerNotebookContentProvider(s,c,b,_){var p,E,F;if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:s,provider:b});let B;b.onDidChangeNotebookContentOptions&&(B=b.onDidChangeNotebookContentOptions(()=>{const V=a.NotebookDocumentContentOptions.from(b.options);this._notebookProxy.$updateNotebookProviderOptions(c,V)}));const Y=(p=_==null?void 0:_.viewOptions)===null||p===void 0?void 0:p.filenamePattern.map(V=>a.NotebookExclusiveDocumentPattern.from(V)).filter(V=>V!==void 0);((E=_==null?void 0:_.viewOptions)===null||E===void 0?void 0:E.filenamePattern)&&!Y&&console.warn(`Notebook content provider view options file name pattern is invalid ${(F=_==null?void 0:_.viewOptions)===null||F===void 0?void 0:F.filenamePattern}`);const fe=a.NotebookDocumentContentOptions.from(_);return this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation,description:s.description},c,{transientOutputs:fe.transientOutputs,transientCellMetadata:fe.transientCellMetadata,transientDocumentMetadata:fe.transientDocumentMetadata,viewOptions:(_==null?void 0:_.viewOptions)&&Y?{displayName:_.viewOptions.displayName,filenamePattern:Y,exclusive:_.viewOptions.exclusive||!1}:void 0}),new g.Disposable(()=>{B==null||B.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}registerNotebookCellStatusBarItemProvider(s,c,b){const _=v._notebookStatusBarItemProviderHandlePool++,p=typeof b.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(_,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(_,p,c);let E;return p!==void 0&&(E=b.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(p))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(_),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(_,p),E&&E.dispose()})}createNotebookEditorDecorationType(s){return new l(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const c=this._documents.get(s);if(c)return c.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenDocument(s),_=this._documents.get(d.URI.revive(b));return(0,P.assertIsDefined)(_==null?void 0:_.apiNotebook)}async showNotebookDocument(s,c){var b;d.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let _;typeof c=="object"?_={position:a.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(a.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:_={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,_),E=p&&((b=this._editors.get(p))===null||b===void 0?void 0:b.apiEditor);if(E)return E;throw p?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,c,b,_){var p;const E=this._notebookStatusBarItemProviders.get(s),F=d.URI.revive(c),B=this._documents.get(F);if(!(!B||!E)){const Y=B.getCellFromIndex(b);if(!!Y){const fe=await E.provideCellStatusBarItems(Y.apiCell,_);if(!!fe){const V=new D.DisposableStore,z=this._statusBarCache.add([V]),ee=(p=fe&&fe.map($=>a.NotebookStatusBarItem.from($,this._commandsConverter,V)))!==null&&p!==void 0?p:void 0;return{cacheId:z,items:ee}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,c,b,_){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const p=this._handlePool++;this._notebookSerializer.set(p,b);const E=a.NotebookDocumentContentOptions.from(_);return this._notebookProxy.$registerNotebookSerializer(p,{id:s.identifier,location:s.extensionLocation,description:s.description},c,E),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(p)})}async $dataToNotebook(s,c,b){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const p=await _.deserializeNotebook(c.buffer,b);return{metadata:a.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(a.NotebookCellData.from)}}async $notebookToData(s,c,b){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const p=await _.serializeNotebook({metadata:a.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(a.NotebookCellData.to)},b);return I.VSBuffer.wrap(p)}cancelOneNotebookCellExecution(s){const c=this._activeExecutions.get(s.uri);c==null||c.cancel()}async $openNotebook(s,c,b,_,p){const{provider:E}=this._getProviderData(s),F=await E.openNotebook(d.URI.revive(c),{backupId:b,untitledDocumentData:_==null?void 0:_.buffer},p);return{metadata:a.NotebookDocumentMetadata.from(F.metadata),cells:F.cells.map(a.NotebookCellData.from)}}async $saveNotebook(s,c,b){const _=this._getNotebookDocument(d.URI.revive(c)),{provider:p}=this._getProviderData(s);return await p.saveNotebook(_.apiNotebook,b),!0}async $saveNotebookAs(s,c,b,_){const p=this._getNotebookDocument(d.URI.revive(c)),{provider:E}=this._getProviderData(s);return await E.saveNotebookAs(d.URI.revive(b),p.apiNotebook,_),!0}async $backupNotebook(s,c,b){var _;const p=this._getNotebookDocument(d.URI.revive(c)),E=this._getProviderData(s),F=(_=this._extensionStoragePaths.workspaceValue(E.extension))!==null&&_!==void 0?_:this._extensionStoragePaths.globalValue(E.extension),B=String((0,y.hash)([p.uri.toString(),this._backupIdPool++])),Y=d.URI.joinPath(F,B),fe=await E.provider.backupNotebook(p.apiNotebook,{destination:Y},b);return p.updateBackup(fe),fe.id}$acceptModelChanged(s,c,b){this._getNotebookDocument(d.URI.revive(s)).acceptModelChanged(c,b)}$acceptDirtyStateChanged(s,c){const b=this._getNotebookDocument(d.URI.revive(s));b.acceptModelChanged({rawEvents:[],versionId:b.apiNotebook.version},c)}$acceptModelSaved(s){const c=this._getNotebookDocument(d.URI.revive(s));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,c);const b=this._editors.get(s);if(!b)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&b._acceptVisibleRanges(c.visibleRanges.ranges.map(a.NotebookRange.to)),c.selections&&b._acceptSelections(c.selections.selections.map(a.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const c in s){const b=this._editors.get(c);if(!b)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);b._acceptViewColumn(a.ViewColumn.to(s[c]))}}$acceptDocumentPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,c);const b=this._getNotebookDocument(d.URI.revive(s));b.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:b.apiNotebook})}_createExtHostEditor(s,c,b){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const _=new f.ExtHostNotebookEditor(c,this._notebookEditorsProxy,s,b.visibleRanges.map(a.NotebookRange.to),b.selections.map(a.NotebookRange.to),typeof b.viewColumn=="number"?a.ViewColumn.to(b.viewColumn):void 0);this._editors.set(c,_)}$acceptDocumentAndEditorsDelta(s){var c,b,_;if(s.removedDocuments)for(const E of s.removedDocuments){const F=d.URI.revive(E),B=this._documents.get(F);B&&(B.dispose(),this._documents.delete(F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.apiNotebook.getCells().map(Y=>Y.document.uri)}),this._onDidCloseNotebookDocument.fire(B.apiNotebook));for(const Y of this._editors.values())Y.notebookData.uri.toString()===F.toString()&&this._editors.delete(Y.id)}if(s.addedDocuments){const E=[];for(const F of s.addedDocuments){const B=d.URI.revive(F.uri),Y=F.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B} `);const fe=this,V=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(z){fe._onDidChangeNotebookCells.fire(z)},emitCellOutputsChange(z){fe._onDidChangeCellOutputs.fire(z)},emitCellMetadataChange(z){fe._onDidChangeCellMetadata.fire(z)},emitCellExecutionStateChange(z){fe._onDidChangeCellExecutionState.fire(z)}},Y,F.metadata?a.NotebookDocumentMetadata.to(F.metadata):new g.NotebookDocumentMetadata,B);V.acceptModelChanged({versionId:F.versionId,rawEvents:[{kind:m.NotebookCellsChangeType.Initialize,changes:[[0,0,F.cells]]}]},!1),E.push(...F.cells.map(z=>S.ExtHostCell.asModelAddData(V.apiNotebook,z))),(c=this._documents.get(B))===null||c===void 0||c.dispose(),this._documents.set(B,V),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this._onDidOpenNotebookDocument.fire(V.apiNotebook)}}if(s.addedEditors)for(const E of s.addedEditors){if(this._editors.has(E.id))return;const F=d.URI.revive(E.documentUri),B=this._documents.get(F);B&&this._createExtHostEditor(B,E.id,E)}const p=[];if(s.removedEditors)for(const E of s.removedEditors){const F=this._editors.get(E);F&&(this._editors.delete(E),((b=this._activeNotebookEditor)===null||b===void 0?void 0:b.id)===F.id&&(this._activeNotebookEditor=void 0),p.push(F))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(F=>this._editors.get(F)).filter(F=>!!F);const E=new Set;this._visibleNotebookEditors.forEach(F=>E.add(F.id));for(const F of this._editors.values()){const B=E.has(F.id);F._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(F=>F).filter(F=>F.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((_=this._activeNotebookEditor)===null||_===void 0?void 0:_.apiEditor)}createNotebookCellExecution(s,c,b){const _=this.lookupNotebookDocument(s);if(!_)throw new Error(`Invalid uri: ${s} `);const p=_.getCellFromIndex(c);if(!p)throw new Error(`Invalid cell index: ${s}, ${c} `);if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const E=new n(s,_,p,this._notebookDocumentsProxy);this._activeExecutions.set(p.uri,E);const F=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),F.dispose(),this._activeExecutions.delete(p.uri))});return E.asApiObject()}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0;var t;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(t||(t={}));class n extends D.Disposable{constructor(s,c,b,_){super();this._uri=s,this._document=c,this._cell=b,this._proxy=_,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new A.CancellationTokenSource),this._collector=new u(10,p=>this.applyEdits(p)),this._executionOrder=b.internalMetadata.executionOrder,this.mixinMetadata({runState:g.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const c={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([c])}cellIndexToHandle(s){const c=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!c)return c.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(c){s._executionOrder=c,s.mixinMetadata({executionOrder:c})},start(c){var b;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:g.NotebookCellExecutionState.Executing,runStartTime:(b=c==null?void 0:c.startTime)!==null&&b!==void 0?b:null})},end(c){var b,_;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:g.NotebookCellExecutionState.Idle,lastRunSuccess:(b=c==null?void 0:c.success)!==null&&b!==void 0?b:null,runEndTime:(_=c==null?void 0:c.endTime)!==null&&_!==void 0?_:null})},clearOutput(c){return s.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,b){s.verifyStateForOutput();const _=s.cellIndexToHandle(b);if(typeof _=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:_,append:!0,outputs:c.map(a.NotebookCellOutput.from)})},async replaceOutput(c,b){s.verifyStateForOutput();const _=s.cellIndexToHandle(b);if(typeof _=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:_,outputs:c.map(a.NotebookCellOutput.from)})},async appendOutputItems(c,b){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,append:!0,items:c.map(a.NotebookCellOutputItem.from),outputId:b})},async replaceOutputItems(c,b){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,items:c.map(a.NotebookCellOutputItem.from),outputId:b})},token:s._tokenSource.token})}}class u{constructor(s,c){this.delay=s,this.callback=c,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,w.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(we[203],_e([0,1,3,6,5,2,9,72]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class D{constructor(i,P,d){this._initData=P,this._extHostNotebook=d,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(i,P,d,h,r,a){for(let _ of this._kernelData.values())if(_.controller.id===P)throw new Error(`notebook controller with id '${P}' ALREADY exist`);const g=this._handlePool++,m=this,S=()=>console.warn(`NO execute handler from notebook controller '${n.id}' of extension: '${i.identifier}'`);let f=!1;const l=new I.DisposableStore,v=new w.Emitter,t=new w.Emitter,n={id:P,viewType:d,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:h||i.identifier.value,preloads:a?a.map(y.NotebookKernelPreload.from):[]};let u=r!=null?r:S,o;this._proxy.$addKernel(g,n).catch(_=>{console.log(_),f=!0});let s=0;const c=()=>{if(!f){const _=++s;Promise.resolve().then(()=>{_===s&&this._proxy.$updateKernel(g,n)})}},b={get id(){return n.id},get viewType(){return n.viewType},onDidChangeNotebookAssociation:v.event,get label(){return n.label},set label(_){var p;n.label=(p=_!=null?_:i.displayName)!==null&&p!==void 0?p:i.name,c()},get detail(){var _;return(_=n.detail)!==null&&_!==void 0?_:""},set detail(_){n.detail=_,c()},get description(){var _;return(_=n.description)!==null&&_!==void 0?_:""},set description(_){n.description=_,c()},get supportedLanguages(){return n.supportedLanguages},set supportedLanguages(_){n.supportedLanguages=_,c()},get hasExecutionOrder(){var _;return(_=n.hasExecutionOrder)!==null&&_!==void 0?_:!1},set hasExecutionOrder(_){n.hasExecutionOrder=_,c()},get preloads(){return n.preloads?n.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return u},set executeHandler(_){u=_!=null?_:S},get interruptHandler(){return o},set interruptHandler(_){o=_,n.supportsInterrupt=Boolean(_),c()},createNotebookCellExecutionTask(_){if(f)throw new Error("notebook controller is DISPOSED");return m._extHostNotebook.createNotebookCellExecution(_.notebook.uri,_.index,n.id)},dispose:()=>{f||(f=!0,this._kernelData.delete(g),l.dispose(),v.dispose(),t.dispose(),this._proxy.$removeKernel(g))},onDidReceiveMessage:t.event,postMessage(_,p){return m._proxy.$postMessage(g,p&&m._extHostNotebook.getIdByEditor(p),_)},asWebviewUri(_){return(0,C.asWebviewUri)(m._initData.environment,String(g),_)},updateNotebookAffinity(_,p){m._proxy.$updateNotebookPriority(g,_.uri,p)}};return this._kernelData.set(g,{extensionId:i.identifier,controller:b,onDidChangeSelection:v,onDidReceiveMessage:t}),b}$acceptSelection(i,P,d){const h=this._kernelData.get(i);h&&h.onDidChangeSelection.fire({selected:d,notebook:this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P)).apiNotebook})}async $executeCells(i,P,d){const h=this._kernelData.get(i);if(!!h){const r=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P));if(!r)throw new Error("MISSING notebook");const a=[];for(let g of d){const m=r.getCell(g);m&&a.push(m.apiCell)}try{await h.controller.executeHandler.call(h.controller,a,r.apiNotebook,h.controller)}catch(g){console.error(g)}}}async $cancelCells(i,P,d){const h=this._kernelData.get(i);if(!!h){const r=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P));if(!r)throw new Error("MISSING notebook");h.controller.interruptHandler&&await h.controller.interruptHandler.call(h.controller,r.apiNotebook);for(let a of d){const g=r.getCell(a);g&&this._extHostNotebook.cancelOneNotebookCellExecution(g)}}}$acceptRendererMessage(i,P,d){const h=this._kernelData.get(i);if(!!h){const r=this._extHostNotebook.getEditorById(P);if(!r)throw new Error(`send message for UNKNOWN editor: ${P}`);h.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:d}))}}}e.ExtHostNotebookKernels=D}),define(we[100],_e([0,1,5,3,6,23,4,14]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends A.Disposable{constructor(r,a,g,m){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,a,g),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(a=>this._proxy.$clear(a,r))}show(r,a){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof r=="boolean"?r:a)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(r,a){super(r,!1,void 0,a)}append(r){super.append(r),this._id.then(a=>this._proxy.$append(a,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends D{constructor(r,a,g){super(r,!0,a,g)}append(r){throw new Error("Not supported")}}class P{constructor(r,a){this.name=r,this._channel=a}append(r){this._channel.then(a=>a.append(r))}appendLine(r){this._channel.then(a=>a.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,a){this._channel.then(g=>g.show(r,a))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(r){this._proxy=r.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,a){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new i(r,a,this._proxy)}};d=Ve([qe(0,C.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(we[204],_e([0,1,11,20,3,6,5,2,7,12,15,47]),function(Q,e,w,I,A,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(h,r,a){const g=h.getProxy(y.MainContext.MainThreadQuickOpen);class m{constructor(o,s){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=s}showQuickPick(o,s,c,b=I.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(o),p=++this._instances,E=g.$show(p,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},b),F={},B=E.then(()=>F);return Promise.race([B,_]).then(Y=>{if(Y!==F)return _.then(fe=>{const V=[];for(let z=0;z<fe.length;z++){const ee=fe[z];let $,R,L,M,U;typeof ee=="string"?$=ee:($=ee.label,R=ee.description,L=ee.detail,M=ee.picked,U=ee.alwaysShow),V.push({label:$,description:R,handle:z,detail:L,picked:M,alwaysShow:U})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{c.onDidSelectItem(fe[z])}),g.$setItems(p,V),E.then(z=>{if(typeof z=="number")return fe[z];if(Array.isArray(z))return z.map(ee=>fe[ee])})})}).then(void 0,Y=>{if(!(0,k.isPromiseCanceledError)(Y))return g.$setError(p,Y),Promise.reject(Y)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,s=I.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,g.$input(o,typeof this._validateInput=="function",s).then(void 0,c=>{if(!(0,k.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(o){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,s=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!c){const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(_=>_.uri.toString()===c.uri.toString())}}createQuickPick(o,s){const c=new t(o,s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(o){const s=new n(o,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(o,s){const c=this._sessions.get(o);c&&c._fireDidChangeValue(s)}$onDidAccept(o){const s=this._sessions.get(o);s&&s._fireDidAccept()}$onDidChangeActive(o,s){const c=this._sessions.get(o);c instanceof t&&c._fireDidChangeActive(s)}$onDidChangeSelection(o,s){const c=this._sessions.get(o);c instanceof t&&c._fireDidChangeSelection(s)}$onDidTriggerButton(o,s){const c=this._sessions.get(o);c&&c._fireDidTriggerButton(s)}$onDidHide(o){const s=this._sessions.get(o);s&&s._fireDidHide()}}class S{constructor(o,s){this._extensionId=o,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((s,c)=>{const b=s===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(b,s)}),this.update({buttons:o.map((s,c)=>({iconPath:f(s.iconPath),tooltip:s.tooltip,handle:s===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const s=this._handlesToButtons.get(o);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(o){if(!this._disposed){for(const s of Object.keys(o)){const c=o[s];this._pendingUpdate[s]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function f(u){if(u instanceof D.ThemeIcon)return{id:u.id};const o=v(u),s=l(u);return{dark:typeof o=="string"?C.URI.file(o):o,light:typeof s=="string"?C.URI.file(s):s}}function l(u){return typeof u=="object"&&"light"in u?u.light:u}function v(u){return typeof u=="object"&&"dark"in u?u.dark:u}class t extends S{constructor(o,s,c){super(o,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((s,c)=>{this._handlesToItems.set(c,s),this._itemsToHandles.set(s,c)}),this.update({items:o.map((s,c)=>({label:s.label,description:s.description,handle:c,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(o){const s=(0,i.coalesce)(o.map(c=>this._handlesToItems.get(c)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(o){const s=(0,i.coalesce)(o.map(c=>this._handlesToItems.get(c)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends S{constructor(o,s){super(o,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?P.default.Error:P.default.Ignore})}}return new m(r,a)}e.createExtHostQuickOpen=d}),define(we[205],_e([0,1,2,3,52,6,11,5,15,112,18,26,33]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(o){if(o)return typeof o.iconPath=="string"?w.URI.file(o.iconPath):o.iconPath}function r(o,s){if(!o.iconPath&&!s.iconPath)return 0;if(o.iconPath){if(!s.iconPath)return 1}else return-1;const c=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,b=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,k.comparePaths)(c,b)}function a(o,s){let c=0;if(o.strikeThrough!==s.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==s.faded)return o.faded?1:-1;if(o.tooltip!==s.tooltip)return(o.tooltip||"").localeCompare(s.tooltip||"");if(c=r(o,s),c!==0)return c;if(o.light&&s.light)c=r(o.light,s.light);else{if(o.light)return 1;if(s.light)return-1}if(c!==0)return c;if(o.dark&&s.dark)c=r(o.dark,s.dark);else{if(o.dark)return 1;if(s.dark)return-1}return c}function g(o,s){if(o.command!==s.command)return o.command<s.command?-1:1;if(o.title!==s.title)return o.title<s.title?-1:1;if(o.tooltip!==s.tooltip){if(o.tooltip!==void 0&&s.tooltip!==void 0)return o.tooltip<s.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(o.arguments===s.arguments)return 0;if(o.arguments)if(s.arguments){if(o.arguments.length!==s.arguments.length)return o.arguments.length-s.arguments.length}else return 1;else return-1;for(let c=0;c<o.arguments.length;c++){const b=o.arguments[c],_=s.arguments[c];if(b!==_)return b<_?-1:1}return 0}function m(o,s){let c=(0,k.comparePaths)(o.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(c!==0)return c;if(o.command&&s.command)c=g(o.command,s.command);else{if(o.command)return 1;if(s.command)return-1}if(c!==0)return c;if(o.decorations&&s.decorations)c=a(o.decorations,s.decorations);else{if(o.decorations)return 1;if(s.decorations)return-1}return c}function S(o,s){for(let c=0;c<o.length;c++)if(o[c]!==s[c])return!1;return!0}function f(o,s){return o.command===s.command&&o.title===s.title&&o.tooltip===s.tooltip&&(o.arguments&&s.arguments?S(o.arguments,s.arguments):o.arguments===s.arguments)}function l(o,s){return(0,D.equals)(o,s,f)}class v{constructor(s,c,b){this._extension=s,this._proxy=c,this._sourceControlHandle=b,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,d.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,c){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,c)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=v;class t{constructor(s,c,b,_,p){this._proxy=s,this._commands=c,this._sourceControlHandle=b,this._id=_,this._label=p,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,c){const b=this._resourceStatesCommandsMap.get(s);return b?(0,y.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const c=[...this._resourceStates].sort(m),_=(0,D.sortedDiff)(this._resourceSnapshot,c,m).map(F=>{const B=F.toInsert.map(Y=>{const fe=this._resourceHandlePool++;this._resourceStatesMap.set(fe,Y);const V=Y.resourceUri,z=h(Y.decorations),ee=Y.decorations&&h(Y.decorations.light)||z,$=Y.decorations&&h(Y.decorations.dark)||z,R=[];let L;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"){const pe=new T.DisposableStore;L=this._commands.converter.toInternal(Y.command,pe),this._resourceStatesDisposablesMap.set(fe,pe)}else this._resourceStatesCommandsMap.set(fe,Y.command);ee&&R.push(ee),$&&$.toString()!==(ee==null?void 0:ee.toString())&&R.push($);const M=Y.decorations&&Y.decorations.tooltip||"",U=Y.decorations&&!!Y.decorations.strikeThrough,G=Y.decorations&&!!Y.decorations.faded,X=Y.contextValue||"";return{rawResource:[fe,V,R,M,U,G,X,L],handle:fe}});return{start:F.start,deleteCount:F.deleteCount,toInsert:B}}),p=_.map(({start:F,deleteCount:B,toInsert:Y})=>[F,B,Y.map(fe=>fe.rawResource)]),E=_.reverse();for(const{start:F,deleteCount:B,toInsert:Y}of E){const fe=Y.map(z=>z.handle),V=this._handlesSnapshot.splice(F,B,...fe);for(const z of V)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(s=this._resourceStatesDisposablesMap.get(z))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=c,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,c,b,_,p,E){this._proxy=c,this._commands=b,this._id=_,this._label=p,this._rootUri=E,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,p,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const c=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&l(this._statusBarCommands,s))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const c=(s||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(s,c){const b=new t(this._proxy,this._commands,this.handle,s,c),_=I.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,_),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const s=[],c=[];for(const[b,_]of this.createdResourceGroups){_.dispose();const p=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});I.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),p.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),s.push([b.handle,b.id,b.label,b.features]);const E=b._takeResourceStateSnapshot();E.length>0&&c.push([b.handle,E]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,s,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(c=>{const b=c._takeResourceStateSnapshot();b.length!==0&&s.push([c.handle,b])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let u=class Tn{constructor(s,c,b){this._commands=c,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=s.getProxy(C.MainContext.MainThreadSCM),this._telemetry=s.getProxy(C.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const p=this._sourceControls.get(_.sourceControlHandle);if(!p)return _;const E=p.getResourceGroup(_.groupHandle);return E?E.getResourceState(_.handle):_}else if(_&&_.$mid===4){const p=this._sourceControls.get(_.sourceControlHandle);return p?p.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const p=this._sourceControls.get(_.handle);return p||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,c,b,_){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,c,b,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const p=Tn._handlePool++,E=new n(s,this._proxy,this._commands,c,b,_);this._sourceControls.set(p,E);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(s.identifier))||[];return F.push(E),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(s.identifier),F),E}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const c=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(s.identifier)),b=c&&c[c.length-1];return b&&b.inputBox}$provideOriginalResource(s,c,b){const _=w.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,_.toString());const p=this._sourceControls.get(s);return!p||!p.quickDiffProvider||!p.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>p.quickDiffProvider.provideOriginalResource(_,b)).then(E=>E||null)}$onInputBoxValueChange(s,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const b=this._sourceControls.get(s);return b&&b.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(s,c,b,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,c,b);const p=this._sourceControls.get(s);if(!p)return Promise.resolve(void 0);const E=p.getResourceGroup(c);return E?E.$executeResourceCommand(b,_):Promise.resolve(void 0)}$validateInput(s,c,b){this.logService.trace("ExtHostSCM#$validateInput",s);const _=this._sourceControls.get(s);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(c,b)).then(p=>p?Promise.resolve([p.message,p.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var c,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((c=this._sourceControls.get(s))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};u._handlePool=0,u=Ve([qe(2,i.ILogService)],u),e.ExtHostSCM=u});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[206],_e([0,1,7,5,135,6]),function(Q,e,w,I,A,T){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(d,h,r,a,g=w.StatusBarAlignment.Left,m,S){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,y,d,"f"),tt(this,C,h,"f"),this._id=D.ID_GEN++,this._statusId=r,this._statusName=a,this._alignment=g,this._priority=m,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!D.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Me(this,C,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Me(this,C,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,h,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const h={message:d};return this._messages.unshift(h),this._update(),new w.Disposable(()=>{const r=this._messages.indexOf(h);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,h){this._proxy=d.getProxy(I.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new k(this)}createStatusBarEntry(d,h,r,a,g){return new D(this._proxy,this._commands,d,h,r,a,g)}setStatusBarMessage(d,h){const r=this._statusMessage.setMessage(d);let a;return typeof h=="number"?a=setTimeout(()=>r.dispose(),h):typeof h!="undefined"&&h.then(()=>r.dispose(),()=>r.dispose()),new w.Disposable(()=>{r.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=i}),define(we[78],_e([0,1,5,3,4]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(C){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,k){return this._proxy.$getValue(C,D).then(i=>i||k)}setValue(C,D,k){return this._proxy.$setValue(C,D,k)}$acceptValue(C,D,k){this._onDidChangeStorage.fire({shared:C,key:D,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(we[79],_e([0,1,4,27,18,77,2]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,P){var d;this._logService=i,this._extHostFileSystem=P,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=Ve([qe(0,I.IExtHostInitDataService),qe(1,A.ILogService),qe(2,T.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(we[40],_e([0,1,3,5,4,2,14,6,7,136,12,173,20,31,156]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class a{constructor(t,n,u,o){this._proxy=t,this._id=n,this._creationOptions=u,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(c,b=!0){s._checkDisposed(),s._proxy.$sendText(s._id,c,b)},show(c){s._checkDisposed(),s._proxy.$show(s._id,c)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,u,o,s,c,b,_,p,E,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:u,env:o,icon:s,initialText:c,waitOnExit:b,strictEnv:_,hideFromUser:p,isFeatureTerminal:E,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class g{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let m=1,S=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[u,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new a(this._proxy,(0,h.generateUuid)(),t,t.name),u=new g(t.pty);return n.createExtensionTerminal().then(o=>{const s=this._setupExtHostProcessListeners(o,u);this._terminalProcessDisposables[o]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new g(n),s=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(t);u&&(this._activeTerminal=u,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const u=this._getTerminalById(t);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:n})}async $acceptTerminalDimensions(t,n,u){const o=this._getTerminalById(t);o&&o.setDimensions(n,u)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,u){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(n,u)}async $acceptTerminalTitleChange(t,n){const u=this._getTerminalById(t);u&&(u.name=n)}async $acceptTerminalClosed(t,n){const u=this._getTerminalObjectIndexById(this._terminals,t);if(u!==null){const o=this._terminals.splice(u,1)[0];o.setExitCode(n),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,n,u,o){if(n){const b=this._getTerminalObjectIndexById(this._terminals,n);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const s={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:T.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},c=new a(this._proxy,t,s,u);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const u=this._getTerminalById(t);u&&u._setProcessId(n)}async $startExtensionTerminal(t,n){const u=this._getTerminalById(t);if(!u)return{message:(0,k.localize)(0,null,t)};u.isOpen||await new Promise(s=>{const c=this.onDidOpenTerminal(async b=>{b===u.value&&(c.dispose(),s())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const u=new C.DisposableStore;u.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),u.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),u.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&u.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const o=this._extensionTerminalAwaitingStart[t];return o&&n instanceof g&&(n.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),u}$acceptProcessAckDataEvent(t,n){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.input(n)}$acceptProcessResize(t,n,u){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(n,u)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(t,u))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(u=>this._proxy.$sendProcessCwd(t,u))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const u=this._getTerminalById(t);if(!u)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const s=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const c=[],b={terminal:u.value,line:n},_=[];for(const F of this._linkProviders)_.push(new Promise(async B=>{s.token.onCancellationRequested(()=>B({provider:F,links:[]}));const Y=await F.provideTerminalLinks(b,s.token)||[];s.token.isCancellationRequested||B({provider:F,links:Y})}));const p=await Promise.all(_);if(s.token.isCancellationRequested)return[];const E=new Map;for(const F of p)F&&F.links.length>0&&c.push(...F.links.map(B=>{const Y={id:m++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return E.set(Y.id,{provider:F.provider,link:B}),Y}));return this._terminalLinkCache.set(t,E),c}$activateLink(t,n){var u;const o=(u=this._terminalLinkCache.get(t))===null||u===void 0?void 0:u.get(n);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const u=this._terminalProcessDisposables[t];u&&(u.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const u=this._getTerminalObjectIndexById(t,n);return u!==null?t[u]:null}_getTerminalObjectIndexById(t,n){let u=null;return t.some((o,s)=>o._id===n?(u=s,!0):!1),u}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new f,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const u=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const u=n[0],o=new f(n[1]);this._setEnvironmentVariableCollection(u,o)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=Ve([qe(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class f{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const u=this.map.get(t);(!u||u.value!==n.value||u.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((u,o)=>t.call(n,o,u,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let l=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,u){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}async $getDefaultShellAndArgs(t){throw new i.NotSupportedError}};l=Ve([qe(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(we[207],_e([0,1,3,15,5,97,9,7]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(d=>d.value)}async showTextDocument(i,P,d){let h;typeof P=="number"?h={position:y.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?h={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:h={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,h),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,P){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const h=P.selections.selections.map(y.Selection.to);d._acceptSelections(h)}if(P.visibleRanges){const h=I.coalesce(P.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(h)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const h=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:h})}if(P.visibleRanges){const h=I.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:h})}}$acceptEditorPositionData(i){for(const P in i){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const h=y.ViewColumn.to(i[P]);d.value.viewColumn!==h&&(d._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:h}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var zt=this&&this.__rest||function(Q,e){var w={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(w[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(w[I[A]]=Q[I[A]]);return w};define(we[208],_e([0,1,2,4,5,6,7]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class C{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{var h,r;if(d&&d.$mid===11){const a=d.uri===void 0?void 0:w.URI.revive(d.uri);return(r=(h=this._itemsBySourceAndUriMap.get(d.source))===null||h===void 0?void 0:h.get(D(a)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(i,P,d,h,r){const a=this._providers.get(i);return a==null?void 0:a.provideTimeline(w.URI.revive(P),d,h,r)}registerTimelineProvider(i,P,d,h){const r=new T.DisposableStore,a=this.convertTimelineItem(P.id,h,r).bind(this);let g;P.onDidChange&&(g=P.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:P.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(S,f,l,v){var t;(v==null?void 0:v.resetCache)&&(r.clear(),(t=m.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(S,f,l);if(n!=null){const u=a(S,v);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(u)})}},dispose(){var S;for(const f of m.values())(S=f.get(P.id))===null||S===void 0||S.clear();g==null||g.dispose(),r.dispose()}}))}convertTimelineItem(i,P,d){return(h,r)=>{let a;if(r==null?void 0:r.cacheResults){let g=this._itemsBySourceAndUriMap.get(i);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(i,g));const m=D(h);a=g.get(m),a===void 0&&(a=new Map,g.set(m,a))}return g=>{var m,S;const{iconPath:f}=g,l=zt(g,["iconPath"]),v=`${i}|${(m=g.id)!==null&&m!==void 0?m:g.timestamp}`;a==null||a.set(v,g);let t,n,u;return g.iconPath&&(f instanceof y.ThemeIcon?u={id:f.id}:w.URI.isUri(f)?(t=f,n=f):{light:t,dark:n}=f),Object.assign(Object.assign({},l),{id:(S=l.id)!==null&&S!==void 0?S:void 0,handle:v,source:i,command:g.command?P.toInternal(g.command,d):void 0,icon:t,iconDark:n,themeIcon:u,accessibilityInformation:g.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const h of this._itemsBySourceAndUriMap.values())(d=h.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function D(k){return k==null?void 0:k.toString()}}),define(we[209],_e([0,1,6,19,2,5]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,i,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=P.schemes.find(h=>!y.supportedSchemes.has(h));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,P.schemes,D,P.label),(0,w.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const d=A.URI.revive(k);return P.canOpenExternalUri(d,i)}async $openUri(D,k,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(we[210],_e([0,1,5,2,6,12,26]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,k),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,i){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(I.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[50],_e([0,1,23,3,2,145,166,72,5]),function(Q,e,w,I,A,T,y,C,D){"use strict";var k,i,P,d,h,r,a,g,m,S,f,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(p,E,F,B,Y,fe,V){k.set(this,void 0),i.set(this,void 0),P.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,""),g.set(this,void 0),m.set(this,!1),S.set(this,!1),f.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new I.Emitter),this._onDidDispose=Me(this,l,"f").event,tt(this,k,p,"f"),tt(this,i,E,"f"),tt(this,g,F,"f"),tt(this,d,B,"f"),tt(this,h,Y,"f"),tt(this,r,fe,"f"),tt(this,f,t(fe),"f"),tt(this,P,V,"f")}dispose(){tt(this,m,!0,"f"),Me(this,l,"f").fire(),Me(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return tt(this,S,!0,"f"),(0,C.asWebviewUri)(Me(this,d,"f"),Me(this,k,"f"),p)}get cspSource(){return Me(this,d,"f").webviewCspSource.replace("{{uuid}}",Me(this,k,"f"))}get html(){return this.assertNotDisposed(),Me(this,a,"f")}set html(p){this.assertNotDisposed(),Me(this,a,"f")!==p&&(tt(this,a,p,"f"),!Me(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(tt(this,S,!0,"f"),Me(this,P,"f").report("Webview vscode-resource: uris",Me(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,i,"f").$setHtml(Me(this,k,"f"),p))}get options(){return this.assertNotDisposed(),Me(this,g,"f")}set options(p){this.assertNotDisposed(),Me(this,i,"f").$setOptions(Me(this,k,"f"),s(Me(this,r,"f"),Me(this,h,"f"),p)),tt(this,g,p,"f")}async postMessage(p){if(Me(this,m,"f"))return!1;const E=n(p,{serializeBuffersForPostMessage:Me(this,f,"f")});return Me(this,i,"f").$postMessage(Me(this,k,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Me(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,k=new WeakMap,i=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,g=new WeakMap,m=new WeakMap,S=new WeakMap,f=new WeakMap,l=new WeakMap;function t(_){if(!_.enableProposedApi)return!1;try{const p=(0,T.normalizeVersion)((0,T.parseVersion)(_.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=56}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(_,p){if(p.serializeBuffersForPostMessage){const E=[],F=(Y,fe)=>{if(fe&&fe instanceof ArrayBuffer){let V=E.findIndex(z=>z.original===fe);if(V===-1){const z=new Uint8Array(fe),ee=w.VSBuffer.wrap(z);V=E.length,E.push({original:fe,vsBuffer:ee})}return{$$vscode_array_buffer_reference$$:!0,index:V}}return fe};return{message:JSON.stringify(_,F),buffers:E.map(Y=>Y.vsBuffer)}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeMessage=n;class u{constructor(p,E,F,B,Y){this.initData=E,this.workspace=F,this._logService=B,this._deprecationService=Y,this._webviews=new Map,this._webviewProxy=p.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(p,E,...F){const B=this.getWebview(p);if(B){const{message:Y}=(0,y.deserializeWebviewMessage)(E,F);B._onMessageEmitter.fire(Y)}}$onMissingCsp(p,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,E,F){const B=new v(p,this._webviewProxy,c(E),this.initData,this.workspace,F,this._deprecationService);return this._webviews.set(p,B),B._onDidDispose(()=>{this._webviews.delete(p)}),B}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=u;function o(_){return{id:_.identifier,location:_.extensionLocation}}e.toExtensionData=o;function s(_,p,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||b(_,p)}}e.serializeWebviewOptions=s;function c(_){var p;return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:(p=_.localResourceRoots)===null||p===void 0?void 0:p.map(E=>A.URI.from(E))}}e.reviveOptions=c;function b(_,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(E=>E.uri),_.extensionLocation]}}),define(we[211],_e([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,u){const o=this.key(t,n.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new h(n,u);return this._documents.set(o,s),s}delete(t,n){const u=this.key(t,n.uri);this._documents.delete(u)}key(t,n){return`${t}@@@${n}`}}var a;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(a||(a={}));class g{constructor(){this._providers=new Map}addTextProvider(t,n,u){return this.add(0,t,n,u)}addCustomProvider(t,n,u){return this.add(1,t,n,u)}get(t){return this._providers.get(t)}add(t,n,u,o){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:u,provider:o}),new d.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,u,o,s){this._extHostDocuments=n,this._extensionStoragePaths=u,this._extHostWebview=o,this._extHostWebviewPanels=s,this._editorProviders=new g,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,u,o){const s=new A.DisposableStore;return S(u)?(s.add(this._editorProviders.addTextProvider(n,t,u)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,o.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,u)),this.supportEditing(u)&&s.add(u.onDidChangeCustomDocument(c=>{const b=this.getCustomDocumentEntry(n,c.document.uri);if(f(c)){const _=b.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,_,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(s,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,u,o,s){var c;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=C.URI.revive(t),p=await b.provider.openCustomDocument(_,{backupId:u,untitledDocumentData:o==null?void 0:o.buffer},s);let E;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(E=(c=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,p,E),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const u=this._editorProviders.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${n}'`);const o=C.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,o);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,u,o,s,c){const b=this._editorProviders.get(u);if(!b)throw new Error(`No provider found for '${u}'`);const _=D.ViewColumn.to(s),p=this._extHostWebview.createNewWebview(n,o.webviewOptions,b.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(n,u,o.title,_,o.panelOptions,p),F=C.URI.revive(t);switch(b.type){case 1:{const{document:B}=this.getCustomDocumentEntry(u,F);return b.provider.resolveCustomEditor(B,E,c)}case 0:{const B=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(B,E,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,u){this.getCustomDocumentEntry(n,t).disposeEdits(u)}async $onMoveCustomEditor(t,n,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=C.URI.revive(n),b=this._extHostDocuments.getDocument(c);await o.provider.moveCustomTextEditor(b,s,w.CancellationToken.None)}async $undo(t,n,u,o){return this.getCustomDocumentEntry(n,t).undo(u,o)}async $redo(t,n,u,o){return this.getCustomDocumentEntry(n,t).redo(u,o)}async $revert(t,n,u){const o=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(o.document,u),o.disposeBackup()}async $onSave(t,n,u){const o=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(o.document,u),o.disposeBackup()}async $onSaveAs(t,n,u,o){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,C.URI.revive(u),o)}async $backup(t,n,u){const o=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},u);return o.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const u=this._documents.get(t,C.URI.revive(n));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(t){const n=this._editorProviders.get(t),u=n==null?void 0:n.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function S(v){return typeof v.resolveCustomTextEditor=="function"}function f(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function l(v){const t=v.scheme===T.Schemas.file||v.scheme===T.Schemas.untitled?v.fsPath:v.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[212],_e([0,1,3,6,2,31,9,50,5,7]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";var i,P,d,h,r,a,g,m,S,f,l,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(c,b,_,p,E,F,B){super();i.set(this,void 0),P.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,void 0),g.set(this,void 0),m.set(this,void 0),S.set(this,!0),f.set(this,!0),l.set(this,!1),v.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,v,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,i,c,"f"),tt(this,P,b,"f"),tt(this,d,_,"f"),tt(this,r,F,"f"),tt(this,m,E,"f"),tt(this,a,p,"f"),tt(this,h,B,"f")}dispose(){Me(this,l,"f")||(tt(this,l,!0,"f"),Me(this,v,"f").fire(),Me(this,P,"f").$disposeWebview(Me(this,i,"f")),Me(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,h,"f")}get viewType(){return this.assertNotDisposed(),Me(this,d,"f")}get title(){return this.assertNotDisposed(),Me(this,a,"f")}set title(c){this.assertNotDisposed(),Me(this,a,"f")!==c&&(tt(this,a,c,"f"),Me(this,P,"f").$setTitle(Me(this,i,"f"),c))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(c){this.assertNotDisposed(),Me(this,g,"f")!==c&&(tt(this,g,c,"f"),Me(this,P,"f").$setIconPath(Me(this,i,"f"),A.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Me(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,m,"f")=="number"&&Me(this,m,"f")<0))return Me(this,m,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,S,"f")}_updateViewState(c){Me(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,f,c.active,"f"),tt(this,S,c.visible,"f"),tt(this,m,c.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(c,b){this.assertNotDisposed(),Me(this,P,"f").$reveal(Me(this,i,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Me(this,l,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,g=new WeakMap,m=new WeakMap,S=new WeakMap,f=new WeakMap,l=new WeakMap,v=new WeakMap,t=new WeakMap;class u{constructor(c,b,_){this.webviews=b,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(c,b,_,p,E={}){const F=typeof p=="object"?p.viewColumn:p,B={viewColumn:y.ViewColumn.from(F),preserveFocus:typeof p=="object"&&!!p.preserveFocus},Y=(0,C.shouldSerializeBuffersForPostMessage)(c),fe=u.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(c),fe,b,{title:_,panelOptions:o(E),webviewOptions:(0,C.serializeWebviewOptions)(c,this.workspace,E),serializeBuffersForPostMessage:Y},B);const V=this.webviews.createNewWebview(fe,E,c);return this.createNewWebviewPanel(fe,b,_,F,E,V)}$onDidChangeWebviewPanelViewStates(c){const b=Object.keys(c);b.sort((_,p)=>{const E=c[_],F=c[p];return E.active?1:F.active?-1:+E.visible-+F.visible});for(const _ of b){const p=this.getWebviewPanel(_);if(!!p){const E=c[_];p._updateViewState({active:E.active,visible:E.visible,viewColumn:y.ViewColumn.to(E.position)})}}}async $onDidDisposeWebviewPanel(c){const b=this.getWebviewPanel(c);b==null||b.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,b,_){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:_,extension:c}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(c)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(c,b,_,p){const E=this._serializers.get(b);if(!E)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:B}=E,Y=this.webviews.createNewWebview(c,_.webviewOptions,B),fe=this.createNewWebviewPanel(c,b,_.title,p,_.panelOptions,Y);await F.deserializeWebviewPanel(fe,_.state)}createNewWebviewPanel(c,b,_,p,E,F){const B=new n(c,this._proxy,b,_,p,E,F);return this._webviewPanels.set(c,B),B}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=u;function o(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[213],_e([0,1,3,6,50,5,7]),function(Q,e,w,I,A,T,y){"use strict";var C,D,k,i,P,d,h,r,a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends I.Disposable{constructor(l,v,t,n,u,o){super();C.set(this,void 0),D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,!1),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Me(this,a,"f").event,g.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,g,"f").event,tt(this,k,t,"f"),tt(this,h,n,"f"),tt(this,C,l,"f"),tt(this,D,v,"f"),tt(this,i,u,"f"),tt(this,d,o,"f")}dispose(){Me(this,P,"f")||(tt(this,P,!0,"f"),Me(this,g,"f").fire(),Me(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,h,"f")}set title(l){this.assertNotDisposed(),Me(this,h,"f")!==l&&(tt(this,h,l,"f"),Me(this,D,"f").$setWebviewViewTitle(Me(this,C,"f"),l))}get description(){return this.assertNotDisposed(),Me(this,r,"f")}set description(l){this.assertNotDisposed(),Me(this,r,"f")!==l&&(tt(this,r,l,"f"),Me(this,D,"f").$setWebviewViewDescription(Me(this,C,"f"),l))}get visible(){return Me(this,d,"f")}get webview(){return Me(this,i,"f")}get viewType(){return Me(this,k,"f")}_setVisible(l){l===Me(this,d,"f")||Me(this,P,"f")||(tt(this,d,l,"f"),Me(this,a,"f").fire())}show(l){this.assertNotDisposed(),Me(this,D,"f").$show(Me(this,C,"f"),!!l)}assertNotDisposed(){if(Me(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,g=new WeakMap;class S{constructor(l,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,v,t,n){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(l),v,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(l,v,t,n,u){const o=this._viewProviders.get(v);if(!o)throw new Error(`No view provider found for '${v}'`);const{provider:s,extension:c}=o,b=this._extHostWebview.createNewWebview(l,{},c),_=new m(l,this._proxy,v,t,b,!0);this._webviewViews.set(l,_),await s.resolveWebviewView(_,{state:n},u)}async $onDidChangeWebviewViewVisibility(l,v){this.getWebviewView(l)._setVisible(v)}async $disposeWebviewView(l){const v=this.getWebviewView(l);this._webviewViews.delete(l),v.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const v=this._webviewViews.get(l);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=S}),define(we[101],_e([0,1,3,5,2,19,8,4,14]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Rn{constructor(P){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=P.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let h;if(typeof P=="string"){h=P;try{P=A.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,h,d)}async asExternalUri(P,d){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const h=await this._proxy.$asExternalUri(P,d);return A.URI.from(h)}};k.InitialState={focused:!0},k=Ve([qe(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(we[214],_e([0,1,18,5,27,14]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends w.AbstractLogger{constructor(D,k){super();this._proxy=D.getProxy(I.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...k){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(D,...k){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(D,...k){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(D,...k){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(D,...k){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(D,...k){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,A.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(we[215],_e([0,1,11,20,12,3,6,113,187,98,23]),function(Q,e,w,I,A,T,y,C,D,k,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(o,s){try{return JSON.stringify(o,s)}catch(c){return"null"}}function h(o,s){return JSON.stringify(o,s)}function r(o){return o?(s,c)=>c&&c.$mid===1?o.transformOutgoing(c):c:null}var a;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},S=Symbol.for("rpcProtocol"),f=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(s,c=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=c,this._uriTransformer=b,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,p=k.ProxyIdentifier.count;_<p;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,C.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:c,sid:b}=s;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,b)),this._proxies[c]}_createProxy(s,c){let b={get:(_,p)=>(typeof p=="string"&&!_[p]&&p.charCodeAt(0)===36&&(_[p]=(...E)=>this._remoteCall(s,p,E)),p===f?c:_[p])};return new Proxy(Object.create(null),b)}set(s,c){return this._locals[s.nid]=c,c}assertRegistered(s){for(let c=0,b=s.length;c<b;c++){const _=s[c];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const c=s.byteLength,b=v.read(s,0),_=b.readUInt8(),p=b.readUInt32();switch(_){case 1:case 2:{let{rpcId:E,method:F,args:B}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(B=(0,C.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(c,p,E,F,B,_===2);break}case 3:case 4:{let{rpcId:E,method:F,args:B}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(B=(0,C.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(c,p,E,F,B,_===4);break}case 5:{this._logger&&this._logger.logIncoming(c,p,0,"ack"),this._onDidReceiveAcknowledge(p);break}case 6:{this._receiveCancel(c,p);break}case 7:{this._receiveReply(c,p,void 0);break}case 9:{let E=t.deserializeReplyOKJSON(b);this._uriTransformer&&(E=(0,C.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReply(c,p,E);break}case 8:{let E=t.deserializeReplyOKVSBuffer(b);this._receiveReply(c,p,E);break}case 10:{let E=t.deserializeReplyErrError(b);this._uriTransformer&&(E=(0,C.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReplyErr(c,p,E);break}case 11:{this._receiveReplyErr(c,p,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,c,b,_,p,E){this._logger&&this._logger.logIncoming(s,c,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${_}(`,p);const F=String(c);let B,Y;if(E){const V=new I.CancellationTokenSource;p.push(V.token),B=this._invokeHandler(b,_,p),Y=()=>V.cancel()}else B=this._invokeHandler(b,_,p),Y=m;this._cancelInvokedHandlers[F]=Y;const fe=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(fe.byteLength,c,1,"ack"),this._protocol.send(fe),B.then(V=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyOK(c,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,c,1,"reply:",V),this._protocol.send(z)},V=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyErr(c,V);this._logger&&this._logger.logOutgoing(z.byteLength,c,1,"replyErr:",V),this._protocol.send(z)})}_receiveCancel(s,c){this._logger&&this._logger.logIncoming(s,c,1,"receiveCancel");const b=String(c);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(s,c,b){this._logger&&this._logger.logIncoming(s,c,0,"receiveReply:",b);const _=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const p=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],p.resolveOk(b)}}_receiveReplyErr(s,c,b){this._logger&&this._logger.logIncoming(s,c,0,"receiveReplyErr:",b);const _=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const p=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let E;b&&(b.$isError?(E=new Error,E.name=b.name,E.message=b.message,E.stack=b.stack):E=b),p.resolveErr(E)}}_invokeHandler(s,c,b){try{return Promise.resolve(this._doInvokeHandler(s,c,b))}catch(_){return Promise.reject(_)}}_doInvokeHandler(s,c,b){const _=this._locals[s];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(s));let p=_[c];if(typeof p!="function")throw new Error("Unknown method "+c+" on actor "+(0,k.getStringIdentifierForProxy)(s));return p.apply(_,b)}_remoteCall(s,c,b){if(this._isDisposed)return Promise.reject(A.canceled());let _=null;if(b.length>0&&I.CancellationToken.isCancellationToken(b[b.length-1])&&(_=b.pop()),_&&_.isCancellationRequested)return Promise.reject(A.canceled());const p=t.serializeRequestArguments(b,this._uriReplacer),E=++this._lastMessageId,F=String(E),B=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const fe=t.serializeCancel(E);this._logger&&this._logger.logOutgoing(fe.byteLength,E,0,"cancel"),this._protocol.send(t.serializeCancel(E))}),this._pendingRPCReplies[F]=B,this._onWillSendRequest(E);const Y=t.serializeRequest(E,s,c,p,!!_);return this._logger&&this._logger.logOutgoing(Y.byteLength,E,0,`request: ${(0,k.getStringIdentifierForProxy)(s)}.${c}(`,b),this._protocol.send(Y),B}}e.RPCProtocol=l,P=S,l.UNRESPONSIVE_TIME=3*1e3;class v{constructor(s,c){this._buff=s,this._offset=c}static alloc(s,c,b){let _=new v(i.VSBuffer.alloc(b+1+4),0);return _.writeUInt8(s),_.writeUInt32(c),_}static read(s,c){return new v(s,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,b}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,b}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,c}static sizeMixedArray(s,c){let b=0;b+=1;for(let _=0,p=s.length;_<p;_++){const E=s[_],F=c[_];switch(b+=1,F){case 1:b+=this.sizeLongString(E);break;case 2:b+=this.sizeVSBuffer(E);break;case 3:break}}return b}writeMixedArray(s,c){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let b=0,_=s.length;b<_;b++){const p=s[b];switch(c[b]){case 1:this.writeUInt8(1),this.writeLongString(p);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(s);for(let b=0;b<s;b++)switch(this.readUInt8()){case 1:c[b]=this.readLongString();break;case 2:c[b]=this.readVSBuffer();break;case 3:c[b]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(s){for(let c=0,b=s.length;c<b;c++)if(s[c]instanceof i.VSBuffer||typeof s[c]=="undefined")return!0;return!1}static serializeRequestArguments(s,c){if(this._arrayContainsBufferOrUndefined(s)){let b=[],_=[];for(let p=0,E=s.length;p<E;p++){const F=s[p];F instanceof i.VSBuffer?(b[p]=F,_[p]=2):typeof F=="undefined"?(b[p]=i.VSBuffer.alloc(0),_[p]=3):(b[p]=i.VSBuffer.fromString(h(F,c)),_[p]=1)}return{type:"mixed",args:b,argsType:_}}return{type:"simple",args:h(s,c)}}static serializeRequest(s,c,b,_,p){return _.type==="mixed"?this._requestMixedArgs(s,c,b,_.args,_.argsType,p):this._requestJSONArgs(s,c,b,_.args,p)}static _requestJSONArgs(s,c,b,_,p){const E=i.VSBuffer.fromString(b),F=i.VSBuffer.fromString(_);let B=0;B+=v.sizeUInt8(),B+=v.sizeShortString(E),B+=v.sizeLongString(F);let Y=v.alloc(p?2:1,s,B);return Y.writeUInt8(c),Y.writeShortString(E),Y.writeLongString(F),Y.buffer}static deserializeRequestJSONArgs(s){const c=s.readUInt8(),b=s.readShortString(),_=s.readLongString();return{rpcId:c,method:b,args:JSON.parse(_)}}static _requestMixedArgs(s,c,b,_,p,E){const F=i.VSBuffer.fromString(b);let B=0;B+=v.sizeUInt8(),B+=v.sizeShortString(F),B+=v.sizeMixedArray(_,p);let Y=v.alloc(E?4:3,s,B);return Y.writeUInt8(c),Y.writeShortString(F),Y.writeMixedArray(_,p),Y.buffer}static deserializeRequestMixedArgs(s){const c=s.readUInt8(),b=s.readShortString(),_=s.readMixedArray(),p=new Array(_.length);for(let E=0,F=_.length;E<F;E++){const B=_[E];typeof B=="string"?p[E]=JSON.parse(B):p[E]=B}return{rpcId:c,method:b,args:p}}static serializeAcknowledged(s){return v.alloc(5,s,0).buffer}static serializeCancel(s){return v.alloc(6,s,0).buffer}static serializeReplyOK(s,c,b){return typeof c=="undefined"?this._serializeReplyOKEmpty(s):c instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(s,c):this._serializeReplyOKJSON(s,d(c,b))}static _serializeReplyOKEmpty(s){return v.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,c){let b=0;b+=v.sizeVSBuffer(c);let _=v.alloc(8,s,b);return _.writeVSBuffer(c),_.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,c){const b=i.VSBuffer.fromString(c);let _=0;_+=v.sizeLongString(b);let p=v.alloc(9,s,_);return p.writeLongString(b),p.buffer}static deserializeReplyOKJSON(s){const c=s.readLongString();return JSON.parse(c)}static serializeReplyErr(s,c){return c?this._serializeReplyErrEror(s,c):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,c){const b=i.VSBuffer.fromString(d(A.transformErrorForSerialization(c),null));let _=0;_+=v.sizeLongString(b);let p=v.alloc(10,s,_);return p.writeLongString(b),p.buffer}static deserializeReplyErrError(s){const c=s.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(s){return v.alloc(11,s,0).buffer}}var n;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var u;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(u||(u={}))}),define(we[216],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(T){const y=C=>{self.removeEventListener("message",y);const D=C.data;Object.defineProperties(self,{postMessage:{value(k,i){D.postMessage(k,i)}},onmessage:{get(){return D.onmessage},set(k){D.onmessage=k}}}),D.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",y)}.toString();class I extends EventTarget{constructor(T,y,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${w})('${y}'))`,k=new Blob([D],{type:"application/javascript"}),i=URL.createObjectURL(k),P=new MessageChannel,d=i,h={type:"_newWorker",id:d,port:P.port2,url:i,options:C};T(h,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};P.port1.postMessage(r),URL.revokeObjectURL(i),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const a=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(a)}),P.port1.addEventListener("message",r=>{const a=new MessageEvent("message",{data:r.data});this.dispatchEvent(a)}),P.port1.start()}}e.NestedWorker=I}),define(we[217],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(we[218],_e([0,1,19,13,21,2,4,217]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||A.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?I.win32:I.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const h=i.indexOf("/",2);h===-1?(P=i.substring(2),i="/"):(P=i.substring(2,h),i=i.substring(h)||"/")}return T.URI.from({scheme:w.Schemas.file,authority:P,path:i,query:"",fragment:""})}};D=Ve([qe(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(we[102],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new w(0,0)}with(y){return new w(0,0)}}e.Position=w;class I{constructor(y,C,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(y,C),this.end=new w(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],_e([0,1,15,28,24,37,8,4,13,12,102]),function(Q,e,w,I,A,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",h=(P.length+d.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var r;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function g(R){return!!R.preview}e.resultIsMatch=g;function m(R){return!!R.resource}e.isFileMatch=m;function S(R){return!!R.message}e.isProgressMessage=S;var f;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=l;class v{constructor(L,M,U){this.ranges=M;const G=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(G)){L=(0,y.getNLines)(L,U.matchLines);let X="",se=0,pe=0;const Te=Math.floor(U.charsPerLine/5),xe=[];for(const Ae of G){const We=Math.max(Ae.startColumn-Te,0),x=Ae.startColumn+U.charsPerLine;if(We>pe+Te+h){const q=P+(We-pe)+d;X+=q+L.slice(We,x),se+=We-(pe+q.length)}else X+=L.slice(pe,x);xe.push(new u(0,Ae.startColumn-se,Ae.endColumn-se)),pe=x}this.preview={text:X,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const X=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,w.mapArrayOrNot)(M,se=>new n(se.startLineNumber-X,se.startColumn,se.endLineNumber-X,se.endColumn))}}}}e.TextSearchMatch=v;function t(R){const L=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,U,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=U,this.endColumn=G}}e.SearchRange=n;class u extends n{constructor(L,M,U){super(L,M,L,U)}}e.OneLineRange=u;var o;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function s(R,L=!0){const M=R&&R.files&&R.files.exclude,U=L&&R&&R.search&&R.search.exclude;if(!(!M&&!U)){if(!M||!U)return M||U;let G=Object.create(null);return G=A.mixin(G,A.deepClone(M)),G=A.mixin(G,A.deepClone(U),!0),G}}e.getExcludes=s;function c(R,L){return R.excludePattern&&I.match(R.excludePattern,L)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&I.match(R.includePattern,L)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const U=M.folder.fsPath;if(T.isEqualOrParent(L,U)){const G=D.relative(U,L);return!M.includePattern||!!I.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var b;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=_;function p(R){const L=R.message;if((0,k.isPromiseCanceledError)(R))return new _(L,b.canceled);try{const M=JSON.parse(L);return new _(M.message,M.code)}catch(M){return new _(L,b.other)}}e.deserializeSearchError=p;function E(R){const L={message:R.message,code:R.code};return new Error(JSON.stringify(L))}e.serializeSearchError=E;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function B(R){return R.type==="success"}e.isSerializedSearchSuccess=B;function Y(R){return!!R.path}e.isSerializedFileMatch=Y;function fe(R,L){const M=R.searchPath?R.searchPath:R.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=fe;class V{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function z(R,L){const M=Object.assign(Object.assign({},R||{}),L||{});return Object.keys(M).filter(U=>{const G=M[U];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=z;class ee{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let U=L.includePattern;M.includePattern&&(U?U=Object.assign(Object.assign({},U),M.includePattern):U=M.includePattern),U&&(this._parsedIncludeExpression=I.parse(U))}includedInQuerySync(L,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,U))}includedInQuery(L,M,U){return Promise.resolve(this._parsedExcludeExpression(L,M,U)).then(X=>!!X).then(X=>X?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,U)).then(se=>!!se):Promise.resolve(!0)).then(X=>X)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=ee;function $(R){for(const L in R)if(typeof R[L]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,15,11,20,3,22,19,81,25,8,10,2,138,4,18,153,48,49,27,14,7,41,5]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f,l,v,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(F,B,Y){return new k.ExtUri(fe=>b(fe,Y)).isEqual(F,B)}function o(F,B,Y){return u(F.uri,B.uri,Y)?0:(0,i.compare)(F.uri.toString(),B.uri.toString())}function s(F,B,Y){return F.index!==B.index?F.index<B.index?-1:1:u(F.uri,B.uri,Y)?(0,i.compare)(F.name,B.name):(0,i.compare)(F.uri.toString(),B.uri.toString())}function c(F,B,Y,fe){const V=F.slice(0).sort((ee,$)=>Y(ee,$,fe)),z=B.slice(0).sort((ee,$)=>Y(ee,$,fe));return(0,w.delta)(V,z,(ee,$)=>Y(ee,$,fe))}function b(F,B){const Y=B.getCapabilities(F.scheme);return!(Y&&Y&1024)}class _ extends m.Workspace{constructor(B,Y,fe,V,z,ee){super(B,fe.map($=>new m.WorkspaceFolder($)),V,ee);this._name=Y,this._isUntitled=z,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(ee),fe.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(B,Y,fe,V){if(!B)return{workspace:null,added:[],removed:[]};const{id:z,name:ee,folders:$,configuration:R,isUntitled:L}=B,M=[],U=Y;Y?$.forEach((pe,Te)=>{const xe=d.URI.revive(pe.uri),Ae=_._findFolder(fe||Y,xe,V);Ae?(Ae.name=pe.name,Ae.index=pe.index,M.push(Ae)):M.push({uri:xe,name:pe.name,index:Te})}):M.push(...$.map(({uri:pe,name:Te,index:xe})=>({uri:d.URI.revive(pe),name:Te,index:xe}))),M.sort((pe,Te)=>pe.index<Te.index?-1:1);const G=new _(z,ee,M,R?d.URI.revive(R):null,!!L,pe=>b(pe,V)),{added:X,removed:se}=c(U?U.workspaceFolders:[],G.workspaceFolders,o,V);return{workspace:G,added:X,removed:se}}static _findFolder(B,Y,fe){for(let V=0;V<B.folders.length;V++){const z=B.workspaceFolders[V];if(u(z.uri,Y,fe))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(B,Y){return Y&&this._structure.get(B)&&(B=(0,k.dirname)(B)),this._structure.findSubstr(B)}resolveWorkspaceFolder(B){return this._structure.get(B)}}let p=class{constructor(B,Y,fe,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=fe,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=B.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=B.getProxy(n.MainContext.MainThreadMessageService);const z=Y.workspace;this._confirmedWorkspace=z?new _(z.id,z.name,[],z.configuration?d.URI.revive(z.configuration):null,!!z.isUntitled,ee=>b(ee,fe)):void 0}$initializeWorkspace(B,Y){this._trusted=Y,this.$acceptWorkspaceData(B),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(B,Y,fe,...V){const z=[];if(Array.isArray(V)&&V.forEach(M=>{d.URI.isUri(M.uri)&&!z.some(U=>u(U.uri,M.uri,this._extHostFileSystemInfo))&&z.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[Y,fe].some(M=>typeof M!="number"||M<0)||fe===0&&z.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(Y+fe>ee.length)return!1;const $=ee.slice(0);$.splice(Y,fe,...z.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<$.length;M++){const U=$[M];if($.some((G,X)=>X!==M&&u(U.uri,G.uri,this._extHostFileSystemInfo)))return!1}$.forEach((M,U)=>M.index=U);const{added:R,removed:L}=c(ee,$,s,this._extHostFileSystemInfo);if(R.length===0&&L.length===0)return!1;if(this._proxy){const M=B.displayName||B.name;this._proxy.$updateWorkspaceFolders(M,Y,fe,z).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,h.localize)(0,null,M,U.toString()),{extension:B},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(B,Y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,Y)}async getWorkspaceFolder2(B,Y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,Y)}async resolveWorkspaceFolder(B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(B)}getPath(){if(!!this._actualWorkspace){const{folders:B}=this._actualWorkspace;if(B.length!==0)return B[0].uri.fsPath}}getRelativePath(B,Y){let fe,V="";if(typeof B=="string"?(fe=d.URI.file(B),V=B):typeof B!="undefined"&&(fe=B,V=B.fsPath),!fe)return V;const z=this.getWorkspaceFolder(fe,!0);if(!z)return V;typeof Y=="undefined"&&this._actualWorkspace&&(Y=this._actualWorkspace.folders.length>1);let ee=(0,k.relativePath)(z.uri,fe);return Y&&z.name&&(ee=`${z.name}/${ee}`),ee}trySetWorkspaceFolders(B){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:B,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:Y,added:fe,removed:V}=_.toExtHostWorkspace(B,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=Y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:fe,removed:V}))}findFiles(B,Y,fe,V,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let ee;if(Y===null?ee=!1:Y&&(typeof Y=="string"?ee=Y:ee=Y.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:R}=E(B);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)($),(0,P.withUndefinedAsNull)(R),(0,P.withUndefinedAsNull)(ee),(0,P.withUndefinedAsNull)(fe),z).then(L=>Array.isArray(L)?L.map(M=>d.URI.revive(M)):[])}async findTextInFiles(B,Y,fe,V,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),$=typeof Y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:Y.previewOptions,{includePattern:R,folder:L}=E(Y.include),M=typeof Y.exclude=="string"?Y.exclude:Y.exclude?Y.exclude.pattern:void 0,U={ignoreSymlinks:typeof Y.followSymlinks=="boolean"?!Y.followSymlinks:void 0,disregardIgnoreFiles:typeof Y.useIgnoreFiles=="boolean"?!Y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof Y.useGlobalIgnoreFiles=="boolean"?!Y.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof Y.useDefaultExcludes=="boolean"?!Y.useDefaultExcludes:!0,fileEncoding:Y.encoding,maxResults:Y.maxResults,previewOptions:$,afterContext:Y.afterContext,beforeContext:Y.beforeContext,includePattern:R,excludePattern:M},G=!1;if(this._activeSearchCallbacks[ee]=X=>{if(!G){const se=d.URI.revive(X.resource);X.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?fe({uri:se,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,Te=>new v.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,Te=>new v.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):fe({uri:se,text:pe.text,lineNumber:pe.lineNumber})})}},z.isCancellationRequested)return{};try{const X=await this._proxy.$startTextSearch(B,(0,P.withUndefinedAsNull)(L),U,ee,z);return delete this._activeSearchCallbacks[ee],X||{}}catch(X){throw delete this._activeSearchCallbacks[ee],X}}$handleTextSearchResult(B,Y){this._activeSearchCallbacks[Y]&&this._activeSearchCallbacks[Y](B)}saveAll(B){return this._proxy.$saveAll(B)}resolveProxy(B){return this._proxy.$resolveProxy(B)}get trusted(){return this._trusted}requestWorkspaceTrust(B){const Y=this._proxy.$requestWorkspaceTrust(B);return(B==null?void 0:B.modal)?Y:Promise.resolve(this._trusted)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};p=Ve([qe(0,l.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,S.IExtHostFileSystemInfo),qe(3,a.ILogService)],p),e.ExtHostWorkspace=p,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function E(F){let B,Y;return F&&(typeof F=="string"?B=F:(B=F.pattern,Y=F.baseFolder||d.URI.file(F.base))),{includePattern:B,folder:Y}}}),define(we[34],_e([0,1,24,3,30,5,7,155,66,10,11,4,14,18,2]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(n,u){if(u){const o=u.split(".");let s=n;for(let c=0;s&&c<o.length;c++)s=s[o[c]];return s}}function g(n){return n instanceof r.URI}function m(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function f(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(g(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(f(n))return{resource:n.uri};if(n===null)return{resource:null}}let v=class{constructor(u,o,s){this._proxy=u.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=s,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new t(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(u,o))}};v=Ve([qe(0,d.IExtHostRpcService),qe(1,A.IExtHostWorkspace),qe(2,h.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(u,o,s,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=u,this._logService=c,this._extHostWorkspace=o,this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,o){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,s))}getConfiguration(u,o,s){const c=l(o)||{},b=this._toReadonlyValue(u?a(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,c,s==null?void 0:s.identifier);function _(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(E){return typeof a(b,E)!="undefined"},get:(E,F)=>{this._validateConfigurationAccess(u?`${u}.${E}`:E,c,s==null?void 0:s.identifier);let B=a(b,E);if(typeof B=="undefined")B=F;else{let Y;const fe=(V,z)=>{let ee;const $=()=>{Y=Y||(0,w.deepClone)(b),ee=ee||a(Y,z)};return(0,k.isObject)(V)?new Proxy(V,{get:(R,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return $(),()=>ee;if(Y)return ee=ee||a(Y,z),ee[L];const M=R[L];return typeof L=="string"?fe(M,`${z}.${L}`):M},set:(R,L,M)=>($(),ee&&(ee[L]=M),!0),deleteProperty:(R,L)=>($(),ee&&delete ee[L],!0),defineProperty:(R,L,M)=>($(),ee&&Object.defineProperty(ee,L,M),!0)}):V};B=fe(B,E)}return B},update:(E,F,B,Y)=>{E=u?`${u}.${E}`:E;const fe=_(B);return F!==void 0?this._proxy.$updateConfigurationOption(fe,E,F,c,Y):this._proxy.$removeConfigurationOption(fe,E,c,Y)},inspect:E=>{var F,B,Y,fe,V,z,ee,$;E=u?`${u}.${E}`:E;const R=(0,w.deepClone)(this._configuration.inspect(E,c,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(B=R.user)===null||B===void 0?void 0:B.value,workspaceValue:(Y=R.workspace)===null||Y===void 0?void 0:Y.value,workspaceFolderValue:(fe=R.workspaceFolder)===null||fe===void 0?void 0:fe.value,defaultLanguageValue:(V=R.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(z=R.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(ee=R.workspace)===null||ee===void 0?void 0:ee.override,workspaceFolderLanguageValue:($=R.workspaceFolder)===null||$===void 0?void 0:$.override,languageIds:R.overrideIdentifiers}}};return typeof b=="object"&&(0,w.mixin)(p,b,!1),Object.freeze(p)}_toReadonlyValue(u){const o=s=>(0,k.isObject)(s)?new Proxy(s,{get:(c,b)=>o(c[b]),set:(c,b,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(c,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(c,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return o(u)}_validateConfigurationAccess(u,o,s){const c=D.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),b=s?`[${s.value}] `:"";if(c===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(o==null?void 0:o.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,o){const s=new C.ConfigurationChangeEvent(u,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,b)=>s.affectsConfiguration(c,l(b))})}_toMap(u){return u.reduce((o,s)=>(o.set(s[0],s[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[103],_e([0,1,2,11,3,5,7,30,39,34,20,40,14,27,4,19,21,18,75,172,12]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(V){function z(R){if(R){const L=R;return L&&!!L.process}else return!1}V.is=z;function ee(R){if(R!=null){const L={process:R.process,args:R.args};return R.options&&(L.options=u.from(R.options)),L}}V.from=ee;function $(R){if(R!=null)return new y.ProcessExecution(R.process,R.args,R.options)}V.to=$})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(V){function z(R){if(R){const L=R;return L&&(!!L.commandLine||!!L.command)}else return!1}V.is=z;function ee(R){if(R!=null){const L={};return R.commandLine!==void 0?L.commandLine=R.commandLine:(L.command=R.command,L.args=R.args),R.options&&(L.options=s.from(R.options)),L}}V.from=ee;function $(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new y.ShellExecution(R.commandLine,R.options):new y.ShellExecution(R.command,R.args?R.args:[],R.options)}V.to=$})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(V){function z(R){if(R){let L=R;return L&&L.customExecution==="customExecution"}else return!1}V.is=z;function ee(R){return{customExecution:"customExecution"}}V.from=ee;function $(R,L){return L.get(R)}V.to=$})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(V){function z(ee,$){let R;return ee.scope!==void 0&&typeof ee.scope!="number"?R=ee.scope.uri:ee.scope!==void 0&&typeof ee.scope=="number"&&(ee.scope===y.TaskScope.Workspace&&$&&$.workspaceFile?R=$.workspaceFile:R=f.USER_TASKS_GROUP_KEY),{id:ee._id,workspaceFolder:R}}V.from=z})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(V){function z(R,L){if(R==null)return[];const M=[];for(let U of R){const G=ee(U,L);G&&M.push(G)}return M}V.fromMany=z;function ee(R,L){if(R!=null){let M;R.execution instanceof y.ProcessExecution?M=o.from(R.execution):R.execution instanceof y.ShellExecution?M=c.from(R.execution):R.execution&&R.execution instanceof y.CustomExecution&&(M=b.from(R.execution));const U=t.from(R.definition);let G;if(R.scope?typeof R.scope=="number"?G=R.scope:G=R.scope.uri:G=y.TaskScope.Workspace,!(!U||!G)){const X=R.group?R.group.id:void 0;return{_id:R._id,definition:U,name:R.name,source:{extensionId:L.identifier.value,label:R.source,scope:G},execution:M,isBackground:R.isBackground,group:X,presentationOptions:n.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}}}V.from=ee;async function $(R,L,M){if(R!=null){let U;o.is(R.execution)?U=o.to(R.execution):c.is(R.execution)?U=c.to(R.execution):b.is(R.execution)&&(U=b.to(R._id,M));const G=t.to(R.definition);let X;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?X=R.source.scope:X=await L.resolveWorkspaceFolder(w.URI.revive(R.source.scope)):X=y.TaskScope.Workspace),!(!G||!X)){const se=new y.Task(G,X,R.name,R.source.label,U,R.problemMatchers);return R.isBackground!==void 0&&(se.isBackground=R.isBackground),R.group!==void 0&&(se.group=y.TaskGroup.from(R.group)),R.presentationOptions&&(se.presentationOptions=n.to(R.presentationOptions)),R._id&&(se._id=R._id),R.detail&&(se.detail=R.detail),se}}}V.to=$})(p=e.TaskDTO||(e.TaskDTO={}));var E;(function(V){function z($){return $}V.from=z;function ee($){if(!!$)return Object.assign(Object.create(null),$)}V.to=ee})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(z,ee,$){this._id=ee,this._task=$,v.set(this,void 0),tt(this,v,z,"f")}get task(){return this._task}terminate(){Me(this,v,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}v=new WeakMap;var B;(function(V){function z(ee){return{id:ee._id,task:void 0}}V.from=z})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let Y=class{constructor(z,ee,$,R,L,M,U,G){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=R,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,ee,$){if(!$)return new y.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:ee,provider:$,extension:z}),this._proxy.$registerTaskProvider(R,ee),new y.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(z,ee){this._proxy.$registerTaskSystem(z,ee)}fetchTasks(z){return this._proxy.$fetchTasks(E.from(z)).then(async ee=>{const $=[];for(let R of ee){const L=await p.to(R,this._workspaceProvider,this._providedCustomExecutions2);L&&$.push(L)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(ee=>z.push(ee)),z}terminateTask(z){if(!(z instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,ee,$){const R=this._providedCustomExecutions2.get(z.id);if(R){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,R),this._terminalService.attachPtyToTerminal(ee,await R.callback($))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const ee=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:ee})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const ee=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:ee,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const ee=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:ee,exitCode:z.exitCode})}$provideTasks(z,ee){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const R=[],L=(0,I.asPromise)(()=>$.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(ee,R,$,M));return new Promise(M=>{L.then(U=>{Promise.all(R).then(()=>{M(U)})})})}async $resolveTask(z,ee){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(ee.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${ee.definition.type}] cannot be resolved by provider of type [${$.type}].`);const R=await p.to(ee,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const L=await $.provider.resolveTask(R,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,$);const M=p.from(L,$.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,ee,$){const R=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,ee.execution)}async getTaskExecution(z,ee){if(typeof z=="string"){const L=this._taskExecutionPromises.get(z);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let $=this._taskExecutionPromises.get(z.id);if($)return $;const R=new Promise(async(L,M)=>{const U=ee||await p.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);U?L(new F(this,z.id,U)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,R),R.then(L=>(this._taskExecutions.set(z.id,L),L),L=>Promise.reject(L))}checkDeprecation(z,ee){z._deprecated&&this._deprecationService.report("Task.constructor",ee.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),R=$.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=$.next()}};Y=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,S.IExtHostApiDeprecationService)],Y),e.ExtHostTaskBase=Y;let fe=class extends Y{constructor(z,ee,$,R,L,M,U,G){super(z,ee,$,R,L,M,U,G);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(z,ee){if(!ee.execution)throw new Error("Tasks to execute must include an execution");const $=p.from(ee,z);if($===void 0)throw new Error("Task is not valid");if(b.is($.execution))await this.addCustomExecution($,ee,!1);else throw new l.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution($),ee);return this._proxy.$executeTask($).catch(L=>{throw new Error(L)}),R}provideTasksInternal(z,ee,$,R){const L=[];if(R)for(let M of R){this.checkDeprecation(M,$),(!M.definition||!z[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const U=p.from(M,$.extension);U&&b.is(U.execution)?(L.push(U),ee.push(this.addCustomExecution(U,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:$.extension}}async resolveTaskInternal(z){if(b.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,ee){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,ee,$){}};fe=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,S.IExtHostApiDeprecationService)],fe),e.WorkerExtHostTask=fe,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)},zt=this&&this.__rest||function(Q,e){var w={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(w[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(w[I[A]]=Q[I[A]]);return w};define(we[219],_e([0,1,15,11,23,20,3,53,43,6,24,10,2,31,5,39,14,69,9,7,30,183,96]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f,l,v,t){"use strict";var n,u,o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=($,R)=>`${$}:${R.toString()}`;let b=class{constructor(R,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new z(this.proxy),this.textDocumentObservers=new ee(this.proxy,L)}registerTestController(R,L){const M=(0,h.generateUuid)();this.controllers.set(M,{instance:L,extensionId:R}),this.proxy.$registerTestController(M);const U=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const X of U)(G=this.testControllers.get(X))===null||G===void 0||G.subscribeFn(M,L)},0),new f.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,L=T.CancellationToken.None){const M=U=>U.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map(U=>U.testId):void 0,tests:M(R.tests),debug:R.debug},L)}createTestRunTask(R,L,M,U=!0){return this.runQueue.createTestRunTask(R,L,M,U)}$publishTestResults(R){this.results=Object.freeze(R.map(L=>(0,i.deepFreeze)(S.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,L){const M=d.URI.revive(L),U=c(R,M);if(!this.testControllers.has(U)){const G=new T.CancellationTokenSource;let X;if(R===1){let Ae=this.documents.getDocument(M);if(!Ae){const We=new k.DisposableStore;Ae=await new Promise(x=>{We.add((0,I.disposableTimeout)(()=>x(void 0),5e3)),We.add(this.documents.onDidAddDocuments(q=>{const ne=q.find(le=>le.document.uri.toString()===M.toString());ne&&x(ne)}))}).finally(()=>We.dispose())}if(Ae){const We=await this.workspace.getWorkspaceFolder2(M,!1);X=x=>x.createDocumentTestRoot?x.createDocumentTestRoot(Ae.document,G.token):(0,e.createDefaultDocumentTestRoot)(x,Ae.document,We,G.token)}}else{const Ae=await this.workspace.getWorkspaceFolder2(M,!1);Ae&&(X=We=>We.createWorkspaceTestRoot(Ae,G.token))}if(!!X){const se=async(Ae,We)=>{try{const x=await X(We);x&&Te.addRoot(x,Ae)}catch(x){console.error(x)}},pe=new k.DisposableStore,Te=pe.add(this.ownedTests.createForHierarchy(Ae=>this.proxy.$publishDiff(R,L,Ae)));pe.add((0,k.toDisposable)(()=>G.dispose(!0)));const xe=[];for(const[Ae,We]of this.controllers)xe.push(se(Ae,We.instance));Promise.all(xe).then(()=>Te.pushDiff([3,-1])),this.testControllers.set(U,{store:pe,collection:Te,subscribeFn:se})}}}async $expandTest(R,L){const M=(0,w.mapFind)(this.testControllers.values(),U=>U.collection.treeId===R.src.tree?U:void 0);await(M==null?void 0:M.collection.expand(R.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,L){var M;const U=d.URI.revive(L),G=c(R,U);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(R,L,M){R===1?this.textDocumentObservers.acceptDiff(d.URI.revive(L),M):this.workspaceObservers.acceptDiff(d.URI.revive(L),M)}async $runTestsForProvider(R,L){const M=this.controllers.get(R.tests[0].src.controller);if(!!M){const U=R.tests.map(({testId:se,src:pe})=>this.ownedTests.getTestById(se,pe==null?void 0:pe.tree)).filter(P.isDefined).map(([se,pe])=>pe),G=R.excludeExtIds.map(se=>this.ownedTests.getTestById(se)).filter(P.isDefined).filter(([se,pe])=>U.some(Te=>se.comparePositions(Te,pe)===1));if(!!U.length){const X={tests:U.map(se=>B.unwrap(se.actual)),exclude:G.map(([,se])=>B.unwrap(se.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:p.fromInternal(R),token:L,extensionId:M.extensionId,req:X,doRun:()=>M.instance.runTests(X,L)})}}}$lookupTest(R){const L=this.ownedTests.getTestById(R.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:U,discoverCts:G,expandLevels:X}=M,se=zt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(se)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&L!==void 0?L:(0,w.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};b=Ve([qe(0,g.IExtHostRpcService),qe(1,a.IExtHostDocumentsAndEditors),qe(2,l.IExtHostWorkspace)],b),e.ExtHostTesting=b;class _{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let L=this.state.get(R.extensionId);L||(L={queue:[],current:void 0},this.state.set(R.extensionId,L));const M=new I.DeferredPromise,U=()=>{const G=[],X=new Set;L.current={publicReq:R.req,factory:se=>{const pe=new E(se,R.dto,X,this.proxy);return G.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,G).finally(()=>M.complete())};return L.queue.push(U),L.queue.length===1&&U(),M.p}createTestRunTask(R,L,M,U){var G,X;const se=this.state.get(R);if((se==null?void 0:se.current.publicReq)===L)return se.current.factory(M);const pe=p.fromPublic(L),Te=new E(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(X=(G=L.exclude)===null||G===void 0?void 0:G.map(xe=>xe.id))!==null&&X!==void 0?X:[],id:pe.id,tests:L.tests.map(xe=>xe.id),persist:U}),Te.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Te}invokeRunner(R,L,M,U){try{const G=M();return(0,I.isThenable)(G)?G.then(()=>this.handleInvokeResult(R,L,U,void 0)).catch(X=>this.handleInvokeResult(R,L,U,X)):this.handleInvokeResult(R,L,U,void 0)}catch(G){return this.handleInvokeResult(R,L,U,G)}}async handleInvokeResult(R,L,M,U){const G=this.state.get(R);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(R),await Promise.all(M.map(X=>X.onEnd.wait())))}}class p{constructor(R,L,M){this.id=R,this.include=L,this.exclude=M}static fromPublic(R){var L,M;return new p((0,h.generateUuid)(),new Set(R.tests.map(U=>U.id)),new Set((M=(L=R.exclude)===null||L===void 0?void 0:L.map(U=>U.id))!==null&&M!==void 0?M:D.Iterable.empty()))}static fromInternal(R){return new p(R.runId,new Set(R.tests.map(L=>L.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let L=R;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class E{constructor(R,L,M,U){this.name=R,n.set(this,void 0),u.set(this,void 0),o.set(this,(0,h.generateUuid)()),s.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,U,"f"),tt(this,u,L,"f"),tt(this,s,M,"f"),U.$startedTestRunTask(L.id,{id:Me(this,o,"f"),name:R,running:!0})}setState(R,L,M){Me(this,u,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$updateTestStateInRun(Me(this,u,"f").id,Me(this,o,"f"),R.id,L,M))}appendMessage(R,L){Me(this,u,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$appendTestMessageInRun(Me(this,u,"f").id,Me(this,o,"f"),R.id,S.TestMessage.from(L)))}appendOutput(R){Me(this,n,"f").$appendOutputToRun(Me(this,u,"f").id,Me(this,o,"f"),A.VSBuffer.fromString(R))}end(){Me(this,n,"f").$finishedTestRunTask(Me(this,u,"f").id,Me(this,o,"f")),this.onEnd.open()}ensureTestIsKnown(R){const L=Me(this,s,"f");if(!L.has(R.id)){const M=[];for(;M.unshift(S.TestItem.from(R)),!(L.has(R.id)||(L.add(R.id),!R.parent));)R=R.parent;Me(this,n,"f").$addTestsToRun(Me(this,u,"f").id,M)}}}n=new WeakMap,u=new WeakMap,o=new WeakMap,s=new WeakMap;const F=async($,R,L,M)=>{if(!!L){const U=await $.createWorkspaceTestRoot(L,M);if(!!U){M.onCancellationRequested(()=>{B.removeFilter(R)});const G=B.getWrapperForTestItem(U,R);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=F;class B extends f.TestItemImpl{constructor(R,L,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=L,this.actualParent=M,!(R instanceof f.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const U=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(R).bus.event(X=>{switch(X[0]){case 3:this[X[1]]=X[2];break;case 0:const se=B.getWrapperForTestItem(X[1],this.filterDocument,this);(0,m.getPrivateApiFor)(se).parent=R,se.refreshMatch();break;default:U.bus.fire(X)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,L,M){let U=this.wrapperMap.get(L);if(U==null?void 0:U.has(R))return U.get(R);U||(U=new WeakMap,this.wrapperMap.set(L,U));const G=new B(R,L,M);return U.set(R,G),G}static unwrap(R){return R instanceof B?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R;const L=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const G=B.getWrapperForTestItem(U,this.filterDocument,this);G.hasNodeMatchingFilter?this.children.has(G.id)||this.addChild(G):G.dispose()}const M=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==L&&((R=this.actualParent)===null||R===void 0||R.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=B,B.wrapperMap=new WeakMap;class Y extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,S.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:L,removed:M}=this;return{get added(){return[...R].map(U=>U.revived)},get updated(){return[...L].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class fe extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let L=[];for(const M of R){const U=this.items.get(M);U&&L.push(U.revived)}return L}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,L){return Object.assign(Object.assign({},R),{revived:S.TestItem.toPlain(R.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new Y(this.changeEmitter)}}e.MirroredTestCollection=fe;class V{constructor(){this.resources=new Map}checkout(R){var L,M;const U=R.toString(),G=(L=this.resources.get(U))!==null&&L!==void 0?L:this.createObserverData(R);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return(0,I.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const L=new fe,M=this.listen(R,G=>L.apply(G)),U={observers:0,tests:L,listener:M};return this.resources.set(R.toString(),U),U}unlisten(R){var L;const M=R.toString(),U=this.resources.get(M);U&&(U.observers=-1,(L=U.pendingDeletion)===null||L===void 0||L.dispose(),U.listener.dispose(),this.resources.delete(M))}}class z extends V{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,L),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class ee extends V{constructor(R,L){super();this.proxy=R,this.documents=L,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){if(!this.documents.getDocument(R))return new f.Disposable(()=>{});const U=R.toString();return this.diffListeners.set(U,L),this.proxy.$subscribeToDiffs(1,R),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(U)})}}}),define(we[220],_e([0,1,15,51,28,58,22,19,13,25,8,10,2,116,141,92,48,175,218,41]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(_,p,E,F){this.configurationService=_,this.workspaceContextService=p,this.editorGroupsService=E,this.pathService=F}text(_,p,E={}){_=this.getContentPattern(_,E);const F=this.configurationService.getValue(),B=p&&p.some(fe=>!this.configurationService.getValue({resource:fe}).search.useRipgrep),Y=this.commonQuery(p==null?void 0:p.map(g.toWorkspaceFolder),E);return Object.assign(Object.assign({},Y),{type:2,contentPattern:_,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:F.search.usePCRE2||B||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles})}getContentPattern(_,p){const E=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},_),{wordSeparators:E.editor.wordSeparators});return this.isCaseSensitive(_,p)&&(F.isCaseSensitive=!0),this.isMultiline(_)&&(F.isMultiline=!0),F}file(_,p={}){const E=this.commonQuery(_,p);return Object.assign(Object.assign({},E),{type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey})}handleIncludeExclude(_,p){return _?(_=Array.isArray(_)?_.map(o):o(_),p?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],p={}){const E=this.handleIncludeExclude(p.includePattern,p.expandPatterns),F=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),B=_.length>1,Y=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,p,F)):_.map(z=>this.getFolderQueryForRoot(z,p,F,B))).filter(z=>!!z),fe={_reason:p._reason,folderQueries:Y,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:E.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const ee=w.coalesce(w.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(L=>L.resource)))).filter(R=>(0,f.pathIncludedInQuery)(fe,R.fsPath)),$=this.commonQueryFromFileList(ee);return Object.assign(Object.assign({},fe),$)}const V=p.extraFileResources&&p.extraFileResources.filter(z=>(0,f.pathIncludedInQuery)(fe,z.fsPath));return fe.extraFileResources=V&&V.length?V:void 0,fe}commonQueryFromFileList(_){const p=[],E=new y.ResourceMap,F={};let B=!1;return _.forEach(Y=>{var fe,V;if(Y.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(Y)){const ee=(V=(fe=this.workspaceContextService.getWorkspaceFolder(Y))===null||fe===void 0?void 0:fe.uri)!==null&&V!==void 0?V:Y.with({path:D.dirname(Y.fsPath)});let $=E.get(ee);$||(B=!0,$={folder:ee,includePattern:{}},p.push($),E.set(ee,$));const R=D.relative(ee.fsPath,Y.fsPath);(0,P.assertIsDefined)($.includePattern)[R.replace(/\\/g,"/")]=!0}else Y.fsPath&&(B=!0,F[Y.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(_,p){if(p.isSmartCase){if(_.isRegExp){if(i.containsUppercaseCharacter(_.pattern,!0))return!0}else if(i.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,h.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const p=$=>D.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),F=(Array.isArray(_)?_:n(_)).map($=>{const R=this.pathService.resolvedUserHome;return R?(0,T.untildify)($,R.scheme===C.Schemas.file?R.fsPath:R.path):$}),B=I.groupBy(F,$=>p($)?"searchPaths":"exprSegments"),Y=(B.exprSegments||[]).map($=>i.rtrim($,"/")).map($=>i.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),u($))),fe={},V=this.expandSearchPathPatterns(B.searchPaths||[]);V&&V.length&&(fe.searchPaths=V);const z=w.flatten(Y),ee=t(...z);return ee&&(fe.pattern=ee),fe}getExcludesForFolder(_,p){return p.disregardExcludeSettings?void 0:(0,f.getExcludes)(_,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const p=w.flatten(_.map(F=>{let{pathPortion:B,globPortion:Y}=v(F);Y&&(Y=s(Y));const fe=this.expandOneSearchPath(B);return w.flatten(fe.map(V=>this.resolveOneSearchPathPattern(V,Y)))})),E=new Map;return p.forEach(F=>{const B=F.searchPath.toString(),Y=E.get(B);Y?F.pattern&&(Y.pattern=Y.pattern||{},Y.pattern[F.pattern]=!0):E.set(B,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==C.Schemas.file?[{searchPath:p[0].uri.with({path:_})}]:[{searchPath:d.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=o(_),_.startsWith("../")||_===".."){const F=D.posix.resolve(p.path,_);return[{searchPath:p.with({path:F})}]}const E=s(_);return[{searchPath:p,pattern:E}]}else{if(_==="./"||_===".\\")return[];{const p=_.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(p){const E=p[1],F=this.workspaceContextService.getWorkspace().folders.filter(B=>B.name===E);if(F.length)return F.map(B=>{const Y=p[2];return{searchPath:B.uri,pattern:Y&&s(Y)}});{const B=r.localize(0,null,E);throw new Error(B)}}}}return[]}resolveOneSearchPathPattern(_,p){const E=_.pattern&&p?`${_.pattern}/${p}`:_.pattern||p,F=[{searchPath:_.searchPath,pattern:E}];return E&&!E.endsWith("**")&&F.push({searchPath:_.searchPath,pattern:E+"/**"}),F}getFolderQueryForSearchPath(_,p,E){const F=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(_.searchPath),p,E,!1);return F?Object.assign(Object.assign({},F),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,p,E,F){let B;const Y=d.URI.isUri(_)?_:_.uri;if(E.searchPaths){const $=E.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,Y))[0];if($&&!$.pattern)return null;$&&(B=$.pattern)}const fe=this.configurationService.getValue({resource:Y}),V=this.getExcludesForFolder(fe,p),z=Object.assign(Object.assign({},V||{}),B||{}),ee=d.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:Y,folderName:F?ee:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:fe.files&&fe.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!fe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!fe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!fe.search.followSymlinks}}};l=Ve([qe(0,a.IConfigurationService),qe(1,g.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,S.IPathService)],l),e.QueryBuilder=l;function v(b){const _=b.match(/[\*\{\}\(\)\[\]\?]/);if(_){const p=_.index,E=b.substr(0,p).match(/[/|\\][^/\\]*$/);if(E){let F=b.substr(0,E.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((E.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((_,p)=>(_[p]=!0,_),Object.create(null)):void 0}function n(b){return A.splitGlobAware(b,",").map(_=>_.trim()).filter(_=>!!_.length)}function u(b){return[`**/${b}/**`,`**/${b}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function o(b){return b.replace(/\\/g,"/")}function s(b){return o(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(b,_){b=w.distinct(b,F=>F.toString());const p=[],E=_.getWorkspace();return b&&b.forEach(F=>{let B;if(_.getWorkbenchState()===2)B=(0,k.relativePath)(E.folders[0].uri,F),B&&B!=="."&&(B="./"+B);else{const Y=_.getWorkspaceFolder(F);if(Y){const fe=Y.name;if(E.folders.filter(z=>z.name===fe).length===1){const z=(0,k.relativePath)(Y.uri,F);z===""?B=`./${Y.name}`:B=`./${Y.name}/${z}`}else B=F.fsPath}}B&&p.push(B)}),p}e.resolveResourcesForSearchIncludes=c}),define(we[221],_e([0,1,25,2,20,12,4,220,41,48]),function(Q,e,w,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(a,g){const m=g.activationEvents;if(!m)return Promise.resolve(void 0);const S=[],f=[];for(const o of m)if(/^workspaceContains:/.test(o)){const s=o.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||a.forceUsingSearch?f.push(s):S.push(s)}if(S.length===0&&f.length===0)return Promise.resolve(void 0);let l;const v=new Promise((o,s)=>{l=o}),t=o=>l({activationEvent:o}),n=Promise.all(S.map(o=>d(a,o,t))).then(()=>{}),u=h(a,g.identifier,f,t);return Promise.all([n,u]).then(()=>{l(void 0)}),v}e.checkActivateWorkspaceContainsExtension=P;async function d(a,g,m){for(const S of a.folders)if(await a.exists(w.joinPath(I.URI.revive(S),g))){m(`workspaceContains:${g}`);return}}async function h(a,g,m,S){if(m.length===0)return Promise.resolve(void 0);const f=new A.CancellationTokenSource,l=a.checkExists(a.folders,m,f.token),v=setTimeout(async()=>{f.cancel(),S(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await l}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}f.dispose(),clearTimeout(v),t&&S(`workspaceContains:${m.join(",")}`)}function r(a,g,m,S){const f=a.get(y.IInstantiationService),l=a.get(D.ISearchService),t=f.createInstance(C.QueryBuilder).file(g.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return l.fileSearch(t,S).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(we[35],_e([0,1,133,13,80,25,11,6,22,2,18,5,34,186,78,30,33,184,12,26,23,162,7,67,4,27,79,14,65,70,40,3,221,74,163]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f,l,v,t,n,u,o,s,c,b,_,p,E,F,B,Y){"use strict";var fe,V,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let ee=class Fn extends C.Disposable{constructor(M,U,G,X,se,pe,Te,xe,Ae,We){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=G,this._initData=Te,this._extHostWorkspace=X,this._extHostConfiguration=se,this._logService=pe,this._extHostTunnelService=Ae,this._extHostTerminalService=We,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=M.createChild(new b.ServiceCollection([r.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const x=new Set;this._initData.hostExtensions.forEach(q=>x.add(f.ExtensionIdentifier.toKey(q))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(q,ne)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(q,ne)},actualActivateExtension:async(q,ne)=>{if(x.has(f.ExtensionIdentifier.toKey(q)))return await this._mainThreadExtensionsProxy.$activateExtension(q,ne),new h.HostExtension;const le=this._registry.getExtensionDescription(q);return this._activateExtension(le,ne)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){S.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this._deactivate(se))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(X=>M.set(k.URI.file(X).fsPath,G))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const G=this._activator.getActivatedExtension(M);if(!G)return U;try{typeof G.module.deactivate=="function"&&(U=Promise.resolve(G.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,C.dispose)(G.subscriptions)}catch(X){}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(G=>{const X=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",X),G},G=>{throw this._logExtensionActivationTimes(M,U,"failure"),G})}_logExtensionActivationTimes(M,U,G,X){const se=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},se),X||{}),{outcome:G}))}_doActivateExtension(M,U){const G=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const X=this._getEntryPoint(M);if(!X)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const se=new h.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,X),se),this._loadExtensionContext(M)]).then(pe=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Fn._callActivate(this._logService,M.identifier,pe[0],pe[1],se))).then(pe=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const U=new v.ExtensionGlobalMemento(M,this._storage),G=new v.ExtensionMemento(M.identifier.value,!1,this._storage),X=new Y.ExtensionSecrets(M,this._secretState),se=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let xe;return Object.freeze({globalState:U,workspaceState:G,secrets:X,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ae){return I.join(M.extensionLocation.fsPath,Ae)},get storagePath(){var Ae;return(Ae=Te._storagePath.workspaceValue(M))===null||Ae===void 0?void 0:Ae.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(M).fsPath},get logPath(){return I.join(Te._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Te._initData.logsLocation,M.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(M)},get globalStorageUri(){return Te._storagePath.globalValue(M)},get extensionMode(){return se},get extension(){return xe===void 0&&(xe=new R(Te,M.identifier,M,pe)),xe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(M),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,G,X,se){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,G,X,se).then(pe=>new h.ActivatedExtension(!1,null,se.build(),G,pe,X.subscriptions))}static _callActivateOptional(M,U,G,X,se){if(typeof G.activate=="function")try{se.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const pe=typeof global=="object"?global:self,Te=G.activate.apply(pe,[X]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(Te).then(xe=>(se.activateResolveStop(),xe))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(G)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(U),X=Promise.all([M,G]).then(()=>{});return Promise.race([X,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(!this.isActivated(U.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:M.map(pe=>pe.uri),forceUsingSearch:G,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Te,xe)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Te,xe)},se=await(0,F.checkActivateWorkspaceContainsExtension)(X,U);if(!!se)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:se.activationEvent}).then(void 0,pe=>this._logService.error(pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(w.localize(0,null));const G=await this._loadCommonJSModule(null,U,new h.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(w.localize(1,null,U.toString()));return new Promise((X,se)=>{const pe=(Ae,We)=>{Ae?se(Ae):X(typeof We=="number"&&We>0?1:0)},Te=(0,T.originalFSPath)(U),xe=G.run(Te,pe);xe&&xe.then&&xe.then(()=>{X(0)}).catch(Ae=>{se(Ae.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,U){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const X=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const se=this._resolvers[X];if(!se)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${X}`);const pe=await se.resolve(M,{resolveAttempt:U});A.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(se));const Te={authority:M,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},xe={extensionHostEnv:pe.extensionHostEnv,trust:pe.trust};return{type:"ok",value:{authority:Te,options:xe,tunnelInformation:{environmentTunnels:pe.environmentTunnels}}}}catch(pe){if(A.mark(`code/extHost/didResolveAuthorityError/${X}`),pe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(X=>X.extensionLocation=k.URI.revive(X.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(U.map(async X=>{const se=this._registry.getExtensionDescription(X);if(!!se){const pe=await this._hostUtils.realpath(se.extensionLocation.fsPath);G.delete(k.URI.file(pe).fsPath)}})),await Promise.all(M.map(async X=>{const se=await this._hostUtils.realpath(X.extensionLocation.fsPath);G.set(k.URI.file(se).fsPath,X)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=l.VSBuffer.alloc(M),G=Math.random()%256;for(let X=0;X<M;X++)U.writeUInt8(G,X);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};ee=Ve([qe(0,u.IInstantiationService),qe(1,e.IHostUtils),qe(2,c.IExtHostRpcService),qe(3,a.IExtHostWorkspace),qe(4,d.IExtHostConfiguration),qe(5,i.ILogService),qe(6,o.IExtHostInitDataService),qe(7,s.IExtensionStoragePaths),qe(8,_.IExtHostTunnelService),qe(9,p.IExtHostTerminalService)],ee),e.AbstractExtHostExtensionService=ee;function $(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class R{constructor(M,U,G,X){fe.set(this,void 0),V.set(this,void 0),z.set(this,void 0),tt(this,fe,M,"f"),tt(this,V,U,"f"),tt(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=I.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=X}get isActive(){return Me(this,fe,"f").isActivated(Me(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,fe,"f").getExtensionExports(Me(this,z,"f"))}activate(){return Me(this,fe,"f").activateByIdWithErrors(Me(this,z,"f"),{startup:!1,extensionId:Me(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,fe=new WeakMap,V=new WeakMap,z=new WeakMap}),define(we[104],_e([0,1,13,2,3,11,5,7,170,30,35,39,174,34,171,14,4,10,46]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let f=class{constructor(c,b,_,p,E){this._workspaceService=b,this._extensionService=_,this._editorsService=p,this._configurationService=E,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(B=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,b){const _=c;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let p=`debug:${encodeURIComponent(_.path||"")}`,E="?";return b&&(p+=`${E}session=${encodeURIComponent(b.id)}`,E="&"),p+=`${E}ref=${_.sourceReference}`,I.URI.parse(p)}else{if(_.path)return I.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const b=[];for(const _ of c.getAllExtensionDescriptions())if(_.contributes){const p=_.contributes.debuggers;if(p&&p.length>0)for(const E of p)(0,r.isDebuggerMainContribution)(E)&&b.push(E.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(b=>c.push(b)),c}addBreakpoints(c){this.startBreakpoints();const b=c.filter(E=>{const F=E.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,E),!0)});this.fireBreakpointChanges(b,[],[]);const _=[],p=new Map;for(const E of b)if(E instanceof C.SourceBreakpoint){let F=p.get(E.location.uri.toString());F||(F={type:"sourceMulti",uri:E.location.uri,lines:[]},p.set(E.location.uri.toString(),F),_.push(F)),F.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof C.FunctionBreakpoint&&_.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(c){this.startBreakpoints();const b=c.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],b,[]);const _=b.filter(F=>F instanceof C.SourceBreakpoint).map(F=>F.id),p=b.filter(F=>F instanceof C.FunctionBreakpoint).map(F=>F.id),E=b.filter(F=>F instanceof C.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(_,p,E)}startDebugging(c,b,_){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,b,{parentSessionID:_.parentSession?_.parentSession.id:void 0,repl:_.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,b,_){if(!b)return new C.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:p,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,_,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,p),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(c,b,_){if(!_)return new C.Disposable(()=>{});if(!this.definesDebugType(c,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:p,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,p),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(c,b){if(!b)return new C.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:_,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==b)})}async $runInTerminal(c,b){return Promise.resolve(void 0)}async $substituteVariables(c,b){if(!this._variableResolver){const[E,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,F)}let _;const p=await this.getFolder(c);return p&&(_={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,b)}createDebugAdapter(c,b){if(c.type==="implementation")return new u(c.implementation)}createSignService(){}async $startDASession(c,b){const _=this,p=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const F=this.convertToDto(E),B=this.createDebugAdapter(F,p);if(!B)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const Y=B;return this._debugAdapters.set(c,Y),this.getDebugAdapterTrackers(p).then(fe=>(fe&&this._debugAdaptersTrackers.set(c,fe),Y.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const z=V,ee={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);ee.body={signature:$},Y.sendResponse(ee)}else throw new Error("no signer")}catch($){ee.success=!1,ee.message=$.message,Y.sendResponse(ee)}}else fe&&fe.onDidSendMessage&&fe.onDidSendMessage(V),V=(0,r.convertToVSCPaths)(V,!0),_._debugServiceProxy.$acceptDAMessage(c,V)}),Y.onError(V=>{fe&&fe.onError&&fe.onError(V),this._debugServiceProxy.$acceptDAError(c,V.name,V.message,V.stack)}),Y.onExit(V=>{fe&&fe.onExit&&fe.onExit((0,m.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,m.withNullAsUndefined)(V),void 0)}),fe&&fe.onWillStartSession&&fe.onWillStartSession(),Y.startSession()))})}$sendDAMessage(c,b){b=(0,r.convertToDAPaths)(b,!1);const _=this._debugAdaptersTrackers.get(c);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(b);const p=this._debugAdapters.get(c);p&&p.sendMessage(b)}$stopDASession(c){const b=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),b&&b.onWillStopSession&&b.onWillStopSession();const _=this._debugAdapters.get(c);return this._debugAdapters.delete(c),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const b=[],_=[],p=[];if(c.added)for(const E of c.added){const F=E.id;if(F&&!this._breakpoints.has(F)){let B;if(E.type==="function")B=new C.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")B=new C.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const Y=I.URI.revive(E.uri);B=new C.SourceBreakpoint(new C.Location(Y,new C.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}B._id=F,this._breakpoints.set(F,B),b.push(B)}}if(c.removed)for(const E of c.removed){const F=this._breakpoints.get(E);F&&(this._breakpoints.delete(E),_.push(F))}if(c.changed){for(const E of c.changed)if(E.id){const F=this._breakpoints.get(E.id);if(F){if(F instanceof C.FunctionBreakpoint&&E.type==="function"){const B=F;B.enabled=E.enabled,B.condition=E.condition,B.hitCondition=E.hitCondition,B.logMessage=E.logMessage,B.functionName=E.functionName}else if(F instanceof C.SourceBreakpoint&&E.type==="source"){const B=F;B.enabled=E.enabled,B.condition=E.condition,B.hitCondition=E.hitCondition,B.logMessage=E.logMessage,B.location=new C.Location(I.URI.revive(E.uri),new C.Position(E.line,E.character))}p.push(F)}}}this.fireBreakpointChanges(b,_,p)}$provideDebugConfigurations(c,b,_){return(0,T.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(b);return p.provideDebugConfigurations(E,_)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(c,b,_,p){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(b);return E.resolveDebugConfiguration(F,_,p)})}$resolveDebugConfigurationWithSubstitutedVariables(c,b,_,p){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(b);return E.resolveDebugConfigurationWithSubstitutedVariables(F,_,p)})}async $provideDebugAdapter(c,b){const _=this.getAdapterDescriptorFactoryByHandle(c);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(b);return this.getAdapterDescriptor(_,p).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(c){const b=await this.getSession(c);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(c){const b=await this.getSession(c);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,b){const _=await this.getSession(c);_&&_._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(c,b){const p={session:await this.getSession(c),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(c){if(c instanceof C.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof C.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const b=this._adapterFactories.filter(_=>_.type===c);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(c){const b=this._adapterFactories.filter(_=>_.handle===c);if(b.length>0)return b[0].factory}getConfigProviderByHandle(c){const b=this._configProviders.filter(_=>_.handle===c);if(b.length>0)return b[0].provider}definesDebugType(c,b){if(c.contributes){const _=c.contributes.debuggers;if(_&&_.length>0){for(const p of _)if(p.label&&p.type&&p.type===b)return!0}}return!1}getDebugAdapterTrackers(c){const _=c.configuration.type,p=this._trackerFactories.filter(E=>E.type===_||E.type==="*").map(E=>(0,T.asPromise)(()=>E.factory.createDebugAdapterTracker(c)).then(F=>F,F=>null));return Promise.race([Promise.all(p).then(E=>{const F=E.filter(B=>!!B);if(F.length>0)return new n(F)}),new Promise((E,F)=>{const B=setTimeout(()=>{clearTimeout(B),F(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(c,b){const _=b.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new C.DebugAdapterServer(_));if(c){const E=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>c.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,E))).then(F=>{if(F)return F})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,p))}daExecutableFromPackage(c,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,b,_){(c.length>0||b.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:b,changed:_}))}async getSession(c){if(c)if(typeof c=="string"){const b=this._debugSessions.get(c);if(b)return b}else{let b=this._debugSessions.get(c.id);if(!b){const _=await this.getFolder(c.folderUri);b=new l(this._debugServiceProxy,c.id,c.type,c.name,_,c.configuration),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(c){if(c){const b=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};f=Ve([qe(0,a.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],f),e.ExtHostDebugServiceBase=f;class l{constructor(c,b,_,p,E,F){this._debugServiceProxy=c,this._id=b,this._type=_,this._name=p,this._workspaceFolder=E,this._configuration=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,b)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=l;class v{constructor(c){this.value=Object.freeze({append(b){c.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=v;class t extends d.AbstractVariableResolverService{constructor(c,b,_,p){super({getFolderUri:E=>{const F=c.filter(B=>B.name===E);if(F&&F.length>0)return F[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(E,F)=>_.getConfiguration(void 0,E).get(F),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(b){const E=b.activeEditor();if(E)return w.normalize(E.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(b&&p){const E=b.activeEditor();if(E){const F=p.getWorkspaceFolder(E.document.uri);if(F)return w.normalize(F.uri.fsPath)}}},getSelectedText:()=>{if(b){const E=b.activeEditor();if(E&&!E.selection.isEmpty)return E.document.getText(E.selection)}},getLineNumber:()=>{if(b){const E=b.activeEditor();if(E)return String(E.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(b=>b.onError?b.onError(c):void 0)}onExit(c,b){this.trackers.forEach(_=>_.onExit?_.onExit(c,b):void 0)}}class u extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends f{constructor(c,b,_,p,E){super(c,b,_,p,E)}createVariableResolver(c,b,_){return new t(c,b,_)}};o=Ve([qe(0,a.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(we[222],_e([0,1,80,2,5,34,33,26,14,27,4,35,46,18]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(f,l,v,t,n,u,o){this._apiFactory=f,this._extensionRegistry=l,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=u,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,l,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,l,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let l of f.nodeModuleName)this._factories.set(l,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(l=>f.alternativeModuleName(l))}};r=Ve([qe(2,i.IInstantiationService),qe(3,T.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,h.ILogService)],r),e.RequireInterceptor=r;class a{constructor(f,l,v,t,n){this._apiFactory=f,this._extensionPaths=l,this._extensionRegistry=v,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,l){const v=this._extensionPaths.findSubstr(l.fsPath);if(v){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,u)=>t+=`	${u} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(f,l){this.nodeModuleName="keytar";const{environment:v}=l,t=f.getProxy(A.MainContext.MainThreadKeytar);if(v.appRoot){let n=v.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,u)=>t.$getPassword(n,u),setPassword:(n,u,o)=>t.$setPassword(n,u,o),deletePassword:(n,u)=>t.$deletePassword(n,u),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(f,l){return this._impl}alternativeModuleName(f){const l=f.length;if(!(l<=7||!this.alternativeNames)){const v=l-7;if((f.charAt(v)==="/"||f.charAt(v)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}}};g=Ve([qe(0,D.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],g);let m=class{constructor(f,l,v){this._extensionPaths=f,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(A.MainContext.MainThreadTelemetry);const t=v.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,u)=>{const o=I.URI.parse(n);return u?this.callOriginal(n,u):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,n,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,n,{}):this.callOriginal(n,u)}}load(f,l,v){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(f),this._impl}callOriginal(f,l){return this.sendNoForwardTelemetry(),this._original(f,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([qe(2,D.IExtHostRpcService)],m)}),define(we[223],_e([0,1,11,12,80,6,2,5,215,18,61,65,27,152,14,71,35,40]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(l,v,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const u=new D.RPCProtocol(l,null,n);v=S._transform(v,u);const o=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());o.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},v)),o.set(r.IExtHostRpcService,new r.ExtHostRpcService(u)),o.set(a.IURITransformerService,new a.URITransformerService(n)),o.set(g.IHostUtils,t);const s=new h.InstantiationService(o,!0),c=s.invokeFunction(E=>E.get(m.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(E=>E.get(k.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=s.invokeFunction(E=>E.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(F,B)=>{let Y="",fe,V;for(const z of B)Y+=`
	at ${z.toString()}`,V=z.getFileName(),!fe&&V&&(fe=E.findSubstr(V));return b.set(F,fe),`${F.name||"Error"}: ${F.message||""}${Y}`}});const _=u.getProxy(C.MainContext.MainThreadExtensionService),p=u.getProxy(C.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(E=>{const F=I.transformErrorForSerialization(E),B=b.get(E);B?_.$onExtensionRuntimeError(B.identifier,F):p.$onUnexpectedError(F)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,v){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(v.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(v.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(v.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(v.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(v.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(v.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(v.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(v.transformIncomingURIs(l.logFile)),l.workspace=v.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=S}),define(we[224],_e([0,1,13,20,60,28,25,55,41]),function(Q,e,w,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,h,r){this.config=d,this.provider=h,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const h=this.config.folderQueries||[];return new Promise((r,a)=>{const g=m=>{this.resultCount++,d(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const S=m.toString(),f=w.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,f)||this.matchFile(g,{base:m,basename:f})}),Promise.all(h.map(m=>this.searchInFolder(m,g))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{a(new Error((0,A.toErrorMessage)(m)))})})}async searchInFolder(d,h){const r=new I.CancellationTokenSource,a=this.getSearchOptionsForFolder(d),g=this.initDirectoryTree(),m=new D.QueryGlobTester(this.config,d),S=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(r),f=C.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,r.token),v=f.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const u=w.posix.relative(d.folder.path,n.path);if(S){const o=w.basename(n.path);this.matchFile(h,{base:d.folder,relativePath:u,basename:o});return}this.addDirectoryEntries(g,d.folder,u,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,m,h),{providerTime:v,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,D.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},h,r,a){if(r===this.filePattern){const m=w.basename(this.filePattern);this.matchFile(a,{base:h,relativePath:this.filePattern,basename:m})}function g(m){const S=w.basename(m),f=w.dirname(m);let l=d[f];l||(l=d[f]=[],g(f)),l.push({base:h,relativePath:m,basename:S})}g(r)}matchDirectoryTree({rootEntries:d,pathToEntries:h},r,a){const g=this,m=this.filePattern;function S(f){const l=T.hasSiblingFn(()=>f.map(v=>v.basename));for(let v=0,t=f.length;v<t;v++){const n=f[v],{relativePath:u,basename:o}=n;if(!!r.includedInQuerySync(u,o,m!==o?l:void 0)){const s=h[u];if(s)S(s);else{if(u===m)continue;g.matchFile(a,n)}if(g.isLimitHit)break}}}S(d)}matchFile(d,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(h))}}class i{constructor(){this.sessions=new Map}fileSearch(d,h,r,a){const g=this.getSessionTokenSource(d.cacheKey),m=new k(d,h,g&&g.token);let S=0;const f=l=>{S+=l.length,r(l.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(m,i.BATCH_SIZE,f,a).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:l.stats}}))}clearCache(d){const h=this.getSessionTokenSource(d);h&&h.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new I.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,h,r,a){a.onCancellationRequested(()=>{d.cancel()});const g=S=>{S&&(m.push(S),h>0&&m.length>=h&&(r(m),m=[]))};let m=[];return d.search(g).then(S=>(m.length&&r(m),S),S=>(m.length&&r(m),Promise.reject(S)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(we[225],_e([0,1,13,15,20,60,25,28,2,41,19,10]),function(Q,e,w,I,A,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(f,l,v){this.query=f,this.provider=l,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,l){const v=this.query.folderQueries||[],t=new A.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,u)=>{this.collector=new r(f);let o=!1;const s=(c,b)=>{if(!o&&!this.isLimitHit){const _=this.resultSize(c);g(c)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const p=this.resultSize(c);this.resultCount+=p,(p>0||!g(c))&&this.collector.add(c,b)}};Promise.all(v.map((c,b)=>this.searchInFolder(c,_=>s(_,b),t.token))).then(c=>{t.dispose(),this.collector.flush();const b=c.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||b,messages:(0,I.flatten)(c.map(_=>(_==null?void 0:_.message)?(0,P.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const b=(0,T.toErrorMessage)(c);u(new Error(b))})})}resultSize(f){return g(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,l){const v=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:v.slice(0,l),preview:{matches:t.slice(0,l),text:f.preview.text},uri:f.uri}}async searchInFolder(f,l,v){const t=new k.QueryGlobTester(this.query,f),n=[],u={report:c=>{if(!!this.validateProviderResult(c)){const b=f.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,_=y.relativePath(f.folder,c.uri);_&&n.push(t.includedInQuery(_,w.basename(_),b).then(p=>{p&&l(c)}))}}},o=this.getSearchOptionsForFolder(f),s=await this.provider.provideTextSearchResults(h(this.query.contentPattern),o,u,v);return await Promise.all(n),s}validateProviderResult(f){if(g(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const l=(0,k.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),t={folder:D.URI.from(f.folder),excludes:v,includes:l,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function h(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class r{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,l=>this.sendItems(l))}add(f,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(a(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=r;function a(S){return g(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function g(S){return!!S.preview}e.extensionResultIsMatch=g;class m{constructor(f,l){this.maxBatchSize=f,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,l){!f||this.addItemToBatch(f,l)}addItems(f,l){!f||this.addItemsToBatch(f,l)}addItemToBatch(f,l){this.batch.push(f),this.batchSize+=l,this.onUpdate()}addItemsToBatch(f,l){this.batch=this.batch.concat(f),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(we[105],_e([0,1,6,5,4,224,14,71,18,2,225]),function(Q,e,w,I,A,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let P=class{constructor(a,g,m){this.extHostRpc=a,this._uriTransformer=g,this._logService=m,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,g){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const m=this._handlePool++;return this._textSearchProvider.set(m,g),this._proxy.$registerTextSearchProvider(m,this._transformScheme(a)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(a,g){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const m=this._handlePool++;return this._fileSearchProvider.set(m,g),this._proxy.$registerFileSearchProvider(m,this._transformScheme(a)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(a,g,m,S){const f=d(m),l=this._fileSearchProvider.get(a);if(l)return this._fileSearchManager.fileSearch(f,l,v=>{this._proxy.$handleFileMatch(a,g,v.map(t=>t.resource))},S);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,g,m,S){const f=this._textSearchProvider.get(a);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const l=d(m);return this.createTextSearchManager(l,f).search(t=>this._proxy.$handleTextMatch(a,g,t),S)}createTextSearchManager(a,g){return new i.TextSearchManager(a,g,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};P=Ve([qe(0,y.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,D.ILogService)],P),e.ExtHostSearch=P;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(h),extraFileResources:r.extraFileResources&&r.extraFileResources.map(a=>k.URI.revive(a))})}e.reviveQuery=d;function h(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(we[226],_e([0,1,130,20,12,3,47,2,123,85,117,59,64,5,191,190,76,192,34,193,194,195,177,196,39,35,197,178,199,200,201,100,181,204,205,206,78,40,207,182,9,7,210,50,101,30,33,51,167,198,93,99,103,104,105,18,71,14,27,202,165,70,75,188,208,164,79,77,213,211,212,189,49,219,209,74,161,94,203,67,102]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f,l,v,t,n,u,o,s,c,b,_,p,E,F,B,Y,fe,V,z,ee,$,R,L,M,U,G,X,se,pe,Te,xe,Ae,We,x,q,ne,le,me,Se,Oe,ge,Ce,Pe,$e,Ee,je,H,te,ve,Le,He,Ue,Xe,W,ie,ce,j,Z,ae,he,ye,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Be(Ne){const Ge=Ne.get(Oe.IExtHostInitDataService),nt=Ne.get(W.IExtHostFileSystemInfo),dt=Ne.get(ve.IExtHostConsumerFileSystem),it=Ne.get(o.IExtHostExtensionService),Je=Ne.get(X.IExtHostWorkspace),mt=Ne.get(ae.IExtHostTelemetry),bt=Ne.get(S.IExtHostConfiguration),be=Ne.get(me.IURITransformerService),de=Ne.get(Se.IExtHostRpcService),oe=Ne.get(V.IExtHostStorage),K=Ne.get(te.IExtensionStoragePaths),Re=Ne.get(le.ILogService),Ie=Ne.get(Pe.IExtHostTunnelService),Qe=Ne.get($e.IExtHostApiDeprecationService),Ze=Ne.get(G.IExtHostWindow),ut=Ne.get(j.IExtHostSecretState);de.set(h.ExtHostContext.ExtHostFileSystemInfo,nt),de.set(h.ExtHostContext.ExtHostLogService,Re),de.set(h.ExtHostContext.ExtHostWorkspace,Je),de.set(h.ExtHostContext.ExtHostConfiguration,bt),de.set(h.ExtHostContext.ExtHostExtensionService,it),de.set(h.ExtHostContext.ExtHostStorage,oe),de.set(h.ExtHostContext.ExtHostTunnelService,Ie),de.set(h.ExtHostContext.ExtHostWindow,Ze),de.set(h.ExtHostContext.ExtHostSecretState,ut),de.set(h.ExtHostContext.ExtHostTelemetry,mt);const ht=de.set(h.ExtHostContext.ExtHostDecorations,Ne.get(We.IExtHostDecorations)),Ye=de.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(u.IExtHostDocumentsAndEditors)),ot=de.set(h.ExtHostContext.ExtHostCommands,Ne.get(g.IExtHostCommands)),ft=de.set(h.ExtHostContext.ExtHostTerminalService,Ne.get(z.IExtHostTerminalService)),at=de.set(h.ExtHostContext.ExtHostDebugService,Ne.get(q.IExtHostDebugService)),Et=de.set(h.ExtHostContext.ExtHostSearch,Ne.get(ne.IExtHostSearch)),vt=de.set(h.ExtHostContext.ExtHostTask,Ne.get(x.IExtHostTask)),Ct=de.set(h.ExtHostContext.ExtHostOutputService,Ne.get(E.IExtHostOutputService)),Pt=de.set(h.ExtHostContext.ExtHostEditorTabs,new Z.ExtHostEditorTabs),At=de.set(h.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(de)),_t=de.set(h.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(de,Ye)),Qt=de.set(h.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(de,Ye,Re)),Yt=de.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Re,_t,de.getProxy(h.MainContext.MainThreadBulkEdits))),gt=de.set(h.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(de,ot,Ye,_t,Re,K)),Jt=de.set(h.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(de,Ge,gt)),St=de.set(h.ExtHostContext.ExtHostEditors,new ee.ExtHostEditors(de,Ye)),Vt=de.set(h.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(de.getProxy(h.MainContext.MainThreadTreeViews),ot,Re)),Xt=de.set(h.ExtHostContext.ExtHostEditorInsets,new Te.ExtHostEditorInsets(de.getProxy(h.MainContext.MainThreadEditorInsets),St,Ge.environment)),jt=de.set(h.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(de,Re)),lt=de.set(h.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(de,be,_t,ot,jt,Re,Qe)),Zt=de.set(h.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(de,lt)),Tt=de.set(h.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(de,Re,Ye)),Bt=de.set(h.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(de,Je,ot)),cn=de.set(h.ExtHostContext.ExtHostSCM,new Y.ExtHostSCM(de,ot,Re)),bn=de.set(h.ExtHostContext.ExtHostComments,new m.ExtHostComments(de,ot,_t)),dn=de.set(h.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(de.getProxy(h.MainContext.MainThreadProgress))),en=de.set(h.ExtHostContext.ExtHosLabelService,new xe.ExtHostLabelService(de)),qt=de.set(h.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(de)),Ot=de.set(h.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(de)),wn=de.set(h.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(de,ot)),tn=de.set(h.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(de,Ge.environment,Je,Re,Qe)),nn=de.set(h.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(de,tn,Je)),Kt=de.set(h.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(de,_t,K,tn,nn)),_n=de.set(h.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(de,tn)),Rt=de.set(h.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(de,Ye,Je)),rn=de.set(h.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(de)),En=(0,pe.values)(h.ExtHostContext);de.assertRegistered(En);const xt=new Xe.ExtHostBulkEdits(de,Ye),sn=new a.ExtHostClipboard(de),Nt=new p.ExtHostMessageService(de,Re),Ft=new l.ExtHostDialogs(de),hn=new fe.ExtHostStatusBar(de,ot.converter),$t=new _.ExtHostLanguages(de,_t);return r.ExtHostApiCommands.register(ot),function(Fe,on,an){const pt=function(){let J=!Fe.isUnderDevelopment;function ue(ke){J||(Re.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")ue(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&ue(rt),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,se.throwProposedApiError)(Fe)}return rt}}(),yn={getSession(J,ue,ke){return Ot.getSession(Fe,J,ue,ke)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(J,ue,ke,rt){return Ot.registerAuthenticationProvider(J,ue,ke,rt)},get onDidChangeAuthenticationProviders(){return(0,se.checkProposedApiEnabled)(Fe),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,se.checkProposedApiEnabled)(Fe),Ot.providers},logout(J,ue){return(0,se.checkProposedApiEnabled)(Fe),Ot.removeSession(J,ue)}},Sn={registerCommand(J,ue,ke){return ot.registerCommand(!0,J,ue,ke)},registerTextEditorCommand(J,ue,ke){return ot.registerCommand(!0,J,(...rt)=>{const wt=St.getActiveTextEditor();if(!wt){Re.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(N=>{ue.apply(ke,[wt,N,...rt])}).then(N=>{N||Re.warn("Edits from command "+J+" were not applied.")},N=>{Re.warn("An error occurred while running command "+J,N)})})},registerDiffInformationCommand:(J,ue,ke)=>((0,se.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,J,async(...rt)=>{const wt=Ye.activeEditor(!0);if(!wt){Re.warn("Cannot execute "+J+" because there is no active text editor.");return}const N=await St.getDiffInformation(wt.id);ue.apply(ke,[N,...rt])})),executeCommand(J,...ue){return ot.executeCommand(J,...ue)},getCommands(J=!1){return ot.getCommands(J)}},fn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var J,ue;return(ue=(J=Ge.environment.appRoot)===null||J===void 0?void 0:J.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return ft.getDefaultShell(!1,an)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ue){return Ze.openUri(J,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(J){return J.scheme===Ge.environment.appUriScheme?At.createAppUri(J):Ze.asExternalUri(J,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ae.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(fn);const Gt=Ge.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Dn={registerTestController(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.registerTestController(Fe.identifier.value,J)},createDocumentTestObserver(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.createTextDocumentTestObserver(J)},createWorkspaceTestObserver(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.createWorkspaceTestObserver(J)},runTests(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.runTests(J)},createTestItem(J,ue){return new L.TestItemImpl(J.id,J.label,J.uri,ue)},createTestRunTask(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),Rt.createTestRunTask(Fe.identifier.value,J,ue,ke)},get onDidChangeTestResults(){return(0,se.checkProposedApiEnabled)(Fe),Rt.onResultsChanged},get testResults(){return(0,se.checkProposedApiEnabled)(Fe),Rt.results}},Cn={getExtension(J){const ue=on.getExtensionDescription(J);if(ue)return new o.Extension(it,Fe.identifier,ue,Gt)},get all(){return on.getAllExtensionDescriptions().map(J=>new o.Extension(it,Fe.identifier,J,Gt))},get onDidChange(){return on.onDidChange}},kn={createDiagnosticCollection(J){return jt.createDiagnosticCollection(Fe.identifier,J)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:J=>jt.getDiagnostics(J),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(J,ue){return $t.changeLanguage(J.uri,ue)},match(J,ue){return(0,P.score)(R.LanguageSelector.from(J),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(J,ue,ke){return lt.registerCodeActionProvider(Fe,pt(J),ue,ke)},registerCodeLensProvider(J,ue){return lt.registerCodeLensProvider(Fe,pt(J),ue)},registerDefinitionProvider(J,ue){return lt.registerDefinitionProvider(Fe,pt(J),ue)},registerDeclarationProvider(J,ue){return lt.registerDeclarationProvider(Fe,pt(J),ue)},registerImplementationProvider(J,ue){return lt.registerImplementationProvider(Fe,pt(J),ue)},registerTypeDefinitionProvider(J,ue){return lt.registerTypeDefinitionProvider(Fe,pt(J),ue)},registerHoverProvider(J,ue){return lt.registerHoverProvider(Fe,pt(J),ue,Fe.identifier)},registerEvaluatableExpressionProvider(J,ue){return lt.registerEvaluatableExpressionProvider(Fe,pt(J),ue,Fe.identifier)},registerInlineValuesProvider(J,ue){return lt.registerInlineValuesProvider(Fe,pt(J),ue,Fe.identifier)},registerDocumentHighlightProvider(J,ue){return lt.registerDocumentHighlightProvider(Fe,pt(J),ue)},registerLinkedEditingRangeProvider(J,ue){return lt.registerLinkedEditingRangeProvider(Fe,pt(J),ue)},registerReferenceProvider(J,ue){return lt.registerReferenceProvider(Fe,pt(J),ue)},registerRenameProvider(J,ue){return lt.registerRenameProvider(Fe,pt(J),ue)},registerDocumentSymbolProvider(J,ue,ke){return lt.registerDocumentSymbolProvider(Fe,pt(J),ue,ke)},registerWorkspaceSymbolProvider(J){return lt.registerWorkspaceSymbolProvider(Fe,J)},registerDocumentFormattingEditProvider(J,ue){return lt.registerDocumentFormattingEditProvider(Fe,pt(J),ue)},registerDocumentRangeFormattingEditProvider(J,ue){return lt.registerDocumentRangeFormattingEditProvider(Fe,pt(J),ue)},registerOnTypeFormattingEditProvider(J,ue,ke,...rt){return lt.registerOnTypeFormattingEditProvider(Fe,pt(J),ue,[ke].concat(rt))},registerDocumentSemanticTokensProvider(J,ue,ke){return lt.registerDocumentSemanticTokensProvider(Fe,pt(J),ue,ke)},registerDocumentRangeSemanticTokensProvider(J,ue,ke){return lt.registerDocumentRangeSemanticTokensProvider(Fe,pt(J),ue,ke)},registerSignatureHelpProvider(J,ue,ke,...rt){return typeof ke=="object"?lt.registerSignatureHelpProvider(Fe,pt(J),ue,ke):lt.registerSignatureHelpProvider(Fe,pt(J),ue,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(J,ue,...ke){return lt.registerCompletionItemProvider(Fe,pt(J),ue,ke)},registerDocumentLinkProvider(J,ue){return lt.registerDocumentLinkProvider(Fe,pt(J),ue)},registerColorProvider(J,ue){return lt.registerColorProvider(Fe,pt(J),ue)},registerFoldingRangeProvider(J,ue){return lt.registerFoldingRangeProvider(Fe,pt(J),ue)},registerSelectionRangeProvider(J,ue){return lt.registerSelectionRangeProvider(Fe,J,ue)},registerCallHierarchyProvider(J,ue){return lt.registerCallHierarchyProvider(Fe,J,ue)},setLanguageConfiguration:(J,ue)=>lt.setLanguageConfiguration(Fe,J,ue),getTokenInformationAtPosition(J,ue){return(0,se.checkProposedApiEnabled)(Fe),$t.tokenAtPosition(J,ue)},registerInlineHintsProvider(J,ue){return(0,se.checkProposedApiEnabled)(Fe),lt.registerInlineHintsProvider(Fe,J,ue)}},In={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(J,ue,ke){const rt=await(C.URI.isUri(J)?Promise.resolve(mn.openTextDocument(J)):Promise.resolve(J));return St.showTextDocument(rt,ue,ke)},createTextEditorDecorationType(J){return St.createTextEditorDecorationType(J)},onDidChangeActiveTextEditor(J,ue,ke){return St.onDidChangeActiveTextEditor(J,ue,ke)},onDidChangeVisibleTextEditors(J,ue,ke){return St.onDidChangeVisibleTextEditors(J,ue,ke)},onDidChangeTextEditorSelection(J,ue,ke){return St.onDidChangeTextEditorSelection(J,ue,ke)},onDidChangeTextEditorOptions(J,ue,ke){return St.onDidChangeTextEditorOptions(J,ue,ke)},onDidChangeTextEditorVisibleRanges(J,ue,ke){return St.onDidChangeTextEditorVisibleRanges(J,ue,ke)},onDidChangeTextEditorViewColumn(J,ue,ke){return St.onDidChangeTextEditorViewColumn(J,ue,ke)},onDidCloseTerminal(J,ue,ke){return ft.onDidCloseTerminal(J,ue,ke)},onDidOpenTerminal(J,ue,ke){return ft.onDidOpenTerminal(J,ue,ke)},onDidChangeActiveTerminal(J,ue,ke){return ft.onDidChangeActiveTerminal(J,ue,ke)},onDidChangeTerminalDimensions(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions(J,ue,ke)},onDidWriteTerminalData(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData(J,ue,ke)},get state(){return Ze.state},onDidChangeWindowState(J,ue,ke){return Ze.onDidChangeWindowState(J,ue,ke)},showInformationMessage(J,...ue){return Nt.showMessage(Fe,y.default.Info,J,ue[0],ue.slice(1))},showWarningMessage(J,...ue){return Nt.showMessage(Fe,y.default.Warning,J,ue[0],ue.slice(1))},showErrorMessage(J,...ue){return Nt.showMessage(Fe,y.default.Error,J,ue[0],ue.slice(1))},showQuickPick(J,ue,ke){return Bt.showQuickPick(J,!!Fe.enableProposedApi,ue,ke)},showWorkspaceFolderPick(J){return Bt.showWorkspaceFolderPick(J)},showInputBox(J,ue){return Bt.showInput(J,ue)},showOpenDialog(J){return Ft.showOpenDialog(J)},showSaveDialog(J){return Ft.showSaveDialog(J)},createStatusBarItem(J,ue){let ke,rt,wt,N;return J&&typeof J!="number"?(ke=J.id,rt=J.name,wt=J.alignment,ue=J.priority,N=J.accessibilityInformation):(ke=Fe.identifier.value,rt=w.localize(0,null,Fe.displayName||Fe.name),wt=J),hn.createStatusBarEntry(ke,rt,wt,ue,N)},setStatusBarMessage(J,ue){return hn.setStatusBarMessage(J,ue)},withScmProgress(J){return Qe.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),dn.withProgress(Fe,{location:L.ProgressLocation.SourceControl},(ue,ke)=>J({report(rt){}}))},withProgress(J,ue){return dn.withProgress(Fe,J,ue)},createOutputChannel(J){return Ct.createOutputChannel(J)},createWebviewPanel(J,ue,ke,rt){return nn.createWebviewPanel(Fe,J,ue,ke,rt)},createWebviewTextEditorInset(J,ue,ke,rt){return(0,se.checkProposedApiEnabled)(Fe),Xt.createWebviewEditorInset(J,ue,ke,rt,Fe)},createTerminal(J,ue,ke){return typeof J=="object"?"pty"in J?ft.createExtensionTerminal(J):(J.message&&(0,se.checkProposedApiEnabled)(Fe),J.icon&&(0,se.checkProposedApiEnabled)(Fe),ft.createTerminalFromOptions(J)):ft.createTerminal(J,ue,ke)},registerTerminalLinkProvider(J){return ft.registerLinkProvider(J)},registerTreeDataProvider(J,ue){return Vt.registerTreeDataProvider(J,ue,Fe)},createTreeView(J,ue){return Vt.createTreeView(J,ue,Fe)},registerWebviewPanelSerializer:(J,ue)=>nn.registerWebviewPanelSerializer(Fe,J,ue),registerCustomEditorProvider:(J,ue,ke={})=>Kt.registerCustomEditorProvider(Fe,J,ue,ke),registerFileDecorationProvider(J){return ht.registerFileDecorationProvider(J,Fe.identifier)},registerUriHandler(J){return At.registerUriHandler(Fe.identifier,J)},createQuickPick(){return Bt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Bt.createInputBox(Fe.identifier)},get activeColorTheme(){return qt.activeColorTheme},onDidChangeActiveColorTheme(J,ue,ke){return qt.onDidChangeActiveColorTheme(J,ue,ke)},registerWebviewViewProvider(J,ue,ke){return _n.registerWebviewViewProvider(Fe,J,ue,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,se.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(J,ue,ke)},get visibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection(J,ue,ke)},onDidChangeNotebookEditorVisibleRanges(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges(J,ue,ke)},showNotebookDocument(J,ue){return(0,se.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(J,ue)},registerExternalUriOpener(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),rn.registerExternalUriOpener(Fe.identifier,J,ue,ke)},get openEditors(){return(0,se.checkProposedApiEnabled)(Fe),Pt.tabs},get onDidChangeOpenEditors(){return(0,se.checkProposedApiEnabled)(Fe),Pt.onDidChangeTabs}},mn={get rootPath(){return Qe.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Je.getPath()},set rootPath(J){throw A.readonly()},getWorkspaceFolder(J){return Je.getWorkspaceFolder(J)},get workspaceFolders(){return Je.getWorkspaceFolders()},get name(){return Je.name},set name(J){throw A.readonly()},get workspaceFile(){return Je.workspaceFile},set workspaceFile(J){throw A.readonly()},updateWorkspaceFolders:(J,ue,...ke)=>Je.updateWorkspaceFolders(Fe,J,ue||0,...ke),onDidChangeWorkspaceFolders:function(J,ue,ke){return Je.onDidChangeWorkspace(J,ue,ke)},asRelativePath:(J,ue)=>Je.getRelativePath(J,ue),findFiles:(J,ue,ke,rt)=>Je.findFiles(R.GlobPattern.from(J),R.GlobPattern.from(ue),ke,Fe.identifier,rt),findTextInFiles:(J,ue,ke,rt)=>{let wt,N;return typeof ue=="object"?(wt=ue,N=ke):(wt={},N=ue,rt=ke),Je.findTextInFiles(J,wt||{},N,Fe.identifier,rt)},saveAll:J=>Je.saveAll(J),applyEdit(J){return xt.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ue,ke,rt)=>Tt.createFileSystemWatcher(R.GlobPattern.from(J),ue,ke,rt),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw A.readonly()},openTextDocument(J){let ue;const ke=J;if(typeof J=="string")ue=Promise.resolve(C.URI.file(J));else if(C.URI.isUri(J))ue=Promise.resolve(J);else if(!ke||typeof ke=="object")ue=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(J,ue,ke)=>_t.onDidAddDocument(J,ue,ke),onDidCloseTextDocument:(J,ue,ke)=>_t.onDidRemoveDocument(J,ue,ke),onDidChangeTextDocument:(J,ue,ke)=>_t.onDidChangeDocument(J,ue,ke),onDidSaveTextDocument:(J,ue,ke)=>_t.onDidSaveDocument(J,ue,ke),onWillSaveTextDocument:(J,ue,ke)=>Yt.getOnWillSaveTextDocumentEvent(Fe)(J,ue,ke),onDidChangeConfiguration:(J,ue,ke)=>an.onDidChangeConfiguration(J,ue,ke),getConfiguration(J,ue){return ue=arguments.length===1?void 0:ue,an.getConfiguration(J,ue,Fe)},registerTextDocumentContentProvider(J,ue){return Qt.registerTextDocumentContentProvider(J,ue)},registerTaskProvider:(J,ue)=>(Qe.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Fe,J,ue)),registerFileSystemProvider(J,ue,ke){return Zt.registerFileSystemProvider(Fe.identifier,J,ue,ke)},get fs(){return dt.value},registerFileSearchProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),Et.registerFileSearchProvider(J,ue)),registerTextSearchProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),Et.registerTextSearchProvider(J,ue)),registerRemoteAuthorityResolver:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),it.registerRemoteAuthorityResolver(J,ue)),registerResourceLabelFormatter:J=>((0,se.checkProposedApiEnabled)(Fe),en.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ue,ke)=>Tt.onDidCreateFile(J,ue,ke),onDidDeleteFiles:(J,ue,ke)=>Tt.onDidDeleteFile(J,ue,ke),onDidRenameFiles:(J,ue,ke)=>Tt.onDidRenameFile(J,ue,ke),onWillCreateFiles:(J,ue,ke)=>Tt.getOnWillCreateFileEvent(Fe)(J,ue,ke),onWillDeleteFiles:(J,ue,ke)=>Tt.getOnWillDeleteFileEvent(Fe)(J,ue,ke),onWillRenameFiles:(J,ue,ke)=>Tt.getOnWillRenameFileEvent(Fe)(J,ue,ke),openTunnel:J=>((0,se.checkProposedApiEnabled)(Fe),Ie.openTunnel(Fe,J).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,se.checkProposedApiEnabled)(Fe),Ie.getTunnels()},onDidChangeTunnels:(J,ue,ke)=>((0,se.checkProposedApiEnabled)(Fe),Ie.onDidChangeTunnels(J,ue,ke)),registerPortAttributesProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),Ie.registerPortsAttributesProvider(J,ue)),registerTimelineProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),wn.registerTimelineProvider(J,ue,Fe.identifier,ot.converter)),get isTrusted(){return Je.trusted},requestWorkspaceTrust:J=>((0,se.checkProposedApiEnabled)(Fe),Je.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ue,ke)=>Je.onDidGrantWorkspaceTrust(J,ue,ke)},gn={get inputBox(){return Qe.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Fe)},createSourceControl(J,ue,ke){return cn.createSourceControl(Fe,J,ue,ke)}},pn={createCommentController(J,ue){return bn.createCommentController(Fe,J,ue)}},Ut={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(J,ue,ke){return at.onDidStartDebugSession(J,ue,ke)},onDidTerminateDebugSession(J,ue,ke){return at.onDidTerminateDebugSession(J,ue,ke)},onDidChangeActiveDebugSession(J,ue,ke){return at.onDidChangeActiveDebugSession(J,ue,ke)},onDidReceiveDebugSessionCustomEvent(J,ue,ke){return at.onDidReceiveDebugSessionCustomEvent(J,ue,ke)},onDidChangeBreakpoints(J,ue,ke){return at.onDidChangeBreakpoints(J,ue,ke)},registerDebugConfigurationProvider(J,ue,ke){return at.registerDebugConfigurationProvider(J,ue,ke||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ue){return at.registerDebugAdapterDescriptorFactory(Fe,J,ue)},registerDebugAdapterTrackerFactory(J,ue){return at.registerDebugAdapterTrackerFactory(J,ue)},startDebugging(J,ue,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(J,ue,{parentSession:ke}):at.startDebugging(J,ue,ke||{})},stopDebugging(J){return at.stopDebugging(J)},addBreakpoints(J){return at.addBreakpoints(J)},removeBreakpoints(J){return at.removeBreakpoints(J)},asDebugSourceUri(J,ue){return at.asDebugSourceUri(J,ue)}},Wt={registerTaskProvider:(J,ue)=>vt.registerTaskProvider(Fe,J,ue),fetchTasks:J=>vt.fetchTasks(J),executeTask:J=>vt.executeTask(Fe,J),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(J,ue,ke)=>vt.onDidStartTask(J,ue,ke),onDidEndTask:(J,ue,ke)=>vt.onDidEndTask(J,ue,ke),onDidStartTaskProcess:(J,ue,ke)=>vt.onDidStartTaskProcess(J,ue,ke),onDidEndTaskProcess:(J,ue,ke)=>vt.onDidEndTaskProcess(J,ue,ke)},Pn={openNotebookDocument:J=>((0,se.checkProposedApiEnabled)(Fe),gt.openNotebookDocument(J)),get onDidOpenNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,se.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map(J=>J.apiNotebook)},registerNotebookSerializer(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.registerNotebookSerializer(Fe,J,ue,ke)},registerNotebookContentProvider:(J,ue,ke)=>((0,se.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,J,ue,ke)),registerNotebookCellStatusBarItemProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),gt.registerNotebookCellStatusBarItemProvider(Fe,J,ue)),createNotebookEditorDecorationType(J){return(0,se.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType(J)},onDidChangeNotebookDocumentMetadata(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata(J,ue,ke)},onDidChangeNotebookCells(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(J,ue,ke)},onDidChangeCellExecutionState(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(J,ue,ke)},onDidChangeCellOutputs(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(J,ue,ke)},onDidChangeCellMetadata(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(J,ue,ke)},createConcatTextDocument(J,ue){return(0,se.checkProposedApiEnabled)(Fe),new H.ExtHostNotebookConcatDocument(gt,_t,J,ue)},createNotebookCellExecutionTask(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.createNotebookCellExecution(J,ue,ke)},createNotebookController(J,ue,ke,rt,wt){return(0,se.checkProposedApiEnabled)(Fe),Jt.createNotebookController(Fe,J,ue,ke,rt,wt)}};return{version:Ge.version,authentication:yn,commands:Sn,comments:pn,debug:Ut,env:fn,extensions:Cn,languages:kn,notebook:Pn,scm:gn,tasks:Wt,test:Dn,window:In,workspace:mn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:d.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:C.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlineHint:L.InlineHint,InlineHintKind:L.InlineHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ze.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Be}),define(we[227],_e([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(Q,e,w,I,A,T,y,C,D,k,i,P,d,h,r,a,g,m,S,f,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,w.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,w.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,w.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,w.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,w.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,w.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,w.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,w.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,w.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,w.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,w.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,w.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,w.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,w.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,w.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,w.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,w.registerSingleton)(v.IExtHostTelemetry,v.ExtHostTelemetry)}),define(we[228],_e([0,1,226,35,222,7,11,5]),function(Q,e,w,I,A,T,y,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var a;const g=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...f)=>{f.forEach(n=>{var u;if(!((u=self.trustedTypes)===null||u===void 0?void 0:u.isScript(n)))throw new Error("TrustedScripts only, please")});const l=f.slice(0,-1).join(","),v=f.pop().toString();return`(function anonymous(${l}) {
${v}
})`}});function m(...S){return g?self.eval(g.createScript("",...S)):new Function(...S)}r.create=m})(k||(k={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(a,g){for(let m of this._alternatives){let S=m(a);if(S){a=S;break}}if(this._factories.has(a))return this._factories.get(a).load(a,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);h(a,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,g,m){var S,f,l,v,t,n,u,o;g=g.with({path:d(g.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const s=await fetch(g.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),s.status!==200)throw new Error(s.statusText);const c=await s.text(),b=`${g.toString(!0)}#vscode-extension`,_=`${c}
//# sourceURL=${b}`;let p;try{p=k.create((f=(S=P._ttpExtensionScripts)===null||S===void 0?void 0:S.createScript("module"))!==null&&f!==void 0?f:"module",(v=(l=P._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript("exports"))!==null&&v!==void 0?v:"exports",(n=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(o=(u=P._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript(_))!==null&&o!==void 0?o:_)}catch(Y){throw a?console.error(`Loading code for extension ${a.value} failed: ${Y.message}`):console.error(`Loading code failed: ${Y.message}`),console.error(`${g.toString(!0)}${typeof Y.line=="number"?` line ${Y.line}`:""}${typeof Y.column=="number"?` column ${Y.column}`:""}`),console.error(Y),Y}const E={},F={exports:E},B=Y=>{const fe=this._fakeModules.getModule(Y,g);if(fe===void 0)throw new Error(`Cannot load module '${Y}'`);return fe};try{return m.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),p(F,E,B),F.exports!==E?F.exports:E}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const g=Date.now()+a;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(D=self.trustedTypes)===null||D===void 0?void 0:D.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,a){return r.endsWith(a)?r:r+a}function h(r,a){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(f,l){const v=console[f];console[f]=function(){r.$logExtensionHostMessage({type:"__$console",severity:l,arguments:S(arguments)}),a&&v.apply(console,arguments)}}const m=1e5;function S(f){const l=[],v=[];if(f.length)for(let t=0;t<f.length;t++){if(typeof f[t]=="undefined")f[t]="undefined";else if(f[t]instanceof Error){const n=f[t];n.stack?f[t]=n.stack:f[t]=n.toString()}v.push(f[t])}try{const t=JSON.stringify(v,function(n,u){if(u&&typeof u=="object"){if(l.indexOf(u)!==-1)return"[Circular]";l.push(u)}return u});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[229],_e([0,1,61,18,35,228,214]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,w.registerSingleton)(I.ILogService,y.ExtHostLogService)}),define(we[231],_e([0,1,23,3,185,223,216,13,80,227,229]),function(Q,e,w,I,A,T,y,C,D){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),m=self.Worker;Worker=function(S,f){const l=`importScripts('${S}');`;f=f||{},f.name=f.name||C.basename(S.toString());const v=new Blob([l],{type:"application/javascript"}),t=URL.createObjectURL(v);return new m(g?g.createScriptURL(t):t,f)}}else self.Worker=class extends y.NestedWorker{constructor(g,m){super(P,g,Object.assign({name:C.basename(g.toString())},m))}};const d=new class{exit(g){i()}async exists(g){return!0}async realpath(g){return g}};class h{constructor(){const m=new MessageChannel,S=new I.Emitter;let f=!1;P(m.port2,[m.port2]),m.port1.onmessage=l=>{const{data:v}=l;if(!(v instanceof ArrayBuffer)){console.warn("UNKNOWN data received",v);return}const t=w.VSBuffer.wrap(new Uint8Array(v,0,v.byteLength));if((0,A.isMessageOfType)(t,2)){f=!0,a("received terminate message from renderer");return}S.fire(t)},this.protocol={onMessage:S.event,send:l=>{if(!f){const v=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);m.port1.postMessage(v,[v])}}}}}function r(g){return new Promise(m=>{const S=g.onMessage(f=>{S.dispose();const l=JSON.parse(f.toString());g.send((0,A.createMessageOfType)(0)),m({protocol:g,initData:l})});g.send((0,A.createMessageOfType)(1))})}let a=g=>i();(function(){const m=new h;D.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(S=>{D.mark("code/extHost/didWaitForInitData");const f=new T.ExtensionHostMain(S.protocol,S.initData,d,null);a=l=>f.terminate(l)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5080d21c0b538b996c83fb7b14a746f656eaef15/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
